/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the X86 target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 150;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(X86InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(X86InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static X86InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static X86InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(1),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s1,
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s80,
  GILLT_s128,
  GILLT_v2s1,
  GILLT_v2s64,
  GILLT_v4s1,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v8s1,
  GILLT_v8s16,
  GILLT_v8s32,
  GILLT_v8s64,
  GILLT_v16s1,
  GILLT_v16s8,
  GILLT_v16s16,
  GILLT_v16s32,
  GILLT_v32s1,
  GILLT_v32s8,
  GILLT_v32s16,
  GILLT_v64s1,
  GILLT_v64s8,
};
const static size_t NumTypeObjects = 25;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(80),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 1),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 1),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(8), 1),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 32),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(16), 1),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getFixed(16), 16),
  LLT::vector(ElementCount::getFixed(16), 32),
  LLT::vector(ElementCount::getFixed(32), 1),
  LLT::vector(ElementCount::getFixed(32), 8),
  LLT::vector(ElementCount::getFixed(32), 16),
  LLT::vector(ElementCount::getFixed(64), 1),
  LLT::vector(ElementCount::getFixed(64), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_TruePredicateBit = 61,
  Feature_HasEGPRBit = 5,
  Feature_NoEGPRBit = 4,
  Feature_HasNDDBit = 6,
  Feature_NoNDDBit = 27,
  Feature_HasZUBit = 149,
  Feature_HasCFBit = 30,
  Feature_HasCMOVBit = 29,
  Feature_NoCMOVBit = 135,
  Feature_HasMMXBit = 107,
  Feature_HasSSE1Bit = 47,
  Feature_UseSSE1Bit = 54,
  Feature_HasSSE2Bit = 46,
  Feature_UseSSE2Bit = 55,
  Feature_HasSSE3Bit = 38,
  Feature_UseSSE3Bit = 64,
  Feature_HasSSSE3Bit = 108,
  Feature_UseSSSE3Bit = 65,
  Feature_UseSSE41Bit = 62,
  Feature_UseSSE42Bit = 69,
  Feature_HasSSE4ABit = 79,
  Feature_NoAVXBit = 75,
  Feature_HasAVXBit = 56,
  Feature_HasAVX2Bit = 50,
  Feature_HasAVX1OnlyBit = 48,
  Feature_HasEVEX512Bit = 142,
  Feature_HasAVX10_2Bit = 106,
  Feature_HasAVX10_2_512Bit = 105,
  Feature_NoAVX10_2Bit = 68,
  Feature_HasAVX512Bit = 92,
  Feature_UseAVXBit = 52,
  Feature_NoAVX512Bit = 43,
  Feature_HasCDIBit = 96,
  Feature_HasVPOPCNTDQBit = 100,
  Feature_HasDQIBit = 94,
  Feature_NoDQIBit = 66,
  Feature_HasBWIBit = 95,
  Feature_NoBWIBit = 63,
  Feature_HasVLXBit = 93,
  Feature_NoVLXBit = 42,
  Feature_NoVLX_Or_NoBWIBit = 60,
  Feature_HasVNNIBit = 102,
  Feature_HasVP2INTERSECTBit = 104,
  Feature_HasFP16Bit = 98,
  Feature_HasAVXVNNIINT16Bit = 91,
  Feature_HasAVXVNNIINT8Bit = 86,
  Feature_HasAVXVNNIBit = 80,
  Feature_NoVLX_Or_NoVNNIBit = 81,
  Feature_HasBITALGBit = 103,
  Feature_HasPOPCNTBit = 67,
  Feature_HasAESBit = 72,
  Feature_HasVAESBit = 74,
  Feature_NoVLX_Or_NoVAESBit = 73,
  Feature_HasFXSRBit = 39,
  Feature_HasX87Bit = 37,
  Feature_HasXSAVEBit = 124,
  Feature_HasXSAVEOPTBit = 125,
  Feature_HasXSAVECBit = 126,
  Feature_HasXSAVESBit = 127,
  Feature_HasPCLMULBit = 76,
  Feature_NoVLX_Or_NoVPCLMULQDQBit = 77,
  Feature_HasVPCLMULQDQBit = 78,
  Feature_HasGFNIBit = 83,
  Feature_HasFMABit = 40,
  Feature_HasFMA4Bit = 44,
  Feature_NoFMA4Bit = 41,
  Feature_HasXOPBit = 45,
  Feature_HasTBMBit = 26,
  Feature_NoTBMBit = 140,
  Feature_HasLWPBit = 12,
  Feature_HasMOVBEBit = 3,
  Feature_NoNDD_Or_NoMOVBEBit = 2,
  Feature_HasRDRANDBit = 7,
  Feature_HasF16CBit = 82,
  Feature_HasFSGSBaseBit = 128,
  Feature_HasLZCNTBit = 9,
  Feature_HasBMIBit = 10,
  Feature_HasBMI2Bit = 11,
  Feature_NoBMI2Bit = 139,
  Feature_HasVBMIBit = 97,
  Feature_HasVBMI2Bit = 101,
  Feature_HasIFMABit = 99,
  Feature_HasAVXIFMABit = 84,
  Feature_NoVLX_Or_NoIFMABit = 85,
  Feature_HasRTMBit = 110,
  Feature_HasSHABit = 71,
  Feature_HasSHA512Bit = 88,
  Feature_HasSM3Bit = 89,
  Feature_HasRDSEEDBit = 8,
  Feature_HasSSEPrefetchBit = 57,
  Feature_HasPREFETCHIBit = 20,
  Feature_HasPrefetchWBit = 109,
  Feature_HasMWAITXBit = 138,
  Feature_HasCLDEMOTEBit = 24,
  Feature_HasMOVDIRIBit = 14,
  Feature_HasMOVDIR64BBit = 15,
  Feature_HasMOVRSBit = 25,
  Feature_HasPTWRITEBit = 131,
  Feature_FPStackf32Bit = 35,
  Feature_FPStackf64Bit = 36,
  Feature_HasSM4Bit = 90,
  Feature_HasCLFLUSHBit = 58,
  Feature_HasCLFLUSHOPTBit = 22,
  Feature_HasCLWBBit = 23,
  Feature_HasWBNOINVDBit = 123,
  Feature_HasRDPIDBit = 130,
  Feature_HasWAITPKGBit = 13,
  Feature_HasINVPCIDBit = 129,
  Feature_HasCX8Bit = 136,
  Feature_HasCX16Bit = 137,
  Feature_HasENQCMDBit = 16,
  Feature_HasAMXFP16Bit = 115,
  Feature_HasCMPCCXADDBit = 21,
  Feature_HasAVXNECONVERTBit = 87,
  Feature_HasKLBit = 111,
  Feature_HasRAOINTBit = 121,
  Feature_HasSERIALIZEBit = 17,
  Feature_HasTSXLDTRKBit = 18,
  Feature_HasAMXTILEBit = 112,
  Feature_HasAMXBF16Bit = 114,
  Feature_HasAMXINT8Bit = 113,
  Feature_HasAMXCOMPLEXBit = 116,
  Feature_HasAMXFP8Bit = 117,
  Feature_HasAMXTRANSPOSEBit = 118,
  Feature_HasAMXAVX512Bit = 119,
  Feature_HasAMXTF32Bit = 120,
  Feature_HasUINTRBit = 19,
  Feature_HasUSERMSRBit = 122,
  Feature_HasCRC32Bit = 70,
  Feature_Not64BitModeBit = 0,
  Feature_In64BitModeBit = 1,
  Feature_IsLP64Bit = 133,
  Feature_NotLP64Bit = 132,
  Feature_NotWin64WithoutFPBit = 134,
  Feature_IsPSBit = 144,
  Feature_NotPSBit = 143,
  Feature_KernelCodeBit = 145,
  Feature_NearDataBit = 147,
  Feature_IsNotPICBit = 146,
  Feature_OptForSizeBit = 51,
  Feature_OptForMinSizeBit = 49,
  Feature_OptForSpeedBit = 141,
  Feature_UseIncDecBit = 28,
  Feature_NoSSE41_Or_OptForSizeBit = 53,
  Feature_CallImmAddrBit = 148,
  Feature_FavorMemIndirectCallBit = 31,
  Feature_HasFastSHLDRotateBit = 34,
  Feature_HasMFenceBit = 59,
  Feature_UseIndirectThunkCallsBit = 33,
  Feature_NotUseIndirectThunkCallsBit = 32,
};

PredicateBitset X86InstructionSelector::
computeAvailableModuleFeatures(const X86Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (true)
    Features.set(Feature_TruePredicateBit);
  if (Subtarget->hasEGPR())
    Features.set(Feature_HasEGPRBit);
  if (!Subtarget->hasEGPR())
    Features.set(Feature_NoEGPRBit);
  if (Subtarget->hasNDD())
    Features.set(Feature_HasNDDBit);
  if (!Subtarget->hasNDD())
    Features.set(Feature_NoNDDBit);
  if (Subtarget->hasZU())
    Features.set(Feature_HasZUBit);
  if (Subtarget->hasCF())
    Features.set(Feature_HasCFBit);
  if (Subtarget->canUseCMOV())
    Features.set(Feature_HasCMOVBit);
  if (!Subtarget->canUseCMOV())
    Features.set(Feature_NoCMOVBit);
  if (Subtarget->hasMMX())
    Features.set(Feature_HasMMXBit);
  if (Subtarget->hasSSE1())
    Features.set(Feature_HasSSE1Bit);
  if (Subtarget->hasSSE1() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE1Bit);
  if (Subtarget->hasSSE2())
    Features.set(Feature_HasSSE2Bit);
  if (Subtarget->hasSSE2() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE2Bit);
  if (Subtarget->hasSSE3())
    Features.set(Feature_HasSSE3Bit);
  if (Subtarget->hasSSE3() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE3Bit);
  if (Subtarget->hasSSSE3())
    Features.set(Feature_HasSSSE3Bit);
  if (Subtarget->hasSSSE3() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSSE3Bit);
  if (Subtarget->hasSSE41() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE41Bit);
  if (Subtarget->hasSSE42() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE42Bit);
  if (Subtarget->hasSSE4A())
    Features.set(Feature_HasSSE4ABit);
  if (!Subtarget->hasAVX())
    Features.set(Feature_NoAVXBit);
  if (Subtarget->hasAVX())
    Features.set(Feature_HasAVXBit);
  if (Subtarget->hasAVX2())
    Features.set(Feature_HasAVX2Bit);
  if (Subtarget->hasAVX() && !Subtarget->hasAVX2())
    Features.set(Feature_HasAVX1OnlyBit);
  if (Subtarget->hasEVEX512())
    Features.set(Feature_HasEVEX512Bit);
  if (Subtarget->hasAVX10_2())
    Features.set(Feature_HasAVX10_2Bit);
  if (Subtarget->hasAVX10_2_512())
    Features.set(Feature_HasAVX10_2_512Bit);
  if (!Subtarget->hasAVX10_2())
    Features.set(Feature_NoAVX10_2Bit);
  if (Subtarget->hasAVX512())
    Features.set(Feature_HasAVX512Bit);
  if (Subtarget->hasAVX() && !Subtarget->hasAVX512())
    Features.set(Feature_UseAVXBit);
  if (!Subtarget->hasAVX512())
    Features.set(Feature_NoAVX512Bit);
  if (Subtarget->hasCDI())
    Features.set(Feature_HasCDIBit);
  if (Subtarget->hasVPOPCNTDQ())
    Features.set(Feature_HasVPOPCNTDQBit);
  if (Subtarget->hasDQI())
    Features.set(Feature_HasDQIBit);
  if (!Subtarget->hasDQI())
    Features.set(Feature_NoDQIBit);
  if (Subtarget->hasBWI())
    Features.set(Feature_HasBWIBit);
  if (!Subtarget->hasBWI())
    Features.set(Feature_NoBWIBit);
  if (Subtarget->hasVLX())
    Features.set(Feature_HasVLXBit);
  if (!Subtarget->hasVLX())
    Features.set(Feature_NoVLXBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasBWI())
    Features.set(Feature_NoVLX_Or_NoBWIBit);
  if (Subtarget->hasVNNI())
    Features.set(Feature_HasVNNIBit);
  if (Subtarget->hasVP2INTERSECT())
    Features.set(Feature_HasVP2INTERSECTBit);
  if (Subtarget->hasFP16())
    Features.set(Feature_HasFP16Bit);
  if (Subtarget->hasAVXVNNIINT16())
    Features.set(Feature_HasAVXVNNIINT16Bit);
  if (Subtarget->hasAVXVNNIINT8())
    Features.set(Feature_HasAVXVNNIINT8Bit);
  if (Subtarget->hasAVXVNNI())
    Features.set(Feature_HasAVXVNNIBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVNNI())
    Features.set(Feature_NoVLX_Or_NoVNNIBit);
  if (Subtarget->hasBITALG())
    Features.set(Feature_HasBITALGBit);
  if (Subtarget->hasPOPCNT())
    Features.set(Feature_HasPOPCNTBit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasVAES())
    Features.set(Feature_HasVAESBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVAES())
    Features.set(Feature_NoVLX_Or_NoVAESBit);
  if (Subtarget->hasFXSR())
    Features.set(Feature_HasFXSRBit);
  if (Subtarget->hasX87())
    Features.set(Feature_HasX87Bit);
  if (Subtarget->hasXSAVE())
    Features.set(Feature_HasXSAVEBit);
  if (Subtarget->hasXSAVEOPT())
    Features.set(Feature_HasXSAVEOPTBit);
  if (Subtarget->hasXSAVEC())
    Features.set(Feature_HasXSAVECBit);
  if (Subtarget->hasXSAVES())
    Features.set(Feature_HasXSAVESBit);
  if (Subtarget->hasPCLMUL())
    Features.set(Feature_HasPCLMULBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVPCLMULQDQ())
    Features.set(Feature_NoVLX_Or_NoVPCLMULQDQBit);
  if (Subtarget->hasVPCLMULQDQ())
    Features.set(Feature_HasVPCLMULQDQBit);
  if (Subtarget->hasGFNI())
    Features.set(Feature_HasGFNIBit);
  if (Subtarget->hasFMA())
    Features.set(Feature_HasFMABit);
  if (Subtarget->hasFMA4())
    Features.set(Feature_HasFMA4Bit);
  if (!Subtarget->hasFMA4())
    Features.set(Feature_NoFMA4Bit);
  if (Subtarget->hasXOP())
    Features.set(Feature_HasXOPBit);
  if (Subtarget->hasTBM())
    Features.set(Feature_HasTBMBit);
  if (!Subtarget->hasTBM())
    Features.set(Feature_NoTBMBit);
  if (Subtarget->hasLWP())
    Features.set(Feature_HasLWPBit);
  if (Subtarget->hasMOVBE())
    Features.set(Feature_HasMOVBEBit);
  if (!Subtarget->hasNDD() || !Subtarget->hasMOVBE())
    Features.set(Feature_NoNDD_Or_NoMOVBEBit);
  if (Subtarget->hasRDRAND())
    Features.set(Feature_HasRDRANDBit);
  if (Subtarget->hasF16C())
    Features.set(Feature_HasF16CBit);
  if (Subtarget->hasFSGSBase())
    Features.set(Feature_HasFSGSBaseBit);
  if (Subtarget->hasLZCNT())
    Features.set(Feature_HasLZCNTBit);
  if (Subtarget->hasBMI())
    Features.set(Feature_HasBMIBit);
  if (Subtarget->hasBMI2())
    Features.set(Feature_HasBMI2Bit);
  if (!Subtarget->hasBMI2())
    Features.set(Feature_NoBMI2Bit);
  if (Subtarget->hasVBMI())
    Features.set(Feature_HasVBMIBit);
  if (Subtarget->hasVBMI2())
    Features.set(Feature_HasVBMI2Bit);
  if (Subtarget->hasIFMA())
    Features.set(Feature_HasIFMABit);
  if (Subtarget->hasAVXIFMA())
    Features.set(Feature_HasAVXIFMABit);
  if (!Subtarget->hasVLX() || !Subtarget->hasIFMA())
    Features.set(Feature_NoVLX_Or_NoIFMABit);
  if (Subtarget->hasRTM())
    Features.set(Feature_HasRTMBit);
  if (Subtarget->hasSHA())
    Features.set(Feature_HasSHABit);
  if (Subtarget->hasSHA512())
    Features.set(Feature_HasSHA512Bit);
  if (Subtarget->hasSM3())
    Features.set(Feature_HasSM3Bit);
  if (Subtarget->hasRDSEED())
    Features.set(Feature_HasRDSEEDBit);
  if (Subtarget->hasSSEPrefetch())
    Features.set(Feature_HasSSEPrefetchBit);
  if (Subtarget->hasPREFETCHI())
    Features.set(Feature_HasPREFETCHIBit);
  if (Subtarget->hasPrefetchW())
    Features.set(Feature_HasPrefetchWBit);
  if (Subtarget->hasMWAITX())
    Features.set(Feature_HasMWAITXBit);
  if (Subtarget->hasCLDEMOTE())
    Features.set(Feature_HasCLDEMOTEBit);
  if (Subtarget->hasMOVDIRI())
    Features.set(Feature_HasMOVDIRIBit);
  if (Subtarget->hasMOVDIR64B())
    Features.set(Feature_HasMOVDIR64BBit);
  if (Subtarget->hasMOVRS())
    Features.set(Feature_HasMOVRSBit);
  if (Subtarget->hasPTWRITE())
    Features.set(Feature_HasPTWRITEBit);
  if (!Subtarget->hasSSE1())
    Features.set(Feature_FPStackf32Bit);
  if (!Subtarget->hasSSE2())
    Features.set(Feature_FPStackf64Bit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasCLFLUSH())
    Features.set(Feature_HasCLFLUSHBit);
  if (Subtarget->hasCLFLUSHOPT())
    Features.set(Feature_HasCLFLUSHOPTBit);
  if (Subtarget->hasCLWB())
    Features.set(Feature_HasCLWBBit);
  if (Subtarget->hasWBNOINVD())
    Features.set(Feature_HasWBNOINVDBit);
  if (Subtarget->hasRDPID())
    Features.set(Feature_HasRDPIDBit);
  if (Subtarget->hasWAITPKG())
    Features.set(Feature_HasWAITPKGBit);
  if (Subtarget->hasINVPCID())
    Features.set(Feature_HasINVPCIDBit);
  if (Subtarget->hasCX8())
    Features.set(Feature_HasCX8Bit);
  if (Subtarget->hasCX16())
    Features.set(Feature_HasCX16Bit);
  if (Subtarget->hasENQCMD())
    Features.set(Feature_HasENQCMDBit);
  if (Subtarget->hasAMXFP16())
    Features.set(Feature_HasAMXFP16Bit);
  if (Subtarget->hasCMPCCXADD())
    Features.set(Feature_HasCMPCCXADDBit);
  if (Subtarget->hasAVXNECONVERT())
    Features.set(Feature_HasAVXNECONVERTBit);
  if (Subtarget->hasKL())
    Features.set(Feature_HasKLBit);
  if (Subtarget->hasRAOINT())
    Features.set(Feature_HasRAOINTBit);
  if (Subtarget->hasSERIALIZE())
    Features.set(Feature_HasSERIALIZEBit);
  if (Subtarget->hasTSXLDTRK())
    Features.set(Feature_HasTSXLDTRKBit);
  if (Subtarget->hasAMXTILE())
    Features.set(Feature_HasAMXTILEBit);
  if (Subtarget->hasAMXBF16())
    Features.set(Feature_HasAMXBF16Bit);
  if (Subtarget->hasAMXINT8())
    Features.set(Feature_HasAMXINT8Bit);
  if (Subtarget->hasAMXCOMPLEX())
    Features.set(Feature_HasAMXCOMPLEXBit);
  if (Subtarget->hasAMXFP8())
    Features.set(Feature_HasAMXFP8Bit);
  if (Subtarget->hasAMXTRANSPOSE())
    Features.set(Feature_HasAMXTRANSPOSEBit);
  if (Subtarget->hasAMXAVX512())
    Features.set(Feature_HasAMXAVX512Bit);
  if (Subtarget->hasAMXTF32())
    Features.set(Feature_HasAMXTF32Bit);
  if (Subtarget->hasUINTR())
    Features.set(Feature_HasUINTRBit);
  if (Subtarget->hasUSERMSR())
    Features.set(Feature_HasUSERMSRBit);
  if (Subtarget->hasCRC32())
    Features.set(Feature_HasCRC32Bit);
  if (!Subtarget->is64Bit())
    Features.set(Feature_Not64BitModeBit);
  if (Subtarget->is64Bit())
    Features.set(Feature_In64BitModeBit);
  if (Subtarget->isTarget64BitLP64())
    Features.set(Feature_IsLP64Bit);
  if (!Subtarget->isTarget64BitLP64())
    Features.set(Feature_NotLP64Bit);
  if (Subtarget->isTargetPS())
    Features.set(Feature_IsPSBit);
  if (!Subtarget->isTargetPS())
    Features.set(Feature_NotPSBit);
  if (TM.getCodeModel() == CodeModel::Kernel)
    Features.set(Feature_KernelCodeBit);
  if (TM.getCodeModel() == CodeModel::Small ||TM.getCodeModel() == CodeModel::Kernel)
    Features.set(Feature_NearDataBit);
  if (!TM.isPositionIndependent())
    Features.set(Feature_IsNotPICBit);
  if (Subtarget->isLegalToCallImmediateAddr())
    Features.set(Feature_CallImmAddrBit);
  if (!Subtarget->slowTwoMemOps())
    Features.set(Feature_FavorMemIndirectCallBit);
  if (Subtarget->hasFastSHLDRotate())
    Features.set(Feature_HasFastSHLDRotateBit);
  if (Subtarget->hasMFence())
    Features.set(Feature_HasMFenceBit);
  if (Subtarget->useIndirectThunkCalls())
    Features.set(Feature_UseIndirectThunkCallsBit);
  if (!Subtarget->useIndirectThunkCalls())
    Features.set(Feature_NotUseIndirectThunkCallsBit);
  return Features;
}

void X86InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const X86Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset X86InstructionSelector::
computeAvailableFunctionFeatures(const X86Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!Subtarget->isTargetWin64() ||Subtarget->getFrameLowering()->hasFP(*MF))
    Features.set(Feature_NotWin64WithoutFPBit);
  if (shouldOptForSize(MF))
    Features.set(Feature_OptForSizeBit);
  if (MF->getFunction().hasMinSize())
    Features.set(Feature_OptForMinSizeBit);
  if (!shouldOptForSize(MF))
    Features.set(Feature_OptForSpeedBit);
  if (!Subtarget->slowIncDec() || shouldOptForSize(MF))
    Features.set(Feature_UseIncDecBit);
  if (shouldOptForSize(MF) || !Subtarget->hasSSE41())
    Features.set(Feature_NoSSE41_Or_OptForSizeBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_FPStackf32,
  GIFBS_FPStackf64,
  GIFBS_HasAVX,
  GIFBS_HasAVX1Only,
  GIFBS_HasAVX2,
  GIFBS_HasAVX512,
  GIFBS_HasAVXNECONVERT,
  GIFBS_HasBITALG,
  GIFBS_HasBMI,
  GIFBS_HasBWI,
  GIFBS_HasCDI,
  GIFBS_HasCLDEMOTE,
  GIFBS_HasCLFLUSH,
  GIFBS_HasCLFLUSHOPT,
  GIFBS_HasCLWB,
  GIFBS_HasDQI,
  GIFBS_HasFP16,
  GIFBS_HasFXSR,
  GIFBS_HasFastSHLDRotate,
  GIFBS_HasKL,
  GIFBS_HasLWP,
  GIFBS_HasLZCNT,
  GIFBS_HasMFence,
  GIFBS_HasMMX,
  GIFBS_HasMOVBE,
  GIFBS_HasMOVRS,
  GIFBS_HasMWAITX,
  GIFBS_HasNDD,
  GIFBS_HasPOPCNT,
  GIFBS_HasPTWRITE,
  GIFBS_HasPrefetchW,
  GIFBS_HasRTM,
  GIFBS_HasSERIALIZE,
  GIFBS_HasSHA,
  GIFBS_HasSHA512,
  GIFBS_HasSM3,
  GIFBS_HasSM4,
  GIFBS_HasSSE1,
  GIFBS_HasSSE2,
  GIFBS_HasSSE3,
  GIFBS_HasSSE4A,
  GIFBS_HasSSEPrefetch,
  GIFBS_HasTBM,
  GIFBS_HasTSXLDTRK,
  GIFBS_HasVBMI2,
  GIFBS_HasVLX,
  GIFBS_HasVPOPCNTDQ,
  GIFBS_HasWAITPKG,
  GIFBS_HasWBNOINVD,
  GIFBS_HasX87,
  GIFBS_HasXOP,
  GIFBS_HasXSAVE,
  GIFBS_HasXSAVEC,
  GIFBS_HasXSAVEOPT,
  GIFBS_HasXSAVES,
  GIFBS_HasZU,
  GIFBS_In64BitMode,
  GIFBS_IsPS,
  GIFBS_NoAVX,
  GIFBS_NoDQI,
  GIFBS_NoEGPR,
  GIFBS_NoNDD,
  GIFBS_NoNDD_Or_NoMOVBE,
  GIFBS_Not64BitMode,
  GIFBS_NotPS,
  GIFBS_UseAVX,
  GIFBS_UseIncDec,
  GIFBS_UseSSE1,
  GIFBS_UseSSE2,
  GIFBS_UseSSE3,
  GIFBS_UseSSE41,
  GIFBS_UseSSSE3,
  GIFBS_HasAES_HasAVX,
  GIFBS_HasAES_NoAVX,
  GIFBS_HasAMXBF16_In64BitMode,
  GIFBS_HasAMXCOMPLEX_In64BitMode,
  GIFBS_HasAMXFP16_In64BitMode,
  GIFBS_HasAMXFP8_In64BitMode,
  GIFBS_HasAMXINT8_In64BitMode,
  GIFBS_HasAMXTF32_In64BitMode,
  GIFBS_HasAMXTILE_In64BitMode,
  GIFBS_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAVX_In64BitMode,
  GIFBS_HasAVX_NoBWI,
  GIFBS_HasAVX_NoVLX,
  GIFBS_HasAVX_NoVLX_Or_NoBWI,
  GIFBS_HasAVX10_2_HasSM4,
  GIFBS_HasAVX10_2_512_HasSM4,
  GIFBS_HasAVX2_NoVLX,
  GIFBS_HasAVX2_NoVLX_Or_NoBWI,
  GIFBS_HasAVX512_HasVAES,
  GIFBS_HasAVX512_HasVLX,
  GIFBS_HasAVX512_HasVPCLMULQDQ,
  GIFBS_HasAVX512_NoBWI,
  GIFBS_HasAVX512_NoDQI,
  GIFBS_HasAVX512_NoEGPR,
  GIFBS_HasAVX512_OptForSize,
  GIFBS_HasBITALG_HasVLX,
  GIFBS_HasBMI_HasEGPR,
  GIFBS_HasBMI_NoEGPR,
  GIFBS_HasBMI2_HasEGPR,
  GIFBS_HasBMI2_NoEGPR,
  GIFBS_HasBWI_HasVLX,
  GIFBS_HasBWI_NoEGPR,
  GIFBS_HasCDI_HasVLX,
  GIFBS_HasCRC32_NoEGPR,
  GIFBS_HasDQI_HasVLX,
  GIFBS_HasDQI_NoBWI,
  GIFBS_HasDQI_NoEGPR,
  GIFBS_HasEGPR_HasINVPCID,
  GIFBS_HasEGPR_In64BitMode,
  GIFBS_HasEVEX512_NoVLX,
  GIFBS_HasFMA4_NoAVX512,
  GIFBS_HasFMA4_NoVLX,
  GIFBS_HasFP16_HasVLX,
  GIFBS_HasFP16_In64BitMode,
  GIFBS_HasFP16_OptForSize,
  GIFBS_HasFSGSBase_In64BitMode,
  GIFBS_HasFXSR_In64BitMode,
  GIFBS_HasINVPCID_NoEGPR,
  GIFBS_HasINVPCID_Not64BitMode,
  GIFBS_HasMOVBE_NoEGPR,
  GIFBS_HasMOVDIR64B_NoEGPR,
  GIFBS_HasMOVDIRI_NoEGPR,
  GIFBS_HasNDD_In64BitMode,
  GIFBS_HasNDD_UseIncDec,
  GIFBS_HasPCLMUL_NoAVX,
  GIFBS_HasPREFETCHI_In64BitMode,
  GIFBS_HasPTWRITE_In64BitMode,
  GIFBS_HasRDPID_In64BitMode,
  GIFBS_HasRDPID_Not64BitMode,
  GIFBS_HasUINTR_In64BitMode,
  GIFBS_HasUSERMSR_NoEGPR,
  GIFBS_HasVAES_HasVLX,
  GIFBS_HasVAES_NoVLX,
  GIFBS_HasVBMI2_HasVLX,
  GIFBS_HasVLX_HasVPCLMULQDQ,
  GIFBS_HasVLX_HasVPOPCNTDQ,
  GIFBS_HasVPCLMULQDQ_NoVLX,
  GIFBS_HasWAITPKG_In64BitMode,
  GIFBS_HasWAITPKG_Not64BitMode,
  GIFBS_HasXSAVE_In64BitMode,
  GIFBS_HasXSAVEC_In64BitMode,
  GIFBS_HasXSAVEOPT_In64BitMode,
  GIFBS_HasXSAVES_In64BitMode,
  GIFBS_In64BitMode_UseIncDec,
  GIFBS_In64BitMode_UseSSE2,
  GIFBS_NoNDD_UseIncDec,
  GIFBS_Not64BitMode_OptForSize,
  GIFBS_NotWin64WithoutFP_OptForMinSize,
  GIFBS_OptForSize_UseAVX,
  GIFBS_OptForSize_UseSSE1,
  GIFBS_OptForSize_UseSSE2,
  GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES,
  GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode,
  GIFBS_HasAMXBF16_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXFP16_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXTF32_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXTILE_HasEGPR_In64BitMode,
  GIFBS_HasAMXTILE_In64BitMode_NoEGPR,
  GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ,
  GIFBS_HasAVX10_2_HasMOVRS_In64BitMode,
  GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode,
  GIFBS_HasAVX512_HasEGPR_In64BitMode,
  GIFBS_HasAVX512_HasEVEX512_NoVLX,
  GIFBS_HasBITALG_HasEVEX512_NoVLX,
  GIFBS_HasBWI_HasEGPR_In64BitMode,
  GIFBS_HasBWI_HasEVEX512_NoVLX,
  GIFBS_HasCDI_HasEVEX512_NoVLX,
  GIFBS_HasCRC32_HasEGPR_In64BitMode,
  GIFBS_HasDQI_HasEGPR_In64BitMode,
  GIFBS_HasDQI_HasEVEX512_NoVLX,
  GIFBS_HasDQI_HasVLX_NoBWI,
  GIFBS_HasEGPR_HasMOVBE_In64BitMode,
  GIFBS_HasEGPR_HasMOVDIR64B_In64BitMode,
  GIFBS_HasEGPR_HasMOVDIRI_In64BitMode,
  GIFBS_HasEGPR_HasMOVRS_In64BitMode,
  GIFBS_HasEGPR_HasUSERMSR_In64BitMode,
  GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX,
  GIFBS_HasFMA_NoAVX512_NoFMA4,
  GIFBS_HasFMA_NoFMA4_NoVLX,
  GIFBS_HasMOVBE_HasNDD_In64BitMode,
  GIFBS_HasMOVDIR64B_In64BitMode_NoEGPR,
  GIFBS_HasMOVDIRI_In64BitMode_NoEGPR,
  GIFBS_HasMOVRS_In64BitMode_NoEGPR,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_FPStackf32Bit, },
  {Feature_FPStackf64Bit, },
  {Feature_HasAVXBit, },
  {Feature_HasAVX1OnlyBit, },
  {Feature_HasAVX2Bit, },
  {Feature_HasAVX512Bit, },
  {Feature_HasAVXNECONVERTBit, },
  {Feature_HasBITALGBit, },
  {Feature_HasBMIBit, },
  {Feature_HasBWIBit, },
  {Feature_HasCDIBit, },
  {Feature_HasCLDEMOTEBit, },
  {Feature_HasCLFLUSHBit, },
  {Feature_HasCLFLUSHOPTBit, },
  {Feature_HasCLWBBit, },
  {Feature_HasDQIBit, },
  {Feature_HasFP16Bit, },
  {Feature_HasFXSRBit, },
  {Feature_HasFastSHLDRotateBit, },
  {Feature_HasKLBit, },
  {Feature_HasLWPBit, },
  {Feature_HasLZCNTBit, },
  {Feature_HasMFenceBit, },
  {Feature_HasMMXBit, },
  {Feature_HasMOVBEBit, },
  {Feature_HasMOVRSBit, },
  {Feature_HasMWAITXBit, },
  {Feature_HasNDDBit, },
  {Feature_HasPOPCNTBit, },
  {Feature_HasPTWRITEBit, },
  {Feature_HasPrefetchWBit, },
  {Feature_HasRTMBit, },
  {Feature_HasSERIALIZEBit, },
  {Feature_HasSHABit, },
  {Feature_HasSHA512Bit, },
  {Feature_HasSM3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSSE1Bit, },
  {Feature_HasSSE2Bit, },
  {Feature_HasSSE3Bit, },
  {Feature_HasSSE4ABit, },
  {Feature_HasSSEPrefetchBit, },
  {Feature_HasTBMBit, },
  {Feature_HasTSXLDTRKBit, },
  {Feature_HasVBMI2Bit, },
  {Feature_HasVLXBit, },
  {Feature_HasVPOPCNTDQBit, },
  {Feature_HasWAITPKGBit, },
  {Feature_HasWBNOINVDBit, },
  {Feature_HasX87Bit, },
  {Feature_HasXOPBit, },
  {Feature_HasXSAVEBit, },
  {Feature_HasXSAVECBit, },
  {Feature_HasXSAVEOPTBit, },
  {Feature_HasXSAVESBit, },
  {Feature_HasZUBit, },
  {Feature_In64BitModeBit, },
  {Feature_IsPSBit, },
  {Feature_NoAVXBit, },
  {Feature_NoDQIBit, },
  {Feature_NoEGPRBit, },
  {Feature_NoNDDBit, },
  {Feature_NoNDD_Or_NoMOVBEBit, },
  {Feature_Not64BitModeBit, },
  {Feature_NotPSBit, },
  {Feature_UseAVXBit, },
  {Feature_UseIncDecBit, },
  {Feature_UseSSE1Bit, },
  {Feature_UseSSE2Bit, },
  {Feature_UseSSE3Bit, },
  {Feature_UseSSE41Bit, },
  {Feature_UseSSSE3Bit, },
  {Feature_HasAESBit, Feature_HasAVXBit, },
  {Feature_HasAESBit, Feature_NoAVXBit, },
  {Feature_HasAMXBF16Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXCOMPLEXBit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP16Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP8Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXINT8Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXTF32Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXTILEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAVXBit, Feature_In64BitModeBit, },
  {Feature_HasAVXBit, Feature_NoBWIBit, },
  {Feature_HasAVXBit, Feature_NoVLXBit, },
  {Feature_HasAVXBit, Feature_NoVLX_Or_NoBWIBit, },
  {Feature_HasAVX10_2Bit, Feature_HasSM4Bit, },
  {Feature_HasAVX10_2_512Bit, Feature_HasSM4Bit, },
  {Feature_HasAVX2Bit, Feature_NoVLXBit, },
  {Feature_HasAVX2Bit, Feature_NoVLX_Or_NoBWIBit, },
  {Feature_HasAVX512Bit, Feature_HasVAESBit, },
  {Feature_HasAVX512Bit, Feature_HasVLXBit, },
  {Feature_HasAVX512Bit, Feature_HasVPCLMULQDQBit, },
  {Feature_HasAVX512Bit, Feature_NoBWIBit, },
  {Feature_HasAVX512Bit, Feature_NoDQIBit, },
  {Feature_HasAVX512Bit, Feature_NoEGPRBit, },
  {Feature_HasAVX512Bit, Feature_OptForSizeBit, },
  {Feature_HasBITALGBit, Feature_HasVLXBit, },
  {Feature_HasBMIBit, Feature_HasEGPRBit, },
  {Feature_HasBMIBit, Feature_NoEGPRBit, },
  {Feature_HasBMI2Bit, Feature_HasEGPRBit, },
  {Feature_HasBMI2Bit, Feature_NoEGPRBit, },
  {Feature_HasBWIBit, Feature_HasVLXBit, },
  {Feature_HasBWIBit, Feature_NoEGPRBit, },
  {Feature_HasCDIBit, Feature_HasVLXBit, },
  {Feature_HasCRC32Bit, Feature_NoEGPRBit, },
  {Feature_HasDQIBit, Feature_HasVLXBit, },
  {Feature_HasDQIBit, Feature_NoBWIBit, },
  {Feature_HasDQIBit, Feature_NoEGPRBit, },
  {Feature_HasEGPRBit, Feature_HasINVPCIDBit, },
  {Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasFMA4Bit, Feature_NoAVX512Bit, },
  {Feature_HasFMA4Bit, Feature_NoVLXBit, },
  {Feature_HasFP16Bit, Feature_HasVLXBit, },
  {Feature_HasFP16Bit, Feature_In64BitModeBit, },
  {Feature_HasFP16Bit, Feature_OptForSizeBit, },
  {Feature_HasFSGSBaseBit, Feature_In64BitModeBit, },
  {Feature_HasFXSRBit, Feature_In64BitModeBit, },
  {Feature_HasINVPCIDBit, Feature_NoEGPRBit, },
  {Feature_HasINVPCIDBit, Feature_Not64BitModeBit, },
  {Feature_HasMOVBEBit, Feature_NoEGPRBit, },
  {Feature_HasMOVDIR64BBit, Feature_NoEGPRBit, },
  {Feature_HasMOVDIRIBit, Feature_NoEGPRBit, },
  {Feature_HasNDDBit, Feature_In64BitModeBit, },
  {Feature_HasNDDBit, Feature_UseIncDecBit, },
  {Feature_HasPCLMULBit, Feature_NoAVXBit, },
  {Feature_HasPREFETCHIBit, Feature_In64BitModeBit, },
  {Feature_HasPTWRITEBit, Feature_In64BitModeBit, },
  {Feature_HasRDPIDBit, Feature_In64BitModeBit, },
  {Feature_HasRDPIDBit, Feature_Not64BitModeBit, },
  {Feature_HasUINTRBit, Feature_In64BitModeBit, },
  {Feature_HasUSERMSRBit, Feature_NoEGPRBit, },
  {Feature_HasVAESBit, Feature_HasVLXBit, },
  {Feature_HasVAESBit, Feature_NoVLXBit, },
  {Feature_HasVBMI2Bit, Feature_HasVLXBit, },
  {Feature_HasVLXBit, Feature_HasVPCLMULQDQBit, },
  {Feature_HasVLXBit, Feature_HasVPOPCNTDQBit, },
  {Feature_HasVPCLMULQDQBit, Feature_NoVLXBit, },
  {Feature_HasWAITPKGBit, Feature_In64BitModeBit, },
  {Feature_HasWAITPKGBit, Feature_Not64BitModeBit, },
  {Feature_HasXSAVEBit, Feature_In64BitModeBit, },
  {Feature_HasXSAVECBit, Feature_In64BitModeBit, },
  {Feature_HasXSAVEOPTBit, Feature_In64BitModeBit, },
  {Feature_HasXSAVESBit, Feature_In64BitModeBit, },
  {Feature_In64BitModeBit, Feature_UseIncDecBit, },
  {Feature_In64BitModeBit, Feature_UseSSE2Bit, },
  {Feature_NoNDDBit, Feature_UseIncDecBit, },
  {Feature_Not64BitModeBit, Feature_OptForSizeBit, },
  {Feature_NotWin64WithoutFPBit, Feature_OptForMinSizeBit, },
  {Feature_OptForSizeBit, Feature_UseAVXBit, },
  {Feature_OptForSizeBit, Feature_UseSSE1Bit, },
  {Feature_OptForSizeBit, Feature_UseSSE2Bit, },
  {Feature_HasAESBit, Feature_HasAVXBit, Feature_NoVLX_Or_NoVAESBit, },
  {Feature_HasAMXAVX512Bit, Feature_HasAVX10_2_512Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXBF16Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXCOMPLEXBit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP16Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTF32Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTILEBit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTILEBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
  {Feature_HasAVXBit, Feature_HasPCLMULBit, Feature_NoVLX_Or_NoVPCLMULQDQBit, },
  {Feature_HasAVX10_2Bit, Feature_HasMOVRSBit, Feature_In64BitModeBit, },
  {Feature_HasAVX10_2_512Bit, Feature_HasMOVRSBit, Feature_In64BitModeBit, },
  {Feature_HasAVX512Bit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasAVX512Bit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasBITALGBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasBWIBit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasBWIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasCDIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasCRC32Bit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasDQIBit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasDQIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasDQIBit, Feature_HasVLXBit, Feature_NoBWIBit, },
  {Feature_HasEGPRBit, Feature_HasMOVBEBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasMOVDIR64BBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasMOVDIRIBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasMOVRSBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasUSERMSRBit, Feature_In64BitModeBit, },
  {Feature_HasEVEX512Bit, Feature_HasVPOPCNTDQBit, Feature_NoVLXBit, },
  {Feature_HasFMABit, Feature_NoAVX512Bit, Feature_NoFMA4Bit, },
  {Feature_HasFMABit, Feature_NoFMA4Bit, Feature_NoVLXBit, },
  {Feature_HasMOVBEBit, Feature_HasNDDBit, Feature_In64BitModeBit, },
  {Feature_HasMOVDIR64BBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
  {Feature_HasMOVDIRIBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
  {Feature_HasMOVRSBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addr,
};
// See constructor for table contents

X86InstructionSelector::ComplexMatcherMemFn
X86InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &X86InstructionSelector::selectAddr, // gi_addr
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_alignedload = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_alignedstore,
  GICXXPred_MI_Predicate_imm_su,
  GICXXPred_MI_Predicate_loadi8,
  GICXXPred_MI_Predicate_loadi16,
  GICXXPred_MI_Predicate_loadi32,
};
bool X86InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_alignedload: {
    
        auto &LdSt = cast<GLoadStore>(MI);
        return LdSt.getAlign() >= LdSt.getMemSize().getValue();
      
    llvm_unreachable("alignedload should have returned");
  }
  case GICXXPred_MI_Predicate_alignedstore: {
    
        auto &LdSt = cast<GLoadStore>(MI);
        return LdSt.getAlign() >= LdSt.getMemSize().getValue();
      
    llvm_unreachable("alignedstore should have returned");
  }
  case GICXXPred_MI_Predicate_imm_su: {
     return true; 
  }
  case GICXXPred_MI_Predicate_loadi8: {
     return isa<GLoad>(MI); 
  }
  case GICXXPred_MI_Predicate_loadi16: {
    
        auto &Load = cast<GLoad>(MI);
        LLT Ty = MRI.getType(Load.getDstReg());
        // Non extending load has MMO and destination types of the same size
        if (Load.getMemSizeInBits() == Ty.getSizeInBits())
           return true;
        return Load.getAlign() >= 2 && Load.isSimple();
      
    llvm_unreachable("loadi16 should have returned");
  }
  case GICXXPred_MI_Predicate_loadi32: {
    
        auto &Load = cast<GLoad>(MI);
        LLT Ty = MRI.getType(Load.getDstReg());
        // Non extending load has MMO and destination types of the same size
        if (Load.getMemSizeInBits() == Ty.getSizeInBits())
           return true;
        return Load.getAlign() >= 4 && Load.isSimple();
      
    llvm_unreachable("loadi32 should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_AndMask64 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_BTCBTSMask64,
  GICXXPred_I64_Predicate_BTRMask64,
  GICXXPred_I64_Predicate_i16immSExt8,
  GICXXPred_I64_Predicate_i32immSExt8,
  GICXXPred_I64_Predicate_i64immSExt8,
  GICXXPred_I64_Predicate_i64immSExt32,
  GICXXPred_I64_Predicate_i64immZExt32,
  GICXXPred_I64_Predicate_i64immZExt32SExt8,
  GICXXPred_I64_Predicate_i64timmSExt32,
  GICXXPred_I64_Predicate_immff00_ffff,
};
bool X86InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_AndMask64: {
    
      return isMask_64(Imm) && !isUInt<32>(Imm);
    
  }
  case GICXXPred_I64_Predicate_BTCBTSMask64: {
    
      return !isInt<32>(Imm) && isPowerOf2_64(Imm);
    
  }
  case GICXXPred_I64_Predicate_BTRMask64: {
    
      return !isUInt<32>(Imm) && !isInt<32>(Imm) && isPowerOf2_64(~Imm);
    
  }
  case GICXXPred_I64_Predicate_i16immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i32immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immSExt32: {
     return isInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immZExt32: {
     return isUInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immZExt32SExt8: {
    
      return isUInt<32>(Imm) && isInt<8>(static_cast<int32_t>(Imm));
    
  }
  case GICXXPred_I64_Predicate_i64timmSExt32: {
     return isInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_immff00_ffff: {
    
      return Imm >= 0xff00 && Imm <= 0xffff;
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm1,
  GICXXPred_APFloat_Predicate_fpimmneg0,
  GICXXPred_APFloat_Predicate_fpimmneg1,
};
bool X86InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm1: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmneg0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmneg1: {
    
      return Imm.isExactlyValue(-1.0);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool X86InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool X86InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("X86InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
X86InstructionSelector::CustomRendererFn
X86InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool X86InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool X86InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("X86InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *X86InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(287), /*)*//*default:*//*Label 77*/ GIMT_Encode4(228511),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(946),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(7179),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(10715), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 3*/ GIMT_Encode4(14498),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 4*/ GIMT_Encode4(25090),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 5*/ GIMT_Encode4(33494), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 6*/ GIMT_Encode4(46195), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 7*/ GIMT_Encode4(46362), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 8*/ GIMT_Encode4(48628),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 9*/ GIMT_Encode4(51806), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 10*/ GIMT_Encode4(53026),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 11*/ GIMT_Encode4(59235),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 12*/ GIMT_Encode4(59568), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 13*/ GIMT_Encode4(60223), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 14*/ GIMT_Encode4(85233),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 15*/ GIMT_Encode4(85469), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    290 */ /*TargetOpcode::G_PREFETCH*//*Label 16*/ GIMT_Encode4(85717), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    306 */ /*TargetOpcode::G_INTRINSIC*//*Label 17*/ GIMT_Encode4(86036),
     /*    310 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 18*/ GIMT_Encode4(99862), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    322 */ /*TargetOpcode::G_ANYEXT*//*Label 19*/ GIMT_Encode4(108937),
     /*    326 */ /*TargetOpcode::G_TRUNC*//*Label 20*/ GIMT_Encode4(109372),
     /*    330 */ /*TargetOpcode::G_CONSTANT*//*Label 21*/ GIMT_Encode4(110461),
     /*    334 */ /*TargetOpcode::G_FCONSTANT*//*Label 22*/ GIMT_Encode4(111067), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    346 */ /*TargetOpcode::G_SEXT*//*Label 23*/ GIMT_Encode4(111520),
     /*    350 */ /*TargetOpcode::G_SEXT_INREG*//*Label 24*/ GIMT_Encode4(113192),
     /*    354 */ /*TargetOpcode::G_ZEXT*//*Label 25*/ GIMT_Encode4(113434),
     /*    358 */ /*TargetOpcode::G_SHL*//*Label 26*/ GIMT_Encode4(115418),
     /*    362 */ /*TargetOpcode::G_LSHR*//*Label 27*/ GIMT_Encode4(117702),
     /*    366 */ /*TargetOpcode::G_ASHR*//*Label 28*/ GIMT_Encode4(119746),
     /*    370 */ /*TargetOpcode::G_FSHL*//*Label 29*/ GIMT_Encode4(121790),
     /*    374 */ /*TargetOpcode::G_FSHR*//*Label 30*/ GIMT_Encode4(122518),
     /*    378 */ /*TargetOpcode::G_ROTR*//*Label 31*/ GIMT_Encode4(123206),
     /*    382 */ /*TargetOpcode::G_ROTL*//*Label 32*/ GIMT_Encode4(126704),
     /*    386 */ /*TargetOpcode::G_ICMP*//*Label 33*/ GIMT_Encode4(130424), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    402 */ /*TargetOpcode::G_SELECT*//*Label 34*/ GIMT_Encode4(132081), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    446 */ /*TargetOpcode::G_UMULH*//*Label 35*/ GIMT_Encode4(139747),
     /*    450 */ /*TargetOpcode::G_SMULH*//*Label 36*/ GIMT_Encode4(140612),
     /*    454 */ /*TargetOpcode::G_UADDSAT*//*Label 37*/ GIMT_Encode4(141477),
     /*    458 */ /*TargetOpcode::G_SADDSAT*//*Label 38*/ GIMT_Encode4(143163),
     /*    462 */ /*TargetOpcode::G_USUBSAT*//*Label 39*/ GIMT_Encode4(144849),
     /*    466 */ /*TargetOpcode::G_SSUBSAT*//*Label 40*/ GIMT_Encode4(145915), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    510 */ /*TargetOpcode::G_FADD*//*Label 41*/ GIMT_Encode4(146981),
     /*    514 */ /*TargetOpcode::G_FSUB*//*Label 42*/ GIMT_Encode4(152083),
     /*    518 */ /*TargetOpcode::G_FMUL*//*Label 43*/ GIMT_Encode4(155477),
     /*    522 */ /*TargetOpcode::G_FMA*//*Label 44*/ GIMT_Encode4(160579), GIMT_Encode4(0),
     /*    530 */ /*TargetOpcode::G_FDIV*//*Label 45*/ GIMT_Encode4(166567), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    578 */ /*TargetOpcode::G_FNEG*//*Label 46*/ GIMT_Encode4(169961),
     /*    582 */ /*TargetOpcode::G_FPEXT*//*Label 47*/ GIMT_Encode4(170084),
     /*    586 */ /*TargetOpcode::G_FPTRUNC*//*Label 48*/ GIMT_Encode4(171016),
     /*    590 */ /*TargetOpcode::G_FPTOSI*//*Label 49*/ GIMT_Encode4(171402),
     /*    594 */ /*TargetOpcode::G_FPTOUI*//*Label 50*/ GIMT_Encode4(172783),
     /*    598 */ /*TargetOpcode::G_SITOFP*//*Label 51*/ GIMT_Encode4(173339),
     /*    602 */ /*TargetOpcode::G_UITOFP*//*Label 52*/ GIMT_Encode4(176715), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    614 */ /*TargetOpcode::G_FABS*//*Label 53*/ GIMT_Encode4(178962), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    686 */ /*TargetOpcode::G_SMIN*//*Label 54*/ GIMT_Encode4(179085),
     /*    690 */ /*TargetOpcode::G_SMAX*//*Label 55*/ GIMT_Encode4(182406),
     /*    694 */ /*TargetOpcode::G_UMIN*//*Label 56*/ GIMT_Encode4(185727),
     /*    698 */ /*TargetOpcode::G_UMAX*//*Label 57*/ GIMT_Encode4(189048),
     /*    702 */ /*TargetOpcode::G_ABS*//*Label 58*/ GIMT_Encode4(192369), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    714 */ /*TargetOpcode::G_BR*//*Label 59*/ GIMT_Encode4(194250), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 60*/ GIMT_Encode4(194266), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    754 */ /*TargetOpcode::G_VECTOR_COMPRESS*//*Label 61*/ GIMT_Encode4(197195),
     /*    758 */ /*TargetOpcode::G_CTTZ*//*Label 62*/ GIMT_Encode4(199177),
     /*    762 */ /*TargetOpcode::G_CTTZ_ZERO_UNDEF*//*Label 63*/ GIMT_Encode4(199483),
     /*    766 */ /*TargetOpcode::G_CTLZ*//*Label 64*/ GIMT_Encode4(199870), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTPOP*//*Label 65*/ GIMT_Encode4(201174),
     /*    778 */ /*TargetOpcode::G_BSWAP*//*Label 66*/ GIMT_Encode4(203436), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    834 */ /*TargetOpcode::G_FSQRT*//*Label 67*/ GIMT_Encode4(203936), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    874 */ /*TargetOpcode::G_STRICT_FADD*//*Label 68*/ GIMT_Encode4(206105),
     /*    878 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 69*/ GIMT_Encode4(210271),
     /*    882 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 70*/ GIMT_Encode4(213197),
     /*    886 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 71*/ GIMT_Encode4(217363), GIMT_Encode4(0),
     /*    894 */ /*TargetOpcode::G_STRICT_FMA*//*Label 72*/ GIMT_Encode4(220289),
     /*    898 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 73*/ GIMT_Encode4(226277), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    934 */ /*TargetOpcode::G_TRAP*//*Label 74*/ GIMT_Encode4(228446),
     /*    938 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 75*/ GIMT_Encode4(228459),
     /*    942 */ /*TargetOpcode::G_UBSANTRAP*//*Label 76*/ GIMT_Encode4(228495),
     /*    946 */ // Label 0: @946
     /*    946 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 94*/ GIMT_Encode4(7178),
     /*    957 */ /*GILLT_s8*//*Label 78*/ GIMT_Encode4(1053),
     /*    961 */ /*GILLT_s16*//*Label 79*/ GIMT_Encode4(1558),
     /*    965 */ /*GILLT_s32*//*Label 80*/ GIMT_Encode4(2208),
     /*    969 */ /*GILLT_s64*//*Label 81*/ GIMT_Encode4(2858), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    985 */ /*GILLT_v2s64*//*Label 82*/ GIMT_Encode4(3682), GIMT_Encode4(0),
     /*    993 */ /*GILLT_v4s32*//*Label 83*/ GIMT_Encode4(4024),
     /*    997 */ /*GILLT_v4s64*//*Label 84*/ GIMT_Encode4(4488), GIMT_Encode4(0),
     /*   1005 */ /*GILLT_v8s16*//*Label 85*/ GIMT_Encode4(4803),
     /*   1009 */ /*GILLT_v8s32*//*Label 86*/ GIMT_Encode4(5267),
     /*   1013 */ /*GILLT_v8s64*//*Label 87*/ GIMT_Encode4(5582), GIMT_Encode4(0),
     /*   1021 */ /*GILLT_v16s8*//*Label 88*/ GIMT_Encode4(5738),
     /*   1025 */ /*GILLT_v16s16*//*Label 89*/ GIMT_Encode4(6080),
     /*   1029 */ /*GILLT_v16s32*//*Label 90*/ GIMT_Encode4(6395), GIMT_Encode4(0),
     /*   1037 */ /*GILLT_v32s8*//*Label 91*/ GIMT_Encode4(6551),
     /*   1041 */ /*GILLT_v32s16*//*Label 92*/ GIMT_Encode4(6866), GIMT_Encode4(0),
     /*   1049 */ /*GILLT_v64s8*//*Label 93*/ GIMT_Encode4(7022),
     /*   1053 */ // Label 78: @1053
     /*   1053 */ GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1557),
     /*   1058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*   1061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*   1064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1068 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1129), // Rule ID 26051 //
     /*   1073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1084 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1087 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1091 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1101 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1108 */     // (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (ADD8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm),
     /*   1111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1113 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1115 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1127 */     GIR_RootConstrainSelectedInstOperands,
     /*   1128 */     // GIR_Coverage, 26051,
     /*   1128 */     GIR_EraseRootFromParent_Done,
     /*   1129 */   // Label 96: @1129
     /*   1129 */   GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1190), // Rule ID 26070 //
     /*   1134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1145 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1148 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1152 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1169 */     // (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (ADD8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm_ND),
     /*   1172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1174 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1176 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1188 */     GIR_RootConstrainSelectedInstOperands,
     /*   1189 */     // GIR_Coverage, 26070,
     /*   1189 */     GIR_EraseRootFromParent_Done,
     /*   1190 */   // Label 97: @1190
     /*   1190 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1251), // Rule ID 22793 //
     /*   1195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1210 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1213 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1217 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1223 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1230 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (ADD8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm),
     /*   1233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1235 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1237 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1241 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1249 */     GIR_RootConstrainSelectedInstOperands,
     /*   1250 */     // GIR_Coverage, 22793,
     /*   1250 */     GIR_EraseRootFromParent_Done,
     /*   1251 */   // Label 98: @1251
     /*   1251 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1312), // Rule ID 22883 //
     /*   1256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1271 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1274 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1278 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1284 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1291 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (ADD8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm_ND),
     /*   1294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1296 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1298 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1302 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1310 */     GIR_RootConstrainSelectedInstOperands,
     /*   1311 */     // GIR_Coverage, 22883,
     /*   1311 */     GIR_EraseRootFromParent_Done,
     /*   1312 */   // Label 99: @1312
     /*   1312 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1340), // Rule ID 22859 //
     /*   1317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   1320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   1328 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, 1:{ *:[i8] })  =>  (INC8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8r),
     /*   1331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1333 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1338 */     GIR_RootConstrainSelectedInstOperands,
     /*   1339 */     // GIR_Coverage, 22859,
     /*   1339 */     GIR_EraseRootFromParent_Done,
     /*   1340 */   // Label 100: @1340
     /*   1340 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1368), // Rule ID 22863 //
     /*   1345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   1348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   1356 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, -1:{ *:[i8] })  =>  (DEC8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8r),
     /*   1359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1361 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1363 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1366 */     GIR_RootConstrainSelectedInstOperands,
     /*   1367 */     // GIR_Coverage, 22863,
     /*   1367 */     GIR_EraseRootFromParent_Done,
     /*   1368 */   // Label 101: @1368
     /*   1368 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1396), // Rule ID 22949 //
     /*   1373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   1376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   1384 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, 1:{ *:[i8] })  =>  (INC8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8r_ND),
     /*   1387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1389 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1391 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1394 */     GIR_RootConstrainSelectedInstOperands,
     /*   1395 */     // GIR_Coverage, 22949,
     /*   1395 */     GIR_EraseRootFromParent_Done,
     /*   1396 */   // Label 102: @1396
     /*   1396 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1424), // Rule ID 22953 //
     /*   1401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   1404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   1412 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, -1:{ *:[i8] })  =>  (DEC8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8r_ND),
     /*   1415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1417 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1422 */     GIR_RootConstrainSelectedInstOperands,
     /*   1423 */     // GIR_Coverage, 22953,
     /*   1423 */     GIR_EraseRootFromParent_Done,
     /*   1424 */   // Label 103: @1424
     /*   1424 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1461), // Rule ID 22797 //
     /*   1429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1444 */     // MIs[1] Operand 1
     /*   1444 */     // No operand predicates
     /*   1444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1446 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ADD8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   1446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri),
     /*   1449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1451 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   1456 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1459 */     GIR_RootConstrainSelectedInstOperands,
     /*   1460 */     // GIR_Coverage, 22797,
     /*   1460 */     GIR_EraseRootFromParent_Done,
     /*   1461 */   // Label 104: @1461
     /*   1461 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1498), // Rule ID 22887 //
     /*   1466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1481 */     // MIs[1] Operand 1
     /*   1481 */     // No operand predicates
     /*   1481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1483 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ADD8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   1483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri_ND),
     /*   1486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1488 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   1493 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1496 */     GIR_RootConstrainSelectedInstOperands,
     /*   1497 */     // GIR_Coverage, 22887,
     /*   1497 */     GIR_EraseRootFromParent_Done,
     /*   1498 */   // Label 105: @1498
     /*   1498 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1527), // Rule ID 22789 //
     /*   1503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1514 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (ADD8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   1514 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD8rr),
     /*   1519 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   1525 */     GIR_RootConstrainSelectedInstOperands,
     /*   1526 */     // GIR_Coverage, 22789,
     /*   1526 */     GIR_Done,
     /*   1527 */   // Label 106: @1527
     /*   1527 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1556), // Rule ID 22879 //
     /*   1532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1543 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (ADD8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   1543 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD8rr_ND),
     /*   1548 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   1554 */     GIR_RootConstrainSelectedInstOperands,
     /*   1555 */     // GIR_Coverage, 22879,
     /*   1555 */     GIR_Done,
     /*   1556 */   // Label 107: @1556
     /*   1556 */   GIM_Reject,
     /*   1557 */ // Label 95: @1557
     /*   1557 */ GIM_Reject,
     /*   1558 */ // Label 79: @1558
     /*   1558 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(2207),
     /*   1563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   1566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*   1569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1573 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1642), // Rule ID 22614 //
     /*   1578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1589 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1592 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1596 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1600 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   1611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1620 */     // (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 128:{ *:[i16] })  =>  (SUB16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -128:{ *:[i16] })
     /*   1620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi_ND),
     /*   1623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   1629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   1632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1640 */     GIR_RootConstrainSelectedInstOperands,
     /*   1641 */     // GIR_Coverage, 22614,
     /*   1641 */     GIR_EraseRootFromParent_Done,
     /*   1642 */   // Label 109: @1642
     /*   1642 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1703), // Rule ID 26052 //
     /*   1647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1658 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1661 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1665 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1682 */     // (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (ADD16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm),
     /*   1685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1687 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1689 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1693 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1701 */     GIR_RootConstrainSelectedInstOperands,
     /*   1702 */     // GIR_Coverage, 26052,
     /*   1702 */     GIR_EraseRootFromParent_Done,
     /*   1703 */   // Label 110: @1703
     /*   1703 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1764), // Rule ID 26071 //
     /*   1708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1719 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1722 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1726 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1736 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1743 */     // (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (ADD16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm_ND),
     /*   1746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1748 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1750 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1762 */     GIR_RootConstrainSelectedInstOperands,
     /*   1763 */     // GIR_Coverage, 26071,
     /*   1763 */     GIR_EraseRootFromParent_Done,
     /*   1764 */   // Label 111: @1764
     /*   1764 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1825), // Rule ID 22794 //
     /*   1769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1784 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1787 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1791 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1804 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (ADD16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm),
     /*   1807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1809 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1811 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1815 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1823 */     GIR_RootConstrainSelectedInstOperands,
     /*   1824 */     // GIR_Coverage, 22794,
     /*   1824 */     GIR_EraseRootFromParent_Done,
     /*   1825 */   // Label 112: @1825
     /*   1825 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1886), // Rule ID 22884 //
     /*   1830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1845 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1848 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1852 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1865 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (ADD16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm_ND),
     /*   1868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1870 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1872 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1876 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1884 */     GIR_RootConstrainSelectedInstOperands,
     /*   1885 */     // GIR_Coverage, 22884,
     /*   1885 */     GIR_EraseRootFromParent_Done,
     /*   1886 */   // Label 113: @1886
     /*   1886 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1924), // Rule ID 22599 //
     /*   1891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1898 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   1909 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, 128:{ *:[i16] })  =>  (SUB16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -128:{ *:[i16] })
     /*   1909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri),
     /*   1912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1914 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   1919 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1922 */     GIR_RootConstrainSelectedInstOperands,
     /*   1923 */     // GIR_Coverage, 22599,
     /*   1923 */     GIR_EraseRootFromParent_Done,
     /*   1924 */   // Label 114: @1924
     /*   1924 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1962), // Rule ID 22605 //
     /*   1929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1936 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   1947 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, 128:{ *:[i16] })  =>  (SUB16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -128:{ *:[i16] })
     /*   1947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri_ND),
     /*   1950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1952 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   1957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1960 */     GIR_RootConstrainSelectedInstOperands,
     /*   1961 */     // GIR_Coverage, 22605,
     /*   1961 */     GIR_EraseRootFromParent_Done,
     /*   1962 */   // Label 115: @1962
     /*   1962 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1990), // Rule ID 22860 //
     /*   1967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   1970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1974 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   1978 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, 1:{ *:[i16] })  =>  (INC16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   1978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16r),
     /*   1981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1983 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1988 */     GIR_RootConstrainSelectedInstOperands,
     /*   1989 */     // GIR_Coverage, 22860,
     /*   1989 */     GIR_EraseRootFromParent_Done,
     /*   1990 */   // Label 116: @1990
     /*   1990 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(2018), // Rule ID 22864 //
     /*   1995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   1998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2006 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, -1:{ *:[i16] })  =>  (DEC16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16r),
     /*   2009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2011 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2013 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2016 */     GIR_RootConstrainSelectedInstOperands,
     /*   2017 */     // GIR_Coverage, 22864,
     /*   2017 */     GIR_EraseRootFromParent_Done,
     /*   2018 */   // Label 117: @2018
     /*   2018 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(2046), // Rule ID 22950 //
     /*   2023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2034 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, 1:{ *:[i16] })  =>  (INC16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16r_ND),
     /*   2037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2039 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2041 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2044 */     GIR_RootConstrainSelectedInstOperands,
     /*   2045 */     // GIR_Coverage, 22950,
     /*   2045 */     GIR_EraseRootFromParent_Done,
     /*   2046 */   // Label 118: @2046
     /*   2046 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(2074), // Rule ID 22954 //
     /*   2051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2058 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2062 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, -1:{ *:[i16] })  =>  (DEC16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16r_ND),
     /*   2065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2067 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2072 */     GIR_RootConstrainSelectedInstOperands,
     /*   2073 */     // GIR_Coverage, 22954,
     /*   2073 */     GIR_EraseRootFromParent_Done,
     /*   2074 */   // Label 119: @2074
     /*   2074 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(2111), // Rule ID 22798 //
     /*   2079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2094 */     // MIs[1] Operand 1
     /*   2094 */     // No operand predicates
     /*   2094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2096 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (ADD16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   2096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri),
     /*   2099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2101 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2109 */     GIR_RootConstrainSelectedInstOperands,
     /*   2110 */     // GIR_Coverage, 22798,
     /*   2110 */     GIR_EraseRootFromParent_Done,
     /*   2111 */   // Label 120: @2111
     /*   2111 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(2148), // Rule ID 22888 //
     /*   2116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2131 */     // MIs[1] Operand 1
     /*   2131 */     // No operand predicates
     /*   2131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2133 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (ADD16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   2133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri_ND),
     /*   2136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2138 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2143 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2146 */     GIR_RootConstrainSelectedInstOperands,
     /*   2147 */     // GIR_Coverage, 22888,
     /*   2147 */     GIR_EraseRootFromParent_Done,
     /*   2148 */   // Label 121: @2148
     /*   2148 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(2177), // Rule ID 22790 //
     /*   2153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2164 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (ADD16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   2164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD16rr),
     /*   2169 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   2175 */     GIR_RootConstrainSelectedInstOperands,
     /*   2176 */     // GIR_Coverage, 22790,
     /*   2176 */     GIR_Done,
     /*   2177 */   // Label 122: @2177
     /*   2177 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(2206), // Rule ID 22880 //
     /*   2182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2193 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (ADD16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   2193 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD16rr_ND),
     /*   2198 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   2204 */     GIR_RootConstrainSelectedInstOperands,
     /*   2205 */     // GIR_Coverage, 22880,
     /*   2205 */     GIR_Done,
     /*   2206 */   // Label 123: @2206
     /*   2206 */   GIM_Reject,
     /*   2207 */ // Label 108: @2207
     /*   2207 */ GIM_Reject,
     /*   2208 */ // Label 80: @2208
     /*   2208 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(2857),
     /*   2213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2223 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(2292), // Rule ID 22615 //
     /*   2228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2239 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2242 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2246 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2250 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2263 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2270 */     // (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 128:{ *:[i32] })  =>  (SUB32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -128:{ *:[i32] })
     /*   2270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi_ND),
     /*   2273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2275 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   2279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2290 */     GIR_RootConstrainSelectedInstOperands,
     /*   2291 */     // GIR_Coverage, 22615,
     /*   2291 */     GIR_EraseRootFromParent_Done,
     /*   2292 */   // Label 125: @2292
     /*   2292 */   GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(2353), // Rule ID 26053 //
     /*   2297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2308 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2311 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2315 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2332 */     // (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (ADD32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm),
     /*   2335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2337 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   2339 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2343 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2351 */     GIR_RootConstrainSelectedInstOperands,
     /*   2352 */     // GIR_Coverage, 26053,
     /*   2352 */     GIR_EraseRootFromParent_Done,
     /*   2353 */   // Label 126: @2353
     /*   2353 */   GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(2414), // Rule ID 26072 //
     /*   2358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2369 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2372 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2376 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2393 */     // (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (ADD32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm_ND),
     /*   2396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2398 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   2400 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2404 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2412 */     GIR_RootConstrainSelectedInstOperands,
     /*   2413 */     // GIR_Coverage, 26072,
     /*   2413 */     GIR_EraseRootFromParent_Done,
     /*   2414 */   // Label 127: @2414
     /*   2414 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(2475), // Rule ID 22795 //
     /*   2419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2434 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2437 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2441 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2454 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ADD32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm),
     /*   2457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2459 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2461 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2473 */     GIR_RootConstrainSelectedInstOperands,
     /*   2474 */     // GIR_Coverage, 22795,
     /*   2474 */     GIR_EraseRootFromParent_Done,
     /*   2475 */   // Label 128: @2475
     /*   2475 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(2536), // Rule ID 22885 //
     /*   2480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2495 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2498 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2502 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2508 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2515 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ADD32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm_ND),
     /*   2518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2520 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2522 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2526 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2534 */     GIR_RootConstrainSelectedInstOperands,
     /*   2535 */     // GIR_Coverage, 22885,
     /*   2535 */     GIR_EraseRootFromParent_Done,
     /*   2536 */   // Label 129: @2536
     /*   2536 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(2574), // Rule ID 22600 //
     /*   2541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2548 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2559 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, 128:{ *:[i32] })  =>  (SUB32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -128:{ *:[i32] })
     /*   2559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri),
     /*   2562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2564 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2572 */     GIR_RootConstrainSelectedInstOperands,
     /*   2573 */     // GIR_Coverage, 22600,
     /*   2573 */     GIR_EraseRootFromParent_Done,
     /*   2574 */   // Label 130: @2574
     /*   2574 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(2612), // Rule ID 22606 //
     /*   2579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2586 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2597 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, 128:{ *:[i32] })  =>  (SUB32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -128:{ *:[i32] })
     /*   2597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri_ND),
     /*   2600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2602 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2610 */     GIR_RootConstrainSelectedInstOperands,
     /*   2611 */     // GIR_Coverage, 22606,
     /*   2611 */     GIR_EraseRootFromParent_Done,
     /*   2612 */   // Label 131: @2612
     /*   2612 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(2640), // Rule ID 22861 //
     /*   2617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   2620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2628 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (INC32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32r),
     /*   2631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2633 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2635 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2638 */     GIR_RootConstrainSelectedInstOperands,
     /*   2639 */     // GIR_Coverage, 22861,
     /*   2639 */     GIR_EraseRootFromParent_Done,
     /*   2640 */   // Label 132: @2640
     /*   2640 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(2668), // Rule ID 22865 //
     /*   2645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   2648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2656 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] })  =>  (DEC32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32r),
     /*   2659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2661 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2666 */     GIR_RootConstrainSelectedInstOperands,
     /*   2667 */     // GIR_Coverage, 22865,
     /*   2667 */     GIR_EraseRootFromParent_Done,
     /*   2668 */   // Label 133: @2668
     /*   2668 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(2696), // Rule ID 22951 //
     /*   2673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2680 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2684 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (INC32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32r_ND),
     /*   2687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2689 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2691 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2694 */     GIR_RootConstrainSelectedInstOperands,
     /*   2695 */     // GIR_Coverage, 22951,
     /*   2695 */     GIR_EraseRootFromParent_Done,
     /*   2696 */   // Label 134: @2696
     /*   2696 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2724), // Rule ID 22955 //
     /*   2701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2708 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2712 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] })  =>  (DEC32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32r_ND),
     /*   2715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2717 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2719 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2722 */     GIR_RootConstrainSelectedInstOperands,
     /*   2723 */     // GIR_Coverage, 22955,
     /*   2723 */     GIR_EraseRootFromParent_Done,
     /*   2724 */   // Label 135: @2724
     /*   2724 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2761), // Rule ID 22799 //
     /*   2729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2744 */     // MIs[1] Operand 1
     /*   2744 */     // No operand predicates
     /*   2744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2746 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (ADD32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   2746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri),
     /*   2749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2751 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2756 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2759 */     GIR_RootConstrainSelectedInstOperands,
     /*   2760 */     // GIR_Coverage, 22799,
     /*   2760 */     GIR_EraseRootFromParent_Done,
     /*   2761 */   // Label 136: @2761
     /*   2761 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2798), // Rule ID 22889 //
     /*   2766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2781 */     // MIs[1] Operand 1
     /*   2781 */     // No operand predicates
     /*   2781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2783 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (ADD32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   2783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri_ND),
     /*   2786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2788 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2793 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2796 */     GIR_RootConstrainSelectedInstOperands,
     /*   2797 */     // GIR_Coverage, 22889,
     /*   2797 */     GIR_EraseRootFromParent_Done,
     /*   2798 */   // Label 137: @2798
     /*   2798 */   GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2827), // Rule ID 22791 //
     /*   2803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2814 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (ADD32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   2814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD32rr),
     /*   2819 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   2825 */     GIR_RootConstrainSelectedInstOperands,
     /*   2826 */     // GIR_Coverage, 22791,
     /*   2826 */     GIR_Done,
     /*   2827 */   // Label 138: @2827
     /*   2827 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2856), // Rule ID 22881 //
     /*   2832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2843 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (ADD32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   2843 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD32rr_ND),
     /*   2848 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   2854 */     GIR_RootConstrainSelectedInstOperands,
     /*   2855 */     // GIR_Coverage, 22881,
     /*   2855 */     GIR_Done,
     /*   2856 */   // Label 139: @2856
     /*   2856 */   GIM_Reject,
     /*   2857 */ // Label 124: @2857
     /*   2857 */ GIM_Reject,
     /*   2858 */ // Label 81: @2858
     /*   2858 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(3681),
     /*   2863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   2873 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2942), // Rule ID 22616 //
     /*   2878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2889 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2892 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   2896 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2900 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2920 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 128:{ *:[i64] })  =>  (SUB64mi32_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -128:{ *:[i64] })
     /*   2920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32_ND),
     /*   2923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2925 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   2929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2940 */     GIR_RootConstrainSelectedInstOperands,
     /*   2941 */     // GIR_Coverage, 22616,
     /*   2941 */     GIR_EraseRootFromParent_Done,
     /*   2942 */   // Label 141: @2942
     /*   2942 */   GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(3018), // Rule ID 22622 //
     /*   2947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2958 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2961 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   2965 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2969 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*   2980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2989 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 2147483648:{ *:[i64] })  =>  (SUB64mi32_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -2147483648:{ *:[i64] })
     /*   2989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32_ND),
     /*   2992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2994 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   2998 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*   3008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3016 */     GIR_RootConstrainSelectedInstOperands,
     /*   3017 */     // GIR_Coverage, 22622,
     /*   3017 */     GIR_EraseRootFromParent_Done,
     /*   3018 */   // Label 142: @3018
     /*   3018 */   GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(3079), // Rule ID 26054 //
     /*   3023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3034 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3037 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3041 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3051 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3058 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (ADD64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm),
     /*   3061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3063 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3065 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3077 */     GIR_RootConstrainSelectedInstOperands,
     /*   3078 */     // GIR_Coverage, 26054,
     /*   3078 */     GIR_EraseRootFromParent_Done,
     /*   3079 */   // Label 143: @3079
     /*   3079 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(3140), // Rule ID 26073 //
     /*   3084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3095 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3098 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3102 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3119 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (ADD64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm_ND),
     /*   3122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3124 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3126 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3138 */     GIR_RootConstrainSelectedInstOperands,
     /*   3139 */     // GIR_Coverage, 26073,
     /*   3139 */     GIR_EraseRootFromParent_Done,
     /*   3140 */   // Label 144: @3140
     /*   3140 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(3201), // Rule ID 22796 //
     /*   3145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3160 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3163 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3167 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3180 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm),
     /*   3183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3185 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3187 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3191 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3199 */     GIR_RootConstrainSelectedInstOperands,
     /*   3200 */     // GIR_Coverage, 22796,
     /*   3200 */     GIR_EraseRootFromParent_Done,
     /*   3201 */   // Label 145: @3201
     /*   3201 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(3262), // Rule ID 22886 //
     /*   3206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3221 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3224 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3228 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3234 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3241 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm_ND),
     /*   3244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3246 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3248 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3260 */     GIR_RootConstrainSelectedInstOperands,
     /*   3261 */     // GIR_Coverage, 22886,
     /*   3261 */     GIR_EraseRootFromParent_Done,
     /*   3262 */   // Label 146: @3262
     /*   3262 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(3300), // Rule ID 22601 //
     /*   3267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3274 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   3285 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 128:{ *:[i64] })  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -128:{ *:[i64] })
     /*   3285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*   3288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3290 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   3295 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3298 */     GIR_RootConstrainSelectedInstOperands,
     /*   3299 */     // GIR_Coverage, 22601,
     /*   3299 */     GIR_EraseRootFromParent_Done,
     /*   3300 */   // Label 147: @3300
     /*   3300 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(3338), // Rule ID 22607 //
     /*   3305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3312 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   3323 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 128:{ *:[i64] })  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -128:{ *:[i64] })
     /*   3323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*   3326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3328 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   3333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3336 */     GIR_RootConstrainSelectedInstOperands,
     /*   3337 */     // GIR_Coverage, 22607,
     /*   3337 */     GIR_EraseRootFromParent_Done,
     /*   3338 */   // Label 148: @3338
     /*   3338 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(3383), // Rule ID 22617 //
     /*   3343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3350 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*   3361 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 2147483648:{ *:[i64] })  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -2147483648:{ *:[i64] })
     /*   3361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*   3364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3366 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3368 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*   3378 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3381 */     GIR_RootConstrainSelectedInstOperands,
     /*   3382 */     // GIR_Coverage, 22617,
     /*   3382 */     GIR_EraseRootFromParent_Done,
     /*   3383 */   // Label 149: @3383
     /*   3383 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(3428), // Rule ID 22619 //
     /*   3388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3395 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*   3406 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 2147483648:{ *:[i64] })  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -2147483648:{ *:[i64] })
     /*   3406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*   3409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3411 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3413 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*   3423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3426 */     GIR_RootConstrainSelectedInstOperands,
     /*   3427 */     // GIR_Coverage, 22619,
     /*   3427 */     GIR_EraseRootFromParent_Done,
     /*   3428 */   // Label 150: @3428
     /*   3428 */   GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(3456), // Rule ID 22862 //
     /*   3433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   3436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   3444 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] })  =>  (INC64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64r),
     /*   3447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3449 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3451 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3454 */     GIR_RootConstrainSelectedInstOperands,
     /*   3455 */     // GIR_Coverage, 22862,
     /*   3455 */     GIR_EraseRootFromParent_Done,
     /*   3456 */   // Label 151: @3456
     /*   3456 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(3484), // Rule ID 22866 //
     /*   3461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   3464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   3472 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] })  =>  (DEC64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64r),
     /*   3475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3477 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3479 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3482 */     GIR_RootConstrainSelectedInstOperands,
     /*   3483 */     // GIR_Coverage, 22866,
     /*   3483 */     GIR_EraseRootFromParent_Done,
     /*   3484 */   // Label 152: @3484
     /*   3484 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(3512), // Rule ID 22952 //
     /*   3489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   3492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   3500 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] })  =>  (INC64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64r_ND),
     /*   3503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3505 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3510 */     GIR_RootConstrainSelectedInstOperands,
     /*   3511 */     // GIR_Coverage, 22952,
     /*   3511 */     GIR_EraseRootFromParent_Done,
     /*   3512 */   // Label 153: @3512
     /*   3512 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(3540), // Rule ID 22956 //
     /*   3517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   3520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   3528 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] })  =>  (DEC64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64r_ND),
     /*   3531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3533 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3535 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3538 */     GIR_RootConstrainSelectedInstOperands,
     /*   3539 */     // GIR_Coverage, 22956,
     /*   3539 */     GIR_EraseRootFromParent_Done,
     /*   3540 */   // Label 154: @3540
     /*   3540 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(3581), // Rule ID 22800 //
     /*   3545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   3560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   3564 */     // MIs[1] Operand 1
     /*   3564 */     // No operand predicates
     /*   3564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3566 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (ADD64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   3566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64ri32),
     /*   3569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3571 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   3576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3579 */     GIR_RootConstrainSelectedInstOperands,
     /*   3580 */     // GIR_Coverage, 22800,
     /*   3580 */     GIR_EraseRootFromParent_Done,
     /*   3581 */   // Label 155: @3581
     /*   3581 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(3622), // Rule ID 22890 //
     /*   3586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   3601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   3605 */     // MIs[1] Operand 1
     /*   3605 */     // No operand predicates
     /*   3605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3607 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (ADD64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   3607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64ri32_ND),
     /*   3610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3612 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   3617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3620 */     GIR_RootConstrainSelectedInstOperands,
     /*   3621 */     // GIR_Coverage, 22890,
     /*   3621 */     GIR_EraseRootFromParent_Done,
     /*   3622 */   // Label 156: @3622
     /*   3622 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(3651), // Rule ID 22792 //
     /*   3627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3638 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (ADD64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   3638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD64rr),
     /*   3643 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   3649 */     GIR_RootConstrainSelectedInstOperands,
     /*   3650 */     // GIR_Coverage, 22792,
     /*   3650 */     GIR_Done,
     /*   3651 */   // Label 157: @3651
     /*   3651 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(3680), // Rule ID 22882 //
     /*   3656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3667 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (ADD64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   3667 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD64rr_ND),
     /*   3672 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   3678 */     GIR_RootConstrainSelectedInstOperands,
     /*   3679 */     // GIR_Coverage, 22882,
     /*   3679 */     GIR_Done,
     /*   3680 */   // Label 158: @3680
     /*   3680 */   GIM_Reject,
     /*   3681 */ // Label 140: @3681
     /*   3681 */ GIM_Reject,
     /*   3682 */ // Label 82: @3682
     /*   3682 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(4023),
     /*   3687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   3690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   3693 */   GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(3755), // Rule ID 23435 //
     /*   3698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   3701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3713 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3716 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3720 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3737 */     // (add:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPADDQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQrm),
     /*   3740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3742 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3744 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3753 */     GIR_RootConstrainSelectedInstOperands,
     /*   3754 */     // GIR_Coverage, 23435,
     /*   3754 */     GIR_EraseRootFromParent_Done,
     /*   3755 */   // Label 160: @3755
     /*   3755 */   GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(3817), // Rule ID 23705 //
     /*   3760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   3763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   3767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3775 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3778 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3782 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   3790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3799 */     // (add:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPADDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ128rm),
     /*   3802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3804 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3806 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3815 */     GIR_RootConstrainSelectedInstOperands,
     /*   3816 */     // GIR_Coverage, 23705,
     /*   3816 */     GIR_EraseRootFromParent_Done,
     /*   3817 */   // Label 161: @3817
     /*   3817 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(3879), // Rule ID 2540 //
     /*   3822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   3825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3841 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3844 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3848 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3861 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQrm),
     /*   3864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3866 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3868 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3877 */     GIR_RootConstrainSelectedInstOperands,
     /*   3878 */     // GIR_Coverage, 2540,
     /*   3878 */     GIR_EraseRootFromParent_Done,
     /*   3879 */   // Label 162: @3879
     /*   3879 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(3941), // Rule ID 4653 //
     /*   3884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   3887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   3891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   3895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3903 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3906 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3910 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3923 */     // (add:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ128rm),
     /*   3926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3928 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3930 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3939 */     GIR_RootConstrainSelectedInstOperands,
     /*   3940 */     // GIR_Coverage, 4653,
     /*   3940 */     GIR_EraseRootFromParent_Done,
     /*   3941 */   // Label 163: @3941
     /*   3941 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(3968), // Rule ID 2539 //
     /*   3946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   3949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3961 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPADDQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   3961 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQrr),
     /*   3966 */     GIR_RootConstrainSelectedInstOperands,
     /*   3967 */     // GIR_Coverage, 2539,
     /*   3967 */     GIR_Done,
     /*   3968 */   // Label 164: @3968
     /*   3968 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(3995), // Rule ID 2541 //
     /*   3973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   3976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3988 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PADDQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   3988 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDQrr),
     /*   3993 */     GIR_RootConstrainSelectedInstOperands,
     /*   3994 */     // GIR_Coverage, 2541,
     /*   3994 */     GIR_Done,
     /*   3995 */   // Label 165: @3995
     /*   3995 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(4022), // Rule ID 4650 //
     /*   4000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4015 */     // (add:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPADDQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*   4015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZ128rr),
     /*   4020 */     GIR_RootConstrainSelectedInstOperands,
     /*   4021 */     // GIR_Coverage, 4650,
     /*   4021 */     GIR_Done,
     /*   4022 */   // Label 166: @4022
     /*   4022 */   GIM_Reject,
     /*   4023 */ // Label 159: @4023
     /*   4023 */ GIM_Reject,
     /*   4024 */ // Label 83: @4024
     /*   4024 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(4487),
     /*   4029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4035 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(4097), // Rule ID 23432 //
     /*   4040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4055 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4058 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4062 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4079 */     // (add:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPADDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDrm),
     /*   4082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4084 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4086 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4095 */     GIR_RootConstrainSelectedInstOperands,
     /*   4096 */     // GIR_Coverage, 23432,
     /*   4096 */     GIR_EraseRootFromParent_Done,
     /*   4097 */   // Label 168: @4097
     /*   4097 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(4159), // Rule ID 23723 //
     /*   4102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4117 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4120 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4124 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4141 */     // (add:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPADDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ128rm),
     /*   4144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4146 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4148 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4157 */     GIR_RootConstrainSelectedInstOperands,
     /*   4158 */     // GIR_Coverage, 23723,
     /*   4158 */     GIR_EraseRootFromParent_Done,
     /*   4159 */   // Label 169: @4159
     /*   4159 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(4221), // Rule ID 2534 //
     /*   4164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4183 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4186 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4190 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4203 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDrm),
     /*   4206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4208 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4210 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4219 */     GIR_RootConstrainSelectedInstOperands,
     /*   4220 */     // GIR_Coverage, 2534,
     /*   4220 */     GIR_EraseRootFromParent_Done,
     /*   4221 */   // Label 170: @4221
     /*   4221 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(4283), // Rule ID 4680 //
     /*   4226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4245 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4248 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4252 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4265 */     // (add:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ128rm),
     /*   4268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4270 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4272 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4281 */     GIR_RootConstrainSelectedInstOperands,
     /*   4282 */     // GIR_Coverage, 4680,
     /*   4282 */     GIR_EraseRootFromParent_Done,
     /*   4283 */   // Label 171: @4283
     /*   4283 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(4344), // Rule ID 17866 //
     /*   4288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   4291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4327 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2), VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*   4327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /*   4330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   4336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   4340 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4342 */     GIR_RootConstrainSelectedInstOperands,
     /*   4343 */     // GIR_Coverage, 17866,
     /*   4343 */     GIR_EraseRootFromParent_Done,
     /*   4344 */   // Label 172: @4344
     /*   4344 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(4405), // Rule ID 25187 //
     /*   4349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   4352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4388 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src3, (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2))  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*   4388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /*   4391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   4397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   4401 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4403 */     GIR_RootConstrainSelectedInstOperands,
     /*   4404 */     // GIR_Coverage, 25187,
     /*   4404 */     GIR_EraseRootFromParent_Done,
     /*   4405 */   // Label 173: @4405
     /*   4405 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(4432), // Rule ID 2533 //
     /*   4410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4425 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPADDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   4425 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDrr),
     /*   4430 */     GIR_RootConstrainSelectedInstOperands,
     /*   4431 */     // GIR_Coverage, 2533,
     /*   4431 */     GIR_Done,
     /*   4432 */   // Label 174: @4432
     /*   4432 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(4459), // Rule ID 2535 //
     /*   4437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   4440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4452 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PADDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   4452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDDrr),
     /*   4457 */     GIR_RootConstrainSelectedInstOperands,
     /*   4458 */     // GIR_Coverage, 2535,
     /*   4458 */     GIR_Done,
     /*   4459 */   // Label 175: @4459
     /*   4459 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4486), // Rule ID 4677 //
     /*   4464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4479 */     // (add:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPADDDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*   4479 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZ128rr),
     /*   4484 */     GIR_RootConstrainSelectedInstOperands,
     /*   4485 */     // GIR_Coverage, 4677,
     /*   4485 */     GIR_Done,
     /*   4486 */   // Label 176: @4486
     /*   4486 */   GIM_Reject,
     /*   4487 */ // Label 167: @4487
     /*   4487 */ GIM_Reject,
     /*   4488 */ // Label 84: @4488
     /*   4488 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4802),
     /*   4493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*   4496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*   4499 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4561), // Rule ID 23437 //
     /*   4504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   4507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4519 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4522 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4526 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4536 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4543 */     // (add:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPADDQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQYrm),
     /*   4546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4548 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4550 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4559 */     GIR_RootConstrainSelectedInstOperands,
     /*   4560 */     // GIR_Coverage, 23437,
     /*   4560 */     GIR_EraseRootFromParent_Done,
     /*   4561 */   // Label 178: @4561
     /*   4561 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4623), // Rule ID 23699 //
     /*   4566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4581 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4584 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4588 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4605 */     // (add:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPADDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ256rm),
     /*   4608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4610 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4612 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4621 */     GIR_RootConstrainSelectedInstOperands,
     /*   4622 */     // GIR_Coverage, 23699,
     /*   4622 */     GIR_EraseRootFromParent_Done,
     /*   4623 */   // Label 179: @4623
     /*   4623 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4685), // Rule ID 2544 //
     /*   4628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   4631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4647 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4650 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4654 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4667 */     // (add:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQYrm),
     /*   4670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4672 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4674 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4683 */     GIR_RootConstrainSelectedInstOperands,
     /*   4684 */     // GIR_Coverage, 2544,
     /*   4684 */     GIR_EraseRootFromParent_Done,
     /*   4685 */   // Label 180: @4685
     /*   4685 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(4747), // Rule ID 4644 //
     /*   4690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4709 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4712 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4716 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4729 */     // (add:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ256rm),
     /*   4732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4734 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4736 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4745 */     GIR_RootConstrainSelectedInstOperands,
     /*   4746 */     // GIR_Coverage, 4644,
     /*   4746 */     GIR_EraseRootFromParent_Done,
     /*   4747 */   // Label 181: @4747
     /*   4747 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(4774), // Rule ID 2543 //
     /*   4752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   4755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4767 */     // (add:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPADDQYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*   4767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQYrr),
     /*   4772 */     GIR_RootConstrainSelectedInstOperands,
     /*   4773 */     // GIR_Coverage, 2543,
     /*   4773 */     GIR_Done,
     /*   4774 */   // Label 182: @4774
     /*   4774 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(4801), // Rule ID 4641 //
     /*   4779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4794 */     // (add:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPADDQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*   4794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZ256rr),
     /*   4799 */     GIR_RootConstrainSelectedInstOperands,
     /*   4800 */     // GIR_Coverage, 4641,
     /*   4800 */     GIR_Done,
     /*   4801 */   // Label 183: @4801
     /*   4801 */   GIM_Reject,
     /*   4802 */ // Label 177: @4802
     /*   4802 */ GIM_Reject,
     /*   4803 */ // Label 85: @4803
     /*   4803 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(5266),
     /*   4808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4814 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(4876), // Rule ID 23429 //
     /*   4819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   4822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4834 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4837 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4841 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4858 */     // (add:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPADDWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWrm),
     /*   4861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4863 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4865 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4874 */     GIR_RootConstrainSelectedInstOperands,
     /*   4875 */     // GIR_Coverage, 23429,
     /*   4875 */     GIR_EraseRootFromParent_Done,
     /*   4876 */   // Label 185: @4876
     /*   4876 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(4938), // Rule ID 23735 //
     /*   4881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   4884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4896 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4899 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4903 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4920 */     // (add:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPADDWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ128rm),
     /*   4923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4925 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4927 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4936 */     GIR_RootConstrainSelectedInstOperands,
     /*   4937 */     // GIR_Coverage, 23735,
     /*   4937 */     GIR_EraseRootFromParent_Done,
     /*   4938 */   // Label 186: @4938
     /*   4938 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(5000), // Rule ID 2528 //
     /*   4943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   4946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4962 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4965 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4969 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4982 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWrm),
     /*   4985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4987 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4989 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4998 */     GIR_RootConstrainSelectedInstOperands,
     /*   4999 */     // GIR_Coverage, 2528,
     /*   4999 */     GIR_EraseRootFromParent_Done,
     /*   5000 */   // Label 187: @5000
     /*   5000 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(5062), // Rule ID 4701 //
     /*   5005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5024 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5027 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5031 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5044 */     // (add:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ128rm),
     /*   5047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5049 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5051 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5060 */     GIR_RootConstrainSelectedInstOperands,
     /*   5061 */     // GIR_Coverage, 4701,
     /*   5061 */     GIR_EraseRootFromParent_Done,
     /*   5062 */   // Label 188: @5062
     /*   5062 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(5123), // Rule ID 17865 //
     /*   5067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   5070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   5090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5106 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2), VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*   5106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*   5109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   5115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   5119 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   5121 */     GIR_RootConstrainSelectedInstOperands,
     /*   5122 */     // GIR_Coverage, 17865,
     /*   5122 */     GIR_EraseRootFromParent_Done,
     /*   5123 */   // Label 189: @5123
     /*   5123 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(5184), // Rule ID 25186 //
     /*   5128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   5131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   5155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5167 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src3, (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2))  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*   5167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*   5170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   5176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   5180 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   5182 */     GIR_RootConstrainSelectedInstOperands,
     /*   5183 */     // GIR_Coverage, 25186,
     /*   5183 */     GIR_EraseRootFromParent_Done,
     /*   5184 */   // Label 190: @5184
     /*   5184 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(5211), // Rule ID 2527 //
     /*   5189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5204 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   5204 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWrr),
     /*   5209 */     GIR_RootConstrainSelectedInstOperands,
     /*   5210 */     // GIR_Coverage, 2527,
     /*   5210 */     GIR_Done,
     /*   5211 */   // Label 191: @5211
     /*   5211 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(5238), // Rule ID 2529 //
     /*   5216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   5219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5231 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   5231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDWrr),
     /*   5236 */     GIR_RootConstrainSelectedInstOperands,
     /*   5237 */     // GIR_Coverage, 2529,
     /*   5237 */     GIR_Done,
     /*   5238 */   // Label 192: @5238
     /*   5238 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(5265), // Rule ID 4698 //
     /*   5243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5258 */     // (add:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*   5258 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZ128rr),
     /*   5263 */     GIR_RootConstrainSelectedInstOperands,
     /*   5264 */     // GIR_Coverage, 4698,
     /*   5264 */     GIR_Done,
     /*   5265 */   // Label 193: @5265
     /*   5265 */   GIM_Reject,
     /*   5266 */ // Label 184: @5266
     /*   5266 */ GIM_Reject,
     /*   5267 */ // Label 86: @5267
     /*   5267 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(5581),
     /*   5272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*   5275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*   5278 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(5340), // Rule ID 23434 //
     /*   5283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   5286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5298 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5301 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5305 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5322 */     // (add:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPADDDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDYrm),
     /*   5325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5327 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5329 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5338 */     GIR_RootConstrainSelectedInstOperands,
     /*   5339 */     // GIR_Coverage, 23434,
     /*   5339 */     GIR_EraseRootFromParent_Done,
     /*   5340 */   // Label 195: @5340
     /*   5340 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(5402), // Rule ID 23717 //
     /*   5345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   5348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5360 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5363 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5367 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5384 */     // (add:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPADDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ256rm),
     /*   5387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5389 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5391 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5400 */     GIR_RootConstrainSelectedInstOperands,
     /*   5401 */     // GIR_Coverage, 23717,
     /*   5401 */     GIR_EraseRootFromParent_Done,
     /*   5402 */   // Label 196: @5402
     /*   5402 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(5464), // Rule ID 2538 //
     /*   5407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   5410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5426 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5429 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5433 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5439 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5446 */     // (add:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDYrm),
     /*   5449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5451 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5453 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5462 */     GIR_RootConstrainSelectedInstOperands,
     /*   5463 */     // GIR_Coverage, 2538,
     /*   5463 */     GIR_EraseRootFromParent_Done,
     /*   5464 */   // Label 197: @5464
     /*   5464 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(5526), // Rule ID 4671 //
     /*   5469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   5472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5488 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5491 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5495 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5508 */     // (add:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ256rm),
     /*   5511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5513 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5515 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5524 */     GIR_RootConstrainSelectedInstOperands,
     /*   5525 */     // GIR_Coverage, 4671,
     /*   5525 */     GIR_EraseRootFromParent_Done,
     /*   5526 */   // Label 198: @5526
     /*   5526 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(5553), // Rule ID 2537 //
     /*   5531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   5534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5546 */     // (add:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPADDDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*   5546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDYrr),
     /*   5551 */     GIR_RootConstrainSelectedInstOperands,
     /*   5552 */     // GIR_Coverage, 2537,
     /*   5552 */     GIR_Done,
     /*   5553 */   // Label 199: @5553
     /*   5553 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(5580), // Rule ID 4668 //
     /*   5558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   5561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5573 */     // (add:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPADDDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*   5573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZ256rr),
     /*   5578 */     GIR_RootConstrainSelectedInstOperands,
     /*   5579 */     // GIR_Coverage, 4668,
     /*   5579 */     GIR_Done,
     /*   5580 */   // Label 200: @5580
     /*   5580 */   GIM_Reject,
     /*   5581 */ // Label 194: @5581
     /*   5581 */ GIM_Reject,
     /*   5582 */ // Label 87: @5582
     /*   5582 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(5737),
     /*   5587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*   5590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*   5593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5597 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(5655), // Rule ID 23693 //
     /*   5602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   5605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5613 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5616 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5620 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5630 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5637 */     // (add:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPADDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZrm),
     /*   5640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5642 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5644 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5653 */     GIR_RootConstrainSelectedInstOperands,
     /*   5654 */     // GIR_Coverage, 23693,
     /*   5654 */     GIR_EraseRootFromParent_Done,
     /*   5655 */   // Label 202: @5655
     /*   5655 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(5713), // Rule ID 4635 //
     /*   5660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   5663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5675 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5678 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5682 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5688 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5695 */     // (add:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZrm),
     /*   5698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5700 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5702 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5711 */     GIR_RootConstrainSelectedInstOperands,
     /*   5712 */     // GIR_Coverage, 4635,
     /*   5712 */     GIR_EraseRootFromParent_Done,
     /*   5713 */   // Label 203: @5713
     /*   5713 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(5736), // Rule ID 4632 //
     /*   5718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   5721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5729 */     // (add:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPADDQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*   5729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZrr),
     /*   5734 */     GIR_RootConstrainSelectedInstOperands,
     /*   5735 */     // GIR_Coverage, 4632,
     /*   5735 */     GIR_Done,
     /*   5736 */   // Label 204: @5736
     /*   5736 */   GIM_Reject,
     /*   5737 */ // Label 201: @5737
     /*   5737 */ GIM_Reject,
     /*   5738 */ // Label 88: @5738
     /*   5738 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(6079),
     /*   5743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   5746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   5749 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(5811), // Rule ID 23426 //
     /*   5754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5769 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5772 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5776 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5793 */     // (add:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPADDBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBrm),
     /*   5796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5798 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5800 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5809 */     GIR_RootConstrainSelectedInstOperands,
     /*   5810 */     // GIR_Coverage, 23426,
     /*   5810 */     GIR_EraseRootFromParent_Done,
     /*   5811 */   // Label 206: @5811
     /*   5811 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(5873), // Rule ID 23744 //
     /*   5816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5831 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5834 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5838 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5855 */     // (add:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPADDBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ128rm),
     /*   5858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5860 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5862 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5871 */     GIR_RootConstrainSelectedInstOperands,
     /*   5872 */     // GIR_Coverage, 23744,
     /*   5872 */     GIR_EraseRootFromParent_Done,
     /*   5873 */   // Label 207: @5873
     /*   5873 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(5935), // Rule ID 2522 //
     /*   5878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5897 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5900 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5904 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5910 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5917 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBrm),
     /*   5920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5922 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5924 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5933 */     GIR_RootConstrainSelectedInstOperands,
     /*   5934 */     // GIR_Coverage, 2522,
     /*   5934 */     GIR_EraseRootFromParent_Done,
     /*   5935 */   // Label 208: @5935
     /*   5935 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(5997), // Rule ID 4719 //
     /*   5940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5959 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5962 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5966 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5979 */     // (add:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ128rm),
     /*   5982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5984 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5986 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5995 */     GIR_RootConstrainSelectedInstOperands,
     /*   5996 */     // GIR_Coverage, 4719,
     /*   5996 */     GIR_EraseRootFromParent_Done,
     /*   5997 */   // Label 209: @5997
     /*   5997 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(6024), // Rule ID 2521 //
     /*   6002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   6005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6017 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*   6017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBrr),
     /*   6022 */     GIR_RootConstrainSelectedInstOperands,
     /*   6023 */     // GIR_Coverage, 2521,
     /*   6023 */     GIR_Done,
     /*   6024 */   // Label 210: @6024
     /*   6024 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(6051), // Rule ID 2523 //
     /*   6029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   6032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6044 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*   6044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDBrr),
     /*   6049 */     GIR_RootConstrainSelectedInstOperands,
     /*   6050 */     // GIR_Coverage, 2523,
     /*   6050 */     GIR_Done,
     /*   6051 */   // Label 211: @6051
     /*   6051 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(6078), // Rule ID 4716 //
     /*   6056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6071 */     // (add:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*   6071 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZ128rr),
     /*   6076 */     GIR_RootConstrainSelectedInstOperands,
     /*   6077 */     // GIR_Coverage, 4716,
     /*   6077 */     GIR_Done,
     /*   6078 */   // Label 212: @6078
     /*   6078 */   GIM_Reject,
     /*   6079 */ // Label 205: @6079
     /*   6079 */ GIM_Reject,
     /*   6080 */ // Label 89: @6080
     /*   6080 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(6394),
     /*   6085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*   6088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*   6091 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(6153), // Rule ID 23431 //
     /*   6096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6111 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6114 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6118 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6128 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6135 */     // (add:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPADDWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWYrm),
     /*   6138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6140 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6151 */     GIR_RootConstrainSelectedInstOperands,
     /*   6152 */     // GIR_Coverage, 23431,
     /*   6152 */     GIR_EraseRootFromParent_Done,
     /*   6153 */   // Label 214: @6153
     /*   6153 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(6215), // Rule ID 23732 //
     /*   6158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6173 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6176 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6180 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6190 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6197 */     // (add:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPADDWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ256rm),
     /*   6200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6202 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6204 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6213 */     GIR_RootConstrainSelectedInstOperands,
     /*   6214 */     // GIR_Coverage, 23732,
     /*   6214 */     GIR_EraseRootFromParent_Done,
     /*   6215 */   // Label 215: @6215
     /*   6215 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(6277), // Rule ID 2532 //
     /*   6220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6239 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6242 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6246 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6259 */     // (add:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWYrm),
     /*   6262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6264 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6266 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6275 */     GIR_RootConstrainSelectedInstOperands,
     /*   6276 */     // GIR_Coverage, 2532,
     /*   6276 */     GIR_EraseRootFromParent_Done,
     /*   6277 */   // Label 216: @6277
     /*   6277 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(6339), // Rule ID 4695 //
     /*   6282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6301 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6304 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6308 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6314 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6321 */     // (add:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ256rm),
     /*   6324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6326 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6328 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6337 */     GIR_RootConstrainSelectedInstOperands,
     /*   6338 */     // GIR_Coverage, 4695,
     /*   6338 */     GIR_EraseRootFromParent_Done,
     /*   6339 */   // Label 217: @6339
     /*   6339 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(6366), // Rule ID 2531 //
     /*   6344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6359 */     // (add:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*   6359 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWYrr),
     /*   6364 */     GIR_RootConstrainSelectedInstOperands,
     /*   6365 */     // GIR_Coverage, 2531,
     /*   6365 */     GIR_Done,
     /*   6366 */   // Label 218: @6366
     /*   6366 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(6393), // Rule ID 4692 //
     /*   6371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6386 */     // (add:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*   6386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZ256rr),
     /*   6391 */     GIR_RootConstrainSelectedInstOperands,
     /*   6392 */     // GIR_Coverage, 4692,
     /*   6392 */     GIR_Done,
     /*   6393 */   // Label 219: @6393
     /*   6393 */   GIM_Reject,
     /*   6394 */ // Label 213: @6394
     /*   6394 */ GIM_Reject,
     /*   6395 */ // Label 90: @6395
     /*   6395 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(6550),
     /*   6400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*   6403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*   6406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6410 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(6468), // Rule ID 23711 //
     /*   6415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   6418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6426 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6429 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6433 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6443 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6450 */     // (add:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPADDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZrm),
     /*   6453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6455 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6457 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6466 */     GIR_RootConstrainSelectedInstOperands,
     /*   6467 */     // GIR_Coverage, 23711,
     /*   6467 */     GIR_EraseRootFromParent_Done,
     /*   6468 */   // Label 221: @6468
     /*   6468 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(6526), // Rule ID 4662 //
     /*   6473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   6476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6488 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6491 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6495 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6508 */     // (add:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZrm),
     /*   6511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6513 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6515 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6524 */     GIR_RootConstrainSelectedInstOperands,
     /*   6525 */     // GIR_Coverage, 4662,
     /*   6525 */     GIR_EraseRootFromParent_Done,
     /*   6526 */   // Label 222: @6526
     /*   6526 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(6549), // Rule ID 4659 //
     /*   6531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   6534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6542 */     // (add:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPADDDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*   6542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZrr),
     /*   6547 */     GIR_RootConstrainSelectedInstOperands,
     /*   6548 */     // GIR_Coverage, 4659,
     /*   6548 */     GIR_Done,
     /*   6549 */   // Label 223: @6549
     /*   6549 */   GIM_Reject,
     /*   6550 */ // Label 220: @6550
     /*   6550 */ GIM_Reject,
     /*   6551 */ // Label 91: @6551
     /*   6551 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(6865),
     /*   6556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*   6559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*   6562 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(6624), // Rule ID 23428 //
     /*   6567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6582 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6585 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6589 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6606 */     // (add:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPADDBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBYrm),
     /*   6609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6611 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6613 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6622 */     GIR_RootConstrainSelectedInstOperands,
     /*   6623 */     // GIR_Coverage, 23428,
     /*   6623 */     GIR_EraseRootFromParent_Done,
     /*   6624 */   // Label 225: @6624
     /*   6624 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(6686), // Rule ID 23741 //
     /*   6629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6644 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6647 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6651 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6668 */     // (add:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPADDBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ256rm),
     /*   6671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6673 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6675 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6684 */     GIR_RootConstrainSelectedInstOperands,
     /*   6685 */     // GIR_Coverage, 23741,
     /*   6685 */     GIR_EraseRootFromParent_Done,
     /*   6686 */   // Label 226: @6686
     /*   6686 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(6748), // Rule ID 2526 //
     /*   6691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6710 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6713 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6717 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6730 */     // (add:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBYrm),
     /*   6733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6735 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6737 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6746 */     GIR_RootConstrainSelectedInstOperands,
     /*   6747 */     // GIR_Coverage, 2526,
     /*   6747 */     GIR_EraseRootFromParent_Done,
     /*   6748 */   // Label 227: @6748
     /*   6748 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(6810), // Rule ID 4713 //
     /*   6753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6772 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6775 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6779 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6792 */     // (add:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ256rm),
     /*   6795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6797 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6799 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6808 */     GIR_RootConstrainSelectedInstOperands,
     /*   6809 */     // GIR_Coverage, 4713,
     /*   6809 */     GIR_EraseRootFromParent_Done,
     /*   6810 */   // Label 228: @6810
     /*   6810 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(6837), // Rule ID 2525 //
     /*   6815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6830 */     // (add:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*   6830 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBYrr),
     /*   6835 */     GIR_RootConstrainSelectedInstOperands,
     /*   6836 */     // GIR_Coverage, 2525,
     /*   6836 */     GIR_Done,
     /*   6837 */   // Label 229: @6837
     /*   6837 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(6864), // Rule ID 4710 //
     /*   6842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6857 */     // (add:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*   6857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZ256rr),
     /*   6862 */     GIR_RootConstrainSelectedInstOperands,
     /*   6863 */     // GIR_Coverage, 4710,
     /*   6863 */     GIR_Done,
     /*   6864 */   // Label 230: @6864
     /*   6864 */   GIM_Reject,
     /*   6865 */ // Label 224: @6865
     /*   6865 */ GIM_Reject,
     /*   6866 */ // Label 92: @6866
     /*   6866 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(7021),
     /*   6871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*   6874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*   6877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6881 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(6939), // Rule ID 23729 //
     /*   6886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   6889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6897 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6900 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6904 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6921 */     // (add:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPADDWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZrm),
     /*   6924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6926 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6928 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6937 */     GIR_RootConstrainSelectedInstOperands,
     /*   6938 */     // GIR_Coverage, 23729,
     /*   6938 */     GIR_EraseRootFromParent_Done,
     /*   6939 */   // Label 232: @6939
     /*   6939 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(6997), // Rule ID 4689 //
     /*   6944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   6947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6959 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6962 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6966 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6979 */     // (add:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZrm),
     /*   6982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6984 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6986 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6995 */     GIR_RootConstrainSelectedInstOperands,
     /*   6996 */     // GIR_Coverage, 4689,
     /*   6996 */     GIR_EraseRootFromParent_Done,
     /*   6997 */   // Label 233: @6997
     /*   6997 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(7020), // Rule ID 4686 //
     /*   7002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7013 */     // (add:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*   7013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZrr),
     /*   7018 */     GIR_RootConstrainSelectedInstOperands,
     /*   7019 */     // GIR_Coverage, 4686,
     /*   7019 */     GIR_Done,
     /*   7020 */   // Label 234: @7020
     /*   7020 */   GIM_Reject,
     /*   7021 */ // Label 231: @7021
     /*   7021 */ GIM_Reject,
     /*   7022 */ // Label 93: @7022
     /*   7022 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(7177),
     /*   7027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*   7030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*   7033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7037 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(7095), // Rule ID 23738 //
     /*   7042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7053 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7056 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   7060 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7077 */     // (add:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPADDBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZrm),
     /*   7080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7082 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7084 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7093 */     GIR_RootConstrainSelectedInstOperands,
     /*   7094 */     // GIR_Coverage, 23738,
     /*   7094 */     GIR_EraseRootFromParent_Done,
     /*   7095 */   // Label 236: @7095
     /*   7095 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(7153), // Rule ID 4707 //
     /*   7100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7115 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7118 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   7122 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7128 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7135 */     // (add:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZrm),
     /*   7138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7140 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7151 */     GIR_RootConstrainSelectedInstOperands,
     /*   7152 */     // GIR_Coverage, 4707,
     /*   7152 */     GIR_EraseRootFromParent_Done,
     /*   7153 */   // Label 237: @7153
     /*   7153 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(7176), // Rule ID 4704 //
     /*   7158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7169 */     // (add:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*   7169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZrr),
     /*   7174 */     GIR_RootConstrainSelectedInstOperands,
     /*   7175 */     // GIR_Coverage, 4704,
     /*   7175 */     GIR_Done,
     /*   7176 */   // Label 238: @7176
     /*   7176 */   GIM_Reject,
     /*   7177 */ // Label 235: @7177
     /*   7177 */ GIM_Reject,
     /*   7178 */ // Label 94: @7178
     /*   7178 */ GIM_Reject,
     /*   7179 */ // Label 1: @7179
     /*   7179 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 255*/ GIMT_Encode4(10714),
     /*   7190 */ /*GILLT_s8*//*Label 239*/ GIMT_Encode4(7286),
     /*   7194 */ /*GILLT_s16*//*Label 240*/ GIMT_Encode4(7638),
     /*   7198 */ /*GILLT_s32*//*Label 241*/ GIMT_Encode4(7990),
     /*   7202 */ /*GILLT_s64*//*Label 242*/ GIMT_Encode4(8342), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   7218 */ /*GILLT_v2s64*//*Label 243*/ GIMT_Encode4(8702), GIMT_Encode4(0),
     /*   7226 */ /*GILLT_v4s32*//*Label 244*/ GIMT_Encode4(8920),
     /*   7230 */ /*GILLT_v4s64*//*Label 245*/ GIMT_Encode4(9138), GIMT_Encode4(0),
     /*   7238 */ /*GILLT_v8s16*//*Label 246*/ GIMT_Encode4(9329),
     /*   7242 */ /*GILLT_v8s32*//*Label 247*/ GIMT_Encode4(9547),
     /*   7246 */ /*GILLT_v8s64*//*Label 248*/ GIMT_Encode4(9738), GIMT_Encode4(0),
     /*   7254 */ /*GILLT_v16s8*//*Label 249*/ GIMT_Encode4(9832),
     /*   7258 */ /*GILLT_v16s16*//*Label 250*/ GIMT_Encode4(10050),
     /*   7262 */ /*GILLT_v16s32*//*Label 251*/ GIMT_Encode4(10241), GIMT_Encode4(0),
     /*   7270 */ /*GILLT_v32s8*//*Label 252*/ GIMT_Encode4(10335),
     /*   7274 */ /*GILLT_v32s16*//*Label 253*/ GIMT_Encode4(10526), GIMT_Encode4(0),
     /*   7282 */ /*GILLT_v64s8*//*Label 254*/ GIMT_Encode4(10620),
     /*   7286 */ // Label 239: @7286
     /*   7286 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(7637),
     /*   7291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*   7294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*   7297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7301 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(7362), // Rule ID 22805 //
     /*   7306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7321 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7324 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7328 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   7332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7341 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (SUB8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8rm),
     /*   7344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7346 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7348 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7360 */     GIR_RootConstrainSelectedInstOperands,
     /*   7361 */     // GIR_Coverage, 22805,
     /*   7361 */     GIR_EraseRootFromParent_Done,
     /*   7362 */   // Label 257: @7362
     /*   7362 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(7423), // Rule ID 22895 //
     /*   7367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7382 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7385 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7389 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   7393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7402 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (SUB8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8rm_ND),
     /*   7405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7407 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7409 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7413 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7421 */     GIR_RootConstrainSelectedInstOperands,
     /*   7422 */     // GIR_Coverage, 22895,
     /*   7422 */     GIR_EraseRootFromParent_Done,
     /*   7423 */   // Label 258: @7423
     /*   7423 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(7451), // Rule ID 241 //
     /*   7428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7431 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7439 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /*   7439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r),
     /*   7442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7444 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7446 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7449 */     GIR_RootConstrainSelectedInstOperands,
     /*   7450 */     // GIR_Coverage, 241,
     /*   7450 */     GIR_EraseRootFromParent_Done,
     /*   7451 */   // Label 259: @7451
     /*   7451 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(7479), // Rule ID 249 //
     /*   7456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   7459 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7467 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /*   7467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r_ND),
     /*   7470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7472 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7477 */     GIR_RootConstrainSelectedInstOperands,
     /*   7478 */     // GIR_Coverage, 249,
     /*   7478 */     GIR_EraseRootFromParent_Done,
     /*   7479 */   // Label 260: @7479
     /*   7479 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(7504), // Rule ID 257 //
     /*   7484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   7487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7495 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r_NF_ND:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /*   7495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r_NF_ND),
     /*   7498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7500 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7502 */     GIR_RootConstrainSelectedInstOperands,
     /*   7503 */     // GIR_Coverage, 257,
     /*   7503 */     GIR_EraseRootFromParent_Done,
     /*   7504 */   // Label 261: @7504
     /*   7504 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(7541), // Rule ID 22809 //
     /*   7509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7524 */     // MIs[1] Operand 1
     /*   7524 */     // No operand predicates
     /*   7524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7526 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SUB8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   7526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8ri),
     /*   7529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7531 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   7536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7539 */     GIR_RootConstrainSelectedInstOperands,
     /*   7540 */     // GIR_Coverage, 22809,
     /*   7540 */     GIR_EraseRootFromParent_Done,
     /*   7541 */   // Label 262: @7541
     /*   7541 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(7578), // Rule ID 22899 //
     /*   7546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7561 */     // MIs[1] Operand 1
     /*   7561 */     // No operand predicates
     /*   7561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7563 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SUB8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   7563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8ri_ND),
     /*   7566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7568 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   7573 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7576 */     GIR_RootConstrainSelectedInstOperands,
     /*   7577 */     // GIR_Coverage, 22899,
     /*   7577 */     GIR_EraseRootFromParent_Done,
     /*   7578 */   // Label 263: @7578
     /*   7578 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(7607), // Rule ID 22801 //
     /*   7583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7594 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SUB8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   7594 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB8rr),
     /*   7599 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   7605 */     GIR_RootConstrainSelectedInstOperands,
     /*   7606 */     // GIR_Coverage, 22801,
     /*   7606 */     GIR_Done,
     /*   7607 */   // Label 264: @7607
     /*   7607 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(7636), // Rule ID 22891 //
     /*   7612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7623 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SUB8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   7623 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB8rr_ND),
     /*   7628 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   7634 */     GIR_RootConstrainSelectedInstOperands,
     /*   7635 */     // GIR_Coverage, 22891,
     /*   7635 */     GIR_Done,
     /*   7636 */   // Label 265: @7636
     /*   7636 */   GIM_Reject,
     /*   7637 */ // Label 256: @7637
     /*   7637 */ GIM_Reject,
     /*   7638 */ // Label 240: @7638
     /*   7638 */ GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(7989),
     /*   7643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   7646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*   7649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7653 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(7714), // Rule ID 22806 //
     /*   7658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7673 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7676 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7680 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   7684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7693 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (SUB16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16rm),
     /*   7696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7698 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7700 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7712 */     GIR_RootConstrainSelectedInstOperands,
     /*   7713 */     // GIR_Coverage, 22806,
     /*   7713 */     GIR_EraseRootFromParent_Done,
     /*   7714 */   // Label 267: @7714
     /*   7714 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(7775), // Rule ID 22896 //
     /*   7719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7734 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7737 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7741 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   7745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7754 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (SUB16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16rm_ND),
     /*   7757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7759 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7761 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7773 */     GIR_RootConstrainSelectedInstOperands,
     /*   7774 */     // GIR_Coverage, 22896,
     /*   7774 */     GIR_EraseRootFromParent_Done,
     /*   7775 */   // Label 268: @7775
     /*   7775 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(7803), // Rule ID 242 //
     /*   7780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7783 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7791 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /*   7791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r),
     /*   7794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7796 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7801 */     GIR_RootConstrainSelectedInstOperands,
     /*   7802 */     // GIR_Coverage, 242,
     /*   7802 */     GIR_EraseRootFromParent_Done,
     /*   7803 */   // Label 269: @7803
     /*   7803 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(7831), // Rule ID 250 //
     /*   7808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   7811 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7819 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /*   7819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r_ND),
     /*   7822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7824 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7829 */     GIR_RootConstrainSelectedInstOperands,
     /*   7830 */     // GIR_Coverage, 250,
     /*   7830 */     GIR_EraseRootFromParent_Done,
     /*   7831 */   // Label 270: @7831
     /*   7831 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(7856), // Rule ID 258 //
     /*   7836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   7839 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7847 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r_NF_ND:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /*   7847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r_NF_ND),
     /*   7850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7852 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7854 */     GIR_RootConstrainSelectedInstOperands,
     /*   7855 */     // GIR_Coverage, 258,
     /*   7855 */     GIR_EraseRootFromParent_Done,
     /*   7856 */   // Label 271: @7856
     /*   7856 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(7893), // Rule ID 22810 //
     /*   7861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7876 */     // MIs[1] Operand 1
     /*   7876 */     // No operand predicates
     /*   7876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7878 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (SUB16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   7878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri),
     /*   7881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7883 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   7888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7891 */     GIR_RootConstrainSelectedInstOperands,
     /*   7892 */     // GIR_Coverage, 22810,
     /*   7892 */     GIR_EraseRootFromParent_Done,
     /*   7893 */   // Label 272: @7893
     /*   7893 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(7930), // Rule ID 22900 //
     /*   7898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7913 */     // MIs[1] Operand 1
     /*   7913 */     // No operand predicates
     /*   7913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7915 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (SUB16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   7915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri_ND),
     /*   7918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7920 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   7925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7928 */     GIR_RootConstrainSelectedInstOperands,
     /*   7929 */     // GIR_Coverage, 22900,
     /*   7929 */     GIR_EraseRootFromParent_Done,
     /*   7930 */   // Label 273: @7930
     /*   7930 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(7959), // Rule ID 22802 //
     /*   7935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7946 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (SUB16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   7946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB16rr),
     /*   7951 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   7957 */     GIR_RootConstrainSelectedInstOperands,
     /*   7958 */     // GIR_Coverage, 22802,
     /*   7958 */     GIR_Done,
     /*   7959 */   // Label 274: @7959
     /*   7959 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(7988), // Rule ID 22892 //
     /*   7964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7975 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (SUB16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   7975 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB16rr_ND),
     /*   7980 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   7986 */     GIR_RootConstrainSelectedInstOperands,
     /*   7987 */     // GIR_Coverage, 22892,
     /*   7987 */     GIR_Done,
     /*   7988 */   // Label 275: @7988
     /*   7988 */   GIM_Reject,
     /*   7989 */ // Label 266: @7989
     /*   7989 */ GIM_Reject,
     /*   7990 */ // Label 241: @7990
     /*   7990 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(8341),
     /*   7995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   7998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   8001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8005 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(8066), // Rule ID 22807 //
     /*   8010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8025 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8028 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8032 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   8036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8045 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (SUB32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32rm),
     /*   8048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8050 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8052 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8064 */     GIR_RootConstrainSelectedInstOperands,
     /*   8065 */     // GIR_Coverage, 22807,
     /*   8065 */     GIR_EraseRootFromParent_Done,
     /*   8066 */   // Label 277: @8066
     /*   8066 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(8127), // Rule ID 22897 //
     /*   8071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8086 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8089 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8093 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   8097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8106 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (SUB32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32rm_ND),
     /*   8109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8111 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8113 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8125 */     GIR_RootConstrainSelectedInstOperands,
     /*   8126 */     // GIR_Coverage, 22897,
     /*   8126 */     GIR_EraseRootFromParent_Done,
     /*   8127 */   // Label 278: @8127
     /*   8127 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(8155), // Rule ID 243 //
     /*   8132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8135 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8143 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*   8143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r),
     /*   8146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8148 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8153 */     GIR_RootConstrainSelectedInstOperands,
     /*   8154 */     // GIR_Coverage, 243,
     /*   8154 */     GIR_EraseRootFromParent_Done,
     /*   8155 */   // Label 279: @8155
     /*   8155 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(8183), // Rule ID 251 //
     /*   8160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8163 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8171 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*   8171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r_ND),
     /*   8174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8176 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8181 */     GIR_RootConstrainSelectedInstOperands,
     /*   8182 */     // GIR_Coverage, 251,
     /*   8182 */     GIR_EraseRootFromParent_Done,
     /*   8183 */   // Label 280: @8183
     /*   8183 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(8208), // Rule ID 259 //
     /*   8188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8199 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r_NF_ND:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*   8199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r_NF_ND),
     /*   8202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8204 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8206 */     GIR_RootConstrainSelectedInstOperands,
     /*   8207 */     // GIR_Coverage, 259,
     /*   8207 */     GIR_EraseRootFromParent_Done,
     /*   8208 */   // Label 281: @8208
     /*   8208 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(8245), // Rule ID 22811 //
     /*   8213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8228 */     // MIs[1] Operand 1
     /*   8228 */     // No operand predicates
     /*   8228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8230 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (SUB32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   8230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri),
     /*   8233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8235 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8243 */     GIR_RootConstrainSelectedInstOperands,
     /*   8244 */     // GIR_Coverage, 22811,
     /*   8244 */     GIR_EraseRootFromParent_Done,
     /*   8245 */   // Label 282: @8245
     /*   8245 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(8282), // Rule ID 22901 //
     /*   8250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8265 */     // MIs[1] Operand 1
     /*   8265 */     // No operand predicates
     /*   8265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8267 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (SUB32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   8267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri_ND),
     /*   8270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8272 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8280 */     GIR_RootConstrainSelectedInstOperands,
     /*   8281 */     // GIR_Coverage, 22901,
     /*   8281 */     GIR_EraseRootFromParent_Done,
     /*   8282 */   // Label 283: @8282
     /*   8282 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(8311), // Rule ID 22803 //
     /*   8287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8298 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (SUB32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   8298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB32rr),
     /*   8303 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8309 */     GIR_RootConstrainSelectedInstOperands,
     /*   8310 */     // GIR_Coverage, 22803,
     /*   8310 */     GIR_Done,
     /*   8311 */   // Label 284: @8311
     /*   8311 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(8340), // Rule ID 22893 //
     /*   8316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8327 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (SUB32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   8327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB32rr_ND),
     /*   8332 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8338 */     GIR_RootConstrainSelectedInstOperands,
     /*   8339 */     // GIR_Coverage, 22893,
     /*   8339 */     GIR_Done,
     /*   8340 */   // Label 285: @8340
     /*   8340 */   GIM_Reject,
     /*   8341 */ // Label 276: @8341
     /*   8341 */ GIM_Reject,
     /*   8342 */ // Label 242: @8342
     /*   8342 */ GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(8701),
     /*   8347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   8350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   8353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8357 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(8418), // Rule ID 22808 //
     /*   8362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8377 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8380 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8384 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8397 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64rm),
     /*   8400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8402 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8404 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8416 */     GIR_RootConstrainSelectedInstOperands,
     /*   8417 */     // GIR_Coverage, 22808,
     /*   8417 */     GIR_EraseRootFromParent_Done,
     /*   8418 */   // Label 287: @8418
     /*   8418 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(8479), // Rule ID 22898 //
     /*   8423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8438 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8441 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8445 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8451 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8458 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64rm_ND),
     /*   8461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8463 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8465 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8477 */     GIR_RootConstrainSelectedInstOperands,
     /*   8478 */     // GIR_Coverage, 22898,
     /*   8478 */     GIR_EraseRootFromParent_Done,
     /*   8479 */   // Label 288: @8479
     /*   8479 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(8507), // Rule ID 244 //
     /*   8484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8495 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /*   8495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r),
     /*   8498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8500 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8502 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8505 */     GIR_RootConstrainSelectedInstOperands,
     /*   8506 */     // GIR_Coverage, 244,
     /*   8506 */     GIR_EraseRootFromParent_Done,
     /*   8507 */   // Label 289: @8507
     /*   8507 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(8535), // Rule ID 252 //
     /*   8512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8515 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8523 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /*   8523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r_ND),
     /*   8526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8528 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8533 */     GIR_RootConstrainSelectedInstOperands,
     /*   8534 */     // GIR_Coverage, 252,
     /*   8534 */     GIR_EraseRootFromParent_Done,
     /*   8535 */   // Label 290: @8535
     /*   8535 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(8560), // Rule ID 260 //
     /*   8540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8551 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r_NF_ND:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /*   8551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r_NF_ND),
     /*   8554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8556 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8558 */     GIR_RootConstrainSelectedInstOperands,
     /*   8559 */     // GIR_Coverage, 260,
     /*   8559 */     GIR_EraseRootFromParent_Done,
     /*   8560 */   // Label 291: @8560
     /*   8560 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(8601), // Rule ID 22812 //
     /*   8565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   8584 */     // MIs[1] Operand 1
     /*   8584 */     // No operand predicates
     /*   8584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8586 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   8586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*   8589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8591 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8599 */     GIR_RootConstrainSelectedInstOperands,
     /*   8600 */     // GIR_Coverage, 22812,
     /*   8600 */     GIR_EraseRootFromParent_Done,
     /*   8601 */   // Label 292: @8601
     /*   8601 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(8642), // Rule ID 22902 //
     /*   8606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   8625 */     // MIs[1] Operand 1
     /*   8625 */     // No operand predicates
     /*   8625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8627 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   8627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*   8630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8632 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8637 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8640 */     GIR_RootConstrainSelectedInstOperands,
     /*   8641 */     // GIR_Coverage, 22902,
     /*   8641 */     GIR_EraseRootFromParent_Done,
     /*   8642 */   // Label 293: @8642
     /*   8642 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(8671), // Rule ID 22804 //
     /*   8647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8658 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (SUB64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   8658 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB64rr),
     /*   8663 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8669 */     GIR_RootConstrainSelectedInstOperands,
     /*   8670 */     // GIR_Coverage, 22804,
     /*   8670 */     GIR_Done,
     /*   8671 */   // Label 294: @8671
     /*   8671 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(8700), // Rule ID 22894 //
     /*   8676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8687 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (SUB64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   8687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB64rr_ND),
     /*   8692 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8698 */     GIR_RootConstrainSelectedInstOperands,
     /*   8699 */     // GIR_Coverage, 22894,
     /*   8699 */     GIR_Done,
     /*   8700 */   // Label 295: @8700
     /*   8700 */   GIM_Reject,
     /*   8701 */ // Label 286: @8701
     /*   8701 */ GIM_Reject,
     /*   8702 */ // Label 243: @8702
     /*   8702 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(8919),
     /*   8707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   8713 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(8775), // Rule ID 2606 //
     /*   8718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   8721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8737 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8740 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8744 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8757 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQrm),
     /*   8760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8762 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8764 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8773 */     GIR_RootConstrainSelectedInstOperands,
     /*   8774 */     // GIR_Coverage, 2606,
     /*   8774 */     GIR_EraseRootFromParent_Done,
     /*   8775 */   // Label 297: @8775
     /*   8775 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(8837), // Rule ID 4743 //
     /*   8780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   8783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   8787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   8791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8799 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8802 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8806 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8812 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8819 */     // (sub:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ128rm),
     /*   8822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8824 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8826 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8835 */     GIR_RootConstrainSelectedInstOperands,
     /*   8836 */     // GIR_Coverage, 4743,
     /*   8836 */     GIR_EraseRootFromParent_Done,
     /*   8837 */   // Label 298: @8837
     /*   8837 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(8864), // Rule ID 2605 //
     /*   8842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   8845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8857 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPSUBQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   8857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQrr),
     /*   8862 */     GIR_RootConstrainSelectedInstOperands,
     /*   8863 */     // GIR_Coverage, 2605,
     /*   8863 */     GIR_Done,
     /*   8864 */   // Label 299: @8864
     /*   8864 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(8891), // Rule ID 2607 //
     /*   8869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   8872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8884 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PSUBQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   8884 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBQrr),
     /*   8889 */     GIR_RootConstrainSelectedInstOperands,
     /*   8890 */     // GIR_Coverage, 2607,
     /*   8890 */     GIR_Done,
     /*   8891 */   // Label 300: @8891
     /*   8891 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(8918), // Rule ID 4740 //
     /*   8896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   8899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   8903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   8907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   8911 */     // (sub:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPSUBQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*   8911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ128rr),
     /*   8916 */     GIR_RootConstrainSelectedInstOperands,
     /*   8917 */     // GIR_Coverage, 4740,
     /*   8917 */     GIR_Done,
     /*   8918 */   // Label 301: @8918
     /*   8918 */   GIM_Reject,
     /*   8919 */ // Label 296: @8919
     /*   8919 */ GIM_Reject,
     /*   8920 */ // Label 244: @8920
     /*   8920 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(9137),
     /*   8925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8931 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(8993), // Rule ID 2600 //
     /*   8936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   8939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8955 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8958 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8962 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8968 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8975 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDrm),
     /*   8978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8980 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8982 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8991 */     GIR_RootConstrainSelectedInstOperands,
     /*   8992 */     // GIR_Coverage, 2600,
     /*   8992 */     GIR_EraseRootFromParent_Done,
     /*   8993 */   // Label 303: @8993
     /*   8993 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(9055), // Rule ID 4770 //
     /*   8998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9017 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9020 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9024 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9030 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9037 */     // (sub:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ128rm),
     /*   9040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9042 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9044 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9053 */     GIR_RootConstrainSelectedInstOperands,
     /*   9054 */     // GIR_Coverage, 4770,
     /*   9054 */     GIR_EraseRootFromParent_Done,
     /*   9055 */   // Label 304: @9055
     /*   9055 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(9082), // Rule ID 2599 //
     /*   9060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   9063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9075 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPSUBDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   9075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDrr),
     /*   9080 */     GIR_RootConstrainSelectedInstOperands,
     /*   9081 */     // GIR_Coverage, 2599,
     /*   9081 */     GIR_Done,
     /*   9082 */   // Label 305: @9082
     /*   9082 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(9109), // Rule ID 2601 //
     /*   9087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   9090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9102 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PSUBDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   9102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBDrr),
     /*   9107 */     GIR_RootConstrainSelectedInstOperands,
     /*   9108 */     // GIR_Coverage, 2601,
     /*   9108 */     GIR_Done,
     /*   9109 */   // Label 306: @9109
     /*   9109 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(9136), // Rule ID 4767 //
     /*   9114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9129 */     // (sub:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPSUBDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*   9129 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ128rr),
     /*   9134 */     GIR_RootConstrainSelectedInstOperands,
     /*   9135 */     // GIR_Coverage, 4767,
     /*   9135 */     GIR_Done,
     /*   9136 */   // Label 307: @9136
     /*   9136 */   GIM_Reject,
     /*   9137 */ // Label 302: @9137
     /*   9137 */ GIM_Reject,
     /*   9138 */ // Label 245: @9138
     /*   9138 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(9328),
     /*   9143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*   9146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*   9149 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(9211), // Rule ID 2610 //
     /*   9154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9173 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9176 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9180 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9186 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9193 */     // (sub:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQYrm),
     /*   9196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9198 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9200 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9209 */     GIR_RootConstrainSelectedInstOperands,
     /*   9210 */     // GIR_Coverage, 2610,
     /*   9210 */     GIR_EraseRootFromParent_Done,
     /*   9211 */   // Label 309: @9211
     /*   9211 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(9273), // Rule ID 4734 //
     /*   9216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9235 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9238 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9242 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9255 */     // (sub:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ256rm),
     /*   9258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9260 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9262 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9271 */     GIR_RootConstrainSelectedInstOperands,
     /*   9272 */     // GIR_Coverage, 4734,
     /*   9272 */     GIR_EraseRootFromParent_Done,
     /*   9273 */   // Label 310: @9273
     /*   9273 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(9300), // Rule ID 2609 //
     /*   9278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9293 */     // (sub:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPSUBQYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*   9293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQYrr),
     /*   9298 */     GIR_RootConstrainSelectedInstOperands,
     /*   9299 */     // GIR_Coverage, 2609,
     /*   9299 */     GIR_Done,
     /*   9300 */   // Label 311: @9300
     /*   9300 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(9327), // Rule ID 4731 //
     /*   9305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9320 */     // (sub:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPSUBQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*   9320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ256rr),
     /*   9325 */     GIR_RootConstrainSelectedInstOperands,
     /*   9326 */     // GIR_Coverage, 4731,
     /*   9326 */     GIR_Done,
     /*   9327 */   // Label 312: @9327
     /*   9327 */   GIM_Reject,
     /*   9328 */ // Label 308: @9328
     /*   9328 */ GIM_Reject,
     /*   9329 */ // Label 246: @9329
     /*   9329 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(9546),
     /*   9334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9340 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(9402), // Rule ID 2594 //
     /*   9345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   9348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9364 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9367 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9371 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9384 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWrm),
     /*   9387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9389 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9391 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9400 */     GIR_RootConstrainSelectedInstOperands,
     /*   9401 */     // GIR_Coverage, 2594,
     /*   9401 */     GIR_EraseRootFromParent_Done,
     /*   9402 */   // Label 314: @9402
     /*   9402 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(9464), // Rule ID 4791 //
     /*   9407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   9410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9426 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9429 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9433 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9439 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9446 */     // (sub:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ128rm),
     /*   9449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9451 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9453 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9462 */     GIR_RootConstrainSelectedInstOperands,
     /*   9463 */     // GIR_Coverage, 4791,
     /*   9463 */     GIR_EraseRootFromParent_Done,
     /*   9464 */   // Label 315: @9464
     /*   9464 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(9491), // Rule ID 2593 //
     /*   9469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   9472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9484 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   9484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWrr),
     /*   9489 */     GIR_RootConstrainSelectedInstOperands,
     /*   9490 */     // GIR_Coverage, 2593,
     /*   9490 */     GIR_Done,
     /*   9491 */   // Label 316: @9491
     /*   9491 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(9518), // Rule ID 2595 //
     /*   9496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   9499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9511 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   9511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBWrr),
     /*   9516 */     GIR_RootConstrainSelectedInstOperands,
     /*   9517 */     // GIR_Coverage, 2595,
     /*   9517 */     GIR_Done,
     /*   9518 */   // Label 317: @9518
     /*   9518 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(9545), // Rule ID 4788 //
     /*   9523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   9526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9538 */     // (sub:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*   9538 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ128rr),
     /*   9543 */     GIR_RootConstrainSelectedInstOperands,
     /*   9544 */     // GIR_Coverage, 4788,
     /*   9544 */     GIR_Done,
     /*   9545 */   // Label 318: @9545
     /*   9545 */   GIM_Reject,
     /*   9546 */ // Label 313: @9546
     /*   9546 */ GIM_Reject,
     /*   9547 */ // Label 247: @9547
     /*   9547 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(9737),
     /*   9552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*   9555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*   9558 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(9620), // Rule ID 2604 //
     /*   9563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9582 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9585 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9589 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9602 */     // (sub:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDYrm),
     /*   9605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9607 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9618 */     GIR_RootConstrainSelectedInstOperands,
     /*   9619 */     // GIR_Coverage, 2604,
     /*   9619 */     GIR_EraseRootFromParent_Done,
     /*   9620 */   // Label 320: @9620
     /*   9620 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(9682), // Rule ID 4761 //
     /*   9625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9644 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9647 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9651 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9664 */     // (sub:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ256rm),
     /*   9667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9669 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9671 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9680 */     GIR_RootConstrainSelectedInstOperands,
     /*   9681 */     // GIR_Coverage, 4761,
     /*   9681 */     GIR_EraseRootFromParent_Done,
     /*   9682 */   // Label 321: @9682
     /*   9682 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(9709), // Rule ID 2603 //
     /*   9687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9702 */     // (sub:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPSUBDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*   9702 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDYrr),
     /*   9707 */     GIR_RootConstrainSelectedInstOperands,
     /*   9708 */     // GIR_Coverage, 2603,
     /*   9708 */     GIR_Done,
     /*   9709 */   // Label 322: @9709
     /*   9709 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(9736), // Rule ID 4758 //
     /*   9714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9729 */     // (sub:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPSUBDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*   9729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ256rr),
     /*   9734 */     GIR_RootConstrainSelectedInstOperands,
     /*   9735 */     // GIR_Coverage, 4758,
     /*   9735 */     GIR_Done,
     /*   9736 */   // Label 323: @9736
     /*   9736 */   GIM_Reject,
     /*   9737 */ // Label 319: @9737
     /*   9737 */ GIM_Reject,
     /*   9738 */ // Label 248: @9738
     /*   9738 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(9831),
     /*   9743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*   9746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*   9749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   9753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   9757 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(9811), // Rule ID 4725 //
     /*   9762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   9765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9773 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9776 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9780 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9793 */     // (sub:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQZrm),
     /*   9796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9798 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9800 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9809 */     GIR_RootConstrainSelectedInstOperands,
     /*   9810 */     // GIR_Coverage, 4725,
     /*   9810 */     GIR_EraseRootFromParent_Done,
     /*   9811 */   // Label 325: @9811
     /*   9811 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(9830), // Rule ID 4722 //
     /*   9816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   9819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   9823 */     // (sub:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPSUBQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*   9823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZrr),
     /*   9828 */     GIR_RootConstrainSelectedInstOperands,
     /*   9829 */     // GIR_Coverage, 4722,
     /*   9829 */     GIR_Done,
     /*   9830 */   // Label 326: @9830
     /*   9830 */   GIM_Reject,
     /*   9831 */ // Label 324: @9831
     /*   9831 */ GIM_Reject,
     /*   9832 */ // Label 249: @9832
     /*   9832 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(10049),
     /*   9837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   9840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   9843 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(9905), // Rule ID 2588 //
     /*   9848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   9851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9867 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9870 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9874 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9887 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBrm),
     /*   9890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9892 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9894 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9903 */     GIR_RootConstrainSelectedInstOperands,
     /*   9904 */     // GIR_Coverage, 2588,
     /*   9904 */     GIR_EraseRootFromParent_Done,
     /*   9905 */   // Label 328: @9905
     /*   9905 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(9967), // Rule ID 4809 //
     /*   9910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   9913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9929 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9932 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9936 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9949 */     // (sub:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ128rm),
     /*   9952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9954 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9956 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9965 */     GIR_RootConstrainSelectedInstOperands,
     /*   9966 */     // GIR_Coverage, 4809,
     /*   9966 */     GIR_EraseRootFromParent_Done,
     /*   9967 */   // Label 329: @9967
     /*   9967 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(9994), // Rule ID 2587 //
     /*   9972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   9975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9987 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*   9987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBrr),
     /*   9992 */     GIR_RootConstrainSelectedInstOperands,
     /*   9993 */     // GIR_Coverage, 2587,
     /*   9993 */     GIR_Done,
     /*   9994 */   // Label 330: @9994
     /*   9994 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(10021), // Rule ID 2589 //
     /*   9999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  10002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10014 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  10014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBBrr),
     /*  10019 */     GIR_RootConstrainSelectedInstOperands,
     /*  10020 */     // GIR_Coverage, 2589,
     /*  10020 */     GIR_Done,
     /*  10021 */   // Label 331: @10021
     /*  10021 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(10048), // Rule ID 4806 //
     /*  10026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10041 */     // (sub:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  10041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ128rr),
     /*  10046 */     GIR_RootConstrainSelectedInstOperands,
     /*  10047 */     // GIR_Coverage, 4806,
     /*  10047 */     GIR_Done,
     /*  10048 */   // Label 332: @10048
     /*  10048 */   GIM_Reject,
     /*  10049 */ // Label 327: @10049
     /*  10049 */ GIM_Reject,
     /*  10050 */ // Label 250: @10050
     /*  10050 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(10240),
     /*  10055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  10058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  10061 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(10123), // Rule ID 2598 //
     /*  10066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10085 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10088 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10092 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10098 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10105 */     // (sub:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWYrm),
     /*  10108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10110 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10112 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10121 */     GIR_RootConstrainSelectedInstOperands,
     /*  10122 */     // GIR_Coverage, 2598,
     /*  10122 */     GIR_EraseRootFromParent_Done,
     /*  10123 */   // Label 334: @10123
     /*  10123 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(10185), // Rule ID 4785 //
     /*  10128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10147 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10150 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10154 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10167 */     // (sub:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ256rm),
     /*  10170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10172 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10174 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10183 */     GIR_RootConstrainSelectedInstOperands,
     /*  10184 */     // GIR_Coverage, 4785,
     /*  10184 */     GIR_EraseRootFromParent_Done,
     /*  10185 */   // Label 335: @10185
     /*  10185 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(10212), // Rule ID 2597 //
     /*  10190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10205 */     // (sub:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  10205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWYrr),
     /*  10210 */     GIR_RootConstrainSelectedInstOperands,
     /*  10211 */     // GIR_Coverage, 2597,
     /*  10211 */     GIR_Done,
     /*  10212 */   // Label 336: @10212
     /*  10212 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(10239), // Rule ID 4782 //
     /*  10217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10232 */     // (sub:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  10232 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ256rr),
     /*  10237 */     GIR_RootConstrainSelectedInstOperands,
     /*  10238 */     // GIR_Coverage, 4782,
     /*  10238 */     GIR_Done,
     /*  10239 */   // Label 337: @10239
     /*  10239 */   GIM_Reject,
     /*  10240 */ // Label 333: @10240
     /*  10240 */ GIM_Reject,
     /*  10241 */ // Label 251: @10241
     /*  10241 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(10334),
     /*  10246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  10249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  10252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10260 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(10314), // Rule ID 4752 //
     /*  10265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  10268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10276 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10279 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10283 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10296 */     // (sub:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDZrm),
     /*  10299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10301 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10303 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10312 */     GIR_RootConstrainSelectedInstOperands,
     /*  10313 */     // GIR_Coverage, 4752,
     /*  10313 */     GIR_EraseRootFromParent_Done,
     /*  10314 */   // Label 339: @10314
     /*  10314 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(10333), // Rule ID 4749 //
     /*  10319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  10322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10326 */     // (sub:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPSUBDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  10326 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZrr),
     /*  10331 */     GIR_RootConstrainSelectedInstOperands,
     /*  10332 */     // GIR_Coverage, 4749,
     /*  10332 */     GIR_Done,
     /*  10333 */   // Label 340: @10333
     /*  10333 */   GIM_Reject,
     /*  10334 */ // Label 338: @10334
     /*  10334 */ GIM_Reject,
     /*  10335 */ // Label 252: @10335
     /*  10335 */ GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(10525),
     /*  10340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  10343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  10346 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(10408), // Rule ID 2592 //
     /*  10351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10370 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10373 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10377 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10383 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10390 */     // (sub:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBYrm),
     /*  10393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10395 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10397 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10406 */     GIR_RootConstrainSelectedInstOperands,
     /*  10407 */     // GIR_Coverage, 2592,
     /*  10407 */     GIR_EraseRootFromParent_Done,
     /*  10408 */   // Label 342: @10408
     /*  10408 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(10470), // Rule ID 4803 //
     /*  10413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10432 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10435 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10439 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10452 */     // (sub:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ256rm),
     /*  10455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10457 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10459 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10468 */     GIR_RootConstrainSelectedInstOperands,
     /*  10469 */     // GIR_Coverage, 4803,
     /*  10469 */     GIR_EraseRootFromParent_Done,
     /*  10470 */   // Label 343: @10470
     /*  10470 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(10497), // Rule ID 2591 //
     /*  10475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10490 */     // (sub:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  10490 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBYrr),
     /*  10495 */     GIR_RootConstrainSelectedInstOperands,
     /*  10496 */     // GIR_Coverage, 2591,
     /*  10496 */     GIR_Done,
     /*  10497 */   // Label 344: @10497
     /*  10497 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(10524), // Rule ID 4800 //
     /*  10502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10517 */     // (sub:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  10517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ256rr),
     /*  10522 */     GIR_RootConstrainSelectedInstOperands,
     /*  10523 */     // GIR_Coverage, 4800,
     /*  10523 */     GIR_Done,
     /*  10524 */   // Label 345: @10524
     /*  10524 */   GIM_Reject,
     /*  10525 */ // Label 341: @10525
     /*  10525 */ GIM_Reject,
     /*  10526 */ // Label 253: @10526
     /*  10526 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(10619),
     /*  10531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  10534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  10537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10545 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(10599), // Rule ID 4779 //
     /*  10550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10561 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10564 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10568 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10574 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10581 */     // (sub:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWZrm),
     /*  10584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10586 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10588 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10597 */     GIR_RootConstrainSelectedInstOperands,
     /*  10598 */     // GIR_Coverage, 4779,
     /*  10598 */     GIR_EraseRootFromParent_Done,
     /*  10599 */   // Label 347: @10599
     /*  10599 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(10618), // Rule ID 4776 //
     /*  10604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10611 */     // (sub:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  10611 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZrr),
     /*  10616 */     GIR_RootConstrainSelectedInstOperands,
     /*  10617 */     // GIR_Coverage, 4776,
     /*  10617 */     GIR_Done,
     /*  10618 */   // Label 348: @10618
     /*  10618 */   GIM_Reject,
     /*  10619 */ // Label 346: @10619
     /*  10619 */ GIM_Reject,
     /*  10620 */ // Label 254: @10620
     /*  10620 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(10713),
     /*  10625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  10628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  10631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10639 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(10693), // Rule ID 4797 //
     /*  10644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10655 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10658 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10662 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10668 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10675 */     // (sub:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBZrm),
     /*  10678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10680 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10682 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10691 */     GIR_RootConstrainSelectedInstOperands,
     /*  10692 */     // GIR_Coverage, 4797,
     /*  10692 */     GIR_EraseRootFromParent_Done,
     /*  10693 */   // Label 350: @10693
     /*  10693 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(10712), // Rule ID 4794 //
     /*  10698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10705 */     // (sub:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  10705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZrr),
     /*  10710 */     GIR_RootConstrainSelectedInstOperands,
     /*  10711 */     // GIR_Coverage, 4794,
     /*  10711 */     GIR_Done,
     /*  10712 */   // Label 351: @10712
     /*  10712 */   GIM_Reject,
     /*  10713 */ // Label 349: @10713
     /*  10713 */ GIM_Reject,
     /*  10714 */ // Label 255: @10714
     /*  10714 */ GIM_Reject,
     /*  10715 */ // Label 2: @10715
     /*  10715 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 364*/ GIMT_Encode4(14497),
     /*  10726 */ /*GILLT_s16*//*Label 352*/ GIMT_Encode4(10810),
     /*  10730 */ /*GILLT_s32*//*Label 353*/ GIMT_Encode4(11227),
     /*  10734 */ /*GILLT_s64*//*Label 354*/ GIMT_Encode4(11644), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10750 */ /*GILLT_v2s64*//*Label 355*/ GIMT_Encode4(12069), GIMT_Encode4(0),
     /*  10758 */ /*GILLT_v4s32*//*Label 356*/ GIMT_Encode4(12398),
     /*  10762 */ /*GILLT_v4s64*//*Label 357*/ GIMT_Encode4(12740), GIMT_Encode4(0),
     /*  10770 */ /*GILLT_v8s16*//*Label 358*/ GIMT_Encode4(13057),
     /*  10774 */ /*GILLT_v8s32*//*Label 359*/ GIMT_Encode4(13399),
     /*  10778 */ /*GILLT_v8s64*//*Label 360*/ GIMT_Encode4(13714), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10790 */ /*GILLT_v16s16*//*Label 361*/ GIMT_Encode4(13870),
     /*  10794 */ /*GILLT_v16s32*//*Label 362*/ GIMT_Encode4(14185), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10806 */ /*GILLT_v32s16*//*Label 363*/ GIMT_Encode4(14341),
     /*  10810 */ // Label 352: @10810
     /*  10810 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(11226),
     /*  10815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  10818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  10821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  10825 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(10889), // Rule ID 22976 //
     /*  10830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10838 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10841 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10845 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  10849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  10853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10857 */     // MIs[2] Operand 1
     /*  10857 */     // No operand predicates
     /*  10857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10859 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10866 */     // (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i16] }):$src2)  =>  (IMUL16rmi:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  10866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rmi),
     /*  10869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10871 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  10875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /*  10878 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  10881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  10887 */     GIR_RootConstrainSelectedInstOperands,
     /*  10888 */     // GIR_Coverage, 22976,
     /*  10888 */     GIR_EraseRootFromParent_Done,
     /*  10889 */   // Label 366: @10889
     /*  10889 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(10950), // Rule ID 26055 //
     /*  10894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  10897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10905 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10908 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10912 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  10916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  10920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10929 */     // (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (IMUL16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm),
     /*  10932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10934 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  10936 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  10943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10948 */     GIR_RootConstrainSelectedInstOperands,
     /*  10949 */     // GIR_Coverage, 26055,
     /*  10949 */     GIR_EraseRootFromParent_Done,
     /*  10950 */   // Label 367: @10950
     /*  10950 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(11011), // Rule ID 26074 //
     /*  10955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  10958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10966 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10969 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10973 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  10977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  10981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10983 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10990 */     // (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (IMUL16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm_ND),
     /*  10993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10995 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  10997 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11001 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11009 */     GIR_RootConstrainSelectedInstOperands,
     /*  11010 */     // GIR_Coverage, 26074,
     /*  11010 */     GIR_EraseRootFromParent_Done,
     /*  11011 */   // Label 368: @11011
     /*  11011 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(11072), // Rule ID 22820 //
     /*  11016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11031 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11034 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11038 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11044 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11051 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (IMUL16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm),
     /*  11054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11056 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11058 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11070 */     GIR_RootConstrainSelectedInstOperands,
     /*  11071 */     // GIR_Coverage, 22820,
     /*  11071 */     GIR_EraseRootFromParent_Done,
     /*  11072 */   // Label 369: @11072
     /*  11072 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(11133), // Rule ID 22910 //
     /*  11077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11092 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11095 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11099 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11112 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (IMUL16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm_ND),
     /*  11115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11117 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11119 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11123 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11131 */     GIR_RootConstrainSelectedInstOperands,
     /*  11132 */     // GIR_Coverage, 22910,
     /*  11132 */     GIR_EraseRootFromParent_Done,
     /*  11133 */   // Label 370: @11133
     /*  11133 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(11167), // Rule ID 22973 //
     /*  11138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11150 */     // MIs[1] Operand 1
     /*  11150 */     // No operand predicates
     /*  11150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11152 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (IMUL16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  11152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rri),
     /*  11155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11157 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  11162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11165 */     GIR_RootConstrainSelectedInstOperands,
     /*  11166 */     // GIR_Coverage, 22973,
     /*  11166 */     GIR_EraseRootFromParent_Done,
     /*  11167 */   // Label 371: @11167
     /*  11167 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(11196), // Rule ID 22817 //
     /*  11172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11183 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (IMUL16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  11183 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL16rr),
     /*  11188 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11194 */     GIR_RootConstrainSelectedInstOperands,
     /*  11195 */     // GIR_Coverage, 22817,
     /*  11195 */     GIR_Done,
     /*  11196 */   // Label 372: @11196
     /*  11196 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(11225), // Rule ID 22907 //
     /*  11201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11212 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (IMUL16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  11212 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL16rr_ND),
     /*  11217 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11223 */     GIR_RootConstrainSelectedInstOperands,
     /*  11224 */     // GIR_Coverage, 22907,
     /*  11224 */     GIR_Done,
     /*  11225 */   // Label 373: @11225
     /*  11225 */   GIM_Reject,
     /*  11226 */ // Label 365: @11226
     /*  11226 */ GIM_Reject,
     /*  11227 */ // Label 353: @11227
     /*  11227 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(11643),
     /*  11232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  11235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  11238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11242 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(11306), // Rule ID 22977 //
     /*  11247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11255 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11258 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11262 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11274 */     // MIs[2] Operand 1
     /*  11274 */     // No operand predicates
     /*  11274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11276 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11283 */     // (mul:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i32] }):$src2)  =>  (IMUL32rmi:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  11283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rmi),
     /*  11286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11288 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  11292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /*  11295 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  11304 */     GIR_RootConstrainSelectedInstOperands,
     /*  11305 */     // GIR_Coverage, 22977,
     /*  11305 */     GIR_EraseRootFromParent_Done,
     /*  11306 */   // Label 375: @11306
     /*  11306 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(11367), // Rule ID 26056 //
     /*  11311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11322 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11325 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11329 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11346 */     // (mul:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (IMUL32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm),
     /*  11349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11351 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11353 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11357 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11365 */     GIR_RootConstrainSelectedInstOperands,
     /*  11366 */     // GIR_Coverage, 26056,
     /*  11366 */     GIR_EraseRootFromParent_Done,
     /*  11367 */   // Label 376: @11367
     /*  11367 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(11428), // Rule ID 26075 //
     /*  11372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11383 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11386 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11390 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11407 */     // (mul:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (IMUL32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm_ND),
     /*  11410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11412 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11414 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11426 */     GIR_RootConstrainSelectedInstOperands,
     /*  11427 */     // GIR_Coverage, 26075,
     /*  11427 */     GIR_EraseRootFromParent_Done,
     /*  11428 */   // Label 377: @11428
     /*  11428 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(11489), // Rule ID 22821 //
     /*  11433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11448 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11451 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11455 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11468 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (IMUL32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm),
     /*  11471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11473 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11475 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11479 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11487 */     GIR_RootConstrainSelectedInstOperands,
     /*  11488 */     // GIR_Coverage, 22821,
     /*  11488 */     GIR_EraseRootFromParent_Done,
     /*  11489 */   // Label 378: @11489
     /*  11489 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(11550), // Rule ID 22911 //
     /*  11494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11509 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11512 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11516 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11529 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (IMUL32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm_ND),
     /*  11532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11534 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11536 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11548 */     GIR_RootConstrainSelectedInstOperands,
     /*  11549 */     // GIR_Coverage, 22911,
     /*  11549 */     GIR_EraseRootFromParent_Done,
     /*  11550 */   // Label 379: @11550
     /*  11550 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(11584), // Rule ID 22974 //
     /*  11555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11567 */     // MIs[1] Operand 1
     /*  11567 */     // No operand predicates
     /*  11567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11569 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (IMUL32rri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  11569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rri),
     /*  11572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11574 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  11579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11582 */     GIR_RootConstrainSelectedInstOperands,
     /*  11583 */     // GIR_Coverage, 22974,
     /*  11583 */     GIR_EraseRootFromParent_Done,
     /*  11584 */   // Label 380: @11584
     /*  11584 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(11613), // Rule ID 22818 //
     /*  11589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11600 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (IMUL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  11600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL32rr),
     /*  11605 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11611 */     GIR_RootConstrainSelectedInstOperands,
     /*  11612 */     // GIR_Coverage, 22818,
     /*  11612 */     GIR_Done,
     /*  11613 */   // Label 381: @11613
     /*  11613 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(11642), // Rule ID 22908 //
     /*  11618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11629 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (IMUL32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  11629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL32rr_ND),
     /*  11634 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11640 */     GIR_RootConstrainSelectedInstOperands,
     /*  11641 */     // GIR_Coverage, 22908,
     /*  11641 */     GIR_Done,
     /*  11642 */   // Label 382: @11642
     /*  11642 */   GIM_Reject,
     /*  11643 */ // Label 374: @11643
     /*  11643 */ GIM_Reject,
     /*  11644 */ // Label 354: @11644
     /*  11644 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(12068),
     /*  11649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  11652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  11655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11659 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(11727), // Rule ID 22978 //
     /*  11664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11672 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11675 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11679 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11691 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  11695 */     // MIs[2] Operand 1
     /*  11695 */     // No operand predicates
     /*  11695 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11697 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11704 */     // (mul:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (IMUL64rmi32:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  11704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rmi32),
     /*  11707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11709 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  11713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /*  11716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  11725 */     GIR_RootConstrainSelectedInstOperands,
     /*  11726 */     // GIR_Coverage, 22978,
     /*  11726 */     GIR_EraseRootFromParent_Done,
     /*  11727 */   // Label 384: @11727
     /*  11727 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(11788), // Rule ID 26057 //
     /*  11732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11743 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11746 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11750 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11767 */     // (mul:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (IMUL64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm),
     /*  11770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11772 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11774 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11778 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11786 */     GIR_RootConstrainSelectedInstOperands,
     /*  11787 */     // GIR_Coverage, 26057,
     /*  11787 */     GIR_EraseRootFromParent_Done,
     /*  11788 */   // Label 385: @11788
     /*  11788 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(11849), // Rule ID 26076 //
     /*  11793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11804 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11807 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11811 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11828 */     // (mul:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (IMUL64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm_ND),
     /*  11831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11833 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11835 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11839 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11847 */     GIR_RootConstrainSelectedInstOperands,
     /*  11848 */     // GIR_Coverage, 26076,
     /*  11848 */     GIR_EraseRootFromParent_Done,
     /*  11849 */   // Label 386: @11849
     /*  11849 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(11910), // Rule ID 22822 //
     /*  11854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11869 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11872 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11876 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11889 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (IMUL64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm),
     /*  11892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11894 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11896 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11908 */     GIR_RootConstrainSelectedInstOperands,
     /*  11909 */     // GIR_Coverage, 22822,
     /*  11909 */     GIR_EraseRootFromParent_Done,
     /*  11910 */   // Label 387: @11910
     /*  11910 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(11971), // Rule ID 22912 //
     /*  11915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11930 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11933 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11937 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11950 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (IMUL64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm_ND),
     /*  11953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11955 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11957 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11961 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11969 */     GIR_RootConstrainSelectedInstOperands,
     /*  11970 */     // GIR_Coverage, 22912,
     /*  11970 */     GIR_EraseRootFromParent_Done,
     /*  11971 */   // Label 388: @11971
     /*  11971 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(12009), // Rule ID 22975 //
     /*  11976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  11992 */     // MIs[1] Operand 1
     /*  11992 */     // No operand predicates
     /*  11992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11994 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (IMUL64rri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  11994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rri32),
     /*  11997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11999 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  12004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  12007 */     GIR_RootConstrainSelectedInstOperands,
     /*  12008 */     // GIR_Coverage, 22975,
     /*  12008 */     GIR_EraseRootFromParent_Done,
     /*  12009 */   // Label 389: @12009
     /*  12009 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(12038), // Rule ID 22819 //
     /*  12014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  12017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12025 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (IMUL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  12025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL64rr),
     /*  12030 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  12036 */     GIR_RootConstrainSelectedInstOperands,
     /*  12037 */     // GIR_Coverage, 22819,
     /*  12037 */     GIR_Done,
     /*  12038 */   // Label 390: @12038
     /*  12038 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(12067), // Rule ID 22909 //
     /*  12043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  12046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12054 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (IMUL64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  12054 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL64rr_ND),
     /*  12059 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  12065 */     GIR_RootConstrainSelectedInstOperands,
     /*  12066 */     // GIR_Coverage, 22909,
     /*  12066 */     GIR_Done,
     /*  12067 */   // Label 391: @12067
     /*  12067 */   GIM_Reject,
     /*  12068 */ // Label 383: @12068
     /*  12068 */ GIM_Reject,
     /*  12069 */ // Label 355: @12069
     /*  12069 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(12397),
     /*  12074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  12077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  12080 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(12142), // Rule ID 23822 //
     /*  12085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12100 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12103 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12107 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12124 */     // (mul:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMULLQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ128rm),
     /*  12127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12129 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12131 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12140 */     GIR_RootConstrainSelectedInstOperands,
     /*  12141 */     // GIR_Coverage, 23822,
     /*  12141 */     GIR_EraseRootFromParent_Done,
     /*  12142 */   // Label 393: @12142
     /*  12142 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(12204), // Rule ID 5022 //
     /*  12147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12166 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12169 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12173 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12186 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ128rm),
     /*  12189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12191 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12193 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12202 */     GIR_RootConstrainSelectedInstOperands,
     /*  12203 */     // GIR_Coverage, 5022,
     /*  12203 */     GIR_EraseRootFromParent_Done,
     /*  12204 */   // Label 394: @12204
     /*  12204 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(12231), // Rule ID 5019 //
     /*  12209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12224 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMULLQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  12224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ128rr),
     /*  12229 */     GIR_RootConstrainSelectedInstOperands,
     /*  12230 */     // GIR_Coverage, 5019,
     /*  12230 */     GIR_Done,
     /*  12231 */   // Label 395: @12231
     /*  12231 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(12396), // Rule ID 19997 //
     /*  12236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /*  12239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  12243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12251 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMULLQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /*  12251 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  12254 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12258 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  12265 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  12268 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12272 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12277 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  12280 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  12284 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  12287 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  12292 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12297 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  12302 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  12305 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12309 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12316 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  12319 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12323 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12328 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12331 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  12335 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  12338 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  12343 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12348 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  12353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  12356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  12360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12365 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12368 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  12371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12378 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  12385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  12390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12395 */     // GIR_Coverage, 19997,
     /*  12395 */     GIR_EraseRootFromParent_Done,
     /*  12396 */   // Label 396: @12396
     /*  12396 */   GIM_Reject,
     /*  12397 */ // Label 392: @12397
     /*  12397 */ GIM_Reject,
     /*  12398 */ // Label 356: @12398
     /*  12398 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(12739),
     /*  12403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12409 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(12471), // Rule ID 23525 //
     /*  12414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  12417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12429 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12432 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12436 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12446 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12453 */     // (mul:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMULLDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDrm),
     /*  12456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12458 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12460 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12469 */     GIR_RootConstrainSelectedInstOperands,
     /*  12470 */     // GIR_Coverage, 23525,
     /*  12470 */     GIR_EraseRootFromParent_Done,
     /*  12471 */   // Label 398: @12471
     /*  12471 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(12533), // Rule ID 23795 //
     /*  12476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  12479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12491 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12494 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12498 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12508 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12515 */     // (mul:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMULLDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ128rm),
     /*  12518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12520 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12522 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12531 */     GIR_RootConstrainSelectedInstOperands,
     /*  12532 */     // GIR_Coverage, 23795,
     /*  12532 */     GIR_EraseRootFromParent_Done,
     /*  12533 */   // Label 399: @12533
     /*  12533 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(12595), // Rule ID 3239 //
     /*  12538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  12541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12557 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12560 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12564 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12577 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDrm),
     /*  12580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12582 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12584 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12593 */     GIR_RootConstrainSelectedInstOperands,
     /*  12594 */     // GIR_Coverage, 3239,
     /*  12594 */     GIR_EraseRootFromParent_Done,
     /*  12595 */   // Label 400: @12595
     /*  12595 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(12657), // Rule ID 4977 //
     /*  12600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  12603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12619 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12622 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12626 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12639 */     // (mul:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ128rm),
     /*  12642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12644 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12646 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12655 */     GIR_RootConstrainSelectedInstOperands,
     /*  12656 */     // GIR_Coverage, 4977,
     /*  12656 */     GIR_EraseRootFromParent_Done,
     /*  12657 */   // Label 401: @12657
     /*  12657 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(12684), // Rule ID 3238 //
     /*  12662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  12665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12677 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMULLDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  12677 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDrr),
     /*  12682 */     GIR_RootConstrainSelectedInstOperands,
     /*  12683 */     // GIR_Coverage, 3238,
     /*  12683 */     GIR_Done,
     /*  12684 */   // Label 402: @12684
     /*  12684 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(12711), // Rule ID 3246 //
     /*  12689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  12692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12704 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMULLDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  12704 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULLDrr),
     /*  12709 */     GIR_RootConstrainSelectedInstOperands,
     /*  12710 */     // GIR_Coverage, 3246,
     /*  12710 */     GIR_Done,
     /*  12711 */   // Label 403: @12711
     /*  12711 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(12738), // Rule ID 4974 //
     /*  12716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  12719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12731 */     // (mul:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMULLDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  12731 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ128rr),
     /*  12736 */     GIR_RootConstrainSelectedInstOperands,
     /*  12737 */     // GIR_Coverage, 4974,
     /*  12737 */     GIR_Done,
     /*  12738 */   // Label 404: @12738
     /*  12738 */   GIM_Reject,
     /*  12739 */ // Label 397: @12739
     /*  12739 */ GIM_Reject,
     /*  12740 */ // Label 357: @12740
     /*  12740 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(13056),
     /*  12745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  12748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  12751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12755 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(12813), // Rule ID 23816 //
     /*  12760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12771 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12774 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12778 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12788 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12795 */     // (mul:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMULLQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ256rm),
     /*  12798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12800 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12802 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12811 */     GIR_RootConstrainSelectedInstOperands,
     /*  12812 */     // GIR_Coverage, 23816,
     /*  12812 */     GIR_EraseRootFromParent_Done,
     /*  12813 */   // Label 406: @12813
     /*  12813 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(12871), // Rule ID 5013 //
     /*  12818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12833 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12836 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12840 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12853 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ256rm),
     /*  12856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12858 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12860 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12869 */     GIR_RootConstrainSelectedInstOperands,
     /*  12870 */     // GIR_Coverage, 5013,
     /*  12870 */     GIR_EraseRootFromParent_Done,
     /*  12871 */   // Label 407: @12871
     /*  12871 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(12894), // Rule ID 5010 //
     /*  12876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12887 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMULLQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  12887 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ256rr),
     /*  12892 */     GIR_RootConstrainSelectedInstOperands,
     /*  12893 */     // GIR_Coverage, 5010,
     /*  12893 */     GIR_Done,
     /*  12894 */   // Label 408: @12894
     /*  12894 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(13055), // Rule ID 19995 //
     /*  12899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /*  12902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12910 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMULLQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /*  12910 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  12913 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12917 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  12924 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  12927 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12931 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12936 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  12939 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  12943 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  12946 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  12951 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12956 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  12961 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  12964 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12968 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12975 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  12978 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12982 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12987 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12990 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  12994 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  12997 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  13002 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  13007 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  13012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  13015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  13019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13024 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13027 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  13030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13037 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  13044 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  13049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  13054 */     // GIR_Coverage, 19995,
     /*  13054 */     GIR_EraseRootFromParent_Done,
     /*  13055 */   // Label 409: @13055
     /*  13055 */   GIM_Reject,
     /*  13056 */ // Label 405: @13056
     /*  13056 */ GIM_Reject,
     /*  13057 */ // Label 358: @13057
     /*  13057 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(13398),
     /*  13062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  13065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  13068 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(13130), // Rule ID 23450 //
     /*  13073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  13076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13088 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13091 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13095 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13112 */     // (mul:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMULLWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWrm),
     /*  13115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13117 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13119 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13128 */     GIR_RootConstrainSelectedInstOperands,
     /*  13129 */     // GIR_Coverage, 23450,
     /*  13129 */     GIR_EraseRootFromParent_Done,
     /*  13130 */   // Label 411: @13130
     /*  13130 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(13192), // Rule ID 23807 //
     /*  13135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13150 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13153 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13157 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13174 */     // (mul:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMULLWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ128rm),
     /*  13177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13179 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13181 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13190 */     GIR_RootConstrainSelectedInstOperands,
     /*  13191 */     // GIR_Coverage, 23807,
     /*  13191 */     GIR_EraseRootFromParent_Done,
     /*  13192 */   // Label 412: @13192
     /*  13192 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(13254), // Rule ID 2570 //
     /*  13197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  13200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13216 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13219 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13223 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13229 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13236 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWrm),
     /*  13239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13241 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13243 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13252 */     GIR_RootConstrainSelectedInstOperands,
     /*  13253 */     // GIR_Coverage, 2570,
     /*  13253 */     GIR_EraseRootFromParent_Done,
     /*  13254 */   // Label 413: @13254
     /*  13254 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(13316), // Rule ID 4998 //
     /*  13259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13278 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13281 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13285 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13298 */     // (mul:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ128rm),
     /*  13301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13303 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13305 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13314 */     GIR_RootConstrainSelectedInstOperands,
     /*  13315 */     // GIR_Coverage, 4998,
     /*  13315 */     GIR_EraseRootFromParent_Done,
     /*  13316 */   // Label 414: @13316
     /*  13316 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(13343), // Rule ID 2569 //
     /*  13321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  13324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13336 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULLWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  13336 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWrr),
     /*  13341 */     GIR_RootConstrainSelectedInstOperands,
     /*  13342 */     // GIR_Coverage, 2569,
     /*  13342 */     GIR_Done,
     /*  13343 */   // Label 415: @13343
     /*  13343 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(13370), // Rule ID 2571 //
     /*  13348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  13351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13363 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULLWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  13363 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULLWrr),
     /*  13368 */     GIR_RootConstrainSelectedInstOperands,
     /*  13369 */     // GIR_Coverage, 2571,
     /*  13369 */     GIR_Done,
     /*  13370 */   // Label 416: @13370
     /*  13370 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(13397), // Rule ID 4995 //
     /*  13375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13390 */     // (mul:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULLWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  13390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ128rr),
     /*  13395 */     GIR_RootConstrainSelectedInstOperands,
     /*  13396 */     // GIR_Coverage, 4995,
     /*  13396 */     GIR_Done,
     /*  13397 */   // Label 417: @13397
     /*  13397 */   GIM_Reject,
     /*  13398 */ // Label 410: @13398
     /*  13398 */ GIM_Reject,
     /*  13399 */ // Label 359: @13399
     /*  13399 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(13713),
     /*  13404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  13407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  13410 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(13472), // Rule ID 23527 //
     /*  13415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  13418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13430 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13433 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13437 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13454 */     // (mul:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMULLDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDYrm),
     /*  13457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13459 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13461 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13470 */     GIR_RootConstrainSelectedInstOperands,
     /*  13471 */     // GIR_Coverage, 23527,
     /*  13471 */     GIR_EraseRootFromParent_Done,
     /*  13472 */   // Label 419: @13472
     /*  13472 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(13534), // Rule ID 23789 //
     /*  13477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  13480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13492 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13499 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13516 */     // (mul:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMULLDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ256rm),
     /*  13519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13521 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13523 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13532 */     GIR_RootConstrainSelectedInstOperands,
     /*  13533 */     // GIR_Coverage, 23789,
     /*  13533 */     GIR_EraseRootFromParent_Done,
     /*  13534 */   // Label 420: @13534
     /*  13534 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(13596), // Rule ID 3243 //
     /*  13539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  13542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13558 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13561 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13565 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13578 */     // (mul:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDYrm),
     /*  13581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13583 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13585 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13594 */     GIR_RootConstrainSelectedInstOperands,
     /*  13595 */     // GIR_Coverage, 3243,
     /*  13595 */     GIR_EraseRootFromParent_Done,
     /*  13596 */   // Label 421: @13596
     /*  13596 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(13658), // Rule ID 4968 //
     /*  13601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  13604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13620 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13623 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13627 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13640 */     // (mul:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ256rm),
     /*  13643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13645 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13647 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13656 */     GIR_RootConstrainSelectedInstOperands,
     /*  13657 */     // GIR_Coverage, 4968,
     /*  13657 */     GIR_EraseRootFromParent_Done,
     /*  13658 */   // Label 422: @13658
     /*  13658 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(13685), // Rule ID 3242 //
     /*  13663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  13666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13678 */     // (mul:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMULLDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  13678 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDYrr),
     /*  13683 */     GIR_RootConstrainSelectedInstOperands,
     /*  13684 */     // GIR_Coverage, 3242,
     /*  13684 */     GIR_Done,
     /*  13685 */   // Label 423: @13685
     /*  13685 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(13712), // Rule ID 4965 //
     /*  13690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  13693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13705 */     // (mul:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMULLDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  13705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ256rr),
     /*  13710 */     GIR_RootConstrainSelectedInstOperands,
     /*  13711 */     // GIR_Coverage, 4965,
     /*  13711 */     GIR_Done,
     /*  13712 */   // Label 424: @13712
     /*  13712 */   GIM_Reject,
     /*  13713 */ // Label 418: @13713
     /*  13713 */ GIM_Reject,
     /*  13714 */ // Label 360: @13714
     /*  13714 */ GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(13869),
     /*  13719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  13722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  13725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13729 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(13787), // Rule ID 23810 //
     /*  13734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  13737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13745 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13748 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13752 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13769 */     // (mul:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMULLQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrm),
     /*  13772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13774 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13776 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13785 */     GIR_RootConstrainSelectedInstOperands,
     /*  13786 */     // GIR_Coverage, 23810,
     /*  13786 */     GIR_EraseRootFromParent_Done,
     /*  13787 */   // Label 426: @13787
     /*  13787 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(13845), // Rule ID 5004 //
     /*  13792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  13795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13807 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13810 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13814 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13820 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13827 */     // (mul:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrm),
     /*  13830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13832 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13834 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13843 */     GIR_RootConstrainSelectedInstOperands,
     /*  13844 */     // GIR_Coverage, 5004,
     /*  13844 */     GIR_EraseRootFromParent_Done,
     /*  13845 */   // Label 427: @13845
     /*  13845 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(13868), // Rule ID 5001 //
     /*  13850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  13853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13861 */     // (mul:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMULLQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  13861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  13866 */     GIR_RootConstrainSelectedInstOperands,
     /*  13867 */     // GIR_Coverage, 5001,
     /*  13867 */     GIR_Done,
     /*  13868 */   // Label 428: @13868
     /*  13868 */   GIM_Reject,
     /*  13869 */ // Label 425: @13869
     /*  13869 */ GIM_Reject,
     /*  13870 */ // Label 361: @13870
     /*  13870 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(14184),
     /*  13875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  13878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  13881 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(13943), // Rule ID 23452 //
     /*  13886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  13889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13901 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13904 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13908 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13925 */     // (mul:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMULLWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWYrm),
     /*  13928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13930 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13932 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13941 */     GIR_RootConstrainSelectedInstOperands,
     /*  13942 */     // GIR_Coverage, 23452,
     /*  13942 */     GIR_EraseRootFromParent_Done,
     /*  13943 */   // Label 430: @13943
     /*  13943 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(14005), // Rule ID 23804 //
     /*  13948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13963 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13966 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13970 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13987 */     // (mul:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMULLWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ256rm),
     /*  13990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13992 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13994 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14003 */     GIR_RootConstrainSelectedInstOperands,
     /*  14004 */     // GIR_Coverage, 23804,
     /*  14004 */     GIR_EraseRootFromParent_Done,
     /*  14005 */   // Label 431: @14005
     /*  14005 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(14067), // Rule ID 2574 //
     /*  14010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  14013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14029 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14032 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14036 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14049 */     // (mul:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWYrm),
     /*  14052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14054 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14056 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14065 */     GIR_RootConstrainSelectedInstOperands,
     /*  14066 */     // GIR_Coverage, 2574,
     /*  14066 */     GIR_EraseRootFromParent_Done,
     /*  14067 */   // Label 432: @14067
     /*  14067 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(14129), // Rule ID 4992 //
     /*  14072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  14075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14091 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14094 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14098 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14111 */     // (mul:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ256rm),
     /*  14114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14116 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14127 */     GIR_RootConstrainSelectedInstOperands,
     /*  14128 */     // GIR_Coverage, 4992,
     /*  14128 */     GIR_EraseRootFromParent_Done,
     /*  14129 */   // Label 433: @14129
     /*  14129 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(14156), // Rule ID 2573 //
     /*  14134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  14137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14149 */     // (mul:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULLWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  14149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWYrr),
     /*  14154 */     GIR_RootConstrainSelectedInstOperands,
     /*  14155 */     // GIR_Coverage, 2573,
     /*  14155 */     GIR_Done,
     /*  14156 */   // Label 434: @14156
     /*  14156 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(14183), // Rule ID 4989 //
     /*  14161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  14164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14176 */     // (mul:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULLWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  14176 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ256rr),
     /*  14181 */     GIR_RootConstrainSelectedInstOperands,
     /*  14182 */     // GIR_Coverage, 4989,
     /*  14182 */     GIR_Done,
     /*  14183 */   // Label 435: @14183
     /*  14183 */   GIM_Reject,
     /*  14184 */ // Label 429: @14184
     /*  14184 */ GIM_Reject,
     /*  14185 */ // Label 362: @14185
     /*  14185 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(14340),
     /*  14190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  14193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  14196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14200 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(14258), // Rule ID 23783 //
     /*  14205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  14208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14216 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14219 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14223 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14240 */     // (mul:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMULLDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZrm),
     /*  14243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14245 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14247 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14256 */     GIR_RootConstrainSelectedInstOperands,
     /*  14257 */     // GIR_Coverage, 23783,
     /*  14257 */     GIR_EraseRootFromParent_Done,
     /*  14258 */   // Label 437: @14258
     /*  14258 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(14316), // Rule ID 4959 //
     /*  14263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  14266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14278 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14281 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14285 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14298 */     // (mul:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZrm),
     /*  14301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14303 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14305 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14314 */     GIR_RootConstrainSelectedInstOperands,
     /*  14315 */     // GIR_Coverage, 4959,
     /*  14315 */     GIR_EraseRootFromParent_Done,
     /*  14316 */   // Label 438: @14316
     /*  14316 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(14339), // Rule ID 4956 //
     /*  14321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  14324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14332 */     // (mul:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMULLDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  14332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZrr),
     /*  14337 */     GIR_RootConstrainSelectedInstOperands,
     /*  14338 */     // GIR_Coverage, 4956,
     /*  14338 */     GIR_Done,
     /*  14339 */   // Label 439: @14339
     /*  14339 */   GIM_Reject,
     /*  14340 */ // Label 436: @14340
     /*  14340 */ GIM_Reject,
     /*  14341 */ // Label 363: @14341
     /*  14341 */ GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(14496),
     /*  14346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  14349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  14352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14356 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(14414), // Rule ID 23801 //
     /*  14361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  14364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14372 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14375 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14379 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14396 */     // (mul:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMULLWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZrm),
     /*  14399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14401 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14403 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14412 */     GIR_RootConstrainSelectedInstOperands,
     /*  14413 */     // GIR_Coverage, 23801,
     /*  14413 */     GIR_EraseRootFromParent_Done,
     /*  14414 */   // Label 441: @14414
     /*  14414 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(14472), // Rule ID 4986 //
     /*  14419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  14422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14434 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14437 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14441 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14454 */     // (mul:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZrm),
     /*  14457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14459 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14461 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14470 */     GIR_RootConstrainSelectedInstOperands,
     /*  14471 */     // GIR_Coverage, 4986,
     /*  14471 */     GIR_EraseRootFromParent_Done,
     /*  14472 */   // Label 442: @14472
     /*  14472 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(14495), // Rule ID 4983 //
     /*  14477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  14480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14488 */     // (mul:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULLWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  14488 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZrr),
     /*  14493 */     GIR_RootConstrainSelectedInstOperands,
     /*  14494 */     // GIR_Coverage, 4983,
     /*  14494 */     GIR_Done,
     /*  14495 */   // Label 443: @14495
     /*  14495 */   GIM_Reject,
     /*  14496 */ // Label 440: @14496
     /*  14496 */ GIM_Reject,
     /*  14497 */ // Label 364: @14497
     /*  14497 */ GIM_Reject,
     /*  14498 */ // Label 3: @14498
     /*  14498 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 467*/ GIMT_Encode4(25089),
     /*  14509 */ /*GILLT_s1*//*Label 444*/ GIMT_Encode4(14609),
     /*  14513 */ /*GILLT_s8*//*Label 445*/ GIMT_Encode4(14955),
     /*  14517 */ /*GILLT_s16*//*Label 446*/ GIMT_Encode4(15348),
     /*  14521 */ /*GILLT_s32*//*Label 447*/ GIMT_Encode4(16033),
     /*  14525 */ /*GILLT_s64*//*Label 448*/ GIMT_Encode4(17859), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14537 */ /*GILLT_v2s1*//*Label 449*/ GIMT_Encode4(19563),
     /*  14541 */ /*GILLT_v2s64*//*Label 450*/ GIMT_Encode4(19909),
     /*  14545 */ /*GILLT_v4s1*//*Label 451*/ GIMT_Encode4(20251),
     /*  14549 */ /*GILLT_v4s32*//*Label 452*/ GIMT_Encode4(20597),
     /*  14553 */ /*GILLT_v4s64*//*Label 453*/ GIMT_Encode4(20939),
     /*  14557 */ /*GILLT_v8s1*//*Label 454*/ GIMT_Encode4(21405),
     /*  14561 */ /*GILLT_v8s16*//*Label 455*/ GIMT_Encode4(21903),
     /*  14565 */ /*GILLT_v8s32*//*Label 456*/ GIMT_Encode4(22245),
     /*  14569 */ /*GILLT_v8s64*//*Label 457*/ GIMT_Encode4(22711),
     /*  14573 */ /*GILLT_v16s1*//*Label 458*/ GIMT_Encode4(22867),
     /*  14577 */ /*GILLT_v16s8*//*Label 459*/ GIMT_Encode4(23027),
     /*  14581 */ /*GILLT_v16s16*//*Label 460*/ GIMT_Encode4(23369),
     /*  14585 */ /*GILLT_v16s32*//*Label 461*/ GIMT_Encode4(23835),
     /*  14589 */ /*GILLT_v32s1*//*Label 462*/ GIMT_Encode4(23991),
     /*  14593 */ /*GILLT_v32s8*//*Label 463*/ GIMT_Encode4(24151),
     /*  14597 */ /*GILLT_v32s16*//*Label 464*/ GIMT_Encode4(24617),
     /*  14601 */ /*GILLT_v64s1*//*Label 465*/ GIMT_Encode4(24773),
     /*  14605 */ /*GILLT_v64s8*//*Label 466*/ GIMT_Encode4(24933),
     /*  14609 */ // Label 444: @14609
     /*  14609 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(14954),
     /*  14614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  14617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  14620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14624 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(14744), // Rule ID 19487 //
     /*  14629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  14641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  14645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14654 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14660 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  14662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14668 */     // (and:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }), VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  14668 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  14671 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14675 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14680 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  14684 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14689 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  14692 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14696 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14701 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  14705 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  14713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  14717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14722 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14725 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  14728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  14743 */     // GIR_Coverage, 19487,
     /*  14743 */     GIR_EraseRootFromParent_Done,
     /*  14744 */   // Label 469: @14744
     /*  14744 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(14864), // Rule ID 25364 //
     /*  14749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  14765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  14769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14778 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14784 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  14786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14788 */     // (and:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src2, (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  14788 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  14791 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14795 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14800 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  14804 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14809 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  14812 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14816 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14821 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  14825 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  14833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  14837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14842 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14845 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  14848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14858 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  14863 */     // GIR_Coverage, 25364,
     /*  14863 */     GIR_EraseRootFromParent_Done,
     /*  14864 */   // Label 470: @14864
     /*  14864 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(14953), // Rule ID 19483 //
     /*  14869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14877 */     // (and:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  14877 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  14880 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14884 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14889 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  14893 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14898 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  14901 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14905 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14910 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  14914 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  14922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  14926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14931 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14934 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  14937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  14952 */     // GIR_Coverage, 19483,
     /*  14952 */     GIR_EraseRootFromParent_Done,
     /*  14953 */   // Label 471: @14953
     /*  14953 */   GIM_Reject,
     /*  14954 */ // Label 468: @14954
     /*  14954 */ GIM_Reject,
     /*  14955 */ // Label 445: @14955
     /*  14955 */ GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(15347),
     /*  14960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  14963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  14966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  14970 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(15031), // Rule ID 26066 //
     /*  14975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  14978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14986 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14989 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14993 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  14997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15003 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15010 */     // (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (AND8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm),
     /*  15013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15015 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15017 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15029 */     GIR_RootConstrainSelectedInstOperands,
     /*  15030 */     // GIR_Coverage, 26066,
     /*  15030 */     GIR_EraseRootFromParent_Done,
     /*  15031 */   // Label 473: @15031
     /*  15031 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(15092), // Rule ID 26085 //
     /*  15036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15047 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15050 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15054 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15071 */     // (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (AND8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm_ND),
     /*  15074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15076 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15078 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15090 */     GIR_RootConstrainSelectedInstOperands,
     /*  15091 */     // GIR_Coverage, 26085,
     /*  15091 */     GIR_EraseRootFromParent_Done,
     /*  15092 */   // Label 474: @15092
     /*  15092 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(15153), // Rule ID 22851 //
     /*  15097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15112 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15115 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15119 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15132 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (AND8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm),
     /*  15135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15137 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15139 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15143 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15151 */     GIR_RootConstrainSelectedInstOperands,
     /*  15152 */     // GIR_Coverage, 22851,
     /*  15152 */     GIR_EraseRootFromParent_Done,
     /*  15153 */   // Label 475: @15153
     /*  15153 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(15214), // Rule ID 22941 //
     /*  15158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15173 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15176 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15180 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15186 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15193 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (AND8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm_ND),
     /*  15196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15198 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15200 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15212 */     GIR_RootConstrainSelectedInstOperands,
     /*  15213 */     // GIR_Coverage, 22941,
     /*  15213 */     GIR_EraseRootFromParent_Done,
     /*  15214 */   // Label 476: @15214
     /*  15214 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(15251), // Rule ID 22855 //
     /*  15219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15234 */     // MIs[1] Operand 1
     /*  15234 */     // No operand predicates
     /*  15234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15236 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (AND8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  15236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8ri),
     /*  15239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15241 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  15246 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15249 */     GIR_RootConstrainSelectedInstOperands,
     /*  15250 */     // GIR_Coverage, 22855,
     /*  15250 */     GIR_EraseRootFromParent_Done,
     /*  15251 */   // Label 477: @15251
     /*  15251 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(15288), // Rule ID 22945 //
     /*  15256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15271 */     // MIs[1] Operand 1
     /*  15271 */     // No operand predicates
     /*  15271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15273 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (AND8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  15273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8ri_ND),
     /*  15276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15278 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  15283 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15286 */     GIR_RootConstrainSelectedInstOperands,
     /*  15287 */     // GIR_Coverage, 22945,
     /*  15287 */     GIR_EraseRootFromParent_Done,
     /*  15288 */   // Label 478: @15288
     /*  15288 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(15317), // Rule ID 22847 //
     /*  15293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15304 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (AND8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  15304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND8rr),
     /*  15309 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  15315 */     GIR_RootConstrainSelectedInstOperands,
     /*  15316 */     // GIR_Coverage, 22847,
     /*  15316 */     GIR_Done,
     /*  15317 */   // Label 479: @15317
     /*  15317 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(15346), // Rule ID 22937 //
     /*  15322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15333 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (AND8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  15333 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND8rr_ND),
     /*  15338 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  15344 */     GIR_RootConstrainSelectedInstOperands,
     /*  15345 */     // GIR_Coverage, 22937,
     /*  15345 */     GIR_Done,
     /*  15346 */   // Label 480: @15346
     /*  15346 */   GIM_Reject,
     /*  15347 */ // Label 472: @15347
     /*  15347 */ GIM_Reject,
     /*  15348 */ // Label 446: @15348
     /*  15348 */ GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(16032),
     /*  15353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  15356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  15359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15363 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(15424), // Rule ID 26067 //
     /*  15368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15379 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15382 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15386 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15396 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15403 */     // (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (AND16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm),
     /*  15406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15408 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15410 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15422 */     GIR_RootConstrainSelectedInstOperands,
     /*  15423 */     // GIR_Coverage, 26067,
     /*  15423 */     GIR_EraseRootFromParent_Done,
     /*  15424 */   // Label 482: @15424
     /*  15424 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(15485), // Rule ID 26086 //
     /*  15429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15440 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15443 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15447 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15464 */     // (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (AND16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm_ND),
     /*  15467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15469 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15471 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15483 */     GIR_RootConstrainSelectedInstOperands,
     /*  15484 */     // GIR_Coverage, 26086,
     /*  15484 */     GIR_EraseRootFromParent_Done,
     /*  15485 */   // Label 483: @15485
     /*  15485 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(15546), // Rule ID 22852 //
     /*  15490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15505 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15508 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15512 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15525 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (AND16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm),
     /*  15528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15530 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15532 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15544 */     GIR_RootConstrainSelectedInstOperands,
     /*  15545 */     // GIR_Coverage, 22852,
     /*  15545 */     GIR_EraseRootFromParent_Done,
     /*  15546 */   // Label 484: @15546
     /*  15546 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(15607), // Rule ID 22942 //
     /*  15551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15566 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15569 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15573 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15586 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (AND16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm_ND),
     /*  15589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15591 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15593 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15605 */     GIR_RootConstrainSelectedInstOperands,
     /*  15606 */     // GIR_Coverage, 22942,
     /*  15606 */     GIR_EraseRootFromParent_Done,
     /*  15607 */   // Label 485: @15607
     /*  15607 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(15709), // Rule ID 26033 //
     /*  15612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  15620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  15628 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  15632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15643 */     // (and:{ *:[i16] } (rotl:{ *:[i16] } -2:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  15643 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  15646 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15650 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  15657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  15660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  15664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15669 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  15672 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  15676 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  15679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  15684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  15689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  15694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR16rr),
     /*  15697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15699 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15707 */     GIR_RootConstrainSelectedInstOperands,
     /*  15708 */     // GIR_Coverage, 26033,
     /*  15708 */     GIR_EraseRootFromParent_Done,
     /*  15709 */   // Label 486: @15709
     /*  15709 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(15811), // Rule ID 22771 //
     /*  15714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  15726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  15734 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  15738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15745 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (rotl:{ *:[i16] } -2:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  15745 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  15748 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15752 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  15759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  15762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  15766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15771 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  15774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  15778 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  15781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  15786 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  15791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  15796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR16rr),
     /*  15799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15801 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15809 */     GIR_RootConstrainSelectedInstOperands,
     /*  15810 */     // GIR_Coverage, 22771,
     /*  15810 */     GIR_EraseRootFromParent_Done,
     /*  15811 */   // Label 487: @15811
     /*  15811 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(15899), // Rule ID 22631 //
     /*  15816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15820 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15831 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, 255:{ *:[i16] })  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src1, sub_8bit:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /*  15831 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /*  15834 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15838 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15843 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src1
     /*  15849 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  15854 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  15859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  15862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /*  15866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15871 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  15874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  15876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15881 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  15888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  15893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  15898 */     // GIR_Coverage, 22631,
     /*  15898 */     GIR_EraseRootFromParent_Done,
     /*  15899 */   // Label 488: @15899
     /*  15899 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(15936), // Rule ID 22856 //
     /*  15904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15919 */     // MIs[1] Operand 1
     /*  15919 */     // No operand predicates
     /*  15919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15921 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (AND16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  15921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16ri),
     /*  15924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15926 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  15931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15934 */     GIR_RootConstrainSelectedInstOperands,
     /*  15935 */     // GIR_Coverage, 22856,
     /*  15935 */     GIR_EraseRootFromParent_Done,
     /*  15936 */   // Label 489: @15936
     /*  15936 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(15973), // Rule ID 22946 //
     /*  15941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15956 */     // MIs[1] Operand 1
     /*  15956 */     // No operand predicates
     /*  15956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15958 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (AND16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  15958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16ri_ND),
     /*  15961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15963 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  15968 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15971 */     GIR_RootConstrainSelectedInstOperands,
     /*  15972 */     // GIR_Coverage, 22946,
     /*  15972 */     GIR_EraseRootFromParent_Done,
     /*  15973 */   // Label 490: @15973
     /*  15973 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(16002), // Rule ID 22848 //
     /*  15978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15989 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (AND16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  15989 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND16rr),
     /*  15994 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  16000 */     GIR_RootConstrainSelectedInstOperands,
     /*  16001 */     // GIR_Coverage, 22848,
     /*  16001 */     GIR_Done,
     /*  16002 */   // Label 491: @16002
     /*  16002 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(16031), // Rule ID 22938 //
     /*  16007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16018 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (AND16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  16018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND16rr_ND),
     /*  16023 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  16029 */     GIR_RootConstrainSelectedInstOperands,
     /*  16030 */     // GIR_Coverage, 22938,
     /*  16030 */     GIR_Done,
     /*  16031 */   // Label 492: @16031
     /*  16031 */   GIM_Reject,
     /*  16032 */ // Label 481: @16032
     /*  16032 */ GIM_Reject,
     /*  16033 */ // Label 447: @16033
     /*  16033 */ GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(17858),
     /*  16038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  16041 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(16133), // Rule ID 17545 //
     /*  16046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  16049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16077 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16089 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16092 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  16096 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16102 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16109 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ANDN32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm),
     /*  16112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  16118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16131 */     GIR_RootConstrainSelectedInstOperands,
     /*  16132 */     // GIR_Coverage, 17545,
     /*  16132 */     GIR_EraseRootFromParent_Done,
     /*  16133 */   // Label 494: @16133
     /*  16133 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(16225), // Rule ID 17549 //
     /*  16138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  16141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16169 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16181 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16184 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  16188 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16201 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ANDN32rm_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm_EVEX),
     /*  16204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  16210 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16223 */     GIR_RootConstrainSelectedInstOperands,
     /*  16224 */     // GIR_Coverage, 17549,
     /*  16224 */     GIR_EraseRootFromParent_Done,
     /*  16225 */   // Label 495: @16225
     /*  16225 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(16317), // Rule ID 25100 //
     /*  16230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  16233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16248 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16251 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16255 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  16271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16280 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16286 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16293 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm),
     /*  16296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  16302 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16315 */     GIR_RootConstrainSelectedInstOperands,
     /*  16316 */     // GIR_Coverage, 25100,
     /*  16316 */     GIR_EraseRootFromParent_Done,
     /*  16317 */   // Label 496: @16317
     /*  16317 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(16409), // Rule ID 25104 //
     /*  16322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  16325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16340 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16343 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16347 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  16363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16372 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16378 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16385 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rm_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm_EVEX),
     /*  16388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  16394 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16407 */     GIR_RootConstrainSelectedInstOperands,
     /*  16408 */     // GIR_Coverage, 25104,
     /*  16408 */     GIR_EraseRootFromParent_Done,
     /*  16409 */   // Label 497: @16409
     /*  16409 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(16477), // Rule ID 26068 //
     /*  16414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  16417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16432 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16435 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16439 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16449 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16456 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (AND32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm),
     /*  16459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16461 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  16463 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16467 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16475 */     GIR_RootConstrainSelectedInstOperands,
     /*  16476 */     // GIR_Coverage, 26068,
     /*  16476 */     GIR_EraseRootFromParent_Done,
     /*  16477 */   // Label 498: @16477
     /*  16477 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(16545), // Rule ID 26087 //
     /*  16482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16500 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16503 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16507 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16524 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (AND32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm_ND),
     /*  16527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16529 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  16531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16535 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16543 */     GIR_RootConstrainSelectedInstOperands,
     /*  16544 */     // GIR_Coverage, 26087,
     /*  16544 */     GIR_EraseRootFromParent_Done,
     /*  16545 */   // Label 499: @16545
     /*  16545 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(16613), // Rule ID 22853 //
     /*  16550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  16553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16572 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16575 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16579 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16592 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (AND32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm),
     /*  16595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16597 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16599 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16603 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16611 */     GIR_RootConstrainSelectedInstOperands,
     /*  16612 */     // GIR_Coverage, 22853,
     /*  16612 */     GIR_EraseRootFromParent_Done,
     /*  16613 */   // Label 500: @16613
     /*  16613 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(16681), // Rule ID 22943 //
     /*  16618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16640 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16647 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16653 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16660 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (AND32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm_ND),
     /*  16663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16665 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16667 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16679 */     GIR_RootConstrainSelectedInstOperands,
     /*  16680 */     // GIR_Coverage, 22943,
     /*  16680 */     GIR_EraseRootFromParent_Done,
     /*  16681 */   // Label 501: @16681
     /*  16681 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(16758), // Rule ID 24992 //
     /*  16686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  16689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16717 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  16721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16733 */     // MIs[2] src
     /*  16733 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16738 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16744 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLCIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  16744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC32rr),
     /*  16747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  16753 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16756 */     GIR_RootConstrainSelectedInstOperands,
     /*  16757 */     // GIR_Coverage, 24992,
     /*  16757 */     GIR_EraseRootFromParent_Done,
     /*  16758 */   // Label 502: @16758
     /*  16758 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(16835), // Rule ID 25004 //
     /*  16763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  16766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16794 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16806 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16810 */     // MIs[2] src
     /*  16810 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16815 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16821 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (TZMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  16821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK32rr),
     /*  16824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  16830 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16833 */     GIR_RootConstrainSelectedInstOperands,
     /*  16834 */     // GIR_Coverage, 25004,
     /*  16834 */     GIR_EraseRootFromParent_Done,
     /*  16835 */   // Label 503: @16835
     /*  16835 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(16912), // Rule ID 17355 //
     /*  16840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  16843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16871 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16887 */     // MIs[2] src
     /*  16887 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16892 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  16896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16898 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  16898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC32rr),
     /*  16901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  16907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16910 */     GIR_RootConstrainSelectedInstOperands,
     /*  16911 */     // GIR_Coverage, 17355,
     /*  16911 */     GIR_EraseRootFromParent_Done,
     /*  16912 */   // Label 504: @16912
     /*  16912 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(16989), // Rule ID 17367 //
     /*  16917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  16920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16948 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16964 */     // MIs[2] src
     /*  16964 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16969 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16975 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (TZMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  16975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK32rr),
     /*  16978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  16984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16987 */     GIR_RootConstrainSelectedInstOperands,
     /*  16988 */     // GIR_Coverage, 17367,
     /*  16988 */     GIR_EraseRootFromParent_Done,
     /*  16989 */   // Label 505: @16989
     /*  16989 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(17047), // Rule ID 24986 //
     /*  16994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  16997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17022 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  17026 */     // MIs[0] src
     /*  17026 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17033 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL32rr),
     /*  17036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  17042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17045 */     GIR_RootConstrainSelectedInstOperands,
     /*  17046 */     // GIR_Coverage, 24986,
     /*  17046 */     GIR_EraseRootFromParent_Done,
     /*  17047 */   // Label 506: @17047
     /*  17047 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(17156), // Rule ID 26039 //
     /*  17052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  17067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  17075 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  17079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  17084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17090 */     // (and:{ *:[i32] } (rotl:{ *:[i32] } -2:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  17090 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17093 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17097 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  17104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  17111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17116 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17119 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  17123 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  17126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17136 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  17141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR32rr),
     /*  17144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17146 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  17148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17154 */     GIR_RootConstrainSelectedInstOperands,
     /*  17155 */     // GIR_Coverage, 26039,
     /*  17155 */     GIR_EraseRootFromParent_Done,
     /*  17156 */   // Label 507: @17156
     /*  17156 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(17210), // Rule ID 17349 //
     /*  17161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  17164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17187 */     // MIs[1] src
     /*  17187 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  17192 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  17196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17198 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL32rr),
     /*  17201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17203 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17208 */     GIR_RootConstrainSelectedInstOperands,
     /*  17209 */     // GIR_Coverage, 17349,
     /*  17209 */     GIR_EraseRootFromParent_Done,
     /*  17210 */   // Label 508: @17210
     /*  17210 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(17319), // Rule ID 22777 //
     /*  17215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  17234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  17242 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  17246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  17251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17253 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (rotl:{ *:[i32] } -2:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  17253 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17256 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17260 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  17267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  17274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17279 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  17286 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  17289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17299 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  17304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR32rr),
     /*  17307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17309 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  17311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17317 */     GIR_RootConstrainSelectedInstOperands,
     /*  17318 */     // GIR_Coverage, 22777,
     /*  17318 */     GIR_EraseRootFromParent_Done,
     /*  17319 */   // Label 509: @17319
     /*  17319 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(17384), // Rule ID 22629 //
     /*  17324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17335 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  17346 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, 65535:{ *:[i32] })  =>  (MOVZX32rr16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src1, sub_16bit:{ *:[i32] }))
     /*  17346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  17349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17358 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src1
     /*  17364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  17369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  17374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /*  17377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17382 */     GIR_RootConstrainSelectedInstOperands,
     /*  17383 */     // GIR_Coverage, 22629,
     /*  17383 */     GIR_EraseRootFromParent_Done,
     /*  17384 */   // Label 510: @17384
     /*  17384 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(17449), // Rule ID 22630 //
     /*  17389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17400 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  17411 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, 255:{ *:[i32] })  =>  (MOVZX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src1, sub_8bit:{ *:[i32] }))
     /*  17411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /*  17414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17423 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src1
     /*  17429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  17434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  17439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /*  17442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17447 */     GIR_RootConstrainSelectedInstOperands,
     /*  17448 */     // GIR_Coverage, 22630,
     /*  17448 */     GIR_EraseRootFromParent_Done,
     /*  17449 */   // Label 511: @17449
     /*  17449 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(17493), // Rule ID 22857 //
     /*  17454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  17457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17476 */     // MIs[1] Operand 1
     /*  17476 */     // No operand predicates
     /*  17476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17478 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (AND32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  17478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32ri),
     /*  17481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17483 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  17485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  17488 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17491 */     GIR_RootConstrainSelectedInstOperands,
     /*  17492 */     // GIR_Coverage, 22857,
     /*  17492 */     GIR_EraseRootFromParent_Done,
     /*  17493 */   // Label 512: @17493
     /*  17493 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(17537), // Rule ID 22947 //
     /*  17498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  17501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17520 */     // MIs[1] Operand 1
     /*  17520 */     // No operand predicates
     /*  17520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17522 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (AND32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  17522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32ri_ND),
     /*  17525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17527 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  17529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  17532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17535 */     GIR_RootConstrainSelectedInstOperands,
     /*  17536 */     // GIR_Coverage, 22947,
     /*  17536 */     GIR_EraseRootFromParent_Done,
     /*  17537 */   // Label 513: @17537
     /*  17537 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(17599), // Rule ID 17543 //
     /*  17542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  17545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17573 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17583 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src2)  =>  (ANDN32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr),
     /*  17586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17592 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  17594 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17597 */     GIR_RootConstrainSelectedInstOperands,
     /*  17598 */     // GIR_Coverage, 17543,
     /*  17598 */     GIR_EraseRootFromParent_Done,
     /*  17599 */   // Label 514: @17599
     /*  17599 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(17661), // Rule ID 17547 //
     /*  17604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  17607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17635 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17645 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src2)  =>  (ANDN32rr_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr_EVEX),
     /*  17648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17654 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  17656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17659 */     GIR_RootConstrainSelectedInstOperands,
     /*  17660 */     // GIR_Coverage, 17547,
     /*  17660 */     GIR_EraseRootFromParent_Done,
     /*  17661 */   // Label 515: @17661
     /*  17661 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(17723), // Rule ID 25098 //
     /*  17666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  17669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17701 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17707 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr),
     /*  17710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17716 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  17718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17721 */     GIR_RootConstrainSelectedInstOperands,
     /*  17722 */     // GIR_Coverage, 25098,
     /*  17722 */     GIR_EraseRootFromParent_Done,
     /*  17723 */   // Label 516: @17723
     /*  17723 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(17785), // Rule ID 25102 //
     /*  17728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  17731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17763 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17769 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rr_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr_EVEX),
     /*  17772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17778 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  17780 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17783 */     GIR_RootConstrainSelectedInstOperands,
     /*  17784 */     // GIR_Coverage, 25102,
     /*  17784 */     GIR_EraseRootFromParent_Done,
     /*  17785 */   // Label 517: @17785
     /*  17785 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(17821), // Rule ID 22849 //
     /*  17790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  17793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17808 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (AND32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17808 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND32rr),
     /*  17813 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  17819 */     GIR_RootConstrainSelectedInstOperands,
     /*  17820 */     // GIR_Coverage, 22849,
     /*  17820 */     GIR_Done,
     /*  17821 */   // Label 518: @17821
     /*  17821 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(17857), // Rule ID 22939 //
     /*  17826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  17829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17844 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (AND32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17844 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND32rr_ND),
     /*  17849 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  17855 */     GIR_RootConstrainSelectedInstOperands,
     /*  17856 */     // GIR_Coverage, 22939,
     /*  17856 */     GIR_Done,
     /*  17857 */   // Label 519: @17857
     /*  17857 */   GIM_Reject,
     /*  17858 */ // Label 493: @17858
     /*  17858 */ GIM_Reject,
     /*  17859 */ // Label 448: @17859
     /*  17859 */ GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(19562),
     /*  17864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  17867 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(17959), // Rule ID 17546 //
     /*  17872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  17875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  17878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  17882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  17894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  17898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  17903 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  17915 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  17918 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  17922 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  17926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17928 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  17935 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ANDN64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  17935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm),
     /*  17938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17944 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  17948 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  17957 */     GIR_RootConstrainSelectedInstOperands,
     /*  17958 */     // GIR_Coverage, 17546,
     /*  17958 */     GIR_EraseRootFromParent_Done,
     /*  17959 */   // Label 521: @17959
     /*  17959 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(18051), // Rule ID 17550 //
     /*  17964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  17967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  17970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  17974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  17986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  17990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  17995 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18007 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18010 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  18014 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  18018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18027 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ANDN64rm_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm_EVEX),
     /*  18030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  18036 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18049 */     GIR_RootConstrainSelectedInstOperands,
     /*  18050 */     // GIR_Coverage, 17550,
     /*  18050 */     GIR_EraseRootFromParent_Done,
     /*  18051 */   // Label 522: @18051
     /*  18051 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(18143), // Rule ID 25101 //
     /*  18056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  18059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18074 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18077 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18081 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  18097 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18106 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18119 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm),
     /*  18122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  18128 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18132 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18141 */     GIR_RootConstrainSelectedInstOperands,
     /*  18142 */     // GIR_Coverage, 25101,
     /*  18142 */     GIR_EraseRootFromParent_Done,
     /*  18143 */   // Label 523: @18143
     /*  18143 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(18235), // Rule ID 25105 //
     /*  18148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  18151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18166 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18169 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18173 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  18189 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18193 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18198 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18211 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rm_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm_EVEX),
     /*  18214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  18220 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18233 */     GIR_RootConstrainSelectedInstOperands,
     /*  18234 */     // GIR_Coverage, 25105,
     /*  18234 */     GIR_EraseRootFromParent_Done,
     /*  18235 */   // Label 524: @18235
     /*  18235 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(18303), // Rule ID 26069 //
     /*  18240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  18243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18258 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18261 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18265 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18282 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (AND64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm),
     /*  18285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18287 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  18289 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18301 */     GIR_RootConstrainSelectedInstOperands,
     /*  18302 */     // GIR_Coverage, 26069,
     /*  18302 */     GIR_EraseRootFromParent_Done,
     /*  18303 */   // Label 525: @18303
     /*  18303 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(18371), // Rule ID 26088 //
     /*  18308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  18311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18326 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18329 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18333 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18343 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18350 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (AND64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm_ND),
     /*  18353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18355 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  18357 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18369 */     GIR_RootConstrainSelectedInstOperands,
     /*  18370 */     // GIR_Coverage, 26088,
     /*  18370 */     GIR_EraseRootFromParent_Done,
     /*  18371 */   // Label 526: @18371
     /*  18371 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(18439), // Rule ID 22854 //
     /*  18376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  18379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18398 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18401 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18405 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18418 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (AND64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm),
     /*  18421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18423 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  18425 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18437 */     GIR_RootConstrainSelectedInstOperands,
     /*  18438 */     // GIR_Coverage, 22854,
     /*  18438 */     GIR_EraseRootFromParent_Done,
     /*  18439 */   // Label 527: @18439
     /*  18439 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(18507), // Rule ID 22944 //
     /*  18444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  18447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18466 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18469 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18473 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18486 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (AND64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm_ND),
     /*  18489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18491 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  18493 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18505 */     GIR_RootConstrainSelectedInstOperands,
     /*  18506 */     // GIR_Coverage, 22944,
     /*  18506 */     GIR_EraseRootFromParent_Done,
     /*  18507 */   // Label 528: @18507
     /*  18507 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(18584), // Rule ID 24993 //
     /*  18512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18543 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  18547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18555 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18559 */     // MIs[2] src
     /*  18559 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18564 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18570 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLCIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC64rr),
     /*  18573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18582 */     GIR_RootConstrainSelectedInstOperands,
     /*  18583 */     // GIR_Coverage, 24993,
     /*  18583 */     GIR_EraseRootFromParent_Done,
     /*  18584 */   // Label 529: @18584
     /*  18584 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(18661), // Rule ID 25005 //
     /*  18589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18620 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18636 */     // MIs[2] src
     /*  18636 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18641 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18647 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (TZMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK64rr),
     /*  18650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18659 */     GIR_RootConstrainSelectedInstOperands,
     /*  18660 */     // GIR_Coverage, 25005,
     /*  18660 */     GIR_EraseRootFromParent_Done,
     /*  18661 */   // Label 530: @18661
     /*  18661 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(18738), // Rule ID 17356 //
     /*  18666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18697 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18709 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18713 */     // MIs[2] src
     /*  18713 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18718 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  18722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18724 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC64rr),
     /*  18727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18733 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18736 */     GIR_RootConstrainSelectedInstOperands,
     /*  18737 */     // GIR_Coverage, 17356,
     /*  18737 */     GIR_EraseRootFromParent_Done,
     /*  18738 */   // Label 531: @18738
     /*  18738 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(18815), // Rule ID 17368 //
     /*  18743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18774 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18790 */     // MIs[2] src
     /*  18790 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18795 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18799 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18801 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (TZMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK64rr),
     /*  18804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18813 */     GIR_RootConstrainSelectedInstOperands,
     /*  18814 */     // GIR_Coverage, 17368,
     /*  18814 */     GIR_EraseRootFromParent_Done,
     /*  18815 */   // Label 532: @18815
     /*  18815 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(18873), // Rule ID 24987 //
     /*  18820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18848 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  18852 */     // MIs[0] src
     /*  18852 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18859 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL64rr),
     /*  18862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18871 */     GIR_RootConstrainSelectedInstOperands,
     /*  18872 */     // GIR_Coverage, 24987,
     /*  18872 */     GIR_EraseRootFromParent_Done,
     /*  18873 */   // Label 533: @18873
     /*  18873 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(18982), // Rule ID 26045 //
     /*  18878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  18893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  18901 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  18905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  18910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18916 */     // (and:{ *:[i64] } (rotl:{ *:[i64] } -2:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  18916 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  18919 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18923 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  18930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  18933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  18937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18942 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18945 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  18949 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  18952 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  18957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  18962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  18967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR64rr),
     /*  18970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18972 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  18974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18980 */     GIR_RootConstrainSelectedInstOperands,
     /*  18981 */     // GIR_Coverage, 26045,
     /*  18981 */     GIR_EraseRootFromParent_Done,
     /*  18982 */   // Label 534: @18982
     /*  18982 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(19036), // Rule ID 17350 //
     /*  18987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19013 */     // MIs[1] src
     /*  19013 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  19018 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  19022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19024 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  19024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL64rr),
     /*  19027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19029 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  19031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19034 */     GIR_RootConstrainSelectedInstOperands,
     /*  19035 */     // GIR_Coverage, 17350,
     /*  19035 */     GIR_EraseRootFromParent_Done,
     /*  19036 */   // Label 535: @19036
     /*  19036 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(19145), // Rule ID 22783 //
     /*  19041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  19060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  19068 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  19072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  19077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19079 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (rotl:{ *:[i64] } -2:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  19079 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  19082 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  19086 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  19093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  19096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  19100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19105 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19108 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  19112 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  19115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  19120 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  19125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  19130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR64rr),
     /*  19133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19135 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  19137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19143 */     GIR_RootConstrainSelectedInstOperands,
     /*  19144 */     // GIR_Coverage, 22783,
     /*  19144 */     GIR_EraseRootFromParent_Done,
     /*  19145 */   // Label 536: @19145
     /*  19145 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(19193), // Rule ID 22858 //
     /*  19150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  19153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19172 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  19176 */     // MIs[1] Operand 1
     /*  19176 */     // No operand predicates
     /*  19176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19178 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (AND64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  19178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64ri32),
     /*  19181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19183 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  19185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  19188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19191 */     GIR_RootConstrainSelectedInstOperands,
     /*  19192 */     // GIR_Coverage, 22858,
     /*  19192 */     GIR_EraseRootFromParent_Done,
     /*  19193 */   // Label 537: @19193
     /*  19193 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(19241), // Rule ID 22948 //
     /*  19198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  19201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  19224 */     // MIs[1] Operand 1
     /*  19224 */     // No operand predicates
     /*  19224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19226 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (AND64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  19226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64ri32_ND),
     /*  19229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19231 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  19233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  19236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19239 */     GIR_RootConstrainSelectedInstOperands,
     /*  19240 */     // GIR_Coverage, 22948,
     /*  19240 */     GIR_EraseRootFromParent_Done,
     /*  19241 */   // Label 538: @19241
     /*  19241 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(19303), // Rule ID 17544 //
     /*  19246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  19249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19277 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19287 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src2)  =>  (ANDN64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr),
     /*  19290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19296 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  19298 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19301 */     GIR_RootConstrainSelectedInstOperands,
     /*  19302 */     // GIR_Coverage, 17544,
     /*  19302 */     GIR_EraseRootFromParent_Done,
     /*  19303 */   // Label 539: @19303
     /*  19303 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(19365), // Rule ID 17548 //
     /*  19308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  19311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19339 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19349 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src2)  =>  (ANDN64rr_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr_EVEX),
     /*  19352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19358 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  19360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19363 */     GIR_RootConstrainSelectedInstOperands,
     /*  19364 */     // GIR_Coverage, 17548,
     /*  19364 */     GIR_EraseRootFromParent_Done,
     /*  19365 */   // Label 540: @19365
     /*  19365 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(19427), // Rule ID 25099 //
     /*  19370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  19373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19405 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19411 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr),
     /*  19414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19420 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  19422 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19425 */     GIR_RootConstrainSelectedInstOperands,
     /*  19426 */     // GIR_Coverage, 25099,
     /*  19426 */     GIR_EraseRootFromParent_Done,
     /*  19427 */   // Label 541: @19427
     /*  19427 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(19489), // Rule ID 25103 //
     /*  19432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  19435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19467 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19473 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rr_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr_EVEX),
     /*  19476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19482 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  19484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19487 */     GIR_RootConstrainSelectedInstOperands,
     /*  19488 */     // GIR_Coverage, 25103,
     /*  19488 */     GIR_EraseRootFromParent_Done,
     /*  19489 */   // Label 542: @19489
     /*  19489 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(19525), // Rule ID 22850 //
     /*  19494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  19497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19512 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (AND64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND64rr),
     /*  19517 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  19523 */     GIR_RootConstrainSelectedInstOperands,
     /*  19524 */     // GIR_Coverage, 22850,
     /*  19524 */     GIR_Done,
     /*  19525 */   // Label 543: @19525
     /*  19525 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(19561), // Rule ID 22940 //
     /*  19530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  19533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19548 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (AND64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND64rr_ND),
     /*  19553 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  19559 */     GIR_RootConstrainSelectedInstOperands,
     /*  19560 */     // GIR_Coverage, 22940,
     /*  19560 */     GIR_Done,
     /*  19561 */   // Label 544: @19561
     /*  19561 */   GIM_Reject,
     /*  19562 */ // Label 520: @19562
     /*  19562 */ GIM_Reject,
     /*  19563 */ // Label 449: @19563
     /*  19563 */ GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(19908),
     /*  19568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  19571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  19574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19578 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(19698), // Rule ID 19488 //
     /*  19583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  19595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  19599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19608 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19614 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  19616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19622 */     // (and:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }), VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  19622 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  19625 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19629 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19634 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  19638 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19643 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  19646 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19650 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19655 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19659 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  19667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  19671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19676 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19679 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  19682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  19697 */     // GIR_Coverage, 19488,
     /*  19697 */     GIR_EraseRootFromParent_Done,
     /*  19698 */   // Label 546: @19698
     /*  19698 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(19818), // Rule ID 25365 //
     /*  19703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  19719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  19723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19732 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19738 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  19740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19742 */     // (and:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src2, (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  19742 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  19745 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19749 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19754 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  19758 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19763 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  19766 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19770 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19775 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19779 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  19787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  19791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19796 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19799 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  19802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  19817 */     // GIR_Coverage, 25365,
     /*  19817 */     GIR_EraseRootFromParent_Done,
     /*  19818 */   // Label 547: @19818
     /*  19818 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(19907), // Rule ID 19484 //
     /*  19823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19831 */     // (and:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  19831 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  19834 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19838 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19843 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  19847 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19852 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  19855 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19859 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19864 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  19868 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  19876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  19880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19885 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19888 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  19891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  19906 */     // GIR_Coverage, 19484,
     /*  19906 */     GIR_EraseRootFromParent_Done,
     /*  19907 */   // Label 548: @19907
     /*  19907 */   GIM_Reject,
     /*  19908 */ // Label 545: @19908
     /*  19908 */ GIM_Reject,
     /*  19909 */ // Label 450: @19909
     /*  19909 */ GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(20250),
     /*  19914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  19920 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(19982), // Rule ID 23357 //
     /*  19925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  19928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  19932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  19940 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  19943 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  19947 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  19951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  19955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  19964 */     // (and:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPANDrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  19964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  19967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19969 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  19971 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  19975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  19980 */     GIR_RootConstrainSelectedInstOperands,
     /*  19981 */     // GIR_Coverage, 23357,
     /*  19981 */     GIR_EraseRootFromParent_Done,
     /*  19982 */   // Label 550: @19982
     /*  19982 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(20044), // Rule ID 24146 //
     /*  19987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  19990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  19994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20002 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20005 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20009 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20026 */     // (and:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPANDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  20029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20031 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20033 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20042 */     GIR_RootConstrainSelectedInstOperands,
     /*  20043 */     // GIR_Coverage, 24146,
     /*  20043 */     GIR_EraseRootFromParent_Done,
     /*  20044 */   // Label 551: @20044
     /*  20044 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(20106), // Rule ID 2110 //
     /*  20049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20068 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20071 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20075 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20081 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20088 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  20091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20093 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  20095 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20104 */     GIR_RootConstrainSelectedInstOperands,
     /*  20105 */     // GIR_Coverage, 2110,
     /*  20105 */     GIR_EraseRootFromParent_Done,
     /*  20106 */   // Label 552: @20106
     /*  20106 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(20168), // Rule ID 5706 //
     /*  20111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20130 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20133 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20137 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20150 */     // (and:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  20153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20155 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  20157 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20166 */     GIR_RootConstrainSelectedInstOperands,
     /*  20167 */     // GIR_Coverage, 5706,
     /*  20167 */     GIR_EraseRootFromParent_Done,
     /*  20168 */   // Label 553: @20168
     /*  20168 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(20195), // Rule ID 2109 //
     /*  20173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20188 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPANDrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  20188 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  20193 */     GIR_RootConstrainSelectedInstOperands,
     /*  20194 */     // GIR_Coverage, 2109,
     /*  20194 */     GIR_Done,
     /*  20195 */   // Label 554: @20195
     /*  20195 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(20222), // Rule ID 2111 //
     /*  20200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  20203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20215 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PANDrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  20215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  20220 */     GIR_RootConstrainSelectedInstOperands,
     /*  20221 */     // GIR_Coverage, 2111,
     /*  20221 */     GIR_Done,
     /*  20222 */   // Label 555: @20222
     /*  20222 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(20249), // Rule ID 5703 //
     /*  20227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20242 */     // (and:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPANDQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  20242 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /*  20247 */     GIR_RootConstrainSelectedInstOperands,
     /*  20248 */     // GIR_Coverage, 5703,
     /*  20248 */     GIR_Done,
     /*  20249 */   // Label 556: @20249
     /*  20249 */   GIM_Reject,
     /*  20250 */ // Label 549: @20250
     /*  20250 */ GIM_Reject,
     /*  20251 */ // Label 451: @20251
     /*  20251 */ GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(20596),
     /*  20256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  20259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  20262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20266 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(20386), // Rule ID 19489 //
     /*  20271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  20283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  20287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20296 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20302 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  20304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20310 */     // (and:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }), VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  20310 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20313 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20317 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20322 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  20326 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20331 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20334 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20338 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20343 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20347 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  20359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20364 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20367 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  20385 */     // GIR_Coverage, 19489,
     /*  20385 */     GIR_EraseRootFromParent_Done,
     /*  20386 */   // Label 558: @20386
     /*  20386 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(20506), // Rule ID 25366 //
     /*  20391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  20407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  20411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20420 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20426 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  20428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20430 */     // (and:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src2, (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  20430 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20433 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20437 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20442 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  20446 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20451 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20454 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20458 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20463 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20467 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  20479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20484 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20487 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  20505 */     // GIR_Coverage, 25366,
     /*  20505 */     GIR_EraseRootFromParent_Done,
     /*  20506 */   // Label 559: @20506
     /*  20506 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(20595), // Rule ID 19485 //
     /*  20511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20519 */     // (and:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  20519 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20522 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20526 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20531 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  20535 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20540 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20543 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20547 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20552 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  20556 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  20568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20573 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20576 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20589 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  20594 */     // GIR_Coverage, 19485,
     /*  20594 */     GIR_EraseRootFromParent_Done,
     /*  20595 */   // Label 560: @20595
     /*  20595 */   GIM_Reject,
     /*  20596 */ // Label 557: @20596
     /*  20596 */ GIM_Reject,
     /*  20597 */ // Label 452: @20597
     /*  20597 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(20938),
     /*  20602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20608 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(20670), // Rule ID 24164 //
     /*  20613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20628 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20635 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20652 */     // (and:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPANDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ128rm),
     /*  20655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20657 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20659 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20668 */     GIR_RootConstrainSelectedInstOperands,
     /*  20669 */     // GIR_Coverage, 24164,
     /*  20669 */     GIR_EraseRootFromParent_Done,
     /*  20670 */   // Label 562: @20670
     /*  20670 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(20732), // Rule ID 25250 //
     /*  20675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20690 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20693 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20697 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20714 */     // (and:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPANDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  20717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20719 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20721 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20730 */     GIR_RootConstrainSelectedInstOperands,
     /*  20731 */     // GIR_Coverage, 25250,
     /*  20731 */     GIR_EraseRootFromParent_Done,
     /*  20732 */   // Label 563: @20732
     /*  20732 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(20794), // Rule ID 5733 //
     /*  20737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20756 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20759 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20763 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20769 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20776 */     // (and:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ128rm),
     /*  20779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20781 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  20783 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20792 */     GIR_RootConstrainSelectedInstOperands,
     /*  20793 */     // GIR_Coverage, 5733,
     /*  20793 */     GIR_EraseRootFromParent_Done,
     /*  20794 */   // Label 564: @20794
     /*  20794 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(20856), // Rule ID 18159 //
     /*  20799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20818 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20821 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20825 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20831 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20838 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  20841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20843 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  20845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20854 */     GIR_RootConstrainSelectedInstOperands,
     /*  20855 */     // GIR_Coverage, 18159,
     /*  20855 */     GIR_EraseRootFromParent_Done,
     /*  20856 */   // Label 565: @20856
     /*  20856 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(20883), // Rule ID 5730 //
     /*  20861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20876 */     // (and:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPANDDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  20876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZ128rr),
     /*  20881 */     GIR_RootConstrainSelectedInstOperands,
     /*  20882 */     // GIR_Coverage, 5730,
     /*  20882 */     GIR_Done,
     /*  20883 */   // Label 566: @20883
     /*  20883 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(20910), // Rule ID 18147 //
     /*  20888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20903 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPANDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  20903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  20908 */     GIR_RootConstrainSelectedInstOperands,
     /*  20909 */     // GIR_Coverage, 18147,
     /*  20909 */     GIR_Done,
     /*  20910 */   // Label 567: @20910
     /*  20910 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(20937), // Rule ID 18171 //
     /*  20915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  20918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20930 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PANDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  20930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  20935 */     GIR_RootConstrainSelectedInstOperands,
     /*  20936 */     // GIR_Coverage, 18171,
     /*  20936 */     GIR_Done,
     /*  20937 */   // Label 568: @20937
     /*  20937 */   GIM_Reject,
     /*  20938 */ // Label 561: @20938
     /*  20938 */ GIM_Reject,
     /*  20939 */ // Label 453: @20939
     /*  20939 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(21404),
     /*  20944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  20947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  20950 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(21012), // Rule ID 23359 //
     /*  20955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  20958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  20962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20970 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20973 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20977 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  20985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20994 */     // (and:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPANDYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  20997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20999 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21001 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21010 */     GIR_RootConstrainSelectedInstOperands,
     /*  21011 */     // GIR_Coverage, 23359,
     /*  21011 */     GIR_EraseRootFromParent_Done,
     /*  21012 */   // Label 570: @21012
     /*  21012 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(21074), // Rule ID 24140 //
     /*  21017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21032 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21035 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21039 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21056 */     // (and:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPANDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  21059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21061 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21063 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21072 */     GIR_RootConstrainSelectedInstOperands,
     /*  21073 */     // GIR_Coverage, 24140,
     /*  21073 */     GIR_EraseRootFromParent_Done,
     /*  21074 */   // Label 571: @21074
     /*  21074 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(21136), // Rule ID 25239 //
     /*  21079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  21082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21094 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21097 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21101 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21111 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21118 */     // (and:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VANDPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  21121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21123 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21125 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21134 */     GIR_RootConstrainSelectedInstOperands,
     /*  21135 */     // GIR_Coverage, 25239,
     /*  21135 */     GIR_EraseRootFromParent_Done,
     /*  21136 */   // Label 572: @21136
     /*  21136 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(21198), // Rule ID 2114 //
     /*  21141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  21144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21160 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21163 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21167 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21180 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  21183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21185 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21187 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21196 */     GIR_RootConstrainSelectedInstOperands,
     /*  21197 */     // GIR_Coverage, 2114,
     /*  21197 */     GIR_EraseRootFromParent_Done,
     /*  21198 */   // Label 573: @21198
     /*  21198 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(21260), // Rule ID 5697 //
     /*  21203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21222 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21225 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21229 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21235 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21242 */     // (and:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  21245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21247 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21249 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21258 */     GIR_RootConstrainSelectedInstOperands,
     /*  21259 */     // GIR_Coverage, 5697,
     /*  21259 */     GIR_EraseRootFromParent_Done,
     /*  21260 */   // Label 574: @21260
     /*  21260 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(21322), // Rule ID 18132 //
     /*  21265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  21268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21284 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21287 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21291 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21304 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  21307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21309 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21311 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21320 */     GIR_RootConstrainSelectedInstOperands,
     /*  21321 */     // GIR_Coverage, 18132,
     /*  21321 */     GIR_EraseRootFromParent_Done,
     /*  21322 */   // Label 575: @21322
     /*  21322 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(21349), // Rule ID 2113 //
     /*  21327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  21330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21342 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPANDYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  21342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  21347 */     GIR_RootConstrainSelectedInstOperands,
     /*  21348 */     // GIR_Coverage, 2113,
     /*  21348 */     GIR_Done,
     /*  21349 */   // Label 576: @21349
     /*  21349 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(21376), // Rule ID 5694 //
     /*  21354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21369 */     // (and:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPANDQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  21369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /*  21374 */     GIR_RootConstrainSelectedInstOperands,
     /*  21375 */     // GIR_Coverage, 5694,
     /*  21375 */     GIR_Done,
     /*  21376 */   // Label 577: @21376
     /*  21376 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(21403), // Rule ID 18116 //
     /*  21381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  21384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21396 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VANDPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  21396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  21401 */     GIR_RootConstrainSelectedInstOperands,
     /*  21402 */     // GIR_Coverage, 18116,
     /*  21402 */     GIR_Done,
     /*  21403 */   // Label 578: @21403
     /*  21403 */   GIM_Reject,
     /*  21404 */ // Label 569: @21404
     /*  21404 */ GIM_Reject,
     /*  21405 */ // Label 454: @21405
     /*  21405 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(21902),
     /*  21410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21420 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(21480), // Rule ID 4430 //
     /*  21425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  21428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21453 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21459 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21467 */     // (and:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (KANDNBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  21467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNBkk),
     /*  21470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21476 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  21478 */     GIR_RootConstrainSelectedInstOperands,
     /*  21479 */     // GIR_Coverage, 4430,
     /*  21479 */     GIR_EraseRootFromParent_Done,
     /*  21480 */   // Label 580: @21480
     /*  21480 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(21603), // Rule ID 19486 //
     /*  21485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  21488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21513 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21519 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21527 */     // (and:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  21527 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  21530 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21534 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21539 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  21543 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21548 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  21551 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21555 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21560 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21564 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  21572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  21576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21581 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21584 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  21587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  21597 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  21602 */     // GIR_Coverage, 19486,
     /*  21602 */     GIR_EraseRootFromParent_Done,
     /*  21603 */   // Label 581: @21603
     /*  21603 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(21663), // Rule ID 23689 //
     /*  21608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  21611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21640 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21646 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21650 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (KANDNBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  21650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNBkk),
     /*  21653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21659 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  21661 */     GIR_RootConstrainSelectedInstOperands,
     /*  21662 */     // GIR_Coverage, 23689,
     /*  21662 */     GIR_EraseRootFromParent_Done,
     /*  21663 */   // Label 582: @21663
     /*  21663 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(21786), // Rule ID 25363 //
     /*  21668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  21671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21700 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21706 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21710 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  21710 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  21713 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21717 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21722 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  21726 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21731 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  21734 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21738 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21743 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21747 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  21755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  21759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21764 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21767 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  21770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  21780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  21785 */     // GIR_Coverage, 25363,
     /*  21785 */     GIR_EraseRootFromParent_Done,
     /*  21786 */   // Label 583: @21786
     /*  21786 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(21809), // Rule ID 4414 //
     /*  21791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  21794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21802 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KANDBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  21802 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDBkk),
     /*  21807 */     GIR_RootConstrainSelectedInstOperands,
     /*  21808 */     // GIR_Coverage, 4414,
     /*  21808 */     GIR_Done,
     /*  21809 */   // Label 584: @21809
     /*  21809 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(21901), // Rule ID 19482 //
     /*  21814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  21817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21825 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  21825 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  21828 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21832 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21837 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  21841 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21846 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  21849 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21853 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21858 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  21862 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  21870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  21874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21879 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21882 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  21885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  21895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  21900 */     // GIR_Coverage, 19482,
     /*  21900 */     GIR_EraseRootFromParent_Done,
     /*  21901 */   // Label 585: @21901
     /*  21901 */   GIM_Reject,
     /*  21902 */ // Label 579: @21902
     /*  21902 */ GIM_Reject,
     /*  21903 */ // Label 455: @21903
     /*  21903 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(22244),
     /*  21908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  21914 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(21976), // Rule ID 25249 //
     /*  21919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  21922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21934 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21937 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21941 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21958 */     // (and:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPANDrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  21961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21963 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21965 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21974 */     GIR_RootConstrainSelectedInstOperands,
     /*  21975 */     // GIR_Coverage, 25249,
     /*  21975 */     GIR_EraseRootFromParent_Done,
     /*  21976 */   // Label 587: @21976
     /*  21976 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(22038), // Rule ID 25430 //
     /*  21981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  21984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  21988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21996 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21999 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22003 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22020 */     // (and:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPANDQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  22023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22025 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22027 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22036 */     GIR_RootConstrainSelectedInstOperands,
     /*  22037 */     // GIR_Coverage, 25430,
     /*  22037 */     GIR_EraseRootFromParent_Done,
     /*  22038 */   // Label 588: @22038
     /*  22038 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(22100), // Rule ID 18158 //
     /*  22043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  22046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22062 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22065 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22069 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22082 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  22085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22087 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22089 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22098 */     GIR_RootConstrainSelectedInstOperands,
     /*  22099 */     // GIR_Coverage, 18158,
     /*  22099 */     GIR_EraseRootFromParent_Done,
     /*  22100 */   // Label 589: @22100
     /*  22100 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(22162), // Rule ID 20024 //
     /*  22105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  22108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22124 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22127 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22131 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22144 */     // (and:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  22147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22149 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22151 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22160 */     GIR_RootConstrainSelectedInstOperands,
     /*  22161 */     // GIR_Coverage, 20024,
     /*  22161 */     GIR_EraseRootFromParent_Done,
     /*  22162 */   // Label 590: @22162
     /*  22162 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(22189), // Rule ID 18146 //
     /*  22167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  22170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22182 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPANDrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  22182 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  22187 */     GIR_RootConstrainSelectedInstOperands,
     /*  22188 */     // GIR_Coverage, 18146,
     /*  22188 */     GIR_Done,
     /*  22189 */   // Label 591: @22189
     /*  22189 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(22216), // Rule ID 18170 //
     /*  22194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  22197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22209 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PANDrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  22209 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  22214 */     GIR_RootConstrainSelectedInstOperands,
     /*  22215 */     // GIR_Coverage, 18170,
     /*  22215 */     GIR_Done,
     /*  22216 */   // Label 592: @22216
     /*  22216 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(22243), // Rule ID 20016 //
     /*  22221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  22224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22236 */     // (and:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPANDQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  22236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /*  22241 */     GIR_RootConstrainSelectedInstOperands,
     /*  22242 */     // GIR_Coverage, 20016,
     /*  22242 */     GIR_Done,
     /*  22243 */   // Label 593: @22243
     /*  22243 */   GIM_Reject,
     /*  22244 */ // Label 586: @22244
     /*  22244 */ GIM_Reject,
     /*  22245 */ // Label 456: @22245
     /*  22245 */ GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(22710),
     /*  22250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  22253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  22256 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(22318), // Rule ID 24158 //
     /*  22261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  22264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22276 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22279 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22283 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22300 */     // (and:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPANDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ256rm),
     /*  22303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22305 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22307 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22316 */     GIR_RootConstrainSelectedInstOperands,
     /*  22317 */     // GIR_Coverage, 24158,
     /*  22317 */     GIR_EraseRootFromParent_Done,
     /*  22318 */   // Label 595: @22318
     /*  22318 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(22380), // Rule ID 25229 //
     /*  22323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  22326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22338 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22341 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22345 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22362 */     // (and:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPANDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  22365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22367 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22369 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22378 */     GIR_RootConstrainSelectedInstOperands,
     /*  22379 */     // GIR_Coverage, 25229,
     /*  22379 */     GIR_EraseRootFromParent_Done,
     /*  22380 */   // Label 596: @22380
     /*  22380 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(22442), // Rule ID 25238 //
     /*  22385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  22388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22400 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22403 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22407 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22424 */     // (and:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VANDPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  22427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22429 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22431 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22440 */     GIR_RootConstrainSelectedInstOperands,
     /*  22441 */     // GIR_Coverage, 25238,
     /*  22441 */     GIR_EraseRootFromParent_Done,
     /*  22442 */   // Label 597: @22442
     /*  22442 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(22504), // Rule ID 5724 //
     /*  22447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  22450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22466 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22469 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22473 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22486 */     // (and:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ256rm),
     /*  22489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22491 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22493 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22502 */     GIR_RootConstrainSelectedInstOperands,
     /*  22503 */     // GIR_Coverage, 5724,
     /*  22503 */     GIR_EraseRootFromParent_Done,
     /*  22504 */   // Label 598: @22504
     /*  22504 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(22566), // Rule ID 18103 //
     /*  22509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  22512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22528 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22531 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22535 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22548 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  22551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22553 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22564 */     GIR_RootConstrainSelectedInstOperands,
     /*  22565 */     // GIR_Coverage, 18103,
     /*  22565 */     GIR_EraseRootFromParent_Done,
     /*  22566 */   // Label 599: @22566
     /*  22566 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(22628), // Rule ID 18131 //
     /*  22571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  22574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22590 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22593 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22597 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22603 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22610 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  22613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22615 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22617 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22626 */     GIR_RootConstrainSelectedInstOperands,
     /*  22627 */     // GIR_Coverage, 18131,
     /*  22627 */     GIR_EraseRootFromParent_Done,
     /*  22628 */   // Label 600: @22628
     /*  22628 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(22655), // Rule ID 5721 //
     /*  22633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  22636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22648 */     // (and:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPANDDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  22648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZ256rr),
     /*  22653 */     GIR_RootConstrainSelectedInstOperands,
     /*  22654 */     // GIR_Coverage, 5721,
     /*  22654 */     GIR_Done,
     /*  22655 */   // Label 601: @22655
     /*  22655 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(22682), // Rule ID 18091 //
     /*  22660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  22663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22675 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPANDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  22675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  22680 */     GIR_RootConstrainSelectedInstOperands,
     /*  22681 */     // GIR_Coverage, 18091,
     /*  22681 */     GIR_Done,
     /*  22682 */   // Label 602: @22682
     /*  22682 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(22709), // Rule ID 18115 //
     /*  22687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  22690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22702 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VANDPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  22702 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  22707 */     GIR_RootConstrainSelectedInstOperands,
     /*  22708 */     // GIR_Coverage, 18115,
     /*  22708 */     GIR_Done,
     /*  22709 */   // Label 603: @22709
     /*  22709 */   GIM_Reject,
     /*  22710 */ // Label 594: @22710
     /*  22710 */ GIM_Reject,
     /*  22711 */ // Label 457: @22711
     /*  22711 */ GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(22866),
     /*  22716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  22719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  22722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22726 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(22784), // Rule ID 24134 //
     /*  22731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  22734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22742 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22745 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22749 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22759 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22766 */     // (and:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPANDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  22769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22771 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22773 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22782 */     GIR_RootConstrainSelectedInstOperands,
     /*  22783 */     // GIR_Coverage, 24134,
     /*  22783 */     GIR_EraseRootFromParent_Done,
     /*  22784 */   // Label 605: @22784
     /*  22784 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(22842), // Rule ID 5688 //
     /*  22789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  22792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22804 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22807 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22811 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22824 */     // (and:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  22827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22829 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22831 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22840 */     GIR_RootConstrainSelectedInstOperands,
     /*  22841 */     // GIR_Coverage, 5688,
     /*  22841 */     GIR_EraseRootFromParent_Done,
     /*  22842 */   // Label 606: @22842
     /*  22842 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(22865), // Rule ID 5685 //
     /*  22847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  22850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22858 */     // (and:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPANDQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  22858 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /*  22863 */     GIR_RootConstrainSelectedInstOperands,
     /*  22864 */     // GIR_Coverage, 5685,
     /*  22864 */     GIR_Done,
     /*  22865 */   // Label 607: @22865
     /*  22865 */   GIM_Reject,
     /*  22866 */ // Label 604: @22866
     /*  22866 */ GIM_Reject,
     /*  22867 */ // Label 458: @22867
     /*  22867 */ GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(23026),
     /*  22872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  22875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  22878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  22882 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(22942), // Rule ID 4431 //
     /*  22887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  22890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  22902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  22906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  22911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22915 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22921 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  22923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  22927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22929 */     // (and:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }), VK16:{ *:[v16i1] }:$src2)  =>  (KANDNWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  22929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  22932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  22938 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  22940 */     GIR_RootConstrainSelectedInstOperands,
     /*  22941 */     // GIR_Coverage, 4431,
     /*  22941 */     GIR_EraseRootFromParent_Done,
     /*  22942 */   // Label 609: @22942
     /*  22942 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(23002), // Rule ID 23690 //
     /*  22947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  22950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  22954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  22966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  22970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  22975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22979 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22985 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  22987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22989 */     // (and:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src2, (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }))  =>  (KANDNWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  22989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  22992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  22998 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  23000 */     GIR_RootConstrainSelectedInstOperands,
     /*  23001 */     // GIR_Coverage, 23690,
     /*  23001 */     GIR_EraseRootFromParent_Done,
     /*  23002 */   // Label 610: @23002
     /*  23002 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(23025), // Rule ID 4415 //
     /*  23007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23018 */     // (and:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KANDWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  23018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  23023 */     GIR_RootConstrainSelectedInstOperands,
     /*  23024 */     // GIR_Coverage, 4415,
     /*  23024 */     GIR_Done,
     /*  23025 */   // Label 611: @23025
     /*  23025 */   GIM_Reject,
     /*  23026 */ // Label 608: @23026
     /*  23026 */ GIM_Reject,
     /*  23027 */ // Label 459: @23027
     /*  23027 */ GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(23368),
     /*  23032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  23035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  23038 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(23100), // Rule ID 25248 //
     /*  23043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  23046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23058 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23061 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23065 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23082 */     // (and:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPANDrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  23085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23087 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23089 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23098 */     GIR_RootConstrainSelectedInstOperands,
     /*  23099 */     // GIR_Coverage, 25248,
     /*  23099 */     GIR_EraseRootFromParent_Done,
     /*  23100 */   // Label 613: @23100
     /*  23100 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(23162), // Rule ID 25429 //
     /*  23105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23120 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23123 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23127 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23144 */     // (and:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPANDQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  23147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23149 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23151 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23160 */     GIR_RootConstrainSelectedInstOperands,
     /*  23161 */     // GIR_Coverage, 25429,
     /*  23161 */     GIR_EraseRootFromParent_Done,
     /*  23162 */   // Label 614: @23162
     /*  23162 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(23224), // Rule ID 18157 //
     /*  23167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  23170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23186 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23189 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23193 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23206 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  23209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23211 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23213 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23222 */     GIR_RootConstrainSelectedInstOperands,
     /*  23223 */     // GIR_Coverage, 18157,
     /*  23223 */     GIR_EraseRootFromParent_Done,
     /*  23224 */   // Label 615: @23224
     /*  23224 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(23286), // Rule ID 20023 //
     /*  23229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23248 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23251 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23255 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23261 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23268 */     // (and:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  23271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23273 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23275 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23284 */     GIR_RootConstrainSelectedInstOperands,
     /*  23285 */     // GIR_Coverage, 20023,
     /*  23285 */     GIR_EraseRootFromParent_Done,
     /*  23286 */   // Label 616: @23286
     /*  23286 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(23313), // Rule ID 18145 //
     /*  23291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  23294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23306 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPANDrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  23306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  23311 */     GIR_RootConstrainSelectedInstOperands,
     /*  23312 */     // GIR_Coverage, 18145,
     /*  23312 */     GIR_Done,
     /*  23313 */   // Label 617: @23313
     /*  23313 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(23340), // Rule ID 18169 //
     /*  23318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  23321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23333 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PANDrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  23333 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  23338 */     GIR_RootConstrainSelectedInstOperands,
     /*  23339 */     // GIR_Coverage, 18169,
     /*  23339 */     GIR_Done,
     /*  23340 */   // Label 618: @23340
     /*  23340 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(23367), // Rule ID 20015 //
     /*  23345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23360 */     // (and:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPANDQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  23360 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /*  23365 */     GIR_RootConstrainSelectedInstOperands,
     /*  23366 */     // GIR_Coverage, 20015,
     /*  23366 */     GIR_Done,
     /*  23367 */   // Label 619: @23367
     /*  23367 */   GIM_Reject,
     /*  23368 */ // Label 612: @23368
     /*  23368 */ GIM_Reject,
     /*  23369 */ // Label 460: @23369
     /*  23369 */ GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(23834),
     /*  23374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  23377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  23380 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(23442), // Rule ID 25228 //
     /*  23385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  23388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23400 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23403 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23407 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23424 */     // (and:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPANDYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  23427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23429 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23431 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23440 */     GIR_RootConstrainSelectedInstOperands,
     /*  23441 */     // GIR_Coverage, 25228,
     /*  23441 */     GIR_EraseRootFromParent_Done,
     /*  23442 */   // Label 621: @23442
     /*  23442 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(23504), // Rule ID 25237 //
     /*  23447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  23450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23462 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23465 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23469 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23486 */     // (and:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VANDPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  23489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23491 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23493 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23502 */     GIR_RootConstrainSelectedInstOperands,
     /*  23503 */     // GIR_Coverage, 25237,
     /*  23503 */     GIR_EraseRootFromParent_Done,
     /*  23504 */   // Label 622: @23504
     /*  23504 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(23566), // Rule ID 25436 //
     /*  23509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23524 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23527 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23531 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23548 */     // (and:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPANDQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  23551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23553 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23564 */     GIR_RootConstrainSelectedInstOperands,
     /*  23565 */     // GIR_Coverage, 25436,
     /*  23565 */     GIR_EraseRootFromParent_Done,
     /*  23566 */   // Label 623: @23566
     /*  23566 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(23628), // Rule ID 18102 //
     /*  23571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  23574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23590 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23593 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23597 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23603 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23610 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  23613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23615 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23617 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23626 */     GIR_RootConstrainSelectedInstOperands,
     /*  23627 */     // GIR_Coverage, 18102,
     /*  23627 */     GIR_EraseRootFromParent_Done,
     /*  23628 */   // Label 624: @23628
     /*  23628 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(23690), // Rule ID 18130 //
     /*  23633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  23636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23652 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23655 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23659 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23672 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  23675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23677 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23679 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23688 */     GIR_RootConstrainSelectedInstOperands,
     /*  23689 */     // GIR_Coverage, 18130,
     /*  23689 */     GIR_EraseRootFromParent_Done,
     /*  23690 */   // Label 625: @23690
     /*  23690 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(23752), // Rule ID 20040 //
     /*  23695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23714 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23717 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23721 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23727 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23734 */     // (and:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  23737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23739 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23741 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23750 */     GIR_RootConstrainSelectedInstOperands,
     /*  23751 */     // GIR_Coverage, 20040,
     /*  23751 */     GIR_EraseRootFromParent_Done,
     /*  23752 */   // Label 626: @23752
     /*  23752 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(23779), // Rule ID 18090 //
     /*  23757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  23760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23772 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPANDYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  23772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  23777 */     GIR_RootConstrainSelectedInstOperands,
     /*  23778 */     // GIR_Coverage, 18090,
     /*  23778 */     GIR_Done,
     /*  23779 */   // Label 627: @23779
     /*  23779 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(23806), // Rule ID 18114 //
     /*  23784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  23787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23799 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VANDPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  23799 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  23804 */     GIR_RootConstrainSelectedInstOperands,
     /*  23805 */     // GIR_Coverage, 18114,
     /*  23805 */     GIR_Done,
     /*  23806 */   // Label 628: @23806
     /*  23806 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(23833), // Rule ID 20032 //
     /*  23811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23826 */     // (and:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPANDQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  23826 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /*  23831 */     GIR_RootConstrainSelectedInstOperands,
     /*  23832 */     // GIR_Coverage, 20032,
     /*  23832 */     GIR_Done,
     /*  23833 */   // Label 629: @23833
     /*  23833 */   GIM_Reject,
     /*  23834 */ // Label 620: @23834
     /*  23834 */ GIM_Reject,
     /*  23835 */ // Label 461: @23835
     /*  23835 */ GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(23990),
     /*  23840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  23843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  23846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23850 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(23908), // Rule ID 24152 //
     /*  23855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23866 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23869 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23873 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23883 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23890 */     // (and:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPANDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZrm),
     /*  23893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23895 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23897 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23906 */     GIR_RootConstrainSelectedInstOperands,
     /*  23907 */     // GIR_Coverage, 24152,
     /*  23907 */     GIR_EraseRootFromParent_Done,
     /*  23908 */   // Label 631: @23908
     /*  23908 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(23966), // Rule ID 5715 //
     /*  23913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23928 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23931 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23935 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23948 */     // (and:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZrm),
     /*  23951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23953 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23955 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23964 */     GIR_RootConstrainSelectedInstOperands,
     /*  23965 */     // GIR_Coverage, 5715,
     /*  23965 */     GIR_EraseRootFromParent_Done,
     /*  23966 */   // Label 632: @23966
     /*  23966 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(23989), // Rule ID 5712 //
     /*  23971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23982 */     // (and:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPANDDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  23982 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZrr),
     /*  23987 */     GIR_RootConstrainSelectedInstOperands,
     /*  23988 */     // GIR_Coverage, 5712,
     /*  23988 */     GIR_Done,
     /*  23989 */   // Label 633: @23989
     /*  23989 */   GIM_Reject,
     /*  23990 */ // Label 630: @23990
     /*  23990 */ GIM_Reject,
     /*  23991 */ // Label 462: @23991
     /*  23991 */ GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(24150),
     /*  23996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  23999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  24002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24006 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(24066), // Rule ID 4432 //
     /*  24011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  24026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  24030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24039 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24045 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  24047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24053 */     // (and:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }), VK32:{ *:[v32i1] }:$src2)  =>  (KANDNDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  24053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNDkk),
     /*  24056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  24062 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  24064 */     GIR_RootConstrainSelectedInstOperands,
     /*  24065 */     // GIR_Coverage, 4432,
     /*  24065 */     GIR_EraseRootFromParent_Done,
     /*  24066 */   // Label 635: @24066
     /*  24066 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(24126), // Rule ID 23691 //
     /*  24071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  24090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  24094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24103 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24109 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  24111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24113 */     // (and:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src2, (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }))  =>  (KANDNDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  24113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNDkk),
     /*  24116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  24122 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  24124 */     GIR_RootConstrainSelectedInstOperands,
     /*  24125 */     // GIR_Coverage, 23691,
     /*  24125 */     GIR_EraseRootFromParent_Done,
     /*  24126 */   // Label 636: @24126
     /*  24126 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(24149), // Rule ID 4416 //
     /*  24131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24142 */     // (and:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KANDDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  24142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDDkk),
     /*  24147 */     GIR_RootConstrainSelectedInstOperands,
     /*  24148 */     // GIR_Coverage, 4416,
     /*  24148 */     GIR_Done,
     /*  24149 */   // Label 637: @24149
     /*  24149 */   GIM_Reject,
     /*  24150 */ // Label 634: @24150
     /*  24150 */ GIM_Reject,
     /*  24151 */ // Label 463: @24151
     /*  24151 */ GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(24616),
     /*  24156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  24159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  24162 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(24224), // Rule ID 25227 //
     /*  24167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  24170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24182 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24185 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24189 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24206 */     // (and:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPANDYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  24209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24211 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24213 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24222 */     GIR_RootConstrainSelectedInstOperands,
     /*  24223 */     // GIR_Coverage, 25227,
     /*  24223 */     GIR_EraseRootFromParent_Done,
     /*  24224 */   // Label 639: @24224
     /*  24224 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(24286), // Rule ID 25236 //
     /*  24229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24244 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24247 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24251 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24261 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24268 */     // (and:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VANDPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  24271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24273 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24275 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24284 */     GIR_RootConstrainSelectedInstOperands,
     /*  24285 */     // GIR_Coverage, 25236,
     /*  24285 */     GIR_EraseRootFromParent_Done,
     /*  24286 */   // Label 640: @24286
     /*  24286 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(24348), // Rule ID 25435 //
     /*  24291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24306 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24309 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24313 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24323 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24330 */     // (and:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPANDQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  24333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24335 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24337 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24346 */     GIR_RootConstrainSelectedInstOperands,
     /*  24347 */     // GIR_Coverage, 25435,
     /*  24347 */     GIR_EraseRootFromParent_Done,
     /*  24348 */   // Label 641: @24348
     /*  24348 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(24410), // Rule ID 18101 //
     /*  24353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  24356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24372 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24375 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24379 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24392 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  24395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24397 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24399 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24408 */     GIR_RootConstrainSelectedInstOperands,
     /*  24409 */     // GIR_Coverage, 18101,
     /*  24409 */     GIR_EraseRootFromParent_Done,
     /*  24410 */   // Label 642: @24410
     /*  24410 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(24472), // Rule ID 18129 //
     /*  24415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24434 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24437 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24441 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24454 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  24457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24459 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24461 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24470 */     GIR_RootConstrainSelectedInstOperands,
     /*  24471 */     // GIR_Coverage, 18129,
     /*  24471 */     GIR_EraseRootFromParent_Done,
     /*  24472 */   // Label 643: @24472
     /*  24472 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(24534), // Rule ID 20039 //
     /*  24477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24496 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24499 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24503 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24516 */     // (and:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  24519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24521 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24523 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24532 */     GIR_RootConstrainSelectedInstOperands,
     /*  24533 */     // GIR_Coverage, 20039,
     /*  24533 */     GIR_EraseRootFromParent_Done,
     /*  24534 */   // Label 644: @24534
     /*  24534 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(24561), // Rule ID 18089 //
     /*  24539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  24542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24554 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPANDYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  24554 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  24559 */     GIR_RootConstrainSelectedInstOperands,
     /*  24560 */     // GIR_Coverage, 18089,
     /*  24560 */     GIR_Done,
     /*  24561 */   // Label 645: @24561
     /*  24561 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(24588), // Rule ID 18113 //
     /*  24566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24581 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VANDPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  24581 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  24586 */     GIR_RootConstrainSelectedInstOperands,
     /*  24587 */     // GIR_Coverage, 18113,
     /*  24587 */     GIR_Done,
     /*  24588 */   // Label 646: @24588
     /*  24588 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(24615), // Rule ID 20031 //
     /*  24593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24608 */     // (and:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPANDQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  24608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /*  24613 */     GIR_RootConstrainSelectedInstOperands,
     /*  24614 */     // GIR_Coverage, 20031,
     /*  24614 */     GIR_Done,
     /*  24615 */   // Label 647: @24615
     /*  24615 */   GIM_Reject,
     /*  24616 */ // Label 638: @24616
     /*  24616 */ GIM_Reject,
     /*  24617 */ // Label 464: @24617
     /*  24617 */ GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(24772),
     /*  24622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  24625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  24628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24632 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(24690), // Rule ID 25442 //
     /*  24637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24648 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24651 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24655 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24672 */     // (and:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPANDQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  24675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24677 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24679 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24688 */     GIR_RootConstrainSelectedInstOperands,
     /*  24689 */     // GIR_Coverage, 25442,
     /*  24689 */     GIR_EraseRootFromParent_Done,
     /*  24690 */   // Label 649: @24690
     /*  24690 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(24748), // Rule ID 20056 //
     /*  24695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24710 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24713 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24717 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24730 */     // (and:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  24733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24735 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24737 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24746 */     GIR_RootConstrainSelectedInstOperands,
     /*  24747 */     // GIR_Coverage, 20056,
     /*  24747 */     GIR_EraseRootFromParent_Done,
     /*  24748 */   // Label 650: @24748
     /*  24748 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(24771), // Rule ID 20048 //
     /*  24753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24764 */     // (and:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPANDQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  24764 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /*  24769 */     GIR_RootConstrainSelectedInstOperands,
     /*  24770 */     // GIR_Coverage, 20048,
     /*  24770 */     GIR_Done,
     /*  24771 */   // Label 651: @24771
     /*  24771 */   GIM_Reject,
     /*  24772 */ // Label 648: @24772
     /*  24772 */ GIM_Reject,
     /*  24773 */ // Label 465: @24773
     /*  24773 */ GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(24932),
     /*  24778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  24781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  24784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24788 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(24848), // Rule ID 4433 //
     /*  24793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  24808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  24812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24821 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24827 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  24829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24835 */     // (and:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }), VK64:{ *:[v64i1] }:$src2)  =>  (KANDNQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  24835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNQkk),
     /*  24838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  24844 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  24846 */     GIR_RootConstrainSelectedInstOperands,
     /*  24847 */     // GIR_Coverage, 4433,
     /*  24847 */     GIR_EraseRootFromParent_Done,
     /*  24848 */   // Label 653: @24848
     /*  24848 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(24908), // Rule ID 23692 //
     /*  24853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  24872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  24876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24885 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24891 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  24893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24895 */     // (and:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src2, (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }))  =>  (KANDNQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  24895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNQkk),
     /*  24898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  24904 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  24906 */     GIR_RootConstrainSelectedInstOperands,
     /*  24907 */     // GIR_Coverage, 23692,
     /*  24907 */     GIR_EraseRootFromParent_Done,
     /*  24908 */   // Label 654: @24908
     /*  24908 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(24931), // Rule ID 4417 //
     /*  24913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  24924 */     // (and:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KANDQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  24924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDQkk),
     /*  24929 */     GIR_RootConstrainSelectedInstOperands,
     /*  24930 */     // GIR_Coverage, 4417,
     /*  24930 */     GIR_Done,
     /*  24931 */   // Label 655: @24931
     /*  24931 */   GIM_Reject,
     /*  24932 */ // Label 652: @24932
     /*  24932 */ GIM_Reject,
     /*  24933 */ // Label 466: @24933
     /*  24933 */ GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(25088),
     /*  24938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  24941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  24944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24948 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(25006), // Rule ID 25441 //
     /*  24953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24964 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24967 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24971 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24981 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24988 */     // (and:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPANDQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  24991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24993 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24995 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25004 */     GIR_RootConstrainSelectedInstOperands,
     /*  25005 */     // GIR_Coverage, 25441,
     /*  25005 */     GIR_EraseRootFromParent_Done,
     /*  25006 */   // Label 657: @25006
     /*  25006 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(25064), // Rule ID 20055 //
     /*  25011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  25014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25026 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25029 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  25033 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25046 */     // (and:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  25049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25051 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25053 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25062 */     GIR_RootConstrainSelectedInstOperands,
     /*  25063 */     // GIR_Coverage, 20055,
     /*  25063 */     GIR_EraseRootFromParent_Done,
     /*  25064 */   // Label 658: @25064
     /*  25064 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(25087), // Rule ID 20047 //
     /*  25069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  25072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25080 */     // (and:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPANDQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  25080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /*  25085 */     GIR_RootConstrainSelectedInstOperands,
     /*  25086 */     // GIR_Coverage, 20047,
     /*  25086 */     GIR_Done,
     /*  25087 */   // Label 659: @25087
     /*  25087 */   GIM_Reject,
     /*  25088 */ // Label 656: @25088
     /*  25088 */ GIM_Reject,
     /*  25089 */ // Label 467: @25089
     /*  25089 */ GIM_Reject,
     /*  25090 */ // Label 4: @25090
     /*  25090 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 683*/ GIMT_Encode4(33493),
     /*  25101 */ /*GILLT_s1*//*Label 660*/ GIMT_Encode4(25201),
     /*  25105 */ /*GILLT_s8*//*Label 661*/ GIMT_Encode4(25301),
     /*  25109 */ /*GILLT_s16*//*Label 662*/ GIMT_Encode4(25694),
     /*  25113 */ /*GILLT_s32*//*Label 663*/ GIMT_Encode4(26291),
     /*  25117 */ /*GILLT_s64*//*Label 664*/ GIMT_Encode4(27747), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  25129 */ /*GILLT_v2s1*//*Label 665*/ GIMT_Encode4(29211),
     /*  25133 */ /*GILLT_v2s64*//*Label 666*/ GIMT_Encode4(29311),
     /*  25137 */ /*GILLT_v4s1*//*Label 667*/ GIMT_Encode4(29653),
     /*  25141 */ /*GILLT_v4s32*//*Label 668*/ GIMT_Encode4(29753),
     /*  25145 */ /*GILLT_v4s64*//*Label 669*/ GIMT_Encode4(30095),
     /*  25149 */ /*GILLT_v8s1*//*Label 670*/ GIMT_Encode4(30561),
     /*  25153 */ /*GILLT_v8s16*//*Label 671*/ GIMT_Encode4(30685),
     /*  25157 */ /*GILLT_v8s32*//*Label 672*/ GIMT_Encode4(31027),
     /*  25161 */ /*GILLT_v8s64*//*Label 673*/ GIMT_Encode4(31493),
     /*  25165 */ /*GILLT_v16s1*//*Label 674*/ GIMT_Encode4(31649),
     /*  25169 */ /*GILLT_v16s8*//*Label 675*/ GIMT_Encode4(31683),
     /*  25173 */ /*GILLT_v16s16*//*Label 676*/ GIMT_Encode4(32025),
     /*  25177 */ /*GILLT_v16s32*//*Label 677*/ GIMT_Encode4(32491),
     /*  25181 */ /*GILLT_v32s1*//*Label 678*/ GIMT_Encode4(32647),
     /*  25185 */ /*GILLT_v32s8*//*Label 679*/ GIMT_Encode4(32681),
     /*  25189 */ /*GILLT_v32s16*//*Label 680*/ GIMT_Encode4(33147),
     /*  25193 */ /*GILLT_v64s1*//*Label 681*/ GIMT_Encode4(33303),
     /*  25197 */ /*GILLT_v64s8*//*Label 682*/ GIMT_Encode4(33337),
     /*  25201 */ // Label 660: @25201
     /*  25201 */ GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(25300), // Rule ID 19491 //
     /*  25206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  25209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  25212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  25216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  25220 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  25224 */   // (or:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  25224 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  25227 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25231 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25236 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  25240 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  25245 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  25248 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25252 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25257 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  25261 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  25266 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  25269 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  25273 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25278 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25281 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25284 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25291 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25294 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  25299 */   // GIR_Coverage, 19491,
     /*  25299 */   GIR_EraseRootFromParent_Done,
     /*  25300 */ // Label 684: @25300
     /*  25300 */ GIM_Reject,
     /*  25301 */ // Label 661: @25301
     /*  25301 */ GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(25693),
     /*  25306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  25309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  25312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25316 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(25377), // Rule ID 26058 //
     /*  25321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25332 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25335 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25339 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25349 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25356 */     // (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (OR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm),
     /*  25359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25361 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25363 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25367 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25375 */     GIR_RootConstrainSelectedInstOperands,
     /*  25376 */     // GIR_Coverage, 26058,
     /*  25376 */     GIR_EraseRootFromParent_Done,
     /*  25377 */   // Label 686: @25377
     /*  25377 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(25438), // Rule ID 26077 //
     /*  25382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25393 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25396 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25400 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25417 */     // (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (OR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm_ND),
     /*  25420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25422 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25424 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25436 */     GIR_RootConstrainSelectedInstOperands,
     /*  25437 */     // GIR_Coverage, 26077,
     /*  25437 */     GIR_EraseRootFromParent_Done,
     /*  25438 */   // Label 687: @25438
     /*  25438 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(25499), // Rule ID 22827 //
     /*  25443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25458 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25461 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25465 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25471 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25478 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (OR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm),
     /*  25481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25483 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25485 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25489 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25497 */     GIR_RootConstrainSelectedInstOperands,
     /*  25498 */     // GIR_Coverage, 22827,
     /*  25498 */     GIR_EraseRootFromParent_Done,
     /*  25499 */   // Label 688: @25499
     /*  25499 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(25560), // Rule ID 22917 //
     /*  25504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25519 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25522 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25526 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25539 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (OR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm_ND),
     /*  25542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25544 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25546 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25550 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25558 */     GIR_RootConstrainSelectedInstOperands,
     /*  25559 */     // GIR_Coverage, 22917,
     /*  25559 */     GIR_EraseRootFromParent_Done,
     /*  25560 */   // Label 689: @25560
     /*  25560 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(25597), // Rule ID 22831 //
     /*  25565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25580 */     // MIs[1] Operand 1
     /*  25580 */     // No operand predicates
     /*  25580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25582 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (OR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  25582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8ri),
     /*  25585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25587 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  25592 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25595 */     GIR_RootConstrainSelectedInstOperands,
     /*  25596 */     // GIR_Coverage, 22831,
     /*  25596 */     GIR_EraseRootFromParent_Done,
     /*  25597 */   // Label 690: @25597
     /*  25597 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(25634), // Rule ID 22921 //
     /*  25602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25617 */     // MIs[1] Operand 1
     /*  25617 */     // No operand predicates
     /*  25617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25619 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (OR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  25619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8ri_ND),
     /*  25622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25624 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  25629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25632 */     GIR_RootConstrainSelectedInstOperands,
     /*  25633 */     // GIR_Coverage, 22921,
     /*  25633 */     GIR_EraseRootFromParent_Done,
     /*  25634 */   // Label 691: @25634
     /*  25634 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(25663), // Rule ID 22823 //
     /*  25639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25650 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (OR8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  25650 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR8rr),
     /*  25655 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  25661 */     GIR_RootConstrainSelectedInstOperands,
     /*  25662 */     // GIR_Coverage, 22823,
     /*  25662 */     GIR_Done,
     /*  25663 */   // Label 692: @25663
     /*  25663 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(25692), // Rule ID 22913 //
     /*  25668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25679 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (OR8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  25679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR8rr_ND),
     /*  25684 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  25690 */     GIR_RootConstrainSelectedInstOperands,
     /*  25691 */     // GIR_Coverage, 22913,
     /*  25691 */     GIR_Done,
     /*  25692 */   // Label 693: @25692
     /*  25692 */   GIM_Reject,
     /*  25693 */ // Label 685: @25693
     /*  25693 */ GIM_Reject,
     /*  25694 */ // Label 662: @25694
     /*  25694 */ GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(26290),
     /*  25699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  25702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  25705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25709 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(25770), // Rule ID 26059 //
     /*  25714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25725 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25728 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25732 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  25736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25742 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25749 */     // (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (OR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm),
     /*  25752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25754 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25756 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25760 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25768 */     GIR_RootConstrainSelectedInstOperands,
     /*  25769 */     // GIR_Coverage, 26059,
     /*  25769 */     GIR_EraseRootFromParent_Done,
     /*  25770 */   // Label 695: @25770
     /*  25770 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(25831), // Rule ID 26078 //
     /*  25775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25786 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25789 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25793 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  25797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25810 */     // (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (OR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm_ND),
     /*  25813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25815 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25817 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25829 */     GIR_RootConstrainSelectedInstOperands,
     /*  25830 */     // GIR_Coverage, 26078,
     /*  25830 */     GIR_EraseRootFromParent_Done,
     /*  25831 */   // Label 696: @25831
     /*  25831 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(25892), // Rule ID 22828 //
     /*  25836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25851 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25854 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25858 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  25862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25871 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (OR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm),
     /*  25874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25876 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25878 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25890 */     GIR_RootConstrainSelectedInstOperands,
     /*  25891 */     // GIR_Coverage, 22828,
     /*  25891 */     GIR_EraseRootFromParent_Done,
     /*  25892 */   // Label 697: @25892
     /*  25892 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(25953), // Rule ID 22918 //
     /*  25897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25912 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25915 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25919 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  25923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25932 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (OR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm_ND),
     /*  25935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25937 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25939 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25943 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25951 */     GIR_RootConstrainSelectedInstOperands,
     /*  25952 */     // GIR_Coverage, 22918,
     /*  25952 */     GIR_EraseRootFromParent_Done,
     /*  25953 */   // Label 698: @25953
     /*  25953 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(26055), // Rule ID 26034 //
     /*  25958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  25966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  25970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  25974 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  25978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25989 */     // (or:{ *:[i16] } (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTS16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  25989 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  25992 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25996 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  26003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  26006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  26010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26015 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  26022 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  26025 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  26030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  26035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  26040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS16rr),
     /*  26043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26045 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26053 */     GIR_RootConstrainSelectedInstOperands,
     /*  26054 */     // GIR_Coverage, 26034,
     /*  26054 */     GIR_EraseRootFromParent_Done,
     /*  26055 */   // Label 699: @26055
     /*  26055 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(26157), // Rule ID 22772 //
     /*  26060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  26072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  26076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  26080 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  26084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  26089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26091 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTS16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  26091 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  26094 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26098 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  26105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  26108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  26112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26117 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26120 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  26124 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  26127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  26132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  26137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  26142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS16rr),
     /*  26145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26147 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26155 */     GIR_RootConstrainSelectedInstOperands,
     /*  26156 */     // GIR_Coverage, 22772,
     /*  26156 */     GIR_EraseRootFromParent_Done,
     /*  26157 */   // Label 700: @26157
     /*  26157 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(26194), // Rule ID 22832 //
     /*  26162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26177 */     // MIs[1] Operand 1
     /*  26177 */     // No operand predicates
     /*  26177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26179 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (OR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  26179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16ri),
     /*  26182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26184 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  26189 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26192 */     GIR_RootConstrainSelectedInstOperands,
     /*  26193 */     // GIR_Coverage, 22832,
     /*  26193 */     GIR_EraseRootFromParent_Done,
     /*  26194 */   // Label 701: @26194
     /*  26194 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(26231), // Rule ID 22922 //
     /*  26199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26214 */     // MIs[1] Operand 1
     /*  26214 */     // No operand predicates
     /*  26214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26216 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (OR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  26216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16ri_ND),
     /*  26219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26221 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  26226 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26229 */     GIR_RootConstrainSelectedInstOperands,
     /*  26230 */     // GIR_Coverage, 22922,
     /*  26230 */     GIR_EraseRootFromParent_Done,
     /*  26231 */   // Label 702: @26231
     /*  26231 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(26260), // Rule ID 22824 //
     /*  26236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26247 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (OR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  26247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR16rr),
     /*  26252 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  26258 */     GIR_RootConstrainSelectedInstOperands,
     /*  26259 */     // GIR_Coverage, 22824,
     /*  26259 */     GIR_Done,
     /*  26260 */   // Label 703: @26260
     /*  26260 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(26289), // Rule ID 22914 //
     /*  26265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26276 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (OR16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  26276 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR16rr_ND),
     /*  26281 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  26287 */     GIR_RootConstrainSelectedInstOperands,
     /*  26288 */     // GIR_Coverage, 22914,
     /*  26288 */     GIR_Done,
     /*  26289 */   // Label 704: @26289
     /*  26289 */   GIM_Reject,
     /*  26290 */ // Label 694: @26290
     /*  26290 */ GIM_Reject,
     /*  26291 */ // Label 663: @26291
     /*  26291 */ GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(27746),
     /*  26296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  26299 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(26367), // Rule ID 26060 //
     /*  26304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26322 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26325 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26329 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26346 */     // (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (OR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm),
     /*  26349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26351 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26353 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26357 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26365 */     GIR_RootConstrainSelectedInstOperands,
     /*  26366 */     // GIR_Coverage, 26060,
     /*  26366 */     GIR_EraseRootFromParent_Done,
     /*  26367 */   // Label 706: @26367
     /*  26367 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(26435), // Rule ID 26079 //
     /*  26372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26390 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26393 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26397 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26414 */     // (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (OR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm_ND),
     /*  26417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26419 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26421 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26433 */     GIR_RootConstrainSelectedInstOperands,
     /*  26434 */     // GIR_Coverage, 26079,
     /*  26434 */     GIR_EraseRootFromParent_Done,
     /*  26435 */   // Label 707: @26435
     /*  26435 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(26503), // Rule ID 22829 //
     /*  26440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26462 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26465 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26469 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26482 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (OR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm),
     /*  26485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26487 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26489 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26493 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26501 */     GIR_RootConstrainSelectedInstOperands,
     /*  26502 */     // GIR_Coverage, 22829,
     /*  26502 */     GIR_EraseRootFromParent_Done,
     /*  26503 */   // Label 708: @26503
     /*  26503 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(26571), // Rule ID 22919 //
     /*  26508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26530 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26533 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26537 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26543 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26550 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (OR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm_ND),
     /*  26553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26555 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26557 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26569 */     GIR_RootConstrainSelectedInstOperands,
     /*  26570 */     // GIR_Coverage, 22919,
     /*  26570 */     GIR_EraseRootFromParent_Done,
     /*  26571 */   // Label 709: @26571
     /*  26571 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(26648), // Rule ID 25000 //
     /*  26576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26607 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  26611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26623 */     // MIs[2] src
     /*  26623 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  26628 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  26632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26634 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC32rr),
     /*  26637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  26643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26646 */     GIR_RootConstrainSelectedInstOperands,
     /*  26647 */     // GIR_Coverage, 25000,
     /*  26647 */     GIR_EraseRootFromParent_Done,
     /*  26648 */   // Label 710: @26648
     /*  26648 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(26725), // Rule ID 25002 //
     /*  26653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26684 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  26688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26700 */     // MIs[2] src
     /*  26700 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  26705 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  26709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26711 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (T1MSKC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC32rr),
     /*  26714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  26720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26723 */     GIR_RootConstrainSelectedInstOperands,
     /*  26724 */     // GIR_Coverage, 25002,
     /*  26724 */     GIR_EraseRootFromParent_Done,
     /*  26725 */   // Label 711: @26725
     /*  26725 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(26803), // Rule ID 24988 //
     /*  26730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  26765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26774 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  26778 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  26782 */     // MIs[0] src
     /*  26782 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26789 */     // (or:{ *:[i32] } (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), -1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  26792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src
     /*  26798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26801 */     GIR_RootConstrainSelectedInstOperands,
     /*  26802 */     // GIR_Coverage, 24988,
     /*  26802 */     GIR_EraseRootFromParent_Done,
     /*  26803 */   // Label 712: @26803
     /*  26803 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(26880), // Rule ID 17363 //
     /*  26808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26839 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  26843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26855 */     // MIs[2] src
     /*  26855 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  26860 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  26864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26866 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC32rr),
     /*  26869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  26875 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26878 */     GIR_RootConstrainSelectedInstOperands,
     /*  26879 */     // GIR_Coverage, 17363,
     /*  26879 */     GIR_EraseRootFromParent_Done,
     /*  26880 */   // Label 713: @26880
     /*  26880 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(26957), // Rule ID 17365 //
     /*  26885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26916 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  26920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26932 */     // MIs[2] src
     /*  26932 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  26937 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  26941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26943 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (T1MSKC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC32rr),
     /*  26946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  26952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26955 */     GIR_RootConstrainSelectedInstOperands,
     /*  26956 */     // GIR_Coverage, 17365,
     /*  26956 */     GIR_EraseRootFromParent_Done,
     /*  26957 */   // Label 714: @26957
     /*  26957 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(27031), // Rule ID 17351 //
     /*  26962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27000 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  27004 */     // MIs[2] src
     /*  27004 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27009 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  27013 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27019 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), -1:{ *:[i32] }))  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27024 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27029 */     GIR_RootConstrainSelectedInstOperands,
     /*  27030 */     // GIR_Coverage, 17351,
     /*  27030 */     GIR_EraseRootFromParent_Done,
     /*  27031 */   // Label 715: @27031
     /*  27031 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(27089), // Rule ID 24996 //
     /*  27036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27064 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  27068 */     // MIs[0] src
     /*  27068 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27075 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS32rr),
     /*  27078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  27084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27087 */     GIR_RootConstrainSelectedInstOperands,
     /*  27088 */     // GIR_Coverage, 24996,
     /*  27088 */     GIR_EraseRootFromParent_Done,
     /*  27089 */   // Label 716: @27089
     /*  27089 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(27147), // Rule ID 24998 //
     /*  27094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27122 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27126 */     // MIs[0] src
     /*  27126 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27133 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLSFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL32rr),
     /*  27136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  27142 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27145 */     GIR_RootConstrainSelectedInstOperands,
     /*  27146 */     // GIR_Coverage, 24998,
     /*  27146 */     GIR_EraseRootFromParent_Done,
     /*  27147 */   // Label 717: @27147
     /*  27147 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(27256), // Rule ID 26040 //
     /*  27152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  27167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  27175 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  27179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  27184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27190 */     // (or:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  27190 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  27193 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  27197 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  27204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  27207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  27211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27216 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  27219 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  27223 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  27226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  27241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS32rr),
     /*  27244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27246 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  27248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  27251 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27254 */     GIR_RootConstrainSelectedInstOperands,
     /*  27255 */     // GIR_Coverage, 26040,
     /*  27255 */     GIR_EraseRootFromParent_Done,
     /*  27256 */   // Label 718: @27256
     /*  27256 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(27314), // Rule ID 24990 //
     /*  27261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  27276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27284 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  27288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27293 */     // MIs[0] src
     /*  27293 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  27298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27300 */     // (or:{ *:[i32] } (sub:{ *:[i32] } -2:{ *:[i32] }, GR32:{ *:[i32] }:$src), GR32:{ *:[i32] }:$src)  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  27309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27312 */     GIR_RootConstrainSelectedInstOperands,
     /*  27313 */     // GIR_Coverage, 24990,
     /*  27313 */     GIR_EraseRootFromParent_Done,
     /*  27314 */   // Label 719: @27314
     /*  27314 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(27368), // Rule ID 17359 //
     /*  27319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27345 */     // MIs[1] src
     /*  27345 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27350 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  27354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27356 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS32rr),
     /*  27359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27361 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27363 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27366 */     GIR_RootConstrainSelectedInstOperands,
     /*  27367 */     // GIR_Coverage, 17359,
     /*  27367 */     GIR_EraseRootFromParent_Done,
     /*  27368 */   // Label 720: @27368
     /*  27368 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(27422), // Rule ID 17361 //
     /*  27373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27399 */     // MIs[1] src
     /*  27399 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27404 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27410 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL32rr),
     /*  27413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27415 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27420 */     GIR_RootConstrainSelectedInstOperands,
     /*  27421 */     // GIR_Coverage, 17361,
     /*  27421 */     GIR_EraseRootFromParent_Done,
     /*  27422 */   // Label 721: @27422
     /*  27422 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(27531), // Rule ID 22778 //
     /*  27427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  27446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  27454 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  27458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  27463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27465 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  27465 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  27468 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  27472 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  27479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  27482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  27486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27491 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  27494 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  27498 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  27501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  27516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS32rr),
     /*  27519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27521 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  27526 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27529 */     GIR_RootConstrainSelectedInstOperands,
     /*  27530 */     // GIR_Coverage, 22778,
     /*  27530 */     GIR_EraseRootFromParent_Done,
     /*  27531 */   // Label 722: @27531
     /*  27531 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(27585), // Rule ID 17353 //
     /*  27536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  27558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27562 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  27566 */     // MIs[1] src
     /*  27566 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27573 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (sub:{ *:[i32] } -2:{ *:[i32] }, GR32:{ *:[i32] }:$src))  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27578 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27583 */     GIR_RootConstrainSelectedInstOperands,
     /*  27584 */     // GIR_Coverage, 17353,
     /*  27584 */     GIR_EraseRootFromParent_Done,
     /*  27585 */   // Label 723: @27585
     /*  27585 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(27629), // Rule ID 22833 //
     /*  27590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27612 */     // MIs[1] Operand 1
     /*  27612 */     // No operand predicates
     /*  27612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27614 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (OR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  27614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32ri),
     /*  27617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27619 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  27624 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27627 */     GIR_RootConstrainSelectedInstOperands,
     /*  27628 */     // GIR_Coverage, 22833,
     /*  27628 */     GIR_EraseRootFromParent_Done,
     /*  27629 */   // Label 724: @27629
     /*  27629 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(27673), // Rule ID 22923 //
     /*  27634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  27637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27656 */     // MIs[1] Operand 1
     /*  27656 */     // No operand predicates
     /*  27656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27658 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (OR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  27658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32ri_ND),
     /*  27661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27663 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  27668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27671 */     GIR_RootConstrainSelectedInstOperands,
     /*  27672 */     // GIR_Coverage, 22923,
     /*  27672 */     GIR_EraseRootFromParent_Done,
     /*  27673 */   // Label 725: @27673
     /*  27673 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(27709), // Rule ID 22825 //
     /*  27678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27696 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (OR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  27696 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR32rr),
     /*  27701 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  27707 */     GIR_RootConstrainSelectedInstOperands,
     /*  27708 */     // GIR_Coverage, 22825,
     /*  27708 */     GIR_Done,
     /*  27709 */   // Label 726: @27709
     /*  27709 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(27745), // Rule ID 22915 //
     /*  27714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  27717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27732 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (OR32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  27732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR32rr_ND),
     /*  27737 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  27743 */     GIR_RootConstrainSelectedInstOperands,
     /*  27744 */     // GIR_Coverage, 22915,
     /*  27744 */     GIR_Done,
     /*  27745 */   // Label 727: @27745
     /*  27745 */   GIM_Reject,
     /*  27746 */ // Label 705: @27746
     /*  27746 */ GIM_Reject,
     /*  27747 */ // Label 664: @27747
     /*  27747 */ GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(29210),
     /*  27752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27755 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(27823), // Rule ID 26061 //
     /*  27760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  27766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  27778 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  27781 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  27785 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  27789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27795 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  27802 */     // (or:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (OR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  27802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm),
     /*  27805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27807 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  27809 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  27813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  27821 */     GIR_RootConstrainSelectedInstOperands,
     /*  27822 */     // GIR_Coverage, 26061,
     /*  27822 */     GIR_EraseRootFromParent_Done,
     /*  27823 */   // Label 729: @27823
     /*  27823 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(27891), // Rule ID 26080 //
     /*  27828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  27831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  27834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  27846 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  27849 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  27853 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  27857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27863 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  27870 */     // (or:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (OR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  27870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm_ND),
     /*  27873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27875 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  27877 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  27881 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  27889 */     GIR_RootConstrainSelectedInstOperands,
     /*  27890 */     // GIR_Coverage, 26080,
     /*  27890 */     GIR_EraseRootFromParent_Done,
     /*  27891 */   // Label 730: @27891
     /*  27891 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(27959), // Rule ID 22830 //
     /*  27896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  27902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  27918 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  27921 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  27925 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  27929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27931 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  27938 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (OR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  27938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm),
     /*  27941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27943 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27945 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  27949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  27957 */     GIR_RootConstrainSelectedInstOperands,
     /*  27958 */     // GIR_Coverage, 22830,
     /*  27958 */     GIR_EraseRootFromParent_Done,
     /*  27959 */   // Label 731: @27959
     /*  27959 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(28027), // Rule ID 22920 //
     /*  27964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  27967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  27970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  27978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  27986 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  27989 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  27993 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  27997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27999 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  28006 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (OR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  28006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm_ND),
     /*  28009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28011 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  28013 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  28017 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  28025 */     GIR_RootConstrainSelectedInstOperands,
     /*  28026 */     // GIR_Coverage, 22920,
     /*  28026 */     GIR_EraseRootFromParent_Done,
     /*  28027 */   // Label 732: @28027
     /*  28027 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(28104), // Rule ID 25001 //
     /*  28032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28063 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28075 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28079 */     // MIs[2] src
     /*  28079 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28084 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  28088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28090 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC64rr),
     /*  28093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28102 */     GIR_RootConstrainSelectedInstOperands,
     /*  28103 */     // GIR_Coverage, 25001,
     /*  28103 */     GIR_EraseRootFromParent_Done,
     /*  28104 */   // Label 733: @28104
     /*  28104 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(28181), // Rule ID 25003 //
     /*  28109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28140 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  28144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28152 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28156 */     // MIs[2] src
     /*  28156 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28161 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  28165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28167 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (T1MSKC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC64rr),
     /*  28170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28179 */     GIR_RootConstrainSelectedInstOperands,
     /*  28180 */     // GIR_Coverage, 25003,
     /*  28180 */     GIR_EraseRootFromParent_Done,
     /*  28181 */   // Label 734: @28181
     /*  28181 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(28259), // Rule ID 24989 //
     /*  28186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  28221 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28230 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  28234 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28238 */     // MIs[0] src
     /*  28238 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  28243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28245 */     // (or:{ *:[i64] } (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), -1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  28248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src
     /*  28254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28257 */     GIR_RootConstrainSelectedInstOperands,
     /*  28258 */     // GIR_Coverage, 24989,
     /*  28258 */     GIR_EraseRootFromParent_Done,
     /*  28259 */   // Label 735: @28259
     /*  28259 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(28336), // Rule ID 17364 //
     /*  28264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28295 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28311 */     // MIs[2] src
     /*  28311 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28316 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  28320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28322 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC64rr),
     /*  28325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28331 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28334 */     GIR_RootConstrainSelectedInstOperands,
     /*  28335 */     // GIR_Coverage, 17364,
     /*  28335 */     GIR_EraseRootFromParent_Done,
     /*  28336 */   // Label 736: @28336
     /*  28336 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(28413), // Rule ID 17366 //
     /*  28341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28372 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28384 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28388 */     // MIs[2] src
     /*  28388 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28393 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  28397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28399 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (T1MSKC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC64rr),
     /*  28402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28411 */     GIR_RootConstrainSelectedInstOperands,
     /*  28412 */     // GIR_Coverage, 17366,
     /*  28412 */     GIR_EraseRootFromParent_Done,
     /*  28413 */   // Label 737: @28413
     /*  28413 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(28487), // Rule ID 17352 //
     /*  28418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28456 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28460 */     // MIs[2] src
     /*  28460 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  28465 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  28469 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28475 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), -1:{ *:[i64] }))  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  28478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28480 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28485 */     GIR_RootConstrainSelectedInstOperands,
     /*  28486 */     // GIR_Coverage, 17352,
     /*  28486 */     GIR_EraseRootFromParent_Done,
     /*  28487 */   // Label 738: @28487
     /*  28487 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(28545), // Rule ID 24997 //
     /*  28492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28520 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  28524 */     // MIs[0] src
     /*  28524 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28531 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS64rr),
     /*  28534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28543 */     GIR_RootConstrainSelectedInstOperands,
     /*  28544 */     // GIR_Coverage, 24997,
     /*  28544 */     GIR_EraseRootFromParent_Done,
     /*  28545 */   // Label 739: @28545
     /*  28545 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(28603), // Rule ID 24999 //
     /*  28550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28578 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28582 */     // MIs[0] src
     /*  28582 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28589 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLSFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL64rr),
     /*  28592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28598 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28601 */     GIR_RootConstrainSelectedInstOperands,
     /*  28602 */     // GIR_Coverage, 24999,
     /*  28602 */     GIR_EraseRootFromParent_Done,
     /*  28603 */   // Label 740: @28603
     /*  28603 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(28712), // Rule ID 26046 //
     /*  28608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  28623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  28631 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  28635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  28640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28646 */     // (or:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  28646 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  28649 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  28653 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  28658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  28660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  28663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  28667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  28672 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  28675 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  28679 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  28682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  28687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  28692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  28697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS64rr),
     /*  28700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28702 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  28704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  28707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28710 */     GIR_RootConstrainSelectedInstOperands,
     /*  28711 */     // GIR_Coverage, 26046,
     /*  28711 */     GIR_EraseRootFromParent_Done,
     /*  28712 */   // Label 741: @28712
     /*  28712 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(28770), // Rule ID 24991 //
     /*  28717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  28732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28740 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  28744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28749 */     // MIs[0] src
     /*  28749 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  28754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28756 */     // (or:{ *:[i64] } (sub:{ *:[i64] } -2:{ *:[i64] }, GR64:{ *:[i64] }:$src), GR64:{ *:[i64] }:$src)  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  28759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  28765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28768 */     GIR_RootConstrainSelectedInstOperands,
     /*  28769 */     // GIR_Coverage, 24991,
     /*  28769 */     GIR_EraseRootFromParent_Done,
     /*  28770 */   // Label 742: @28770
     /*  28770 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(28824), // Rule ID 17360 //
     /*  28775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28801 */     // MIs[1] src
     /*  28801 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  28806 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  28810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28812 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS64rr),
     /*  28815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28822 */     GIR_RootConstrainSelectedInstOperands,
     /*  28823 */     // GIR_Coverage, 17360,
     /*  28823 */     GIR_EraseRootFromParent_Done,
     /*  28824 */   // Label 743: @28824
     /*  28824 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(28878), // Rule ID 17362 //
     /*  28829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28855 */     // MIs[1] src
     /*  28855 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  28860 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28866 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL64rr),
     /*  28869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28871 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28876 */     GIR_RootConstrainSelectedInstOperands,
     /*  28877 */     // GIR_Coverage, 17362,
     /*  28877 */     GIR_EraseRootFromParent_Done,
     /*  28878 */   // Label 744: @28878
     /*  28878 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(28987), // Rule ID 22784 //
     /*  28883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  28902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  28910 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  28914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  28919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28921 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  28921 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  28924 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  28928 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  28933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  28935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  28938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  28942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  28947 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  28950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  28954 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  28957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  28962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  28967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  28972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS64rr),
     /*  28975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28977 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  28979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  28982 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28985 */     GIR_RootConstrainSelectedInstOperands,
     /*  28986 */     // GIR_Coverage, 22784,
     /*  28986 */     GIR_EraseRootFromParent_Done,
     /*  28987 */   // Label 745: @28987
     /*  28987 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(29041), // Rule ID 17354 //
     /*  28992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  29014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  29018 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  29022 */     // MIs[1] src
     /*  29022 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  29027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29029 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (sub:{ *:[i64] } -2:{ *:[i64] }, GR64:{ *:[i64] }:$src))  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  29029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  29032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29034 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29039 */     GIR_RootConstrainSelectedInstOperands,
     /*  29040 */     // GIR_Coverage, 17354,
     /*  29040 */     GIR_EraseRootFromParent_Done,
     /*  29041 */   // Label 746: @29041
     /*  29041 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(29089), // Rule ID 22834 //
     /*  29046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  29049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  29072 */     // MIs[1] Operand 1
     /*  29072 */     // No operand predicates
     /*  29072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29074 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (OR64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  29074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64ri32),
     /*  29077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29079 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  29084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29087 */     GIR_RootConstrainSelectedInstOperands,
     /*  29088 */     // GIR_Coverage, 22834,
     /*  29088 */     GIR_EraseRootFromParent_Done,
     /*  29089 */   // Label 747: @29089
     /*  29089 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(29137), // Rule ID 22924 //
     /*  29094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  29097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29116 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  29120 */     // MIs[1] Operand 1
     /*  29120 */     // No operand predicates
     /*  29120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29122 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (OR64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  29122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64ri32_ND),
     /*  29125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29127 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  29132 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29135 */     GIR_RootConstrainSelectedInstOperands,
     /*  29136 */     // GIR_Coverage, 22924,
     /*  29136 */     GIR_EraseRootFromParent_Done,
     /*  29137 */   // Label 748: @29137
     /*  29137 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(29173), // Rule ID 22826 //
     /*  29142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  29145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29160 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (OR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  29160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR64rr),
     /*  29165 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  29171 */     GIR_RootConstrainSelectedInstOperands,
     /*  29172 */     // GIR_Coverage, 22826,
     /*  29172 */     GIR_Done,
     /*  29173 */   // Label 749: @29173
     /*  29173 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(29209), // Rule ID 22916 //
     /*  29178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  29181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29196 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (OR64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  29196 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR64rr_ND),
     /*  29201 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  29207 */     GIR_RootConstrainSelectedInstOperands,
     /*  29208 */     // GIR_Coverage, 22916,
     /*  29208 */     GIR_Done,
     /*  29209 */   // Label 750: @29209
     /*  29209 */   GIM_Reject,
     /*  29210 */ // Label 728: @29210
     /*  29210 */ GIM_Reject,
     /*  29211 */ // Label 665: @29211
     /*  29211 */ GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(29310), // Rule ID 19492 //
     /*  29216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  29219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  29222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  29226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  29230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  29234 */   // (or:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  29234 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  29237 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29241 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29246 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  29250 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29255 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  29258 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29262 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29267 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  29271 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29276 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  29279 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  29283 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29288 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  29291 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  29294 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  29296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29301 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29304 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  29309 */   // GIR_Coverage, 19492,
     /*  29309 */   GIR_EraseRootFromParent_Done,
     /*  29310 */ // Label 751: @29310
     /*  29310 */ GIM_Reject,
     /*  29311 */ // Label 666: @29311
     /*  29311 */ GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(29652),
     /*  29316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  29322 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(29384), // Rule ID 23360 //
     /*  29327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29342 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29345 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29349 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29366 */     // (or:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  29369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29371 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  29373 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29382 */     GIR_RootConstrainSelectedInstOperands,
     /*  29383 */     // GIR_Coverage, 23360,
     /*  29383 */     GIR_EraseRootFromParent_Done,
     /*  29384 */   // Label 753: @29384
     /*  29384 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(29446), // Rule ID 24182 //
     /*  29389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29404 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29407 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29411 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29421 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29428 */     // (or:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  29431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29433 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  29435 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29444 */     GIR_RootConstrainSelectedInstOperands,
     /*  29445 */     // GIR_Coverage, 24182,
     /*  29445 */     GIR_EraseRootFromParent_Done,
     /*  29446 */   // Label 754: @29446
     /*  29446 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(29508), // Rule ID 2116 //
     /*  29451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29470 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29473 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29477 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29483 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29490 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  29493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29495 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29497 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29506 */     GIR_RootConstrainSelectedInstOperands,
     /*  29507 */     // GIR_Coverage, 2116,
     /*  29507 */     GIR_EraseRootFromParent_Done,
     /*  29508 */   // Label 755: @29508
     /*  29508 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(29570), // Rule ID 5760 //
     /*  29513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29532 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29535 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29539 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29552 */     // (or:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  29555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29557 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29559 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29568 */     GIR_RootConstrainSelectedInstOperands,
     /*  29569 */     // GIR_Coverage, 5760,
     /*  29569 */     GIR_EraseRootFromParent_Done,
     /*  29570 */   // Label 756: @29570
     /*  29570 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(29597), // Rule ID 2115 //
     /*  29575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29590 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  29590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  29595 */     GIR_RootConstrainSelectedInstOperands,
     /*  29596 */     // GIR_Coverage, 2115,
     /*  29596 */     GIR_Done,
     /*  29597 */   // Label 757: @29597
     /*  29597 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(29624), // Rule ID 2117 //
     /*  29602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  29605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29617 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  29617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  29622 */     GIR_RootConstrainSelectedInstOperands,
     /*  29623 */     // GIR_Coverage, 2117,
     /*  29623 */     GIR_Done,
     /*  29624 */   // Label 758: @29624
     /*  29624 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(29651), // Rule ID 5757 //
     /*  29629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29644 */     // (or:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPORQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  29644 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /*  29649 */     GIR_RootConstrainSelectedInstOperands,
     /*  29650 */     // GIR_Coverage, 5757,
     /*  29650 */     GIR_Done,
     /*  29651 */   // Label 759: @29651
     /*  29651 */   GIM_Reject,
     /*  29652 */ // Label 752: @29652
     /*  29652 */ GIM_Reject,
     /*  29653 */ // Label 667: @29653
     /*  29653 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(29752), // Rule ID 19493 //
     /*  29658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  29661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  29664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  29668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  29672 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  29676 */   // (or:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  29676 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  29679 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29683 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29688 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  29692 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29697 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  29700 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29704 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29709 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  29713 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29718 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  29721 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  29725 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29730 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  29733 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  29736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  29738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29743 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29746 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  29751 */   // GIR_Coverage, 19493,
     /*  29751 */   GIR_EraseRootFromParent_Done,
     /*  29752 */ // Label 760: @29752
     /*  29752 */ GIM_Reject,
     /*  29753 */ // Label 668: @29753
     /*  29753 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(30094),
     /*  29758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29764 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(29826), // Rule ID 24200 //
     /*  29769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29784 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29787 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29791 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29801 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29808 */     // (or:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ128rm),
     /*  29811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29813 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  29815 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29824 */     GIR_RootConstrainSelectedInstOperands,
     /*  29825 */     // GIR_Coverage, 24200,
     /*  29825 */     GIR_EraseRootFromParent_Done,
     /*  29826 */   // Label 762: @29826
     /*  29826 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(29888), // Rule ID 25253 //
     /*  29831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29846 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29849 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29853 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29863 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29870 */     // (or:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  29873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29875 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  29877 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29886 */     GIR_RootConstrainSelectedInstOperands,
     /*  29887 */     // GIR_Coverage, 25253,
     /*  29887 */     GIR_EraseRootFromParent_Done,
     /*  29888 */   // Label 763: @29888
     /*  29888 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(29950), // Rule ID 5787 //
     /*  29893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29912 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29915 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29919 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29932 */     // (or:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ128rm),
     /*  29935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29937 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29939 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29948 */     GIR_RootConstrainSelectedInstOperands,
     /*  29949 */     // GIR_Coverage, 5787,
     /*  29949 */     GIR_EraseRootFromParent_Done,
     /*  29950 */   // Label 764: @29950
     /*  29950 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(30012), // Rule ID 18162 //
     /*  29955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29974 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29977 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29981 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29994 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  29997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29999 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30001 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30010 */     GIR_RootConstrainSelectedInstOperands,
     /*  30011 */     // GIR_Coverage, 18162,
     /*  30011 */     GIR_EraseRootFromParent_Done,
     /*  30012 */   // Label 765: @30012
     /*  30012 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(30039), // Rule ID 5784 //
     /*  30017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30032 */     // (or:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPORDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  30032 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZ128rr),
     /*  30037 */     GIR_RootConstrainSelectedInstOperands,
     /*  30038 */     // GIR_Coverage, 5784,
     /*  30038 */     GIR_Done,
     /*  30039 */   // Label 766: @30039
     /*  30039 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(30066), // Rule ID 18150 //
     /*  30044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30059 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  30059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  30064 */     GIR_RootConstrainSelectedInstOperands,
     /*  30065 */     // GIR_Coverage, 18150,
     /*  30065 */     GIR_Done,
     /*  30066 */   // Label 767: @30066
     /*  30066 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(30093), // Rule ID 18174 //
     /*  30071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  30074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30086 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  30086 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  30091 */     GIR_RootConstrainSelectedInstOperands,
     /*  30092 */     // GIR_Coverage, 18174,
     /*  30092 */     GIR_Done,
     /*  30093 */   // Label 768: @30093
     /*  30093 */   GIM_Reject,
     /*  30094 */ // Label 761: @30094
     /*  30094 */ GIM_Reject,
     /*  30095 */ // Label 669: @30095
     /*  30095 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(30560),
     /*  30100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  30103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  30106 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(30168), // Rule ID 23362 //
     /*  30111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  30114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30126 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30129 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30133 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30150 */     // (or:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  30153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30155 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30157 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30166 */     GIR_RootConstrainSelectedInstOperands,
     /*  30167 */     // GIR_Coverage, 23362,
     /*  30167 */     GIR_EraseRootFromParent_Done,
     /*  30168 */   // Label 770: @30168
     /*  30168 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(30230), // Rule ID 24176 //
     /*  30173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30188 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30191 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30195 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30212 */     // (or:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  30215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30217 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30219 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30228 */     GIR_RootConstrainSelectedInstOperands,
     /*  30229 */     // GIR_Coverage, 24176,
     /*  30229 */     GIR_EraseRootFromParent_Done,
     /*  30230 */   // Label 771: @30230
     /*  30230 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(30292), // Rule ID 25243 //
     /*  30235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  30238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30250 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30253 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30257 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30274 */     // (or:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  30277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30279 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30281 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30290 */     GIR_RootConstrainSelectedInstOperands,
     /*  30291 */     // GIR_Coverage, 25243,
     /*  30291 */     GIR_EraseRootFromParent_Done,
     /*  30292 */   // Label 772: @30292
     /*  30292 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(30354), // Rule ID 2120 //
     /*  30297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  30300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30316 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30319 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30323 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30336 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  30339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30341 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30343 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30352 */     GIR_RootConstrainSelectedInstOperands,
     /*  30353 */     // GIR_Coverage, 2120,
     /*  30353 */     GIR_EraseRootFromParent_Done,
     /*  30354 */   // Label 773: @30354
     /*  30354 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(30416), // Rule ID 5751 //
     /*  30359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30378 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30381 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30385 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30391 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30398 */     // (or:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  30401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30403 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30405 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30414 */     GIR_RootConstrainSelectedInstOperands,
     /*  30415 */     // GIR_Coverage, 5751,
     /*  30415 */     GIR_EraseRootFromParent_Done,
     /*  30416 */   // Label 774: @30416
     /*  30416 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(30478), // Rule ID 18136 //
     /*  30421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  30424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30440 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30443 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30447 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30460 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  30463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30465 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30467 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30476 */     GIR_RootConstrainSelectedInstOperands,
     /*  30477 */     // GIR_Coverage, 18136,
     /*  30477 */     GIR_EraseRootFromParent_Done,
     /*  30478 */   // Label 775: @30478
     /*  30478 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(30505), // Rule ID 2119 //
     /*  30483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  30486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30498 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPORYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  30498 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  30503 */     GIR_RootConstrainSelectedInstOperands,
     /*  30504 */     // GIR_Coverage, 2119,
     /*  30504 */     GIR_Done,
     /*  30505 */   // Label 776: @30505
     /*  30505 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(30532), // Rule ID 5748 //
     /*  30510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30525 */     // (or:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPORQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  30525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /*  30530 */     GIR_RootConstrainSelectedInstOperands,
     /*  30531 */     // GIR_Coverage, 5748,
     /*  30531 */     GIR_Done,
     /*  30532 */   // Label 777: @30532
     /*  30532 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(30559), // Rule ID 18120 //
     /*  30537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  30540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30552 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VORPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  30552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  30557 */     GIR_RootConstrainSelectedInstOperands,
     /*  30558 */     // GIR_Coverage, 18120,
     /*  30558 */     GIR_Done,
     /*  30559 */   // Label 778: @30559
     /*  30559 */   GIM_Reject,
     /*  30560 */ // Label 769: @30560
     /*  30560 */ GIM_Reject,
     /*  30561 */ // Label 670: @30561
     /*  30561 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(30684),
     /*  30566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  30569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  30572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  30576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  30580 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  30584 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(30599), // Rule ID 4418 //
     /*  30589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  30592 */     // (or:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  30592 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORBkk),
     /*  30597 */     GIR_RootConstrainSelectedInstOperands,
     /*  30598 */     // GIR_Coverage, 4418,
     /*  30598 */     GIR_Done,
     /*  30599 */   // Label 780: @30599
     /*  30599 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(30683), // Rule ID 19490 //
     /*  30604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  30607 */     // (or:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  30607 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  30610 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30614 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30619 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  30623 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  30628 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  30631 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30635 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30640 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  30644 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  30649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  30652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  30656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30661 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  30664 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  30667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  30669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  30677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  30682 */     // GIR_Coverage, 19490,
     /*  30682 */     GIR_EraseRootFromParent_Done,
     /*  30683 */   // Label 781: @30683
     /*  30683 */   GIM_Reject,
     /*  30684 */ // Label 779: @30684
     /*  30684 */ GIM_Reject,
     /*  30685 */ // Label 671: @30685
     /*  30685 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(31026),
     /*  30690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  30696 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(30758), // Rule ID 25252 //
     /*  30701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30716 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30719 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30723 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30733 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30740 */     // (or:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  30743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30745 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30747 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30756 */     GIR_RootConstrainSelectedInstOperands,
     /*  30757 */     // GIR_Coverage, 25252,
     /*  30757 */     GIR_EraseRootFromParent_Done,
     /*  30758 */   // Label 783: @30758
     /*  30758 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(30820), // Rule ID 25432 //
     /*  30763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  30766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30778 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30781 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30785 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30795 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30802 */     // (or:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  30805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30807 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30809 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30818 */     GIR_RootConstrainSelectedInstOperands,
     /*  30819 */     // GIR_Coverage, 25432,
     /*  30819 */     GIR_EraseRootFromParent_Done,
     /*  30820 */   // Label 784: @30820
     /*  30820 */   GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(30882), // Rule ID 18161 //
     /*  30825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30844 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30847 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30851 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30864 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  30867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30869 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30871 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30880 */     GIR_RootConstrainSelectedInstOperands,
     /*  30881 */     // GIR_Coverage, 18161,
     /*  30881 */     GIR_EraseRootFromParent_Done,
     /*  30882 */   // Label 785: @30882
     /*  30882 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(30944), // Rule ID 20026 //
     /*  30887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  30890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30906 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30909 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30913 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30926 */     // (or:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  30929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30931 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30933 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30942 */     GIR_RootConstrainSelectedInstOperands,
     /*  30943 */     // GIR_Coverage, 20026,
     /*  30943 */     GIR_EraseRootFromParent_Done,
     /*  30944 */   // Label 786: @30944
     /*  30944 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(30971), // Rule ID 18149 //
     /*  30949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30964 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  30964 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  30969 */     GIR_RootConstrainSelectedInstOperands,
     /*  30970 */     // GIR_Coverage, 18149,
     /*  30970 */     GIR_Done,
     /*  30971 */   // Label 787: @30971
     /*  30971 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(30998), // Rule ID 18173 //
     /*  30976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  30979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30991 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  30991 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  30996 */     GIR_RootConstrainSelectedInstOperands,
     /*  30997 */     // GIR_Coverage, 18173,
     /*  30997 */     GIR_Done,
     /*  30998 */   // Label 788: @30998
     /*  30998 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(31025), // Rule ID 20018 //
     /*  31003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  31006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31018 */     // (or:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPORQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  31018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /*  31023 */     GIR_RootConstrainSelectedInstOperands,
     /*  31024 */     // GIR_Coverage, 20018,
     /*  31024 */     GIR_Done,
     /*  31025 */   // Label 789: @31025
     /*  31025 */   GIM_Reject,
     /*  31026 */ // Label 782: @31026
     /*  31026 */ GIM_Reject,
     /*  31027 */ // Label 672: @31027
     /*  31027 */ GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(31492),
     /*  31032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  31035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  31038 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(31100), // Rule ID 24194 //
     /*  31043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  31046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31058 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31061 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31065 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31082 */     // (or:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ256rm),
     /*  31085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31087 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31089 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31098 */     GIR_RootConstrainSelectedInstOperands,
     /*  31099 */     // GIR_Coverage, 24194,
     /*  31099 */     GIR_EraseRootFromParent_Done,
     /*  31100 */   // Label 791: @31100
     /*  31100 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(31162), // Rule ID 25232 //
     /*  31105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  31108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31120 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31123 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31127 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31144 */     // (or:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  31147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31149 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31151 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31160 */     GIR_RootConstrainSelectedInstOperands,
     /*  31161 */     // GIR_Coverage, 25232,
     /*  31161 */     GIR_EraseRootFromParent_Done,
     /*  31162 */   // Label 792: @31162
     /*  31162 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(31224), // Rule ID 25242 //
     /*  31167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  31170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31182 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31185 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31189 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31206 */     // (or:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  31209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31211 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31213 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31222 */     GIR_RootConstrainSelectedInstOperands,
     /*  31223 */     // GIR_Coverage, 25242,
     /*  31223 */     GIR_EraseRootFromParent_Done,
     /*  31224 */   // Label 793: @31224
     /*  31224 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(31286), // Rule ID 5778 //
     /*  31229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  31232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31248 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31251 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31255 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31261 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31268 */     // (or:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ256rm),
     /*  31271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31273 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31275 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31284 */     GIR_RootConstrainSelectedInstOperands,
     /*  31285 */     // GIR_Coverage, 5778,
     /*  31285 */     GIR_EraseRootFromParent_Done,
     /*  31286 */   // Label 794: @31286
     /*  31286 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(31348), // Rule ID 18106 //
     /*  31291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  31294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31310 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31313 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31317 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31323 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31330 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  31333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31335 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31337 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31346 */     GIR_RootConstrainSelectedInstOperands,
     /*  31347 */     // GIR_Coverage, 18106,
     /*  31347 */     GIR_EraseRootFromParent_Done,
     /*  31348 */   // Label 795: @31348
     /*  31348 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(31410), // Rule ID 18135 //
     /*  31353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  31356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31372 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31375 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31379 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31392 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  31395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31397 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31399 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31408 */     GIR_RootConstrainSelectedInstOperands,
     /*  31409 */     // GIR_Coverage, 18135,
     /*  31409 */     GIR_EraseRootFromParent_Done,
     /*  31410 */   // Label 796: @31410
     /*  31410 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(31437), // Rule ID 5775 //
     /*  31415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  31418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31430 */     // (or:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPORDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  31430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZ256rr),
     /*  31435 */     GIR_RootConstrainSelectedInstOperands,
     /*  31436 */     // GIR_Coverage, 5775,
     /*  31436 */     GIR_Done,
     /*  31437 */   // Label 797: @31437
     /*  31437 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(31464), // Rule ID 18094 //
     /*  31442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  31445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31457 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPORYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  31457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  31462 */     GIR_RootConstrainSelectedInstOperands,
     /*  31463 */     // GIR_Coverage, 18094,
     /*  31463 */     GIR_Done,
     /*  31464 */   // Label 798: @31464
     /*  31464 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(31491), // Rule ID 18119 //
     /*  31469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  31472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31484 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VORPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  31484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  31489 */     GIR_RootConstrainSelectedInstOperands,
     /*  31490 */     // GIR_Coverage, 18119,
     /*  31490 */     GIR_Done,
     /*  31491 */   // Label 799: @31491
     /*  31491 */   GIM_Reject,
     /*  31492 */ // Label 790: @31492
     /*  31492 */ GIM_Reject,
     /*  31493 */ // Label 673: @31493
     /*  31493 */ GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(31648),
     /*  31498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  31501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  31504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31508 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(31566), // Rule ID 24170 //
     /*  31513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31524 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31527 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31531 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31548 */     // (or:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  31551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31553 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31564 */     GIR_RootConstrainSelectedInstOperands,
     /*  31565 */     // GIR_Coverage, 24170,
     /*  31565 */     GIR_EraseRootFromParent_Done,
     /*  31566 */   // Label 801: @31566
     /*  31566 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(31624), // Rule ID 5742 //
     /*  31571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31586 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31589 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31593 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31606 */     // (or:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  31609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31611 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31613 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31622 */     GIR_RootConstrainSelectedInstOperands,
     /*  31623 */     // GIR_Coverage, 5742,
     /*  31623 */     GIR_EraseRootFromParent_Done,
     /*  31624 */   // Label 802: @31624
     /*  31624 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(31647), // Rule ID 5739 //
     /*  31629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31640 */     // (or:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPORQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  31640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /*  31645 */     GIR_RootConstrainSelectedInstOperands,
     /*  31646 */     // GIR_Coverage, 5739,
     /*  31646 */     GIR_Done,
     /*  31647 */   // Label 803: @31647
     /*  31647 */   GIM_Reject,
     /*  31648 */ // Label 800: @31648
     /*  31648 */ GIM_Reject,
     /*  31649 */ // Label 674: @31649
     /*  31649 */ GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(31682), // Rule ID 4419 //
     /*  31654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  31660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  31663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  31667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  31671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  31675 */   // (or:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  31675 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  31680 */   GIR_RootConstrainSelectedInstOperands,
     /*  31681 */   // GIR_Coverage, 4419,
     /*  31681 */   GIR_Done,
     /*  31682 */ // Label 804: @31682
     /*  31682 */ GIM_Reject,
     /*  31683 */ // Label 675: @31683
     /*  31683 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(32024),
     /*  31688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31694 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(31756), // Rule ID 25251 //
     /*  31699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  31702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31714 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31717 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31721 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31731 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31738 */     // (or:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  31741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31743 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31745 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31754 */     GIR_RootConstrainSelectedInstOperands,
     /*  31755 */     // GIR_Coverage, 25251,
     /*  31755 */     GIR_EraseRootFromParent_Done,
     /*  31756 */   // Label 806: @31756
     /*  31756 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(31818), // Rule ID 25431 //
     /*  31761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  31764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31776 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31779 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31783 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31793 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31800 */     // (or:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  31803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31805 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31807 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31816 */     GIR_RootConstrainSelectedInstOperands,
     /*  31817 */     // GIR_Coverage, 25431,
     /*  31817 */     GIR_EraseRootFromParent_Done,
     /*  31818 */   // Label 807: @31818
     /*  31818 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(31880), // Rule ID 18160 //
     /*  31823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  31826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31842 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31845 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31849 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31855 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31862 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  31865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31867 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31869 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31878 */     GIR_RootConstrainSelectedInstOperands,
     /*  31879 */     // GIR_Coverage, 18160,
     /*  31879 */     GIR_EraseRootFromParent_Done,
     /*  31880 */   // Label 808: @31880
     /*  31880 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(31942), // Rule ID 20025 //
     /*  31885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  31888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31904 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31907 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31911 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31924 */     // (or:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  31927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31929 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31931 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31940 */     GIR_RootConstrainSelectedInstOperands,
     /*  31941 */     // GIR_Coverage, 20025,
     /*  31941 */     GIR_EraseRootFromParent_Done,
     /*  31942 */   // Label 809: @31942
     /*  31942 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(31969), // Rule ID 18148 //
     /*  31947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  31950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31962 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  31962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  31967 */     GIR_RootConstrainSelectedInstOperands,
     /*  31968 */     // GIR_Coverage, 18148,
     /*  31968 */     GIR_Done,
     /*  31969 */   // Label 810: @31969
     /*  31969 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(31996), // Rule ID 18172 //
     /*  31974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  31977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31989 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  31989 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  31994 */     GIR_RootConstrainSelectedInstOperands,
     /*  31995 */     // GIR_Coverage, 18172,
     /*  31995 */     GIR_Done,
     /*  31996 */   // Label 811: @31996
     /*  31996 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(32023), // Rule ID 20017 //
     /*  32001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32016 */     // (or:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPORQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  32016 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /*  32021 */     GIR_RootConstrainSelectedInstOperands,
     /*  32022 */     // GIR_Coverage, 20017,
     /*  32022 */     GIR_Done,
     /*  32023 */   // Label 812: @32023
     /*  32023 */   GIM_Reject,
     /*  32024 */ // Label 805: @32024
     /*  32024 */ GIM_Reject,
     /*  32025 */ // Label 676: @32025
     /*  32025 */ GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(32490),
     /*  32030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  32033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  32036 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(32098), // Rule ID 25231 //
     /*  32041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32056 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32059 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32063 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32073 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32080 */     // (or:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32085 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32087 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32096 */     GIR_RootConstrainSelectedInstOperands,
     /*  32097 */     // GIR_Coverage, 25231,
     /*  32097 */     GIR_EraseRootFromParent_Done,
     /*  32098 */   // Label 814: @32098
     /*  32098 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(32160), // Rule ID 25241 //
     /*  32103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32118 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32121 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32125 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32142 */     // (or:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  32145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32147 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32149 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32158 */     GIR_RootConstrainSelectedInstOperands,
     /*  32159 */     // GIR_Coverage, 25241,
     /*  32159 */     GIR_EraseRootFromParent_Done,
     /*  32160 */   // Label 815: @32160
     /*  32160 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(32222), // Rule ID 25438 //
     /*  32165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32180 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32183 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32187 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32204 */     // (or:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  32207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32209 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32211 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32220 */     GIR_RootConstrainSelectedInstOperands,
     /*  32221 */     // GIR_Coverage, 25438,
     /*  32221 */     GIR_EraseRootFromParent_Done,
     /*  32222 */   // Label 816: @32222
     /*  32222 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(32284), // Rule ID 18105 //
     /*  32227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32246 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32249 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32253 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32259 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32266 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32271 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32273 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32282 */     GIR_RootConstrainSelectedInstOperands,
     /*  32283 */     // GIR_Coverage, 18105,
     /*  32283 */     GIR_EraseRootFromParent_Done,
     /*  32284 */   // Label 817: @32284
     /*  32284 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(32346), // Rule ID 18134 //
     /*  32289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32308 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32311 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32315 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32328 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  32331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32333 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32335 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32344 */     GIR_RootConstrainSelectedInstOperands,
     /*  32345 */     // GIR_Coverage, 18134,
     /*  32345 */     GIR_EraseRootFromParent_Done,
     /*  32346 */   // Label 818: @32346
     /*  32346 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(32408), // Rule ID 20042 //
     /*  32351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32370 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32373 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32377 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32383 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32390 */     // (or:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  32393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32395 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32397 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32406 */     GIR_RootConstrainSelectedInstOperands,
     /*  32407 */     // GIR_Coverage, 20042,
     /*  32407 */     GIR_EraseRootFromParent_Done,
     /*  32408 */   // Label 819: @32408
     /*  32408 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(32435), // Rule ID 18093 //
     /*  32413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32428 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPORYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  32428 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  32433 */     GIR_RootConstrainSelectedInstOperands,
     /*  32434 */     // GIR_Coverage, 18093,
     /*  32434 */     GIR_Done,
     /*  32435 */   // Label 820: @32435
     /*  32435 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(32462), // Rule ID 18118 //
     /*  32440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32455 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VORPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  32455 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  32460 */     GIR_RootConstrainSelectedInstOperands,
     /*  32461 */     // GIR_Coverage, 18118,
     /*  32461 */     GIR_Done,
     /*  32462 */   // Label 821: @32462
     /*  32462 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(32489), // Rule ID 20034 //
     /*  32467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32482 */     // (or:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPORQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  32482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /*  32487 */     GIR_RootConstrainSelectedInstOperands,
     /*  32488 */     // GIR_Coverage, 20034,
     /*  32488 */     GIR_Done,
     /*  32489 */   // Label 822: @32489
     /*  32489 */   GIM_Reject,
     /*  32490 */ // Label 813: @32490
     /*  32490 */ GIM_Reject,
     /*  32491 */ // Label 677: @32491
     /*  32491 */ GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(32646),
     /*  32496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  32499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  32502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32506 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(32564), // Rule ID 24188 //
     /*  32511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  32514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32522 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32525 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32529 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32539 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32546 */     // (or:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZrm),
     /*  32549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32551 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32553 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32562 */     GIR_RootConstrainSelectedInstOperands,
     /*  32563 */     // GIR_Coverage, 24188,
     /*  32563 */     GIR_EraseRootFromParent_Done,
     /*  32564 */   // Label 824: @32564
     /*  32564 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(32622), // Rule ID 5769 //
     /*  32569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  32572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32584 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32587 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32591 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32604 */     // (or:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZrm),
     /*  32607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32609 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32611 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32620 */     GIR_RootConstrainSelectedInstOperands,
     /*  32621 */     // GIR_Coverage, 5769,
     /*  32621 */     GIR_EraseRootFromParent_Done,
     /*  32622 */   // Label 825: @32622
     /*  32622 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(32645), // Rule ID 5766 //
     /*  32627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  32630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32638 */     // (or:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPORDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  32638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZrr),
     /*  32643 */     GIR_RootConstrainSelectedInstOperands,
     /*  32644 */     // GIR_Coverage, 5766,
     /*  32644 */     GIR_Done,
     /*  32645 */   // Label 826: @32645
     /*  32645 */   GIM_Reject,
     /*  32646 */ // Label 823: @32646
     /*  32646 */ GIM_Reject,
     /*  32647 */ // Label 678: @32647
     /*  32647 */ GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(32680), // Rule ID 4420 //
     /*  32652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  32655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  32658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  32661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  32665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  32669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  32673 */   // (or:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  32673 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORDkk),
     /*  32678 */   GIR_RootConstrainSelectedInstOperands,
     /*  32679 */   // GIR_Coverage, 4420,
     /*  32679 */   GIR_Done,
     /*  32680 */ // Label 827: @32680
     /*  32680 */ GIM_Reject,
     /*  32681 */ // Label 679: @32681
     /*  32681 */ GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(33146),
     /*  32686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  32689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  32692 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(32754), // Rule ID 25230 //
     /*  32697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32712 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32715 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32719 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32736 */     // (or:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32741 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32743 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32752 */     GIR_RootConstrainSelectedInstOperands,
     /*  32753 */     // GIR_Coverage, 25230,
     /*  32753 */     GIR_EraseRootFromParent_Done,
     /*  32754 */   // Label 829: @32754
     /*  32754 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(32816), // Rule ID 25240 //
     /*  32759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32774 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32777 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32781 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32791 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32798 */     // (or:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  32801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32803 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32805 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32814 */     GIR_RootConstrainSelectedInstOperands,
     /*  32815 */     // GIR_Coverage, 25240,
     /*  32815 */     GIR_EraseRootFromParent_Done,
     /*  32816 */   // Label 830: @32816
     /*  32816 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(32878), // Rule ID 25437 //
     /*  32821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32836 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32839 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32843 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32853 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32860 */     // (or:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  32863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32865 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32867 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32876 */     GIR_RootConstrainSelectedInstOperands,
     /*  32877 */     // GIR_Coverage, 25437,
     /*  32877 */     GIR_EraseRootFromParent_Done,
     /*  32878 */   // Label 831: @32878
     /*  32878 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(32940), // Rule ID 18104 //
     /*  32883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32902 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32905 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32909 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32922 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32927 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32929 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32938 */     GIR_RootConstrainSelectedInstOperands,
     /*  32939 */     // GIR_Coverage, 18104,
     /*  32939 */     GIR_EraseRootFromParent_Done,
     /*  32940 */   // Label 832: @32940
     /*  32940 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(33002), // Rule ID 18133 //
     /*  32945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32964 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32967 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32971 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32984 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  32987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32989 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32991 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33000 */     GIR_RootConstrainSelectedInstOperands,
     /*  33001 */     // GIR_Coverage, 18133,
     /*  33001 */     GIR_EraseRootFromParent_Done,
     /*  33002 */   // Label 833: @33002
     /*  33002 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(33064), // Rule ID 20041 //
     /*  33007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  33010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33026 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33029 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33033 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33046 */     // (or:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  33049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33051 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33053 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33062 */     GIR_RootConstrainSelectedInstOperands,
     /*  33063 */     // GIR_Coverage, 20041,
     /*  33063 */     GIR_EraseRootFromParent_Done,
     /*  33064 */   // Label 834: @33064
     /*  33064 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(33091), // Rule ID 18092 //
     /*  33069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  33072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33084 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPORYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  33084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  33089 */     GIR_RootConstrainSelectedInstOperands,
     /*  33090 */     // GIR_Coverage, 18092,
     /*  33090 */     GIR_Done,
     /*  33091 */   // Label 835: @33091
     /*  33091 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(33118), // Rule ID 18117 //
     /*  33096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  33099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33111 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VORPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  33111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  33116 */     GIR_RootConstrainSelectedInstOperands,
     /*  33117 */     // GIR_Coverage, 18117,
     /*  33117 */     GIR_Done,
     /*  33118 */   // Label 836: @33118
     /*  33118 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(33145), // Rule ID 20033 //
     /*  33123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  33126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33138 */     // (or:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPORQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  33138 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /*  33143 */     GIR_RootConstrainSelectedInstOperands,
     /*  33144 */     // GIR_Coverage, 20033,
     /*  33144 */     GIR_Done,
     /*  33145 */   // Label 837: @33145
     /*  33145 */   GIM_Reject,
     /*  33146 */ // Label 828: @33146
     /*  33146 */ GIM_Reject,
     /*  33147 */ // Label 680: @33147
     /*  33147 */ GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(33302),
     /*  33152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  33155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  33158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33162 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(33220), // Rule ID 25444 //
     /*  33167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33178 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33181 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33185 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33202 */     // (or:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33207 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33209 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33218 */     GIR_RootConstrainSelectedInstOperands,
     /*  33219 */     // GIR_Coverage, 25444,
     /*  33219 */     GIR_EraseRootFromParent_Done,
     /*  33220 */   // Label 839: @33220
     /*  33220 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(33278), // Rule ID 20058 //
     /*  33225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33240 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33243 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33247 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33253 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33260 */     // (or:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33265 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33267 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33276 */     GIR_RootConstrainSelectedInstOperands,
     /*  33277 */     // GIR_Coverage, 20058,
     /*  33277 */     GIR_EraseRootFromParent_Done,
     /*  33278 */   // Label 840: @33278
     /*  33278 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(33301), // Rule ID 20050 //
     /*  33283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33294 */     // (or:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPORQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  33294 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /*  33299 */     GIR_RootConstrainSelectedInstOperands,
     /*  33300 */     // GIR_Coverage, 20050,
     /*  33300 */     GIR_Done,
     /*  33301 */   // Label 841: @33301
     /*  33301 */   GIM_Reject,
     /*  33302 */ // Label 838: @33302
     /*  33302 */ GIM_Reject,
     /*  33303 */ // Label 681: @33303
     /*  33303 */ GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(33336), // Rule ID 4421 //
     /*  33308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  33311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  33314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  33317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  33321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  33325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  33329 */   // (or:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  33329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORQkk),
     /*  33334 */   GIR_RootConstrainSelectedInstOperands,
     /*  33335 */   // GIR_Coverage, 4421,
     /*  33335 */   GIR_Done,
     /*  33336 */ // Label 842: @33336
     /*  33336 */ GIM_Reject,
     /*  33337 */ // Label 682: @33337
     /*  33337 */ GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(33492),
     /*  33342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  33345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  33348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33352 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(33410), // Rule ID 25443 //
     /*  33357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33368 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33371 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33375 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33392 */     // (or:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33397 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33399 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33408 */     GIR_RootConstrainSelectedInstOperands,
     /*  33409 */     // GIR_Coverage, 25443,
     /*  33409 */     GIR_EraseRootFromParent_Done,
     /*  33410 */   // Label 844: @33410
     /*  33410 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(33468), // Rule ID 20057 //
     /*  33415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33430 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33433 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33437 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33443 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33450 */     // (or:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33455 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33457 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33466 */     GIR_RootConstrainSelectedInstOperands,
     /*  33467 */     // GIR_Coverage, 20057,
     /*  33467 */     GIR_EraseRootFromParent_Done,
     /*  33468 */   // Label 845: @33468
     /*  33468 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(33491), // Rule ID 20049 //
     /*  33473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33484 */     // (or:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPORQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  33484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /*  33489 */     GIR_RootConstrainSelectedInstOperands,
     /*  33490 */     // GIR_Coverage, 20049,
     /*  33490 */     GIR_Done,
     /*  33491 */   // Label 846: @33491
     /*  33491 */   GIM_Reject,
     /*  33492 */ // Label 843: @33492
     /*  33492 */ GIM_Reject,
     /*  33493 */ // Label 683: @33493
     /*  33493 */ GIM_Reject,
     /*  33494 */ // Label 5: @33494
     /*  33494 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 870*/ GIMT_Encode4(46194),
     /*  33505 */ /*GILLT_s1*//*Label 847*/ GIMT_Encode4(33605),
     /*  33509 */ /*GILLT_s8*//*Label 848*/ GIMT_Encode4(34163),
     /*  33513 */ /*GILLT_s16*//*Label 849*/ GIMT_Encode4(34690),
     /*  33517 */ /*GILLT_s32*//*Label 850*/ GIMT_Encode4(35435),
     /*  33521 */ /*GILLT_s64*//*Label 851*/ GIMT_Encode4(36383), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  33533 */ /*GILLT_v2s1*//*Label 852*/ GIMT_Encode4(37290),
     /*  33537 */ /*GILLT_v2s64*//*Label 853*/ GIMT_Encode4(37832),
     /*  33541 */ /*GILLT_v4s1*//*Label 854*/ GIMT_Encode4(38452),
     /*  33545 */ /*GILLT_v4s32*//*Label 855*/ GIMT_Encode4(38994),
     /*  33549 */ /*GILLT_v4s64*//*Label 856*/ GIMT_Encode4(39614),
     /*  33553 */ /*GILLT_v8s1*//*Label 857*/ GIMT_Encode4(40358),
     /*  33557 */ /*GILLT_v8s16*//*Label 858*/ GIMT_Encode4(41156),
     /*  33561 */ /*GILLT_v8s32*//*Label 859*/ GIMT_Encode4(41776),
     /*  33565 */ /*GILLT_v8s64*//*Label 860*/ GIMT_Encode4(42520),
     /*  33569 */ /*GILLT_v16s1*//*Label 861*/ GIMT_Encode4(42718),
     /*  33573 */ /*GILLT_v16s8*//*Label 862*/ GIMT_Encode4(42976),
     /*  33577 */ /*GILLT_v16s16*//*Label 863*/ GIMT_Encode4(43596),
     /*  33581 */ /*GILLT_v16s32*//*Label 864*/ GIMT_Encode4(44340),
     /*  33585 */ /*GILLT_v32s1*//*Label 865*/ GIMT_Encode4(44538),
     /*  33589 */ /*GILLT_v32s8*//*Label 866*/ GIMT_Encode4(44796),
     /*  33593 */ /*GILLT_v32s16*//*Label 867*/ GIMT_Encode4(45540),
     /*  33597 */ /*GILLT_v64s1*//*Label 868*/ GIMT_Encode4(45738),
     /*  33601 */ /*GILLT_v64s8*//*Label 869*/ GIMT_Encode4(45996),
     /*  33605 */ // Label 847: @33605
     /*  33605 */ GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(34162),
     /*  33610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  33613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  33616 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(33740), // Rule ID 25369 //
     /*  33621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  33641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33650 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33656 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  33658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33664 */     // (xor:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }), VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  33664 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  33667 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33671 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33676 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  33680 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33685 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  33688 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33692 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33697 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  33701 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  33709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  33713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33718 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  33721 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  33724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  33726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  33734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  33739 */     // GIR_Coverage, 25369,
     /*  33739 */     GIR_EraseRootFromParent_Done,
     /*  33740 */   // Label 872: @33740
     /*  33740 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(33865), // Rule ID 19495 //
     /*  33745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  33765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  33779 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33785 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  33787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33789 */     // (xor:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2), immAllOnesV:{ *:[v1i1] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  33789 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  33792 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33796 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33801 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  33805 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33810 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  33813 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33817 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33822 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  33826 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  33834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  33838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33843 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  33846 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  33849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  33851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  33859 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  33864 */     // GIR_Coverage, 19495,
     /*  33864 */     GIR_EraseRootFromParent_Done,
     /*  33865 */   // Label 873: @33865
     /*  33865 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(33989), // Rule ID 25370 //
     /*  33870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  33894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33903 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33909 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  33911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33913 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src2, (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  33913 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  33916 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33920 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33925 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  33929 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33934 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  33937 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33941 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33946 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  33950 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  33958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  33962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33967 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  33970 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  33973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  33975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  33983 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  33988 */     // GIR_Coverage, 25370,
     /*  33988 */     GIR_EraseRootFromParent_Done,
     /*  33989 */   // Label 874: @33989
     /*  33989 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(34068), // Rule ID 19481 //
     /*  33994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  33998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34006 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34012 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  34014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34016 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src, immAllOnesV:{ *:[v1i1] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  34016 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  34019 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34023 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34028 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  34032 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  34040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  34044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34049 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34062 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  34067 */     // GIR_Coverage, 19481,
     /*  34067 */     GIR_EraseRootFromParent_Done,
     /*  34068 */   // Label 875: @34068
     /*  34068 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(34161), // Rule ID 19499 //
     /*  34073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34085 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  34085 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  34088 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34092 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34097 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  34101 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34106 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  34109 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34113 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34118 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  34122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  34130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  34134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34139 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34142 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  34145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  34160 */     // GIR_Coverage, 19499,
     /*  34160 */     GIR_EraseRootFromParent_Done,
     /*  34161 */   // Label 876: @34161
     /*  34161 */   GIM_Reject,
     /*  34162 */ // Label 871: @34162
     /*  34162 */ GIM_Reject,
     /*  34163 */ // Label 848: @34163
     /*  34163 */ GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(34689),
     /*  34168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  34171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  34174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34178 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(34234), // Rule ID 273 //
     /*  34183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  34186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34194 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34197 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34201 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34205 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34218 */     // (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, -1:{ *:[i8] })  =>  (NOT8m_ND:{ *:[i8] } addr:{ *:[iPTR] }:$src1)
     /*  34218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8m_ND),
     /*  34221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  34227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34232 */     GIR_RootConstrainSelectedInstOperands,
     /*  34233 */     // GIR_Coverage, 273,
     /*  34233 */     GIR_EraseRootFromParent_Done,
     /*  34234 */   // Label 878: @34234
     /*  34234 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(34295), // Rule ID 26062 //
     /*  34239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34250 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34253 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34257 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34274 */     // (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (XOR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm),
     /*  34277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34279 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34281 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34285 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34293 */     GIR_RootConstrainSelectedInstOperands,
     /*  34294 */     // GIR_Coverage, 26062,
     /*  34294 */     GIR_EraseRootFromParent_Done,
     /*  34295 */   // Label 879: @34295
     /*  34295 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(34356), // Rule ID 26081 //
     /*  34300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34311 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34314 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34318 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34335 */     // (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (XOR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm_ND),
     /*  34338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34340 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34342 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34346 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34354 */     GIR_RootConstrainSelectedInstOperands,
     /*  34355 */     // GIR_Coverage, 26081,
     /*  34355 */     GIR_EraseRootFromParent_Done,
     /*  34356 */   // Label 880: @34356
     /*  34356 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(34417), // Rule ID 22839 //
     /*  34361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34376 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34379 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34383 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34396 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (XOR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm),
     /*  34399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34401 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34403 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34407 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34415 */     GIR_RootConstrainSelectedInstOperands,
     /*  34416 */     // GIR_Coverage, 22839,
     /*  34416 */     GIR_EraseRootFromParent_Done,
     /*  34417 */   // Label 881: @34417
     /*  34417 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(34478), // Rule ID 22929 //
     /*  34422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34437 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34440 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34444 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34450 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34457 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (XOR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm_ND),
     /*  34460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34462 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34464 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34468 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34476 */     GIR_RootConstrainSelectedInstOperands,
     /*  34477 */     // GIR_Coverage, 22929,
     /*  34477 */     GIR_EraseRootFromParent_Done,
     /*  34478 */   // Label 882: @34478
     /*  34478 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(34506), // Rule ID 22596 //
     /*  34483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-128),
     /*  34491 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -128:{ *:[i8] })  =>  (ADD8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, -128:{ *:[i8] })
     /*  34491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri),
     /*  34494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34496 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  34501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34504 */     GIR_RootConstrainSelectedInstOperands,
     /*  34505 */     // GIR_Coverage, 22596,
     /*  34505 */     GIR_EraseRootFromParent_Done,
     /*  34506 */   // Label 883: @34506
     /*  34506 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(34531), // Rule ID 245 //
     /*  34511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34522 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -1:{ *:[i8] })  =>  (NOT8r:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /*  34522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8r),
     /*  34525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34527 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34529 */     GIR_RootConstrainSelectedInstOperands,
     /*  34530 */     // GIR_Coverage, 245,
     /*  34530 */     GIR_EraseRootFromParent_Done,
     /*  34531 */   // Label 884: @34531
     /*  34531 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(34556), // Rule ID 253 //
     /*  34536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  34539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34547 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -1:{ *:[i8] })  =>  (NOT8r_ND:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /*  34547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8r_ND),
     /*  34550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34552 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34554 */     GIR_RootConstrainSelectedInstOperands,
     /*  34555 */     // GIR_Coverage, 253,
     /*  34555 */     GIR_EraseRootFromParent_Done,
     /*  34556 */   // Label 885: @34556
     /*  34556 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(34593), // Rule ID 22843 //
     /*  34561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34576 */     // MIs[1] Operand 1
     /*  34576 */     // No operand predicates
     /*  34576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34578 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (XOR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  34578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8ri),
     /*  34581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34583 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  34588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34591 */     GIR_RootConstrainSelectedInstOperands,
     /*  34592 */     // GIR_Coverage, 22843,
     /*  34592 */     GIR_EraseRootFromParent_Done,
     /*  34593 */   // Label 886: @34593
     /*  34593 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(34630), // Rule ID 22933 //
     /*  34598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34613 */     // MIs[1] Operand 1
     /*  34613 */     // No operand predicates
     /*  34613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34615 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (XOR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  34615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8ri_ND),
     /*  34618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34620 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  34625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34628 */     GIR_RootConstrainSelectedInstOperands,
     /*  34629 */     // GIR_Coverage, 22933,
     /*  34629 */     GIR_EraseRootFromParent_Done,
     /*  34630 */   // Label 887: @34630
     /*  34630 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(34659), // Rule ID 22835 //
     /*  34635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34646 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (XOR8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  34646 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR8rr),
     /*  34651 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  34657 */     GIR_RootConstrainSelectedInstOperands,
     /*  34658 */     // GIR_Coverage, 22835,
     /*  34658 */     GIR_Done,
     /*  34659 */   // Label 888: @34659
     /*  34659 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(34688), // Rule ID 22925 //
     /*  34664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34675 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (XOR8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  34675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR8rr_ND),
     /*  34680 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  34686 */     GIR_RootConstrainSelectedInstOperands,
     /*  34687 */     // GIR_Coverage, 22925,
     /*  34687 */     GIR_Done,
     /*  34688 */   // Label 889: @34688
     /*  34688 */   GIM_Reject,
     /*  34689 */ // Label 877: @34689
     /*  34689 */ GIM_Reject,
     /*  34690 */ // Label 849: @34690
     /*  34690 */ GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(35434),
     /*  34695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  34698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  34701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  34705 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(34761), // Rule ID 274 //
     /*  34710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  34713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34721 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34724 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34728 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  34732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34745 */     // (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:{ *:[i16] })  =>  (NOT16m_ND:{ *:[i16] } addr:{ *:[iPTR] }:$src1)
     /*  34745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16m_ND),
     /*  34748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34750 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  34754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34759 */     GIR_RootConstrainSelectedInstOperands,
     /*  34760 */     // GIR_Coverage, 274,
     /*  34760 */     GIR_EraseRootFromParent_Done,
     /*  34761 */   // Label 891: @34761
     /*  34761 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(34822), // Rule ID 26063 //
     /*  34766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34777 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34780 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34784 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  34788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  34792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34801 */     // (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (XOR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm),
     /*  34804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34806 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34808 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34812 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34820 */     GIR_RootConstrainSelectedInstOperands,
     /*  34821 */     // GIR_Coverage, 26063,
     /*  34821 */     GIR_EraseRootFromParent_Done,
     /*  34822 */   // Label 892: @34822
     /*  34822 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(34883), // Rule ID 26082 //
     /*  34827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34838 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34841 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34845 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  34849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  34853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34855 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34862 */     // (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (XOR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm_ND),
     /*  34865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34867 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34869 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34881 */     GIR_RootConstrainSelectedInstOperands,
     /*  34882 */     // GIR_Coverage, 26082,
     /*  34882 */     GIR_EraseRootFromParent_Done,
     /*  34883 */   // Label 893: @34883
     /*  34883 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(34944), // Rule ID 22840 //
     /*  34888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  34895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34903 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34906 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34910 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  34914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34923 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (XOR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm),
     /*  34926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34928 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34930 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34942 */     GIR_RootConstrainSelectedInstOperands,
     /*  34943 */     // GIR_Coverage, 22840,
     /*  34943 */     GIR_EraseRootFromParent_Done,
     /*  34944 */   // Label 894: @34944
     /*  34944 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(35005), // Rule ID 22930 //
     /*  34949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  34956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34964 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34967 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34971 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  34975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34984 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (XOR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm_ND),
     /*  34987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34989 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34991 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35003 */     GIR_RootConstrainSelectedInstOperands,
     /*  35004 */     // GIR_Coverage, 22930,
     /*  35004 */     GIR_EraseRootFromParent_Done,
     /*  35005 */   // Label 895: @35005
     /*  35005 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(35047), // Rule ID 22597 //
     /*  35010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35014 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(-32768),
     /*  35025 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -32768:{ *:[i16] })  =>  (ADD16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -32768:{ *:[i16] })
     /*  35025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri),
     /*  35028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35030 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35032 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-32768),
     /*  35042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35045 */     GIR_RootConstrainSelectedInstOperands,
     /*  35046 */     // GIR_Coverage, 22597,
     /*  35046 */     GIR_EraseRootFromParent_Done,
     /*  35047 */   // Label 896: @35047
     /*  35047 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(35149), // Rule ID 26035 //
     /*  35052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  35060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  35064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  35068 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  35072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  35077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35083 */     // (xor:{ *:[i16] } (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTC16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  35083 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  35086 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35090 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  35097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  35100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35109 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35112 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  35116 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  35124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  35129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  35134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC16rr),
     /*  35137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35139 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35144 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35147 */     GIR_RootConstrainSelectedInstOperands,
     /*  35148 */     // GIR_Coverage, 26035,
     /*  35148 */     GIR_EraseRootFromParent_Done,
     /*  35149 */   // Label 897: @35149
     /*  35149 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(35251), // Rule ID 22773 //
     /*  35154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  35166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  35170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  35174 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  35178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  35183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35185 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTC16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  35185 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  35188 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35192 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  35199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  35202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35211 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  35218 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  35226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  35231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  35236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC16rr),
     /*  35239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35241 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35246 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35249 */     GIR_RootConstrainSelectedInstOperands,
     /*  35250 */     // GIR_Coverage, 22773,
     /*  35250 */     GIR_EraseRootFromParent_Done,
     /*  35251 */   // Label 898: @35251
     /*  35251 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(35276), // Rule ID 246 //
     /*  35256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35263 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  35267 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -1:{ *:[i16] })  =>  (NOT16r:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /*  35267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16r),
     /*  35270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35272 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35274 */     GIR_RootConstrainSelectedInstOperands,
     /*  35275 */     // GIR_Coverage, 246,
     /*  35275 */     GIR_EraseRootFromParent_Done,
     /*  35276 */   // Label 899: @35276
     /*  35276 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(35301), // Rule ID 254 //
     /*  35281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  35284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  35292 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -1:{ *:[i16] })  =>  (NOT16r_ND:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /*  35292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16r_ND),
     /*  35295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35297 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35299 */     GIR_RootConstrainSelectedInstOperands,
     /*  35300 */     // GIR_Coverage, 254,
     /*  35300 */     GIR_EraseRootFromParent_Done,
     /*  35301 */   // Label 900: @35301
     /*  35301 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(35338), // Rule ID 22844 //
     /*  35306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35321 */     // MIs[1] Operand 1
     /*  35321 */     // No operand predicates
     /*  35321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35323 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (XOR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  35323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16ri),
     /*  35326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35328 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  35333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35336 */     GIR_RootConstrainSelectedInstOperands,
     /*  35337 */     // GIR_Coverage, 22844,
     /*  35337 */     GIR_EraseRootFromParent_Done,
     /*  35338 */   // Label 901: @35338
     /*  35338 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(35375), // Rule ID 22934 //
     /*  35343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35358 */     // MIs[1] Operand 1
     /*  35358 */     // No operand predicates
     /*  35358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35360 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (XOR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  35360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16ri_ND),
     /*  35363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35365 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  35370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35373 */     GIR_RootConstrainSelectedInstOperands,
     /*  35374 */     // GIR_Coverage, 22934,
     /*  35374 */     GIR_EraseRootFromParent_Done,
     /*  35375 */   // Label 902: @35375
     /*  35375 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(35404), // Rule ID 22836 //
     /*  35380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35391 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (XOR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  35391 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR16rr),
     /*  35396 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  35402 */     GIR_RootConstrainSelectedInstOperands,
     /*  35403 */     // GIR_Coverage, 22836,
     /*  35403 */     GIR_Done,
     /*  35404 */   // Label 903: @35404
     /*  35404 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(35433), // Rule ID 22926 //
     /*  35409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35420 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (XOR16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  35420 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR16rr_ND),
     /*  35425 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  35431 */     GIR_RootConstrainSelectedInstOperands,
     /*  35432 */     // GIR_Coverage, 22926,
     /*  35432 */     GIR_Done,
     /*  35433 */   // Label 904: @35433
     /*  35433 */   GIM_Reject,
     /*  35434 */ // Label 890: @35434
     /*  35434 */ GIM_Reject,
     /*  35435 */ // Label 850: @35435
     /*  35435 */ GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(36382),
     /*  35440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35443 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(35506), // Rule ID 275 //
     /*  35448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  35451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35466 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35469 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35473 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35477 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  35481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35483 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35490 */     // (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:{ *:[i32] })  =>  (NOT32m_ND:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  35490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32m_ND),
     /*  35493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35495 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  35499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35504 */     GIR_RootConstrainSelectedInstOperands,
     /*  35505 */     // GIR_Coverage, 275,
     /*  35505 */     GIR_EraseRootFromParent_Done,
     /*  35506 */   // Label 906: @35506
     /*  35506 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(35574), // Rule ID 26064 //
     /*  35511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35529 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35532 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35536 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35546 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35553 */     // (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (XOR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm),
     /*  35556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35558 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35560 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35572 */     GIR_RootConstrainSelectedInstOperands,
     /*  35573 */     // GIR_Coverage, 26064,
     /*  35573 */     GIR_EraseRootFromParent_Done,
     /*  35574 */   // Label 907: @35574
     /*  35574 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(35642), // Rule ID 26083 //
     /*  35579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35597 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35600 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35604 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35621 */     // (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (XOR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm_ND),
     /*  35624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35626 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35628 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35640 */     GIR_RootConstrainSelectedInstOperands,
     /*  35641 */     // GIR_Coverage, 26083,
     /*  35641 */     GIR_EraseRootFromParent_Done,
     /*  35642 */   // Label 908: @35642
     /*  35642 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(35710), // Rule ID 22841 //
     /*  35647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35669 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35672 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35676 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35689 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (XOR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm),
     /*  35692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35694 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35696 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35708 */     GIR_RootConstrainSelectedInstOperands,
     /*  35709 */     // GIR_Coverage, 22841,
     /*  35709 */     GIR_EraseRootFromParent_Done,
     /*  35710 */   // Label 909: @35710
     /*  35710 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(35778), // Rule ID 22931 //
     /*  35715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35737 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35740 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35744 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35757 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (XOR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm_ND),
     /*  35760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35762 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35764 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35776 */     GIR_RootConstrainSelectedInstOperands,
     /*  35777 */     // GIR_Coverage, 22931,
     /*  35777 */     GIR_EraseRootFromParent_Done,
     /*  35778 */   // Label 910: @35778
     /*  35778 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(35827), // Rule ID 22598 //
     /*  35783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35794 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(-2147483648),
     /*  35805 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -2147483648:{ *:[i32] })  =>  (ADD32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -2147483648:{ *:[i32] })
     /*  35805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri),
     /*  35808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35810 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35812 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*  35822 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35825 */     GIR_RootConstrainSelectedInstOperands,
     /*  35826 */     // GIR_Coverage, 22598,
     /*  35826 */     GIR_EraseRootFromParent_Done,
     /*  35827 */   // Label 911: @35827
     /*  35827 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(35885), // Rule ID 24994 //
     /*  35832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  35835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  35847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35860 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  35864 */     // MIs[0] src
     /*  35864 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35871 */     // (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  35871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK32rr),
     /*  35874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  35880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35883 */     GIR_RootConstrainSelectedInstOperands,
     /*  35884 */     // GIR_Coverage, 24994,
     /*  35884 */     GIR_EraseRootFromParent_Done,
     /*  35885 */   // Label 912: @35885
     /*  35885 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(35994), // Rule ID 26041 //
     /*  35890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  35905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  35913 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  35917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  35922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35928 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  35928 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  35931 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35935 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  35942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  35945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35954 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35957 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  35961 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  35969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  35974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  35979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC32rr),
     /*  35982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35984 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35989 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35992 */     GIR_RootConstrainSelectedInstOperands,
     /*  35993 */     // GIR_Coverage, 26041,
     /*  35993 */     GIR_EraseRootFromParent_Done,
     /*  35994 */   // Label 913: @35994
     /*  35994 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(36048), // Rule ID 17357 //
     /*  35999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  36002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36025 */     // MIs[1] src
     /*  36025 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  36030 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  36034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36036 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  36036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK32rr),
     /*  36039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36041 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  36043 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36046 */     GIR_RootConstrainSelectedInstOperands,
     /*  36047 */     // GIR_Coverage, 17357,
     /*  36047 */     GIR_EraseRootFromParent_Done,
     /*  36048 */   // Label 914: @36048
     /*  36048 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(36157), // Rule ID 22779 //
     /*  36053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  36080 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  36084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  36089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36091 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  36091 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  36094 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36098 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  36105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36117 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36120 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  36124 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  36132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  36137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  36142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC32rr),
     /*  36145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36147 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36155 */     GIR_RootConstrainSelectedInstOperands,
     /*  36156 */     // GIR_Coverage, 22779,
     /*  36156 */     GIR_EraseRootFromParent_Done,
     /*  36157 */   // Label 915: @36157
     /*  36157 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(36189), // Rule ID 247 //
     /*  36162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  36180 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] })  =>  (NOT32r:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*  36180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32r),
     /*  36183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36185 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36187 */     GIR_RootConstrainSelectedInstOperands,
     /*  36188 */     // GIR_Coverage, 247,
     /*  36188 */     GIR_EraseRootFromParent_Done,
     /*  36189 */   // Label 916: @36189
     /*  36189 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(36221), // Rule ID 255 //
     /*  36194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  36197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  36212 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] })  =>  (NOT32r_ND:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*  36212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32r_ND),
     /*  36215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36217 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36219 */     GIR_RootConstrainSelectedInstOperands,
     /*  36220 */     // GIR_Coverage, 255,
     /*  36220 */     GIR_EraseRootFromParent_Done,
     /*  36221 */   // Label 917: @36221
     /*  36221 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(36265), // Rule ID 22845 //
     /*  36226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36248 */     // MIs[1] Operand 1
     /*  36248 */     // No operand predicates
     /*  36248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36250 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (XOR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  36250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32ri),
     /*  36253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36255 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  36260 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36263 */     GIR_RootConstrainSelectedInstOperands,
     /*  36264 */     // GIR_Coverage, 22845,
     /*  36264 */     GIR_EraseRootFromParent_Done,
     /*  36265 */   // Label 918: @36265
     /*  36265 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(36309), // Rule ID 22935 //
     /*  36270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36292 */     // MIs[1] Operand 1
     /*  36292 */     // No operand predicates
     /*  36292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36294 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (XOR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  36294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32ri_ND),
     /*  36297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36299 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  36304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36307 */     GIR_RootConstrainSelectedInstOperands,
     /*  36308 */     // GIR_Coverage, 22935,
     /*  36308 */     GIR_EraseRootFromParent_Done,
     /*  36309 */   // Label 919: @36309
     /*  36309 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(36345), // Rule ID 22837 //
     /*  36314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36332 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (XOR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  36332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR32rr),
     /*  36337 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  36343 */     GIR_RootConstrainSelectedInstOperands,
     /*  36344 */     // GIR_Coverage, 22837,
     /*  36344 */     GIR_Done,
     /*  36345 */   // Label 920: @36345
     /*  36345 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(36381), // Rule ID 22927 //
     /*  36350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36368 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (XOR32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  36368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR32rr_ND),
     /*  36373 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  36379 */     GIR_RootConstrainSelectedInstOperands,
     /*  36380 */     // GIR_Coverage, 22927,
     /*  36380 */     GIR_Done,
     /*  36381 */   // Label 921: @36381
     /*  36381 */   GIM_Reject,
     /*  36382 */ // Label 905: @36382
     /*  36382 */ GIM_Reject,
     /*  36383 */ // Label 851: @36383
     /*  36383 */ GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(37289),
     /*  36388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36391 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(36454), // Rule ID 276 //
     /*  36396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  36399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36414 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36417 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36421 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36425 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  36429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36438 */     // (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, -1:{ *:[i64] })  =>  (NOT64m_ND:{ *:[i64] } addr:{ *:[iPTR] }:$src1)
     /*  36438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64m_ND),
     /*  36441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36443 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  36447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36452 */     GIR_RootConstrainSelectedInstOperands,
     /*  36453 */     // GIR_Coverage, 276,
     /*  36453 */     GIR_EraseRootFromParent_Done,
     /*  36454 */   // Label 923: @36454
     /*  36454 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(36522), // Rule ID 26065 //
     /*  36459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36477 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36480 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36484 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36501 */     // (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (XOR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm),
     /*  36504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36506 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  36508 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36512 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36520 */     GIR_RootConstrainSelectedInstOperands,
     /*  36521 */     // GIR_Coverage, 26065,
     /*  36521 */     GIR_EraseRootFromParent_Done,
     /*  36522 */   // Label 924: @36522
     /*  36522 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(36590), // Rule ID 26084 //
     /*  36527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36545 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36548 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36552 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36569 */     // (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (XOR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm_ND),
     /*  36572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36574 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  36576 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36588 */     GIR_RootConstrainSelectedInstOperands,
     /*  36589 */     // GIR_Coverage, 26084,
     /*  36589 */     GIR_EraseRootFromParent_Done,
     /*  36590 */   // Label 925: @36590
     /*  36590 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(36658), // Rule ID 22842 //
     /*  36595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36617 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36620 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36624 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36630 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36637 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (XOR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm),
     /*  36640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36642 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36644 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36656 */     GIR_RootConstrainSelectedInstOperands,
     /*  36657 */     // GIR_Coverage, 22842,
     /*  36657 */     GIR_EraseRootFromParent_Done,
     /*  36658 */   // Label 926: @36658
     /*  36658 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(36726), // Rule ID 22932 //
     /*  36663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36685 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36688 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36692 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36705 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (XOR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm_ND),
     /*  36708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36710 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36712 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36724 */     GIR_RootConstrainSelectedInstOperands,
     /*  36725 */     // GIR_Coverage, 22932,
     /*  36725 */     GIR_EraseRootFromParent_Done,
     /*  36726 */   // Label 927: @36726
     /*  36726 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(36784), // Rule ID 24995 //
     /*  36731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  36734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36759 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  36763 */     // MIs[0] src
     /*  36763 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  36768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36770 */     // (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  36770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK64rr),
     /*  36773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  36779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36782 */     GIR_RootConstrainSelectedInstOperands,
     /*  36783 */     // GIR_Coverage, 24995,
     /*  36783 */     GIR_EraseRootFromParent_Done,
     /*  36784 */   // Label 928: @36784
     /*  36784 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(36893), // Rule ID 26047 //
     /*  36789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  36812 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  36816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  36821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36827 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  36827 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36830 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36834 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  36841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36853 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  36860 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  36868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  36873 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  36878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC64rr),
     /*  36881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36883 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  36885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36891 */     GIR_RootConstrainSelectedInstOperands,
     /*  36892 */     // GIR_Coverage, 26047,
     /*  36892 */     GIR_EraseRootFromParent_Done,
     /*  36893 */   // Label 929: @36893
     /*  36893 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(36947), // Rule ID 17358 //
     /*  36898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  36901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36924 */     // MIs[1] src
     /*  36924 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  36929 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  36933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36935 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  36935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK64rr),
     /*  36938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36940 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  36942 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36945 */     GIR_RootConstrainSelectedInstOperands,
     /*  36946 */     // GIR_Coverage, 17358,
     /*  36946 */     GIR_EraseRootFromParent_Done,
     /*  36947 */   // Label 930: @36947
     /*  36947 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(37056), // Rule ID 22785 //
     /*  36952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  36979 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  36983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  36988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36990 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  36990 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36993 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36997 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  37004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37016 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37019 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  37023 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  37031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  37036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  37041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC64rr),
     /*  37044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37046 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37054 */     GIR_RootConstrainSelectedInstOperands,
     /*  37055 */     // GIR_Coverage, 22785,
     /*  37055 */     GIR_EraseRootFromParent_Done,
     /*  37056 */   // Label 931: @37056
     /*  37056 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(37088), // Rule ID 248 //
     /*  37061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  37064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37075 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  37079 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] })  =>  (NOT64r:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /*  37079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64r),
     /*  37082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37084 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37086 */     GIR_RootConstrainSelectedInstOperands,
     /*  37087 */     // GIR_Coverage, 248,
     /*  37087 */     GIR_EraseRootFromParent_Done,
     /*  37088 */   // Label 932: @37088
     /*  37088 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(37120), // Rule ID 256 //
     /*  37093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  37096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  37111 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] })  =>  (NOT64r_ND:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /*  37111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64r_ND),
     /*  37114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37116 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37118 */     GIR_RootConstrainSelectedInstOperands,
     /*  37119 */     // GIR_Coverage, 256,
     /*  37119 */     GIR_EraseRootFromParent_Done,
     /*  37120 */   // Label 933: @37120
     /*  37120 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(37168), // Rule ID 22846 //
     /*  37125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  37128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  37151 */     // MIs[1] Operand 1
     /*  37151 */     // No operand predicates
     /*  37151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37153 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (XOR64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  37153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64ri32),
     /*  37156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37158 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  37163 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37166 */     GIR_RootConstrainSelectedInstOperands,
     /*  37167 */     // GIR_Coverage, 22846,
     /*  37167 */     GIR_EraseRootFromParent_Done,
     /*  37168 */   // Label 934: @37168
     /*  37168 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(37216), // Rule ID 22936 //
     /*  37173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  37176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  37199 */     // MIs[1] Operand 1
     /*  37199 */     // No operand predicates
     /*  37199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37201 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (XOR64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  37201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64ri32_ND),
     /*  37204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37206 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  37211 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37214 */     GIR_RootConstrainSelectedInstOperands,
     /*  37215 */     // GIR_Coverage, 22936,
     /*  37215 */     GIR_EraseRootFromParent_Done,
     /*  37216 */   // Label 935: @37216
     /*  37216 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(37252), // Rule ID 22838 //
     /*  37221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  37224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37239 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (XOR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  37239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR64rr),
     /*  37244 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  37250 */     GIR_RootConstrainSelectedInstOperands,
     /*  37251 */     // GIR_Coverage, 22838,
     /*  37251 */     GIR_Done,
     /*  37252 */   // Label 936: @37252
     /*  37252 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(37288), // Rule ID 22928 //
     /*  37257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  37260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37275 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (XOR64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  37275 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR64rr_ND),
     /*  37280 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  37286 */     GIR_RootConstrainSelectedInstOperands,
     /*  37287 */     // GIR_Coverage, 22928,
     /*  37287 */     GIR_Done,
     /*  37288 */   // Label 937: @37288
     /*  37288 */   GIM_Reject,
     /*  37289 */ // Label 922: @37289
     /*  37289 */ GIM_Reject,
     /*  37290 */ // Label 852: @37290
     /*  37290 */ GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(37831),
     /*  37295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37305 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(37425), // Rule ID 25371 //
     /*  37310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  37335 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37341 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  37343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37349 */     // (xor:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }), VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37349 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37352 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37356 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37361 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  37365 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37370 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37373 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37377 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37382 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  37386 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  37398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37403 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37406 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37424 */     // GIR_Coverage, 25371,
     /*  37424 */     GIR_EraseRootFromParent_Done,
     /*  37425 */   // Label 939: @37425
     /*  37425 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(37546), // Rule ID 19496 //
     /*  37430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  37460 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37466 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  37468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37470 */     // (xor:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2), immAllOnesV:{ *:[v2i1] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37470 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37473 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37477 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37482 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  37486 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37491 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37494 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37498 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37503 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  37507 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  37519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37524 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37527 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37545 */     // GIR_Coverage, 19496,
     /*  37545 */     GIR_EraseRootFromParent_Done,
     /*  37546 */   // Label 940: @37546
     /*  37546 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(37666), // Rule ID 25372 //
     /*  37551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  37580 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37586 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  37588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37590 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src2, (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37590 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37593 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37597 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37602 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  37606 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37611 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37614 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37618 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37623 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  37627 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  37639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37644 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37647 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37665 */     // GIR_Coverage, 25372,
     /*  37665 */     GIR_EraseRootFromParent_Done,
     /*  37666 */   // Label 941: @37666
     /*  37666 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(37741), // Rule ID 19480 //
     /*  37671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37679 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37685 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  37687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37689 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src, immAllOnesV:{ *:[v2i1] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37689 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37692 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37696 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37701 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  37705 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  37717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37722 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37740 */     // GIR_Coverage, 19480,
     /*  37740 */     GIR_EraseRootFromParent_Done,
     /*  37741 */   // Label 942: @37741
     /*  37741 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(37830), // Rule ID 19500 //
     /*  37746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37754 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37754 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37757 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37761 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37766 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  37770 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37775 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37778 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37782 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37787 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  37791 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  37803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37808 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37811 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37829 */     // GIR_Coverage, 19500,
     /*  37829 */     GIR_EraseRootFromParent_Done,
     /*  37830 */   // Label 943: @37830
     /*  37830 */   GIM_Reject,
     /*  37831 */ // Label 938: @37831
     /*  37831 */ GIM_Reject,
     /*  37832 */ // Label 853: @37832
     /*  37832 */ GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(38451),
     /*  37837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  37840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  37843 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(37905), // Rule ID 23363 //
     /*  37848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  37851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  37855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  37863 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  37866 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  37870 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  37874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  37878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  37887 */     // (xor:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPXORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  37887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  37890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37892 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  37894 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  37898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  37903 */     GIR_RootConstrainSelectedInstOperands,
     /*  37904 */     // GIR_Coverage, 23363,
     /*  37904 */     GIR_EraseRootFromParent_Done,
     /*  37905 */   // Label 945: @37905
     /*  37905 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(37967), // Rule ID 24218 //
     /*  37910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  37913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  37917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  37925 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  37928 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  37932 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  37936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  37940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  37949 */     // (xor:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPXORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  37949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  37952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37954 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  37956 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  37960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  37965 */     GIR_RootConstrainSelectedInstOperands,
     /*  37966 */     // GIR_Coverage, 24218,
     /*  37966 */     GIR_EraseRootFromParent_Done,
     /*  37967 */   // Label 946: @37967
     /*  37967 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(38029), // Rule ID 2122 //
     /*  37972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  37975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  37979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  37983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  37991 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  37994 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  37998 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  38002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38004 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  38011 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  38011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  38014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38016 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  38018 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  38022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  38027 */     GIR_RootConstrainSelectedInstOperands,
     /*  38028 */     // GIR_Coverage, 2122,
     /*  38028 */     GIR_EraseRootFromParent_Done,
     /*  38029 */   // Label 947: @38029
     /*  38029 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(38091), // Rule ID 5814 //
     /*  38034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  38037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  38053 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  38056 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  38060 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  38064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38066 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  38073 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  38073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  38076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38078 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  38080 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  38084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  38089 */     GIR_RootConstrainSelectedInstOperands,
     /*  38090 */     // GIR_Coverage, 5814,
     /*  38090 */     GIR_EraseRootFromParent_Done,
     /*  38091 */   // Label 948: @38091
     /*  38091 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(38323), // Rule ID 21945 //
     /*  38096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  38099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  38103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38111 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38117 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  38119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38121 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, immAllOnesV:{ *:[v2i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  38121 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  38124 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38128 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  38135 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  38138 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38142 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38147 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  38150 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38154 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  38157 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  38162 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38167 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  38172 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  38175 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38179 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  38186 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  38189 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38193 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38198 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  38201 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38205 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  38208 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  38213 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38218 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  38223 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  38226 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38230 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38237 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  38240 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38244 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38249 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38252 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38256 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  38259 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  38264 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38269 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  38274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  38277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  38281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38286 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38289 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  38292 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  38295 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  38298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38305 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  38312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  38317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38322 */     // GIR_Coverage, 21945,
     /*  38322 */     GIR_EraseRootFromParent_Done,
     /*  38323 */   // Label 949: @38323
     /*  38323 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(38369), // Rule ID 21953 //
     /*  38328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  38331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38343 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38349 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  38351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38353 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, immAllOnesV:{ *:[v2i64] })  =>  (VPTERNLOGQZ128rri:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VR128X:{ *:[v2i64] }:$src, VR128X:{ *:[v2i64] }:$src, 15:{ *:[i8] })
     /*  38353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  38356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38358 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  38360 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  38362 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  38364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  38367 */     GIR_RootConstrainSelectedInstOperands,
     /*  38368 */     // GIR_Coverage, 21953,
     /*  38368 */     GIR_EraseRootFromParent_Done,
     /*  38369 */   // Label 950: @38369
     /*  38369 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(38396), // Rule ID 2121 //
     /*  38374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  38377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38389 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPXORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  38389 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  38394 */     GIR_RootConstrainSelectedInstOperands,
     /*  38395 */     // GIR_Coverage, 2121,
     /*  38395 */     GIR_Done,
     /*  38396 */   // Label 951: @38396
     /*  38396 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(38423), // Rule ID 2123 //
     /*  38401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  38404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38416 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PXORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  38416 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  38421 */     GIR_RootConstrainSelectedInstOperands,
     /*  38422 */     // GIR_Coverage, 2123,
     /*  38422 */     GIR_Done,
     /*  38423 */   // Label 952: @38423
     /*  38423 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(38450), // Rule ID 5811 //
     /*  38428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  38431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38443 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPXORQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  38443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /*  38448 */     GIR_RootConstrainSelectedInstOperands,
     /*  38449 */     // GIR_Coverage, 5811,
     /*  38449 */     GIR_Done,
     /*  38450 */   // Label 953: @38450
     /*  38450 */   GIM_Reject,
     /*  38451 */ // Label 944: @38451
     /*  38451 */ GIM_Reject,
     /*  38452 */ // Label 854: @38452
     /*  38452 */ GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(38993),
     /*  38457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38467 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(38587), // Rule ID 25373 //
     /*  38472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  38497 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38503 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  38505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38511 */     // (xor:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }), VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38511 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38514 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38518 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38523 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  38527 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38532 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38535 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38539 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38544 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  38548 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  38560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38565 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38568 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  38586 */     // GIR_Coverage, 25373,
     /*  38586 */     GIR_EraseRootFromParent_Done,
     /*  38587 */   // Label 955: @38587
     /*  38587 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(38708), // Rule ID 19497 //
     /*  38592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  38622 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  38630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38632 */     // (xor:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2), immAllOnesV:{ *:[v4i1] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38632 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38635 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38639 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38644 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  38648 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38653 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38656 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38660 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38665 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  38669 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  38681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38686 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38689 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38702 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  38707 */     // GIR_Coverage, 19497,
     /*  38707 */     GIR_EraseRootFromParent_Done,
     /*  38708 */   // Label 956: @38708
     /*  38708 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(38828), // Rule ID 25374 //
     /*  38713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  38742 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38748 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  38750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38752 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src2, (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38752 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38755 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38759 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38764 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  38768 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38773 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38776 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38780 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38785 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  38789 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  38801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38806 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38809 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38822 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  38827 */     // GIR_Coverage, 25374,
     /*  38827 */     GIR_EraseRootFromParent_Done,
     /*  38828 */   // Label 957: @38828
     /*  38828 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(38903), // Rule ID 19479 //
     /*  38833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38841 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38847 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  38849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38851 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src, immAllOnesV:{ *:[v4i1] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38851 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38854 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38858 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38863 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38867 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  38879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38884 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  38902 */     // GIR_Coverage, 19479,
     /*  38902 */     GIR_EraseRootFromParent_Done,
     /*  38903 */   // Label 958: @38903
     /*  38903 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(38992), // Rule ID 19501 //
     /*  38908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38916 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38916 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38919 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38923 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38928 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  38932 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38937 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38940 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38944 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38949 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  38953 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  38965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38970 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38973 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  38991 */     // GIR_Coverage, 19501,
     /*  38991 */     GIR_EraseRootFromParent_Done,
     /*  38992 */   // Label 959: @38992
     /*  38992 */   GIM_Reject,
     /*  38993 */ // Label 954: @38993
     /*  38993 */ GIM_Reject,
     /*  38994 */ // Label 855: @38994
     /*  38994 */ GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(39613),
     /*  38999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39005 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(39067), // Rule ID 24236 //
     /*  39010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39025 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39028 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39032 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39049 */     // (xor:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPXORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ128rm),
     /*  39052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39054 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39056 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39065 */     GIR_RootConstrainSelectedInstOperands,
     /*  39066 */     // GIR_Coverage, 24236,
     /*  39066 */     GIR_EraseRootFromParent_Done,
     /*  39067 */   // Label 961: @39067
     /*  39067 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(39129), // Rule ID 25256 //
     /*  39072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  39075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39087 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39090 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39094 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39111 */     // (xor:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPXORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  39114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39116 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39127 */     GIR_RootConstrainSelectedInstOperands,
     /*  39128 */     // GIR_Coverage, 25256,
     /*  39128 */     GIR_EraseRootFromParent_Done,
     /*  39129 */   // Label 962: @39129
     /*  39129 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(39191), // Rule ID 5841 //
     /*  39134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39153 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39156 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39160 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39173 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ128rm),
     /*  39176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39178 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  39180 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39189 */     GIR_RootConstrainSelectedInstOperands,
     /*  39190 */     // GIR_Coverage, 5841,
     /*  39190 */     GIR_EraseRootFromParent_Done,
     /*  39191 */   // Label 963: @39191
     /*  39191 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(39253), // Rule ID 18165 //
     /*  39196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  39199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39215 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39218 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39222 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39228 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39235 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  39238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39240 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  39242 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39251 */     GIR_RootConstrainSelectedInstOperands,
     /*  39252 */     // GIR_Coverage, 18165,
     /*  39252 */     GIR_EraseRootFromParent_Done,
     /*  39253 */   // Label 964: @39253
     /*  39253 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(39485), // Rule ID 21944 //
     /*  39258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  39261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  39265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39273 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39279 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  39281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39283 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, immAllOnesV:{ *:[v4i32] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  39283 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  39286 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39290 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  39297 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  39300 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39304 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39309 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  39312 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39316 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  39319 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  39324 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39329 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  39334 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  39337 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39341 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  39348 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  39351 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39355 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39360 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  39363 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39367 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  39370 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  39375 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39380 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  39385 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  39388 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39392 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39399 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  39402 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39406 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39411 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39414 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39418 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  39421 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  39426 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39431 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  39436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  39439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  39443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39448 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39451 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  39454 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  39457 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  39460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39467 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  39474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  39479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39484 */     // GIR_Coverage, 21944,
     /*  39484 */     GIR_EraseRootFromParent_Done,
     /*  39485 */   // Label 965: @39485
     /*  39485 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(39531), // Rule ID 21952 //
     /*  39490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  39493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39505 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39511 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  39513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39515 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, immAllOnesV:{ *:[v4i32] })  =>  (VPTERNLOGQZ128rri:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VR128X:{ *:[v4i32] }:$src, VR128X:{ *:[v4i32] }:$src, 15:{ *:[i8] })
     /*  39515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  39518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39520 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39522 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39524 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  39529 */     GIR_RootConstrainSelectedInstOperands,
     /*  39530 */     // GIR_Coverage, 21952,
     /*  39530 */     GIR_EraseRootFromParent_Done,
     /*  39531 */   // Label 966: @39531
     /*  39531 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(39558), // Rule ID 5838 //
     /*  39536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39551 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPXORDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  39551 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZ128rr),
     /*  39556 */     GIR_RootConstrainSelectedInstOperands,
     /*  39557 */     // GIR_Coverage, 5838,
     /*  39557 */     GIR_Done,
     /*  39558 */   // Label 967: @39558
     /*  39558 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(39585), // Rule ID 18153 //
     /*  39563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  39566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39578 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPXORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  39578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  39583 */     GIR_RootConstrainSelectedInstOperands,
     /*  39584 */     // GIR_Coverage, 18153,
     /*  39584 */     GIR_Done,
     /*  39585 */   // Label 968: @39585
     /*  39585 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(39612), // Rule ID 18177 //
     /*  39590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  39593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39605 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PXORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  39605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  39610 */     GIR_RootConstrainSelectedInstOperands,
     /*  39611 */     // GIR_Coverage, 18177,
     /*  39611 */     GIR_Done,
     /*  39612 */   // Label 969: @39612
     /*  39612 */   GIM_Reject,
     /*  39613 */ // Label 960: @39613
     /*  39613 */ GIM_Reject,
     /*  39614 */ // Label 856: @39614
     /*  39614 */ GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(40357),
     /*  39619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  39622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  39625 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(39687), // Rule ID 23365 //
     /*  39630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  39633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39645 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39648 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39652 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39669 */     // (xor:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPXORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  39672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39674 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39676 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39685 */     GIR_RootConstrainSelectedInstOperands,
     /*  39686 */     // GIR_Coverage, 23365,
     /*  39686 */     GIR_EraseRootFromParent_Done,
     /*  39687 */   // Label 971: @39687
     /*  39687 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(39749), // Rule ID 24212 //
     /*  39692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  39699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39707 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39710 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39714 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  39722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39731 */     // (xor:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPXORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  39734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39736 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39738 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39747 */     GIR_RootConstrainSelectedInstOperands,
     /*  39748 */     // GIR_Coverage, 24212,
     /*  39748 */     GIR_EraseRootFromParent_Done,
     /*  39749 */   // Label 972: @39749
     /*  39749 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(39811), // Rule ID 25247 //
     /*  39754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  39757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39769 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39772 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39776 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39793 */     // (xor:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VXORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  39796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39798 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39800 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39809 */     GIR_RootConstrainSelectedInstOperands,
     /*  39810 */     // GIR_Coverage, 25247,
     /*  39810 */     GIR_EraseRootFromParent_Done,
     /*  39811 */   // Label 973: @39811
     /*  39811 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(39873), // Rule ID 2126 //
     /*  39816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  39819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39835 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39838 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39842 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39855 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  39858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39860 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  39862 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39871 */     GIR_RootConstrainSelectedInstOperands,
     /*  39872 */     // GIR_Coverage, 2126,
     /*  39872 */     GIR_EraseRootFromParent_Done,
     /*  39873 */   // Label 974: @39873
     /*  39873 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(39935), // Rule ID 5805 //
     /*  39878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  39885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  39889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39897 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39900 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39904 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39910 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39917 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  39920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39922 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  39924 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39933 */     GIR_RootConstrainSelectedInstOperands,
     /*  39934 */     // GIR_Coverage, 5805,
     /*  39934 */     GIR_EraseRootFromParent_Done,
     /*  39935 */   // Label 975: @39935
     /*  39935 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(39997), // Rule ID 18140 //
     /*  39940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  39943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39959 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39962 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39966 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39979 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  39982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39984 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  39986 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39995 */     GIR_RootConstrainSelectedInstOperands,
     /*  39996 */     // GIR_Coverage, 18140,
     /*  39996 */     GIR_EraseRootFromParent_Done,
     /*  39997 */   // Label 976: @39997
     /*  39997 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(40229), // Rule ID 21949 //
     /*  40002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  40005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40017 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40023 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  40025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40027 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, immAllOnesV:{ *:[v4i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  40027 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  40030 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40034 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  40041 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  40044 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40048 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40053 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  40056 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  40060 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  40063 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  40068 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40073 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40078 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  40081 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40085 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  40092 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  40095 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40099 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40104 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  40107 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  40111 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  40114 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  40119 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40124 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40129 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  40132 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40136 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40143 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  40146 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40150 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40155 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40158 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  40162 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  40165 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  40170 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40175 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  40183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  40187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40192 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40195 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  40198 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  40201 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  40204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40211 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  40218 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40228 */     // GIR_Coverage, 21949,
     /*  40228 */     GIR_EraseRootFromParent_Done,
     /*  40229 */   // Label 977: @40229
     /*  40229 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(40275), // Rule ID 21957 //
     /*  40234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  40237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40249 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40255 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  40257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40259 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, immAllOnesV:{ *:[v4i64] })  =>  (VPTERNLOGQZ256rri:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VR256X:{ *:[v4i64] }:$src, VR256X:{ *:[v4i64] }:$src, 15:{ *:[i8] })
     /*  40259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  40262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40264 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40266 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40268 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  40273 */     GIR_RootConstrainSelectedInstOperands,
     /*  40274 */     // GIR_Coverage, 21957,
     /*  40274 */     GIR_EraseRootFromParent_Done,
     /*  40275 */   // Label 978: @40275
     /*  40275 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(40302), // Rule ID 2125 //
     /*  40280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  40283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40295 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPXORYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  40295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  40300 */     GIR_RootConstrainSelectedInstOperands,
     /*  40301 */     // GIR_Coverage, 2125,
     /*  40301 */     GIR_Done,
     /*  40302 */   // Label 979: @40302
     /*  40302 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(40329), // Rule ID 5802 //
     /*  40307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  40310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40322 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPXORQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  40322 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /*  40327 */     GIR_RootConstrainSelectedInstOperands,
     /*  40328 */     // GIR_Coverage, 5802,
     /*  40328 */     GIR_Done,
     /*  40329 */   // Label 980: @40329
     /*  40329 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(40356), // Rule ID 18124 //
     /*  40334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  40337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40349 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VXORPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  40349 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  40354 */     GIR_RootConstrainSelectedInstOperands,
     /*  40355 */     // GIR_Coverage, 18124,
     /*  40355 */     GIR_Done,
     /*  40356 */   // Label 981: @40356
     /*  40356 */   GIM_Reject,
     /*  40357 */ // Label 970: @40357
     /*  40357 */ GIM_Reject,
     /*  40358 */ // Label 857: @40358
     /*  40358 */ GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(41155),
     /*  40363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40373 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(40433), // Rule ID 23681 //
     /*  40378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40406 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40412 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40420 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  40420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /*  40423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40429 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  40431 */     GIR_RootConstrainSelectedInstOperands,
     /*  40432 */     // GIR_Coverage, 23681,
     /*  40432 */     GIR_EraseRootFromParent_Done,
     /*  40433 */   // Label 983: @40433
     /*  40433 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(40556), // Rule ID 25367 //
     /*  40438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  40441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40466 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40472 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40480 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  40480 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  40483 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40487 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40492 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  40496 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40501 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  40504 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40508 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40513 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40517 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  40525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  40529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40534 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40537 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  40540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  40555 */     // GIR_Coverage, 25367,
     /*  40555 */     GIR_EraseRootFromParent_Done,
     /*  40556 */   // Label 984: @40556
     /*  40556 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(40619), // Rule ID 4422 //
     /*  40561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40594 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40600 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40604 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2), immAllOnesV:{ *:[v8i1] })  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  40604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /*  40607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  40617 */     GIR_RootConstrainSelectedInstOperands,
     /*  40618 */     // GIR_Coverage, 4422,
     /*  40618 */     GIR_EraseRootFromParent_Done,
     /*  40619 */   // Label 985: @40619
     /*  40619 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(40743), // Rule ID 19494 //
     /*  40624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  40627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40657 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40663 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40667 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2), immAllOnesV:{ *:[v8i1] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  40667 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  40670 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40674 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40679 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  40683 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40688 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  40691 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40695 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40700 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40704 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  40712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  40716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40721 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40724 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  40727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  40742 */     // GIR_Coverage, 19494,
     /*  40742 */     GIR_EraseRootFromParent_Done,
     /*  40743 */   // Label 986: @40743
     /*  40743 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(40803), // Rule ID 23682 //
     /*  40748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40780 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40786 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40790 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  40790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /*  40793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40799 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  40801 */     GIR_RootConstrainSelectedInstOperands,
     /*  40802 */     // GIR_Coverage, 23682,
     /*  40802 */     GIR_EraseRootFromParent_Done,
     /*  40803 */   // Label 987: @40803
     /*  40803 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(40926), // Rule ID 25368 //
     /*  40808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  40811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40840 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40846 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40850 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  40850 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  40853 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40857 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40862 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  40866 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40871 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  40874 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40878 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40883 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40887 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  40895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  40899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40904 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40907 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  40910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  40925 */     // GIR_Coverage, 25368,
     /*  40925 */     GIR_EraseRootFromParent_Done,
     /*  40926 */   // Label 988: @40926
     /*  40926 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(40961), // Rule ID 4410 //
     /*  40931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40942 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40948 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  40950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40952 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src, immAllOnesV:{ *:[v8i1] })  =>  (KNOTBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src)
     /*  40952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTBkk),
     /*  40955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40957 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40959 */     GIR_RootConstrainSelectedInstOperands,
     /*  40960 */     // GIR_Coverage, 4410,
     /*  40960 */     GIR_EraseRootFromParent_Done,
     /*  40961 */   // Label 989: @40961
     /*  40961 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(41039), // Rule ID 19478 //
     /*  40966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoDQI),
     /*  40969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40977 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40983 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  40985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40987 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src, immAllOnesV:{ *:[v8i1] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  40987 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  40990 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40994 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40999 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41003 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  41011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  41015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41020 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  41038 */     // GIR_Coverage, 19478,
     /*  41038 */     GIR_EraseRootFromParent_Done,
     /*  41039 */   // Label 990: @41039
     /*  41039 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(41062), // Rule ID 4426 //
     /*  41044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  41047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41055 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KXORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  41055 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORBkk),
     /*  41060 */     GIR_RootConstrainSelectedInstOperands,
     /*  41061 */     // GIR_Coverage, 4426,
     /*  41061 */     GIR_Done,
     /*  41062 */   // Label 991: @41062
     /*  41062 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(41154), // Rule ID 19498 //
     /*  41067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  41070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41078 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  41078 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  41081 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41085 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41090 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  41094 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41099 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  41102 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41106 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41111 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  41115 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  41123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  41127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41132 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41135 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  41138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  41153 */     // GIR_Coverage, 19498,
     /*  41153 */     GIR_EraseRootFromParent_Done,
     /*  41154 */   // Label 992: @41154
     /*  41154 */   GIM_Reject,
     /*  41155 */ // Label 982: @41155
     /*  41155 */ GIM_Reject,
     /*  41156 */ // Label 858: @41156
     /*  41156 */ GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(41775),
     /*  41161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  41164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41167 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(41229), // Rule ID 25255 //
     /*  41172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  41175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41187 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41190 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41194 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41211 */     // (xor:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPXORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  41214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41216 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41218 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41227 */     GIR_RootConstrainSelectedInstOperands,
     /*  41228 */     // GIR_Coverage, 25255,
     /*  41228 */     GIR_EraseRootFromParent_Done,
     /*  41229 */   // Label 994: @41229
     /*  41229 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(41291), // Rule ID 25434 //
     /*  41234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41249 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41252 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41256 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41266 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41273 */     // (xor:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPXORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  41276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41278 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41280 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41289 */     GIR_RootConstrainSelectedInstOperands,
     /*  41290 */     // GIR_Coverage, 25434,
     /*  41290 */     GIR_EraseRootFromParent_Done,
     /*  41291 */   // Label 995: @41291
     /*  41291 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(41353), // Rule ID 18164 //
     /*  41296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  41299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41315 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41318 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41322 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41335 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  41338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41340 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  41342 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41351 */     GIR_RootConstrainSelectedInstOperands,
     /*  41352 */     // GIR_Coverage, 18164,
     /*  41352 */     GIR_EraseRootFromParent_Done,
     /*  41353 */   // Label 996: @41353
     /*  41353 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(41415), // Rule ID 20028 //
     /*  41358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41377 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41380 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41384 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41397 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  41400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41402 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  41404 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41413 */     GIR_RootConstrainSelectedInstOperands,
     /*  41414 */     // GIR_Coverage, 20028,
     /*  41414 */     GIR_EraseRootFromParent_Done,
     /*  41415 */   // Label 997: @41415
     /*  41415 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(41647), // Rule ID 21943 //
     /*  41420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  41423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  41427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41435 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41441 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  41443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41445 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, immAllOnesV:{ *:[v8i16] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  41445 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  41448 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41452 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  41459 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  41462 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41466 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41471 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  41474 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41478 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  41481 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  41486 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41491 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  41496 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  41499 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41503 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  41510 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  41513 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41517 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41522 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  41525 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41529 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  41532 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  41537 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41542 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  41547 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  41550 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41554 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41561 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  41564 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41568 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41573 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41576 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41580 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  41583 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  41588 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41593 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  41598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  41601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  41605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41610 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41613 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  41616 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  41619 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  41622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41629 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  41636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  41641 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41646 */     // GIR_Coverage, 21943,
     /*  41646 */     GIR_EraseRootFromParent_Done,
     /*  41647 */   // Label 998: @41647
     /*  41647 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(41693), // Rule ID 21951 //
     /*  41652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41667 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41673 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  41675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41677 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, immAllOnesV:{ *:[v8i16] })  =>  (VPTERNLOGQZ128rri:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VR128X:{ *:[v8i16] }:$src, VR128X:{ *:[v8i16] }:$src, 15:{ *:[i8] })
     /*  41677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  41680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41682 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41684 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41686 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  41691 */     GIR_RootConstrainSelectedInstOperands,
     /*  41692 */     // GIR_Coverage, 21951,
     /*  41692 */     GIR_EraseRootFromParent_Done,
     /*  41693 */   // Label 999: @41693
     /*  41693 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(41720), // Rule ID 18152 //
     /*  41698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  41701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41713 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPXORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  41713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  41718 */     GIR_RootConstrainSelectedInstOperands,
     /*  41719 */     // GIR_Coverage, 18152,
     /*  41719 */     GIR_Done,
     /*  41720 */   // Label 1000: @41720
     /*  41720 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(41747), // Rule ID 18176 //
     /*  41725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  41728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41740 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PXORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  41740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  41745 */     GIR_RootConstrainSelectedInstOperands,
     /*  41746 */     // GIR_Coverage, 18176,
     /*  41746 */     GIR_Done,
     /*  41747 */   // Label 1001: @41747
     /*  41747 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(41774), // Rule ID 20020 //
     /*  41752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41767 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPXORQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  41767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /*  41772 */     GIR_RootConstrainSelectedInstOperands,
     /*  41773 */     // GIR_Coverage, 20020,
     /*  41773 */     GIR_Done,
     /*  41774 */   // Label 1002: @41774
     /*  41774 */   GIM_Reject,
     /*  41775 */ // Label 993: @41775
     /*  41775 */ GIM_Reject,
     /*  41776 */ // Label 859: @41776
     /*  41776 */ GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(42519),
     /*  41781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  41784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  41787 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(41849), // Rule ID 24230 //
     /*  41792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  41795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  41799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41807 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41810 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41814 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  41822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41831 */     // (xor:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPXORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ256rm),
     /*  41834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41836 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41838 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41847 */     GIR_RootConstrainSelectedInstOperands,
     /*  41848 */     // GIR_Coverage, 24230,
     /*  41848 */     GIR_EraseRootFromParent_Done,
     /*  41849 */   // Label 1004: @41849
     /*  41849 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(41911), // Rule ID 25235 //
     /*  41854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  41857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  41861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41869 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41872 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41876 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  41884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41886 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41893 */     // (xor:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPXORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  41896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41898 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41900 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41909 */     GIR_RootConstrainSelectedInstOperands,
     /*  41910 */     // GIR_Coverage, 25235,
     /*  41910 */     GIR_EraseRootFromParent_Done,
     /*  41911 */   // Label 1005: @41911
     /*  41911 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(41973), // Rule ID 25246 //
     /*  41916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  41919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  41923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41931 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41934 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41938 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  41946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41948 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41955 */     // (xor:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VXORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  41958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41960 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41962 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41971 */     GIR_RootConstrainSelectedInstOperands,
     /*  41972 */     // GIR_Coverage, 25246,
     /*  41972 */     GIR_EraseRootFromParent_Done,
     /*  41973 */   // Label 1006: @41973
     /*  41973 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(42035), // Rule ID 5832 //
     /*  41978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  41981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  41985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  41989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41997 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42000 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42004 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42010 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42017 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ256rm),
     /*  42020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42022 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42024 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42033 */     GIR_RootConstrainSelectedInstOperands,
     /*  42034 */     // GIR_Coverage, 5832,
     /*  42034 */     GIR_EraseRootFromParent_Done,
     /*  42035 */   // Label 1007: @42035
     /*  42035 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(42097), // Rule ID 18109 //
     /*  42040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  42043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42059 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42062 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42066 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42079 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  42082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42084 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42086 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42095 */     GIR_RootConstrainSelectedInstOperands,
     /*  42096 */     // GIR_Coverage, 18109,
     /*  42096 */     GIR_EraseRootFromParent_Done,
     /*  42097 */   // Label 1008: @42097
     /*  42097 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(42159), // Rule ID 18139 //
     /*  42102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  42105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42121 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42124 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42128 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42141 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  42144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42146 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42148 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42157 */     GIR_RootConstrainSelectedInstOperands,
     /*  42158 */     // GIR_Coverage, 18139,
     /*  42158 */     GIR_EraseRootFromParent_Done,
     /*  42159 */   // Label 1009: @42159
     /*  42159 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(42391), // Rule ID 21948 //
     /*  42164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  42167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42179 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42185 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42189 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, immAllOnesV:{ *:[v8i32] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  42189 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  42192 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42196 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  42203 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  42206 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42210 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42215 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  42218 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  42222 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  42225 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  42230 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42235 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42240 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  42243 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42247 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  42254 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  42257 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42261 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42266 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  42269 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  42273 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  42276 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  42281 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42286 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42291 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  42294 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42298 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42305 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  42308 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42312 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42317 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42320 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  42324 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  42327 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  42332 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42337 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  42345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  42349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42354 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42357 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  42360 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  42363 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  42366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42373 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  42380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42390 */     // GIR_Coverage, 21948,
     /*  42390 */     GIR_EraseRootFromParent_Done,
     /*  42391 */   // Label 1010: @42391
     /*  42391 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(42437), // Rule ID 21956 //
     /*  42396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  42399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42411 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42417 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42421 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, immAllOnesV:{ *:[v8i32] })  =>  (VPTERNLOGQZ256rri:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VR256X:{ *:[v8i32] }:$src, VR256X:{ *:[v8i32] }:$src, 15:{ *:[i8] })
     /*  42421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  42424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42426 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42428 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42430 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  42435 */     GIR_RootConstrainSelectedInstOperands,
     /*  42436 */     // GIR_Coverage, 21956,
     /*  42436 */     GIR_EraseRootFromParent_Done,
     /*  42437 */   // Label 1011: @42437
     /*  42437 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(42464), // Rule ID 5829 //
     /*  42442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  42445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42457 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPXORDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  42457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZ256rr),
     /*  42462 */     GIR_RootConstrainSelectedInstOperands,
     /*  42463 */     // GIR_Coverage, 5829,
     /*  42463 */     GIR_Done,
     /*  42464 */   // Label 1012: @42464
     /*  42464 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(42491), // Rule ID 18097 //
     /*  42469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  42472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42484 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPXORYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  42484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  42489 */     GIR_RootConstrainSelectedInstOperands,
     /*  42490 */     // GIR_Coverage, 18097,
     /*  42490 */     GIR_Done,
     /*  42491 */   // Label 1013: @42491
     /*  42491 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(42518), // Rule ID 18123 //
     /*  42496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  42499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42511 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VXORPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  42511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  42516 */     GIR_RootConstrainSelectedInstOperands,
     /*  42517 */     // GIR_Coverage, 18123,
     /*  42517 */     GIR_Done,
     /*  42518 */   // Label 1014: @42518
     /*  42518 */   GIM_Reject,
     /*  42519 */ // Label 1003: @42519
     /*  42519 */ GIM_Reject,
     /*  42520 */ // Label 860: @42520
     /*  42520 */ GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(42717),
     /*  42525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  42528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  42531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42535 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(42593), // Rule ID 24206 //
     /*  42540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42551 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42554 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42558 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42568 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42575 */     // (xor:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPXORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  42578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42580 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  42582 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42591 */     GIR_RootConstrainSelectedInstOperands,
     /*  42592 */     // GIR_Coverage, 24206,
     /*  42592 */     GIR_EraseRootFromParent_Done,
     /*  42593 */   // Label 1016: @42593
     /*  42593 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(42651), // Rule ID 5796 //
     /*  42598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42613 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42616 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42620 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42633 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  42636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42638 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42640 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42649 */     GIR_RootConstrainSelectedInstOperands,
     /*  42650 */     // GIR_Coverage, 5796,
     /*  42650 */     GIR_EraseRootFromParent_Done,
     /*  42651 */   // Label 1017: @42651
     /*  42651 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(42693), // Rule ID 21941 //
     /*  42656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42667 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42673 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42677 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, immAllOnesV:{ *:[v8i64] })  =>  (VPTERNLOGQZrri:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VR512:{ *:[v8i64] }:$src, VR512:{ *:[v8i64] }:$src, 15:{ *:[i8] })
     /*  42677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  42680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42682 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42684 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42686 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  42691 */     GIR_RootConstrainSelectedInstOperands,
     /*  42692 */     // GIR_Coverage, 21941,
     /*  42692 */     GIR_EraseRootFromParent_Done,
     /*  42693 */   // Label 1018: @42693
     /*  42693 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(42716), // Rule ID 5793 //
     /*  42698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42709 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPXORQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  42709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /*  42714 */     GIR_RootConstrainSelectedInstOperands,
     /*  42715 */     // GIR_Coverage, 5793,
     /*  42715 */     GIR_Done,
     /*  42716 */   // Label 1019: @42716
     /*  42716 */   GIM_Reject,
     /*  42717 */ // Label 1015: @42717
     /*  42717 */ GIM_Reject,
     /*  42718 */ // Label 861: @42718
     /*  42718 */ GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(42975),
     /*  42723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  42726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  42729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42733 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(42793), // Rule ID 23683 //
     /*  42738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  42753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  42757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42766 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42772 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  42774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42780 */     // (xor:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }), VK16:{ *:[v16i1] }:$src2)  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  42780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  42783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  42789 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  42791 */     GIR_RootConstrainSelectedInstOperands,
     /*  42792 */     // GIR_Coverage, 23683,
     /*  42792 */     GIR_EraseRootFromParent_Done,
     /*  42793 */   // Label 1021: @42793
     /*  42793 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(42856), // Rule ID 4423 //
     /*  42798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  42813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  42817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42831 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42837 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  42839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42841 */     // (xor:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2), immAllOnesV:{ *:[v16i1] })  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  42841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  42844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  42850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  42854 */     GIR_RootConstrainSelectedInstOperands,
     /*  42855 */     // GIR_Coverage, 4423,
     /*  42855 */     GIR_EraseRootFromParent_Done,
     /*  42856 */   // Label 1022: @42856
     /*  42856 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(42916), // Rule ID 23684 //
     /*  42861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  42880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  42884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42893 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42899 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  42901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42903 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src2, (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }))  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  42903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  42906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  42912 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  42914 */     GIR_RootConstrainSelectedInstOperands,
     /*  42915 */     // GIR_Coverage, 23684,
     /*  42915 */     GIR_EraseRootFromParent_Done,
     /*  42916 */   // Label 1023: @42916
     /*  42916 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(42951), // Rule ID 4411 //
     /*  42921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42932 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42938 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42942 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src, immAllOnesV:{ *:[v16i1] })  =>  (KNOTWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src)
     /*  42942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  42945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42947 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42949 */     GIR_RootConstrainSelectedInstOperands,
     /*  42950 */     // GIR_Coverage, 4411,
     /*  42950 */     GIR_EraseRootFromParent_Done,
     /*  42951 */   // Label 1024: @42951
     /*  42951 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(42974), // Rule ID 4427 //
     /*  42956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42967 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KXORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  42967 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  42972 */     GIR_RootConstrainSelectedInstOperands,
     /*  42973 */     // GIR_Coverage, 4427,
     /*  42973 */     GIR_Done,
     /*  42974 */   // Label 1025: @42974
     /*  42974 */   GIM_Reject,
     /*  42975 */ // Label 1020: @42975
     /*  42975 */ GIM_Reject,
     /*  42976 */ // Label 862: @42976
     /*  42976 */ GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(43595),
     /*  42981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  42984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  42987 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(43049), // Rule ID 25254 //
     /*  42992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  42995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  42999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43007 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43010 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43014 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43024 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43031 */     // (xor:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPXORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  43034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43036 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43038 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43047 */     GIR_RootConstrainSelectedInstOperands,
     /*  43048 */     // GIR_Coverage, 25254,
     /*  43048 */     GIR_EraseRootFromParent_Done,
     /*  43049 */   // Label 1027: @43049
     /*  43049 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(43111), // Rule ID 25433 //
     /*  43054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43069 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43072 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43076 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43093 */     // (xor:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPXORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  43096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43098 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43100 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43109 */     GIR_RootConstrainSelectedInstOperands,
     /*  43110 */     // GIR_Coverage, 25433,
     /*  43110 */     GIR_EraseRootFromParent_Done,
     /*  43111 */   // Label 1028: @43111
     /*  43111 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(43173), // Rule ID 18163 //
     /*  43116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  43119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43135 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43138 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43142 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43148 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43155 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  43158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43160 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43162 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43171 */     GIR_RootConstrainSelectedInstOperands,
     /*  43172 */     // GIR_Coverage, 18163,
     /*  43172 */     GIR_EraseRootFromParent_Done,
     /*  43173 */   // Label 1029: @43173
     /*  43173 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(43235), // Rule ID 20027 //
     /*  43178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43197 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43200 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43204 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43217 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  43220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43222 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43224 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43233 */     GIR_RootConstrainSelectedInstOperands,
     /*  43234 */     // GIR_Coverage, 20027,
     /*  43234 */     GIR_EraseRootFromParent_Done,
     /*  43235 */   // Label 1030: @43235
     /*  43235 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(43467), // Rule ID 21942 //
     /*  43240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  43243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  43247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43255 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43261 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  43263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43265 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, immAllOnesV:{ *:[v16i8] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  43265 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  43268 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43272 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  43279 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  43282 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43286 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43291 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  43294 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  43298 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  43301 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  43306 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43311 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  43316 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  43319 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43323 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  43330 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  43333 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43337 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43342 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  43345 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  43349 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  43352 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  43357 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43362 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  43367 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  43370 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43374 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43381 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  43384 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43388 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43393 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43396 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  43400 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  43403 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  43408 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43413 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  43418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  43421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  43425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43430 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43433 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  43436 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  43439 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  43442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43449 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  43456 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  43461 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43466 */     // GIR_Coverage, 21942,
     /*  43466 */     GIR_EraseRootFromParent_Done,
     /*  43467 */   // Label 1031: @43467
     /*  43467 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(43513), // Rule ID 21950 //
     /*  43472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43487 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43493 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  43495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43497 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, immAllOnesV:{ *:[v16i8] })  =>  (VPTERNLOGQZ128rri:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VR128X:{ *:[v16i8] }:$src, VR128X:{ *:[v16i8] }:$src, 15:{ *:[i8] })
     /*  43497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  43500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43502 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43504 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43506 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  43511 */     GIR_RootConstrainSelectedInstOperands,
     /*  43512 */     // GIR_Coverage, 21950,
     /*  43512 */     GIR_EraseRootFromParent_Done,
     /*  43513 */   // Label 1032: @43513
     /*  43513 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(43540), // Rule ID 18151 //
     /*  43518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  43521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43533 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPXORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  43533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  43538 */     GIR_RootConstrainSelectedInstOperands,
     /*  43539 */     // GIR_Coverage, 18151,
     /*  43539 */     GIR_Done,
     /*  43540 */   // Label 1033: @43540
     /*  43540 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(43567), // Rule ID 18175 //
     /*  43545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  43548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43560 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PXORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  43560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  43565 */     GIR_RootConstrainSelectedInstOperands,
     /*  43566 */     // GIR_Coverage, 18175,
     /*  43566 */     GIR_Done,
     /*  43567 */   // Label 1034: @43567
     /*  43567 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(43594), // Rule ID 20019 //
     /*  43572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43587 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPXORQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  43587 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /*  43592 */     GIR_RootConstrainSelectedInstOperands,
     /*  43593 */     // GIR_Coverage, 20019,
     /*  43593 */     GIR_Done,
     /*  43594 */   // Label 1035: @43594
     /*  43594 */   GIM_Reject,
     /*  43595 */ // Label 1026: @43595
     /*  43595 */ GIM_Reject,
     /*  43596 */ // Label 863: @43596
     /*  43596 */ GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(44339),
     /*  43601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  43604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  43607 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(43669), // Rule ID 25234 //
     /*  43612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  43615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43627 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43630 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43634 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43651 */     // (xor:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPXORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  43654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43656 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43658 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43667 */     GIR_RootConstrainSelectedInstOperands,
     /*  43668 */     // GIR_Coverage, 25234,
     /*  43668 */     GIR_EraseRootFromParent_Done,
     /*  43669 */   // Label 1037: @43669
     /*  43669 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(43731), // Rule ID 25245 //
     /*  43674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  43677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43689 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43692 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43696 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43713 */     // (xor:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VXORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  43716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43718 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43720 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43729 */     GIR_RootConstrainSelectedInstOperands,
     /*  43730 */     // GIR_Coverage, 25245,
     /*  43730 */     GIR_EraseRootFromParent_Done,
     /*  43731 */   // Label 1038: @43731
     /*  43731 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(43793), // Rule ID 25440 //
     /*  43736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  43743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43751 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43754 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43758 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  43766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43768 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43775 */     // (xor:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPXORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  43778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43780 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43782 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43791 */     GIR_RootConstrainSelectedInstOperands,
     /*  43792 */     // GIR_Coverage, 25440,
     /*  43792 */     GIR_EraseRootFromParent_Done,
     /*  43793 */   // Label 1039: @43793
     /*  43793 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(43855), // Rule ID 18108 //
     /*  43798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  43801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43817 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43820 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43824 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43830 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43837 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  43840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43842 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43844 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43853 */     GIR_RootConstrainSelectedInstOperands,
     /*  43854 */     // GIR_Coverage, 18108,
     /*  43854 */     GIR_EraseRootFromParent_Done,
     /*  43855 */   // Label 1040: @43855
     /*  43855 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(43917), // Rule ID 18138 //
     /*  43860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  43863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43879 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43882 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43886 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43899 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  43902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43904 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43906 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43915 */     GIR_RootConstrainSelectedInstOperands,
     /*  43916 */     // GIR_Coverage, 18138,
     /*  43916 */     GIR_EraseRootFromParent_Done,
     /*  43917 */   // Label 1041: @43917
     /*  43917 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(43979), // Rule ID 20044 //
     /*  43922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  43929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  43933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43941 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43944 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43948 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43954 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43961 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  43964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43966 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43968 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43977 */     GIR_RootConstrainSelectedInstOperands,
     /*  43978 */     // GIR_Coverage, 20044,
     /*  43978 */     GIR_EraseRootFromParent_Done,
     /*  43979 */   // Label 1042: @43979
     /*  43979 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(44211), // Rule ID 21947 //
     /*  43984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  43987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  43991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  43995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43999 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44005 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44009 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, immAllOnesV:{ *:[v16i16] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  44009 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  44012 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44016 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  44023 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  44026 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  44030 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44035 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  44038 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  44042 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  44045 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  44050 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44055 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44060 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  44063 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44067 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  44074 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  44077 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  44081 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44086 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  44089 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  44093 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  44096 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  44101 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44106 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44111 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  44114 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44118 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  44125 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  44128 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  44132 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44137 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  44140 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  44144 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  44147 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  44152 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44157 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  44165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  44169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44174 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44177 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  44180 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  44183 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  44186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44193 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  44200 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44205 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44210 */     // GIR_Coverage, 21947,
     /*  44210 */     GIR_EraseRootFromParent_Done,
     /*  44211 */   // Label 1043: @44211
     /*  44211 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(44257), // Rule ID 21955 //
     /*  44216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  44219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44231 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44237 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44241 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, immAllOnesV:{ *:[v16i16] })  =>  (VPTERNLOGQZ256rri:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VR256X:{ *:[v16i16] }:$src, VR256X:{ *:[v16i16] }:$src, 15:{ *:[i8] })
     /*  44241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  44244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44246 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44248 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44250 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  44255 */     GIR_RootConstrainSelectedInstOperands,
     /*  44256 */     // GIR_Coverage, 21955,
     /*  44256 */     GIR_EraseRootFromParent_Done,
     /*  44257 */   // Label 1044: @44257
     /*  44257 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(44284), // Rule ID 18096 //
     /*  44262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  44265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44277 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPXORYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  44277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  44282 */     GIR_RootConstrainSelectedInstOperands,
     /*  44283 */     // GIR_Coverage, 18096,
     /*  44283 */     GIR_Done,
     /*  44284 */   // Label 1045: @44284
     /*  44284 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(44311), // Rule ID 18122 //
     /*  44289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  44292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44304 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VXORPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  44304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  44309 */     GIR_RootConstrainSelectedInstOperands,
     /*  44310 */     // GIR_Coverage, 18122,
     /*  44310 */     GIR_Done,
     /*  44311 */   // Label 1046: @44311
     /*  44311 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(44338), // Rule ID 20036 //
     /*  44316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  44319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44331 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPXORQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  44331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /*  44336 */     GIR_RootConstrainSelectedInstOperands,
     /*  44337 */     // GIR_Coverage, 20036,
     /*  44337 */     GIR_Done,
     /*  44338 */   // Label 1047: @44338
     /*  44338 */   GIM_Reject,
     /*  44339 */ // Label 1036: @44339
     /*  44339 */ GIM_Reject,
     /*  44340 */ // Label 864: @44340
     /*  44340 */ GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(44537),
     /*  44345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  44348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  44351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44355 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(44413), // Rule ID 24224 //
     /*  44360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44371 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44374 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44378 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44395 */     // (xor:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPXORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZrm),
     /*  44398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44400 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  44402 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44411 */     GIR_RootConstrainSelectedInstOperands,
     /*  44412 */     // GIR_Coverage, 24224,
     /*  44412 */     GIR_EraseRootFromParent_Done,
     /*  44413 */   // Label 1049: @44413
     /*  44413 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(44471), // Rule ID 5823 //
     /*  44418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44433 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44436 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44440 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44446 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44453 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZrm),
     /*  44456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44458 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  44460 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44469 */     GIR_RootConstrainSelectedInstOperands,
     /*  44470 */     // GIR_Coverage, 5823,
     /*  44470 */     GIR_EraseRootFromParent_Done,
     /*  44471 */   // Label 1050: @44471
     /*  44471 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(44513), // Rule ID 21940 //
     /*  44476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44487 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44493 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44497 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, immAllOnesV:{ *:[v16i32] })  =>  (VPTERNLOGQZrri:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VR512:{ *:[v16i32] }:$src, VR512:{ *:[v16i32] }:$src, 15:{ *:[i8] })
     /*  44497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  44500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44502 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44504 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44506 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  44511 */     GIR_RootConstrainSelectedInstOperands,
     /*  44512 */     // GIR_Coverage, 21940,
     /*  44512 */     GIR_EraseRootFromParent_Done,
     /*  44513 */   // Label 1051: @44513
     /*  44513 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(44536), // Rule ID 5820 //
     /*  44518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44529 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPXORDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  44529 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZrr),
     /*  44534 */     GIR_RootConstrainSelectedInstOperands,
     /*  44535 */     // GIR_Coverage, 5820,
     /*  44535 */     GIR_Done,
     /*  44536 */   // Label 1052: @44536
     /*  44536 */   GIM_Reject,
     /*  44537 */ // Label 1048: @44537
     /*  44537 */ GIM_Reject,
     /*  44538 */ // Label 865: @44538
     /*  44538 */ GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(44795),
     /*  44543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44553 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(44613), // Rule ID 23685 //
     /*  44558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44586 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44592 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  44594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44600 */     // (xor:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }), VK32:{ *:[v32i1] }:$src2)  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /*  44603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  44609 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  44611 */     GIR_RootConstrainSelectedInstOperands,
     /*  44612 */     // GIR_Coverage, 23685,
     /*  44612 */     GIR_EraseRootFromParent_Done,
     /*  44613 */   // Label 1054: @44613
     /*  44613 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(44676), // Rule ID 4424 //
     /*  44618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44651 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44657 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  44659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44661 */     // (xor:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2), immAllOnesV:{ *:[v32i1] })  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /*  44664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  44670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  44674 */     GIR_RootConstrainSelectedInstOperands,
     /*  44675 */     // GIR_Coverage, 4424,
     /*  44675 */     GIR_EraseRootFromParent_Done,
     /*  44676 */   // Label 1055: @44676
     /*  44676 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(44736), // Rule ID 23686 //
     /*  44681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44713 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44719 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  44721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44723 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src2, (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }))  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /*  44726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  44732 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  44734 */     GIR_RootConstrainSelectedInstOperands,
     /*  44735 */     // GIR_Coverage, 23686,
     /*  44735 */     GIR_EraseRootFromParent_Done,
     /*  44736 */   // Label 1056: @44736
     /*  44736 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(44771), // Rule ID 4412 //
     /*  44741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44752 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44758 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44762 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src, immAllOnesV:{ *:[v32i1] })  =>  (KNOTDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src)
     /*  44762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTDkk),
     /*  44765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44767 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44769 */     GIR_RootConstrainSelectedInstOperands,
     /*  44770 */     // GIR_Coverage, 4412,
     /*  44770 */     GIR_EraseRootFromParent_Done,
     /*  44771 */   // Label 1057: @44771
     /*  44771 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(44794), // Rule ID 4428 //
     /*  44776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44787 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KXORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORDkk),
     /*  44792 */     GIR_RootConstrainSelectedInstOperands,
     /*  44793 */     // GIR_Coverage, 4428,
     /*  44793 */     GIR_Done,
     /*  44794 */   // Label 1058: @44794
     /*  44794 */   GIM_Reject,
     /*  44795 */ // Label 1053: @44795
     /*  44795 */ GIM_Reject,
     /*  44796 */ // Label 866: @44796
     /*  44796 */ GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(45539),
     /*  44801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  44804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  44807 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(44869), // Rule ID 25233 //
     /*  44812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  44815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44827 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44830 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44834 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44851 */     // (xor:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPXORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  44854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44856 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  44858 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44867 */     GIR_RootConstrainSelectedInstOperands,
     /*  44868 */     // GIR_Coverage, 25233,
     /*  44868 */     GIR_EraseRootFromParent_Done,
     /*  44869 */   // Label 1060: @44869
     /*  44869 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(44931), // Rule ID 25244 //
     /*  44874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  44877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44889 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44892 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44896 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44906 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44913 */     // (xor:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VXORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  44916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44918 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  44920 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44929 */     GIR_RootConstrainSelectedInstOperands,
     /*  44930 */     // GIR_Coverage, 25244,
     /*  44930 */     GIR_EraseRootFromParent_Done,
     /*  44931 */   // Label 1061: @44931
     /*  44931 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(44993), // Rule ID 25439 //
     /*  44936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  44939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44951 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44954 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44958 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44968 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44975 */     // (xor:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPXORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  44978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44980 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  44982 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44991 */     GIR_RootConstrainSelectedInstOperands,
     /*  44992 */     // GIR_Coverage, 25439,
     /*  44992 */     GIR_EraseRootFromParent_Done,
     /*  44993 */   // Label 1062: @44993
     /*  44993 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(45055), // Rule ID 18107 //
     /*  44998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  45001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45017 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45020 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45024 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45030 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45037 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  45040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45042 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45044 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45053 */     GIR_RootConstrainSelectedInstOperands,
     /*  45054 */     // GIR_Coverage, 18107,
     /*  45054 */     GIR_EraseRootFromParent_Done,
     /*  45055 */   // Label 1063: @45055
     /*  45055 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(45117), // Rule ID 18137 //
     /*  45060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  45063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45079 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45082 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45086 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45099 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  45102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45104 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45106 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45115 */     GIR_RootConstrainSelectedInstOperands,
     /*  45116 */     // GIR_Coverage, 18137,
     /*  45116 */     GIR_EraseRootFromParent_Done,
     /*  45117 */   // Label 1064: @45117
     /*  45117 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(45179), // Rule ID 20043 //
     /*  45122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45141 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45144 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45148 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45161 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  45164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45166 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45168 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45177 */     GIR_RootConstrainSelectedInstOperands,
     /*  45178 */     // GIR_Coverage, 20043,
     /*  45178 */     GIR_EraseRootFromParent_Done,
     /*  45179 */   // Label 1065: @45179
     /*  45179 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(45411), // Rule ID 21946 //
     /*  45184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  45187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45199 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45205 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45209 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, immAllOnesV:{ *:[v32i8] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  45209 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  45212 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45216 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  45223 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  45226 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45230 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45235 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  45238 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  45242 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  45245 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  45250 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45255 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45260 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  45263 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45267 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  45274 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  45277 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45281 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45286 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  45289 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  45293 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  45296 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  45301 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45306 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45311 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  45314 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45318 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  45325 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  45328 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45332 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45337 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  45340 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  45344 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  45347 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  45352 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45357 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  45365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  45369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45374 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  45377 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  45380 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  45383 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  45386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45393 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  45400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45405 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45410 */     // GIR_Coverage, 21946,
     /*  45410 */     GIR_EraseRootFromParent_Done,
     /*  45411 */   // Label 1066: @45411
     /*  45411 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(45457), // Rule ID 21954 //
     /*  45416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45431 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45437 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45441 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, immAllOnesV:{ *:[v32i8] })  =>  (VPTERNLOGQZ256rri:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VR256X:{ *:[v32i8] }:$src, VR256X:{ *:[v32i8] }:$src, 15:{ *:[i8] })
     /*  45441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  45444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45446 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45448 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45450 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  45455 */     GIR_RootConstrainSelectedInstOperands,
     /*  45456 */     // GIR_Coverage, 21954,
     /*  45456 */     GIR_EraseRootFromParent_Done,
     /*  45457 */   // Label 1067: @45457
     /*  45457 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(45484), // Rule ID 18095 //
     /*  45462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  45465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45477 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPXORYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  45477 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  45482 */     GIR_RootConstrainSelectedInstOperands,
     /*  45483 */     // GIR_Coverage, 18095,
     /*  45483 */     GIR_Done,
     /*  45484 */   // Label 1068: @45484
     /*  45484 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(45511), // Rule ID 18121 //
     /*  45489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  45492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45504 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VXORPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  45504 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  45509 */     GIR_RootConstrainSelectedInstOperands,
     /*  45510 */     // GIR_Coverage, 18121,
     /*  45510 */     GIR_Done,
     /*  45511 */   // Label 1069: @45511
     /*  45511 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(45538), // Rule ID 20035 //
     /*  45516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45531 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPXORQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  45531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /*  45536 */     GIR_RootConstrainSelectedInstOperands,
     /*  45537 */     // GIR_Coverage, 20035,
     /*  45537 */     GIR_Done,
     /*  45538 */   // Label 1070: @45538
     /*  45538 */   GIM_Reject,
     /*  45539 */ // Label 1059: @45539
     /*  45539 */ GIM_Reject,
     /*  45540 */ // Label 867: @45540
     /*  45540 */ GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(45737),
     /*  45545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  45548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  45551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45555 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(45613), // Rule ID 25446 //
     /*  45560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45571 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45574 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45578 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45588 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45595 */     // (xor:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPXORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  45598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45600 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  45602 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45611 */     GIR_RootConstrainSelectedInstOperands,
     /*  45612 */     // GIR_Coverage, 25446,
     /*  45612 */     GIR_EraseRootFromParent_Done,
     /*  45613 */   // Label 1072: @45613
     /*  45613 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(45671), // Rule ID 20060 //
     /*  45618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45633 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45636 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45640 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45653 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  45656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45658 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45660 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45669 */     GIR_RootConstrainSelectedInstOperands,
     /*  45670 */     // GIR_Coverage, 20060,
     /*  45670 */     GIR_EraseRootFromParent_Done,
     /*  45671 */   // Label 1073: @45671
     /*  45671 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(45713), // Rule ID 21939 //
     /*  45676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45687 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45693 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45697 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, immAllOnesV:{ *:[v32i16] })  =>  (VPTERNLOGQZrri:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VR512:{ *:[v32i16] }:$src, VR512:{ *:[v32i16] }:$src, 15:{ *:[i8] })
     /*  45697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  45700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45702 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45704 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45706 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  45711 */     GIR_RootConstrainSelectedInstOperands,
     /*  45712 */     // GIR_Coverage, 21939,
     /*  45712 */     GIR_EraseRootFromParent_Done,
     /*  45713 */   // Label 1074: @45713
     /*  45713 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(45736), // Rule ID 20052 //
     /*  45718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45729 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPXORQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  45729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /*  45734 */     GIR_RootConstrainSelectedInstOperands,
     /*  45735 */     // GIR_Coverage, 20052,
     /*  45735 */     GIR_Done,
     /*  45736 */   // Label 1075: @45736
     /*  45736 */   GIM_Reject,
     /*  45737 */ // Label 1071: @45737
     /*  45737 */ GIM_Reject,
     /*  45738 */ // Label 868: @45738
     /*  45738 */ GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(45995),
     /*  45743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  45746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  45749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45753 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(45813), // Rule ID 23687 //
     /*  45758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  45761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  45773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  45777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45786 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45792 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  45794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45800 */     // (xor:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }), VK64:{ *:[v64i1] }:$src2)  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  45800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /*  45803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  45809 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  45811 */     GIR_RootConstrainSelectedInstOperands,
     /*  45812 */     // GIR_Coverage, 23687,
     /*  45812 */     GIR_EraseRootFromParent_Done,
     /*  45813 */   // Label 1077: @45813
     /*  45813 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(45876), // Rule ID 4425 //
     /*  45818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  45821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  45833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  45837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45851 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45857 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  45859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45861 */     // (xor:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2), immAllOnesV:{ *:[v64i1] })  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  45861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /*  45864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  45870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  45874 */     GIR_RootConstrainSelectedInstOperands,
     /*  45875 */     // GIR_Coverage, 4425,
     /*  45875 */     GIR_EraseRootFromParent_Done,
     /*  45876 */   // Label 1078: @45876
     /*  45876 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(45936), // Rule ID 23688 //
     /*  45881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  45884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  45900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  45904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45913 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45919 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  45921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45923 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src2, (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }))  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  45923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /*  45926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  45932 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  45934 */     GIR_RootConstrainSelectedInstOperands,
     /*  45935 */     // GIR_Coverage, 23688,
     /*  45935 */     GIR_EraseRootFromParent_Done,
     /*  45936 */   // Label 1079: @45936
     /*  45936 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(45971), // Rule ID 4413 //
     /*  45941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  45944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45952 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45958 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45962 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src, immAllOnesV:{ *:[v64i1] })  =>  (KNOTQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src)
     /*  45962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTQkk),
     /*  45965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45967 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45969 */     GIR_RootConstrainSelectedInstOperands,
     /*  45970 */     // GIR_Coverage, 4413,
     /*  45970 */     GIR_EraseRootFromParent_Done,
     /*  45971 */   // Label 1080: @45971
     /*  45971 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(45994), // Rule ID 4429 //
     /*  45976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  45979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45987 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KXORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  45987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORQkk),
     /*  45992 */     GIR_RootConstrainSelectedInstOperands,
     /*  45993 */     // GIR_Coverage, 4429,
     /*  45993 */     GIR_Done,
     /*  45994 */   // Label 1081: @45994
     /*  45994 */   GIM_Reject,
     /*  45995 */ // Label 1076: @45995
     /*  45995 */ GIM_Reject,
     /*  45996 */ // Label 869: @45996
     /*  45996 */ GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(46193),
     /*  46001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  46004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  46007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46011 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(46069), // Rule ID 25445 //
     /*  46016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  46027 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  46030 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  46034 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  46038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46044 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  46051 */     // (xor:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPXORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  46051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  46054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46056 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  46058 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  46062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  46067 */     GIR_RootConstrainSelectedInstOperands,
     /*  46068 */     // GIR_Coverage, 25445,
     /*  46068 */     GIR_EraseRootFromParent_Done,
     /*  46069 */   // Label 1083: @46069
     /*  46069 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(46127), // Rule ID 20059 //
     /*  46074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  46089 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  46092 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  46096 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  46100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  46109 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  46109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  46112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46114 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46116 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  46120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  46125 */     GIR_RootConstrainSelectedInstOperands,
     /*  46126 */     // GIR_Coverage, 20059,
     /*  46126 */     GIR_EraseRootFromParent_Done,
     /*  46127 */   // Label 1084: @46127
     /*  46127 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(46169), // Rule ID 21938 //
     /*  46132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46143 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46149 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  46151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46153 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, immAllOnesV:{ *:[v64i8] })  =>  (VPTERNLOGQZrri:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VR512:{ *:[v64i8] }:$src, VR512:{ *:[v64i8] }:$src, 15:{ *:[i8] })
     /*  46153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  46156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46158 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46160 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46162 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  46167 */     GIR_RootConstrainSelectedInstOperands,
     /*  46168 */     // GIR_Coverage, 21938,
     /*  46168 */     GIR_EraseRootFromParent_Done,
     /*  46169 */   // Label 1085: @46169
     /*  46169 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(46192), // Rule ID 20051 //
     /*  46174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46185 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPXORQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  46185 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /*  46190 */     GIR_RootConstrainSelectedInstOperands,
     /*  46191 */     // GIR_Coverage, 20051,
     /*  46191 */     GIR_Done,
     /*  46192 */   // Label 1086: @46192
     /*  46192 */   GIM_Reject,
     /*  46193 */ // Label 1082: @46193
     /*  46193 */ GIM_Reject,
     /*  46194 */ // Label 870: @46194
     /*  46194 */ GIM_Reject,
     /*  46195 */ // Label 6: @46195
     /*  46195 */ GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(46361),
     /*  46200 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  46203 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(16), GIMT_Encode2(24), /*)*//*default:*//*Label 1091*/ GIMT_Encode4(46360),
     /*  46214 */   /*GILLT_v16s1*//*Label 1088*/ GIMT_Encode4(46246), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46230 */   /*GILLT_v32s1*//*Label 1089*/ GIMT_Encode4(46284), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46242 */   /*GILLT_v64s1*//*Label 1090*/ GIMT_Encode4(46322),
     /*  46246 */   // Label 1088: @46246
     /*  46246 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(46283), // Rule ID 19502 //
     /*  46251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46254 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  46257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  46260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  46268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  46272 */     // (concat_vectors:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KUNPCKBWkk:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK8:{ *:[v8i1] }:$src1)
     /*  46272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKBWkk),
     /*  46275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46277 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46279 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46281 */     GIR_RootConstrainSelectedInstOperands,
     /*  46282 */     // GIR_Coverage, 19502,
     /*  46282 */     GIR_EraseRootFromParent_Done,
     /*  46283 */   // Label 1092: @46283
     /*  46283 */   GIM_Reject,
     /*  46284 */   // Label 1089: @46284
     /*  46284 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(46321), // Rule ID 19503 //
     /*  46289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46292 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  46295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  46298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  46302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46310 */     // (concat_vectors:{ *:[v32i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KUNPCKWDkk:{ *:[v32i1] } VK16:{ *:[v16i1] }:$src2, VK16:{ *:[v16i1] }:$src1)
     /*  46310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKWDkk),
     /*  46313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46315 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46317 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46319 */     GIR_RootConstrainSelectedInstOperands,
     /*  46320 */     // GIR_Coverage, 19503,
     /*  46320 */     GIR_EraseRootFromParent_Done,
     /*  46321 */   // Label 1093: @46321
     /*  46321 */   GIM_Reject,
     /*  46322 */   // Label 1090: @46322
     /*  46322 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(46359), // Rule ID 19504 //
     /*  46327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46330 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  46333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  46336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  46344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  46348 */     // (concat_vectors:{ *:[v64i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KUNPCKDQkk:{ *:[v64i1] } VK32:{ *:[v32i1] }:$src2, VK32:{ *:[v32i1] }:$src1)
     /*  46348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKDQkk),
     /*  46351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46353 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46355 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46357 */     GIR_RootConstrainSelectedInstOperands,
     /*  46358 */     // GIR_Coverage, 19504,
     /*  46358 */     GIR_EraseRootFromParent_Done,
     /*  46359 */   // Label 1094: @46359
     /*  46359 */   GIM_Reject,
     /*  46360 */   // Label 1091: @46360
     /*  46360 */   GIM_Reject,
     /*  46361 */ // Label 1087: @46361
     /*  46361 */ GIM_Reject,
     /*  46362 */ // Label 7: @46362
     /*  46362 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(24), /*)*//*default:*//*Label 1103*/ GIMT_Encode4(48627),
     /*  46373 */ /*GILLT_s8*//*Label 1095*/ GIMT_Encode4(46465),
     /*  46377 */ /*GILLT_s16*//*Label 1096*/ GIMT_Encode4(46526),
     /*  46381 */ /*GILLT_s32*//*Label 1097*/ GIMT_Encode4(47356),
     /*  46385 */ /*GILLT_s64*//*Label 1098*/ GIMT_Encode4(47770), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46417 */ /*GILLT_v8s1*//*Label 1099*/ GIMT_Encode4(48184), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46433 */ /*GILLT_v16s1*//*Label 1100*/ GIMT_Encode4(48345), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46449 */ /*GILLT_v32s1*//*Label 1101*/ GIMT_Encode4(48485), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46461 */ /*GILLT_v64s1*//*Label 1102*/ GIMT_Encode4(48556),
     /*  46465 */ // Label 1095: @46465
     /*  46465 */ GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(46525), // Rule ID 19433 //
     /*  46470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  46473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  46477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  46481 */   // (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } VK8:{ *:[v8i1] }:$src, GR32:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /*  46481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46493 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46497 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /*  46502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46507 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /*  46514 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  46519 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  46524 */   // GIR_Coverage, 19433,
     /*  46524 */   GIR_EraseRootFromParent_Done,
     /*  46525 */ // Label 1104: @46525
     /*  46525 */ GIM_Reject,
     /*  46526 */ // Label 1096: @46526
     /*  46526 */ GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(46586), // Rule ID 19430 //
     /*  46531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  46534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46542 */   // (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /*  46542 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46545 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46549 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46554 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46558 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /*  46563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46568 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  46575 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  46580 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  46585 */   // GIR_Coverage, 19430,
     /*  46585 */   GIR_EraseRootFromParent_Done,
     /*  46586 */ // Label 1105: @46586
     /*  46586 */ GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(46687), // Rule ID 22139 //
     /*  46591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  46594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  46601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46605 */   // (bitconvert:{ *:[f16] } GR16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VMOVW2SHrr:{ *:[f128] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] })), FR16X:{ *:[i32] })
     /*  46605 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  46608 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46612 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46617 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46619 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  46622 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46626 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46631 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46634 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46638 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/4,
     /*  46641 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  46646 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  46651 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  46656 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  46659 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVW2SHrr),
     /*  46663 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46668 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46671 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46678 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  46681 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  46686 */   // GIR_Coverage, 22139,
     /*  46686 */   GIR_EraseRootFromParent_Done,
     /*  46687 */ // Label 1106: @46687
     /*  46687 */ GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(46767), // Rule ID 22152 //
     /*  46692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  46695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  46706 */   // (bitconvert:{ *:[i16] } FR16X:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VMOVSH2Wrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[f128] } FR16X:{ *:[f16] }:$src, VR128X:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /*  46706 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  46709 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46713 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46718 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46722 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128XRegClassID),
     /*  46727 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46730 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSH2Wrr),
     /*  46734 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46739 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46742 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46749 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  46756 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  46761 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  46766 */   // GIR_Coverage, 22152,
     /*  46766 */   GIR_EraseRootFromParent_Done,
     /*  46767 */ // Label 1107: @46767
     /*  46767 */ GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(46846), // Rule ID 18339 //
     /*  46772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  46775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46782 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VPEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /*  46782 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46785 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46789 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46794 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46798 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  46803 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46806 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPEXTRWrri),
     /*  46810 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46815 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46818 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  46821 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46828 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  46835 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  46840 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  46845 */   // GIR_Coverage, 18339,
     /*  46845 */   GIR_EraseRootFromParent_Done,
     /*  46846 */ // Label 1108: @46846
     /*  46846 */ GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(46963), // Rule ID 18340 //
     /*  46851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  46854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  46861 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  46861 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  46864 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46868 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  46875 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  46878 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46882 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46887 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  46890 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46894 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /*  46897 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  46902 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  46907 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  46912 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46915 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46919 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46924 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  46926 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  46929 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWrri),
     /*  46933 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46938 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46941 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  46944 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  46947 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46954 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  46957 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  46962 */   // GIR_Coverage, 18340,
     /*  46962 */   GIR_EraseRootFromParent_Done,
     /*  46963 */ // Label 1109: @46963
     /*  46963 */ GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(47042), // Rule ID 18336 //
     /*  46968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  46971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46978 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (PEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /*  46978 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46981 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46985 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46990 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46994 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  46999 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47002 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PEXTRWrri),
     /*  47006 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47011 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47014 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47024 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  47031 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  47036 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  47041 */   // GIR_Coverage, 18336,
     /*  47041 */   GIR_EraseRootFromParent_Done,
     /*  47042 */ // Label 1110: @47042
     /*  47042 */ GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(47159), // Rule ID 18337 //
     /*  47047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  47057 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (PINSRWrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  47057 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47060 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47064 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  47071 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47074 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47078 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47083 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  47086 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47090 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /*  47093 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47098 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47103 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  47108 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47111 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47115 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47120 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  47122 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  47125 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PINSRWrri),
     /*  47129 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47134 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47137 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47140 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47150 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47153 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  47158 */   // GIR_Coverage, 18337,
     /*  47158 */   GIR_EraseRootFromParent_Done,
     /*  47159 */ // Label 1111: @47159
     /*  47159 */ GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(47238), // Rule ID 21840 //
     /*  47164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  47167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  47174 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VPEXTRWZrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16X:{ *:[f16] }:$src, VR128X:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /*  47174 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47177 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47181 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47186 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47190 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128XRegClassID),
     /*  47195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPEXTRWZrri),
     /*  47202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47207 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47210 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47220 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  47227 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  47232 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  47237 */   // GIR_Coverage, 21840,
     /*  47237 */   GIR_EraseRootFromParent_Done,
     /*  47238 */ // Label 1112: @47238
     /*  47238 */ GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(47355), // Rule ID 21841 //
     /*  47243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  47246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  47253 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWZrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16X:{ *:[i32] })
     /*  47253 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47256 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47260 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  47267 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47270 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47274 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47279 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  47282 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47286 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /*  47289 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47294 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47299 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  47304 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47307 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47311 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  47318 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  47321 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWZrri),
     /*  47325 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47330 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47333 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47336 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47346 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47349 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  47354 */   // GIR_Coverage, 21841,
     /*  47354 */   GIR_EraseRootFromParent_Done,
     /*  47355 */ // Label 1113: @47355
     /*  47355 */ GIM_Reject,
     /*  47356 */ // Label 1097: @47356
     /*  47356 */ GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(47418), // Rule ID 22524 //
     /*  47361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  47364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47371 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47375 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47379 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47382 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  47389 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47393 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47395 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47402 */   // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_32>>)  =>  (MOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  47402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSrm_alt),
     /*  47405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47407 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47411 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47416 */   GIR_RootConstrainSelectedInstOperands,
     /*  47417 */   // GIR_Coverage, 22524,
     /*  47417 */   GIR_EraseRootFromParent_Done,
     /*  47418 */ // Label 1114: @47418
     /*  47418 */ GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(47480), // Rule ID 22525 //
     /*  47423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47433 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47437 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47441 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47444 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  47451 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47455 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47457 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47464 */   // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_32>>)  =>  (VMOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  47464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSrm_alt),
     /*  47467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47469 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47473 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47478 */   GIR_RootConstrainSelectedInstOperands,
     /*  47479 */   // GIR_Coverage, 22525,
     /*  47479 */   GIR_EraseRootFromParent_Done,
     /*  47480 */ // Label 1115: @47480
     /*  47480 */ GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(47542), // Rule ID 22526 //
     /*  47485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47495 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47499 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47503 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47506 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  47513 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47517 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47519 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47526 */   // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_32>>)  =>  (VMOVSSZrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  47526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZrm_alt),
     /*  47529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47531 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47535 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47540 */   GIR_RootConstrainSelectedInstOperands,
     /*  47541 */   // GIR_Coverage, 22526,
     /*  47541 */   GIR_EraseRootFromParent_Done,
     /*  47542 */ // Label 1116: @47542
     /*  47542 */ GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(47568), // Rule ID 2914 //
     /*  47547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47561 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VMOVDI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /*  47561 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSrr),
     /*  47566 */   GIR_RootConstrainSelectedInstOperands,
     /*  47567 */   // GIR_Coverage, 2914,
     /*  47567 */   GIR_Done,
     /*  47568 */ // Label 1117: @47568
     /*  47568 */ GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(47594), // Rule ID 2915 //
     /*  47573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47587 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (MOVDI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /*  47587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVDI2SSrr),
     /*  47592 */   GIR_RootConstrainSelectedInstOperands,
     /*  47593 */   // GIR_Coverage, 2915,
     /*  47593 */   GIR_Done,
     /*  47594 */ // Label 1118: @47594
     /*  47594 */ GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(47620), // Rule ID 2924 //
     /*  47599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47613 */   // (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VMOVSS2DIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  47613 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIrr),
     /*  47618 */   GIR_RootConstrainSelectedInstOperands,
     /*  47619 */   // GIR_Coverage, 2924,
     /*  47619 */   GIR_Done,
     /*  47620 */ // Label 1119: @47620
     /*  47620 */ GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(47646), // Rule ID 2925 //
     /*  47625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47639 */   // (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (MOVSS2DIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  47639 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSS2DIrr),
     /*  47644 */   GIR_RootConstrainSelectedInstOperands,
     /*  47645 */   // GIR_Coverage, 2925,
     /*  47645 */   GIR_Done,
     /*  47646 */ // Label 1120: @47646
     /*  47646 */ GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(47672), // Rule ID 4597 //
     /*  47651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47665 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VMOVDI2SSZrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /*  47665 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSZrr),
     /*  47670 */   GIR_RootConstrainSelectedInstOperands,
     /*  47671 */   // GIR_Coverage, 4597,
     /*  47671 */   GIR_Done,
     /*  47672 */ // Label 1121: @47672
     /*  47672 */ GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(47698), // Rule ID 4602 //
     /*  47677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47691 */   // (bitconvert:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VMOVSS2DIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /*  47691 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIZrr),
     /*  47696 */   GIR_RootConstrainSelectedInstOperands,
     /*  47697 */   // GIR_Coverage, 4602,
     /*  47697 */   GIR_Done,
     /*  47698 */ // Label 1122: @47698
     /*  47698 */ GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(47725), // Rule ID 19441 //
     /*  47703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  47706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  47714 */   // (bitconvert:{ *:[i32] } VK32:{ *:[v32i1] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK32:{ *:[v32i1] }:$src, GR32:{ *:[i32] })
     /*  47714 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47719 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /*  47724 */   // GIR_Coverage, 19441,
     /*  47724 */   GIR_Done,
     /*  47725 */ // Label 1123: @47725
     /*  47725 */ GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(47769), // Rule ID 19875 //
     /*  47730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  47733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  47741 */   // (bitconvert:{ *:[f32] } VK32:{ *:[v32i1] }:$src)  =>  (VMOVDI2SSZrr:{ *:[f32] } (KMOVDrk:{ *:[i32] } VK32:{ *:[v32i1] }:$src))
     /*  47741 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47744 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVDrk),
     /*  47748 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47753 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47757 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSZrr),
     /*  47762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47764 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47767 */   GIR_RootConstrainSelectedInstOperands,
     /*  47768 */   // GIR_Coverage, 19875,
     /*  47768 */   GIR_EraseRootFromParent_Done,
     /*  47769 */ // Label 1124: @47769
     /*  47769 */ GIM_Reject,
     /*  47770 */ // Label 1098: @47770
     /*  47770 */ GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(47832), // Rule ID 22527 //
     /*  47775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  47781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  47785 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47789 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47793 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47796 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  47803 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47807 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47809 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47816 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_64>>)  =>  (MOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  47816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDrm_alt),
     /*  47819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47821 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47825 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47830 */   GIR_RootConstrainSelectedInstOperands,
     /*  47831 */   // GIR_Coverage, 22527,
     /*  47831 */   GIR_EraseRootFromParent_Done,
     /*  47832 */ // Label 1125: @47832
     /*  47832 */ GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(47894), // Rule ID 22528 //
     /*  47837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  47843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  47847 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47851 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47855 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47858 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  47865 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47869 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47871 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47878 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_64>>)  =>  (VMOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  47878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDrm_alt),
     /*  47881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47883 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47887 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47892 */   GIR_RootConstrainSelectedInstOperands,
     /*  47893 */   // GIR_Coverage, 22528,
     /*  47893 */   GIR_EraseRootFromParent_Done,
     /*  47894 */ // Label 1126: @47894
     /*  47894 */ GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(47956), // Rule ID 22529 //
     /*  47899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  47905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  47909 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47913 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47917 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47920 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  47927 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47931 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47933 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47940 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_64>>)  =>  (VMOVSDZrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  47940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDZrm_alt),
     /*  47943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47945 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47949 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47954 */   GIR_RootConstrainSelectedInstOperands,
     /*  47955 */   // GIR_Coverage, 22529,
     /*  47955 */   GIR_EraseRootFromParent_Done,
     /*  47956 */ // Label 1127: @47956
     /*  47956 */ GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(47982), // Rule ID 2909 //
     /*  47961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  47967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  47971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  47975 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VMOV64toSDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /*  47975 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDrr),
     /*  47980 */   GIR_RootConstrainSelectedInstOperands,
     /*  47981 */   // GIR_Coverage, 2909,
     /*  47981 */   GIR_Done,
     /*  47982 */ // Label 1128: @47982
     /*  47982 */ GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(48008), // Rule ID 2913 //
     /*  47987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  47993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  47997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48001 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (MOV64toSDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /*  48001 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOV64toSDrr),
     /*  48006 */   GIR_RootConstrainSelectedInstOperands,
     /*  48007 */   // GIR_Coverage, 2913,
     /*  48007 */   GIR_Done,
     /*  48008 */ // Label 1129: @48008
     /*  48008 */ GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(48034), // Rule ID 2922 //
     /*  48013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  48016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48027 */   // (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VMOVSDto64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  48027 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64rr),
     /*  48032 */   GIR_RootConstrainSelectedInstOperands,
     /*  48033 */   // GIR_Coverage, 2922,
     /*  48033 */   GIR_Done,
     /*  48034 */ // Label 1130: @48034
     /*  48034 */ GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(48060), // Rule ID 2923 //
     /*  48039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  48042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48053 */   // (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (MOVSDto64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  48053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSDto64rr),
     /*  48058 */   GIR_RootConstrainSelectedInstOperands,
     /*  48059 */   // GIR_Coverage, 2923,
     /*  48059 */   GIR_Done,
     /*  48060 */ // Label 1131: @48060
     /*  48060 */ GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(48086), // Rule ID 4595 //
     /*  48065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48079 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VMOV64toSDZrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /*  48079 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDZrr),
     /*  48084 */   GIR_RootConstrainSelectedInstOperands,
     /*  48085 */   // GIR_Coverage, 4595,
     /*  48085 */   GIR_Done,
     /*  48086 */ // Label 1132: @48086
     /*  48086 */ GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(48112), // Rule ID 4596 //
     /*  48091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48105 */   // (bitconvert:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VMOVSDto64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /*  48105 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64Zrr),
     /*  48110 */   GIR_RootConstrainSelectedInstOperands,
     /*  48111 */   // GIR_Coverage, 4596,
     /*  48111 */   GIR_Done,
     /*  48112 */ // Label 1133: @48112
     /*  48112 */ GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(48139), // Rule ID 19443 //
     /*  48117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  48120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  48128 */   // (bitconvert:{ *:[i64] } VK64:{ *:[v64i1] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i64] } VK64:{ *:[v64i1] }:$src, GR64:{ *:[i32] })
     /*  48128 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48133 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  48138 */   // GIR_Coverage, 19443,
     /*  48138 */   GIR_Done,
     /*  48139 */ // Label 1134: @48139
     /*  48139 */ GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(48183), // Rule ID 19877 //
     /*  48144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  48147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  48155 */   // (bitconvert:{ *:[f64] } VK64:{ *:[v64i1] }:$src)  =>  (VMOV64toSDZrr:{ *:[f64] } (KMOVQrk:{ *:[i64] } VK64:{ *:[v64i1] }:$src))
     /*  48155 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  48158 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVQrk),
     /*  48162 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48167 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48171 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDZrr),
     /*  48176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48178 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48181 */   GIR_RootConstrainSelectedInstOperands,
     /*  48182 */   // GIR_Coverage, 19877,
     /*  48182 */   GIR_EraseRootFromParent_Done,
     /*  48183 */ // Label 1135: @48183
     /*  48183 */ GIM_Reject,
     /*  48184 */ // Label 1099: @48184
     /*  48184 */ GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(48344),
     /*  48189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  48192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  48196 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(48269), // Rule ID 19447 //
     /*  48201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48212 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48215 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48219 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48232 */     // (bitconvert:{ *:[v8i1] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), VK8:{ *:[i32] })
     /*  48232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  48239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48244 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  48248 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  48268 */     // GIR_Coverage, 19447,
     /*  48268 */     GIR_EraseRootFromParent_Done,
     /*  48269 */   // Label 1137: @48269
     /*  48269 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(48343), // Rule ID 19432 //
     /*  48274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  48278 */     // (bitconvert:{ *:[v8i1] } GR8:{ *:[i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src, sub_8bit:{ *:[i32] }), VK8:{ *:[i32] })
     /*  48278 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48281 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  48285 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  48292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  48299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48304 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  48307 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48311 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  48314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  48319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  48324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  48329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  48342 */     // GIR_Coverage, 19432,
     /*  48342 */     GIR_EraseRootFromParent_Done,
     /*  48343 */   // Label 1138: @48343
     /*  48343 */   GIM_Reject,
     /*  48344 */ // Label 1136: @48344
     /*  48344 */ GIM_Reject,
     /*  48345 */ // Label 1100: @48345
     /*  48345 */ GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(48484),
     /*  48350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  48353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  48357 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(48409), // Rule ID 19448 //
     /*  48362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48373 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48376 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48380 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  48384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48393 */     // (bitconvert:{ *:[v16i1] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (KMOVWkm:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)
     /*  48393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWkm),
     /*  48396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48398 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48407 */     GIR_RootConstrainSelectedInstOperands,
     /*  48408 */     // GIR_Coverage, 19448,
     /*  48408 */     GIR_EraseRootFromParent_Done,
     /*  48409 */   // Label 1140: @48409
     /*  48409 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(48483), // Rule ID 19429 //
     /*  48414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  48418 */     // (bitconvert:{ *:[v16i1] } GR16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), VK16:{ *:[i32] })
     /*  48418 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48421 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  48425 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  48432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  48439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48444 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  48447 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48451 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/4,
     /*  48454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  48459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  48464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  48469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  48482 */     // GIR_Coverage, 19429,
     /*  48482 */     GIR_EraseRootFromParent_Done,
     /*  48483 */   // Label 1141: @48483
     /*  48483 */   GIM_Reject,
     /*  48484 */ // Label 1139: @48484
     /*  48484 */ GIM_Reject,
     /*  48485 */ // Label 1101: @48485
     /*  48485 */ GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(48555),
     /*  48490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  48493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  48497 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(48517), // Rule ID 19440 //
     /*  48502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  48506 */     // (bitconvert:{ *:[v32i1] } GR32:{ *:[i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } GR32:{ *:[i32] }:$src, VK32:{ *:[i32] })
     /*  48506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48511 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /*  48516 */     // GIR_Coverage, 19440,
     /*  48516 */     GIR_Done,
     /*  48517 */   // Label 1143: @48517
     /*  48517 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(48554), // Rule ID 19874 //
     /*  48522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  48526 */     // (bitconvert:{ *:[v32i1] } FR32X:{ *:[f32] }:$src)  =>  (KMOVDkr:{ *:[v32i1] } (VMOVSS2DIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src))
     /*  48526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIZrr),
     /*  48533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDkr),
     /*  48547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48552 */     GIR_RootConstrainSelectedInstOperands,
     /*  48553 */     // GIR_Coverage, 19874,
     /*  48553 */     GIR_EraseRootFromParent_Done,
     /*  48554 */   // Label 1144: @48554
     /*  48554 */   GIM_Reject,
     /*  48555 */ // Label 1142: @48555
     /*  48555 */ GIM_Reject,
     /*  48556 */ // Label 1102: @48556
     /*  48556 */ GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(48626),
     /*  48561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  48568 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(48588), // Rule ID 19442 //
     /*  48573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48577 */     // (bitconvert:{ *:[v64i1] } GR64:{ *:[i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v64i1] } GR64:{ *:[i64] }:$src, VK64:{ *:[i32] })
     /*  48577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48582 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK64RegClassID),
     /*  48587 */     // GIR_Coverage, 19442,
     /*  48587 */     GIR_Done,
     /*  48588 */   // Label 1146: @48588
     /*  48588 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(48625), // Rule ID 19876 //
     /*  48593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48597 */     // (bitconvert:{ *:[v64i1] } FR64X:{ *:[f64] }:$src)  =>  (KMOVQkr:{ *:[v64i1] } (VMOVSDto64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src))
     /*  48597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  48600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64Zrr),
     /*  48604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48609 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQkr),
     /*  48618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48623 */     GIR_RootConstrainSelectedInstOperands,
     /*  48624 */     // GIR_Coverage, 19876,
     /*  48624 */     GIR_EraseRootFromParent_Done,
     /*  48625 */   // Label 1147: @48625
     /*  48625 */   GIM_Reject,
     /*  48626 */ // Label 1145: @48626
     /*  48626 */ GIM_Reject,
     /*  48627 */ // Label 1103: @48627
     /*  48627 */ GIM_Reject,
     /*  48628 */ // Label 8: @48628
     /*  48628 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 1160*/ GIMT_Encode4(51805),
     /*  48639 */ /*GILLT_s16*//*Label 1148*/ GIMT_Encode4(48723),
     /*  48643 */ /*GILLT_s32*//*Label 1149*/ GIMT_Encode4(48784),
     /*  48647 */ /*GILLT_s64*//*Label 1150*/ GIMT_Encode4(49408), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48663 */ /*GILLT_v2s64*//*Label 1151*/ GIMT_Encode4(50032), GIMT_Encode4(0),
     /*  48671 */ /*GILLT_v4s32*//*Label 1152*/ GIMT_Encode4(50121),
     /*  48675 */ /*GILLT_v4s64*//*Label 1153*/ GIMT_Encode4(50567), GIMT_Encode4(0),
     /*  48683 */ /*GILLT_v8s16*//*Label 1154*/ GIMT_Encode4(50746),
     /*  48687 */ /*GILLT_v8s32*//*Label 1155*/ GIMT_Encode4(50835),
     /*  48691 */ /*GILLT_v8s64*//*Label 1156*/ GIMT_Encode4(51186), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48703 */ /*GILLT_v16s16*//*Label 1157*/ GIMT_Encode4(51454),
     /*  48707 */ /*GILLT_v16s32*//*Label 1158*/ GIMT_Encode4(51543), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48719 */ /*GILLT_v32s16*//*Label 1159*/ GIMT_Encode4(51716),
     /*  48723 */ // Label 1148: @48723
     /*  48723 */ GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(48783), // Rule ID 22168 //
     /*  48728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  48731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  48734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  48738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  48742 */   // (lrint:{ *:[i16] } FR16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VCVTTSH2SIZrr:{ *:[i32] } FR16:{ *:[f16] }:$src), sub_16bit:{ *:[i32] })
     /*  48742 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48745 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /*  48749 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48754 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48765 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  48772 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  48777 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  48782 */   // GIR_Coverage, 22168,
     /*  48782 */   GIR_EraseRootFromParent_Done,
     /*  48783 */ // Label 1161: @48783
     /*  48783 */ GIM_Reject,
     /*  48784 */ // Label 1149: @48784
     /*  48784 */ GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(48843), // Rule ID 1755 //
     /*  48789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  48792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  48795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  48799 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48803 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48807 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48810 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48814 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48818 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48820 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48827 */   // (lrint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  48827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIrm),
     /*  48830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48832 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48836 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48841 */   GIR_RootConstrainSelectedInstOperands,
     /*  48842 */   // GIR_Coverage, 1755,
     /*  48842 */   GIR_EraseRootFromParent_Done,
     /*  48843 */ // Label 1162: @48843
     /*  48843 */ GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(48902), // Rule ID 1759 //
     /*  48848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  48851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  48858 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48862 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48866 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48869 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48873 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48877 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48879 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48886 */   // (lrint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  48886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIrm),
     /*  48889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48891 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48895 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48900 */   GIR_RootConstrainSelectedInstOperands,
     /*  48901 */   // GIR_Coverage, 1759,
     /*  48901 */   GIR_EraseRootFromParent_Done,
     /*  48902 */ // Label 1163: @48902
     /*  48902 */ GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(48961), // Rule ID 1779 //
     /*  48907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  48910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  48913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  48917 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48921 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48925 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48928 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48932 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48936 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48938 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48945 */   // (lrint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  48945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SIrm),
     /*  48948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48950 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48954 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48959 */   GIR_RootConstrainSelectedInstOperands,
     /*  48960 */   // GIR_Coverage, 1779,
     /*  48960 */   GIR_EraseRootFromParent_Done,
     /*  48961 */ // Label 1164: @48961
     /*  48961 */ GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(49020), // Rule ID 1783 //
     /*  48966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  48969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  48976 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48980 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48984 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48987 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48991 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48995 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48997 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49004 */   // (lrint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SIrm),
     /*  49007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49009 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49013 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49018 */   GIR_RootConstrainSelectedInstOperands,
     /*  49019 */   // GIR_Coverage, 1783,
     /*  49019 */   GIR_EraseRootFromParent_Done,
     /*  49020 */ // Label 1165: @49020
     /*  49020 */ GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(49079), // Rule ID 10352 //
     /*  49025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49035 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49039 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49043 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49046 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49050 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49054 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49056 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49063 */   // (lrint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIZrm),
     /*  49066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49068 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49072 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49077 */   GIR_RootConstrainSelectedInstOperands,
     /*  49078 */   // GIR_Coverage, 10352,
     /*  49078 */   GIR_EraseRootFromParent_Done,
     /*  49079 */ // Label 1166: @49079
     /*  49079 */ GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(49138), // Rule ID 10356 //
     /*  49084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49094 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49098 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49102 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49105 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49109 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49113 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49115 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49122 */   // (lrint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIZrm),
     /*  49125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49127 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49131 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49136 */   GIR_RootConstrainSelectedInstOperands,
     /*  49137 */   // GIR_Coverage, 10356,
     /*  49137 */   GIR_EraseRootFromParent_Done,
     /*  49138 */ // Label 1167: @49138
     /*  49138 */ GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(49197), // Rule ID 22170 //
     /*  49143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  49146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  49149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49153 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49157 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49161 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49164 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49168 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49172 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49174 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49181 */   // (lrint:{ *:[i32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrm),
     /*  49184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49186 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49190 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49195 */   GIR_RootConstrainSelectedInstOperands,
     /*  49196 */   // GIR_Coverage, 22170,
     /*  49196 */   GIR_EraseRootFromParent_Done,
     /*  49197 */ // Label 1168: @49197
     /*  49197 */ GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(49227), // Rule ID 1754 //
     /*  49202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  49216 */   // (lrint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  49216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIrr),
     /*  49221 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49225 */   GIR_RootConstrainSelectedInstOperands,
     /*  49226 */   // GIR_Coverage, 1754,
     /*  49226 */   GIR_Done,
     /*  49227 */ // Label 1169: @49227
     /*  49227 */ GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(49257), // Rule ID 1758 //
     /*  49232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  49246 */   // (lrint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /*  49246 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIrr),
     /*  49251 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49255 */   GIR_RootConstrainSelectedInstOperands,
     /*  49256 */   // GIR_Coverage, 1758,
     /*  49256 */   GIR_Done,
     /*  49257 */ // Label 1170: @49257
     /*  49257 */ GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(49287), // Rule ID 1778 //
     /*  49262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  49265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  49276 */   // (lrint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  49276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SIrr),
     /*  49281 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49285 */   GIR_RootConstrainSelectedInstOperands,
     /*  49286 */   // GIR_Coverage, 1778,
     /*  49286 */   GIR_Done,
     /*  49287 */ // Label 1171: @49287
     /*  49287 */ GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(49317), // Rule ID 1782 //
     /*  49292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  49295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  49306 */   // (lrint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /*  49306 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SIrr),
     /*  49311 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49315 */   GIR_RootConstrainSelectedInstOperands,
     /*  49316 */   // GIR_Coverage, 1782,
     /*  49316 */   GIR_Done,
     /*  49317 */ // Label 1172: @49317
     /*  49317 */ GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(49347), // Rule ID 10351 //
     /*  49322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  49336 */   // (lrint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /*  49336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIZrr),
     /*  49341 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49345 */   GIR_RootConstrainSelectedInstOperands,
     /*  49346 */   // GIR_Coverage, 10351,
     /*  49346 */   GIR_Done,
     /*  49347 */ // Label 1173: @49347
     /*  49347 */ GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(49377), // Rule ID 10355 //
     /*  49352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  49366 */   // (lrint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /*  49366 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIZrr),
     /*  49371 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49375 */   GIR_RootConstrainSelectedInstOperands,
     /*  49376 */   // GIR_Coverage, 10355,
     /*  49376 */   GIR_Done,
     /*  49377 */ // Label 1174: @49377
     /*  49377 */ GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(49407), // Rule ID 22169 //
     /*  49382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  49385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  49388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  49396 */   // (lrint:{ *:[i32] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SIZrr:{ *:[i32] } FR16:{ *:[f16] }:$src)
     /*  49396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /*  49401 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49405 */   GIR_RootConstrainSelectedInstOperands,
     /*  49406 */   // GIR_Coverage, 22169,
     /*  49406 */   GIR_Done,
     /*  49407 */ // Label 1175: @49407
     /*  49407 */ GIM_Reject,
     /*  49408 */ // Label 1150: @49408
     /*  49408 */ GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(49467), // Rule ID 17989 //
     /*  49413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49423 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49427 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49431 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49434 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49438 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49442 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49444 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49451 */   // (lrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rm),
     /*  49454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49456 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49460 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49465 */   GIR_RootConstrainSelectedInstOperands,
     /*  49466 */   // GIR_Coverage, 17989,
     /*  49466 */   GIR_EraseRootFromParent_Done,
     /*  49467 */ // Label 1176: @49467
     /*  49467 */ GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(49526), // Rule ID 17991 //
     /*  49472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49482 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49486 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49490 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49493 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49497 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49501 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49503 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49510 */   // (lrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rm),
     /*  49513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49515 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49519 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49524 */   GIR_RootConstrainSelectedInstOperands,
     /*  49525 */   // GIR_Coverage, 17991,
     /*  49525 */   GIR_EraseRootFromParent_Done,
     /*  49526 */ // Label 1177: @49526
     /*  49526 */ GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(49585), // Rule ID 17993 //
     /*  49531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  49534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49541 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49545 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49549 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49552 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49556 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49560 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49562 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49569 */   // (lrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rm),
     /*  49572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49574 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49578 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49583 */   GIR_RootConstrainSelectedInstOperands,
     /*  49584 */   // GIR_Coverage, 17993,
     /*  49584 */   GIR_EraseRootFromParent_Done,
     /*  49585 */ // Label 1178: @49585
     /*  49585 */ GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(49644), // Rule ID 17995 //
     /*  49590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  49593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49600 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49604 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49608 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49611 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49615 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49619 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49621 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49628 */   // (lrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rm),
     /*  49631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49633 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49637 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49642 */   GIR_RootConstrainSelectedInstOperands,
     /*  49643 */   // GIR_Coverage, 17995,
     /*  49643 */   GIR_EraseRootFromParent_Done,
     /*  49644 */ // Label 1179: @49644
     /*  49644 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(49703), // Rule ID 21159 //
     /*  49649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49659 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49663 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49667 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49670 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49674 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49678 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49680 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49687 */   // (lrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrm),
     /*  49690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49692 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49696 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49701 */   GIR_RootConstrainSelectedInstOperands,
     /*  49702 */   // GIR_Coverage, 21159,
     /*  49702 */   GIR_EraseRootFromParent_Done,
     /*  49703 */ // Label 1180: @49703
     /*  49703 */ GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(49762), // Rule ID 21161 //
     /*  49708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49718 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49722 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49726 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49729 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49733 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49737 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49739 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49746 */   // (lrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrm),
     /*  49749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49751 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49755 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49760 */   GIR_RootConstrainSelectedInstOperands,
     /*  49761 */   // GIR_Coverage, 21161,
     /*  49761 */   GIR_EraseRootFromParent_Done,
     /*  49762 */ // Label 1181: @49762
     /*  49762 */ GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(49821), // Rule ID 22172 //
     /*  49767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  49770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  49773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49777 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49781 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49785 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49788 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49792 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49796 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49798 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49805 */   // (lrint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrm),
     /*  49808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49810 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49814 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49819 */   GIR_RootConstrainSelectedInstOperands,
     /*  49820 */   // GIR_Coverage, 22172,
     /*  49820 */   GIR_EraseRootFromParent_Done,
     /*  49821 */ // Label 1182: @49821
     /*  49821 */ GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(49851), // Rule ID 17988 //
     /*  49826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  49840 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  49840 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rr),
     /*  49845 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49849 */   GIR_RootConstrainSelectedInstOperands,
     /*  49850 */   // GIR_Coverage, 17988,
     /*  49850 */   GIR_Done,
     /*  49851 */ // Label 1183: @49851
     /*  49851 */ GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(49881), // Rule ID 17990 //
     /*  49856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  49870 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  49870 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rr),
     /*  49875 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49879 */   GIR_RootConstrainSelectedInstOperands,
     /*  49880 */   // GIR_Coverage, 17990,
     /*  49880 */   GIR_Done,
     /*  49881 */ // Label 1184: @49881
     /*  49881 */ GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(49911), // Rule ID 17992 //
     /*  49886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  49889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  49900 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  49900 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rr),
     /*  49905 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49909 */   GIR_RootConstrainSelectedInstOperands,
     /*  49910 */   // GIR_Coverage, 17992,
     /*  49910 */   GIR_Done,
     /*  49911 */ // Label 1185: @49911
     /*  49911 */ GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(49941), // Rule ID 17994 //
     /*  49916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  49919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  49930 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  49930 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rr),
     /*  49935 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49939 */   GIR_RootConstrainSelectedInstOperands,
     /*  49940 */   // GIR_Coverage, 17994,
     /*  49940 */   GIR_Done,
     /*  49941 */ // Label 1186: @49941
     /*  49941 */ GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(49971), // Rule ID 21158 //
     /*  49946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  49960 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64Zrr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  49960 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrr),
     /*  49965 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49969 */   GIR_RootConstrainSelectedInstOperands,
     /*  49970 */   // GIR_Coverage, 21158,
     /*  49970 */   GIR_Done,
     /*  49971 */ // Label 1187: @49971
     /*  49971 */ GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(50001), // Rule ID 21160 //
     /*  49976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  49990 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64Zrr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  49990 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrr),
     /*  49995 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49999 */   GIR_RootConstrainSelectedInstOperands,
     /*  50000 */   // GIR_Coverage, 21160,
     /*  50000 */   GIR_Done,
     /*  50001 */ // Label 1188: @50001
     /*  50001 */ GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(50031), // Rule ID 22171 //
     /*  50006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  50009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  50012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  50020 */   // (lrint:{ *:[i64] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16:{ *:[f16] }:$src)
     /*  50020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /*  50025 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50029 */   GIR_RootConstrainSelectedInstOperands,
     /*  50030 */   // GIR_Coverage, 22171,
     /*  50030 */   GIR_Done,
     /*  50031 */ // Label 1189: @50031
     /*  50031 */ GIM_Reject,
     /*  50032 */ // Label 1151: @50032
     /*  50032 */ GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(50120),
     /*  50037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  50040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50044 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(50096), // Rule ID 21384 //
     /*  50049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50060 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50063 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50067 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50073 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50080 */     // (lrint:{ *:[v2i64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  50080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rm),
     /*  50083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50094 */     GIR_RootConstrainSelectedInstOperands,
     /*  50095 */     // GIR_Coverage, 21384,
     /*  50095 */     GIR_EraseRootFromParent_Done,
     /*  50096 */   // Label 1191: @50096
     /*  50096 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(50119), // Rule ID 21383 //
     /*  50101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50108 */     // (lrint:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)  =>  (VCVTPD2QQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)
     /*  50108 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rr),
     /*  50113 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50117 */     GIR_RootConstrainSelectedInstOperands,
     /*  50118 */     // GIR_Coverage, 21383,
     /*  50118 */     GIR_Done,
     /*  50119 */   // Label 1192: @50119
     /*  50119 */   GIM_Reject,
     /*  50120 */ // Label 1190: @50120
     /*  50120 */ GIM_Reject,
     /*  50121 */ // Label 1152: @50121
     /*  50121 */ GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(50180), // Rule ID 18043 //
     /*  50126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50136 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50140 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50144 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50147 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50151 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50155 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50157 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50164 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQrm),
     /*  50167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50169 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50173 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50178 */   GIR_RootConstrainSelectedInstOperands,
     /*  50179 */   // GIR_Coverage, 18043,
     /*  50179 */   GIR_EraseRootFromParent_Done,
     /*  50180 */ // Label 1193: @50180
     /*  50180 */ GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(50239), // Rule ID 18047 //
     /*  50185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50195 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50199 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50203 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50206 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50210 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50214 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50216 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50223 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2DQYrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQYrm),
     /*  50226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50228 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50232 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50237 */   GIR_RootConstrainSelectedInstOperands,
     /*  50238 */   // GIR_Coverage, 18047,
     /*  50238 */   GIR_EraseRootFromParent_Done,
     /*  50239 */ // Label 1194: @50239
     /*  50239 */ GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(50298), // Rule ID 18049 //
     /*  50244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  50247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50254 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50258 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50262 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50265 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50269 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50273 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50275 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50282 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTPS2DQrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTPS2DQrm),
     /*  50285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50287 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50291 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50296 */   GIR_RootConstrainSelectedInstOperands,
     /*  50297 */   // GIR_Coverage, 18049,
     /*  50297 */   GIR_EraseRootFromParent_Done,
     /*  50298 */ // Label 1195: @50298
     /*  50298 */ GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(50357), // Rule ID 21356 //
     /*  50303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50313 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50317 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50321 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50324 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50328 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50332 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50334 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50341 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ128rm),
     /*  50344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50346 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50350 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50355 */   GIR_RootConstrainSelectedInstOperands,
     /*  50356 */   // GIR_Coverage, 21356,
     /*  50356 */   GIR_EraseRootFromParent_Done,
     /*  50357 */ // Label 1196: @50357
     /*  50357 */ GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(50416), // Rule ID 21360 //
     /*  50362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50372 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50376 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50380 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50383 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50387 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50391 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50393 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50400 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2DQZ256rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZ256rm),
     /*  50403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50405 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50409 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50414 */   GIR_RootConstrainSelectedInstOperands,
     /*  50415 */   // GIR_Coverage, 21360,
     /*  50415 */   GIR_EraseRootFromParent_Done,
     /*  50416 */ // Label 1197: @50416
     /*  50416 */ GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(50446), // Rule ID 18042 //
     /*  50421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50435 */   // (lrint:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)  =>  (VCVTPS2DQrr:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)
     /*  50435 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQrr),
     /*  50440 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50444 */   GIR_RootConstrainSelectedInstOperands,
     /*  50445 */   // GIR_Coverage, 18042,
     /*  50445 */   GIR_Done,
     /*  50446 */ // Label 1198: @50446
     /*  50446 */ GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(50476), // Rule ID 18046 //
     /*  50451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  50465 */   // (lrint:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)  =>  (VCVTPD2DQYrr:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)
     /*  50465 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQYrr),
     /*  50470 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50474 */   GIR_RootConstrainSelectedInstOperands,
     /*  50475 */   // GIR_Coverage, 18046,
     /*  50475 */   GIR_Done,
     /*  50476 */ // Label 1199: @50476
     /*  50476 */ GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(50506), // Rule ID 18048 //
     /*  50481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  50484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50495 */   // (lrint:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)  =>  (CVTPS2DQrr:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)
     /*  50495 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTPS2DQrr),
     /*  50500 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50504 */   GIR_RootConstrainSelectedInstOperands,
     /*  50505 */   // GIR_Coverage, 18048,
     /*  50505 */   GIR_Done,
     /*  50506 */ // Label 1200: @50506
     /*  50506 */ GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(50536), // Rule ID 21355 //
     /*  50511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50525 */   // (lrint:{ *:[v4i32] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2DQZ128rr:{ *:[v4i32] } VR128X:{ *:[v4f32] }:$src)
     /*  50525 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ128rr),
     /*  50530 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50534 */   GIR_RootConstrainSelectedInstOperands,
     /*  50535 */   // GIR_Coverage, 21355,
     /*  50535 */   GIR_Done,
     /*  50536 */ // Label 1201: @50536
     /*  50536 */ GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(50566), // Rule ID 21359 //
     /*  50541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50555 */   // (lrint:{ *:[v4i32] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2DQZ256rr:{ *:[v4i32] } VR256X:{ *:[v4f64] }:$src)
     /*  50555 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZ256rr),
     /*  50560 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50564 */   GIR_RootConstrainSelectedInstOperands,
     /*  50565 */   // GIR_Coverage, 21359,
     /*  50565 */   GIR_Done,
     /*  50566 */ // Label 1202: @50566
     /*  50566 */ GIM_Reject,
     /*  50567 */ // Label 1153: @50567
     /*  50567 */ GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(50626), // Rule ID 21380 //
     /*  50572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50582 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50586 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50590 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50593 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50597 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50601 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50603 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50610 */   // (lrint:{ *:[v4i64] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  50610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rm),
     /*  50613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50615 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50619 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50624 */   GIR_RootConstrainSelectedInstOperands,
     /*  50625 */   // GIR_Coverage, 21380,
     /*  50625 */   GIR_EraseRootFromParent_Done,
     /*  50626 */ // Label 1203: @50626
     /*  50626 */ GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(50685), // Rule ID 21386 //
     /*  50631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50641 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50645 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50649 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50652 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50656 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50660 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50662 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50669 */   // (lrint:{ *:[v4i64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  50669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rm),
     /*  50672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50674 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50678 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50683 */   GIR_RootConstrainSelectedInstOperands,
     /*  50684 */   // GIR_Coverage, 21386,
     /*  50684 */   GIR_EraseRootFromParent_Done,
     /*  50685 */ // Label 1204: @50685
     /*  50685 */ GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(50715), // Rule ID 21379 //
     /*  50690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50704 */   // (lrint:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2QQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)
     /*  50704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rr),
     /*  50709 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50713 */   GIR_RootConstrainSelectedInstOperands,
     /*  50714 */   // GIR_Coverage, 21379,
     /*  50714 */   GIR_Done,
     /*  50715 */ // Label 1205: @50715
     /*  50715 */ GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(50745), // Rule ID 21385 //
     /*  50720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50734 */   // (lrint:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2QQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)
     /*  50734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rr),
     /*  50739 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50743 */   GIR_RootConstrainSelectedInstOperands,
     /*  50744 */   // GIR_Coverage, 21385,
     /*  50744 */   GIR_Done,
     /*  50745 */ // Label 1206: @50745
     /*  50745 */ GIM_Reject,
     /*  50746 */ // Label 1154: @50746
     /*  50746 */ GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(50834),
     /*  50751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  50754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50758 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(50810), // Rule ID 22155 //
     /*  50763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  50766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50774 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50777 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50781 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50794 */     // (lrint:{ *:[v8i16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2WZ128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  50794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ128rm),
     /*  50797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50799 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50808 */     GIR_RootConstrainSelectedInstOperands,
     /*  50809 */     // GIR_Coverage, 22155,
     /*  50809 */     GIR_EraseRootFromParent_Done,
     /*  50810 */   // Label 1208: @50810
     /*  50810 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(50833), // Rule ID 22154 //
     /*  50815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  50818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50822 */     // (lrint:{ *:[v8i16] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2WZ128rr:{ *:[v8i16] } VR128X:{ *:[v8f16] }:$src)
     /*  50822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ128rr),
     /*  50827 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50831 */     GIR_RootConstrainSelectedInstOperands,
     /*  50832 */     // GIR_Coverage, 22154,
     /*  50832 */     GIR_Done,
     /*  50833 */   // Label 1209: @50833
     /*  50833 */   GIM_Reject,
     /*  50834 */ // Label 1207: @50834
     /*  50834 */ GIM_Reject,
     /*  50835 */ // Label 1155: @50835
     /*  50835 */ GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(50894), // Rule ID 18045 //
     /*  50840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  50846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  50850 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50854 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50858 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50861 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50865 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50869 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50871 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50878 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  50878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQYrm),
     /*  50881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50883 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50887 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50892 */   GIR_RootConstrainSelectedInstOperands,
     /*  50893 */   // GIR_Coverage, 18045,
     /*  50893 */   GIR_EraseRootFromParent_Done,
     /*  50894 */ // Label 1210: @50894
     /*  50894 */ GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(50953), // Rule ID 21358 //
     /*  50899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  50905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50909 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50913 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50917 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50920 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50924 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50928 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50930 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50937 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  50937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ256rm),
     /*  50940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50942 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50946 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50951 */   GIR_RootConstrainSelectedInstOperands,
     /*  50952 */   // GIR_Coverage, 21358,
     /*  50952 */   GIR_EraseRootFromParent_Done,
     /*  50953 */ // Label 1211: @50953
     /*  50953 */ GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(51009), // Rule ID 21364 //
     /*  50958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  50961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50965 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50969 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50973 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50976 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50980 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50984 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50986 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50993 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2DQZrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  50993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZrm),
     /*  50996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50998 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51002 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51007 */   GIR_RootConstrainSelectedInstOperands,
     /*  51008 */   // GIR_Coverage, 21364,
     /*  51008 */   GIR_EraseRootFromParent_Done,
     /*  51009 */ // Label 1212: @51009
     /*  51009 */ GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(51068), // Rule ID 22159 //
     /*  51014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51024 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51028 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51032 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51035 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51039 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51043 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51045 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51052 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2DQZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  51052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZ256rm),
     /*  51055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51057 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51061 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51066 */   GIR_RootConstrainSelectedInstOperands,
     /*  51067 */   // GIR_Coverage, 22159,
     /*  51067 */   GIR_EraseRootFromParent_Done,
     /*  51068 */ // Label 1213: @51068
     /*  51068 */ GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(51098), // Rule ID 18044 //
     /*  51073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  51076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  51083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  51087 */   // (lrint:{ *:[v8i32] } VR256:{ *:[v8f32] }:$src)  =>  (VCVTPS2DQYrr:{ *:[v8i32] } VR256:{ *:[v8f32] }:$src)
     /*  51087 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQYrr),
     /*  51092 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51096 */   GIR_RootConstrainSelectedInstOperands,
     /*  51097 */   // GIR_Coverage, 18044,
     /*  51097 */   GIR_Done,
     /*  51098 */ // Label 1214: @51098
     /*  51098 */ GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(51128), // Rule ID 21357 //
     /*  51103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  51106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51117 */   // (lrint:{ *:[v8i32] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2DQZ256rr:{ *:[v8i32] } VR256X:{ *:[v8f32] }:$src)
     /*  51117 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ256rr),
     /*  51122 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51126 */   GIR_RootConstrainSelectedInstOperands,
     /*  51127 */   // GIR_Coverage, 21357,
     /*  51127 */   GIR_Done,
     /*  51128 */ // Label 1215: @51128
     /*  51128 */ GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(51155), // Rule ID 21363 //
     /*  51133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51144 */   // (lrint:{ *:[v8i32] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2DQZrr:{ *:[v8i32] } VR512:{ *:[v8f64] }:$src)
     /*  51144 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZrr),
     /*  51149 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51153 */   GIR_RootConstrainSelectedInstOperands,
     /*  51154 */   // GIR_Coverage, 21363,
     /*  51154 */   GIR_Done,
     /*  51155 */ // Label 1216: @51155
     /*  51155 */ GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(51185), // Rule ID 22158 //
     /*  51160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  51174 */   // (lrint:{ *:[v8i32] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2DQZ256rr:{ *:[v8i32] } VR128X:{ *:[v8f16] }:$src)
     /*  51174 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZ256rr),
     /*  51179 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51183 */   GIR_RootConstrainSelectedInstOperands,
     /*  51184 */   // GIR_Coverage, 22158,
     /*  51184 */   GIR_Done,
     /*  51185 */ // Label 1217: @51185
     /*  51185 */ GIM_Reject,
     /*  51186 */ // Label 1156: @51186
     /*  51186 */ GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(51245), // Rule ID 21392 //
     /*  51191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51201 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51205 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51209 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51212 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51216 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51220 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51222 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51229 */   // (lrint:{ *:[v8i64] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  51229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrm),
     /*  51232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51234 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51238 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51243 */   GIR_RootConstrainSelectedInstOperands,
     /*  51244 */   // GIR_Coverage, 21392,
     /*  51244 */   GIR_EraseRootFromParent_Done,
     /*  51245 */ // Label 1218: @51245
     /*  51245 */ GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(51304), // Rule ID 21396 //
     /*  51250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51260 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51264 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51268 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51271 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51275 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51279 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51281 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51288 */   // (lrint:{ *:[v8i64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  51288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrm),
     /*  51291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51293 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51297 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51302 */   GIR_RootConstrainSelectedInstOperands,
     /*  51303 */   // GIR_Coverage, 21396,
     /*  51303 */   GIR_EraseRootFromParent_Done,
     /*  51304 */ // Label 1219: @51304
     /*  51304 */ GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(51363), // Rule ID 22165 //
     /*  51309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51319 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51323 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51327 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51330 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51334 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51338 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51340 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51347 */   // (lrint:{ *:[v8i64] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  51347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrm),
     /*  51350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51352 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51356 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51361 */   GIR_RootConstrainSelectedInstOperands,
     /*  51362 */   // GIR_Coverage, 22165,
     /*  51362 */   GIR_EraseRootFromParent_Done,
     /*  51363 */ // Label 1220: @51363
     /*  51363 */ GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(51393), // Rule ID 21391 //
     /*  51368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51382 */   // (lrint:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2QQZrr:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)
     /*  51382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrr),
     /*  51387 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51391 */   GIR_RootConstrainSelectedInstOperands,
     /*  51392 */   // GIR_Coverage, 21391,
     /*  51392 */   GIR_Done,
     /*  51393 */ // Label 1221: @51393
     /*  51393 */ GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(51423), // Rule ID 21395 //
     /*  51398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51412 */   // (lrint:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2QQZrr:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)
     /*  51412 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrr),
     /*  51417 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51421 */   GIR_RootConstrainSelectedInstOperands,
     /*  51422 */   // GIR_Coverage, 21395,
     /*  51422 */   GIR_Done,
     /*  51423 */ // Label 1222: @51423
     /*  51423 */ GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(51453), // Rule ID 22164 //
     /*  51428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  51442 */   // (lrint:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2QQZrr:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)
     /*  51442 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrr),
     /*  51447 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51451 */   GIR_RootConstrainSelectedInstOperands,
     /*  51452 */   // GIR_Coverage, 22164,
     /*  51452 */   GIR_Done,
     /*  51453 */ // Label 1223: @51453
     /*  51453 */ GIM_Reject,
     /*  51454 */ // Label 1157: @51454
     /*  51454 */ GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(51542),
     /*  51459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  51462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51466 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(51518), // Rule ID 22157 //
     /*  51471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51482 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51485 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51489 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51502 */     // (lrint:{ *:[v16i16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2WZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  51502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ256rm),
     /*  51505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51507 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51516 */     GIR_RootConstrainSelectedInstOperands,
     /*  51517 */     // GIR_Coverage, 22157,
     /*  51517 */     GIR_EraseRootFromParent_Done,
     /*  51518 */   // Label 1225: @51518
     /*  51518 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(51541), // Rule ID 22156 //
     /*  51523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51530 */     // (lrint:{ *:[v16i16] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2WZ256rr:{ *:[v16i16] } VR256X:{ *:[v16f16] }:$src)
     /*  51530 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ256rr),
     /*  51535 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51539 */     GIR_RootConstrainSelectedInstOperands,
     /*  51540 */     // GIR_Coverage, 22156,
     /*  51540 */     GIR_Done,
     /*  51541 */   // Label 1226: @51541
     /*  51541 */   GIM_Reject,
     /*  51542 */ // Label 1224: @51542
     /*  51542 */ GIM_Reject,
     /*  51543 */ // Label 1158: @51543
     /*  51543 */ GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(51599), // Rule ID 21362 //
     /*  51548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  51551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51555 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51559 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51563 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51566 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51570 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51574 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51576 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51583 */   // (lrint:{ *:[v16i32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  51583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZrm),
     /*  51586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51588 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51592 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51597 */   GIR_RootConstrainSelectedInstOperands,
     /*  51598 */   // GIR_Coverage, 21362,
     /*  51598 */   GIR_EraseRootFromParent_Done,
     /*  51599 */ // Label 1227: @51599
     /*  51599 */ GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(51658), // Rule ID 22163 //
     /*  51604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  51610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51614 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51618 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51622 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51625 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51629 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51633 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51635 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51642 */   // (lrint:{ *:[v16i32] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2DQZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  51642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZrm),
     /*  51645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51647 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51651 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51656 */   GIR_RootConstrainSelectedInstOperands,
     /*  51657 */   // GIR_Coverage, 22163,
     /*  51657 */   GIR_EraseRootFromParent_Done,
     /*  51658 */ // Label 1228: @51658
     /*  51658 */ GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(51685), // Rule ID 21361 //
     /*  51663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  51666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51674 */   // (lrint:{ *:[v16i32] } VR512:{ *:[v16f32] }:$src)  =>  (VCVTPS2DQZrr:{ *:[v16i32] } VR512:{ *:[v16f32] }:$src)
     /*  51674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZrr),
     /*  51679 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51683 */   GIR_RootConstrainSelectedInstOperands,
     /*  51684 */   // GIR_Coverage, 21361,
     /*  51684 */   GIR_Done,
     /*  51685 */ // Label 1229: @51685
     /*  51685 */ GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(51715), // Rule ID 22162 //
     /*  51690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  51696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51704 */   // (lrint:{ *:[v16i32] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2DQZrr:{ *:[v16i32] } VR256X:{ *:[v16f16] }:$src)
     /*  51704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZrr),
     /*  51709 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51713 */   GIR_RootConstrainSelectedInstOperands,
     /*  51714 */   // GIR_Coverage, 22162,
     /*  51714 */   GIR_Done,
     /*  51715 */ // Label 1230: @51715
     /*  51715 */ GIM_Reject,
     /*  51716 */ // Label 1159: @51716
     /*  51716 */ GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(51804),
     /*  51721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  51724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51728 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(51780), // Rule ID 22161 //
     /*  51733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51744 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51747 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51751 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51764 */     // (lrint:{ *:[v32i16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2WZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /*  51764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZrm),
     /*  51767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51769 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51778 */     GIR_RootConstrainSelectedInstOperands,
     /*  51779 */     // GIR_Coverage, 22161,
     /*  51779 */     GIR_EraseRootFromParent_Done,
     /*  51780 */   // Label 1232: @51780
     /*  51780 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(51803), // Rule ID 22160 //
     /*  51785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51792 */     // (lrint:{ *:[v32i16] } VR512:{ *:[v32f16] }:$src)  =>  (VCVTPH2WZrr:{ *:[v32i16] } VR512:{ *:[v32f16] }:$src)
     /*  51792 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZrr),
     /*  51797 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51801 */     GIR_RootConstrainSelectedInstOperands,
     /*  51802 */     // GIR_Coverage, 22160,
     /*  51802 */     GIR_Done,
     /*  51803 */   // Label 1233: @51803
     /*  51803 */   GIM_Reject,
     /*  51804 */ // Label 1231: @51804
     /*  51804 */ GIM_Reject,
     /*  51805 */ // Label 1160: @51805
     /*  51805 */ GIM_Reject,
     /*  51806 */ // Label 9: @51806
     /*  51806 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 1238*/ GIMT_Encode4(53025),
     /*  51817 */ /*GILLT_s64*//*Label 1234*/ GIMT_Encode4(51865), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  51833 */ /*GILLT_v2s64*//*Label 1235*/ GIMT_Encode4(52489), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  51845 */ /*GILLT_v4s64*//*Label 1236*/ GIMT_Encode4(52578), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  51861 */ /*GILLT_v8s64*//*Label 1237*/ GIMT_Encode4(52757),
     /*  51865 */ // Label 1234: @51865
     /*  51865 */ GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(51924), // Rule ID 1757 //
     /*  51870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  51873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  51876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  51880 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51884 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51888 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51891 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51895 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51899 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51901 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51908 */   // (llrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  51908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rm),
     /*  51911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51913 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51917 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51922 */   GIR_RootConstrainSelectedInstOperands,
     /*  51923 */   // GIR_Coverage, 1757,
     /*  51923 */   GIR_EraseRootFromParent_Done,
     /*  51924 */ // Label 1239: @51924
     /*  51924 */ GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(51983), // Rule ID 1761 //
     /*  51929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  51932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  51935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  51939 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51943 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51947 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51950 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51954 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51958 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51960 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51967 */   // (llrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  51967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rm),
     /*  51970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51972 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51976 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51981 */   GIR_RootConstrainSelectedInstOperands,
     /*  51982 */   // GIR_Coverage, 1761,
     /*  51982 */   GIR_EraseRootFromParent_Done,
     /*  51983 */ // Label 1240: @51983
     /*  51983 */ GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(52042), // Rule ID 1781 //
     /*  51988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  51991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  51994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  51998 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52002 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52006 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52009 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52013 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52017 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52019 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52026 */   // (llrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rm),
     /*  52029 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52031 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52035 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52040 */   GIR_RootConstrainSelectedInstOperands,
     /*  52041 */   // GIR_Coverage, 1781,
     /*  52041 */   GIR_EraseRootFromParent_Done,
     /*  52042 */ // Label 1241: @52042
     /*  52042 */ GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(52101), // Rule ID 1785 //
     /*  52047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  52050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52057 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52061 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52065 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52068 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52072 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52076 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52078 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52085 */   // (llrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rm),
     /*  52088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52090 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52094 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52099 */   GIR_RootConstrainSelectedInstOperands,
     /*  52100 */   // GIR_Coverage, 1785,
     /*  52100 */   GIR_EraseRootFromParent_Done,
     /*  52101 */ // Label 1242: @52101
     /*  52101 */ GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(52160), // Rule ID 10354 //
     /*  52106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52116 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52120 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52124 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52127 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52131 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52135 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52137 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52144 */   // (llrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrm),
     /*  52147 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52149 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52153 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52158 */   GIR_RootConstrainSelectedInstOperands,
     /*  52159 */   // GIR_Coverage, 10354,
     /*  52159 */   GIR_EraseRootFromParent_Done,
     /*  52160 */ // Label 1243: @52160
     /*  52160 */ GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(52219), // Rule ID 10358 //
     /*  52165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52175 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52179 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52183 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52186 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52190 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52194 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52196 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52203 */   // (llrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrm),
     /*  52206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52208 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52212 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52217 */   GIR_RootConstrainSelectedInstOperands,
     /*  52218 */   // GIR_Coverage, 10358,
     /*  52218 */   GIR_EraseRootFromParent_Done,
     /*  52219 */ // Label 1244: @52219
     /*  52219 */ GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(52278), // Rule ID 22174 //
     /*  52224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  52227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  52230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52234 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52238 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52242 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52245 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52249 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52253 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52255 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52262 */   // (llrint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrm),
     /*  52265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52267 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52271 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52276 */   GIR_RootConstrainSelectedInstOperands,
     /*  52277 */   // GIR_Coverage, 22174,
     /*  52277 */   GIR_EraseRootFromParent_Done,
     /*  52278 */ // Label 1245: @52278
     /*  52278 */ GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(52308), // Rule ID 1756 //
     /*  52283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  52286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  52297 */   // (llrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  52297 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rr),
     /*  52302 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52306 */   GIR_RootConstrainSelectedInstOperands,
     /*  52307 */   // GIR_Coverage, 1756,
     /*  52307 */   GIR_Done,
     /*  52308 */ // Label 1246: @52308
     /*  52308 */ GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(52338), // Rule ID 1760 //
     /*  52313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  52316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  52327 */   // (llrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  52327 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rr),
     /*  52332 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52336 */   GIR_RootConstrainSelectedInstOperands,
     /*  52337 */   // GIR_Coverage, 1760,
     /*  52337 */   GIR_Done,
     /*  52338 */ // Label 1247: @52338
     /*  52338 */ GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(52368), // Rule ID 1780 //
     /*  52343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  52346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  52357 */   // (llrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  52357 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rr),
     /*  52362 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52366 */   GIR_RootConstrainSelectedInstOperands,
     /*  52367 */   // GIR_Coverage, 1780,
     /*  52367 */   GIR_Done,
     /*  52368 */ // Label 1248: @52368
     /*  52368 */ GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(52398), // Rule ID 1784 //
     /*  52373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  52376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  52387 */   // (llrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  52387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rr),
     /*  52392 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52396 */   GIR_RootConstrainSelectedInstOperands,
     /*  52397 */   // GIR_Coverage, 1784,
     /*  52397 */   GIR_Done,
     /*  52398 */ // Label 1249: @52398
     /*  52398 */ GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(52428), // Rule ID 10353 //
     /*  52403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  52417 */   // (llrint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /*  52417 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrr),
     /*  52422 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52426 */   GIR_RootConstrainSelectedInstOperands,
     /*  52427 */   // GIR_Coverage, 10353,
     /*  52427 */   GIR_Done,
     /*  52428 */ // Label 1250: @52428
     /*  52428 */ GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(52458), // Rule ID 10357 //
     /*  52433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  52447 */   // (llrint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /*  52447 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrr),
     /*  52452 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52456 */   GIR_RootConstrainSelectedInstOperands,
     /*  52457 */   // GIR_Coverage, 10357,
     /*  52457 */   GIR_Done,
     /*  52458 */ // Label 1251: @52458
     /*  52458 */ GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(52488), // Rule ID 22173 //
     /*  52463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  52466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  52469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  52477 */   // (llrint:{ *:[i64] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16:{ *:[f16] }:$src)
     /*  52477 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /*  52482 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52486 */   GIR_RootConstrainSelectedInstOperands,
     /*  52487 */   // GIR_Coverage, 22173,
     /*  52487 */   GIR_Done,
     /*  52488 */ // Label 1252: @52488
     /*  52488 */ GIM_Reject,
     /*  52489 */ // Label 1235: @52489
     /*  52489 */ GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(52577),
     /*  52494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  52497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  52501 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(52553), // Rule ID 21388 //
     /*  52506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52517 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52520 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52524 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52537 */     // (llrint:{ *:[v2i64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  52537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rm),
     /*  52540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52542 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52551 */     GIR_RootConstrainSelectedInstOperands,
     /*  52552 */     // GIR_Coverage, 21388,
     /*  52552 */     GIR_EraseRootFromParent_Done,
     /*  52553 */   // Label 1254: @52553
     /*  52553 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(52576), // Rule ID 21387 //
     /*  52558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  52565 */     // (llrint:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)  =>  (VCVTPD2QQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)
     /*  52565 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rr),
     /*  52570 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52574 */     GIR_RootConstrainSelectedInstOperands,
     /*  52575 */     // GIR_Coverage, 21387,
     /*  52575 */     GIR_Done,
     /*  52576 */   // Label 1255: @52576
     /*  52576 */   GIM_Reject,
     /*  52577 */ // Label 1253: @52577
     /*  52577 */ GIM_Reject,
     /*  52578 */ // Label 1236: @52578
     /*  52578 */ GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(52637), // Rule ID 21382 //
     /*  52583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52593 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52597 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52601 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52604 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52608 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52612 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52614 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52621 */   // (llrint:{ *:[v4i64] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  52621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rm),
     /*  52624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52626 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52630 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52635 */   GIR_RootConstrainSelectedInstOperands,
     /*  52636 */   // GIR_Coverage, 21382,
     /*  52636 */   GIR_EraseRootFromParent_Done,
     /*  52637 */ // Label 1256: @52637
     /*  52637 */ GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(52696), // Rule ID 21390 //
     /*  52642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  52648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52652 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52656 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52660 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52663 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52667 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52671 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52673 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52680 */   // (llrint:{ *:[v4i64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  52680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rm),
     /*  52683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52685 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52689 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52694 */   GIR_RootConstrainSelectedInstOperands,
     /*  52695 */   // GIR_Coverage, 21390,
     /*  52695 */   GIR_EraseRootFromParent_Done,
     /*  52696 */ // Label 1257: @52696
     /*  52696 */ GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(52726), // Rule ID 21381 //
     /*  52701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  52715 */   // (llrint:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2QQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)
     /*  52715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rr),
     /*  52720 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52724 */   GIR_RootConstrainSelectedInstOperands,
     /*  52725 */   // GIR_Coverage, 21381,
     /*  52725 */   GIR_Done,
     /*  52726 */ // Label 1258: @52726
     /*  52726 */ GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(52756), // Rule ID 21389 //
     /*  52731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  52737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52745 */   // (llrint:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2QQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)
     /*  52745 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rr),
     /*  52750 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52754 */   GIR_RootConstrainSelectedInstOperands,
     /*  52755 */   // GIR_Coverage, 21389,
     /*  52755 */   GIR_Done,
     /*  52756 */ // Label 1259: @52756
     /*  52756 */ GIM_Reject,
     /*  52757 */ // Label 1237: @52757
     /*  52757 */ GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(52816), // Rule ID 21394 //
     /*  52762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  52765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  52768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  52772 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52776 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52780 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52783 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52787 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52791 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52793 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52800 */   // (llrint:{ *:[v8i64] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  52800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrm),
     /*  52803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52805 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52809 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52814 */   GIR_RootConstrainSelectedInstOperands,
     /*  52815 */   // GIR_Coverage, 21394,
     /*  52815 */   GIR_EraseRootFromParent_Done,
     /*  52816 */ // Label 1260: @52816
     /*  52816 */ GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(52875), // Rule ID 21398 //
     /*  52821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  52824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  52827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  52831 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52835 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52839 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52842 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52846 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52850 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52852 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52859 */   // (llrint:{ *:[v8i64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  52859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrm),
     /*  52862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52864 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52868 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52873 */   GIR_RootConstrainSelectedInstOperands,
     /*  52874 */   // GIR_Coverage, 21398,
     /*  52874 */   GIR_EraseRootFromParent_Done,
     /*  52875 */ // Label 1261: @52875
     /*  52875 */ GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(52934), // Rule ID 22167 //
     /*  52880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  52883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  52890 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52898 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52901 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52905 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52909 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52911 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52918 */   // (llrint:{ *:[v8i64] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  52918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrm),
     /*  52921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52923 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52927 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52932 */   GIR_RootConstrainSelectedInstOperands,
     /*  52933 */   // GIR_Coverage, 22167,
     /*  52933 */   GIR_EraseRootFromParent_Done,
     /*  52934 */ // Label 1262: @52934
     /*  52934 */ GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(52964), // Rule ID 21393 //
     /*  52939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  52942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  52945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  52949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52953 */   // (llrint:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2QQZrr:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)
     /*  52953 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrr),
     /*  52958 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52962 */   GIR_RootConstrainSelectedInstOperands,
     /*  52963 */   // GIR_Coverage, 21393,
     /*  52963 */   GIR_Done,
     /*  52964 */ // Label 1263: @52964
     /*  52964 */ GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(52994), // Rule ID 21397 //
     /*  52969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  52972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  52975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  52979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  52983 */   // (llrint:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2QQZrr:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)
     /*  52983 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrr),
     /*  52988 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52992 */   GIR_RootConstrainSelectedInstOperands,
     /*  52993 */   // GIR_Coverage, 21397,
     /*  52993 */   GIR_Done,
     /*  52994 */ // Label 1264: @52994
     /*  52994 */ GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(53024), // Rule ID 22166 //
     /*  52999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  53002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  53013 */   // (llrint:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2QQZrr:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)
     /*  53013 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrr),
     /*  53018 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  53022 */   GIR_RootConstrainSelectedInstOperands,
     /*  53023 */   // GIR_Coverage, 22166,
     /*  53023 */   GIR_Done,
     /*  53024 */ // Label 1265: @53024
     /*  53024 */ GIM_Reject,
     /*  53025 */ // Label 1238: @53025
     /*  53025 */ GIM_Reject,
     /*  53026 */ // Label 10: @53026
     /*  53026 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 1291*/ GIMT_Encode4(59234),
     /*  53037 */ /*GILLT_s1*//*Label 1266*/ GIMT_Encode4(53137),
     /*  53041 */ /*GILLT_s8*//*Label 1267*/ GIMT_Encode4(53204),
     /*  53045 */ /*GILLT_s16*//*Label 1268*/ GIMT_Encode4(53341),
     /*  53049 */ /*GILLT_s32*//*Label 1269*/ GIMT_Encode4(53890),
     /*  53053 */ /*GILLT_s64*//*Label 1270*/ GIMT_Encode4(54308),
     /*  53057 */ /*GILLT_s80*//*Label 1271*/ GIMT_Encode4(54877),
     /*  53061 */ /*GILLT_s128*//*Label 1272*/ GIMT_Encode4(55036),
     /*  53065 */ /*GILLT_v2s1*//*Label 1273*/ GIMT_Encode4(55164),
     /*  53069 */ /*GILLT_v2s64*//*Label 1274*/ GIMT_Encode4(55231),
     /*  53073 */ /*GILLT_v4s1*//*Label 1275*/ GIMT_Encode4(55725),
     /*  53077 */ /*GILLT_v4s32*//*Label 1276*/ GIMT_Encode4(55792),
     /*  53081 */ /*GILLT_v4s64*//*Label 1277*/ GIMT_Encode4(56286),
     /*  53085 */ /*GILLT_v8s1*//*Label 1278*/ GIMT_Encode4(56620),
     /*  53089 */ /*GILLT_v8s16*//*Label 1279*/ GIMT_Encode4(56702),
     /*  53093 */ /*GILLT_v8s32*//*Label 1280*/ GIMT_Encode4(57276),
     /*  53097 */ /*GILLT_v8s64*//*Label 1281*/ GIMT_Encode4(57610),
     /*  53101 */ /*GILLT_v16s1*//*Label 1282*/ GIMT_Encode4(57784),
     /*  53105 */ /*GILLT_v16s8*//*Label 1283*/ GIMT_Encode4(57866),
     /*  53109 */ /*GILLT_v16s16*//*Label 1284*/ GIMT_Encode4(58120),
     /*  53113 */ /*GILLT_v16s32*//*Label 1285*/ GIMT_Encode4(58454),
     /*  53117 */ /*GILLT_v32s1*//*Label 1286*/ GIMT_Encode4(58628),
     /*  53121 */ /*GILLT_v32s8*//*Label 1287*/ GIMT_Encode4(58710),
     /*  53125 */ /*GILLT_v32s16*//*Label 1288*/ GIMT_Encode4(58884),
     /*  53129 */ /*GILLT_v64s1*//*Label 1289*/ GIMT_Encode4(59058),
     /*  53133 */ /*GILLT_v64s8*//*Label 1290*/ GIMT_Encode4(59140),
     /*  53137 */ // Label 1266: @53137
     /*  53137 */ GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(53203), // Rule ID 19444 //
     /*  53142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  53145 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53148 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  53156 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53160 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53167 */   // (ld:{ *:[v1i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src), VK1:{ *:[i32] })
     /*  53167 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /*  53170 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  53174 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53179 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53183 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53194 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53197 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  53202 */   // GIR_Coverage, 19444,
     /*  53202 */   GIR_EraseRootFromParent_Done,
     /*  53203 */ // Label 1292: @53203
     /*  53203 */ GIM_Reject,
     /*  53204 */ // Label 1267: @53204
     /*  53204 */ GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(53249), // Rule ID 22514 //
     /*  53209 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  53212 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  53223 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53227 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53234 */   // (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_8>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  53234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  53237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53239 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53243 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53247 */   GIR_RootConstrainSelectedInstOperands,
     /*  53248 */   // GIR_Coverage, 22514,
     /*  53248 */   GIR_EraseRootFromParent_Done,
     /*  53249 */ // Label 1293: @53249
     /*  53249 */ GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(53298), // Rule ID 22577 //
     /*  53254 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53257 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53261 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  53272 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53276 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53283 */   // (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  53283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  53286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53288 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53292 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53296 */   GIR_RootConstrainSelectedInstOperands,
     /*  53297 */   // GIR_Coverage, 22577,
     /*  53297 */   GIR_EraseRootFromParent_Done,
     /*  53298 */ // Label 1294: @53298
     /*  53298 */ GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(53340), // Rule ID 28 //
     /*  53303 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  53310 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53314 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  53318 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53325 */   // (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  53325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  53328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53330 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53334 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53338 */   GIR_RootConstrainSelectedInstOperands,
     /*  53339 */   // GIR_Coverage, 28,
     /*  53339 */   GIR_EraseRootFromParent_Done,
     /*  53340 */ // Label 1295: @53340
     /*  53340 */ GIM_Reject,
     /*  53341 */ // Label 1268: @53341
     /*  53341 */ GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(53386), // Rule ID 22515 //
     /*  53346 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  53349 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  53356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53360 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53364 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53371 */   // (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_16>>  =>  (MOV16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  53371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16rm),
     /*  53374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53376 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53380 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53384 */   GIR_RootConstrainSelectedInstOperands,
     /*  53385 */   // GIR_Coverage, 22515,
     /*  53385 */   GIR_EraseRootFromParent_Done,
     /*  53386 */ // Label 1296: @53386
     /*  53386 */ GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(53465), // Rule ID 22578 //
     /*  53391 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53394 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53398 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53409 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53413 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53420 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  53420 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53423 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  53427 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53432 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53436 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53440 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53447 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  53454 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  53459 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  53464 */   // GIR_Coverage, 22578,
     /*  53464 */   GIR_EraseRootFromParent_Done,
     /*  53465 */ // Label 1297: @53465
     /*  53465 */ GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(53544), // Rule ID 22580 //
     /*  53470 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53473 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53477 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53488 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53492 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53499 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  53499 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53502 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  53506 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53511 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53515 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53519 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53524 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53526 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  53533 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  53538 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  53543 */   // GIR_Coverage, 22580,
     /*  53543 */   GIR_EraseRootFromParent_Done,
     /*  53544 */ // Label 1298: @53544
     /*  53544 */ GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(53589), // Rule ID 4620 //
     /*  53549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  53552 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53555 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  53563 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53567 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53574 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSHZrm_alt:{ *:[f16] } addr:{ *:[iPTR] }:$src)
     /*  53574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSHZrm_alt),
     /*  53577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53579 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53583 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53587 */   GIR_RootConstrainSelectedInstOperands,
     /*  53588 */   // GIR_Coverage, 4620,
     /*  53588 */   GIR_EraseRootFromParent_Done,
     /*  53589 */ // Label 1299: @53589
     /*  53589 */ GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(53675), // Rule ID 18338 //
     /*  53594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  53597 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53600 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  53608 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53612 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53619 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWrmi:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), addr:{ *:[iPTR] }:$src, 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  53619 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  53622 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  53626 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53631 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  53633 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  53636 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWrmi),
     /*  53640 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53645 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  53648 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53652 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  53655 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53659 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53666 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53669 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  53674 */   // GIR_Coverage, 18338,
     /*  53674 */   GIR_EraseRootFromParent_Done,
     /*  53675 */ // Label 1300: @53675
     /*  53675 */ GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(53717), // Rule ID 29 //
     /*  53680 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53687 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53691 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  53695 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53702 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>  =>  (MOV16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  53702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16rm),
     /*  53705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53707 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53711 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53715 */   GIR_RootConstrainSelectedInstOperands,
     /*  53716 */   // GIR_Coverage, 29,
     /*  53716 */   GIR_EraseRootFromParent_Done,
     /*  53717 */ // Label 1301: @53717
     /*  53717 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(53803), // Rule ID 18334 //
     /*  53722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  53725 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53728 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  53736 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53740 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53747 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (PINSRWrmi:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), addr:{ *:[iPTR] }:$src, 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  53747 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  53750 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  53754 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  53761 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  53764 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PINSRWrmi),
     /*  53768 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53773 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  53776 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53780 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  53783 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53787 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53794 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  53802 */   // GIR_Coverage, 18334,
     /*  53802 */   GIR_EraseRootFromParent_Done,
     /*  53803 */ // Label 1302: @53803
     /*  53803 */ GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(53889), // Rule ID 21838 //
     /*  53808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  53811 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53814 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  53822 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53826 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53833 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWZrmi:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), addr:{ *:[iPTR] }:$src, 0:{ *:[i8] }), FR16X:{ *:[i32] })
     /*  53833 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  53836 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  53840 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53845 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  53847 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  53850 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWZrmi),
     /*  53854 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53859 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  53862 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53866 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  53869 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53880 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53883 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  53888 */   // GIR_Coverage, 21838,
     /*  53888 */   GIR_EraseRootFromParent_Done,
     /*  53889 */ // Label 1303: @53889
     /*  53889 */ GIM_Reject,
     /*  53890 */ // Label 1269: @53890
     /*  53890 */ GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(53935), // Rule ID 22516 //
     /*  53895 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  53898 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  53905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  53909 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53913 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53920 */   // (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_32>>  =>  (MOV32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  53920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32rm),
     /*  53923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53925 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53929 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53933 */   GIR_RootConstrainSelectedInstOperands,
     /*  53934 */   // GIR_Coverage, 22516,
     /*  53934 */   GIR_EraseRootFromParent_Done,
     /*  53935 */ // Label 1304: @53935
     /*  53935 */ GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(53983), // Rule ID 1079 //
     /*  53940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /*  53943 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53946 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /*  53954 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53958 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53965 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_Fp32m:{ *:[f32] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  53965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp32m),
     /*  53968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53970 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53974 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  53977 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53981 */   GIR_RootConstrainSelectedInstOperands,
     /*  53982 */   // GIR_Coverage, 1079,
     /*  53982 */   GIR_EraseRootFromParent_Done,
     /*  53983 */ // Label 1305: @53983
     /*  53983 */ GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(54028), // Rule ID 1696 //
     /*  53988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  53991 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53994 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  54002 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54006 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54013 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  54013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSrm_alt),
     /*  54016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54018 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54022 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54026 */   GIR_RootConstrainSelectedInstOperands,
     /*  54027 */   // GIR_Coverage, 1696,
     /*  54027 */   GIR_EraseRootFromParent_Done,
     /*  54028 */ // Label 1306: @54028
     /*  54028 */ GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(54073), // Rule ID 1697 //
     /*  54033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  54036 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54039 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  54047 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54051 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54058 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  54058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSrm_alt),
     /*  54061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54063 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54067 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54071 */   GIR_RootConstrainSelectedInstOperands,
     /*  54072 */   // GIR_Coverage, 1697,
     /*  54072 */   GIR_EraseRootFromParent_Done,
     /*  54073 */ // Label 1307: @54073
     /*  54073 */ GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(54122), // Rule ID 22579 //
     /*  54078 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54081 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54085 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54096 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54100 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54107 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54112 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54116 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54120 */   GIR_RootConstrainSelectedInstOperands,
     /*  54121 */   // GIR_Coverage, 22579,
     /*  54121 */   GIR_EraseRootFromParent_Done,
     /*  54122 */ // Label 1308: @54122
     /*  54122 */ GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(54171), // Rule ID 22581 //
     /*  54127 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54130 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54134 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54145 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54149 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54156 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54159 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54161 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54165 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54169 */   GIR_RootConstrainSelectedInstOperands,
     /*  54170 */   // GIR_Coverage, 22581,
     /*  54170 */   GIR_EraseRootFromParent_Done,
     /*  54171 */ // Label 1309: @54171
     /*  54171 */ GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(54220), // Rule ID 22582 //
     /*  54176 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54179 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54183 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  54190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54194 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54198 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54205 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  54208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54210 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54214 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54218 */   GIR_RootConstrainSelectedInstOperands,
     /*  54219 */   // GIR_Coverage, 22582,
     /*  54219 */   GIR_EraseRootFromParent_Done,
     /*  54220 */ // Label 1310: @54220
     /*  54220 */ GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(54265), // Rule ID 4608 //
     /*  54225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  54228 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54231 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  54239 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54243 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54250 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSSZrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  54250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZrm_alt),
     /*  54253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54255 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54259 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54263 */   GIR_RootConstrainSelectedInstOperands,
     /*  54264 */   // GIR_Coverage, 4608,
     /*  54264 */   GIR_EraseRootFromParent_Done,
     /*  54265 */ // Label 1311: @54265
     /*  54265 */ GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(54307), // Rule ID 30 //
     /*  54270 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54277 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54281 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  54285 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54292 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>  =>  (MOV32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32rm),
     /*  54295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54297 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54301 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54305 */   GIR_RootConstrainSelectedInstOperands,
     /*  54306 */   // GIR_Coverage, 30,
     /*  54306 */   GIR_EraseRootFromParent_Done,
     /*  54307 */ // Label 1312: @54307
     /*  54307 */ GIM_Reject,
     /*  54308 */ // Label 1270: @54308
     /*  54308 */ GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(54353), // Rule ID 22517 //
     /*  54313 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  54316 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  54323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54327 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54331 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54338 */   // (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_64>>  =>  (MOV64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  54338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64rm),
     /*  54341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54343 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54347 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54351 */   GIR_RootConstrainSelectedInstOperands,
     /*  54352 */   // GIR_Coverage, 22517,
     /*  54352 */   GIR_EraseRootFromParent_Done,
     /*  54353 */ // Label 1313: @54353
     /*  54353 */ GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(54395), // Rule ID 31 //
     /*  54358 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54361 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54369 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54373 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54380 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOV64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  54380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64rm),
     /*  54383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54385 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54389 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54393 */   GIR_RootConstrainSelectedInstOperands,
     /*  54394 */   // GIR_Coverage, 31,
     /*  54394 */   GIR_EraseRootFromParent_Done,
     /*  54395 */ // Label 1314: @54395
     /*  54395 */ GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(54443), // Rule ID 1080 //
     /*  54400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  54403 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54406 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  54414 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54418 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54425 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_Fp64m:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  54425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp64m),
     /*  54428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54430 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54434 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  54437 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54441 */   GIR_RootConstrainSelectedInstOperands,
     /*  54442 */   // GIR_Coverage, 1080,
     /*  54442 */   GIR_EraseRootFromParent_Done,
     /*  54443 */ // Label 1315: @54443
     /*  54443 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(54498), // Rule ID 1082 //
     /*  54448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  54451 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54454 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54458 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  54465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  54469 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54473 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54480 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>  =>  (LD_Fp32m64:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  54480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp32m64),
     /*  54483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54485 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54489 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  54492 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54496 */   GIR_RootConstrainSelectedInstOperands,
     /*  54497 */   // GIR_Coverage, 1082,
     /*  54497 */   GIR_EraseRootFromParent_Done,
     /*  54498 */ // Label 1316: @54498
     /*  54498 */ GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(54543), // Rule ID 1700 //
     /*  54503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  54506 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54509 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  54517 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54521 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54528 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  54528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDrm_alt),
     /*  54531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54533 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54537 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54541 */   GIR_RootConstrainSelectedInstOperands,
     /*  54542 */   // GIR_Coverage, 1700,
     /*  54542 */   GIR_EraseRootFromParent_Done,
     /*  54543 */ // Label 1317: @54543
     /*  54543 */ GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(54588), // Rule ID 1701 //
     /*  54548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  54551 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54554 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  54562 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54566 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54573 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  54573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDrm_alt),
     /*  54576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54578 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54582 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54586 */   GIR_RootConstrainSelectedInstOperands,
     /*  54587 */   // GIR_Coverage, 1701,
     /*  54587 */   GIR_EraseRootFromParent_Done,
     /*  54588 */ // Label 1318: @54588
     /*  54588 */ GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(54669), // Rule ID 22584 //
     /*  54593 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54596 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54600 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54611 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54615 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54622 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  54622 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54625 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54629 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54634 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  54638 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54652 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  54658 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  54663 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  54668 */   // GIR_Coverage, 22584,
     /*  54668 */   GIR_EraseRootFromParent_Done,
     /*  54669 */ // Label 1319: @54669
     /*  54669 */ GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(54750), // Rule ID 22585 //
     /*  54674 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54677 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54681 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54692 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54696 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54703 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  54703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54715 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  54719 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54733 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  54739 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  54744 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  54749 */   // GIR_Coverage, 22585,
     /*  54749 */   GIR_EraseRootFromParent_Done,
     /*  54750 */ // Label 1320: @54750
     /*  54750 */ GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(54831), // Rule ID 22586 //
     /*  54755 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54758 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54762 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  54769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54773 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54777 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54784 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  54784 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54787 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  54791 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54796 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  54800 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54804 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54814 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  54820 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  54825 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  54830 */   // GIR_Coverage, 22586,
     /*  54830 */   GIR_EraseRootFromParent_Done,
     /*  54831 */ // Label 1321: @54831
     /*  54831 */ GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(54876), // Rule ID 4614 //
     /*  54836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  54839 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54842 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  54850 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54854 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54861 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSDZrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  54861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDZrm_alt),
     /*  54864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54866 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54870 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54874 */   GIR_RootConstrainSelectedInstOperands,
     /*  54875 */   // GIR_Coverage, 4614,
     /*  54875 */   GIR_EraseRootFromParent_Done,
     /*  54876 */ // Label 1322: @54876
     /*  54876 */ GIM_Reject,
     /*  54877 */ // Label 1271: @54877
     /*  54877 */ GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(55035),
     /*  54882 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54885 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(54930), // Rule ID 1081 //
     /*  54890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  54893 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  54901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54912 */     // (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_Fp80m:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  54912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp80m),
     /*  54915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54917 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  54924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54928 */     GIR_RootConstrainSelectedInstOperands,
     /*  54929 */     // GIR_Coverage, 1081,
     /*  54929 */     GIR_EraseRootFromParent_Done,
     /*  54930 */   // Label 1324: @54930
     /*  54930 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(54982), // Rule ID 1083 //
     /*  54935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  54938 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54942 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  54949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  54953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54964 */     // (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>  =>  (LD_Fp64m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  54964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp64m80),
     /*  54967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54969 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  54976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54980 */     GIR_RootConstrainSelectedInstOperands,
     /*  54981 */     // GIR_Coverage, 1083,
     /*  54981 */     GIR_EraseRootFromParent_Done,
     /*  54982 */   // Label 1325: @54982
     /*  54982 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(55034), // Rule ID 1084 //
     /*  54987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  54990 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54994 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  55001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  55005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55016 */     // (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>  =>  (LD_Fp32m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  55016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp32m80),
     /*  55019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55021 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  55028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55032 */     GIR_RootConstrainSelectedInstOperands,
     /*  55033 */     // GIR_Coverage, 1084,
     /*  55033 */     GIR_EraseRootFromParent_Done,
     /*  55034 */   // Label 1326: @55034
     /*  55034 */   GIM_Reject,
     /*  55035 */ // Label 1323: @55035
     /*  55035 */ GIM_Reject,
     /*  55036 */ // Label 1272: @55036
     /*  55036 */ GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(55163),
     /*  55041 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55044 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55048 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(55086), // Rule ID 23142 //
     /*  55053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoAVX),
     /*  55056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55071 */     // (ld:{ *:[f128] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[f128] } addr:{ *:[iPTR] }:$src)
     /*  55071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  55074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55084 */     GIR_RootConstrainSelectedInstOperands,
     /*  55085 */     // GIR_Coverage, 23142,
     /*  55085 */     GIR_EraseRootFromParent_Done,
     /*  55086 */   // Label 1328: @55086
     /*  55086 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(55124), // Rule ID 23146 //
     /*  55091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55109 */     // (ld:{ *:[f128] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSrm:{ *:[f128] } addr:{ *:[iPTR] }:$src)
     /*  55109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSrm),
     /*  55112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55114 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55122 */     GIR_RootConstrainSelectedInstOperands,
     /*  55123 */     // GIR_Coverage, 23146,
     /*  55123 */     GIR_EraseRootFromParent_Done,
     /*  55124 */   // Label 1329: @55124
     /*  55124 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(55162), // Rule ID 23150 //
     /*  55129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  55132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55147 */     // (ld:{ *:[f128] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ128rm:{ *:[f128] } addr:{ *:[iPTR] }:$src)
     /*  55147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128rm),
     /*  55150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55152 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55160 */     GIR_RootConstrainSelectedInstOperands,
     /*  55161 */     // GIR_Coverage, 23150,
     /*  55161 */     GIR_EraseRootFromParent_Done,
     /*  55162 */   // Label 1330: @55162
     /*  55162 */   GIM_Reject,
     /*  55163 */ // Label 1327: @55163
     /*  55163 */ GIM_Reject,
     /*  55164 */ // Label 1273: @55164
     /*  55164 */ GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(55230), // Rule ID 19445 //
     /*  55169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  55172 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55175 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  55183 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55187 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55194 */   // (ld:{ *:[v2i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src), VK2:{ *:[i32] })
     /*  55194 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /*  55197 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  55201 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55206 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  55210 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55214 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55221 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  55229 */   // GIR_Coverage, 19445,
     /*  55229 */   GIR_EraseRootFromParent_Done,
     /*  55230 */ // Label 1331: @55230
     /*  55230 */ GIM_Reject,
     /*  55231 */ // Label 1274: @55231
     /*  55231 */ GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(55724),
     /*  55236 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55239 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55243 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(55285), // Rule ID 1703 //
     /*  55248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55259 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55270 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDrm),
     /*  55273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55275 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55283 */     GIR_RootConstrainSelectedInstOperands,
     /*  55284 */     // GIR_Coverage, 1703,
     /*  55284 */     GIR_EraseRootFromParent_Done,
     /*  55285 */   // Label 1333: @55285
     /*  55285 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(55323), // Rule ID 1705 //
     /*  55290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55308 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDrm),
     /*  55311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55313 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55321 */     GIR_RootConstrainSelectedInstOperands,
     /*  55322 */     // GIR_Coverage, 1705,
     /*  55322 */     GIR_EraseRootFromParent_Done,
     /*  55323 */   // Label 1334: @55323
     /*  55323 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(55365), // Rule ID 1712 //
     /*  55328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  55331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55339 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55350 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPDrm),
     /*  55353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55355 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55363 */     GIR_RootConstrainSelectedInstOperands,
     /*  55364 */     // GIR_Coverage, 1712,
     /*  55364 */     GIR_EraseRootFromParent_Done,
     /*  55365 */   // Label 1335: @55365
     /*  55365 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(55403), // Rule ID 1713 //
     /*  55370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  55373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55388 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPDrm),
     /*  55391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55393 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55401 */     GIR_RootConstrainSelectedInstOperands,
     /*  55402 */     // GIR_Coverage, 1713,
     /*  55402 */     GIR_EraseRootFromParent_Done,
     /*  55403 */   // Label 1336: @55403
     /*  55403 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(55445), // Rule ID 2517 //
     /*  55408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55419 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55430 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  55433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55435 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55443 */     GIR_RootConstrainSelectedInstOperands,
     /*  55444 */     // GIR_Coverage, 2517,
     /*  55444 */     GIR_EraseRootFromParent_Done,
     /*  55445 */   // Label 1337: @55445
     /*  55445 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(55483), // Rule ID 2518 //
     /*  55450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55468 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  55471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55473 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55481 */     GIR_RootConstrainSelectedInstOperands,
     /*  55482 */     // GIR_Coverage, 2518,
     /*  55482 */     GIR_EraseRootFromParent_Done,
     /*  55483 */   // Label 1338: @55483
     /*  55483 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(55525), // Rule ID 4489 //
     /*  55488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55495 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55499 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55510 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rm),
     /*  55513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55515 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55523 */     GIR_RootConstrainSelectedInstOperands,
     /*  55524 */     // GIR_Coverage, 4489,
     /*  55524 */     GIR_EraseRootFromParent_Done,
     /*  55525 */   // Label 1339: @55525
     /*  55525 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(55563), // Rule ID 4514 //
     /*  55530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55548 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ128rm),
     /*  55551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55553 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55561 */     GIR_RootConstrainSelectedInstOperands,
     /*  55562 */     // GIR_Coverage, 4514,
     /*  55562 */     GIR_EraseRootFromParent_Done,
     /*  55563 */   // Label 1340: @55563
     /*  55563 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(55605), // Rule ID 4543 //
     /*  55568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55575 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55579 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55590 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  55593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55595 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55603 */     GIR_RootConstrainSelectedInstOperands,
     /*  55604 */     // GIR_Coverage, 4543,
     /*  55604 */     GIR_EraseRootFromParent_Done,
     /*  55605 */   // Label 1341: @55605
     /*  55605 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(55643), // Rule ID 4586 //
     /*  55610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55628 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  55631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55633 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55641 */     GIR_RootConstrainSelectedInstOperands,
     /*  55642 */     // GIR_Coverage, 4586,
     /*  55642 */     GIR_EraseRootFromParent_Done,
     /*  55643 */   // Label 1342: @55643
     /*  55643 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(55685), // Rule ID 17938 //
     /*  55648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  55651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55659 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55670 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  55673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55675 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55683 */     GIR_RootConstrainSelectedInstOperands,
     /*  55684 */     // GIR_Coverage, 17938,
     /*  55684 */     GIR_EraseRootFromParent_Done,
     /*  55685 */   // Label 1343: @55685
     /*  55685 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(55723), // Rule ID 17942 //
     /*  55690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  55693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55708 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  55711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55713 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55721 */     GIR_RootConstrainSelectedInstOperands,
     /*  55722 */     // GIR_Coverage, 17942,
     /*  55722 */     GIR_EraseRootFromParent_Done,
     /*  55723 */   // Label 1344: @55723
     /*  55723 */   GIM_Reject,
     /*  55724 */ // Label 1332: @55724
     /*  55724 */ GIM_Reject,
     /*  55725 */ // Label 1275: @55725
     /*  55725 */ GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(55791), // Rule ID 19446 //
     /*  55730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  55733 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55736 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  55744 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55748 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55755 */   // (ld:{ *:[v4i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src), VK4:{ *:[i32] })
     /*  55755 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /*  55758 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  55762 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55767 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  55771 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55775 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55782 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55785 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  55790 */   // GIR_Coverage, 19446,
     /*  55790 */   GIR_EraseRootFromParent_Done,
     /*  55791 */ // Label 1345: @55791
     /*  55791 */ GIM_Reject,
     /*  55792 */ // Label 1276: @55792
     /*  55792 */ GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(56285),
     /*  55797 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55800 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55804 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(55846), // Rule ID 1702 //
     /*  55809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55820 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55831 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  55831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSrm),
     /*  55834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55836 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55844 */     GIR_RootConstrainSelectedInstOperands,
     /*  55845 */     // GIR_Coverage, 1702,
     /*  55845 */     GIR_EraseRootFromParent_Done,
     /*  55846 */   // Label 1347: @55846
     /*  55846 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(55884), // Rule ID 1704 //
     /*  55851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55869 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  55869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSrm),
     /*  55872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55874 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55882 */     GIR_RootConstrainSelectedInstOperands,
     /*  55883 */     // GIR_Coverage, 1704,
     /*  55883 */     GIR_EraseRootFromParent_Done,
     /*  55884 */   // Label 1348: @55884
     /*  55884 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(55926), // Rule ID 1710 //
     /*  55889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  55892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55900 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55911 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  55911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  55914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55916 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55924 */     GIR_RootConstrainSelectedInstOperands,
     /*  55925 */     // GIR_Coverage, 1710,
     /*  55925 */     GIR_EraseRootFromParent_Done,
     /*  55926 */   // Label 1349: @55926
     /*  55926 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(55964), // Rule ID 1711 //
     /*  55931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  55934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55949 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  55949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  55952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55954 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55962 */     GIR_RootConstrainSelectedInstOperands,
     /*  55963 */     // GIR_Coverage, 1711,
     /*  55963 */     GIR_EraseRootFromParent_Done,
     /*  55964 */   // Label 1350: @55964
     /*  55964 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(56006), // Rule ID 4471 //
     /*  55969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55980 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55991 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  55991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rm),
     /*  55994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55996 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56004 */     GIR_RootConstrainSelectedInstOperands,
     /*  56005 */     // GIR_Coverage, 4471,
     /*  56005 */     GIR_EraseRootFromParent_Done,
     /*  56006 */   // Label 1351: @56006
     /*  56006 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(56044), // Rule ID 4502 //
     /*  56011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56018 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56029 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128rm),
     /*  56032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56034 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56042 */     GIR_RootConstrainSelectedInstOperands,
     /*  56043 */     // GIR_Coverage, 4502,
     /*  56043 */     GIR_EraseRootFromParent_Done,
     /*  56044 */   // Label 1352: @56044
     /*  56044 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(56086), // Rule ID 17939 //
     /*  56049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56060 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56071 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  56074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56084 */     GIR_RootConstrainSelectedInstOperands,
     /*  56085 */     // GIR_Coverage, 17939,
     /*  56085 */     GIR_EraseRootFromParent_Done,
     /*  56086 */   // Label 1353: @56086
     /*  56086 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(56124), // Rule ID 17943 //
     /*  56091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56109 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  56112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56114 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56122 */     GIR_RootConstrainSelectedInstOperands,
     /*  56123 */     // GIR_Coverage, 17943,
     /*  56123 */     GIR_EraseRootFromParent_Done,
     /*  56124 */   // Label 1354: @56124
     /*  56124 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(56166), // Rule ID 18318 //
     /*  56129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56140 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56151 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  56154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56156 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56164 */     GIR_RootConstrainSelectedInstOperands,
     /*  56165 */     // GIR_Coverage, 18318,
     /*  56165 */     GIR_EraseRootFromParent_Done,
     /*  56166 */   // Label 1355: @56166
     /*  56166 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(56204), // Rule ID 18322 //
     /*  56171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56189 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  56192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56194 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56202 */     GIR_RootConstrainSelectedInstOperands,
     /*  56203 */     // GIR_Coverage, 18322,
     /*  56203 */     GIR_EraseRootFromParent_Done,
     /*  56204 */   // Label 1356: @56204
     /*  56204 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(56246), // Rule ID 19811 //
     /*  56209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  56212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56220 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56231 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  56234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56236 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56244 */     GIR_RootConstrainSelectedInstOperands,
     /*  56245 */     // GIR_Coverage, 19811,
     /*  56245 */     GIR_EraseRootFromParent_Done,
     /*  56246 */   // Label 1357: @56246
     /*  56246 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(56284), // Rule ID 19815 //
     /*  56251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  56254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56269 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  56272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56274 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56282 */     GIR_RootConstrainSelectedInstOperands,
     /*  56283 */     // GIR_Coverage, 19815,
     /*  56283 */     GIR_EraseRootFromParent_Done,
     /*  56284 */   // Label 1358: @56284
     /*  56284 */   GIM_Reject,
     /*  56285 */ // Label 1346: @56285
     /*  56285 */ GIM_Reject,
     /*  56286 */ // Label 1277: @56286
     /*  56286 */ GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(56619),
     /*  56291 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56294 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56298 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(56340), // Rule ID 1707 //
     /*  56303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56314 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56325 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDYrm),
     /*  56328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56330 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56338 */     GIR_RootConstrainSelectedInstOperands,
     /*  56339 */     // GIR_Coverage, 1707,
     /*  56339 */     GIR_EraseRootFromParent_Done,
     /*  56340 */   // Label 1360: @56340
     /*  56340 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(56378), // Rule ID 1709 //
     /*  56345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56363 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDYrm),
     /*  56366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56368 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56376 */     GIR_RootConstrainSelectedInstOperands,
     /*  56377 */     // GIR_Coverage, 1709,
     /*  56377 */     GIR_EraseRootFromParent_Done,
     /*  56378 */   // Label 1361: @56378
     /*  56378 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(56420), // Rule ID 4484 //
     /*  56383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56394 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56405 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rm),
     /*  56408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56410 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56418 */     GIR_RootConstrainSelectedInstOperands,
     /*  56419 */     // GIR_Coverage, 4484,
     /*  56419 */     GIR_EraseRootFromParent_Done,
     /*  56420 */   // Label 1362: @56420
     /*  56420 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(56458), // Rule ID 4511 //
     /*  56425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56443 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ256rm),
     /*  56446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56448 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56456 */     GIR_RootConstrainSelectedInstOperands,
     /*  56457 */     // GIR_Coverage, 4511,
     /*  56457 */     GIR_EraseRootFromParent_Done,
     /*  56458 */   // Label 1363: @56458
     /*  56458 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(56500), // Rule ID 4538 //
     /*  56463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56474 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56485 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  56488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56490 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56498 */     GIR_RootConstrainSelectedInstOperands,
     /*  56499 */     // GIR_Coverage, 4538,
     /*  56499 */     GIR_EraseRootFromParent_Done,
     /*  56500 */   // Label 1364: @56500
     /*  56500 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(56538), // Rule ID 4583 //
     /*  56505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56523 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  56526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56528 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56536 */     GIR_RootConstrainSelectedInstOperands,
     /*  56537 */     // GIR_Coverage, 4583,
     /*  56537 */     GIR_EraseRootFromParent_Done,
     /*  56538 */   // Label 1365: @56538
     /*  56538 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(56580), // Rule ID 17914 //
     /*  56543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56554 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56565 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  56568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56570 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56578 */     GIR_RootConstrainSelectedInstOperands,
     /*  56579 */     // GIR_Coverage, 17914,
     /*  56579 */     GIR_EraseRootFromParent_Done,
     /*  56580 */   // Label 1366: @56580
     /*  56580 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(56618), // Rule ID 17918 //
     /*  56585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56603 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  56606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56608 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56616 */     GIR_RootConstrainSelectedInstOperands,
     /*  56617 */     // GIR_Coverage, 17918,
     /*  56617 */     GIR_EraseRootFromParent_Done,
     /*  56618 */   // Label 1367: @56618
     /*  56618 */   GIM_Reject,
     /*  56619 */ // Label 1359: @56619
     /*  56619 */ GIM_Reject,
     /*  56620 */ // Label 1278: @56620
     /*  56620 */ GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(56701),
     /*  56625 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56628 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  56636 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56640 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(56670), // Rule ID 4394 //
     /*  56645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoEGPR),
     /*  56648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56655 */     // (ld:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)
     /*  56655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  56658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56660 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56668 */     GIR_RootConstrainSelectedInstOperands,
     /*  56669 */     // GIR_Coverage, 4394,
     /*  56669 */     GIR_EraseRootFromParent_Done,
     /*  56670 */   // Label 1369: @56670
     /*  56670 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(56700), // Rule ID 4396 //
     /*  56675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEGPR_In64BitMode),
     /*  56678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56685 */     // (ld:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVBkm_EVEX:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)
     /*  56685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBkm_EVEX),
     /*  56688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56690 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56698 */     GIR_RootConstrainSelectedInstOperands,
     /*  56699 */     // GIR_Coverage, 4396,
     /*  56699 */     GIR_EraseRootFromParent_Done,
     /*  56700 */   // Label 1370: @56700
     /*  56700 */   GIM_Reject,
     /*  56701 */ // Label 1368: @56701
     /*  56701 */ GIM_Reject,
     /*  56702 */ // Label 1279: @56702
     /*  56702 */ GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(57275),
     /*  56707 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56710 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56714 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(56756), // Rule ID 17930 //
     /*  56719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56730 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56741 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  56741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSrm),
     /*  56744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56746 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56754 */     GIR_RootConstrainSelectedInstOperands,
     /*  56755 */     // GIR_Coverage, 17930,
     /*  56755 */     GIR_EraseRootFromParent_Done,
     /*  56756 */   // Label 1372: @56756
     /*  56756 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(56794), // Rule ID 17931 //
     /*  56761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56779 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  56779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSrm),
     /*  56782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56784 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56792 */     GIR_RootConstrainSelectedInstOperands,
     /*  56793 */     // GIR_Coverage, 17931,
     /*  56793 */     GIR_EraseRootFromParent_Done,
     /*  56794 */   // Label 1373: @56794
     /*  56794 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(56836), // Rule ID 17940 //
     /*  56799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56810 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56821 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  56821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  56824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56826 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56834 */     GIR_RootConstrainSelectedInstOperands,
     /*  56835 */     // GIR_Coverage, 17940,
     /*  56835 */     GIR_EraseRootFromParent_Done,
     /*  56836 */   // Label 1374: @56836
     /*  56836 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(56874), // Rule ID 17944 //
     /*  56841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56859 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  56859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  56862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56864 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56872 */     GIR_RootConstrainSelectedInstOperands,
     /*  56873 */     // GIR_Coverage, 17944,
     /*  56873 */     GIR_EraseRootFromParent_Done,
     /*  56874 */   // Label 1375: @56874
     /*  56874 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(56916), // Rule ID 17954 //
     /*  56879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  56882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56890 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56901 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  56901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  56904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56906 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56914 */     GIR_RootConstrainSelectedInstOperands,
     /*  56915 */     // GIR_Coverage, 17954,
     /*  56915 */     GIR_EraseRootFromParent_Done,
     /*  56916 */   // Label 1376: @56916
     /*  56916 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(56954), // Rule ID 17955 //
     /*  56921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  56924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56939 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  56939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  56942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56944 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56952 */     GIR_RootConstrainSelectedInstOperands,
     /*  56953 */     // GIR_Coverage, 17955,
     /*  56953 */     GIR_EraseRootFromParent_Done,
     /*  56954 */   // Label 1377: @56954
     /*  56954 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(56996), // Rule ID 18319 //
     /*  56959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56970 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56981 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  56981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  56984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56986 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56994 */     GIR_RootConstrainSelectedInstOperands,
     /*  56995 */     // GIR_Coverage, 18319,
     /*  56995 */     GIR_EraseRootFromParent_Done,
     /*  56996 */   // Label 1378: @56996
     /*  56996 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(57038), // Rule ID 18320 //
     /*  57001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57012 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57023 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  57026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57028 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57036 */     GIR_RootConstrainSelectedInstOperands,
     /*  57037 */     // GIR_Coverage, 18320,
     /*  57037 */     GIR_EraseRootFromParent_Done,
     /*  57038 */   // Label 1379: @57038
     /*  57038 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(57076), // Rule ID 18323 //
     /*  57043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57061 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  57064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57066 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57074 */     GIR_RootConstrainSelectedInstOperands,
     /*  57075 */     // GIR_Coverage, 18323,
     /*  57075 */     GIR_EraseRootFromParent_Done,
     /*  57076 */   // Label 1380: @57076
     /*  57076 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(57114), // Rule ID 18324 //
     /*  57081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57099 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  57102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57104 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57112 */     GIR_RootConstrainSelectedInstOperands,
     /*  57113 */     // GIR_Coverage, 18324,
     /*  57113 */     GIR_EraseRootFromParent_Done,
     /*  57114 */   // Label 1381: @57114
     /*  57114 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(57156), // Rule ID 19812 //
     /*  57119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57130 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57141 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  57144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57146 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57154 */     GIR_RootConstrainSelectedInstOperands,
     /*  57155 */     // GIR_Coverage, 19812,
     /*  57155 */     GIR_EraseRootFromParent_Done,
     /*  57156 */   // Label 1382: @57156
     /*  57156 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(57198), // Rule ID 19813 //
     /*  57161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57172 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57183 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rm),
     /*  57186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57188 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57196 */     GIR_RootConstrainSelectedInstOperands,
     /*  57197 */     // GIR_Coverage, 19813,
     /*  57197 */     GIR_EraseRootFromParent_Done,
     /*  57198 */   // Label 1383: @57198
     /*  57198 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(57236), // Rule ID 19816 //
     /*  57203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57221 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  57224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57226 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57234 */     GIR_RootConstrainSelectedInstOperands,
     /*  57235 */     // GIR_Coverage, 19816,
     /*  57235 */     GIR_EraseRootFromParent_Done,
     /*  57236 */   // Label 1384: @57236
     /*  57236 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(57274), // Rule ID 19817 //
     /*  57241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57259 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128rm),
     /*  57262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57264 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57272 */     GIR_RootConstrainSelectedInstOperands,
     /*  57273 */     // GIR_Coverage, 19817,
     /*  57273 */     GIR_EraseRootFromParent_Done,
     /*  57274 */   // Label 1385: @57274
     /*  57274 */   GIM_Reject,
     /*  57275 */ // Label 1371: @57275
     /*  57275 */ GIM_Reject,
     /*  57276 */ // Label 1280: @57276
     /*  57276 */ GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(57609),
     /*  57281 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  57284 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  57288 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(57330), // Rule ID 1706 //
     /*  57293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57300 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57304 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57315 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  57318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57320 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57328 */     GIR_RootConstrainSelectedInstOperands,
     /*  57329 */     // GIR_Coverage, 1706,
     /*  57329 */     GIR_EraseRootFromParent_Done,
     /*  57330 */   // Label 1387: @57330
     /*  57330 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(57368), // Rule ID 1708 //
     /*  57335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57353 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  57356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57358 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57366 */     GIR_RootConstrainSelectedInstOperands,
     /*  57367 */     // GIR_Coverage, 1708,
     /*  57367 */     GIR_EraseRootFromParent_Done,
     /*  57368 */   // Label 1388: @57368
     /*  57368 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(57410), // Rule ID 4466 //
     /*  57373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  57376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57384 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57395 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rm),
     /*  57398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57400 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57408 */     GIR_RootConstrainSelectedInstOperands,
     /*  57409 */     // GIR_Coverage, 4466,
     /*  57409 */     GIR_EraseRootFromParent_Done,
     /*  57410 */   // Label 1389: @57410
     /*  57410 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(57448), // Rule ID 4499 //
     /*  57415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  57418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57433 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256rm),
     /*  57436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57438 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57446 */     GIR_RootConstrainSelectedInstOperands,
     /*  57447 */     // GIR_Coverage, 4499,
     /*  57447 */     GIR_EraseRootFromParent_Done,
     /*  57448 */   // Label 1390: @57448
     /*  57448 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(57490), // Rule ID 17915 //
     /*  57453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57464 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57475 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  57478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57480 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57488 */     GIR_RootConstrainSelectedInstOperands,
     /*  57489 */     // GIR_Coverage, 17915,
     /*  57489 */     GIR_EraseRootFromParent_Done,
     /*  57490 */   // Label 1391: @57490
     /*  57490 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(57528), // Rule ID 17919 //
     /*  57495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57513 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  57516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57518 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57526 */     GIR_RootConstrainSelectedInstOperands,
     /*  57527 */     // GIR_Coverage, 17919,
     /*  57527 */     GIR_EraseRootFromParent_Done,
     /*  57528 */   // Label 1392: @57528
     /*  57528 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(57570), // Rule ID 19827 //
     /*  57533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57544 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57555 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  57558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57560 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57568 */     GIR_RootConstrainSelectedInstOperands,
     /*  57569 */     // GIR_Coverage, 19827,
     /*  57569 */     GIR_EraseRootFromParent_Done,
     /*  57570 */   // Label 1393: @57570
     /*  57570 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(57608), // Rule ID 19831 //
     /*  57575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57593 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  57596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57598 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57606 */     GIR_RootConstrainSelectedInstOperands,
     /*  57607 */     // GIR_Coverage, 19831,
     /*  57607 */     GIR_EraseRootFromParent_Done,
     /*  57608 */   // Label 1394: @57608
     /*  57608 */   GIM_Reject,
     /*  57609 */ // Label 1386: @57609
     /*  57609 */ GIM_Reject,
     /*  57610 */ // Label 1281: @57610
     /*  57610 */ GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(57783),
     /*  57615 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  57618 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  57622 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(57664), // Rule ID 4479 //
     /*  57627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57638 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57649 */     // (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /*  57649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrm),
     /*  57652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57654 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57662 */     GIR_RootConstrainSelectedInstOperands,
     /*  57663 */     // GIR_Coverage, 4479,
     /*  57663 */     GIR_EraseRootFromParent_Done,
     /*  57664 */   // Label 1396: @57664
     /*  57664 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(57702), // Rule ID 4508 //
     /*  57669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57687 */     // (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /*  57687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZrm),
     /*  57690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57692 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57700 */     GIR_RootConstrainSelectedInstOperands,
     /*  57701 */     // GIR_Coverage, 4508,
     /*  57701 */     GIR_EraseRootFromParent_Done,
     /*  57702 */   // Label 1397: @57702
     /*  57702 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(57744), // Rule ID 4533 //
     /*  57707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57718 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57729 */     // (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  57729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  57732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57734 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57742 */     GIR_RootConstrainSelectedInstOperands,
     /*  57743 */     // GIR_Coverage, 4533,
     /*  57743 */     GIR_EraseRootFromParent_Done,
     /*  57744 */   // Label 1398: @57744
     /*  57744 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(57782), // Rule ID 4580 //
     /*  57749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57756 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57767 */     // (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  57767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  57770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57772 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57780 */     GIR_RootConstrainSelectedInstOperands,
     /*  57781 */     // GIR_Coverage, 4580,
     /*  57781 */     GIR_EraseRootFromParent_Done,
     /*  57782 */   // Label 1399: @57782
     /*  57782 */   GIM_Reject,
     /*  57783 */ // Label 1395: @57783
     /*  57783 */ GIM_Reject,
     /*  57784 */ // Label 1282: @57784
     /*  57784 */ GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(57865),
     /*  57789 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  57792 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  57796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  57800 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57804 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(57834), // Rule ID 4398 //
     /*  57809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoEGPR),
     /*  57812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57819 */     // (ld:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVWkm:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)
     /*  57819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWkm),
     /*  57822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57824 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57832 */     GIR_RootConstrainSelectedInstOperands,
     /*  57833 */     // GIR_Coverage, 4398,
     /*  57833 */     GIR_EraseRootFromParent_Done,
     /*  57834 */   // Label 1401: @57834
     /*  57834 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(57864), // Rule ID 4400 //
     /*  57839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEGPR_In64BitMode),
     /*  57842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57849 */     // (ld:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVWkm_EVEX:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)
     /*  57849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWkm_EVEX),
     /*  57852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57854 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57862 */     GIR_RootConstrainSelectedInstOperands,
     /*  57863 */     // GIR_Coverage, 4400,
     /*  57863 */     GIR_EraseRootFromParent_Done,
     /*  57864 */   // Label 1402: @57864
     /*  57864 */   GIM_Reject,
     /*  57865 */ // Label 1400: @57865
     /*  57865 */ GIM_Reject,
     /*  57866 */ // Label 1283: @57866
     /*  57866 */ GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(58119),
     /*  57871 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  57874 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  57878 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(57920), // Rule ID 17941 //
     /*  57883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  57886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57894 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57905 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  57905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  57908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57910 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57918 */     GIR_RootConstrainSelectedInstOperands,
     /*  57919 */     // GIR_Coverage, 17941,
     /*  57919 */     GIR_EraseRootFromParent_Done,
     /*  57920 */   // Label 1404: @57920
     /*  57920 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(57958), // Rule ID 17945 //
     /*  57925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  57928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57943 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  57943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  57946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57948 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57956 */     GIR_RootConstrainSelectedInstOperands,
     /*  57957 */     // GIR_Coverage, 17945,
     /*  57957 */     GIR_EraseRootFromParent_Done,
     /*  57958 */   // Label 1405: @57958
     /*  57958 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(58000), // Rule ID 18321 //
     /*  57963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57974 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57985 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  57985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  57988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57990 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57998 */     GIR_RootConstrainSelectedInstOperands,
     /*  57999 */     // GIR_Coverage, 18321,
     /*  57999 */     GIR_EraseRootFromParent_Done,
     /*  58000 */   // Label 1406: @58000
     /*  58000 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(58038), // Rule ID 18325 //
     /*  58005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  58012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58023 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  58026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58028 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58036 */     GIR_RootConstrainSelectedInstOperands,
     /*  58037 */     // GIR_Coverage, 18325,
     /*  58037 */     GIR_EraseRootFromParent_Done,
     /*  58038 */   // Label 1407: @58038
     /*  58038 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(58080), // Rule ID 19814 //
     /*  58043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  58050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58054 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58065 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  58068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58070 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58078 */     GIR_RootConstrainSelectedInstOperands,
     /*  58079 */     // GIR_Coverage, 19814,
     /*  58079 */     GIR_EraseRootFromParent_Done,
     /*  58080 */   // Label 1408: @58080
     /*  58080 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(58118), // Rule ID 19818 //
     /*  58085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  58092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58103 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  58106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58108 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58116 */     GIR_RootConstrainSelectedInstOperands,
     /*  58117 */     // GIR_Coverage, 19818,
     /*  58117 */     GIR_EraseRootFromParent_Done,
     /*  58118 */   // Label 1409: @58118
     /*  58118 */   GIM_Reject,
     /*  58119 */ // Label 1403: @58119
     /*  58119 */ GIM_Reject,
     /*  58120 */ // Label 1284: @58120
     /*  58120 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(58453),
     /*  58125 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58128 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58132 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(58174), // Rule ID 17916 //
     /*  58137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58148 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58159 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  58162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58164 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58172 */     GIR_RootConstrainSelectedInstOperands,
     /*  58173 */     // GIR_Coverage, 17916,
     /*  58173 */     GIR_EraseRootFromParent_Done,
     /*  58174 */   // Label 1411: @58174
     /*  58174 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(58212), // Rule ID 17920 //
     /*  58179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58197 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  58200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58202 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58210 */     GIR_RootConstrainSelectedInstOperands,
     /*  58211 */     // GIR_Coverage, 17920,
     /*  58211 */     GIR_EraseRootFromParent_Done,
     /*  58212 */   // Label 1412: @58212
     /*  58212 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(58254), // Rule ID 17934 //
     /*  58217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58228 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58239 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  58242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58244 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58252 */     GIR_RootConstrainSelectedInstOperands,
     /*  58253 */     // GIR_Coverage, 17934,
     /*  58253 */     GIR_EraseRootFromParent_Done,
     /*  58254 */   // Label 1413: @58254
     /*  58254 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(58292), // Rule ID 17935 //
     /*  58259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58277 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  58280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58282 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58290 */     GIR_RootConstrainSelectedInstOperands,
     /*  58291 */     // GIR_Coverage, 17935,
     /*  58291 */     GIR_EraseRootFromParent_Done,
     /*  58292 */   // Label 1414: @58292
     /*  58292 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(58334), // Rule ID 19828 //
     /*  58297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58308 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58319 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  58322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58324 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58332 */     GIR_RootConstrainSelectedInstOperands,
     /*  58333 */     // GIR_Coverage, 19828,
     /*  58333 */     GIR_EraseRootFromParent_Done,
     /*  58334 */   // Label 1415: @58334
     /*  58334 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(58376), // Rule ID 19829 //
     /*  58339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58350 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58361 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rm),
     /*  58364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58366 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58374 */     GIR_RootConstrainSelectedInstOperands,
     /*  58375 */     // GIR_Coverage, 19829,
     /*  58375 */     GIR_EraseRootFromParent_Done,
     /*  58376 */   // Label 1416: @58376
     /*  58376 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(58414), // Rule ID 19832 //
     /*  58381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58399 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  58402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58404 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58412 */     GIR_RootConstrainSelectedInstOperands,
     /*  58413 */     // GIR_Coverage, 19832,
     /*  58413 */     GIR_EraseRootFromParent_Done,
     /*  58414 */   // Label 1417: @58414
     /*  58414 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(58452), // Rule ID 19833 //
     /*  58419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58437 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256rm),
     /*  58440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58442 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58450 */     GIR_RootConstrainSelectedInstOperands,
     /*  58451 */     // GIR_Coverage, 19833,
     /*  58451 */     GIR_EraseRootFromParent_Done,
     /*  58452 */   // Label 1418: @58452
     /*  58452 */   GIM_Reject,
     /*  58453 */ // Label 1410: @58453
     /*  58453 */ GIM_Reject,
     /*  58454 */ // Label 1285: @58454
     /*  58454 */ GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(58627),
     /*  58459 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58462 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58466 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(58508), // Rule ID 4461 //
     /*  58471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58482 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58493 */     // (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /*  58493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrm),
     /*  58496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58506 */     GIR_RootConstrainSelectedInstOperands,
     /*  58507 */     // GIR_Coverage, 4461,
     /*  58507 */     GIR_EraseRootFromParent_Done,
     /*  58508 */   // Label 1420: @58508
     /*  58508 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(58546), // Rule ID 4496 //
     /*  58513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58531 */     // (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /*  58531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZrm),
     /*  58534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58536 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58544 */     GIR_RootConstrainSelectedInstOperands,
     /*  58545 */     // GIR_Coverage, 4496,
     /*  58545 */     GIR_EraseRootFromParent_Done,
     /*  58546 */   // Label 1421: @58546
     /*  58546 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(58588), // Rule ID 19795 //
     /*  58551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58562 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58573 */     // (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  58573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  58576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58578 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58586 */     GIR_RootConstrainSelectedInstOperands,
     /*  58587 */     // GIR_Coverage, 19795,
     /*  58587 */     GIR_EraseRootFromParent_Done,
     /*  58588 */   // Label 1422: @58588
     /*  58588 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(58626), // Rule ID 19799 //
     /*  58593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58611 */     // (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  58611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  58614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58616 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58624 */     GIR_RootConstrainSelectedInstOperands,
     /*  58625 */     // GIR_Coverage, 19799,
     /*  58625 */     GIR_EraseRootFromParent_Done,
     /*  58626 */   // Label 1423: @58626
     /*  58626 */   GIM_Reject,
     /*  58627 */ // Label 1419: @58627
     /*  58627 */ GIM_Reject,
     /*  58628 */ // Label 1286: @58628
     /*  58628 */ GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(58709),
     /*  58633 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58636 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  58644 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58648 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(58678), // Rule ID 4402 //
     /*  58653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  58656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58663 */     // (ld:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVDkm:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)
     /*  58663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDkm),
     /*  58666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58668 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58676 */     GIR_RootConstrainSelectedInstOperands,
     /*  58677 */     // GIR_Coverage, 4402,
     /*  58677 */     GIR_EraseRootFromParent_Done,
     /*  58678 */   // Label 1425: @58678
     /*  58678 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(58708), // Rule ID 4406 //
     /*  58683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  58686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58693 */     // (ld:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVDkm_EVEX:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)
     /*  58693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDkm_EVEX),
     /*  58696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58698 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58706 */     GIR_RootConstrainSelectedInstOperands,
     /*  58707 */     // GIR_Coverage, 4406,
     /*  58707 */     GIR_EraseRootFromParent_Done,
     /*  58708 */   // Label 1426: @58708
     /*  58708 */   GIM_Reject,
     /*  58709 */ // Label 1424: @58709
     /*  58709 */ GIM_Reject,
     /*  58710 */ // Label 1287: @58710
     /*  58710 */ GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(58883),
     /*  58715 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58718 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58722 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(58764), // Rule ID 17917 //
     /*  58727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58738 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58749 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  58749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  58752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58754 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58762 */     GIR_RootConstrainSelectedInstOperands,
     /*  58763 */     // GIR_Coverage, 17917,
     /*  58763 */     GIR_EraseRootFromParent_Done,
     /*  58764 */   // Label 1428: @58764
     /*  58764 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(58802), // Rule ID 17921 //
     /*  58769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58787 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  58787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  58790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58792 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58800 */     GIR_RootConstrainSelectedInstOperands,
     /*  58801 */     // GIR_Coverage, 17921,
     /*  58801 */     GIR_EraseRootFromParent_Done,
     /*  58802 */   // Label 1429: @58802
     /*  58802 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(58844), // Rule ID 19830 //
     /*  58807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58818 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58829 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  58829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  58832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58834 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58842 */     GIR_RootConstrainSelectedInstOperands,
     /*  58843 */     // GIR_Coverage, 19830,
     /*  58843 */     GIR_EraseRootFromParent_Done,
     /*  58844 */   // Label 1430: @58844
     /*  58844 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(58882), // Rule ID 19834 //
     /*  58849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58867 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  58867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  58870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58872 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58880 */     GIR_RootConstrainSelectedInstOperands,
     /*  58881 */     // GIR_Coverage, 19834,
     /*  58881 */     GIR_EraseRootFromParent_Done,
     /*  58882 */   // Label 1431: @58882
     /*  58882 */   GIM_Reject,
     /*  58883 */ // Label 1427: @58883
     /*  58883 */ GIM_Reject,
     /*  58884 */ // Label 1288: @58884
     /*  58884 */ GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(59057),
     /*  58889 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58892 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58896 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(58938), // Rule ID 19796 //
     /*  58901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58912 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58923 */     // (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /*  58923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  58926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58928 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58936 */     GIR_RootConstrainSelectedInstOperands,
     /*  58937 */     // GIR_Coverage, 19796,
     /*  58937 */     GIR_EraseRootFromParent_Done,
     /*  58938 */   // Label 1433: @58938
     /*  58938 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(58980), // Rule ID 19797 //
     /*  58943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58954 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58965 */     // (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /*  58965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrm),
     /*  58968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58970 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58978 */     GIR_RootConstrainSelectedInstOperands,
     /*  58979 */     // GIR_Coverage, 19797,
     /*  58979 */     GIR_EraseRootFromParent_Done,
     /*  58980 */   // Label 1434: @58980
     /*  58980 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(59018), // Rule ID 19800 //
     /*  58985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59003 */     // (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /*  59003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  59006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59008 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59016 */     GIR_RootConstrainSelectedInstOperands,
     /*  59017 */     // GIR_Coverage, 19800,
     /*  59017 */     GIR_EraseRootFromParent_Done,
     /*  59018 */   // Label 1435: @59018
     /*  59018 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(59056), // Rule ID 19801 //
     /*  59023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59041 */     // (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /*  59041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZrm),
     /*  59044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59046 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59054 */     GIR_RootConstrainSelectedInstOperands,
     /*  59055 */     // GIR_Coverage, 19801,
     /*  59055 */     GIR_EraseRootFromParent_Done,
     /*  59056 */   // Label 1436: @59056
     /*  59056 */   GIM_Reject,
     /*  59057 */ // Label 1432: @59057
     /*  59057 */ GIM_Reject,
     /*  59058 */ // Label 1289: @59058
     /*  59058 */ GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(59139),
     /*  59063 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59066 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  59070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  59074 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59078 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(59108), // Rule ID 4404 //
     /*  59083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  59086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59093 */     // (ld:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVQkm:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)
     /*  59093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQkm),
     /*  59096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59098 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59106 */     GIR_RootConstrainSelectedInstOperands,
     /*  59107 */     // GIR_Coverage, 4404,
     /*  59107 */     GIR_EraseRootFromParent_Done,
     /*  59108 */   // Label 1438: @59108
     /*  59108 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(59138), // Rule ID 4408 //
     /*  59113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  59116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59123 */     // (ld:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVQkm_EVEX:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)
     /*  59123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQkm_EVEX),
     /*  59126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59128 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59136 */     GIR_RootConstrainSelectedInstOperands,
     /*  59137 */     // GIR_Coverage, 4408,
     /*  59137 */     GIR_EraseRootFromParent_Done,
     /*  59138 */   // Label 1439: @59138
     /*  59138 */   GIM_Reject,
     /*  59139 */ // Label 1437: @59139
     /*  59139 */ GIM_Reject,
     /*  59140 */ // Label 1290: @59140
     /*  59140 */ GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(59233),
     /*  59145 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59148 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  59152 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(59194), // Rule ID 19798 //
     /*  59157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59168 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  59172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59179 */     // (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)
     /*  59179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  59182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59184 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59192 */     GIR_RootConstrainSelectedInstOperands,
     /*  59193 */     // GIR_Coverage, 19798,
     /*  59193 */     GIR_EraseRootFromParent_Done,
     /*  59194 */   // Label 1441: @59194
     /*  59194 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(59232), // Rule ID 19802 //
     /*  59199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59206 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59217 */     // (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)
     /*  59217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  59220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59222 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59230 */     GIR_RootConstrainSelectedInstOperands,
     /*  59231 */     // GIR_Coverage, 19802,
     /*  59231 */     GIR_EraseRootFromParent_Done,
     /*  59232 */   // Label 1442: @59232
     /*  59232 */   GIM_Reject,
     /*  59233 */ // Label 1440: @59233
     /*  59233 */ GIM_Reject,
     /*  59234 */ // Label 1291: @59234
     /*  59234 */ GIM_Reject,
     /*  59235 */ // Label 11: @59235
     /*  59235 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 1446*/ GIMT_Encode4(59567),
     /*  59246 */ /*GILLT_s16*//*Label 1443*/ GIMT_Encode4(59258),
     /*  59250 */ /*GILLT_s32*//*Label 1444*/ GIMT_Encode4(59334),
     /*  59254 */ /*GILLT_s64*//*Label 1445*/ GIMT_Encode4(59428),
     /*  59258 */ // Label 1443: @59258
     /*  59258 */ GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(59333), // Rule ID 22645 //
     /*  59263 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59266 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  59277 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59281 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59288 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  59288 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  59291 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rm8),
     /*  59295 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59300 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  59304 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59315 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  59322 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  59327 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  59332 */   // GIR_Coverage, 22645,
     /*  59332 */   GIR_EraseRootFromParent_Done,
     /*  59333 */ // Label 1447: @59333
     /*  59333 */ GIM_Reject,
     /*  59334 */ // Label 1444: @59334
     /*  59334 */ GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(59427),
     /*  59339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59342 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(59384), // Rule ID 615 //
     /*  59347 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59369 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (MOVSX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rm8),
     /*  59372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59374 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59382 */     GIR_RootConstrainSelectedInstOperands,
     /*  59383 */     // GIR_Coverage, 615,
     /*  59383 */     GIR_EraseRootFromParent_Done,
     /*  59384 */   // Label 1449: @59384
     /*  59384 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(59426), // Rule ID 617 //
     /*  59389 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  59396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59411 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (MOVSX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rm16),
     /*  59414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59416 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59424 */     GIR_RootConstrainSelectedInstOperands,
     /*  59425 */     // GIR_Coverage, 617,
     /*  59425 */     GIR_EraseRootFromParent_Done,
     /*  59426 */   // Label 1450: @59426
     /*  59426 */   GIM_Reject,
     /*  59427 */ // Label 1448: @59427
     /*  59427 */ GIM_Reject,
     /*  59428 */ // Label 1445: @59428
     /*  59428 */ GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(59566),
     /*  59433 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59436 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(59478), // Rule ID 623 //
     /*  59441 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59463 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (MOVSX64rm8:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  59463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX64rm8),
     /*  59466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59468 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59476 */     GIR_RootConstrainSelectedInstOperands,
     /*  59477 */     // GIR_Coverage, 623,
     /*  59477 */     GIR_EraseRootFromParent_Done,
     /*  59478 */   // Label 1452: @59478
     /*  59478 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(59520), // Rule ID 625 //
     /*  59483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  59490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59505 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (MOVSX64rm16:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  59505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX64rm16),
     /*  59508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59510 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59518 */     GIR_RootConstrainSelectedInstOperands,
     /*  59519 */     // GIR_Coverage, 625,
     /*  59519 */     GIR_EraseRootFromParent_Done,
     /*  59520 */   // Label 1453: @59520
     /*  59520 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(59565), // Rule ID 627 //
     /*  59525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  59528 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  59535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59550 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (MOVSX64rm32:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  59550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX64rm32),
     /*  59553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59563 */     GIR_RootConstrainSelectedInstOperands,
     /*  59564 */     // GIR_Coverage, 627,
     /*  59564 */     GIR_EraseRootFromParent_Done,
     /*  59565 */   // Label 1454: @59565
     /*  59565 */   GIM_Reject,
     /*  59566 */ // Label 1451: @59566
     /*  59566 */ GIM_Reject,
     /*  59567 */ // Label 1446: @59567
     /*  59567 */ GIM_Reject,
     /*  59568 */ // Label 12: @59568
     /*  59568 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1459*/ GIMT_Encode4(60222),
     /*  59579 */ /*GILLT_s8*//*Label 1455*/ GIMT_Encode4(59595),
     /*  59583 */ /*GILLT_s16*//*Label 1456*/ GIMT_Encode4(59641),
     /*  59587 */ /*GILLT_s32*//*Label 1457*/ GIMT_Encode4(59780),
     /*  59591 */ /*GILLT_s64*//*Label 1458*/ GIMT_Encode4(59916),
     /*  59595 */ // Label 1455: @59595
     /*  59595 */ GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(59640), // Rule ID 22573 //
     /*  59600 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59603 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  59614 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59618 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59625 */   // (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  59625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  59628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59630 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59634 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59638 */   GIR_RootConstrainSelectedInstOperands,
     /*  59639 */   // GIR_Coverage, 22573,
     /*  59639 */   GIR_EraseRootFromParent_Done,
     /*  59640 */ // Label 1460: @59640
     /*  59640 */ GIM_Reject,
     /*  59641 */ // Label 1456: @59641
     /*  59641 */ GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(59779),
     /*  59646 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59649 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  59660 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59664 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(59721), // Rule ID 22574 //
     /*  59669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59676 */     // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  59676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  59679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  59683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59688 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  59692 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59703 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  59710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  59715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  59720 */     // GIR_Coverage, 22574,
     /*  59720 */     GIR_EraseRootFromParent_Done,
     /*  59721 */   // Label 1462: @59721
     /*  59721 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(59778), // Rule ID 22647 //
     /*  59726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59733 */     // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  59733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  59736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  59740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59745 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  59749 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59760 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  59767 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  59772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  59777 */     // GIR_Coverage, 22647,
     /*  59777 */     GIR_EraseRootFromParent_Done,
     /*  59778 */   // Label 1463: @59778
     /*  59778 */   GIM_Reject,
     /*  59779 */ // Label 1461: @59779
     /*  59779 */ GIM_Reject,
     /*  59780 */ // Label 1457: @59780
     /*  59780 */ GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(59915),
     /*  59785 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59788 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(59830), // Rule ID 619 //
     /*  59793 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59815 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  59818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59820 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59828 */     GIR_RootConstrainSelectedInstOperands,
     /*  59829 */     // GIR_Coverage, 619,
     /*  59829 */     GIR_EraseRootFromParent_Done,
     /*  59830 */   // Label 1465: @59830
     /*  59830 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(59872), // Rule ID 621 //
     /*  59835 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  59842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59857 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  59860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59862 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59870 */     GIR_RootConstrainSelectedInstOperands,
     /*  59871 */     // GIR_Coverage, 621,
     /*  59871 */     GIR_EraseRootFromParent_Done,
     /*  59872 */   // Label 1466: @59872
     /*  59872 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(59914), // Rule ID 22575 //
     /*  59877 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59899 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  59902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59904 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59912 */     GIR_RootConstrainSelectedInstOperands,
     /*  59913 */     // GIR_Coverage, 22575,
     /*  59913 */     GIR_EraseRootFromParent_Done,
     /*  59914 */   // Label 1467: @59914
     /*  59914 */   GIM_Reject,
     /*  59915 */ // Label 1464: @59915
     /*  59915 */ GIM_Reject,
     /*  59916 */ // Label 1458: @59916
     /*  59916 */ GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(60221),
     /*  59921 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59924 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(59998), // Rule ID 17590 //
     /*  59929 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59940 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59951 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  59951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  59954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  59958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59963 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  59967 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  59976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  59987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  59992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  59997 */     // GIR_Coverage, 17590,
     /*  59997 */     GIR_EraseRootFromParent_Done,
     /*  59998 */   // Label 1469: @59998
     /*  59998 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(60072), // Rule ID 17592 //
     /*  60003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  60010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60025 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  60032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60037 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60041 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60071 */     // GIR_Coverage, 17592,
     /*  60071 */     GIR_EraseRootFromParent_Done,
     /*  60072 */   // Label 1470: @60072
     /*  60072 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(60146), // Rule ID 17594 //
     /*  60077 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  60084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60099 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32rm),
     /*  60106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60111 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60115 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60135 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60145 */     // GIR_Coverage, 17594,
     /*  60145 */     GIR_EraseRootFromParent_Done,
     /*  60146 */   // Label 1471: @60146
     /*  60146 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(60220), // Rule ID 22576 //
     /*  60151 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60173 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  60180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60185 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60189 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60214 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60219 */     // GIR_Coverage, 22576,
     /*  60219 */     GIR_EraseRootFromParent_Done,
     /*  60220 */   // Label 1472: @60220
     /*  60220 */   GIM_Reject,
     /*  60221 */ // Label 1468: @60221
     /*  60221 */ GIM_Reject,
     /*  60222 */ // Label 1459: @60222
     /*  60222 */ GIM_Reject,
     /*  60223 */ // Label 13: @60223
     /*  60223 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 1495*/ GIMT_Encode4(85232),
     /*  60234 */ /*GILLT_s8*//*Label 1473*/ GIMT_Encode4(60330),
     /*  60238 */ /*GILLT_s16*//*Label 1474*/ GIMT_Encode4(64928),
     /*  60242 */ /*GILLT_s32*//*Label 1475*/ GIMT_Encode4(70100),
     /*  60246 */ /*GILLT_s64*//*Label 1476*/ GIMT_Encode4(75728),
     /*  60250 */ /*GILLT_s80*//*Label 1477*/ GIMT_Encode4(80993),
     /*  60254 */ /*GILLT_s128*//*Label 1478*/ GIMT_Encode4(81042), GIMT_Encode4(0),
     /*  60262 */ /*GILLT_v2s64*//*Label 1479*/ GIMT_Encode4(81296), GIMT_Encode4(0),
     /*  60270 */ /*GILLT_v4s32*//*Label 1480*/ GIMT_Encode4(81790),
     /*  60274 */ /*GILLT_v4s64*//*Label 1481*/ GIMT_Encode4(82284),
     /*  60278 */ /*GILLT_v8s1*//*Label 1482*/ GIMT_Encode4(82618),
     /*  60282 */ /*GILLT_v8s16*//*Label 1483*/ GIMT_Encode4(82700),
     /*  60286 */ /*GILLT_v8s32*//*Label 1484*/ GIMT_Encode4(83274),
     /*  60290 */ /*GILLT_v8s64*//*Label 1485*/ GIMT_Encode4(83608),
     /*  60294 */ /*GILLT_v16s1*//*Label 1486*/ GIMT_Encode4(83782),
     /*  60298 */ /*GILLT_v16s8*//*Label 1487*/ GIMT_Encode4(83864),
     /*  60302 */ /*GILLT_v16s16*//*Label 1488*/ GIMT_Encode4(84118),
     /*  60306 */ /*GILLT_v16s32*//*Label 1489*/ GIMT_Encode4(84452),
     /*  60310 */ /*GILLT_v32s1*//*Label 1490*/ GIMT_Encode4(84626),
     /*  60314 */ /*GILLT_v32s8*//*Label 1491*/ GIMT_Encode4(84708),
     /*  60318 */ /*GILLT_v32s16*//*Label 1492*/ GIMT_Encode4(84882),
     /*  60322 */ /*GILLT_v64s1*//*Label 1493*/ GIMT_Encode4(85056),
     /*  60326 */ /*GILLT_v64s8*//*Label 1494*/ GIMT_Encode4(85138),
     /*  60330 */ // Label 1473: @60330
     /*  60330 */ GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(60422), // Rule ID 22490 //
     /*  60335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60338 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60341 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60348 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60352 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  60356 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60360 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60364 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60368 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60372 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60375 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60382 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60386 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  60390 */   // MIs[0] dst
     /*  60390 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60395 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60397 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60404 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_8>>, 1:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (INC8m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8m),
     /*  60407 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60411 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60414 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60420 */   GIR_RootConstrainSelectedInstOperands,
     /*  60421 */   // GIR_Coverage, 22490,
     /*  60421 */   GIR_EraseRootFromParent_Done,
     /*  60422 */ // Label 1496: @60422
     /*  60422 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(60514), // Rule ID 22494 //
     /*  60427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60430 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60433 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60440 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60444 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  60448 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60452 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60456 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60460 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60464 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60467 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60474 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60478 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60482 */   // MIs[0] dst
     /*  60482 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60487 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60489 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60496 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (DEC8m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8m),
     /*  60499 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60503 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60506 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60512 */   GIR_RootConstrainSelectedInstOperands,
     /*  60513 */   // GIR_Coverage, 22494,
     /*  60513 */   GIR_EraseRootFromParent_Done,
     /*  60514 */ // Label 1497: @60514
     /*  60514 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(60603), // Rule ID 22498 //
     /*  60519 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60522 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60529 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60533 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  60537 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60541 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60545 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  60549 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60553 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60557 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60560 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60567 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60571 */   // MIs[0] dst
     /*  60571 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60576 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60578 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60585 */   // (atomic_store (sub:{ *:[i8] } 0:{ *:[i8] }, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (NEG8m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8m),
     /*  60588 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60592 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60595 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60601 */   GIR_RootConstrainSelectedInstOperands,
     /*  60602 */   // GIR_Coverage, 22498,
     /*  60602 */   GIR_EraseRootFromParent_Done,
     /*  60603 */ // Label 1498: @60603
     /*  60603 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(60689), // Rule ID 22502 //
     /*  60608 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60611 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60618 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60622 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60626 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60630 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60634 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60638 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60642 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60645 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60652 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60656 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60660 */   // MIs[0] dst
     /*  60660 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60665 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60667 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60674 */   // (atomic_store (xor:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (NOT8m addr:{ *:[iPTR] }:$dst)
     /*  60674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8m),
     /*  60677 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60681 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60687 */   GIR_RootConstrainSelectedInstOperands,
     /*  60688 */   // GIR_Coverage, 22502,
     /*  60688 */   GIR_EraseRootFromParent_Done,
     /*  60689 */ // Label 1499: @60689
     /*  60689 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(60775), // Rule ID 225 //
     /*  60694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60697 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60700 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  60704 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  60712 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60716 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60720 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60724 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60728 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60731 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60735 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  60739 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  60743 */   // MIs[0] src1
     /*  60743 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60748 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60750 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60757 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 1:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC8m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  60757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8m),
     /*  60760 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  60764 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60767 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60773 */   GIR_RootConstrainSelectedInstOperands,
     /*  60774 */   // GIR_Coverage, 225,
     /*  60774 */   GIR_EraseRootFromParent_Done,
     /*  60775 */ // Label 1500: @60775
     /*  60775 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(60861), // Rule ID 228 //
     /*  60780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60783 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60786 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  60790 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60794 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  60798 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60802 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60806 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60810 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60814 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60817 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60821 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  60825 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60829 */   // MIs[0] src1
     /*  60829 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60834 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60836 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60843 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC8m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  60843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8m),
     /*  60846 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  60850 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60853 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60859 */   GIR_RootConstrainSelectedInstOperands,
     /*  60860 */   // GIR_Coverage, 228,
     /*  60860 */   GIR_EraseRootFromParent_Done,
     /*  60861 */ // Label 1501: @60861
     /*  60861 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(60944), // Rule ID 17611 //
     /*  60866 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60869 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  60873 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60877 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  60881 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60885 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60889 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60893 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60897 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60900 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60904 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  60908 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 7,
     /*  60912 */   // MIs[0] dst
     /*  60912 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60917 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60919 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60926 */   // (st (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR8m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8m1),
     /*  60929 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60933 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60936 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60942 */   GIR_RootConstrainSelectedInstOperands,
     /*  60943 */   // GIR_Coverage, 17611,
     /*  60943 */   GIR_EraseRootFromParent_Done,
     /*  60944 */ // Label 1502: @60944
     /*  60944 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(61027), // Rule ID 17615 //
     /*  60949 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60952 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  60956 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60960 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  60964 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60968 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60972 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60976 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60980 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60983 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60987 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  60991 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 7,
     /*  60995 */   // MIs[0] dst
     /*  60995 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61000 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61002 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61009 */   // (st (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL8m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  61009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8m1),
     /*  61012 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  61016 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61019 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61025 */   GIR_RootConstrainSelectedInstOperands,
     /*  61026 */   // GIR_Coverage, 17615,
     /*  61026 */   GIR_EraseRootFromParent_Done,
     /*  61027 */ // Label 1503: @61027
     /*  61027 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(61110), // Rule ID 261 //
     /*  61032 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61035 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61039 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61043 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  61047 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61051 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61055 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  61059 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61063 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61067 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61070 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61074 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61078 */   // MIs[0] src1
     /*  61078 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61083 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61085 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61092 */   // (st (sub:{ *:[i8] } 0:{ *:[i8] }, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG8m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  61092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8m),
     /*  61095 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61099 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61102 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61108 */   GIR_RootConstrainSelectedInstOperands,
     /*  61109 */   // GIR_Coverage, 261,
     /*  61109 */   GIR_EraseRootFromParent_Done,
     /*  61110 */ // Label 1504: @61110
     /*  61110 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(61190), // Rule ID 269 //
     /*  61115 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61118 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61122 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61126 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61130 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61134 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61138 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61142 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61146 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61149 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61153 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61157 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61161 */   // MIs[0] src1
     /*  61161 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61166 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61168 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61175 */   // (st (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT8m addr:{ *:[iPTR] }:$src1)
     /*  61175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8m),
     /*  61178 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61182 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61188 */   GIR_RootConstrainSelectedInstOperands,
     /*  61189 */   // GIR_Coverage, 269,
     /*  61189 */   GIR_EraseRootFromParent_Done,
     /*  61190 */ // Label 1505: @61190
     /*  61190 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(61285), // Rule ID 413 //
     /*  61195 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61198 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61202 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61206 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  61210 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61214 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61218 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61222 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61226 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61229 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61233 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61237 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61241 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61245 */   // MIs[3] Operand 1
     /*  61245 */   // No operand predicates
     /*  61245 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61249 */   // MIs[0] src1
     /*  61249 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61254 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61256 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61263 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mi),
     /*  61266 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61270 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61273 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61276 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61283 */   GIR_RootConstrainSelectedInstOperands,
     /*  61284 */   // GIR_Coverage, 413,
     /*  61284 */   GIR_EraseRootFromParent_Done,
     /*  61285 */ // Label 1506: @61285
     /*  61285 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(61380), // Rule ID 305 //
     /*  61290 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61293 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61297 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61301 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61305 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61309 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61313 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61317 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61321 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61324 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61328 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61332 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61336 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61340 */   // MIs[3] Operand 1
     /*  61340 */   // No operand predicates
     /*  61340 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61344 */   // MIs[0] src1
     /*  61344 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61349 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61351 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61358 */   // (st (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mi),
     /*  61361 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61365 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61368 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61371 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61378 */   GIR_RootConstrainSelectedInstOperands,
     /*  61379 */   // GIR_Coverage, 305,
     /*  61379 */   GIR_EraseRootFromParent_Done,
     /*  61380 */ // Label 1507: @61380
     /*  61380 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(61475), // Rule ID 341 //
     /*  61385 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61388 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61392 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61396 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  61400 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61404 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61408 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61412 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61416 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61419 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61423 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61427 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61431 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61435 */   // MIs[3] Operand 1
     /*  61435 */   // No operand predicates
     /*  61435 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61439 */   // MIs[0] src1
     /*  61439 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61444 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61446 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61453 */   // (st (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mi),
     /*  61456 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61460 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61463 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61466 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61473 */   GIR_RootConstrainSelectedInstOperands,
     /*  61474 */   // GIR_Coverage, 341,
     /*  61474 */   GIR_EraseRootFromParent_Done,
     /*  61475 */ // Label 1508: @61475
     /*  61475 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(61570), // Rule ID 453 //
     /*  61480 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61483 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61487 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61491 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  61495 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61499 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61503 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61507 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61511 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61514 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61518 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61522 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61526 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61530 */   // MIs[3] Operand 1
     /*  61530 */   // No operand predicates
     /*  61530 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61534 */   // MIs[0] src1
     /*  61534 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61539 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61541 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61548 */   // (st (sub:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mi),
     /*  61551 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61555 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61558 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61561 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61568 */   GIR_RootConstrainSelectedInstOperands,
     /*  61569 */   // GIR_Coverage, 453,
     /*  61569 */   GIR_EraseRootFromParent_Done,
     /*  61570 */ // Label 1509: @61570
     /*  61570 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(61665), // Rule ID 377 //
     /*  61575 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61578 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61582 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61586 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61590 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61594 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61598 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61602 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61606 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61609 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61613 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61617 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61621 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61625 */   // MIs[3] Operand 1
     /*  61625 */   // No operand predicates
     /*  61625 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61629 */   // MIs[0] src1
     /*  61629 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61634 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61636 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61643 */   // (st (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mi),
     /*  61646 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61650 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61653 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61656 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61663 */   GIR_RootConstrainSelectedInstOperands,
     /*  61664 */   // GIR_Coverage, 377,
     /*  61664 */   GIR_EraseRootFromParent_Done,
     /*  61665 */ // Label 1510: @61665
     /*  61665 */ GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(61762), // Rule ID 22426 //
     /*  61670 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61673 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61680 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61684 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  61688 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61692 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61696 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61700 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61704 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61707 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61714 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61718 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61722 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61726 */   // MIs[3] Operand 1
     /*  61726 */   // No operand predicates
     /*  61726 */   // MIs[0] dst
     /*  61726 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61731 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61733 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61740 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (ADD8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  61740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mi),
     /*  61743 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  61747 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  61750 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61753 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61760 */   GIR_RootConstrainSelectedInstOperands,
     /*  61761 */   // GIR_Coverage, 22426,
     /*  61761 */   GIR_EraseRootFromParent_Done,
     /*  61762 */ // Label 1511: @61762
     /*  61762 */ GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(61859), // Rule ID 22434 //
     /*  61767 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61770 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61777 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61781 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61785 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61789 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61793 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61797 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61801 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61804 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61811 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61815 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61819 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61823 */   // MIs[3] Operand 1
     /*  61823 */   // No operand predicates
     /*  61823 */   // MIs[0] dst
     /*  61823 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61828 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61830 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61837 */   // (atomic_store (and:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (AND8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  61837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mi),
     /*  61840 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  61844 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  61847 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61850 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61857 */   GIR_RootConstrainSelectedInstOperands,
     /*  61858 */   // GIR_Coverage, 22434,
     /*  61858 */   GIR_EraseRootFromParent_Done,
     /*  61859 */ // Label 1512: @61859
     /*  61859 */ GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(61956), // Rule ID 22442 //
     /*  61864 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61867 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61874 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61878 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  61882 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61886 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61890 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61894 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61898 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61901 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61908 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61912 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61916 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61920 */   // MIs[3] Operand 1
     /*  61920 */   // No operand predicates
     /*  61920 */   // MIs[0] dst
     /*  61920 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61925 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61927 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61934 */   // (atomic_store (or:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (OR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  61934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mi),
     /*  61937 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  61941 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  61944 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61947 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61954 */   GIR_RootConstrainSelectedInstOperands,
     /*  61955 */   // GIR_Coverage, 22442,
     /*  61955 */   GIR_EraseRootFromParent_Done,
     /*  61956 */ // Label 1513: @61956
     /*  61956 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(62053), // Rule ID 22458 //
     /*  61961 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61964 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61971 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61975 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  61979 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61983 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61987 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61991 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61995 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61998 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62005 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62009 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62013 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62017 */   // MIs[3] Operand 1
     /*  62017 */   // No operand predicates
     /*  62017 */   // MIs[0] dst
     /*  62017 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62022 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62024 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62031 */   // (atomic_store (sub:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (SUB8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mi),
     /*  62034 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62038 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62041 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62044 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62051 */   GIR_RootConstrainSelectedInstOperands,
     /*  62052 */   // GIR_Coverage, 22458,
     /*  62052 */   GIR_EraseRootFromParent_Done,
     /*  62053 */ // Label 1514: @62053
     /*  62053 */ GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(62150), // Rule ID 22450 //
     /*  62058 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62061 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62068 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62072 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62076 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62080 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62084 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62088 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62092 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62095 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62102 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62106 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62110 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62114 */   // MIs[3] Operand 1
     /*  62114 */   // No operand predicates
     /*  62114 */   // MIs[0] dst
     /*  62114 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62119 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62121 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62128 */   // (atomic_store (xor:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (XOR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mi),
     /*  62131 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62135 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62138 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62141 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62148 */   GIR_RootConstrainSelectedInstOperands,
     /*  62149 */   // GIR_Coverage, 22450,
     /*  62149 */   GIR_EraseRootFromParent_Done,
     /*  62150 */ // Label 1515: @62150
     /*  62150 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(62241), // Rule ID 732 //
     /*  62155 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62158 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62162 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62166 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  62170 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62174 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62178 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62182 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62186 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62189 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62193 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62197 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62201 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62205 */   // MIs[3] Operand 1
     /*  62205 */   // No operand predicates
     /*  62205 */   // MIs[0] src1
     /*  62205 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62210 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62212 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62219 */   // (st (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mi),
     /*  62222 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62226 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62229 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62232 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62239 */   GIR_RootConstrainSelectedInstOperands,
     /*  62240 */   // GIR_Coverage, 732,
     /*  62240 */   GIR_EraseRootFromParent_Done,
     /*  62241 */ // Label 1516: @62241
     /*  62241 */ GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(62332), // Rule ID 700 //
     /*  62246 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62249 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62253 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62257 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62261 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62265 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62269 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62273 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62277 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62280 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62284 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62288 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62292 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62296 */   // MIs[3] Operand 1
     /*  62296 */   // No operand predicates
     /*  62296 */   // MIs[0] src1
     /*  62296 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62301 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62303 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62310 */   // (st (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mi),
     /*  62313 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62317 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62320 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62323 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62330 */   GIR_RootConstrainSelectedInstOperands,
     /*  62331 */   // GIR_Coverage, 700,
     /*  62331 */   GIR_EraseRootFromParent_Done,
     /*  62332 */ // Label 1517: @62332
     /*  62332 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(62423), // Rule ID 764 //
     /*  62337 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62340 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62344 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62348 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  62352 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62356 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62360 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62364 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62368 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62371 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62375 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62379 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62383 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62387 */   // MIs[3] Operand 1
     /*  62387 */   // No operand predicates
     /*  62387 */   // MIs[0] src1
     /*  62387 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62392 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62394 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62401 */   // (st (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mi),
     /*  62404 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62408 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62411 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62414 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62421 */   GIR_RootConstrainSelectedInstOperands,
     /*  62422 */   // GIR_Coverage, 764,
     /*  62422 */   GIR_EraseRootFromParent_Done,
     /*  62423 */ // Label 1518: @62423
     /*  62423 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(62514), // Rule ID 796 //
     /*  62428 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62431 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62435 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62439 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  62443 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62447 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62451 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62455 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62459 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62462 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62466 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62470 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62474 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62478 */   // MIs[3] Operand 1
     /*  62478 */   // No operand predicates
     /*  62478 */   // MIs[0] src1
     /*  62478 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62483 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62485 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62492 */   // (st (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mi),
     /*  62495 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62499 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62502 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62505 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62512 */   GIR_RootConstrainSelectedInstOperands,
     /*  62513 */   // GIR_Coverage, 796,
     /*  62513 */   GIR_EraseRootFromParent_Done,
     /*  62514 */ // Label 1519: @62514
     /*  62514 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(62605), // Rule ID 668 //
     /*  62519 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62522 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62526 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62530 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  62534 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62538 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62542 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62546 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62550 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62553 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62557 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62561 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62565 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62569 */   // MIs[3] Operand 1
     /*  62569 */   // No operand predicates
     /*  62569 */   // MIs[0] src1
     /*  62569 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62574 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62576 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62583 */   // (st (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mi),
     /*  62586 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62590 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62593 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62596 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62603 */   GIR_RootConstrainSelectedInstOperands,
     /*  62604 */   // GIR_Coverage, 668,
     /*  62604 */   GIR_EraseRootFromParent_Done,
     /*  62605 */ // Label 1520: @62605
     /*  62605 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(62699), // Rule ID 22430 //
     /*  62610 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62613 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62620 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62624 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  62628 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62632 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62636 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62640 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62644 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62647 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62654 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62658 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  62663 */   // MIs[0] dst
     /*  62663 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62668 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62670 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62677 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  62677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  62680 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62684 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  62688 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62691 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  62697 */   GIR_RootConstrainSelectedInstOperands,
     /*  62698 */   // GIR_Coverage, 22430,
     /*  62698 */   GIR_EraseRootFromParent_Done,
     /*  62699 */ // Label 1521: @62699
     /*  62699 */ GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(62793), // Rule ID 25999 //
     /*  62704 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62707 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62714 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62718 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  62722 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62726 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62730 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  62735 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62739 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62743 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62746 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62753 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62757 */   // MIs[0] dst
     /*  62757 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62762 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62764 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62771 */   // (atomic_store (add:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  62771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  62774 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62778 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  62782 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62785 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  62791 */   GIR_RootConstrainSelectedInstOperands,
     /*  62792 */   // GIR_Coverage, 25999,
     /*  62792 */   GIR_EraseRootFromParent_Done,
     /*  62793 */ // Label 1522: @62793
     /*  62793 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(62887), // Rule ID 22438 //
     /*  62798 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62801 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62808 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62812 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62816 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62820 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62824 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62828 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62832 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62835 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62842 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62846 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  62851 */   // MIs[0] dst
     /*  62851 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62856 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62858 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62865 */   // (atomic_store (and:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  62865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  62868 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62872 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  62876 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62879 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  62885 */   GIR_RootConstrainSelectedInstOperands,
     /*  62886 */   // GIR_Coverage, 22438,
     /*  62886 */   GIR_EraseRootFromParent_Done,
     /*  62887 */ // Label 1523: @62887
     /*  62887 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(62981), // Rule ID 26003 //
     /*  62892 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62895 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62902 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62906 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62910 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62914 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62918 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  62923 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62927 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62931 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62934 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62941 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62945 */   // MIs[0] dst
     /*  62945 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62950 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62952 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62959 */   // (atomic_store (and:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  62959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  62962 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62966 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  62970 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62973 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  62979 */   GIR_RootConstrainSelectedInstOperands,
     /*  62980 */   // GIR_Coverage, 26003,
     /*  62980 */   GIR_EraseRootFromParent_Done,
     /*  62981 */ // Label 1524: @62981
     /*  62981 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(63075), // Rule ID 22446 //
     /*  62986 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62989 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62996 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63000 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  63004 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63008 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63012 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63016 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63020 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63023 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63030 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63034 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63039 */   // MIs[0] dst
     /*  63039 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63044 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63046 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63053 */   // (atomic_store (or:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  63056 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63060 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63064 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63067 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63073 */   GIR_RootConstrainSelectedInstOperands,
     /*  63074 */   // GIR_Coverage, 22446,
     /*  63074 */   GIR_EraseRootFromParent_Done,
     /*  63075 */ // Label 1525: @63075
     /*  63075 */ GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(63169), // Rule ID 26007 //
     /*  63080 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63083 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63090 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63094 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  63098 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63102 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63106 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63111 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63115 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63119 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63122 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63129 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63133 */   // MIs[0] dst
     /*  63133 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63138 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63140 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63147 */   // (atomic_store (or:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  63150 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63154 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  63158 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63161 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63167 */   GIR_RootConstrainSelectedInstOperands,
     /*  63168 */   // GIR_Coverage, 26007,
     /*  63168 */   GIR_EraseRootFromParent_Done,
     /*  63169 */ // Label 1526: @63169
     /*  63169 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(63263), // Rule ID 22462 //
     /*  63174 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63177 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63184 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63188 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  63192 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63196 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63200 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63204 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63208 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63211 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63218 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63222 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63227 */   // MIs[0] dst
     /*  63227 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63232 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63234 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63241 */   // (atomic_store (sub:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (SUB8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mr),
     /*  63244 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63248 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63252 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63255 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63261 */   GIR_RootConstrainSelectedInstOperands,
     /*  63262 */   // GIR_Coverage, 22462,
     /*  63262 */   GIR_EraseRootFromParent_Done,
     /*  63263 */ // Label 1527: @63263
     /*  63263 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(63357), // Rule ID 22454 //
     /*  63268 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63271 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63278 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63282 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63286 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63290 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63294 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63298 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63302 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63305 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63312 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63316 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63321 */   // MIs[0] dst
     /*  63321 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63326 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63328 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63335 */   // (atomic_store (xor:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  63338 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63342 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63346 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63349 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63355 */   GIR_RootConstrainSelectedInstOperands,
     /*  63356 */   // GIR_Coverage, 22454,
     /*  63356 */   GIR_EraseRootFromParent_Done,
     /*  63357 */ // Label 1528: @63357
     /*  63357 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(63451), // Rule ID 26011 //
     /*  63362 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63365 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63372 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63376 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63380 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63384 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63388 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63393 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63397 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63401 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63404 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63411 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63415 */   // MIs[0] dst
     /*  63415 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63420 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63422 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63429 */   // (atomic_store (xor:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  63432 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63436 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  63440 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63443 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63449 */   GIR_RootConstrainSelectedInstOperands,
     /*  63450 */   // GIR_Coverage, 26011,
     /*  63450 */   GIR_EraseRootFromParent_Done,
     /*  63451 */ // Label 1529: @63451
     /*  63451 */ GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(63539), // Rule ID 409 //
     /*  63456 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63459 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63463 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63467 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  63471 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63475 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63479 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63483 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63487 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63490 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63494 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63498 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63503 */   // MIs[0] src1
     /*  63503 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63508 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63510 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63517 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  63517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  63520 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  63524 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  63528 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63531 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63537 */   GIR_RootConstrainSelectedInstOperands,
     /*  63538 */   // GIR_Coverage, 409,
     /*  63538 */   GIR_EraseRootFromParent_Done,
     /*  63539 */ // Label 1530: @63539
     /*  63539 */ GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(63627), // Rule ID 23219 //
     /*  63544 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63547 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63551 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63555 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  63559 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63563 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63567 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63572 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63576 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63580 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63583 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63587 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63591 */   // MIs[0] src1
     /*  63591 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63596 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63598 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63605 */   // (st (add:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  63605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  63608 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  63612 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  63616 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63619 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63625 */   GIR_RootConstrainSelectedInstOperands,
     /*  63626 */   // GIR_Coverage, 23219,
     /*  63626 */   GIR_EraseRootFromParent_Done,
     /*  63627 */ // Label 1531: @63627
     /*  63627 */ GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(63715), // Rule ID 301 //
     /*  63632 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63635 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63639 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63643 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63647 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63651 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63655 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63659 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63663 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63666 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63670 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63674 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63679 */   // MIs[0] src1
     /*  63679 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63684 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63686 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63693 */   // (st (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  63693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  63696 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  63700 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  63704 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63707 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63713 */   GIR_RootConstrainSelectedInstOperands,
     /*  63714 */   // GIR_Coverage, 301,
     /*  63714 */   GIR_EraseRootFromParent_Done,
     /*  63715 */ // Label 1532: @63715
     /*  63715 */ GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(63803), // Rule ID 23183 //
     /*  63720 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63723 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63727 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63731 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63735 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63739 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63743 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63748 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63752 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63756 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63759 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63763 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63767 */   // MIs[0] src1
     /*  63767 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63772 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63774 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63781 */   // (st (and:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  63781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  63784 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  63788 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  63792 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63795 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63801 */   GIR_RootConstrainSelectedInstOperands,
     /*  63802 */   // GIR_Coverage, 23183,
     /*  63802 */   GIR_EraseRootFromParent_Done,
     /*  63803 */ // Label 1533: @63803
     /*  63803 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(63901), // Rule ID 748 //
     /*  63808 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63811 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63815 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63819 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  63823 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63827 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63831 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63835 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63839 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63842 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63846 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  63850 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  63855 */   // MIs[0] src1
     /*  63855 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63860 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63862 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63869 */   // (st (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  63869 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  63873 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63879 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  63883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mCL),
     /*  63886 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  63890 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63893 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63899 */   GIR_RootConstrainSelectedInstOperands,
     /*  63900 */   // GIR_Coverage, 748,
     /*  63900 */   GIR_EraseRootFromParent_Done,
     /*  63901 */ // Label 1534: @63901
     /*  63901 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(63999), // Rule ID 716 //
     /*  63906 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63909 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63913 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63917 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63921 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63925 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63929 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63933 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63937 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63940 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63944 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  63948 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  63953 */   // MIs[0] src1
     /*  63953 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63958 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63960 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63967 */   // (st (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  63967 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  63971 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63977 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  63981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mCL),
     /*  63984 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  63988 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63991 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63997 */   GIR_RootConstrainSelectedInstOperands,
     /*  63998 */   // GIR_Coverage, 716,
     /*  63998 */   GIR_EraseRootFromParent_Done,
     /*  63999 */ // Label 1535: @63999
     /*  63999 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(64087), // Rule ID 337 //
     /*  64004 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64007 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64011 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64015 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  64019 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64023 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64027 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64031 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64035 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64038 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64042 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64046 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64051 */   // MIs[0] src1
     /*  64051 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64056 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64058 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64065 */   // (st (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  64068 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64072 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64076 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64079 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64085 */   GIR_RootConstrainSelectedInstOperands,
     /*  64086 */   // GIR_Coverage, 337,
     /*  64086 */   GIR_EraseRootFromParent_Done,
     /*  64087 */ // Label 1536: @64087
     /*  64087 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(64175), // Rule ID 23195 //
     /*  64092 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64095 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64099 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64103 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  64107 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64111 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64115 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64120 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64124 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64128 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64131 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64135 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64139 */   // MIs[0] src1
     /*  64139 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64144 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64146 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64153 */   // (st (or:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  64156 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64160 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  64164 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64167 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64173 */   GIR_RootConstrainSelectedInstOperands,
     /*  64174 */   // GIR_Coverage, 23195,
     /*  64174 */   GIR_EraseRootFromParent_Done,
     /*  64175 */ // Label 1537: @64175
     /*  64175 */ GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(64273), // Rule ID 780 //
     /*  64180 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64183 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64187 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64191 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  64195 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64199 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64203 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64207 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64211 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64214 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64218 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64222 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64227 */   // MIs[0] src1
     /*  64227 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64232 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64234 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64241 */   // (st (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64241 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64245 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64251 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mCL),
     /*  64258 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64262 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64265 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64271 */   GIR_RootConstrainSelectedInstOperands,
     /*  64272 */   // GIR_Coverage, 780,
     /*  64272 */   GIR_EraseRootFromParent_Done,
     /*  64273 */ // Label 1538: @64273
     /*  64273 */ GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(64371), // Rule ID 812 //
     /*  64278 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64281 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64285 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64289 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  64293 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64297 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64301 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64305 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64309 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64312 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64316 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64320 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64325 */   // MIs[0] src1
     /*  64325 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64330 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64332 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64339 */   // (st (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64343 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64349 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mCL),
     /*  64356 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64360 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64363 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64369 */   GIR_RootConstrainSelectedInstOperands,
     /*  64370 */   // GIR_Coverage, 812,
     /*  64370 */   GIR_EraseRootFromParent_Done,
     /*  64371 */ // Label 1539: @64371
     /*  64371 */ GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(64469), // Rule ID 684 //
     /*  64376 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64379 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64383 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64387 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  64391 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64395 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64399 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64403 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64407 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64410 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64414 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64418 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64423 */   // MIs[0] src1
     /*  64423 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64428 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64430 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64437 */   // (st (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64437 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64441 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64447 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mCL),
     /*  64454 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64458 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64461 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64467 */   GIR_RootConstrainSelectedInstOperands,
     /*  64468 */   // GIR_Coverage, 684,
     /*  64468 */   GIR_EraseRootFromParent_Done,
     /*  64469 */ // Label 1540: @64469
     /*  64469 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(64557), // Rule ID 445 //
     /*  64474 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64477 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64481 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64485 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  64489 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64493 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64497 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64501 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64505 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64508 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64512 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64516 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64521 */   // MIs[0] src1
     /*  64521 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64526 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64528 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64535 */   // (st (sub:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mr),
     /*  64538 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64542 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64546 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64549 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64555 */   GIR_RootConstrainSelectedInstOperands,
     /*  64556 */   // GIR_Coverage, 445,
     /*  64556 */   GIR_EraseRootFromParent_Done,
     /*  64557 */ // Label 1541: @64557
     /*  64557 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(64645), // Rule ID 373 //
     /*  64562 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64565 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64569 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64573 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64577 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64581 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64585 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64589 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64593 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64596 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64600 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64604 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64609 */   // MIs[0] src1
     /*  64609 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64614 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64616 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64623 */   // (st (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  64626 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64630 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64634 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64637 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64643 */   GIR_RootConstrainSelectedInstOperands,
     /*  64644 */   // GIR_Coverage, 373,
     /*  64644 */   GIR_EraseRootFromParent_Done,
     /*  64645 */ // Label 1542: @64645
     /*  64645 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(64733), // Rule ID 23207 //
     /*  64650 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64653 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64657 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64661 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64665 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64669 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64673 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64678 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64682 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64686 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64689 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64693 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64697 */   // MIs[0] src1
     /*  64697 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64702 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64704 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64711 */   // (st (xor:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  64714 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64718 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  64722 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64725 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64731 */   GIR_RootConstrainSelectedInstOperands,
     /*  64732 */   // GIR_Coverage, 23207,
     /*  64732 */   GIR_EraseRootFromParent_Done,
     /*  64733 */ // Label 1543: @64733
     /*  64733 */ GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(64787), // Rule ID 24 //
     /*  64738 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64741 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64745 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64749 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64753 */   // MIs[1] Operand 1
     /*  64753 */   // No operand predicates
     /*  64753 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  64757 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  64761 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64763 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64770 */   // (st (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV8mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  64770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mi),
     /*  64773 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  64777 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  64780 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  64785 */   GIR_RootConstrainSelectedInstOperands,
     /*  64786 */   // GIR_Coverage, 24,
     /*  64786 */   GIR_EraseRootFromParent_Done,
     /*  64787 */ // Label 1544: @64787
     /*  64787 */ GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(64840), // Rule ID 22506 //
     /*  64792 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  64795 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  64802 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64806 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64810 */   // MIs[1] Operand 1
     /*  64810 */   // No operand predicates
     /*  64810 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  64814 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64816 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64823 */   // (atomic_store (imm:{ *:[i8] }):$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (MOV8mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  64823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mi),
     /*  64826 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  64830 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  64833 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  64838 */   GIR_RootConstrainSelectedInstOperands,
     /*  64839 */   // GIR_Coverage, 22506,
     /*  64839 */   GIR_EraseRootFromParent_Done,
     /*  64840 */ // Label 1545: @64840
     /*  64840 */ GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(64885), // Rule ID 22510 //
     /*  64845 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  64848 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  64855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64859 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  64863 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64870 */   // (atomic_store GR8:{ *:[i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (MOV8mr addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  64870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mr),
     /*  64873 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  64877 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  64879 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  64883 */   GIR_RootConstrainSelectedInstOperands,
     /*  64884 */   // GIR_Coverage, 22510,
     /*  64884 */   GIR_EraseRootFromParent_Done,
     /*  64885 */ // Label 1546: @64885
     /*  64885 */ GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(64927), // Rule ID 32 //
     /*  64890 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64893 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64901 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  64905 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64912 */   // (st GR8:{ *:[i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV8mr addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  64912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mr),
     /*  64915 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  64919 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  64921 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  64925 */   GIR_RootConstrainSelectedInstOperands,
     /*  64926 */   // GIR_Coverage, 32,
     /*  64926 */   GIR_EraseRootFromParent_Done,
     /*  64927 */ // Label 1547: @64927
     /*  64927 */ GIM_Reject,
     /*  64928 */ // Label 1474: @64928
     /*  64928 */ GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(65020), // Rule ID 22491 //
     /*  64933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  64936 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  64939 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  64946 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64950 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  64954 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  64958 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  64962 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64966 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64970 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  64973 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  64980 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64984 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  64988 */   // MIs[0] dst
     /*  64988 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64993 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64995 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65002 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_16>>, 1:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (INC16m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16m),
     /*  65005 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65009 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65012 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65018 */   GIR_RootConstrainSelectedInstOperands,
     /*  65019 */   // GIR_Coverage, 22491,
     /*  65019 */   GIR_EraseRootFromParent_Done,
     /*  65020 */ // Label 1548: @65020
     /*  65020 */ GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(65112), // Rule ID 22495 //
     /*  65025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65028 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65031 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65038 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65042 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65046 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65050 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65054 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65058 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65062 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65065 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65072 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65076 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65080 */   // MIs[0] dst
     /*  65080 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65085 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65087 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65094 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (DEC16m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16m),
     /*  65097 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65101 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65104 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65110 */   GIR_RootConstrainSelectedInstOperands,
     /*  65111 */   // GIR_Coverage, 22495,
     /*  65111 */   GIR_EraseRootFromParent_Done,
     /*  65112 */ // Label 1549: @65112
     /*  65112 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(65201), // Rule ID 22499 //
     /*  65117 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65120 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65127 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65131 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  65135 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65139 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65143 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  65147 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65151 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65155 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65158 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65165 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65169 */   // MIs[0] dst
     /*  65169 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65174 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65176 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65183 */   // (atomic_store (sub:{ *:[i16] } 0:{ *:[i16] }, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (NEG16m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16m),
     /*  65186 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65190 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65193 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65199 */   GIR_RootConstrainSelectedInstOperands,
     /*  65200 */   // GIR_Coverage, 22499,
     /*  65200 */   GIR_EraseRootFromParent_Done,
     /*  65201 */ // Label 1550: @65201
     /*  65201 */ GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(65287), // Rule ID 22503 //
     /*  65206 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65209 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65216 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65220 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65224 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65228 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65232 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65236 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65240 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65243 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65250 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65254 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65258 */   // MIs[0] dst
     /*  65258 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65263 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65265 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65272 */   // (atomic_store (xor:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (NOT16m addr:{ *:[iPTR] }:$dst)
     /*  65272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16m),
     /*  65275 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65279 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65285 */   GIR_RootConstrainSelectedInstOperands,
     /*  65286 */   // GIR_Coverage, 22503,
     /*  65286 */   GIR_EraseRootFromParent_Done,
     /*  65287 */ // Label 1551: @65287
     /*  65287 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(65373), // Rule ID 226 //
     /*  65292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65295 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65298 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65302 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65306 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65310 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65314 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65318 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65322 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65326 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65329 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65333 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65337 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  65341 */   // MIs[0] src1
     /*  65341 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65346 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65348 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65355 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 1:{ *:[i16] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC16m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  65355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16m),
     /*  65358 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  65362 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65365 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65371 */   GIR_RootConstrainSelectedInstOperands,
     /*  65372 */   // GIR_Coverage, 226,
     /*  65372 */   GIR_EraseRootFromParent_Done,
     /*  65373 */ // Label 1552: @65373
     /*  65373 */ GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(65459), // Rule ID 229 //
     /*  65378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65381 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65384 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65388 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65392 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65396 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65400 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65404 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65408 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65412 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65415 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65419 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65423 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65427 */   // MIs[0] src1
     /*  65427 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65432 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65434 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65441 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC16m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  65441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16m),
     /*  65444 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  65448 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65451 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65457 */   GIR_RootConstrainSelectedInstOperands,
     /*  65458 */   // GIR_Coverage, 229,
     /*  65458 */   GIR_EraseRootFromParent_Done,
     /*  65459 */ // Label 1553: @65459
     /*  65459 */ GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(65552), // Rule ID 22611 //
     /*  65464 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65467 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65471 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65475 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65479 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65483 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65487 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65491 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65495 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65498 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65502 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65506 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(128),
     /*  65517 */   // MIs[0] dst
     /*  65517 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65522 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65524 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65531 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 128:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -128:{ *:[i16] })
     /*  65531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi),
     /*  65534 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  65541 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65544 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65550 */   GIR_RootConstrainSelectedInstOperands,
     /*  65551 */   // GIR_Coverage, 22611,
     /*  65551 */   GIR_EraseRootFromParent_Done,
     /*  65552 */ // Label 1554: @65552
     /*  65552 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(65635), // Rule ID 17612 //
     /*  65557 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65560 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65564 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65568 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  65572 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65576 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  65580 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65584 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65588 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65591 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65595 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65599 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 15,
     /*  65603 */   // MIs[0] dst
     /*  65603 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65608 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65610 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65617 */   // (st (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR16m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16m1),
     /*  65620 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65624 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65627 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65633 */   GIR_RootConstrainSelectedInstOperands,
     /*  65634 */   // GIR_Coverage, 17612,
     /*  65634 */   GIR_EraseRootFromParent_Done,
     /*  65635 */ // Label 1555: @65635
     /*  65635 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(65718), // Rule ID 17616 //
     /*  65640 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65643 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65647 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65651 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  65655 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65659 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  65663 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65667 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65671 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65674 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65678 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65682 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 15,
     /*  65686 */   // MIs[0] dst
     /*  65686 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65691 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65693 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65700 */   // (st (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL16m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16m1),
     /*  65703 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65707 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65710 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65716 */   GIR_RootConstrainSelectedInstOperands,
     /*  65717 */   // GIR_Coverage, 17616,
     /*  65717 */   GIR_EraseRootFromParent_Done,
     /*  65718 */ // Label 1556: @65718
     /*  65718 */ GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(65801), // Rule ID 262 //
     /*  65723 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65726 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65730 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65734 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  65738 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65742 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65746 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  65750 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65754 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65758 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65761 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65765 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65769 */   // MIs[0] src1
     /*  65769 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65774 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65776 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65783 */   // (st (sub:{ *:[i16] } 0:{ *:[i16] }, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG16m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  65783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16m),
     /*  65786 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  65790 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65793 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65799 */   GIR_RootConstrainSelectedInstOperands,
     /*  65800 */   // GIR_Coverage, 262,
     /*  65800 */   GIR_EraseRootFromParent_Done,
     /*  65801 */ // Label 1557: @65801
     /*  65801 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(65881), // Rule ID 270 //
     /*  65806 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65809 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65813 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65817 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65821 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65825 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65829 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65833 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65837 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65840 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65844 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65848 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65852 */   // MIs[0] src1
     /*  65852 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65857 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65859 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65866 */   // (st (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT16m addr:{ *:[iPTR] }:$src1)
     /*  65866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16m),
     /*  65869 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  65873 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65879 */   GIR_RootConstrainSelectedInstOperands,
     /*  65880 */   // GIR_Coverage, 270,
     /*  65880 */   GIR_EraseRootFromParent_Done,
     /*  65881 */ // Label 1558: @65881
     /*  65881 */ GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(65976), // Rule ID 414 //
     /*  65886 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65889 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65893 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65897 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65901 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65905 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65909 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65913 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65917 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65920 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65924 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65928 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  65932 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65936 */   // MIs[3] Operand 1
     /*  65936 */   // No operand predicates
     /*  65936 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  65940 */   // MIs[0] src1
     /*  65940 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65945 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  65947 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65954 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  65954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mi),
     /*  65957 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  65961 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  65964 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65967 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  65974 */   GIR_RootConstrainSelectedInstOperands,
     /*  65975 */   // GIR_Coverage, 414,
     /*  65975 */   GIR_EraseRootFromParent_Done,
     /*  65976 */ // Label 1559: @65976
     /*  65976 */ GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(66071), // Rule ID 306 //
     /*  65981 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65984 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65988 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65992 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65996 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66000 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66004 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66008 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66012 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66015 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66019 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66023 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66027 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66031 */   // MIs[3] Operand 1
     /*  66031 */   // No operand predicates
     /*  66031 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66035 */   // MIs[0] src1
     /*  66035 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66040 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66042 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66049 */   // (st (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mi),
     /*  66052 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66056 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66059 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66062 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66069 */   GIR_RootConstrainSelectedInstOperands,
     /*  66070 */   // GIR_Coverage, 306,
     /*  66070 */   GIR_EraseRootFromParent_Done,
     /*  66071 */ // Label 1560: @66071
     /*  66071 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(66166), // Rule ID 342 //
     /*  66076 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66079 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66083 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66087 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  66091 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66095 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66099 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66103 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66107 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66110 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66114 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66118 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66122 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66126 */   // MIs[3] Operand 1
     /*  66126 */   // No operand predicates
     /*  66126 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66130 */   // MIs[0] src1
     /*  66130 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66135 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66137 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66144 */   // (st (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mi),
     /*  66147 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66151 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66154 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66157 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66164 */   GIR_RootConstrainSelectedInstOperands,
     /*  66165 */   // GIR_Coverage, 342,
     /*  66165 */   GIR_EraseRootFromParent_Done,
     /*  66166 */ // Label 1561: @66166
     /*  66166 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(66261), // Rule ID 454 //
     /*  66171 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66174 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66178 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66182 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  66186 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66190 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66194 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66198 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66202 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66205 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66209 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66213 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66217 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66221 */   // MIs[3] Operand 1
     /*  66221 */   // No operand predicates
     /*  66221 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66225 */   // MIs[0] src1
     /*  66225 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66230 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66232 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66239 */   // (st (sub:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi),
     /*  66242 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66246 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66249 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66252 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66259 */   GIR_RootConstrainSelectedInstOperands,
     /*  66260 */   // GIR_Coverage, 454,
     /*  66260 */   GIR_EraseRootFromParent_Done,
     /*  66261 */ // Label 1562: @66261
     /*  66261 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(66356), // Rule ID 378 //
     /*  66266 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66269 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66273 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66277 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66281 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66285 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66289 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66293 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66297 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66300 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66304 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66308 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66312 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66316 */   // MIs[3] Operand 1
     /*  66316 */   // No operand predicates
     /*  66316 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66320 */   // MIs[0] src1
     /*  66320 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66325 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66327 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66334 */   // (st (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mi),
     /*  66337 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66341 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66344 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66347 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66354 */   GIR_RootConstrainSelectedInstOperands,
     /*  66355 */   // GIR_Coverage, 378,
     /*  66355 */   GIR_EraseRootFromParent_Done,
     /*  66356 */ // Label 1563: @66356
     /*  66356 */ GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(66453), // Rule ID 22427 //
     /*  66361 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66364 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66371 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66375 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  66379 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66383 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66387 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66391 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66395 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66398 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66405 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66409 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66413 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66417 */   // MIs[3] Operand 1
     /*  66417 */   // No operand predicates
     /*  66417 */   // MIs[0] dst
     /*  66417 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66422 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66424 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66431 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (ADD16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mi),
     /*  66434 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66438 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66441 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66444 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66451 */   GIR_RootConstrainSelectedInstOperands,
     /*  66452 */   // GIR_Coverage, 22427,
     /*  66452 */   GIR_EraseRootFromParent_Done,
     /*  66453 */ // Label 1564: @66453
     /*  66453 */ GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(66550), // Rule ID 22435 //
     /*  66458 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66461 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66468 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66472 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66476 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66480 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66484 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66488 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66492 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66495 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66502 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66506 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66510 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66514 */   // MIs[3] Operand 1
     /*  66514 */   // No operand predicates
     /*  66514 */   // MIs[0] dst
     /*  66514 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66519 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66521 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66528 */   // (atomic_store (and:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (AND16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mi),
     /*  66531 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66535 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66538 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66541 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66548 */   GIR_RootConstrainSelectedInstOperands,
     /*  66549 */   // GIR_Coverage, 22435,
     /*  66549 */   GIR_EraseRootFromParent_Done,
     /*  66550 */ // Label 1565: @66550
     /*  66550 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(66647), // Rule ID 22443 //
     /*  66555 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66558 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66565 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66569 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  66573 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66577 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66581 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66585 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66589 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66592 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66599 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66603 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66607 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66611 */   // MIs[3] Operand 1
     /*  66611 */   // No operand predicates
     /*  66611 */   // MIs[0] dst
     /*  66611 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66616 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66618 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66625 */   // (atomic_store (or:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (OR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mi),
     /*  66628 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66632 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66635 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66638 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66645 */   GIR_RootConstrainSelectedInstOperands,
     /*  66646 */   // GIR_Coverage, 22443,
     /*  66646 */   GIR_EraseRootFromParent_Done,
     /*  66647 */ // Label 1566: @66647
     /*  66647 */ GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(66744), // Rule ID 22459 //
     /*  66652 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66655 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66662 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66666 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  66670 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66674 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66678 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66682 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66686 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66689 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66696 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66700 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66704 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66708 */   // MIs[3] Operand 1
     /*  66708 */   // No operand predicates
     /*  66708 */   // MIs[0] dst
     /*  66708 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66713 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66715 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66722 */   // (atomic_store (sub:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (SUB16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi),
     /*  66725 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66729 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66732 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66735 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66742 */   GIR_RootConstrainSelectedInstOperands,
     /*  66743 */   // GIR_Coverage, 22459,
     /*  66743 */   GIR_EraseRootFromParent_Done,
     /*  66744 */ // Label 1567: @66744
     /*  66744 */ GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(66841), // Rule ID 22451 //
     /*  66749 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66752 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66759 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66763 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66767 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66771 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66775 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66779 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66783 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66786 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66793 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66797 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66801 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66805 */   // MIs[3] Operand 1
     /*  66805 */   // No operand predicates
     /*  66805 */   // MIs[0] dst
     /*  66805 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66810 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66812 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66819 */   // (atomic_store (xor:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (XOR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mi),
     /*  66822 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66826 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66829 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66832 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66839 */   GIR_RootConstrainSelectedInstOperands,
     /*  66840 */   // GIR_Coverage, 22451,
     /*  66840 */   GIR_EraseRootFromParent_Done,
     /*  66841 */ // Label 1568: @66841
     /*  66841 */ GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(66932), // Rule ID 733 //
     /*  66846 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66849 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66853 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66857 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  66861 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66865 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  66869 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66873 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66877 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66880 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66884 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  66888 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66892 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66896 */   // MIs[3] Operand 1
     /*  66896 */   // No operand predicates
     /*  66896 */   // MIs[0] src1
     /*  66896 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66901 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66903 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66910 */   // (st (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  66910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mi),
     /*  66913 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66917 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66920 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66923 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66930 */   GIR_RootConstrainSelectedInstOperands,
     /*  66931 */   // GIR_Coverage, 733,
     /*  66931 */   GIR_EraseRootFromParent_Done,
     /*  66932 */ // Label 1569: @66932
     /*  66932 */ GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(67023), // Rule ID 701 //
     /*  66937 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66940 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66944 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66948 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  66952 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66956 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  66960 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66964 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66968 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66971 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66975 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  66979 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66983 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66987 */   // MIs[3] Operand 1
     /*  66987 */   // No operand predicates
     /*  66987 */   // MIs[0] src1
     /*  66987 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66992 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66994 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67001 */   // (st (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mi),
     /*  67004 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67008 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67011 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67014 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67021 */   GIR_RootConstrainSelectedInstOperands,
     /*  67022 */   // GIR_Coverage, 701,
     /*  67022 */   GIR_EraseRootFromParent_Done,
     /*  67023 */ // Label 1570: @67023
     /*  67023 */ GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(67114), // Rule ID 765 //
     /*  67028 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67031 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67035 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67039 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  67043 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67047 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67051 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67055 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67059 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67062 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67066 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67070 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67074 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67078 */   // MIs[3] Operand 1
     /*  67078 */   // No operand predicates
     /*  67078 */   // MIs[0] src1
     /*  67078 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67083 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67085 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67092 */   // (st (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mi),
     /*  67095 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67099 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67102 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67105 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67112 */   GIR_RootConstrainSelectedInstOperands,
     /*  67113 */   // GIR_Coverage, 765,
     /*  67113 */   GIR_EraseRootFromParent_Done,
     /*  67114 */ // Label 1571: @67114
     /*  67114 */ GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(67205), // Rule ID 797 //
     /*  67119 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67122 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67126 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67130 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  67134 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67138 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67142 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67146 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67150 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67153 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67157 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67161 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67165 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67169 */   // MIs[3] Operand 1
     /*  67169 */   // No operand predicates
     /*  67169 */   // MIs[0] src1
     /*  67169 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67174 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67176 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67183 */   // (st (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mi),
     /*  67186 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67190 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67193 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67196 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67203 */   GIR_RootConstrainSelectedInstOperands,
     /*  67204 */   // GIR_Coverage, 797,
     /*  67204 */   GIR_EraseRootFromParent_Done,
     /*  67205 */ // Label 1572: @67205
     /*  67205 */ GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(67296), // Rule ID 669 //
     /*  67210 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67213 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67217 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67221 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  67225 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67229 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67233 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67237 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67241 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67244 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67248 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67252 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67256 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67260 */   // MIs[3] Operand 1
     /*  67260 */   // No operand predicates
     /*  67260 */   // MIs[0] src1
     /*  67260 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67265 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67267 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67274 */   // (st (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mi),
     /*  67277 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67281 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67284 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67287 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67294 */   GIR_RootConstrainSelectedInstOperands,
     /*  67295 */   // GIR_Coverage, 669,
     /*  67295 */   GIR_EraseRootFromParent_Done,
     /*  67296 */ // Label 1573: @67296
     /*  67296 */ GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(67390), // Rule ID 22431 //
     /*  67301 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67304 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67311 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67315 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  67319 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67323 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67327 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67331 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67335 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67338 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67345 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67349 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67354 */   // MIs[0] dst
     /*  67354 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67359 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67361 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67368 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  67371 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67375 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  67379 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67382 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67388 */   GIR_RootConstrainSelectedInstOperands,
     /*  67389 */   // GIR_Coverage, 22431,
     /*  67389 */   GIR_EraseRootFromParent_Done,
     /*  67390 */ // Label 1574: @67390
     /*  67390 */ GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(67484), // Rule ID 26000 //
     /*  67395 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67398 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67405 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67409 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  67413 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67417 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67421 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67426 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67430 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67434 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67437 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67444 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67448 */   // MIs[0] dst
     /*  67448 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67453 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67455 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67462 */   // (atomic_store (add:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  67465 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67469 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  67473 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67476 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67482 */   GIR_RootConstrainSelectedInstOperands,
     /*  67483 */   // GIR_Coverage, 26000,
     /*  67483 */   GIR_EraseRootFromParent_Done,
     /*  67484 */ // Label 1575: @67484
     /*  67484 */ GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(67578), // Rule ID 22439 //
     /*  67489 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67492 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67499 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67503 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67507 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67511 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67515 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67519 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67523 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67526 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67533 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67537 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67542 */   // MIs[0] dst
     /*  67542 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67547 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67549 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67556 */   // (atomic_store (and:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  67559 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67563 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  67567 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67570 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67576 */   GIR_RootConstrainSelectedInstOperands,
     /*  67577 */   // GIR_Coverage, 22439,
     /*  67577 */   GIR_EraseRootFromParent_Done,
     /*  67578 */ // Label 1576: @67578
     /*  67578 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(67672), // Rule ID 26004 //
     /*  67583 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67586 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67593 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67597 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67601 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67605 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67609 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67614 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67618 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67622 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67625 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67632 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67636 */   // MIs[0] dst
     /*  67636 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67641 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67643 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67650 */   // (atomic_store (and:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  67653 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67657 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  67661 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67664 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67670 */   GIR_RootConstrainSelectedInstOperands,
     /*  67671 */   // GIR_Coverage, 26004,
     /*  67671 */   GIR_EraseRootFromParent_Done,
     /*  67672 */ // Label 1577: @67672
     /*  67672 */ GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(67766), // Rule ID 22447 //
     /*  67677 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67680 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67687 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67691 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  67695 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67699 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67703 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67707 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67711 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67714 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67721 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67725 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67730 */   // MIs[0] dst
     /*  67730 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67735 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67737 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67744 */   // (atomic_store (or:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  67747 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67751 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  67755 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67758 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67764 */   GIR_RootConstrainSelectedInstOperands,
     /*  67765 */   // GIR_Coverage, 22447,
     /*  67765 */   GIR_EraseRootFromParent_Done,
     /*  67766 */ // Label 1578: @67766
     /*  67766 */ GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(67860), // Rule ID 26008 //
     /*  67771 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67774 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67781 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67785 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  67789 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67793 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67797 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67802 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67806 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67810 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67813 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67820 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67824 */   // MIs[0] dst
     /*  67824 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67829 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67831 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67838 */   // (atomic_store (or:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  67841 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67845 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  67849 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67852 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67858 */   GIR_RootConstrainSelectedInstOperands,
     /*  67859 */   // GIR_Coverage, 26008,
     /*  67859 */   GIR_EraseRootFromParent_Done,
     /*  67860 */ // Label 1579: @67860
     /*  67860 */ GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(67954), // Rule ID 22463 //
     /*  67865 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67868 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67875 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67879 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  67883 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67887 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67891 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67895 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67899 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67902 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67909 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67913 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67918 */   // MIs[0] dst
     /*  67918 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67923 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67925 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67932 */   // (atomic_store (sub:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (SUB16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mr),
     /*  67935 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67939 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  67943 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67946 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67952 */   GIR_RootConstrainSelectedInstOperands,
     /*  67953 */   // GIR_Coverage, 22463,
     /*  67953 */   GIR_EraseRootFromParent_Done,
     /*  67954 */ // Label 1580: @67954
     /*  67954 */ GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(68048), // Rule ID 22455 //
     /*  67959 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67962 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67969 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67973 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67977 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67981 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67985 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67989 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67993 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67996 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68003 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68007 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68012 */   // MIs[0] dst
     /*  68012 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68017 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68019 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68026 */   // (atomic_store (xor:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  68029 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68033 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  68037 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68040 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68046 */   GIR_RootConstrainSelectedInstOperands,
     /*  68047 */   // GIR_Coverage, 22455,
     /*  68047 */   GIR_EraseRootFromParent_Done,
     /*  68048 */ // Label 1581: @68048
     /*  68048 */ GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(68142), // Rule ID 26012 //
     /*  68053 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68056 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68063 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68067 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68071 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68075 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68079 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68084 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68088 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68092 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68095 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68102 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68106 */   // MIs[0] dst
     /*  68106 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68111 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68113 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68120 */   // (atomic_store (xor:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  68123 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68127 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  68131 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68134 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68140 */   GIR_RootConstrainSelectedInstOperands,
     /*  68141 */   // GIR_Coverage, 26012,
     /*  68141 */   GIR_EraseRootFromParent_Done,
     /*  68142 */ // Label 1582: @68142
     /*  68142 */ GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(68230), // Rule ID 410 //
     /*  68147 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68150 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68154 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68158 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  68162 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68166 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68170 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68174 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68178 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68181 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68185 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68189 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68194 */   // MIs[0] src1
     /*  68194 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68199 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68201 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68208 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  68211 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68215 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  68219 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68222 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68228 */   GIR_RootConstrainSelectedInstOperands,
     /*  68229 */   // GIR_Coverage, 410,
     /*  68229 */   GIR_EraseRootFromParent_Done,
     /*  68230 */ // Label 1583: @68230
     /*  68230 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(68318), // Rule ID 23220 //
     /*  68235 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68238 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68242 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68246 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  68250 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68254 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68258 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68263 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68267 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68271 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68274 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68278 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68282 */   // MIs[0] src1
     /*  68282 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68287 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68289 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68296 */   // (st (add:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  68299 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68303 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  68307 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68310 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68316 */   GIR_RootConstrainSelectedInstOperands,
     /*  68317 */   // GIR_Coverage, 23220,
     /*  68317 */   GIR_EraseRootFromParent_Done,
     /*  68318 */ // Label 1584: @68318
     /*  68318 */ GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(68406), // Rule ID 302 //
     /*  68323 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68326 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68330 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68334 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68338 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68342 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68346 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68350 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68354 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68357 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68361 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68365 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68370 */   // MIs[0] src1
     /*  68370 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68375 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68377 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68384 */   // (st (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  68387 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68391 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  68395 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68398 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68404 */   GIR_RootConstrainSelectedInstOperands,
     /*  68405 */   // GIR_Coverage, 302,
     /*  68405 */   GIR_EraseRootFromParent_Done,
     /*  68406 */ // Label 1585: @68406
     /*  68406 */ GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(68494), // Rule ID 23184 //
     /*  68411 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68414 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68418 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68422 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68426 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68430 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68434 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68439 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68443 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68447 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68450 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68454 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68458 */   // MIs[0] src1
     /*  68458 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68463 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68465 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68472 */   // (st (and:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  68475 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68479 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  68483 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68486 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68492 */   GIR_RootConstrainSelectedInstOperands,
     /*  68493 */   // GIR_Coverage, 23184,
     /*  68493 */   GIR_EraseRootFromParent_Done,
     /*  68494 */ // Label 1586: @68494
     /*  68494 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(68592), // Rule ID 749 //
     /*  68499 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68502 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68506 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68510 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  68514 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68518 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  68522 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68526 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68530 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68533 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68537 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  68541 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  68546 */   // MIs[0] src1
     /*  68546 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68551 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68553 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68560 */   // (st (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  68560 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68564 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68570 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  68574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mCL),
     /*  68577 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68581 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68584 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68590 */   GIR_RootConstrainSelectedInstOperands,
     /*  68591 */   // GIR_Coverage, 749,
     /*  68591 */   GIR_EraseRootFromParent_Done,
     /*  68592 */ // Label 1587: @68592
     /*  68592 */ GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(68690), // Rule ID 717 //
     /*  68597 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68600 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68604 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68608 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  68612 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68616 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  68620 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68624 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68628 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68631 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68635 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  68639 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  68644 */   // MIs[0] src1
     /*  68644 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68649 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68651 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68658 */   // (st (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  68658 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68662 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68668 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  68672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mCL),
     /*  68675 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68679 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68682 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68688 */   GIR_RootConstrainSelectedInstOperands,
     /*  68689 */   // GIR_Coverage, 717,
     /*  68689 */   GIR_EraseRootFromParent_Done,
     /*  68690 */ // Label 1588: @68690
     /*  68690 */ GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(68778), // Rule ID 338 //
     /*  68695 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68698 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68702 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68706 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  68710 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68714 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68718 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68722 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68726 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68729 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68733 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68737 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68742 */   // MIs[0] src1
     /*  68742 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68747 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68749 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68756 */   // (st (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  68759 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68763 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  68767 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68770 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68776 */   GIR_RootConstrainSelectedInstOperands,
     /*  68777 */   // GIR_Coverage, 338,
     /*  68777 */   GIR_EraseRootFromParent_Done,
     /*  68778 */ // Label 1589: @68778
     /*  68778 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(68866), // Rule ID 23196 //
     /*  68783 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68786 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68790 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68794 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  68798 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68802 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68806 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68811 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68815 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68819 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68822 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68826 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68830 */   // MIs[0] src1
     /*  68830 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68835 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68837 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68844 */   // (st (or:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  68847 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68851 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  68855 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68858 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68864 */   GIR_RootConstrainSelectedInstOperands,
     /*  68865 */   // GIR_Coverage, 23196,
     /*  68865 */   GIR_EraseRootFromParent_Done,
     /*  68866 */ // Label 1590: @68866
     /*  68866 */ GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(68964), // Rule ID 781 //
     /*  68871 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68874 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68878 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68882 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  68886 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68890 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  68894 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68898 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68902 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68905 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68909 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  68913 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  68918 */   // MIs[0] src1
     /*  68918 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68923 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68925 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68932 */   // (st (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  68932 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68936 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68942 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  68946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mCL),
     /*  68949 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68953 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68956 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68962 */   GIR_RootConstrainSelectedInstOperands,
     /*  68963 */   // GIR_Coverage, 781,
     /*  68963 */   GIR_EraseRootFromParent_Done,
     /*  68964 */ // Label 1591: @68964
     /*  68964 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(69062), // Rule ID 813 //
     /*  68969 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68972 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68976 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68980 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  68984 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68988 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  68992 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68996 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69000 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69003 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69007 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  69011 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  69016 */   // MIs[0] src1
     /*  69016 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69021 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69023 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69030 */   // (st (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  69030 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69034 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69040 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  69044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mCL),
     /*  69047 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69051 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69054 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69060 */   GIR_RootConstrainSelectedInstOperands,
     /*  69061 */   // GIR_Coverage, 813,
     /*  69061 */   GIR_EraseRootFromParent_Done,
     /*  69062 */ // Label 1592: @69062
     /*  69062 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(69160), // Rule ID 685 //
     /*  69067 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69070 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69074 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69078 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  69082 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69086 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  69090 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69094 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69098 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69101 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69105 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  69109 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  69114 */   // MIs[0] src1
     /*  69114 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69119 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69121 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69128 */   // (st (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  69128 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69132 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69138 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  69142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mCL),
     /*  69145 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69149 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69152 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69158 */   GIR_RootConstrainSelectedInstOperands,
     /*  69159 */   // GIR_Coverage, 685,
     /*  69159 */   GIR_EraseRootFromParent_Done,
     /*  69160 */ // Label 1593: @69160
     /*  69160 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(69248), // Rule ID 446 //
     /*  69165 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69168 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69172 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69176 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  69180 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69184 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69188 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69192 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69196 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69199 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69203 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69207 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69212 */   // MIs[0] src1
     /*  69212 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69217 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69219 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69226 */   // (st (sub:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mr),
     /*  69229 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69233 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  69237 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69240 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69246 */   GIR_RootConstrainSelectedInstOperands,
     /*  69247 */   // GIR_Coverage, 446,
     /*  69247 */   GIR_EraseRootFromParent_Done,
     /*  69248 */ // Label 1594: @69248
     /*  69248 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(69336), // Rule ID 374 //
     /*  69253 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69256 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69260 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69264 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69268 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69272 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69276 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69280 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69284 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69287 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69291 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69295 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69300 */   // MIs[0] src1
     /*  69300 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69305 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69307 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69314 */   // (st (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  69317 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69321 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  69325 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69328 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69334 */   GIR_RootConstrainSelectedInstOperands,
     /*  69335 */   // GIR_Coverage, 374,
     /*  69335 */   GIR_EraseRootFromParent_Done,
     /*  69336 */ // Label 1595: @69336
     /*  69336 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(69424), // Rule ID 23208 //
     /*  69341 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69344 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69348 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69352 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69356 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69360 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69364 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69369 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69373 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69377 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69380 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69384 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69388 */   // MIs[0] src1
     /*  69388 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69393 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69395 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69402 */   // (st (xor:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  69405 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69409 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  69413 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69416 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69422 */   GIR_RootConstrainSelectedInstOperands,
     /*  69423 */   // GIR_Coverage, 23208,
     /*  69423 */   GIR_EraseRootFromParent_Done,
     /*  69424 */ // Label 1596: @69424
     /*  69424 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(69478), // Rule ID 25 //
     /*  69429 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69432 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69436 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69440 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69444 */   // MIs[1] Operand 1
     /*  69444 */   // No operand predicates
     /*  69444 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  69448 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69452 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69454 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69461 */   // (st (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV16mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  69461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mi),
     /*  69464 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69468 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  69471 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  69476 */   GIR_RootConstrainSelectedInstOperands,
     /*  69477 */   // GIR_Coverage, 25,
     /*  69477 */   GIR_EraseRootFromParent_Done,
     /*  69478 */ // Label 1597: @69478
     /*  69478 */ GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(69531), // Rule ID 22507 //
     /*  69483 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  69486 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  69493 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69497 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69501 */   // MIs[1] Operand 1
     /*  69501 */   // No operand predicates
     /*  69501 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69505 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69507 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69514 */   // (atomic_store (imm:{ *:[i16] }):$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (MOV16mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  69514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mi),
     /*  69517 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69521 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  69524 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  69529 */   GIR_RootConstrainSelectedInstOperands,
     /*  69530 */   // GIR_Coverage, 22507,
     /*  69530 */   GIR_EraseRootFromParent_Done,
     /*  69531 */ // Label 1598: @69531
     /*  69531 */ GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(69594), // Rule ID 50 //
     /*  69536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /*  69539 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69542 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69546 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69550 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  69554 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69558 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69563 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69567 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69569 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69576 */   // (st (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE16mr addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src1)
     /*  69576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16mr),
     /*  69579 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69583 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  69587 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  69592 */   GIR_RootConstrainSelectedInstOperands,
     /*  69593 */   // GIR_Coverage, 50,
     /*  69593 */   GIR_EraseRootFromParent_Done,
     /*  69594 */ // Label 1599: @69594
     /*  69594 */ GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(69657), // Rule ID 56 //
     /*  69599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /*  69602 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69605 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69609 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69613 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  69617 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69621 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69626 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69630 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69632 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69639 */   // (st (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE16mr_EVEX addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src1)
     /*  69639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16mr_EVEX),
     /*  69642 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69646 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  69650 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  69655 */   GIR_RootConstrainSelectedInstOperands,
     /*  69656 */   // GIR_Coverage, 56,
     /*  69656 */   GIR_EraseRootFromParent_Done,
     /*  69657 */ // Label 1600: @69657
     /*  69657 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(69702), // Rule ID 22511 //
     /*  69662 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  69665 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  69672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69676 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69680 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69687 */   // (atomic_store GR16:{ *:[i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (MOV16mr addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  69687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mr),
     /*  69690 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69694 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  69696 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  69700 */   GIR_RootConstrainSelectedInstOperands,
     /*  69701 */   // GIR_Coverage, 22511,
     /*  69701 */   GIR_EraseRootFromParent_Done,
     /*  69702 */ // Label 1601: @69702
     /*  69702 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(69744), // Rule ID 33 //
     /*  69707 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69710 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69718 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69722 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69729 */   // (st GR16:{ *:[i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV16mr addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  69729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mr),
     /*  69732 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69736 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  69738 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  69742 */   GIR_RootConstrainSelectedInstOperands,
     /*  69743 */   // GIR_Coverage, 33,
     /*  69743 */   GIR_EraseRootFromParent_Done,
     /*  69744 */ // Label 1602: @69744
     /*  69744 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(69789), // Rule ID 4621 //
     /*  69749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  69752 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69755 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  69763 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69767 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69774 */   // (st FR16X:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSHZmr addr:{ *:[iPTR] }:$dst, FR16X:{ *:[f16] }:$src)
     /*  69774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSHZmr),
     /*  69777 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69781 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  69783 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  69787 */   GIR_RootConstrainSelectedInstOperands,
     /*  69788 */   // GIR_Coverage, 4621,
     /*  69788 */   GIR_EraseRootFromParent_Done,
     /*  69789 */ // Label 1603: @69789
     /*  69789 */ GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(69855), // Rule ID 18546 //
     /*  69794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  69797 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69800 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69804 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69808 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69815 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PEXTRWmri addr:{ *:[iPTR] }:$dst, (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] })
     /*  69815 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  69818 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69822 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69827 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  69831 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  69836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PEXTRWmri),
     /*  69839 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69843 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69849 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  69853 */   GIR_RootConstrainSelectedInstOperands,
     /*  69854 */   // GIR_Coverage, 18546,
     /*  69854 */   GIR_EraseRootFromParent_Done,
     /*  69855 */ // Label 1604: @69855
     /*  69855 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(69921), // Rule ID 18547 //
     /*  69860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  69863 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69866 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69870 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69874 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69881 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VPEXTRWmri addr:{ *:[iPTR] }:$dst, (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] })
     /*  69881 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  69884 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69888 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69893 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  69897 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  69902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPEXTRWmri),
     /*  69905 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69909 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69915 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  69919 */   GIR_RootConstrainSelectedInstOperands,
     /*  69920 */   // GIR_Coverage, 18547,
     /*  69920 */   GIR_EraseRootFromParent_Done,
     /*  69921 */ // Label 1605: @69921
     /*  69921 */ GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(70033), // Rule ID 18335 //
     /*  69926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  69929 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69932 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69936 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69940 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69947 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV16mr addr:{ *:[iPTR] }:$dst, (EXTRACT_SUBREG:{ *:[i16] } (PEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] }))
     /*  69947 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  69950 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69954 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69959 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  69963 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  69968 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  69971 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::PEXTRWrri),
     /*  69975 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69980 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  69983 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /*  69986 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  69988 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  69991 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69995 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70000 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  70007 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  70012 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  70017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mr),
     /*  70020 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70024 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70027 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70031 */   GIR_RootConstrainSelectedInstOperands,
     /*  70032 */   // GIR_Coverage, 18335,
     /*  70032 */   GIR_EraseRootFromParent_Done,
     /*  70033 */ // Label 1606: @70033
     /*  70033 */ GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(70099), // Rule ID 21839 //
     /*  70038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  70041 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70044 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70048 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70052 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70059 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VPEXTRWZmri addr:{ *:[iPTR] }:$dst, (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] })
     /*  70059 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  70062 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70066 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70071 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70075 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPEXTRWZmri),
     /*  70083 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70087 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  70093 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70097 */   GIR_RootConstrainSelectedInstOperands,
     /*  70098 */   // GIR_Coverage, 21839,
     /*  70098 */   GIR_EraseRootFromParent_Done,
     /*  70099 */ // Label 1607: @70099
     /*  70099 */ GIM_Reject,
     /*  70100 */ // Label 1475: @70100
     /*  70100 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(70192), // Rule ID 22492 //
     /*  70105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70108 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70111 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70118 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70122 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70126 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70130 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70134 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70138 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70142 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70145 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70152 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70156 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  70160 */   // MIs[0] dst
     /*  70160 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70165 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70167 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70174 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_32>>, 1:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (INC32m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32m),
     /*  70177 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70181 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70184 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70190 */   GIR_RootConstrainSelectedInstOperands,
     /*  70191 */   // GIR_Coverage, 22492,
     /*  70191 */   GIR_EraseRootFromParent_Done,
     /*  70192 */ // Label 1608: @70192
     /*  70192 */ GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(70284), // Rule ID 22496 //
     /*  70197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70200 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70203 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70210 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70214 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70218 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70222 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70226 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70230 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70234 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70237 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70244 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70248 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70252 */   // MIs[0] dst
     /*  70252 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70257 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70259 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70266 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (DEC32m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32m),
     /*  70269 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70273 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70276 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70282 */   GIR_RootConstrainSelectedInstOperands,
     /*  70283 */   // GIR_Coverage, 22496,
     /*  70283 */   GIR_EraseRootFromParent_Done,
     /*  70284 */ // Label 1609: @70284
     /*  70284 */ GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(70373), // Rule ID 22500 //
     /*  70289 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70292 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70299 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70303 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  70307 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70311 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70315 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  70319 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70323 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70327 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70330 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70337 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70341 */   // MIs[0] dst
     /*  70341 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70346 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70348 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70355 */   // (atomic_store (sub:{ *:[i32] } 0:{ *:[i32] }, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (NEG32m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32m),
     /*  70358 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70362 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70365 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70371 */   GIR_RootConstrainSelectedInstOperands,
     /*  70372 */   // GIR_Coverage, 22500,
     /*  70372 */   GIR_EraseRootFromParent_Done,
     /*  70373 */ // Label 1610: @70373
     /*  70373 */ GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(70459), // Rule ID 22504 //
     /*  70378 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70381 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70388 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70392 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70396 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70400 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70404 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70408 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70412 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70415 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70422 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70426 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70430 */   // MIs[0] dst
     /*  70430 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70435 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70437 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70444 */   // (atomic_store (xor:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (NOT32m addr:{ *:[iPTR] }:$dst)
     /*  70444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32m),
     /*  70447 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70451 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70457 */   GIR_RootConstrainSelectedInstOperands,
     /*  70458 */   // GIR_Coverage, 22504,
     /*  70458 */   GIR_EraseRootFromParent_Done,
     /*  70459 */ // Label 1611: @70459
     /*  70459 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(70545), // Rule ID 227 //
     /*  70464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70467 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70470 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70474 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70478 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70482 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70486 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70490 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70494 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70498 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70501 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70505 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  70509 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  70513 */   // MIs[0] src1
     /*  70513 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70518 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70520 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70527 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 1:{ *:[i32] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC32m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  70527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32m),
     /*  70530 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  70534 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70537 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70543 */   GIR_RootConstrainSelectedInstOperands,
     /*  70544 */   // GIR_Coverage, 227,
     /*  70544 */   GIR_EraseRootFromParent_Done,
     /*  70545 */ // Label 1612: @70545
     /*  70545 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(70631), // Rule ID 230 //
     /*  70550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70553 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70556 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70560 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70564 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70568 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70572 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70576 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70580 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70584 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70587 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70591 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  70595 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70599 */   // MIs[0] src1
     /*  70599 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70604 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70606 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70613 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC32m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  70613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32m),
     /*  70616 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  70620 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70623 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70629 */   GIR_RootConstrainSelectedInstOperands,
     /*  70630 */   // GIR_Coverage, 230,
     /*  70630 */   GIR_EraseRootFromParent_Done,
     /*  70631 */ // Label 1613: @70631
     /*  70631 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(70724), // Rule ID 22612 //
     /*  70636 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70639 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70643 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70647 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70651 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70655 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70659 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70663 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70667 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70670 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70674 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  70678 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(128),
     /*  70689 */   // MIs[0] dst
     /*  70689 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70694 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70696 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70703 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 128:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -128:{ *:[i32] })
     /*  70703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi),
     /*  70706 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  70713 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70716 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70722 */   GIR_RootConstrainSelectedInstOperands,
     /*  70723 */   // GIR_Coverage, 22612,
     /*  70723 */   GIR_EraseRootFromParent_Done,
     /*  70724 */ // Label 1614: @70724
     /*  70724 */ GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(70807), // Rule ID 17613 //
     /*  70729 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70732 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70736 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70740 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  70744 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70748 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  70752 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70756 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70760 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70763 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70767 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  70771 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 31,
     /*  70775 */   // MIs[0] dst
     /*  70775 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70780 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70782 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70789 */   // (st (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR32m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32m1),
     /*  70792 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70796 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70799 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70805 */   GIR_RootConstrainSelectedInstOperands,
     /*  70806 */   // GIR_Coverage, 17613,
     /*  70806 */   GIR_EraseRootFromParent_Done,
     /*  70807 */ // Label 1615: @70807
     /*  70807 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(70890), // Rule ID 17617 //
     /*  70812 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70815 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70819 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70823 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  70827 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70831 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  70835 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70839 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70843 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70846 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70850 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  70854 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 31,
     /*  70858 */   // MIs[0] dst
     /*  70858 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70863 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70865 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70872 */   // (st (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL32m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32m1),
     /*  70875 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70879 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70882 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70888 */   GIR_RootConstrainSelectedInstOperands,
     /*  70889 */   // GIR_Coverage, 17617,
     /*  70889 */   GIR_EraseRootFromParent_Done,
     /*  70890 */ // Label 1616: @70890
     /*  70890 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(70973), // Rule ID 263 //
     /*  70895 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70898 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70902 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70906 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  70910 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70914 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70918 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  70922 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70926 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70930 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70933 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70937 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  70941 */   // MIs[0] src1
     /*  70941 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70946 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70948 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70955 */   // (st (sub:{ *:[i32] } 0:{ *:[i32] }, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG32m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  70955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32m),
     /*  70958 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  70962 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70965 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70971 */   GIR_RootConstrainSelectedInstOperands,
     /*  70972 */   // GIR_Coverage, 263,
     /*  70972 */   GIR_EraseRootFromParent_Done,
     /*  70973 */ // Label 1617: @70973
     /*  70973 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(71053), // Rule ID 271 //
     /*  70978 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70981 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70985 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70989 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70993 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70997 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71001 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71005 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71009 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71012 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71016 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71020 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  71024 */   // MIs[0] src1
     /*  71024 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71029 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71031 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71038 */   // (st (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT32m addr:{ *:[iPTR] }:$src1)
     /*  71038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32m),
     /*  71041 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71045 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71051 */   GIR_RootConstrainSelectedInstOperands,
     /*  71052 */   // GIR_Coverage, 271,
     /*  71052 */   GIR_EraseRootFromParent_Done,
     /*  71053 */ // Label 1618: @71053
     /*  71053 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(71148), // Rule ID 415 //
     /*  71058 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71061 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71065 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71069 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  71073 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71077 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71081 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71085 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71089 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71092 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71096 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71100 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71104 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71108 */   // MIs[3] Operand 1
     /*  71108 */   // No operand predicates
     /*  71108 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71112 */   // MIs[0] src1
     /*  71112 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71117 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71119 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71126 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mi),
     /*  71129 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71133 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71136 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71139 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71146 */   GIR_RootConstrainSelectedInstOperands,
     /*  71147 */   // GIR_Coverage, 415,
     /*  71147 */   GIR_EraseRootFromParent_Done,
     /*  71148 */ // Label 1619: @71148
     /*  71148 */ GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(71243), // Rule ID 307 //
     /*  71153 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71156 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71160 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71164 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71168 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71172 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71176 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71180 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71184 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71187 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71191 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71195 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71199 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71203 */   // MIs[3] Operand 1
     /*  71203 */   // No operand predicates
     /*  71203 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71207 */   // MIs[0] src1
     /*  71207 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71212 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71214 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71221 */   // (st (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mi),
     /*  71224 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71228 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71231 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71234 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71241 */   GIR_RootConstrainSelectedInstOperands,
     /*  71242 */   // GIR_Coverage, 307,
     /*  71242 */   GIR_EraseRootFromParent_Done,
     /*  71243 */ // Label 1620: @71243
     /*  71243 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(71338), // Rule ID 343 //
     /*  71248 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71251 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71255 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71259 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  71263 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71267 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71271 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71275 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71279 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71282 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71286 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71290 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71294 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71298 */   // MIs[3] Operand 1
     /*  71298 */   // No operand predicates
     /*  71298 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71302 */   // MIs[0] src1
     /*  71302 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71307 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71309 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71316 */   // (st (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mi),
     /*  71319 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71323 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71326 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71329 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71336 */   GIR_RootConstrainSelectedInstOperands,
     /*  71337 */   // GIR_Coverage, 343,
     /*  71337 */   GIR_EraseRootFromParent_Done,
     /*  71338 */ // Label 1621: @71338
     /*  71338 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(71433), // Rule ID 455 //
     /*  71343 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71346 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71350 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71354 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  71358 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71362 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71366 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71370 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71374 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71377 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71381 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71385 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71389 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71393 */   // MIs[3] Operand 1
     /*  71393 */   // No operand predicates
     /*  71393 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71397 */   // MIs[0] src1
     /*  71397 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71402 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71404 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71411 */   // (st (sub:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi),
     /*  71414 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71418 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71421 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71424 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71431 */   GIR_RootConstrainSelectedInstOperands,
     /*  71432 */   // GIR_Coverage, 455,
     /*  71432 */   GIR_EraseRootFromParent_Done,
     /*  71433 */ // Label 1622: @71433
     /*  71433 */ GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(71528), // Rule ID 379 //
     /*  71438 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71441 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71445 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71449 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71453 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71457 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71461 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71465 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71469 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71472 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71476 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71480 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71484 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71488 */   // MIs[3] Operand 1
     /*  71488 */   // No operand predicates
     /*  71488 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71492 */   // MIs[0] src1
     /*  71492 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71497 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71499 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71506 */   // (st (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mi),
     /*  71509 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71513 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71516 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71519 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71526 */   GIR_RootConstrainSelectedInstOperands,
     /*  71527 */   // GIR_Coverage, 379,
     /*  71527 */   GIR_EraseRootFromParent_Done,
     /*  71528 */ // Label 1623: @71528
     /*  71528 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(71625), // Rule ID 22428 //
     /*  71533 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71536 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71543 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71547 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  71551 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71555 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71559 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71563 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71567 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71570 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71577 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71581 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71585 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71589 */   // MIs[3] Operand 1
     /*  71589 */   // No operand predicates
     /*  71589 */   // MIs[0] dst
     /*  71589 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71594 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71596 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71603 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (ADD32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  71603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mi),
     /*  71606 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71610 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  71613 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71616 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71623 */   GIR_RootConstrainSelectedInstOperands,
     /*  71624 */   // GIR_Coverage, 22428,
     /*  71624 */   GIR_EraseRootFromParent_Done,
     /*  71625 */ // Label 1624: @71625
     /*  71625 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(71722), // Rule ID 22436 //
     /*  71630 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71633 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71640 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71644 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71648 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71652 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71656 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71660 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71664 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71667 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71674 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71678 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71682 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71686 */   // MIs[3] Operand 1
     /*  71686 */   // No operand predicates
     /*  71686 */   // MIs[0] dst
     /*  71686 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71691 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71693 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71700 */   // (atomic_store (and:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (AND32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  71700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mi),
     /*  71703 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71707 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  71710 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71720 */   GIR_RootConstrainSelectedInstOperands,
     /*  71721 */   // GIR_Coverage, 22436,
     /*  71721 */   GIR_EraseRootFromParent_Done,
     /*  71722 */ // Label 1625: @71722
     /*  71722 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(71819), // Rule ID 22444 //
     /*  71727 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71730 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71737 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71741 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  71745 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71749 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71753 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71757 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71761 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71764 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71771 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71775 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71779 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71783 */   // MIs[3] Operand 1
     /*  71783 */   // No operand predicates
     /*  71783 */   // MIs[0] dst
     /*  71783 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71788 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71790 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71797 */   // (atomic_store (or:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (OR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  71797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mi),
     /*  71800 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71804 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  71807 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71810 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71817 */   GIR_RootConstrainSelectedInstOperands,
     /*  71818 */   // GIR_Coverage, 22444,
     /*  71818 */   GIR_EraseRootFromParent_Done,
     /*  71819 */ // Label 1626: @71819
     /*  71819 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(71916), // Rule ID 22460 //
     /*  71824 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71827 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71834 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71838 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  71842 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71846 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71850 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71854 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71858 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71861 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71868 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71872 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71876 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71880 */   // MIs[3] Operand 1
     /*  71880 */   // No operand predicates
     /*  71880 */   // MIs[0] dst
     /*  71880 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71885 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71887 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71894 */   // (atomic_store (sub:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (SUB32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  71894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi),
     /*  71897 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71901 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  71904 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71907 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71914 */   GIR_RootConstrainSelectedInstOperands,
     /*  71915 */   // GIR_Coverage, 22460,
     /*  71915 */   GIR_EraseRootFromParent_Done,
     /*  71916 */ // Label 1627: @71916
     /*  71916 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(72013), // Rule ID 22452 //
     /*  71921 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71924 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71931 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71935 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71939 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71943 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71947 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71951 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71955 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71958 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71965 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71969 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71973 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71977 */   // MIs[3] Operand 1
     /*  71977 */   // No operand predicates
     /*  71977 */   // MIs[0] dst
     /*  71977 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71982 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71984 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71991 */   // (atomic_store (xor:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (XOR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  71991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mi),
     /*  71994 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71998 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72001 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72004 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72011 */   GIR_RootConstrainSelectedInstOperands,
     /*  72012 */   // GIR_Coverage, 22452,
     /*  72012 */   GIR_EraseRootFromParent_Done,
     /*  72013 */ // Label 1628: @72013
     /*  72013 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(72117), // Rule ID 833 //
     /*  72018 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72021 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72025 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72029 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  72033 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72037 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72041 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  72045 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72049 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72053 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72056 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72060 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72064 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  72069 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  72073 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72077 */   // MIs[3] Operand 1
     /*  72077 */   // No operand predicates
     /*  72077 */   // MIs[0] src1
     /*  72077 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72082 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72084 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72091 */   // (st (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD32mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  72091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mri8),
     /*  72094 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72098 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  72102 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  72105 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72108 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72115 */   GIR_RootConstrainSelectedInstOperands,
     /*  72116 */   // GIR_Coverage, 833,
     /*  72116 */   GIR_EraseRootFromParent_Done,
     /*  72117 */ // Label 1629: @72117
     /*  72117 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(72221), // Rule ID 857 //
     /*  72122 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72125 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72129 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72133 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  72137 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72141 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72145 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  72149 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  72154 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72158 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72162 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72165 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72169 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72173 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  72177 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72181 */   // MIs[3] Operand 1
     /*  72181 */   // No operand predicates
     /*  72181 */   // MIs[0] src1
     /*  72181 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72186 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72188 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72195 */   // (st (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD32mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  72195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mri8),
     /*  72198 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72202 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  72206 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  72209 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72212 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72219 */   GIR_RootConstrainSelectedInstOperands,
     /*  72220 */   // GIR_Coverage, 857,
     /*  72220 */   GIR_EraseRootFromParent_Done,
     /*  72221 */ // Label 1630: @72221
     /*  72221 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(72312), // Rule ID 734 //
     /*  72226 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72229 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72233 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72237 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  72241 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72245 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72249 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72253 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72257 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72260 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72264 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72268 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72272 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72276 */   // MIs[3] Operand 1
     /*  72276 */   // No operand predicates
     /*  72276 */   // MIs[0] src1
     /*  72276 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72281 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72283 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72290 */   // (st (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mi),
     /*  72293 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72297 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72300 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72303 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72310 */   GIR_RootConstrainSelectedInstOperands,
     /*  72311 */   // GIR_Coverage, 734,
     /*  72311 */   GIR_EraseRootFromParent_Done,
     /*  72312 */ // Label 1631: @72312
     /*  72312 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(72403), // Rule ID 702 //
     /*  72317 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72320 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72324 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72328 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  72332 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72336 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72340 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72344 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72348 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72351 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72355 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72359 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72363 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72367 */   // MIs[3] Operand 1
     /*  72367 */   // No operand predicates
     /*  72367 */   // MIs[0] src1
     /*  72367 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72372 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72374 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72381 */   // (st (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mi),
     /*  72384 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72388 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72391 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72394 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72401 */   GIR_RootConstrainSelectedInstOperands,
     /*  72402 */   // GIR_Coverage, 702,
     /*  72402 */   GIR_EraseRootFromParent_Done,
     /*  72403 */ // Label 1632: @72403
     /*  72403 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(72494), // Rule ID 766 //
     /*  72408 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72411 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72415 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72419 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  72423 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72427 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72431 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72435 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72439 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72442 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72446 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72450 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72454 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72458 */   // MIs[3] Operand 1
     /*  72458 */   // No operand predicates
     /*  72458 */   // MIs[0] src1
     /*  72458 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72463 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72465 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72472 */   // (st (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mi),
     /*  72475 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72479 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72482 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72485 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72492 */   GIR_RootConstrainSelectedInstOperands,
     /*  72493 */   // GIR_Coverage, 766,
     /*  72493 */   GIR_EraseRootFromParent_Done,
     /*  72494 */ // Label 1633: @72494
     /*  72494 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(72585), // Rule ID 798 //
     /*  72499 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72502 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72506 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72510 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  72514 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72518 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72522 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72526 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72530 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72533 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72537 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72541 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72545 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72549 */   // MIs[3] Operand 1
     /*  72549 */   // No operand predicates
     /*  72549 */   // MIs[0] src1
     /*  72549 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72554 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72556 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72563 */   // (st (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mi),
     /*  72566 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72570 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72573 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72576 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72583 */   GIR_RootConstrainSelectedInstOperands,
     /*  72584 */   // GIR_Coverage, 798,
     /*  72584 */   GIR_EraseRootFromParent_Done,
     /*  72585 */ // Label 1634: @72585
     /*  72585 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(72676), // Rule ID 670 //
     /*  72590 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72593 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72597 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72601 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  72605 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72609 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72613 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72617 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72621 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72624 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72628 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72632 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72636 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72640 */   // MIs[3] Operand 1
     /*  72640 */   // No operand predicates
     /*  72640 */   // MIs[0] src1
     /*  72640 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72645 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72647 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72654 */   // (st (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mi),
     /*  72657 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72661 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72664 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72667 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72674 */   GIR_RootConstrainSelectedInstOperands,
     /*  72675 */   // GIR_Coverage, 670,
     /*  72675 */   GIR_EraseRootFromParent_Done,
     /*  72676 */ // Label 1635: @72676
     /*  72676 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(72770), // Rule ID 22432 //
     /*  72681 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72684 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72691 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72695 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  72699 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72703 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72707 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72711 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72715 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72718 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72725 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72729 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  72734 */   // MIs[0] dst
     /*  72734 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72739 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72741 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72748 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  72748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  72751 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72755 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  72759 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72762 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  72768 */   GIR_RootConstrainSelectedInstOperands,
     /*  72769 */   // GIR_Coverage, 22432,
     /*  72769 */   GIR_EraseRootFromParent_Done,
     /*  72770 */ // Label 1636: @72770
     /*  72770 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(72864), // Rule ID 26001 //
     /*  72775 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72778 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72785 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72789 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  72793 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72797 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72801 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  72806 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72810 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72814 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72817 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72824 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72828 */   // MIs[0] dst
     /*  72828 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72833 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72835 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72842 */   // (atomic_store (add:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  72842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  72845 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72849 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  72853 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72856 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  72862 */   GIR_RootConstrainSelectedInstOperands,
     /*  72863 */   // GIR_Coverage, 26001,
     /*  72863 */   GIR_EraseRootFromParent_Done,
     /*  72864 */ // Label 1637: @72864
     /*  72864 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(72958), // Rule ID 22440 //
     /*  72869 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72872 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72879 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72883 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72887 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72891 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72895 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72899 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72903 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72906 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72913 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72917 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  72922 */   // MIs[0] dst
     /*  72922 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72927 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72929 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72936 */   // (atomic_store (and:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  72936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  72939 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72943 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  72947 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72950 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  72956 */   GIR_RootConstrainSelectedInstOperands,
     /*  72957 */   // GIR_Coverage, 22440,
     /*  72957 */   GIR_EraseRootFromParent_Done,
     /*  72958 */ // Label 1638: @72958
     /*  72958 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(73052), // Rule ID 26005 //
     /*  72963 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72966 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72973 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72977 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72981 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72985 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72989 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  72994 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72998 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73002 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73005 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73012 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73016 */   // MIs[0] dst
     /*  73016 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73021 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73023 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73030 */   // (atomic_store (and:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  73033 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73037 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73041 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73044 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73050 */   GIR_RootConstrainSelectedInstOperands,
     /*  73051 */   // GIR_Coverage, 26005,
     /*  73051 */   GIR_EraseRootFromParent_Done,
     /*  73052 */ // Label 1639: @73052
     /*  73052 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(73146), // Rule ID 22448 //
     /*  73057 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73060 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73067 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73071 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  73075 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73079 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73083 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73087 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73091 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73094 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73101 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73105 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73110 */   // MIs[0] dst
     /*  73110 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73115 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73117 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73124 */   // (atomic_store (or:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  73127 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73131 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73135 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73144 */   GIR_RootConstrainSelectedInstOperands,
     /*  73145 */   // GIR_Coverage, 22448,
     /*  73145 */   GIR_EraseRootFromParent_Done,
     /*  73146 */ // Label 1640: @73146
     /*  73146 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(73240), // Rule ID 26009 //
     /*  73151 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73154 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73161 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73165 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  73169 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73173 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73177 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73182 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73186 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73190 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73193 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73200 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73204 */   // MIs[0] dst
     /*  73204 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73209 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73211 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73218 */   // (atomic_store (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  73221 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73225 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73229 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73232 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73238 */   GIR_RootConstrainSelectedInstOperands,
     /*  73239 */   // GIR_Coverage, 26009,
     /*  73239 */   GIR_EraseRootFromParent_Done,
     /*  73240 */ // Label 1641: @73240
     /*  73240 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(73334), // Rule ID 22464 //
     /*  73245 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73248 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73255 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73259 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  73263 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73267 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73271 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73275 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73279 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73282 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73289 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73293 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73298 */   // MIs[0] dst
     /*  73298 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73303 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73305 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73312 */   // (atomic_store (sub:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (SUB32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mr),
     /*  73315 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73319 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73323 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73326 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73332 */   GIR_RootConstrainSelectedInstOperands,
     /*  73333 */   // GIR_Coverage, 22464,
     /*  73333 */   GIR_EraseRootFromParent_Done,
     /*  73334 */ // Label 1642: @73334
     /*  73334 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(73428), // Rule ID 22456 //
     /*  73339 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73342 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73349 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73353 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73357 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73361 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73365 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73369 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73373 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73376 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73383 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73387 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73392 */   // MIs[0] dst
     /*  73392 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73397 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73399 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73406 */   // (atomic_store (xor:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  73409 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73413 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73417 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73420 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73426 */   GIR_RootConstrainSelectedInstOperands,
     /*  73427 */   // GIR_Coverage, 22456,
     /*  73427 */   GIR_EraseRootFromParent_Done,
     /*  73428 */ // Label 1643: @73428
     /*  73428 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(73522), // Rule ID 26013 //
     /*  73433 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73436 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73443 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73447 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73451 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73455 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73459 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73464 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73468 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73472 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73475 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73482 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73486 */   // MIs[0] dst
     /*  73486 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73491 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73493 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73500 */   // (atomic_store (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  73503 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73507 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73511 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73514 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73520 */   GIR_RootConstrainSelectedInstOperands,
     /*  73521 */   // GIR_Coverage, 26013,
     /*  73521 */   GIR_EraseRootFromParent_Done,
     /*  73522 */ // Label 1644: @73522
     /*  73522 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(73633), // Rule ID 836 //
     /*  73527 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73530 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73534 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73538 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  73542 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73546 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73550 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  73554 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73558 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73562 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73565 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73569 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  73573 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73578 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  73583 */   // MIs[0] src1
     /*  73583 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73588 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73590 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73597 */   // (st (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD32mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  73597 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73601 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73607 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  73611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mrCL),
     /*  73614 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  73618 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  73622 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73625 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73631 */   GIR_RootConstrainSelectedInstOperands,
     /*  73632 */   // GIR_Coverage, 836,
     /*  73632 */   GIR_EraseRootFromParent_Done,
     /*  73633 */ // Label 1645: @73633
     /*  73633 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(73744), // Rule ID 860 //
     /*  73638 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73641 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73645 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73649 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  73653 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73657 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73661 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  73665 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73670 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73674 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73678 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73681 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73685 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  73689 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  73694 */   // MIs[0] src1
     /*  73694 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73699 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73701 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73708 */   // (st (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD32mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  73708 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73712 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73718 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  73722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mrCL),
     /*  73725 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  73729 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  73733 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73736 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73742 */   GIR_RootConstrainSelectedInstOperands,
     /*  73743 */   // GIR_Coverage, 860,
     /*  73743 */   GIR_EraseRootFromParent_Done,
     /*  73744 */ // Label 1646: @73744
     /*  73744 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(73832), // Rule ID 411 //
     /*  73749 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73752 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73756 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73760 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  73764 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73768 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73772 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73776 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73780 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73783 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73787 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73791 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73796 */   // MIs[0] src1
     /*  73796 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73801 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73803 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73810 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  73810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  73813 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  73817 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  73821 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73824 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73830 */   GIR_RootConstrainSelectedInstOperands,
     /*  73831 */   // GIR_Coverage, 411,
     /*  73831 */   GIR_EraseRootFromParent_Done,
     /*  73832 */ // Label 1647: @73832
     /*  73832 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(73920), // Rule ID 23221 //
     /*  73837 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73840 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73844 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73848 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  73852 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73856 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73860 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73865 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73869 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73873 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73876 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73880 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73884 */   // MIs[0] src1
     /*  73884 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73889 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73891 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73898 */   // (st (add:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  73898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  73901 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  73905 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  73909 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73912 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73918 */   GIR_RootConstrainSelectedInstOperands,
     /*  73919 */   // GIR_Coverage, 23221,
     /*  73919 */   GIR_EraseRootFromParent_Done,
     /*  73920 */ // Label 1648: @73920
     /*  73920 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(74008), // Rule ID 303 //
     /*  73925 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73928 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73932 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73936 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73940 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73944 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73948 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73952 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73956 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73959 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73963 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73967 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73972 */   // MIs[0] src1
     /*  73972 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73977 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73979 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73986 */   // (st (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  73986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  73989 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  73993 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  73997 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74000 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74006 */   GIR_RootConstrainSelectedInstOperands,
     /*  74007 */   // GIR_Coverage, 303,
     /*  74007 */   GIR_EraseRootFromParent_Done,
     /*  74008 */ // Label 1649: @74008
     /*  74008 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(74096), // Rule ID 23185 //
     /*  74013 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74016 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74020 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74024 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74028 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74032 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74036 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74041 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74045 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74049 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74052 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74056 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74060 */   // MIs[0] src1
     /*  74060 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74065 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74067 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74074 */   // (st (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  74077 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74081 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74085 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74088 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74094 */   GIR_RootConstrainSelectedInstOperands,
     /*  74095 */   // GIR_Coverage, 23185,
     /*  74095 */   GIR_EraseRootFromParent_Done,
     /*  74096 */ // Label 1650: @74096
     /*  74096 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(74194), // Rule ID 750 //
     /*  74101 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74104 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74108 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74112 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  74116 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74120 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74124 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74128 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74132 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74135 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74139 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74143 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74148 */   // MIs[0] src1
     /*  74148 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74153 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74155 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74162 */   // (st (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  74162 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74166 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74172 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  74176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mCL),
     /*  74179 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74183 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74186 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74192 */   GIR_RootConstrainSelectedInstOperands,
     /*  74193 */   // GIR_Coverage, 750,
     /*  74193 */   GIR_EraseRootFromParent_Done,
     /*  74194 */ // Label 1651: @74194
     /*  74194 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(74292), // Rule ID 718 //
     /*  74199 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74202 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74206 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74210 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  74214 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74218 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74222 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74226 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74230 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74233 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74237 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74241 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74246 */   // MIs[0] src1
     /*  74246 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74251 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74253 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74260 */   // (st (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  74260 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74264 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74270 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  74274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mCL),
     /*  74277 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74281 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74284 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74290 */   GIR_RootConstrainSelectedInstOperands,
     /*  74291 */   // GIR_Coverage, 718,
     /*  74291 */   GIR_EraseRootFromParent_Done,
     /*  74292 */ // Label 1652: @74292
     /*  74292 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(74380), // Rule ID 339 //
     /*  74297 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74300 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74304 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74308 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  74312 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74316 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74320 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74324 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74328 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74331 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74335 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74339 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74344 */   // MIs[0] src1
     /*  74344 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74349 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74351 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74358 */   // (st (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  74361 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74365 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74369 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74372 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74378 */   GIR_RootConstrainSelectedInstOperands,
     /*  74379 */   // GIR_Coverage, 339,
     /*  74379 */   GIR_EraseRootFromParent_Done,
     /*  74380 */ // Label 1653: @74380
     /*  74380 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(74468), // Rule ID 23197 //
     /*  74385 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74388 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74392 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74396 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  74400 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74404 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74408 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74413 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74417 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74421 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74424 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74428 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74432 */   // MIs[0] src1
     /*  74432 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74437 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74439 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74446 */   // (st (or:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  74449 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74453 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74457 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74460 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74466 */   GIR_RootConstrainSelectedInstOperands,
     /*  74467 */   // GIR_Coverage, 23197,
     /*  74467 */   GIR_EraseRootFromParent_Done,
     /*  74468 */ // Label 1654: @74468
     /*  74468 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(74566), // Rule ID 782 //
     /*  74473 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74476 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74480 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74484 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  74488 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74492 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74496 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74500 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74504 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74507 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74511 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74515 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74520 */   // MIs[0] src1
     /*  74520 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74525 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74527 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74534 */   // (st (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  74534 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74538 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74544 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  74548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mCL),
     /*  74551 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74555 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74558 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74564 */   GIR_RootConstrainSelectedInstOperands,
     /*  74565 */   // GIR_Coverage, 782,
     /*  74565 */   GIR_EraseRootFromParent_Done,
     /*  74566 */ // Label 1655: @74566
     /*  74566 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(74664), // Rule ID 814 //
     /*  74571 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74574 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74578 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74582 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  74586 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74590 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74594 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74598 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74602 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74605 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74609 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74613 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74618 */   // MIs[0] src1
     /*  74618 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74623 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74625 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74632 */   // (st (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  74632 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74636 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74642 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  74646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mCL),
     /*  74649 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74653 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74656 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74662 */   GIR_RootConstrainSelectedInstOperands,
     /*  74663 */   // GIR_Coverage, 814,
     /*  74663 */   GIR_EraseRootFromParent_Done,
     /*  74664 */ // Label 1656: @74664
     /*  74664 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(74762), // Rule ID 686 //
     /*  74669 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74672 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74676 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74680 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  74684 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74688 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74692 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74696 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74700 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74703 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74707 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74711 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74716 */   // MIs[0] src1
     /*  74716 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74721 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74723 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74730 */   // (st (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  74730 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74734 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74740 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  74744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mCL),
     /*  74747 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74751 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74754 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74760 */   GIR_RootConstrainSelectedInstOperands,
     /*  74761 */   // GIR_Coverage, 686,
     /*  74761 */   GIR_EraseRootFromParent_Done,
     /*  74762 */ // Label 1657: @74762
     /*  74762 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(74850), // Rule ID 447 //
     /*  74767 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74770 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74774 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74778 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  74782 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74786 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74790 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74794 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74798 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74801 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74805 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74809 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74814 */   // MIs[0] src1
     /*  74814 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74819 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74821 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74828 */   // (st (sub:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mr),
     /*  74831 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74835 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74839 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74842 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74848 */   GIR_RootConstrainSelectedInstOperands,
     /*  74849 */   // GIR_Coverage, 447,
     /*  74849 */   GIR_EraseRootFromParent_Done,
     /*  74850 */ // Label 1658: @74850
     /*  74850 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(74938), // Rule ID 375 //
     /*  74855 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74858 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74862 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74866 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74870 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74874 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74878 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74882 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74886 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74889 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74893 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74897 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74902 */   // MIs[0] src1
     /*  74902 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74907 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74909 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74916 */   // (st (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  74919 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74923 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74927 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74930 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74936 */   GIR_RootConstrainSelectedInstOperands,
     /*  74937 */   // GIR_Coverage, 375,
     /*  74937 */   GIR_EraseRootFromParent_Done,
     /*  74938 */ // Label 1659: @74938
     /*  74938 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(75026), // Rule ID 23209 //
     /*  74943 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74946 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74950 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74954 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74958 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74962 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74966 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74971 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74975 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74979 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74982 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74986 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74990 */   // MIs[0] src1
     /*  74990 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74995 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74997 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75004 */   // (st (xor:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  75004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  75007 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75011 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  75015 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75018 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75024 */   GIR_RootConstrainSelectedInstOperands,
     /*  75025 */   // GIR_Coverage, 23209,
     /*  75025 */   GIR_EraseRootFromParent_Done,
     /*  75026 */ // Label 1660: @75026
     /*  75026 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(75080), // Rule ID 26 //
     /*  75031 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75034 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75038 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75042 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75046 */   // MIs[1] Operand 1
     /*  75046 */   // No operand predicates
     /*  75046 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  75050 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75054 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75056 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75063 */   // (st (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV32mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  75063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mi),
     /*  75066 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75070 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  75073 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75078 */   GIR_RootConstrainSelectedInstOperands,
     /*  75079 */   // GIR_Coverage, 26,
     /*  75079 */   GIR_EraseRootFromParent_Done,
     /*  75080 */ // Label 1661: @75080
     /*  75080 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(75146), // Rule ID 22518 //
     /*  75085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  75088 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75091 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75098 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75102 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  75106 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75110 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75115 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75119 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75121 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75128 */   // (atomic_store (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (MOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSmr),
     /*  75131 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75135 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  75139 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75144 */   GIR_RootConstrainSelectedInstOperands,
     /*  75145 */   // GIR_Coverage, 22518,
     /*  75145 */   GIR_EraseRootFromParent_Done,
     /*  75146 */ // Label 1662: @75146
     /*  75146 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(75212), // Rule ID 22519 //
     /*  75151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  75154 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75157 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75164 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75168 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  75172 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75176 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75181 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75185 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75187 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75194 */   // (atomic_store (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (VMOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSmr),
     /*  75197 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75201 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  75205 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75210 */   GIR_RootConstrainSelectedInstOperands,
     /*  75211 */   // GIR_Coverage, 22519,
     /*  75211 */   GIR_EraseRootFromParent_Done,
     /*  75212 */ // Label 1663: @75212
     /*  75212 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(75278), // Rule ID 22520 //
     /*  75217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  75220 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75223 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75230 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75234 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  75238 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75242 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75247 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75251 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75253 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75260 */   // (atomic_store (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (VMOVSSZmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZmr),
     /*  75263 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75267 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  75271 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75276 */   GIR_RootConstrainSelectedInstOperands,
     /*  75277 */   // GIR_Coverage, 22520,
     /*  75277 */   GIR_EraseRootFromParent_Done,
     /*  75278 */ // Label 1664: @75278
     /*  75278 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(75331), // Rule ID 22508 //
     /*  75283 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75286 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75293 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75297 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75301 */   // MIs[1] Operand 1
     /*  75301 */   // No operand predicates
     /*  75301 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75305 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75307 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75314 */   // (atomic_store (imm:{ *:[i32] }):$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (MOV32mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  75314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mi),
     /*  75317 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75321 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  75324 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75329 */   GIR_RootConstrainSelectedInstOperands,
     /*  75330 */   // GIR_Coverage, 22508,
     /*  75330 */   GIR_EraseRootFromParent_Done,
     /*  75331 */ // Label 1665: @75331
     /*  75331 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(75394), // Rule ID 52 //
     /*  75336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /*  75339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75342 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  75354 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75358 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75363 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75367 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75369 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75376 */   // (st (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE32mr addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src1)
     /*  75376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32mr),
     /*  75379 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75383 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  75387 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75392 */   GIR_RootConstrainSelectedInstOperands,
     /*  75393 */   // GIR_Coverage, 52,
     /*  75393 */   GIR_EraseRootFromParent_Done,
     /*  75394 */ // Label 1666: @75394
     /*  75394 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(75457), // Rule ID 58 //
     /*  75399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /*  75402 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75405 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75409 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75413 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  75417 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75421 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75426 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75430 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75432 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75439 */   // (st (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE32mr_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src1)
     /*  75439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32mr_EVEX),
     /*  75442 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75446 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  75450 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75455 */   GIR_RootConstrainSelectedInstOperands,
     /*  75456 */   // GIR_Coverage, 58,
     /*  75456 */   GIR_EraseRootFromParent_Done,
     /*  75457 */ // Label 1667: @75457
     /*  75457 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(75502), // Rule ID 22512 //
     /*  75462 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75465 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75476 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75480 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75487 */   // (atomic_store GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (MOV32mr addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  75487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mr),
     /*  75490 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75494 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75496 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75500 */   GIR_RootConstrainSelectedInstOperands,
     /*  75501 */   // GIR_Coverage, 22512,
     /*  75501 */   GIR_EraseRootFromParent_Done,
     /*  75502 */ // Label 1668: @75502
     /*  75502 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(75544), // Rule ID 34 //
     /*  75507 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75510 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75518 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75522 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75529 */   // (st GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV32mr addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  75529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mr),
     /*  75532 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75536 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75538 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75542 */   GIR_RootConstrainSelectedInstOperands,
     /*  75543 */   // GIR_Coverage, 34,
     /*  75543 */   GIR_EraseRootFromParent_Done,
     /*  75544 */ // Label 1669: @75544
     /*  75544 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(75592), // Rule ID 1094 //
     /*  75549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /*  75552 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75555 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /*  75563 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75567 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75574 */   // (st RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST_Fp32m:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP32:{ *:[f32] }:$src)
     /*  75574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp32m),
     /*  75577 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  75581 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75583 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  75586 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75590 */   GIR_RootConstrainSelectedInstOperands,
     /*  75591 */   // GIR_Coverage, 1094,
     /*  75591 */   GIR_EraseRootFromParent_Done,
     /*  75592 */ // Label 1670: @75592
     /*  75592 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(75637), // Rule ID 1687 //
     /*  75597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  75600 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75603 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75611 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75615 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75622 */   // (st FR32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSmr),
     /*  75625 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75629 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75631 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75635 */   GIR_RootConstrainSelectedInstOperands,
     /*  75636 */   // GIR_Coverage, 1687,
     /*  75636 */   GIR_EraseRootFromParent_Done,
     /*  75637 */ // Label 1671: @75637
     /*  75637 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(75682), // Rule ID 1689 //
     /*  75642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  75645 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75648 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75656 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75660 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75667 */   // (st FR32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSmr),
     /*  75670 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75674 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75676 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75680 */   GIR_RootConstrainSelectedInstOperands,
     /*  75681 */   // GIR_Coverage, 1689,
     /*  75681 */   GIR_EraseRootFromParent_Done,
     /*  75682 */ // Label 1672: @75682
     /*  75682 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(75727), // Rule ID 4609 //
     /*  75687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  75690 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75693 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  75701 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75705 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75712 */   // (st FR32X:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSSZmr addr:{ *:[iPTR] }:$dst, FR32X:{ *:[f32] }:$src)
     /*  75712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZmr),
     /*  75715 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75719 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75721 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75725 */   GIR_RootConstrainSelectedInstOperands,
     /*  75726 */   // GIR_Coverage, 4609,
     /*  75726 */   GIR_EraseRootFromParent_Done,
     /*  75727 */ // Label 1673: @75727
     /*  75727 */ GIM_Reject,
     /*  75728 */ // Label 1476: @75728
     /*  75728 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(75820), // Rule ID 22493 //
     /*  75733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  75736 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75739 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  75746 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75750 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  75754 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  75758 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  75762 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75766 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75770 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75773 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  75780 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75784 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  75788 */   // MIs[0] dst
     /*  75788 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75793 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75795 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75802 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_64>>, 1:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (INC64m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  75802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64m),
     /*  75805 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75809 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75812 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75818 */   GIR_RootConstrainSelectedInstOperands,
     /*  75819 */   // GIR_Coverage, 22493,
     /*  75819 */   GIR_EraseRootFromParent_Done,
     /*  75820 */ // Label 1674: @75820
     /*  75820 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(75912), // Rule ID 22497 //
     /*  75825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  75828 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75831 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  75838 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75842 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  75846 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  75850 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  75854 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75858 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75862 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75865 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  75872 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75876 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  75880 */   // MIs[0] dst
     /*  75880 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75885 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75887 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75894 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_64>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (DEC64m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  75894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64m),
     /*  75897 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75901 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75904 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75910 */   GIR_RootConstrainSelectedInstOperands,
     /*  75911 */   // GIR_Coverage, 22497,
     /*  75911 */   GIR_EraseRootFromParent_Done,
     /*  75912 */ // Label 1675: @75912
     /*  75912 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(76001), // Rule ID 22501 //
     /*  75917 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75920 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  75927 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75931 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  75935 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  75939 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  75943 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  75947 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75951 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75955 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75958 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  75965 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75969 */   // MIs[0] dst
     /*  75969 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75974 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75976 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75983 */   // (atomic_store (sub:{ *:[i64] } 0:{ *:[i64] }, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (NEG64m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  75983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64m),
     /*  75986 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75990 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75993 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75999 */   GIR_RootConstrainSelectedInstOperands,
     /*  76000 */   // GIR_Coverage, 22501,
     /*  76000 */   GIR_EraseRootFromParent_Done,
     /*  76001 */ // Label 1676: @76001
     /*  76001 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(76087), // Rule ID 22505 //
     /*  76006 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76009 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76016 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76020 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76024 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76028 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76032 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76036 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76040 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76043 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76050 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76054 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  76058 */   // MIs[0] dst
     /*  76058 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76063 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76065 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76072 */   // (atomic_store (xor:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_64>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (NOT64m addr:{ *:[iPTR] }:$dst)
     /*  76072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64m),
     /*  76075 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76079 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76085 */   GIR_RootConstrainSelectedInstOperands,
     /*  76086 */   // GIR_Coverage, 22505,
     /*  76086 */   GIR_EraseRootFromParent_Done,
     /*  76087 */ // Label 1677: @76087
     /*  76087 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(76173), // Rule ID 231 //
     /*  76092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_UseIncDec),
     /*  76095 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76098 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76102 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76106 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76110 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76114 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76118 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76122 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76126 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76129 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76133 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76137 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  76141 */   // MIs[0] src1
     /*  76141 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76146 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76148 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76155 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 1:{ *:[i64] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC64m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  76155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64m),
     /*  76158 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  76162 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76165 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76171 */   GIR_RootConstrainSelectedInstOperands,
     /*  76172 */   // GIR_Coverage, 231,
     /*  76172 */   GIR_EraseRootFromParent_Done,
     /*  76173 */ // Label 1678: @76173
     /*  76173 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(76259), // Rule ID 232 //
     /*  76178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_UseIncDec),
     /*  76181 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76184 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76188 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76192 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76196 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76200 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76204 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76208 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76212 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76215 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76219 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76223 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  76227 */   // MIs[0] src1
     /*  76227 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76232 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76234 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76241 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC64m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  76241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64m),
     /*  76244 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  76248 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76251 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76257 */   GIR_RootConstrainSelectedInstOperands,
     /*  76258 */   // GIR_Coverage, 232,
     /*  76258 */   GIR_EraseRootFromParent_Done,
     /*  76259 */ // Label 1679: @76259
     /*  76259 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(76352), // Rule ID 22613 //
     /*  76264 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76267 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76271 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76275 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76279 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76283 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76287 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76291 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76295 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76298 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76302 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76306 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(128),
     /*  76317 */   // MIs[0] dst
     /*  76317 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76322 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76324 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76331 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 128:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -128:{ *:[i64] })
     /*  76331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32),
     /*  76334 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  76341 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76344 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76350 */   GIR_RootConstrainSelectedInstOperands,
     /*  76351 */   // GIR_Coverage, 22613,
     /*  76351 */   GIR_EraseRootFromParent_Done,
     /*  76352 */ // Label 1680: @76352
     /*  76352 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(76452), // Rule ID 22621 //
     /*  76357 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76360 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76364 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76368 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76372 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76376 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76380 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76384 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76388 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76391 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76395 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76399 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2147483648),
     /*  76410 */   // MIs[0] dst
     /*  76410 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76415 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76417 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76424 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 2147483648:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -2147483648:{ *:[i64] })
     /*  76424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32),
     /*  76427 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76431 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*  76441 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76444 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76450 */   GIR_RootConstrainSelectedInstOperands,
     /*  76451 */   // GIR_Coverage, 22621,
     /*  76451 */   GIR_EraseRootFromParent_Done,
     /*  76452 */ // Label 1681: @76452
     /*  76452 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(76538), // Rule ID 17614 //
     /*  76457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  76460 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76463 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76467 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  76475 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76479 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  76483 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76487 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76491 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76494 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76498 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76502 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 63,
     /*  76506 */   // MIs[0] dst
     /*  76506 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76511 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76513 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76520 */   // (st (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR64m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64m1),
     /*  76523 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76527 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76530 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76536 */   GIR_RootConstrainSelectedInstOperands,
     /*  76537 */   // GIR_Coverage, 17614,
     /*  76537 */   GIR_EraseRootFromParent_Done,
     /*  76538 */ // Label 1682: @76538
     /*  76538 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(76624), // Rule ID 17618 //
     /*  76543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  76546 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76549 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76553 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76557 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  76561 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76565 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  76569 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76573 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76577 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76580 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76584 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76588 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 63,
     /*  76592 */   // MIs[0] dst
     /*  76592 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76597 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76599 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76606 */   // (st (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL64m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64m1),
     /*  76609 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76613 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76616 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76622 */   GIR_RootConstrainSelectedInstOperands,
     /*  76623 */   // GIR_Coverage, 17618,
     /*  76623 */   GIR_EraseRootFromParent_Done,
     /*  76624 */ // Label 1683: @76624
     /*  76624 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(76710), // Rule ID 264 //
     /*  76629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  76632 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76635 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76639 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76643 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  76647 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76651 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76655 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  76659 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76663 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76667 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76670 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76674 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76678 */   // MIs[0] src1
     /*  76678 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76683 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76685 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76692 */   // (st (sub:{ *:[i64] } 0:{ *:[i64] }, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG64m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  76692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64m),
     /*  76695 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  76699 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76702 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76708 */   GIR_RootConstrainSelectedInstOperands,
     /*  76709 */   // GIR_Coverage, 264,
     /*  76709 */   GIR_EraseRootFromParent_Done,
     /*  76710 */ // Label 1684: @76710
     /*  76710 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(76793), // Rule ID 272 //
     /*  76715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  76718 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76721 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76725 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76729 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76733 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76737 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76741 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76745 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76749 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76752 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76756 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76760 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  76764 */   // MIs[0] src1
     /*  76764 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76769 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76771 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76778 */   // (st (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT64m addr:{ *:[iPTR] }:$src1)
     /*  76778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64m),
     /*  76781 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  76785 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76791 */   GIR_RootConstrainSelectedInstOperands,
     /*  76792 */   // GIR_Coverage, 272,
     /*  76792 */   GIR_EraseRootFromParent_Done,
     /*  76793 */ // Label 1685: @76793
     /*  76793 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(76894), // Rule ID 22429 //
     /*  76798 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76801 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76808 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76812 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76816 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76820 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76824 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76828 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76832 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76835 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76842 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76846 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  76850 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76854 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  76858 */   // MIs[3] Operand 1
     /*  76858 */   // No operand predicates
     /*  76858 */   // MIs[0] dst
     /*  76858 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76863 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76865 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76872 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (ADD64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  76872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mi32),
     /*  76875 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76879 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  76882 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76885 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  76892 */   GIR_RootConstrainSelectedInstOperands,
     /*  76893 */   // GIR_Coverage, 22429,
     /*  76893 */   GIR_EraseRootFromParent_Done,
     /*  76894 */ // Label 1686: @76894
     /*  76894 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(76995), // Rule ID 22437 //
     /*  76899 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76902 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76909 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76913 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76917 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76921 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76925 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76929 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76933 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76936 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76943 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76947 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  76951 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76955 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  76959 */   // MIs[3] Operand 1
     /*  76959 */   // No operand predicates
     /*  76959 */   // MIs[0] dst
     /*  76959 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76964 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76966 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76973 */   // (atomic_store (and:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (AND64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  76973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mi32),
     /*  76976 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76980 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  76983 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76986 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  76993 */   GIR_RootConstrainSelectedInstOperands,
     /*  76994 */   // GIR_Coverage, 22437,
     /*  76994 */   GIR_EraseRootFromParent_Done,
     /*  76995 */ // Label 1687: @76995
     /*  76995 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(77096), // Rule ID 22445 //
     /*  77000 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77003 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77010 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77014 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77018 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77022 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77026 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77030 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77034 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77037 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77044 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77048 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77052 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77056 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77060 */   // MIs[3] Operand 1
     /*  77060 */   // No operand predicates
     /*  77060 */   // MIs[0] dst
     /*  77060 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77065 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77067 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77074 */   // (atomic_store (or:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (OR64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mi32),
     /*  77077 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77081 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77084 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77087 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77094 */   GIR_RootConstrainSelectedInstOperands,
     /*  77095 */   // GIR_Coverage, 22445,
     /*  77095 */   GIR_EraseRootFromParent_Done,
     /*  77096 */ // Label 1688: @77096
     /*  77096 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(77197), // Rule ID 22461 //
     /*  77101 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77104 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77111 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77115 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  77119 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77123 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77127 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77131 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77135 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77138 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77145 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77149 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77153 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77157 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77161 */   // MIs[3] Operand 1
     /*  77161 */   // No operand predicates
     /*  77161 */   // MIs[0] dst
     /*  77161 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77166 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77168 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77175 */   // (atomic_store (sub:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (SUB64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32),
     /*  77178 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77182 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77185 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77188 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77195 */   GIR_RootConstrainSelectedInstOperands,
     /*  77196 */   // GIR_Coverage, 22461,
     /*  77196 */   GIR_EraseRootFromParent_Done,
     /*  77197 */ // Label 1689: @77197
     /*  77197 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(77298), // Rule ID 22453 //
     /*  77202 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77205 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77212 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77216 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77220 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77224 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77228 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77232 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77236 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77239 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77246 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77250 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77254 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77258 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77262 */   // MIs[3] Operand 1
     /*  77262 */   // No operand predicates
     /*  77262 */   // MIs[0] dst
     /*  77262 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77267 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77269 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77276 */   // (atomic_store (xor:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (XOR64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mi32),
     /*  77279 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77283 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77286 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77289 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77296 */   GIR_RootConstrainSelectedInstOperands,
     /*  77297 */   // GIR_Coverage, 22453,
     /*  77297 */   GIR_EraseRootFromParent_Done,
     /*  77298 */ // Label 1690: @77298
     /*  77298 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(77402), // Rule ID 834 //
     /*  77303 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77306 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77310 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77314 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  77318 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77322 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77326 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  77330 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77334 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77338 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77341 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77345 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77349 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  77354 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  77358 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77362 */   // MIs[3] Operand 1
     /*  77362 */   // No operand predicates
     /*  77362 */   // MIs[0] src1
     /*  77362 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77367 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77369 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77376 */   // (st (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD64mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  77376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mri8),
     /*  77379 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77383 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  77387 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  77390 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77393 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77400 */   GIR_RootConstrainSelectedInstOperands,
     /*  77401 */   // GIR_Coverage, 834,
     /*  77401 */   GIR_EraseRootFromParent_Done,
     /*  77402 */ // Label 1691: @77402
     /*  77402 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(77506), // Rule ID 858 //
     /*  77407 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77410 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77414 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77418 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  77422 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77426 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77430 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  77434 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  77439 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77443 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77447 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77450 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77454 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77458 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  77462 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77466 */   // MIs[3] Operand 1
     /*  77466 */   // No operand predicates
     /*  77466 */   // MIs[0] src1
     /*  77466 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77471 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77473 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77480 */   // (st (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD64mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  77480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mri8),
     /*  77483 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77487 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  77491 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  77494 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77497 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77504 */   GIR_RootConstrainSelectedInstOperands,
     /*  77505 */   // GIR_Coverage, 858,
     /*  77505 */   GIR_EraseRootFromParent_Done,
     /*  77506 */ // Label 1692: @77506
     /*  77506 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(77600), // Rule ID 735 //
     /*  77511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  77514 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77517 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77521 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77525 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  77529 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77533 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  77537 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77541 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77545 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77548 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77552 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77556 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77560 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77564 */   // MIs[3] Operand 1
     /*  77564 */   // No operand predicates
     /*  77564 */   // MIs[0] src1
     /*  77564 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77569 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77571 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77578 */   // (st (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  77578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mi),
     /*  77581 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77585 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  77588 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77591 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77598 */   GIR_RootConstrainSelectedInstOperands,
     /*  77599 */   // GIR_Coverage, 735,
     /*  77599 */   GIR_EraseRootFromParent_Done,
     /*  77600 */ // Label 1693: @77600
     /*  77600 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(77694), // Rule ID 703 //
     /*  77605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  77608 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77611 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77615 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77619 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  77623 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77627 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  77631 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77635 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77639 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77642 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77646 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77650 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77654 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77658 */   // MIs[3] Operand 1
     /*  77658 */   // No operand predicates
     /*  77658 */   // MIs[0] src1
     /*  77658 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77663 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77665 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77672 */   // (st (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  77672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mi),
     /*  77675 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77679 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  77682 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77685 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77692 */   GIR_RootConstrainSelectedInstOperands,
     /*  77693 */   // GIR_Coverage, 703,
     /*  77693 */   GIR_EraseRootFromParent_Done,
     /*  77694 */ // Label 1694: @77694
     /*  77694 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(77788), // Rule ID 767 //
     /*  77699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  77702 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77705 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77709 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77713 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  77717 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77721 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  77725 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77729 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77733 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77736 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77740 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77744 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77748 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77752 */   // MIs[3] Operand 1
     /*  77752 */   // No operand predicates
     /*  77752 */   // MIs[0] src1
     /*  77752 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77757 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77759 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77766 */   // (st (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  77766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mi),
     /*  77769 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77773 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  77776 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77779 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77786 */   GIR_RootConstrainSelectedInstOperands,
     /*  77787 */   // GIR_Coverage, 767,
     /*  77787 */   GIR_EraseRootFromParent_Done,
     /*  77788 */ // Label 1695: @77788
     /*  77788 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(77882), // Rule ID 799 //
     /*  77793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  77796 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77799 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77803 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77807 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  77811 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77815 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  77819 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77823 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77827 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77830 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77834 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77838 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77842 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77846 */   // MIs[3] Operand 1
     /*  77846 */   // No operand predicates
     /*  77846 */   // MIs[0] src1
     /*  77846 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77851 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77853 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77860 */   // (st (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  77860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mi),
     /*  77863 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77867 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  77870 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77873 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77880 */   GIR_RootConstrainSelectedInstOperands,
     /*  77881 */   // GIR_Coverage, 799,
     /*  77881 */   GIR_EraseRootFromParent_Done,
     /*  77882 */ // Label 1696: @77882
     /*  77882 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(77976), // Rule ID 671 //
     /*  77887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  77890 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77893 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77897 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77901 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  77905 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77909 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  77913 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77917 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77921 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77924 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77928 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77932 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77936 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77940 */   // MIs[3] Operand 1
     /*  77940 */   // No operand predicates
     /*  77940 */   // MIs[0] src1
     /*  77940 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77945 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77947 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77954 */   // (st (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  77954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mi),
     /*  77957 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77961 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  77964 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77967 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77974 */   GIR_RootConstrainSelectedInstOperands,
     /*  77975 */   // GIR_Coverage, 671,
     /*  77975 */   GIR_EraseRootFromParent_Done,
     /*  77976 */ // Label 1697: @77976
     /*  77976 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(78070), // Rule ID 22433 //
     /*  77981 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77984 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77991 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77995 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  77999 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78003 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78007 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78011 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78015 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78018 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78025 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78029 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78034 */   // MIs[0] dst
     /*  78034 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78039 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78041 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78048 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  78051 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78055 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78059 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78062 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78068 */   GIR_RootConstrainSelectedInstOperands,
     /*  78069 */   // GIR_Coverage, 22433,
     /*  78069 */   GIR_EraseRootFromParent_Done,
     /*  78070 */ // Label 1698: @78070
     /*  78070 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(78164), // Rule ID 26002 //
     /*  78075 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78078 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78085 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78089 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  78093 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78097 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78101 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78106 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78110 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78114 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78117 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78124 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78128 */   // MIs[0] dst
     /*  78128 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78133 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78135 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78142 */   // (atomic_store (add:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  78145 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78149 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  78153 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78156 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78162 */   GIR_RootConstrainSelectedInstOperands,
     /*  78163 */   // GIR_Coverage, 26002,
     /*  78163 */   GIR_EraseRootFromParent_Done,
     /*  78164 */ // Label 1699: @78164
     /*  78164 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(78258), // Rule ID 22441 //
     /*  78169 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78172 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78179 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78183 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78187 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78191 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78195 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78199 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78203 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78206 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78213 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78217 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78222 */   // MIs[0] dst
     /*  78222 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78227 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78229 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78236 */   // (atomic_store (and:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  78239 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78243 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78247 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78250 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78256 */   GIR_RootConstrainSelectedInstOperands,
     /*  78257 */   // GIR_Coverage, 22441,
     /*  78257 */   GIR_EraseRootFromParent_Done,
     /*  78258 */ // Label 1700: @78258
     /*  78258 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(78352), // Rule ID 26006 //
     /*  78263 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78266 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78273 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78277 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78281 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78285 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78289 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78294 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78298 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78302 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78305 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78312 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78316 */   // MIs[0] dst
     /*  78316 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78321 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78323 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78330 */   // (atomic_store (and:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  78333 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78337 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  78341 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78344 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78350 */   GIR_RootConstrainSelectedInstOperands,
     /*  78351 */   // GIR_Coverage, 26006,
     /*  78351 */   GIR_EraseRootFromParent_Done,
     /*  78352 */ // Label 1701: @78352
     /*  78352 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(78446), // Rule ID 22449 //
     /*  78357 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78360 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78367 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78371 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78375 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78379 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78383 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78387 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78391 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78394 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78401 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78405 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78410 */   // MIs[0] dst
     /*  78410 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78415 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78417 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78424 */   // (atomic_store (or:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  78427 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78431 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78435 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78438 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78444 */   GIR_RootConstrainSelectedInstOperands,
     /*  78445 */   // GIR_Coverage, 22449,
     /*  78445 */   GIR_EraseRootFromParent_Done,
     /*  78446 */ // Label 1702: @78446
     /*  78446 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(78540), // Rule ID 26010 //
     /*  78451 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78454 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78461 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78465 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78469 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78473 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78477 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78482 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78486 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78490 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78493 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78500 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78504 */   // MIs[0] dst
     /*  78504 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78509 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78511 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78518 */   // (atomic_store (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  78521 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78525 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  78529 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78532 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78538 */   GIR_RootConstrainSelectedInstOperands,
     /*  78539 */   // GIR_Coverage, 26010,
     /*  78539 */   GIR_EraseRootFromParent_Done,
     /*  78540 */ // Label 1703: @78540
     /*  78540 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(78634), // Rule ID 22465 //
     /*  78545 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78548 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78555 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78559 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  78563 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78567 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78571 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78575 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78579 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78582 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78589 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78593 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78598 */   // MIs[0] dst
     /*  78598 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78603 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78605 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78612 */   // (atomic_store (sub:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (SUB64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mr),
     /*  78615 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78619 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78623 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78626 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78632 */   GIR_RootConstrainSelectedInstOperands,
     /*  78633 */   // GIR_Coverage, 22465,
     /*  78633 */   GIR_EraseRootFromParent_Done,
     /*  78634 */ // Label 1704: @78634
     /*  78634 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(78728), // Rule ID 22457 //
     /*  78639 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78642 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78649 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78653 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78657 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78661 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78665 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78669 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78673 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78676 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78683 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78687 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78692 */   // MIs[0] dst
     /*  78692 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78697 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78699 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78706 */   // (atomic_store (xor:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  78709 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78713 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78717 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78720 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78726 */   GIR_RootConstrainSelectedInstOperands,
     /*  78727 */   // GIR_Coverage, 22457,
     /*  78727 */   GIR_EraseRootFromParent_Done,
     /*  78728 */ // Label 1705: @78728
     /*  78728 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(78822), // Rule ID 26014 //
     /*  78733 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78736 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78743 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78747 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78751 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78755 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78759 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78764 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78768 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78772 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78775 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78782 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78786 */   // MIs[0] dst
     /*  78786 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78791 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78793 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78800 */   // (atomic_store (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  78803 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78807 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  78811 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78814 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78820 */   GIR_RootConstrainSelectedInstOperands,
     /*  78821 */   // GIR_Coverage, 26014,
     /*  78821 */   GIR_EraseRootFromParent_Done,
     /*  78822 */ // Label 1706: @78822
     /*  78822 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(78933), // Rule ID 837 //
     /*  78827 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78830 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78834 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78838 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  78842 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78846 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78850 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  78854 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78858 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78862 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78865 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78869 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78873 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78878 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  78883 */   // MIs[0] src1
     /*  78883 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78888 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78890 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78897 */   // (st (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD64mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  78897 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78901 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78907 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  78911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mrCL),
     /*  78914 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78918 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  78922 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78925 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78931 */   GIR_RootConstrainSelectedInstOperands,
     /*  78932 */   // GIR_Coverage, 837,
     /*  78932 */   GIR_EraseRootFromParent_Done,
     /*  78933 */ // Label 1707: @78933
     /*  78933 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(79044), // Rule ID 861 //
     /*  78938 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78941 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78945 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78949 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  78953 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78957 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78961 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  78965 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78970 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78974 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78978 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78981 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78985 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78989 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  78994 */   // MIs[0] src1
     /*  78994 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78999 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79001 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79008 */   // (st (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD64mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79008 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79012 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79018 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  79022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mrCL),
     /*  79025 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79029 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  79033 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79036 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79042 */   GIR_RootConstrainSelectedInstOperands,
     /*  79043 */   // GIR_Coverage, 861,
     /*  79043 */   GIR_EraseRootFromParent_Done,
     /*  79044 */ // Label 1708: @79044
     /*  79044 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(79132), // Rule ID 412 //
     /*  79049 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79052 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79056 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79060 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  79064 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79068 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79072 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79076 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79080 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79083 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79087 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79091 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79096 */   // MIs[0] src1
     /*  79096 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79101 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79103 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79110 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  79113 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79117 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  79121 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79124 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79130 */   GIR_RootConstrainSelectedInstOperands,
     /*  79131 */   // GIR_Coverage, 412,
     /*  79131 */   GIR_EraseRootFromParent_Done,
     /*  79132 */ // Label 1709: @79132
     /*  79132 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(79220), // Rule ID 23222 //
     /*  79137 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79140 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79144 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79148 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  79152 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79156 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79160 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79165 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79169 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79173 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79176 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79180 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79184 */   // MIs[0] src1
     /*  79184 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79189 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79191 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79198 */   // (st (add:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  79201 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79205 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  79209 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79212 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79218 */   GIR_RootConstrainSelectedInstOperands,
     /*  79219 */   // GIR_Coverage, 23222,
     /*  79219 */   GIR_EraseRootFromParent_Done,
     /*  79220 */ // Label 1710: @79220
     /*  79220 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(79308), // Rule ID 304 //
     /*  79225 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79228 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79232 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79236 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79240 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79244 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79248 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79252 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79256 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79259 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79263 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79267 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79272 */   // MIs[0] src1
     /*  79272 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79277 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79279 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79286 */   // (st (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  79289 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79293 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  79297 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79300 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79306 */   GIR_RootConstrainSelectedInstOperands,
     /*  79307 */   // GIR_Coverage, 304,
     /*  79307 */   GIR_EraseRootFromParent_Done,
     /*  79308 */ // Label 1711: @79308
     /*  79308 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(79396), // Rule ID 23186 //
     /*  79313 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79316 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79320 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79324 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79328 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79332 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79336 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79341 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79345 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79349 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79352 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79356 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79360 */   // MIs[0] src1
     /*  79360 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79365 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79367 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79374 */   // (st (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  79377 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79381 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  79385 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79388 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79394 */   GIR_RootConstrainSelectedInstOperands,
     /*  79395 */   // GIR_Coverage, 23186,
     /*  79395 */   GIR_EraseRootFromParent_Done,
     /*  79396 */ // Label 1712: @79396
     /*  79396 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(79497), // Rule ID 751 //
     /*  79401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  79404 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79407 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79411 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79415 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  79419 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79423 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  79427 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79431 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79435 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79438 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79442 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79446 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  79451 */   // MIs[0] src1
     /*  79451 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79456 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79458 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79465 */   // (st (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  79465 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79469 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79475 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  79479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mCL),
     /*  79482 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79486 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79489 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79495 */   GIR_RootConstrainSelectedInstOperands,
     /*  79496 */   // GIR_Coverage, 751,
     /*  79496 */   GIR_EraseRootFromParent_Done,
     /*  79497 */ // Label 1713: @79497
     /*  79497 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(79598), // Rule ID 719 //
     /*  79502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  79505 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79508 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79512 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79516 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  79520 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79524 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  79528 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79532 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79536 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79539 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79543 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79547 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  79552 */   // MIs[0] src1
     /*  79552 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79557 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79559 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79566 */   // (st (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  79566 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79570 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79576 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  79580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mCL),
     /*  79583 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79587 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79590 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79596 */   GIR_RootConstrainSelectedInstOperands,
     /*  79597 */   // GIR_Coverage, 719,
     /*  79597 */   GIR_EraseRootFromParent_Done,
     /*  79598 */ // Label 1714: @79598
     /*  79598 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(79686), // Rule ID 340 //
     /*  79603 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79606 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79610 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79614 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79618 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79622 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79626 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79630 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79634 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79637 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79641 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79645 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79650 */   // MIs[0] src1
     /*  79650 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79655 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79657 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79664 */   // (st (or:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  79667 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79671 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  79675 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79678 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79684 */   GIR_RootConstrainSelectedInstOperands,
     /*  79685 */   // GIR_Coverage, 340,
     /*  79685 */   GIR_EraseRootFromParent_Done,
     /*  79686 */ // Label 1715: @79686
     /*  79686 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(79774), // Rule ID 23198 //
     /*  79691 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79694 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79698 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79702 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79706 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79710 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79714 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79719 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79723 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79727 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79730 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79734 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79738 */   // MIs[0] src1
     /*  79738 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79743 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79745 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79752 */   // (st (or:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  79755 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79759 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  79763 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79766 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79772 */   GIR_RootConstrainSelectedInstOperands,
     /*  79773 */   // GIR_Coverage, 23198,
     /*  79773 */   GIR_EraseRootFromParent_Done,
     /*  79774 */ // Label 1716: @79774
     /*  79774 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(79875), // Rule ID 783 //
     /*  79779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  79782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79785 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79789 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79793 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  79797 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79801 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  79805 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79809 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79813 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79816 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79820 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79824 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  79829 */   // MIs[0] src1
     /*  79829 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79834 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79836 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79843 */   // (st (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  79843 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79847 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79853 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  79857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mCL),
     /*  79860 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79864 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79867 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79873 */   GIR_RootConstrainSelectedInstOperands,
     /*  79874 */   // GIR_Coverage, 783,
     /*  79874 */   GIR_EraseRootFromParent_Done,
     /*  79875 */ // Label 1717: @79875
     /*  79875 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(79976), // Rule ID 815 //
     /*  79880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  79883 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79886 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79890 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  79898 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79902 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  79906 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79910 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79914 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79917 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79921 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79925 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  79930 */   // MIs[0] src1
     /*  79930 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79935 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79937 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79944 */   // (st (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  79944 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79948 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79954 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  79958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mCL),
     /*  79961 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79965 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79968 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79974 */   GIR_RootConstrainSelectedInstOperands,
     /*  79975 */   // GIR_Coverage, 815,
     /*  79975 */   GIR_EraseRootFromParent_Done,
     /*  79976 */ // Label 1718: @79976
     /*  79976 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(80077), // Rule ID 687 //
     /*  79981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  79984 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79987 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79991 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79995 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  79999 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80003 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  80007 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80011 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80015 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80018 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80022 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80026 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80031 */   // MIs[0] src1
     /*  80031 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80036 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80038 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80045 */   // (st (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80045 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80049 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80055 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mCL),
     /*  80062 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80066 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80069 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80075 */   GIR_RootConstrainSelectedInstOperands,
     /*  80076 */   // GIR_Coverage, 687,
     /*  80076 */   GIR_EraseRootFromParent_Done,
     /*  80077 */ // Label 1719: @80077
     /*  80077 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(80165), // Rule ID 448 //
     /*  80082 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80085 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80089 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80093 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  80097 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80101 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80105 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80109 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80113 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80116 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80120 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80124 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80129 */   // MIs[0] src1
     /*  80129 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80134 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80136 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80143 */   // (st (sub:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mr),
     /*  80146 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80150 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  80154 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80157 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80163 */   GIR_RootConstrainSelectedInstOperands,
     /*  80164 */   // GIR_Coverage, 448,
     /*  80164 */   GIR_EraseRootFromParent_Done,
     /*  80165 */ // Label 1720: @80165
     /*  80165 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(80253), // Rule ID 376 //
     /*  80170 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80173 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80177 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80181 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80185 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80189 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80193 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80197 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80201 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80204 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80208 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80212 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80217 */   // MIs[0] src1
     /*  80217 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80222 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80224 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80231 */   // (st (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  80234 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80238 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  80242 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80245 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80251 */   GIR_RootConstrainSelectedInstOperands,
     /*  80252 */   // GIR_Coverage, 376,
     /*  80252 */   GIR_EraseRootFromParent_Done,
     /*  80253 */ // Label 1721: @80253
     /*  80253 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(80341), // Rule ID 23210 //
     /*  80258 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80261 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80265 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80269 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80273 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80277 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80281 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80286 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80290 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80294 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80297 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80301 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80305 */   // MIs[0] src1
     /*  80305 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80310 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80312 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80319 */   // (st (xor:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  80322 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80326 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  80330 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80333 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80339 */   GIR_RootConstrainSelectedInstOperands,
     /*  80340 */   // GIR_Coverage, 23210,
     /*  80340 */   GIR_EraseRootFromParent_Done,
     /*  80341 */ // Label 1722: @80341
     /*  80341 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(80398), // Rule ID 22509 //
     /*  80346 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  80349 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  80356 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80360 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80364 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  80368 */   // MIs[1] Operand 1
     /*  80368 */   // No operand predicates
     /*  80368 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80372 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80374 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80381 */   // (atomic_store (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (MOV64mi32 addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  80381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64mi32),
     /*  80384 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80388 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  80391 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  80396 */   GIR_RootConstrainSelectedInstOperands,
     /*  80397 */   // GIR_Coverage, 22509,
     /*  80397 */   GIR_EraseRootFromParent_Done,
     /*  80398 */ // Label 1723: @80398
     /*  80398 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(80464), // Rule ID 22521 //
     /*  80403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  80406 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  80409 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  80416 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80420 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  80424 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80428 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  80433 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80437 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80439 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80446 */   // (atomic_store (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (MOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  80446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDmr),
     /*  80449 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80453 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  80457 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  80462 */   GIR_RootConstrainSelectedInstOperands,
     /*  80463 */   // GIR_Coverage, 22521,
     /*  80463 */   GIR_EraseRootFromParent_Done,
     /*  80464 */ // Label 1724: @80464
     /*  80464 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(80530), // Rule ID 22522 //
     /*  80469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  80472 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  80475 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  80482 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80486 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  80490 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80494 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  80499 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80503 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80505 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80512 */   // (atomic_store (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (VMOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  80512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDmr),
     /*  80515 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80519 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  80523 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  80528 */   GIR_RootConstrainSelectedInstOperands,
     /*  80529 */   // GIR_Coverage, 22522,
     /*  80529 */   GIR_EraseRootFromParent_Done,
     /*  80530 */ // Label 1725: @80530
     /*  80530 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(80596), // Rule ID 22523 //
     /*  80535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  80538 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  80541 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  80548 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80552 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  80556 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80560 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  80565 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80569 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80571 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80578 */   // (atomic_store (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (VMOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  80578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDmr),
     /*  80581 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80585 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  80589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  80594 */   GIR_RootConstrainSelectedInstOperands,
     /*  80595 */   // GIR_Coverage, 22523,
     /*  80595 */   GIR_EraseRootFromParent_Done,
     /*  80596 */ // Label 1726: @80596
     /*  80596 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(80659), // Rule ID 54 //
     /*  80601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /*  80604 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80607 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80611 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80615 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  80619 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80623 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80628 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80632 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80634 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80641 */   // (st (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE64mr addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src1)
     /*  80641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64mr),
     /*  80644 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80648 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  80652 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  80657 */   GIR_RootConstrainSelectedInstOperands,
     /*  80658 */   // GIR_Coverage, 54,
     /*  80658 */   GIR_EraseRootFromParent_Done,
     /*  80659 */ // Label 1727: @80659
     /*  80659 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(80722), // Rule ID 60 //
     /*  80664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /*  80667 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80670 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80674 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80678 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  80682 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80686 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80691 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80695 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80697 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80704 */   // (st (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE64mr_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src1)
     /*  80704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64mr_EVEX),
     /*  80707 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80711 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  80715 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  80720 */   GIR_RootConstrainSelectedInstOperands,
     /*  80721 */   // GIR_Coverage, 60,
     /*  80721 */   GIR_EraseRootFromParent_Done,
     /*  80722 */ // Label 1728: @80722
     /*  80722 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(80767), // Rule ID 22513 //
     /*  80727 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  80730 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  80737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80741 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80745 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80752 */   // (atomic_store GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (MOV64mr addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  80752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64mr),
     /*  80755 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80759 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  80761 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80765 */   GIR_RootConstrainSelectedInstOperands,
     /*  80766 */   // GIR_Coverage, 22513,
     /*  80766 */   GIR_EraseRootFromParent_Done,
     /*  80767 */ // Label 1729: @80767
     /*  80767 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(80809), // Rule ID 35 //
     /*  80772 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80775 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80783 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80787 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80794 */   // (st GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV64mr addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  80794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64mr),
     /*  80797 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80801 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  80803 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80807 */   GIR_RootConstrainSelectedInstOperands,
     /*  80808 */   // GIR_Coverage, 35,
     /*  80808 */   GIR_EraseRootFromParent_Done,
     /*  80809 */ // Label 1730: @80809
     /*  80809 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(80857), // Rule ID 1096 //
     /*  80814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  80817 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80820 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  80828 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80832 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80839 */   // (st RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST_Fp64m:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP64:{ *:[f64] }:$src)
     /*  80839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp64m),
     /*  80842 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  80846 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  80848 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  80851 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80855 */   GIR_RootConstrainSelectedInstOperands,
     /*  80856 */   // GIR_Coverage, 1096,
     /*  80856 */   GIR_EraseRootFromParent_Done,
     /*  80857 */ // Label 1731: @80857
     /*  80857 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(80902), // Rule ID 1691 //
     /*  80862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  80865 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80868 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  80876 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80880 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80887 */   // (st FR64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  80887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDmr),
     /*  80890 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80894 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  80896 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80900 */   GIR_RootConstrainSelectedInstOperands,
     /*  80901 */   // GIR_Coverage, 1691,
     /*  80901 */   GIR_EraseRootFromParent_Done,
     /*  80902 */ // Label 1732: @80902
     /*  80902 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(80947), // Rule ID 1693 //
     /*  80907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  80910 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80913 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  80921 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80925 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80932 */   // (st FR64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  80932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDmr),
     /*  80935 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80939 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  80941 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80945 */   GIR_RootConstrainSelectedInstOperands,
     /*  80946 */   // GIR_Coverage, 1693,
     /*  80946 */   GIR_EraseRootFromParent_Done,
     /*  80947 */ // Label 1733: @80947
     /*  80947 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(80992), // Rule ID 4615 //
     /*  80952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  80955 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80958 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  80966 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80970 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80977 */   // (st FR64X:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSDZmr addr:{ *:[iPTR] }:$dst, FR64X:{ *:[f64] }:$src)
     /*  80977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDZmr),
     /*  80980 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80984 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  80986 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80990 */   GIR_RootConstrainSelectedInstOperands,
     /*  80991 */   // GIR_Coverage, 4615,
     /*  80991 */   GIR_EraseRootFromParent_Done,
     /*  80992 */ // Label 1734: @80992
     /*  80992 */ GIM_Reject,
     /*  80993 */ // Label 1477: @80993
     /*  80993 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(81041), // Rule ID 1099 //
     /*  80998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  81001 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81004 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  81012 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81016 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81023 */   // (st RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST_FpP80m:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /*  81023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_FpP80m),
     /*  81026 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81030 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81032 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81035 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81039 */   GIR_RootConstrainSelectedInstOperands,
     /*  81040 */   // GIR_Coverage, 1099,
     /*  81040 */   GIR_EraseRootFromParent_Done,
     /*  81041 */ // Label 1735: @81041
     /*  81041 */ GIM_Reject,
     /*  81042 */ // Label 1478: @81042
     /*  81042 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(81295),
     /*  81047 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81050 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81054 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(81096), // Rule ID 23139 //
     /*  81059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoAVX),
     /*  81062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81070 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81081 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  81084 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81088 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81094 */     GIR_RootConstrainSelectedInstOperands,
     /*  81095 */     // GIR_Coverage, 23139,
     /*  81095 */     GIR_EraseRootFromParent_Done,
     /*  81096 */   // Label 1737: @81096
     /*  81096 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(81134), // Rule ID 23140 //
     /*  81101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoAVX),
     /*  81104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81108 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81119 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  81122 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81126 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81132 */     GIR_RootConstrainSelectedInstOperands,
     /*  81133 */     // GIR_Coverage, 23140,
     /*  81133 */     GIR_EraseRootFromParent_Done,
     /*  81134 */   // Label 1738: @81134
     /*  81134 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(81176), // Rule ID 23143 //
     /*  81139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81150 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81161 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSmr),
     /*  81164 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81168 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81174 */     GIR_RootConstrainSelectedInstOperands,
     /*  81175 */     // GIR_Coverage, 23143,
     /*  81175 */     GIR_EraseRootFromParent_Done,
     /*  81176 */   // Label 1739: @81176
     /*  81176 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(81214), // Rule ID 23144 //
     /*  81181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81199 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSmr),
     /*  81202 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81206 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81212 */     GIR_RootConstrainSelectedInstOperands,
     /*  81213 */     // GIR_Coverage, 23144,
     /*  81213 */     GIR_EraseRootFromParent_Done,
     /*  81214 */   // Label 1740: @81214
     /*  81214 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(81256), // Rule ID 23147 //
     /*  81219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  81222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  81226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81241 */     // (st VR128X:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[f128] }:$src)
     /*  81241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128mr),
     /*  81244 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81248 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81254 */     GIR_RootConstrainSelectedInstOperands,
     /*  81255 */     // GIR_Coverage, 23147,
     /*  81255 */     GIR_EraseRootFromParent_Done,
     /*  81256 */   // Label 1741: @81256
     /*  81256 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(81294), // Rule ID 23148 //
     /*  81261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  81264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  81268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81279 */     // (st VR128X:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[f128] }:$src)
     /*  81279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128mr),
     /*  81282 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81286 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81292 */     GIR_RootConstrainSelectedInstOperands,
     /*  81293 */     // GIR_Coverage, 23148,
     /*  81293 */     GIR_EraseRootFromParent_Done,
     /*  81294 */   // Label 1742: @81294
     /*  81294 */   GIM_Reject,
     /*  81295 */ // Label 1736: @81295
     /*  81295 */ GIM_Reject,
     /*  81296 */ // Label 1479: @81296
     /*  81296 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(81789),
     /*  81301 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81304 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81308 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(81350), // Rule ID 1715 //
     /*  81313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81324 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81335 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  81335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDmr),
     /*  81338 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81342 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81348 */     GIR_RootConstrainSelectedInstOperands,
     /*  81349 */     // GIR_Coverage, 1715,
     /*  81349 */     GIR_EraseRootFromParent_Done,
     /*  81350 */   // Label 1744: @81350
     /*  81350 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(81388), // Rule ID 1717 //
     /*  81355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81373 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  81373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDmr),
     /*  81376 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81380 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81386 */     GIR_RootConstrainSelectedInstOperands,
     /*  81387 */     // GIR_Coverage, 1717,
     /*  81387 */     GIR_EraseRootFromParent_Done,
     /*  81388 */   // Label 1745: @81388
     /*  81388 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(81430), // Rule ID 1723 //
     /*  81393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  81396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81404 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81415 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  81415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPDmr),
     /*  81418 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81422 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81428 */     GIR_RootConstrainSelectedInstOperands,
     /*  81429 */     // GIR_Coverage, 1723,
     /*  81429 */     GIR_EraseRootFromParent_Done,
     /*  81430 */   // Label 1746: @81430
     /*  81430 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(81468), // Rule ID 1725 //
     /*  81435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  81438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81453 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  81453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPDmr),
     /*  81456 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81460 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81466 */     GIR_RootConstrainSelectedInstOperands,
     /*  81467 */     // GIR_Coverage, 1725,
     /*  81467 */     GIR_EraseRootFromParent_Done,
     /*  81468 */   // Label 1747: @81468
     /*  81468 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(81510), // Rule ID 2519 //
     /*  81473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81484 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81495 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  81495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  81498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81502 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81508 */     GIR_RootConstrainSelectedInstOperands,
     /*  81509 */     // GIR_Coverage, 2519,
     /*  81509 */     GIR_EraseRootFromParent_Done,
     /*  81510 */   // Label 1748: @81510
     /*  81510 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(81548), // Rule ID 2520 //
     /*  81515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81533 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  81533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  81536 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81540 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81546 */     GIR_RootConstrainSelectedInstOperands,
     /*  81547 */     // GIR_Coverage, 2520,
     /*  81547 */     GIR_EraseRootFromParent_Done,
     /*  81548 */   // Label 1749: @81548
     /*  81548 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(81590), // Rule ID 4495 //
     /*  81553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  81556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  81560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81564 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81575 */     // (st VR128X:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2f64] }:$src)
     /*  81575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128mr),
     /*  81578 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81582 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81588 */     GIR_RootConstrainSelectedInstOperands,
     /*  81589 */     // GIR_Coverage, 4495,
     /*  81589 */     GIR_EraseRootFromParent_Done,
     /*  81590 */   // Label 1750: @81590
     /*  81590 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(81628), // Rule ID 4519 //
     /*  81595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  81598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  81602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81613 */     // (st VR128X:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2f64] }:$src)
     /*  81613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ128mr),
     /*  81616 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81620 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81626 */     GIR_RootConstrainSelectedInstOperands,
     /*  81627 */     // GIR_Coverage, 4519,
     /*  81627 */     GIR_EraseRootFromParent_Done,
     /*  81628 */   // Label 1751: @81628
     /*  81628 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(81670), // Rule ID 4549 //
     /*  81633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  81636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  81640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81644 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81655 */     // (st VR128X:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2i64] }:$src)
     /*  81655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  81658 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81662 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81668 */     GIR_RootConstrainSelectedInstOperands,
     /*  81669 */     // GIR_Coverage, 4549,
     /*  81669 */     GIR_EraseRootFromParent_Done,
     /*  81670 */   // Label 1752: @81670
     /*  81670 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(81708), // Rule ID 4591 //
     /*  81675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  81678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  81682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81693 */     // (st VR128X:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2i64] }:$src)
     /*  81693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  81696 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81700 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81706 */     GIR_RootConstrainSelectedInstOperands,
     /*  81707 */     // GIR_Coverage, 4591,
     /*  81707 */     GIR_EraseRootFromParent_Done,
     /*  81708 */   // Label 1753: @81708
     /*  81708 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(81750), // Rule ID 17946 //
     /*  81713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  81716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81724 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81735 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  81735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  81738 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81742 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81748 */     GIR_RootConstrainSelectedInstOperands,
     /*  81749 */     // GIR_Coverage, 17946,
     /*  81749 */     GIR_EraseRootFromParent_Done,
     /*  81750 */   // Label 1754: @81750
     /*  81750 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(81788), // Rule ID 17950 //
     /*  81755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  81758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81773 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  81773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  81776 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81780 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81786 */     GIR_RootConstrainSelectedInstOperands,
     /*  81787 */     // GIR_Coverage, 17950,
     /*  81787 */     GIR_EraseRootFromParent_Done,
     /*  81788 */   // Label 1755: @81788
     /*  81788 */   GIM_Reject,
     /*  81789 */ // Label 1743: @81789
     /*  81789 */ GIM_Reject,
     /*  81790 */ // Label 1480: @81790
     /*  81790 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(82283),
     /*  81795 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81798 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81802 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(81844), // Rule ID 1714 //
     /*  81807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81818 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81829 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  81829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSmr),
     /*  81832 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81836 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81842 */     GIR_RootConstrainSelectedInstOperands,
     /*  81843 */     // GIR_Coverage, 1714,
     /*  81843 */     GIR_EraseRootFromParent_Done,
     /*  81844 */   // Label 1757: @81844
     /*  81844 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(81882), // Rule ID 1716 //
     /*  81849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81867 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  81867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSmr),
     /*  81870 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81874 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81880 */     GIR_RootConstrainSelectedInstOperands,
     /*  81881 */     // GIR_Coverage, 1716,
     /*  81881 */     GIR_EraseRootFromParent_Done,
     /*  81882 */   // Label 1758: @81882
     /*  81882 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(81924), // Rule ID 1722 //
     /*  81887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  81890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81898 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81909 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  81909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  81912 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81916 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81922 */     GIR_RootConstrainSelectedInstOperands,
     /*  81923 */     // GIR_Coverage, 1722,
     /*  81923 */     GIR_EraseRootFromParent_Done,
     /*  81924 */   // Label 1759: @81924
     /*  81924 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(81962), // Rule ID 1724 //
     /*  81929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  81932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81947 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  81947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  81950 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81954 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81960 */     GIR_RootConstrainSelectedInstOperands,
     /*  81961 */     // GIR_Coverage, 1724,
     /*  81961 */     GIR_EraseRootFromParent_Done,
     /*  81962 */   // Label 1760: @81962
     /*  81962 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(82004), // Rule ID 4477 //
     /*  81967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  81970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  81974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81978 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81989 */     // (st VR128X:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4f32] }:$src)
     /*  81989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128mr),
     /*  81992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81996 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82002 */     GIR_RootConstrainSelectedInstOperands,
     /*  82003 */     // GIR_Coverage, 4477,
     /*  82003 */     GIR_EraseRootFromParent_Done,
     /*  82004 */   // Label 1761: @82004
     /*  82004 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(82042), // Rule ID 4507 //
     /*  82009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82027 */     // (st VR128X:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4f32] }:$src)
     /*  82027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128mr),
     /*  82030 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82034 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82040 */     GIR_RootConstrainSelectedInstOperands,
     /*  82041 */     // GIR_Coverage, 4507,
     /*  82041 */     GIR_EraseRootFromParent_Done,
     /*  82042 */   // Label 1762: @82042
     /*  82042 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(82084), // Rule ID 17947 //
     /*  82047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82058 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82069 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  82072 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82076 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82082 */     GIR_RootConstrainSelectedInstOperands,
     /*  82083 */     // GIR_Coverage, 17947,
     /*  82083 */     GIR_EraseRootFromParent_Done,
     /*  82084 */   // Label 1763: @82084
     /*  82084 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(82122), // Rule ID 17951 //
     /*  82089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82107 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  82110 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82114 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82120 */     GIR_RootConstrainSelectedInstOperands,
     /*  82121 */     // GIR_Coverage, 17951,
     /*  82121 */     GIR_EraseRootFromParent_Done,
     /*  82122 */   // Label 1764: @82122
     /*  82122 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(82164), // Rule ID 18326 //
     /*  82127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82138 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82149 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  82152 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82156 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82162 */     GIR_RootConstrainSelectedInstOperands,
     /*  82163 */     // GIR_Coverage, 18326,
     /*  82163 */     GIR_EraseRootFromParent_Done,
     /*  82164 */   // Label 1765: @82164
     /*  82164 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(82202), // Rule ID 18330 //
     /*  82169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82176 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82187 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  82190 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82194 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82200 */     GIR_RootConstrainSelectedInstOperands,
     /*  82201 */     // GIR_Coverage, 18330,
     /*  82201 */     GIR_EraseRootFromParent_Done,
     /*  82202 */   // Label 1766: @82202
     /*  82202 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(82244), // Rule ID 19819 //
     /*  82207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  82210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82218 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82229 */     // (st VR128X:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4i32] }:$src)
     /*  82229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  82232 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82236 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82242 */     GIR_RootConstrainSelectedInstOperands,
     /*  82243 */     // GIR_Coverage, 19819,
     /*  82243 */     GIR_EraseRootFromParent_Done,
     /*  82244 */   // Label 1767: @82244
     /*  82244 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(82282), // Rule ID 19823 //
     /*  82249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  82252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82267 */     // (st VR128X:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4i32] }:$src)
     /*  82267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  82270 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82274 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82280 */     GIR_RootConstrainSelectedInstOperands,
     /*  82281 */     // GIR_Coverage, 19823,
     /*  82281 */     GIR_EraseRootFromParent_Done,
     /*  82282 */   // Label 1768: @82282
     /*  82282 */   GIM_Reject,
     /*  82283 */ // Label 1756: @82283
     /*  82283 */ GIM_Reject,
     /*  82284 */ // Label 1481: @82284
     /*  82284 */ GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(82617),
     /*  82289 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  82292 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82296 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(82338), // Rule ID 1719 //
     /*  82301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  82308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82312 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82323 */     // (st VR256:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4f64] }:$src)
     /*  82323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDYmr),
     /*  82326 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82330 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82336 */     GIR_RootConstrainSelectedInstOperands,
     /*  82337 */     // GIR_Coverage, 1719,
     /*  82337 */     GIR_EraseRootFromParent_Done,
     /*  82338 */   // Label 1770: @82338
     /*  82338 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(82376), // Rule ID 1721 //
     /*  82343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  82350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82361 */     // (st VR256:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4f64] }:$src)
     /*  82361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDYmr),
     /*  82364 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82368 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82374 */     GIR_RootConstrainSelectedInstOperands,
     /*  82375 */     // GIR_Coverage, 1721,
     /*  82375 */     GIR_EraseRootFromParent_Done,
     /*  82376 */   // Label 1771: @82376
     /*  82376 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(82418), // Rule ID 4494 //
     /*  82381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  82388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82403 */     // (st VR256X:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4f64] }:$src)
     /*  82403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256mr),
     /*  82406 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82410 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82416 */     GIR_RootConstrainSelectedInstOperands,
     /*  82417 */     // GIR_Coverage, 4494,
     /*  82417 */     GIR_EraseRootFromParent_Done,
     /*  82418 */   // Label 1772: @82418
     /*  82418 */   GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(82456), // Rule ID 4518 //
     /*  82423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  82430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82441 */     // (st VR256X:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4f64] }:$src)
     /*  82441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ256mr),
     /*  82444 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82448 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82454 */     GIR_RootConstrainSelectedInstOperands,
     /*  82455 */     // GIR_Coverage, 4518,
     /*  82455 */     GIR_EraseRootFromParent_Done,
     /*  82456 */   // Label 1773: @82456
     /*  82456 */   GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(82498), // Rule ID 4548 //
     /*  82461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  82468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82472 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82483 */     // (st VR256X:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4i64] }:$src)
     /*  82483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  82486 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82490 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82496 */     GIR_RootConstrainSelectedInstOperands,
     /*  82497 */     // GIR_Coverage, 4548,
     /*  82497 */     GIR_EraseRootFromParent_Done,
     /*  82498 */   // Label 1774: @82498
     /*  82498 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(82536), // Rule ID 4590 //
     /*  82503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  82510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82521 */     // (st VR256X:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4i64] }:$src)
     /*  82521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  82524 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82528 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82534 */     GIR_RootConstrainSelectedInstOperands,
     /*  82535 */     // GIR_Coverage, 4590,
     /*  82535 */     GIR_EraseRootFromParent_Done,
     /*  82536 */   // Label 1775: @82536
     /*  82536 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(82578), // Rule ID 17922 //
     /*  82541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  82548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82552 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82563 */     // (st VR256:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src)
     /*  82563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  82566 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82570 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82576 */     GIR_RootConstrainSelectedInstOperands,
     /*  82577 */     // GIR_Coverage, 17922,
     /*  82577 */     GIR_EraseRootFromParent_Done,
     /*  82578 */   // Label 1776: @82578
     /*  82578 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(82616), // Rule ID 17926 //
     /*  82583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  82590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82601 */     // (st VR256:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src)
     /*  82601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  82604 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82608 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82614 */     GIR_RootConstrainSelectedInstOperands,
     /*  82615 */     // GIR_Coverage, 17926,
     /*  82615 */     GIR_EraseRootFromParent_Done,
     /*  82616 */   // Label 1777: @82616
     /*  82616 */   GIM_Reject,
     /*  82617 */ // Label 1769: @82617
     /*  82617 */ GIM_Reject,
     /*  82618 */ // Label 1482: @82618
     /*  82618 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(82699),
     /*  82623 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  82626 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  82634 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82638 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(82668), // Rule ID 4395 //
     /*  82643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoEGPR),
     /*  82646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82653 */     // (st VK8:{ *:[v8i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVBmk addr:{ *:[iPTR] }:$dst, VK8:{ *:[v8i1] }:$src)
     /*  82653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBmk),
     /*  82656 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82660 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82666 */     GIR_RootConstrainSelectedInstOperands,
     /*  82667 */     // GIR_Coverage, 4395,
     /*  82667 */     GIR_EraseRootFromParent_Done,
     /*  82668 */   // Label 1779: @82668
     /*  82668 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(82698), // Rule ID 4397 //
     /*  82673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEGPR_In64BitMode),
     /*  82676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82683 */     // (st VK8:{ *:[v8i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVBmk_EVEX addr:{ *:[iPTR] }:$dst, VK8:{ *:[v8i1] }:$src)
     /*  82683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBmk_EVEX),
     /*  82686 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82690 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82696 */     GIR_RootConstrainSelectedInstOperands,
     /*  82697 */     // GIR_Coverage, 4397,
     /*  82697 */     GIR_EraseRootFromParent_Done,
     /*  82698 */   // Label 1780: @82698
     /*  82698 */   GIM_Reject,
     /*  82699 */ // Label 1778: @82699
     /*  82699 */ GIM_Reject,
     /*  82700 */ // Label 1483: @82700
     /*  82700 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(83273),
     /*  82705 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  82708 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82712 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(82754), // Rule ID 17932 //
     /*  82717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82728 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82739 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  82739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSmr),
     /*  82742 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82746 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82752 */     GIR_RootConstrainSelectedInstOperands,
     /*  82753 */     // GIR_Coverage, 17932,
     /*  82753 */     GIR_EraseRootFromParent_Done,
     /*  82754 */   // Label 1782: @82754
     /*  82754 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(82792), // Rule ID 17933 //
     /*  82759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82777 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  82777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSmr),
     /*  82780 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82784 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82790 */     GIR_RootConstrainSelectedInstOperands,
     /*  82791 */     // GIR_Coverage, 17933,
     /*  82791 */     GIR_EraseRootFromParent_Done,
     /*  82792 */   // Label 1783: @82792
     /*  82792 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(82834), // Rule ID 17948 //
     /*  82797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82808 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82819 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  82819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  82822 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82826 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82832 */     GIR_RootConstrainSelectedInstOperands,
     /*  82833 */     // GIR_Coverage, 17948,
     /*  82833 */     GIR_EraseRootFromParent_Done,
     /*  82834 */   // Label 1784: @82834
     /*  82834 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(82872), // Rule ID 17952 //
     /*  82839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82857 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  82857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  82860 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82864 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82870 */     GIR_RootConstrainSelectedInstOperands,
     /*  82871 */     // GIR_Coverage, 17952,
     /*  82871 */     GIR_EraseRootFromParent_Done,
     /*  82872 */   // Label 1785: @82872
     /*  82872 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(82914), // Rule ID 17956 //
     /*  82877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  82880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82899 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  82899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  82902 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82906 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82912 */     GIR_RootConstrainSelectedInstOperands,
     /*  82913 */     // GIR_Coverage, 17956,
     /*  82913 */     GIR_EraseRootFromParent_Done,
     /*  82914 */   // Label 1786: @82914
     /*  82914 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(82952), // Rule ID 17957 //
     /*  82919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  82922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82937 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  82937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  82940 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82944 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82950 */     GIR_RootConstrainSelectedInstOperands,
     /*  82951 */     // GIR_Coverage, 17957,
     /*  82951 */     GIR_EraseRootFromParent_Done,
     /*  82952 */   // Label 1787: @82952
     /*  82952 */   GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(82994), // Rule ID 18327 //
     /*  82957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82968 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82979 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  82979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  82982 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82986 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82992 */     GIR_RootConstrainSelectedInstOperands,
     /*  82993 */     // GIR_Coverage, 18327,
     /*  82993 */     GIR_EraseRootFromParent_Done,
     /*  82994 */   // Label 1788: @82994
     /*  82994 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(83036), // Rule ID 18328 //
     /*  82999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83010 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83021 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  83024 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83028 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83034 */     GIR_RootConstrainSelectedInstOperands,
     /*  83035 */     // GIR_Coverage, 18328,
     /*  83035 */     GIR_EraseRootFromParent_Done,
     /*  83036 */   // Label 1789: @83036
     /*  83036 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(83074), // Rule ID 18331 //
     /*  83041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83059 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  83062 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83066 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83072 */     GIR_RootConstrainSelectedInstOperands,
     /*  83073 */     // GIR_Coverage, 18331,
     /*  83073 */     GIR_EraseRootFromParent_Done,
     /*  83074 */   // Label 1790: @83074
     /*  83074 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(83112), // Rule ID 18332 //
     /*  83079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83097 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  83100 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83104 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83110 */     GIR_RootConstrainSelectedInstOperands,
     /*  83111 */     // GIR_Coverage, 18332,
     /*  83111 */     GIR_EraseRootFromParent_Done,
     /*  83112 */   // Label 1791: @83112
     /*  83112 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(83154), // Rule ID 19820 //
     /*  83117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83128 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83139 */     // (st VR128X:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8i16] }:$src)
     /*  83139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  83142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83146 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83152 */     GIR_RootConstrainSelectedInstOperands,
     /*  83153 */     // GIR_Coverage, 19820,
     /*  83153 */     GIR_EraseRootFromParent_Done,
     /*  83154 */   // Label 1792: @83154
     /*  83154 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(83196), // Rule ID 19821 //
     /*  83159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83170 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83181 */     // (st VR128X:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8f16] }:$src)
     /*  83181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128mr),
     /*  83184 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83188 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83194 */     GIR_RootConstrainSelectedInstOperands,
     /*  83195 */     // GIR_Coverage, 19821,
     /*  83195 */     GIR_EraseRootFromParent_Done,
     /*  83196 */   // Label 1793: @83196
     /*  83196 */   GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(83234), // Rule ID 19824 //
     /*  83201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83219 */     // (st VR128X:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8i16] }:$src)
     /*  83219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  83222 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83226 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83232 */     GIR_RootConstrainSelectedInstOperands,
     /*  83233 */     // GIR_Coverage, 19824,
     /*  83233 */     GIR_EraseRootFromParent_Done,
     /*  83234 */   // Label 1794: @83234
     /*  83234 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(83272), // Rule ID 19825 //
     /*  83239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83246 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83257 */     // (st VR128X:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8f16] }:$src)
     /*  83257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128mr),
     /*  83260 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83264 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83270 */     GIR_RootConstrainSelectedInstOperands,
     /*  83271 */     // GIR_Coverage, 19825,
     /*  83271 */     GIR_EraseRootFromParent_Done,
     /*  83272 */   // Label 1795: @83272
     /*  83272 */   GIM_Reject,
     /*  83273 */ // Label 1781: @83273
     /*  83273 */ GIM_Reject,
     /*  83274 */ // Label 1484: @83274
     /*  83274 */ GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(83607),
     /*  83279 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83282 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83286 */   GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(83328), // Rule ID 1718 //
     /*  83291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83302 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83313 */     // (st VR256:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8f32] }:$src)
     /*  83313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  83316 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83320 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83326 */     GIR_RootConstrainSelectedInstOperands,
     /*  83327 */     // GIR_Coverage, 1718,
     /*  83327 */     GIR_EraseRootFromParent_Done,
     /*  83328 */   // Label 1797: @83328
     /*  83328 */   GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(83366), // Rule ID 1720 //
     /*  83333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83351 */     // (st VR256:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8f32] }:$src)
     /*  83351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  83354 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83358 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83364 */     GIR_RootConstrainSelectedInstOperands,
     /*  83365 */     // GIR_Coverage, 1720,
     /*  83365 */     GIR_EraseRootFromParent_Done,
     /*  83366 */   // Label 1798: @83366
     /*  83366 */   GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(83408), // Rule ID 4476 //
     /*  83371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  83374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83378 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83382 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83393 */     // (st VR256X:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8f32] }:$src)
     /*  83393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256mr),
     /*  83396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83400 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83406 */     GIR_RootConstrainSelectedInstOperands,
     /*  83407 */     // GIR_Coverage, 4476,
     /*  83407 */     GIR_EraseRootFromParent_Done,
     /*  83408 */   // Label 1799: @83408
     /*  83408 */   GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(83446), // Rule ID 4506 //
     /*  83413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  83416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83420 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83431 */     // (st VR256X:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8f32] }:$src)
     /*  83431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256mr),
     /*  83434 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83438 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83444 */     GIR_RootConstrainSelectedInstOperands,
     /*  83445 */     // GIR_Coverage, 4506,
     /*  83445 */     GIR_EraseRootFromParent_Done,
     /*  83446 */   // Label 1800: @83446
     /*  83446 */   GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(83488), // Rule ID 17923 //
     /*  83451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83462 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83473 */     // (st VR256:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src)
     /*  83473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  83476 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83480 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83486 */     GIR_RootConstrainSelectedInstOperands,
     /*  83487 */     // GIR_Coverage, 17923,
     /*  83487 */     GIR_EraseRootFromParent_Done,
     /*  83488 */   // Label 1801: @83488
     /*  83488 */   GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(83526), // Rule ID 17927 //
     /*  83493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83511 */     // (st VR256:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src)
     /*  83511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  83514 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83518 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83524 */     GIR_RootConstrainSelectedInstOperands,
     /*  83525 */     // GIR_Coverage, 17927,
     /*  83525 */     GIR_EraseRootFromParent_Done,
     /*  83526 */   // Label 1802: @83526
     /*  83526 */   GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(83568), // Rule ID 19835 //
     /*  83531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83542 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83553 */     // (st VR256X:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8i32] }:$src)
     /*  83553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  83556 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83560 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83566 */     GIR_RootConstrainSelectedInstOperands,
     /*  83567 */     // GIR_Coverage, 19835,
     /*  83567 */     GIR_EraseRootFromParent_Done,
     /*  83568 */   // Label 1803: @83568
     /*  83568 */   GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(83606), // Rule ID 19839 //
     /*  83573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83591 */     // (st VR256X:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8i32] }:$src)
     /*  83591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  83594 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83598 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83604 */     GIR_RootConstrainSelectedInstOperands,
     /*  83605 */     // GIR_Coverage, 19839,
     /*  83605 */     GIR_EraseRootFromParent_Done,
     /*  83606 */   // Label 1804: @83606
     /*  83606 */   GIM_Reject,
     /*  83607 */ // Label 1796: @83607
     /*  83607 */ GIM_Reject,
     /*  83608 */ // Label 1485: @83608
     /*  83608 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(83781),
     /*  83613 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83616 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83620 */   GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(83662), // Rule ID 4493 //
     /*  83625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  83628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  83632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83636 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83647 */     // (st VR512:{ *:[v8f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8f64] }:$src)
     /*  83647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZmr),
     /*  83650 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83654 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83660 */     GIR_RootConstrainSelectedInstOperands,
     /*  83661 */     // GIR_Coverage, 4493,
     /*  83661 */     GIR_EraseRootFromParent_Done,
     /*  83662 */   // Label 1806: @83662
     /*  83662 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(83700), // Rule ID 4517 //
     /*  83667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  83670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  83674 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83685 */     // (st VR512:{ *:[v8f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8f64] }:$src)
     /*  83685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZmr),
     /*  83688 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83692 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83698 */     GIR_RootConstrainSelectedInstOperands,
     /*  83699 */     // GIR_Coverage, 4517,
     /*  83699 */     GIR_EraseRootFromParent_Done,
     /*  83700 */   // Label 1807: @83700
     /*  83700 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(83742), // Rule ID 4547 //
     /*  83705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  83708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  83712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83716 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83727 */     // (st VR512:{ *:[v8i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8i64] }:$src)
     /*  83727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  83730 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83734 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83740 */     GIR_RootConstrainSelectedInstOperands,
     /*  83741 */     // GIR_Coverage, 4547,
     /*  83741 */     GIR_EraseRootFromParent_Done,
     /*  83742 */   // Label 1808: @83742
     /*  83742 */   GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(83780), // Rule ID 4589 //
     /*  83747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  83750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  83754 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83765 */     // (st VR512:{ *:[v8i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8i64] }:$src)
     /*  83765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  83768 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83772 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83778 */     GIR_RootConstrainSelectedInstOperands,
     /*  83779 */     // GIR_Coverage, 4589,
     /*  83779 */     GIR_EraseRootFromParent_Done,
     /*  83780 */   // Label 1809: @83780
     /*  83780 */   GIM_Reject,
     /*  83781 */ // Label 1805: @83781
     /*  83781 */ GIM_Reject,
     /*  83782 */ // Label 1486: @83782
     /*  83782 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(83863),
     /*  83787 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83790 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  83798 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83802 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(83832), // Rule ID 4399 //
     /*  83807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoEGPR),
     /*  83810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83817 */     // (st VK16:{ *:[v16i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVWmk addr:{ *:[iPTR] }:$dst, VK16:{ *:[v16i1] }:$src)
     /*  83817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWmk),
     /*  83820 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83824 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83830 */     GIR_RootConstrainSelectedInstOperands,
     /*  83831 */     // GIR_Coverage, 4399,
     /*  83831 */     GIR_EraseRootFromParent_Done,
     /*  83832 */   // Label 1811: @83832
     /*  83832 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(83862), // Rule ID 4401 //
     /*  83837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEGPR_In64BitMode),
     /*  83840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83847 */     // (st VK16:{ *:[v16i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVWmk_EVEX addr:{ *:[iPTR] }:$dst, VK16:{ *:[v16i1] }:$src)
     /*  83847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWmk_EVEX),
     /*  83850 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83854 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83860 */     GIR_RootConstrainSelectedInstOperands,
     /*  83861 */     // GIR_Coverage, 4401,
     /*  83861 */     GIR_EraseRootFromParent_Done,
     /*  83862 */   // Label 1812: @83862
     /*  83862 */   GIM_Reject,
     /*  83863 */ // Label 1810: @83863
     /*  83863 */ GIM_Reject,
     /*  83864 */ // Label 1487: @83864
     /*  83864 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(84117),
     /*  83869 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83872 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83876 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(83918), // Rule ID 17949 //
     /*  83881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  83884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83892 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83903 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  83903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  83906 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83910 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83916 */     GIR_RootConstrainSelectedInstOperands,
     /*  83917 */     // GIR_Coverage, 17949,
     /*  83917 */     GIR_EraseRootFromParent_Done,
     /*  83918 */   // Label 1814: @83918
     /*  83918 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(83956), // Rule ID 17953 //
     /*  83923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  83926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83941 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  83941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  83944 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83948 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83954 */     GIR_RootConstrainSelectedInstOperands,
     /*  83955 */     // GIR_Coverage, 17953,
     /*  83955 */     GIR_EraseRootFromParent_Done,
     /*  83956 */   // Label 1815: @83956
     /*  83956 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(83998), // Rule ID 18329 //
     /*  83961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83972 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83983 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  83983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  83986 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83990 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83996 */     GIR_RootConstrainSelectedInstOperands,
     /*  83997 */     // GIR_Coverage, 18329,
     /*  83997 */     GIR_EraseRootFromParent_Done,
     /*  83998 */   // Label 1816: @83998
     /*  83998 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(84036), // Rule ID 18333 //
     /*  84003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84021 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  84024 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84028 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84034 */     GIR_RootConstrainSelectedInstOperands,
     /*  84035 */     // GIR_Coverage, 18333,
     /*  84035 */     GIR_EraseRootFromParent_Done,
     /*  84036 */   // Label 1817: @84036
     /*  84036 */   GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(84078), // Rule ID 19822 //
     /*  84041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  84048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84052 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84063 */     // (st VR128X:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v16i8] }:$src)
     /*  84063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  84066 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84070 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84076 */     GIR_RootConstrainSelectedInstOperands,
     /*  84077 */     // GIR_Coverage, 19822,
     /*  84077 */     GIR_EraseRootFromParent_Done,
     /*  84078 */   // Label 1818: @84078
     /*  84078 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(84116), // Rule ID 19826 //
     /*  84083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  84090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84101 */     // (st VR128X:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v16i8] }:$src)
     /*  84101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  84104 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84108 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84114 */     GIR_RootConstrainSelectedInstOperands,
     /*  84115 */     // GIR_Coverage, 19826,
     /*  84115 */     GIR_EraseRootFromParent_Done,
     /*  84116 */   // Label 1819: @84116
     /*  84116 */   GIM_Reject,
     /*  84117 */ // Label 1813: @84117
     /*  84117 */ GIM_Reject,
     /*  84118 */ // Label 1488: @84118
     /*  84118 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(84451),
     /*  84123 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84126 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84130 */   GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(84172), // Rule ID 17924 //
     /*  84135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84146 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84157 */     // (st VR256:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16i16] }:$src)
     /*  84157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  84160 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84164 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84170 */     GIR_RootConstrainSelectedInstOperands,
     /*  84171 */     // GIR_Coverage, 17924,
     /*  84171 */     GIR_EraseRootFromParent_Done,
     /*  84172 */   // Label 1821: @84172
     /*  84172 */   GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(84210), // Rule ID 17928 //
     /*  84177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84195 */     // (st VR256:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16i16] }:$src)
     /*  84195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  84198 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84202 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84208 */     GIR_RootConstrainSelectedInstOperands,
     /*  84209 */     // GIR_Coverage, 17928,
     /*  84209 */     GIR_EraseRootFromParent_Done,
     /*  84210 */   // Label 1822: @84210
     /*  84210 */   GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(84252), // Rule ID 17936 //
     /*  84215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84226 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84237 */     // (st VR256:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16f16] }:$src)
     /*  84237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  84240 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84244 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84250 */     GIR_RootConstrainSelectedInstOperands,
     /*  84251 */     // GIR_Coverage, 17936,
     /*  84251 */     GIR_EraseRootFromParent_Done,
     /*  84252 */   // Label 1823: @84252
     /*  84252 */   GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(84290), // Rule ID 17937 //
     /*  84257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84275 */     // (st VR256:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16f16] }:$src)
     /*  84275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  84278 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84282 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84288 */     GIR_RootConstrainSelectedInstOperands,
     /*  84289 */     // GIR_Coverage, 17937,
     /*  84289 */     GIR_EraseRootFromParent_Done,
     /*  84290 */   // Label 1824: @84290
     /*  84290 */   GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(84332), // Rule ID 19836 //
     /*  84295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84302 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84306 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84317 */     // (st VR256X:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16i16] }:$src)
     /*  84317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  84320 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84324 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84330 */     GIR_RootConstrainSelectedInstOperands,
     /*  84331 */     // GIR_Coverage, 19836,
     /*  84331 */     GIR_EraseRootFromParent_Done,
     /*  84332 */   // Label 1825: @84332
     /*  84332 */   GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(84374), // Rule ID 19837 //
     /*  84337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84348 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84359 */     // (st VR256X:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16f16] }:$src)
     /*  84359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256mr),
     /*  84362 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84366 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84372 */     GIR_RootConstrainSelectedInstOperands,
     /*  84373 */     // GIR_Coverage, 19837,
     /*  84373 */     GIR_EraseRootFromParent_Done,
     /*  84374 */   // Label 1826: @84374
     /*  84374 */   GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(84412), // Rule ID 19840 //
     /*  84379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84397 */     // (st VR256X:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16i16] }:$src)
     /*  84397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  84400 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84404 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84410 */     GIR_RootConstrainSelectedInstOperands,
     /*  84411 */     // GIR_Coverage, 19840,
     /*  84411 */     GIR_EraseRootFromParent_Done,
     /*  84412 */   // Label 1827: @84412
     /*  84412 */   GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(84450), // Rule ID 19841 //
     /*  84417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84435 */     // (st VR256X:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16f16] }:$src)
     /*  84435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256mr),
     /*  84438 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84442 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84448 */     GIR_RootConstrainSelectedInstOperands,
     /*  84449 */     // GIR_Coverage, 19841,
     /*  84449 */     GIR_EraseRootFromParent_Done,
     /*  84450 */   // Label 1828: @84450
     /*  84450 */   GIM_Reject,
     /*  84451 */ // Label 1820: @84451
     /*  84451 */ GIM_Reject,
     /*  84452 */ // Label 1489: @84452
     /*  84452 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(84625),
     /*  84457 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84460 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84464 */   GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(84506), // Rule ID 4475 //
     /*  84469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84476 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84480 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84491 */     // (st VR512:{ *:[v16f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16f32] }:$src)
     /*  84491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZmr),
     /*  84494 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84498 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84504 */     GIR_RootConstrainSelectedInstOperands,
     /*  84505 */     // GIR_Coverage, 4475,
     /*  84505 */     GIR_EraseRootFromParent_Done,
     /*  84506 */   // Label 1830: @84506
     /*  84506 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(84544), // Rule ID 4505 //
     /*  84511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84529 */     // (st VR512:{ *:[v16f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16f32] }:$src)
     /*  84529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZmr),
     /*  84532 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84536 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84542 */     GIR_RootConstrainSelectedInstOperands,
     /*  84543 */     // GIR_Coverage, 4505,
     /*  84543 */     GIR_EraseRootFromParent_Done,
     /*  84544 */   // Label 1831: @84544
     /*  84544 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(84586), // Rule ID 19803 //
     /*  84549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84560 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84571 */     // (st VR512:{ *:[v16i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16i32] }:$src)
     /*  84571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  84574 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84578 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84584 */     GIR_RootConstrainSelectedInstOperands,
     /*  84585 */     // GIR_Coverage, 19803,
     /*  84585 */     GIR_EraseRootFromParent_Done,
     /*  84586 */   // Label 1832: @84586
     /*  84586 */   GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(84624), // Rule ID 19807 //
     /*  84591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84609 */     // (st VR512:{ *:[v16i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16i32] }:$src)
     /*  84609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  84612 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84616 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84622 */     GIR_RootConstrainSelectedInstOperands,
     /*  84623 */     // GIR_Coverage, 19807,
     /*  84623 */     GIR_EraseRootFromParent_Done,
     /*  84624 */   // Label 1833: @84624
     /*  84624 */   GIM_Reject,
     /*  84625 */ // Label 1829: @84625
     /*  84625 */ GIM_Reject,
     /*  84626 */ // Label 1490: @84626
     /*  84626 */ GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(84707),
     /*  84631 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84634 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  84642 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84646 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(84676), // Rule ID 4403 //
     /*  84651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  84654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84661 */     // (st VK32:{ *:[v32i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVDmk addr:{ *:[iPTR] }:$dst, VK32:{ *:[v32i1] }:$src)
     /*  84661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDmk),
     /*  84664 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84668 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84674 */     GIR_RootConstrainSelectedInstOperands,
     /*  84675 */     // GIR_Coverage, 4403,
     /*  84675 */     GIR_EraseRootFromParent_Done,
     /*  84676 */   // Label 1835: @84676
     /*  84676 */   GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(84706), // Rule ID 4407 //
     /*  84681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  84684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84691 */     // (st VK32:{ *:[v32i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVDmk_EVEX addr:{ *:[iPTR] }:$dst, VK32:{ *:[v32i1] }:$src)
     /*  84691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDmk_EVEX),
     /*  84694 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84698 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84704 */     GIR_RootConstrainSelectedInstOperands,
     /*  84705 */     // GIR_Coverage, 4407,
     /*  84705 */     GIR_EraseRootFromParent_Done,
     /*  84706 */   // Label 1836: @84706
     /*  84706 */   GIM_Reject,
     /*  84707 */ // Label 1834: @84707
     /*  84707 */ GIM_Reject,
     /*  84708 */ // Label 1491: @84708
     /*  84708 */ GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(84881),
     /*  84713 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84716 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84720 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(84762), // Rule ID 17925 //
     /*  84725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84736 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84747 */     // (st VR256:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v32i8] }:$src)
     /*  84747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  84750 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84754 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84760 */     GIR_RootConstrainSelectedInstOperands,
     /*  84761 */     // GIR_Coverage, 17925,
     /*  84761 */     GIR_EraseRootFromParent_Done,
     /*  84762 */   // Label 1838: @84762
     /*  84762 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(84800), // Rule ID 17929 //
     /*  84767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84785 */     // (st VR256:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v32i8] }:$src)
     /*  84785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  84788 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84792 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84798 */     GIR_RootConstrainSelectedInstOperands,
     /*  84799 */     // GIR_Coverage, 17929,
     /*  84799 */     GIR_EraseRootFromParent_Done,
     /*  84800 */   // Label 1839: @84800
     /*  84800 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(84842), // Rule ID 19838 //
     /*  84805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84816 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84827 */     // (st VR256X:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v32i8] }:$src)
     /*  84827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  84830 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84834 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84840 */     GIR_RootConstrainSelectedInstOperands,
     /*  84841 */     // GIR_Coverage, 19838,
     /*  84841 */     GIR_EraseRootFromParent_Done,
     /*  84842 */   // Label 1840: @84842
     /*  84842 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(84880), // Rule ID 19842 //
     /*  84847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84865 */     // (st VR256X:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v32i8] }:$src)
     /*  84865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  84868 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84872 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84878 */     GIR_RootConstrainSelectedInstOperands,
     /*  84879 */     // GIR_Coverage, 19842,
     /*  84879 */     GIR_EraseRootFromParent_Done,
     /*  84880 */   // Label 1841: @84880
     /*  84880 */   GIM_Reject,
     /*  84881 */ // Label 1837: @84881
     /*  84881 */ GIM_Reject,
     /*  84882 */ // Label 1492: @84882
     /*  84882 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(85055),
     /*  84887 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84890 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84894 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(84936), // Rule ID 19804 //
     /*  84899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84921 */     // (st VR512:{ *:[v32i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32i16] }:$src)
     /*  84921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  84924 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84928 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84934 */     GIR_RootConstrainSelectedInstOperands,
     /*  84935 */     // GIR_Coverage, 19804,
     /*  84935 */     GIR_EraseRootFromParent_Done,
     /*  84936 */   // Label 1843: @84936
     /*  84936 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(84978), // Rule ID 19805 //
     /*  84941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84952 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84963 */     // (st VR512:{ *:[v32f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32f16] }:$src)
     /*  84963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZmr),
     /*  84966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84970 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84976 */     GIR_RootConstrainSelectedInstOperands,
     /*  84977 */     // GIR_Coverage, 19805,
     /*  84977 */     GIR_EraseRootFromParent_Done,
     /*  84978 */   // Label 1844: @84978
     /*  84978 */   GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(85016), // Rule ID 19808 //
     /*  84983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85001 */     // (st VR512:{ *:[v32i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32i16] }:$src)
     /*  85001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  85004 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85008 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85014 */     GIR_RootConstrainSelectedInstOperands,
     /*  85015 */     // GIR_Coverage, 19808,
     /*  85015 */     GIR_EraseRootFromParent_Done,
     /*  85016 */   // Label 1845: @85016
     /*  85016 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(85054), // Rule ID 19809 //
     /*  85021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85039 */     // (st VR512:{ *:[v32f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32f16] }:$src)
     /*  85039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZmr),
     /*  85042 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85046 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85052 */     GIR_RootConstrainSelectedInstOperands,
     /*  85053 */     // GIR_Coverage, 19809,
     /*  85053 */     GIR_EraseRootFromParent_Done,
     /*  85054 */   // Label 1846: @85054
     /*  85054 */   GIM_Reject,
     /*  85055 */ // Label 1842: @85055
     /*  85055 */ GIM_Reject,
     /*  85056 */ // Label 1493: @85056
     /*  85056 */ GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(85137),
     /*  85061 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85064 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  85072 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85076 */   GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(85106), // Rule ID 4405 //
     /*  85081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  85084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85091 */     // (st VK64:{ *:[v64i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVQmk addr:{ *:[iPTR] }:$dst, VK64:{ *:[v64i1] }:$src)
     /*  85091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQmk),
     /*  85094 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85098 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85104 */     GIR_RootConstrainSelectedInstOperands,
     /*  85105 */     // GIR_Coverage, 4405,
     /*  85105 */     GIR_EraseRootFromParent_Done,
     /*  85106 */   // Label 1848: @85106
     /*  85106 */   GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(85136), // Rule ID 4409 //
     /*  85111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  85114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85121 */     // (st VK64:{ *:[v64i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVQmk_EVEX addr:{ *:[iPTR] }:$dst, VK64:{ *:[v64i1] }:$src)
     /*  85121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQmk_EVEX),
     /*  85124 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85128 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85134 */     GIR_RootConstrainSelectedInstOperands,
     /*  85135 */     // GIR_Coverage, 4409,
     /*  85135 */     GIR_EraseRootFromParent_Done,
     /*  85136 */   // Label 1849: @85136
     /*  85136 */   GIM_Reject,
     /*  85137 */ // Label 1847: @85137
     /*  85137 */ GIM_Reject,
     /*  85138 */ // Label 1494: @85138
     /*  85138 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(85231),
     /*  85143 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85146 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85150 */   GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(85192), // Rule ID 19806 //
     /*  85155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85166 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85177 */     // (st VR512:{ *:[v64i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v64i8] }:$src)
     /*  85177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  85180 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85184 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85190 */     GIR_RootConstrainSelectedInstOperands,
     /*  85191 */     // GIR_Coverage, 19806,
     /*  85191 */     GIR_EraseRootFromParent_Done,
     /*  85192 */   // Label 1851: @85192
     /*  85192 */   GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(85230), // Rule ID 19810 //
     /*  85197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85215 */     // (st VR512:{ *:[v64i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v64i8] }:$src)
     /*  85215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  85218 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85222 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85228 */     GIR_RootConstrainSelectedInstOperands,
     /*  85229 */     // GIR_Coverage, 19810,
     /*  85229 */     GIR_EraseRootFromParent_Done,
     /*  85230 */   // Label 1852: @85230
     /*  85230 */   GIM_Reject,
     /*  85231 */ // Label 1850: @85231
     /*  85231 */ GIM_Reject,
     /*  85232 */ // Label 1495: @85232
     /*  85232 */ GIM_Reject,
     /*  85233 */ // Label 14: @85233
     /*  85233 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1857*/ GIMT_Encode4(85468),
     /*  85244 */ /*GILLT_s8*//*Label 1853*/ GIMT_Encode4(85260),
     /*  85248 */ /*GILLT_s16*//*Label 1854*/ GIMT_Encode4(85312),
     /*  85252 */ /*GILLT_s32*//*Label 1855*/ GIMT_Encode4(85364),
     /*  85256 */ /*GILLT_s64*//*Label 1856*/ GIMT_Encode4(85416),
     /*  85260 */ // Label 1853: @85260
     /*  85260 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(85311), // Rule ID 45 //
     /*  85265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  85268 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  85275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  85279 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  85287 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85294 */   // (atomic_swap:{ *:[i8] } addr:{ *:[iPTR] }:$ptr, GR8:{ *:[i8] }:$val)<<P:Predicate_atomic_swap_i8>>  =>  (XCHG8rm:{ *:[i8] } GR8:{ *:[i8] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  85294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG8rm),
     /*  85297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85299 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  85301 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  85305 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85309 */   GIR_RootConstrainSelectedInstOperands,
     /*  85310 */   // GIR_Coverage, 45,
     /*  85310 */   GIR_EraseRootFromParent_Done,
     /*  85311 */ // Label 1858: @85311
     /*  85311 */ GIM_Reject,
     /*  85312 */ // Label 1854: @85312
     /*  85312 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(85363), // Rule ID 46 //
     /*  85317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  85320 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  85327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  85331 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  85339 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85346 */   // (atomic_swap:{ *:[i16] } addr:{ *:[iPTR] }:$ptr, GR16:{ *:[i16] }:$val)<<P:Predicate_atomic_swap_i16>>  =>  (XCHG16rm:{ *:[i16] } GR16:{ *:[i16] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  85346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG16rm),
     /*  85349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85351 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  85353 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  85357 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85361 */   GIR_RootConstrainSelectedInstOperands,
     /*  85362 */   // GIR_Coverage, 46,
     /*  85362 */   GIR_EraseRootFromParent_Done,
     /*  85363 */ // Label 1859: @85363
     /*  85363 */ GIM_Reject,
     /*  85364 */ // Label 1855: @85364
     /*  85364 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(85415), // Rule ID 47 //
     /*  85369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  85372 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  85379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  85383 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85387 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  85391 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85398 */   // (atomic_swap:{ *:[i32] } addr:{ *:[iPTR] }:$ptr, GR32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i32>>  =>  (XCHG32rm:{ *:[i32] } GR32:{ *:[i32] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  85398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG32rm),
     /*  85401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85403 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  85405 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  85409 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85413 */   GIR_RootConstrainSelectedInstOperands,
     /*  85414 */   // GIR_Coverage, 47,
     /*  85414 */   GIR_EraseRootFromParent_Done,
     /*  85415 */ // Label 1860: @85415
     /*  85415 */ GIM_Reject,
     /*  85416 */ // Label 1856: @85416
     /*  85416 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(85467), // Rule ID 48 //
     /*  85421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  85424 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  85431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  85435 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  85443 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85450 */   // (atomic_swap:{ *:[i64] } addr:{ *:[iPTR] }:$ptr, GR64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_i64>>  =>  (XCHG64rm:{ *:[i64] } GR64:{ *:[i64] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  85450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG64rm),
     /*  85453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85455 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  85457 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  85461 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85465 */   GIR_RootConstrainSelectedInstOperands,
     /*  85466 */   // GIR_Coverage, 48,
     /*  85466 */   GIR_EraseRootFromParent_Done,
     /*  85467 */ // Label 1861: @85467
     /*  85467 */ GIM_Reject,
     /*  85468 */ // Label 1857: @85468
     /*  85468 */ GIM_Reject,
     /*  85469 */ // Label 15: @85469
     /*  85469 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1866*/ GIMT_Encode4(85716),
     /*  85480 */ /*GILLT_s8*//*Label 1862*/ GIMT_Encode4(85496),
     /*  85484 */ /*GILLT_s16*//*Label 1863*/ GIMT_Encode4(85551),
     /*  85488 */ /*GILLT_s32*//*Label 1864*/ GIMT_Encode4(85606),
     /*  85492 */ /*GILLT_s64*//*Label 1865*/ GIMT_Encode4(85661),
     /*  85496 */ // Label 1862: @85496
     /*  85496 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(85550), // Rule ID 17297 //
     /*  85501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  85504 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  85511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  85515 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85519 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  85523 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85530 */   // (atomic_load_add:{ *:[i8] } addr:{ *:[iPTR] }:$ptr, GR8:{ *:[i8] }:$val)<<P:Predicate_atomic_load_add_i8>>  =>  (LXADD8:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  85530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD8),
     /*  85533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85535 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  85537 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  85541 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  85544 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85548 */   GIR_RootConstrainSelectedInstOperands,
     /*  85549 */   // GIR_Coverage, 17297,
     /*  85549 */   GIR_EraseRootFromParent_Done,
     /*  85550 */ // Label 1867: @85550
     /*  85550 */ GIM_Reject,
     /*  85551 */ // Label 1863: @85551
     /*  85551 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(85605), // Rule ID 17298 //
     /*  85556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  85559 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  85566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  85570 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85574 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  85578 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85585 */   // (atomic_load_add:{ *:[i16] } addr:{ *:[iPTR] }:$ptr, GR16:{ *:[i16] }:$val)<<P:Predicate_atomic_load_add_i16>>  =>  (LXADD16:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  85585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD16),
     /*  85588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85590 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  85592 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  85596 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  85599 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85603 */   GIR_RootConstrainSelectedInstOperands,
     /*  85604 */   // GIR_Coverage, 17298,
     /*  85604 */   GIR_EraseRootFromParent_Done,
     /*  85605 */ // Label 1868: @85605
     /*  85605 */ GIM_Reject,
     /*  85606 */ // Label 1864: @85606
     /*  85606 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(85660), // Rule ID 17299 //
     /*  85611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  85614 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  85621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  85625 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  85633 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85640 */   // (atomic_load_add:{ *:[i32] } addr:{ *:[iPTR] }:$ptr, GR32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i32>>  =>  (LXADD32:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  85640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD32),
     /*  85643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85645 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  85647 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  85651 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  85654 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85658 */   GIR_RootConstrainSelectedInstOperands,
     /*  85659 */   // GIR_Coverage, 17299,
     /*  85659 */   GIR_EraseRootFromParent_Done,
     /*  85660 */ // Label 1869: @85660
     /*  85660 */ GIM_Reject,
     /*  85661 */ // Label 1865: @85661
     /*  85661 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(85715), // Rule ID 17300 //
     /*  85666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  85669 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  85676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  85680 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85684 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  85688 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85695 */   // (atomic_load_add:{ *:[i64] } addr:{ *:[iPTR] }:$ptr, GR64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_i64>>  =>  (LXADD64:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  85695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD64),
     /*  85698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85700 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  85702 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  85706 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  85709 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85713 */   GIR_RootConstrainSelectedInstOperands,
     /*  85714 */   // GIR_Coverage, 17300,
     /*  85714 */   GIR_EraseRootFromParent_Done,
     /*  85715 */ // Label 1870: @85715
     /*  85715 */ GIM_Reject,
     /*  85716 */ // Label 1866: @85716
     /*  85716 */ GIM_Reject,
     /*  85717 */ // Label 16: @85717
     /*  85717 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(85872),
     /*  85722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  85725 */   GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(85775), // Rule ID 156 //
     /*  85730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPREFETCHI_In64BitMode),
     /*  85733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  85736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  85739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  85743 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  85747 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 3,
     /*  85751 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  85755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85762 */     // (prefetch addr:{ *:[iPTR] }:$src, 0:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (PREFETCHIT0 addr:{ *:[iPTR] }:$src)
     /*  85762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHIT0),
     /*  85765 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  85769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85773 */     GIR_RootConstrainSelectedInstOperands,
     /*  85774 */     // GIR_Coverage, 156,
     /*  85774 */     GIR_EraseRootFromParent_Done,
     /*  85775 */   // Label 1872: @85775
     /*  85775 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(85825), // Rule ID 157 //
     /*  85780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPREFETCHI_In64BitMode),
     /*  85783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  85786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  85789 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  85793 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  85797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 2,
     /*  85801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  85805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85812 */     // (prefetch addr:{ *:[iPTR] }:$src, 0:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (PREFETCHIT1 addr:{ *:[iPTR] }:$src)
     /*  85812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHIT1),
     /*  85815 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  85819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85823 */     GIR_RootConstrainSelectedInstOperands,
     /*  85824 */     // GIR_Coverage, 157,
     /*  85824 */     GIR_EraseRootFromParent_Done,
     /*  85825 */   // Label 1873: @85825
     /*  85825 */   GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(85871), // Rule ID 16982 //
     /*  85830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPrefetchW),
     /*  85833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  85836 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  85840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /*  85844 */     // MIs[0] Operand 2
     /*  85844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  85847 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  85851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85858 */     // (prefetch addr:{ *:[iPTR] }:$addr, 1:{ *:[i32] }, (timm:{ *:[i32] })<<P:Predicate_PrefetchWLevel>>, 1:{ *:[i32] })  =>  (PREFETCHW addr:{ *:[iPTR] }:$addr)
     /*  85858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHW),
     /*  85861 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // addr
     /*  85865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85869 */     GIR_RootConstrainSelectedInstOperands,
     /*  85870 */     // GIR_Coverage, 16982,
     /*  85870 */     GIR_EraseRootFromParent_Done,
     /*  85871 */   // Label 1874: @85871
     /*  85871 */   GIM_Reject,
     /*  85872 */ // Label 1871: @85872
     /*  85872 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(86035),
     /*  85877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  85880 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  85883 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  85887 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  85890 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(85926), // Rule ID 2504 //
     /*  85895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  85898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 3,
     /*  85902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  85906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85913 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHT0 addr:{ *:[iPTR] }:$src)
     /*  85913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHT0),
     /*  85916 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  85920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85924 */     GIR_RootConstrainSelectedInstOperands,
     /*  85925 */     // GIR_Coverage, 2504,
     /*  85925 */     GIR_EraseRootFromParent_Done,
     /*  85926 */   // Label 1876: @85926
     /*  85926 */   GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(85962), // Rule ID 2505 //
     /*  85931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  85934 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 2,
     /*  85938 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  85942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85949 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHT1 addr:{ *:[iPTR] }:$src)
     /*  85949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHT1),
     /*  85952 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  85956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85960 */     GIR_RootConstrainSelectedInstOperands,
     /*  85961 */     // GIR_Coverage, 2505,
     /*  85961 */     GIR_EraseRootFromParent_Done,
     /*  85962 */   // Label 1877: @85962
     /*  85962 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(85998), // Rule ID 2506 //
     /*  85967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  85970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  85974 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  85978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85985 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHT2 addr:{ *:[iPTR] }:$src)
     /*  85985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHT2),
     /*  85988 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  85992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85996 */     GIR_RootConstrainSelectedInstOperands,
     /*  85997 */     // GIR_Coverage, 2506,
     /*  85997 */     GIR_EraseRootFromParent_Done,
     /*  85998 */   // Label 1878: @85998
     /*  85998 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(86034), // Rule ID 2507 //
     /*  86003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  86010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86021 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHNTA addr:{ *:[iPTR] }:$src)
     /*  86021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHNTA),
     /*  86024 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86032 */     GIR_RootConstrainSelectedInstOperands,
     /*  86033 */     // GIR_Coverage, 2507,
     /*  86033 */     GIR_EraseRootFromParent_Done,
     /*  86034 */   // Label 1879: @86034
     /*  86034 */   GIM_Reject,
     /*  86035 */ // Label 1875: @86035
     /*  86035 */ GIM_Reject,
     /*  86036 */ // Label 17: @86036
     /*  86036 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(88365),
     /*  86041 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  86044 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(86111), // Rule ID 1529 //
     /*  86049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubwd),
     /*  86057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86075 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86078 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86082 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86088 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86095 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14945:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBWDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  86095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBWDrm),
     /*  86098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86100 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86109 */     GIR_RootConstrainSelectedInstOperands,
     /*  86110 */     // GIR_Coverage, 1529,
     /*  86110 */     GIR_EraseRootFromParent_Done,
     /*  86111 */   // Label 1881: @86111
     /*  86111 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(86178), // Rule ID 1531 //
     /*  86116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubdq),
     /*  86124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  86127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86142 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86145 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86149 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86155 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86162 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14944:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBDQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  86162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBDQrm),
     /*  86165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86167 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86176 */     GIR_RootConstrainSelectedInstOperands,
     /*  86177 */     // GIR_Coverage, 1531,
     /*  86177 */     GIR_EraseRootFromParent_Done,
     /*  86178 */   // Label 1882: @86178
     /*  86178 */   GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(86245), // Rule ID 1533 //
     /*  86183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubbw),
     /*  86191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86209 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86212 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86216 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86229 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14943:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBBWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  86229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBBWrm),
     /*  86232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86234 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86243 */     GIR_RootConstrainSelectedInstOperands,
     /*  86244 */     // GIR_Coverage, 1533,
     /*  86244 */     GIR_EraseRootFromParent_Done,
     /*  86245 */   // Label 1883: @86245
     /*  86245 */   GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(86312), // Rule ID 1535 //
     /*  86250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwq),
     /*  86258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  86261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86276 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86279 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86283 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86296 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14942:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDWQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  86296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWQrm),
     /*  86299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86301 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86310 */     GIR_RootConstrainSelectedInstOperands,
     /*  86311 */     // GIR_Coverage, 1535,
     /*  86311 */     GIR_EraseRootFromParent_Done,
     /*  86312 */   // Label 1884: @86312
     /*  86312 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(86379), // Rule ID 1537 //
     /*  86317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwd),
     /*  86325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86343 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86346 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86350 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86356 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86363 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14941:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDWDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  86363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWDrm),
     /*  86366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86368 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86377 */     GIR_RootConstrainSelectedInstOperands,
     /*  86378 */     // GIR_Coverage, 1537,
     /*  86378 */     GIR_EraseRootFromParent_Done,
     /*  86379 */   // Label 1885: @86379
     /*  86379 */   GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(86446), // Rule ID 1539 //
     /*  86384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwq),
     /*  86392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  86395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86410 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86413 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86417 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86430 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14940:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUWQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  86430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWQrm),
     /*  86433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86435 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86444 */     GIR_RootConstrainSelectedInstOperands,
     /*  86445 */     // GIR_Coverage, 1539,
     /*  86445 */     GIR_EraseRootFromParent_Done,
     /*  86446 */   // Label 1886: @86446
     /*  86446 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(86513), // Rule ID 1541 //
     /*  86451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwd),
     /*  86459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86477 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86480 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86484 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86497 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14939:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUWDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  86497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWDrm),
     /*  86500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86502 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86511 */     GIR_RootConstrainSelectedInstOperands,
     /*  86512 */     // GIR_Coverage, 1541,
     /*  86512 */     GIR_EraseRootFromParent_Done,
     /*  86513 */   // Label 1887: @86513
     /*  86513 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(86580), // Rule ID 1543 //
     /*  86518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddudq),
     /*  86526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  86529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86544 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86547 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86551 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86564 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14938:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUDQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  86564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUDQrm),
     /*  86567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86569 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86578 */     GIR_RootConstrainSelectedInstOperands,
     /*  86579 */     // GIR_Coverage, 1543,
     /*  86579 */     GIR_EraseRootFromParent_Done,
     /*  86580 */   // Label 1888: @86580
     /*  86580 */   GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(86647), // Rule ID 1545 //
     /*  86585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubw),
     /*  86593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86611 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86614 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86618 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86631 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14937:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUBWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  86631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBWrm),
     /*  86634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86636 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86645 */     GIR_RootConstrainSelectedInstOperands,
     /*  86646 */     // GIR_Coverage, 1545,
     /*  86646 */     GIR_EraseRootFromParent_Done,
     /*  86647 */   // Label 1889: @86647
     /*  86647 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(86714), // Rule ID 1547 //
     /*  86652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubq),
     /*  86660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  86663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86678 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86681 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86685 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86698 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14936:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUBQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  86698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBQrm),
     /*  86701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86703 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86712 */     GIR_RootConstrainSelectedInstOperands,
     /*  86713 */     // GIR_Coverage, 1547,
     /*  86713 */     GIR_EraseRootFromParent_Done,
     /*  86714 */   // Label 1890: @86714
     /*  86714 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(86781), // Rule ID 1549 //
     /*  86719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubd),
     /*  86727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86745 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86748 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86752 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86758 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86765 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14935:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUBDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  86765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBDrm),
     /*  86768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86770 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86779 */     GIR_RootConstrainSelectedInstOperands,
     /*  86780 */     // GIR_Coverage, 1549,
     /*  86780 */     GIR_EraseRootFromParent_Done,
     /*  86781 */   // Label 1891: @86781
     /*  86781 */   GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(86848), // Rule ID 1551 //
     /*  86786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadddq),
     /*  86794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  86797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86812 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86815 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86819 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86832 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14934:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDDQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  86832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDDQrm),
     /*  86835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86837 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86846 */     GIR_RootConstrainSelectedInstOperands,
     /*  86847 */     // GIR_Coverage, 1551,
     /*  86847 */     GIR_EraseRootFromParent_Done,
     /*  86848 */   // Label 1892: @86848
     /*  86848 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(86915), // Rule ID 1553 //
     /*  86853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbw),
     /*  86861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86879 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86882 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86886 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86899 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14933:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDBWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  86899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBWrm),
     /*  86902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86904 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86913 */     GIR_RootConstrainSelectedInstOperands,
     /*  86914 */     // GIR_Coverage, 1553,
     /*  86914 */     GIR_EraseRootFromParent_Done,
     /*  86915 */   // Label 1893: @86915
     /*  86915 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(86982), // Rule ID 1555 //
     /*  86920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbq),
     /*  86928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  86931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86946 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86949 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86953 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86966 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14932:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDBQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  86966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBQrm),
     /*  86969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86971 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86980 */     GIR_RootConstrainSelectedInstOperands,
     /*  86981 */     // GIR_Coverage, 1555,
     /*  86981 */     GIR_EraseRootFromParent_Done,
     /*  86982 */   // Label 1894: @86982
     /*  86982 */   GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(87049), // Rule ID 1557 //
     /*  86987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbd),
     /*  86995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87013 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87016 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87020 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87026 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87033 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14931:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDBDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  87033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBDrm),
     /*  87036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87038 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87047 */     GIR_RootConstrainSelectedInstOperands,
     /*  87048 */     // GIR_Coverage, 1557,
     /*  87048 */     GIR_EraseRootFromParent_Done,
     /*  87049 */   // Label 1895: @87049
     /*  87049 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(87116), // Rule ID 1563 //
     /*  87054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps),
     /*  87062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87080 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87083 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87087 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87100 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14923:{ *:[iPTR] }, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  87100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSrm),
     /*  87103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87105 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87114 */     GIR_RootConstrainSelectedInstOperands,
     /*  87115 */     // GIR_Coverage, 1563,
     /*  87115 */     GIR_EraseRootFromParent_Done,
     /*  87116 */   // Label 1896: @87116
     /*  87116 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(87183), // Rule ID 1565 //
     /*  87121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps_256),
     /*  87129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  87132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  87135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  87139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87147 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87150 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87154 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87167 */     // (intrinsic_wo_chain:{ *:[v8f32] } 14924:{ *:[iPTR] }, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  87167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSYrm),
     /*  87170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87172 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87181 */     GIR_RootConstrainSelectedInstOperands,
     /*  87182 */     // GIR_Coverage, 1565,
     /*  87182 */     GIR_EraseRootFromParent_Done,
     /*  87183 */   // Label 1897: @87183
     /*  87183 */   GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(87250), // Rule ID 1571 //
     /*  87188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd),
     /*  87196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  87202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87214 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87217 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87221 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87234 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14921:{ *:[iPTR] }, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  87234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDrm),
     /*  87237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87239 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87248 */     GIR_RootConstrainSelectedInstOperands,
     /*  87249 */     // GIR_Coverage, 1571,
     /*  87249 */     GIR_EraseRootFromParent_Done,
     /*  87250 */   // Label 1898: @87250
     /*  87250 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(87317), // Rule ID 1573 //
     /*  87255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd_256),
     /*  87263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  87266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  87269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  87273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87281 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87284 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87288 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87301 */     // (intrinsic_wo_chain:{ *:[v4f64] } 14922:{ *:[iPTR] }, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  87301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDYrm),
     /*  87304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87306 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87315 */     GIR_RootConstrainSelectedInstOperands,
     /*  87316 */     // GIR_Coverage, 1573,
     /*  87316 */     GIR_EraseRootFromParent_Done,
     /*  87317 */   // Label 1899: @87317
     /*  87317 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(87384), // Rule ID 3363 //
     /*  87322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  87325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /*  87330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  87336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87348 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87351 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87355 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87361 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87368 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13296:{ *:[iPTR] }, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESIMCrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /*  87368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESIMCrm),
     /*  87371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87373 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  87377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87382 */     GIR_RootConstrainSelectedInstOperands,
     /*  87383 */     // GIR_Coverage, 3363,
     /*  87383 */     GIR_EraseRootFromParent_Done,
     /*  87384 */   // Label 1900: @87384
     /*  87384 */   GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(87420), // Rule ID 1528 //
     /*  87389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubwd),
     /*  87397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87411 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14945:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHSUBWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /*  87411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBWDrr),
     /*  87414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87416 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87418 */     GIR_RootConstrainSelectedInstOperands,
     /*  87419 */     // GIR_Coverage, 1528,
     /*  87419 */     GIR_EraseRootFromParent_Done,
     /*  87420 */   // Label 1901: @87420
     /*  87420 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(87456), // Rule ID 1530 //
     /*  87425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubdq),
     /*  87433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87447 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14944:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHSUBDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /*  87447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBDQrr),
     /*  87450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87452 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87454 */     GIR_RootConstrainSelectedInstOperands,
     /*  87455 */     // GIR_Coverage, 1530,
     /*  87455 */     GIR_EraseRootFromParent_Done,
     /*  87456 */   // Label 1902: @87456
     /*  87456 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(87492), // Rule ID 1532 //
     /*  87461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubbw),
     /*  87469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87483 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14943:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHSUBBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /*  87483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBBWrr),
     /*  87486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87488 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87490 */     GIR_RootConstrainSelectedInstOperands,
     /*  87491 */     // GIR_Coverage, 1532,
     /*  87491 */     GIR_EraseRootFromParent_Done,
     /*  87492 */   // Label 1903: @87492
     /*  87492 */   GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(87528), // Rule ID 1534 //
     /*  87497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwq),
     /*  87505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87519 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14942:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDWQrr:{ *:[v2i64] } VR128:{ *:[v8i16] }:$src)
     /*  87519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWQrr),
     /*  87522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87524 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87526 */     GIR_RootConstrainSelectedInstOperands,
     /*  87527 */     // GIR_Coverage, 1534,
     /*  87527 */     GIR_EraseRootFromParent_Done,
     /*  87528 */   // Label 1904: @87528
     /*  87528 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(87564), // Rule ID 1536 //
     /*  87533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwd),
     /*  87541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87555 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14941:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /*  87555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWDrr),
     /*  87558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87560 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87562 */     GIR_RootConstrainSelectedInstOperands,
     /*  87563 */     // GIR_Coverage, 1536,
     /*  87563 */     GIR_EraseRootFromParent_Done,
     /*  87564 */   // Label 1905: @87564
     /*  87564 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(87600), // Rule ID 1538 //
     /*  87569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwq),
     /*  87577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87591 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14940:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDUWQrr:{ *:[v2i64] } VR128:{ *:[v8i16] }:$src)
     /*  87591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWQrr),
     /*  87594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87596 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87598 */     GIR_RootConstrainSelectedInstOperands,
     /*  87599 */     // GIR_Coverage, 1538,
     /*  87599 */     GIR_EraseRootFromParent_Done,
     /*  87600 */   // Label 1906: @87600
     /*  87600 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(87636), // Rule ID 1540 //
     /*  87605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwd),
     /*  87613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87627 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14939:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDUWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /*  87627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWDrr),
     /*  87630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87632 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87634 */     GIR_RootConstrainSelectedInstOperands,
     /*  87635 */     // GIR_Coverage, 1540,
     /*  87635 */     GIR_EraseRootFromParent_Done,
     /*  87636 */   // Label 1907: @87636
     /*  87636 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(87672), // Rule ID 1542 //
     /*  87641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddudq),
     /*  87649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87663 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14938:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHADDUDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /*  87663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUDQrr),
     /*  87666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87668 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87670 */     GIR_RootConstrainSelectedInstOperands,
     /*  87671 */     // GIR_Coverage, 1542,
     /*  87671 */     GIR_EraseRootFromParent_Done,
     /*  87672 */   // Label 1908: @87672
     /*  87672 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(87708), // Rule ID 1544 //
     /*  87677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubw),
     /*  87685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87699 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14937:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /*  87699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBWrr),
     /*  87702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87704 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87706 */     GIR_RootConstrainSelectedInstOperands,
     /*  87707 */     // GIR_Coverage, 1544,
     /*  87707 */     GIR_EraseRootFromParent_Done,
     /*  87708 */   // Label 1909: @87708
     /*  87708 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(87744), // Rule ID 1546 //
     /*  87713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubq),
     /*  87721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87735 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14936:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBQrr:{ *:[v2i64] } VR128:{ *:[v16i8] }:$src)
     /*  87735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBQrr),
     /*  87738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87740 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87742 */     GIR_RootConstrainSelectedInstOperands,
     /*  87743 */     // GIR_Coverage, 1546,
     /*  87743 */     GIR_EraseRootFromParent_Done,
     /*  87744 */   // Label 1910: @87744
     /*  87744 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(87780), // Rule ID 1548 //
     /*  87749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubd),
     /*  87757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87771 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14935:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBDrr:{ *:[v4i32] } VR128:{ *:[v16i8] }:$src)
     /*  87771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBDrr),
     /*  87774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87776 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87778 */     GIR_RootConstrainSelectedInstOperands,
     /*  87779 */     // GIR_Coverage, 1548,
     /*  87779 */     GIR_EraseRootFromParent_Done,
     /*  87780 */   // Label 1911: @87780
     /*  87780 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(87816), // Rule ID 1550 //
     /*  87785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadddq),
     /*  87793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87807 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14934:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHADDDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /*  87807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDDQrr),
     /*  87810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87812 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87814 */     GIR_RootConstrainSelectedInstOperands,
     /*  87815 */     // GIR_Coverage, 1550,
     /*  87815 */     GIR_EraseRootFromParent_Done,
     /*  87816 */   // Label 1912: @87816
     /*  87816 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(87852), // Rule ID 1552 //
     /*  87821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbw),
     /*  87829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87843 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14933:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /*  87843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBWrr),
     /*  87846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87848 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87850 */     GIR_RootConstrainSelectedInstOperands,
     /*  87851 */     // GIR_Coverage, 1552,
     /*  87851 */     GIR_EraseRootFromParent_Done,
     /*  87852 */   // Label 1913: @87852
     /*  87852 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(87888), // Rule ID 1554 //
     /*  87857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbq),
     /*  87865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87879 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14932:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBQrr:{ *:[v2i64] } VR128:{ *:[v16i8] }:$src)
     /*  87879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBQrr),
     /*  87882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87884 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87886 */     GIR_RootConstrainSelectedInstOperands,
     /*  87887 */     // GIR_Coverage, 1554,
     /*  87887 */     GIR_EraseRootFromParent_Done,
     /*  87888 */   // Label 1914: @87888
     /*  87888 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(87924), // Rule ID 1556 //
     /*  87893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbd),
     /*  87901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87915 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14931:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBDrr:{ *:[v4i32] } VR128:{ *:[v16i8] }:$src)
     /*  87915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBDrr),
     /*  87918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87920 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87922 */     GIR_RootConstrainSelectedInstOperands,
     /*  87923 */     // GIR_Coverage, 1556,
     /*  87923 */     GIR_EraseRootFromParent_Done,
     /*  87924 */   // Label 1915: @87924
     /*  87924 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(87960), // Rule ID 1558 //
     /*  87929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ss),
     /*  87937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87951 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14926:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VFRCZSSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /*  87951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZSSrr),
     /*  87954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87956 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87958 */     GIR_RootConstrainSelectedInstOperands,
     /*  87959 */     // GIR_Coverage, 1558,
     /*  87959 */     GIR_EraseRootFromParent_Done,
     /*  87960 */   // Label 1916: @87960
     /*  87960 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(87996), // Rule ID 1562 //
     /*  87965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps),
     /*  87973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87987 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14923:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VFRCZPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /*  87987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSrr),
     /*  87990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87992 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  87994 */     GIR_RootConstrainSelectedInstOperands,
     /*  87995 */     // GIR_Coverage, 1562,
     /*  87995 */     GIR_EraseRootFromParent_Done,
     /*  87996 */   // Label 1917: @87996
     /*  87996 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(88032), // Rule ID 1564 //
     /*  88001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps_256),
     /*  88009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  88012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  88015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88023 */     // (intrinsic_wo_chain:{ *:[v8f32] } 14924:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src)  =>  (VFRCZPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /*  88023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSYrr),
     /*  88026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88028 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88030 */     GIR_RootConstrainSelectedInstOperands,
     /*  88031 */     // GIR_Coverage, 1564,
     /*  88031 */     GIR_EraseRootFromParent_Done,
     /*  88032 */   // Label 1918: @88032
     /*  88032 */   GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(88068), // Rule ID 1566 //
     /*  88037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_sd),
     /*  88045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88059 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14925:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src)  =>  (VFRCZSDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /*  88059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZSDrr),
     /*  88062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88064 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88066 */     GIR_RootConstrainSelectedInstOperands,
     /*  88067 */     // GIR_Coverage, 1566,
     /*  88067 */     GIR_EraseRootFromParent_Done,
     /*  88068 */   // Label 1919: @88068
     /*  88068 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(88104), // Rule ID 1570 //
     /*  88073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd),
     /*  88081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88095 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14921:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src)  =>  (VFRCZPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /*  88095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDrr),
     /*  88098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88100 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88102 */     GIR_RootConstrainSelectedInstOperands,
     /*  88103 */     // GIR_Coverage, 1570,
     /*  88103 */     GIR_EraseRootFromParent_Done,
     /*  88104 */   // Label 1920: @88104
     /*  88104 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(88140), // Rule ID 1572 //
     /*  88109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd_256),
     /*  88117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  88120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  88123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88131 */     // (intrinsic_wo_chain:{ *:[v4f64] } 14922:{ *:[iPTR] }, VR256:{ *:[v4f64] }:$src)  =>  (VFRCZPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /*  88131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDYrr),
     /*  88134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88136 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88138 */     GIR_RootConstrainSelectedInstOperands,
     /*  88139 */     // GIR_Coverage, 1572,
     /*  88139 */     GIR_EraseRootFromParent_Done,
     /*  88140 */   // Label 1921: @88140
     /*  88140 */   GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(88176), // Rule ID 3362 //
     /*  88145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  88148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /*  88153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88167 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13296:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1)  =>  (VAESIMCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1)
     /*  88167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESIMCrr),
     /*  88170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88172 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  88174 */     GIR_RootConstrainSelectedInstOperands,
     /*  88175 */     // GIR_Coverage, 3362,
     /*  88175 */     GIR_EraseRootFromParent_Done,
     /*  88176 */   // Label 1922: @88176
     /*  88176 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(88212), // Rule ID 3364 //
     /*  88181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  88184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /*  88189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88203 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13296:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1)  =>  (AESIMCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1)
     /*  88203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESIMCrr),
     /*  88206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88208 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  88210 */     GIR_RootConstrainSelectedInstOperands,
     /*  88211 */     // GIR_Coverage, 3364,
     /*  88211 */     GIR_EraseRootFromParent_Done,
     /*  88212 */   // Label 1923: @88212
     /*  88212 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(88250), // Rule ID 18265 //
     /*  88217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  88220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rsqrt_ss),
     /*  88225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88239 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14631:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (RSQRTSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  88239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RSQRTSSr_Int),
     /*  88242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88244 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88246 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88248 */     GIR_RootConstrainSelectedInstOperands,
     /*  88249 */     // GIR_Coverage, 18265,
     /*  88249 */     GIR_EraseRootFromParent_Done,
     /*  88250 */   // Label 1924: @88250
     /*  88250 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(88288), // Rule ID 18269 //
     /*  88255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  88258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rsqrt_ss),
     /*  88263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88277 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14631:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VRSQRTSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  88277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VRSQRTSSr_Int),
     /*  88280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88282 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88284 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88286 */     GIR_RootConstrainSelectedInstOperands,
     /*  88287 */     // GIR_Coverage, 18269,
     /*  88287 */     GIR_EraseRootFromParent_Done,
     /*  88288 */   // Label 1925: @88288
     /*  88288 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(88326), // Rule ID 18285 //
     /*  88293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  88296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rcp_ss),
     /*  88301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88315 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14629:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (RCPSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  88315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RCPSSr_Int),
     /*  88318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88320 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88322 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88324 */     GIR_RootConstrainSelectedInstOperands,
     /*  88325 */     // GIR_Coverage, 18285,
     /*  88325 */     GIR_EraseRootFromParent_Done,
     /*  88326 */   // Label 1926: @88326
     /*  88326 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(88364), // Rule ID 18289 //
     /*  88331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  88334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rcp_ss),
     /*  88339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88353 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14629:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VRCPSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  88353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VRCPSSr_Int),
     /*  88356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88358 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88360 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88362 */     GIR_RootConstrainSelectedInstOperands,
     /*  88363 */     // GIR_Coverage, 18289,
     /*  88363 */     GIR_EraseRootFromParent_Done,
     /*  88364 */   // Label 1927: @88364
     /*  88364 */   GIM_Reject,
     /*  88365 */ // Label 1880: @88365
     /*  88365 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(95146),
     /*  88370 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  88373 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(88445), // Rule ID 3367 //
     /*  88378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  88381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /*  88386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88404 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88407 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88411 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88415 */     // MIs[0] src2
     /*  88415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  88418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88420 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  88427 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13297:{ *:[iPTR] }, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src2)  =>  (VAESKEYGENASSIST128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1, (timm:{ *:[i8] }):$src2)
     /*  88427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESKEYGENASSIST128rm),
     /*  88430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88432 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  88436 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  88438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88443 */     GIR_RootConstrainSelectedInstOperands,
     /*  88444 */     // GIR_Coverage, 3367,
     /*  88444 */     GIR_EraseRootFromParent_Done,
     /*  88445 */   // Label 1929: @88445
     /*  88445 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(88521), // Rule ID 16789 //
     /*  88450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  88453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  88458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  88471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  88475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  88479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88483 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88486 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88490 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  88503 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14900:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Z128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  88503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z128rm),
     /*  88506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88508 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  88510 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  88514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88519 */     GIR_RootConstrainSelectedInstOperands,
     /*  88520 */     // GIR_Coverage, 16789,
     /*  88520 */     GIR_EraseRootFromParent_Done,
     /*  88521 */   // Label 1930: @88521
     /*  88521 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(88597), // Rule ID 16791 //
     /*  88526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  88529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  88534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  88537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  88540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  88543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  88547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  88551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  88555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88559 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88562 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88566 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88572 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  88579 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14901:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Z256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  88579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z256rm),
     /*  88582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88584 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  88586 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  88590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88595 */     GIR_RootConstrainSelectedInstOperands,
     /*  88596 */     // GIR_Coverage, 16791,
     /*  88596 */     GIR_EraseRootFromParent_Done,
     /*  88597 */   // Label 1931: @88597
     /*  88597 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(88673), // Rule ID 16795 //
     /*  88602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  88605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  88610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  88623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  88627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  88631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88635 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88638 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88642 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88648 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  88655 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14903:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Z128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  88655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z128rm),
     /*  88658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88660 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  88662 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  88666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88671 */     GIR_RootConstrainSelectedInstOperands,
     /*  88672 */     // GIR_Coverage, 16795,
     /*  88672 */     GIR_EraseRootFromParent_Done,
     /*  88673 */   // Label 1932: @88673
     /*  88673 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(88749), // Rule ID 16797 //
     /*  88678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  88681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  88686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  88689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  88692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  88695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  88699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  88703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  88707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88711 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88714 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88718 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  88731 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14904:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Z256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  88731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z256rm),
     /*  88734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88736 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  88738 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  88742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88747 */     GIR_RootConstrainSelectedInstOperands,
     /*  88748 */     // GIR_Coverage, 16797,
     /*  88748 */     GIR_EraseRootFromParent_Done,
     /*  88749 */   // Label 1933: @88749
     /*  88749 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(88825), // Rule ID 3022 //
     /*  88754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  88757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /*  88762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  88783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88787 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88790 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88794 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88800 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  88807 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14769:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  88807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBrm),
     /*  88810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88812 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  88814 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  88818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88823 */     GIR_RootConstrainSelectedInstOperands,
     /*  88824 */     // GIR_Coverage, 3022,
     /*  88824 */     GIR_EraseRootFromParent_Done,
     /*  88825 */   // Label 1934: @88825
     /*  88825 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(88901), // Rule ID 3024 //
     /*  88830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  88833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /*  88838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  88859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88863 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88866 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88870 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  88883 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14773:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  88883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWrm),
     /*  88886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88888 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  88890 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  88894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88899 */     GIR_RootConstrainSelectedInstOperands,
     /*  88900 */     // GIR_Coverage, 3024,
     /*  88900 */     GIR_EraseRootFromParent_Done,
     /*  88901 */   // Label 1935: @88901
     /*  88901 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(88977), // Rule ID 3026 //
     /*  88906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  88909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /*  88914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  88935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88939 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88942 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88946 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  88959 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14771:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  88959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDrm),
     /*  88962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88964 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  88966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  88970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88975 */     GIR_RootConstrainSelectedInstOperands,
     /*  88976 */     // GIR_Coverage, 3026,
     /*  88976 */     GIR_EraseRootFromParent_Done,
     /*  88977 */   // Label 1936: @88977
     /*  88977 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(89053), // Rule ID 3028 //
     /*  88982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  88985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /*  88990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89015 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89018 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89022 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89028 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89035 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14753:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWrm),
     /*  89038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89040 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89042 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89051 */     GIR_RootConstrainSelectedInstOperands,
     /*  89052 */     // GIR_Coverage, 3028,
     /*  89052 */     GIR_EraseRootFromParent_Done,
     /*  89053 */   // Label 1937: @89053
     /*  89053 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(89129), // Rule ID 3030 //
     /*  89058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /*  89066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89091 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89094 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89098 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89111 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14759:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWrm),
     /*  89114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89116 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89127 */     GIR_RootConstrainSelectedInstOperands,
     /*  89128 */     // GIR_Coverage, 3030,
     /*  89128 */     GIR_EraseRootFromParent_Done,
     /*  89129 */   // Label 1938: @89129
     /*  89129 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(89205), // Rule ID 3046 //
     /*  89134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_b),
     /*  89142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /*  89145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  89148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /*  89151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89167 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89170 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89174 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89180 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89187 */     // (intrinsic_wo_chain:{ *:[v32i8] } 13660:{ *:[iPTR] }, VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBYrm),
     /*  89190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89192 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89194 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89203 */     GIR_RootConstrainSelectedInstOperands,
     /*  89204 */     // GIR_Coverage, 3046,
     /*  89204 */     GIR_EraseRootFromParent_Done,
     /*  89205 */   // Label 1939: @89205
     /*  89205 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(89281), // Rule ID 3048 //
     /*  89210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_w),
     /*  89218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  89221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  89224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  89227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89243 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89246 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89250 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89263 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13662:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWYrm),
     /*  89266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89268 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89270 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89279 */     GIR_RootConstrainSelectedInstOperands,
     /*  89280 */     // GIR_Coverage, 3048,
     /*  89280 */     GIR_EraseRootFromParent_Done,
     /*  89281 */   // Label 1940: @89281
     /*  89281 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(89357), // Rule ID 3050 //
     /*  89286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_d),
     /*  89294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  89297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  89300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  89303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89319 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89322 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89326 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89339 */     // (intrinsic_wo_chain:{ *:[v8i32] } 13661:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDYrm),
     /*  89342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89344 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89346 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89355 */     GIR_RootConstrainSelectedInstOperands,
     /*  89356 */     // GIR_Coverage, 3050,
     /*  89356 */     GIR_EraseRootFromParent_Done,
     /*  89357 */   // Label 1941: @89357
     /*  89357 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(89433), // Rule ID 3052 //
     /*  89362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phadd_sw),
     /*  89370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  89373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  89376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  89379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89395 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89398 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89402 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89415 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13647:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWYrm),
     /*  89418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89420 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89422 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89431 */     GIR_RootConstrainSelectedInstOperands,
     /*  89432 */     // GIR_Coverage, 3052,
     /*  89432 */     GIR_EraseRootFromParent_Done,
     /*  89433 */   // Label 1942: @89433
     /*  89433 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(89509), // Rule ID 3054 //
     /*  89438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phsub_sw),
     /*  89446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  89449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  89452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  89455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89471 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89474 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89478 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89484 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89491 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13650:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWYrm),
     /*  89494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89496 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89507 */     GIR_RootConstrainSelectedInstOperands,
     /*  89508 */     // GIR_Coverage, 3054,
     /*  89508 */     GIR_EraseRootFromParent_Done,
     /*  89509 */   // Label 1943: @89509
     /*  89509 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(89585), // Rule ID 3309 //
     /*  89514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  89517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  89522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  89525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  89528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  89531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  89535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  89539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89547 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89550 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89554 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89560 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89567 */     // (intrinsic_wo_chain:{ *:[i32] } 14727:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m8:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m8),
     /*  89570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89572 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89574 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89583 */     GIR_RootConstrainSelectedInstOperands,
     /*  89584 */     // GIR_Coverage, 3309,
     /*  89584 */     GIR_EraseRootFromParent_Done,
     /*  89585 */   // Label 1944: @89585
     /*  89585 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(89661), // Rule ID 3311 //
     /*  89590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  89593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  89598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  89601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  89604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  89607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  89611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  89615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89623 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89626 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89630 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89643 */     // (intrinsic_wo_chain:{ *:[i32] } 14725:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m16:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m16),
     /*  89646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89648 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89650 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89659 */     GIR_RootConstrainSelectedInstOperands,
     /*  89660 */     // GIR_Coverage, 3311,
     /*  89660 */     GIR_EraseRootFromParent_Done,
     /*  89661 */   // Label 1945: @89661
     /*  89661 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(89737), // Rule ID 3313 //
     /*  89666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  89669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  89674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  89677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  89680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  89683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  89687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  89691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89699 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89702 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89706 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89719 */     // (intrinsic_wo_chain:{ *:[i32] } 14726:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m32:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m32),
     /*  89722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89724 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89726 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89735 */     GIR_RootConstrainSelectedInstOperands,
     /*  89736 */     // GIR_Coverage, 3313,
     /*  89736 */     GIR_EraseRootFromParent_Done,
     /*  89737 */   // Label 1946: @89737
     /*  89737 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(89813), // Rule ID 3315 //
     /*  89742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  89745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  89750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  89753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  89756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  89759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  89763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  89767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89775 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89778 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89782 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89788 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89795 */     // (intrinsic_wo_chain:{ *:[i64] } 14728:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r64m64:{ *:[i64] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64m64),
     /*  89798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89800 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89802 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89811 */     GIR_RootConstrainSelectedInstOperands,
     /*  89812 */     // GIR_Coverage, 3315,
     /*  89812 */     GIR_EraseRootFromParent_Done,
     /*  89813 */   // Label 1947: @89813
     /*  89813 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(89889), // Rule ID 3317 //
     /*  89818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  89821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  89826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  89829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  89832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  89835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  89839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  89843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89851 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89854 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89858 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89871 */     // (intrinsic_wo_chain:{ *:[i32] } 14727:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m8_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m8_EVEX),
     /*  89874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89876 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89878 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89887 */     GIR_RootConstrainSelectedInstOperands,
     /*  89888 */     // GIR_Coverage, 3317,
     /*  89888 */     GIR_EraseRootFromParent_Done,
     /*  89889 */   // Label 1948: @89889
     /*  89889 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(89965), // Rule ID 3319 //
     /*  89894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  89897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  89902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  89905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  89908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  89911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  89915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  89919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89927 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89930 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89934 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89947 */     // (intrinsic_wo_chain:{ *:[i32] } 14725:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m16_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m16_EVEX),
     /*  89950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89952 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89954 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89963 */     GIR_RootConstrainSelectedInstOperands,
     /*  89964 */     // GIR_Coverage, 3319,
     /*  89964 */     GIR_EraseRootFromParent_Done,
     /*  89965 */   // Label 1949: @89965
     /*  89965 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(90041), // Rule ID 3321 //
     /*  89970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  89973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  89978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  89981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  89984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  89987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  89991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  89995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90003 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90006 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90010 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90023 */     // (intrinsic_wo_chain:{ *:[i32] } 14726:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m32_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m32_EVEX),
     /*  90026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90028 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90030 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90039 */     GIR_RootConstrainSelectedInstOperands,
     /*  90040 */     // GIR_Coverage, 3321,
     /*  90040 */     GIR_EraseRootFromParent_Done,
     /*  90041 */   // Label 1950: @90041
     /*  90041 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(90117), // Rule ID 3323 //
     /*  90046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  90054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  90057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  90060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  90063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90079 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90082 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90086 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90099 */     // (intrinsic_wo_chain:{ *:[i64] } 14728:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r64m64_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64m64_EVEX),
     /*  90102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90104 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90106 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90115 */     GIR_RootConstrainSelectedInstOperands,
     /*  90116 */     // GIR_Coverage, 3323,
     /*  90116 */     GIR_EraseRootFromParent_Done,
     /*  90117 */   // Label 1951: @90117
     /*  90117 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(90193), // Rule ID 3339 //
     /*  90122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  90125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  90130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  90133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  90139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90155 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90158 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90162 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90168 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90175 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13290:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCrm),
     /*  90178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90180 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90182 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90191 */     GIR_RootConstrainSelectedInstOperands,
     /*  90192 */     // GIR_Coverage, 3339,
     /*  90192 */     GIR_EraseRootFromParent_Done,
     /*  90193 */   // Label 1952: @90193
     /*  90193 */   GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(90269), // Rule ID 3341 //
     /*  90198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  90201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  90206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  90209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  90215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90231 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90234 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90238 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90251 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13293:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTrm),
     /*  90254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90256 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90258 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90267 */     GIR_RootConstrainSelectedInstOperands,
     /*  90268 */     // GIR_Coverage, 3341,
     /*  90268 */     GIR_EraseRootFromParent_Done,
     /*  90269 */   // Label 1953: @90269
     /*  90269 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(90345), // Rule ID 3343 //
     /*  90274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  90277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  90282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  90285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  90291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90307 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90310 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90314 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90320 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90327 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13284:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECrm),
     /*  90330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90332 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90334 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90343 */     GIR_RootConstrainSelectedInstOperands,
     /*  90344 */     // GIR_Coverage, 3343,
     /*  90344 */     GIR_EraseRootFromParent_Done,
     /*  90345 */   // Label 1954: @90345
     /*  90345 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(90421), // Rule ID 3345 //
     /*  90350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  90353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  90358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  90361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  90367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90383 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90386 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90390 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90396 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90403 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13287:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTrm),
     /*  90406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90408 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90410 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90419 */     GIR_RootConstrainSelectedInstOperands,
     /*  90420 */     // GIR_Coverage, 3345,
     /*  90420 */     GIR_EraseRootFromParent_Done,
     /*  90421 */   // Label 1955: @90421
     /*  90421 */   GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(90497), // Rule ID 3347 //
     /*  90426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  90429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  90434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  90437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  90440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  90443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90459 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90462 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90466 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90472 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90479 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13291:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCYrm),
     /*  90482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90484 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90486 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90495 */     GIR_RootConstrainSelectedInstOperands,
     /*  90496 */     // GIR_Coverage, 3347,
     /*  90496 */     GIR_EraseRootFromParent_Done,
     /*  90497 */   // Label 1956: @90497
     /*  90497 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(90573), // Rule ID 3349 //
     /*  90502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  90505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  90510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  90513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  90516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  90519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90535 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90538 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90542 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90555 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13294:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTYrm),
     /*  90558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90560 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90562 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90571 */     GIR_RootConstrainSelectedInstOperands,
     /*  90572 */     // GIR_Coverage, 3349,
     /*  90572 */     GIR_EraseRootFromParent_Done,
     /*  90573 */   // Label 1957: @90573
     /*  90573 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(90649), // Rule ID 3351 //
     /*  90578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  90581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  90586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  90589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  90592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  90595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90611 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90614 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90618 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90631 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13285:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECYrm),
     /*  90634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90636 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90638 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90647 */     GIR_RootConstrainSelectedInstOperands,
     /*  90648 */     // GIR_Coverage, 3351,
     /*  90648 */     GIR_EraseRootFromParent_Done,
     /*  90649 */   // Label 1958: @90649
     /*  90649 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(90725), // Rule ID 3353 //
     /*  90654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  90657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  90662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  90665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  90668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  90671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90687 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90690 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90694 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90700 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90707 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13288:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTYrm),
     /*  90710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90712 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90714 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90723 */     GIR_RootConstrainSelectedInstOperands,
     /*  90724 */     // GIR_Coverage, 3353,
     /*  90724 */     GIR_EraseRootFromParent_Done,
     /*  90725 */   // Label 1959: @90725
     /*  90725 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(90801), // Rule ID 3564 //
     /*  90730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  90733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  90738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  90741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90763 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90766 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90770 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90776 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90783 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14900:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4rm),
     /*  90786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90788 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90790 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90799 */     GIR_RootConstrainSelectedInstOperands,
     /*  90800 */     // GIR_Coverage, 3564,
     /*  90800 */     GIR_EraseRootFromParent_Done,
     /*  90801 */   // Label 1960: @90801
     /*  90801 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(90877), // Rule ID 3566 //
     /*  90806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  90809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  90814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  90817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  90820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  90823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90839 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90842 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90846 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90859 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14901:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Yrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Yrm),
     /*  90862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90864 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90866 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90875 */     GIR_RootConstrainSelectedInstOperands,
     /*  90876 */     // GIR_Coverage, 3566,
     /*  90876 */     GIR_EraseRootFromParent_Done,
     /*  90877 */   // Label 1961: @90877
     /*  90877 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(90953), // Rule ID 3568 //
     /*  90882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  90885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  90890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  90893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90915 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90918 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90922 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90928 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90935 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14903:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4rm),
     /*  90938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90940 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90942 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90951 */     GIR_RootConstrainSelectedInstOperands,
     /*  90952 */     // GIR_Coverage, 3568,
     /*  90952 */     GIR_EraseRootFromParent_Done,
     /*  90953 */   // Label 1962: @90953
     /*  90953 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(91029), // Rule ID 3570 //
     /*  90958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  90961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  90966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  90969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  90972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  90975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90991 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90994 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90998 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91004 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91011 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14904:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Yrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Yrm),
     /*  91014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91016 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91018 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91027 */     GIR_RootConstrainSelectedInstOperands,
     /*  91028 */     // GIR_Coverage, 3570,
     /*  91028 */     GIR_EraseRootFromParent_Done,
     /*  91029 */   // Label 1963: @91029
     /*  91029 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(91105), // Rule ID 14060 //
     /*  91034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  91042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  91045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91067 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91070 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91074 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91087 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13290:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ128rm),
     /*  91090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91092 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91094 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91103 */     GIR_RootConstrainSelectedInstOperands,
     /*  91104 */     // GIR_Coverage, 14060,
     /*  91104 */     GIR_EraseRootFromParent_Done,
     /*  91105 */   // Label 1964: @91105
     /*  91105 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(91181), // Rule ID 14062 //
     /*  91110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  91118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91143 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91146 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91150 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91156 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91163 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13291:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ256rm),
     /*  91166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91168 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91170 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91179 */     GIR_RootConstrainSelectedInstOperands,
     /*  91180 */     // GIR_Coverage, 14062,
     /*  91180 */     GIR_EraseRootFromParent_Done,
     /*  91181 */   // Label 1965: @91181
     /*  91181 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(91257), // Rule ID 14064 //
     /*  91186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  91189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_512),
     /*  91194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  91197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  91200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  91203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91219 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91222 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91226 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91239 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13292:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZrm),
     /*  91242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91244 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91246 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91255 */     GIR_RootConstrainSelectedInstOperands,
     /*  91256 */     // GIR_Coverage, 14064,
     /*  91256 */     GIR_EraseRootFromParent_Done,
     /*  91257 */   // Label 1966: @91257
     /*  91257 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(91333), // Rule ID 14066 //
     /*  91262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  91270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  91273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91295 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91298 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91302 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91315 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13293:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ128rm),
     /*  91318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91320 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91322 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91331 */     GIR_RootConstrainSelectedInstOperands,
     /*  91332 */     // GIR_Coverage, 14066,
     /*  91332 */     GIR_EraseRootFromParent_Done,
     /*  91333 */   // Label 1967: @91333
     /*  91333 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(91409), // Rule ID 14068 //
     /*  91338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  91346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91371 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91374 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91378 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91384 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91391 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13294:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ256rm),
     /*  91394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91396 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91398 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91407 */     GIR_RootConstrainSelectedInstOperands,
     /*  91408 */     // GIR_Coverage, 14068,
     /*  91408 */     GIR_EraseRootFromParent_Done,
     /*  91409 */   // Label 1968: @91409
     /*  91409 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(91485), // Rule ID 14070 //
     /*  91414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  91417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_512),
     /*  91422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  91425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  91428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  91431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91447 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91450 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91454 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91467 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13295:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZrm),
     /*  91470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91472 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91474 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91483 */     GIR_RootConstrainSelectedInstOperands,
     /*  91484 */     // GIR_Coverage, 14070,
     /*  91484 */     GIR_EraseRootFromParent_Done,
     /*  91485 */   // Label 1969: @91485
     /*  91485 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(91561), // Rule ID 14072 //
     /*  91490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  91498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  91501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91523 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91526 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91530 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91536 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91543 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13284:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ128rm),
     /*  91546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91548 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91550 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91559 */     GIR_RootConstrainSelectedInstOperands,
     /*  91560 */     // GIR_Coverage, 14072,
     /*  91560 */     GIR_EraseRootFromParent_Done,
     /*  91561 */   // Label 1970: @91561
     /*  91561 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(91637), // Rule ID 14074 //
     /*  91566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  91574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91599 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91602 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91606 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91612 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91619 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13285:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ256rm),
     /*  91622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91624 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91626 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91635 */     GIR_RootConstrainSelectedInstOperands,
     /*  91636 */     // GIR_Coverage, 14074,
     /*  91636 */     GIR_EraseRootFromParent_Done,
     /*  91637 */   // Label 1971: @91637
     /*  91637 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(91713), // Rule ID 14076 //
     /*  91642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  91645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_512),
     /*  91650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  91653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  91656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  91659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91675 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91678 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91682 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91688 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91695 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13286:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZrm),
     /*  91698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91700 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91702 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91711 */     GIR_RootConstrainSelectedInstOperands,
     /*  91712 */     // GIR_Coverage, 14076,
     /*  91712 */     GIR_EraseRootFromParent_Done,
     /*  91713 */   // Label 1972: @91713
     /*  91713 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(91789), // Rule ID 14078 //
     /*  91718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  91726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  91729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91751 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91754 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91758 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91764 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91771 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13287:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ128rm),
     /*  91774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91776 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91778 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91787 */     GIR_RootConstrainSelectedInstOperands,
     /*  91788 */     // GIR_Coverage, 14078,
     /*  91788 */     GIR_EraseRootFromParent_Done,
     /*  91789 */   // Label 1973: @91789
     /*  91789 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(91865), // Rule ID 14080 //
     /*  91794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  91802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91827 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91830 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91834 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91847 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13288:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ256rm),
     /*  91850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91852 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91854 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91863 */     GIR_RootConstrainSelectedInstOperands,
     /*  91864 */     // GIR_Coverage, 14080,
     /*  91864 */     GIR_EraseRootFromParent_Done,
     /*  91865 */   // Label 1974: @91865
     /*  91865 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(91941), // Rule ID 14082 //
     /*  91870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  91873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_512),
     /*  91878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  91881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  91884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  91887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91903 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91906 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91910 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91923 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13289:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZrm),
     /*  91926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91928 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91930 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91939 */     GIR_RootConstrainSelectedInstOperands,
     /*  91940 */     // GIR_Coverage, 14082,
     /*  91940 */     GIR_EraseRootFromParent_Done,
     /*  91941 */   // Label 1975: @91941
     /*  91941 */   GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(92017), // Rule ID 16793 //
     /*  91946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  91949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4512),
     /*  91954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  91957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  91960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  91963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91979 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91982 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91986 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91992 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91999 */     // (intrinsic_wo_chain:{ *:[v16i32] } 14902:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Zrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Zrm),
     /*  92002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92004 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92006 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92015 */     GIR_RootConstrainSelectedInstOperands,
     /*  92016 */     // GIR_Coverage, 16793,
     /*  92016 */     GIR_EraseRootFromParent_Done,
     /*  92017 */   // Label 1976: @92017
     /*  92017 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(92093), // Rule ID 16799 //
     /*  92022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  92025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4512),
     /*  92030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  92033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  92036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  92039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92055 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92058 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92062 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92068 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92075 */     // (intrinsic_wo_chain:{ *:[v16i32] } 14905:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Zrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Zrm),
     /*  92078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92080 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92082 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92091 */     GIR_RootConstrainSelectedInstOperands,
     /*  92092 */     // GIR_Coverage, 16799,
     /*  92092 */     GIR_EraseRootFromParent_Done,
     /*  92093 */   // Label 1977: @92093
     /*  92093 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(92134), // Rule ID 3366 //
     /*  92098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  92101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /*  92106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92120 */     // MIs[0] src2
     /*  92120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  92123 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13297:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)  =>  (VAESKEYGENASSIST128rr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)
     /*  92123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESKEYGENASSIST128rr),
     /*  92126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92128 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92130 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92132 */     GIR_RootConstrainSelectedInstOperands,
     /*  92133 */     // GIR_Coverage, 3366,
     /*  92133 */     GIR_EraseRootFromParent_Done,
     /*  92134 */   // Label 1978: @92134
     /*  92134 */   GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(92175), // Rule ID 3368 //
     /*  92139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  92142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /*  92147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92161 */     // MIs[0] src2
     /*  92161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  92164 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13297:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)  =>  (AESKEYGENASSIST128rr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)
     /*  92164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESKEYGENASSIST128rr),
     /*  92167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92169 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92171 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92173 */     GIR_RootConstrainSelectedInstOperands,
     /*  92174 */     // GIR_Coverage, 3368,
     /*  92174 */     GIR_EraseRootFromParent_Done,
     /*  92175 */   // Label 1979: @92175
     /*  92175 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(92220), // Rule ID 16788 //
     /*  92180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  92183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  92188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92209 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14900:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VSM4KEY4Z128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  92209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z128rr),
     /*  92212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92214 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92216 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92218 */     GIR_RootConstrainSelectedInstOperands,
     /*  92219 */     // GIR_Coverage, 16788,
     /*  92219 */     GIR_EraseRootFromParent_Done,
     /*  92220 */   // Label 1980: @92220
     /*  92220 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(92265), // Rule ID 16790 //
     /*  92225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  92228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  92233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  92236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  92239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  92242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92254 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14901:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VSM4KEY4Z256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  92254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z256rr),
     /*  92257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92259 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92261 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92263 */     GIR_RootConstrainSelectedInstOperands,
     /*  92264 */     // GIR_Coverage, 16790,
     /*  92264 */     GIR_EraseRootFromParent_Done,
     /*  92265 */   // Label 1981: @92265
     /*  92265 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(92310), // Rule ID 16794 //
     /*  92270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  92273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  92278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92299 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14903:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VSM4RNDS4Z128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  92299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z128rr),
     /*  92302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92304 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92306 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92308 */     GIR_RootConstrainSelectedInstOperands,
     /*  92309 */     // GIR_Coverage, 16794,
     /*  92309 */     GIR_EraseRootFromParent_Done,
     /*  92310 */   // Label 1982: @92310
     /*  92310 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(92355), // Rule ID 16796 //
     /*  92315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  92318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  92323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  92326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  92329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  92332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92344 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14904:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VSM4RNDS4Z256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  92344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z256rr),
     /*  92347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92349 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92351 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92353 */     GIR_RootConstrainSelectedInstOperands,
     /*  92354 */     // GIR_Coverage, 16796,
     /*  92354 */     GIR_EraseRootFromParent_Done,
     /*  92355 */   // Label 1983: @92355
     /*  92355 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(92400), // Rule ID 3021 //
     /*  92360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  92363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /*  92368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  92371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  92377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92389 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14769:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSIGNBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  92389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBrr),
     /*  92392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92394 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92396 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92398 */     GIR_RootConstrainSelectedInstOperands,
     /*  92399 */     // GIR_Coverage, 3021,
     /*  92399 */     GIR_EraseRootFromParent_Done,
     /*  92400 */   // Label 1984: @92400
     /*  92400 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(92445), // Rule ID 3023 //
     /*  92405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  92408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /*  92413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  92416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  92419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  92422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92434 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14773:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSIGNWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  92434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWrr),
     /*  92437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92439 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92441 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92443 */     GIR_RootConstrainSelectedInstOperands,
     /*  92444 */     // GIR_Coverage, 3023,
     /*  92444 */     GIR_EraseRootFromParent_Done,
     /*  92445 */   // Label 1985: @92445
     /*  92445 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(92490), // Rule ID 3025 //
     /*  92450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  92453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /*  92458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92479 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14771:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPSIGNDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  92479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDrr),
     /*  92482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92484 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92486 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92488 */     GIR_RootConstrainSelectedInstOperands,
     /*  92489 */     // GIR_Coverage, 3025,
     /*  92489 */     GIR_EraseRootFromParent_Done,
     /*  92490 */   // Label 1986: @92490
     /*  92490 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(92535), // Rule ID 3027 //
     /*  92495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  92498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /*  92503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  92506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  92509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  92512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92524 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14753:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPHADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  92524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWrr),
     /*  92527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92529 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92531 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92533 */     GIR_RootConstrainSelectedInstOperands,
     /*  92534 */     // GIR_Coverage, 3027,
     /*  92534 */     GIR_EraseRootFromParent_Done,
     /*  92535 */   // Label 1987: @92535
     /*  92535 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(92580), // Rule ID 3029 //
     /*  92540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  92543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /*  92548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  92551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  92554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  92557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92569 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14759:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPHSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  92569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWrr),
     /*  92572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92574 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92576 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92578 */     GIR_RootConstrainSelectedInstOperands,
     /*  92579 */     // GIR_Coverage, 3029,
     /*  92579 */     GIR_EraseRootFromParent_Done,
     /*  92580 */   // Label 1988: @92580
     /*  92580 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(92625), // Rule ID 3045 //
     /*  92585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  92588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_b),
     /*  92593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /*  92596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  92599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /*  92602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  92606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  92610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  92614 */     // (intrinsic_wo_chain:{ *:[v32i8] } 13660:{ *:[iPTR] }, VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSIGNBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  92614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBYrr),
     /*  92617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92619 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92621 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92623 */     GIR_RootConstrainSelectedInstOperands,
     /*  92624 */     // GIR_Coverage, 3045,
     /*  92624 */     GIR_EraseRootFromParent_Done,
     /*  92625 */   // Label 1989: @92625
     /*  92625 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(92670), // Rule ID 3047 //
     /*  92630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  92633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_w),
     /*  92638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  92641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  92644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  92647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  92651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  92655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  92659 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13662:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSIGNWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  92659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWYrr),
     /*  92662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92664 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92666 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92668 */     GIR_RootConstrainSelectedInstOperands,
     /*  92669 */     // GIR_Coverage, 3047,
     /*  92669 */     GIR_EraseRootFromParent_Done,
     /*  92670 */   // Label 1990: @92670
     /*  92670 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(92715), // Rule ID 3049 //
     /*  92675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  92678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_d),
     /*  92683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  92686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  92689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  92692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  92696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  92700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  92704 */     // (intrinsic_wo_chain:{ *:[v8i32] } 13661:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPSIGNDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  92704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDYrr),
     /*  92707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92709 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92711 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92713 */     GIR_RootConstrainSelectedInstOperands,
     /*  92714 */     // GIR_Coverage, 3049,
     /*  92714 */     GIR_EraseRootFromParent_Done,
     /*  92715 */   // Label 1991: @92715
     /*  92715 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(92760), // Rule ID 3051 //
     /*  92720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  92723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phadd_sw),
     /*  92728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  92731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  92734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  92737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  92741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  92745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  92749 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13647:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPHADDSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  92749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWYrr),
     /*  92752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92754 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92756 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92758 */     GIR_RootConstrainSelectedInstOperands,
     /*  92759 */     // GIR_Coverage, 3051,
     /*  92759 */     GIR_EraseRootFromParent_Done,
     /*  92760 */   // Label 1992: @92760
     /*  92760 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(92805), // Rule ID 3053 //
     /*  92765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  92768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phsub_sw),
     /*  92773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  92776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  92779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  92782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  92786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  92790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  92794 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13650:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPHSUBSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  92794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWYrr),
     /*  92797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92799 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92801 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92803 */     GIR_RootConstrainSelectedInstOperands,
     /*  92804 */     // GIR_Coverage, 3053,
     /*  92804 */     GIR_EraseRootFromParent_Done,
     /*  92805 */   // Label 1993: @92805
     /*  92805 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(92850), // Rule ID 3063 //
     /*  92810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  92813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /*  92818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  92821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  92827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92839 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14769:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSIGNBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  92839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNBrr),
     /*  92842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92844 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92846 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92848 */     GIR_RootConstrainSelectedInstOperands,
     /*  92849 */     // GIR_Coverage, 3063,
     /*  92849 */     GIR_EraseRootFromParent_Done,
     /*  92850 */   // Label 1994: @92850
     /*  92850 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(92895), // Rule ID 3065 //
     /*  92855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  92858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /*  92863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  92866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  92869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  92872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92884 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14773:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSIGNWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  92884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNWrr),
     /*  92887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92889 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92891 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92893 */     GIR_RootConstrainSelectedInstOperands,
     /*  92894 */     // GIR_Coverage, 3065,
     /*  92894 */     GIR_EraseRootFromParent_Done,
     /*  92895 */   // Label 1995: @92895
     /*  92895 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(92940), // Rule ID 3067 //
     /*  92900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  92903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /*  92908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92929 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14771:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PSIGNDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  92929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNDrr),
     /*  92932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92934 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92936 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92938 */     GIR_RootConstrainSelectedInstOperands,
     /*  92939 */     // GIR_Coverage, 3067,
     /*  92939 */     GIR_EraseRootFromParent_Done,
     /*  92940 */   // Label 1996: @92940
     /*  92940 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(92985), // Rule ID 3071 //
     /*  92945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  92948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /*  92953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  92956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  92959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  92962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92974 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14753:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PHADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  92974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PHADDSWrr),
     /*  92977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92979 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92981 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92983 */     GIR_RootConstrainSelectedInstOperands,
     /*  92984 */     // GIR_Coverage, 3071,
     /*  92984 */     GIR_EraseRootFromParent_Done,
     /*  92985 */   // Label 1997: @92985
     /*  92985 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(93030), // Rule ID 3073 //
     /*  92990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  92993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /*  92998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93019 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14759:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PHSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PHSUBSWrr),
     /*  93022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93024 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93026 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93028 */     GIR_RootConstrainSelectedInstOperands,
     /*  93029 */     // GIR_Coverage, 3073,
     /*  93029 */     GIR_EraseRootFromParent_Done,
     /*  93030 */   // Label 1998: @93030
     /*  93030 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(93075), // Rule ID 3308 //
     /*  93035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  93043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  93052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  93064 */     // (intrinsic_wo_chain:{ *:[i32] } 14727:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (CRC32r32r8:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  93064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r8),
     /*  93067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93069 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93071 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93073 */     GIR_RootConstrainSelectedInstOperands,
     /*  93074 */     // GIR_Coverage, 3308,
     /*  93074 */     GIR_EraseRootFromParent_Done,
     /*  93075 */   // Label 1999: @93075
     /*  93075 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(93120), // Rule ID 3310 //
     /*  93080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  93088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  93097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  93109 */     // (intrinsic_wo_chain:{ *:[i32] } 14725:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (CRC32r32r16:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  93109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r16),
     /*  93112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93114 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93116 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93118 */     GIR_RootConstrainSelectedInstOperands,
     /*  93119 */     // GIR_Coverage, 3310,
     /*  93119 */     GIR_EraseRootFromParent_Done,
     /*  93120 */   // Label 2000: @93120
     /*  93120 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(93165), // Rule ID 3312 //
     /*  93125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  93133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93154 */     // (intrinsic_wo_chain:{ *:[i32] } 14726:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (CRC32r32r32:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  93154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r32),
     /*  93157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93159 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93161 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93163 */     GIR_RootConstrainSelectedInstOperands,
     /*  93164 */     // GIR_Coverage, 3312,
     /*  93164 */     GIR_EraseRootFromParent_Done,
     /*  93165 */   // Label 2001: @93165
     /*  93165 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(93210), // Rule ID 3314 //
     /*  93170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  93178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  93181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  93184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  93187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93199 */     // (intrinsic_wo_chain:{ *:[i64] } 14728:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (CRC32r64r64:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  93199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64r64),
     /*  93202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93204 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93206 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93208 */     GIR_RootConstrainSelectedInstOperands,
     /*  93209 */     // GIR_Coverage, 3314,
     /*  93209 */     GIR_EraseRootFromParent_Done,
     /*  93210 */   // Label 2002: @93210
     /*  93210 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(93255), // Rule ID 3316 //
     /*  93215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  93218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  93223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  93232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  93244 */     // (intrinsic_wo_chain:{ *:[i32] } 14727:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (CRC32r32r8_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  93244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r8_EVEX),
     /*  93247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93249 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93251 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93253 */     GIR_RootConstrainSelectedInstOperands,
     /*  93254 */     // GIR_Coverage, 3316,
     /*  93254 */     GIR_EraseRootFromParent_Done,
     /*  93255 */   // Label 2003: @93255
     /*  93255 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(93300), // Rule ID 3318 //
     /*  93260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  93263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  93268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  93277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  93289 */     // (intrinsic_wo_chain:{ *:[i32] } 14725:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (CRC32r32r16_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  93289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r16_EVEX),
     /*  93292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93294 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93296 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93298 */     GIR_RootConstrainSelectedInstOperands,
     /*  93299 */     // GIR_Coverage, 3318,
     /*  93299 */     GIR_EraseRootFromParent_Done,
     /*  93300 */   // Label 2004: @93300
     /*  93300 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(93345), // Rule ID 3320 //
     /*  93305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  93308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  93313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93334 */     // (intrinsic_wo_chain:{ *:[i32] } 14726:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (CRC32r32r32_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  93334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r32_EVEX),
     /*  93337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93339 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93341 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93343 */     GIR_RootConstrainSelectedInstOperands,
     /*  93344 */     // GIR_Coverage, 3320,
     /*  93344 */     GIR_EraseRootFromParent_Done,
     /*  93345 */   // Label 2005: @93345
     /*  93345 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(93390), // Rule ID 3322 //
     /*  93350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  93353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  93358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  93361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  93364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  93367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93379 */     // (intrinsic_wo_chain:{ *:[i64] } 14728:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (CRC32r64r64_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  93379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64r64_EVEX),
     /*  93382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93384 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93386 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93388 */     GIR_RootConstrainSelectedInstOperands,
     /*  93389 */     // GIR_Coverage, 3322,
     /*  93389 */     GIR_EraseRootFromParent_Done,
     /*  93390 */   // Label 2006: @93390
     /*  93390 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(93435), // Rule ID 3326 //
     /*  93395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  93398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1nexte),
     /*  93403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93424 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14597:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1NEXTErr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  93424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1NEXTErr),
     /*  93427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93429 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93431 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93433 */     GIR_RootConstrainSelectedInstOperands,
     /*  93434 */     // GIR_Coverage, 3326,
     /*  93434 */     GIR_EraseRootFromParent_Done,
     /*  93435 */   // Label 2007: @93435
     /*  93435 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(93480), // Rule ID 3328 //
     /*  93440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  93443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1msg1),
     /*  93448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93469 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14595:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  93469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1MSG1rr),
     /*  93472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93474 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93476 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93478 */     GIR_RootConstrainSelectedInstOperands,
     /*  93479 */     // GIR_Coverage, 3328,
     /*  93479 */     GIR_EraseRootFromParent_Done,
     /*  93480 */   // Label 2008: @93480
     /*  93480 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(93525), // Rule ID 3330 //
     /*  93485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  93488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1msg2),
     /*  93493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93514 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14596:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  93514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1MSG2rr),
     /*  93517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93519 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93521 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93523 */     GIR_RootConstrainSelectedInstOperands,
     /*  93524 */     // GIR_Coverage, 3330,
     /*  93524 */     GIR_EraseRootFromParent_Done,
     /*  93525 */   // Label 2009: @93525
     /*  93525 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(93570), // Rule ID 3334 //
     /*  93530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  93533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256msg1),
     /*  93538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93559 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14599:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA256MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  93559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256MSG1rr),
     /*  93562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93564 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93566 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93568 */     GIR_RootConstrainSelectedInstOperands,
     /*  93569 */     // GIR_Coverage, 3334,
     /*  93569 */     GIR_EraseRootFromParent_Done,
     /*  93570 */   // Label 2010: @93570
     /*  93570 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(93615), // Rule ID 3336 //
     /*  93575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  93578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256msg2),
     /*  93583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93604 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14600:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA256MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  93604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256MSG2rr),
     /*  93607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93609 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93611 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93613 */     GIR_RootConstrainSelectedInstOperands,
     /*  93614 */     // GIR_Coverage, 3336,
     /*  93614 */     GIR_EraseRootFromParent_Done,
     /*  93615 */   // Label 2011: @93615
     /*  93615 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(93660), // Rule ID 3338 //
     /*  93620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  93623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  93628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  93631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  93634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  93637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93649 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13290:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESENCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  93649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCrr),
     /*  93652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93654 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93656 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93658 */     GIR_RootConstrainSelectedInstOperands,
     /*  93659 */     // GIR_Coverage, 3338,
     /*  93659 */     GIR_EraseRootFromParent_Done,
     /*  93660 */   // Label 2012: @93660
     /*  93660 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(93705), // Rule ID 3340 //
     /*  93665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  93668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  93673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  93676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  93679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  93682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93694 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13293:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESENCLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  93694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTrr),
     /*  93697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93699 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93701 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93703 */     GIR_RootConstrainSelectedInstOperands,
     /*  93704 */     // GIR_Coverage, 3340,
     /*  93704 */     GIR_EraseRootFromParent_Done,
     /*  93705 */   // Label 2013: @93705
     /*  93705 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(93750), // Rule ID 3342 //
     /*  93710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  93713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  93718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  93721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  93724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  93727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93739 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13284:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESDECrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  93739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECrr),
     /*  93742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93744 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93746 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93748 */     GIR_RootConstrainSelectedInstOperands,
     /*  93749 */     // GIR_Coverage, 3342,
     /*  93749 */     GIR_EraseRootFromParent_Done,
     /*  93750 */   // Label 2014: @93750
     /*  93750 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(93795), // Rule ID 3344 //
     /*  93755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  93758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  93763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  93766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  93769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  93772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93784 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13287:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESDECLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  93784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTrr),
     /*  93787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93789 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93791 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93793 */     GIR_RootConstrainSelectedInstOperands,
     /*  93794 */     // GIR_Coverage, 3344,
     /*  93794 */     GIR_EraseRootFromParent_Done,
     /*  93795 */   // Label 2015: @93795
     /*  93795 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(93840), // Rule ID 3346 //
     /*  93800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  93803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  93808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  93811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  93814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  93817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93829 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13291:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESENCYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  93829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCYrr),
     /*  93832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93834 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93836 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93838 */     GIR_RootConstrainSelectedInstOperands,
     /*  93839 */     // GIR_Coverage, 3346,
     /*  93839 */     GIR_EraseRootFromParent_Done,
     /*  93840 */   // Label 2016: @93840
     /*  93840 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(93885), // Rule ID 3348 //
     /*  93845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  93848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  93853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  93856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  93859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  93862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93874 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13294:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESENCLASTYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  93874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTYrr),
     /*  93877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93879 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93881 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93883 */     GIR_RootConstrainSelectedInstOperands,
     /*  93884 */     // GIR_Coverage, 3348,
     /*  93884 */     GIR_EraseRootFromParent_Done,
     /*  93885 */   // Label 2017: @93885
     /*  93885 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(93930), // Rule ID 3350 //
     /*  93890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  93893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  93898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  93901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  93904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  93907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93919 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13285:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESDECYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  93919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECYrr),
     /*  93922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93924 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93926 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93928 */     GIR_RootConstrainSelectedInstOperands,
     /*  93929 */     // GIR_Coverage, 3350,
     /*  93929 */     GIR_EraseRootFromParent_Done,
     /*  93930 */   // Label 2018: @93930
     /*  93930 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(93975), // Rule ID 3352 //
     /*  93935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  93938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  93943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  93946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  93949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  93952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93964 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13288:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESDECLASTYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  93964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTYrr),
     /*  93967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93969 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93971 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93973 */     GIR_RootConstrainSelectedInstOperands,
     /*  93974 */     // GIR_Coverage, 3352,
     /*  93974 */     GIR_EraseRootFromParent_Done,
     /*  93975 */   // Label 2019: @93975
     /*  93975 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(94020), // Rule ID 3354 //
     /*  93980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  93983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  93988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  93991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  93994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  93997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94009 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13290:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESENCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESENCrr),
     /*  94012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94014 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94016 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94018 */     GIR_RootConstrainSelectedInstOperands,
     /*  94019 */     // GIR_Coverage, 3354,
     /*  94019 */     GIR_EraseRootFromParent_Done,
     /*  94020 */   // Label 2020: @94020
     /*  94020 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(94065), // Rule ID 3356 //
     /*  94025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  94033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94054 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13293:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESENCLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESENCLASTrr),
     /*  94057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94059 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94061 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94063 */     GIR_RootConstrainSelectedInstOperands,
     /*  94064 */     // GIR_Coverage, 3356,
     /*  94064 */     GIR_EraseRootFromParent_Done,
     /*  94065 */   // Label 2021: @94065
     /*  94065 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(94110), // Rule ID 3358 //
     /*  94070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  94078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94099 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13284:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESDECrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESDECrr),
     /*  94102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94104 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94106 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94108 */     GIR_RootConstrainSelectedInstOperands,
     /*  94109 */     // GIR_Coverage, 3358,
     /*  94109 */     GIR_EraseRootFromParent_Done,
     /*  94110 */   // Label 2022: @94110
     /*  94110 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(94155), // Rule ID 3360 //
     /*  94115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  94123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94144 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13287:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESDECLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESDECLASTrr),
     /*  94147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94149 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94151 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94153 */     GIR_RootConstrainSelectedInstOperands,
     /*  94154 */     // GIR_Coverage, 3360,
     /*  94154 */     GIR_EraseRootFromParent_Done,
     /*  94155 */   // Label 2023: @94155
     /*  94155 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(94200), // Rule ID 3377 //
     /*  94160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE4A),
     /*  94163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse4a_extrq),
     /*  94168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  94177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94189 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14743:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src, VR128:{ *:[v16i8] }:$mask)  =>  (EXTRQ:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src, VR128:{ *:[v16i8] }:$mask)
     /*  94189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::EXTRQ),
     /*  94192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94194 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  94196 */     GIR_RootToRootCopy, /*OpIdx*/3, // mask
     /*  94198 */     GIR_RootConstrainSelectedInstOperands,
     /*  94199 */     // GIR_Coverage, 3377,
     /*  94199 */     GIR_EraseRootFromParent_Done,
     /*  94200 */   // Label 2024: @94200
     /*  94200 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(94245), // Rule ID 3379 //
     /*  94205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE4A),
     /*  94208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse4a_insertq),
     /*  94213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94234 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14745:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src, VR128:{ *:[v2i64] }:$mask)  =>  (INSERTQ:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src, VR128:{ *:[v2i64] }:$mask)
     /*  94234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INSERTQ),
     /*  94237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94239 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  94241 */     GIR_RootToRootCopy, /*OpIdx*/3, // mask
     /*  94243 */     GIR_RootConstrainSelectedInstOperands,
     /*  94244 */     // GIR_Coverage, 3379,
     /*  94244 */     GIR_EraseRootFromParent_Done,
     /*  94245 */   // Label 2025: @94245
     /*  94245 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(94290), // Rule ID 3554 //
     /*  94250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /*  94253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512msg1),
     /*  94258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94279 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14894:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VSHA512MSG1rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512MSG1rr),
     /*  94282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94284 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94286 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94288 */     GIR_RootConstrainSelectedInstOperands,
     /*  94289 */     // GIR_Coverage, 3554,
     /*  94289 */     GIR_EraseRootFromParent_Done,
     /*  94290 */   // Label 2026: @94290
     /*  94290 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(94335), // Rule ID 3555 //
     /*  94295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /*  94298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512msg2),
     /*  94303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94324 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14895:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VSHA512MSG2rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512MSG2rr),
     /*  94327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94329 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94331 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94333 */     GIR_RootConstrainSelectedInstOperands,
     /*  94334 */     // GIR_Coverage, 3555,
     /*  94334 */     GIR_EraseRootFromParent_Done,
     /*  94335 */   // Label 2027: @94335
     /*  94335 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(94380), // Rule ID 3563 //
     /*  94340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  94343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  94348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94369 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14900:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VSM4KEY4rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4rr),
     /*  94372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94374 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94376 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94378 */     GIR_RootConstrainSelectedInstOperands,
     /*  94379 */     // GIR_Coverage, 3563,
     /*  94379 */     GIR_EraseRootFromParent_Done,
     /*  94380 */   // Label 2028: @94380
     /*  94380 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(94425), // Rule ID 3565 //
     /*  94385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  94388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  94393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  94396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  94399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  94402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94414 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14901:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VSM4KEY4Yrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  94414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Yrr),
     /*  94417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94419 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94421 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94423 */     GIR_RootConstrainSelectedInstOperands,
     /*  94424 */     // GIR_Coverage, 3565,
     /*  94424 */     GIR_EraseRootFromParent_Done,
     /*  94425 */   // Label 2029: @94425
     /*  94425 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(94470), // Rule ID 3567 //
     /*  94430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  94433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  94438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94459 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14903:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VSM4RNDS4rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4rr),
     /*  94462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94464 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94466 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94468 */     GIR_RootConstrainSelectedInstOperands,
     /*  94469 */     // GIR_Coverage, 3567,
     /*  94469 */     GIR_EraseRootFromParent_Done,
     /*  94470 */   // Label 2030: @94470
     /*  94470 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(94515), // Rule ID 3569 //
     /*  94475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  94478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  94483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  94486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  94489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  94492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94504 */     // (intrinsic_wo_chain:{ *:[v8i32] } 14904:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VSM4RNDS4Yrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  94504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Yrr),
     /*  94507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94509 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94511 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94513 */     GIR_RootConstrainSelectedInstOperands,
     /*  94514 */     // GIR_Coverage, 3569,
     /*  94514 */     GIR_EraseRootFromParent_Done,
     /*  94515 */   // Label 2031: @94515
     /*  94515 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(94560), // Rule ID 14059 //
     /*  94520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  94523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  94528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  94541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  94545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  94549 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13290:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESENCZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  94549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ128rr),
     /*  94552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94554 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94556 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94558 */     GIR_RootConstrainSelectedInstOperands,
     /*  94559 */     // GIR_Coverage, 14059,
     /*  94559 */     GIR_EraseRootFromParent_Done,
     /*  94560 */   // Label 2032: @94560
     /*  94560 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(94605), // Rule ID 14061 //
     /*  94565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  94568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  94573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  94586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  94590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  94594 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13291:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESENCZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  94594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ256rr),
     /*  94597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94599 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94601 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94603 */     GIR_RootConstrainSelectedInstOperands,
     /*  94604 */     // GIR_Coverage, 14061,
     /*  94604 */     GIR_EraseRootFromParent_Done,
     /*  94605 */   // Label 2033: @94605
     /*  94605 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(94650), // Rule ID 14063 //
     /*  94610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  94613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_512),
     /*  94618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  94621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  94624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  94627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  94631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  94635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  94639 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13292:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESENCZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  94639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZrr),
     /*  94642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94644 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94646 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94648 */     GIR_RootConstrainSelectedInstOperands,
     /*  94649 */     // GIR_Coverage, 14063,
     /*  94649 */     GIR_EraseRootFromParent_Done,
     /*  94650 */   // Label 2034: @94650
     /*  94650 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(94695), // Rule ID 14065 //
     /*  94655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  94658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  94663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  94676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  94680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  94684 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13293:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESENCLASTZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  94684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ128rr),
     /*  94687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94689 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94691 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94693 */     GIR_RootConstrainSelectedInstOperands,
     /*  94694 */     // GIR_Coverage, 14065,
     /*  94694 */     GIR_EraseRootFromParent_Done,
     /*  94695 */   // Label 2035: @94695
     /*  94695 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(94740), // Rule ID 14067 //
     /*  94700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  94703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  94708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  94721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  94725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  94729 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13294:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESENCLASTZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  94729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ256rr),
     /*  94732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94734 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94736 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94738 */     GIR_RootConstrainSelectedInstOperands,
     /*  94739 */     // GIR_Coverage, 14067,
     /*  94739 */     GIR_EraseRootFromParent_Done,
     /*  94740 */   // Label 2036: @94740
     /*  94740 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(94785), // Rule ID 14069 //
     /*  94745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  94748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_512),
     /*  94753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  94756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  94759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  94762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  94766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  94770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  94774 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13295:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESENCLASTZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  94774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZrr),
     /*  94777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94779 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94781 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94783 */     GIR_RootConstrainSelectedInstOperands,
     /*  94784 */     // GIR_Coverage, 14069,
     /*  94784 */     GIR_EraseRootFromParent_Done,
     /*  94785 */   // Label 2037: @94785
     /*  94785 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(94830), // Rule ID 14071 //
     /*  94790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  94793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  94798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  94811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  94815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  94819 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13284:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESDECZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  94819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ128rr),
     /*  94822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94824 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94826 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94828 */     GIR_RootConstrainSelectedInstOperands,
     /*  94829 */     // GIR_Coverage, 14071,
     /*  94829 */     GIR_EraseRootFromParent_Done,
     /*  94830 */   // Label 2038: @94830
     /*  94830 */   GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(94875), // Rule ID 14073 //
     /*  94835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  94838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  94843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  94856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  94860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  94864 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13285:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESDECZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  94864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ256rr),
     /*  94867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94869 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94871 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94873 */     GIR_RootConstrainSelectedInstOperands,
     /*  94874 */     // GIR_Coverage, 14073,
     /*  94874 */     GIR_EraseRootFromParent_Done,
     /*  94875 */   // Label 2039: @94875
     /*  94875 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(94920), // Rule ID 14075 //
     /*  94880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  94883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_512),
     /*  94888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  94891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  94894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  94897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  94901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  94905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  94909 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13286:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESDECZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  94909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZrr),
     /*  94912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94914 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94916 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94918 */     GIR_RootConstrainSelectedInstOperands,
     /*  94919 */     // GIR_Coverage, 14075,
     /*  94919 */     GIR_EraseRootFromParent_Done,
     /*  94920 */   // Label 2040: @94920
     /*  94920 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(94965), // Rule ID 14077 //
     /*  94925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  94928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  94933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  94946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  94950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  94954 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13287:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESDECLASTZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  94954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ128rr),
     /*  94957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94959 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94961 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94963 */     GIR_RootConstrainSelectedInstOperands,
     /*  94964 */     // GIR_Coverage, 14077,
     /*  94964 */     GIR_EraseRootFromParent_Done,
     /*  94965 */   // Label 2041: @94965
     /*  94965 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(95010), // Rule ID 14079 //
     /*  94970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  94973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  94978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  94991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  94995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  94999 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13288:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESDECLASTZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  94999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ256rr),
     /*  95002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95004 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95006 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95008 */     GIR_RootConstrainSelectedInstOperands,
     /*  95009 */     // GIR_Coverage, 14079,
     /*  95009 */     GIR_EraseRootFromParent_Done,
     /*  95010 */   // Label 2042: @95010
     /*  95010 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(95055), // Rule ID 14081 //
     /*  95015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_512),
     /*  95023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95044 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13289:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESDECLASTZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZrr),
     /*  95047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95049 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95051 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95053 */     GIR_RootConstrainSelectedInstOperands,
     /*  95054 */     // GIR_Coverage, 14081,
     /*  95054 */     GIR_EraseRootFromParent_Done,
     /*  95055 */   // Label 2043: @95055
     /*  95055 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(95100), // Rule ID 16792 //
     /*  95060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  95063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4512),
     /*  95068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  95071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  95074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  95077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95089 */     // (intrinsic_wo_chain:{ *:[v16i32] } 14902:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VSM4KEY4Zrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  95089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Zrr),
     /*  95092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95094 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95096 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95098 */     GIR_RootConstrainSelectedInstOperands,
     /*  95099 */     // GIR_Coverage, 16792,
     /*  95099 */     GIR_EraseRootFromParent_Done,
     /*  95100 */   // Label 2044: @95100
     /*  95100 */   GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(95145), // Rule ID 16798 //
     /*  95105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  95108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4512),
     /*  95113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  95116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  95119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  95122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95134 */     // (intrinsic_wo_chain:{ *:[v16i32] } 14905:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VSM4RNDS4Zrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  95134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Zrr),
     /*  95137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95139 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95141 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95143 */     GIR_RootConstrainSelectedInstOperands,
     /*  95144 */     // GIR_Coverage, 16798,
     /*  95144 */     GIR_EraseRootFromParent_Done,
     /*  95145 */   // Label 2045: @95145
     /*  95145 */   GIM_Reject,
     /*  95146 */ // Label 1928: @95146
     /*  95146 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(99732),
     /*  95151 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  95154 */   GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(95235), // Rule ID 23531 //
     /*  95159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  95167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  95170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95188 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95191 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95195 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95203 */     // MIs[0] src3
     /*  95203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95215 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14712:{ *:[iPTR] }, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, (timm:{ *:[i8] }):$src3)  =>  (VDPPSrmi:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSrmi),
     /*  95218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95220 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  95222 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95226 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95233 */     GIR_RootConstrainSelectedInstOperands,
     /*  95234 */     // GIR_Coverage, 23531,
     /*  95234 */     GIR_EraseRootFromParent_Done,
     /*  95235 */   // Label 2047: @95235
     /*  95235 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(95316), // Rule ID 23532 //
     /*  95240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  95248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95269 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95272 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95276 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95284 */     // MIs[0] src3
     /*  95284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95296 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14711:{ *:[iPTR] }, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, (timm:{ *:[i8] }):$src3)  =>  (VDPPDrmi:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPDrmi),
     /*  95299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95301 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  95303 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95307 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95314 */     GIR_RootConstrainSelectedInstOperands,
     /*  95315 */     // GIR_Coverage, 23532,
     /*  95315 */     GIR_EraseRootFromParent_Done,
     /*  95316 */   // Label 2048: @95316
     /*  95316 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(95397), // Rule ID 23533 //
     /*  95321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_dp_ps_256),
     /*  95329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  95332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  95335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  95338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95350 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95353 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95357 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95365 */     // MIs[0] src3
     /*  95365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95377 */     // (intrinsic_wo_chain:{ *:[v8f32] } 13322:{ *:[iPTR] }, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, (timm:{ *:[i8] }):$src3)  =>  (VDPPSYrmi:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSYrmi),
     /*  95380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95382 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  95384 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95388 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95395 */     GIR_RootConstrainSelectedInstOperands,
     /*  95396 */     // GIR_Coverage, 23533,
     /*  95396 */     GIR_EraseRootFromParent_Done,
     /*  95397 */   // Label 2049: @95397
     /*  95397 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(95478), // Rule ID 3253 //
     /*  95402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  95410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  95413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  95431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95435 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95438 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95442 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95446 */     // MIs[0] src3
     /*  95446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95451 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95458 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14712:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VDPPSrmi:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSrmi),
     /*  95461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95463 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95465 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95469 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95476 */     GIR_RootConstrainSelectedInstOperands,
     /*  95477 */     // GIR_Coverage, 3253,
     /*  95477 */     GIR_EraseRootFromParent_Done,
     /*  95478 */   // Label 2050: @95478
     /*  95478 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(95559), // Rule ID 3255 //
     /*  95483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  95491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  95512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95516 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95519 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95523 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95527 */     // MIs[0] src3
     /*  95527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95539 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14711:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VDPPDrmi:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPDrmi),
     /*  95542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95544 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95546 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95550 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95557 */     GIR_RootConstrainSelectedInstOperands,
     /*  95558 */     // GIR_Coverage, 3255,
     /*  95558 */     GIR_EraseRootFromParent_Done,
     /*  95559 */   // Label 2051: @95559
     /*  95559 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(95640), // Rule ID 3257 //
     /*  95564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_dp_ps_256),
     /*  95572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  95575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  95578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  95581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  95593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95597 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95600 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95604 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95608 */     // MIs[0] src3
     /*  95608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95620 */     // (intrinsic_wo_chain:{ *:[v8f32] } 13322:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VDPPSYrmi:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSYrmi),
     /*  95623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95625 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95627 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95631 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95638 */     GIR_RootConstrainSelectedInstOperands,
     /*  95639 */     // GIR_Coverage, 3257,
     /*  95639 */     GIR_EraseRootFromParent_Done,
     /*  95640 */   // Label 2052: @95640
     /*  95640 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(95721), // Rule ID 3373 //
     /*  95645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ),
     /*  95648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  95653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  95674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95678 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95681 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95685 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95689 */     // MIs[0] src3
     /*  95689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95701 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14563:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQrmi:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQrmi),
     /*  95704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95706 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95708 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95712 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95719 */     GIR_RootConstrainSelectedInstOperands,
     /*  95720 */     // GIR_Coverage, 3373,
     /*  95720 */     GIR_EraseRootFromParent_Done,
     /*  95721 */   // Label 2053: @95721
     /*  95721 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(95802), // Rule ID 3375 //
     /*  95726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPCLMULQDQ_NoVLX),
     /*  95729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  95734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  95755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95759 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95762 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95766 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95770 */     // MIs[0] src3
     /*  95770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95782 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14564:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQYrmi:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQYrmi),
     /*  95785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95787 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95789 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95793 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95800 */     GIR_RootConstrainSelectedInstOperands,
     /*  95801 */     // GIR_Coverage, 3375,
     /*  95801 */     GIR_EraseRootFromParent_Done,
     /*  95802 */   // Label 2054: @95802
     /*  95802 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(95883), // Rule ID 14084 //
     /*  95807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVPCLMULQDQ),
     /*  95810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_512),
     /*  95815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  95836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95840 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95843 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95847 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95851 */     // MIs[0] src3
     /*  95851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95856 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95863 */     // (intrinsic_wo_chain:{ *:[v8i64] } 14565:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZrmi:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZrmi),
     /*  95866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95868 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95870 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95874 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95881 */     GIR_RootConstrainSelectedInstOperands,
     /*  95882 */     // GIR_Coverage, 14084,
     /*  95882 */     GIR_EraseRootFromParent_Done,
     /*  95883 */   // Label 2055: @95883
     /*  95883 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(95964), // Rule ID 14086 //
     /*  95888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  95891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  95896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  95917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95921 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95924 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95928 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95932 */     // MIs[0] src3
     /*  95932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95944 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14563:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ128rmi:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ128rmi),
     /*  95947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95949 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95951 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95955 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95962 */     GIR_RootConstrainSelectedInstOperands,
     /*  95963 */     // GIR_Coverage, 14086,
     /*  95963 */     GIR_EraseRootFromParent_Done,
     /*  95964 */   // Label 2056: @95964
     /*  95964 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(96045), // Rule ID 14088 //
     /*  95969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  95972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  95977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  95998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96002 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96005 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96009 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96013 */     // MIs[0] src3
     /*  96013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96018 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96025 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14564:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ256rmi:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ256rmi),
     /*  96028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96030 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96032 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96036 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96043 */     GIR_RootConstrainSelectedInstOperands,
     /*  96044 */     // GIR_Coverage, 14088,
     /*  96044 */     GIR_EraseRootFromParent_Done,
     /*  96045 */   // Label 2057: @96045
     /*  96045 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(96130), // Rule ID 23333 //
     /*  96050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcswd),
     /*  96058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  96070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96082 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96085 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96089 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96110 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14957:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  96110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSWDrm),
     /*  96113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96115 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96117 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96121 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96128 */     GIR_RootConstrainSelectedInstOperands,
     /*  96129 */     // GIR_Coverage, 23333,
     /*  96129 */     GIR_EraseRootFromParent_Done,
     /*  96130 */   // Label 2058: @96130
     /*  96130 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(96215), // Rule ID 23334 //
     /*  96135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcsswd),
     /*  96143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  96155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96167 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96170 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96174 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96188 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96195 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14956:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  96195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSSWDrm),
     /*  96198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96200 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96202 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96206 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96213 */     GIR_RootConstrainSelectedInstOperands,
     /*  96214 */     // GIR_Coverage, 23334,
     /*  96214 */     GIR_EraseRootFromParent_Done,
     /*  96215 */   // Label 2059: @96215
     /*  96215 */   GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(96300), // Rule ID 23335 //
     /*  96220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsww),
     /*  96228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  96240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96252 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96255 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96259 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96273 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96280 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14955:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  96280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrm),
     /*  96283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96285 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96287 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96291 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96298 */     GIR_RootConstrainSelectedInstOperands,
     /*  96299 */     // GIR_Coverage, 23335,
     /*  96299 */     GIR_EraseRootFromParent_Done,
     /*  96300 */   // Label 2060: @96300
     /*  96300 */   GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(96385), // Rule ID 23336 //
     /*  96305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacswd),
     /*  96313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  96325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96337 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96340 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96344 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96358 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96365 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14954:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  96365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWDrm),
     /*  96368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96370 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96372 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96376 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96383 */     GIR_RootConstrainSelectedInstOperands,
     /*  96384 */     // GIR_Coverage, 23336,
     /*  96384 */     GIR_EraseRootFromParent_Done,
     /*  96385 */   // Label 2061: @96385
     /*  96385 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(96470), // Rule ID 23337 //
     /*  96390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssww),
     /*  96398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  96410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96422 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96425 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96429 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96443 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96450 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14953:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  96450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWWrm),
     /*  96453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96455 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96457 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96461 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96468 */     GIR_RootConstrainSelectedInstOperands,
     /*  96469 */     // GIR_Coverage, 23337,
     /*  96469 */     GIR_EraseRootFromParent_Done,
     /*  96470 */   // Label 2062: @96470
     /*  96470 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(96555), // Rule ID 23338 //
     /*  96475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsswd),
     /*  96483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  96495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96507 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96510 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96514 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96528 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96535 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14952:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  96535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWDrm),
     /*  96538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96540 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96542 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96546 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96553 */     GIR_RootConstrainSelectedInstOperands,
     /*  96554 */     // GIR_Coverage, 23338,
     /*  96554 */     GIR_EraseRootFromParent_Done,
     /*  96555 */   // Label 2063: @96555
     /*  96555 */   GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(96640), // Rule ID 23339 //
     /*  96560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdql),
     /*  96568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  96571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  96574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  96580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96592 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96599 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96620 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14951:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  96620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQLrm),
     /*  96623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96625 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96627 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96631 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96638 */     GIR_RootConstrainSelectedInstOperands,
     /*  96639 */     // GIR_Coverage, 23339,
     /*  96639 */     GIR_EraseRootFromParent_Done,
     /*  96640 */   // Label 2064: @96640
     /*  96640 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(96725), // Rule ID 23340 //
     /*  96645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdqh),
     /*  96653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  96656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  96659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  96665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96677 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96680 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96684 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96705 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14950:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  96705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQHrm),
     /*  96708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96710 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96712 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96716 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96723 */     GIR_RootConstrainSelectedInstOperands,
     /*  96724 */     // GIR_Coverage, 23340,
     /*  96724 */     GIR_EraseRootFromParent_Done,
     /*  96725 */   // Label 2065: @96725
     /*  96725 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(96810), // Rule ID 23341 //
     /*  96730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdd),
     /*  96738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  96744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  96750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96762 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96765 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96769 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96790 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14949:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  96790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDDrm),
     /*  96793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96795 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96797 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96801 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96808 */     GIR_RootConstrainSelectedInstOperands,
     /*  96809 */     // GIR_Coverage, 23341,
     /*  96809 */     GIR_EraseRootFromParent_Done,
     /*  96810 */   // Label 2066: @96810
     /*  96810 */   GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(96895), // Rule ID 23342 //
     /*  96815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdql),
     /*  96823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  96826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  96829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  96835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96847 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96850 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96854 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96875 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14948:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  96875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQLrm),
     /*  96878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96880 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96882 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96886 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96893 */     GIR_RootConstrainSelectedInstOperands,
     /*  96894 */     // GIR_Coverage, 23342,
     /*  96894 */     GIR_EraseRootFromParent_Done,
     /*  96895 */   // Label 2067: @96895
     /*  96895 */   GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(96980), // Rule ID 23343 //
     /*  96900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdqh),
     /*  96908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  96911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  96914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  96920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96932 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96935 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96939 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96960 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14947:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  96960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQHrm),
     /*  96963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96965 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96967 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96971 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96978 */     GIR_RootConstrainSelectedInstOperands,
     /*  96979 */     // GIR_Coverage, 23343,
     /*  96979 */     GIR_EraseRootFromParent_Done,
     /*  96980 */   // Label 2068: @96980
     /*  96980 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(97065), // Rule ID 23344 //
     /*  96985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdd),
     /*  96993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  96999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97017 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97020 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97024 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97045 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14946:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrm),
     /*  97048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97050 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97052 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97056 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97063 */     GIR_RootConstrainSelectedInstOperands,
     /*  97064 */     // GIR_Coverage, 23344,
     /*  97064 */     GIR_EraseRootFromParent_Done,
     /*  97065 */   // Label 2069: @97065
     /*  97065 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(97150), // Rule ID 1619 //
     /*  97070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcswd),
     /*  97078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97106 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97109 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97113 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97123 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97130 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14957:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSWDrm),
     /*  97133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97135 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97137 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97141 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97148 */     GIR_RootConstrainSelectedInstOperands,
     /*  97149 */     // GIR_Coverage, 1619,
     /*  97149 */     GIR_EraseRootFromParent_Done,
     /*  97150 */   // Label 2070: @97150
     /*  97150 */   GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(97235), // Rule ID 1621 //
     /*  97155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcsswd),
     /*  97163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97191 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97194 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97198 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97215 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14956:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSSWDrm),
     /*  97218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97220 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97222 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97226 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97233 */     GIR_RootConstrainSelectedInstOperands,
     /*  97234 */     // GIR_Coverage, 1621,
     /*  97234 */     GIR_EraseRootFromParent_Done,
     /*  97235 */   // Label 2071: @97235
     /*  97235 */   GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(97320), // Rule ID 1623 //
     /*  97240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsww),
     /*  97248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  97260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97276 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97279 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97283 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97300 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14955:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  97300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrm),
     /*  97303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97305 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97307 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97311 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97318 */     GIR_RootConstrainSelectedInstOperands,
     /*  97319 */     // GIR_Coverage, 1623,
     /*  97319 */     GIR_EraseRootFromParent_Done,
     /*  97320 */   // Label 2072: @97320
     /*  97320 */   GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(97405), // Rule ID 1625 //
     /*  97325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacswd),
     /*  97333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97361 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97364 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97368 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97378 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97385 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14954:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWDrm),
     /*  97388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97390 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97392 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97396 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97403 */     GIR_RootConstrainSelectedInstOperands,
     /*  97404 */     // GIR_Coverage, 1625,
     /*  97404 */     GIR_EraseRootFromParent_Done,
     /*  97405 */   // Label 2073: @97405
     /*  97405 */   GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(97490), // Rule ID 1627 //
     /*  97410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssww),
     /*  97418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  97430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97446 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97449 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97453 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97470 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14953:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  97470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWWrm),
     /*  97473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97475 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97477 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97481 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97488 */     GIR_RootConstrainSelectedInstOperands,
     /*  97489 */     // GIR_Coverage, 1627,
     /*  97489 */     GIR_EraseRootFromParent_Done,
     /*  97490 */   // Label 2074: @97490
     /*  97490 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(97575), // Rule ID 1629 //
     /*  97495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsswd),
     /*  97503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97531 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97534 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97538 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97555 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14952:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWDrm),
     /*  97558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97560 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97562 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97566 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97573 */     GIR_RootConstrainSelectedInstOperands,
     /*  97574 */     // GIR_Coverage, 1629,
     /*  97574 */     GIR_EraseRootFromParent_Done,
     /*  97575 */   // Label 2075: @97575
     /*  97575 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(97660), // Rule ID 1631 //
     /*  97580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdql),
     /*  97588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97616 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97619 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97623 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97640 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14951:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQLrm),
     /*  97643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97645 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97647 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97651 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97658 */     GIR_RootConstrainSelectedInstOperands,
     /*  97659 */     // GIR_Coverage, 1631,
     /*  97659 */     GIR_EraseRootFromParent_Done,
     /*  97660 */   // Label 2076: @97660
     /*  97660 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(97745), // Rule ID 1633 //
     /*  97665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdqh),
     /*  97673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97701 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97704 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97708 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97725 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14950:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQHrm),
     /*  97728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97730 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97732 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97736 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97743 */     GIR_RootConstrainSelectedInstOperands,
     /*  97744 */     // GIR_Coverage, 1633,
     /*  97744 */     GIR_EraseRootFromParent_Done,
     /*  97745 */   // Label 2077: @97745
     /*  97745 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(97830), // Rule ID 1635 //
     /*  97750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdd),
     /*  97758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97786 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97789 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97793 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97810 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14949:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDDrm),
     /*  97813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97815 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97817 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97821 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97828 */     GIR_RootConstrainSelectedInstOperands,
     /*  97829 */     // GIR_Coverage, 1635,
     /*  97829 */     GIR_EraseRootFromParent_Done,
     /*  97830 */   // Label 2078: @97830
     /*  97830 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(97915), // Rule ID 1637 //
     /*  97835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdql),
     /*  97843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97871 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97874 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97878 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97895 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14948:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQLrm),
     /*  97898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97900 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97902 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97906 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97913 */     GIR_RootConstrainSelectedInstOperands,
     /*  97914 */     // GIR_Coverage, 1637,
     /*  97914 */     GIR_EraseRootFromParent_Done,
     /*  97915 */   // Label 2079: @97915
     /*  97915 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(98000), // Rule ID 1639 //
     /*  97920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdqh),
     /*  97928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97956 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97959 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97963 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97973 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97980 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14947:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQHrm),
     /*  97983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97985 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97987 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97991 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97998 */     GIR_RootConstrainSelectedInstOperands,
     /*  97999 */     // GIR_Coverage, 1639,
     /*  97999 */     GIR_EraseRootFromParent_Done,
     /*  98000 */   // Label 2080: @98000
     /*  98000 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(98085), // Rule ID 1641 //
     /*  98005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdd),
     /*  98013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98041 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98044 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98048 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98065 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14946:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrm),
     /*  98068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98070 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98072 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98076 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98083 */     GIR_RootConstrainSelectedInstOperands,
     /*  98084 */     // GIR_Coverage, 1641,
     /*  98084 */     GIR_EraseRootFromParent_Done,
     /*  98085 */   // Label 2081: @98085
     /*  98085 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(98170), // Rule ID 3558 //
     /*  98090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /*  98093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg1),
     /*  98098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  98126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98130 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98133 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98137 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98150 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14897:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM3MSG1rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /*  98150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG1rm),
     /*  98153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98155 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98157 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98159 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /*  98163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98168 */     GIR_RootConstrainSelectedInstOperands,
     /*  98169 */     // GIR_Coverage, 3558,
     /*  98169 */     GIR_EraseRootFromParent_Done,
     /*  98170 */   // Label 2082: @98170
     /*  98170 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(98255), // Rule ID 3560 //
     /*  98175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /*  98178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg2),
     /*  98183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  98211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98215 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98218 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98222 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98228 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98235 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14898:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM3MSG2rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /*  98235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG2rm),
     /*  98238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98240 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98242 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98244 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /*  98248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98253 */     GIR_RootConstrainSelectedInstOperands,
     /*  98254 */     // GIR_Coverage, 3560,
     /*  98254 */     GIR_EraseRootFromParent_Done,
     /*  98255 */   // Label 2083: @98255
     /*  98255 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(98305), // Rule ID 3252 //
     /*  98260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  98263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  98268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98289 */     // MIs[0] src3
     /*  98289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98292 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14712:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPSrri:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSrri),
     /*  98295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98297 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98299 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98301 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98303 */     GIR_RootConstrainSelectedInstOperands,
     /*  98304 */     // GIR_Coverage, 3252,
     /*  98304 */     GIR_EraseRootFromParent_Done,
     /*  98305 */   // Label 2084: @98305
     /*  98305 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(98355), // Rule ID 3254 //
     /*  98310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  98313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  98318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98339 */     // MIs[0] src3
     /*  98339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98342 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14711:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPDrri:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPDrri),
     /*  98345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98347 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98349 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98351 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98353 */     GIR_RootConstrainSelectedInstOperands,
     /*  98354 */     // GIR_Coverage, 3254,
     /*  98354 */     GIR_EraseRootFromParent_Done,
     /*  98355 */   // Label 2085: @98355
     /*  98355 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(98405), // Rule ID 3256 //
     /*  98360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  98363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_dp_ps_256),
     /*  98368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  98371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  98374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  98377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  98381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  98385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  98389 */     // MIs[0] src3
     /*  98389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98392 */     // (intrinsic_wo_chain:{ *:[v8f32] } 13322:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPSYrri:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSYrri),
     /*  98395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98397 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98399 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98401 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98403 */     GIR_RootConstrainSelectedInstOperands,
     /*  98404 */     // GIR_Coverage, 3256,
     /*  98404 */     GIR_EraseRootFromParent_Done,
     /*  98405 */   // Label 2086: @98405
     /*  98405 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(98455), // Rule ID 3262 //
     /*  98410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  98413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  98418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98439 */     // MIs[0] src3
     /*  98439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98442 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14712:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (DPPSrri:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DPPSrri),
     /*  98445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98447 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98449 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98451 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98453 */     GIR_RootConstrainSelectedInstOperands,
     /*  98454 */     // GIR_Coverage, 3262,
     /*  98454 */     GIR_EraseRootFromParent_Done,
     /*  98455 */   // Label 2087: @98455
     /*  98455 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(98505), // Rule ID 3264 //
     /*  98460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  98463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  98468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98489 */     // MIs[0] src3
     /*  98489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98492 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14711:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (DPPDrri:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DPPDrri),
     /*  98495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98497 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98499 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98501 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98503 */     GIR_RootConstrainSelectedInstOperands,
     /*  98504 */     // GIR_Coverage, 3264,
     /*  98504 */     GIR_EraseRootFromParent_Done,
     /*  98505 */   // Label 2088: @98505
     /*  98505 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(98555), // Rule ID 3324 //
     /*  98510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  98513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1rnds4),
     /*  98518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98539 */     // MIs[0] src3
     /*  98539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98542 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14598:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (SHA1RNDS4rri:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1RNDS4rri),
     /*  98545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98547 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98549 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98551 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98553 */     GIR_RootConstrainSelectedInstOperands,
     /*  98554 */     // GIR_Coverage, 3324,
     /*  98554 */     GIR_EraseRootFromParent_Done,
     /*  98555 */   // Label 2089: @98555
     /*  98555 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(98605), // Rule ID 3370 //
     /*  98560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPCLMUL_NoAVX),
     /*  98563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  98568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98589 */     // MIs[0] src3
     /*  98589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98592 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14563:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (PCLMULQDQrri:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PCLMULQDQrri),
     /*  98595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98597 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98599 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98601 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98603 */     GIR_RootConstrainSelectedInstOperands,
     /*  98604 */     // GIR_Coverage, 3370,
     /*  98604 */     GIR_EraseRootFromParent_Done,
     /*  98605 */   // Label 2090: @98605
     /*  98605 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(98655), // Rule ID 3372 //
     /*  98610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ),
     /*  98613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  98618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98639 */     // MIs[0] src3
     /*  98639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98642 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14563:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQrri:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQrri),
     /*  98645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98647 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98649 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98651 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98653 */     GIR_RootConstrainSelectedInstOperands,
     /*  98654 */     // GIR_Coverage, 3372,
     /*  98654 */     GIR_EraseRootFromParent_Done,
     /*  98655 */   // Label 2091: @98655
     /*  98655 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(98705), // Rule ID 3374 //
     /*  98660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPCLMULQDQ_NoVLX),
     /*  98663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  98668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  98671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  98674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  98677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  98681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  98685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  98689 */     // MIs[0] src3
     /*  98689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98692 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14564:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQYrri:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQYrri),
     /*  98695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98697 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98699 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98701 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98703 */     GIR_RootConstrainSelectedInstOperands,
     /*  98704 */     // GIR_Coverage, 3374,
     /*  98704 */     GIR_EraseRootFromParent_Done,
     /*  98705 */   // Label 2092: @98705
     /*  98705 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(98755), // Rule ID 14083 //
     /*  98710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVPCLMULQDQ),
     /*  98713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_512),
     /*  98718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  98721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  98724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  98727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  98731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  98735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  98739 */     // MIs[0] src3
     /*  98739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98742 */     // (intrinsic_wo_chain:{ *:[v8i64] } 14565:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZrri:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZrri),
     /*  98745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98747 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98749 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98751 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98753 */     GIR_RootConstrainSelectedInstOperands,
     /*  98754 */     // GIR_Coverage, 14083,
     /*  98754 */     GIR_EraseRootFromParent_Done,
     /*  98755 */   // Label 2093: @98755
     /*  98755 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(98805), // Rule ID 14085 //
     /*  98760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  98763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  98768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  98781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  98785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  98789 */     // MIs[0] src3
     /*  98789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98792 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14563:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ128rri:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ128rri),
     /*  98795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98797 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98799 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98801 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98803 */     GIR_RootConstrainSelectedInstOperands,
     /*  98804 */     // GIR_Coverage, 14085,
     /*  98804 */     GIR_EraseRootFromParent_Done,
     /*  98805 */   // Label 2094: @98805
     /*  98805 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(98855), // Rule ID 14087 //
     /*  98810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  98813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  98818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  98821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  98824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  98827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  98831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  98835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  98839 */     // MIs[0] src3
     /*  98839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98842 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14564:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ256rri:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  98842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ256rri),
     /*  98845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98847 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98849 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98851 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98853 */     GIR_RootConstrainSelectedInstOperands,
     /*  98854 */     // GIR_Coverage, 14087,
     /*  98854 */     GIR_EraseRootFromParent_Done,
     /*  98855 */   // Label 2095: @98855
     /*  98855 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(98909), // Rule ID 1618 //
     /*  98860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcswd),
     /*  98868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  98874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  98877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98896 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14957:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSWDrr),
     /*  98899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98901 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98903 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98905 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98907 */     GIR_RootConstrainSelectedInstOperands,
     /*  98908 */     // GIR_Coverage, 1618,
     /*  98908 */     GIR_EraseRootFromParent_Done,
     /*  98909 */   // Label 2096: @98909
     /*  98909 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(98963), // Rule ID 1620 //
     /*  98914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcsswd),
     /*  98922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  98928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  98931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98950 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14956:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSSWDrr),
     /*  98953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98955 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98957 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98959 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98961 */     GIR_RootConstrainSelectedInstOperands,
     /*  98962 */     // GIR_Coverage, 1620,
     /*  98962 */     GIR_EraseRootFromParent_Done,
     /*  98963 */   // Label 2097: @98963
     /*  98963 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(99017), // Rule ID 1622 //
     /*  98968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsww),
     /*  98976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  98979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  98982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  98985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  98988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99004 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14955:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  99004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*  99007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99009 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99011 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99013 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99015 */     GIR_RootConstrainSelectedInstOperands,
     /*  99016 */     // GIR_Coverage, 1622,
     /*  99016 */     GIR_EraseRootFromParent_Done,
     /*  99017 */   // Label 2098: @99017
     /*  99017 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(99071), // Rule ID 1624 //
     /*  99022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacswd),
     /*  99030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99058 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14954:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWDrr),
     /*  99061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99063 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99065 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99067 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99069 */     GIR_RootConstrainSelectedInstOperands,
     /*  99070 */     // GIR_Coverage, 1624,
     /*  99070 */     GIR_EraseRootFromParent_Done,
     /*  99071 */   // Label 2099: @99071
     /*  99071 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(99125), // Rule ID 1626 //
     /*  99076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssww),
     /*  99084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  99087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  99096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99112 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14953:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  99112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWWrr),
     /*  99115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99117 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99119 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99121 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99123 */     GIR_RootConstrainSelectedInstOperands,
     /*  99124 */     // GIR_Coverage, 1626,
     /*  99124 */     GIR_EraseRootFromParent_Done,
     /*  99125 */   // Label 2100: @99125
     /*  99125 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(99179), // Rule ID 1628 //
     /*  99130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsswd),
     /*  99138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99166 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14952:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWDrr),
     /*  99169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99171 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99173 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99175 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99177 */     GIR_RootConstrainSelectedInstOperands,
     /*  99178 */     // GIR_Coverage, 1628,
     /*  99178 */     GIR_EraseRootFromParent_Done,
     /*  99179 */   // Label 2101: @99179
     /*  99179 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(99233), // Rule ID 1630 //
     /*  99184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdql),
     /*  99192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  99204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99220 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14951:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQLrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  99220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQLrr),
     /*  99223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99225 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99227 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99229 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99231 */     GIR_RootConstrainSelectedInstOperands,
     /*  99232 */     // GIR_Coverage, 1630,
     /*  99232 */     GIR_EraseRootFromParent_Done,
     /*  99233 */   // Label 2102: @99233
     /*  99233 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(99287), // Rule ID 1632 //
     /*  99238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdqh),
     /*  99246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  99258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99274 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14950:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQHrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  99274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQHrr),
     /*  99277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99279 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99281 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99283 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99285 */     GIR_RootConstrainSelectedInstOperands,
     /*  99286 */     // GIR_Coverage, 1632,
     /*  99286 */     GIR_EraseRootFromParent_Done,
     /*  99287 */   // Label 2103: @99287
     /*  99287 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(99341), // Rule ID 1634 //
     /*  99292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdd),
     /*  99300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99328 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14949:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDDrr),
     /*  99331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99333 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99335 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99337 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99339 */     GIR_RootConstrainSelectedInstOperands,
     /*  99340 */     // GIR_Coverage, 1634,
     /*  99340 */     GIR_EraseRootFromParent_Done,
     /*  99341 */   // Label 2104: @99341
     /*  99341 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(99395), // Rule ID 1636 //
     /*  99346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdql),
     /*  99354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  99366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99382 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14948:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQLrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  99382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQLrr),
     /*  99385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99387 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99389 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99391 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99393 */     GIR_RootConstrainSelectedInstOperands,
     /*  99394 */     // GIR_Coverage, 1636,
     /*  99394 */     GIR_EraseRootFromParent_Done,
     /*  99395 */   // Label 2105: @99395
     /*  99395 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(99449), // Rule ID 1638 //
     /*  99400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdqh),
     /*  99408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  99420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99436 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14947:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQHrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  99436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQHrr),
     /*  99439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99441 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99443 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99445 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99447 */     GIR_RootConstrainSelectedInstOperands,
     /*  99448 */     // GIR_Coverage, 1638,
     /*  99448 */     GIR_EraseRootFromParent_Done,
     /*  99449 */   // Label 2106: @99449
     /*  99449 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(99503), // Rule ID 1640 //
     /*  99454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdd),
     /*  99462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99490 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14946:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /*  99493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99495 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99497 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99499 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99501 */     GIR_RootConstrainSelectedInstOperands,
     /*  99502 */     // GIR_Coverage, 1640,
     /*  99502 */     GIR_EraseRootFromParent_Done,
     /*  99503 */   // Label 2107: @99503
     /*  99503 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(99569), // Rule ID 3332 //
     /*  99508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  99511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256rnds2),
     /*  99516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99544 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14601:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, XMM0:{ *:[v4i32] })  =>  (SHA256RNDS2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  99544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99548 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::XMM0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99554 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XMM0
     /*  99558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256RNDS2rr),
     /*  99561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99563 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99565 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99567 */     GIR_RootConstrainSelectedInstOperands,
     /*  99568 */     // GIR_Coverage, 3332,
     /*  99568 */     GIR_EraseRootFromParent_Done,
     /*  99569 */   // Label 2108: @99569
     /*  99569 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(99623), // Rule ID 3556 //
     /*  99574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /*  99577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512rnds2),
     /*  99582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  99585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  99588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  99591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  99594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99610 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14896:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VSHA512RNDS2rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  99610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512RNDS2rr),
     /*  99613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99615 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99617 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99619 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99621 */     GIR_RootConstrainSelectedInstOperands,
     /*  99622 */     // GIR_Coverage, 3556,
     /*  99622 */     GIR_EraseRootFromParent_Done,
     /*  99623 */   // Label 2109: @99623
     /*  99623 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(99677), // Rule ID 3557 //
     /*  99628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /*  99631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg1),
     /*  99636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99664 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14897:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VSM3MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG1rr),
     /*  99667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99669 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99671 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99673 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99675 */     GIR_RootConstrainSelectedInstOperands,
     /*  99676 */     // GIR_Coverage, 3557,
     /*  99676 */     GIR_EraseRootFromParent_Done,
     /*  99677 */   // Label 2110: @99677
     /*  99677 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(99731), // Rule ID 3559 //
     /*  99682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /*  99685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg2),
     /*  99690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99718 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14898:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VSM3MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG2rr),
     /*  99721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99723 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99725 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99727 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99729 */     GIR_RootConstrainSelectedInstOperands,
     /*  99730 */     // GIR_Coverage, 3559,
     /*  99730 */     GIR_EraseRootFromParent_Done,
     /*  99731 */   // Label 2111: @99731
     /*  99731 */   GIM_Reject,
     /*  99732 */ // Label 2046: @99732
     /*  99732 */ GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(99861),
     /*  99737 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  99740 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3rnds2),
     /*  99745 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99751 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99754 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99761 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99765 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99769 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(99830), // Rule ID 3562 //
     /*  99774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /*  99777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  99781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  99785 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99788 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  99792 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  99796 */     // MIs[0] src4
     /*  99796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99801 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  99808 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14899:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i32] }):$src4)  =>  (VSM3RNDS2rmi:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, addr:{ *:[iPTR] }:$src3, (timm:{ *:[i32] }):$src4)
     /*  99808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3RNDS2rmi),
     /*  99811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99813 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99815 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99817 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /*  99821 */     GIR_RootToRootCopy, /*OpIdx*/5, // src4
     /*  99823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  99828 */     GIR_RootConstrainSelectedInstOperands,
     /*  99829 */     // GIR_Coverage, 3562,
     /*  99829 */     GIR_EraseRootFromParent_Done,
     /*  99830 */   // Label 2113: @99830
     /*  99830 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(99860), // Rule ID 3561 //
     /*  99835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /*  99838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99842 */     // MIs[0] src4
     /*  99842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99845 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14899:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3, (timm:{ *:[i32] }):$src4)  =>  (VSM3RNDS2rri:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3, (timm:{ *:[i32] }):$src4)
     /*  99845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3RNDS2rri),
     /*  99848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99850 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99852 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99854 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99856 */     GIR_RootToRootCopy, /*OpIdx*/5, // src4
     /*  99858 */     GIR_RootConstrainSelectedInstOperands,
     /*  99859 */     // GIR_Coverage, 3561,
     /*  99859 */     GIR_EraseRootFromParent_Done,
     /*  99860 */   // Label 2114: @99860
     /*  99860 */   GIM_Reject,
     /*  99861 */ // Label 2112: @99861
     /*  99861 */ GIM_Reject,
     /*  99862 */ // Label 18: @99862
     /*  99862 */ GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(100421),
     /*  99867 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /*  99870 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(99892), // Rule ID 149 //
     /*  99875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSERIALIZE),
     /*  99878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_serialize),
     /*  99883 */     // (intrinsic_void 14593:{ *:[iPTR] })  =>  (SERIALIZE)
     /*  99883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SERIALIZE),
     /*  99886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99890 */     GIR_RootConstrainSelectedInstOperands,
     /*  99891 */     // GIR_Coverage, 149,
     /*  99891 */     GIR_EraseRootFromParent_Done,
     /*  99892 */   // Label 2116: @99892
     /*  99892 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(99914), // Rule ID 150 //
     /*  99897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTSXLDTRK),
     /*  99900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsusldtrk),
     /*  99905 */     // (intrinsic_void 14981:{ *:[iPTR] })  =>  (XSUSLDTRK)
     /*  99905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSUSLDTRK),
     /*  99908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99912 */     GIR_RootConstrainSelectedInstOperands,
     /*  99913 */     // GIR_Coverage, 150,
     /*  99913 */     GIR_EraseRootFromParent_Done,
     /*  99914 */   // Label 2117: @99914
     /*  99914 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(99936), // Rule ID 151 //
     /*  99919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTSXLDTRK),
     /*  99922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xresldtrk),
     /*  99927 */     // (intrinsic_void 14967:{ *:[iPTR] })  =>  (XRESLDTRK)
     /*  99927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRESLDTRK),
     /*  99930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99934 */     GIR_RootConstrainSelectedInstOperands,
     /*  99935 */     // GIR_Coverage, 151,
     /*  99935 */     GIR_EraseRootFromParent_Done,
     /*  99936 */   // Label 2118: @99936
     /*  99936 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(99958), // Rule ID 152 //
     /*  99941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /*  99944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clui),
     /*  99949 */     // (intrinsic_void 14451:{ *:[iPTR] })  =>  (CLUI)
     /*  99949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLUI),
     /*  99952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99956 */     GIR_RootConstrainSelectedInstOperands,
     /*  99957 */     // GIR_Coverage, 152,
     /*  99957 */     GIR_EraseRootFromParent_Done,
     /*  99958 */   // Label 2119: @99958
     /*  99958 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(99980), // Rule ID 153 //
     /*  99963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /*  99966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_stui),
     /*  99971 */     // (intrinsic_void 14775:{ *:[iPTR] })  =>  (STUI)
     /*  99971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STUI),
     /*  99974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99978 */     GIR_RootConstrainSelectedInstOperands,
     /*  99979 */     // GIR_Coverage, 153,
     /*  99979 */     GIR_EraseRootFromParent_Done,
     /*  99980 */   // Label 2120: @99980
     /*  99980 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(99999), // Rule ID 2509 //
     /*  99985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_pause),
     /*  99990 */     // (intrinsic_void 14670:{ *:[iPTR] })  =>  (PAUSE)
     /*  99990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PAUSE),
     /*  99993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99997 */     GIR_RootConstrainSelectedInstOperands,
     /*  99998 */     // GIR_Coverage, 2509,
     /*  99998 */     GIR_EraseRootFromParent_Done,
     /*  99999 */   // Label 2121: @99999
     /*  99999 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(100021), // Rule ID 2510 //
     /* 100004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE1),
     /* 100007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_sfence),
     /* 100012 */     // (intrinsic_void 14632:{ *:[iPTR] })  =>  (SFENCE)
     /* 100012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SFENCE),
     /* 100015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100019 */     GIR_RootConstrainSelectedInstOperands,
     /* 100020 */     // GIR_Coverage, 2510,
     /* 100020 */     GIR_EraseRootFromParent_Done,
     /* 100021 */   // Label 2122: @100021
     /* 100021 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(100043), // Rule ID 2511 //
     /* 100026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE2),
     /* 100029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_lfence),
     /* 100034 */     // (intrinsic_void 14659:{ *:[iPTR] })  =>  (LFENCE)
     /* 100034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LFENCE),
     /* 100037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100041 */     GIR_RootConstrainSelectedInstOperands,
     /* 100042 */     // GIR_Coverage, 2511,
     /* 100042 */     GIR_EraseRootFromParent_Done,
     /* 100043 */   // Label 2123: @100043
     /* 100043 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(100065), // Rule ID 2512 //
     /* 100048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMFence),
     /* 100051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_mfence),
     /* 100056 */     // (intrinsic_void 14663:{ *:[iPTR] })  =>  (MFENCE)
     /* 100056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MFENCE),
     /* 100059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100063 */     GIR_RootConstrainSelectedInstOperands,
     /* 100064 */     // GIR_Coverage, 2512,
     /* 100064 */     GIR_EraseRootFromParent_Done,
     /* 100065 */   // Label 2124: @100065
     /* 100065 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(100131), // Rule ID 3426 //
     /* 100070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 100073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_vzeroall),
     /* 100078 */     // (intrinsic_void 13365:{ *:[iPTR] })  =>  (VZEROALL)
     /* 100078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VZEROALL),
     /* 100081 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM0*/0,
     /* 100084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM1*/1,
     /* 100087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM2*/2,
     /* 100090 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM3*/3,
     /* 100093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM4*/4,
     /* 100096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM5*/5,
     /* 100099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM6*/6,
     /* 100102 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM7*/7,
     /* 100105 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM8*/8,
     /* 100108 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM9*/9,
     /* 100111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM10*/10,
     /* 100114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM11*/11,
     /* 100117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM12*/12,
     /* 100120 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM13*/13,
     /* 100123 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM14*/14,
     /* 100126 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM15*/15,
     /* 100129 */     GIR_RootConstrainSelectedInstOperands,
     /* 100130 */     // GIR_Coverage, 3426,
     /* 100130 */     GIR_EraseRootFromParent_Done,
     /* 100131 */   // Label 2125: @100131
     /* 100131 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(100197), // Rule ID 3427 //
     /* 100136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 100139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_vzeroupper),
     /* 100144 */     // (intrinsic_void 13366:{ *:[iPTR] })  =>  (VZEROUPPER)
     /* 100144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VZEROUPPER),
     /* 100147 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM0*/0,
     /* 100150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM1*/1,
     /* 100153 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM2*/2,
     /* 100156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM3*/3,
     /* 100159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM4*/4,
     /* 100162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM5*/5,
     /* 100165 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM6*/6,
     /* 100168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM7*/7,
     /* 100171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM8*/8,
     /* 100174 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM9*/9,
     /* 100177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM10*/10,
     /* 100180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM11*/11,
     /* 100183 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM12*/12,
     /* 100186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM13*/13,
     /* 100189 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM14*/14,
     /* 100192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM15*/15,
     /* 100195 */     GIR_RootConstrainSelectedInstOperands,
     /* 100196 */     // GIR_Coverage, 3427,
     /* 100196 */     GIR_EraseRootFromParent_Done,
     /* 100197 */   // Label 2126: @100197
     /* 100197 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(100267), // Rule ID 16801 //
     /* 100202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMMX),
     /* 100205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_mmx_emms),
     /* 100210 */     // (intrinsic_void 14486:{ *:[iPTR] })  =>  (MMX_EMMS:{ *:[x86mmx] })
     /* 100210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MMX_EMMS),
     /* 100213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM0*/0,
     /* 100216 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM1*/1,
     /* 100219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM2*/2,
     /* 100222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM3*/3,
     /* 100225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM4*/4,
     /* 100228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM5*/5,
     /* 100231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM6*/6,
     /* 100234 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM7*/7,
     /* 100237 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST0*/8,
     /* 100240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST1*/9,
     /* 100243 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST2*/10,
     /* 100246 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST3*/11,
     /* 100249 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST4*/12,
     /* 100252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST5*/13,
     /* 100255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST6*/14,
     /* 100258 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST7*/15,
     /* 100261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100265 */     GIR_RootConstrainSelectedInstOperands,
     /* 100266 */     // GIR_Coverage, 16801,
     /* 100266 */     GIR_EraseRootFromParent_Done,
     /* 100267 */   // Label 2127: @100267
     /* 100267 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(100289), // Rule ID 16984 //
     /* 100272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 100275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xend),
     /* 100280 */     // (intrinsic_void 14919:{ *:[iPTR] })  =>  (XEND)
     /* 100280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XEND),
     /* 100283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100287 */     GIR_RootConstrainSelectedInstOperands,
     /* 100288 */     // GIR_Coverage, 16984,
     /* 100288 */     GIR_EraseRootFromParent_Done,
     /* 100289 */   // Label 2128: @100289
     /* 100289 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(100335), // Rule ID 16996 //
     /* 100294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode),
     /* 100297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tilerelease),
     /* 100302 */     // (intrinsic_void 14845:{ *:[iPTR] })  =>  (TILERELEASE:{ *:[x86amx] })
     /* 100302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TILERELEASE),
     /* 100305 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM0*/0,
     /* 100308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM1*/1,
     /* 100311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM2*/2,
     /* 100314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM3*/3,
     /* 100317 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM4*/4,
     /* 100320 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM5*/5,
     /* 100323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM6*/6,
     /* 100326 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM7*/7,
     /* 100329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100333 */     GIR_RootConstrainSelectedInstOperands,
     /* 100334 */     // GIR_Coverage, 16996,
     /* 100334 */     GIR_EraseRootFromParent_Done,
     /* 100335 */   // Label 2129: @100335
     /* 100335 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(100354), // Rule ID 17085 //
     /* 100340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wbinvd),
     /* 100345 */     // (intrinsic_void 14906:{ *:[iPTR] })  =>  (WBINVD)
     /* 100345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WBINVD),
     /* 100348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100352 */     GIR_RootConstrainSelectedInstOperands,
     /* 100353 */     // GIR_Coverage, 17085,
     /* 100353 */     GIR_EraseRootFromParent_Done,
     /* 100354 */   // Label 2130: @100354
     /* 100354 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(100376), // Rule ID 17086 //
     /* 100359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWBNOINVD),
     /* 100362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wbnoinvd),
     /* 100367 */     // (intrinsic_void 14907:{ *:[iPTR] })  =>  (WBNOINVD)
     /* 100367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WBNOINVD),
     /* 100370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100374 */     GIR_RootConstrainSelectedInstOperands,
     /* 100375 */     // GIR_Coverage, 17086,
     /* 100375 */     GIR_EraseRootFromParent_Done,
     /* 100376 */   // Label 2131: @100376
     /* 100376 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(100398), // Rule ID 17091 //
     /* 100381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_saveprevssp),
     /* 100386 */     // (intrinsic_void 14588:{ *:[iPTR] })  =>  (SAVEPREVSSP)
     /* 100386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAVEPREVSSP),
     /* 100389 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 100392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100396 */     GIR_RootConstrainSelectedInstOperands,
     /* 100397 */     // GIR_Coverage, 17091,
     /* 100397 */     GIR_EraseRootFromParent_Done,
     /* 100398 */   // Label 2132: @100398
     /* 100398 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(100420), // Rule ID 17101 //
     /* 100403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_setssbsy),
     /* 100408 */     // (intrinsic_void 14594:{ *:[iPTR] })  =>  (SETSSBSY)
     /* 100408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SETSSBSY),
     /* 100411 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 100414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100418 */     GIR_RootConstrainSelectedInstOperands,
     /* 100419 */     // GIR_Coverage, 17101,
     /* 100419 */     GIR_EraseRootFromParent_Done,
     /* 100420 */   // Label 2133: @100420
     /* 100420 */   GIM_Reject,
     /* 100421 */ // Label 2115: @100421
     /* 100421 */ GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(102309),
     /* 100426 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 100429 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(100487), // Rule ID 17129 //
     /* 100434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE_In64BitMode),
     /* 100437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite64),
     /* 100442 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 100445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 100453 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100456 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 100460 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 100464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100466 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100473 */     // (intrinsic_void 14568:{ *:[iPTR] }, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (PTWRITE64m addr:{ *:[iPTR] }:$dst)
     /* 100473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITE64m),
     /* 100476 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 100480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 100485 */     GIR_RootConstrainSelectedInstOperands,
     /* 100486 */     // GIR_Coverage, 17129,
     /* 100486 */     GIR_EraseRootFromParent_Done,
     /* 100487 */   // Label 2135: @100487
     /* 100487 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(100545), // Rule ID 17128 //
     /* 100492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE),
     /* 100495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite32),
     /* 100500 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 100511 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100514 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 100518 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 100522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100531 */     // (intrinsic_void 14567:{ *:[iPTR] }, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (PTWRITEm addr:{ *:[iPTR] }:$dst)
     /* 100531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITEm),
     /* 100534 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 100538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 100543 */     GIR_RootConstrainSelectedInstOperands,
     /* 100544 */     // GIR_Coverage, 17128,
     /* 100544 */     GIR_EraseRootFromParent_Done,
     /* 100545 */   // Label 2136: @100545
     /* 100545 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(100582), // Rule ID 162 //
     /* 100550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLFLUSHOPT),
     /* 100553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clflushopt),
     /* 100558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100569 */     // (intrinsic_void 14449:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLFLUSHOPT addr:{ *:[iPTR] }:$src)
     /* 100569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLFLUSHOPT),
     /* 100572 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 100576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100580 */     GIR_RootConstrainSelectedInstOperands,
     /* 100581 */     // GIR_Coverage, 162,
     /* 100581 */     GIR_EraseRootFromParent_Done,
     /* 100582 */   // Label 2137: @100582
     /* 100582 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(100619), // Rule ID 163 //
     /* 100587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLWB),
     /* 100590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clwb),
     /* 100595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100606 */     // (intrinsic_void 14452:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLWB addr:{ *:[iPTR] }:$src)
     /* 100606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLWB),
     /* 100609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 100613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100617 */     GIR_RootConstrainSelectedInstOperands,
     /* 100618 */     // GIR_Coverage, 163,
     /* 100618 */     GIR_EraseRootFromParent_Done,
     /* 100619 */   // Label 2138: @100619
     /* 100619 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(100656), // Rule ID 164 //
     /* 100624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLDEMOTE),
     /* 100627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_cldemote),
     /* 100632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100643 */     // (intrinsic_void 14448:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLDEMOTE addr:{ *:[iPTR] }:$src)
     /* 100643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLDEMOTE),
     /* 100646 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 100650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100654 */     GIR_RootConstrainSelectedInstOperands,
     /* 100655 */     // GIR_Coverage, 164,
     /* 100655 */     GIR_EraseRootFromParent_Done,
     /* 100656 */   // Label 2139: @100656
     /* 100656 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(100693), // Rule ID 169 //
     /* 100661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS),
     /* 100664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_prefetchrs),
     /* 100669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100680 */     // (intrinsic_void 14566:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (PREFETCHRST2 addr:{ *:[iPTR] }:$src)
     /* 100680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHRST2),
     /* 100683 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 100687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100691 */     GIR_RootConstrainSelectedInstOperands,
     /* 100692 */     // GIR_Coverage, 169,
     /* 100692 */     GIR_EraseRootFromParent_Done,
     /* 100693 */   // Label 2140: @100693
     /* 100693 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(100730), // Rule ID 1132 //
     /* 100698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR),
     /* 100701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxsave),
     /* 100706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100717 */     // (intrinsic_void 14472:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (FXSAVE addr:{ *:[iPTR] }:$dst)
     /* 100717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXSAVE),
     /* 100720 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 100724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100728 */     GIR_RootConstrainSelectedInstOperands,
     /* 100729 */     // GIR_Coverage, 1132,
     /* 100729 */     GIR_EraseRootFromParent_Done,
     /* 100730 */   // Label 2141: @100730
     /* 100730 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(100767), // Rule ID 1133 //
     /* 100735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR_In64BitMode),
     /* 100738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxsave64),
     /* 100743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100754 */     // (intrinsic_void 14473:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (FXSAVE64 addr:{ *:[iPTR] }:$dst)
     /* 100754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXSAVE64),
     /* 100757 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 100761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100765 */     GIR_RootConstrainSelectedInstOperands,
     /* 100766 */     // GIR_Coverage, 1133,
     /* 100766 */     GIR_EraseRootFromParent_Done,
     /* 100767 */   // Label 2142: @100767
     /* 100767 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(100810), // Rule ID 1134 //
     /* 100772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR),
     /* 100775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxrstor),
     /* 100780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100791 */     // (intrinsic_void 14470:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (FXRSTOR:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 100791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXRSTOR),
     /* 100794 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 100798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 100801 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPCW*/1,
     /* 100804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100808 */     GIR_RootConstrainSelectedInstOperands,
     /* 100809 */     // GIR_Coverage, 1134,
     /* 100809 */     GIR_EraseRootFromParent_Done,
     /* 100810 */   // Label 2143: @100810
     /* 100810 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(100853), // Rule ID 1135 //
     /* 100815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR_In64BitMode),
     /* 100818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxrstor64),
     /* 100823 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100834 */     // (intrinsic_void 14471:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (FXRSTOR64:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 100834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXRSTOR64),
     /* 100837 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 100841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 100844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPCW*/1,
     /* 100847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100851 */     GIR_RootConstrainSelectedInstOperands,
     /* 100852 */     // GIR_Coverage, 1135,
     /* 100852 */     GIR_EraseRootFromParent_Done,
     /* 100853 */   // Label 2144: @100853
     /* 100853 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(100890), // Rule ID 2508 //
     /* 100858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLFLUSH),
     /* 100861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_clflush),
     /* 100866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100877 */     // (intrinsic_void 14640:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLFLUSH addr:{ *:[iPTR] }:$src)
     /* 100877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLFLUSH),
     /* 100880 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 100884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100888 */     GIR_RootConstrainSelectedInstOperands,
     /* 100889 */     // GIR_Coverage, 2508,
     /* 100889 */     GIR_EraseRootFromParent_Done,
     /* 100890 */   // Label 2145: @100890
     /* 100890 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(100930), // Rule ID 2513 //
     /* 100895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 100898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_ldmxcsr),
     /* 100903 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100914 */     // (intrinsic_void 14621:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VLDMXCSR addr:{ *:[iPTR] }:$src)
     /* 100914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VLDMXCSR),
     /* 100917 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 100921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MXCSR*/0,
     /* 100924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100928 */     GIR_RootConstrainSelectedInstOperands,
     /* 100929 */     // GIR_Coverage, 2513,
     /* 100929 */     GIR_EraseRootFromParent_Done,
     /* 100930 */   // Label 2146: @100930
     /* 100930 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(100967), // Rule ID 2514 //
     /* 100935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 100938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_stmxcsr),
     /* 100943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100954 */     // (intrinsic_void 14633:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (VSTMXCSR addr:{ *:[iPTR] }:$dst)
     /* 100954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSTMXCSR),
     /* 100957 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 100961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100965 */     GIR_RootConstrainSelectedInstOperands,
     /* 100966 */     // GIR_Coverage, 2514,
     /* 100966 */     GIR_EraseRootFromParent_Done,
     /* 100967 */   // Label 2147: @100967
     /* 100967 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(101004), // Rule ID 2515 //
     /* 100972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_ldmxcsr),
     /* 100977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100988 */     // (intrinsic_void 14621:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDMXCSR addr:{ *:[iPTR] }:$src)
     /* 100988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDMXCSR),
     /* 100991 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 100995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MXCSR*/0,
     /* 100998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101002 */     GIR_RootConstrainSelectedInstOperands,
     /* 101003 */     // GIR_Coverage, 2515,
     /* 101003 */     GIR_EraseRootFromParent_Done,
     /* 101004 */   // Label 2148: @101004
     /* 101004 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(101038), // Rule ID 2516 //
     /* 101009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_stmxcsr),
     /* 101014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101025 */     // (intrinsic_void 14633:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (STMXCSR addr:{ *:[iPTR] }:$dst)
     /* 101025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STMXCSR),
     /* 101028 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101036 */     GIR_RootConstrainSelectedInstOperands,
     /* 101037 */     // GIR_Coverage, 2516,
     /* 101037 */     GIR_EraseRootFromParent_Done,
     /* 101038 */   // Label 2149: @101038
     /* 101038 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(101099), // Rule ID 16992 //
     /* 101043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode_NoEGPR),
     /* 101046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ldtilecfg),
     /* 101051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101062 */     // (intrinsic_void 14478:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDTILECFG:{ *:[x86amx] } addr:{ *:[iPTR] }:$src)
     /* 101062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDTILECFG),
     /* 101065 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM0*/0,
     /* 101072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM1*/1,
     /* 101075 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM2*/2,
     /* 101078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM3*/3,
     /* 101081 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM4*/4,
     /* 101084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM5*/5,
     /* 101087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM6*/6,
     /* 101090 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM7*/7,
     /* 101093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101097 */     GIR_RootConstrainSelectedInstOperands,
     /* 101098 */     // GIR_Coverage, 16992,
     /* 101098 */     GIR_EraseRootFromParent_Done,
     /* 101099 */   // Label 2150: @101099
     /* 101099 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(101136), // Rule ID 16993 //
     /* 101104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode_NoEGPR),
     /* 101107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sttilecfg),
     /* 101112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101123 */     // (intrinsic_void 14774:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (STTILECFG addr:{ *:[iPTR] }:$src)
     /* 101123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STTILECFG),
     /* 101126 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101134 */     GIR_RootConstrainSelectedInstOperands,
     /* 101135 */     // GIR_Coverage, 16993,
     /* 101135 */     GIR_EraseRootFromParent_Done,
     /* 101136 */   // Label 2151: @101136
     /* 101136 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(101197), // Rule ID 16994 //
     /* 101141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_HasEGPR_In64BitMode),
     /* 101144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ldtilecfg),
     /* 101149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101160 */     // (intrinsic_void 14478:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDTILECFG_EVEX:{ *:[x86amx] } addr:{ *:[iPTR] }:$src)
     /* 101160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDTILECFG_EVEX),
     /* 101163 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM0*/0,
     /* 101170 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM1*/1,
     /* 101173 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM2*/2,
     /* 101176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM3*/3,
     /* 101179 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM4*/4,
     /* 101182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM5*/5,
     /* 101185 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM6*/6,
     /* 101188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM7*/7,
     /* 101191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101195 */     GIR_RootConstrainSelectedInstOperands,
     /* 101196 */     // GIR_Coverage, 16994,
     /* 101196 */     GIR_EraseRootFromParent_Done,
     /* 101197 */   // Label 2152: @101197
     /* 101197 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(101234), // Rule ID 16995 //
     /* 101202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_HasEGPR_In64BitMode),
     /* 101205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sttilecfg),
     /* 101210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101221 */     // (intrinsic_void 14774:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (STTILECFG_EVEX addr:{ *:[iPTR] }:$src)
     /* 101221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STTILECFG_EVEX),
     /* 101224 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101232 */     GIR_RootConstrainSelectedInstOperands,
     /* 101233 */     // GIR_Coverage, 16995,
     /* 101233 */     GIR_EraseRootFromParent_Done,
     /* 101234 */   // Label 2153: @101234
     /* 101234 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(101271), // Rule ID 17092 //
     /* 101239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_rstorssp),
     /* 101244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101255 */     // (intrinsic_void 14587:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (RSTORSSP addr:{ *:[iPTR] }:$src)
     /* 101255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RSTORSSP),
     /* 101258 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 101265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101269 */     GIR_RootConstrainSelectedInstOperands,
     /* 101270 */     // GIR_Coverage, 17092,
     /* 101270 */     GIR_EraseRootFromParent_Done,
     /* 101271 */   // Label 2154: @101271
     /* 101271 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(101308), // Rule ID 17102 //
     /* 101276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clrssbsy),
     /* 101281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101292 */     // (intrinsic_void 14450:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLRSSBSY addr:{ *:[iPTR] }:$src)
     /* 101292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLRSSBSY),
     /* 101295 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 101302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101306 */     GIR_RootConstrainSelectedInstOperands,
     /* 101307 */     // GIR_Coverage, 17102,
     /* 101307 */     GIR_EraseRootFromParent_Done,
     /* 101308 */   // Label 2155: @101308
     /* 101308 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(101338), // Rule ID 17074 //
     /* 101313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_int),
     /* 101318 */     // MIs[0] Operand 1
     /* 101318 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(3),
     /* 101329 */     // (intrinsic_void 14476:{ *:[iPTR] }, 3:{ *:[i8] })  =>  (INT3)
     /* 101329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT3),
     /* 101332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101336 */     GIR_RootConstrainSelectedInstOperands,
     /* 101337 */     // GIR_Coverage, 17074,
     /* 101337 */     GIR_EraseRootFromParent_Done,
     /* 101338 */   // Label 2156: @101338
     /* 101338 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(101365), // Rule ID 16986 //
     /* 101343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 101346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xabort),
     /* 101351 */     // MIs[0] imm
     /* 101351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 101354 */     // (intrinsic_void 14917:{ *:[iPTR] }, (timm:{ *:[i8] }):$imm)  =>  (XABORT (timm:{ *:[i8] }):$imm)
     /* 101354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XABORT),
     /* 101357 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 101359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101363 */     GIR_RootConstrainSelectedInstOperands,
     /* 101364 */     // GIR_Coverage, 16986,
     /* 101364 */     GIR_EraseRootFromParent_Done,
     /* 101365 */   // Label 2157: @101365
     /* 101365 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(101392), // Rule ID 16998 //
     /* 101370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode),
     /* 101373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tilezero),
     /* 101378 */     // MIs[0] src
     /* 101378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 101381 */     // (intrinsic_void 14848:{ *:[iPTR] }, (timm:{ *:[i8] }):$src)  =>  (PTILEZERO (timm:{ *:[i8] }):$src)
     /* 101381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEZERO),
     /* 101384 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 101386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101390 */     GIR_RootConstrainSelectedInstOperands,
     /* 101391 */     // GIR_Coverage, 16998,
     /* 101391 */     GIR_EraseRootFromParent_Done,
     /* 101392 */   // Label 2158: @101392
     /* 101392 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(101416), // Rule ID 17076 //
     /* 101397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_int),
     /* 101402 */     // MIs[0] trap
     /* 101402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 101405 */     // (intrinsic_void 14476:{ *:[iPTR] }, (timm:{ *:[i8] }):$trap)  =>  (INT (timm:{ *:[i8] }):$trap)
     /* 101405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT),
     /* 101408 */     GIR_RootToRootCopy, /*OpIdx*/1, // trap
     /* 101410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101414 */     GIR_RootConstrainSelectedInstOperands,
     /* 101415 */     // GIR_Coverage, 17076,
     /* 101415 */     GIR_EraseRootFromParent_Done,
     /* 101416 */   // Label 2159: @101416
     /* 101416 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(101450), // Rule ID 1 //
     /* 101421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 101424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_flags_read_u32),
     /* 101429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 101436 */     // (intrinsic_w_chain:{ *:[i32] } 14462:{ *:[iPTR] })  =>  (RDFLAGS32:{ *:[i32] }:{ *:[i32] })
     /* 101436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFLAGS32),
     /* 101439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 101444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101448 */     GIR_RootConstrainSelectedInstOperands,
     /* 101449 */     // GIR_Coverage, 1,
     /* 101449 */     GIR_EraseRootFromParent_Done,
     /* 101450 */   // Label 2160: @101450
     /* 101450 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(101484), // Rule ID 2 //
     /* 101455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 101458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_flags_read_u64),
     /* 101463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 101466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 101470 */     // (intrinsic_w_chain:{ *:[i64] } 14463:{ *:[iPTR] })  =>  (RDFLAGS64:{ *:[i64] }:{ *:[i32] })
     /* 101470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFLAGS64),
     /* 101473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 101478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101482 */     GIR_RootConstrainSelectedInstOperands,
     /* 101483 */     // GIR_Coverage, 2,
     /* 101483 */     GIR_EraseRootFromParent_Done,
     /* 101484 */   // Label 2161: @101484
     /* 101484 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(101515), // Rule ID 115 //
     /* 101489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 101492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_slwpcb),
     /* 101497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 101504 */     // (intrinsic_w_chain:{ *:[i32] } 14602:{ *:[iPTR] })  =>  (SLWPCB:{ *:[i32] })
     /* 101504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SLWPCB),
     /* 101507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101513 */     GIR_RootConstrainSelectedInstOperands,
     /* 101514 */     // GIR_Coverage, 115,
     /* 101514 */     GIR_EraseRootFromParent_Done,
     /* 101515 */   // Label 2162: @101515
     /* 101515 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(101546), // Rule ID 117 //
     /* 101520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 101523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_slwpcb),
     /* 101528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 101531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 101535 */     // (intrinsic_w_chain:{ *:[i64] } 14602:{ *:[iPTR] })  =>  (SLWPCB64:{ *:[i64] })
     /* 101535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SLWPCB64),
     /* 101538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101544 */     GIR_RootConstrainSelectedInstOperands,
     /* 101545 */     // GIR_Coverage, 117,
     /* 101545 */     GIR_EraseRootFromParent_Done,
     /* 101546 */   // Label 2163: @101546
     /* 101546 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(101577), // Rule ID 16983 //
     /* 101551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 101554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xbegin),
     /* 101559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 101566 */     // (intrinsic_w_chain:{ *:[i32] } 14918:{ *:[iPTR] })  =>  (XBEGIN:{ *:[i32] })
     /* 101566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XBEGIN),
     /* 101569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101575 */     GIR_RootConstrainSelectedInstOperands,
     /* 101576 */     // GIR_Coverage, 16983,
     /* 101576 */     GIR_EraseRootFromParent_Done,
     /* 101577 */   // Label 2164: @101577
     /* 101577 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(101608), // Rule ID 17118 //
     /* 101582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 101585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdfsbase_32),
     /* 101590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 101597 */     // (intrinsic_w_chain:{ *:[i32] } 14569:{ *:[iPTR] })  =>  (RDFSBASE:{ *:[i32] })
     /* 101597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFSBASE),
     /* 101600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101606 */     GIR_RootConstrainSelectedInstOperands,
     /* 101607 */     // GIR_Coverage, 17118,
     /* 101607 */     GIR_EraseRootFromParent_Done,
     /* 101608 */   // Label 2165: @101608
     /* 101608 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(101639), // Rule ID 17119 //
     /* 101613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 101616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdfsbase_64),
     /* 101621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 101624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 101628 */     // (intrinsic_w_chain:{ *:[i64] } 14570:{ *:[iPTR] })  =>  (RDFSBASE64:{ *:[i64] })
     /* 101628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFSBASE64),
     /* 101631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101637 */     GIR_RootConstrainSelectedInstOperands,
     /* 101638 */     // GIR_Coverage, 17119,
     /* 101638 */     GIR_EraseRootFromParent_Done,
     /* 101639 */   // Label 2166: @101639
     /* 101639 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(101670), // Rule ID 17120 //
     /* 101644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 101647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdgsbase_32),
     /* 101652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 101659 */     // (intrinsic_w_chain:{ *:[i32] } 14571:{ *:[iPTR] })  =>  (RDGSBASE:{ *:[i32] })
     /* 101659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDGSBASE),
     /* 101662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101668 */     GIR_RootConstrainSelectedInstOperands,
     /* 101669 */     // GIR_Coverage, 17120,
     /* 101669 */     GIR_EraseRootFromParent_Done,
     /* 101670 */   // Label 2167: @101670
     /* 101670 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(101701), // Rule ID 17121 //
     /* 101675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 101678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdgsbase_64),
     /* 101683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 101686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 101690 */     // (intrinsic_w_chain:{ *:[i64] } 14572:{ *:[iPTR] })  =>  (RDGSBASE64:{ *:[i64] })
     /* 101690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDGSBASE64),
     /* 101693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101699 */     GIR_RootConstrainSelectedInstOperands,
     /* 101700 */     // GIR_Coverage, 17121,
     /* 101700 */     GIR_EraseRootFromParent_Done,
     /* 101701 */   // Label 2168: @101701
     /* 101701 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(101732), // Rule ID 17127 //
     /* 101706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDPID_Not64BitMode),
     /* 101709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdpid),
     /* 101714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 101721 */     // (intrinsic_w_chain:{ *:[i32] } 14573:{ *:[iPTR] })  =>  (RDPID32:{ *:[i32] })
     /* 101721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDPID32),
     /* 101724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101730 */     GIR_RootConstrainSelectedInstOperands,
     /* 101731 */     // GIR_Coverage, 17127,
     /* 101731 */     GIR_EraseRootFromParent_Done,
     /* 101732 */   // Label 2169: @101732
     /* 101732 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(101789), // Rule ID 22380 //
     /* 101737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDPID_In64BitMode),
     /* 101740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdpid),
     /* 101745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 101752 */     // (intrinsic_w_chain:{ *:[i32] } 14573:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (RDPID64:{ *:[i64] }), sub_32bit:{ *:[i32] })
     /* 101752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 101755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::RDPID64),
     /* 101759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101771 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_32bit),
     /* 101778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 101783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 101788 */     // GIR_Coverage, 22380,
     /* 101788 */     GIR_EraseRootFromParent_Done,
     /* 101789 */   // Label 2170: @101789
     /* 101789 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(101829), // Rule ID 3 //
     /* 101794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 101797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_flags_write_u32),
     /* 101802 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 101809 */     // (intrinsic_void 14464:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRFLAGS32:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 101809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFLAGS32),
     /* 101812 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 101814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 101817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/1,
     /* 101820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::DF*/2,
     /* 101823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101827 */     GIR_RootConstrainSelectedInstOperands,
     /* 101828 */     // GIR_Coverage, 3,
     /* 101828 */     GIR_EraseRootFromParent_Done,
     /* 101829 */   // Label 2171: @101829
     /* 101829 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(101869), // Rule ID 4 //
     /* 101834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 101837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_flags_write_u64),
     /* 101842 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 101845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 101849 */     // (intrinsic_void 14465:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRFLAGS64:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 101849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFLAGS64),
     /* 101852 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 101854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::RSP*/0,
     /* 101857 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/1,
     /* 101860 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::DF*/2,
     /* 101863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101867 */     GIR_RootConstrainSelectedInstOperands,
     /* 101868 */     // GIR_Coverage, 4,
     /* 101868 */     GIR_EraseRootFromParent_Done,
     /* 101869 */   // Label 2172: @101869
     /* 101869 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(101900), // Rule ID 154 //
     /* 101874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 101877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_senduipi),
     /* 101882 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 101885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 101889 */     // (intrinsic_void 14592:{ *:[iPTR] }, GR64:{ *:[i64] }:$arg)  =>  (SENDUIPI GR64:{ *:[i64] }:$arg)
     /* 101889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SENDUIPI),
     /* 101892 */     GIR_RootToRootCopy, /*OpIdx*/1, // arg
     /* 101894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101898 */     GIR_RootConstrainSelectedInstOperands,
     /* 101899 */     // GIR_Coverage, 154,
     /* 101899 */     GIR_EraseRootFromParent_Done,
     /* 101900 */   // Label 2173: @101900
     /* 101900 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(101931), // Rule ID 17087 //
     /* 101905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_incsspd),
     /* 101910 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 101917 */     // (intrinsic_void 14474:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (INCSSPD GR32:{ *:[i32] }:$src)
     /* 101917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INCSSPD),
     /* 101920 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 101922 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 101925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101929 */     GIR_RootConstrainSelectedInstOperands,
     /* 101930 */     // GIR_Coverage, 17087,
     /* 101930 */     GIR_EraseRootFromParent_Done,
     /* 101931 */   // Label 2174: @101931
     /* 101931 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(101962), // Rule ID 17088 //
     /* 101936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_incsspq),
     /* 101941 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 101944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 101948 */     // (intrinsic_void 14475:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (INCSSPQ GR64:{ *:[i64] }:$src)
     /* 101948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INCSSPQ),
     /* 101951 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 101953 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 101956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101960 */     GIR_RootConstrainSelectedInstOperands,
     /* 101961 */     // GIR_Coverage, 17088,
     /* 101961 */     GIR_EraseRootFromParent_Done,
     /* 101962 */   // Label 2175: @101962
     /* 101962 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(101993), // Rule ID 17122 //
     /* 101967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 101970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrfsbase_32),
     /* 101975 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 101982 */     // (intrinsic_void 14908:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRFSBASE GR32:{ *:[i32] }:$src)
     /* 101982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFSBASE),
     /* 101985 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 101987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101991 */     GIR_RootConstrainSelectedInstOperands,
     /* 101992 */     // GIR_Coverage, 17122,
     /* 101992 */     GIR_EraseRootFromParent_Done,
     /* 101993 */   // Label 2176: @101993
     /* 101993 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(102024), // Rule ID 17123 //
     /* 101998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrfsbase_64),
     /* 102006 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102013 */     // (intrinsic_void 14909:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRFSBASE64 GR64:{ *:[i64] }:$src)
     /* 102013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFSBASE64),
     /* 102016 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102022 */     GIR_RootConstrainSelectedInstOperands,
     /* 102023 */     // GIR_Coverage, 17123,
     /* 102023 */     GIR_EraseRootFromParent_Done,
     /* 102024 */   // Label 2177: @102024
     /* 102024 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(102055), // Rule ID 17124 //
     /* 102029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrgsbase_32),
     /* 102037 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102044 */     // (intrinsic_void 14910:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRGSBASE GR32:{ *:[i32] }:$src)
     /* 102044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRGSBASE),
     /* 102047 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102053 */     GIR_RootConstrainSelectedInstOperands,
     /* 102054 */     // GIR_Coverage, 17124,
     /* 102054 */     GIR_EraseRootFromParent_Done,
     /* 102055 */   // Label 2178: @102055
     /* 102055 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(102086), // Rule ID 17125 //
     /* 102060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrgsbase_64),
     /* 102068 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102075 */     // (intrinsic_void 14911:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRGSBASE64 GR64:{ *:[i64] }:$src)
     /* 102075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRGSBASE64),
     /* 102078 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102084 */     GIR_RootConstrainSelectedInstOperands,
     /* 102085 */     // GIR_Coverage, 17125,
     /* 102085 */     GIR_EraseRootFromParent_Done,
     /* 102086 */   // Label 2179: @102086
     /* 102086 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(102117), // Rule ID 17130 //
     /* 102091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE),
     /* 102094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite32),
     /* 102099 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102106 */     // (intrinsic_void 14567:{ *:[iPTR] }, GR32:{ *:[i32] }:$dst)  =>  (PTWRITEr GR32:{ *:[i32] }:$dst)
     /* 102106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITEr),
     /* 102109 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 102111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102115 */     GIR_RootConstrainSelectedInstOperands,
     /* 102116 */     // GIR_Coverage, 17130,
     /* 102116 */     GIR_EraseRootFromParent_Done,
     /* 102117 */   // Label 2180: @102117
     /* 102117 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(102148), // Rule ID 17131 //
     /* 102122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE_In64BitMode),
     /* 102125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite64),
     /* 102130 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102137 */     // (intrinsic_void 14568:{ *:[iPTR] }, GR64:{ *:[i64] }:$dst)  =>  (PTWRITE64r GR64:{ *:[i64] }:$dst)
     /* 102137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITE64r),
     /* 102140 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 102142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102146 */     GIR_RootConstrainSelectedInstOperands,
     /* 102147 */     // GIR_Coverage, 17131,
     /* 102147 */     GIR_EraseRootFromParent_Done,
     /* 102148 */   // Label 2181: @102148
     /* 102148 */   GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(102180), // Rule ID 114 //
     /* 102153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_llwpcb),
     /* 102161 */     // MIs[0] src
     /* 102161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 102165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102169 */     // (intrinsic_void 14480:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (LLWPCB GR32:{ *:[i32] }:$src)
     /* 102169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LLWPCB),
     /* 102172 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102178 */     GIR_RootConstrainSelectedInstOperands,
     /* 102179 */     // GIR_Coverage, 114,
     /* 102179 */     GIR_EraseRootFromParent_Done,
     /* 102180 */   // Label 2182: @102180
     /* 102180 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(102212), // Rule ID 116 //
     /* 102185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_llwpcb),
     /* 102193 */     // MIs[0] src
     /* 102193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102201 */     // (intrinsic_void 14480:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (LLWPCB64 GR64:{ *:[i64] }:$src)
     /* 102201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LLWPCB64),
     /* 102204 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102210 */     GIR_RootConstrainSelectedInstOperands,
     /* 102211 */     // GIR_Coverage, 116,
     /* 102211 */     GIR_EraseRootFromParent_Done,
     /* 102212 */   // Label 2183: @102212
     /* 102212 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(102244), // Rule ID 126 //
     /* 102217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG_Not64BitMode),
     /* 102220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 102225 */     // MIs[0] src
     /* 102225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/16,
     /* 102229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 102233 */     // (intrinsic_void 14865:{ *:[iPTR] }, GR16:{ *:[i16] }:$src)  =>  (UMONITOR16 GR16:{ *:[i16] }:$src)
     /* 102233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR16),
     /* 102236 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102242 */     GIR_RootConstrainSelectedInstOperands,
     /* 102243 */     // GIR_Coverage, 126,
     /* 102243 */     GIR_EraseRootFromParent_Done,
     /* 102244 */   // Label 2184: @102244
     /* 102244 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(102276), // Rule ID 127 //
     /* 102249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG),
     /* 102252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 102257 */     // MIs[0] src
     /* 102257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 102261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102265 */     // (intrinsic_void 14865:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (UMONITOR32 GR32:{ *:[i32] }:$src)
     /* 102265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR32),
     /* 102268 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102274 */     GIR_RootConstrainSelectedInstOperands,
     /* 102275 */     // GIR_Coverage, 127,
     /* 102275 */     GIR_EraseRootFromParent_Done,
     /* 102276 */   // Label 2185: @102276
     /* 102276 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(102308), // Rule ID 128 //
     /* 102281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG_In64BitMode),
     /* 102284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 102289 */     // MIs[0] src
     /* 102289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102297 */     // (intrinsic_void 14865:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (UMONITOR64 GR64:{ *:[i64] }:$src)
     /* 102297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR64),
     /* 102300 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102306 */     GIR_RootConstrainSelectedInstOperands,
     /* 102307 */     // GIR_Coverage, 128,
     /* 102307 */     GIR_EraseRootFromParent_Done,
     /* 102308 */   // Label 2186: @102308
     /* 102308 */   GIM_Reject,
     /* 102309 */ // Label 2134: @102309
     /* 102309 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(105303),
     /* 102314 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 102317 */   GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(102363), // Rule ID 165 //
     /* 102322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 102325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsqi),
     /* 102330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 102333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 102337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102348 */     // (intrinsic_w_chain:{ *:[i8] } 14560:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /* 102348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS8rm),
     /* 102351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102353 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102361 */     GIR_RootConstrainSelectedInstOperands,
     /* 102362 */     // GIR_Coverage, 165,
     /* 102362 */     GIR_EraseRootFromParent_Done,
     /* 102363 */   // Label 2188: @102363
     /* 102363 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(102409), // Rule ID 166 //
     /* 102368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 102371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrshi),
     /* 102376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 102379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 102383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102394 */     // (intrinsic_w_chain:{ *:[i16] } 14559:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 102394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS16rm),
     /* 102397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102399 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102407 */     GIR_RootConstrainSelectedInstOperands,
     /* 102408 */     // GIR_Coverage, 166,
     /* 102408 */     GIR_EraseRootFromParent_Done,
     /* 102409 */   // Label 2189: @102409
     /* 102409 */   GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(102455), // Rule ID 167 //
     /* 102414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 102417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrssi),
     /* 102422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102429 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102440 */     // (intrinsic_w_chain:{ *:[i32] } 14561:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 102440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS32rm),
     /* 102443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102445 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102453 */     GIR_RootConstrainSelectedInstOperands,
     /* 102454 */     // GIR_Coverage, 167,
     /* 102454 */     GIR_EraseRootFromParent_Done,
     /* 102455 */   // Label 2190: @102455
     /* 102455 */   GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(102501), // Rule ID 168 //
     /* 102460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 102463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsdi),
     /* 102468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102486 */     // (intrinsic_w_chain:{ *:[i64] } 14558:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 102486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS64rm),
     /* 102489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102491 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102499 */     GIR_RootConstrainSelectedInstOperands,
     /* 102500 */     // GIR_Coverage, 168,
     /* 102500 */     GIR_EraseRootFromParent_Done,
     /* 102501 */   // Label 2191: @102501
     /* 102501 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(102547), // Rule ID 170 //
     /* 102506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 102509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsqi),
     /* 102514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 102517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 102521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102532 */     // (intrinsic_w_chain:{ *:[i8] } 14560:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS8rm_EVEX:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /* 102532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS8rm_EVEX),
     /* 102535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102537 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102545 */     GIR_RootConstrainSelectedInstOperands,
     /* 102546 */     // GIR_Coverage, 170,
     /* 102546 */     GIR_EraseRootFromParent_Done,
     /* 102547 */   // Label 2192: @102547
     /* 102547 */   GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(102593), // Rule ID 171 //
     /* 102552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 102555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrshi),
     /* 102560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 102563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 102567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102578 */     // (intrinsic_w_chain:{ *:[i16] } 14559:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS16rm_EVEX:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 102578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS16rm_EVEX),
     /* 102581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102583 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102591 */     GIR_RootConstrainSelectedInstOperands,
     /* 102592 */     // GIR_Coverage, 171,
     /* 102592 */     GIR_EraseRootFromParent_Done,
     /* 102593 */   // Label 2193: @102593
     /* 102593 */   GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(102639), // Rule ID 172 //
     /* 102598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 102601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrssi),
     /* 102606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102624 */     // (intrinsic_w_chain:{ *:[i32] } 14561:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 102624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS32rm_EVEX),
     /* 102627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102629 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102637 */     GIR_RootConstrainSelectedInstOperands,
     /* 102638 */     // GIR_Coverage, 172,
     /* 102638 */     GIR_EraseRootFromParent_Done,
     /* 102639 */   // Label 2194: @102639
     /* 102639 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(102685), // Rule ID 173 //
     /* 102644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 102647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsdi),
     /* 102652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102670 */     // (intrinsic_w_chain:{ *:[i64] } 14558:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 102670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS64rm_EVEX),
     /* 102673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102675 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102683 */     GIR_RootConstrainSelectedInstOperands,
     /* 102684 */     // GIR_Coverage, 173,
     /* 102684 */     GIR_EraseRootFromParent_Done,
     /* 102685 */   // Label 2195: @102685
     /* 102685 */   GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(102731), // Rule ID 2950 //
     /* 102690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 102693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse3_ldu_dq),
     /* 102698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 102701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 102705 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102716 */     // (intrinsic_w_chain:{ *:[v16i8] } 14706:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VLDDQUrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 102716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VLDDQUrm),
     /* 102719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102721 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102729 */     GIR_RootConstrainSelectedInstOperands,
     /* 102730 */     // GIR_Coverage, 2950,
     /* 102730 */     GIR_EraseRootFromParent_Done,
     /* 102731 */   // Label 2196: @102731
     /* 102731 */   GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(102777), // Rule ID 2951 //
     /* 102736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 102739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_ldu_dq_256),
     /* 102744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /* 102747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 102751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102762 */     // (intrinsic_w_chain:{ *:[v32i8] } 13327:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VLDDQUYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /* 102762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VLDDQUYrm),
     /* 102765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102767 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102775 */     GIR_RootConstrainSelectedInstOperands,
     /* 102776 */     // GIR_Coverage, 2951,
     /* 102776 */     GIR_EraseRootFromParent_Done,
     /* 102777 */   // Label 2197: @102777
     /* 102777 */   GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(102823), // Rule ID 2952 //
     /* 102782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE3),
     /* 102785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse3_ldu_dq),
     /* 102790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 102793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 102797 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102808 */     // (intrinsic_w_chain:{ *:[v16i8] } 14706:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDDQUrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 102808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDDQUrm),
     /* 102811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102813 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102821 */     GIR_RootConstrainSelectedInstOperands,
     /* 102822 */     // GIR_Coverage, 2952,
     /* 102822 */     GIR_EraseRootFromParent_Done,
     /* 102823 */   // Label 2198: @102823
     /* 102823 */   GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(102869), // Rule ID 3542 //
     /* 102828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 102831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnebf162ps128),
     /* 102836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 102839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 102843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102854 */     // (intrinsic_w_chain:{ *:[v4f32] } 14869:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNEBF162PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 102854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNEBF162PSrm),
     /* 102857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102859 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102867 */     GIR_RootConstrainSelectedInstOperands,
     /* 102868 */     // GIR_Coverage, 3542,
     /* 102868 */     GIR_EraseRootFromParent_Done,
     /* 102869 */   // Label 2199: @102869
     /* 102869 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(102915), // Rule ID 3543 //
     /* 102874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 102877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnebf162ps256),
     /* 102882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 102885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 102889 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102900 */     // (intrinsic_w_chain:{ *:[v8f32] } 14870:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNEBF162PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 102900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNEBF162PSYrm),
     /* 102903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102905 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102913 */     GIR_RootConstrainSelectedInstOperands,
     /* 102914 */     // GIR_Coverage, 3543,
     /* 102914 */     GIR_EraseRootFromParent_Done,
     /* 102915 */   // Label 2200: @102915
     /* 102915 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(102961), // Rule ID 3544 //
     /* 102920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 102923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnesh2ps128),
     /* 102928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 102931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 102935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102946 */     // (intrinsic_w_chain:{ *:[v4f32] } 14871:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNESH2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 102946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNESH2PSrm),
     /* 102949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102951 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102959 */     GIR_RootConstrainSelectedInstOperands,
     /* 102960 */     // GIR_Coverage, 3544,
     /* 102960 */     GIR_EraseRootFromParent_Done,
     /* 102961 */   // Label 2201: @102961
     /* 102961 */   GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(103007), // Rule ID 3545 //
     /* 102966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 102969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnesh2ps256),
     /* 102974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 102977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 102981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 102985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102992 */     // (intrinsic_w_chain:{ *:[v8f32] } 14872:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNESH2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 102992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNESH2PSYrm),
     /* 102995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102997 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103005 */     GIR_RootConstrainSelectedInstOperands,
     /* 103006 */     // GIR_Coverage, 3545,
     /* 103006 */     GIR_EraseRootFromParent_Done,
     /* 103007 */   // Label 2202: @103007
     /* 103007 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(103053), // Rule ID 3546 //
     /* 103012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneebf162ps128),
     /* 103020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103038 */     // (intrinsic_w_chain:{ *:[v4f32] } 14873:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEBF162PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEBF162PSrm),
     /* 103041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103043 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103051 */     GIR_RootConstrainSelectedInstOperands,
     /* 103052 */     // GIR_Coverage, 3546,
     /* 103052 */     GIR_EraseRootFromParent_Done,
     /* 103053 */   // Label 2203: @103053
     /* 103053 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(103099), // Rule ID 3547 //
     /* 103058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneebf162ps256),
     /* 103066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103084 */     // (intrinsic_w_chain:{ *:[v8f32] } 14874:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEBF162PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEBF162PSYrm),
     /* 103087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103089 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103097 */     GIR_RootConstrainSelectedInstOperands,
     /* 103098 */     // GIR_Coverage, 3547,
     /* 103098 */     GIR_EraseRootFromParent_Done,
     /* 103099 */   // Label 2204: @103099
     /* 103099 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(103145), // Rule ID 3548 //
     /* 103104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneeph2ps128),
     /* 103112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103130 */     // (intrinsic_w_chain:{ *:[v4f32] } 14875:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEPH2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEPH2PSrm),
     /* 103133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103135 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103143 */     GIR_RootConstrainSelectedInstOperands,
     /* 103144 */     // GIR_Coverage, 3548,
     /* 103144 */     GIR_EraseRootFromParent_Done,
     /* 103145 */   // Label 2205: @103145
     /* 103145 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(103191), // Rule ID 3549 //
     /* 103150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneeph2ps256),
     /* 103158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103176 */     // (intrinsic_w_chain:{ *:[v8f32] } 14876:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEPH2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEPH2PSYrm),
     /* 103179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103181 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103189 */     GIR_RootConstrainSelectedInstOperands,
     /* 103190 */     // GIR_Coverage, 3549,
     /* 103190 */     GIR_EraseRootFromParent_Done,
     /* 103191 */   // Label 2206: @103191
     /* 103191 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(103237), // Rule ID 3550 //
     /* 103196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneobf162ps128),
     /* 103204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103222 */     // (intrinsic_w_chain:{ *:[v4f32] } 14877:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOBF162PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOBF162PSrm),
     /* 103225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103227 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103235 */     GIR_RootConstrainSelectedInstOperands,
     /* 103236 */     // GIR_Coverage, 3550,
     /* 103236 */     GIR_EraseRootFromParent_Done,
     /* 103237 */   // Label 2207: @103237
     /* 103237 */   GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(103283), // Rule ID 3551 //
     /* 103242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneobf162ps256),
     /* 103250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103268 */     // (intrinsic_w_chain:{ *:[v8f32] } 14878:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOBF162PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOBF162PSYrm),
     /* 103271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103273 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103281 */     GIR_RootConstrainSelectedInstOperands,
     /* 103282 */     // GIR_Coverage, 3551,
     /* 103282 */     GIR_EraseRootFromParent_Done,
     /* 103283 */   // Label 2208: @103283
     /* 103283 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(103329), // Rule ID 3552 //
     /* 103288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneoph2ps128),
     /* 103296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103314 */     // (intrinsic_w_chain:{ *:[v4f32] } 14879:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOPH2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOPH2PSrm),
     /* 103317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103319 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103327 */     GIR_RootConstrainSelectedInstOperands,
     /* 103328 */     // GIR_Coverage, 3552,
     /* 103328 */     GIR_EraseRootFromParent_Done,
     /* 103329 */   // Label 2209: @103329
     /* 103329 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(103375), // Rule ID 3553 //
     /* 103334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneoph2ps256),
     /* 103342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103360 */     // (intrinsic_w_chain:{ *:[v8f32] } 14880:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOPH2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOPH2PSYrm),
     /* 103363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103365 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103373 */     GIR_RootConstrainSelectedInstOperands,
     /* 103374 */     // GIR_Coverage, 3553,
     /* 103374 */     GIR_EraseRootFromParent_Done,
     /* 103375 */   // Label 2210: @103375
     /* 103375 */   GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(103421), // Rule ID 16752 //
     /* 103380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 103383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsb512),
     /* 103388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v64s8,
     /* 103391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 103395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103406 */     // (intrinsic_w_chain:{ *:[v64i8] } 13583:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSBZm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)
     /* 103406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSBZm),
     /* 103409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103411 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103419 */     GIR_RootConstrainSelectedInstOperands,
     /* 103420 */     // GIR_Coverage, 16752,
     /* 103420 */     GIR_EraseRootFromParent_Done,
     /* 103421 */   // Label 2211: @103421
     /* 103421 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(103467), // Rule ID 16755 //
     /* 103426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 103429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsb128),
     /* 103434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 103437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 103441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103452 */     // (intrinsic_w_chain:{ *:[v16i8] } 13581:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSBZ128m:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 103452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSBZ128m),
     /* 103455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103457 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103465 */     GIR_RootConstrainSelectedInstOperands,
     /* 103466 */     // GIR_Coverage, 16755,
     /* 103466 */     GIR_EraseRootFromParent_Done,
     /* 103467 */   // Label 2212: @103467
     /* 103467 */   GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(103513), // Rule ID 16758 //
     /* 103472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 103475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsb256),
     /* 103480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /* 103483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 103487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103498 */     // (intrinsic_w_chain:{ *:[v32i8] } 13582:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSBZ256m:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /* 103498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSBZ256m),
     /* 103501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103503 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103511 */     GIR_RootConstrainSelectedInstOperands,
     /* 103512 */     // GIR_Coverage, 16758,
     /* 103512 */     GIR_EraseRootFromParent_Done,
     /* 103513 */   // Label 2213: @103513
     /* 103513 */   GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(103559), // Rule ID 16761 //
     /* 103518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 103521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsw512),
     /* 103526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 103529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 103533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103544 */     // (intrinsic_w_chain:{ *:[v32i16] } 13592:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSWZm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /* 103544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSWZm),
     /* 103547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103549 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103557 */     GIR_RootConstrainSelectedInstOperands,
     /* 103558 */     // GIR_Coverage, 16761,
     /* 103558 */     GIR_EraseRootFromParent_Done,
     /* 103559 */   // Label 2214: @103559
     /* 103559 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(103605), // Rule ID 16764 //
     /* 103564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 103567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsw128),
     /* 103572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 103575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 103579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103590 */     // (intrinsic_w_chain:{ *:[v8i16] } 13590:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSWZ128m:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /* 103590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSWZ128m),
     /* 103593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103595 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103603 */     GIR_RootConstrainSelectedInstOperands,
     /* 103604 */     // GIR_Coverage, 16764,
     /* 103604 */     GIR_EraseRootFromParent_Done,
     /* 103605 */   // Label 2215: @103605
     /* 103605 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(103651), // Rule ID 16767 //
     /* 103610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 103613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsw256),
     /* 103618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 103621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 103625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103636 */     // (intrinsic_w_chain:{ *:[v16i16] } 13591:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSWZ256m:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 103636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSWZ256m),
     /* 103639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103641 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103649 */     GIR_RootConstrainSelectedInstOperands,
     /* 103650 */     // GIR_Coverage, 16767,
     /* 103650 */     GIR_EraseRootFromParent_Done,
     /* 103651 */   // Label 2216: @103651
     /* 103651 */   GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(103697), // Rule ID 16770 //
     /* 103656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 103659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsd512),
     /* 103664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 103667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 103671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103682 */     // (intrinsic_w_chain:{ *:[v16i32] } 13586:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSDZm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 103682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSDZm),
     /* 103685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103687 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103695 */     GIR_RootConstrainSelectedInstOperands,
     /* 103696 */     // GIR_Coverage, 16770,
     /* 103696 */     GIR_EraseRootFromParent_Done,
     /* 103697 */   // Label 2217: @103697
     /* 103697 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(103743), // Rule ID 16773 //
     /* 103702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 103705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsd128),
     /* 103710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 103717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103728 */     // (intrinsic_w_chain:{ *:[v4i32] } 13584:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSDZ128m:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /* 103728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSDZ128m),
     /* 103731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103733 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103741 */     GIR_RootConstrainSelectedInstOperands,
     /* 103742 */     // GIR_Coverage, 16773,
     /* 103742 */     GIR_EraseRootFromParent_Done,
     /* 103743 */   // Label 2218: @103743
     /* 103743 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(103789), // Rule ID 16776 //
     /* 103748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 103751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsd256),
     /* 103756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 103763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103774 */     // (intrinsic_w_chain:{ *:[v8i32] } 13585:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSDZ256m:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 103774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSDZ256m),
     /* 103777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103779 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103787 */     GIR_RootConstrainSelectedInstOperands,
     /* 103788 */     // GIR_Coverage, 16776,
     /* 103788 */     GIR_EraseRootFromParent_Done,
     /* 103789 */   // Label 2219: @103789
     /* 103789 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(103835), // Rule ID 16779 //
     /* 103794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 103797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsq512),
     /* 103802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /* 103805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 103809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103820 */     // (intrinsic_w_chain:{ *:[v8i64] } 13589:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSQZm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 103820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSQZm),
     /* 103823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103825 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103833 */     GIR_RootConstrainSelectedInstOperands,
     /* 103834 */     // GIR_Coverage, 16779,
     /* 103834 */     GIR_EraseRootFromParent_Done,
     /* 103835 */   // Label 2220: @103835
     /* 103835 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(103881), // Rule ID 16782 //
     /* 103840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 103843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsq128),
     /* 103848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 103851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 103855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103866 */     // (intrinsic_w_chain:{ *:[v2i64] } 13587:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSQZ128m:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /* 103866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSQZ128m),
     /* 103869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103871 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103879 */     GIR_RootConstrainSelectedInstOperands,
     /* 103880 */     // GIR_Coverage, 16782,
     /* 103880 */     GIR_EraseRootFromParent_Done,
     /* 103881 */   // Label 2221: @103881
     /* 103881 */   GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(103927), // Rule ID 16785 //
     /* 103886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 103889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsq256),
     /* 103894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 103897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 103901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103912 */     // (intrinsic_w_chain:{ *:[v4i64] } 13588:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSQZ256m:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 103912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSQZ256m),
     /* 103915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103917 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103925 */     GIR_RootConstrainSelectedInstOperands,
     /* 103926 */     // GIR_Coverage, 16785,
     /* 103926 */     GIR_EraseRootFromParent_Done,
     /* 103927 */   // Label 2222: @103927
     /* 103927 */   GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(103973), // Rule ID 17093 //
     /* 103932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 103935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssd),
     /* 103940 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 103943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 103947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103958 */     // (intrinsic_void 14913:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSD addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 103958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSD),
     /* 103961 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 103965 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 103967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103971 */     GIR_RootConstrainSelectedInstOperands,
     /* 103972 */     // GIR_Coverage, 17093,
     /* 103972 */     GIR_EraseRootFromParent_Done,
     /* 103973 */   // Label 2223: @103973
     /* 103973 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(104019), // Rule ID 17094 //
     /* 103978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 103981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssq),
     /* 103986 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 103989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 103993 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104004 */     // (intrinsic_void 14914:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSQ addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSQ),
     /* 104007 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104011 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104017 */     GIR_RootConstrainSelectedInstOperands,
     /* 104018 */     // GIR_Coverage, 17094,
     /* 104018 */     GIR_EraseRootFromParent_Done,
     /* 104019 */   // Label 2224: @104019
     /* 104019 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(104065), // Rule ID 17095 //
     /* 104024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussd),
     /* 104032 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104050 */     // (intrinsic_void 14915:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSD addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSD),
     /* 104053 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104057 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104063 */     GIR_RootConstrainSelectedInstOperands,
     /* 104064 */     // GIR_Coverage, 17095,
     /* 104064 */     GIR_EraseRootFromParent_Done,
     /* 104065 */   // Label 2225: @104065
     /* 104065 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(104111), // Rule ID 17096 //
     /* 104070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussq),
     /* 104078 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104096 */     // (intrinsic_void 14916:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSQ addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSQ),
     /* 104099 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104103 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104109 */     GIR_RootConstrainSelectedInstOperands,
     /* 104110 */     // GIR_Coverage, 17096,
     /* 104110 */     GIR_EraseRootFromParent_Done,
     /* 104111 */   // Label 2226: @104111
     /* 104111 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(104157), // Rule ID 17097 //
     /* 104116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssd),
     /* 104124 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104142 */     // (intrinsic_void 14913:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSD_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSD_EVEX),
     /* 104145 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104149 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104155 */     GIR_RootConstrainSelectedInstOperands,
     /* 104156 */     // GIR_Coverage, 17097,
     /* 104156 */     GIR_EraseRootFromParent_Done,
     /* 104157 */   // Label 2227: @104157
     /* 104157 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(104203), // Rule ID 17098 //
     /* 104162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssq),
     /* 104170 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104188 */     // (intrinsic_void 14914:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSQ_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSQ_EVEX),
     /* 104191 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104195 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104201 */     GIR_RootConstrainSelectedInstOperands,
     /* 104202 */     // GIR_Coverage, 17098,
     /* 104202 */     GIR_EraseRootFromParent_Done,
     /* 104203 */   // Label 2228: @104203
     /* 104203 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(104249), // Rule ID 17099 //
     /* 104208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussd),
     /* 104216 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104234 */     // (intrinsic_void 14915:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSD_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSD_EVEX),
     /* 104237 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104241 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104247 */     GIR_RootConstrainSelectedInstOperands,
     /* 104248 */     // GIR_Coverage, 17099,
     /* 104248 */     GIR_EraseRootFromParent_Done,
     /* 104249 */   // Label 2229: @104249
     /* 104249 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(104295), // Rule ID 17100 //
     /* 104254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussq),
     /* 104262 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104280 */     // (intrinsic_void 14916:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSQ_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSQ_EVEX),
     /* 104283 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104287 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104293 */     GIR_RootConstrainSelectedInstOperands,
     /* 104294 */     // GIR_Coverage, 17100,
     /* 104294 */     GIR_EraseRootFromParent_Done,
     /* 104295 */   // Label 2230: @104295
     /* 104295 */   GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(104341), // Rule ID 17126 //
     /* 104300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasINVPCID_Not64BitMode),
     /* 104303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_invpcid),
     /* 104308 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104326 */     // (intrinsic_void 14477:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)  =>  (INVPCID32 GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 104326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INVPCID32),
     /* 104329 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 104331 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 104335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104339 */     GIR_RootConstrainSelectedInstOperands,
     /* 104340 */     // GIR_Coverage, 17126,
     /* 104340 */     GIR_EraseRootFromParent_Done,
     /* 104341 */   // Label 2231: @104341
     /* 104341 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(104433), // Rule ID 22378 //
     /* 104346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasINVPCID_NoEGPR),
     /* 104349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_invpcid),
     /* 104354 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104372 */     // (intrinsic_void 14477:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)  =>  (INVPCID64 (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1), sub_32bit:{ *:[i32] }), addr:{ *:[iPTR] }:$src2)
     /* 104372 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104375 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::MOV32rr),
     /* 104379 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104384 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 104388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104402 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 104405 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104408 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/6,
     /* 104411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 104416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 104421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INVPCID64),
     /* 104424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104427 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 104431 */     GIR_RootConstrainSelectedInstOperands,
     /* 104432 */     // GIR_Coverage, 22378,
     /* 104432 */     GIR_EraseRootFromParent_Done,
     /* 104433 */   // Label 2232: @104433
     /* 104433 */   GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(104525), // Rule ID 22379 //
     /* 104438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasINVPCID),
     /* 104441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_invpcid),
     /* 104446 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104453 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104464 */     // (intrinsic_void 14477:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)  =>  (INVPCID64_EVEX (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1), sub_32bit:{ *:[i32] }), addr:{ *:[iPTR] }:$src2)
     /* 104464 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104467 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::MOV32rr),
     /* 104471 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104476 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 104480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104494 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 104497 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104500 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/6,
     /* 104503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 104508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 104513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INVPCID64_EVEX),
     /* 104516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104519 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 104523 */     GIR_RootConstrainSelectedInstOperands,
     /* 104524 */     // GIR_Coverage, 22379,
     /* 104524 */     GIR_EraseRootFromParent_Done,
     /* 104525 */   // Label 2233: @104525
     /* 104525 */   GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(104571), // Rule ID 131 //
     /* 104530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIRI_NoEGPR),
     /* 104533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore32),
     /* 104538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 104541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104556 */     // (intrinsic_void 14456:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)  =>  (MOVDIRI32 addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI32),
     /* 104559 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104563 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 104565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104569 */     GIR_RootConstrainSelectedInstOperands,
     /* 104570 */     // GIR_Coverage, 131,
     /* 104570 */     GIR_EraseRootFromParent_Done,
     /* 104571 */   // Label 2234: @104571
     /* 104571 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(104617), // Rule ID 132 //
     /* 104576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIRI_In64BitMode_NoEGPR),
     /* 104579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore64),
     /* 104584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 104587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104602 */     // (intrinsic_void 14457:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)  =>  (MOVDIRI64 addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI64),
     /* 104605 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104609 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 104611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104615 */     GIR_RootConstrainSelectedInstOperands,
     /* 104616 */     // GIR_Coverage, 132,
     /* 104616 */     GIR_EraseRootFromParent_Done,
     /* 104617 */   // Label 2235: @104617
     /* 104617 */   GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(104663), // Rule ID 133 //
     /* 104622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIRI_In64BitMode),
     /* 104625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore32),
     /* 104630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 104633 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104648 */     // (intrinsic_void 14456:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)  =>  (MOVDIRI32_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI32_EVEX),
     /* 104651 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104655 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 104657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104661 */     GIR_RootConstrainSelectedInstOperands,
     /* 104662 */     // GIR_Coverage, 133,
     /* 104662 */     GIR_EraseRootFromParent_Done,
     /* 104663 */   // Label 2236: @104663
     /* 104663 */   GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(104709), // Rule ID 134 //
     /* 104668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIRI_In64BitMode),
     /* 104671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore64),
     /* 104676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 104679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104694 */     // (intrinsic_void 14457:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)  =>  (MOVDIRI64_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI64_EVEX),
     /* 104697 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104701 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 104703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104707 */     GIR_RootConstrainSelectedInstOperands,
     /* 104708 */     // GIR_Coverage, 134,
     /* 104708 */     GIR_EraseRootFromParent_Done,
     /* 104709 */   // Label 2237: @104709
     /* 104709 */   GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(104756), // Rule ID 135 //
     /* 104714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIR64B_NoEGPR),
     /* 104717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 104722 */     // MIs[0] dst
     /* 104722 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 104726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104741 */     // (intrinsic_void 14557:{ *:[iPTR] }, GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B32 GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 104741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B32),
     /* 104744 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 104746 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104754 */     GIR_RootConstrainSelectedInstOperands,
     /* 104755 */     // GIR_Coverage, 135,
     /* 104755 */     GIR_EraseRootFromParent_Done,
     /* 104756 */   // Label 2238: @104756
     /* 104756 */   GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(104803), // Rule ID 136 //
     /* 104761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIR64B_In64BitMode_NoEGPR),
     /* 104764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 104769 */     // MIs[0] dst
     /* 104769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104788 */     // (intrinsic_void 14557:{ *:[iPTR] }, GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B64 GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 104788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B64),
     /* 104791 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 104793 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104801 */     GIR_RootConstrainSelectedInstOperands,
     /* 104802 */     // GIR_Coverage, 136,
     /* 104802 */     GIR_EraseRootFromParent_Done,
     /* 104803 */   // Label 2239: @104803
     /* 104803 */   GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(104850), // Rule ID 137 //
     /* 104808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIR64B_In64BitMode),
     /* 104811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 104816 */     // MIs[0] dst
     /* 104816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 104820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104835 */     // (intrinsic_void 14557:{ *:[iPTR] }, GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B32_EVEX GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 104835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B32_EVEX),
     /* 104838 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 104840 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104848 */     GIR_RootConstrainSelectedInstOperands,
     /* 104849 */     // GIR_Coverage, 137,
     /* 104849 */     GIR_EraseRootFromParent_Done,
     /* 104850 */   // Label 2240: @104850
     /* 104850 */   GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(104897), // Rule ID 138 //
     /* 104855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIR64B_In64BitMode),
     /* 104858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 104863 */     // MIs[0] dst
     /* 104863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104882 */     // (intrinsic_void 14557:{ *:[iPTR] }, GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B64_EVEX GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 104882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B64_EVEX),
     /* 104885 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 104887 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104895 */     GIR_RootConstrainSelectedInstOperands,
     /* 104896 */     // GIR_Coverage, 138,
     /* 104896 */     GIR_EraseRootFromParent_Done,
     /* 104897 */   // Label 2241: @104897
     /* 104897 */   GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(104929), // Rule ID 17024 //
     /* 104902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTRANSPOSE_In64BitMode),
     /* 104905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttransposed),
     /* 104910 */     // MIs[0] dst
     /* 104910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 104913 */     // MIs[0] src
     /* 104913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 104916 */     // (intrinsic_void 14863:{ *:[iPTR] }, (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)  =>  (PTTRANSPOSED (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)
     /* 104916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTRANSPOSED),
     /* 104919 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 104921 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 104923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104927 */     GIR_RootConstrainSelectedInstOperands,
     /* 104928 */     // GIR_Coverage, 17024,
     /* 104928 */     GIR_EraseRootFromParent_Done,
     /* 104929 */   // Label 2242: @104929
     /* 104929 */   GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(104961), // Rule ID 17036 //
     /* 104934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 104937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tconjtfp16),
     /* 104942 */     // MIs[0] dst
     /* 104942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 104945 */     // MIs[0] src
     /* 104945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 104948 */     // (intrinsic_void 14802:{ *:[iPTR] }, (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)  =>  (PTCONJTFP16 (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)
     /* 104948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCONJTFP16),
     /* 104951 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 104953 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 104955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104959 */     GIR_RootConstrainSelectedInstOperands,
     /* 104960 */     // GIR_Coverage, 17036,
     /* 104960 */     GIR_EraseRootFromParent_Done,
     /* 104961 */   // Label 2243: @104961
     /* 104961 */   GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(105004), // Rule ID 17151 //
     /* 104966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::asan_check_memaccess),
     /* 104971 */     // MIs[0] addr
     /* 104971 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64PLTSafeRegClassID),
     /* 104979 */     // MIs[0] accessinfo
     /* 104979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 104982 */     // (intrinsic_void 9:{ *:[iPTR] }, GR64PLTSafe:{ *:[i64] }:$addr, (timm:{ *:[i32] }):$accessinfo)  =>  (ASAN_CHECK_MEMACCESS:{ *:[i64] } GR64PLTSafe:{ *:[i64] }:$addr, (timm:{ *:[i32] }):$accessinfo)
     /* 104982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ASAN_CHECK_MEMACCESS),
     /* 104985 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 104987 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 104989 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::R10*/0,
     /* 104992 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::R11*/1,
     /* 104995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/2,
     /* 104998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105002 */     GIR_RootConstrainSelectedInstOperands,
     /* 105003 */     // GIR_Coverage, 17151,
     /* 105003 */     GIR_EraseRootFromParent_Done,
     /* 105004 */   // Label 2244: @105004
     /* 105004 */   GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(105044), // Rule ID 17077 //
     /* 105009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUSERMSR_NoEGPR),
     /* 105012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_urdmsr),
     /* 105017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 105020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105031 */     // (intrinsic_w_chain:{ *:[i64] } 14867:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (URDMSRrr:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 105031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::URDMSRrr),
     /* 105034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105036 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105042 */     GIR_RootConstrainSelectedInstOperands,
     /* 105043 */     // GIR_Coverage, 17077,
     /* 105043 */     GIR_EraseRootFromParent_Done,
     /* 105044 */   // Label 2245: @105044
     /* 105044 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(105084), // Rule ID 17081 //
     /* 105049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasUSERMSR_In64BitMode),
     /* 105052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_urdmsr),
     /* 105057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 105060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105071 */     // (intrinsic_w_chain:{ *:[i64] } 14867:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (URDMSRrr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 105071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::URDMSRrr_EVEX),
     /* 105074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105076 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105082 */     GIR_RootConstrainSelectedInstOperands,
     /* 105083 */     // GIR_Coverage, 17081,
     /* 105083 */     GIR_EraseRootFromParent_Done,
     /* 105084 */   // Label 2246: @105084
     /* 105084 */   GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(105121), // Rule ID 17089 //
     /* 105089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdsspd),
     /* 105094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 105097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105108 */     // (intrinsic_w_chain:{ *:[i32] } 14583:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (RDSSPD:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 105108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDSSPD),
     /* 105111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105113 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105119 */     GIR_RootConstrainSelectedInstOperands,
     /* 105120 */     // GIR_Coverage, 17089,
     /* 105120 */     GIR_EraseRootFromParent_Done,
     /* 105121 */   // Label 2247: @105121
     /* 105121 */   GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(105158), // Rule ID 17090 //
     /* 105126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdsspq),
     /* 105131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 105134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105145 */     // (intrinsic_w_chain:{ *:[i64] } 14584:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (RDSSPQ:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 105145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDSSPQ),
     /* 105148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105150 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105156 */     GIR_RootConstrainSelectedInstOperands,
     /* 105157 */     // GIR_Coverage, 17090,
     /* 105157 */     GIR_EraseRootFromParent_Done,
     /* 105158 */   // Label 2248: @105158
     /* 105158 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(105222), // Rule ID 3085 //
     /* 105163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 105166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse3_mwait),
     /* 105171 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32_ArgRef_and_GR32_CBRegClassID),
     /* 105181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 105185 */     // (intrinsic_void 14708:{ *:[iPTR] }, ECX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (MWAITrr)
     /* 105185 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105189 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105195 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // EAX
     /* 105199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105203 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::ECX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105209 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // ECX
     /* 105213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MWAITrr),
     /* 105216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105220 */     GIR_RootConstrainSelectedInstOperands,
     /* 105221 */     // GIR_Coverage, 3085,
     /* 105221 */     GIR_EraseRootFromParent_Done,
     /* 105222 */   // Label 2249: @105222
     /* 105222 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(105262), // Rule ID 17079 //
     /* 105227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUSERMSR_NoEGPR),
     /* 105230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_uwrmsr),
     /* 105235 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105249 */     // (intrinsic_void 14868:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (UWRMSRrr GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 105249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UWRMSRrr),
     /* 105252 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105254 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 105256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105260 */     GIR_RootConstrainSelectedInstOperands,
     /* 105261 */     // GIR_Coverage, 17079,
     /* 105261 */     GIR_EraseRootFromParent_Done,
     /* 105262 */   // Label 2250: @105262
     /* 105262 */   GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(105302), // Rule ID 17083 //
     /* 105267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasUSERMSR_In64BitMode),
     /* 105270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_uwrmsr),
     /* 105275 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105289 */     // (intrinsic_void 14868:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (UWRMSRrr_EVEX GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 105289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UWRMSRrr_EVEX),
     /* 105292 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105294 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 105296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105300 */     GIR_RootConstrainSelectedInstOperands,
     /* 105301 */     // GIR_Coverage, 17083,
     /* 105301 */     GIR_EraseRootFromParent_Done,
     /* 105302 */   // Label 2251: @105302
     /* 105302 */   GIM_Reject,
     /* 105303 */ // Label 2187: @105303
     /* 105303 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(108848),
     /* 105308 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 105311 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(105383), // Rule ID 123 //
     /* 105316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 105319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval32),
     /* 105324 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105342 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105345 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105349 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 105353 */     // MIs[0] cntl
     /* 105353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 105356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105358 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105365 */     // (intrinsic_void 14484:{ *:[iPTR] }, GR32:{ *:[i32] }:$src0, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL32rmi GR32:{ *:[i32] }:$src0, addr:{ *:[iPTR] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 105365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL32rmi),
     /* 105368 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 105370 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 105374 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 105376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105381 */     GIR_RootConstrainSelectedInstOperands,
     /* 105382 */     // GIR_Coverage, 123,
     /* 105382 */     GIR_EraseRootFromParent_Done,
     /* 105383 */   // Label 2253: @105383
     /* 105383 */   GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(105455), // Rule ID 125 //
     /* 105388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 105391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval64),
     /* 105396 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105414 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105417 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105421 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 105425 */     // MIs[0] cntl
     /* 105425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 105428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105437 */     // (intrinsic_void 14485:{ *:[iPTR] }, GR64:{ *:[i64] }:$src0, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL64rmi GR64:{ *:[i64] }:$src0, addr:{ *:[iPTR] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 105437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL64rmi),
     /* 105440 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 105442 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 105446 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 105448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105453 */     GIR_RootConstrainSelectedInstOperands,
     /* 105454 */     // GIR_Coverage, 125,
     /* 105454 */     GIR_EraseRootFromParent_Done,
     /* 105455 */   // Label 2254: @105455
     /* 105455 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(105510), // Rule ID 3386 //
     /* 105460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 105463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_ps),
     /* 105468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 105471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 105474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 105478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 105486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105493 */     // (intrinsic_w_chain:{ *:[v4f32] } 13330:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src1)  =>  (VMASKMOVPSrm:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 105493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSrm),
     /* 105496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105498 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 105500 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 105504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105508 */     GIR_RootConstrainSelectedInstOperands,
     /* 105509 */     // GIR_Coverage, 3386,
     /* 105509 */     GIR_EraseRootFromParent_Done,
     /* 105510 */   // Label 2255: @105510
     /* 105510 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(105565), // Rule ID 3387 //
     /* 105515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 105518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_ps_256),
     /* 105523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 105526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 105529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 105533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 105541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105548 */     // (intrinsic_w_chain:{ *:[v8f32] } 13331:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8i32] }:$src1)  =>  (VMASKMOVPSYrm:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 105548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSYrm),
     /* 105551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105553 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 105555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 105559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105563 */     GIR_RootConstrainSelectedInstOperands,
     /* 105564 */     // GIR_Coverage, 3387,
     /* 105564 */     GIR_EraseRootFromParent_Done,
     /* 105565 */   // Label 2256: @105565
     /* 105565 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(105620), // Rule ID 3390 //
     /* 105570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 105573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_pd),
     /* 105578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 105581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 105584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 105588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 105596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105603 */     // (intrinsic_w_chain:{ *:[v2f64] } 13328:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src1)  =>  (VMASKMOVPDrm:{ *:[v2f64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 105603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDrm),
     /* 105606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105608 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 105610 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 105614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105618 */     GIR_RootConstrainSelectedInstOperands,
     /* 105619 */     // GIR_Coverage, 3390,
     /* 105619 */     GIR_EraseRootFromParent_Done,
     /* 105620 */   // Label 2257: @105620
     /* 105620 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(105675), // Rule ID 3391 //
     /* 105625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 105628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_pd_256),
     /* 105633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 105636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 105639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 105643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 105651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105658 */     // (intrinsic_w_chain:{ *:[v4f64] } 13329:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4i64] }:$src1)  =>  (VMASKMOVPDYrm:{ *:[v4f64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 105658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDYrm),
     /* 105661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105663 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 105665 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 105669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105673 */     GIR_RootConstrainSelectedInstOperands,
     /* 105674 */     // GIR_Coverage, 3391,
     /* 105674 */     GIR_EraseRootFromParent_Done,
     /* 105675 */   // Label 2258: @105675
     /* 105675 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(105730), // Rule ID 3464 //
     /* 105680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 105683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_d),
     /* 105688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 105691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 105694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 105698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 105706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105713 */     // (intrinsic_w_chain:{ *:[v4i32] } 13628:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src1)  =>  (VPMASKMOVDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 105713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDrm),
     /* 105716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105718 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 105720 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 105724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105728 */     GIR_RootConstrainSelectedInstOperands,
     /* 105729 */     // GIR_Coverage, 3464,
     /* 105729 */     GIR_EraseRootFromParent_Done,
     /* 105730 */   // Label 2259: @105730
     /* 105730 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(105785), // Rule ID 3465 //
     /* 105735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 105738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_d_256),
     /* 105743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 105746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 105749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 105753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 105761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105768 */     // (intrinsic_w_chain:{ *:[v8i32] } 13629:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8i32] }:$src1)  =>  (VPMASKMOVDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 105768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDYrm),
     /* 105771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105773 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 105775 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 105779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105783 */     GIR_RootConstrainSelectedInstOperands,
     /* 105784 */     // GIR_Coverage, 3465,
     /* 105784 */     GIR_EraseRootFromParent_Done,
     /* 105785 */   // Label 2260: @105785
     /* 105785 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(105840), // Rule ID 3468 //
     /* 105790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 105793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_q),
     /* 105798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 105801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 105804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 105808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 105816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105823 */     // (intrinsic_w_chain:{ *:[v2i64] } 13630:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src1)  =>  (VPMASKMOVQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 105823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQrm),
     /* 105826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105828 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 105830 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 105834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105838 */     GIR_RootConstrainSelectedInstOperands,
     /* 105839 */     // GIR_Coverage, 3468,
     /* 105839 */     GIR_EraseRootFromParent_Done,
     /* 105840 */   // Label 2261: @105840
     /* 105840 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(105895), // Rule ID 3469 //
     /* 105845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 105848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_q_256),
     /* 105853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 105856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 105859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 105863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 105871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105878 */     // (intrinsic_w_chain:{ *:[v4i64] } 13631:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4i64] }:$src1)  =>  (VPMASKMOVQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 105878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQYrm),
     /* 105881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105883 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 105885 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 105889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105893 */     GIR_RootConstrainSelectedInstOperands,
     /* 105894 */     // GIR_Coverage, 3469,
     /* 105894 */     GIR_EraseRootFromParent_Done,
     /* 105895 */   // Label 2262: @105895
     /* 105895 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(105950), // Rule ID 3388 //
     /* 105900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 105903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_ps),
     /* 105908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 105911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 105914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 105922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 105926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105933 */     // (intrinsic_void 13334:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMASKMOVPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 105933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSmr),
     /* 105936 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105940 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 105942 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 105944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105948 */     GIR_RootConstrainSelectedInstOperands,
     /* 105949 */     // GIR_Coverage, 3388,
     /* 105949 */     GIR_EraseRootFromParent_Done,
     /* 105950 */   // Label 2263: @105950
     /* 105950 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(106005), // Rule ID 3389 //
     /* 105955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 105958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_ps_256),
     /* 105963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 105966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 105969 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 105977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 105981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105988 */     // (intrinsic_void 13335:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMASKMOVPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 105988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSYmr),
     /* 105991 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105995 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 105997 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 105999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106003 */     GIR_RootConstrainSelectedInstOperands,
     /* 106004 */     // GIR_Coverage, 3389,
     /* 106004 */     GIR_EraseRootFromParent_Done,
     /* 106005 */   // Label 2264: @106005
     /* 106005 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(106060), // Rule ID 3392 //
     /* 106010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_pd),
     /* 106018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 106021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106043 */     // (intrinsic_void 13332:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMASKMOVPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 106043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDmr),
     /* 106046 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106050 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106052 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106058 */     GIR_RootConstrainSelectedInstOperands,
     /* 106059 */     // GIR_Coverage, 3392,
     /* 106059 */     GIR_EraseRootFromParent_Done,
     /* 106060 */   // Label 2265: @106060
     /* 106060 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(106115), // Rule ID 3393 //
     /* 106065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_pd_256),
     /* 106073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 106076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 106079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106098 */     // (intrinsic_void 13333:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMASKMOVPDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 106098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDYmr),
     /* 106101 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106105 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106107 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106113 */     GIR_RootConstrainSelectedInstOperands,
     /* 106114 */     // GIR_Coverage, 3393,
     /* 106114 */     GIR_EraseRootFromParent_Done,
     /* 106115 */   // Label 2266: @106115
     /* 106115 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(106170), // Rule ID 3466 //
     /* 106120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_d),
     /* 106128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 106131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 106134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106153 */     // (intrinsic_void 13632:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMASKMOVDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 106153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDmr),
     /* 106156 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106160 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106162 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106168 */     GIR_RootConstrainSelectedInstOperands,
     /* 106169 */     // GIR_Coverage, 3466,
     /* 106169 */     GIR_EraseRootFromParent_Done,
     /* 106170 */   // Label 2267: @106170
     /* 106170 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(106225), // Rule ID 3467 //
     /* 106175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_d_256),
     /* 106183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 106186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106208 */     // (intrinsic_void 13633:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMASKMOVDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 106208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDYmr),
     /* 106211 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106215 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106217 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106223 */     GIR_RootConstrainSelectedInstOperands,
     /* 106224 */     // GIR_Coverage, 3467,
     /* 106224 */     GIR_EraseRootFromParent_Done,
     /* 106225 */   // Label 2268: @106225
     /* 106225 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(106280), // Rule ID 3470 //
     /* 106230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_q),
     /* 106238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 106241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106263 */     // (intrinsic_void 13634:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPMASKMOVQmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 106263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQmr),
     /* 106266 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106270 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106272 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106278 */     GIR_RootConstrainSelectedInstOperands,
     /* 106279 */     // GIR_Coverage, 3470,
     /* 106279 */     GIR_EraseRootFromParent_Done,
     /* 106280 */   // Label 2269: @106280
     /* 106280 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(106335), // Rule ID 3471 //
     /* 106285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_q_256),
     /* 106293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 106296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 106299 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106318 */     // (intrinsic_void 13635:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPMASKMOVQYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 106318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQYmr),
     /* 106321 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106325 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106327 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106333 */     GIR_RootConstrainSelectedInstOperands,
     /* 106334 */     // GIR_Coverage, 3471,
     /* 106334 */     GIR_EraseRootFromParent_Done,
     /* 106335 */   // Label 2270: @106335
     /* 106335 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(106414), // Rule ID 17104 //
     /* 106340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE),
     /* 106343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsave),
     /* 106348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 106354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 106362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 106366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106373 */     // (intrinsic_void 14972:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVE addr:{ *:[iPTR] }:$dst)
     /* 106373 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106377 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106383 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 106387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106391 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106397 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 106401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVE),
     /* 106404 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106412 */     GIR_RootConstrainSelectedInstOperands,
     /* 106413 */     // GIR_Coverage, 17104,
     /* 106413 */     GIR_EraseRootFromParent_Done,
     /* 106414 */   // Label 2271: @106414
     /* 106414 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(106493), // Rule ID 17105 //
     /* 106419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE_In64BitMode),
     /* 106422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsave64),
     /* 106427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 106433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 106441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 106445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106452 */     // (intrinsic_void 14973:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVE64 addr:{ *:[iPTR] }:$dst)
     /* 106452 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106456 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106462 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 106466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106470 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106476 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 106480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVE64),
     /* 106483 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106491 */     GIR_RootConstrainSelectedInstOperands,
     /* 106492 */     // GIR_Coverage, 17105,
     /* 106492 */     GIR_EraseRootFromParent_Done,
     /* 106493 */   // Label 2272: @106493
     /* 106493 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(106572), // Rule ID 17106 //
     /* 106498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE),
     /* 106501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstor),
     /* 106506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 106512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 106520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 106524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106531 */     // (intrinsic_void 14968:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTOR addr:{ *:[iPTR] }:$dst)
     /* 106531 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106535 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106541 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 106545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106549 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 106559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTOR),
     /* 106562 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106570 */     GIR_RootConstrainSelectedInstOperands,
     /* 106571 */     // GIR_Coverage, 17106,
     /* 106571 */     GIR_EraseRootFromParent_Done,
     /* 106572 */   // Label 2273: @106572
     /* 106572 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(106651), // Rule ID 17107 //
     /* 106577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE_In64BitMode),
     /* 106580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstor64),
     /* 106585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 106591 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 106599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 106603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106610 */     // (intrinsic_void 14969:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTOR64 addr:{ *:[iPTR] }:$dst)
     /* 106610 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106614 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106620 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 106624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106628 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 106638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTOR64),
     /* 106641 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106649 */     GIR_RootConstrainSelectedInstOperands,
     /* 106650 */     // GIR_Coverage, 17107,
     /* 106650 */     GIR_EraseRootFromParent_Done,
     /* 106651 */   // Label 2274: @106651
     /* 106651 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(106730), // Rule ID 17108 //
     /* 106656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEOPT),
     /* 106659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaveopt),
     /* 106664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 106670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 106678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 106682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106689 */     // (intrinsic_void 14976:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEOPT addr:{ *:[iPTR] }:$dst)
     /* 106689 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106693 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106699 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 106703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106707 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 106717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEOPT),
     /* 106720 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106728 */     GIR_RootConstrainSelectedInstOperands,
     /* 106729 */     // GIR_Coverage, 17108,
     /* 106729 */     GIR_EraseRootFromParent_Done,
     /* 106730 */   // Label 2275: @106730
     /* 106730 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(106809), // Rule ID 17109 //
     /* 106735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEOPT_In64BitMode),
     /* 106738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaveopt64),
     /* 106743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 106749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 106757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 106761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106768 */     // (intrinsic_void 14977:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEOPT64 addr:{ *:[iPTR] }:$dst)
     /* 106768 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106772 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106778 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 106782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106786 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106792 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 106796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEOPT64),
     /* 106799 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106807 */     GIR_RootConstrainSelectedInstOperands,
     /* 106808 */     // GIR_Coverage, 17109,
     /* 106808 */     GIR_EraseRootFromParent_Done,
     /* 106809 */   // Label 2276: @106809
     /* 106809 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(106888), // Rule ID 17110 //
     /* 106814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEC),
     /* 106817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsavec),
     /* 106822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 106828 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 106836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 106840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106847 */     // (intrinsic_void 14974:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEC addr:{ *:[iPTR] }:$dst)
     /* 106847 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106851 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106857 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 106861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106865 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106871 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 106875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEC),
     /* 106878 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106886 */     GIR_RootConstrainSelectedInstOperands,
     /* 106887 */     // GIR_Coverage, 17110,
     /* 106887 */     GIR_EraseRootFromParent_Done,
     /* 106888 */   // Label 2277: @106888
     /* 106888 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(106967), // Rule ID 17111 //
     /* 106893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEC_In64BitMode),
     /* 106896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsavec64),
     /* 106901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 106907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 106915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 106919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106926 */     // (intrinsic_void 14975:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEC64 addr:{ *:[iPTR] }:$dst)
     /* 106926 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106930 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106936 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 106940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106944 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 106954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEC64),
     /* 106957 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106965 */     GIR_RootConstrainSelectedInstOperands,
     /* 106966 */     // GIR_Coverage, 17111,
     /* 106966 */     GIR_EraseRootFromParent_Done,
     /* 106967 */   // Label 2278: @106967
     /* 106967 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(107046), // Rule ID 17112 //
     /* 106972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVES),
     /* 106975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaves),
     /* 106980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 106986 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 106994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 106998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107005 */     // (intrinsic_void 14978:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVES addr:{ *:[iPTR] }:$dst)
     /* 107005 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107009 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107015 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107023 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVES),
     /* 107036 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107044 */     GIR_RootConstrainSelectedInstOperands,
     /* 107045 */     // GIR_Coverage, 17112,
     /* 107045 */     GIR_EraseRootFromParent_Done,
     /* 107046 */   // Label 2279: @107046
     /* 107046 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(107125), // Rule ID 17113 //
     /* 107051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE_In64BitMode),
     /* 107054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaves64),
     /* 107059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107084 */     // (intrinsic_void 14979:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVES64 addr:{ *:[iPTR] }:$dst)
     /* 107084 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107088 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107094 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107102 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107108 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVES64),
     /* 107115 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107123 */     GIR_RootConstrainSelectedInstOperands,
     /* 107124 */     // GIR_Coverage, 17113,
     /* 107124 */     GIR_EraseRootFromParent_Done,
     /* 107125 */   // Label 2280: @107125
     /* 107125 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(107204), // Rule ID 17114 //
     /* 107130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVES),
     /* 107133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstors),
     /* 107138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107163 */     // (intrinsic_void 14970:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTORS addr:{ *:[iPTR] }:$dst)
     /* 107163 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107167 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107173 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107181 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107187 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTORS),
     /* 107194 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107202 */     GIR_RootConstrainSelectedInstOperands,
     /* 107203 */     // GIR_Coverage, 17114,
     /* 107203 */     GIR_EraseRootFromParent_Done,
     /* 107204 */   // Label 2281: @107204
     /* 107204 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(107283), // Rule ID 17115 //
     /* 107209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVES_In64BitMode),
     /* 107212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstors64),
     /* 107217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107242 */     // (intrinsic_void 14971:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTORS64 addr:{ *:[iPTR] }:$dst)
     /* 107242 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107246 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107252 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107260 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTORS64),
     /* 107273 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107281 */     GIR_RootConstrainSelectedInstOperands,
     /* 107282 */     // GIR_Coverage, 17115,
     /* 107282 */     GIR_EraseRootFromParent_Done,
     /* 107283 */   // Label 2282: @107283
     /* 107283 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(107320), // Rule ID 17003 //
     /* 107288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 107291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbssd),
     /* 107296 */     // MIs[0] src1
     /* 107296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107299 */     // MIs[0] src2
     /* 107299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107302 */     // MIs[0] src3
     /* 107302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107305 */     // (intrinsic_void 14820:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBSSD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBSSD),
     /* 107308 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107310 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107312 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107318 */     GIR_RootConstrainSelectedInstOperands,
     /* 107319 */     // GIR_Coverage, 17003,
     /* 107319 */     GIR_EraseRootFromParent_Done,
     /* 107320 */   // Label 2283: @107320
     /* 107320 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(107357), // Rule ID 17004 //
     /* 107325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 107328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbsud),
     /* 107333 */     // MIs[0] src1
     /* 107333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107336 */     // MIs[0] src2
     /* 107336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107339 */     // MIs[0] src3
     /* 107339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107342 */     // (intrinsic_void 14822:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBSUD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBSUD),
     /* 107345 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107347 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107349 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107355 */     GIR_RootConstrainSelectedInstOperands,
     /* 107356 */     // GIR_Coverage, 17004,
     /* 107356 */     GIR_EraseRootFromParent_Done,
     /* 107357 */   // Label 2284: @107357
     /* 107357 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(107394), // Rule ID 17005 //
     /* 107362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 107365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbusd),
     /* 107370 */     // MIs[0] src1
     /* 107370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107373 */     // MIs[0] src2
     /* 107373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107376 */     // MIs[0] src3
     /* 107376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107379 */     // (intrinsic_void 14824:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBUSD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBUSD),
     /* 107382 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107384 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107386 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107392 */     GIR_RootConstrainSelectedInstOperands,
     /* 107393 */     // GIR_Coverage, 17005,
     /* 107393 */     GIR_EraseRootFromParent_Done,
     /* 107394 */   // Label 2285: @107394
     /* 107394 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(107431), // Rule ID 17006 //
     /* 107399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 107402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbuud),
     /* 107407 */     // MIs[0] src1
     /* 107407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107410 */     // MIs[0] src2
     /* 107410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107413 */     // MIs[0] src3
     /* 107413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107416 */     // (intrinsic_void 14826:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBUUD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBUUD),
     /* 107419 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107421 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107423 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107429 */     GIR_RootConstrainSelectedInstOperands,
     /* 107430 */     // GIR_Coverage, 17006,
     /* 107430 */     GIR_EraseRootFromParent_Done,
     /* 107431 */   // Label 2286: @107431
     /* 107431 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(107468), // Rule ID 17008 //
     /* 107436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXBF16_In64BitMode),
     /* 107439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbf16ps),
     /* 107444 */     // MIs[0] src1
     /* 107444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107447 */     // MIs[0] src2
     /* 107447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107450 */     // MIs[0] src3
     /* 107450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107453 */     // (intrinsic_void 14814:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBF16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBF16PS),
     /* 107456 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107458 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107460 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107466 */     GIR_RootConstrainSelectedInstOperands,
     /* 107467 */     // GIR_Coverage, 17008,
     /* 107467 */     GIR_EraseRootFromParent_Done,
     /* 107468 */   // Label 2287: @107468
     /* 107468 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(107505), // Rule ID 17010 //
     /* 107473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP16_In64BitMode),
     /* 107476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpfp16ps),
     /* 107481 */     // MIs[0] src1
     /* 107481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107484 */     // MIs[0] src2
     /* 107484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107487 */     // MIs[0] src3
     /* 107487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107490 */     // (intrinsic_void 14828:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPFP16PS),
     /* 107493 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107495 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107497 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107503 */     GIR_RootConstrainSelectedInstOperands,
     /* 107504 */     // GIR_Coverage, 17010,
     /* 107504 */     GIR_EraseRootFromParent_Done,
     /* 107505 */   // Label 2288: @107505
     /* 107505 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(107542), // Rule ID 17013 //
     /* 107510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_In64BitMode),
     /* 107513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tcmmimfp16ps),
     /* 107518 */     // MIs[0] src1
     /* 107518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107521 */     // MIs[0] src2
     /* 107521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107524 */     // MIs[0] src3
     /* 107524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107527 */     // (intrinsic_void 14796:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCMMIMFP16PS),
     /* 107530 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107532 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107534 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107540 */     GIR_RootConstrainSelectedInstOperands,
     /* 107541 */     // GIR_Coverage, 17013,
     /* 107541 */     GIR_EraseRootFromParent_Done,
     /* 107542 */   // Label 2289: @107542
     /* 107542 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(107579), // Rule ID 17014 //
     /* 107547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_In64BitMode),
     /* 107550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tcmmrlfp16ps),
     /* 107555 */     // MIs[0] src1
     /* 107555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107558 */     // MIs[0] src2
     /* 107558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107561 */     // MIs[0] src3
     /* 107561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107564 */     // (intrinsic_void 14798:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCMMRLFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCMMRLFP16PS),
     /* 107567 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107569 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107571 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107577 */     GIR_RootConstrainSelectedInstOperands,
     /* 107578 */     // GIR_Coverage, 17014,
     /* 107578 */     GIR_EraseRootFromParent_Done,
     /* 107579 */   // Label 2290: @107579
     /* 107579 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(107616), // Rule ID 17015 //
     /* 107584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 107587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbf8ps),
     /* 107592 */     // MIs[0] src1
     /* 107592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107595 */     // MIs[0] src2
     /* 107595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107598 */     // MIs[0] src3
     /* 107598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107601 */     // (intrinsic_void 14816:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBF8PS),
     /* 107604 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107606 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107608 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107614 */     GIR_RootConstrainSelectedInstOperands,
     /* 107615 */     // GIR_Coverage, 17015,
     /* 107615 */     GIR_EraseRootFromParent_Done,
     /* 107616 */   // Label 2291: @107616
     /* 107616 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(107653), // Rule ID 17016 //
     /* 107621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 107624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbhf8ps),
     /* 107629 */     // MIs[0] src1
     /* 107629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107632 */     // MIs[0] src2
     /* 107632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107635 */     // MIs[0] src3
     /* 107635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107638 */     // (intrinsic_void 14818:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBHF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBHF8PS),
     /* 107641 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107643 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107645 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107651 */     GIR_RootConstrainSelectedInstOperands,
     /* 107652 */     // GIR_Coverage, 17016,
     /* 107652 */     GIR_EraseRootFromParent_Done,
     /* 107653 */   // Label 2292: @107653
     /* 107653 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(107690), // Rule ID 17017 //
     /* 107658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 107661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdphbf8ps),
     /* 107666 */     // MIs[0] src1
     /* 107666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107669 */     // MIs[0] src2
     /* 107669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107672 */     // MIs[0] src3
     /* 107672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107675 */     // (intrinsic_void 14830:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPHBF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPHBF8PS),
     /* 107678 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107680 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107682 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107688 */     GIR_RootConstrainSelectedInstOperands,
     /* 107689 */     // GIR_Coverage, 17017,
     /* 107689 */     GIR_EraseRootFromParent_Done,
     /* 107690 */   // Label 2293: @107690
     /* 107690 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(107727), // Rule ID 17018 //
     /* 107695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 107698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdphf8ps),
     /* 107703 */     // MIs[0] src1
     /* 107703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107706 */     // MIs[0] src2
     /* 107706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107709 */     // MIs[0] src3
     /* 107709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107712 */     // (intrinsic_void 14832:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPHF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPHF8PS),
     /* 107715 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107717 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107719 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107725 */     GIR_RootConstrainSelectedInstOperands,
     /* 107726 */     // GIR_Coverage, 17018,
     /* 107726 */     GIR_EraseRootFromParent_Done,
     /* 107727 */   // Label 2294: @107727
     /* 107727 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(107764), // Rule ID 17026 //
     /* 107732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXBF16_HasAMXTRANSPOSE_In64BitMode),
     /* 107735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttdpbf16ps),
     /* 107740 */     // MIs[0] src1
     /* 107740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107743 */     // MIs[0] src2
     /* 107743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107746 */     // MIs[0] src3
     /* 107746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107749 */     // (intrinsic_void 14857:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTDPBF16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTDPBF16PS),
     /* 107752 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107754 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107756 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107762 */     GIR_RootConstrainSelectedInstOperands,
     /* 107763 */     // GIR_Coverage, 17026,
     /* 107763 */     GIR_EraseRootFromParent_Done,
     /* 107764 */   // Label 2295: @107764
     /* 107764 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(107801), // Rule ID 17028 //
     /* 107769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP16_HasAMXTRANSPOSE_In64BitMode),
     /* 107772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttdpfp16ps),
     /* 107777 */     // MIs[0] src1
     /* 107777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107780 */     // MIs[0] src2
     /* 107780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107783 */     // MIs[0] src3
     /* 107783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107786 */     // (intrinsic_void 14859:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTDPFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTDPFP16PS),
     /* 107789 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107791 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107793 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107799 */     GIR_RootConstrainSelectedInstOperands,
     /* 107800 */     // GIR_Coverage, 17028,
     /* 107800 */     GIR_EraseRootFromParent_Done,
     /* 107801 */   // Label 2296: @107801
     /* 107801 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(107838), // Rule ID 17033 //
     /* 107806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 107809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttcmmimfp16ps),
     /* 107814 */     // MIs[0] src1
     /* 107814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107817 */     // MIs[0] src2
     /* 107817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107820 */     // MIs[0] src3
     /* 107820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107823 */     // (intrinsic_void 14853:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTCMMIMFP16PS),
     /* 107826 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107828 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107830 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107836 */     GIR_RootConstrainSelectedInstOperands,
     /* 107837 */     // GIR_Coverage, 17033,
     /* 107837 */     GIR_EraseRootFromParent_Done,
     /* 107838 */   // Label 2297: @107838
     /* 107838 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(107875), // Rule ID 17034 //
     /* 107843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 107846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttcmmrlfp16ps),
     /* 107851 */     // MIs[0] src1
     /* 107851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107854 */     // MIs[0] src2
     /* 107854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107857 */     // MIs[0] src3
     /* 107857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107860 */     // (intrinsic_void 14855:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTCMMRLFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTCMMRLFP16PS),
     /* 107863 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107865 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107867 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107873 */     GIR_RootConstrainSelectedInstOperands,
     /* 107874 */     // GIR_Coverage, 17034,
     /* 107874 */     GIR_EraseRootFromParent_Done,
     /* 107875 */   // Label 2298: @107875
     /* 107875 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(107912), // Rule ID 17035 //
     /* 107880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 107883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tconjtcmmimfp16ps),
     /* 107888 */     // MIs[0] src1
     /* 107888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107891 */     // MIs[0] src2
     /* 107891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107894 */     // MIs[0] src3
     /* 107894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107897 */     // (intrinsic_void 14800:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCONJTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCONJTCMMIMFP16PS),
     /* 107900 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107902 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107904 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107910 */     GIR_RootConstrainSelectedInstOperands,
     /* 107911 */     // GIR_Coverage, 17035,
     /* 107911 */     GIR_EraseRootFromParent_Done,
     /* 107912 */   // Label 2299: @107912
     /* 107912 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(107949), // Rule ID 17054 //
     /* 107917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTF32_In64BitMode),
     /* 107920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tmmultf32ps),
     /* 107925 */     // MIs[0] src1
     /* 107925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107928 */     // MIs[0] src2
     /* 107928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107931 */     // MIs[0] src3
     /* 107931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107934 */     // (intrinsic_void 14850:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTMMULTF32PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTMMULTF32PS),
     /* 107937 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107939 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107941 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107947 */     GIR_RootConstrainSelectedInstOperands,
     /* 107948 */     // GIR_Coverage, 17054,
     /* 107948 */     GIR_EraseRootFromParent_Done,
     /* 107949 */   // Label 2300: @107949
     /* 107949 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(107986), // Rule ID 17056 //
     /* 107954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTF32_HasAMXTRANSPOSE_In64BitMode),
     /* 107957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttmmultf32ps),
     /* 107962 */     // MIs[0] src1
     /* 107962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 107965 */     // MIs[0] src2
     /* 107965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 107968 */     // MIs[0] src3
     /* 107968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 107971 */     // (intrinsic_void 14861:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTMMULTF32PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 107971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTMMULTF32PS),
     /* 107974 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107976 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 107978 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 107980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107984 */     GIR_RootConstrainSelectedInstOperands,
     /* 107985 */     // GIR_Coverage, 17056,
     /* 107985 */     GIR_EraseRootFromParent_Done,
     /* 107986 */   // Label 2301: @107986
     /* 107986 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(108039), // Rule ID 17037 //
     /* 107991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 107994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowd2ps),
     /* 107999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108009 */     // MIs[0] src1
     /* 108009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108020 */     // MIs[1] Operand 1
     /* 108020 */     // No operand predicates
     /* 108020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108022 */     // (intrinsic_w_chain:{ *:[v16f32] } 14804:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWD2PSrri:{ *:[v16f32] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWD2PSrri),
     /* 108025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108027 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108037 */     GIR_RootConstrainSelectedInstOperands,
     /* 108038 */     // GIR_Coverage, 17037,
     /* 108038 */     GIR_EraseRootFromParent_Done,
     /* 108039 */   // Label 2302: @108039
     /* 108039 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(108092), // Rule ID 17046 //
     /* 108044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phh),
     /* 108052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108062 */     // MIs[0] src1
     /* 108062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108073 */     // MIs[1] Operand 1
     /* 108073 */     // No operand predicates
     /* 108073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108075 */     // (intrinsic_w_chain:{ *:[v32f16] } 14810:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWPS2PHHrri:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHHrri),
     /* 108078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108080 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108090 */     GIR_RootConstrainSelectedInstOperands,
     /* 108091 */     // GIR_Coverage, 17046,
     /* 108091 */     GIR_EraseRootFromParent_Done,
     /* 108092 */   // Label 2303: @108092
     /* 108092 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(108145), // Rule ID 17048 //
     /* 108097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phl),
     /* 108105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108115 */     // MIs[0] src1
     /* 108115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108126 */     // MIs[1] Operand 1
     /* 108126 */     // No operand predicates
     /* 108126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108128 */     // (intrinsic_w_chain:{ *:[v32f16] } 14812:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWPS2PHLrri:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHLrri),
     /* 108131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108133 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108143 */     GIR_RootConstrainSelectedInstOperands,
     /* 108144 */     // GIR_Coverage, 17048,
     /* 108144 */     GIR_EraseRootFromParent_Done,
     /* 108145 */   // Label 2304: @108145
     /* 108145 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(108198), // Rule ID 17049 //
     /* 108150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tilemovrow),
     /* 108158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108168 */     // MIs[0] src1
     /* 108168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108179 */     // MIs[1] Operand 1
     /* 108179 */     // No operand predicates
     /* 108179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108181 */     // (intrinsic_w_chain:{ *:[v16i32] } 14843:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTILEMOVROWrri:{ *:[v16i32] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEMOVROWrri),
     /* 108184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108186 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108196 */     GIR_RootConstrainSelectedInstOperands,
     /* 108197 */     // GIR_Coverage, 17049,
     /* 108197 */     GIR_EraseRootFromParent_Done,
     /* 108198 */   // Label 2305: @108198
     /* 108198 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(108243), // Rule ID 17038 //
     /* 108203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowd2ps),
     /* 108211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108221 */     // MIs[0] src1
     /* 108221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108228 */     // (intrinsic_w_chain:{ *:[v16f32] } 14804:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWD2PSrre:{ *:[v16f32] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 108228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWD2PSrre),
     /* 108231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108233 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108235 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 108237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108241 */     GIR_RootConstrainSelectedInstOperands,
     /* 108242 */     // GIR_Coverage, 17038,
     /* 108242 */     GIR_EraseRootFromParent_Done,
     /* 108243 */   // Label 2306: @108243
     /* 108243 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(108288), // Rule ID 17045 //
     /* 108248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phh),
     /* 108256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108266 */     // MIs[0] src1
     /* 108266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108273 */     // (intrinsic_w_chain:{ *:[v32f16] } 14810:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWPS2PHHrre:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 108273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHHrre),
     /* 108276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108278 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108280 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 108282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108286 */     GIR_RootConstrainSelectedInstOperands,
     /* 108287 */     // GIR_Coverage, 17045,
     /* 108287 */     GIR_EraseRootFromParent_Done,
     /* 108288 */   // Label 2307: @108288
     /* 108288 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(108333), // Rule ID 17047 //
     /* 108293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phl),
     /* 108301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108311 */     // MIs[0] src1
     /* 108311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108318 */     // (intrinsic_w_chain:{ *:[v32f16] } 14812:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWPS2PHLrre:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 108318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHLrre),
     /* 108321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108323 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108325 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 108327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108331 */     GIR_RootConstrainSelectedInstOperands,
     /* 108332 */     // GIR_Coverage, 17047,
     /* 108332 */     GIR_EraseRootFromParent_Done,
     /* 108333 */   // Label 2308: @108333
     /* 108333 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(108378), // Rule ID 17050 //
     /* 108338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tilemovrow),
     /* 108346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108356 */     // MIs[0] src1
     /* 108356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108363 */     // (intrinsic_w_chain:{ *:[v16i32] } 14843:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTILEMOVROWrre:{ *:[v16i32] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 108363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEMOVROWrre),
     /* 108366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108368 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108370 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 108372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108376 */     GIR_RootConstrainSelectedInstOperands,
     /* 108377 */     // GIR_Coverage, 17050,
     /* 108377 */     GIR_EraseRootFromParent_Done,
     /* 108378 */   // Label 2309: @108378
     /* 108378 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(108423), // Rule ID 122 //
     /* 108383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 108386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval32),
     /* 108391 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 108394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 108397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108405 */     // MIs[0] cntl
     /* 108405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108408 */     // (intrinsic_void 14484:{ *:[iPTR] }, GR32:{ *:[i32] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL32rri GR32:{ *:[i32] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 108408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL32rri),
     /* 108411 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 108413 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108415 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 108417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108421 */     GIR_RootConstrainSelectedInstOperands,
     /* 108422 */     // GIR_Coverage, 122,
     /* 108422 */     GIR_EraseRootFromParent_Done,
     /* 108423 */   // Label 2310: @108423
     /* 108423 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(108468), // Rule ID 124 //
     /* 108428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 108431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval64),
     /* 108436 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 108442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 108446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108450 */     // MIs[0] cntl
     /* 108450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108453 */     // (intrinsic_void 14485:{ *:[iPTR] }, GR64:{ *:[i64] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL64rri GR64:{ *:[i64] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 108453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL64rri),
     /* 108456 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 108458 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108460 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 108462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108466 */     GIR_RootConstrainSelectedInstOperands,
     /* 108467 */     // GIR_Coverage, 124,
     /* 108467 */     GIR_EraseRootFromParent_Done,
     /* 108468 */   // Label 2311: @108468
     /* 108468 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(108550), // Rule ID 17103 //
     /* 108473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsetbv),
     /* 108478 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 108481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 108484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32_ArgRef_and_GR32_CBRegClassID),
     /* 108491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 108495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 108499 */     // (intrinsic_void 14980:{ *:[iPTR] }, ECX:{ *:[i32] }, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSETBV)
     /* 108499 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108503 */     GIR_AddRegister, /*InsnID*/3, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108509 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 108513 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108517 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108523 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 108527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108531 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::ECX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108537 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // ECX
     /* 108541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSETBV),
     /* 108544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108548 */     GIR_RootConstrainSelectedInstOperands,
     /* 108549 */     // GIR_Coverage, 17103,
     /* 108549 */     GIR_EraseRootFromParent_Done,
     /* 108550 */   // Label 2312: @108550
     /* 108550 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(108599), // Rule ID 17292 //
     /* 108555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMWAITX),
     /* 108558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_mwaitx),
     /* 108563 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 108566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 108569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108584 */     // (intrinsic_void 14562:{ *:[iPTR] }, GR32:{ *:[i32] }:$ecx, GR32:{ *:[i32] }:$eax, GR32:{ *:[i32] }:$ebx)  =>  (MWAITX GR32:{ *:[i32] }:$ecx, GR32:{ *:[i32] }:$eax, GR32:{ *:[i32] }:$ebx)
     /* 108584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MWAITX),
     /* 108587 */     GIR_RootToRootCopy, /*OpIdx*/1, // ecx
     /* 108589 */     GIR_RootToRootCopy, /*OpIdx*/2, // eax
     /* 108591 */     GIR_RootToRootCopy, /*OpIdx*/3, // ebx
     /* 108593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108597 */     GIR_RootConstrainSelectedInstOperands,
     /* 108598 */     // GIR_Coverage, 17292,
     /* 108598 */     GIR_EraseRootFromParent_Done,
     /* 108599 */   // Label 2313: @108599
     /* 108599 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(108661), // Rule ID 2902 //
     /* 108604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_In64BitMode),
     /* 108607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 108612 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 108615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 108618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 108622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 108626 */     // MIs[0] Operand 3
     /* 108626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 108630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64_with_sub_32bit_in_GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 108634 */     // (intrinsic_void 14660:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, RDI:{ *:[i64] })  =>  (VMASKMOVDQU64 VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 108634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108638 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::RDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108644 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // RDI
     /* 108648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVDQU64),
     /* 108651 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108653 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 108655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108659 */     GIR_RootConstrainSelectedInstOperands,
     /* 108660 */     // GIR_Coverage, 2902,
     /* 108660 */     GIR_EraseRootFromParent_Done,
     /* 108661 */   // Label 2314: @108661
     /* 108661 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(108723), // Rule ID 2903 //
     /* 108666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 108669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 108674 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 108677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 108680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 108684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 108688 */     // MIs[0] Operand 3
     /* 108688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/32,
     /* 108692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 108696 */     // (intrinsic_void 14660:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, EDI:{ *:[i32] })  =>  (VMASKMOVDQU VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 108696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108700 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108706 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // EDI
     /* 108710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVDQU),
     /* 108713 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108715 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 108717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108721 */     GIR_RootConstrainSelectedInstOperands,
     /* 108722 */     // GIR_Coverage, 2903,
     /* 108722 */     GIR_EraseRootFromParent_Done,
     /* 108723 */   // Label 2315: @108723
     /* 108723 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(108785), // Rule ID 2904 //
     /* 108728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_UseSSE2),
     /* 108731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 108736 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 108739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 108742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 108746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 108750 */     // MIs[0] Operand 3
     /* 108750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 108754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64_with_sub_32bit_in_GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 108758 */     // (intrinsic_void 14660:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, RDI:{ *:[i64] })  =>  (MASKMOVDQU64 VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 108758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108762 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::RDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108768 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // RDI
     /* 108772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MASKMOVDQU64),
     /* 108775 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108777 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 108779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108783 */     GIR_RootConstrainSelectedInstOperands,
     /* 108784 */     // GIR_Coverage, 2904,
     /* 108784 */     GIR_EraseRootFromParent_Done,
     /* 108785 */   // Label 2316: @108785
     /* 108785 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(108847), // Rule ID 2905 //
     /* 108790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 108793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 108798 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 108801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 108804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 108808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 108812 */     // MIs[0] Operand 3
     /* 108812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/32,
     /* 108816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 108820 */     // (intrinsic_void 14660:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, EDI:{ *:[i32] })  =>  (MASKMOVDQU VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 108820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108824 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // EDI
     /* 108834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MASKMOVDQU),
     /* 108837 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108839 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 108841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108845 */     GIR_RootConstrainSelectedInstOperands,
     /* 108846 */     // GIR_Coverage, 2905,
     /* 108846 */     GIR_EraseRootFromParent_Done,
     /* 108847 */   // Label 2317: @108847
     /* 108847 */   GIM_Reject,
     /* 108848 */ // Label 2252: @108848
     /* 108848 */ GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(108936), // Rule ID 16987 //
     /* 108853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasKL),
     /* 108856 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 108859 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_loadiwkey),
     /* 108864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 108867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 108870 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 108873 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 108876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 108880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 108884 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 108888 */   GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 108892 */   // (intrinsic_void 14481:{ *:[iPTR] }, XMM0:{ *:[v2i64] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, EAX:{ *:[i32] })  =>  (LOADIWKEY:{ *:[i32] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 108892 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108896 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108902 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // EAX
     /* 108906 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108910 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::XMM0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108916 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // XMM0
     /* 108920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LOADIWKEY),
     /* 108923 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108925 */   GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 108927 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 108930 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108934 */   GIR_RootConstrainSelectedInstOperands,
     /* 108935 */   // GIR_Coverage, 16987,
     /* 108935 */   GIR_EraseRootFromParent_Done,
     /* 108936 */ // Label 2318: @108936
     /* 108936 */ GIM_Reject,
     /* 108937 */ // Label 19: @108937
     /* 108937 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2322*/ GIMT_Encode4(109371),
     /* 108948 */ /*GILLT_s16*//*Label 2319*/ GIMT_Encode4(108960),
     /* 108952 */ /*GILLT_s32*//*Label 2320*/ GIMT_Encode4(109018),
     /* 108956 */ /*GILLT_s64*//*Label 2321*/ GIMT_Encode4(109193),
     /* 108960 */ // Label 2319: @108960
     /* 108960 */ GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(109017), // Rule ID 22587 //
     /* 108965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 108968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 108972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 108976 */   // (anyext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 108976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 108979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 108983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108988 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 108992 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 108994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108999 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 109006 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 109011 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 109016 */   // GIR_Coverage, 22587,
     /* 109016 */   GIR_EraseRootFromParent_Done,
     /* 109017 */ // Label 2323: @109017
     /* 109017 */ GIM_Reject,
     /* 109018 */ // Label 2320: @109018
     /* 109018 */ GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(109064), // Rule ID 19436 //
     /* 109023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109030 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109034 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 109038 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 109042 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 109047 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109049 */   // (anyext:{ *:[i32] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] })
     /* 109049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109054 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 109058 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 109063 */   // GIR_Coverage, 19436,
     /* 109063 */   GIR_EraseRootFromParent_Done,
     /* 109064 */ // Label 2324: @109064
     /* 109064 */ GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(109110), // Rule ID 19439 //
     /* 109069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109076 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109080 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 109084 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 109088 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 109093 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109095 */   // (anyext:{ *:[i32] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK8:{ *:[v8i1] }:$src, GR32:{ *:[i32] })
     /* 109095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109100 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 109104 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 109109 */   // GIR_Coverage, 19439,
     /* 109109 */   GIR_EraseRootFromParent_Done,
     /* 109110 */ // Label 2325: @109110
     /* 109110 */ GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(109133), // Rule ID 22588 //
     /* 109115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109126 */   // (anyext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 109126 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 109131 */   GIR_RootConstrainSelectedInstOperands,
     /* 109132 */   // GIR_Coverage, 22588,
     /* 109132 */   GIR_Done,
     /* 109133 */ // Label 2326: @109133
     /* 109133 */ GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(109192), // Rule ID 22589 //
     /* 109138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 109145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 109149 */   // (anyext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] })
     /* 109149 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109152 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109156 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109161 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109168 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109171 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 109176 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 109181 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 109186 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 109191 */   // GIR_Coverage, 22589,
     /* 109191 */   GIR_EraseRootFromParent_Done,
     /* 109192 */ // Label 2327: @109192
     /* 109192 */ GIM_Reject,
     /* 109193 */ // Label 2321: @109193
     /* 109193 */ GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(109252), // Rule ID 22590 //
     /* 109198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 109205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109209 */   // (anyext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_32bit:{ *:[i32] })
     /* 109209 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109212 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 109216 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109221 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109235 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 109241 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 109246 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 109251 */   // GIR_Coverage, 22590,
     /* 109251 */   GIR_EraseRootFromParent_Done,
     /* 109252 */ // Label 2328: @109252
     /* 109252 */ GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(109311), // Rule ID 22591 //
     /* 109257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 109264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 109268 */   // (anyext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src), sub_32bit:{ *:[i32] })
     /* 109268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 109275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109280 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109284 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109294 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 109300 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 109305 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 109310 */   // GIR_Coverage, 22591,
     /* 109310 */   GIR_EraseRootFromParent_Done,
     /* 109311 */ // Label 2329: @109311
     /* 109311 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(109370), // Rule ID 22592 //
     /* 109316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 109323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109327 */   // (anyext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR32:{ *:[i32] }:$src, sub_32bit:{ *:[i32] })
     /* 109327 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 109330 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109334 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109346 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109349 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 109354 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 109359 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR64RegClassID),
     /* 109364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 109369 */   // GIR_Coverage, 22592,
     /* 109369 */   GIR_EraseRootFromParent_Done,
     /* 109370 */ // Label 2330: @109370
     /* 109370 */ GIM_Reject,
     /* 109371 */ // Label 2322: @109371
     /* 109371 */ GIM_Reject,
     /* 109372 */ // Label 20: @109372
     /* 109372 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 2339*/ GIMT_Encode4(110460),
     /* 109383 */ /*GILLT_s8*//*Label 2331*/ GIMT_Encode4(109467),
     /* 109387 */ /*GILLT_s16*//*Label 2332*/ GIMT_Encode4(109751), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109419 */ /*GILLT_v4s32*//*Label 2333*/ GIMT_Encode4(109790), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109431 */ /*GILLT_v8s16*//*Label 2334*/ GIMT_Encode4(109930),
     /* 109435 */ /*GILLT_v8s32*//*Label 2335*/ GIMT_Encode4(110093), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109447 */ /*GILLT_v16s8*//*Label 2336*/ GIMT_Encode4(110120),
     /* 109451 */ /*GILLT_v16s16*//*Label 2337*/ GIMT_Encode4(110406), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109463 */ /*GILLT_v32s8*//*Label 2338*/ GIMT_Encode4(110433),
     /* 109467 */ // Label 2331: @109467
     /* 109467 */ GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(109542), // Rule ID 19431 //
     /* 109472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109479 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109483 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 109487 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 109491 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 109496 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109498 */   // (trunc:{ *:[i8] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 109498 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109501 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109505 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109510 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 109514 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 109519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109524 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 109531 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 109536 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 109541 */   // GIR_Coverage, 19431,
     /* 109541 */   GIR_EraseRootFromParent_Done,
     /* 109542 */ // Label 2340: @109542
     /* 109542 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(109605), // Rule ID 22649 //
     /* 109547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 109550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 109557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109561 */   // (trunc:{ *:[i8] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } GR32:{ *:[i32] }:$src, GR32_ABCD:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 109561 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109564 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109568 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109573 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109577 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32_ABCDRegClassID),
     /* 109582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109587 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 109594 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 109599 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32_ABCDRegClassID),
     /* 109604 */   // GIR_Coverage, 22649,
     /* 109604 */   GIR_EraseRootFromParent_Done,
     /* 109605 */ // Label 2341: @109605
     /* 109605 */ GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(109668), // Rule ID 22650 //
     /* 109610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 109613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 109620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 109624 */   // (trunc:{ *:[i8] } GR16:{ *:[i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i16] } GR16:{ *:[i16] }:$src, GR16_ABCD:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 109624 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 109627 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109631 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109636 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109640 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16_ABCDRegClassID),
     /* 109645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109650 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 109657 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 109662 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR16_ABCDRegClassID),
     /* 109667 */   // GIR_Coverage, 22650,
     /* 109667 */   GIR_EraseRootFromParent_Done,
     /* 109668 */ // Label 2342: @109668
     /* 109668 */ GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(109709), // Rule ID 22654 //
     /* 109673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 109676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109687 */   // (trunc:{ *:[i8] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src, sub_8bit:{ *:[i32] })
     /* 109687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109692 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 109698 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 109703 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 109708 */   // GIR_Coverage, 22654,
     /* 109708 */   GIR_EraseRootFromParent_Done,
     /* 109709 */ // Label 2343: @109709
     /* 109709 */ GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(109750), // Rule ID 22655 //
     /* 109714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 109717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 109728 */   // (trunc:{ *:[i8] } GR16:{ *:[i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src, sub_8bit:{ *:[i32] })
     /* 109728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109733 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 109739 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 109744 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 109749 */   // GIR_Coverage, 22655,
     /* 109749 */   GIR_EraseRootFromParent_Done,
     /* 109750 */ // Label 2344: @109750
     /* 109750 */ GIM_Reject,
     /* 109751 */ // Label 2332: @109751
     /* 109751 */ GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(109789), // Rule ID 22648 //
     /* 109756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 109763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109767 */   // (trunc:{ *:[i16] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src, sub_16bit:{ *:[i32] })
     /* 109767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109772 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
     /* 109778 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 109783 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 109788 */   // GIR_Coverage, 22648,
     /* 109788 */   GIR_EraseRootFromParent_Done,
     /* 109789 */ // Label 2345: @109789
     /* 109789 */ GIM_Reject,
     /* 109790 */ // Label 2333: @109790
     /* 109790 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(109929),
     /* 109795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 109798 */   GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(109821), // Rule ID 12261 //
     /* 109803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 109806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 109810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 109814 */     // (trunc:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)  =>  (VPMOVQDZ256rr:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)
     /* 109814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZ256rr),
     /* 109819 */     GIR_RootConstrainSelectedInstOperands,
     /* 109820 */     // GIR_Coverage, 12261,
     /* 109820 */     GIR_Done,
     /* 109821 */   // Label 2347: @109821
     /* 109821 */   GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(109928), // Rule ID 21556 //
     /* 109826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 109829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 109833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 109837 */     // (trunc:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPMOVQDZrr:{ *:[v8i32] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 109837 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 109840 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109844 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 109851 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 109854 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109858 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109863 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 109866 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109870 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 109873 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 109878 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 109883 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 109888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 109891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZrr),
     /* 109895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109900 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 109903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109910 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 109917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 109922 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 109927 */     // GIR_Coverage, 21556,
     /* 109927 */     GIR_EraseRootFromParent_Done,
     /* 109928 */   // Label 2348: @109928
     /* 109928 */   GIM_Reject,
     /* 109929 */ // Label 2346: @109929
     /* 109929 */ GIM_Reject,
     /* 109930 */ // Label 2334: @109930
     /* 109930 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(109956), // Rule ID 12237 //
     /* 109935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 109938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 109941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 109945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 109949 */   // (trunc:{ *:[v8i16] } VR512:{ *:[v8i64] }:$src)  =>  (VPMOVQWZrr:{ *:[v8i16] } VR512:{ *:[v8i64] }:$src)
     /* 109949 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQWZrr),
     /* 109954 */   GIR_RootConstrainSelectedInstOperands,
     /* 109955 */   // GIR_Coverage, 12237,
     /* 109955 */   GIR_Done,
     /* 109956 */ // Label 2349: @109956
     /* 109956 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(109982), // Rule ID 12315 //
     /* 109961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 109964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 109967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 109971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 109975 */   // (trunc:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVDWZ256rr:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)
     /* 109975 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZ256rr),
     /* 109980 */   GIR_RootConstrainSelectedInstOperands,
     /* 109981 */   // GIR_Coverage, 12315,
     /* 109981 */   GIR_Done,
     /* 109982 */ // Label 2350: @109982
     /* 109982 */ GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(110092), // Rule ID 21555 //
     /* 109987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 109990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 109993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 109997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110001 */   // (trunc:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPMOVDWZrr:{ *:[v16i16] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 110001 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 110004 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110008 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110013 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110015 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 110018 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110022 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110027 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110030 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110034 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 110037 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 110042 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 110047 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 110055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 110059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110064 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110067 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110074 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 110081 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 110086 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110091 */   // GIR_Coverage, 21555,
     /* 110091 */   GIR_EraseRootFromParent_Done,
     /* 110092 */ // Label 2351: @110092
     /* 110092 */ GIM_Reject,
     /* 110093 */ // Label 2335: @110093
     /* 110093 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(110119), // Rule ID 12264 //
     /* 110098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 110101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 110104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110112 */   // (trunc:{ *:[v8i32] } VR512:{ *:[v8i64] }:$src)  =>  (VPMOVQDZrr:{ *:[v8i32] } VR512:{ *:[v8i64] }:$src)
     /* 110112 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZrr),
     /* 110117 */   GIR_RootConstrainSelectedInstOperands,
     /* 110118 */   // GIR_Coverage, 12264,
     /* 110118 */   GIR_Done,
     /* 110119 */ // Label 2352: @110119
     /* 110119 */ GIM_Reject,
     /* 110120 */ // Label 2336: @110120
     /* 110120 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(110196), // Rule ID 21649 //
     /* 110125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoBWI),
     /* 110128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110135 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110139 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 110143 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110146 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 110150 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 110154 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110156 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 110163 */   // (trunc:{ *:[v16i8] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVZXWDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src))
     /* 110163 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 110166 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrm),
     /* 110170 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110175 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /* 110179 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 110189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110191 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110194 */   GIR_RootConstrainSelectedInstOperands,
     /* 110195 */   // GIR_Coverage, 21649,
     /* 110195 */   GIR_EraseRootFromParent_Done,
     /* 110196 */ // Label 2353: @110196
     /* 110196 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(110222), // Rule ID 12291 //
     /* 110201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 110204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 110207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110215 */   // (trunc:{ *:[v16i8] } VR512:{ *:[v16i32] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } VR512:{ *:[v16i32] }:$src)
     /* 110215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 110220 */   GIR_RootConstrainSelectedInstOperands,
     /* 110221 */   // GIR_Coverage, 12291,
     /* 110221 */   GIR_Done,
     /* 110222 */ // Label 2354: @110222
     /* 110222 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(110248), // Rule ID 12342 //
     /* 110227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 110230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110241 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVWBZ256rr:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)
     /* 110241 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZ256rr),
     /* 110246 */   GIR_RootConstrainSelectedInstOperands,
     /* 110247 */   // GIR_Coverage, 12342,
     /* 110247 */   GIR_Done,
     /* 110248 */ // Label 2355: @110248
     /* 110248 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(110358), // Rule ID 21557 //
     /* 110253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 110256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 110263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110267 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPMOVWBZrr:{ *:[v32i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 110267 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 110270 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110274 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110281 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 110284 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110288 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110293 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110296 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110300 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 110303 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 110308 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 110313 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110318 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 110321 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZrr),
     /* 110325 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110330 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110333 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110340 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 110347 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 110352 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110357 */   // GIR_Coverage, 21557,
     /* 110357 */   GIR_EraseRootFromParent_Done,
     /* 110358 */ // Label 2356: @110358
     /* 110358 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(110405), // Rule ID 21648 //
     /* 110363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoBWI),
     /* 110366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110377 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVZXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src))
     /* 110377 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 110380 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrr),
     /* 110384 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110389 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 110398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110400 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110403 */   GIR_RootConstrainSelectedInstOperands,
     /* 110404 */   // GIR_Coverage, 21648,
     /* 110404 */   GIR_EraseRootFromParent_Done,
     /* 110405 */ // Label 2357: @110405
     /* 110405 */ GIM_Reject,
     /* 110406 */ // Label 2337: @110406
     /* 110406 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(110432), // Rule ID 12318 //
     /* 110411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 110414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 110417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110425 */   // (trunc:{ *:[v16i16] } VR512:{ *:[v16i32] }:$src)  =>  (VPMOVDWZrr:{ *:[v16i16] } VR512:{ *:[v16i32] }:$src)
     /* 110425 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 110430 */   GIR_RootConstrainSelectedInstOperands,
     /* 110431 */   // GIR_Coverage, 12318,
     /* 110431 */   GIR_Done,
     /* 110432 */ // Label 2358: @110432
     /* 110432 */ GIM_Reject,
     /* 110433 */ // Label 2338: @110433
     /* 110433 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(110459), // Rule ID 12345 //
     /* 110438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 110441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 110444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110452 */   // (trunc:{ *:[v32i8] } VR512:{ *:[v32i16] }:$src)  =>  (VPMOVWBZrr:{ *:[v32i8] } VR512:{ *:[v32i16] }:$src)
     /* 110452 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZrr),
     /* 110457 */   GIR_RootConstrainSelectedInstOperands,
     /* 110458 */   // GIR_Coverage, 12345,
     /* 110458 */   GIR_Done,
     /* 110459 */ // Label 2359: @110459
     /* 110459 */ GIM_Reject,
     /* 110460 */ // Label 2339: @110460
     /* 110460 */ GIM_Reject,
     /* 110461 */ // Label 21: @110461
     /* 110461 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2364*/ GIMT_Encode4(111066),
     /* 110472 */ /*GILLT_s8*//*Label 2360*/ GIMT_Encode4(110488),
     /* 110476 */ /*GILLT_s16*//*Label 2361*/ GIMT_Encode4(110570),
     /* 110480 */ /*GILLT_s32*//*Label 2362*/ GIMT_Encode4(110770),
     /* 110484 */ /*GILLT_s64*//*Label 2363*/ GIMT_Encode4(110912),
     /* 110488 */ // Label 2360: @110488
     /* 110488 */ GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(110569),
     /* 110493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 110497 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(110553), // Rule ID 22383 //
     /* 110502 */     // MIs[0] Operand 1
     /* 110502 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 110513 */     // 0:{ *:[i8] }  =>  (EXTRACT_SUBREG:{ *:[i8] } (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 110513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 110520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110525 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 110528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110535 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 110542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 110547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 110552 */     // GIR_Coverage, 22383,
     /* 110552 */     GIR_EraseRootFromParent_Done,
     /* 110553 */   // Label 2366: @110553
     /* 110553 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(110568), // Rule ID 19 //
     /* 110558 */     // MIs[0] Operand 1
     /* 110558 */     // No operand predicates
     /* 110558 */     // (imm:{ *:[i8] }):$src  =>  (MOV8ri:{ *:[i8] } (imm:{ *:[i8] }):$src)
     /* 110558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8ri),
     /* 110561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 110566 */     GIR_RootConstrainSelectedInstOperands,
     /* 110567 */     // GIR_Coverage, 19,
     /* 110567 */     GIR_EraseRootFromParent_Done,
     /* 110568 */   // Label 2367: @110568
     /* 110568 */   GIM_Reject,
     /* 110569 */ // Label 2365: @110569
     /* 110569 */ GIM_Reject,
     /* 110570 */ // Label 2361: @110570
     /* 110570 */ GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(110769),
     /* 110575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 110579 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(110635), // Rule ID 22384 //
     /* 110584 */     // MIs[0] Operand 1
     /* 110584 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 110595 */     // 0:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 110595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 110602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110607 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 110610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110617 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 110624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 110629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 110634 */     // GIR_Coverage, 22384,
     /* 110634 */     GIR_EraseRootFromParent_Done,
     /* 110635 */   // Label 2369: @110635
     /* 110635 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(110694), // Rule ID 22386 //
     /* 110640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 110643 */     // MIs[0] Operand 1
     /* 110643 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 110654 */     // 1:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r1:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 110654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r1),
     /* 110661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110666 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 110669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110676 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 110683 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 110688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 110693 */     // GIR_Coverage, 22386,
     /* 110693 */     GIR_EraseRootFromParent_Done,
     /* 110694 */   // Label 2370: @110694
     /* 110694 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(110753), // Rule ID 22387 //
     /* 110699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 110702 */     // MIs[0] Operand 1
     /* 110702 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 110713 */     // -1:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r_1:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 110713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r_1),
     /* 110720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110725 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 110728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110735 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 110742 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 110747 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 110752 */     // GIR_Coverage, 22387,
     /* 110752 */     GIR_EraseRootFromParent_Done,
     /* 110753 */   // Label 2371: @110753
     /* 110753 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(110768), // Rule ID 20 //
     /* 110758 */     // MIs[0] Operand 1
     /* 110758 */     // No operand predicates
     /* 110758 */     // (imm:{ *:[i16] }):$src  =>  (MOV16ri:{ *:[i16] } (imm:{ *:[i16] }):$src)
     /* 110758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16ri),
     /* 110761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 110766 */     GIR_RootConstrainSelectedInstOperands,
     /* 110767 */     // GIR_Coverage, 20,
     /* 110767 */     GIR_EraseRootFromParent_Done,
     /* 110768 */   // Label 2372: @110768
     /* 110768 */   GIM_Reject,
     /* 110769 */ // Label 2368: @110769
     /* 110769 */ GIM_Reject,
     /* 110770 */ // Label 2362: @110770
     /* 110770 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(110800), // Rule ID 17152 //
     /* 110775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110779 */   // MIs[0] Operand 1
     /* 110779 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 110790 */   // 0:{ *:[i32] }  =>  (MOV32r0:{ *:[i32] }:{ *:[i32] })
     /* 110790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 110793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110795 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 110798 */   GIR_RootConstrainSelectedInstOperands,
     /* 110799 */   // GIR_Coverage, 17152,
     /* 110799 */   GIR_EraseRootFromParent_Done,
     /* 110800 */ // Label 2373: @110800
     /* 110800 */ GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(110833), // Rule ID 17153 //
     /* 110805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 110808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110812 */   // MIs[0] Operand 1
     /* 110812 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 110823 */   // 1:{ *:[i32] }  =>  (MOV32r1:{ *:[i32] }:{ *:[i32] })
     /* 110823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r1),
     /* 110826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110828 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 110831 */   GIR_RootConstrainSelectedInstOperands,
     /* 110832 */   // GIR_Coverage, 17153,
     /* 110832 */   GIR_EraseRootFromParent_Done,
     /* 110833 */ // Label 2374: @110833
     /* 110833 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(110866), // Rule ID 17154 //
     /* 110838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 110841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110845 */   // MIs[0] Operand 1
     /* 110845 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 110856 */   // -1:{ *:[i32] }  =>  (MOV32r_1:{ *:[i32] }:{ *:[i32] })
     /* 110856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r_1),
     /* 110859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110861 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 110864 */   GIR_RootConstrainSelectedInstOperands,
     /* 110865 */   // GIR_Coverage, 17154,
     /* 110865 */   GIR_EraseRootFromParent_Done,
     /* 110866 */ // Label 2375: @110866
     /* 110866 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(110892), // Rule ID 17155 //
     /* 110871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotWin64WithoutFP_OptForMinSize),
     /* 110874 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32immSExt8),
     /* 110878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110882 */   // MIs[0] Operand 1
     /* 110882 */   // No operand predicates
     /* 110882 */   // (imm:{ *:[i32] })<<P:Predicate_i32immSExt8>>:$src  =>  (MOV32ImmSExti8:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 110882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ImmSExti8),
     /* 110885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110887 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 110890 */   GIR_RootConstrainSelectedInstOperands,
     /* 110891 */   // GIR_Coverage, 17155,
     /* 110891 */   GIR_EraseRootFromParent_Done,
     /* 110892 */ // Label 2376: @110892
     /* 110892 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(110911), // Rule ID 21 //
     /* 110897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110901 */   // MIs[0] Operand 1
     /* 110901 */   // No operand predicates
     /* 110901 */   // (imm:{ *:[i32] }):$src  =>  (MOV32ri:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 110901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ri),
     /* 110904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110906 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 110909 */   GIR_RootConstrainSelectedInstOperands,
     /* 110910 */   // GIR_Coverage, 21,
     /* 110910 */   GIR_EraseRootFromParent_Done,
     /* 110911 */ // Label 2377: @110911
     /* 110911 */ GIM_Reject,
     /* 110912 */ // Label 2363: @110912
     /* 110912 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(110974), // Rule ID 22385 //
     /* 110917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 110921 */   // MIs[0] Operand 1
     /* 110921 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 110932 */   // 0:{ *:[i64] }  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_32bit:{ *:[i32] })
     /* 110932 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110935 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 110939 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110944 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 110947 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110957 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 110963 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 110968 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 110973 */   // GIR_Coverage, 22385,
     /* 110973 */   GIR_EraseRootFromParent_Done,
     /* 110974 */ // Label 2378: @110974
     /* 110974 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(111000), // Rule ID 17156 //
     /* 110979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotWin64WithoutFP_OptForMinSize),
     /* 110982 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt8),
     /* 110986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 110990 */   // MIs[0] Operand 1
     /* 110990 */   // No operand predicates
     /* 110990 */   // (imm:{ *:[i64] })<<P:Predicate_i64immSExt8>>:$src  =>  (MOV64ImmSExti8:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 110990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ImmSExti8),
     /* 110993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110995 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 110998 */   GIR_RootConstrainSelectedInstOperands,
     /* 110999 */   // GIR_Coverage, 17156,
     /* 110999 */   GIR_EraseRootFromParent_Done,
     /* 111000 */ // Label 2379: @111000
     /* 111000 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(111023), // Rule ID 17157 //
     /* 111005 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immZExt32),
     /* 111009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111013 */   // MIs[0] Operand 1
     /* 111013 */   // No operand predicates
     /* 111013 */   // (imm:{ *:[i64] })<<P:Predicate_i64immZExt32>>:$src  =>  (MOV32ri64:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ri64),
     /* 111016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111018 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111021 */   GIR_RootConstrainSelectedInstOperands,
     /* 111022 */   // GIR_Coverage, 17157,
     /* 111022 */   GIR_EraseRootFromParent_Done,
     /* 111023 */ // Label 2380: @111023
     /* 111023 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(111046), // Rule ID 22 //
     /* 111028 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /* 111032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111036 */   // MIs[0] Operand 1
     /* 111036 */   // No operand predicates
     /* 111036 */   // (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src  =>  (MOV64ri32:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ri32),
     /* 111039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111041 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111044 */   GIR_RootConstrainSelectedInstOperands,
     /* 111045 */   // GIR_Coverage, 22,
     /* 111045 */   GIR_EraseRootFromParent_Done,
     /* 111046 */ // Label 2381: @111046
     /* 111046 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(111065), // Rule ID 23 //
     /* 111051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111055 */   // MIs[0] Operand 1
     /* 111055 */   // No operand predicates
     /* 111055 */   // (imm:{ *:[i64] }):$src  =>  (MOV64ri:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ri),
     /* 111058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111060 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111063 */   GIR_RootConstrainSelectedInstOperands,
     /* 111064 */   // GIR_Coverage, 23,
     /* 111064 */   GIR_EraseRootFromParent_Done,
     /* 111065 */ // Label 2382: @111065
     /* 111065 */ GIM_Reject,
     /* 111066 */ // Label 2364: @111066
     /* 111066 */ GIM_Reject,
     /* 111067 */ // Label 22: @111067
     /* 111067 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 2386*/ GIMT_Encode4(111519),
     /* 111078 */ /*GILLT_s32*//*Label 2383*/ GIMT_Encode4(111090),
     /* 111082 */ /*GILLT_s64*//*Label 2384*/ GIMT_Encode4(111235),
     /* 111086 */ /*GILLT_s80*//*Label 2385*/ GIMT_Encode4(111380),
     /* 111090 */ // Label 2383: @111090
     /* 111090 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(111116), // Rule ID 1115 //
     /* 111095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111098 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 111102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111106 */   // MIs[0] Operand 1
     /* 111106 */   // No operand predicates
     /* 111106 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (LD_Fp032:{ *:[f32] }:{ *:[i16] })
     /* 111106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp032),
     /* 111109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111111 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111114 */   GIR_RootConstrainSelectedInstOperands,
     /* 111115 */   // GIR_Coverage, 1115,
     /* 111115 */   GIR_EraseRootFromParent_Done,
     /* 111116 */ // Label 2387: @111116
     /* 111116 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(111142), // Rule ID 1116 //
     /* 111121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111124 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 111128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111132 */   // MIs[0] Operand 1
     /* 111132 */   // No operand predicates
     /* 111132 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm1>>  =>  (LD_Fp132:{ *:[f32] }:{ *:[i16] })
     /* 111132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp132),
     /* 111135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111137 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111140 */   GIR_RootConstrainSelectedInstOperands,
     /* 111141 */   // GIR_Coverage, 1116,
     /* 111141 */   GIR_EraseRootFromParent_Done,
     /* 111142 */ // Label 2388: @111142
     /* 111142 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(111188), // Rule ID 17719 //
     /* 111147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111150 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 111154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111158 */   // MIs[0] Operand 1
     /* 111158 */   // No operand predicates
     /* 111158 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } (LD_Fp032:{ *:[f32] }:{ *:[i16] }))
     /* 111158 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111161 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp032),
     /* 111165 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111170 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111173 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 111178 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111180 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111183 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111186 */   GIR_RootConstrainSelectedInstOperands,
     /* 111187 */   // GIR_Coverage, 17719,
     /* 111187 */   GIR_EraseRootFromParent_Done,
     /* 111188 */ // Label 2389: @111188
     /* 111188 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(111234), // Rule ID 17720 //
     /* 111193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111196 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 111200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111204 */   // MIs[0] Operand 1
     /* 111204 */   // No operand predicates
     /* 111204 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } (LD_Fp132:{ *:[f32] }:{ *:[i16] }))
     /* 111204 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111207 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp132),
     /* 111211 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111216 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 111224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111226 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111229 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111232 */   GIR_RootConstrainSelectedInstOperands,
     /* 111233 */   // GIR_Coverage, 17720,
     /* 111233 */   GIR_EraseRootFromParent_Done,
     /* 111234 */ // Label 2390: @111234
     /* 111234 */ GIM_Reject,
     /* 111235 */ // Label 2384: @111235
     /* 111235 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(111261), // Rule ID 1117 //
     /* 111240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 111243 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 111247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 111251 */   // MIs[0] Operand 1
     /* 111251 */   // No operand predicates
     /* 111251 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (LD_Fp064:{ *:[f64] }:{ *:[i16] })
     /* 111251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp064),
     /* 111254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111256 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111259 */   GIR_RootConstrainSelectedInstOperands,
     /* 111260 */   // GIR_Coverage, 1117,
     /* 111260 */   GIR_EraseRootFromParent_Done,
     /* 111261 */ // Label 2391: @111261
     /* 111261 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(111287), // Rule ID 1118 //
     /* 111266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 111269 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 111273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 111277 */   // MIs[0] Operand 1
     /* 111277 */   // No operand predicates
     /* 111277 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm1>>  =>  (LD_Fp164:{ *:[f64] }:{ *:[i16] })
     /* 111277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp164),
     /* 111280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111282 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111285 */   GIR_RootConstrainSelectedInstOperands,
     /* 111286 */   // GIR_Coverage, 1118,
     /* 111286 */   GIR_EraseRootFromParent_Done,
     /* 111287 */ // Label 2392: @111287
     /* 111287 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(111333), // Rule ID 17721 //
     /* 111292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 111295 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 111299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 111303 */   // MIs[0] Operand 1
     /* 111303 */   // No operand predicates
     /* 111303 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } (LD_Fp064:{ *:[f64] }:{ *:[i16] }))
     /* 111303 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 111306 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp064),
     /* 111310 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111315 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 111323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111325 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111328 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111331 */   GIR_RootConstrainSelectedInstOperands,
     /* 111332 */   // GIR_Coverage, 17721,
     /* 111332 */   GIR_EraseRootFromParent_Done,
     /* 111333 */ // Label 2393: @111333
     /* 111333 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(111379), // Rule ID 17722 //
     /* 111338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 111341 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 111345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 111349 */   // MIs[0] Operand 1
     /* 111349 */   // No operand predicates
     /* 111349 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } (LD_Fp164:{ *:[f64] }:{ *:[i16] }))
     /* 111349 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 111352 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp164),
     /* 111356 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111361 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 111369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111374 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111377 */   GIR_RootConstrainSelectedInstOperands,
     /* 111378 */   // GIR_Coverage, 17722,
     /* 111378 */   GIR_EraseRootFromParent_Done,
     /* 111379 */ // Label 2394: @111379
     /* 111379 */ GIM_Reject,
     /* 111380 */ // Label 2385: @111380
     /* 111380 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(111406), // Rule ID 1119 //
     /* 111385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 111388 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 111392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 111396 */   // MIs[0] Operand 1
     /* 111396 */   // No operand predicates
     /* 111396 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimm0>>  =>  (LD_Fp080:{ *:[f80] }:{ *:[i16] })
     /* 111396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp080),
     /* 111399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111401 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111404 */   GIR_RootConstrainSelectedInstOperands,
     /* 111405 */   // GIR_Coverage, 1119,
     /* 111405 */   GIR_EraseRootFromParent_Done,
     /* 111406 */ // Label 2395: @111406
     /* 111406 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(111432), // Rule ID 1120 //
     /* 111411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 111414 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 111418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 111422 */   // MIs[0] Operand 1
     /* 111422 */   // No operand predicates
     /* 111422 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimm1>>  =>  (LD_Fp180:{ *:[f80] }:{ *:[i16] })
     /* 111422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp180),
     /* 111425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111427 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111430 */   GIR_RootConstrainSelectedInstOperands,
     /* 111431 */   // GIR_Coverage, 1120,
     /* 111431 */   GIR_EraseRootFromParent_Done,
     /* 111432 */ // Label 2396: @111432
     /* 111432 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(111475), // Rule ID 17723 //
     /* 111437 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 111441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 111445 */   // MIs[0] Operand 1
     /* 111445 */   // No operand predicates
     /* 111445 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } (LD_Fp080:{ *:[f80] }:{ *:[i16] }))
     /* 111445 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s80,
     /* 111448 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp080),
     /* 111452 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111457 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 111465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111467 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111470 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111473 */   GIR_RootConstrainSelectedInstOperands,
     /* 111474 */   // GIR_Coverage, 17723,
     /* 111474 */   GIR_EraseRootFromParent_Done,
     /* 111475 */ // Label 2397: @111475
     /* 111475 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(111518), // Rule ID 17724 //
     /* 111480 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 111484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 111488 */   // MIs[0] Operand 1
     /* 111488 */   // No operand predicates
     /* 111488 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } (LD_Fp180:{ *:[f80] }:{ *:[i16] }))
     /* 111488 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s80,
     /* 111491 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp180),
     /* 111495 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111500 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111503 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 111508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111510 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111513 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111516 */   GIR_RootConstrainSelectedInstOperands,
     /* 111517 */   // GIR_Coverage, 17724,
     /* 111517 */   GIR_EraseRootFromParent_Done,
     /* 111518 */ // Label 2398: @111518
     /* 111518 */ GIM_Reject,
     /* 111519 */ // Label 2386: @111519
     /* 111519 */ GIM_Reject,
     /* 111520 */ // Label 23: @111520
     /* 111520 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(25), /*)*//*default:*//*Label 2414*/ GIMT_Encode4(113191),
     /* 111531 */ /*GILLT_s16*//*Label 2399*/ GIMT_Encode4(111623),
     /* 111535 */ /*GILLT_s32*//*Label 2400*/ GIMT_Encode4(111681),
     /* 111539 */ /*GILLT_s64*//*Label 2401*/ GIMT_Encode4(111728), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 111555 */ /*GILLT_v2s64*//*Label 2402*/ GIMT_Encode4(111801), GIMT_Encode4(0),
     /* 111563 */ /*GILLT_v4s32*//*Label 2403*/ GIMT_Encode4(111828),
     /* 111567 */ /*GILLT_v4s64*//*Label 2404*/ GIMT_Encode4(111855), GIMT_Encode4(0),
     /* 111575 */ /*GILLT_v8s16*//*Label 2405*/ GIMT_Encode4(112052),
     /* 111579 */ /*GILLT_v8s32*//*Label 2406*/ GIMT_Encode4(112121),
     /* 111583 */ /*GILLT_v8s64*//*Label 2407*/ GIMT_Encode4(112318), GIMT_Encode4(0),
     /* 111591 */ /*GILLT_v16s8*//*Label 2408*/ GIMT_Encode4(112515),
     /* 111595 */ /*GILLT_v16s16*//*Label 2409*/ GIMT_Encode4(112584),
     /* 111599 */ /*GILLT_v16s32*//*Label 2410*/ GIMT_Encode4(112828), GIMT_Encode4(0),
     /* 111607 */ /*GILLT_v32s8*//*Label 2411*/ GIMT_Encode4(113025),
     /* 111611 */ /*GILLT_v32s16*//*Label 2412*/ GIMT_Encode4(113052), GIMT_Encode4(0),
     /* 111619 */ /*GILLT_v64s8*//*Label 2413*/ GIMT_Encode4(113164),
     /* 111623 */ // Label 2399: @111623
     /* 111623 */ GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(111680), // Rule ID 22644 //
     /* 111628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 111631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 111635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 111639 */   // (sext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 111639 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111642 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 111646 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111651 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 111655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111662 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 111669 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 111674 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111679 */   // GIR_Coverage, 22644,
     /* 111679 */   GIR_EraseRootFromParent_Done,
     /* 111680 */ // Label 2415: @111680
     /* 111680 */ GIM_Reject,
     /* 111681 */ // Label 2400: @111681
     /* 111681 */ GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(111704), // Rule ID 614 //
     /* 111686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 111689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 111697 */   // (sext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVSX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 111697 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 111702 */   GIR_RootConstrainSelectedInstOperands,
     /* 111703 */   // GIR_Coverage, 614,
     /* 111703 */   GIR_Done,
     /* 111704 */ // Label 2416: @111704
     /* 111704 */ GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(111727), // Rule ID 616 //
     /* 111709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 111712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 111720 */   // (sext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (MOVSX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /* 111720 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr16),
     /* 111725 */   GIR_RootConstrainSelectedInstOperands,
     /* 111726 */   // GIR_Coverage, 616,
     /* 111726 */   GIR_Done,
     /* 111727 */ // Label 2417: @111727
     /* 111727 */ GIM_Reject,
     /* 111728 */ // Label 2401: @111728
     /* 111728 */ GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(111751), // Rule ID 622 //
     /* 111733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 111736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 111744 */   // (sext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (MOVSX64rr8:{ *:[i64] } GR8:{ *:[i8] }:$src)
     /* 111744 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr8),
     /* 111749 */   GIR_RootConstrainSelectedInstOperands,
     /* 111750 */   // GIR_Coverage, 622,
     /* 111750 */   GIR_Done,
     /* 111751 */ // Label 2418: @111751
     /* 111751 */ GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(111774), // Rule ID 624 //
     /* 111756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 111759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 111767 */   // (sext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (MOVSX64rr16:{ *:[i64] } GR16:{ *:[i16] }:$src)
     /* 111767 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr16),
     /* 111772 */   GIR_RootConstrainSelectedInstOperands,
     /* 111773 */   // GIR_Coverage, 624,
     /* 111773 */   GIR_Done,
     /* 111774 */ // Label 2419: @111774
     /* 111774 */ GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(111800), // Rule ID 626 //
     /* 111779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 111782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 111785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111793 */   // (sext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (MOVSX64rr32:{ *:[i64] } GR32:{ *:[i32] }:$src)
     /* 111793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr32),
     /* 111798 */   GIR_RootConstrainSelectedInstOperands,
     /* 111799 */   // GIR_Coverage, 626,
     /* 111799 */   GIR_Done,
     /* 111800 */ // Label 2420: @111800
     /* 111800 */ GIM_Reject,
     /* 111801 */ // Label 2402: @111801
     /* 111801 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(111827), // Rule ID 12593 //
     /* 111806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 111809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 111812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 111816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 111820 */   // (sext:{ *:[v2i64] } VK2:{ *:[v2i1] }:$src)  =>  (VPMOVM2QZ128rk:{ *:[v2i64] } VK2:{ *:[v2i1] }:$src)
     /* 111820 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZ128rk),
     /* 111825 */   GIR_RootConstrainSelectedInstOperands,
     /* 111826 */   // GIR_Coverage, 12593,
     /* 111826 */   GIR_Done,
     /* 111827 */ // Label 2421: @111827
     /* 111827 */ GIM_Reject,
     /* 111828 */ // Label 2403: @111828
     /* 111828 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(111854), // Rule ID 12590 //
     /* 111833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 111836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 111839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 111843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 111847 */   // (sext:{ *:[v4i32] } VK4:{ *:[v4i1] }:$src)  =>  (VPMOVM2DZ128rk:{ *:[v4i32] } VK4:{ *:[v4i1] }:$src)
     /* 111847 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ128rk),
     /* 111852 */   GIR_RootConstrainSelectedInstOperands,
     /* 111853 */   // GIR_Coverage, 12590,
     /* 111853 */   GIR_Done,
     /* 111854 */ // Label 2422: @111854
     /* 111854 */ GIM_Reject,
     /* 111855 */ // Label 2404: @111855
     /* 111855 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(111914), // Rule ID 18389 //
     /* 111860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 111863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 111870 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111874 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 111878 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111881 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 111885 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 111889 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111891 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 111898 */   // (sext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXDQYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 111898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQYrm),
     /* 111901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111903 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 111907 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 111912 */   GIR_RootConstrainSelectedInstOperands,
     /* 111913 */   // GIR_Coverage, 18389,
     /* 111913 */   GIR_EraseRootFromParent_Done,
     /* 111914 */ // Label 2423: @111914
     /* 111914 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(111973), // Rule ID 21584 //
     /* 111919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 111922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 111929 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111933 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 111937 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111940 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 111944 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 111948 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111950 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 111957 */   // (sext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXDQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 111957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZ256rm),
     /* 111960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111962 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 111966 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 111971 */   GIR_RootConstrainSelectedInstOperands,
     /* 111972 */   // GIR_Coverage, 21584,
     /* 111972 */   GIR_EraseRootFromParent_Done,
     /* 111973 */ // Label 2424: @111973
     /* 111973 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(111999), // Rule ID 12570 //
     /* 111978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 111981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 111988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 111992 */   // (sext:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)  =>  (VPMOVSXDQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)
     /* 111992 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZ256rr),
     /* 111997 */   GIR_RootConstrainSelectedInstOperands,
     /* 111998 */   // GIR_Coverage, 12570,
     /* 111998 */   GIR_Done,
     /* 111999 */ // Label 2425: @111999
     /* 111999 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(112025), // Rule ID 12592 //
     /* 112004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 112010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 112018 */   // (sext:{ *:[v4i64] } VK4:{ *:[v4i1] }:$src)  =>  (VPMOVM2QZ256rk:{ *:[v4i64] } VK4:{ *:[v4i1] }:$src)
     /* 112018 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZ256rk),
     /* 112023 */   GIR_RootConstrainSelectedInstOperands,
     /* 112024 */   // GIR_Coverage, 12592,
     /* 112024 */   GIR_Done,
     /* 112025 */ // Label 2426: @112025
     /* 112025 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(112051), // Rule ID 18377 //
     /* 112030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 112033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 112044 */   // (sext:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)  =>  (VPMOVSXDQYrr:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)
     /* 112044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQYrr),
     /* 112049 */   GIR_RootConstrainSelectedInstOperands,
     /* 112050 */   // GIR_Coverage, 18377,
     /* 112050 */   GIR_Done,
     /* 112051 */ // Label 2427: @112051
     /* 112051 */ GIM_Reject,
     /* 112052 */ // Label 2405: @112052
     /* 112052 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(112120),
     /* 112057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 112060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 112068 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(112083), // Rule ID 12587 //
     /* 112073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 112076 */     // (sext:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2WZ128rk:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)
     /* 112076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZ128rk),
     /* 112081 */     GIR_RootConstrainSelectedInstOperands,
     /* 112082 */     // GIR_Coverage, 12587,
     /* 112082 */     GIR_Done,
     /* 112083 */   // Label 2429: @112083
     /* 112083 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(112119), // Rule ID 21660 //
     /* 112088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX_NoBWI),
     /* 112091 */     // (sext:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVDWZ256rr:{ *:[v8i16] } (VPMOVM2DZ256rk:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src))
     /* 112091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 112094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ256rk),
     /* 112098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112103 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZ256rr),
     /* 112112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112117 */     GIR_RootConstrainSelectedInstOperands,
     /* 112118 */     // GIR_Coverage, 21660,
     /* 112118 */     GIR_EraseRootFromParent_Done,
     /* 112119 */   // Label 2430: @112119
     /* 112119 */   GIM_Reject,
     /* 112120 */ // Label 2428: @112120
     /* 112120 */ GIM_Reject,
     /* 112121 */ // Label 2406: @112121
     /* 112121 */ GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(112180), // Rule ID 18385 //
     /* 112126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 112129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112136 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112140 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112144 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112147 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112151 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112155 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112157 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112164 */   // (sext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWDYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 112164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDYrm),
     /* 112167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112169 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112173 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112178 */   GIR_RootConstrainSelectedInstOperands,
     /* 112179 */   // GIR_Coverage, 18385,
     /* 112179 */   GIR_EraseRootFromParent_Done,
     /* 112180 */ // Label 2431: @112180
     /* 112180 */ GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(112239), // Rule ID 21583 //
     /* 112185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 112188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112195 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112199 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112203 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112206 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112210 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112214 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112216 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112223 */   // (sext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 112223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZ256rm),
     /* 112226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112228 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112232 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112237 */   GIR_RootConstrainSelectedInstOperands,
     /* 112238 */   // GIR_Coverage, 21583,
     /* 112238 */   GIR_EraseRootFromParent_Done,
     /* 112239 */ // Label 2432: @112239
     /* 112239 */ GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(112265), // Rule ID 12534 //
     /* 112244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 112247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112258 */   // (sext:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVSXWDZ256rr:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)
     /* 112258 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZ256rr),
     /* 112263 */   GIR_RootConstrainSelectedInstOperands,
     /* 112264 */   // GIR_Coverage, 12534,
     /* 112264 */   GIR_Done,
     /* 112265 */ // Label 2433: @112265
     /* 112265 */ GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(112291), // Rule ID 12589 //
     /* 112270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 112276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 112284 */   // (sext:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2DZ256rk:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src)
     /* 112284 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ256rk),
     /* 112289 */   GIR_RootConstrainSelectedInstOperands,
     /* 112290 */   // GIR_Coverage, 12589,
     /* 112290 */   GIR_Done,
     /* 112291 */ // Label 2434: @112291
     /* 112291 */ GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(112317), // Rule ID 18375 //
     /* 112296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 112299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 112310 */   // (sext:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)  =>  (VPMOVSXWDYrr:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)
     /* 112310 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDYrr),
     /* 112315 */   GIR_RootConstrainSelectedInstOperands,
     /* 112316 */   // GIR_Coverage, 18375,
     /* 112316 */   GIR_Done,
     /* 112317 */ // Label 2435: @112317
     /* 112317 */ GIM_Reject,
     /* 112318 */ // Label 2407: @112318
     /* 112318 */ GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(112377), // Rule ID 21588 //
     /* 112323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 112326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 112333 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112337 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112341 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112344 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112348 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112352 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112354 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112361 */   // (sext:{ *:[v8i64] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 112361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWQZrm),
     /* 112364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112366 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112370 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112375 */   GIR_RootConstrainSelectedInstOperands,
     /* 112376 */   // GIR_Coverage, 21588,
     /* 112376 */   GIR_EraseRootFromParent_Done,
     /* 112377 */ // Label 2436: @112377
     /* 112377 */ GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(112436), // Rule ID 21589 //
     /* 112382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 112385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 112388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 112392 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112396 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112400 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112403 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112407 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112411 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112413 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112420 */   // (sext:{ *:[v8i64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXDQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 112420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZrm),
     /* 112423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112425 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112429 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112434 */   GIR_RootConstrainSelectedInstOperands,
     /* 112435 */   // GIR_Coverage, 21589,
     /* 112435 */   GIR_EraseRootFromParent_Done,
     /* 112436 */ // Label 2437: @112436
     /* 112436 */ GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(112462), // Rule ID 12558 //
     /* 112441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 112444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 112451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112455 */   // (sext:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVSXWQZrr:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)
     /* 112455 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWQZrr),
     /* 112460 */   GIR_RootConstrainSelectedInstOperands,
     /* 112461 */   // GIR_Coverage, 12558,
     /* 112461 */   GIR_Done,
     /* 112462 */ // Label 2438: @112462
     /* 112462 */ GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(112488), // Rule ID 12576 //
     /* 112467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 112470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 112473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 112477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112481 */   // (sext:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVSXDQZrr:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)
     /* 112481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZrr),
     /* 112486 */   GIR_RootConstrainSelectedInstOperands,
     /* 112487 */   // GIR_Coverage, 12576,
     /* 112487 */   GIR_Done,
     /* 112488 */ // Label 2439: @112488
     /* 112488 */ GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(112514), // Rule ID 12591 //
     /* 112493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 112496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 112499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 112503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 112507 */   // (sext:{ *:[v8i64] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2QZrk:{ *:[v8i64] } VK8:{ *:[v8i1] }:$src)
     /* 112507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZrk),
     /* 112512 */   GIR_RootConstrainSelectedInstOperands,
     /* 112513 */   // GIR_Coverage, 12591,
     /* 112513 */   GIR_Done,
     /* 112514 */ // Label 2440: @112514
     /* 112514 */ GIM_Reject,
     /* 112515 */ // Label 2408: @112515
     /* 112515 */ GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(112583),
     /* 112520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 112523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 112531 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(112546), // Rule ID 12584 //
     /* 112536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 112539 */     // (sext:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2BZ128rk:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)
     /* 112539 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZ128rk),
     /* 112544 */     GIR_RootConstrainSelectedInstOperands,
     /* 112545 */     // GIR_Coverage, 12584,
     /* 112545 */     GIR_Done,
     /* 112546 */   // Label 2442: @112546
     /* 112546 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(112582), // Rule ID 21658 //
     /* 112551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoBWI),
     /* 112554 */     // (sext:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src))
     /* 112554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 112557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 112561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 112575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112580 */     GIR_RootConstrainSelectedInstOperands,
     /* 112581 */     // GIR_Coverage, 21658,
     /* 112581 */     GIR_EraseRootFromParent_Done,
     /* 112582 */   // Label 2443: @112582
     /* 112582 */   GIM_Reject,
     /* 112583 */ // Label 2441: @112583
     /* 112583 */ GIM_Reject,
     /* 112584 */ // Label 2409: @112584
     /* 112584 */ GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(112643), // Rule ID 18379 //
     /* 112589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 112592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112599 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112603 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112607 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112610 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112614 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112618 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112620 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112627 */   // (sext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBWYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 112627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWYrm),
     /* 112630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112632 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112636 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112641 */   GIR_RootConstrainSelectedInstOperands,
     /* 112642 */   // GIR_Coverage, 18379,
     /* 112642 */   GIR_EraseRootFromParent_Done,
     /* 112643 */ // Label 2444: @112643
     /* 112643 */ GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(112702), // Rule ID 21582 //
     /* 112648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 112651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112658 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112662 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112666 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112669 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112673 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112677 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112679 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112686 */   // (sext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 112686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZ256rm),
     /* 112689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112691 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112695 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112700 */   GIR_RootConstrainSelectedInstOperands,
     /* 112701 */   // GIR_Coverage, 21582,
     /* 112701 */   GIR_EraseRootFromParent_Done,
     /* 112702 */ // Label 2445: @112702
     /* 112702 */ GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(112728), // Rule ID 12480 //
     /* 112707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 112710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112721 */   // (sext:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVSXBWZ256rr:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)
     /* 112721 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZ256rr),
     /* 112726 */   GIR_RootConstrainSelectedInstOperands,
     /* 112727 */   // GIR_Coverage, 12480,
     /* 112727 */   GIR_Done,
     /* 112728 */ // Label 2446: @112728
     /* 112728 */ GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(112754), // Rule ID 12586 //
     /* 112733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 112736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 112739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 112747 */   // (sext:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2WZ256rk:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)
     /* 112747 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZ256rk),
     /* 112752 */   GIR_RootConstrainSelectedInstOperands,
     /* 112753 */   // GIR_Coverage, 12586,
     /* 112753 */   GIR_Done,
     /* 112754 */ // Label 2447: @112754
     /* 112754 */ GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(112780), // Rule ID 18372 //
     /* 112759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 112762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 112773 */   // (sext:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)  =>  (VPMOVSXBWYrr:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)
     /* 112773 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWYrr),
     /* 112778 */   GIR_RootConstrainSelectedInstOperands,
     /* 112779 */   // GIR_Coverage, 18372,
     /* 112779 */   GIR_Done,
     /* 112780 */ // Label 2448: @112780
     /* 112780 */ GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(112827), // Rule ID 21659 //
     /* 112785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoBWI),
     /* 112788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 112791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 112799 */   // (sext:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVDWZrr:{ *:[v16i16] } (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src))
     /* 112799 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 112802 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 112806 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112811 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112815 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 112820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112822 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112825 */   GIR_RootConstrainSelectedInstOperands,
     /* 112826 */   // GIR_Coverage, 21659,
     /* 112826 */   GIR_EraseRootFromParent_Done,
     /* 112827 */ // Label 2449: @112827
     /* 112827 */ GIM_Reject,
     /* 112828 */ // Label 2410: @112828
     /* 112828 */ GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(112887), // Rule ID 21586 //
     /* 112833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 112836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 112843 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112847 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112851 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112854 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112858 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112862 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112864 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112871 */   // (sext:{ *:[v16i32] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 112871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBDZrm),
     /* 112874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112876 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112880 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112885 */   GIR_RootConstrainSelectedInstOperands,
     /* 112886 */   // GIR_Coverage, 21586,
     /* 112886 */   GIR_EraseRootFromParent_Done,
     /* 112887 */ // Label 2450: @112887
     /* 112887 */ GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(112946), // Rule ID 21587 //
     /* 112892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 112895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 112898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 112902 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112906 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112910 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112913 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112917 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112921 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112923 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112930 */   // (sext:{ *:[v16i32] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 112930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZrm),
     /* 112933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112935 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112939 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112944 */   GIR_RootConstrainSelectedInstOperands,
     /* 112945 */   // GIR_Coverage, 21587,
     /* 112945 */   GIR_EraseRootFromParent_Done,
     /* 112946 */ // Label 2451: @112946
     /* 112946 */ GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(112972), // Rule ID 12504 //
     /* 112951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 112954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 112961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112965 */   // (sext:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVSXBDZrr:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)
     /* 112965 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBDZrr),
     /* 112970 */   GIR_RootConstrainSelectedInstOperands,
     /* 112971 */   // GIR_Coverage, 12504,
     /* 112971 */   GIR_Done,
     /* 112972 */ // Label 2452: @112972
     /* 112972 */ GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(112998), // Rule ID 12540 //
     /* 112977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 112980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 112983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 112987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112991 */   // (sext:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVSXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)
     /* 112991 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZrr),
     /* 112996 */   GIR_RootConstrainSelectedInstOperands,
     /* 112997 */   // GIR_Coverage, 12540,
     /* 112997 */   GIR_Done,
     /* 112998 */ // Label 2453: @112998
     /* 112998 */ GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(113024), // Rule ID 12588 //
     /* 113003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 113006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113017 */   // (sext:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src)
     /* 113017 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 113022 */   GIR_RootConstrainSelectedInstOperands,
     /* 113023 */   // GIR_Coverage, 12588,
     /* 113023 */   GIR_Done,
     /* 113024 */ // Label 2454: @113024
     /* 113024 */ GIM_Reject,
     /* 113025 */ // Label 2411: @113025
     /* 113025 */ GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(113051), // Rule ID 12583 //
     /* 113030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 113036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 113044 */   // (sext:{ *:[v32i8] } VK32:{ *:[v32i1] }:$src)  =>  (VPMOVM2BZ256rk:{ *:[v32i8] } VK32:{ *:[v32i1] }:$src)
     /* 113044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZ256rk),
     /* 113049 */   GIR_RootConstrainSelectedInstOperands,
     /* 113050 */   // GIR_Coverage, 12583,
     /* 113050 */   GIR_Done,
     /* 113051 */ // Label 2455: @113051
     /* 113051 */ GIM_Reject,
     /* 113052 */ // Label 2412: @113052
     /* 113052 */ GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(113111), // Rule ID 21585 //
     /* 113057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 113063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113067 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113071 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113075 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113078 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113082 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113086 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113088 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113095 */   // (sext:{ *:[v32i16] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /* 113095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZrm),
     /* 113098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113100 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113104 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113109 */   GIR_RootConstrainSelectedInstOperands,
     /* 113110 */   // GIR_Coverage, 21585,
     /* 113110 */   GIR_EraseRootFromParent_Done,
     /* 113111 */ // Label 2456: @113111
     /* 113111 */ GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(113137), // Rule ID 12486 //
     /* 113116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 113122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113130 */   // (sext:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)  =>  (VPMOVSXBWZrr:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)
     /* 113130 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZrr),
     /* 113135 */   GIR_RootConstrainSelectedInstOperands,
     /* 113136 */   // GIR_Coverage, 12486,
     /* 113136 */   GIR_Done,
     /* 113137 */ // Label 2457: @113137
     /* 113137 */ GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(113163), // Rule ID 12585 //
     /* 113142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 113148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 113156 */   // (sext:{ *:[v32i16] } VK32:{ *:[v32i1] }:$src)  =>  (VPMOVM2WZrk:{ *:[v32i16] } VK32:{ *:[v32i1] }:$src)
     /* 113156 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZrk),
     /* 113161 */   GIR_RootConstrainSelectedInstOperands,
     /* 113162 */   // GIR_Coverage, 12585,
     /* 113162 */   GIR_Done,
     /* 113163 */ // Label 2458: @113163
     /* 113163 */ GIM_Reject,
     /* 113164 */ // Label 2413: @113164
     /* 113164 */ GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(113190), // Rule ID 12582 //
     /* 113169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 113175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 113183 */   // (sext:{ *:[v64i8] } VK64:{ *:[v64i1] }:$src)  =>  (VPMOVM2BZrk:{ *:[v64i8] } VK64:{ *:[v64i1] }:$src)
     /* 113183 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZrk),
     /* 113188 */   GIR_RootConstrainSelectedInstOperands,
     /* 113189 */   // GIR_Coverage, 12582,
     /* 113189 */   GIR_Done,
     /* 113190 */ // Label 2459: @113190
     /* 113190 */ GIM_Reject,
     /* 113191 */ // Label 2414: @113191
     /* 113191 */ GIM_Reject,
     /* 113192 */ // Label 24: @113192
     /* 113192 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2462*/ GIMT_Encode4(113433),
     /* 113203 */ /*GILLT_s16*//*Label 2460*/ GIMT_Encode4(113211),
     /* 113207 */ /*GILLT_s32*//*Label 2461*/ GIMT_Encode4(113307),
     /* 113211 */ // Label 2460: @113211
     /* 113211 */ GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(113306), // Rule ID 22640 //
     /* 113216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 113223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 113227 */   // MIs[0] Operand 2
     /* 113227 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 113238 */   // (sext_inreg:{ *:[i16] } GR16:{ *:[i16] }:$src, i8:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src, sub_8bit:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /* 113238 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 113241 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113245 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113250 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 113256 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 113261 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 113266 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113269 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 113273 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113278 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 113281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113288 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 113295 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 113300 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 113305 */   // GIR_Coverage, 22640,
     /* 113305 */   GIR_EraseRootFromParent_Done,
     /* 113306 */ // Label 2463: @113306
     /* 113306 */ GIM_Reject,
     /* 113307 */ // Label 2461: @113307
     /* 113307 */ GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(113432),
     /* 113312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 113319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 113323 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(113377), // Rule ID 22638 //
     /* 113328 */     // MIs[0] Operand 2
     /* 113328 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 113339 */     // (sext_inreg:{ *:[i32] } GR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (MOVSX32rr16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src, sub_16bit:{ *:[i32] }))
     /* 113339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113351 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
     /* 113357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 113362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 113367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr16),
     /* 113370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113375 */     GIR_RootConstrainSelectedInstOperands,
     /* 113376 */     // GIR_Coverage, 22638,
     /* 113376 */     GIR_EraseRootFromParent_Done,
     /* 113377 */   // Label 2465: @113377
     /* 113377 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(113431), // Rule ID 22639 //
     /* 113382 */     // MIs[0] Operand 2
     /* 113382 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 113393 */     // (sext_inreg:{ *:[i32] } GR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (MOVSX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src, sub_8bit:{ *:[i32] }))
     /* 113393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 113396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113405 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 113411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 113416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 113421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 113424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113429 */     GIR_RootConstrainSelectedInstOperands,
     /* 113430 */     // GIR_Coverage, 22639,
     /* 113430 */     GIR_EraseRootFromParent_Done,
     /* 113431 */   // Label 2466: @113431
     /* 113431 */   GIM_Reject,
     /* 113432 */ // Label 2464: @113432
     /* 113432 */ GIM_Reject,
     /* 113433 */ // Label 2462: @113433
     /* 113433 */ GIM_Reject,
     /* 113434 */ // Label 25: @113434
     /* 113434 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2476*/ GIMT_Encode4(115417),
     /* 113445 */ /*GILLT_s16*//*Label 2467*/ GIMT_Encode4(113529),
     /* 113449 */ /*GILLT_s32*//*Label 2468*/ GIMT_Encode4(113587),
     /* 113453 */ /*GILLT_s64*//*Label 2469*/ GIMT_Encode4(113939), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113481 */ /*GILLT_v4s64*//*Label 2470*/ GIMT_Encode4(114486), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113493 */ /*GILLT_v8s32*//*Label 2471*/ GIMT_Encode4(114654),
     /* 113497 */ /*GILLT_v8s64*//*Label 2472*/ GIMT_Encode4(114822), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113509 */ /*GILLT_v16s16*//*Label 2473*/ GIMT_Encode4(114993),
     /* 113513 */ /*GILLT_v16s32*//*Label 2474*/ GIMT_Encode4(115161), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113525 */ /*GILLT_v32s16*//*Label 2475*/ GIMT_Encode4(115332),
     /* 113529 */ // Label 2467: @113529
     /* 113529 */ GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(113586), // Rule ID 22646 //
     /* 113534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 113537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 113541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 113545 */   // (zext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 113545 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113548 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 113552 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113557 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113568 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 113575 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 113580 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 113585 */   // GIR_Coverage, 22646,
     /* 113585 */   GIR_EraseRootFromParent_Done,
     /* 113586 */ // Label 2477: @113586
     /* 113586 */ GIM_Reject,
     /* 113587 */ // Label 2468: @113587
     /* 113587 */ GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(113710), // Rule ID 22970 //
     /* 113592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 113595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 113602 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113606 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 113610 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113614 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113618 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113622 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113626 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113629 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 113633 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 113637 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 113641 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 113645 */   // MIs[3] Operand 1
     /* 113645 */   // No operand predicates
     /* 113645 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 113647 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113654 */   // (zext:{ *:[i32] } (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i32] } 0:{ *:[i32] }, (IMULZU16rmi:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 113654 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113657 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rmi),
     /* 113661 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113666 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src1
     /* 113670 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // src2
     /* 113673 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 113676 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 113683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 113688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113693 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 113699 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 113704 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 113709 */   // GIR_Coverage, 22970,
     /* 113709 */   GIR_EraseRootFromParent_Done,
     /* 113710 */ // Label 2478: @113710
     /* 113710 */ GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(113805), // Rule ID 22969 //
     /* 113715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 113718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 113725 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113729 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 113733 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113737 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113741 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 113746 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113750 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 113754 */   // MIs[2] Operand 1
     /* 113754 */   // No operand predicates
     /* 113754 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113756 */   // (zext:{ *:[i32] } (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i32] } 0:{ *:[i32] }, (IMULZU16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 113756 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113759 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rri),
     /* 113763 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113768 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 113772 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // src2
     /* 113775 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 113778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 113783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113788 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 113794 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 113799 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 113804 */   // GIR_Coverage, 22969,
     /* 113804 */   GIR_EraseRootFromParent_Done,
     /* 113805 */ // Label 2479: @113805
     /* 113805 */ GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(113847), // Rule ID 19434 //
     /* 113810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 113817 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113821 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 113825 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113829 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113834 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113836 */   // (zext:{ *:[i32] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (KMOVWrk:{ *:[i32] } VK16:{ *:[v16i1] }:$src)
     /* 113836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWrk),
     /* 113839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113841 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 113845 */   GIR_RootConstrainSelectedInstOperands,
     /* 113846 */   // GIR_Coverage, 19434,
     /* 113846 */   GIR_EraseRootFromParent_Done,
     /* 113847 */ // Label 2480: @113847
     /* 113847 */ GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(113892), // Rule ID 19437 //
     /* 113852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 113855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 113858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 113862 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113866 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 113870 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 113874 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 113879 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113881 */   // (zext:{ *:[i32] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (KMOVBrk:{ *:[i32] } VK8:{ *:[v8i1] }:$src)
     /* 113881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBrk),
     /* 113884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113886 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 113890 */   GIR_RootConstrainSelectedInstOperands,
     /* 113891 */   // GIR_Coverage, 19437,
     /* 113891 */   GIR_EraseRootFromParent_Done,
     /* 113892 */ // Label 2481: @113892
     /* 113892 */ GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(113915), // Rule ID 618 //
     /* 113897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 113900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 113904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 113908 */   // (zext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 113908 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 113913 */   GIR_RootConstrainSelectedInstOperands,
     /* 113914 */   // GIR_Coverage, 618,
     /* 113914 */   GIR_Done,
     /* 113915 */ // Label 2482: @113915
     /* 113915 */ GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(113938), // Rule ID 620 //
     /* 113920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 113927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 113931 */   // (zext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /* 113931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 113936 */   GIR_RootConstrainSelectedInstOperands,
     /* 113937 */   // GIR_Coverage, 620,
     /* 113937 */   GIR_Done,
     /* 113938 */ // Label 2483: @113938
     /* 113938 */ GIM_Reject,
     /* 113939 */ // Label 2469: @113939
     /* 113939 */ GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(114062), // Rule ID 22972 //
     /* 113944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 113947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 113954 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113958 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 113962 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113966 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113970 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113974 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113978 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113981 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 113985 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 113989 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 113993 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 113997 */   // MIs[3] Operand 1
     /* 113997 */   // No operand predicates
     /* 113997 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 113999 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 114006 */   // (zext:{ *:[i64] } (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (IMULZU16rmi:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rmi),
     /* 114013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114018 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src1
     /* 114022 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // src2
     /* 114025 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114028 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 114035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114045 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114051 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114056 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114061 */   // GIR_Coverage, 22972,
     /* 114061 */   GIR_EraseRootFromParent_Done,
     /* 114062 */ // Label 2484: @114062
     /* 114062 */ GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(114157), // Rule ID 22971 //
     /* 114067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114077 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114081 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114085 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114089 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114093 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114098 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114102 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114106 */   // MIs[2] Operand 1
     /* 114106 */   // No operand predicates
     /* 114106 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114108 */   // (zext:{ *:[i64] } (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (IMULZU16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114108 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114111 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rri),
     /* 114115 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114120 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 114124 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // src2
     /* 114127 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114130 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114140 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114146 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114151 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114156 */   // GIR_Coverage, 22971,
     /* 114156 */   GIR_EraseRootFromParent_Done,
     /* 114157 */ // Label 2485: @114157
     /* 114157 */ GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(114231), // Rule ID 19435 //
     /* 114162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114169 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114173 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114177 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 114181 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 114186 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114188 */   // (zext:{ *:[i64] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (KMOVWrk:{ *:[i32] } VK16:{ *:[v16i1] }:$src), sub_32bit:{ *:[i32] })
     /* 114188 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114191 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVWrk),
     /* 114195 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114200 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 114204 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114214 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 114220 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114225 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 114230 */   // GIR_Coverage, 19435,
     /* 114230 */   GIR_EraseRootFromParent_Done,
     /* 114231 */ // Label 2486: @114231
     /* 114231 */ GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(114308), // Rule ID 19438 //
     /* 114236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 114239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114246 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114250 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114254 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 114258 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 114263 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114265 */   // (zext:{ *:[i64] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (KMOVBrk:{ *:[i32] } VK8:{ *:[v8i1] }:$src), sub_32bit:{ *:[i32] })
     /* 114265 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114268 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBrk),
     /* 114272 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114277 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 114281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114291 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 114297 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114302 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 114307 */   // GIR_Coverage, 19438,
     /* 114307 */   GIR_EraseRootFromParent_Done,
     /* 114308 */ // Label 2487: @114308
     /* 114308 */ GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(114367), // Rule ID 17589 //
     /* 114313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 114324 */   // (zext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_32bit:{ *:[i32] })
     /* 114324 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114327 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 114331 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114336 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114340 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114350 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 114356 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114361 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 114366 */   // GIR_Coverage, 17589,
     /* 114366 */   GIR_EraseRootFromParent_Done,
     /* 114367 */ // Label 2488: @114367
     /* 114367 */ GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(114426), // Rule ID 17591 //
     /* 114372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114383 */   // (zext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src), sub_32bit:{ *:[i32] })
     /* 114383 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114386 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 114390 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114395 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114399 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 114415 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114420 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 114425 */   // GIR_Coverage, 17591,
     /* 114425 */   GIR_EraseRootFromParent_Done,
     /* 114426 */ // Label 2489: @114426
     /* 114426 */ GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(114485), // Rule ID 17593 //
     /* 114431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114442 */   // (zext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rr:{ *:[i32] } GR32:{ *:[i32] }:$src), sub_32bit:{ *:[i32] })
     /* 114442 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114445 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32rr),
     /* 114449 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114454 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114468 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 114474 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114479 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 114484 */   // GIR_Coverage, 17593,
     /* 114484 */   GIR_EraseRootFromParent_Done,
     /* 114485 */ // Label 2490: @114485
     /* 114485 */ GIM_Reject,
     /* 114486 */ // Label 2470: @114486
     /* 114486 */ GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(114653),
     /* 114491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114494 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(114550), // Rule ID 18412 //
     /* 114499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 114502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 114506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 114514 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114517 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 114521 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 114525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 114534 */     // (zext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXDQYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 114534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQYrm),
     /* 114537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 114543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114548 */     GIR_RootConstrainSelectedInstOperands,
     /* 114549 */     // GIR_Coverage, 18412,
     /* 114549 */     GIR_EraseRootFromParent_Done,
     /* 114550 */   // Label 2492: @114550
     /* 114550 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(114606), // Rule ID 21617 //
     /* 114555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 114558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 114562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 114570 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114573 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 114577 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 114581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 114590 */     // (zext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXDQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 114590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZ256rm),
     /* 114593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114595 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 114599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114604 */     GIR_RootConstrainSelectedInstOperands,
     /* 114605 */     // GIR_Coverage, 21617,
     /* 114605 */     GIR_EraseRootFromParent_Done,
     /* 114606 */   // Label 2493: @114606
     /* 114606 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(114629), // Rule ID 12462 //
     /* 114611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 114614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 114618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 114622 */     // (zext:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)  =>  (VPMOVZXDQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)
     /* 114622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZ256rr),
     /* 114627 */     GIR_RootConstrainSelectedInstOperands,
     /* 114628 */     // GIR_Coverage, 12462,
     /* 114628 */     GIR_Done,
     /* 114629 */   // Label 2494: @114629
     /* 114629 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(114652), // Rule ID 18400 //
     /* 114634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 114637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 114641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 114645 */     // (zext:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)  =>  (VPMOVZXDQYrr:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)
     /* 114645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQYrr),
     /* 114650 */     GIR_RootConstrainSelectedInstOperands,
     /* 114651 */     // GIR_Coverage, 18400,
     /* 114651 */     GIR_Done,
     /* 114652 */   // Label 2495: @114652
     /* 114652 */   GIM_Reject,
     /* 114653 */ // Label 2491: @114653
     /* 114653 */ GIM_Reject,
     /* 114654 */ // Label 2471: @114654
     /* 114654 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(114821),
     /* 114659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114662 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(114718), // Rule ID 18408 //
     /* 114667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 114670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 114674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 114682 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114685 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 114689 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 114693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 114702 */     // (zext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWDYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 114702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDYrm),
     /* 114705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114707 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 114711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114716 */     GIR_RootConstrainSelectedInstOperands,
     /* 114717 */     // GIR_Coverage, 18408,
     /* 114717 */     GIR_EraseRootFromParent_Done,
     /* 114718 */   // Label 2497: @114718
     /* 114718 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(114774), // Rule ID 21616 //
     /* 114723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 114726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 114730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 114738 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114741 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 114745 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 114749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114751 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 114758 */     // (zext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 114758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZ256rm),
     /* 114761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114763 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 114767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114772 */     GIR_RootConstrainSelectedInstOperands,
     /* 114773 */     // GIR_Coverage, 21616,
     /* 114773 */     GIR_EraseRootFromParent_Done,
     /* 114774 */   // Label 2498: @114774
     /* 114774 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(114797), // Rule ID 12426 //
     /* 114779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 114782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 114786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 114790 */     // (zext:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVZXWDZ256rr:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)
     /* 114790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZ256rr),
     /* 114795 */     GIR_RootConstrainSelectedInstOperands,
     /* 114796 */     // GIR_Coverage, 12426,
     /* 114796 */     GIR_Done,
     /* 114797 */   // Label 2499: @114797
     /* 114797 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(114820), // Rule ID 18398 //
     /* 114802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 114805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 114809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 114813 */     // (zext:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)  =>  (VPMOVZXWDYrr:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)
     /* 114813 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDYrr),
     /* 114818 */     GIR_RootConstrainSelectedInstOperands,
     /* 114819 */     // GIR_Coverage, 18398,
     /* 114819 */     GIR_Done,
     /* 114820 */   // Label 2500: @114820
     /* 114820 */   GIM_Reject,
     /* 114821 */ // Label 2496: @114821
     /* 114821 */ GIM_Reject,
     /* 114822 */ // Label 2472: @114822
     /* 114822 */ GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(114881), // Rule ID 21621 //
     /* 114827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 114830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 114837 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114841 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 114845 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114848 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 114852 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 114856 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114858 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 114865 */   // (zext:{ *:[v8i64] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 114865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWQZrm),
     /* 114868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114870 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 114874 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114879 */   GIR_RootConstrainSelectedInstOperands,
     /* 114880 */   // GIR_Coverage, 21621,
     /* 114880 */   GIR_EraseRootFromParent_Done,
     /* 114881 */ // Label 2501: @114881
     /* 114881 */ GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(114940), // Rule ID 21622 //
     /* 114886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 114889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 114892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 114896 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114900 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 114904 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114907 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 114911 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 114915 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114917 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 114924 */   // (zext:{ *:[v8i64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXDQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 114924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZrm),
     /* 114927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114929 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 114933 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114938 */   GIR_RootConstrainSelectedInstOperands,
     /* 114939 */   // GIR_Coverage, 21622,
     /* 114939 */   GIR_EraseRootFromParent_Done,
     /* 114940 */ // Label 2502: @114940
     /* 114940 */ GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(114966), // Rule ID 12450 //
     /* 114945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 114948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 114955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 114959 */   // (zext:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVZXWQZrr:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)
     /* 114959 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWQZrr),
     /* 114964 */   GIR_RootConstrainSelectedInstOperands,
     /* 114965 */   // GIR_Coverage, 12450,
     /* 114965 */   GIR_Done,
     /* 114966 */ // Label 2503: @114966
     /* 114966 */ GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(114992), // Rule ID 12468 //
     /* 114971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 114974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 114977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 114981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 114985 */   // (zext:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVZXDQZrr:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)
     /* 114985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZrr),
     /* 114990 */   GIR_RootConstrainSelectedInstOperands,
     /* 114991 */   // GIR_Coverage, 12468,
     /* 114991 */   GIR_Done,
     /* 114992 */ // Label 2504: @114992
     /* 114992 */ GIM_Reject,
     /* 114993 */ // Label 2473: @114993
     /* 114993 */ GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(115160),
     /* 114998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 115001 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(115057), // Rule ID 18402 //
     /* 115006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 115009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115021 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115024 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115028 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115034 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115041 */     // (zext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBWYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 115041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWYrm),
     /* 115044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115046 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115055 */     GIR_RootConstrainSelectedInstOperands,
     /* 115056 */     // GIR_Coverage, 18402,
     /* 115056 */     GIR_EraseRootFromParent_Done,
     /* 115057 */   // Label 2506: @115057
     /* 115057 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(115113), // Rule ID 21615 //
     /* 115062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 115065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115077 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115080 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115084 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115090 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115097 */     // (zext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 115097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZ256rm),
     /* 115100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115102 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115111 */     GIR_RootConstrainSelectedInstOperands,
     /* 115112 */     // GIR_Coverage, 21615,
     /* 115112 */     GIR_EraseRootFromParent_Done,
     /* 115113 */   // Label 2507: @115113
     /* 115113 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(115136), // Rule ID 12372 //
     /* 115118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 115121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115129 */     // (zext:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVZXBWZ256rr:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)
     /* 115129 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZ256rr),
     /* 115134 */     GIR_RootConstrainSelectedInstOperands,
     /* 115135 */     // GIR_Coverage, 12372,
     /* 115135 */     GIR_Done,
     /* 115136 */   // Label 2508: @115136
     /* 115136 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(115159), // Rule ID 18395 //
     /* 115141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 115144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 115152 */     // (zext:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)  =>  (VPMOVZXBWYrr:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)
     /* 115152 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWYrr),
     /* 115157 */     GIR_RootConstrainSelectedInstOperands,
     /* 115158 */     // GIR_Coverage, 18395,
     /* 115158 */     GIR_Done,
     /* 115159 */   // Label 2509: @115159
     /* 115159 */   GIM_Reject,
     /* 115160 */ // Label 2505: @115160
     /* 115160 */ GIM_Reject,
     /* 115161 */ // Label 2474: @115161
     /* 115161 */ GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(115220), // Rule ID 21619 //
     /* 115166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 115172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115176 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115180 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115184 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115187 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115191 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115195 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115197 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115204 */   // (zext:{ *:[v16i32] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 115204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBDZrm),
     /* 115207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115209 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115213 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115218 */   GIR_RootConstrainSelectedInstOperands,
     /* 115219 */   // GIR_Coverage, 21619,
     /* 115219 */   GIR_EraseRootFromParent_Done,
     /* 115220 */ // Label 2510: @115220
     /* 115220 */ GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(115279), // Rule ID 21620 //
     /* 115225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 115231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115235 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115239 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115243 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115246 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115250 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115254 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115256 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115263 */   // (zext:{ *:[v16i32] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 115263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrm),
     /* 115266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115268 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115272 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115277 */   GIR_RootConstrainSelectedInstOperands,
     /* 115278 */   // GIR_Coverage, 21620,
     /* 115278 */   GIR_EraseRootFromParent_Done,
     /* 115279 */ // Label 2511: @115279
     /* 115279 */ GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(115305), // Rule ID 12396 //
     /* 115284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 115290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115298 */   // (zext:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVZXBDZrr:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)
     /* 115298 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBDZrr),
     /* 115303 */   GIR_RootConstrainSelectedInstOperands,
     /* 115304 */   // GIR_Coverage, 12396,
     /* 115304 */   GIR_Done,
     /* 115305 */ // Label 2512: @115305
     /* 115305 */ GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(115331), // Rule ID 12432 //
     /* 115310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 115316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115324 */   // (zext:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVZXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)
     /* 115324 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrr),
     /* 115329 */   GIR_RootConstrainSelectedInstOperands,
     /* 115330 */   // GIR_Coverage, 12432,
     /* 115330 */   GIR_Done,
     /* 115331 */ // Label 2513: @115331
     /* 115331 */ GIM_Reject,
     /* 115332 */ // Label 2475: @115332
     /* 115332 */ GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(115416),
     /* 115337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 115340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115344 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(115396), // Rule ID 21618 //
     /* 115349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 115352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115360 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115363 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115367 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115373 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115380 */     // (zext:{ *:[v32i16] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /* 115380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZrm),
     /* 115383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115394 */     GIR_RootConstrainSelectedInstOperands,
     /* 115395 */     // GIR_Coverage, 21618,
     /* 115395 */     GIR_EraseRootFromParent_Done,
     /* 115396 */   // Label 2515: @115396
     /* 115396 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(115415), // Rule ID 12378 //
     /* 115401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 115404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115408 */     // (zext:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)  =>  (VPMOVZXBWZrr:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)
     /* 115408 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZrr),
     /* 115413 */     GIR_RootConstrainSelectedInstOperands,
     /* 115414 */     // GIR_Coverage, 12378,
     /* 115414 */     GIR_Done,
     /* 115415 */   // Label 2516: @115415
     /* 115415 */   GIM_Reject,
     /* 115416 */ // Label 2514: @115416
     /* 115416 */ GIM_Reject,
     /* 115417 */ // Label 2476: @115417
     /* 115417 */ GIM_Reject,
     /* 115418 */ // Label 26: @115418
     /* 115418 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2521*/ GIMT_Encode4(117701),
     /* 115429 */ /*GILLT_s8*//*Label 2517*/ GIMT_Encode4(115445),
     /* 115433 */ /*GILLT_s16*//*Label 2518*/ GIMT_Encode4(115820),
     /* 115437 */ /*GILLT_s32*//*Label 2519*/ GIMT_Encode4(116195),
     /* 115441 */ /*GILLT_s64*//*Label 2520*/ GIMT_Encode4(116948),
     /* 115445 */ // Label 2517: @115445
     /* 115445 */ GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(115819),
     /* 115450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 115453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 115456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 115460 */   GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(115527), // Rule ID 672 //
     /* 115465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 115468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115476 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115479 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115483 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 115487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 115491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115495 */     // MIs[2] Operand 1
     /* 115495 */     // No operand predicates
     /* 115495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115504 */     // (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (SHL8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 115504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mi_ND),
     /* 115507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115509 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 115513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 115516 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 115519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115525 */     GIR_RootConstrainSelectedInstOperands,
     /* 115526 */     // GIR_Coverage, 672,
     /* 115526 */     GIR_EraseRootFromParent_Done,
     /* 115527 */   // Label 2523: @115527
     /* 115527 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(115600), // Rule ID 688 //
     /* 115532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 115535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115543 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115546 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115550 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 115554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 115558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115560 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115567 */     // (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (SHL8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 115567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115571 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115577 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 115581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mCL_ND),
     /* 115584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115586 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 115590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 115593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115598 */     GIR_RootConstrainSelectedInstOperands,
     /* 115599 */     // GIR_Coverage, 688,
     /* 115599 */     GIR_EraseRootFromParent_Done,
     /* 115600 */   // Label 2524: @115600
     /* 115600 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(115630), // Rule ID 22671 //
     /* 115605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 115608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 115612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 115616 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 1:{ *:[i8] })  =>  (ADD8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src1)
     /* 115616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rr),
     /* 115619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115621 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 115623 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 115625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 115628 */     GIR_RootConstrainSelectedInstOperands,
     /* 115629 */     // GIR_Coverage, 22671,
     /* 115629 */     GIR_EraseRootFromParent_Done,
     /* 115630 */   // Label 2525: @115630
     /* 115630 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(115660), // Rule ID 22675 //
     /* 115635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 115638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 115642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 115646 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 1:{ *:[i8] })  =>  (ADD8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src1)
     /* 115646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rr_ND),
     /* 115649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115651 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 115653 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 115655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 115658 */     GIR_RootConstrainSelectedInstOperands,
     /* 115659 */     // GIR_Coverage, 22675,
     /* 115659 */     GIR_EraseRootFromParent_Done,
     /* 115660 */   // Label 2526: @115660
     /* 115660 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(115697), // Rule ID 660 //
     /* 115665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 115668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 115672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 115676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115680 */     // MIs[1] Operand 1
     /* 115680 */     // No operand predicates
     /* 115680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115682 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 115682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8ri),
     /* 115685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115687 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 115689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 115692 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 115695 */     GIR_RootConstrainSelectedInstOperands,
     /* 115696 */     // GIR_Coverage, 660,
     /* 115696 */     GIR_EraseRootFromParent_Done,
     /* 115697 */   // Label 2527: @115697
     /* 115697 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(115734), // Rule ID 664 //
     /* 115702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 115705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 115709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 115713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115717 */     // MIs[1] Operand 1
     /* 115717 */     // No operand predicates
     /* 115717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115719 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 115719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8ri_ND),
     /* 115722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115724 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 115726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 115729 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 115732 */     GIR_RootConstrainSelectedInstOperands,
     /* 115733 */     // GIR_Coverage, 664,
     /* 115733 */     GIR_EraseRootFromParent_Done,
     /* 115734 */   // Label 2528: @115734
     /* 115734 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(115776), // Rule ID 676 //
     /* 115739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 115742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 115746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 115750 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHL8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 115750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115754 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115760 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 115764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8rCL),
     /* 115767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115769 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 115771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 115774 */     GIR_RootConstrainSelectedInstOperands,
     /* 115775 */     // GIR_Coverage, 676,
     /* 115775 */     GIR_EraseRootFromParent_Done,
     /* 115776 */   // Label 2529: @115776
     /* 115776 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(115818), // Rule ID 680 //
     /* 115781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 115784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 115788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 115792 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHL8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 115792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115796 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115802 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 115806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8rCL_ND),
     /* 115809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115811 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 115813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 115816 */     GIR_RootConstrainSelectedInstOperands,
     /* 115817 */     // GIR_Coverage, 680,
     /* 115817 */     GIR_EraseRootFromParent_Done,
     /* 115818 */   // Label 2530: @115818
     /* 115818 */   GIM_Reject,
     /* 115819 */ // Label 2522: @115819
     /* 115819 */ GIM_Reject,
     /* 115820 */ // Label 2518: @115820
     /* 115820 */ GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(116194),
     /* 115825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 115831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 115835 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(115902), // Rule ID 673 //
     /* 115840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 115843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115851 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115854 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115858 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 115862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 115866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115870 */     // MIs[2] Operand 1
     /* 115870 */     // No operand predicates
     /* 115870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115879 */     // (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (SHL16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 115879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mi_ND),
     /* 115882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115884 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 115888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 115891 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 115894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115900 */     GIR_RootConstrainSelectedInstOperands,
     /* 115901 */     // GIR_Coverage, 673,
     /* 115901 */     GIR_EraseRootFromParent_Done,
     /* 115902 */   // Label 2532: @115902
     /* 115902 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(115975), // Rule ID 689 //
     /* 115907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 115910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115918 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115921 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115925 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 115929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 115933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115935 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115942 */     // (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (SHL16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 115942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115946 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115952 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 115956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mCL_ND),
     /* 115959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115961 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 115965 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 115968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115973 */     GIR_RootConstrainSelectedInstOperands,
     /* 115974 */     // GIR_Coverage, 689,
     /* 115974 */     GIR_EraseRootFromParent_Done,
     /* 115975 */   // Label 2533: @115975
     /* 115975 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(116005), // Rule ID 22672 //
     /* 115980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 115983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 115987 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 115991 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 1:{ *:[i8] })  =>  (ADD16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src1)
     /* 115991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rr),
     /* 115994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115996 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 115998 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116003 */     GIR_RootConstrainSelectedInstOperands,
     /* 116004 */     // GIR_Coverage, 22672,
     /* 116004 */     GIR_EraseRootFromParent_Done,
     /* 116005 */   // Label 2534: @116005
     /* 116005 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(116035), // Rule ID 22676 //
     /* 116010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 116013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116021 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 1:{ *:[i8] })  =>  (ADD16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src1)
     /* 116021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rr_ND),
     /* 116024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116026 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116028 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116033 */     GIR_RootConstrainSelectedInstOperands,
     /* 116034 */     // GIR_Coverage, 22676,
     /* 116034 */     GIR_EraseRootFromParent_Done,
     /* 116035 */   // Label 2535: @116035
     /* 116035 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(116072), // Rule ID 661 //
     /* 116040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116055 */     // MIs[1] Operand 1
     /* 116055 */     // No operand predicates
     /* 116055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116057 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16ri),
     /* 116060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116062 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116070 */     GIR_RootConstrainSelectedInstOperands,
     /* 116071 */     // GIR_Coverage, 661,
     /* 116071 */     GIR_EraseRootFromParent_Done,
     /* 116072 */   // Label 2536: @116072
     /* 116072 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(116109), // Rule ID 665 //
     /* 116077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116092 */     // MIs[1] Operand 1
     /* 116092 */     // No operand predicates
     /* 116092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116094 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16ri_ND),
     /* 116097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116099 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116107 */     GIR_RootConstrainSelectedInstOperands,
     /* 116108 */     // GIR_Coverage, 665,
     /* 116108 */     GIR_EraseRootFromParent_Done,
     /* 116109 */   // Label 2537: @116109
     /* 116109 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(116151), // Rule ID 677 //
     /* 116114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116125 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHL16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 116125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116129 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116135 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16rCL),
     /* 116142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116144 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116149 */     GIR_RootConstrainSelectedInstOperands,
     /* 116150 */     // GIR_Coverage, 677,
     /* 116150 */     GIR_EraseRootFromParent_Done,
     /* 116151 */   // Label 2538: @116151
     /* 116151 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(116193), // Rule ID 681 //
     /* 116156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116167 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHL16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 116167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116171 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116177 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16rCL_ND),
     /* 116184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116186 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116191 */     GIR_RootConstrainSelectedInstOperands,
     /* 116192 */     // GIR_Coverage, 681,
     /* 116192 */     GIR_EraseRootFromParent_Done,
     /* 116193 */   // Label 2539: @116193
     /* 116193 */   GIM_Reject,
     /* 116194 */ // Label 2531: @116194
     /* 116194 */ GIM_Reject,
     /* 116195 */ // Label 2519: @116195
     /* 116195 */ GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(116947),
     /* 116200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 116206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 116210 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(116277), // Rule ID 674 //
     /* 116215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116226 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116229 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116233 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 116237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 116241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116245 */     // MIs[2] Operand 1
     /* 116245 */     // No operand predicates
     /* 116245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116254 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (SHL32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mi_ND),
     /* 116257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116259 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 116266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116275 */     GIR_RootConstrainSelectedInstOperands,
     /* 116276 */     // GIR_Coverage, 674,
     /* 116276 */     GIR_EraseRootFromParent_Done,
     /* 116277 */   // Label 2541: @116277
     /* 116277 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(116350), // Rule ID 690 //
     /* 116282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116293 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116296 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116300 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 116304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116310 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116317 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SHL32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 116317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116321 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116327 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mCL_ND),
     /* 116334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116336 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116348 */     GIR_RootConstrainSelectedInstOperands,
     /* 116349 */     // GIR_Coverage, 690,
     /* 116349 */     GIR_EraseRootFromParent_Done,
     /* 116350 */   // Label 2542: @116350
     /* 116350 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(116460), // Rule ID 17671 //
     /* 116355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 116358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116366 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116369 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116373 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 116377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116383 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116390 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 116390 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116393 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116397 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116416 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116419 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 116423 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 116426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 116431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 116436 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 116441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rm),
     /* 116444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116446 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116458 */     GIR_RootConstrainSelectedInstOperands,
     /* 116459 */     // GIR_Coverage, 17671,
     /* 116459 */     GIR_EraseRootFromParent_Done,
     /* 116460 */   // Label 2543: @116460
     /* 116460 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(116570), // Rule ID 17703 //
     /* 116465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 116468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116476 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116479 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116483 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 116487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116500 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 116500 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116503 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116507 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116526 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 116533 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 116536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 116541 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 116546 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 116551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rm_EVEX),
     /* 116554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116556 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116568 */     GIR_RootConstrainSelectedInstOperands,
     /* 116569 */     // GIR_Coverage, 17703,
     /* 116569 */     GIR_EraseRootFromParent_Done,
     /* 116570 */   // Label 2544: @116570
     /* 116570 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(116600), // Rule ID 22673 //
     /* 116575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 116582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116586 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 1:{ *:[i8] })  =>  (ADD32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src1)
     /* 116586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rr),
     /* 116589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116591 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116593 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116598 */     GIR_RootConstrainSelectedInstOperands,
     /* 116599 */     // GIR_Coverage, 22673,
     /* 116599 */     GIR_EraseRootFromParent_Done,
     /* 116600 */   // Label 2545: @116600
     /* 116600 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(116630), // Rule ID 22677 //
     /* 116605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 116608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 116612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116616 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 1:{ *:[i8] })  =>  (ADD32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src1)
     /* 116616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rr_ND),
     /* 116619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116621 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116623 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116628 */     GIR_RootConstrainSelectedInstOperands,
     /* 116629 */     // GIR_Coverage, 22677,
     /* 116629 */     GIR_EraseRootFromParent_Done,
     /* 116630 */   // Label 2546: @116630
     /* 116630 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(116667), // Rule ID 662 //
     /* 116635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 116642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116650 */     // MIs[1] Operand 1
     /* 116650 */     // No operand predicates
     /* 116650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116652 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32ri),
     /* 116655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116657 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116665 */     GIR_RootConstrainSelectedInstOperands,
     /* 116666 */     // GIR_Coverage, 662,
     /* 116666 */     GIR_EraseRootFromParent_Done,
     /* 116667 */   // Label 2547: @116667
     /* 116667 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(116704), // Rule ID 666 //
     /* 116672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 116679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116687 */     // MIs[1] Operand 1
     /* 116687 */     // No operand predicates
     /* 116687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116689 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32ri_ND),
     /* 116692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116694 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116699 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116702 */     GIR_RootConstrainSelectedInstOperands,
     /* 116703 */     // GIR_Coverage, 666,
     /* 116703 */     GIR_EraseRootFromParent_Done,
     /* 116704 */   // Label 2548: @116704
     /* 116704 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(116783), // Rule ID 17667 //
     /* 116709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 116712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 116716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116720 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 116720 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116723 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116727 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116746 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116749 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 116753 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 116756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 116761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 116766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 116771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rr),
     /* 116774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116776 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116781 */     GIR_RootConstrainSelectedInstOperands,
     /* 116782 */     // GIR_Coverage, 17667,
     /* 116782 */     GIR_EraseRootFromParent_Done,
     /* 116783 */   // Label 2549: @116783
     /* 116783 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(116862), // Rule ID 17699 //
     /* 116788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 116791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 116795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116799 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 116799 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116802 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116806 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116825 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116828 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 116832 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 116835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 116840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 116845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 116850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rr_EVEX),
     /* 116853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116855 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116860 */     GIR_RootConstrainSelectedInstOperands,
     /* 116861 */     // GIR_Coverage, 17699,
     /* 116861 */     GIR_EraseRootFromParent_Done,
     /* 116862 */   // Label 2550: @116862
     /* 116862 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(116904), // Rule ID 678 //
     /* 116867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 116874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116878 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHL32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 116878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116882 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116888 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32rCL),
     /* 116895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116897 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116899 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116902 */     GIR_RootConstrainSelectedInstOperands,
     /* 116903 */     // GIR_Coverage, 678,
     /* 116903 */     GIR_EraseRootFromParent_Done,
     /* 116904 */   // Label 2551: @116904
     /* 116904 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(116946), // Rule ID 682 //
     /* 116909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 116916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116920 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHL32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 116920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116924 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116930 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32rCL_ND),
     /* 116937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116939 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116944 */     GIR_RootConstrainSelectedInstOperands,
     /* 116945 */     // GIR_Coverage, 682,
     /* 116945 */     GIR_EraseRootFromParent_Done,
     /* 116946 */   // Label 2552: @116946
     /* 116946 */   GIM_Reject,
     /* 116947 */ // Label 2540: @116947
     /* 116947 */ GIM_Reject,
     /* 116948 */ // Label 2520: @116948
     /* 116948 */ GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(117700),
     /* 116953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 116959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 116963 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(117030), // Rule ID 675 //
     /* 116968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116979 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116982 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 116986 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 116994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116998 */     // MIs[2] Operand 1
     /* 116998 */     // No operand predicates
     /* 116998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 117000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117007 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (SHL64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mi_ND),
     /* 117010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117012 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 117019 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 117028 */     GIR_RootConstrainSelectedInstOperands,
     /* 117029 */     // GIR_Coverage, 675,
     /* 117029 */     GIR_EraseRootFromParent_Done,
     /* 117030 */   // Label 2554: @117030
     /* 117030 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(117103), // Rule ID 691 //
     /* 117035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117046 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117049 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117053 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117063 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117070 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SHL64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 117070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117074 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117080 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mCL_ND),
     /* 117087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117089 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117101 */     GIR_RootConstrainSelectedInstOperands,
     /* 117102 */     // GIR_Coverage, 691,
     /* 117102 */     GIR_EraseRootFromParent_Done,
     /* 117103 */   // Label 2555: @117103
     /* 117103 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(117213), // Rule ID 17672 //
     /* 117108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 117111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117119 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117122 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117126 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117136 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117143 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117143 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 117146 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117150 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117169 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117172 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117176 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rm),
     /* 117197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117199 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117211 */     GIR_RootConstrainSelectedInstOperands,
     /* 117212 */     // GIR_Coverage, 17672,
     /* 117212 */     GIR_EraseRootFromParent_Done,
     /* 117213 */   // Label 2556: @117213
     /* 117213 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(117323), // Rule ID 17704 //
     /* 117218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 117221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117229 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117232 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117236 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117246 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117253 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117253 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 117256 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117260 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117279 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117286 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117299 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rm_EVEX),
     /* 117307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117309 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117321 */     GIR_RootConstrainSelectedInstOperands,
     /* 117322 */     // GIR_Coverage, 17704,
     /* 117322 */     GIR_EraseRootFromParent_Done,
     /* 117323 */   // Label 2557: @117323
     /* 117323 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(117353), // Rule ID 22674 //
     /* 117328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 117339 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 1:{ *:[i8] })  =>  (ADD64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src1)
     /* 117339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rr),
     /* 117342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117344 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117346 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117351 */     GIR_RootConstrainSelectedInstOperands,
     /* 117352 */     // GIR_Coverage, 22674,
     /* 117352 */     GIR_EraseRootFromParent_Done,
     /* 117353 */   // Label 2558: @117353
     /* 117353 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(117383), // Rule ID 22678 //
     /* 117358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 117361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 117369 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 1:{ *:[i8] })  =>  (ADD64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src1)
     /* 117369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rr_ND),
     /* 117372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117374 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117376 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117378 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117381 */     GIR_RootConstrainSelectedInstOperands,
     /* 117382 */     // GIR_Coverage, 22678,
     /* 117382 */     GIR_EraseRootFromParent_Done,
     /* 117383 */   // Label 2559: @117383
     /* 117383 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(117420), // Rule ID 663 //
     /* 117388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 117399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117403 */     // MIs[1] Operand 1
     /* 117403 */     // No operand predicates
     /* 117403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117405 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64ri),
     /* 117408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117410 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 117415 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117418 */     GIR_RootConstrainSelectedInstOperands,
     /* 117419 */     // GIR_Coverage, 663,
     /* 117419 */     GIR_EraseRootFromParent_Done,
     /* 117420 */   // Label 2560: @117420
     /* 117420 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(117457), // Rule ID 667 //
     /* 117425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 117436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117440 */     // MIs[1] Operand 1
     /* 117440 */     // No operand predicates
     /* 117440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117442 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64ri_ND),
     /* 117445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117447 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 117452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117455 */     GIR_RootConstrainSelectedInstOperands,
     /* 117456 */     // GIR_Coverage, 667,
     /* 117456 */     GIR_EraseRootFromParent_Done,
     /* 117457 */   // Label 2561: @117457
     /* 117457 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(117536), // Rule ID 17668 //
     /* 117462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 117465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117473 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117473 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 117476 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117480 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117499 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117502 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117506 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117509 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rr),
     /* 117527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117529 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117534 */     GIR_RootConstrainSelectedInstOperands,
     /* 117535 */     // GIR_Coverage, 17668,
     /* 117535 */     GIR_EraseRootFromParent_Done,
     /* 117536 */   // Label 2562: @117536
     /* 117536 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(117615), // Rule ID 17700 //
     /* 117541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 117544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117552 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117552 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 117555 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117559 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117578 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117581 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117585 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117593 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rr_EVEX),
     /* 117606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117608 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117613 */     GIR_RootConstrainSelectedInstOperands,
     /* 117614 */     // GIR_Coverage, 17700,
     /* 117614 */     GIR_EraseRootFromParent_Done,
     /* 117615 */   // Label 2563: @117615
     /* 117615 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(117657), // Rule ID 679 //
     /* 117620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117631 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHL64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 117631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117635 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117641 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64rCL),
     /* 117648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117650 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117655 */     GIR_RootConstrainSelectedInstOperands,
     /* 117656 */     // GIR_Coverage, 679,
     /* 117656 */     GIR_EraseRootFromParent_Done,
     /* 117657 */   // Label 2564: @117657
     /* 117657 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(117699), // Rule ID 683 //
     /* 117662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117673 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHL64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 117673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117677 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117683 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64rCL_ND),
     /* 117690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117692 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117694 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117697 */     GIR_RootConstrainSelectedInstOperands,
     /* 117698 */     // GIR_Coverage, 683,
     /* 117698 */     GIR_EraseRootFromParent_Done,
     /* 117699 */   // Label 2565: @117699
     /* 117699 */   GIM_Reject,
     /* 117700 */ // Label 2553: @117700
     /* 117700 */ GIM_Reject,
     /* 117701 */ // Label 2521: @117701
     /* 117701 */ GIM_Reject,
     /* 117702 */ // Label 27: @117702
     /* 117702 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2570*/ GIMT_Encode4(119745),
     /* 117713 */ /*GILLT_s8*//*Label 2566*/ GIMT_Encode4(117729),
     /* 117717 */ /*GILLT_s16*//*Label 2567*/ GIMT_Encode4(118044),
     /* 117721 */ /*GILLT_s32*//*Label 2568*/ GIMT_Encode4(118359),
     /* 117725 */ /*GILLT_s64*//*Label 2569*/ GIMT_Encode4(119052),
     /* 117729 */ // Label 2566: @117729
     /* 117729 */ GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(118043),
     /* 117734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 117737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 117740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117744 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(117811), // Rule ID 704 //
     /* 117749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117760 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117763 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117767 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 117771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 117775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117779 */     // MIs[2] Operand 1
     /* 117779 */     // No operand predicates
     /* 117779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 117781 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117788 */     // (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (SHR8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mi_ND),
     /* 117791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117793 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 117800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 117809 */     GIR_RootConstrainSelectedInstOperands,
     /* 117810 */     // GIR_Coverage, 704,
     /* 117810 */     GIR_EraseRootFromParent_Done,
     /* 117811 */   // Label 2572: @117811
     /* 117811 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(117884), // Rule ID 720 //
     /* 117816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117827 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117830 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117834 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 117838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117851 */     // (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (SHR8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 117851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117855 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117861 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mCL_ND),
     /* 117868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117870 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117882 */     GIR_RootConstrainSelectedInstOperands,
     /* 117883 */     // GIR_Coverage, 720,
     /* 117883 */     GIR_EraseRootFromParent_Done,
     /* 117884 */   // Label 2573: @117884
     /* 117884 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(117921), // Rule ID 692 //
     /* 117889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 117900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117904 */     // MIs[1] Operand 1
     /* 117904 */     // No operand predicates
     /* 117904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117906 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8ri),
     /* 117909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117911 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 117916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117919 */     GIR_RootConstrainSelectedInstOperands,
     /* 117920 */     // GIR_Coverage, 692,
     /* 117920 */     GIR_EraseRootFromParent_Done,
     /* 117921 */   // Label 2574: @117921
     /* 117921 */   GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(117958), // Rule ID 696 //
     /* 117926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 117937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117941 */     // MIs[1] Operand 1
     /* 117941 */     // No operand predicates
     /* 117941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117943 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8ri_ND),
     /* 117946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117948 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 117953 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117956 */     GIR_RootConstrainSelectedInstOperands,
     /* 117957 */     // GIR_Coverage, 696,
     /* 117957 */     GIR_EraseRootFromParent_Done,
     /* 117958 */   // Label 2575: @117958
     /* 117958 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(118000), // Rule ID 708 //
     /* 117963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117974 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 117974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117978 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117984 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8rCL),
     /* 117991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117993 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117998 */     GIR_RootConstrainSelectedInstOperands,
     /* 117999 */     // GIR_Coverage, 708,
     /* 117999 */     GIR_EraseRootFromParent_Done,
     /* 118000 */   // Label 2576: @118000
     /* 118000 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(118042), // Rule ID 712 //
     /* 118005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118016 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 118016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118020 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8rCL_ND),
     /* 118033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118035 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118040 */     GIR_RootConstrainSelectedInstOperands,
     /* 118041 */     // GIR_Coverage, 712,
     /* 118041 */     GIR_EraseRootFromParent_Done,
     /* 118042 */   // Label 2577: @118042
     /* 118042 */   GIM_Reject,
     /* 118043 */ // Label 2571: @118043
     /* 118043 */ GIM_Reject,
     /* 118044 */ // Label 2567: @118044
     /* 118044 */ GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(118358),
     /* 118049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 118052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 118055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118059 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(118126), // Rule ID 705 //
     /* 118064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118075 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118078 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118082 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 118086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 118090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118094 */     // MIs[2] Operand 1
     /* 118094 */     // No operand predicates
     /* 118094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 118096 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118103 */     // (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (SHR16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mi_ND),
     /* 118106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118108 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 118115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 118124 */     GIR_RootConstrainSelectedInstOperands,
     /* 118125 */     // GIR_Coverage, 705,
     /* 118125 */     GIR_EraseRootFromParent_Done,
     /* 118126 */   // Label 2579: @118126
     /* 118126 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(118199), // Rule ID 721 //
     /* 118131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118142 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118145 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118149 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 118153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118166 */     // (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (SHR16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 118166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118170 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118176 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mCL_ND),
     /* 118183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118185 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118189 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118197 */     GIR_RootConstrainSelectedInstOperands,
     /* 118198 */     // GIR_Coverage, 721,
     /* 118198 */     GIR_EraseRootFromParent_Done,
     /* 118199 */   // Label 2580: @118199
     /* 118199 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(118236), // Rule ID 693 //
     /* 118204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118219 */     // MIs[1] Operand 1
     /* 118219 */     // No operand predicates
     /* 118219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118221 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16ri),
     /* 118224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118226 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118234 */     GIR_RootConstrainSelectedInstOperands,
     /* 118235 */     // GIR_Coverage, 693,
     /* 118235 */     GIR_EraseRootFromParent_Done,
     /* 118236 */   // Label 2581: @118236
     /* 118236 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(118273), // Rule ID 697 //
     /* 118241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118256 */     // MIs[1] Operand 1
     /* 118256 */     // No operand predicates
     /* 118256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118258 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16ri_ND),
     /* 118261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118263 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118268 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118271 */     GIR_RootConstrainSelectedInstOperands,
     /* 118272 */     // GIR_Coverage, 697,
     /* 118272 */     GIR_EraseRootFromParent_Done,
     /* 118273 */   // Label 2582: @118273
     /* 118273 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(118315), // Rule ID 709 //
     /* 118278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118289 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 118289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118293 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118299 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16rCL),
     /* 118306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118308 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118310 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118313 */     GIR_RootConstrainSelectedInstOperands,
     /* 118314 */     // GIR_Coverage, 709,
     /* 118314 */     GIR_EraseRootFromParent_Done,
     /* 118315 */   // Label 2583: @118315
     /* 118315 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(118357), // Rule ID 713 //
     /* 118320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118331 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 118331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118335 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118341 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16rCL_ND),
     /* 118348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118350 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118355 */     GIR_RootConstrainSelectedInstOperands,
     /* 118356 */     // GIR_Coverage, 713,
     /* 118356 */     GIR_EraseRootFromParent_Done,
     /* 118357 */   // Label 2584: @118357
     /* 118357 */   GIM_Reject,
     /* 118358 */ // Label 2578: @118358
     /* 118358 */ GIM_Reject,
     /* 118359 */ // Label 2568: @118359
     /* 118359 */ GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(119051),
     /* 118364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 118370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 118374 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(118441), // Rule ID 706 //
     /* 118379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118390 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118393 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118397 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 118401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 118405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118409 */     // MIs[2] Operand 1
     /* 118409 */     // No operand predicates
     /* 118409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 118411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118418 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (SHR32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mi_ND),
     /* 118421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118423 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 118430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 118439 */     GIR_RootConstrainSelectedInstOperands,
     /* 118440 */     // GIR_Coverage, 706,
     /* 118440 */     GIR_EraseRootFromParent_Done,
     /* 118441 */   // Label 2586: @118441
     /* 118441 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(118514), // Rule ID 722 //
     /* 118446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118457 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118460 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118464 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 118468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118474 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118481 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SHR32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 118481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118485 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118491 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mCL_ND),
     /* 118498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118500 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118512 */     GIR_RootConstrainSelectedInstOperands,
     /* 118513 */     // GIR_Coverage, 722,
     /* 118513 */     GIR_EraseRootFromParent_Done,
     /* 118514 */   // Label 2587: @118514
     /* 118514 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(118624), // Rule ID 17663 //
     /* 118519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 118522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118530 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118533 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118537 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 118541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118547 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118554 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 118554 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118557 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118561 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118580 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118583 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 118587 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 118590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 118595 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 118600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 118605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rm),
     /* 118608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118610 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118622 */     GIR_RootConstrainSelectedInstOperands,
     /* 118623 */     // GIR_Coverage, 17663,
     /* 118623 */     GIR_EraseRootFromParent_Done,
     /* 118624 */   // Label 2588: @118624
     /* 118624 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(118734), // Rule ID 17695 //
     /* 118629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 118632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118640 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118647 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 118651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118664 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 118664 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118667 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118671 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118690 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118693 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 118697 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 118700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 118705 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 118710 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 118715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rm_EVEX),
     /* 118718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118720 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118732 */     GIR_RootConstrainSelectedInstOperands,
     /* 118733 */     // GIR_Coverage, 17695,
     /* 118733 */     GIR_EraseRootFromParent_Done,
     /* 118734 */   // Label 2589: @118734
     /* 118734 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(118771), // Rule ID 694 //
     /* 118739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 118746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118754 */     // MIs[1] Operand 1
     /* 118754 */     // No operand predicates
     /* 118754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118756 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32ri),
     /* 118759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118761 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118769 */     GIR_RootConstrainSelectedInstOperands,
     /* 118770 */     // GIR_Coverage, 694,
     /* 118770 */     GIR_EraseRootFromParent_Done,
     /* 118771 */   // Label 2590: @118771
     /* 118771 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(118808), // Rule ID 698 //
     /* 118776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 118783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118791 */     // MIs[1] Operand 1
     /* 118791 */     // No operand predicates
     /* 118791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118793 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32ri_ND),
     /* 118796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118798 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118806 */     GIR_RootConstrainSelectedInstOperands,
     /* 118807 */     // GIR_Coverage, 698,
     /* 118807 */     GIR_EraseRootFromParent_Done,
     /* 118808 */   // Label 2591: @118808
     /* 118808 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(118887), // Rule ID 17659 //
     /* 118813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 118816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 118820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118824 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 118824 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118827 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118831 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118850 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118853 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 118857 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 118860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 118865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 118870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 118875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rr),
     /* 118878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118880 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118885 */     GIR_RootConstrainSelectedInstOperands,
     /* 118886 */     // GIR_Coverage, 17659,
     /* 118886 */     GIR_EraseRootFromParent_Done,
     /* 118887 */   // Label 2592: @118887
     /* 118887 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(118966), // Rule ID 17691 //
     /* 118892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 118895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 118899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118903 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 118903 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118906 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118910 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118929 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118932 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 118936 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 118939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 118944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 118949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 118954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rr_EVEX),
     /* 118957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118959 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118964 */     GIR_RootConstrainSelectedInstOperands,
     /* 118965 */     // GIR_Coverage, 17691,
     /* 118965 */     GIR_EraseRootFromParent_Done,
     /* 118966 */   // Label 2593: @118966
     /* 118966 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(119008), // Rule ID 710 //
     /* 118971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 118978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118982 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 118982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118986 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32rCL),
     /* 118999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119001 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119006 */     GIR_RootConstrainSelectedInstOperands,
     /* 119007 */     // GIR_Coverage, 710,
     /* 119007 */     GIR_EraseRootFromParent_Done,
     /* 119008 */   // Label 2594: @119008
     /* 119008 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(119050), // Rule ID 714 //
     /* 119013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119024 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 119024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119028 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32rCL_ND),
     /* 119041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119043 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119048 */     GIR_RootConstrainSelectedInstOperands,
     /* 119049 */     // GIR_Coverage, 714,
     /* 119049 */     GIR_EraseRootFromParent_Done,
     /* 119050 */   // Label 2595: @119050
     /* 119050 */   GIM_Reject,
     /* 119051 */ // Label 2585: @119051
     /* 119051 */ GIM_Reject,
     /* 119052 */ // Label 2569: @119052
     /* 119052 */ GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(119744),
     /* 119057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 119063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 119067 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(119134), // Rule ID 707 //
     /* 119072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119083 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119086 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119090 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 119098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119102 */     // MIs[2] Operand 1
     /* 119102 */     // No operand predicates
     /* 119102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119111 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (SHR64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mi_ND),
     /* 119114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119116 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 119123 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 119132 */     GIR_RootConstrainSelectedInstOperands,
     /* 119133 */     // GIR_Coverage, 707,
     /* 119133 */     GIR_EraseRootFromParent_Done,
     /* 119134 */   // Label 2597: @119134
     /* 119134 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(119207), // Rule ID 723 //
     /* 119139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119150 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119153 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119157 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119174 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SHR64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 119174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119178 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119184 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mCL_ND),
     /* 119191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119193 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119197 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119205 */     GIR_RootConstrainSelectedInstOperands,
     /* 119206 */     // GIR_Coverage, 723,
     /* 119206 */     GIR_EraseRootFromParent_Done,
     /* 119207 */   // Label 2598: @119207
     /* 119207 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(119317), // Rule ID 17664 //
     /* 119212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 119215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119223 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119226 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119230 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119247 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119247 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 119250 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119254 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119273 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119276 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119280 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 119288 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 119293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rm),
     /* 119301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119303 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119315 */     GIR_RootConstrainSelectedInstOperands,
     /* 119316 */     // GIR_Coverage, 17664,
     /* 119316 */     GIR_EraseRootFromParent_Done,
     /* 119317 */   // Label 2599: @119317
     /* 119317 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(119427), // Rule ID 17696 //
     /* 119322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 119325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119333 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119336 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119340 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119350 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119357 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119357 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 119360 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119364 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119383 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119390 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 119398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 119403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rm_EVEX),
     /* 119411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119413 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119425 */     GIR_RootConstrainSelectedInstOperands,
     /* 119426 */     // GIR_Coverage, 17696,
     /* 119426 */     GIR_EraseRootFromParent_Done,
     /* 119427 */   // Label 2600: @119427
     /* 119427 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(119464), // Rule ID 695 //
     /* 119432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 119435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 119439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 119443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119447 */     // MIs[1] Operand 1
     /* 119447 */     // No operand predicates
     /* 119447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119449 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64ri),
     /* 119452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119454 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 119459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119462 */     GIR_RootConstrainSelectedInstOperands,
     /* 119463 */     // GIR_Coverage, 695,
     /* 119463 */     GIR_EraseRootFromParent_Done,
     /* 119464 */   // Label 2601: @119464
     /* 119464 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(119501), // Rule ID 699 //
     /* 119469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 119476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 119480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119484 */     // MIs[1] Operand 1
     /* 119484 */     // No operand predicates
     /* 119484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119486 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64ri_ND),
     /* 119489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119491 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 119496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119499 */     GIR_RootConstrainSelectedInstOperands,
     /* 119500 */     // GIR_Coverage, 699,
     /* 119500 */     GIR_EraseRootFromParent_Done,
     /* 119501 */   // Label 2602: @119501
     /* 119501 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(119580), // Rule ID 17660 //
     /* 119506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 119509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 119513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119517 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119517 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 119520 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119524 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119543 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119550 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119553 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 119558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 119563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rr),
     /* 119571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119573 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119578 */     GIR_RootConstrainSelectedInstOperands,
     /* 119579 */     // GIR_Coverage, 17660,
     /* 119579 */     GIR_EraseRootFromParent_Done,
     /* 119580 */   // Label 2603: @119580
     /* 119580 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(119659), // Rule ID 17692 //
     /* 119585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 119588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 119592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119596 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119596 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 119599 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119603 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119622 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119625 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119629 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 119637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 119642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rr_EVEX),
     /* 119650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119652 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119657 */     GIR_RootConstrainSelectedInstOperands,
     /* 119658 */     // GIR_Coverage, 17692,
     /* 119658 */     GIR_EraseRootFromParent_Done,
     /* 119659 */   // Label 2604: @119659
     /* 119659 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(119701), // Rule ID 711 //
     /* 119664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 119667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 119671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119675 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 119675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119679 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119685 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64rCL),
     /* 119692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119694 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119699 */     GIR_RootConstrainSelectedInstOperands,
     /* 119700 */     // GIR_Coverage, 711,
     /* 119700 */     GIR_EraseRootFromParent_Done,
     /* 119701 */   // Label 2605: @119701
     /* 119701 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(119743), // Rule ID 715 //
     /* 119706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 119713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119717 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 119717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119721 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64rCL_ND),
     /* 119734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119736 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119741 */     GIR_RootConstrainSelectedInstOperands,
     /* 119742 */     // GIR_Coverage, 715,
     /* 119742 */     GIR_EraseRootFromParent_Done,
     /* 119743 */   // Label 2606: @119743
     /* 119743 */   GIM_Reject,
     /* 119744 */ // Label 2596: @119744
     /* 119744 */ GIM_Reject,
     /* 119745 */ // Label 2570: @119745
     /* 119745 */ GIM_Reject,
     /* 119746 */ // Label 28: @119746
     /* 119746 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2611*/ GIMT_Encode4(121789),
     /* 119757 */ /*GILLT_s8*//*Label 2607*/ GIMT_Encode4(119773),
     /* 119761 */ /*GILLT_s16*//*Label 2608*/ GIMT_Encode4(120088),
     /* 119765 */ /*GILLT_s32*//*Label 2609*/ GIMT_Encode4(120403),
     /* 119769 */ /*GILLT_s64*//*Label 2610*/ GIMT_Encode4(121096),
     /* 119773 */ // Label 2607: @119773
     /* 119773 */ GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(120087),
     /* 119778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 119781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 119784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119788 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(119855), // Rule ID 736 //
     /* 119793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119804 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119807 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119811 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 119815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 119819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119823 */     // MIs[2] Operand 1
     /* 119823 */     // No operand predicates
     /* 119823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119832 */     // (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (SAR8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mi_ND),
     /* 119835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119837 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 119844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 119853 */     GIR_RootConstrainSelectedInstOperands,
     /* 119854 */     // GIR_Coverage, 736,
     /* 119854 */     GIR_EraseRootFromParent_Done,
     /* 119855 */   // Label 2613: @119855
     /* 119855 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(119928), // Rule ID 752 //
     /* 119860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119871 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119874 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119878 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 119882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119895 */     // (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (SAR8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 119895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119899 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119905 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mCL_ND),
     /* 119912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119914 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119918 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119926 */     GIR_RootConstrainSelectedInstOperands,
     /* 119927 */     // GIR_Coverage, 752,
     /* 119927 */     GIR_EraseRootFromParent_Done,
     /* 119928 */   // Label 2614: @119928
     /* 119928 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(119965), // Rule ID 724 //
     /* 119933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 119936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 119944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119948 */     // MIs[1] Operand 1
     /* 119948 */     // No operand predicates
     /* 119948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119950 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8ri),
     /* 119953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119955 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 119960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119963 */     GIR_RootConstrainSelectedInstOperands,
     /* 119964 */     // GIR_Coverage, 724,
     /* 119964 */     GIR_EraseRootFromParent_Done,
     /* 119965 */   // Label 2615: @119965
     /* 119965 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(120002), // Rule ID 728 //
     /* 119970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 119981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119985 */     // MIs[1] Operand 1
     /* 119985 */     // No operand predicates
     /* 119985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119987 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8ri_ND),
     /* 119990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119992 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 119997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120000 */     GIR_RootConstrainSelectedInstOperands,
     /* 120001 */     // GIR_Coverage, 728,
     /* 120001 */     GIR_EraseRootFromParent_Done,
     /* 120002 */   // Label 2616: @120002
     /* 120002 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(120044), // Rule ID 740 //
     /* 120007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120018 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SAR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 120018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120022 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120028 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8rCL),
     /* 120035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120037 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120039 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120042 */     GIR_RootConstrainSelectedInstOperands,
     /* 120043 */     // GIR_Coverage, 740,
     /* 120043 */     GIR_EraseRootFromParent_Done,
     /* 120044 */   // Label 2617: @120044
     /* 120044 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(120086), // Rule ID 744 //
     /* 120049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120060 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SAR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 120060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120064 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120070 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8rCL_ND),
     /* 120077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120079 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120081 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120084 */     GIR_RootConstrainSelectedInstOperands,
     /* 120085 */     // GIR_Coverage, 744,
     /* 120085 */     GIR_EraseRootFromParent_Done,
     /* 120086 */   // Label 2618: @120086
     /* 120086 */   GIM_Reject,
     /* 120087 */ // Label 2612: @120087
     /* 120087 */ GIM_Reject,
     /* 120088 */ // Label 2608: @120088
     /* 120088 */ GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(120402),
     /* 120093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 120099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120103 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(120170), // Rule ID 737 //
     /* 120108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120119 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120122 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120126 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 120130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120138 */     // MIs[2] Operand 1
     /* 120138 */     // No operand predicates
     /* 120138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120147 */     // (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (SAR16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mi_ND),
     /* 120150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120152 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 120159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 120168 */     GIR_RootConstrainSelectedInstOperands,
     /* 120169 */     // GIR_Coverage, 737,
     /* 120169 */     GIR_EraseRootFromParent_Done,
     /* 120170 */   // Label 2620: @120170
     /* 120170 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(120243), // Rule ID 753 //
     /* 120175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120186 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120189 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120193 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 120197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120210 */     // (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (SAR16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 120210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120214 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120220 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mCL_ND),
     /* 120227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120233 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120241 */     GIR_RootConstrainSelectedInstOperands,
     /* 120242 */     // GIR_Coverage, 753,
     /* 120242 */     GIR_EraseRootFromParent_Done,
     /* 120243 */   // Label 2621: @120243
     /* 120243 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(120280), // Rule ID 725 //
     /* 120248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120263 */     // MIs[1] Operand 1
     /* 120263 */     // No operand predicates
     /* 120263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120265 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16ri),
     /* 120268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120270 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120275 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120278 */     GIR_RootConstrainSelectedInstOperands,
     /* 120279 */     // GIR_Coverage, 725,
     /* 120279 */     GIR_EraseRootFromParent_Done,
     /* 120280 */   // Label 2622: @120280
     /* 120280 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(120317), // Rule ID 729 //
     /* 120285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120300 */     // MIs[1] Operand 1
     /* 120300 */     // No operand predicates
     /* 120300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120302 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16ri_ND),
     /* 120305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120307 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120312 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120315 */     GIR_RootConstrainSelectedInstOperands,
     /* 120316 */     // GIR_Coverage, 729,
     /* 120316 */     GIR_EraseRootFromParent_Done,
     /* 120317 */   // Label 2623: @120317
     /* 120317 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(120359), // Rule ID 741 //
     /* 120322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120333 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SAR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 120333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120337 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120343 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16rCL),
     /* 120350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120352 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120357 */     GIR_RootConstrainSelectedInstOperands,
     /* 120358 */     // GIR_Coverage, 741,
     /* 120358 */     GIR_EraseRootFromParent_Done,
     /* 120359 */   // Label 2624: @120359
     /* 120359 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(120401), // Rule ID 745 //
     /* 120364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120375 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SAR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 120375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120379 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120385 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16rCL_ND),
     /* 120392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120394 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120396 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120399 */     GIR_RootConstrainSelectedInstOperands,
     /* 120400 */     // GIR_Coverage, 745,
     /* 120400 */     GIR_EraseRootFromParent_Done,
     /* 120401 */   // Label 2625: @120401
     /* 120401 */   GIM_Reject,
     /* 120402 */ // Label 2619: @120402
     /* 120402 */ GIM_Reject,
     /* 120403 */ // Label 2609: @120403
     /* 120403 */ GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(121095),
     /* 120408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 120414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 120418 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(120485), // Rule ID 738 //
     /* 120423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120434 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120437 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120441 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 120445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120453 */     // MIs[2] Operand 1
     /* 120453 */     // No operand predicates
     /* 120453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120462 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (SAR32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mi_ND),
     /* 120465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120467 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 120474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 120483 */     GIR_RootConstrainSelectedInstOperands,
     /* 120484 */     // GIR_Coverage, 738,
     /* 120484 */     GIR_EraseRootFromParent_Done,
     /* 120485 */   // Label 2627: @120485
     /* 120485 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(120558), // Rule ID 754 //
     /* 120490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120501 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120504 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120508 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 120512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120525 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SAR32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 120525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120529 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120535 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mCL_ND),
     /* 120542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120544 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120556 */     GIR_RootConstrainSelectedInstOperands,
     /* 120557 */     // GIR_Coverage, 754,
     /* 120557 */     GIR_EraseRootFromParent_Done,
     /* 120558 */   // Label 2628: @120558
     /* 120558 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(120668), // Rule ID 17655 //
     /* 120563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 120566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120574 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120577 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120581 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 120585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120598 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SARX32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 120598 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120601 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120605 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120624 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 120627 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 120631 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 120634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 120639 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 120644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 120649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rm),
     /* 120652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120654 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120666 */     GIR_RootConstrainSelectedInstOperands,
     /* 120667 */     // GIR_Coverage, 17655,
     /* 120667 */     GIR_EraseRootFromParent_Done,
     /* 120668 */   // Label 2629: @120668
     /* 120668 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(120778), // Rule ID 17687 //
     /* 120673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 120676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120684 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120687 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120691 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 120695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120708 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SARX32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 120708 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120711 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120715 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120734 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 120737 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 120741 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 120744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 120749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 120754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 120759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rm_EVEX),
     /* 120762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120764 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120776 */     GIR_RootConstrainSelectedInstOperands,
     /* 120777 */     // GIR_Coverage, 17687,
     /* 120777 */     GIR_EraseRootFromParent_Done,
     /* 120778 */   // Label 2630: @120778
     /* 120778 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(120815), // Rule ID 726 //
     /* 120783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 120790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120798 */     // MIs[1] Operand 1
     /* 120798 */     // No operand predicates
     /* 120798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120800 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32ri),
     /* 120803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120805 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120813 */     GIR_RootConstrainSelectedInstOperands,
     /* 120814 */     // GIR_Coverage, 726,
     /* 120814 */     GIR_EraseRootFromParent_Done,
     /* 120815 */   // Label 2631: @120815
     /* 120815 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(120852), // Rule ID 730 //
     /* 120820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 120827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120835 */     // MIs[1] Operand 1
     /* 120835 */     // No operand predicates
     /* 120835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120837 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32ri_ND),
     /* 120840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120842 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120847 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120850 */     GIR_RootConstrainSelectedInstOperands,
     /* 120851 */     // GIR_Coverage, 730,
     /* 120851 */     GIR_EraseRootFromParent_Done,
     /* 120852 */   // Label 2632: @120852
     /* 120852 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(120931), // Rule ID 17651 //
     /* 120857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 120860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 120864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120868 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 120868 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120871 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120875 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120894 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 120897 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 120901 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 120904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 120909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 120914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 120919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rr),
     /* 120922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120924 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120929 */     GIR_RootConstrainSelectedInstOperands,
     /* 120930 */     // GIR_Coverage, 17651,
     /* 120930 */     GIR_EraseRootFromParent_Done,
     /* 120931 */   // Label 2633: @120931
     /* 120931 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(121010), // Rule ID 17683 //
     /* 120936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 120939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 120943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120947 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 120947 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120950 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120954 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120973 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 120976 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 120980 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 120983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 120988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 120993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 120998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rr_EVEX),
     /* 121001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121003 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121008 */     GIR_RootConstrainSelectedInstOperands,
     /* 121009 */     // GIR_Coverage, 17683,
     /* 121009 */     GIR_EraseRootFromParent_Done,
     /* 121010 */   // Label 2634: @121010
     /* 121010 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(121052), // Rule ID 742 //
     /* 121015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 121018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121026 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SAR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 121026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121030 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121036 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32rCL),
     /* 121043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121045 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121047 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121050 */     GIR_RootConstrainSelectedInstOperands,
     /* 121051 */     // GIR_Coverage, 742,
     /* 121051 */     GIR_EraseRootFromParent_Done,
     /* 121052 */   // Label 2635: @121052
     /* 121052 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(121094), // Rule ID 746 //
     /* 121057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121068 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SAR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 121068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121072 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121078 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32rCL_ND),
     /* 121085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121087 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121089 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121092 */     GIR_RootConstrainSelectedInstOperands,
     /* 121093 */     // GIR_Coverage, 746,
     /* 121093 */     GIR_EraseRootFromParent_Done,
     /* 121094 */   // Label 2636: @121094
     /* 121094 */   GIM_Reject,
     /* 121095 */ // Label 2626: @121095
     /* 121095 */ GIM_Reject,
     /* 121096 */ // Label 2610: @121096
     /* 121096 */ GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(121788),
     /* 121101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 121104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 121107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 121111 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(121178), // Rule ID 739 //
     /* 121116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121127 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121130 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 121134 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 121142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121146 */     // MIs[2] Operand 1
     /* 121146 */     // No operand predicates
     /* 121146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121148 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121155 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (SAR64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mi_ND),
     /* 121158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121160 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 121167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 121176 */     GIR_RootConstrainSelectedInstOperands,
     /* 121177 */     // GIR_Coverage, 739,
     /* 121177 */     GIR_EraseRootFromParent_Done,
     /* 121178 */   // Label 2638: @121178
     /* 121178 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(121251), // Rule ID 755 //
     /* 121183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121194 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121197 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 121201 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121218 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SAR64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 121218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121222 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mCL_ND),
     /* 121235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121237 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121241 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121249 */     GIR_RootConstrainSelectedInstOperands,
     /* 121250 */     // GIR_Coverage, 755,
     /* 121250 */     GIR_EraseRootFromParent_Done,
     /* 121251 */   // Label 2639: @121251
     /* 121251 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(121361), // Rule ID 17656 //
     /* 121256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 121259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121267 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121270 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 121274 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121284 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121291 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SARX64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121291 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121294 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121298 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 121308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121317 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121320 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121324 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 121332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 121337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rm),
     /* 121345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121347 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121359 */     GIR_RootConstrainSelectedInstOperands,
     /* 121360 */     // GIR_Coverage, 17656,
     /* 121360 */     GIR_EraseRootFromParent_Done,
     /* 121361 */   // Label 2640: @121361
     /* 121361 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(121471), // Rule ID 17688 //
     /* 121366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 121369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121377 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121380 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 121384 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121401 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SARX64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121401 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121404 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121408 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 121418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121427 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121434 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 121442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 121447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rm_EVEX),
     /* 121455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121457 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121469 */     GIR_RootConstrainSelectedInstOperands,
     /* 121470 */     // GIR_Coverage, 17688,
     /* 121470 */     GIR_EraseRootFromParent_Done,
     /* 121471 */   // Label 2641: @121471
     /* 121471 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(121508), // Rule ID 727 //
     /* 121476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 121479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 121483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 121487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121491 */     // MIs[1] Operand 1
     /* 121491 */     // No operand predicates
     /* 121491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121493 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64ri),
     /* 121496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121498 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 121503 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121506 */     GIR_RootConstrainSelectedInstOperands,
     /* 121507 */     // GIR_Coverage, 727,
     /* 121507 */     GIR_EraseRootFromParent_Done,
     /* 121508 */   // Label 2642: @121508
     /* 121508 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(121545), // Rule ID 731 //
     /* 121513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 121520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 121524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121528 */     // MIs[1] Operand 1
     /* 121528 */     // No operand predicates
     /* 121528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121530 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64ri_ND),
     /* 121533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121535 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 121540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121543 */     GIR_RootConstrainSelectedInstOperands,
     /* 121544 */     // GIR_Coverage, 731,
     /* 121544 */     GIR_EraseRootFromParent_Done,
     /* 121545 */   // Label 2643: @121545
     /* 121545 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(121624), // Rule ID 17652 //
     /* 121550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 121553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 121557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121561 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121561 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121564 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121568 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 121578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121587 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121594 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 121602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 121607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rr),
     /* 121615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121617 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121622 */     GIR_RootConstrainSelectedInstOperands,
     /* 121623 */     // GIR_Coverage, 17652,
     /* 121623 */     GIR_EraseRootFromParent_Done,
     /* 121624 */   // Label 2644: @121624
     /* 121624 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(121703), // Rule ID 17684 //
     /* 121629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 121632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 121636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121640 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121640 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121643 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121647 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 121657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121666 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121669 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121673 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121676 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 121681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 121686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rr_EVEX),
     /* 121694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121696 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121701 */     GIR_RootConstrainSelectedInstOperands,
     /* 121702 */     // GIR_Coverage, 17684,
     /* 121702 */     GIR_EraseRootFromParent_Done,
     /* 121703 */   // Label 2645: @121703
     /* 121703 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(121745), // Rule ID 743 //
     /* 121708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 121711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 121715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121719 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SAR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 121719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121723 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121729 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64rCL),
     /* 121736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121738 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121743 */     GIR_RootConstrainSelectedInstOperands,
     /* 121744 */     // GIR_Coverage, 743,
     /* 121744 */     GIR_EraseRootFromParent_Done,
     /* 121745 */   // Label 2646: @121745
     /* 121745 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(121787), // Rule ID 747 //
     /* 121750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 121757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121761 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SAR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 121761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121765 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121771 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64rCL_ND),
     /* 121778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121780 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121782 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121785 */     GIR_RootConstrainSelectedInstOperands,
     /* 121786 */     // GIR_Coverage, 747,
     /* 121786 */     GIR_EraseRootFromParent_Done,
     /* 121787 */   // Label 2647: @121787
     /* 121787 */   GIM_Reject,
     /* 121788 */ // Label 2637: @121788
     /* 121788 */ GIM_Reject,
     /* 121789 */ // Label 2611: @121789
     /* 121789 */ GIM_Reject,
     /* 121790 */ // Label 29: @121790
     /* 121790 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2650*/ GIMT_Encode4(122517),
     /* 121801 */ /*GILLT_s32*//*Label 2648*/ GIMT_Encode4(121809),
     /* 121805 */ /*GILLT_s64*//*Label 2649*/ GIMT_Encode4(122163),
     /* 121809 */ // Label 2648: @121809
     /* 121809 */ GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(122162),
     /* 121814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 121817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 121820 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 121823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121827 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(121900), // Rule ID 839 //
     /* 121832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121843 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121846 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121850 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 121854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 121862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121866 */     // MIs[2] Operand 1
     /* 121866 */     // No operand predicates
     /* 121866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121875 */     // (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32mri8_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 121875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mri8_ND),
     /* 121878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121880 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121884 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 121886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 121889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 121898 */     GIR_RootConstrainSelectedInstOperands,
     /* 121899 */     // GIR_Coverage, 839,
     /* 121899 */     GIR_EraseRootFromParent_Done,
     /* 121900 */   // Label 2652: @121900
     /* 121900 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(121979), // Rule ID 842 //
     /* 121905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121916 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121919 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121923 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 121927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121944 */     // (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32mrCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 121944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121948 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121954 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 121958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mrCL_ND),
     /* 121961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121963 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121967 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 121969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121977 */     GIR_RootConstrainSelectedInstOperands,
     /* 121978 */     // GIR_Coverage, 842,
     /* 121978 */     GIR_EraseRootFromParent_Done,
     /* 121979 */   // Label 2653: @121979
     /* 121979 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(122022), // Rule ID 821 //
     /* 121984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 121987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 121999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122003 */     // MIs[1] Operand 1
     /* 122003 */     // No operand predicates
     /* 122003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122005 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32rri8:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rri8),
     /* 122008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122010 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122012 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 122017 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122020 */     GIR_RootConstrainSelectedInstOperands,
     /* 122021 */     // GIR_Coverage, 821,
     /* 122021 */     GIR_EraseRootFromParent_Done,
     /* 122022 */   // Label 2654: @122022
     /* 122022 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(122065), // Rule ID 827 //
     /* 122027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 122042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122046 */     // MIs[1] Operand 1
     /* 122046 */     // No operand predicates
     /* 122046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122048 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32rri8_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rri8_ND),
     /* 122051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122053 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122055 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 122060 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122063 */     GIR_RootConstrainSelectedInstOperands,
     /* 122064 */     // GIR_Coverage, 827,
     /* 122064 */     GIR_EraseRootFromParent_Done,
     /* 122065 */   // Label 2655: @122065
     /* 122065 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(122113), // Rule ID 824 //
     /* 122070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122085 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32rrCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 122085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122089 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122095 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rrCL),
     /* 122102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122104 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122106 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122108 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122111 */     GIR_RootConstrainSelectedInstOperands,
     /* 122112 */     // GIR_Coverage, 824,
     /* 122112 */     GIR_EraseRootFromParent_Done,
     /* 122113 */   // Label 2656: @122113
     /* 122113 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(122161), // Rule ID 830 //
     /* 122118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122133 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32rrCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 122133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122137 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122143 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rrCL_ND),
     /* 122150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122152 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122154 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122159 */     GIR_RootConstrainSelectedInstOperands,
     /* 122160 */     // GIR_Coverage, 830,
     /* 122160 */     GIR_EraseRootFromParent_Done,
     /* 122161 */   // Label 2657: @122161
     /* 122161 */   GIM_Reject,
     /* 122162 */ // Label 2651: @122162
     /* 122162 */ GIM_Reject,
     /* 122163 */ // Label 2649: @122163
     /* 122163 */ GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(122516),
     /* 122168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 122171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 122174 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 122177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122181 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(122254), // Rule ID 840 //
     /* 122186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122197 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122200 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 122204 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 122216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122220 */     // MIs[2] Operand 1
     /* 122220 */     // No operand predicates
     /* 122220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122229 */     // (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64mri8_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mri8_ND),
     /* 122232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122234 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122238 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 122243 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 122252 */     GIR_RootConstrainSelectedInstOperands,
     /* 122253 */     // GIR_Coverage, 840,
     /* 122253 */     GIR_EraseRootFromParent_Done,
     /* 122254 */   // Label 2659: @122254
     /* 122254 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(122333), // Rule ID 843 //
     /* 122259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122270 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122273 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 122277 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122298 */     // (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64mrCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 122298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122302 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122308 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mrCL_ND),
     /* 122315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122317 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122321 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 122331 */     GIR_RootConstrainSelectedInstOperands,
     /* 122332 */     // GIR_Coverage, 843,
     /* 122332 */     GIR_EraseRootFromParent_Done,
     /* 122333 */   // Label 2660: @122333
     /* 122333 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(122376), // Rule ID 822 //
     /* 122338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 122353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122357 */     // MIs[1] Operand 1
     /* 122357 */     // No operand predicates
     /* 122357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122359 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64rri8:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rri8),
     /* 122362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122364 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122366 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 122371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122374 */     GIR_RootConstrainSelectedInstOperands,
     /* 122375 */     // GIR_Coverage, 822,
     /* 122375 */     GIR_EraseRootFromParent_Done,
     /* 122376 */   // Label 2661: @122376
     /* 122376 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(122419), // Rule ID 828 //
     /* 122381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 122396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122400 */     // MIs[1] Operand 1
     /* 122400 */     // No operand predicates
     /* 122400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122402 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64rri8_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rri8_ND),
     /* 122405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122407 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122409 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 122414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122417 */     GIR_RootConstrainSelectedInstOperands,
     /* 122418 */     // GIR_Coverage, 828,
     /* 122418 */     GIR_EraseRootFromParent_Done,
     /* 122419 */   // Label 2662: @122419
     /* 122419 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(122467), // Rule ID 825 //
     /* 122424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122439 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64rrCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 122439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122443 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122449 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rrCL),
     /* 122456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122458 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122460 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122462 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122465 */     GIR_RootConstrainSelectedInstOperands,
     /* 122466 */     // GIR_Coverage, 825,
     /* 122466 */     GIR_EraseRootFromParent_Done,
     /* 122467 */   // Label 2663: @122467
     /* 122467 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(122515), // Rule ID 831 //
     /* 122472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122487 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64rrCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 122487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122491 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122497 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rrCL_ND),
     /* 122504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122506 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122508 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122513 */     GIR_RootConstrainSelectedInstOperands,
     /* 122514 */     // GIR_Coverage, 831,
     /* 122514 */     GIR_EraseRootFromParent_Done,
     /* 122515 */   // Label 2664: @122515
     /* 122515 */   GIM_Reject,
     /* 122516 */ // Label 2658: @122516
     /* 122516 */ GIM_Reject,
     /* 122517 */ // Label 2650: @122517
     /* 122517 */ GIM_Reject,
     /* 122518 */ // Label 30: @122518
     /* 122518 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2667*/ GIMT_Encode4(123205),
     /* 122529 */ /*GILLT_s32*//*Label 2665*/ GIMT_Encode4(122537),
     /* 122533 */ /*GILLT_s64*//*Label 2666*/ GIMT_Encode4(122871),
     /* 122537 */ // Label 2665: @122537
     /* 122537 */ GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(122870),
     /* 122542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 122545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 122548 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 122551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122559 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(122628), // Rule ID 863 //
     /* 122564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 122571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122575 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122578 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122582 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 122586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 122590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122594 */     // MIs[2] Operand 1
     /* 122594 */     // No operand predicates
     /* 122594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122596 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122603 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src3)  =>  (SHRD32mri8_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mri8_ND),
     /* 122606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122608 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122612 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 122614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 122617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 122626 */     GIR_RootConstrainSelectedInstOperands,
     /* 122627 */     // GIR_Coverage, 863,
     /* 122627 */     GIR_EraseRootFromParent_Done,
     /* 122628 */   // Label 2669: @122628
     /* 122628 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(122703), // Rule ID 866 //
     /* 122633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 122640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122644 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122647 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122651 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 122655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122668 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SHRD32mrCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 122668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122672 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mrCL_ND),
     /* 122685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122687 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122691 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 122693 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 122701 */     GIR_RootConstrainSelectedInstOperands,
     /* 122702 */     // GIR_Coverage, 866,
     /* 122702 */     GIR_EraseRootFromParent_Done,
     /* 122703 */   // Label 2670: @122703
     /* 122703 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(122742), // Rule ID 845 //
     /* 122708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 122719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122723 */     // MIs[1] Operand 1
     /* 122723 */     // No operand predicates
     /* 122723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122725 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD32rri8:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rri8),
     /* 122728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122730 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 122732 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 122734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 122737 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122740 */     GIR_RootConstrainSelectedInstOperands,
     /* 122741 */     // GIR_Coverage, 845,
     /* 122741 */     GIR_EraseRootFromParent_Done,
     /* 122742 */   // Label 2671: @122742
     /* 122742 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(122781), // Rule ID 851 //
     /* 122747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 122758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122762 */     // MIs[1] Operand 1
     /* 122762 */     // No operand predicates
     /* 122762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122764 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD32rri8_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rri8_ND),
     /* 122767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122769 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 122771 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 122773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 122776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122779 */     GIR_RootConstrainSelectedInstOperands,
     /* 122780 */     // GIR_Coverage, 851,
     /* 122780 */     GIR_EraseRootFromParent_Done,
     /* 122781 */   // Label 2672: @122781
     /* 122781 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(122825), // Rule ID 848 //
     /* 122786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122797 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHRD32rrCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 122797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122801 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122807 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rrCL),
     /* 122814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122816 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 122818 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 122820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122823 */     GIR_RootConstrainSelectedInstOperands,
     /* 122824 */     // GIR_Coverage, 848,
     /* 122824 */     GIR_EraseRootFromParent_Done,
     /* 122825 */   // Label 2673: @122825
     /* 122825 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(122869), // Rule ID 854 //
     /* 122830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122841 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHRD32rrCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 122841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122845 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122851 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rrCL_ND),
     /* 122858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122860 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 122862 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 122864 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122867 */     GIR_RootConstrainSelectedInstOperands,
     /* 122868 */     // GIR_Coverage, 854,
     /* 122868 */     GIR_EraseRootFromParent_Done,
     /* 122869 */   // Label 2674: @122869
     /* 122869 */   GIM_Reject,
     /* 122870 */ // Label 2668: @122870
     /* 122870 */ GIM_Reject,
     /* 122871 */ // Label 2666: @122871
     /* 122871 */ GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(123204),
     /* 122876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 122879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 122882 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 122885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122893 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(122962), // Rule ID 864 //
     /* 122898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 122905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122909 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122912 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 122916 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 122924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122928 */     // MIs[2] Operand 1
     /* 122928 */     // No operand predicates
     /* 122928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122930 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122937 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src3)  =>  (SHRD64mri8_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mri8_ND),
     /* 122940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122942 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122946 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 122948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 122951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 122960 */     GIR_RootConstrainSelectedInstOperands,
     /* 122961 */     // GIR_Coverage, 864,
     /* 122961 */     GIR_EraseRootFromParent_Done,
     /* 122962 */   // Label 2676: @122962
     /* 122962 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(123037), // Rule ID 867 //
     /* 122967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 122974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122978 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122981 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 122985 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123002 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SHRD64mrCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123006 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123012 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mrCL_ND),
     /* 123019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123021 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123025 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123027 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 123035 */     GIR_RootConstrainSelectedInstOperands,
     /* 123036 */     // GIR_Coverage, 867,
     /* 123036 */     GIR_EraseRootFromParent_Done,
     /* 123037 */   // Label 2677: @123037
     /* 123037 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(123076), // Rule ID 846 //
     /* 123042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123057 */     // MIs[1] Operand 1
     /* 123057 */     // No operand predicates
     /* 123057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123059 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD64rri8:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rri8),
     /* 123062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123064 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123066 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123071 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123074 */     GIR_RootConstrainSelectedInstOperands,
     /* 123075 */     // GIR_Coverage, 846,
     /* 123075 */     GIR_EraseRootFromParent_Done,
     /* 123076 */   // Label 2678: @123076
     /* 123076 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(123115), // Rule ID 852 //
     /* 123081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123096 */     // MIs[1] Operand 1
     /* 123096 */     // No operand predicates
     /* 123096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123098 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD64rri8_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rri8_ND),
     /* 123101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123103 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123105 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123110 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123113 */     GIR_RootConstrainSelectedInstOperands,
     /* 123114 */     // GIR_Coverage, 852,
     /* 123114 */     GIR_EraseRootFromParent_Done,
     /* 123115 */   // Label 2679: @123115
     /* 123115 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(123159), // Rule ID 849 //
     /* 123120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123131 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHRD64rrCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123135 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123141 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rrCL),
     /* 123148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123150 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123152 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123157 */     GIR_RootConstrainSelectedInstOperands,
     /* 123158 */     // GIR_Coverage, 849,
     /* 123158 */     GIR_EraseRootFromParent_Done,
     /* 123159 */   // Label 2680: @123159
     /* 123159 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(123203), // Rule ID 855 //
     /* 123164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123175 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHRD64rrCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123179 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123185 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rrCL_ND),
     /* 123192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123194 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123196 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123201 */     GIR_RootConstrainSelectedInstOperands,
     /* 123202 */     // GIR_Coverage, 855,
     /* 123202 */     GIR_EraseRootFromParent_Done,
     /* 123203 */   // Label 2681: @123203
     /* 123203 */   GIM_Reject,
     /* 123204 */ // Label 2675: @123204
     /* 123204 */ GIM_Reject,
     /* 123205 */ // Label 2667: @123205
     /* 123205 */ GIM_Reject,
     /* 123206 */ // Label 31: @123206
     /* 123206 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(20), /*)*//*default:*//*Label 2692*/ GIMT_Encode4(126703),
     /* 123217 */ /*GILLT_s8*//*Label 2682*/ GIMT_Encode4(123293),
     /* 123221 */ /*GILLT_s16*//*Label 2683*/ GIMT_Encode4(123723),
     /* 123225 */ /*GILLT_s32*//*Label 2684*/ GIMT_Encode4(124153),
     /* 123229 */ /*GILLT_s64*//*Label 2685*/ GIMT_Encode4(124816), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123245 */ /*GILLT_v2s64*//*Label 2686*/ GIMT_Encode4(125479), GIMT_Encode4(0),
     /* 123253 */ /*GILLT_v4s32*//*Label 2687*/ GIMT_Encode4(125746),
     /* 123257 */ /*GILLT_v4s64*//*Label 2688*/ GIMT_Encode4(126013), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123269 */ /*GILLT_v8s32*//*Label 2689*/ GIMT_Encode4(126264),
     /* 123273 */ /*GILLT_v8s64*//*Label 2690*/ GIMT_Encode4(126515), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123289 */ /*GILLT_v16s32*//*Label 2691*/ GIMT_Encode4(126609),
     /* 123293 */ // Label 2682: @123293
     /* 123293 */ GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(123722),
     /* 123298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 123301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 123304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 123308 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(123367), // Rule ID 17623 //
     /* 123313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 123316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123324 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123327 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123331 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 123335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 123339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123348 */     // (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] })  =>  (ROL8m1_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 123348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8m1_ND),
     /* 123351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123353 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 123357 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 123365 */     GIR_RootConstrainSelectedInstOperands,
     /* 123366 */     // GIR_Coverage, 17623,
     /* 123366 */     GIR_EraseRootFromParent_Done,
     /* 123367 */   // Label 2694: @123367
     /* 123367 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(123434), // Rule ID 800 //
     /* 123372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123383 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123386 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123390 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 123394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 123398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123402 */     // MIs[2] Operand 1
     /* 123402 */     // No operand predicates
     /* 123402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123411 */     // (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (ROR8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 123411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mi_ND),
     /* 123414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123416 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 123423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 123432 */     GIR_RootConstrainSelectedInstOperands,
     /* 123433 */     // GIR_Coverage, 800,
     /* 123433 */     GIR_EraseRootFromParent_Done,
     /* 123434 */   // Label 2695: @123434
     /* 123434 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(123507), // Rule ID 816 //
     /* 123439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123450 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123453 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123457 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 123461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123474 */     // (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (ROR8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 123474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123478 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123484 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 123488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mCL_ND),
     /* 123491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123493 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 123505 */     GIR_RootConstrainSelectedInstOperands,
     /* 123506 */     // GIR_Coverage, 816,
     /* 123506 */     GIR_EraseRootFromParent_Done,
     /* 123507 */   // Label 2696: @123507
     /* 123507 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(123535), // Rule ID 17599 //
     /* 123512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 123519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 123523 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROL8r1:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 123523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8r1),
     /* 123526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123528 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123533 */     GIR_RootConstrainSelectedInstOperands,
     /* 123534 */     // GIR_Coverage, 17599,
     /* 123534 */     GIR_EraseRootFromParent_Done,
     /* 123535 */   // Label 2697: @123535
     /* 123535 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(123563), // Rule ID 17607 //
     /* 123540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 123543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 123547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 123551 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROL8r1_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 123551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8r1_ND),
     /* 123554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123556 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123561 */     GIR_RootConstrainSelectedInstOperands,
     /* 123562 */     // GIR_Coverage, 17607,
     /* 123562 */     GIR_EraseRootFromParent_Done,
     /* 123563 */   // Label 2698: @123563
     /* 123563 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(123600), // Rule ID 788 //
     /* 123568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 123575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123583 */     // MIs[1] Operand 1
     /* 123583 */     // No operand predicates
     /* 123583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123585 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 123585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8ri),
     /* 123588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123590 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 123595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123598 */     GIR_RootConstrainSelectedInstOperands,
     /* 123599 */     // GIR_Coverage, 788,
     /* 123599 */     GIR_EraseRootFromParent_Done,
     /* 123600 */   // Label 2699: @123600
     /* 123600 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(123637), // Rule ID 792 //
     /* 123605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 123612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123620 */     // MIs[1] Operand 1
     /* 123620 */     // No operand predicates
     /* 123620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123622 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 123622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8ri_ND),
     /* 123625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123627 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 123632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123635 */     GIR_RootConstrainSelectedInstOperands,
     /* 123636 */     // GIR_Coverage, 792,
     /* 123636 */     GIR_EraseRootFromParent_Done,
     /* 123637 */   // Label 2700: @123637
     /* 123637 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(123679), // Rule ID 804 //
     /* 123642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 123649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123653 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 123653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123657 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123663 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 123667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8rCL),
     /* 123670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123672 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123677 */     GIR_RootConstrainSelectedInstOperands,
     /* 123678 */     // GIR_Coverage, 804,
     /* 123678 */     GIR_EraseRootFromParent_Done,
     /* 123679 */   // Label 2701: @123679
     /* 123679 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(123721), // Rule ID 808 //
     /* 123684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 123691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123695 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 123695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123699 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123705 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 123709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8rCL_ND),
     /* 123712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123714 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123719 */     GIR_RootConstrainSelectedInstOperands,
     /* 123720 */     // GIR_Coverage, 808,
     /* 123720 */     GIR_EraseRootFromParent_Done,
     /* 123721 */   // Label 2702: @123721
     /* 123721 */   GIM_Reject,
     /* 123722 */ // Label 2693: @123722
     /* 123722 */ GIM_Reject,
     /* 123723 */ // Label 2683: @123723
     /* 123723 */ GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(124152),
     /* 123728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 123731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 123734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 123738 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(123797), // Rule ID 17624 //
     /* 123743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 123746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123754 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123757 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123761 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 123765 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 123769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123771 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123778 */     // (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] })  =>  (ROL16m1_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 123778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16m1_ND),
     /* 123781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123783 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 123787 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 123795 */     GIR_RootConstrainSelectedInstOperands,
     /* 123796 */     // GIR_Coverage, 17624,
     /* 123796 */     GIR_EraseRootFromParent_Done,
     /* 123797 */   // Label 2704: @123797
     /* 123797 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(123864), // Rule ID 801 //
     /* 123802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123813 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123816 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123820 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 123824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 123828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123832 */     // MIs[2] Operand 1
     /* 123832 */     // No operand predicates
     /* 123832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123841 */     // (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (ROR16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 123841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mi_ND),
     /* 123844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123846 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 123853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 123862 */     GIR_RootConstrainSelectedInstOperands,
     /* 123863 */     // GIR_Coverage, 801,
     /* 123863 */     GIR_EraseRootFromParent_Done,
     /* 123864 */   // Label 2705: @123864
     /* 123864 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(123937), // Rule ID 817 //
     /* 123869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123880 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123883 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123887 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 123891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123904 */     // (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (ROR16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 123904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123908 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123914 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 123918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mCL_ND),
     /* 123921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123923 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123927 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 123935 */     GIR_RootConstrainSelectedInstOperands,
     /* 123936 */     // GIR_Coverage, 817,
     /* 123936 */     GIR_EraseRootFromParent_Done,
     /* 123937 */   // Label 2706: @123937
     /* 123937 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(123965), // Rule ID 17600 //
     /* 123942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 123949 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 123953 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROL16r1:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 123953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16r1),
     /* 123956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123958 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123963 */     GIR_RootConstrainSelectedInstOperands,
     /* 123964 */     // GIR_Coverage, 17600,
     /* 123964 */     GIR_EraseRootFromParent_Done,
     /* 123965 */   // Label 2707: @123965
     /* 123965 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(123993), // Rule ID 17608 //
     /* 123970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 123973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 123977 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 123981 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROL16r1_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 123981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16r1_ND),
     /* 123984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123986 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123991 */     GIR_RootConstrainSelectedInstOperands,
     /* 123992 */     // GIR_Coverage, 17608,
     /* 123992 */     GIR_EraseRootFromParent_Done,
     /* 123993 */   // Label 2708: @123993
     /* 123993 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(124030), // Rule ID 789 //
     /* 123998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124013 */     // MIs[1] Operand 1
     /* 124013 */     // No operand predicates
     /* 124013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124015 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16ri),
     /* 124018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124020 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124028 */     GIR_RootConstrainSelectedInstOperands,
     /* 124029 */     // GIR_Coverage, 789,
     /* 124029 */     GIR_EraseRootFromParent_Done,
     /* 124030 */   // Label 2709: @124030
     /* 124030 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(124067), // Rule ID 793 //
     /* 124035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124050 */     // MIs[1] Operand 1
     /* 124050 */     // No operand predicates
     /* 124050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124052 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16ri_ND),
     /* 124055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124057 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124065 */     GIR_RootConstrainSelectedInstOperands,
     /* 124066 */     // GIR_Coverage, 793,
     /* 124066 */     GIR_EraseRootFromParent_Done,
     /* 124067 */   // Label 2710: @124067
     /* 124067 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(124109), // Rule ID 805 //
     /* 124072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124083 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124087 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124093 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16rCL),
     /* 124100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124102 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124107 */     GIR_RootConstrainSelectedInstOperands,
     /* 124108 */     // GIR_Coverage, 805,
     /* 124108 */     GIR_EraseRootFromParent_Done,
     /* 124109 */   // Label 2711: @124109
     /* 124109 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(124151), // Rule ID 809 //
     /* 124114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124125 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124129 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124135 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16rCL_ND),
     /* 124142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124144 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124149 */     GIR_RootConstrainSelectedInstOperands,
     /* 124150 */     // GIR_Coverage, 809,
     /* 124150 */     GIR_EraseRootFromParent_Done,
     /* 124151 */   // Label 2712: @124151
     /* 124151 */   GIM_Reject,
     /* 124152 */ // Label 2703: @124152
     /* 124152 */ GIM_Reject,
     /* 124153 */ // Label 2684: @124153
     /* 124153 */ GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(124815),
     /* 124158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 124161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 124164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 124168 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(124227), // Rule ID 17625 //
     /* 124173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124184 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124187 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124191 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124195 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 124199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124208 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] })  =>  (ROL32m1_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 124208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32m1_ND),
     /* 124211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124213 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124217 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124225 */     GIR_RootConstrainSelectedInstOperands,
     /* 124226 */     // GIR_Coverage, 17625,
     /* 124226 */     GIR_EraseRootFromParent_Done,
     /* 124227 */   // Label 2714: @124227
     /* 124227 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(124294), // Rule ID 802 //
     /* 124232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124243 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124246 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124250 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124262 */     // MIs[2] Operand 1
     /* 124262 */     // No operand predicates
     /* 124262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124271 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (ROR32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mi_ND),
     /* 124274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124276 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 124283 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 124292 */     GIR_RootConstrainSelectedInstOperands,
     /* 124293 */     // GIR_Coverage, 802,
     /* 124293 */     GIR_EraseRootFromParent_Done,
     /* 124294 */   // Label 2715: @124294
     /* 124294 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(124358), // Rule ID 17647 //
     /* 124299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 124302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124310 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124313 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124317 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124329 */     // MIs[2] Operand 1
     /* 124329 */     // No operand predicates
     /* 124329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124338 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 124338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32mi),
     /* 124341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124343 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 124350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 124356 */     GIR_RootConstrainSelectedInstOperands,
     /* 124357 */     // GIR_Coverage, 17647,
     /* 124357 */     GIR_EraseRootFromParent_Done,
     /* 124358 */   // Label 2716: @124358
     /* 124358 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(124422), // Rule ID 17679 //
     /* 124363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 124366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124374 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124377 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124381 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124393 */     // MIs[2] Operand 1
     /* 124393 */     // No operand predicates
     /* 124393 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124402 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX32mi_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 124402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32mi_EVEX),
     /* 124405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124407 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 124414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 124420 */     GIR_RootConstrainSelectedInstOperands,
     /* 124421 */     // GIR_Coverage, 17679,
     /* 124421 */     GIR_EraseRootFromParent_Done,
     /* 124422 */   // Label 2717: @124422
     /* 124422 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(124495), // Rule ID 818 //
     /* 124427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124438 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124441 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124445 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124462 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (ROR32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 124462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124466 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124472 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mCL_ND),
     /* 124479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124481 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124493 */     GIR_RootConstrainSelectedInstOperands,
     /* 124494 */     // GIR_Coverage, 818,
     /* 124494 */     GIR_EraseRootFromParent_Done,
     /* 124495 */   // Label 2718: @124495
     /* 124495 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(124529), // Rule ID 17643 //
     /* 124500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 124503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 124507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124515 */     // MIs[1] Operand 1
     /* 124515 */     // No operand predicates
     /* 124515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124517 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX32ri:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 124517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32ri),
     /* 124520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124522 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 124524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 124527 */     GIR_RootConstrainSelectedInstOperands,
     /* 124528 */     // GIR_Coverage, 17643,
     /* 124528 */     GIR_EraseRootFromParent_Done,
     /* 124529 */   // Label 2719: @124529
     /* 124529 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(124563), // Rule ID 17675 //
     /* 124534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 124537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 124541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124549 */     // MIs[1] Operand 1
     /* 124549 */     // No operand predicates
     /* 124549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124551 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX32ri_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 124551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32ri_EVEX),
     /* 124554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124556 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 124558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 124561 */     GIR_RootConstrainSelectedInstOperands,
     /* 124562 */     // GIR_Coverage, 17675,
     /* 124562 */     GIR_EraseRootFromParent_Done,
     /* 124563 */   // Label 2720: @124563
     /* 124563 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(124600), // Rule ID 870 //
     /* 124568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 124571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 124575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124583 */     // MIs[1] Operand 1
     /* 124583 */     // No operand predicates
     /* 124583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124585 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHRDROT32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 124585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRDROT32ri),
     /* 124588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124590 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 124595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124598 */     GIR_RootConstrainSelectedInstOperands,
     /* 124599 */     // GIR_Coverage, 870,
     /* 124599 */     GIR_EraseRootFromParent_Done,
     /* 124600 */   // Label 2721: @124600
     /* 124600 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(124628), // Rule ID 17601 //
     /* 124605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 124612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 124616 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROL32r1:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 124616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32r1),
     /* 124619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124621 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124626 */     GIR_RootConstrainSelectedInstOperands,
     /* 124627 */     // GIR_Coverage, 17601,
     /* 124627 */     GIR_EraseRootFromParent_Done,
     /* 124628 */   // Label 2722: @124628
     /* 124628 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(124656), // Rule ID 17609 //
     /* 124633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 124640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 124644 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROL32r1_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 124644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32r1_ND),
     /* 124647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124649 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124654 */     GIR_RootConstrainSelectedInstOperands,
     /* 124655 */     // GIR_Coverage, 17609,
     /* 124655 */     GIR_EraseRootFromParent_Done,
     /* 124656 */   // Label 2723: @124656
     /* 124656 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(124693), // Rule ID 790 //
     /* 124661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 124668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124676 */     // MIs[1] Operand 1
     /* 124676 */     // No operand predicates
     /* 124676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124678 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32ri),
     /* 124681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124683 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124688 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124691 */     GIR_RootConstrainSelectedInstOperands,
     /* 124692 */     // GIR_Coverage, 790,
     /* 124692 */     GIR_EraseRootFromParent_Done,
     /* 124693 */   // Label 2724: @124693
     /* 124693 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(124730), // Rule ID 794 //
     /* 124698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 124705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124713 */     // MIs[1] Operand 1
     /* 124713 */     // No operand predicates
     /* 124713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124715 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32ri_ND),
     /* 124718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124720 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124725 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124728 */     GIR_RootConstrainSelectedInstOperands,
     /* 124729 */     // GIR_Coverage, 794,
     /* 124729 */     GIR_EraseRootFromParent_Done,
     /* 124730 */   // Label 2725: @124730
     /* 124730 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(124772), // Rule ID 806 //
     /* 124735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 124742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124746 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 124746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124750 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124756 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32rCL),
     /* 124763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124765 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124767 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124770 */     GIR_RootConstrainSelectedInstOperands,
     /* 124771 */     // GIR_Coverage, 806,
     /* 124771 */     GIR_EraseRootFromParent_Done,
     /* 124772 */   // Label 2726: @124772
     /* 124772 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(124814), // Rule ID 810 //
     /* 124777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 124784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124788 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 124788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124792 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124798 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32rCL_ND),
     /* 124805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124807 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124812 */     GIR_RootConstrainSelectedInstOperands,
     /* 124813 */     // GIR_Coverage, 810,
     /* 124813 */     GIR_EraseRootFromParent_Done,
     /* 124814 */   // Label 2727: @124814
     /* 124814 */   GIM_Reject,
     /* 124815 */ // Label 2713: @124815
     /* 124815 */ GIM_Reject,
     /* 124816 */ // Label 2685: @124816
     /* 124816 */ GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(125478),
     /* 124821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 124824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 124827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 124831 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(124890), // Rule ID 17626 //
     /* 124836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124847 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124850 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 124854 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 124862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124871 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] })  =>  (ROL64m1_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 124871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64m1_ND),
     /* 124874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124888 */     GIR_RootConstrainSelectedInstOperands,
     /* 124889 */     // GIR_Coverage, 17626,
     /* 124889 */     GIR_EraseRootFromParent_Done,
     /* 124890 */   // Label 2729: @124890
     /* 124890 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(124957), // Rule ID 803 //
     /* 124895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124906 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124909 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 124913 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124925 */     // MIs[2] Operand 1
     /* 124925 */     // No operand predicates
     /* 124925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124934 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (ROR64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mi_ND),
     /* 124937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124939 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 124946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 124955 */     GIR_RootConstrainSelectedInstOperands,
     /* 124956 */     // GIR_Coverage, 803,
     /* 124956 */     GIR_EraseRootFromParent_Done,
     /* 124957 */   // Label 2730: @124957
     /* 124957 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(125021), // Rule ID 17648 //
     /* 124962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 124965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124973 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124976 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 124980 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124992 */     // MIs[2] Operand 1
     /* 124992 */     // No operand predicates
     /* 124992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124994 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125001 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX64mi:{ *:[i64] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64mi),
     /* 125004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125006 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 125013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125019 */     GIR_RootConstrainSelectedInstOperands,
     /* 125020 */     // GIR_Coverage, 17648,
     /* 125020 */     GIR_EraseRootFromParent_Done,
     /* 125021 */   // Label 2731: @125021
     /* 125021 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(125085), // Rule ID 17680 //
     /* 125026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 125029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125037 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125040 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125044 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125056 */     // MIs[2] Operand 1
     /* 125056 */     // No operand predicates
     /* 125056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125065 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX64mi_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64mi_EVEX),
     /* 125068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125070 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 125077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125083 */     GIR_RootConstrainSelectedInstOperands,
     /* 125084 */     // GIR_Coverage, 17680,
     /* 125084 */     GIR_EraseRootFromParent_Done,
     /* 125085 */   // Label 2732: @125085
     /* 125085 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(125158), // Rule ID 819 //
     /* 125090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125101 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125104 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125108 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125125 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (ROR64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 125125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125129 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125135 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mCL_ND),
     /* 125142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125144 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 125148 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 125156 */     GIR_RootConstrainSelectedInstOperands,
     /* 125157 */     // GIR_Coverage, 819,
     /* 125157 */     GIR_EraseRootFromParent_Done,
     /* 125158 */   // Label 2733: @125158
     /* 125158 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(125192), // Rule ID 17644 //
     /* 125163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 125166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125178 */     // MIs[1] Operand 1
     /* 125178 */     // No operand predicates
     /* 125178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125180 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX64ri:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64ri),
     /* 125183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125185 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125190 */     GIR_RootConstrainSelectedInstOperands,
     /* 125191 */     // GIR_Coverage, 17644,
     /* 125191 */     GIR_EraseRootFromParent_Done,
     /* 125192 */   // Label 2734: @125192
     /* 125192 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(125226), // Rule ID 17676 //
     /* 125197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 125200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125212 */     // MIs[1] Operand 1
     /* 125212 */     // No operand predicates
     /* 125212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125214 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX64ri_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64ri_EVEX),
     /* 125217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125219 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125224 */     GIR_RootConstrainSelectedInstOperands,
     /* 125225 */     // GIR_Coverage, 17676,
     /* 125225 */     GIR_EraseRootFromParent_Done,
     /* 125226 */   // Label 2735: @125226
     /* 125226 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(125263), // Rule ID 871 //
     /* 125231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 125234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125246 */     // MIs[1] Operand 1
     /* 125246 */     // No operand predicates
     /* 125246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125248 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHRDROT64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 125248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRDROT64ri),
     /* 125251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125253 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125258 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125261 */     GIR_RootConstrainSelectedInstOperands,
     /* 125262 */     // GIR_Coverage, 871,
     /* 125262 */     GIR_EraseRootFromParent_Done,
     /* 125263 */   // Label 2736: @125263
     /* 125263 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(125291), // Rule ID 17602 //
     /* 125268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125275 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 125279 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROL64r1:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 125279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64r1),
     /* 125282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125284 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125286 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125289 */     GIR_RootConstrainSelectedInstOperands,
     /* 125290 */     // GIR_Coverage, 17602,
     /* 125290 */     GIR_EraseRootFromParent_Done,
     /* 125291 */   // Label 2737: @125291
     /* 125291 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(125319), // Rule ID 17610 //
     /* 125296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 125299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125303 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 125307 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROL64r1_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 125307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64r1_ND),
     /* 125310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125312 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125317 */     GIR_RootConstrainSelectedInstOperands,
     /* 125318 */     // GIR_Coverage, 17610,
     /* 125318 */     GIR_EraseRootFromParent_Done,
     /* 125319 */   // Label 2738: @125319
     /* 125319 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(125356), // Rule ID 791 //
     /* 125324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125339 */     // MIs[1] Operand 1
     /* 125339 */     // No operand predicates
     /* 125339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125341 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64ri),
     /* 125344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125346 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 125351 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125354 */     GIR_RootConstrainSelectedInstOperands,
     /* 125355 */     // GIR_Coverage, 791,
     /* 125355 */     GIR_EraseRootFromParent_Done,
     /* 125356 */   // Label 2739: @125356
     /* 125356 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(125393), // Rule ID 795 //
     /* 125361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125376 */     // MIs[1] Operand 1
     /* 125376 */     // No operand predicates
     /* 125376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125378 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64ri_ND),
     /* 125381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125383 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 125388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125391 */     GIR_RootConstrainSelectedInstOperands,
     /* 125392 */     // GIR_Coverage, 795,
     /* 125392 */     GIR_EraseRootFromParent_Done,
     /* 125393 */   // Label 2740: @125393
     /* 125393 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(125435), // Rule ID 807 //
     /* 125398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125409 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 125409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125413 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125419 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64rCL),
     /* 125426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125428 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125433 */     GIR_RootConstrainSelectedInstOperands,
     /* 125434 */     // GIR_Coverage, 807,
     /* 125434 */     GIR_EraseRootFromParent_Done,
     /* 125435 */   // Label 2741: @125435
     /* 125435 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(125477), // Rule ID 811 //
     /* 125440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125451 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 125451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125455 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125461 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64rCL_ND),
     /* 125468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125470 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125472 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125475 */     GIR_RootConstrainSelectedInstOperands,
     /* 125476 */     // GIR_Coverage, 811,
     /* 125476 */     GIR_EraseRootFromParent_Done,
     /* 125477 */   // Label 2742: @125477
     /* 125477 */   GIM_Reject,
     /* 125478 */ // Label 2728: @125478
     /* 125478 */ GIM_Reject,
     /* 125479 */ // Label 2686: @125479
     /* 125479 */ GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(125745),
     /* 125484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 125487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 125490 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(125552), // Rule ID 8004 //
     /* 125495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 125498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 125502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 125506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125514 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125517 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125521 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125534 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 125534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ128rm),
     /* 125537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125539 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125541 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 125545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 125550 */     GIR_RootConstrainSelectedInstOperands,
     /* 125551 */     // GIR_Coverage, 8004,
     /* 125551 */     GIR_EraseRootFromParent_Done,
     /* 125552 */   // Label 2744: @125552
     /* 125552 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(125579), // Rule ID 8001 //
     /* 125557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 125560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 125564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 125568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 125572 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPRORVQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 125572 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ128rr),
     /* 125577 */     GIR_RootConstrainSelectedInstOperands,
     /* 125578 */     // GIR_Coverage, 8001,
     /* 125578 */     GIR_Done,
     /* 125579 */   // Label 2745: @125579
     /* 125579 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(125744), // Rule ID 20803 //
     /* 125584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 125587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 125591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 125595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 125599 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPRORVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 125599 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 125602 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125606 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 125613 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 125616 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 125620 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125625 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 125628 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 125632 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 125635 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 125640 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 125645 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 125650 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 125653 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125657 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125664 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 125667 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 125671 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125676 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 125679 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 125683 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 125686 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 125691 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 125696 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 125701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 125704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 125708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125713 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 125716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 125719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125726 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 125733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 125738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 125743 */     // GIR_Coverage, 20803,
     /* 125743 */     GIR_EraseRootFromParent_Done,
     /* 125744 */   // Label 2746: @125744
     /* 125744 */   GIM_Reject,
     /* 125745 */ // Label 2743: @125745
     /* 125745 */ GIM_Reject,
     /* 125746 */ // Label 2687: @125746
     /* 125746 */ GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(126012),
     /* 125751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 125757 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(125819), // Rule ID 7977 //
     /* 125762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 125765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 125769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 125773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125781 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125784 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125788 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125801 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 125801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ128rm),
     /* 125804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125806 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125808 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 125812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 125817 */     GIR_RootConstrainSelectedInstOperands,
     /* 125818 */     // GIR_Coverage, 7977,
     /* 125818 */     GIR_EraseRootFromParent_Done,
     /* 125819 */   // Label 2748: @125819
     /* 125819 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(125846), // Rule ID 7974 //
     /* 125824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 125827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 125831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 125835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 125839 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPRORVDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 125839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ128rr),
     /* 125844 */     GIR_RootConstrainSelectedInstOperands,
     /* 125845 */     // GIR_Coverage, 7974,
     /* 125845 */     GIR_Done,
     /* 125846 */   // Label 2749: @125846
     /* 125846 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(126011), // Rule ID 20805 //
     /* 125851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 125854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 125858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 125862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 125866 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPRORVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 125866 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 125869 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125873 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 125880 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 125883 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 125887 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125892 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 125895 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 125899 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 125902 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 125907 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 125912 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 125917 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 125920 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125924 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125931 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 125934 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 125938 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125943 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 125946 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 125950 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 125953 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 125958 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 125963 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 125968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 125971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 125975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125980 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 125983 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 125986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125993 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 126000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 126005 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126010 */     // GIR_Coverage, 20805,
     /* 126010 */     GIR_EraseRootFromParent_Done,
     /* 126011 */   // Label 2750: @126011
     /* 126011 */   GIM_Reject,
     /* 126012 */ // Label 2747: @126012
     /* 126012 */ GIM_Reject,
     /* 126013 */ // Label 2688: @126013
     /* 126013 */ GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(126263),
     /* 126018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 126021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 126024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126032 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(126086), // Rule ID 7995 //
     /* 126037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126048 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126051 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126055 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126061 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126068 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ256rm),
     /* 126071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126073 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126075 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126084 */     GIR_RootConstrainSelectedInstOperands,
     /* 126085 */     // GIR_Coverage, 7995,
     /* 126085 */     GIR_EraseRootFromParent_Done,
     /* 126086 */   // Label 2752: @126086
     /* 126086 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(126105), // Rule ID 7992 //
     /* 126091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126098 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPRORVQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 126098 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ256rr),
     /* 126103 */     GIR_RootConstrainSelectedInstOperands,
     /* 126104 */     // GIR_Coverage, 7992,
     /* 126104 */     GIR_Done,
     /* 126105 */   // Label 2753: @126105
     /* 126105 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(126262), // Rule ID 20804 //
     /* 126110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 126113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126117 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPRORVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 126117 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 126120 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126124 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 126131 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 126134 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126138 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126143 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 126146 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 126150 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 126153 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126158 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126163 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126168 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 126171 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126175 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126182 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 126185 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126189 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126194 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 126197 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 126201 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 126204 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126209 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126214 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 126222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 126226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126231 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 126234 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 126237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126244 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 126251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126261 */     // GIR_Coverage, 20804,
     /* 126261 */     GIR_EraseRootFromParent_Done,
     /* 126262 */   // Label 2754: @126262
     /* 126262 */   GIM_Reject,
     /* 126263 */ // Label 2751: @126263
     /* 126263 */ GIM_Reject,
     /* 126264 */ // Label 2689: @126264
     /* 126264 */ GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(126514),
     /* 126269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 126272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 126275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126283 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(126337), // Rule ID 7968 //
     /* 126288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126299 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126302 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126306 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126319 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ256rm),
     /* 126322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126324 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126326 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126335 */     GIR_RootConstrainSelectedInstOperands,
     /* 126336 */     // GIR_Coverage, 7968,
     /* 126336 */     GIR_EraseRootFromParent_Done,
     /* 126337 */   // Label 2756: @126337
     /* 126337 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(126356), // Rule ID 7965 //
     /* 126342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126349 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPRORVDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 126349 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ256rr),
     /* 126354 */     GIR_RootConstrainSelectedInstOperands,
     /* 126355 */     // GIR_Coverage, 7965,
     /* 126355 */     GIR_Done,
     /* 126356 */   // Label 2757: @126356
     /* 126356 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(126513), // Rule ID 20806 //
     /* 126361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 126364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126368 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPRORVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 126368 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 126371 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126375 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 126382 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 126385 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126389 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126394 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 126397 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 126401 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 126404 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126409 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126414 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126419 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 126422 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126426 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126433 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 126436 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126440 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126445 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 126448 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 126452 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 126455 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126460 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126465 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 126473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 126477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126482 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 126485 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 126488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126495 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 126502 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126507 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126512 */     // GIR_Coverage, 20806,
     /* 126512 */     GIR_EraseRootFromParent_Done,
     /* 126513 */   // Label 2758: @126513
     /* 126513 */   GIM_Reject,
     /* 126514 */ // Label 2755: @126514
     /* 126514 */ GIM_Reject,
     /* 126515 */ // Label 2690: @126515
     /* 126515 */ GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(126608),
     /* 126520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 126523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 126526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 126530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 126534 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(126588), // Rule ID 7986 //
     /* 126539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 126542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126550 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126553 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126557 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126570 */     // (rotr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrm),
     /* 126573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126575 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126577 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126586 */     GIR_RootConstrainSelectedInstOperands,
     /* 126587 */     // GIR_Coverage, 7986,
     /* 126587 */     GIR_EraseRootFromParent_Done,
     /* 126588 */   // Label 2760: @126588
     /* 126588 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(126607), // Rule ID 7983 //
     /* 126593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 126596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 126600 */     // (rotr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPRORVQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 126600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 126605 */     GIR_RootConstrainSelectedInstOperands,
     /* 126606 */     // GIR_Coverage, 7983,
     /* 126606 */     GIR_Done,
     /* 126607 */   // Label 2761: @126607
     /* 126607 */   GIM_Reject,
     /* 126608 */ // Label 2759: @126608
     /* 126608 */ GIM_Reject,
     /* 126609 */ // Label 2691: @126609
     /* 126609 */ GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(126702),
     /* 126614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 126617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 126620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 126624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 126628 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(126682), // Rule ID 7959 //
     /* 126633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 126636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126644 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126647 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126651 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126664 */     // (rotr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrm),
     /* 126667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126669 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126671 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126680 */     GIR_RootConstrainSelectedInstOperands,
     /* 126681 */     // GIR_Coverage, 7959,
     /* 126681 */     GIR_EraseRootFromParent_Done,
     /* 126682 */   // Label 2763: @126682
     /* 126682 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(126701), // Rule ID 7956 //
     /* 126687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 126690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 126694 */     // (rotr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPRORVDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 126694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 126699 */     GIR_RootConstrainSelectedInstOperands,
     /* 126700 */     // GIR_Coverage, 7956,
     /* 126700 */     GIR_Done,
     /* 126701 */   // Label 2764: @126701
     /* 126701 */   GIM_Reject,
     /* 126702 */ // Label 2762: @126702
     /* 126702 */ GIM_Reject,
     /* 126703 */ // Label 2692: @126703
     /* 126703 */ GIM_Reject,
     /* 126704 */ // Label 32: @126704
     /* 126704 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(20), /*)*//*default:*//*Label 2777*/ GIMT_Encode4(130423),
     /* 126715 */ /*GILLT_s8*//*Label 2765*/ GIMT_Encode4(126791),
     /* 126719 */ /*GILLT_s16*//*Label 2766*/ GIMT_Encode4(127221),
     /* 126723 */ /*GILLT_s32*//*Label 2767*/ GIMT_Encode4(127651),
     /* 126727 */ /*GILLT_s64*//*Label 2768*/ GIMT_Encode4(128118), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126743 */ /*GILLT_v2s64*//*Label 2769*/ GIMT_Encode4(128585), GIMT_Encode4(0),
     /* 126751 */ /*GILLT_v4s32*//*Label 2770*/ GIMT_Encode4(129003),
     /* 126755 */ /*GILLT_v4s64*//*Label 2771*/ GIMT_Encode4(129421), GIMT_Encode4(0),
     /* 126763 */ /*GILLT_v8s16*//*Label 2772*/ GIMT_Encode4(129672),
     /* 126767 */ /*GILLT_v8s32*//*Label 2773*/ GIMT_Encode4(129828),
     /* 126771 */ /*GILLT_v8s64*//*Label 2774*/ GIMT_Encode4(130079), GIMT_Encode4(0),
     /* 126779 */ /*GILLT_v16s8*//*Label 2775*/ GIMT_Encode4(130173), GIMT_Encode4(0),
     /* 126787 */ /*GILLT_v16s32*//*Label 2776*/ GIMT_Encode4(130329),
     /* 126791 */ // Label 2765: @126791
     /* 126791 */ GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(127220),
     /* 126796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 126799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 126802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 126806 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(126865), // Rule ID 17619 //
     /* 126811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 126814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126822 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126825 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126829 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 126833 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 126837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126839 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126846 */     // (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] })  =>  (ROR8m1_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 126846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8m1_ND),
     /* 126849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126851 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 126855 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 126858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126863 */     GIR_RootConstrainSelectedInstOperands,
     /* 126864 */     // GIR_Coverage, 17619,
     /* 126864 */     GIR_EraseRootFromParent_Done,
     /* 126865 */   // Label 2779: @126865
     /* 126865 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(126932), // Rule ID 768 //
     /* 126870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 126873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126881 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126884 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126888 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 126892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 126896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126900 */     // MIs[2] Operand 1
     /* 126900 */     // No operand predicates
     /* 126900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 126902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126909 */     // (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (ROL8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 126909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mi_ND),
     /* 126912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126914 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 126918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 126921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 126924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 126930 */     GIR_RootConstrainSelectedInstOperands,
     /* 126931 */     // GIR_Coverage, 768,
     /* 126931 */     GIR_EraseRootFromParent_Done,
     /* 126932 */   // Label 2780: @126932
     /* 126932 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(127005), // Rule ID 784 //
     /* 126937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 126940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126948 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126951 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126955 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 126959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 126963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126965 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126972 */     // (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (ROL8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 126972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126976 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126982 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 126986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mCL_ND),
     /* 126989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126991 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 126995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 126998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127003 */     GIR_RootConstrainSelectedInstOperands,
     /* 127004 */     // GIR_Coverage, 784,
     /* 127004 */     GIR_EraseRootFromParent_Done,
     /* 127005 */   // Label 2781: @127005
     /* 127005 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(127033), // Rule ID 17595 //
     /* 127010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 127021 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROR8r1:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8r1),
     /* 127024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127026 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127028 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127031 */     GIR_RootConstrainSelectedInstOperands,
     /* 127032 */     // GIR_Coverage, 17595,
     /* 127032 */     GIR_EraseRootFromParent_Done,
     /* 127033 */   // Label 2782: @127033
     /* 127033 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(127061), // Rule ID 17603 //
     /* 127038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127045 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 127049 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROR8r1_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8r1_ND),
     /* 127052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127054 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127059 */     GIR_RootConstrainSelectedInstOperands,
     /* 127060 */     // GIR_Coverage, 17603,
     /* 127060 */     GIR_EraseRootFromParent_Done,
     /* 127061 */   // Label 2783: @127061
     /* 127061 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(127098), // Rule ID 756 //
     /* 127066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127081 */     // MIs[1] Operand 1
     /* 127081 */     // No operand predicates
     /* 127081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127083 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8ri),
     /* 127086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127088 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 127093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127096 */     GIR_RootConstrainSelectedInstOperands,
     /* 127097 */     // GIR_Coverage, 756,
     /* 127097 */     GIR_EraseRootFromParent_Done,
     /* 127098 */   // Label 2784: @127098
     /* 127098 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(127135), // Rule ID 760 //
     /* 127103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127118 */     // MIs[1] Operand 1
     /* 127118 */     // No operand predicates
     /* 127118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127120 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8ri_ND),
     /* 127123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127125 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 127130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127133 */     GIR_RootConstrainSelectedInstOperands,
     /* 127134 */     // GIR_Coverage, 760,
     /* 127134 */     GIR_EraseRootFromParent_Done,
     /* 127135 */   // Label 2785: @127135
     /* 127135 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(127177), // Rule ID 772 //
     /* 127140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127151 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROL8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127155 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127161 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8rCL),
     /* 127168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127170 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127175 */     GIR_RootConstrainSelectedInstOperands,
     /* 127176 */     // GIR_Coverage, 772,
     /* 127176 */     GIR_EraseRootFromParent_Done,
     /* 127177 */   // Label 2786: @127177
     /* 127177 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(127219), // Rule ID 776 //
     /* 127182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127193 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROL8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127197 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127203 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8rCL_ND),
     /* 127210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127212 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127217 */     GIR_RootConstrainSelectedInstOperands,
     /* 127218 */     // GIR_Coverage, 776,
     /* 127218 */     GIR_EraseRootFromParent_Done,
     /* 127219 */   // Label 2787: @127219
     /* 127219 */   GIM_Reject,
     /* 127220 */ // Label 2778: @127220
     /* 127220 */ GIM_Reject,
     /* 127221 */ // Label 2766: @127221
     /* 127221 */ GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(127650),
     /* 127226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 127229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 127232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 127236 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(127295), // Rule ID 17620 //
     /* 127241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127252 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127255 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127259 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 127263 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 127267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127276 */     // (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] })  =>  (ROR16m1_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 127276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16m1_ND),
     /* 127279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127281 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 127285 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127293 */     GIR_RootConstrainSelectedInstOperands,
     /* 127294 */     // GIR_Coverage, 17620,
     /* 127294 */     GIR_EraseRootFromParent_Done,
     /* 127295 */   // Label 2789: @127295
     /* 127295 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(127362), // Rule ID 769 //
     /* 127300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127311 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127314 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127318 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 127322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 127326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127330 */     // MIs[2] Operand 1
     /* 127330 */     // No operand predicates
     /* 127330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 127332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127339 */     // (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (ROL16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mi_ND),
     /* 127342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127344 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 127348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 127351 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 127360 */     GIR_RootConstrainSelectedInstOperands,
     /* 127361 */     // GIR_Coverage, 769,
     /* 127361 */     GIR_EraseRootFromParent_Done,
     /* 127362 */   // Label 2790: @127362
     /* 127362 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(127435), // Rule ID 785 //
     /* 127367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127378 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127381 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127385 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 127389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127402 */     // (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (ROL16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 127402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127406 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mCL_ND),
     /* 127419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127421 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 127425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127433 */     GIR_RootConstrainSelectedInstOperands,
     /* 127434 */     // GIR_Coverage, 785,
     /* 127434 */     GIR_EraseRootFromParent_Done,
     /* 127435 */   // Label 2791: @127435
     /* 127435 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(127463), // Rule ID 17596 //
     /* 127440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 127447 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 127451 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROR16r1:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 127451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16r1),
     /* 127454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127456 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127458 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127461 */     GIR_RootConstrainSelectedInstOperands,
     /* 127462 */     // GIR_Coverage, 17596,
     /* 127462 */     GIR_EraseRootFromParent_Done,
     /* 127463 */   // Label 2792: @127463
     /* 127463 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(127491), // Rule ID 17604 //
     /* 127468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 127475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 127479 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROR16r1_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 127479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16r1_ND),
     /* 127482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127484 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127489 */     GIR_RootConstrainSelectedInstOperands,
     /* 127490 */     // GIR_Coverage, 17604,
     /* 127490 */     GIR_EraseRootFromParent_Done,
     /* 127491 */   // Label 2793: @127491
     /* 127491 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(127528), // Rule ID 757 //
     /* 127496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 127503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127511 */     // MIs[1] Operand 1
     /* 127511 */     // No operand predicates
     /* 127511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127513 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri),
     /* 127516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127518 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 127523 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127526 */     GIR_RootConstrainSelectedInstOperands,
     /* 127527 */     // GIR_Coverage, 757,
     /* 127527 */     GIR_EraseRootFromParent_Done,
     /* 127528 */   // Label 2794: @127528
     /* 127528 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(127565), // Rule ID 761 //
     /* 127533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 127540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127548 */     // MIs[1] Operand 1
     /* 127548 */     // No operand predicates
     /* 127548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127550 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri_ND),
     /* 127553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127555 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 127560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127563 */     GIR_RootConstrainSelectedInstOperands,
     /* 127564 */     // GIR_Coverage, 761,
     /* 127564 */     GIR_EraseRootFromParent_Done,
     /* 127565 */   // Label 2795: @127565
     /* 127565 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(127607), // Rule ID 773 //
     /* 127570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 127577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127581 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROL16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 127581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127585 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127591 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16rCL),
     /* 127598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127600 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127605 */     GIR_RootConstrainSelectedInstOperands,
     /* 127606 */     // GIR_Coverage, 773,
     /* 127606 */     GIR_EraseRootFromParent_Done,
     /* 127607 */   // Label 2796: @127607
     /* 127607 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(127649), // Rule ID 777 //
     /* 127612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 127619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127623 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROL16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 127623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127627 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127633 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16rCL_ND),
     /* 127640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127642 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127647 */     GIR_RootConstrainSelectedInstOperands,
     /* 127648 */     // GIR_Coverage, 777,
     /* 127648 */     GIR_EraseRootFromParent_Done,
     /* 127649 */   // Label 2797: @127649
     /* 127649 */   GIM_Reject,
     /* 127650 */ // Label 2788: @127650
     /* 127650 */ GIM_Reject,
     /* 127651 */ // Label 2767: @127651
     /* 127651 */ GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(128117),
     /* 127656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 127662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 127666 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(127725), // Rule ID 17621 //
     /* 127671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127682 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127685 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127689 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 127693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 127697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127699 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127706 */     // (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] })  =>  (ROR32m1_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 127706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32m1_ND),
     /* 127709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127711 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 127715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127723 */     GIR_RootConstrainSelectedInstOperands,
     /* 127724 */     // GIR_Coverage, 17621,
     /* 127724 */     GIR_EraseRootFromParent_Done,
     /* 127725 */   // Label 2799: @127725
     /* 127725 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(127792), // Rule ID 770 //
     /* 127730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127741 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127744 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127748 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 127752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 127756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127760 */     // MIs[2] Operand 1
     /* 127760 */     // No operand predicates
     /* 127760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 127762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127769 */     // (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (ROL32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mi_ND),
     /* 127772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127774 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 127778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 127781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 127790 */     GIR_RootConstrainSelectedInstOperands,
     /* 127791 */     // GIR_Coverage, 770,
     /* 127791 */     GIR_EraseRootFromParent_Done,
     /* 127792 */   // Label 2800: @127792
     /* 127792 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(127865), // Rule ID 786 //
     /* 127797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127808 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127811 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127815 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 127819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127832 */     // (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (ROL32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 127832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127836 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mCL_ND),
     /* 127849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127851 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 127855 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127863 */     GIR_RootConstrainSelectedInstOperands,
     /* 127864 */     // GIR_Coverage, 786,
     /* 127864 */     GIR_EraseRootFromParent_Done,
     /* 127865 */   // Label 2801: @127865
     /* 127865 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(127902), // Rule ID 868 //
     /* 127870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 127873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 127877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127885 */     // MIs[1] Operand 1
     /* 127885 */     // No operand predicates
     /* 127885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127887 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHLDROT32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 127887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLDROT32ri),
     /* 127890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127892 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 127897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127900 */     GIR_RootConstrainSelectedInstOperands,
     /* 127901 */     // GIR_Coverage, 868,
     /* 127901 */     GIR_EraseRootFromParent_Done,
     /* 127902 */   // Label 2802: @127902
     /* 127902 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(127930), // Rule ID 17597 //
     /* 127907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 127914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 127918 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROR32r1:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 127918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32r1),
     /* 127921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127923 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127928 */     GIR_RootConstrainSelectedInstOperands,
     /* 127929 */     // GIR_Coverage, 17597,
     /* 127929 */     GIR_EraseRootFromParent_Done,
     /* 127930 */   // Label 2803: @127930
     /* 127930 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(127958), // Rule ID 17605 //
     /* 127935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 127942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 127946 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROR32r1_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 127946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32r1_ND),
     /* 127949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127951 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127953 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127956 */     GIR_RootConstrainSelectedInstOperands,
     /* 127957 */     // GIR_Coverage, 17605,
     /* 127957 */     GIR_EraseRootFromParent_Done,
     /* 127958 */   // Label 2804: @127958
     /* 127958 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(127995), // Rule ID 758 //
     /* 127963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 127970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127978 */     // MIs[1] Operand 1
     /* 127978 */     // No operand predicates
     /* 127978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127980 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32ri),
     /* 127983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127985 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 127990 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127993 */     GIR_RootConstrainSelectedInstOperands,
     /* 127994 */     // GIR_Coverage, 758,
     /* 127994 */     GIR_EraseRootFromParent_Done,
     /* 127995 */   // Label 2805: @127995
     /* 127995 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(128032), // Rule ID 762 //
     /* 128000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128015 */     // MIs[1] Operand 1
     /* 128015 */     // No operand predicates
     /* 128015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128017 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32ri_ND),
     /* 128020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128022 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128027 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128030 */     GIR_RootConstrainSelectedInstOperands,
     /* 128031 */     // GIR_Coverage, 762,
     /* 128031 */     GIR_EraseRootFromParent_Done,
     /* 128032 */   // Label 2806: @128032
     /* 128032 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(128074), // Rule ID 774 //
     /* 128037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128048 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROL32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128052 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32rCL),
     /* 128065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128067 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128072 */     GIR_RootConstrainSelectedInstOperands,
     /* 128073 */     // GIR_Coverage, 774,
     /* 128073 */     GIR_EraseRootFromParent_Done,
     /* 128074 */   // Label 2807: @128074
     /* 128074 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(128116), // Rule ID 778 //
     /* 128079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128090 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROL32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128094 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128100 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32rCL_ND),
     /* 128107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128109 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128114 */     GIR_RootConstrainSelectedInstOperands,
     /* 128115 */     // GIR_Coverage, 778,
     /* 128115 */     GIR_EraseRootFromParent_Done,
     /* 128116 */   // Label 2808: @128116
     /* 128116 */   GIM_Reject,
     /* 128117 */ // Label 2798: @128117
     /* 128117 */ GIM_Reject,
     /* 128118 */ // Label 2768: @128118
     /* 128118 */ GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(128584),
     /* 128123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 128129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128133 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(128192), // Rule ID 17622 //
     /* 128138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128149 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128152 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 128156 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128160 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 128164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128173 */     // (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] })  =>  (ROR64m1_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 128173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64m1_ND),
     /* 128176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128178 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 128182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128190 */     GIR_RootConstrainSelectedInstOperands,
     /* 128191 */     // GIR_Coverage, 17622,
     /* 128191 */     GIR_EraseRootFromParent_Done,
     /* 128192 */   // Label 2810: @128192
     /* 128192 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(128259), // Rule ID 771 //
     /* 128197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128208 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128211 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 128215 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 128223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128227 */     // MIs[2] Operand 1
     /* 128227 */     // No operand predicates
     /* 128227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 128229 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128236 */     // (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (ROL64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mi_ND),
     /* 128239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128241 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 128248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 128257 */     GIR_RootConstrainSelectedInstOperands,
     /* 128258 */     // GIR_Coverage, 771,
     /* 128258 */     GIR_EraseRootFromParent_Done,
     /* 128259 */   // Label 2811: @128259
     /* 128259 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(128332), // Rule ID 787 //
     /* 128264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128275 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128278 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 128282 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128299 */     // (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (ROL64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 128299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128303 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128309 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mCL_ND),
     /* 128316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128318 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128322 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128330 */     GIR_RootConstrainSelectedInstOperands,
     /* 128331 */     // GIR_Coverage, 787,
     /* 128331 */     GIR_EraseRootFromParent_Done,
     /* 128332 */   // Label 2812: @128332
     /* 128332 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(128369), // Rule ID 869 //
     /* 128337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 128340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128352 */     // MIs[1] Operand 1
     /* 128352 */     // No operand predicates
     /* 128352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128354 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHLDROT64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 128354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLDROT64ri),
     /* 128357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128359 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 128364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128367 */     GIR_RootConstrainSelectedInstOperands,
     /* 128368 */     // GIR_Coverage, 869,
     /* 128368 */     GIR_EraseRootFromParent_Done,
     /* 128369 */   // Label 2813: @128369
     /* 128369 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(128397), // Rule ID 17598 //
     /* 128374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 128385 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROR64r1:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 128385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64r1),
     /* 128388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128390 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128395 */     GIR_RootConstrainSelectedInstOperands,
     /* 128396 */     // GIR_Coverage, 17598,
     /* 128396 */     GIR_EraseRootFromParent_Done,
     /* 128397 */   // Label 2814: @128397
     /* 128397 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(128425), // Rule ID 17606 //
     /* 128402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128409 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 128413 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROR64r1_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 128413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64r1_ND),
     /* 128416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128418 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128423 */     GIR_RootConstrainSelectedInstOperands,
     /* 128424 */     // GIR_Coverage, 17606,
     /* 128424 */     GIR_EraseRootFromParent_Done,
     /* 128425 */   // Label 2815: @128425
     /* 128425 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(128462), // Rule ID 759 //
     /* 128430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128445 */     // MIs[1] Operand 1
     /* 128445 */     // No operand predicates
     /* 128445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128447 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64ri),
     /* 128450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128452 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128457 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128460 */     GIR_RootConstrainSelectedInstOperands,
     /* 128461 */     // GIR_Coverage, 759,
     /* 128461 */     GIR_EraseRootFromParent_Done,
     /* 128462 */   // Label 2816: @128462
     /* 128462 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(128499), // Rule ID 763 //
     /* 128467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128482 */     // MIs[1] Operand 1
     /* 128482 */     // No operand predicates
     /* 128482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128484 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64ri_ND),
     /* 128487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128489 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128494 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128497 */     GIR_RootConstrainSelectedInstOperands,
     /* 128498 */     // GIR_Coverage, 763,
     /* 128498 */     GIR_EraseRootFromParent_Done,
     /* 128499 */   // Label 2817: @128499
     /* 128499 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(128541), // Rule ID 775 //
     /* 128504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128515 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROL64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 128515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128519 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64rCL),
     /* 128532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128534 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128539 */     GIR_RootConstrainSelectedInstOperands,
     /* 128540 */     // GIR_Coverage, 775,
     /* 128540 */     GIR_EraseRootFromParent_Done,
     /* 128541 */   // Label 2818: @128541
     /* 128541 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(128583), // Rule ID 779 //
     /* 128546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128557 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROL64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 128557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128561 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128567 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64rCL_ND),
     /* 128574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128576 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128578 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128581 */     GIR_RootConstrainSelectedInstOperands,
     /* 128582 */     // GIR_Coverage, 779,
     /* 128582 */     GIR_EraseRootFromParent_Done,
     /* 128583 */   // Label 2819: @128583
     /* 128583 */   GIM_Reject,
     /* 128584 */ // Label 2809: @128584
     /* 128584 */ GIM_Reject,
     /* 128585 */ // Label 2769: @128585
     /* 128585 */ GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(129002),
     /* 128590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 128593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 128596 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(128658), // Rule ID 1582 //
     /* 128601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 128604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 128608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128616 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128619 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 128623 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 128631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128640 */     // (rotl:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src2)  =>  (VPROTQmr:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 128640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTQmr),
     /* 128643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128645 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128649 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 128651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128656 */     GIR_RootConstrainSelectedInstOperands,
     /* 128657 */     // GIR_Coverage, 1582,
     /* 128657 */     GIR_EraseRootFromParent_Done,
     /* 128658 */   // Label 2821: @128658
     /* 128658 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(128720), // Rule ID 1581 //
     /* 128663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 128666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 128670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 128674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128682 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128685 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 128689 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128702 */     // (rotl:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 128702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTQrm),
     /* 128705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128707 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128709 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 128713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128718 */     GIR_RootConstrainSelectedInstOperands,
     /* 128719 */     // GIR_Coverage, 1581,
     /* 128719 */     GIR_EraseRootFromParent_Done,
     /* 128720 */   // Label 2822: @128720
     /* 128720 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(128782), // Rule ID 8058 //
     /* 128725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 128728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 128732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 128736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128744 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128747 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 128751 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128764 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 128764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ128rm),
     /* 128767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128769 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128771 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 128775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128780 */     GIR_RootConstrainSelectedInstOperands,
     /* 128781 */     // GIR_Coverage, 8058,
     /* 128781 */     GIR_EraseRootFromParent_Done,
     /* 128782 */   // Label 2823: @128782
     /* 128782 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(128809), // Rule ID 1580 //
     /* 128787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 128790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 128794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 128798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 128802 */     // (rotl:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPROTQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 128802 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTQrr),
     /* 128807 */     GIR_RootConstrainSelectedInstOperands,
     /* 128808 */     // GIR_Coverage, 1580,
     /* 128808 */     GIR_Done,
     /* 128809 */   // Label 2824: @128809
     /* 128809 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(128836), // Rule ID 8055 //
     /* 128814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 128817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 128821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 128825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 128829 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPROLVQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 128829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ128rr),
     /* 128834 */     GIR_RootConstrainSelectedInstOperands,
     /* 128835 */     // GIR_Coverage, 8055,
     /* 128835 */     GIR_Done,
     /* 128836 */   // Label 2825: @128836
     /* 128836 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(129001), // Rule ID 20795 //
     /* 128841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 128844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 128848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 128852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 128856 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPROLVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 128856 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 128859 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128863 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 128870 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 128873 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 128877 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128882 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 128885 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 128889 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 128892 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 128897 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 128902 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 128907 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 128910 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128914 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 128921 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 128924 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 128928 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128933 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 128936 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 128940 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 128943 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 128948 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 128953 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 128958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 128961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 128965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128970 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 128973 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 128976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128983 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 128990 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 128995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129000 */     // GIR_Coverage, 20795,
     /* 129000 */     GIR_EraseRootFromParent_Done,
     /* 129001 */   // Label 2826: @129001
     /* 129001 */   GIM_Reject,
     /* 129002 */ // Label 2820: @129002
     /* 129002 */ GIM_Reject,
     /* 129003 */ // Label 2770: @129003
     /* 129003 */ GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(129420),
     /* 129008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 129014 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(129076), // Rule ID 1579 //
     /* 129019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129034 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129037 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129041 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129051 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129058 */     // (rotl:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src2)  =>  (VPROTDmr:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 129058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTDmr),
     /* 129061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129063 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 129067 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 129069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129074 */     GIR_RootConstrainSelectedInstOperands,
     /* 129075 */     // GIR_Coverage, 1579,
     /* 129075 */     GIR_EraseRootFromParent_Done,
     /* 129076 */   // Label 2828: @129076
     /* 129076 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(129138), // Rule ID 1578 //
     /* 129081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129100 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129103 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129107 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129120 */     // (rotl:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTDrm),
     /* 129123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129125 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129127 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129136 */     GIR_RootConstrainSelectedInstOperands,
     /* 129137 */     // GIR_Coverage, 1578,
     /* 129137 */     GIR_EraseRootFromParent_Done,
     /* 129138 */   // Label 2829: @129138
     /* 129138 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(129200), // Rule ID 8031 //
     /* 129143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129162 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129165 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129169 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129182 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ128rm),
     /* 129185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129187 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129189 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129198 */     GIR_RootConstrainSelectedInstOperands,
     /* 129199 */     // GIR_Coverage, 8031,
     /* 129199 */     GIR_EraseRootFromParent_Done,
     /* 129200 */   // Label 2830: @129200
     /* 129200 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(129227), // Rule ID 1577 //
     /* 129205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129220 */     // (rotl:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPROTDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 129220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTDrr),
     /* 129225 */     GIR_RootConstrainSelectedInstOperands,
     /* 129226 */     // GIR_Coverage, 1577,
     /* 129226 */     GIR_Done,
     /* 129227 */   // Label 2831: @129227
     /* 129227 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(129254), // Rule ID 8028 //
     /* 129232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129247 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPROLVDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 129247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ128rr),
     /* 129252 */     GIR_RootConstrainSelectedInstOperands,
     /* 129253 */     // GIR_Coverage, 8028,
     /* 129253 */     GIR_Done,
     /* 129254 */   // Label 2832: @129254
     /* 129254 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(129419), // Rule ID 20797 //
     /* 129259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 129262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 129266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129274 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPROLVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 129274 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 129277 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129281 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 129288 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 129291 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 129295 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129300 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 129303 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 129307 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 129310 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 129315 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129320 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 129325 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 129328 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129332 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129339 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 129342 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 129346 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129351 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 129354 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 129358 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 129361 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 129366 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 129376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 129379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 129383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129388 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 129391 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 129394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129401 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 129408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 129413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129418 */     // GIR_Coverage, 20797,
     /* 129418 */     GIR_EraseRootFromParent_Done,
     /* 129419 */   // Label 2833: @129419
     /* 129419 */   GIM_Reject,
     /* 129420 */ // Label 2827: @129420
     /* 129420 */ GIM_Reject,
     /* 129421 */ // Label 2771: @129421
     /* 129421 */ GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(129671),
     /* 129426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 129429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 129432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 129436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 129440 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(129494), // Rule ID 8049 //
     /* 129445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129456 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129459 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129463 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129469 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129476 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ256rm),
     /* 129479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129481 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129483 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129492 */     GIR_RootConstrainSelectedInstOperands,
     /* 129493 */     // GIR_Coverage, 8049,
     /* 129493 */     GIR_EraseRootFromParent_Done,
     /* 129494 */   // Label 2835: @129494
     /* 129494 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(129513), // Rule ID 8046 //
     /* 129499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 129506 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPROLVQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 129506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ256rr),
     /* 129511 */     GIR_RootConstrainSelectedInstOperands,
     /* 129512 */     // GIR_Coverage, 8046,
     /* 129512 */     GIR_Done,
     /* 129513 */   // Label 2836: @129513
     /* 129513 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(129670), // Rule ID 20796 //
     /* 129518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 129521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 129525 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPROLVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 129525 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 129528 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129532 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 129539 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 129542 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 129546 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129551 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 129554 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 129558 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 129561 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 129566 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129571 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 129576 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 129579 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129583 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129590 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 129593 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 129597 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129602 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 129605 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 129609 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 129612 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 129617 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129622 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 129627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 129630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 129634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129639 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 129642 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 129645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129652 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 129659 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 129664 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129669 */     // GIR_Coverage, 20796,
     /* 129669 */     GIR_EraseRootFromParent_Done,
     /* 129670 */   // Label 2837: @129670
     /* 129670 */   GIM_Reject,
     /* 129671 */ // Label 2834: @129671
     /* 129671 */ GIM_Reject,
     /* 129672 */ // Label 2772: @129672
     /* 129672 */ GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(129827),
     /* 129677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 129683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129687 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(129745), // Rule ID 1585 //
     /* 129692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129703 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129706 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129710 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129720 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129727 */     // (rotl:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src2)  =>  (VPROTWmr:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 129727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTWmr),
     /* 129730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129732 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 129736 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 129738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129743 */     GIR_RootConstrainSelectedInstOperands,
     /* 129744 */     // GIR_Coverage, 1585,
     /* 129744 */     GIR_EraseRootFromParent_Done,
     /* 129745 */   // Label 2839: @129745
     /* 129745 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(129803), // Rule ID 1584 //
     /* 129750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129765 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129768 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129772 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129778 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129785 */     // (rotl:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTWrm),
     /* 129788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129790 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129792 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129801 */     GIR_RootConstrainSelectedInstOperands,
     /* 129802 */     // GIR_Coverage, 1584,
     /* 129802 */     GIR_EraseRootFromParent_Done,
     /* 129803 */   // Label 2840: @129803
     /* 129803 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(129826), // Rule ID 1583 //
     /* 129808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129819 */     // (rotl:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPROTWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 129819 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTWrr),
     /* 129824 */     GIR_RootConstrainSelectedInstOperands,
     /* 129825 */     // GIR_Coverage, 1583,
     /* 129825 */     GIR_Done,
     /* 129826 */   // Label 2841: @129826
     /* 129826 */   GIM_Reject,
     /* 129827 */ // Label 2838: @129827
     /* 129827 */ GIM_Reject,
     /* 129828 */ // Label 2773: @129828
     /* 129828 */ GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(130078),
     /* 129833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 129836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 129839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 129843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 129847 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(129901), // Rule ID 8022 //
     /* 129852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129863 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129866 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129870 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129883 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ256rm),
     /* 129886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129888 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129890 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129899 */     GIR_RootConstrainSelectedInstOperands,
     /* 129900 */     // GIR_Coverage, 8022,
     /* 129900 */     GIR_EraseRootFromParent_Done,
     /* 129901 */   // Label 2843: @129901
     /* 129901 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(129920), // Rule ID 8019 //
     /* 129906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 129913 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPROLVDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 129913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ256rr),
     /* 129918 */     GIR_RootConstrainSelectedInstOperands,
     /* 129919 */     // GIR_Coverage, 8019,
     /* 129919 */     GIR_Done,
     /* 129920 */   // Label 2844: @129920
     /* 129920 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(130077), // Rule ID 20798 //
     /* 129925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 129928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 129932 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPROLVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 129932 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 129935 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129939 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 129946 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 129949 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 129953 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129958 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 129961 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 129965 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 129968 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 129973 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129978 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 129983 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 129986 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129990 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129997 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 130000 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130004 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130009 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 130012 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 130016 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 130019 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130024 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130029 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 130037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 130041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130046 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130049 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 130052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130059 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 130066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130076 */     // GIR_Coverage, 20798,
     /* 130076 */     GIR_EraseRootFromParent_Done,
     /* 130077 */   // Label 2845: @130077
     /* 130077 */   GIM_Reject,
     /* 130078 */ // Label 2842: @130078
     /* 130078 */ GIM_Reject,
     /* 130079 */ // Label 2774: @130079
     /* 130079 */ GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(130172),
     /* 130084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 130087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 130090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130098 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(130152), // Rule ID 8040 //
     /* 130103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 130106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130114 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130117 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130121 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130127 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130134 */     // (rotl:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrm),
     /* 130137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130139 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130141 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130150 */     GIR_RootConstrainSelectedInstOperands,
     /* 130151 */     // GIR_Coverage, 8040,
     /* 130151 */     GIR_EraseRootFromParent_Done,
     /* 130152 */   // Label 2847: @130152
     /* 130152 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(130171), // Rule ID 8037 //
     /* 130157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 130160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130164 */     // (rotl:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPROLVQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 130164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 130169 */     GIR_RootConstrainSelectedInstOperands,
     /* 130170 */     // GIR_Coverage, 8037,
     /* 130170 */     GIR_Done,
     /* 130171 */   // Label 2848: @130171
     /* 130171 */   GIM_Reject,
     /* 130172 */ // Label 2846: @130172
     /* 130172 */ GIM_Reject,
     /* 130173 */ // Label 2775: @130173
     /* 130173 */ GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(130328),
     /* 130178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 130181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 130184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130188 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(130246), // Rule ID 1576 //
     /* 130193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130204 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130207 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130211 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130221 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130228 */     // (rotl:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src2)  =>  (VPROTBmr:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 130228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTBmr),
     /* 130231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130233 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 130237 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 130239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130244 */     GIR_RootConstrainSelectedInstOperands,
     /* 130245 */     // GIR_Coverage, 1576,
     /* 130245 */     GIR_EraseRootFromParent_Done,
     /* 130246 */   // Label 2850: @130246
     /* 130246 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(130304), // Rule ID 1575 //
     /* 130251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130266 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130269 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130273 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130286 */     // (rotl:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTBrm),
     /* 130289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130291 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130293 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130302 */     GIR_RootConstrainSelectedInstOperands,
     /* 130303 */     // GIR_Coverage, 1575,
     /* 130303 */     GIR_EraseRootFromParent_Done,
     /* 130304 */   // Label 2851: @130304
     /* 130304 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(130327), // Rule ID 1574 //
     /* 130309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130320 */     // (rotl:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPROTBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 130320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTBrr),
     /* 130325 */     GIR_RootConstrainSelectedInstOperands,
     /* 130326 */     // GIR_Coverage, 1574,
     /* 130326 */     GIR_Done,
     /* 130327 */   // Label 2852: @130327
     /* 130327 */   GIM_Reject,
     /* 130328 */ // Label 2849: @130328
     /* 130328 */ GIM_Reject,
     /* 130329 */ // Label 2776: @130329
     /* 130329 */ GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(130422),
     /* 130334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 130337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 130340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130348 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(130402), // Rule ID 8013 //
     /* 130353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 130356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130364 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130367 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130371 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130384 */     // (rotl:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrm),
     /* 130387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130389 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130391 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130400 */     GIR_RootConstrainSelectedInstOperands,
     /* 130401 */     // GIR_Coverage, 8013,
     /* 130401 */     GIR_EraseRootFromParent_Done,
     /* 130402 */   // Label 2854: @130402
     /* 130402 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(130421), // Rule ID 8010 //
     /* 130407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 130410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130414 */     // (rotl:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPROLVDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 130414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 130419 */     GIR_RootConstrainSelectedInstOperands,
     /* 130420 */     // GIR_Coverage, 8010,
     /* 130420 */     GIR_Done,
     /* 130421 */   // Label 2855: @130421
     /* 130421 */   GIM_Reject,
     /* 130422 */ // Label 2853: @130422
     /* 130422 */ GIM_Reject,
     /* 130423 */ // Label 2777: @130423
     /* 130423 */ GIM_Reject,
     /* 130424 */ // Label 33: @130424
     /* 130424 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(24), /*)*//*default:*//*Label 2862*/ GIMT_Encode4(132080),
     /* 130435 */ /*GILLT_v2s1*//*Label 2856*/ GIMT_Encode4(130503), GIMT_Encode4(0),
     /* 130443 */ /*GILLT_v4s1*//*Label 2857*/ GIMT_Encode4(130664), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130455 */ /*GILLT_v8s1*//*Label 2858*/ GIMT_Encode4(131011), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130471 */ /*GILLT_v16s1*//*Label 2859*/ GIMT_Encode4(131408), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130487 */ /*GILLT_v32s1*//*Label 2860*/ GIMT_Encode4(131805), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130499 */ /*GILLT_v64s1*//*Label 2861*/ GIMT_Encode4(132029),
     /* 130503 */ // Label 2856: @130503
     /* 130503 */ GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(130663),
     /* 130508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 130511 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 130514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 130518 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 130523 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 130527 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(130558), // Rule ID 12605 //
     /* 130532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 130535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130539 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 130545 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 130547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130549 */     // (setcc:{ *:[v2i1] } immAllZerosV:{ *:[v2i64] }, VR128X:{ *:[v2i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZ128kr:{ *:[v2i1] } VR128X:{ *:[v2i64] }:$src)
     /* 130549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZ128kr),
     /* 130552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130554 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 130556 */     GIR_RootConstrainSelectedInstOperands,
     /* 130557 */     // GIR_Coverage, 12605,
     /* 130557 */     GIR_EraseRootFromParent_Done,
     /* 130558 */   // Label 2864: @130558
     /* 130558 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(130662), // Rule ID 21657 //
     /* 130563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 130566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130570 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 130576 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 130578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130580 */     // (setcc:{ *:[v2i1] } immAllZerosV:{ *:[v2i64] }, VR128X:{ *:[v2i64] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (VPMOVQ2MZkr:{ *:[v8i1] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] })), VK2:{ *:[i32] })
     /* 130580 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 130583 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130587 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130594 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 130597 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130601 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130606 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 130609 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 130613 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 130616 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130621 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130626 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 130631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 130634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 130638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130643 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 130661 */     // GIR_Coverage, 21657,
     /* 130661 */     GIR_EraseRootFromParent_Done,
     /* 130662 */   // Label 2865: @130662
     /* 130662 */   GIM_Reject,
     /* 130663 */ // Label 2863: @130663
     /* 130663 */ GIM_Reject,
     /* 130664 */ // Label 2857: @130664
     /* 130664 */ GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(130714), // Rule ID 12602 //
     /* 130669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 130672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 130675 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 130678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 130682 */   // MIs[0] Operand 1
     /* 130682 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 130687 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130691 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 130697 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 130699 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 130703 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130705 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i32] }, VR128X:{ *:[v4i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZ128kr:{ *:[v4i1] } VR128X:{ *:[v4i32] }:$src)
     /* 130705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZ128kr),
     /* 130708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130710 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 130712 */   GIR_RootConstrainSelectedInstOperands,
     /* 130713 */   // GIR_Coverage, 12602,
     /* 130713 */   GIR_EraseRootFromParent_Done,
     /* 130714 */ // Label 2866: @130714
     /* 130714 */ GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(130764), // Rule ID 12604 //
     /* 130719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 130722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 130725 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 130728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 130732 */   // MIs[0] Operand 1
     /* 130732 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 130737 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130741 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 130747 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 130749 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130753 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130755 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i64] }, VR256X:{ *:[v4i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZ256kr:{ *:[v4i1] } VR256X:{ *:[v4i64] }:$src)
     /* 130755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZ256kr),
     /* 130758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130760 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 130762 */   GIR_RootConstrainSelectedInstOperands,
     /* 130763 */   // GIR_Coverage, 12604,
     /* 130763 */   GIR_EraseRootFromParent_Done,
     /* 130764 */ // Label 2867: @130764
     /* 130764 */ GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(130887), // Rule ID 21655 //
     /* 130769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 130772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 130775 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 130778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 130782 */   // MIs[0] Operand 1
     /* 130782 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 130787 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130791 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 130797 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 130799 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 130803 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130805 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i32] }, VR128X:{ *:[v4i32] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (VPMOVD2MZkr:{ *:[v16i1] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] })), VK4:{ *:[i32] })
     /* 130805 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 130808 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130812 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130817 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130819 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 130822 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130826 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130831 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 130834 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 130838 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 130841 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130846 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130851 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 130856 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 130859 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 130863 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130868 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130871 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130878 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130881 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 130886 */   // GIR_Coverage, 21655,
     /* 130886 */   GIR_EraseRootFromParent_Done,
     /* 130887 */ // Label 2868: @130887
     /* 130887 */ GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(131010), // Rule ID 21656 //
     /* 130892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 130895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 130898 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 130901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 130905 */   // MIs[0] Operand 1
     /* 130905 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 130910 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130914 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 130920 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 130922 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130926 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130928 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i64] }, VR256X:{ *:[v4i64] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (VPMOVQ2MZkr:{ *:[v8i1] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), VK4:{ *:[i32] })
     /* 130928 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 130931 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130935 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130942 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 130945 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130949 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130954 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 130957 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 130961 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 130964 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130969 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130974 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130979 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 130982 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 130986 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130991 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130994 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131001 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131004 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 131009 */   // GIR_Coverage, 21656,
     /* 131009 */   GIR_EraseRootFromParent_Done,
     /* 131010 */ // Label 2869: @131010
     /* 131010 */ GIM_Reject,
     /* 131011 */ // Label 2858: @131011
     /* 131011 */ GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(131061), // Rule ID 12599 //
     /* 131016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 131019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 131022 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 131025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131029 */   // MIs[0] Operand 1
     /* 131029 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131034 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131038 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131044 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131046 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131050 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131052 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i16] }, VR128X:{ *:[v8i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZ128kr:{ *:[v8i1] } VR128X:{ *:[v8i16] }:$src)
     /* 131052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZ128kr),
     /* 131055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131057 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131059 */   GIR_RootConstrainSelectedInstOperands,
     /* 131060 */   // GIR_Coverage, 12599,
     /* 131060 */   GIR_EraseRootFromParent_Done,
     /* 131061 */ // Label 2870: @131061
     /* 131061 */ GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(131111), // Rule ID 12601 //
     /* 131066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 131072 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 131075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131079 */   // MIs[0] Operand 1
     /* 131079 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131084 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131088 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131094 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131096 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131100 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131102 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i32] }, VR256X:{ *:[v8i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZ256kr:{ *:[v8i1] } VR256X:{ *:[v8i32] }:$src)
     /* 131102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZ256kr),
     /* 131105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131107 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131109 */   GIR_RootConstrainSelectedInstOperands,
     /* 131110 */   // GIR_Coverage, 12601,
     /* 131110 */   GIR_EraseRootFromParent_Done,
     /* 131111 */ // Label 2871: @131111
     /* 131111 */ GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(131161), // Rule ID 12603 //
     /* 131116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 131119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 131122 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 131125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131129 */   // MIs[0] Operand 1
     /* 131129 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131134 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131138 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131144 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131146 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 131150 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131152 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZkr:{ *:[v8i1] } VR512:{ *:[v8i64] }:$src)
     /* 131152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 131155 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131157 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131159 */   GIR_RootConstrainSelectedInstOperands,
     /* 131160 */   // GIR_Coverage, 12603,
     /* 131160 */   GIR_EraseRootFromParent_Done,
     /* 131161 */ // Label 2872: @131161
     /* 131161 */ GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(131284), // Rule ID 21653 //
     /* 131166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 131169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 131172 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 131175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131179 */   // MIs[0] Operand 1
     /* 131179 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131184 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131188 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131194 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131196 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131200 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131202 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i16] }, VR128X:{ *:[v8i16] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (VPMOVW2MZkr:{ *:[v32i1] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] })), VK8:{ *:[i32] })
     /* 131202 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 131205 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131209 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131214 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131216 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 131219 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131223 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131228 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131231 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131235 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 131238 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131243 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131248 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 131253 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s1,
     /* 131256 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 131260 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131265 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131268 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131275 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131278 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 131283 */   // GIR_Coverage, 21653,
     /* 131283 */   GIR_EraseRootFromParent_Done,
     /* 131284 */ // Label 2873: @131284
     /* 131284 */ GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(131407), // Rule ID 21654 //
     /* 131289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 131292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 131295 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 131298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131302 */   // MIs[0] Operand 1
     /* 131302 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131307 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131311 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131317 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131319 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131323 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131325 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i32] }, VR256X:{ *:[v8i32] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (VPMOVD2MZkr:{ *:[v16i1] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] })), VK8:{ *:[i32] })
     /* 131325 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 131328 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131332 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131337 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131339 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 131342 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131346 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131351 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131354 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131358 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 131361 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131366 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131371 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 131376 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 131379 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 131383 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131388 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131391 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131398 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131401 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 131406 */   // GIR_Coverage, 21654,
     /* 131406 */   GIR_EraseRootFromParent_Done,
     /* 131407 */ // Label 2874: @131407
     /* 131407 */ GIM_Reject,
     /* 131408 */ // Label 2859: @131408
     /* 131408 */ GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(131458), // Rule ID 12596 //
     /* 131413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 131416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 131419 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 131422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 131426 */   // MIs[0] Operand 1
     /* 131426 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131431 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131435 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131441 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131443 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131447 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131449 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i8] }, VR128X:{ *:[v16i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZ128kr:{ *:[v16i1] } VR128X:{ *:[v16i8] }:$src)
     /* 131449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZ128kr),
     /* 131452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131454 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131456 */   GIR_RootConstrainSelectedInstOperands,
     /* 131457 */   // GIR_Coverage, 12596,
     /* 131457 */   GIR_EraseRootFromParent_Done,
     /* 131458 */ // Label 2875: @131458
     /* 131458 */ GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(131508), // Rule ID 12598 //
     /* 131463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 131466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 131469 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 131472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 131476 */   // MIs[0] Operand 1
     /* 131476 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131481 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131485 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131491 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131493 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131497 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131499 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i16] }, VR256X:{ *:[v16i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZ256kr:{ *:[v16i1] } VR256X:{ *:[v16i16] }:$src)
     /* 131499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZ256kr),
     /* 131502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131504 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131506 */   GIR_RootConstrainSelectedInstOperands,
     /* 131507 */   // GIR_Coverage, 12598,
     /* 131507 */   GIR_EraseRootFromParent_Done,
     /* 131508 */ // Label 2876: @131508
     /* 131508 */ GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(131558), // Rule ID 12600 //
     /* 131513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 131516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 131519 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 131522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 131526 */   // MIs[0] Operand 1
     /* 131526 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131531 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131535 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131541 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131543 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 131547 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131549 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZkr:{ *:[v16i1] } VR512:{ *:[v16i32] }:$src)
     /* 131549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 131552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131554 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131556 */   GIR_RootConstrainSelectedInstOperands,
     /* 131557 */   // GIR_Coverage, 12600,
     /* 131557 */   GIR_EraseRootFromParent_Done,
     /* 131558 */ // Label 2877: @131558
     /* 131558 */ GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(131681), // Rule ID 21651 //
     /* 131563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 131566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 131569 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 131572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 131576 */   // MIs[0] Operand 1
     /* 131576 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131581 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131585 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131591 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131593 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131597 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131599 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i8] }, VR128X:{ *:[v16i8] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (VPMOVB2MZkr:{ *:[v64i1] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] })), VK16:{ *:[i32] })
     /* 131599 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 131602 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131606 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131613 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 131616 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131620 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131625 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131628 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131632 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 131635 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131640 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131645 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 131650 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s1,
     /* 131653 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 131657 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131662 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131672 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131675 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 131680 */   // GIR_Coverage, 21651,
     /* 131680 */   GIR_EraseRootFromParent_Done,
     /* 131681 */ // Label 2878: @131681
     /* 131681 */ GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(131804), // Rule ID 21652 //
     /* 131686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 131689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 131692 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 131695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 131699 */   // MIs[0] Operand 1
     /* 131699 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131704 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131708 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131714 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131716 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131720 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131722 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i16] }, VR256X:{ *:[v16i16] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (VPMOVW2MZkr:{ *:[v32i1] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] })), VK16:{ *:[i32] })
     /* 131722 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 131725 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131729 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131734 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131736 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 131739 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131743 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131748 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131751 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131755 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 131758 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131763 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131768 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 131773 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s1,
     /* 131776 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 131780 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131785 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131795 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131798 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 131803 */   // GIR_Coverage, 21652,
     /* 131803 */   GIR_EraseRootFromParent_Done,
     /* 131804 */ // Label 2879: @131804
     /* 131804 */ GIM_Reject,
     /* 131805 */ // Label 2860: @131805
     /* 131805 */ GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(131855), // Rule ID 12595 //
     /* 131810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 131813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 131816 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 131819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 131823 */   // MIs[0] Operand 1
     /* 131823 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131828 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131832 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131838 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131840 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131844 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131846 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i8] }, VR256X:{ *:[v32i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZ256kr:{ *:[v32i1] } VR256X:{ *:[v32i8] }:$src)
     /* 131846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZ256kr),
     /* 131849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131851 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131853 */   GIR_RootConstrainSelectedInstOperands,
     /* 131854 */   // GIR_Coverage, 12595,
     /* 131854 */   GIR_EraseRootFromParent_Done,
     /* 131855 */ // Label 2880: @131855
     /* 131855 */ GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(131905), // Rule ID 12597 //
     /* 131860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 131863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 131866 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 131869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 131873 */   // MIs[0] Operand 1
     /* 131873 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131878 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131882 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131888 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131890 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 131894 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131896 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i16] }, VR512:{ *:[v32i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZkr:{ *:[v32i1] } VR512:{ *:[v32i16] }:$src)
     /* 131896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 131899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131901 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131903 */   GIR_RootConstrainSelectedInstOperands,
     /* 131904 */   // GIR_Coverage, 12597,
     /* 131904 */   GIR_EraseRootFromParent_Done,
     /* 131905 */ // Label 2881: @131905
     /* 131905 */ GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(132028), // Rule ID 21650 //
     /* 131910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 131913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 131916 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 131919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 131923 */   // MIs[0] Operand 1
     /* 131923 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131928 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131932 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131938 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131940 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131944 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131946 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i8] }, VR256X:{ *:[v32i8] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } (VPMOVB2MZkr:{ *:[v64i1] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] })), VK32:{ *:[i32] })
     /* 131946 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 131949 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131953 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131958 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131960 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 131963 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131967 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131972 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131975 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131979 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 131982 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131987 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131992 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 131997 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s1,
     /* 132000 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 132004 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132009 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132012 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132019 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132022 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /* 132027 */   // GIR_Coverage, 21650,
     /* 132027 */   GIR_EraseRootFromParent_Done,
     /* 132028 */ // Label 2882: @132028
     /* 132028 */ GIM_Reject,
     /* 132029 */ // Label 2861: @132029
     /* 132029 */ GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(132079), // Rule ID 12594 //
     /* 132034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 132037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 132040 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 132043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 132047 */   // MIs[0] Operand 1
     /* 132047 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132052 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132056 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132062 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132064 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 132068 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132070 */   // (setcc:{ *:[v64i1] } immAllZerosV:{ *:[v64i8] }, VR512:{ *:[v64i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZkr:{ *:[v64i1] } VR512:{ *:[v64i8] }:$src)
     /* 132070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 132073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132075 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132077 */   GIR_RootConstrainSelectedInstOperands,
     /* 132078 */   // GIR_Coverage, 12594,
     /* 132078 */   GIR_EraseRootFromParent_Done,
     /* 132079 */ // Label 2883: @132079
     /* 132079 */ GIM_Reject,
     /* 132080 */ // Label 2862: @132080
     /* 132080 */ GIM_Reject,
     /* 132081 */ // Label 34: @132081
     /* 132081 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 2896*/ GIMT_Encode4(139746),
     /* 132092 */ /*GILLT_v2s64*//*Label 2884*/ GIMT_Encode4(132160), GIMT_Encode4(0),
     /* 132100 */ /*GILLT_v4s32*//*Label 2885*/ GIMT_Encode4(133024),
     /* 132104 */ /*GILLT_v4s64*//*Label 2886*/ GIMT_Encode4(133888), GIMT_Encode4(0),
     /* 132112 */ /*GILLT_v8s16*//*Label 2887*/ GIMT_Encode4(134668),
     /* 132116 */ /*GILLT_v8s32*//*Label 2888*/ GIMT_Encode4(135826),
     /* 132120 */ /*GILLT_v8s64*//*Label 2889*/ GIMT_Encode4(136606), GIMT_Encode4(0),
     /* 132128 */ /*GILLT_v16s8*//*Label 2890*/ GIMT_Encode4(136987),
     /* 132132 */ /*GILLT_v16s16*//*Label 2891*/ GIMT_Encode4(137427),
     /* 132136 */ /*GILLT_v16s32*//*Label 2892*/ GIMT_Encode4(138497), GIMT_Encode4(0),
     /* 132144 */ /*GILLT_v32s8*//*Label 2893*/ GIMT_Encode4(138838),
     /* 132148 */ /*GILLT_v32s16*//*Label 2894*/ GIMT_Encode4(139242), GIMT_Encode4(0),
     /* 132156 */ /*GILLT_v64s8*//*Label 2895*/ GIMT_Encode4(139660),
     /* 132160 */ // Label 2884: @132160
     /* 132160 */ GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(133023),
     /* 132165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 132168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 132171 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 132174 */   GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(132219), // Rule ID 4488 //
     /* 132179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 132182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 132198 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132204 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132208 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src, immAllZerosV:{ *:[v2f64] })  =>  (VMOVAPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 132208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rrkz),
     /* 132211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132213 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 132215 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 132217 */     GIR_RootConstrainSelectedInstOperands,
     /* 132218 */     // GIR_Coverage, 4488,
     /* 132218 */     GIR_EraseRootFromParent_Done,
     /* 132219 */   // Label 2898: @132219
     /* 132219 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(132264), // Rule ID 4542 //
     /* 132224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 132227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 132243 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132249 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132253 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src, immAllZerosV:{ *:[v2i64] })  =>  (VMOVDQA64Z128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 132253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rrkz),
     /* 132256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132258 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 132260 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 132262 */     GIR_RootConstrainSelectedInstOperands,
     /* 132263 */     // GIR_Coverage, 4542,
     /* 132263 */     GIR_EraseRootFromParent_Done,
     /* 132264 */   // Label 2899: @132264
     /* 132264 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(132413), // Rule ID 19776 //
     /* 132269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 132272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 132276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 132288 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132294 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132298 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, immAllZerosV:{ *:[v2f64] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } (VMOVAPDZrrkz:{ *:[v8f64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 132298 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 132301 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132305 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 132312 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 132315 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132319 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132324 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 132327 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 132331 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 132334 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132339 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132344 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 132349 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 132352 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132356 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132361 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 132365 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 132370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 132373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 132377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132382 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132385 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 132388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132395 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 132402 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 132407 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132412 */     // GIR_Coverage, 19776,
     /* 132412 */     GIR_EraseRootFromParent_Done,
     /* 132413 */   // Label 2900: @132413
     /* 132413 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(132562), // Rule ID 19778 //
     /* 132418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 132421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 132425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 132437 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132443 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132447 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, immAllZerosV:{ *:[v2i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 132447 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 132450 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132454 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 132461 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 132464 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132468 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132473 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 132476 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 132480 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 132483 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132488 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132493 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 132498 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 132501 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132505 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132510 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 132514 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 132519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 132522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 132526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132531 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132534 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 132537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132544 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 132551 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 132556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132561 */     // GIR_Coverage, 19778,
     /* 132561 */     GIR_EraseRootFromParent_Done,
     /* 132562 */   // Label 2901: @132562
     /* 132562 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(132599), // Rule ID 4490 //
     /* 132567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 132570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132586 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src0)  =>  (VMOVAPDZ128rrk:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src0, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1)
     /* 132586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rrk),
     /* 132589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132591 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 132593 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 132595 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 132597 */     GIR_RootConstrainSelectedInstOperands,
     /* 132598 */     // GIR_Coverage, 4490,
     /* 132598 */     GIR_EraseRootFromParent_Done,
     /* 132599 */   // Label 2902: @132599
     /* 132599 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(132636), // Rule ID 4544 //
     /* 132604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 132607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132623 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src0)  =>  (VMOVDQA64Z128rrk:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src0, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1)
     /* 132623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rrk),
     /* 132626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132628 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 132630 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 132632 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 132634 */     GIR_RootConstrainSelectedInstOperands,
     /* 132635 */     // GIR_Coverage, 4544,
     /* 132635 */     GIR_EraseRootFromParent_Done,
     /* 132636 */   // Label 2903: @132636
     /* 132636 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(132829), // Rule ID 19775 //
     /* 132641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 132644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 132648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132660 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v2f64] } (VMOVAPDZrrk:{ *:[v8f64] } (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 132660 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 132663 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132667 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 132674 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 132677 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132681 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132686 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 132689 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 132693 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 132696 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132701 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132706 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 132711 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 132714 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132718 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132723 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 132727 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 132732 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 132735 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132739 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132746 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 132749 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132753 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132758 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132761 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 132765 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 132768 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132773 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132778 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 132783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 132786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 132790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132795 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132798 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 132801 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 132804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132811 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 132818 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 132823 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132828 */     // GIR_Coverage, 19775,
     /* 132828 */     GIR_EraseRootFromParent_Done,
     /* 132829 */   // Label 2904: @132829
     /* 132829 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(133022), // Rule ID 19777 //
     /* 132834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 132837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 132841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132853 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VMOVDQA64Zrrk:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 132853 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 132856 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132860 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 132867 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 132870 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132874 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132879 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 132882 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 132886 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 132889 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132894 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132899 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 132904 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 132907 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132911 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132916 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 132920 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 132925 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 132928 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132932 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132939 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 132942 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132946 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132951 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132954 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 132958 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 132961 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132966 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132971 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 132976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 132979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 132983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132988 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132991 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 132994 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 132997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133004 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133021 */     // GIR_Coverage, 19777,
     /* 133021 */     GIR_EraseRootFromParent_Done,
     /* 133022 */   // Label 2905: @133022
     /* 133022 */   GIM_Reject,
     /* 133023 */ // Label 2897: @133023
     /* 133023 */ GIM_Reject,
     /* 133024 */ // Label 2885: @133024
     /* 133024 */ GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(133887),
     /* 133029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 133032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 133035 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 133038 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(133083), // Rule ID 4470 //
     /* 133043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133062 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133068 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133072 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src, immAllZerosV:{ *:[v4f32] })  =>  (VMOVAPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 133072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rrkz),
     /* 133075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133077 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133079 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 133081 */     GIR_RootConstrainSelectedInstOperands,
     /* 133082 */     // GIR_Coverage, 4470,
     /* 133082 */     GIR_EraseRootFromParent_Done,
     /* 133083 */   // Label 2907: @133083
     /* 133083 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(133128), // Rule ID 4528 //
     /* 133088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133107 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133113 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133117 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src, immAllZerosV:{ *:[v4i32] })  =>  (VMOVDQA32Z128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 133117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z128rrkz),
     /* 133120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133122 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133124 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 133126 */     GIR_RootConstrainSelectedInstOperands,
     /* 133127 */     // GIR_Coverage, 4528,
     /* 133127 */     GIR_EraseRootFromParent_Done,
     /* 133128 */   // Label 2908: @133128
     /* 133128 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(133277), // Rule ID 19768 //
     /* 133133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133152 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133158 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133162 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, immAllZerosV:{ *:[v4f32] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } (VMOVAPSZrrkz:{ *:[v16f32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133162 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 133165 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133169 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133176 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 133179 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133183 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133188 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 133191 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133195 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 133198 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133203 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133208 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133213 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 133216 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133220 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133225 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133229 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 133234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 133237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 133241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133246 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133249 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 133252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133259 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133266 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133271 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133276 */     // GIR_Coverage, 19768,
     /* 133276 */     GIR_EraseRootFromParent_Done,
     /* 133277 */   // Label 2909: @133277
     /* 133277 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(133426), // Rule ID 19770 //
     /* 133282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133301 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133307 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133311 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, immAllZerosV:{ *:[v4i32] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VMOVDQA32Zrrkz:{ *:[v16i32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133311 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 133314 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133318 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133325 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 133328 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133332 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133337 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 133340 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133344 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 133347 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133352 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133357 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133362 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 133365 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133369 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133374 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133378 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 133383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 133386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 133390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133395 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133398 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 133401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133408 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133415 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133425 */     // GIR_Coverage, 19770,
     /* 133425 */     GIR_EraseRootFromParent_Done,
     /* 133426 */   // Label 2910: @133426
     /* 133426 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(133463), // Rule ID 4472 //
     /* 133431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133450 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src0)  =>  (VMOVAPSZ128rrk:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1)
     /* 133450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rrk),
     /* 133453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133455 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 133457 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133459 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 133461 */     GIR_RootConstrainSelectedInstOperands,
     /* 133462 */     // GIR_Coverage, 4472,
     /* 133462 */     GIR_EraseRootFromParent_Done,
     /* 133463 */   // Label 2911: @133463
     /* 133463 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(133500), // Rule ID 4529 //
     /* 133468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133487 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src0)  =>  (VMOVDQA32Z128rrk:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1)
     /* 133487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z128rrk),
     /* 133490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133492 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 133494 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133496 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 133498 */     GIR_RootConstrainSelectedInstOperands,
     /* 133499 */     // GIR_Coverage, 4529,
     /* 133499 */     GIR_EraseRootFromParent_Done,
     /* 133500 */   // Label 2912: @133500
     /* 133500 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(133693), // Rule ID 19767 //
     /* 133505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133524 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4f32] } (VMOVAPSZrrk:{ *:[v16f32] } (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133524 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 133527 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133531 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 133538 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 133541 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133545 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133550 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 133553 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133557 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 133560 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133565 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133570 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133575 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 133578 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133582 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133587 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133591 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 133596 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 133599 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133603 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133610 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 133613 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133617 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133622 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 133625 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 133629 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 133632 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133637 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133642 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 133650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 133654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133659 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133662 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 133665 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 133668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133675 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133687 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133692 */     // GIR_Coverage, 19767,
     /* 133692 */     GIR_EraseRootFromParent_Done,
     /* 133693 */   // Label 2913: @133693
     /* 133693 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(133886), // Rule ID 19769 //
     /* 133698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133717 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VMOVDQA32Zrrk:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133717 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 133720 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133724 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 133731 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 133734 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133738 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133743 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 133746 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133750 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 133753 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133758 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133763 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133768 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 133771 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133775 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133780 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133784 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 133789 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 133792 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133796 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133803 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 133806 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133810 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133815 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 133818 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 133822 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 133825 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133830 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133835 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 133843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 133847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133852 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133855 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 133858 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 133861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133868 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133885 */     // GIR_Coverage, 19769,
     /* 133885 */     GIR_EraseRootFromParent_Done,
     /* 133886 */   // Label 2914: @133886
     /* 133886 */   GIM_Reject,
     /* 133887 */ // Label 2906: @133887
     /* 133887 */ GIM_Reject,
     /* 133888 */ // Label 2886: @133888
     /* 133888 */ GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(134667),
     /* 133893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 133896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 133899 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 133902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 133906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 133914 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(133947), // Rule ID 4483 //
     /* 133919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133926 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133932 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133936 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src, immAllZerosV:{ *:[v4f64] })  =>  (VMOVAPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 133936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rrkz),
     /* 133939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133941 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133943 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 133945 */     GIR_RootConstrainSelectedInstOperands,
     /* 133946 */     // GIR_Coverage, 4483,
     /* 133946 */     GIR_EraseRootFromParent_Done,
     /* 133947 */   // Label 2916: @133947
     /* 133947 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(133980), // Rule ID 4537 //
     /* 133952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133959 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133965 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133969 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src, immAllZerosV:{ *:[v4i64] })  =>  (VMOVDQA64Z256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 133969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rrkz),
     /* 133972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133974 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133976 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 133978 */     GIR_RootConstrainSelectedInstOperands,
     /* 133979 */     // GIR_Coverage, 4537,
     /* 133979 */     GIR_EraseRootFromParent_Done,
     /* 133980 */   // Label 2917: @133980
     /* 133980 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(134117), // Rule ID 19780 //
     /* 133985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133992 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133998 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134002 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, immAllZerosV:{ *:[v4f64] })  =>  (EXTRACT_SUBREG:{ *:[v4f64] } (VMOVAPDZrrkz:{ *:[v8f64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 134002 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 134005 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134009 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134016 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 134019 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134023 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134028 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 134031 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134035 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 134038 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134043 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134048 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134053 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 134056 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134060 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134065 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134069 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 134077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 134081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134086 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134089 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 134092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134099 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 134106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134116 */     // GIR_Coverage, 19780,
     /* 134116 */     GIR_EraseRootFromParent_Done,
     /* 134117 */   // Label 2918: @134117
     /* 134117 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(134254), // Rule ID 19782 //
     /* 134122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134129 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134135 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134139 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, immAllZerosV:{ *:[v4i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 134139 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 134142 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134146 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134153 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 134156 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134160 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134165 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 134168 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134172 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 134175 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134180 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134185 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134190 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 134193 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134197 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134202 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134206 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 134214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 134218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134223 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134226 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 134229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134236 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 134243 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134253 */     // GIR_Coverage, 19782,
     /* 134253 */     GIR_EraseRootFromParent_Done,
     /* 134254 */   // Label 2919: @134254
     /* 134254 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(134279), // Rule ID 4485 //
     /* 134259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134266 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src0)  =>  (VMOVAPDZ256rrk:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1)
     /* 134266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rrk),
     /* 134269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134271 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 134273 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134275 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 134277 */     GIR_RootConstrainSelectedInstOperands,
     /* 134278 */     // GIR_Coverage, 4485,
     /* 134278 */     GIR_EraseRootFromParent_Done,
     /* 134279 */   // Label 2920: @134279
     /* 134279 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(134304), // Rule ID 4539 //
     /* 134284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134291 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src0)  =>  (VMOVDQA64Z256rrk:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1)
     /* 134291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rrk),
     /* 134294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134296 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 134298 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134300 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 134302 */     GIR_RootConstrainSelectedInstOperands,
     /* 134303 */     // GIR_Coverage, 4539,
     /* 134303 */     GIR_EraseRootFromParent_Done,
     /* 134304 */   // Label 2921: @134304
     /* 134304 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(134485), // Rule ID 19779 //
     /* 134309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134316 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4f64] } (VMOVAPDZrrk:{ *:[v8f64] } (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 134316 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 134319 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134323 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 134330 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 134333 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134337 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134342 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 134345 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134349 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 134352 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134357 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134362 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134367 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 134370 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134374 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134379 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134383 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134388 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 134391 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134395 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134402 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 134405 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134409 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134414 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 134417 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 134421 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 134424 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134429 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134434 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 134442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 134446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134451 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134454 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 134457 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 134460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134467 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 134474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134484 */     // GIR_Coverage, 19779,
     /* 134484 */     GIR_EraseRootFromParent_Done,
     /* 134485 */   // Label 2922: @134485
     /* 134485 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(134666), // Rule ID 19781 //
     /* 134490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134497 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VMOVDQA64Zrrk:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 134497 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 134500 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134504 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 134511 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 134514 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134518 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134523 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 134526 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134530 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 134533 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134538 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134543 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134548 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 134551 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134555 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134560 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134564 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134569 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 134572 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134576 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134583 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 134586 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134590 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134595 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 134598 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 134602 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 134605 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134610 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134615 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 134623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 134627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134632 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134635 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 134638 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 134641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134648 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 134655 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134665 */     // GIR_Coverage, 19781,
     /* 134665 */     GIR_EraseRootFromParent_Done,
     /* 134666 */   // Label 2923: @134666
     /* 134666 */   GIM_Reject,
     /* 134667 */ // Label 2915: @134667
     /* 134667 */ GIM_Reject,
     /* 134668 */ // Label 2887: @134668
     /* 134668 */ GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(135825),
     /* 134673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 134676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 134679 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 134682 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(134761), // Rule ID 19866 //
     /* 134687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 134690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 134702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 134706 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134709 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 134713 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 134717 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 134721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 134725 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134731 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 134733 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 134742 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, immAllZerosV:{ *:[v8f16] })  =>  (VMOVDQU16Z128rmkz:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 134742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmkz),
     /* 134745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134747 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134749 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 134753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 134759 */     GIR_RootConstrainSelectedInstOperands,
     /* 134760 */     // GIR_Coverage, 19866,
     /* 134760 */     GIR_EraseRootFromParent_Done,
     /* 134761 */   // Label 2925: @134761
     /* 134761 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(134836), // Rule ID 19868 //
     /* 134766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 134769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 134781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 134785 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134788 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 134792 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 134796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 134800 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134806 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 134808 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 134817 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, immAllZerosV:{ *:[v8f16] })  =>  (VMOVDQU16Z128rmkz:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 134817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmkz),
     /* 134820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134822 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134824 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 134828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 134834 */     GIR_RootConstrainSelectedInstOperands,
     /* 134835 */     // GIR_Coverage, 19868,
     /* 134835 */     GIR_EraseRootFromParent_Done,
     /* 134836 */   // Label 2926: @134836
     /* 134836 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(134908), // Rule ID 19865 //
     /* 134841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 134844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 134856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 134860 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134863 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 134867 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 134871 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 134875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 134888 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, VR128X:{ *:[v8f16] }:$src0)  =>  (VMOVDQU16Z128rmk:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 134888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmk),
     /* 134891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134893 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 134895 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134897 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 134901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134906 */     GIR_RootConstrainSelectedInstOperands,
     /* 134907 */     // GIR_Coverage, 19865,
     /* 134907 */     GIR_EraseRootFromParent_Done,
     /* 134908 */   // Label 2927: @134908
     /* 134908 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(134976), // Rule ID 19867 //
     /* 134913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 134916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 134928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 134932 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134935 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 134939 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 134943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 134956 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src0)  =>  (VMOVDQU16Z128rmk:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 134956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmk),
     /* 134959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134961 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 134963 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134965 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 134969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134974 */     GIR_RootConstrainSelectedInstOperands,
     /* 134975 */     // GIR_Coverage, 19867,
     /* 134975 */     GIR_EraseRootFromParent_Done,
     /* 134976 */   // Label 2928: @134976
     /* 134976 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(135021), // Rule ID 4570 //
     /* 134981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 134984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135000 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135006 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135010 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src, immAllZerosV:{ *:[v8i16] })  =>  (VMOVDQU16Z128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 135010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrkz),
     /* 135013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135015 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135017 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 135019 */     GIR_RootConstrainSelectedInstOperands,
     /* 135020 */     // GIR_Coverage, 4570,
     /* 135020 */     GIR_EraseRootFromParent_Done,
     /* 135021 */   // Label 2929: @135021
     /* 135021 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(135170), // Rule ID 19788 //
     /* 135026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 135029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 135033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135045 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135051 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135055 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, immAllZerosV:{ *:[v8i16] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VMOVDQU16Zrrkz:{ *:[v32i16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 135055 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 135058 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135062 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135069 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 135072 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135076 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135081 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 135084 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135088 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 135091 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135096 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135101 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 135106 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 135109 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135113 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135118 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 135127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 135130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 135134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135139 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 135142 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 135145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 135147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135152 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 135159 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 135164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135169 */     // GIR_Coverage, 19788,
     /* 135169 */     GIR_EraseRootFromParent_Done,
     /* 135170 */   // Label 2930: @135170
     /* 135170 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(135319), // Rule ID 19792 //
     /* 135175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 135178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 135182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135194 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135200 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135204 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, immAllZerosV:{ *:[v8f16] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } (VMOVDQU16Zrrkz:{ *:[v32f16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 135204 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 135207 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135211 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135218 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 135221 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135225 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135230 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 135233 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135237 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 135240 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135245 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135250 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 135255 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 135258 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135262 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135267 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135271 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 135276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 135279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 135283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135288 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 135291 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 135294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 135296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135301 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 135308 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 135313 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135318 */     // GIR_Coverage, 19792,
     /* 135318 */     GIR_EraseRootFromParent_Done,
     /* 135319 */   // Label 2931: @135319
     /* 135319 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(135364), // Rule ID 19864 //
     /* 135324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135343 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135349 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135353 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, immAllZerosV:{ *:[v8f16] })  =>  (VMOVDQU16Z128rrkz:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1)
     /* 135353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrkz),
     /* 135356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135358 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135360 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 135362 */     GIR_RootConstrainSelectedInstOperands,
     /* 135363 */     // GIR_Coverage, 19864,
     /* 135363 */     GIR_EraseRootFromParent_Done,
     /* 135364 */   // Label 2932: @135364
     /* 135364 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(135401), // Rule ID 4571 //
     /* 135369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135388 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src0)  =>  (VMOVDQU16Z128rrk:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1)
     /* 135388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrk),
     /* 135391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135393 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 135395 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135397 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 135399 */     GIR_RootConstrainSelectedInstOperands,
     /* 135400 */     // GIR_Coverage, 4571,
     /* 135400 */     GIR_EraseRootFromParent_Done,
     /* 135401 */   // Label 2933: @135401
     /* 135401 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(135594), // Rule ID 19787 //
     /* 135406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 135409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 135413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135425 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VMOVDQU16Zrrk:{ *:[v32i16] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 135425 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 135428 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135432 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 135439 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 135442 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135446 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135451 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 135454 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135458 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 135461 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135466 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135471 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 135476 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 135479 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135483 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135488 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135492 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 135497 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 135500 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135504 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 135511 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 135514 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135518 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135523 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 135526 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 135530 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 135533 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135538 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135543 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 135548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 135551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 135555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135560 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 135563 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 135566 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 135569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 135571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135576 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 135583 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 135588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135593 */     // GIR_Coverage, 19787,
     /* 135593 */     GIR_EraseRootFromParent_Done,
     /* 135594 */   // Label 2934: @135594
     /* 135594 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(135787), // Rule ID 19791 //
     /* 135599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 135602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 135606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135618 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8f16] } (VMOVDQU16Zrrk:{ *:[v32f16] } (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 135618 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 135621 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135625 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 135632 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 135635 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135639 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135644 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 135647 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135651 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 135654 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135659 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135664 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 135669 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 135672 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135676 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135681 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135685 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 135690 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 135693 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135697 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 135704 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 135707 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135711 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135716 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 135719 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 135723 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 135726 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135731 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135736 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 135741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 135744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 135748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135753 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 135756 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 135759 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 135762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 135764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135769 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 135776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 135781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135786 */     // GIR_Coverage, 19791,
     /* 135786 */     GIR_EraseRootFromParent_Done,
     /* 135787 */   // Label 2935: @135787
     /* 135787 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(135824), // Rule ID 19863 //
     /* 135792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135811 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src0)  =>  (VMOVDQU16Z128rrk:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1)
     /* 135811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrk),
     /* 135814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135816 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 135818 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135820 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 135822 */     GIR_RootConstrainSelectedInstOperands,
     /* 135823 */     // GIR_Coverage, 19863,
     /* 135823 */     GIR_EraseRootFromParent_Done,
     /* 135824 */   // Label 2936: @135824
     /* 135824 */   GIM_Reject,
     /* 135825 */ // Label 2924: @135825
     /* 135825 */ GIM_Reject,
     /* 135826 */ // Label 2888: @135826
     /* 135826 */ GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(136605),
     /* 135831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 135834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 135837 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 135840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 135844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135848 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 135852 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(135885), // Rule ID 4465 //
     /* 135857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 135860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135864 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135870 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135874 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src, immAllZerosV:{ *:[v8f32] })  =>  (VMOVAPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 135874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rrkz),
     /* 135877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135879 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135881 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 135883 */     GIR_RootConstrainSelectedInstOperands,
     /* 135884 */     // GIR_Coverage, 4465,
     /* 135884 */     GIR_EraseRootFromParent_Done,
     /* 135885 */   // Label 2938: @135885
     /* 135885 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(135918), // Rule ID 4524 //
     /* 135890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 135893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135897 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135903 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135907 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src, immAllZerosV:{ *:[v8i32] })  =>  (VMOVDQA32Z256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 135907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z256rrkz),
     /* 135910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135912 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135914 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 135916 */     GIR_RootConstrainSelectedInstOperands,
     /* 135917 */     // GIR_Coverage, 4524,
     /* 135917 */     GIR_EraseRootFromParent_Done,
     /* 135918 */   // Label 2939: @135918
     /* 135918 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(136055), // Rule ID 19772 //
     /* 135923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 135926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135930 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135936 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135940 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, immAllZerosV:{ *:[v8f32] })  =>  (EXTRACT_SUBREG:{ *:[v8f32] } (VMOVAPSZrrkz:{ *:[v16f32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 135940 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 135943 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135947 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135954 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 135957 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135961 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135966 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 135969 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135973 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 135976 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135981 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135986 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135991 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 135994 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135998 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136003 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136007 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 136012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 136015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 136019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136024 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136027 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 136030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136037 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 136044 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136054 */     // GIR_Coverage, 19772,
     /* 136054 */     GIR_EraseRootFromParent_Done,
     /* 136055 */   // Label 2940: @136055
     /* 136055 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(136192), // Rule ID 19774 //
     /* 136060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 136063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136067 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136073 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136077 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, immAllZerosV:{ *:[v8i32] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VMOVDQA32Zrrkz:{ *:[v16i32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 136077 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 136080 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136084 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136091 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 136094 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136098 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136103 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 136106 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136110 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 136113 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136118 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136123 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136128 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 136131 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136135 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136140 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136144 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 136149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 136152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 136156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136161 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136164 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 136167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136174 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 136181 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136186 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136191 */     // GIR_Coverage, 19774,
     /* 136191 */     GIR_EraseRootFromParent_Done,
     /* 136192 */   // Label 2941: @136192
     /* 136192 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(136217), // Rule ID 4467 //
     /* 136197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136204 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src0)  =>  (VMOVAPSZ256rrk:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1)
     /* 136204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rrk),
     /* 136207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136209 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136211 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136213 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136215 */     GIR_RootConstrainSelectedInstOperands,
     /* 136216 */     // GIR_Coverage, 4467,
     /* 136216 */     GIR_EraseRootFromParent_Done,
     /* 136217 */   // Label 2942: @136217
     /* 136217 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(136242), // Rule ID 4525 //
     /* 136222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136229 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src0)  =>  (VMOVDQA32Z256rrk:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1)
     /* 136229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z256rrk),
     /* 136232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136234 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136236 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136238 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136240 */     GIR_RootConstrainSelectedInstOperands,
     /* 136241 */     // GIR_Coverage, 4525,
     /* 136241 */     GIR_EraseRootFromParent_Done,
     /* 136242 */   // Label 2943: @136242
     /* 136242 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(136423), // Rule ID 19771 //
     /* 136247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 136250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136254 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8f32] } (VMOVAPSZrrk:{ *:[v16f32] } (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 136254 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 136257 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136261 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 136268 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 136271 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136275 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136280 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 136283 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136287 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 136290 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136295 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136300 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136305 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 136308 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136312 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136317 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136321 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 136326 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 136329 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136333 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136340 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 136343 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136347 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136352 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 136355 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 136359 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 136362 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136367 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136372 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 136380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 136384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136389 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136392 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 136395 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 136398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136405 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 136412 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136417 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136422 */     // GIR_Coverage, 19771,
     /* 136422 */     GIR_EraseRootFromParent_Done,
     /* 136423 */   // Label 2944: @136423
     /* 136423 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(136604), // Rule ID 19773 //
     /* 136428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 136431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136435 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VMOVDQA32Zrrk:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 136435 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 136438 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136442 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 136449 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 136452 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136456 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136461 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 136464 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136468 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 136471 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136476 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136481 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136486 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 136489 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136493 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136498 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136502 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 136507 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 136510 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136514 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136521 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 136524 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136528 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136533 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 136536 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 136540 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 136543 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136548 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136553 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 136561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 136565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136570 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136573 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 136576 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 136579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136586 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 136593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136598 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136603 */     // GIR_Coverage, 19773,
     /* 136603 */     GIR_EraseRootFromParent_Done,
     /* 136604 */   // Label 2945: @136604
     /* 136604 */   GIM_Reject,
     /* 136605 */ // Label 2937: @136605
     /* 136605 */ GIM_Reject,
     /* 136606 */ // Label 2889: @136606
     /* 136606 */ GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(136986),
     /* 136611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 136614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 136617 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 136620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 136624 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(136693), // Rule ID 19765 //
     /* 136629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 136637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 136641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 136645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 136650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 136654 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136660 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 136662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 136666 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136672 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /* 136674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 136678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 136680 */     // (vselect:{ *:[v8i64] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$mask, immAllOnesV:{ *:[v8i1] }), immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src)  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } VK8:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 136680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 136683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // mask
     /* 136689 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 136691 */     GIR_RootConstrainSelectedInstOperands,
     /* 136692 */     // GIR_Coverage, 19765,
     /* 136692 */     GIR_EraseRootFromParent_Done,
     /* 136693 */   // Label 2947: @136693
     /* 136693 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(136740), // Rule ID 3598 //
     /* 136698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 136701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 136709 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136715 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 136717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 136721 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136727 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 136729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 136731 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, immAllOnesV:{ *:[v8i64] }, immAllZerosV:{ *:[v8i64] })  =>  (AVX512_512_SEXT_MASK_64:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask)
     /* 136731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AVX512_512_SEXT_MASK_64),
     /* 136734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136736 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136738 */     GIR_RootConstrainSelectedInstOperands,
     /* 136739 */     // GIR_Coverage, 3598,
     /* 136739 */     GIR_EraseRootFromParent_Done,
     /* 136740 */   // Label 2948: @136740
     /* 136740 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(136837), // Rule ID 19763 //
     /* 136745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 136753 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136759 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 136765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136767 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src)  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$mask, VK16:{ *:[i32] })), VK8:{ *:[i32] }), VR512:{ *:[v8i64] }:$src)
     /* 136767 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 136770 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136774 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136779 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136783 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 136788 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 136791 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 136795 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136800 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 136803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 136808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136817 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 136825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 136828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136833 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 136835 */     GIR_RootConstrainSelectedInstOperands,
     /* 136836 */     // GIR_Coverage, 19763,
     /* 136836 */     GIR_EraseRootFromParent_Done,
     /* 136837 */   // Label 2949: @136837
     /* 136837 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(136878), // Rule ID 4478 //
     /* 136842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 136845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 136853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136857 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136863 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136867 */     // (vselect:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src, immAllZerosV:{ *:[v8f64] })  =>  (VMOVAPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 136867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 136870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136872 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136874 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 136876 */     GIR_RootConstrainSelectedInstOperands,
     /* 136877 */     // GIR_Coverage, 4478,
     /* 136877 */     GIR_EraseRootFromParent_Done,
     /* 136878 */   // Label 2950: @136878
     /* 136878 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(136919), // Rule ID 4532 //
     /* 136883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 136886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 136894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136898 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136904 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136908 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src, immAllZerosV:{ *:[v8i64] })  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 136908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 136911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136913 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136915 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 136917 */     GIR_RootConstrainSelectedInstOperands,
     /* 136918 */     // GIR_Coverage, 4532,
     /* 136918 */     GIR_EraseRootFromParent_Done,
     /* 136919 */   // Label 2951: @136919
     /* 136919 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(136952), // Rule ID 4480 //
     /* 136924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 136927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 136935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 136939 */     // (vselect:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src0)  =>  (VMOVAPDZrrk:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src1)
     /* 136939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 136942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136944 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136946 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136948 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136950 */     GIR_RootConstrainSelectedInstOperands,
     /* 136951 */     // GIR_Coverage, 4480,
     /* 136951 */     GIR_EraseRootFromParent_Done,
     /* 136952 */   // Label 2952: @136952
     /* 136952 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(136985), // Rule ID 4534 //
     /* 136957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 136960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 136968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 136972 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src0)  =>  (VMOVDQA64Zrrk:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src1)
     /* 136972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 136975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136977 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136979 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136981 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136983 */     GIR_RootConstrainSelectedInstOperands,
     /* 136984 */     // GIR_Coverage, 4534,
     /* 136984 */     GIR_EraseRootFromParent_Done,
     /* 136985 */   // Label 2953: @136985
     /* 136985 */   GIM_Reject,
     /* 136986 */ // Label 2946: @136986
     /* 136986 */ GIM_Reject,
     /* 136987 */ // Label 2890: @136987
     /* 136987 */ GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(137426),
     /* 136992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 136995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 136998 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 137001 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(137046), // Rule ID 4558 //
     /* 137006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 137009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137025 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137031 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137035 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src, immAllZerosV:{ *:[v16i8] })  =>  (VMOVDQU8Z128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 137035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z128rrkz),
     /* 137038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137040 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137042 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 137044 */     GIR_RootConstrainSelectedInstOperands,
     /* 137045 */     // GIR_Coverage, 4558,
     /* 137045 */     GIR_EraseRootFromParent_Done,
     /* 137046 */   // Label 2955: @137046
     /* 137046 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(137195), // Rule ID 19784 //
     /* 137051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 137054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 137058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137070 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137076 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137080 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, immAllZerosV:{ *:[v16i8] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VMOVDQU8Zrrkz:{ *:[v64i8] } (COPY_TO_REGCLASS:{ *:[v64i1] } VK16WM:{ *:[v16i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 137080 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s8,
     /* 137083 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137087 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137094 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 137097 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137101 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137106 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 137109 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 137113 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 137116 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137121 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137126 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 137131 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s1,
     /* 137134 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137138 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137143 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137147 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 137152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 137155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 137159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137164 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137167 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 137170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 137172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137177 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 137184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 137189 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137194 */     // GIR_Coverage, 19784,
     /* 137194 */     GIR_EraseRootFromParent_Done,
     /* 137195 */   // Label 2956: @137195
     /* 137195 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(137232), // Rule ID 4559 //
     /* 137200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 137203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137219 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src0)  =>  (VMOVDQU8Z128rrk:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1)
     /* 137219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z128rrk),
     /* 137222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137224 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 137226 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137228 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 137230 */     GIR_RootConstrainSelectedInstOperands,
     /* 137231 */     // GIR_Coverage, 4559,
     /* 137231 */     GIR_EraseRootFromParent_Done,
     /* 137232 */   // Label 2957: @137232
     /* 137232 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(137425), // Rule ID 19783 //
     /* 137237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 137240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 137244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137256 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VMOVDQU8Zrrk:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v64i1] } VK16WM:{ *:[v16i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 137256 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v64s8,
     /* 137259 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137263 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 137270 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v64s8,
     /* 137273 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137277 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137282 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 137285 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 137289 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 137292 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137297 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137302 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 137307 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s1,
     /* 137310 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137314 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137319 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137323 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 137328 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 137331 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137335 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137342 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 137345 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137349 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137354 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 137357 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 137361 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 137364 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137369 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137374 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 137379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 137382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 137386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137391 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137394 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 137397 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 137400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 137402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137407 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 137414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 137419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137424 */     // GIR_Coverage, 19783,
     /* 137424 */     GIR_EraseRootFromParent_Done,
     /* 137425 */   // Label 2958: @137425
     /* 137425 */   GIM_Reject,
     /* 137426 */ // Label 2954: @137426
     /* 137426 */ GIM_Reject,
     /* 137427 */ // Label 2891: @137427
     /* 137427 */ GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(138496),
     /* 137432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 137435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 137438 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 137441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 137445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137449 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(137520), // Rule ID 19856 //
     /* 137454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 137457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 137461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 137465 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137468 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 137472 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 137476 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 137480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 137484 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137490 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 137492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 137494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 137501 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, immAllZerosV:{ *:[v16f16] })  =>  (VMOVDQU16Z256rmkz:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 137501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmkz),
     /* 137504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137506 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137508 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 137512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 137518 */     GIR_RootConstrainSelectedInstOperands,
     /* 137519 */     // GIR_Coverage, 19856,
     /* 137519 */     GIR_EraseRootFromParent_Done,
     /* 137520 */   // Label 2960: @137520
     /* 137520 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(137587), // Rule ID 19858 //
     /* 137525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 137528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 137532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 137536 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137539 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 137543 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 137547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 137551 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137557 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 137559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 137561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 137568 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, immAllZerosV:{ *:[v16f16] })  =>  (VMOVDQU16Z256rmkz:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 137568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmkz),
     /* 137571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137573 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137575 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 137579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 137585 */     GIR_RootConstrainSelectedInstOperands,
     /* 137586 */     // GIR_Coverage, 19858,
     /* 137586 */     GIR_EraseRootFromParent_Done,
     /* 137587 */   // Label 2961: @137587
     /* 137587 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(137651), // Rule ID 19855 //
     /* 137592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 137595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 137599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 137603 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137606 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 137610 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 137614 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 137618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 137622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 137631 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, VR256X:{ *:[v16f16] }:$src0)  =>  (VMOVDQU16Z256rmk:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 137631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmk),
     /* 137634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137636 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 137638 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137640 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 137644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 137649 */     GIR_RootConstrainSelectedInstOperands,
     /* 137650 */     // GIR_Coverage, 19855,
     /* 137650 */     GIR_EraseRootFromParent_Done,
     /* 137651 */   // Label 2962: @137651
     /* 137651 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(137711), // Rule ID 19857 //
     /* 137656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 137659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 137663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 137667 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137670 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 137674 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 137678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 137682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137684 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 137691 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src0)  =>  (VMOVDQU16Z256rmk:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 137691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmk),
     /* 137694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137696 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 137698 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137700 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 137704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 137709 */     GIR_RootConstrainSelectedInstOperands,
     /* 137710 */     // GIR_Coverage, 19857,
     /* 137710 */     GIR_EraseRootFromParent_Done,
     /* 137711 */   // Label 2963: @137711
     /* 137711 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(137748), // Rule ID 4566 //
     /* 137716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 137719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 137723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137727 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137733 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137737 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src, immAllZerosV:{ *:[v16i16] })  =>  (VMOVDQU16Z256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 137737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrkz),
     /* 137740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137742 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137744 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 137746 */     GIR_RootConstrainSelectedInstOperands,
     /* 137747 */     // GIR_Coverage, 4566,
     /* 137747 */     GIR_EraseRootFromParent_Done,
     /* 137748 */   // Label 2964: @137748
     /* 137748 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(137889), // Rule ID 19790 //
     /* 137753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 137756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 137760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137764 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137770 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137774 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, immAllZerosV:{ *:[v16i16] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VMOVDQU16Zrrkz:{ *:[v32i16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 137774 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 137777 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137781 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137788 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 137791 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137795 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137800 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 137803 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 137807 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 137810 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137815 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137820 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137825 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 137828 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137832 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137837 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137841 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 137846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 137849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 137853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137858 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137861 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 137864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 137866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137871 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 137878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137888 */     // GIR_Coverage, 19790,
     /* 137888 */     GIR_EraseRootFromParent_Done,
     /* 137889 */   // Label 2965: @137889
     /* 137889 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(138030), // Rule ID 19794 //
     /* 137894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 137897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 137901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137905 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137911 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137915 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, immAllZerosV:{ *:[v16f16] })  =>  (EXTRACT_SUBREG:{ *:[v16f16] } (VMOVDQU16Zrrkz:{ *:[v32f16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 137915 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 137918 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137922 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137929 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 137932 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137936 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137941 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 137944 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 137948 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 137951 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137956 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137961 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137966 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 137969 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137973 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137978 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137982 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 137987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 137990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 137994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137999 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138002 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 138005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138012 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 138019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138029 */     // GIR_Coverage, 19794,
     /* 138029 */     GIR_EraseRootFromParent_Done,
     /* 138030 */   // Label 2966: @138030
     /* 138030 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(138067), // Rule ID 19854 //
     /* 138035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138046 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138052 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138056 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, immAllZerosV:{ *:[v16f16] })  =>  (VMOVDQU16Z256rrkz:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1)
     /* 138056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrkz),
     /* 138059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138061 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138063 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 138065 */     GIR_RootConstrainSelectedInstOperands,
     /* 138066 */     // GIR_Coverage, 19854,
     /* 138066 */     GIR_EraseRootFromParent_Done,
     /* 138067 */   // Label 2967: @138067
     /* 138067 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(138096), // Rule ID 4567 //
     /* 138072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138083 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src0)  =>  (VMOVDQU16Z256rrk:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1)
     /* 138083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrk),
     /* 138086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138088 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138090 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138092 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 138094 */     GIR_RootConstrainSelectedInstOperands,
     /* 138095 */     // GIR_Coverage, 4567,
     /* 138095 */     GIR_EraseRootFromParent_Done,
     /* 138096 */   // Label 2968: @138096
     /* 138096 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(138281), // Rule ID 19789 //
     /* 138101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138112 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VMOVDQU16Zrrk:{ *:[v32i16] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 138112 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 138115 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138119 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 138126 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 138129 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138133 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138138 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 138141 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138145 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 138148 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138153 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138158 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138163 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 138166 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138170 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138175 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138179 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 138184 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 138187 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138191 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138198 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 138201 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138205 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138210 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 138213 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 138217 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 138220 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138225 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138230 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 138238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 138242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138247 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138250 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 138253 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 138256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138263 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 138270 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138280 */     // GIR_Coverage, 19789,
     /* 138280 */     GIR_EraseRootFromParent_Done,
     /* 138281 */   // Label 2969: @138281
     /* 138281 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(138466), // Rule ID 19793 //
     /* 138286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138297 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16f16] } (VMOVDQU16Zrrk:{ *:[v32f16] } (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 138297 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 138300 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138304 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 138311 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 138314 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138318 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138323 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 138326 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138330 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 138333 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138338 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138343 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138348 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 138351 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138355 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138360 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138364 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 138369 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 138372 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138376 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138383 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 138386 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138390 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138395 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 138398 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 138402 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 138405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138410 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138415 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 138423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 138427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138432 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138435 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 138438 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 138441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138448 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 138455 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138465 */     // GIR_Coverage, 19793,
     /* 138465 */     GIR_EraseRootFromParent_Done,
     /* 138466 */   // Label 2970: @138466
     /* 138466 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(138495), // Rule ID 19853 //
     /* 138471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138482 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src0)  =>  (VMOVDQU16Z256rrk:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1)
     /* 138482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrk),
     /* 138485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138487 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138489 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138491 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 138493 */     GIR_RootConstrainSelectedInstOperands,
     /* 138494 */     // GIR_Coverage, 19853,
     /* 138494 */     GIR_EraseRootFromParent_Done,
     /* 138495 */   // Label 2971: @138495
     /* 138495 */   GIM_Reject,
     /* 138496 */ // Label 2959: @138496
     /* 138496 */ GIM_Reject,
     /* 138497 */ // Label 2892: @138497
     /* 138497 */ GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(138837),
     /* 138502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 138505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 138508 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 138511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 138515 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(138584), // Rule ID 19766 //
     /* 138520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 138528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 138532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 138536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 138541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 138545 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138551 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 138553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 138557 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138563 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /* 138565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 138569 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 138571 */     // (vselect:{ *:[v16i32] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$mask, immAllOnesV:{ *:[v16i1] }), immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src)  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 138571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 138574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // mask
     /* 138580 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 138582 */     GIR_RootConstrainSelectedInstOperands,
     /* 138583 */     // GIR_Coverage, 19766,
     /* 138583 */     GIR_EraseRootFromParent_Done,
     /* 138584 */   // Label 2973: @138584
     /* 138584 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(138631), // Rule ID 3597 //
     /* 138589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 138592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 138596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138600 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138606 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 138608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 138612 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138618 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 138620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 138622 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, immAllOnesV:{ *:[v16i32] }, immAllZerosV:{ *:[v16i32] })  =>  (AVX512_512_SEXT_MASK_32:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask)
     /* 138622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AVX512_512_SEXT_MASK_32),
     /* 138625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138627 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138629 */     GIR_RootConstrainSelectedInstOperands,
     /* 138630 */     // GIR_Coverage, 3597,
     /* 138630 */     GIR_EraseRootFromParent_Done,
     /* 138631 */   // Label 2974: @138631
     /* 138631 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(138688), // Rule ID 19764 //
     /* 138636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 138640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138644 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138650 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 138656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138658 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src)  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } (KNOTWkk:{ *:[v16i1] } VK16WM:{ *:[v16i1] }:$mask), VR512:{ *:[v16i32] }:$src)
     /* 138658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 138661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 138665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138670 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 138679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138684 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 138686 */     GIR_RootConstrainSelectedInstOperands,
     /* 138687 */     // GIR_Coverage, 19764,
     /* 138687 */     GIR_EraseRootFromParent_Done,
     /* 138688 */   // Label 2975: @138688
     /* 138688 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(138729), // Rule ID 4460 //
     /* 138693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 138696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 138700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 138704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138708 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138714 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138718 */     // (vselect:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src, immAllZerosV:{ *:[v16f32] })  =>  (VMOVAPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 138718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 138721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138723 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138725 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 138727 */     GIR_RootConstrainSelectedInstOperands,
     /* 138728 */     // GIR_Coverage, 4460,
     /* 138728 */     GIR_EraseRootFromParent_Done,
     /* 138729 */   // Label 2976: @138729
     /* 138729 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(138770), // Rule ID 4520 //
     /* 138734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 138737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 138741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 138745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138749 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138755 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138759 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src, immAllZerosV:{ *:[v16i32] })  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 138759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 138762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138764 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138766 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 138768 */     GIR_RootConstrainSelectedInstOperands,
     /* 138769 */     // GIR_Coverage, 4520,
     /* 138769 */     GIR_EraseRootFromParent_Done,
     /* 138770 */   // Label 2977: @138770
     /* 138770 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(138803), // Rule ID 4462 //
     /* 138775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 138778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 138782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 138786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 138790 */     // (vselect:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src0)  =>  (VMOVAPSZrrk:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src1)
     /* 138790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 138793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138795 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138797 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138799 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 138801 */     GIR_RootConstrainSelectedInstOperands,
     /* 138802 */     // GIR_Coverage, 4462,
     /* 138802 */     GIR_EraseRootFromParent_Done,
     /* 138803 */   // Label 2978: @138803
     /* 138803 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(138836), // Rule ID 4521 //
     /* 138808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 138811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 138815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 138819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 138823 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src0)  =>  (VMOVDQA32Zrrk:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src1)
     /* 138823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 138826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138828 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138830 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138832 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 138834 */     GIR_RootConstrainSelectedInstOperands,
     /* 138835 */     // GIR_Coverage, 4521,
     /* 138835 */     GIR_EraseRootFromParent_Done,
     /* 138836 */   // Label 2979: @138836
     /* 138836 */   GIM_Reject,
     /* 138837 */ // Label 2972: @138837
     /* 138837 */ GIM_Reject,
     /* 138838 */ // Label 2893: @138838
     /* 138838 */ GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(139241),
     /* 138843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 138846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 138849 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 138852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 138860 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138864 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(138897), // Rule ID 4554 //
     /* 138869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138876 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138882 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138886 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src, immAllZerosV:{ *:[v32i8] })  =>  (VMOVDQU8Z256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 138886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z256rrkz),
     /* 138889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138891 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138893 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 138895 */     GIR_RootConstrainSelectedInstOperands,
     /* 138896 */     // GIR_Coverage, 4554,
     /* 138896 */     GIR_EraseRootFromParent_Done,
     /* 138897 */   // Label 2981: @138897
     /* 138897 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(139034), // Rule ID 19786 //
     /* 138902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138909 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138915 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138919 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, immAllZerosV:{ *:[v32i8] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VMOVDQU8Zrrkz:{ *:[v64i8] } (COPY_TO_REGCLASS:{ *:[v64i1] } VK32WM:{ *:[v32i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 138919 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s8,
     /* 138922 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138926 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138933 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 138936 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138940 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138945 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 138948 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138952 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 138955 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138960 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138965 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138970 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s1,
     /* 138973 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138977 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138982 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138986 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 138991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 138994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 138998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139003 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 139006 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 139009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139016 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 139023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139033 */     // GIR_Coverage, 19786,
     /* 139033 */     GIR_EraseRootFromParent_Done,
     /* 139034 */   // Label 2982: @139034
     /* 139034 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(139059), // Rule ID 4555 //
     /* 139039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 139042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139046 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src0)  =>  (VMOVDQU8Z256rrk:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1)
     /* 139046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z256rrk),
     /* 139049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139051 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139053 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139055 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139057 */     GIR_RootConstrainSelectedInstOperands,
     /* 139058 */     // GIR_Coverage, 4555,
     /* 139058 */     GIR_EraseRootFromParent_Done,
     /* 139059 */   // Label 2983: @139059
     /* 139059 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(139240), // Rule ID 19785 //
     /* 139064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 139067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139071 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VMOVDQU8Zrrk:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v64i1] } VK32WM:{ *:[v32i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 139071 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v64s8,
     /* 139074 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139078 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 139085 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v64s8,
     /* 139088 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139092 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139097 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 139100 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 139104 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 139107 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139112 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139117 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139122 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s1,
     /* 139125 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139129 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139134 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 139138 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 139143 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 139146 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139150 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139157 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 139160 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139164 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139169 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 139172 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 139176 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 139179 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139184 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139189 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 139197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 139201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139206 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 139209 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 139212 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 139215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139222 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 139229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139239 */     // GIR_Coverage, 19785,
     /* 139239 */     GIR_EraseRootFromParent_Done,
     /* 139240 */   // Label 2984: @139240
     /* 139240 */   GIM_Reject,
     /* 139241 */ // Label 2980: @139241
     /* 139241 */ GIM_Reject,
     /* 139242 */ // Label 2894: @139242
     /* 139242 */ GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(139659),
     /* 139247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 139250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 139253 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 139256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 139264 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(139335), // Rule ID 19846 //
     /* 139269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 139272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 139280 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139283 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 139287 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 139291 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 139295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 139299 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139305 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 139307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 139309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 139316 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, immAllZerosV:{ *:[v32f16] })  =>  (VMOVDQU16Zrmkz:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 139316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmkz),
     /* 139319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139321 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139323 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 139327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 139333 */     GIR_RootConstrainSelectedInstOperands,
     /* 139334 */     // GIR_Coverage, 19846,
     /* 139334 */     GIR_EraseRootFromParent_Done,
     /* 139335 */   // Label 2986: @139335
     /* 139335 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(139402), // Rule ID 19848 //
     /* 139340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 139343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 139351 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139354 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 139358 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 139362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 139366 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139372 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 139374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 139376 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 139383 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, immAllZerosV:{ *:[v32f16] })  =>  (VMOVDQU16Zrmkz:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 139383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmkz),
     /* 139386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139388 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139390 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 139394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 139400 */     GIR_RootConstrainSelectedInstOperands,
     /* 139401 */     // GIR_Coverage, 19848,
     /* 139401 */     GIR_EraseRootFromParent_Done,
     /* 139402 */   // Label 2987: @139402
     /* 139402 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(139466), // Rule ID 19845 //
     /* 139407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 139410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 139418 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139421 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 139425 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 139429 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 139433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139439 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 139446 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, VR512:{ *:[v32f16] }:$src0)  =>  (VMOVDQU16Zrmk:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 139446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmk),
     /* 139449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139451 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139453 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139455 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 139459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 139464 */     GIR_RootConstrainSelectedInstOperands,
     /* 139465 */     // GIR_Coverage, 19845,
     /* 139465 */     GIR_EraseRootFromParent_Done,
     /* 139466 */   // Label 2988: @139466
     /* 139466 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(139526), // Rule ID 19847 //
     /* 139471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 139474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 139482 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139485 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 139489 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 139493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 139506 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src0)  =>  (VMOVDQU16Zrmk:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 139506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmk),
     /* 139509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139511 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139513 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139515 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 139519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 139524 */     GIR_RootConstrainSelectedInstOperands,
     /* 139525 */     // GIR_Coverage, 19847,
     /* 139525 */     GIR_EraseRootFromParent_Done,
     /* 139526 */   // Label 2989: @139526
     /* 139526 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(139563), // Rule ID 4562 //
     /* 139531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 139534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139542 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139548 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139552 */     // (vselect:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src, immAllZerosV:{ *:[v32i16] })  =>  (VMOVDQU16Zrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 139552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 139555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139557 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139559 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 139561 */     GIR_RootConstrainSelectedInstOperands,
     /* 139562 */     // GIR_Coverage, 4562,
     /* 139562 */     GIR_EraseRootFromParent_Done,
     /* 139563 */   // Label 2990: @139563
     /* 139563 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(139600), // Rule ID 19844 //
     /* 139568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 139571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139579 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139585 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139589 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1, immAllZerosV:{ *:[v32f16] })  =>  (VMOVDQU16Zrrkz:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1)
     /* 139589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 139592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139594 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139596 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139598 */     GIR_RootConstrainSelectedInstOperands,
     /* 139599 */     // GIR_Coverage, 19844,
     /* 139599 */     GIR_EraseRootFromParent_Done,
     /* 139600 */   // Label 2991: @139600
     /* 139600 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(139629), // Rule ID 4563 //
     /* 139605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 139608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139616 */     // (vselect:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src0)  =>  (VMOVDQU16Zrrk:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src1)
     /* 139616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 139619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139621 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139623 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139625 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139627 */     GIR_RootConstrainSelectedInstOperands,
     /* 139628 */     // GIR_Coverage, 4563,
     /* 139628 */     GIR_EraseRootFromParent_Done,
     /* 139629 */   // Label 2992: @139629
     /* 139629 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(139658), // Rule ID 19843 //
     /* 139634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 139637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139645 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src0)  =>  (VMOVDQU16Zrrk:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1)
     /* 139645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 139648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139650 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139652 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139654 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139656 */     GIR_RootConstrainSelectedInstOperands,
     /* 139657 */     // GIR_Coverage, 19843,
     /* 139657 */     GIR_EraseRootFromParent_Done,
     /* 139658 */   // Label 2993: @139658
     /* 139658 */   GIM_Reject,
     /* 139659 */ // Label 2985: @139659
     /* 139659 */ GIM_Reject,
     /* 139660 */ // Label 2895: @139660
     /* 139660 */ GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(139745),
     /* 139665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 139668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 139671 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 139674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64WMRegClassID),
     /* 139682 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139686 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(139719), // Rule ID 4550 //
     /* 139691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 139694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139698 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139704 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139708 */     // (vselect:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src, immAllZerosV:{ *:[v64i8] })  =>  (VMOVDQU8Zrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 139708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 139711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139713 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139715 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 139717 */     GIR_RootConstrainSelectedInstOperands,
     /* 139718 */     // GIR_Coverage, 4550,
     /* 139718 */     GIR_EraseRootFromParent_Done,
     /* 139719 */   // Label 2995: @139719
     /* 139719 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(139744), // Rule ID 4551 //
     /* 139724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 139727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139731 */     // (vselect:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src0)  =>  (VMOVDQU8Zrrk:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src0, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src1)
     /* 139731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 139734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139736 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139738 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139740 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139742 */     GIR_RootConstrainSelectedInstOperands,
     /* 139743 */     // GIR_Coverage, 4551,
     /* 139743 */     GIR_EraseRootFromParent_Done,
     /* 139744 */   // Label 2996: @139744
     /* 139744 */   GIM_Reject,
     /* 139745 */ // Label 2994: @139745
     /* 139745 */ GIM_Reject,
     /* 139746 */ // Label 2896: @139746
     /* 139746 */ GIM_Reject,
     /* 139747 */ // Label 35: @139747
     /* 139747 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(23), /*)*//*default:*//*Label 3000*/ GIMT_Encode4(140611),
     /* 139758 */ /*GILLT_v8s16*//*Label 2997*/ GIMT_Encode4(139798), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 139778 */ /*GILLT_v16s16*//*Label 2998*/ GIMT_Encode4(140140), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 139794 */ /*GILLT_v32s16*//*Label 2999*/ GIMT_Encode4(140455),
     /* 139798 */ // Label 2997: @139798
     /* 139798 */ GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(140139),
     /* 139803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 139806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 139809 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(139871), // Rule ID 23453 //
     /* 139814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 139817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 139821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 139829 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139832 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 139836 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 139840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 139844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 139853 */     // (mulhu:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMULHUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 139853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWrm),
     /* 139856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139858 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139860 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 139864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 139869 */     GIR_RootConstrainSelectedInstOperands,
     /* 139870 */     // GIR_Coverage, 23453,
     /* 139870 */     GIR_EraseRootFromParent_Done,
     /* 139871 */   // Label 3002: @139871
     /* 139871 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(139933), // Rule ID 23843 //
     /* 139876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 139879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 139883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 139891 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139894 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 139898 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 139902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 139906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139908 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 139915 */     // (mulhu:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMULHUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 139915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ128rm),
     /* 139918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139920 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139922 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 139926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 139931 */     GIR_RootConstrainSelectedInstOperands,
     /* 139932 */     // GIR_Coverage, 23843,
     /* 139932 */     GIR_EraseRootFromParent_Done,
     /* 139933 */   // Label 3003: @139933
     /* 139933 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(139995), // Rule ID 2576 //
     /* 139938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 139941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 139945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 139949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 139957 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139960 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 139964 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 139968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 139977 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 139977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWrm),
     /* 139980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139982 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 139984 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 139988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 139993 */     GIR_RootConstrainSelectedInstOperands,
     /* 139994 */     // GIR_Coverage, 2576,
     /* 139994 */     GIR_EraseRootFromParent_Done,
     /* 139995 */   // Label 3004: @139995
     /* 139995 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(140057), // Rule ID 5061 //
     /* 140000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140019 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140022 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140026 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140032 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140039 */     // (mulhu:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ128rm),
     /* 140042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140044 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 140046 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140055 */     GIR_RootConstrainSelectedInstOperands,
     /* 140056 */     // GIR_Coverage, 5061,
     /* 140056 */     GIR_EraseRootFromParent_Done,
     /* 140057 */   // Label 3005: @140057
     /* 140057 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(140084), // Rule ID 2575 //
     /* 140062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 140065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140077 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULHUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 140077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWrr),
     /* 140082 */     GIR_RootConstrainSelectedInstOperands,
     /* 140083 */     // GIR_Coverage, 2575,
     /* 140083 */     GIR_Done,
     /* 140084 */   // Label 3006: @140084
     /* 140084 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(140111), // Rule ID 2577 //
     /* 140089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 140092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140104 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULHUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 140104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULHUWrr),
     /* 140109 */     GIR_RootConstrainSelectedInstOperands,
     /* 140110 */     // GIR_Coverage, 2577,
     /* 140110 */     GIR_Done,
     /* 140111 */   // Label 3007: @140111
     /* 140111 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(140138), // Rule ID 5058 //
     /* 140116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140131 */     // (mulhu:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULHUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 140131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ128rr),
     /* 140136 */     GIR_RootConstrainSelectedInstOperands,
     /* 140137 */     // GIR_Coverage, 5058,
     /* 140137 */     GIR_Done,
     /* 140138 */   // Label 3008: @140138
     /* 140138 */   GIM_Reject,
     /* 140139 */ // Label 3001: @140139
     /* 140139 */ GIM_Reject,
     /* 140140 */ // Label 2998: @140140
     /* 140140 */ GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(140454),
     /* 140145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 140148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 140151 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(140213), // Rule ID 23455 //
     /* 140156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 140159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140171 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140174 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140178 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140188 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140195 */     // (mulhu:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMULHUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWYrm),
     /* 140198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140200 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140202 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140211 */     GIR_RootConstrainSelectedInstOperands,
     /* 140212 */     // GIR_Coverage, 23455,
     /* 140212 */     GIR_EraseRootFromParent_Done,
     /* 140213 */   // Label 3010: @140213
     /* 140213 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(140275), // Rule ID 23840 //
     /* 140218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140233 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140236 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140240 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140250 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140257 */     // (mulhu:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMULHUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ256rm),
     /* 140260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140262 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140264 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140273 */     GIR_RootConstrainSelectedInstOperands,
     /* 140274 */     // GIR_Coverage, 23840,
     /* 140274 */     GIR_EraseRootFromParent_Done,
     /* 140275 */   // Label 3011: @140275
     /* 140275 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(140337), // Rule ID 2580 //
     /* 140280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 140283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140299 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140302 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140306 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140319 */     // (mulhu:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWYrm),
     /* 140322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140324 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 140326 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140335 */     GIR_RootConstrainSelectedInstOperands,
     /* 140336 */     // GIR_Coverage, 2580,
     /* 140336 */     GIR_EraseRootFromParent_Done,
     /* 140337 */   // Label 3012: @140337
     /* 140337 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(140399), // Rule ID 5055 //
     /* 140342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140361 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140364 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140368 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140374 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140381 */     // (mulhu:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ256rm),
     /* 140384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140386 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 140388 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140397 */     GIR_RootConstrainSelectedInstOperands,
     /* 140398 */     // GIR_Coverage, 5055,
     /* 140398 */     GIR_EraseRootFromParent_Done,
     /* 140399 */   // Label 3013: @140399
     /* 140399 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(140426), // Rule ID 2579 //
     /* 140404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 140407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140419 */     // (mulhu:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULHUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 140419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWYrr),
     /* 140424 */     GIR_RootConstrainSelectedInstOperands,
     /* 140425 */     // GIR_Coverage, 2579,
     /* 140425 */     GIR_Done,
     /* 140426 */   // Label 3014: @140426
     /* 140426 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(140453), // Rule ID 5052 //
     /* 140431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140446 */     // (mulhu:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULHUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 140446 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ256rr),
     /* 140451 */     GIR_RootConstrainSelectedInstOperands,
     /* 140452 */     // GIR_Coverage, 5052,
     /* 140452 */     GIR_Done,
     /* 140453 */   // Label 3015: @140453
     /* 140453 */   GIM_Reject,
     /* 140454 */ // Label 3009: @140454
     /* 140454 */ GIM_Reject,
     /* 140455 */ // Label 2999: @140455
     /* 140455 */ GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(140610),
     /* 140460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 140463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 140466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140470 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(140528), // Rule ID 23837 //
     /* 140475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140486 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140489 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140493 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140510 */     // (mulhu:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMULHUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZrm),
     /* 140513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140515 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140517 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140526 */     GIR_RootConstrainSelectedInstOperands,
     /* 140527 */     // GIR_Coverage, 23837,
     /* 140527 */     GIR_EraseRootFromParent_Done,
     /* 140528 */   // Label 3017: @140528
     /* 140528 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(140586), // Rule ID 5049 //
     /* 140533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140548 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140551 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140555 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140568 */     // (mulhu:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZrm),
     /* 140571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140573 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 140575 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140584 */     GIR_RootConstrainSelectedInstOperands,
     /* 140585 */     // GIR_Coverage, 5049,
     /* 140585 */     GIR_EraseRootFromParent_Done,
     /* 140586 */   // Label 3018: @140586
     /* 140586 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(140609), // Rule ID 5046 //
     /* 140591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140602 */     // (mulhu:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULHUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 140602 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZrr),
     /* 140607 */     GIR_RootConstrainSelectedInstOperands,
     /* 140608 */     // GIR_Coverage, 5046,
     /* 140608 */     GIR_Done,
     /* 140609 */   // Label 3019: @140609
     /* 140609 */   GIM_Reject,
     /* 140610 */ // Label 3016: @140610
     /* 140610 */ GIM_Reject,
     /* 140611 */ // Label 3000: @140611
     /* 140611 */ GIM_Reject,
     /* 140612 */ // Label 36: @140612
     /* 140612 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(23), /*)*//*default:*//*Label 3023*/ GIMT_Encode4(141476),
     /* 140623 */ /*GILLT_v8s16*//*Label 3020*/ GIMT_Encode4(140663), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 140643 */ /*GILLT_v16s16*//*Label 3021*/ GIMT_Encode4(141005), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 140659 */ /*GILLT_v32s16*//*Label 3022*/ GIMT_Encode4(141320),
     /* 140663 */ // Label 3020: @140663
     /* 140663 */ GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(141004),
     /* 140668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 140671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 140674 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(140736), // Rule ID 23456 //
     /* 140679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 140682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140694 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140697 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140701 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140718 */     // (mulhs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMULHWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWrm),
     /* 140721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140723 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140725 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140734 */     GIR_RootConstrainSelectedInstOperands,
     /* 140735 */     // GIR_Coverage, 23456,
     /* 140735 */     GIR_EraseRootFromParent_Done,
     /* 140736 */   // Label 3025: @140736
     /* 140736 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(140798), // Rule ID 23834 //
     /* 140741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140756 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140759 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140763 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140773 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140780 */     // (mulhs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMULHWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ128rm),
     /* 140783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140785 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140787 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140796 */     GIR_RootConstrainSelectedInstOperands,
     /* 140797 */     // GIR_Coverage, 23834,
     /* 140797 */     GIR_EraseRootFromParent_Done,
     /* 140798 */   // Label 3026: @140798
     /* 140798 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(140860), // Rule ID 2582 //
     /* 140803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 140806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140822 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140825 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140829 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140842 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWrm),
     /* 140845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140847 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 140849 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140858 */     GIR_RootConstrainSelectedInstOperands,
     /* 140859 */     // GIR_Coverage, 2582,
     /* 140859 */     GIR_EraseRootFromParent_Done,
     /* 140860 */   // Label 3027: @140860
     /* 140860 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(140922), // Rule ID 5043 //
     /* 140865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140884 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140887 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140891 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140904 */     // (mulhs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ128rm),
     /* 140907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140909 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 140911 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140920 */     GIR_RootConstrainSelectedInstOperands,
     /* 140921 */     // GIR_Coverage, 5043,
     /* 140921 */     GIR_EraseRootFromParent_Done,
     /* 140922 */   // Label 3028: @140922
     /* 140922 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(140949), // Rule ID 2581 //
     /* 140927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 140930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140942 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULHWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 140942 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWrr),
     /* 140947 */     GIR_RootConstrainSelectedInstOperands,
     /* 140948 */     // GIR_Coverage, 2581,
     /* 140948 */     GIR_Done,
     /* 140949 */   // Label 3029: @140949
     /* 140949 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(140976), // Rule ID 2583 //
     /* 140954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 140957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140969 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULHWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 140969 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULHWrr),
     /* 140974 */     GIR_RootConstrainSelectedInstOperands,
     /* 140975 */     // GIR_Coverage, 2583,
     /* 140975 */     GIR_Done,
     /* 140976 */   // Label 3030: @140976
     /* 140976 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(141003), // Rule ID 5040 //
     /* 140981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140996 */     // (mulhs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULHWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 140996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ128rr),
     /* 141001 */     GIR_RootConstrainSelectedInstOperands,
     /* 141002 */     // GIR_Coverage, 5040,
     /* 141002 */     GIR_Done,
     /* 141003 */   // Label 3031: @141003
     /* 141003 */   GIM_Reject,
     /* 141004 */ // Label 3024: @141004
     /* 141004 */ GIM_Reject,
     /* 141005 */ // Label 3021: @141005
     /* 141005 */ GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(141319),
     /* 141010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 141013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 141016 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(141078), // Rule ID 23458 //
     /* 141021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141036 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141039 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141043 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141053 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141060 */     // (mulhs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMULHWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWYrm),
     /* 141063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141065 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141067 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141076 */     GIR_RootConstrainSelectedInstOperands,
     /* 141077 */     // GIR_Coverage, 23458,
     /* 141077 */     GIR_EraseRootFromParent_Done,
     /* 141078 */   // Label 3033: @141078
     /* 141078 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(141140), // Rule ID 23831 //
     /* 141083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141098 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141101 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141105 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141122 */     // (mulhs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMULHWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ256rm),
     /* 141125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141127 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141129 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141138 */     GIR_RootConstrainSelectedInstOperands,
     /* 141139 */     // GIR_Coverage, 23831,
     /* 141139 */     GIR_EraseRootFromParent_Done,
     /* 141140 */   // Label 3034: @141140
     /* 141140 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(141202), // Rule ID 2586 //
     /* 141145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141164 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141167 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141171 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141184 */     // (mulhs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWYrm),
     /* 141187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141189 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141191 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141200 */     GIR_RootConstrainSelectedInstOperands,
     /* 141201 */     // GIR_Coverage, 2586,
     /* 141201 */     GIR_EraseRootFromParent_Done,
     /* 141202 */   // Label 3035: @141202
     /* 141202 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(141264), // Rule ID 5037 //
     /* 141207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141226 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141229 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141233 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141246 */     // (mulhs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ256rm),
     /* 141249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141251 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141253 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141262 */     GIR_RootConstrainSelectedInstOperands,
     /* 141263 */     // GIR_Coverage, 5037,
     /* 141263 */     GIR_EraseRootFromParent_Done,
     /* 141264 */   // Label 3036: @141264
     /* 141264 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(141291), // Rule ID 2585 //
     /* 141269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141284 */     // (mulhs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULHWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 141284 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWYrr),
     /* 141289 */     GIR_RootConstrainSelectedInstOperands,
     /* 141290 */     // GIR_Coverage, 2585,
     /* 141290 */     GIR_Done,
     /* 141291 */   // Label 3037: @141291
     /* 141291 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(141318), // Rule ID 5034 //
     /* 141296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141311 */     // (mulhs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULHWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 141311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ256rr),
     /* 141316 */     GIR_RootConstrainSelectedInstOperands,
     /* 141317 */     // GIR_Coverage, 5034,
     /* 141317 */     GIR_Done,
     /* 141318 */   // Label 3038: @141318
     /* 141318 */   GIM_Reject,
     /* 141319 */ // Label 3032: @141319
     /* 141319 */ GIM_Reject,
     /* 141320 */ // Label 3022: @141320
     /* 141320 */ GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(141475),
     /* 141325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 141328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 141331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141335 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(141393), // Rule ID 23828 //
     /* 141340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141351 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141354 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141358 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141368 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141375 */     // (mulhs:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMULHWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZrm),
     /* 141378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141380 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141382 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141391 */     GIR_RootConstrainSelectedInstOperands,
     /* 141392 */     // GIR_Coverage, 23828,
     /* 141392 */     GIR_EraseRootFromParent_Done,
     /* 141393 */   // Label 3040: @141393
     /* 141393 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(141451), // Rule ID 5031 //
     /* 141398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141413 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141416 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141420 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141426 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141433 */     // (mulhs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZrm),
     /* 141436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141438 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141440 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141449 */     GIR_RootConstrainSelectedInstOperands,
     /* 141450 */     // GIR_Coverage, 5031,
     /* 141450 */     GIR_EraseRootFromParent_Done,
     /* 141451 */   // Label 3041: @141451
     /* 141451 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(141474), // Rule ID 5028 //
     /* 141456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141467 */     // (mulhs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULHWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 141467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZrr),
     /* 141472 */     GIR_RootConstrainSelectedInstOperands,
     /* 141473 */     // GIR_Coverage, 5028,
     /* 141473 */     GIR_Done,
     /* 141474 */   // Label 3042: @141474
     /* 141474 */   GIM_Reject,
     /* 141475 */ // Label 3039: @141475
     /* 141475 */ GIM_Reject,
     /* 141476 */ // Label 3023: @141476
     /* 141476 */ GIM_Reject,
     /* 141477 */ // Label 37: @141477
     /* 141477 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3049*/ GIMT_Encode4(143162),
     /* 141488 */ /*GILLT_v8s16*//*Label 3043*/ GIMT_Encode4(141536), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 141504 */ /*GILLT_v16s8*//*Label 3044*/ GIMT_Encode4(141878),
     /* 141508 */ /*GILLT_v16s16*//*Label 3045*/ GIMT_Encode4(142220), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 141520 */ /*GILLT_v32s8*//*Label 3046*/ GIMT_Encode4(142535),
     /* 141524 */ /*GILLT_v32s16*//*Label 3047*/ GIMT_Encode4(142850), GIMT_Encode4(0),
     /* 141532 */ /*GILLT_v64s8*//*Label 3048*/ GIMT_Encode4(143006),
     /* 141536 */ // Label 3043: @141536
     /* 141536 */ GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(141877),
     /* 141541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 141544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 141547 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(141609), // Rule ID 23447 //
     /* 141552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 141555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141567 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141570 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141574 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141584 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141591 */     // (uaddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPADDUSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWrm),
     /* 141594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141596 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141598 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141607 */     GIR_RootConstrainSelectedInstOperands,
     /* 141608 */     // GIR_Coverage, 23447,
     /* 141608 */     GIR_EraseRootFromParent_Done,
     /* 141609 */   // Label 3051: @141609
     /* 141609 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(141671), // Rule ID 23771 //
     /* 141614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141629 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141632 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141636 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141653 */     // (uaddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPADDUSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ128rm),
     /* 141656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141658 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141660 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141669 */     GIR_RootConstrainSelectedInstOperands,
     /* 141670 */     // GIR_Coverage, 23771,
     /* 141670 */     GIR_EraseRootFromParent_Done,
     /* 141671 */   // Label 3052: @141671
     /* 141671 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(141733), // Rule ID 2564 //
     /* 141676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 141679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141695 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141698 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141702 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141708 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141715 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWrm),
     /* 141718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141720 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141722 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141731 */     GIR_RootConstrainSelectedInstOperands,
     /* 141732 */     // GIR_Coverage, 2564,
     /* 141732 */     GIR_EraseRootFromParent_Done,
     /* 141733 */   // Label 3053: @141733
     /* 141733 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(141795), // Rule ID 4899 //
     /* 141738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141757 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141760 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141764 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141770 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141777 */     // (uaddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ128rm),
     /* 141780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141782 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141784 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141793 */     GIR_RootConstrainSelectedInstOperands,
     /* 141794 */     // GIR_Coverage, 4899,
     /* 141794 */     GIR_EraseRootFromParent_Done,
     /* 141795 */   // Label 3054: @141795
     /* 141795 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(141822), // Rule ID 2563 //
     /* 141800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 141803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141815 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 141815 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWrr),
     /* 141820 */     GIR_RootConstrainSelectedInstOperands,
     /* 141821 */     // GIR_Coverage, 2563,
     /* 141821 */     GIR_Done,
     /* 141822 */   // Label 3055: @141822
     /* 141822 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(141849), // Rule ID 2565 //
     /* 141827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 141830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141842 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 141842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDUSWrr),
     /* 141847 */     GIR_RootConstrainSelectedInstOperands,
     /* 141848 */     // GIR_Coverage, 2565,
     /* 141848 */     GIR_Done,
     /* 141849 */   // Label 3056: @141849
     /* 141849 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(141876), // Rule ID 4896 //
     /* 141854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141869 */     // (uaddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDUSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 141869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ128rr),
     /* 141874 */     GIR_RootConstrainSelectedInstOperands,
     /* 141875 */     // GIR_Coverage, 4896,
     /* 141875 */     GIR_Done,
     /* 141876 */   // Label 3057: @141876
     /* 141876 */   GIM_Reject,
     /* 141877 */ // Label 3050: @141877
     /* 141877 */ GIM_Reject,
     /* 141878 */ // Label 3044: @141878
     /* 141878 */ GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(142219),
     /* 141883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 141886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 141889 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(141951), // Rule ID 23444 //
     /* 141894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 141897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141909 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141912 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141916 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141926 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141933 */     // (uaddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPADDUSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBrm),
     /* 141936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141938 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141940 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141949 */     GIR_RootConstrainSelectedInstOperands,
     /* 141950 */     // GIR_Coverage, 23444,
     /* 141950 */     GIR_EraseRootFromParent_Done,
     /* 141951 */   // Label 3059: @141951
     /* 141951 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(142013), // Rule ID 23780 //
     /* 141956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141971 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141974 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141978 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141995 */     // (uaddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPADDUSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ128rm),
     /* 141998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142000 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142002 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142011 */     GIR_RootConstrainSelectedInstOperands,
     /* 142012 */     // GIR_Coverage, 23780,
     /* 142012 */     GIR_EraseRootFromParent_Done,
     /* 142013 */   // Label 3060: @142013
     /* 142013 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(142075), // Rule ID 2558 //
     /* 142018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142037 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142040 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142044 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142057 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBrm),
     /* 142060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142062 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142064 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142073 */     GIR_RootConstrainSelectedInstOperands,
     /* 142074 */     // GIR_Coverage, 2558,
     /* 142074 */     GIR_EraseRootFromParent_Done,
     /* 142075 */   // Label 3061: @142075
     /* 142075 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(142137), // Rule ID 4917 //
     /* 142080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142099 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142102 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142106 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142119 */     // (uaddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ128rm),
     /* 142122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142124 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142126 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142135 */     GIR_RootConstrainSelectedInstOperands,
     /* 142136 */     // GIR_Coverage, 4917,
     /* 142136 */     GIR_EraseRootFromParent_Done,
     /* 142137 */   // Label 3062: @142137
     /* 142137 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(142164), // Rule ID 2557 //
     /* 142142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142157 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 142157 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBrr),
     /* 142162 */     GIR_RootConstrainSelectedInstOperands,
     /* 142163 */     // GIR_Coverage, 2557,
     /* 142163 */     GIR_Done,
     /* 142164 */   // Label 3063: @142164
     /* 142164 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(142191), // Rule ID 2559 //
     /* 142169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 142172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142184 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 142184 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDUSBrr),
     /* 142189 */     GIR_RootConstrainSelectedInstOperands,
     /* 142190 */     // GIR_Coverage, 2559,
     /* 142190 */     GIR_Done,
     /* 142191 */   // Label 3064: @142191
     /* 142191 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(142218), // Rule ID 4914 //
     /* 142196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142211 */     // (uaddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDUSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 142211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ128rr),
     /* 142216 */     GIR_RootConstrainSelectedInstOperands,
     /* 142217 */     // GIR_Coverage, 4914,
     /* 142217 */     GIR_Done,
     /* 142218 */   // Label 3065: @142218
     /* 142218 */   GIM_Reject,
     /* 142219 */ // Label 3058: @142219
     /* 142219 */ GIM_Reject,
     /* 142220 */ // Label 3045: @142220
     /* 142220 */ GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(142534),
     /* 142225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 142228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 142231 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(142293), // Rule ID 23449 //
     /* 142236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 142239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142251 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142254 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142258 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142268 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142275 */     // (uaddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPADDUSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWYrm),
     /* 142278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142280 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142282 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142291 */     GIR_RootConstrainSelectedInstOperands,
     /* 142292 */     // GIR_Coverage, 23449,
     /* 142292 */     GIR_EraseRootFromParent_Done,
     /* 142293 */   // Label 3067: @142293
     /* 142293 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(142355), // Rule ID 23768 //
     /* 142298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142313 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142316 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142320 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142337 */     // (uaddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPADDUSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ256rm),
     /* 142340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142342 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142344 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142353 */     GIR_RootConstrainSelectedInstOperands,
     /* 142354 */     // GIR_Coverage, 23768,
     /* 142354 */     GIR_EraseRootFromParent_Done,
     /* 142355 */   // Label 3068: @142355
     /* 142355 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(142417), // Rule ID 2568 //
     /* 142360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 142363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142379 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142382 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142386 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142392 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142399 */     // (uaddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWYrm),
     /* 142402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142404 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142406 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142415 */     GIR_RootConstrainSelectedInstOperands,
     /* 142416 */     // GIR_Coverage, 2568,
     /* 142416 */     GIR_EraseRootFromParent_Done,
     /* 142417 */   // Label 3069: @142417
     /* 142417 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(142479), // Rule ID 4893 //
     /* 142422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142441 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142444 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142448 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142461 */     // (uaddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ256rm),
     /* 142464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142466 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142468 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142477 */     GIR_RootConstrainSelectedInstOperands,
     /* 142478 */     // GIR_Coverage, 4893,
     /* 142478 */     GIR_EraseRootFromParent_Done,
     /* 142479 */   // Label 3070: @142479
     /* 142479 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(142506), // Rule ID 2567 //
     /* 142484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 142487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142499 */     // (uaddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDUSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 142499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWYrr),
     /* 142504 */     GIR_RootConstrainSelectedInstOperands,
     /* 142505 */     // GIR_Coverage, 2567,
     /* 142505 */     GIR_Done,
     /* 142506 */   // Label 3071: @142506
     /* 142506 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(142533), // Rule ID 4890 //
     /* 142511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142526 */     // (uaddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDUSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 142526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ256rr),
     /* 142531 */     GIR_RootConstrainSelectedInstOperands,
     /* 142532 */     // GIR_Coverage, 4890,
     /* 142532 */     GIR_Done,
     /* 142533 */   // Label 3072: @142533
     /* 142533 */   GIM_Reject,
     /* 142534 */ // Label 3066: @142534
     /* 142534 */ GIM_Reject,
     /* 142535 */ // Label 3046: @142535
     /* 142535 */ GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(142849),
     /* 142540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 142543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 142546 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(142608), // Rule ID 23446 //
     /* 142551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 142554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142566 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142569 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142573 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142590 */     // (uaddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPADDUSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBYrm),
     /* 142593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142595 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142597 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142606 */     GIR_RootConstrainSelectedInstOperands,
     /* 142607 */     // GIR_Coverage, 23446,
     /* 142607 */     GIR_EraseRootFromParent_Done,
     /* 142608 */   // Label 3074: @142608
     /* 142608 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(142670), // Rule ID 23777 //
     /* 142613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142628 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142635 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142652 */     // (uaddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPADDUSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ256rm),
     /* 142655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142657 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142659 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142668 */     GIR_RootConstrainSelectedInstOperands,
     /* 142669 */     // GIR_Coverage, 23777,
     /* 142669 */     GIR_EraseRootFromParent_Done,
     /* 142670 */   // Label 3075: @142670
     /* 142670 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(142732), // Rule ID 2562 //
     /* 142675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 142678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142694 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142697 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142701 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142714 */     // (uaddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBYrm),
     /* 142717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142719 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142721 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142730 */     GIR_RootConstrainSelectedInstOperands,
     /* 142731 */     // GIR_Coverage, 2562,
     /* 142731 */     GIR_EraseRootFromParent_Done,
     /* 142732 */   // Label 3076: @142732
     /* 142732 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(142794), // Rule ID 4911 //
     /* 142737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142756 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142759 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142763 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142769 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142776 */     // (uaddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ256rm),
     /* 142779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142781 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142783 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142792 */     GIR_RootConstrainSelectedInstOperands,
     /* 142793 */     // GIR_Coverage, 4911,
     /* 142793 */     GIR_EraseRootFromParent_Done,
     /* 142794 */   // Label 3077: @142794
     /* 142794 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(142821), // Rule ID 2561 //
     /* 142799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 142802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142814 */     // (uaddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDUSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 142814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBYrr),
     /* 142819 */     GIR_RootConstrainSelectedInstOperands,
     /* 142820 */     // GIR_Coverage, 2561,
     /* 142820 */     GIR_Done,
     /* 142821 */   // Label 3078: @142821
     /* 142821 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(142848), // Rule ID 4908 //
     /* 142826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142841 */     // (uaddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDUSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 142841 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ256rr),
     /* 142846 */     GIR_RootConstrainSelectedInstOperands,
     /* 142847 */     // GIR_Coverage, 4908,
     /* 142847 */     GIR_Done,
     /* 142848 */   // Label 3079: @142848
     /* 142848 */   GIM_Reject,
     /* 142849 */ // Label 3073: @142849
     /* 142849 */ GIM_Reject,
     /* 142850 */ // Label 3047: @142850
     /* 142850 */ GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(143005),
     /* 142855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 142858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 142861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 142865 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(142923), // Rule ID 23765 //
     /* 142870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 142873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142881 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142884 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142888 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 142896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142898 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142905 */     // (uaddsat:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPADDUSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZrm),
     /* 142908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142910 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142912 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142921 */     GIR_RootConstrainSelectedInstOperands,
     /* 142922 */     // GIR_Coverage, 23765,
     /* 142922 */     GIR_EraseRootFromParent_Done,
     /* 142923 */   // Label 3081: @142923
     /* 142923 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(142981), // Rule ID 4887 //
     /* 142928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 142931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 142935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142943 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142946 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142950 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142963 */     // (uaddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZrm),
     /* 142966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142968 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142970 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142979 */     GIR_RootConstrainSelectedInstOperands,
     /* 142980 */     // GIR_Coverage, 4887,
     /* 142980 */     GIR_EraseRootFromParent_Done,
     /* 142981 */   // Label 3082: @142981
     /* 142981 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(143004), // Rule ID 4884 //
     /* 142986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 142989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 142993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 142997 */     // (uaddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDUSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 142997 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZrr),
     /* 143002 */     GIR_RootConstrainSelectedInstOperands,
     /* 143003 */     // GIR_Coverage, 4884,
     /* 143003 */     GIR_Done,
     /* 143004 */   // Label 3083: @143004
     /* 143004 */   GIM_Reject,
     /* 143005 */ // Label 3080: @143005
     /* 143005 */ GIM_Reject,
     /* 143006 */ // Label 3048: @143006
     /* 143006 */ GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(143161),
     /* 143011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 143014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 143017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143021 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(143079), // Rule ID 23774 //
     /* 143026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143037 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143040 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143044 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143054 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143061 */     // (uaddsat:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPADDUSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZrm),
     /* 143064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143066 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143068 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143077 */     GIR_RootConstrainSelectedInstOperands,
     /* 143078 */     // GIR_Coverage, 23774,
     /* 143078 */     GIR_EraseRootFromParent_Done,
     /* 143079 */   // Label 3085: @143079
     /* 143079 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(143137), // Rule ID 4905 //
     /* 143084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143099 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143102 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143106 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143119 */     // (uaddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZrm),
     /* 143122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143124 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143126 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143135 */     GIR_RootConstrainSelectedInstOperands,
     /* 143136 */     // GIR_Coverage, 4905,
     /* 143136 */     GIR_EraseRootFromParent_Done,
     /* 143137 */   // Label 3086: @143137
     /* 143137 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(143160), // Rule ID 4902 //
     /* 143142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143153 */     // (uaddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDUSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 143153 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZrr),
     /* 143158 */     GIR_RootConstrainSelectedInstOperands,
     /* 143159 */     // GIR_Coverage, 4902,
     /* 143159 */     GIR_Done,
     /* 143160 */   // Label 3087: @143160
     /* 143160 */   GIM_Reject,
     /* 143161 */ // Label 3084: @143161
     /* 143161 */ GIM_Reject,
     /* 143162 */ // Label 3049: @143162
     /* 143162 */ GIM_Reject,
     /* 143163 */ // Label 38: @143163
     /* 143163 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3094*/ GIMT_Encode4(144848),
     /* 143174 */ /*GILLT_v8s16*//*Label 3088*/ GIMT_Encode4(143222), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 143190 */ /*GILLT_v16s8*//*Label 3089*/ GIMT_Encode4(143564),
     /* 143194 */ /*GILLT_v16s16*//*Label 3090*/ GIMT_Encode4(143906), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 143206 */ /*GILLT_v32s8*//*Label 3091*/ GIMT_Encode4(144221),
     /* 143210 */ /*GILLT_v32s16*//*Label 3092*/ GIMT_Encode4(144536), GIMT_Encode4(0),
     /* 143218 */ /*GILLT_v64s8*//*Label 3093*/ GIMT_Encode4(144692),
     /* 143222 */ // Label 3088: @143222
     /* 143222 */ GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(143563),
     /* 143227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 143230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143233 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(143295), // Rule ID 23441 //
     /* 143238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 143241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143253 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143256 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143260 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143277 */     // (saddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPADDSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWrm),
     /* 143280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143282 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143293 */     GIR_RootConstrainSelectedInstOperands,
     /* 143294 */     // GIR_Coverage, 23441,
     /* 143294 */     GIR_EraseRootFromParent_Done,
     /* 143295 */   // Label 3096: @143295
     /* 143295 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(143357), // Rule ID 23753 //
     /* 143300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143315 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143318 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143322 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143339 */     // (saddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPADDSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ128rm),
     /* 143342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143344 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143346 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143355 */     GIR_RootConstrainSelectedInstOperands,
     /* 143356 */     // GIR_Coverage, 23753,
     /* 143356 */     GIR_EraseRootFromParent_Done,
     /* 143357 */   // Label 3097: @143357
     /* 143357 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(143419), // Rule ID 2552 //
     /* 143362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 143365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143381 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143384 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143388 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143401 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWrm),
     /* 143404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143406 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143408 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143417 */     GIR_RootConstrainSelectedInstOperands,
     /* 143418 */     // GIR_Coverage, 2552,
     /* 143418 */     GIR_EraseRootFromParent_Done,
     /* 143419 */   // Label 3098: @143419
     /* 143419 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(143481), // Rule ID 4827 //
     /* 143424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143443 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143446 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143450 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143456 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143463 */     // (saddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ128rm),
     /* 143466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143468 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143470 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143479 */     GIR_RootConstrainSelectedInstOperands,
     /* 143480 */     // GIR_Coverage, 4827,
     /* 143480 */     GIR_EraseRootFromParent_Done,
     /* 143481 */   // Label 3099: @143481
     /* 143481 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(143508), // Rule ID 2551 //
     /* 143486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 143489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143501 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 143501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWrr),
     /* 143506 */     GIR_RootConstrainSelectedInstOperands,
     /* 143507 */     // GIR_Coverage, 2551,
     /* 143507 */     GIR_Done,
     /* 143508 */   // Label 3100: @143508
     /* 143508 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(143535), // Rule ID 2553 //
     /* 143513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 143516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143528 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 143528 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDSWrr),
     /* 143533 */     GIR_RootConstrainSelectedInstOperands,
     /* 143534 */     // GIR_Coverage, 2553,
     /* 143534 */     GIR_Done,
     /* 143535 */   // Label 3101: @143535
     /* 143535 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(143562), // Rule ID 4824 //
     /* 143540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143555 */     // (saddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 143555 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ128rr),
     /* 143560 */     GIR_RootConstrainSelectedInstOperands,
     /* 143561 */     // GIR_Coverage, 4824,
     /* 143561 */     GIR_Done,
     /* 143562 */   // Label 3102: @143562
     /* 143562 */   GIM_Reject,
     /* 143563 */ // Label 3095: @143563
     /* 143563 */ GIM_Reject,
     /* 143564 */ // Label 3089: @143564
     /* 143564 */ GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(143905),
     /* 143569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 143572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 143575 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(143637), // Rule ID 23438 //
     /* 143580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 143583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143595 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143598 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143602 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143612 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143619 */     // (saddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPADDSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBrm),
     /* 143622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143624 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143626 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143635 */     GIR_RootConstrainSelectedInstOperands,
     /* 143636 */     // GIR_Coverage, 23438,
     /* 143636 */     GIR_EraseRootFromParent_Done,
     /* 143637 */   // Label 3104: @143637
     /* 143637 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(143699), // Rule ID 23762 //
     /* 143642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143657 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143660 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143664 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143674 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143681 */     // (saddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPADDSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ128rm),
     /* 143684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143686 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143688 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143697 */     GIR_RootConstrainSelectedInstOperands,
     /* 143698 */     // GIR_Coverage, 23762,
     /* 143698 */     GIR_EraseRootFromParent_Done,
     /* 143699 */   // Label 3105: @143699
     /* 143699 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(143761), // Rule ID 2546 //
     /* 143704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 143707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143723 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143726 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143730 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143736 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143743 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBrm),
     /* 143746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143748 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143750 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143759 */     GIR_RootConstrainSelectedInstOperands,
     /* 143760 */     // GIR_Coverage, 2546,
     /* 143760 */     GIR_EraseRootFromParent_Done,
     /* 143761 */   // Label 3106: @143761
     /* 143761 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(143823), // Rule ID 4845 //
     /* 143766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143785 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143788 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143792 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143805 */     // (saddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ128rm),
     /* 143808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143810 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143812 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143821 */     GIR_RootConstrainSelectedInstOperands,
     /* 143822 */     // GIR_Coverage, 4845,
     /* 143822 */     GIR_EraseRootFromParent_Done,
     /* 143823 */   // Label 3107: @143823
     /* 143823 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(143850), // Rule ID 2545 //
     /* 143828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 143831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143843 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 143843 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBrr),
     /* 143848 */     GIR_RootConstrainSelectedInstOperands,
     /* 143849 */     // GIR_Coverage, 2545,
     /* 143849 */     GIR_Done,
     /* 143850 */   // Label 3108: @143850
     /* 143850 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(143877), // Rule ID 2547 //
     /* 143855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 143858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143870 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 143870 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDSBrr),
     /* 143875 */     GIR_RootConstrainSelectedInstOperands,
     /* 143876 */     // GIR_Coverage, 2547,
     /* 143876 */     GIR_Done,
     /* 143877 */   // Label 3109: @143877
     /* 143877 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(143904), // Rule ID 4842 //
     /* 143882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 143897 */     // (saddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 143897 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ128rr),
     /* 143902 */     GIR_RootConstrainSelectedInstOperands,
     /* 143903 */     // GIR_Coverage, 4842,
     /* 143903 */     GIR_Done,
     /* 143904 */   // Label 3110: @143904
     /* 143904 */   GIM_Reject,
     /* 143905 */ // Label 3103: @143905
     /* 143905 */ GIM_Reject,
     /* 143906 */ // Label 3090: @143906
     /* 143906 */ GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(144220),
     /* 143911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 143914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 143917 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(143979), // Rule ID 23443 //
     /* 143922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143937 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143940 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143944 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143954 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143961 */     // (saddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPADDSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWYrm),
     /* 143964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143966 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143968 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143977 */     GIR_RootConstrainSelectedInstOperands,
     /* 143978 */     // GIR_Coverage, 23443,
     /* 143978 */     GIR_EraseRootFromParent_Done,
     /* 143979 */   // Label 3112: @143979
     /* 143979 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(144041), // Rule ID 23750 //
     /* 143984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143999 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144002 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144006 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144023 */     // (saddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPADDSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ256rm),
     /* 144026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144028 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144030 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144039 */     GIR_RootConstrainSelectedInstOperands,
     /* 144040 */     // GIR_Coverage, 23750,
     /* 144040 */     GIR_EraseRootFromParent_Done,
     /* 144041 */   // Label 3113: @144041
     /* 144041 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(144103), // Rule ID 2556 //
     /* 144046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144065 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144068 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144072 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144078 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144085 */     // (saddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWYrm),
     /* 144088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144090 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144092 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144101 */     GIR_RootConstrainSelectedInstOperands,
     /* 144102 */     // GIR_Coverage, 2556,
     /* 144102 */     GIR_EraseRootFromParent_Done,
     /* 144103 */   // Label 3114: @144103
     /* 144103 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(144165), // Rule ID 4821 //
     /* 144108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144127 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144130 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144134 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144147 */     // (saddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ256rm),
     /* 144150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144152 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144154 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144163 */     GIR_RootConstrainSelectedInstOperands,
     /* 144164 */     // GIR_Coverage, 4821,
     /* 144164 */     GIR_EraseRootFromParent_Done,
     /* 144165 */   // Label 3115: @144165
     /* 144165 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(144192), // Rule ID 2555 //
     /* 144170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144185 */     // (saddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 144185 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWYrr),
     /* 144190 */     GIR_RootConstrainSelectedInstOperands,
     /* 144191 */     // GIR_Coverage, 2555,
     /* 144191 */     GIR_Done,
     /* 144192 */   // Label 3116: @144192
     /* 144192 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(144219), // Rule ID 4818 //
     /* 144197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144212 */     // (saddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 144212 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ256rr),
     /* 144217 */     GIR_RootConstrainSelectedInstOperands,
     /* 144218 */     // GIR_Coverage, 4818,
     /* 144218 */     GIR_Done,
     /* 144219 */   // Label 3117: @144219
     /* 144219 */   GIM_Reject,
     /* 144220 */ // Label 3111: @144220
     /* 144220 */ GIM_Reject,
     /* 144221 */ // Label 3091: @144221
     /* 144221 */ GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(144535),
     /* 144226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 144229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 144232 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(144294), // Rule ID 23440 //
     /* 144237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144252 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144255 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144259 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144276 */     // (saddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPADDSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBYrm),
     /* 144279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144281 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144283 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144292 */     GIR_RootConstrainSelectedInstOperands,
     /* 144293 */     // GIR_Coverage, 23440,
     /* 144293 */     GIR_EraseRootFromParent_Done,
     /* 144294 */   // Label 3119: @144294
     /* 144294 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(144356), // Rule ID 23759 //
     /* 144299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144314 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144317 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144321 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144338 */     // (saddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPADDSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ256rm),
     /* 144341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144343 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144345 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144354 */     GIR_RootConstrainSelectedInstOperands,
     /* 144355 */     // GIR_Coverage, 23759,
     /* 144355 */     GIR_EraseRootFromParent_Done,
     /* 144356 */   // Label 3120: @144356
     /* 144356 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(144418), // Rule ID 2550 //
     /* 144361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144380 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144383 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144387 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144400 */     // (saddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBYrm),
     /* 144403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144405 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144407 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144416 */     GIR_RootConstrainSelectedInstOperands,
     /* 144417 */     // GIR_Coverage, 2550,
     /* 144417 */     GIR_EraseRootFromParent_Done,
     /* 144418 */   // Label 3121: @144418
     /* 144418 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(144480), // Rule ID 4839 //
     /* 144423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144442 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144445 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144449 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144462 */     // (saddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ256rm),
     /* 144465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144467 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144469 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144478 */     GIR_RootConstrainSelectedInstOperands,
     /* 144479 */     // GIR_Coverage, 4839,
     /* 144479 */     GIR_EraseRootFromParent_Done,
     /* 144480 */   // Label 3122: @144480
     /* 144480 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(144507), // Rule ID 2549 //
     /* 144485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144500 */     // (saddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 144500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBYrr),
     /* 144505 */     GIR_RootConstrainSelectedInstOperands,
     /* 144506 */     // GIR_Coverage, 2549,
     /* 144506 */     GIR_Done,
     /* 144507 */   // Label 3123: @144507
     /* 144507 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(144534), // Rule ID 4836 //
     /* 144512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144527 */     // (saddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 144527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ256rr),
     /* 144532 */     GIR_RootConstrainSelectedInstOperands,
     /* 144533 */     // GIR_Coverage, 4836,
     /* 144533 */     GIR_Done,
     /* 144534 */   // Label 3124: @144534
     /* 144534 */   GIM_Reject,
     /* 144535 */ // Label 3118: @144535
     /* 144535 */ GIM_Reject,
     /* 144536 */ // Label 3092: @144536
     /* 144536 */ GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(144691),
     /* 144541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 144544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 144547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 144551 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(144609), // Rule ID 23747 //
     /* 144556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 144559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144567 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144570 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144574 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 144582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144584 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144591 */     // (saddsat:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPADDSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZrm),
     /* 144594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144596 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144598 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144607 */     GIR_RootConstrainSelectedInstOperands,
     /* 144608 */     // GIR_Coverage, 23747,
     /* 144608 */     GIR_EraseRootFromParent_Done,
     /* 144609 */   // Label 3126: @144609
     /* 144609 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(144667), // Rule ID 4815 //
     /* 144614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 144617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 144621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144629 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144632 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144636 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144642 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144649 */     // (saddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZrm),
     /* 144652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144654 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144656 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144665 */     GIR_RootConstrainSelectedInstOperands,
     /* 144666 */     // GIR_Coverage, 4815,
     /* 144666 */     GIR_EraseRootFromParent_Done,
     /* 144667 */   // Label 3127: @144667
     /* 144667 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(144690), // Rule ID 4812 //
     /* 144672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 144675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 144679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 144683 */     // (saddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 144683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZrr),
     /* 144688 */     GIR_RootConstrainSelectedInstOperands,
     /* 144689 */     // GIR_Coverage, 4812,
     /* 144689 */     GIR_Done,
     /* 144690 */   // Label 3128: @144690
     /* 144690 */   GIM_Reject,
     /* 144691 */ // Label 3125: @144691
     /* 144691 */ GIM_Reject,
     /* 144692 */ // Label 3093: @144692
     /* 144692 */ GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(144847),
     /* 144697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 144700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 144703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 144707 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(144765), // Rule ID 23756 //
     /* 144712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 144715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144723 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144726 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144730 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 144738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144740 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144747 */     // (saddsat:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPADDSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZrm),
     /* 144750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144752 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144754 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144763 */     GIR_RootConstrainSelectedInstOperands,
     /* 144764 */     // GIR_Coverage, 23756,
     /* 144764 */     GIR_EraseRootFromParent_Done,
     /* 144765 */   // Label 3130: @144765
     /* 144765 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(144823), // Rule ID 4833 //
     /* 144770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 144773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 144777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144785 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144788 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144792 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144805 */     // (saddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZrm),
     /* 144808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144810 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144812 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144821 */     GIR_RootConstrainSelectedInstOperands,
     /* 144822 */     // GIR_Coverage, 4833,
     /* 144822 */     GIR_EraseRootFromParent_Done,
     /* 144823 */   // Label 3131: @144823
     /* 144823 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(144846), // Rule ID 4830 //
     /* 144828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 144831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 144835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 144839 */     // (saddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 144839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZrr),
     /* 144844 */     GIR_RootConstrainSelectedInstOperands,
     /* 144845 */     // GIR_Coverage, 4830,
     /* 144845 */     GIR_Done,
     /* 144846 */   // Label 3132: @144846
     /* 144846 */   GIM_Reject,
     /* 144847 */ // Label 3129: @144847
     /* 144847 */ GIM_Reject,
     /* 144848 */ // Label 3094: @144848
     /* 144848 */ GIM_Reject,
     /* 144849 */ // Label 39: @144849
     /* 144849 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3139*/ GIMT_Encode4(145914),
     /* 144860 */ /*GILLT_v8s16*//*Label 3133*/ GIMT_Encode4(144908), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 144876 */ /*GILLT_v16s8*//*Label 3134*/ GIMT_Encode4(145126),
     /* 144880 */ /*GILLT_v16s16*//*Label 3135*/ GIMT_Encode4(145344), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 144892 */ /*GILLT_v32s8*//*Label 3136*/ GIMT_Encode4(145535),
     /* 144896 */ /*GILLT_v32s16*//*Label 3137*/ GIMT_Encode4(145726), GIMT_Encode4(0),
     /* 144904 */ /*GILLT_v64s8*//*Label 3138*/ GIMT_Encode4(145820),
     /* 144908 */ // Label 3133: @144908
     /* 144908 */ GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(145125),
     /* 144913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 144916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144919 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(144981), // Rule ID 2630 //
     /* 144924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144943 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144946 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144950 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144963 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWrm),
     /* 144966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144968 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144970 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144979 */     GIR_RootConstrainSelectedInstOperands,
     /* 144980 */     // GIR_Coverage, 2630,
     /* 144980 */     GIR_EraseRootFromParent_Done,
     /* 144981 */   // Label 3141: @144981
     /* 144981 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(145043), // Rule ID 4935 //
     /* 144986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145005 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145008 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145012 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145018 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145025 */     // (usubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ128rm),
     /* 145028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145030 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145032 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145041 */     GIR_RootConstrainSelectedInstOperands,
     /* 145042 */     // GIR_Coverage, 4935,
     /* 145042 */     GIR_EraseRootFromParent_Done,
     /* 145043 */   // Label 3142: @145043
     /* 145043 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(145070), // Rule ID 2629 //
     /* 145048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145063 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 145063 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWrr),
     /* 145068 */     GIR_RootConstrainSelectedInstOperands,
     /* 145069 */     // GIR_Coverage, 2629,
     /* 145069 */     GIR_Done,
     /* 145070 */   // Label 3143: @145070
     /* 145070 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(145097), // Rule ID 2631 //
     /* 145075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 145078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145090 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 145090 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBUSWrr),
     /* 145095 */     GIR_RootConstrainSelectedInstOperands,
     /* 145096 */     // GIR_Coverage, 2631,
     /* 145096 */     GIR_Done,
     /* 145097 */   // Label 3144: @145097
     /* 145097 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(145124), // Rule ID 4932 //
     /* 145102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145117 */     // (usubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBUSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 145117 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ128rr),
     /* 145122 */     GIR_RootConstrainSelectedInstOperands,
     /* 145123 */     // GIR_Coverage, 4932,
     /* 145123 */     GIR_Done,
     /* 145124 */   // Label 3145: @145124
     /* 145124 */   GIM_Reject,
     /* 145125 */ // Label 3140: @145125
     /* 145125 */ GIM_Reject,
     /* 145126 */ // Label 3134: @145126
     /* 145126 */ GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(145343),
     /* 145131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 145134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 145137 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(145199), // Rule ID 2624 //
     /* 145142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145161 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145164 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145168 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145181 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBrm),
     /* 145184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145186 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145188 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145197 */     GIR_RootConstrainSelectedInstOperands,
     /* 145198 */     // GIR_Coverage, 2624,
     /* 145198 */     GIR_EraseRootFromParent_Done,
     /* 145199 */   // Label 3147: @145199
     /* 145199 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(145261), // Rule ID 4953 //
     /* 145204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145223 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145226 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145230 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145243 */     // (usubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ128rm),
     /* 145246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145248 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145250 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145259 */     GIR_RootConstrainSelectedInstOperands,
     /* 145260 */     // GIR_Coverage, 4953,
     /* 145260 */     GIR_EraseRootFromParent_Done,
     /* 145261 */   // Label 3148: @145261
     /* 145261 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(145288), // Rule ID 2623 //
     /* 145266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145281 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 145281 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBrr),
     /* 145286 */     GIR_RootConstrainSelectedInstOperands,
     /* 145287 */     // GIR_Coverage, 2623,
     /* 145287 */     GIR_Done,
     /* 145288 */   // Label 3149: @145288
     /* 145288 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(145315), // Rule ID 2625 //
     /* 145293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 145296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145308 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 145308 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBUSBrr),
     /* 145313 */     GIR_RootConstrainSelectedInstOperands,
     /* 145314 */     // GIR_Coverage, 2625,
     /* 145314 */     GIR_Done,
     /* 145315 */   // Label 3150: @145315
     /* 145315 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(145342), // Rule ID 4950 //
     /* 145320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145335 */     // (usubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBUSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 145335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ128rr),
     /* 145340 */     GIR_RootConstrainSelectedInstOperands,
     /* 145341 */     // GIR_Coverage, 4950,
     /* 145341 */     GIR_Done,
     /* 145342 */   // Label 3151: @145342
     /* 145342 */   GIM_Reject,
     /* 145343 */ // Label 3146: @145343
     /* 145343 */ GIM_Reject,
     /* 145344 */ // Label 3135: @145344
     /* 145344 */ GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(145534),
     /* 145349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 145352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 145355 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(145417), // Rule ID 2634 //
     /* 145360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 145363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145379 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145382 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145386 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145392 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145399 */     // (usubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWYrm),
     /* 145402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145404 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145406 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145415 */     GIR_RootConstrainSelectedInstOperands,
     /* 145416 */     // GIR_Coverage, 2634,
     /* 145416 */     GIR_EraseRootFromParent_Done,
     /* 145417 */   // Label 3153: @145417
     /* 145417 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(145479), // Rule ID 4929 //
     /* 145422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145441 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145444 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145448 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145461 */     // (usubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ256rm),
     /* 145464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145466 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145468 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145477 */     GIR_RootConstrainSelectedInstOperands,
     /* 145478 */     // GIR_Coverage, 4929,
     /* 145478 */     GIR_EraseRootFromParent_Done,
     /* 145479 */   // Label 3154: @145479
     /* 145479 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(145506), // Rule ID 2633 //
     /* 145484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 145487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145499 */     // (usubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBUSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 145499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWYrr),
     /* 145504 */     GIR_RootConstrainSelectedInstOperands,
     /* 145505 */     // GIR_Coverage, 2633,
     /* 145505 */     GIR_Done,
     /* 145506 */   // Label 3155: @145506
     /* 145506 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(145533), // Rule ID 4926 //
     /* 145511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145526 */     // (usubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBUSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 145526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ256rr),
     /* 145531 */     GIR_RootConstrainSelectedInstOperands,
     /* 145532 */     // GIR_Coverage, 4926,
     /* 145532 */     GIR_Done,
     /* 145533 */   // Label 3156: @145533
     /* 145533 */   GIM_Reject,
     /* 145534 */ // Label 3152: @145534
     /* 145534 */ GIM_Reject,
     /* 145535 */ // Label 3136: @145535
     /* 145535 */ GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(145725),
     /* 145540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 145543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 145546 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(145608), // Rule ID 2628 //
     /* 145551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 145554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145570 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145573 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145577 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145590 */     // (usubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBYrm),
     /* 145593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145595 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145597 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145606 */     GIR_RootConstrainSelectedInstOperands,
     /* 145607 */     // GIR_Coverage, 2628,
     /* 145607 */     GIR_EraseRootFromParent_Done,
     /* 145608 */   // Label 3158: @145608
     /* 145608 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(145670), // Rule ID 4947 //
     /* 145613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145632 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145635 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145639 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145652 */     // (usubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ256rm),
     /* 145655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145657 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145659 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145668 */     GIR_RootConstrainSelectedInstOperands,
     /* 145669 */     // GIR_Coverage, 4947,
     /* 145669 */     GIR_EraseRootFromParent_Done,
     /* 145670 */   // Label 3159: @145670
     /* 145670 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(145697), // Rule ID 2627 //
     /* 145675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 145678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145690 */     // (usubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBUSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 145690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBYrr),
     /* 145695 */     GIR_RootConstrainSelectedInstOperands,
     /* 145696 */     // GIR_Coverage, 2627,
     /* 145696 */     GIR_Done,
     /* 145697 */   // Label 3160: @145697
     /* 145697 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(145724), // Rule ID 4944 //
     /* 145702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145717 */     // (usubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBUSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 145717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ256rr),
     /* 145722 */     GIR_RootConstrainSelectedInstOperands,
     /* 145723 */     // GIR_Coverage, 4944,
     /* 145723 */     GIR_Done,
     /* 145724 */   // Label 3161: @145724
     /* 145724 */   GIM_Reject,
     /* 145725 */ // Label 3157: @145725
     /* 145725 */ GIM_Reject,
     /* 145726 */ // Label 3137: @145726
     /* 145726 */ GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(145819),
     /* 145731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 145734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 145737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145745 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(145799), // Rule ID 4923 //
     /* 145750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145761 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145764 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145768 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145781 */     // (usubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZrm),
     /* 145784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145786 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145788 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145797 */     GIR_RootConstrainSelectedInstOperands,
     /* 145798 */     // GIR_Coverage, 4923,
     /* 145798 */     GIR_EraseRootFromParent_Done,
     /* 145799 */   // Label 3163: @145799
     /* 145799 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(145818), // Rule ID 4920 //
     /* 145804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145811 */     // (usubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBUSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 145811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZrr),
     /* 145816 */     GIR_RootConstrainSelectedInstOperands,
     /* 145817 */     // GIR_Coverage, 4920,
     /* 145817 */     GIR_Done,
     /* 145818 */   // Label 3164: @145818
     /* 145818 */   GIM_Reject,
     /* 145819 */ // Label 3162: @145819
     /* 145819 */ GIM_Reject,
     /* 145820 */ // Label 3138: @145820
     /* 145820 */ GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(145913),
     /* 145825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 145828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 145831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145839 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(145893), // Rule ID 4941 //
     /* 145844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145855 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145858 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145862 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145875 */     // (usubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZrm),
     /* 145878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145880 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145882 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145891 */     GIR_RootConstrainSelectedInstOperands,
     /* 145892 */     // GIR_Coverage, 4941,
     /* 145892 */     GIR_EraseRootFromParent_Done,
     /* 145893 */   // Label 3166: @145893
     /* 145893 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(145912), // Rule ID 4938 //
     /* 145898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145905 */     // (usubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBUSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 145905 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZrr),
     /* 145910 */     GIR_RootConstrainSelectedInstOperands,
     /* 145911 */     // GIR_Coverage, 4938,
     /* 145911 */     GIR_Done,
     /* 145912 */   // Label 3167: @145912
     /* 145912 */   GIM_Reject,
     /* 145913 */ // Label 3165: @145913
     /* 145913 */ GIM_Reject,
     /* 145914 */ // Label 3139: @145914
     /* 145914 */ GIM_Reject,
     /* 145915 */ // Label 40: @145915
     /* 145915 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3174*/ GIMT_Encode4(146980),
     /* 145926 */ /*GILLT_v8s16*//*Label 3168*/ GIMT_Encode4(145974), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 145942 */ /*GILLT_v16s8*//*Label 3169*/ GIMT_Encode4(146192),
     /* 145946 */ /*GILLT_v16s16*//*Label 3170*/ GIMT_Encode4(146410), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 145958 */ /*GILLT_v32s8*//*Label 3171*/ GIMT_Encode4(146601),
     /* 145962 */ /*GILLT_v32s16*//*Label 3172*/ GIMT_Encode4(146792), GIMT_Encode4(0),
     /* 145970 */ /*GILLT_v64s8*//*Label 3173*/ GIMT_Encode4(146886),
     /* 145974 */ // Label 3168: @145974
     /* 145974 */ GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(146191),
     /* 145979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 145982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145985 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(146047), // Rule ID 2618 //
     /* 145990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146009 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146012 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146016 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146029 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWrm),
     /* 146032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146034 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146036 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146045 */     GIR_RootConstrainSelectedInstOperands,
     /* 146046 */     // GIR_Coverage, 2618,
     /* 146046 */     GIR_EraseRootFromParent_Done,
     /* 146047 */   // Label 3176: @146047
     /* 146047 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(146109), // Rule ID 4863 //
     /* 146052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146071 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146074 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146078 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146091 */     // (ssubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ128rm),
     /* 146094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146096 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146098 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146107 */     GIR_RootConstrainSelectedInstOperands,
     /* 146108 */     // GIR_Coverage, 4863,
     /* 146108 */     GIR_EraseRootFromParent_Done,
     /* 146109 */   // Label 3177: @146109
     /* 146109 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(146136), // Rule ID 2617 //
     /* 146114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 146117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146129 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 146129 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWrr),
     /* 146134 */     GIR_RootConstrainSelectedInstOperands,
     /* 146135 */     // GIR_Coverage, 2617,
     /* 146135 */     GIR_Done,
     /* 146136 */   // Label 3178: @146136
     /* 146136 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(146163), // Rule ID 2619 //
     /* 146141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 146144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146156 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 146156 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBSWrr),
     /* 146161 */     GIR_RootConstrainSelectedInstOperands,
     /* 146162 */     // GIR_Coverage, 2619,
     /* 146162 */     GIR_Done,
     /* 146163 */   // Label 3179: @146163
     /* 146163 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(146190), // Rule ID 4860 //
     /* 146168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146183 */     // (ssubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 146183 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ128rr),
     /* 146188 */     GIR_RootConstrainSelectedInstOperands,
     /* 146189 */     // GIR_Coverage, 4860,
     /* 146189 */     GIR_Done,
     /* 146190 */   // Label 3180: @146190
     /* 146190 */   GIM_Reject,
     /* 146191 */ // Label 3175: @146191
     /* 146191 */ GIM_Reject,
     /* 146192 */ // Label 3169: @146192
     /* 146192 */ GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(146409),
     /* 146197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 146200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 146203 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(146265), // Rule ID 2612 //
     /* 146208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 146211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146227 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146230 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146234 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146247 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBrm),
     /* 146250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146252 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146254 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146263 */     GIR_RootConstrainSelectedInstOperands,
     /* 146264 */     // GIR_Coverage, 2612,
     /* 146264 */     GIR_EraseRootFromParent_Done,
     /* 146265 */   // Label 3182: @146265
     /* 146265 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(146327), // Rule ID 4881 //
     /* 146270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146289 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146292 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146296 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146309 */     // (ssubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ128rm),
     /* 146312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146314 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146316 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146325 */     GIR_RootConstrainSelectedInstOperands,
     /* 146326 */     // GIR_Coverage, 4881,
     /* 146326 */     GIR_EraseRootFromParent_Done,
     /* 146327 */   // Label 3183: @146327
     /* 146327 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(146354), // Rule ID 2611 //
     /* 146332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 146335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146347 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 146347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBrr),
     /* 146352 */     GIR_RootConstrainSelectedInstOperands,
     /* 146353 */     // GIR_Coverage, 2611,
     /* 146353 */     GIR_Done,
     /* 146354 */   // Label 3184: @146354
     /* 146354 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(146381), // Rule ID 2613 //
     /* 146359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 146362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146374 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 146374 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBSBrr),
     /* 146379 */     GIR_RootConstrainSelectedInstOperands,
     /* 146380 */     // GIR_Coverage, 2613,
     /* 146380 */     GIR_Done,
     /* 146381 */   // Label 3185: @146381
     /* 146381 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(146408), // Rule ID 4878 //
     /* 146386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146401 */     // (ssubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 146401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ128rr),
     /* 146406 */     GIR_RootConstrainSelectedInstOperands,
     /* 146407 */     // GIR_Coverage, 4878,
     /* 146407 */     GIR_Done,
     /* 146408 */   // Label 3186: @146408
     /* 146408 */   GIM_Reject,
     /* 146409 */ // Label 3181: @146409
     /* 146409 */ GIM_Reject,
     /* 146410 */ // Label 3170: @146410
     /* 146410 */ GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(146600),
     /* 146415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 146418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 146421 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(146483), // Rule ID 2622 //
     /* 146426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146445 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146448 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146452 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146458 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146465 */     // (ssubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWYrm),
     /* 146468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146470 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146472 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146481 */     GIR_RootConstrainSelectedInstOperands,
     /* 146482 */     // GIR_Coverage, 2622,
     /* 146482 */     GIR_EraseRootFromParent_Done,
     /* 146483 */   // Label 3188: @146483
     /* 146483 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(146545), // Rule ID 4857 //
     /* 146488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146507 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146510 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146514 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146520 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146527 */     // (ssubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ256rm),
     /* 146530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146532 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146534 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146543 */     GIR_RootConstrainSelectedInstOperands,
     /* 146544 */     // GIR_Coverage, 4857,
     /* 146544 */     GIR_EraseRootFromParent_Done,
     /* 146545 */   // Label 3189: @146545
     /* 146545 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(146572), // Rule ID 2621 //
     /* 146550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146565 */     // (ssubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 146565 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWYrr),
     /* 146570 */     GIR_RootConstrainSelectedInstOperands,
     /* 146571 */     // GIR_Coverage, 2621,
     /* 146571 */     GIR_Done,
     /* 146572 */   // Label 3190: @146572
     /* 146572 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(146599), // Rule ID 4854 //
     /* 146577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146592 */     // (ssubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 146592 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ256rr),
     /* 146597 */     GIR_RootConstrainSelectedInstOperands,
     /* 146598 */     // GIR_Coverage, 4854,
     /* 146598 */     GIR_Done,
     /* 146599 */   // Label 3191: @146599
     /* 146599 */   GIM_Reject,
     /* 146600 */ // Label 3187: @146600
     /* 146600 */ GIM_Reject,
     /* 146601 */ // Label 3171: @146601
     /* 146601 */ GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(146791),
     /* 146606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 146609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 146612 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(146674), // Rule ID 2616 //
     /* 146617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146636 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146656 */     // (ssubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBYrm),
     /* 146659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146661 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146672 */     GIR_RootConstrainSelectedInstOperands,
     /* 146673 */     // GIR_Coverage, 2616,
     /* 146673 */     GIR_EraseRootFromParent_Done,
     /* 146674 */   // Label 3193: @146674
     /* 146674 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(146736), // Rule ID 4875 //
     /* 146679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146698 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146701 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146705 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146718 */     // (ssubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ256rm),
     /* 146721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146723 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146725 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146734 */     GIR_RootConstrainSelectedInstOperands,
     /* 146735 */     // GIR_Coverage, 4875,
     /* 146735 */     GIR_EraseRootFromParent_Done,
     /* 146736 */   // Label 3194: @146736
     /* 146736 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(146763), // Rule ID 2615 //
     /* 146741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146756 */     // (ssubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 146756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBYrr),
     /* 146761 */     GIR_RootConstrainSelectedInstOperands,
     /* 146762 */     // GIR_Coverage, 2615,
     /* 146762 */     GIR_Done,
     /* 146763 */   // Label 3195: @146763
     /* 146763 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(146790), // Rule ID 4872 //
     /* 146768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146783 */     // (ssubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 146783 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ256rr),
     /* 146788 */     GIR_RootConstrainSelectedInstOperands,
     /* 146789 */     // GIR_Coverage, 4872,
     /* 146789 */     GIR_Done,
     /* 146790 */   // Label 3196: @146790
     /* 146790 */   GIM_Reject,
     /* 146791 */ // Label 3192: @146791
     /* 146791 */ GIM_Reject,
     /* 146792 */ // Label 3172: @146792
     /* 146792 */ GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(146885),
     /* 146797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 146800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 146803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146811 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(146865), // Rule ID 4851 //
     /* 146816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146827 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146830 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146834 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146847 */     // (ssubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZrm),
     /* 146850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146852 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146854 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146863 */     GIR_RootConstrainSelectedInstOperands,
     /* 146864 */     // GIR_Coverage, 4851,
     /* 146864 */     GIR_EraseRootFromParent_Done,
     /* 146865 */   // Label 3198: @146865
     /* 146865 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(146884), // Rule ID 4848 //
     /* 146870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146877 */     // (ssubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 146877 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZrr),
     /* 146882 */     GIR_RootConstrainSelectedInstOperands,
     /* 146883 */     // GIR_Coverage, 4848,
     /* 146883 */     GIR_Done,
     /* 146884 */   // Label 3199: @146884
     /* 146884 */   GIM_Reject,
     /* 146885 */ // Label 3197: @146885
     /* 146885 */ GIM_Reject,
     /* 146886 */ // Label 3173: @146886
     /* 146886 */ GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(146979),
     /* 146891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 146894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 146897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146905 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(146959), // Rule ID 4869 //
     /* 146910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146921 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146924 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146928 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146941 */     // (ssubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZrm),
     /* 146944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146946 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146948 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146957 */     GIR_RootConstrainSelectedInstOperands,
     /* 146958 */     // GIR_Coverage, 4869,
     /* 146958 */     GIR_EraseRootFromParent_Done,
     /* 146959 */   // Label 3201: @146959
     /* 146959 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(146978), // Rule ID 4866 //
     /* 146964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146971 */     // (ssubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 146971 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZrr),
     /* 146976 */     GIR_RootConstrainSelectedInstOperands,
     /* 146977 */     // GIR_Coverage, 4866,
     /* 146977 */     GIR_Done,
     /* 146978 */   // Label 3202: @146978
     /* 146978 */   GIM_Reject,
     /* 146979 */ // Label 3200: @146979
     /* 146979 */ GIM_Reject,
     /* 146980 */ // Label 3174: @146980
     /* 146980 */ GIM_Reject,
     /* 146981 */ // Label 41: @146981
     /* 146981 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3216*/ GIMT_Encode4(152082),
     /* 146992 */ /*GILLT_s16*//*Label 3203*/ GIMT_Encode4(147076),
     /* 146996 */ /*GILLT_s32*//*Label 3204*/ GIMT_Encode4(147236),
     /* 147000 */ /*GILLT_s64*//*Label 3205*/ GIMT_Encode4(148349),
     /* 147004 */ /*GILLT_s80*//*Label 3206*/ GIMT_Encode4(149606), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 147016 */ /*GILLT_v2s64*//*Label 3207*/ GIMT_Encode4(149928), GIMT_Encode4(0),
     /* 147024 */ /*GILLT_v4s32*//*Label 3208*/ GIMT_Encode4(150282),
     /* 147028 */ /*GILLT_v4s64*//*Label 3209*/ GIMT_Encode4(150636), GIMT_Encode4(0),
     /* 147036 */ /*GILLT_v8s16*//*Label 3210*/ GIMT_Encode4(150959),
     /* 147040 */ /*GILLT_v8s32*//*Label 3211*/ GIMT_Encode4(151119),
     /* 147044 */ /*GILLT_v8s64*//*Label 3212*/ GIMT_Encode4(151442), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 147056 */ /*GILLT_v16s16*//*Label 3213*/ GIMT_Encode4(151602),
     /* 147060 */ /*GILLT_v16s32*//*Label 3214*/ GIMT_Encode4(151762), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 147072 */ /*GILLT_v32s16*//*Label 3215*/ GIMT_Encode4(151922),
     /* 147076 */ // Label 3203: @147076
     /* 147076 */ GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(147235),
     /* 147081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 147084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 147087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147091 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(147149), // Rule ID 24247 //
     /* 147096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 147099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147107 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147114 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147124 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147131 */     // (fadd:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 147134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147136 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 147138 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147147 */     GIR_RootConstrainSelectedInstOperands,
     /* 147148 */     // GIR_Coverage, 24247,
     /* 147148 */     GIR_EraseRootFromParent_Done,
     /* 147149 */   // Label 3218: @147149
     /* 147149 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(147207), // Rule ID 5954 //
     /* 147154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 147157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147169 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147172 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147176 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147189 */     // (fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 147192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147194 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147196 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147205 */     GIR_RootConstrainSelectedInstOperands,
     /* 147206 */     // GIR_Coverage, 5954,
     /* 147206 */     GIR_EraseRootFromParent_Done,
     /* 147207 */   // Label 3219: @147207
     /* 147207 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(147234), // Rule ID 5952 //
     /* 147212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 147215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147223 */     // (fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VADDSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 147223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSHZrr),
     /* 147228 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 147232 */     GIR_RootConstrainSelectedInstOperands,
     /* 147233 */     // GIR_Coverage, 5952,
     /* 147233 */     GIR_Done,
     /* 147234 */   // Label 3220: @147234
     /* 147234 */   GIM_Reject,
     /* 147235 */ // Label 3217: @147235
     /* 147235 */ GIM_Reject,
     /* 147236 */ // Label 3204: @147236
     /* 147236 */ GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(148348),
     /* 147241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 147244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147247 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(147325), // Rule ID 26015 //
     /* 147252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 147255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 147267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 147271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147279 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 147282 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147289 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 147293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 147299 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147306 */     // (fadd:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_32>>), FR32:{ *:[f32] }:$src1)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 147309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147311 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 147313 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 147323 */     GIR_RootConstrainSelectedInstOperands,
     /* 147324 */     // GIR_Coverage, 26015,
     /* 147324 */     GIR_EraseRootFromParent_Done,
     /* 147325 */   // Label 3222: @147325
     /* 147325 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(147403), // Rule ID 26016 //
     /* 147330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 147333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 147345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 147349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147357 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 147360 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147367 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 147371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 147377 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147384 */     // (fadd:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_32>>), FR32:{ *:[f32] }:$src1)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 147387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147389 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 147391 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 147401 */     GIR_RootConstrainSelectedInstOperands,
     /* 147402 */     // GIR_Coverage, 26016,
     /* 147402 */     GIR_EraseRootFromParent_Done,
     /* 147403 */   // Label 3223: @147403
     /* 147403 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(147481), // Rule ID 26017 //
     /* 147408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 147411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 147415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 147423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 147427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147435 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 147438 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147445 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 147449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 147453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 147455 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147462 */     // (fadd:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_32>>), FR32X:{ *:[f32] }:$src1)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 147465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147467 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 147469 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 147479 */     GIR_RootConstrainSelectedInstOperands,
     /* 147480 */     // GIR_Coverage, 26017,
     /* 147480 */     GIR_EraseRootFromParent_Done,
     /* 147481 */   // Label 3224: @147481
     /* 147481 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(147559), // Rule ID 22466 //
     /* 147486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 147489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 147505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 147509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147517 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 147520 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147527 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 147531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 147533 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147540 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_32>>))  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 147543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147545 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 147557 */     GIR_RootConstrainSelectedInstOperands,
     /* 147558 */     // GIR_Coverage, 22466,
     /* 147558 */     GIR_EraseRootFromParent_Done,
     /* 147559 */   // Label 3225: @147559
     /* 147559 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(147637), // Rule ID 22467 //
     /* 147564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 147567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 147583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 147587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147595 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 147598 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147605 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 147609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 147611 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147618 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_32>>))  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 147621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147623 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 147635 */     GIR_RootConstrainSelectedInstOperands,
     /* 147636 */     // GIR_Coverage, 22467,
     /* 147636 */     GIR_EraseRootFromParent_Done,
     /* 147637 */   // Label 3226: @147637
     /* 147637 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(147715), // Rule ID 22468 //
     /* 147642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 147645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 147649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 147653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 147661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 147665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147673 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 147676 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147683 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 147687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 147689 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147696 */     // (fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_32>>))  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 147699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147701 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147703 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 147713 */     GIR_RootConstrainSelectedInstOperands,
     /* 147714 */     // GIR_Coverage, 22468,
     /* 147714 */     GIR_EraseRootFromParent_Done,
     /* 147715 */   // Label 3227: @147715
     /* 147715 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(147780), // Rule ID 23234 //
     /* 147720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 147723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 147727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147735 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147738 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147742 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 147750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147752 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147759 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 147762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147764 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 147766 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147770 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 147773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147778 */     GIR_RootConstrainSelectedInstOperands,
     /* 147779 */     // GIR_Coverage, 23234,
     /* 147779 */     GIR_EraseRootFromParent_Done,
     /* 147780 */   // Label 3228: @147780
     /* 147780 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(147842), // Rule ID 23379 //
     /* 147785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 147788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147800 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147803 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147807 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147824 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 147827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147829 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 147831 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147840 */     GIR_RootConstrainSelectedInstOperands,
     /* 147841 */     // GIR_Coverage, 23379,
     /* 147841 */     GIR_EraseRootFromParent_Done,
     /* 147842 */   // Label 3229: @147842
     /* 147842 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(147904), // Rule ID 23383 //
     /* 147847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 147850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147862 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147865 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147869 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147879 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147886 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 147889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147891 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 147893 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147902 */     GIR_RootConstrainSelectedInstOperands,
     /* 147903 */     // GIR_Coverage, 23383,
     /* 147903 */     GIR_EraseRootFromParent_Done,
     /* 147904 */   // Label 3230: @147904
     /* 147904 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(147966), // Rule ID 24243 //
     /* 147909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 147912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 147916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147924 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147927 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147931 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 147939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147948 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 147951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147953 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 147955 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147964 */     GIR_RootConstrainSelectedInstOperands,
     /* 147965 */     // GIR_Coverage, 24243,
     /* 147965 */     GIR_EraseRootFromParent_Done,
     /* 147966 */   // Label 3231: @147966
     /* 147966 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(148031), // Rule ID 910 //
     /* 147971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 147974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 147978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 147982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147990 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147993 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147997 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148003 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148010 */     // (fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 148013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148015 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148017 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148029 */     GIR_RootConstrainSelectedInstOperands,
     /* 148030 */     // GIR_Coverage, 910,
     /* 148030 */     GIR_EraseRootFromParent_Done,
     /* 148031 */   // Label 3232: @148031
     /* 148031 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(148093), // Rule ID 2160 //
     /* 148036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148055 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148058 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148062 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148068 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148075 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 148078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148080 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148082 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148091 */     GIR_RootConstrainSelectedInstOperands,
     /* 148092 */     // GIR_Coverage, 2160,
     /* 148092 */     GIR_EraseRootFromParent_Done,
     /* 148093 */   // Label 3233: @148093
     /* 148093 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(148155), // Rule ID 2168 //
     /* 148098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 148101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148117 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148120 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148124 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148130 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148137 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 148140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148142 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148144 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148153 */     GIR_RootConstrainSelectedInstOperands,
     /* 148154 */     // GIR_Coverage, 2168,
     /* 148154 */     GIR_EraseRootFromParent_Done,
     /* 148155 */   // Label 3234: @148155
     /* 148155 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(148217), // Rule ID 5916 //
     /* 148160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148179 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148182 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148186 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148192 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148199 */     // (fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 148202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148204 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148206 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148215 */     GIR_RootConstrainSelectedInstOperands,
     /* 148216 */     // GIR_Coverage, 5916,
     /* 148216 */     GIR_EraseRootFromParent_Done,
     /* 148217 */   // Label 3235: @148217
     /* 148217 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(148254), // Rule ID 886 //
     /* 148222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148237 */     // (fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (ADD_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 148237 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32),
     /* 148242 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 148248 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 148252 */     GIR_RootConstrainSelectedInstOperands,
     /* 148253 */     // GIR_Coverage, 886,
     /* 148253 */     GIR_Done,
     /* 148254 */   // Label 3236: @148254
     /* 148254 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(148285), // Rule ID 2158 //
     /* 148259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148274 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 148274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSrr),
     /* 148279 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 148283 */     GIR_RootConstrainSelectedInstOperands,
     /* 148284 */     // GIR_Coverage, 2158,
     /* 148284 */     GIR_Done,
     /* 148285 */   // Label 3237: @148285
     /* 148285 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(148316), // Rule ID 2166 //
     /* 148290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 148293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148305 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (ADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 148305 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSSrr),
     /* 148310 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 148314 */     GIR_RootConstrainSelectedInstOperands,
     /* 148315 */     // GIR_Coverage, 2166,
     /* 148315 */     GIR_Done,
     /* 148316 */   // Label 3238: @148316
     /* 148316 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(148347), // Rule ID 5914 //
     /* 148321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148336 */     // (fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VADDSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 148336 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSZrr),
     /* 148341 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 148345 */     GIR_RootConstrainSelectedInstOperands,
     /* 148346 */     // GIR_Coverage, 5914,
     /* 148346 */     GIR_Done,
     /* 148347 */   // Label 3239: @148347
     /* 148347 */   GIM_Reject,
     /* 148348 */ // Label 3221: @148348
     /* 148348 */ GIM_Reject,
     /* 148349 */ // Label 3205: @148349
     /* 148349 */ GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(149605),
     /* 148354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 148357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148360 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(148438), // Rule ID 26018 //
     /* 148365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 148368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 148372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 148384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148392 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148395 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 148402 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 148410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148412 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148419 */     // (fadd:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_64>>), FR64:{ *:[f64] }:$src1)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 148422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148424 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148426 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148436 */     GIR_RootConstrainSelectedInstOperands,
     /* 148437 */     // GIR_Coverage, 26018,
     /* 148437 */     GIR_EraseRootFromParent_Done,
     /* 148438 */   // Label 3241: @148438
     /* 148438 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(148516), // Rule ID 26019 //
     /* 148443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 148450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 148462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148470 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148473 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 148480 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 148488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148490 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148497 */     // (fadd:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_64>>), FR64:{ *:[f64] }:$src1)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 148500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148502 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148504 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148514 */     GIR_RootConstrainSelectedInstOperands,
     /* 148515 */     // GIR_Coverage, 26019,
     /* 148515 */     GIR_EraseRootFromParent_Done,
     /* 148516 */   // Label 3242: @148516
     /* 148516 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(148594), // Rule ID 26020 //
     /* 148521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 148528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 148540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148548 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148551 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 148558 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 148566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148575 */     // (fadd:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_64>>), FR64X:{ *:[f64] }:$src1)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 148578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148580 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148582 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148592 */     GIR_RootConstrainSelectedInstOperands,
     /* 148593 */     // GIR_Coverage, 26020,
     /* 148593 */     GIR_EraseRootFromParent_Done,
     /* 148594 */   // Label 3243: @148594
     /* 148594 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(148672), // Rule ID 22469 //
     /* 148599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 148602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 148606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 148610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 148622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148630 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148633 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 148640 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148646 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148653 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_64>>))  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 148656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148658 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148660 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148670 */     GIR_RootConstrainSelectedInstOperands,
     /* 148671 */     // GIR_Coverage, 22469,
     /* 148671 */     GIR_EraseRootFromParent_Done,
     /* 148672 */   // Label 3244: @148672
     /* 148672 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(148750), // Rule ID 22470 //
     /* 148677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 148684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 148688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 148700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148708 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148711 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 148718 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148724 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148731 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_64>>))  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 148734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148736 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148738 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148748 */     GIR_RootConstrainSelectedInstOperands,
     /* 148749 */     // GIR_Coverage, 22470,
     /* 148749 */     GIR_EraseRootFromParent_Done,
     /* 148750 */   // Label 3245: @148750
     /* 148750 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(148828), // Rule ID 22471 //
     /* 148755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 148762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 148766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 148778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148786 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148789 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 148796 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148802 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148809 */     // (fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_64>>))  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 148812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148814 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148816 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148826 */     GIR_RootConstrainSelectedInstOperands,
     /* 148827 */     // GIR_Coverage, 22471,
     /* 148827 */     GIR_EraseRootFromParent_Done,
     /* 148828 */   // Label 3246: @148828
     /* 148828 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(148893), // Rule ID 23236 //
     /* 148833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 148836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 148840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148848 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148851 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148855 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 148863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148872 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 148875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148877 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148879 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148883 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148891 */     GIR_RootConstrainSelectedInstOperands,
     /* 148892 */     // GIR_Coverage, 23236,
     /* 148892 */     GIR_EraseRootFromParent_Done,
     /* 148893 */   // Label 3247: @148893
     /* 148893 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(148965), // Rule ID 23238 //
     /* 148898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 148901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 148905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148913 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148916 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148920 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148927 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 148935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148944 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 148947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148949 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148951 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148963 */     GIR_RootConstrainSelectedInstOperands,
     /* 148964 */     // GIR_Coverage, 23238,
     /* 148964 */     GIR_EraseRootFromParent_Done,
     /* 148965 */   // Label 3248: @148965
     /* 148965 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(149027), // Rule ID 23381 //
     /* 148970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 148977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148985 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148988 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148992 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149009 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 149012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149014 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149016 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149025 */     GIR_RootConstrainSelectedInstOperands,
     /* 149026 */     // GIR_Coverage, 23381,
     /* 149026 */     GIR_EraseRootFromParent_Done,
     /* 149027 */   // Label 3249: @149027
     /* 149027 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(149089), // Rule ID 23385 //
     /* 149032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 149035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149047 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149050 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149054 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149071 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 149074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149076 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149078 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149087 */     GIR_RootConstrainSelectedInstOperands,
     /* 149088 */     // GIR_Coverage, 23385,
     /* 149088 */     GIR_EraseRootFromParent_Done,
     /* 149089 */   // Label 3250: @149089
     /* 149089 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(149151), // Rule ID 24245 //
     /* 149094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149109 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149112 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149116 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149126 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149133 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 149136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149138 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149140 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149149 */     GIR_RootConstrainSelectedInstOperands,
     /* 149150 */     // GIR_Coverage, 24245,
     /* 149150 */     GIR_EraseRootFromParent_Done,
     /* 149151 */   // Label 3251: @149151
     /* 149151 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(149216), // Rule ID 912 //
     /* 149156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 149159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149175 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149178 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149182 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149188 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149195 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 149198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149200 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149202 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149214 */     GIR_RootConstrainSelectedInstOperands,
     /* 149215 */     // GIR_Coverage, 912,
     /* 149215 */     GIR_EraseRootFromParent_Done,
     /* 149216 */   // Label 3252: @149216
     /* 149216 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(149288), // Rule ID 914 //
     /* 149221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 149224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149240 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149243 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149247 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149254 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149260 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149267 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 149270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149272 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149274 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149286 */     GIR_RootConstrainSelectedInstOperands,
     /* 149287 */     // GIR_Coverage, 914,
     /* 149287 */     GIR_EraseRootFromParent_Done,
     /* 149288 */   // Label 3253: @149288
     /* 149288 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(149350), // Rule ID 2164 //
     /* 149293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 149296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149312 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149315 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149319 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149332 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 149335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149337 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149339 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149348 */     GIR_RootConstrainSelectedInstOperands,
     /* 149349 */     // GIR_Coverage, 2164,
     /* 149349 */     GIR_EraseRootFromParent_Done,
     /* 149350 */   // Label 3254: @149350
     /* 149350 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(149412), // Rule ID 2172 //
     /* 149355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 149358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149374 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149377 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149381 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149394 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 149397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149399 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149401 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149410 */     GIR_RootConstrainSelectedInstOperands,
     /* 149411 */     // GIR_Coverage, 2172,
     /* 149411 */     GIR_EraseRootFromParent_Done,
     /* 149412 */   // Label 3255: @149412
     /* 149412 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(149474), // Rule ID 5935 //
     /* 149417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149436 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149439 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149443 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149449 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149456 */     // (fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 149459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149461 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149463 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149472 */     GIR_RootConstrainSelectedInstOperands,
     /* 149473 */     // GIR_Coverage, 5935,
     /* 149473 */     GIR_EraseRootFromParent_Done,
     /* 149474 */   // Label 3256: @149474
     /* 149474 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(149511), // Rule ID 888 //
     /* 149479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 149482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149494 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (ADD_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 149494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64),
     /* 149499 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 149505 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 149509 */     GIR_RootConstrainSelectedInstOperands,
     /* 149510 */     // GIR_Coverage, 888,
     /* 149510 */     GIR_Done,
     /* 149511 */   // Label 3257: @149511
     /* 149511 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(149542), // Rule ID 2162 //
     /* 149516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 149519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149531 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 149531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDrr),
     /* 149536 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 149540 */     GIR_RootConstrainSelectedInstOperands,
     /* 149541 */     // GIR_Coverage, 2162,
     /* 149541 */     GIR_Done,
     /* 149542 */   // Label 3258: @149542
     /* 149542 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(149573), // Rule ID 2170 //
     /* 149547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 149550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149562 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (ADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 149562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSDrr),
     /* 149567 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 149571 */     GIR_RootConstrainSelectedInstOperands,
     /* 149572 */     // GIR_Coverage, 2170,
     /* 149572 */     GIR_Done,
     /* 149573 */   // Label 3259: @149573
     /* 149573 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(149604), // Rule ID 5933 //
     /* 149578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149593 */     // (fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VADDSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 149593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDZrr),
     /* 149598 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 149602 */     GIR_RootConstrainSelectedInstOperands,
     /* 149603 */     // GIR_Coverage, 5933,
     /* 149603 */     GIR_Done,
     /* 149604 */   // Label 3260: @149604
     /* 149604 */   GIM_Reject,
     /* 149605 */ // Label 3240: @149605
     /* 149605 */ GIM_Reject,
     /* 149606 */ // Label 3206: @149606
     /* 149606 */ GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(149927),
     /* 149611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 149614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 149617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 149621 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(149689), // Rule ID 23240 //
     /* 149626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 149629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149637 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149640 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149644 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149651 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 149659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149668 */     // (fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 149671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149673 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149675 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149679 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149687 */     GIR_RootConstrainSelectedInstOperands,
     /* 149688 */     // GIR_Coverage, 23240,
     /* 149688 */     GIR_EraseRootFromParent_Done,
     /* 149689 */   // Label 3262: @149689
     /* 149689 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(149757), // Rule ID 23242 //
     /* 149694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 149697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149705 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149708 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149712 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149719 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 149727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149736 */     // (fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 149739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149741 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149743 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149747 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149755 */     GIR_RootConstrainSelectedInstOperands,
     /* 149756 */     // GIR_Coverage, 23242,
     /* 149756 */     GIR_EraseRootFromParent_Done,
     /* 149757 */   // Label 3263: @149757
     /* 149757 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(149825), // Rule ID 916 //
     /* 149762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 149765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 149769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149777 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149780 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149784 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149791 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149804 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 149807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149809 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149811 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149815 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149823 */     GIR_RootConstrainSelectedInstOperands,
     /* 149824 */     // GIR_Coverage, 916,
     /* 149824 */     GIR_EraseRootFromParent_Done,
     /* 149825 */   // Label 3264: @149825
     /* 149825 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(149893), // Rule ID 918 //
     /* 149830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 149833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 149837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149845 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149848 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149852 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149859 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149872 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 149875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149877 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149879 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149883 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149891 */     GIR_RootConstrainSelectedInstOperands,
     /* 149892 */     // GIR_Coverage, 918,
     /* 149892 */     GIR_EraseRootFromParent_Done,
     /* 149893 */   // Label 3265: @149893
     /* 149893 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(149926), // Rule ID 890 //
     /* 149898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 149901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 149905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 149909 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (ADD_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 149909 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80),
     /* 149914 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 149920 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 149924 */     GIR_RootConstrainSelectedInstOperands,
     /* 149925 */     // GIR_Coverage, 890,
     /* 149925 */     GIR_Done,
     /* 149926 */   // Label 3266: @149926
     /* 149926 */   GIM_Reject,
     /* 149927 */ // Label 3261: @149927
     /* 149927 */ GIM_Reject,
     /* 149928 */ // Label 3207: @149928
     /* 149928 */ GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(150281),
     /* 149933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 149936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 149939 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(150001), // Rule ID 23369 //
     /* 149944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 149947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 149951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149959 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149962 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149966 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 149974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149983 */     // (fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 149986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149988 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149990 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149999 */     GIR_RootConstrainSelectedInstOperands,
     /* 150000 */     // GIR_Coverage, 23369,
     /* 150000 */     GIR_EraseRootFromParent_Done,
     /* 150001 */   // Label 3268: @150001
     /* 150001 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(150063), // Rule ID 24293 //
     /* 150006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 150009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150021 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150024 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150028 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150045 */     // (fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 150048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150050 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150052 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150061 */     GIR_RootConstrainSelectedInstOperands,
     /* 150062 */     // GIR_Coverage, 24293,
     /* 150062 */     GIR_EraseRootFromParent_Done,
     /* 150063 */   // Label 3269: @150063
     /* 150063 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(150125), // Rule ID 2140 //
     /* 150068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 150071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150087 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150090 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150094 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150100 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150107 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 150110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150112 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150114 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150123 */     GIR_RootConstrainSelectedInstOperands,
     /* 150124 */     // GIR_Coverage, 2140,
     /* 150124 */     GIR_EraseRootFromParent_Done,
     /* 150125 */   // Label 3270: @150125
     /* 150125 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(150187), // Rule ID 6308 //
     /* 150130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 150133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150149 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150152 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150156 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150169 */     // (fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 150172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150174 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150176 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150185 */     GIR_RootConstrainSelectedInstOperands,
     /* 150186 */     // GIR_Coverage, 6308,
     /* 150186 */     GIR_EraseRootFromParent_Done,
     /* 150187 */   // Label 3271: @150187
     /* 150187 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(150218), // Rule ID 2138 //
     /* 150192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 150195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150207 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 150207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDrr),
     /* 150212 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150216 */     GIR_RootConstrainSelectedInstOperands,
     /* 150217 */     // GIR_Coverage, 2138,
     /* 150217 */     GIR_Done,
     /* 150218 */   // Label 3272: @150218
     /* 150218 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(150249), // Rule ID 2154 //
     /* 150223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 150226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150238 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (ADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 150238 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPDrr),
     /* 150243 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150247 */     GIR_RootConstrainSelectedInstOperands,
     /* 150248 */     // GIR_Coverage, 2154,
     /* 150248 */     GIR_Done,
     /* 150249 */   // Label 3273: @150249
     /* 150249 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(150280), // Rule ID 6304 //
     /* 150254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 150257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150269 */     // (fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VADDPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 150269 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rr),
     /* 150274 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150278 */     GIR_RootConstrainSelectedInstOperands,
     /* 150279 */     // GIR_Coverage, 6304,
     /* 150279 */     GIR_Done,
     /* 150280 */   // Label 3274: @150280
     /* 150280 */   GIM_Reject,
     /* 150281 */ // Label 3267: @150281
     /* 150281 */ GIM_Reject,
     /* 150282 */ // Label 3208: @150282
     /* 150282 */ GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(150635),
     /* 150287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150293 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(150355), // Rule ID 23367 //
     /* 150298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 150301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150313 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150316 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150320 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150337 */     // (fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 150340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150342 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150344 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150353 */     GIR_RootConstrainSelectedInstOperands,
     /* 150354 */     // GIR_Coverage, 23367,
     /* 150354 */     GIR_EraseRootFromParent_Done,
     /* 150355 */   // Label 3276: @150355
     /* 150355 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(150417), // Rule ID 24277 //
     /* 150360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 150363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150375 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150378 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150382 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150392 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150399 */     // (fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 150402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150404 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150406 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150415 */     GIR_RootConstrainSelectedInstOperands,
     /* 150416 */     // GIR_Coverage, 24277,
     /* 150416 */     GIR_EraseRootFromParent_Done,
     /* 150417 */   // Label 3277: @150417
     /* 150417 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(150479), // Rule ID 2136 //
     /* 150422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 150425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150441 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150444 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150448 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150461 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 150464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150466 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150468 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150477 */     GIR_RootConstrainSelectedInstOperands,
     /* 150478 */     // GIR_Coverage, 2136,
     /* 150478 */     GIR_EraseRootFromParent_Done,
     /* 150479 */   // Label 3278: @150479
     /* 150479 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(150541), // Rule ID 6284 //
     /* 150484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 150487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150503 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150506 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150510 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150523 */     // (fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 150526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150528 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150530 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150539 */     GIR_RootConstrainSelectedInstOperands,
     /* 150540 */     // GIR_Coverage, 6284,
     /* 150540 */     GIR_EraseRootFromParent_Done,
     /* 150541 */   // Label 3279: @150541
     /* 150541 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(150572), // Rule ID 2134 //
     /* 150546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 150549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150561 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 150561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSrr),
     /* 150566 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150570 */     GIR_RootConstrainSelectedInstOperands,
     /* 150571 */     // GIR_Coverage, 2134,
     /* 150571 */     GIR_Done,
     /* 150572 */   // Label 3280: @150572
     /* 150572 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(150603), // Rule ID 2150 //
     /* 150577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 150580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 150592 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (ADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 150592 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPSrr),
     /* 150597 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150601 */     GIR_RootConstrainSelectedInstOperands,
     /* 150602 */     // GIR_Coverage, 2150,
     /* 150602 */     GIR_Done,
     /* 150603 */   // Label 3281: @150603
     /* 150603 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(150634), // Rule ID 6280 //
     /* 150608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 150611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150623 */     // (fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VADDPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 150623 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rr),
     /* 150628 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150632 */     GIR_RootConstrainSelectedInstOperands,
     /* 150633 */     // GIR_Coverage, 6280,
     /* 150633 */     GIR_Done,
     /* 150634 */   // Label 3282: @150634
     /* 150634 */   GIM_Reject,
     /* 150635 */ // Label 3275: @150635
     /* 150635 */ GIM_Reject,
     /* 150636 */ // Label 3209: @150636
     /* 150636 */ GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(150958),
     /* 150641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 150644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 150647 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(150709), // Rule ID 23373 //
     /* 150652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 150655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 150659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150667 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150670 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150674 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 150682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150684 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150691 */     // (fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 150694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150696 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150698 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150707 */     GIR_RootConstrainSelectedInstOperands,
     /* 150708 */     // GIR_Coverage, 23373,
     /* 150708 */     GIR_EraseRootFromParent_Done,
     /* 150709 */   // Label 3284: @150709
     /* 150709 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(150771), // Rule ID 24301 //
     /* 150714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 150717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 150721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150729 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150732 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150736 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 150744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150746 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150753 */     // (fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 150756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150758 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150760 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150769 */     GIR_RootConstrainSelectedInstOperands,
     /* 150770 */     // GIR_Coverage, 24301,
     /* 150770 */     GIR_EraseRootFromParent_Done,
     /* 150771 */   // Label 3285: @150771
     /* 150771 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(150833), // Rule ID 2148 //
     /* 150776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 150779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 150783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 150787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150795 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150798 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150802 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150808 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150815 */     // (fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 150818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150820 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150822 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150831 */     GIR_RootConstrainSelectedInstOperands,
     /* 150832 */     // GIR_Coverage, 2148,
     /* 150832 */     GIR_EraseRootFromParent_Done,
     /* 150833 */   // Label 3286: @150833
     /* 150833 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(150895), // Rule ID 6320 //
     /* 150838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 150841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 150845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 150849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150857 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150860 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150864 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150877 */     // (fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 150880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150882 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150884 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150893 */     GIR_RootConstrainSelectedInstOperands,
     /* 150894 */     // GIR_Coverage, 6320,
     /* 150894 */     GIR_EraseRootFromParent_Done,
     /* 150895 */   // Label 3287: @150895
     /* 150895 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(150926), // Rule ID 2146 //
     /* 150900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 150903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 150907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 150911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 150915 */     // (fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VADDPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 150915 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDYrr),
     /* 150920 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150924 */     GIR_RootConstrainSelectedInstOperands,
     /* 150925 */     // GIR_Coverage, 2146,
     /* 150925 */     GIR_Done,
     /* 150926 */   // Label 3288: @150926
     /* 150926 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(150957), // Rule ID 6316 //
     /* 150931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 150934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 150938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 150942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 150946 */     // (fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VADDPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 150946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rr),
     /* 150951 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150955 */     GIR_RootConstrainSelectedInstOperands,
     /* 150956 */     // GIR_Coverage, 6316,
     /* 150956 */     GIR_Done,
     /* 150957 */   // Label 3289: @150957
     /* 150957 */   GIM_Reject,
     /* 150958 */ // Label 3283: @150958
     /* 150958 */ GIM_Reject,
     /* 150959 */ // Label 3210: @150959
     /* 150959 */ GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(151118),
     /* 150964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 150974 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(151032), // Rule ID 24317 //
     /* 150979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 150982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150990 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150993 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150997 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151014 */     // (fadd:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 151017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151019 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151021 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151030 */     GIR_RootConstrainSelectedInstOperands,
     /* 151031 */     // GIR_Coverage, 24317,
     /* 151031 */     GIR_EraseRootFromParent_Done,
     /* 151032 */   // Label 3291: @151032
     /* 151032 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(151090), // Rule ID 6344 //
     /* 151037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 151040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151052 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151055 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151059 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151072 */     // (fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 151075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151077 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151079 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151088 */     GIR_RootConstrainSelectedInstOperands,
     /* 151089 */     // GIR_Coverage, 6344,
     /* 151089 */     GIR_EraseRootFromParent_Done,
     /* 151090 */   // Label 3292: @151090
     /* 151090 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(151117), // Rule ID 6340 //
     /* 151095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 151098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151106 */     // (fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VADDPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 151106 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rr),
     /* 151111 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151115 */     GIR_RootConstrainSelectedInstOperands,
     /* 151116 */     // GIR_Coverage, 6340,
     /* 151116 */     GIR_Done,
     /* 151117 */   // Label 3293: @151117
     /* 151117 */   GIM_Reject,
     /* 151118 */ // Label 3290: @151118
     /* 151118 */ GIM_Reject,
     /* 151119 */ // Label 3211: @151119
     /* 151119 */ GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(151441),
     /* 151124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 151127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 151130 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(151192), // Rule ID 23371 //
     /* 151135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151150 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151153 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151157 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151174 */     // (fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 151177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151179 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151181 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151190 */     GIR_RootConstrainSelectedInstOperands,
     /* 151191 */     // GIR_Coverage, 23371,
     /* 151191 */     GIR_EraseRootFromParent_Done,
     /* 151192 */   // Label 3295: @151192
     /* 151192 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(151254), // Rule ID 24285 //
     /* 151197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151212 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151215 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151219 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151229 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151236 */     // (fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 151239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151241 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151243 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151252 */     GIR_RootConstrainSelectedInstOperands,
     /* 151253 */     // GIR_Coverage, 24285,
     /* 151253 */     GIR_EraseRootFromParent_Done,
     /* 151254 */   // Label 3296: @151254
     /* 151254 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(151316), // Rule ID 2144 //
     /* 151259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151278 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151281 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151285 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151298 */     // (fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 151301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151303 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151305 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151314 */     GIR_RootConstrainSelectedInstOperands,
     /* 151315 */     // GIR_Coverage, 2144,
     /* 151315 */     GIR_EraseRootFromParent_Done,
     /* 151316 */   // Label 3297: @151316
     /* 151316 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(151378), // Rule ID 6296 //
     /* 151321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151340 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151343 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151347 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151360 */     // (fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 151363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151365 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151367 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151376 */     GIR_RootConstrainSelectedInstOperands,
     /* 151377 */     // GIR_Coverage, 6296,
     /* 151377 */     GIR_EraseRootFromParent_Done,
     /* 151378 */   // Label 3298: @151378
     /* 151378 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(151409), // Rule ID 2142 //
     /* 151383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 151398 */     // (fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VADDPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 151398 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSYrr),
     /* 151403 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151407 */     GIR_RootConstrainSelectedInstOperands,
     /* 151408 */     // GIR_Coverage, 2142,
     /* 151408 */     GIR_Done,
     /* 151409 */   // Label 3299: @151409
     /* 151409 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(151440), // Rule ID 6292 //
     /* 151414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151429 */     // (fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VADDPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 151429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rr),
     /* 151434 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151438 */     GIR_RootConstrainSelectedInstOperands,
     /* 151439 */     // GIR_Coverage, 6292,
     /* 151439 */     GIR_Done,
     /* 151440 */   // Label 3300: @151440
     /* 151440 */   GIM_Reject,
     /* 151441 */ // Label 3294: @151441
     /* 151441 */ GIM_Reject,
     /* 151442 */ // Label 3212: @151442
     /* 151442 */ GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(151601),
     /* 151447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 151450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 151453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 151457 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(151515), // Rule ID 24269 //
     /* 151462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 151465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151473 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151476 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151480 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 151488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151497 */     // (fadd:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 151500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151502 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151504 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151513 */     GIR_RootConstrainSelectedInstOperands,
     /* 151514 */     // GIR_Coverage, 24269,
     /* 151514 */     GIR_EraseRootFromParent_Done,
     /* 151515 */   // Label 3302: @151515
     /* 151515 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(151573), // Rule ID 6272 //
     /* 151520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 151523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 151527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151535 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151538 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151542 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151555 */     // (fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 151558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151560 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151562 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151571 */     GIR_RootConstrainSelectedInstOperands,
     /* 151572 */     // GIR_Coverage, 6272,
     /* 151572 */     GIR_EraseRootFromParent_Done,
     /* 151573 */   // Label 3303: @151573
     /* 151573 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(151600), // Rule ID 6268 //
     /* 151578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 151581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 151585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 151589 */     // (fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VADDPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 151589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZrr),
     /* 151594 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151598 */     GIR_RootConstrainSelectedInstOperands,
     /* 151599 */     // GIR_Coverage, 6268,
     /* 151599 */     GIR_Done,
     /* 151600 */   // Label 3304: @151600
     /* 151600 */   GIM_Reject,
     /* 151601 */ // Label 3301: @151601
     /* 151601 */ GIM_Reject,
     /* 151602 */ // Label 3213: @151602
     /* 151602 */ GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(151761),
     /* 151607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 151610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 151613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151617 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(151675), // Rule ID 24325 //
     /* 151622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 151625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151633 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151636 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151640 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151650 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151657 */     // (fadd:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 151660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151662 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151664 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151673 */     GIR_RootConstrainSelectedInstOperands,
     /* 151674 */     // GIR_Coverage, 24325,
     /* 151674 */     GIR_EraseRootFromParent_Done,
     /* 151675 */   // Label 3306: @151675
     /* 151675 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(151733), // Rule ID 6356 //
     /* 151680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 151683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151695 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151698 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151702 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151708 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151715 */     // (fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 151718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151720 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151722 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151731 */     GIR_RootConstrainSelectedInstOperands,
     /* 151732 */     // GIR_Coverage, 6356,
     /* 151732 */     GIR_EraseRootFromParent_Done,
     /* 151733 */   // Label 3307: @151733
     /* 151733 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(151760), // Rule ID 6352 //
     /* 151738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 151741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 151749 */     // (fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VADDPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 151749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rr),
     /* 151754 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151758 */     GIR_RootConstrainSelectedInstOperands,
     /* 151759 */     // GIR_Coverage, 6352,
     /* 151759 */     GIR_Done,
     /* 151760 */   // Label 3308: @151760
     /* 151760 */   GIM_Reject,
     /* 151761 */ // Label 3305: @151761
     /* 151761 */ GIM_Reject,
     /* 151762 */ // Label 3214: @151762
     /* 151762 */ GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(151921),
     /* 151767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 151770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 151773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 151777 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(151835), // Rule ID 24261 //
     /* 151782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 151785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151793 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151796 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151800 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 151808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151817 */     // (fadd:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 151820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151822 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151824 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151833 */     GIR_RootConstrainSelectedInstOperands,
     /* 151834 */     // GIR_Coverage, 24261,
     /* 151834 */     GIR_EraseRootFromParent_Done,
     /* 151835 */   // Label 3310: @151835
     /* 151835 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(151893), // Rule ID 6260 //
     /* 151840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 151843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 151847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151855 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151858 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151862 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151875 */     // (fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 151878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151880 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151882 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151891 */     GIR_RootConstrainSelectedInstOperands,
     /* 151892 */     // GIR_Coverage, 6260,
     /* 151892 */     GIR_EraseRootFromParent_Done,
     /* 151893 */   // Label 3311: @151893
     /* 151893 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(151920), // Rule ID 6256 //
     /* 151898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 151901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 151905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 151909 */     // (fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VADDPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 151909 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZrr),
     /* 151914 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151918 */     GIR_RootConstrainSelectedInstOperands,
     /* 151919 */     // GIR_Coverage, 6256,
     /* 151919 */     GIR_Done,
     /* 151920 */   // Label 3312: @151920
     /* 151920 */   GIM_Reject,
     /* 151921 */ // Label 3309: @151921
     /* 151921 */ GIM_Reject,
     /* 151922 */ // Label 3215: @151922
     /* 151922 */ GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(152081),
     /* 151927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 151930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 151933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 151937 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(151995), // Rule ID 24309 //
     /* 151942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 151945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151953 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151956 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151960 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 151968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151977 */     // (fadd:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 151980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151982 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151984 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151993 */     GIR_RootConstrainSelectedInstOperands,
     /* 151994 */     // GIR_Coverage, 24309,
     /* 151994 */     GIR_EraseRootFromParent_Done,
     /* 151995 */   // Label 3314: @151995
     /* 151995 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(152053), // Rule ID 6332 //
     /* 152000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 152003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152015 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152018 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152022 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152028 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152035 */     // (fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 152038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152040 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152042 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152051 */     GIR_RootConstrainSelectedInstOperands,
     /* 152052 */     // GIR_Coverage, 6332,
     /* 152052 */     GIR_EraseRootFromParent_Done,
     /* 152053 */   // Label 3315: @152053
     /* 152053 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(152080), // Rule ID 6328 //
     /* 152058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 152061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152069 */     // (fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VADDPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 152069 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZrr),
     /* 152074 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152078 */     GIR_RootConstrainSelectedInstOperands,
     /* 152079 */     // GIR_Coverage, 6328,
     /* 152079 */     GIR_Done,
     /* 152080 */   // Label 3316: @152080
     /* 152080 */   GIM_Reject,
     /* 152081 */ // Label 3313: @152081
     /* 152081 */ GIM_Reject,
     /* 152082 */ // Label 3216: @152082
     /* 152082 */ GIM_Reject,
     /* 152083 */ // Label 42: @152083
     /* 152083 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3330*/ GIMT_Encode4(155476),
     /* 152094 */ /*GILLT_s16*//*Label 3317*/ GIMT_Encode4(152178),
     /* 152098 */ /*GILLT_s32*//*Label 3318*/ GIMT_Encode4(152276),
     /* 152102 */ /*GILLT_s64*//*Label 3319*/ GIMT_Encode4(152969),
     /* 152106 */ /*GILLT_s80*//*Label 3320*/ GIMT_Encode4(153806), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 152118 */ /*GILLT_v2s64*//*Label 3321*/ GIMT_Encode4(154128), GIMT_Encode4(0),
     /* 152126 */ /*GILLT_v4s32*//*Label 3322*/ GIMT_Encode4(154358),
     /* 152130 */ /*GILLT_v4s64*//*Label 3323*/ GIMT_Encode4(154588), GIMT_Encode4(0),
     /* 152138 */ /*GILLT_v8s16*//*Label 3324*/ GIMT_Encode4(154787),
     /* 152142 */ /*GILLT_v8s32*//*Label 3325*/ GIMT_Encode4(154885),
     /* 152146 */ /*GILLT_v8s64*//*Label 3326*/ GIMT_Encode4(155084), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 152158 */ /*GILLT_v16s16*//*Label 3327*/ GIMT_Encode4(155182),
     /* 152162 */ /*GILLT_v16s32*//*Label 3328*/ GIMT_Encode4(155280), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 152174 */ /*GILLT_v32s16*//*Label 3329*/ GIMT_Encode4(155378),
     /* 152178 */ // Label 3317: @152178
     /* 152178 */ GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(152275),
     /* 152183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 152186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 152189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 152193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 152197 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(152251), // Rule ID 6068 //
     /* 152202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 152205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152213 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152216 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152220 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152233 */     // (fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrm),
     /* 152236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152238 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152240 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152249 */     GIR_RootConstrainSelectedInstOperands,
     /* 152250 */     // GIR_Coverage, 6068,
     /* 152250 */     GIR_EraseRootFromParent_Done,
     /* 152251 */   // Label 3332: @152251
     /* 152251 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(152274), // Rule ID 6066 //
     /* 152256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 152259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 152263 */     // (fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VSUBSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 152263 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrr),
     /* 152268 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152272 */     GIR_RootConstrainSelectedInstOperands,
     /* 152273 */     // GIR_Coverage, 6066,
     /* 152273 */     GIR_Done,
     /* 152274 */   // Label 3333: @152274
     /* 152274 */   GIM_Reject,
     /* 152275 */ // Label 3331: @152275
     /* 152275 */ GIM_Reject,
     /* 152276 */ // Label 3318: @152276
     /* 152276 */ GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(152968),
     /* 152281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 152284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152287 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(152365), // Rule ID 22472 //
     /* 152292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 152295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 152311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 152315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 152319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152323 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152326 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152333 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 152337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 152339 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152346 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_32>>))  =>  (SUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSSrm),
     /* 152349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152351 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152353 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 152363 */     GIR_RootConstrainSelectedInstOperands,
     /* 152364 */     // GIR_Coverage, 22472,
     /* 152364 */     GIR_EraseRootFromParent_Done,
     /* 152365 */   // Label 3335: @152365
     /* 152365 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(152443), // Rule ID 22473 //
     /* 152370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 152373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 152389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 152393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 152397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152401 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152404 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152411 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 152415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 152417 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152424 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_32>>))  =>  (VSUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSrm),
     /* 152427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152429 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152431 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 152441 */     GIR_RootConstrainSelectedInstOperands,
     /* 152442 */     // GIR_Coverage, 22473,
     /* 152442 */     GIR_EraseRootFromParent_Done,
     /* 152443 */   // Label 3336: @152443
     /* 152443 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(152521), // Rule ID 22474 //
     /* 152448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 152451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 152455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 152459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 152467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 152471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 152475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152479 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152482 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152489 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 152493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 152495 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152502 */     // (fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_32>>))  =>  (VSUBSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrm),
     /* 152505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152507 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152509 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 152519 */     GIR_RootConstrainSelectedInstOperands,
     /* 152520 */     // GIR_Coverage, 22474,
     /* 152520 */     GIR_EraseRootFromParent_Done,
     /* 152521 */   // Label 3337: @152521
     /* 152521 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(152586), // Rule ID 954 //
     /* 152526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 152529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 152533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152541 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152544 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152548 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 152556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152558 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152565 */     // (fsub:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp32m),
     /* 152568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152570 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152572 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 152579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152584 */     GIR_RootConstrainSelectedInstOperands,
     /* 152585 */     // GIR_Coverage, 954,
     /* 152585 */     GIR_EraseRootFromParent_Done,
     /* 152586 */   // Label 3338: @152586
     /* 152586 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(152651), // Rule ID 932 //
     /* 152591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 152594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 152598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 152602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152610 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152613 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152617 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152623 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152630 */     // (fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32m),
     /* 152633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152635 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152637 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152641 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 152644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152649 */     GIR_RootConstrainSelectedInstOperands,
     /* 152650 */     // GIR_Coverage, 932,
     /* 152650 */     GIR_EraseRootFromParent_Done,
     /* 152651 */   // Label 3339: @152651
     /* 152651 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(152713), // Rule ID 2240 //
     /* 152656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 152659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152675 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152678 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152682 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152688 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152695 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSrm),
     /* 152698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152700 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152702 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152711 */     GIR_RootConstrainSelectedInstOperands,
     /* 152712 */     // GIR_Coverage, 2240,
     /* 152712 */     GIR_EraseRootFromParent_Done,
     /* 152713 */   // Label 3340: @152713
     /* 152713 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(152775), // Rule ID 2248 //
     /* 152718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 152721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152737 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152740 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152744 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152757 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSSrm),
     /* 152760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152762 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152764 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152773 */     GIR_RootConstrainSelectedInstOperands,
     /* 152774 */     // GIR_Coverage, 2248,
     /* 152774 */     GIR_EraseRootFromParent_Done,
     /* 152775 */   // Label 3341: @152775
     /* 152775 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(152837), // Rule ID 6030 //
     /* 152780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 152783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 152787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 152791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152799 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152802 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152806 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152812 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152819 */     // (fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrm),
     /* 152822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152824 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152826 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152835 */     GIR_RootConstrainSelectedInstOperands,
     /* 152836 */     // GIR_Coverage, 6030,
     /* 152836 */     GIR_EraseRootFromParent_Done,
     /* 152837 */   // Label 3342: @152837
     /* 152837 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(152874), // Rule ID 892 //
     /* 152842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 152845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 152849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 152853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 152857 */     // (fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (SUB_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 152857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32),
     /* 152862 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 152868 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 152872 */     GIR_RootConstrainSelectedInstOperands,
     /* 152873 */     // GIR_Coverage, 892,
     /* 152873 */     GIR_Done,
     /* 152874 */   // Label 3343: @152874
     /* 152874 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(152905), // Rule ID 2238 //
     /* 152879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 152882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152894 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VSUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 152894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSrr),
     /* 152899 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152903 */     GIR_RootConstrainSelectedInstOperands,
     /* 152904 */     // GIR_Coverage, 2238,
     /* 152904 */     GIR_Done,
     /* 152905 */   // Label 3344: @152905
     /* 152905 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(152936), // Rule ID 2246 //
     /* 152910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 152913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 152925 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (SUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 152925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSSrr),
     /* 152930 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152934 */     GIR_RootConstrainSelectedInstOperands,
     /* 152935 */     // GIR_Coverage, 2246,
     /* 152935 */     GIR_Done,
     /* 152936 */   // Label 3345: @152936
     /* 152936 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(152967), // Rule ID 6028 //
     /* 152941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 152944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 152948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 152952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 152956 */     // (fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VSUBSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 152956 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrr),
     /* 152961 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152965 */     GIR_RootConstrainSelectedInstOperands,
     /* 152966 */     // GIR_Coverage, 6028,
     /* 152966 */     GIR_Done,
     /* 152967 */   // Label 3346: @152967
     /* 152967 */   GIM_Reject,
     /* 152968 */ // Label 3334: @152968
     /* 152968 */ GIM_Reject,
     /* 152969 */ // Label 3319: @152969
     /* 152969 */ GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(153805),
     /* 152974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 152977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152980 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(153058), // Rule ID 22475 //
     /* 152985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 152988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 152992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 152996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 153004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 153008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153016 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153019 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 153026 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 153030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153032 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153039 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_64>>))  =>  (SUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSDrm),
     /* 153042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153044 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153046 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 153056 */     GIR_RootConstrainSelectedInstOperands,
     /* 153057 */     // GIR_Coverage, 22475,
     /* 153057 */     GIR_EraseRootFromParent_Done,
     /* 153058 */   // Label 3348: @153058
     /* 153058 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(153136), // Rule ID 22476 //
     /* 153063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 153066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 153070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 153074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 153082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 153086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153094 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153097 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 153104 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 153108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153110 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153117 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_64>>))  =>  (VSUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDrm),
     /* 153120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153122 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153124 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 153134 */     GIR_RootConstrainSelectedInstOperands,
     /* 153135 */     // GIR_Coverage, 22476,
     /* 153135 */     GIR_EraseRootFromParent_Done,
     /* 153136 */   // Label 3349: @153136
     /* 153136 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(153214), // Rule ID 22477 //
     /* 153141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 153148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 153152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 153160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 153164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153172 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153175 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 153182 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 153186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153188 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153195 */     // (fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_64>>))  =>  (VSUBSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrm),
     /* 153198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153200 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153202 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 153212 */     GIR_RootConstrainSelectedInstOperands,
     /* 153213 */     // GIR_Coverage, 22477,
     /* 153213 */     GIR_EraseRootFromParent_Done,
     /* 153214 */   // Label 3350: @153214
     /* 153214 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(153279), // Rule ID 956 //
     /* 153219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 153222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153234 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153237 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153241 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153251 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153258 */     // (fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m),
     /* 153261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153263 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153265 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 153272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153277 */     GIR_RootConstrainSelectedInstOperands,
     /* 153278 */     // GIR_Coverage, 956,
     /* 153278 */     GIR_EraseRootFromParent_Done,
     /* 153279 */   // Label 3351: @153279
     /* 153279 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(153351), // Rule ID 958 //
     /* 153284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 153287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153299 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153302 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153306 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153313 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153323 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153330 */     // (fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m32),
     /* 153333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153335 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153337 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153341 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 153344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153349 */     GIR_RootConstrainSelectedInstOperands,
     /* 153350 */     // GIR_Coverage, 958,
     /* 153350 */     GIR_EraseRootFromParent_Done,
     /* 153351 */   // Label 3352: @153351
     /* 153351 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(153416), // Rule ID 934 //
     /* 153356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 153359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153375 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153378 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153382 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153395 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m),
     /* 153398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153400 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153402 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 153409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153414 */     GIR_RootConstrainSelectedInstOperands,
     /* 153415 */     // GIR_Coverage, 934,
     /* 153415 */     GIR_EraseRootFromParent_Done,
     /* 153416 */   // Label 3353: @153416
     /* 153416 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(153488), // Rule ID 936 //
     /* 153421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 153424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153440 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153443 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153447 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153454 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153467 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m32),
     /* 153470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153472 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153474 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153478 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 153481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153486 */     GIR_RootConstrainSelectedInstOperands,
     /* 153487 */     // GIR_Coverage, 936,
     /* 153487 */     GIR_EraseRootFromParent_Done,
     /* 153488 */   // Label 3354: @153488
     /* 153488 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(153550), // Rule ID 2244 //
     /* 153493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 153496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 153500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 153504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153512 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153515 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153519 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153532 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDrm),
     /* 153535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153537 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153548 */     GIR_RootConstrainSelectedInstOperands,
     /* 153549 */     // GIR_Coverage, 2244,
     /* 153549 */     GIR_EraseRootFromParent_Done,
     /* 153550 */   // Label 3355: @153550
     /* 153550 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(153612), // Rule ID 2252 //
     /* 153555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 153558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 153562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 153566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153574 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153577 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153581 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153594 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSDrm),
     /* 153597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153599 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153601 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153610 */     GIR_RootConstrainSelectedInstOperands,
     /* 153611 */     // GIR_Coverage, 2252,
     /* 153611 */     GIR_EraseRootFromParent_Done,
     /* 153612 */   // Label 3356: @153612
     /* 153612 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(153674), // Rule ID 6049 //
     /* 153617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 153624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 153628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153636 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153656 */     // (fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrm),
     /* 153659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153661 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153672 */     GIR_RootConstrainSelectedInstOperands,
     /* 153673 */     // GIR_Coverage, 6049,
     /* 153673 */     GIR_EraseRootFromParent_Done,
     /* 153674 */   // Label 3357: @153674
     /* 153674 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(153711), // Rule ID 894 //
     /* 153679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 153682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 153694 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (SUB_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 153694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64),
     /* 153699 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 153705 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 153709 */     GIR_RootConstrainSelectedInstOperands,
     /* 153710 */     // GIR_Coverage, 894,
     /* 153710 */     GIR_Done,
     /* 153711 */   // Label 3358: @153711
     /* 153711 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(153742), // Rule ID 2242 //
     /* 153716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 153719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 153723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 153727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 153731 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VSUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 153731 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDrr),
     /* 153736 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153740 */     GIR_RootConstrainSelectedInstOperands,
     /* 153741 */     // GIR_Coverage, 2242,
     /* 153741 */     GIR_Done,
     /* 153742 */   // Label 3359: @153742
     /* 153742 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(153773), // Rule ID 2250 //
     /* 153747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 153750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 153754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 153758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 153762 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (SUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 153762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSDrr),
     /* 153767 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153771 */     GIR_RootConstrainSelectedInstOperands,
     /* 153772 */     // GIR_Coverage, 2250,
     /* 153772 */     GIR_Done,
     /* 153773 */   // Label 3360: @153773
     /* 153773 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(153804), // Rule ID 6047 //
     /* 153778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 153785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 153789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 153793 */     // (fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VSUBSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 153793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrr),
     /* 153798 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153802 */     GIR_RootConstrainSelectedInstOperands,
     /* 153803 */     // GIR_Coverage, 6047,
     /* 153803 */     GIR_Done,
     /* 153804 */   // Label 3361: @153804
     /* 153804 */   GIM_Reject,
     /* 153805 */ // Label 3347: @153805
     /* 153805 */ GIM_Reject,
     /* 153806 */ // Label 3320: @153806
     /* 153806 */ GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(154127),
     /* 153811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 153814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 153817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 153821 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(153889), // Rule ID 960 //
     /* 153826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 153829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153837 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153840 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153844 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153851 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 153859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153868 */     // (fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m32),
     /* 153871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153873 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153875 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153879 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 153882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153887 */     GIR_RootConstrainSelectedInstOperands,
     /* 153888 */     // GIR_Coverage, 960,
     /* 153888 */     GIR_EraseRootFromParent_Done,
     /* 153889 */   // Label 3363: @153889
     /* 153889 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(153957), // Rule ID 962 //
     /* 153894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 153897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153905 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153908 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153912 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 153919 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 153927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153929 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153936 */     // (fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m64),
     /* 153939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153941 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153943 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153947 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 153950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153955 */     GIR_RootConstrainSelectedInstOperands,
     /* 153956 */     // GIR_Coverage, 962,
     /* 153956 */     GIR_EraseRootFromParent_Done,
     /* 153957 */   // Label 3364: @153957
     /* 153957 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(154025), // Rule ID 938 //
     /* 153962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 153965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 153969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153977 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153980 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153984 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153991 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154004 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m32),
     /* 154007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154009 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154011 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154015 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154023 */     GIR_RootConstrainSelectedInstOperands,
     /* 154024 */     // GIR_Coverage, 938,
     /* 154024 */     GIR_EraseRootFromParent_Done,
     /* 154025 */   // Label 3365: @154025
     /* 154025 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(154093), // Rule ID 940 //
     /* 154030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 154033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 154037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154045 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154048 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154052 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154059 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154072 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (SUB_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m64),
     /* 154075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154077 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154079 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154091 */     GIR_RootConstrainSelectedInstOperands,
     /* 154092 */     // GIR_Coverage, 940,
     /* 154092 */     GIR_EraseRootFromParent_Done,
     /* 154093 */   // Label 3366: @154093
     /* 154093 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(154126), // Rule ID 896 //
     /* 154098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 154101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 154105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 154109 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (SUB_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 154109 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80),
     /* 154114 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 154120 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 154124 */     GIR_RootConstrainSelectedInstOperands,
     /* 154125 */     // GIR_Coverage, 896,
     /* 154125 */     GIR_Done,
     /* 154126 */   // Label 3367: @154126
     /* 154126 */   GIM_Reject,
     /* 154127 */ // Label 3362: @154127
     /* 154127 */ GIM_Reject,
     /* 154128 */ // Label 3321: @154128
     /* 154128 */ GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(154357),
     /* 154133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 154136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 154139 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(154201), // Rule ID 2220 //
     /* 154144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 154147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154163 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154166 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154170 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154183 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDrm),
     /* 154186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154188 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154190 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154199 */     GIR_RootConstrainSelectedInstOperands,
     /* 154200 */     // GIR_Coverage, 2220,
     /* 154200 */     GIR_EraseRootFromParent_Done,
     /* 154201 */   // Label 3369: @154201
     /* 154201 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(154263), // Rule ID 6542 //
     /* 154206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 154209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154225 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154228 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154232 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154238 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154245 */     // (fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rm),
     /* 154248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154250 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154252 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154261 */     GIR_RootConstrainSelectedInstOperands,
     /* 154262 */     // GIR_Coverage, 6542,
     /* 154262 */     GIR_EraseRootFromParent_Done,
     /* 154263 */   // Label 3370: @154263
     /* 154263 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(154294), // Rule ID 2218 //
     /* 154268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 154271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154283 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VSUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 154283 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDrr),
     /* 154288 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154292 */     GIR_RootConstrainSelectedInstOperands,
     /* 154293 */     // GIR_Coverage, 2218,
     /* 154293 */     GIR_Done,
     /* 154294 */   // Label 3371: @154294
     /* 154294 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(154325), // Rule ID 2234 //
     /* 154299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 154302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154314 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (SUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 154314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPDrr),
     /* 154319 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154323 */     GIR_RootConstrainSelectedInstOperands,
     /* 154324 */     // GIR_Coverage, 2234,
     /* 154324 */     GIR_Done,
     /* 154325 */   // Label 3372: @154325
     /* 154325 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(154356), // Rule ID 6538 //
     /* 154330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 154333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154345 */     // (fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VSUBPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 154345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rr),
     /* 154350 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154354 */     GIR_RootConstrainSelectedInstOperands,
     /* 154355 */     // GIR_Coverage, 6538,
     /* 154355 */     GIR_Done,
     /* 154356 */   // Label 3373: @154356
     /* 154356 */   GIM_Reject,
     /* 154357 */ // Label 3368: @154357
     /* 154357 */ GIM_Reject,
     /* 154358 */ // Label 3322: @154358
     /* 154358 */ GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(154587),
     /* 154363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154369 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(154431), // Rule ID 2216 //
     /* 154374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 154377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154393 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154396 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154400 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154413 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSrm),
     /* 154416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154418 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154420 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154429 */     GIR_RootConstrainSelectedInstOperands,
     /* 154430 */     // GIR_Coverage, 2216,
     /* 154430 */     GIR_EraseRootFromParent_Done,
     /* 154431 */   // Label 3375: @154431
     /* 154431 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(154493), // Rule ID 6518 //
     /* 154436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 154439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154455 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154458 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154462 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154475 */     // (fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rm),
     /* 154478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154480 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154482 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154491 */     GIR_RootConstrainSelectedInstOperands,
     /* 154492 */     // GIR_Coverage, 6518,
     /* 154492 */     GIR_EraseRootFromParent_Done,
     /* 154493 */   // Label 3376: @154493
     /* 154493 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(154524), // Rule ID 2214 //
     /* 154498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 154501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154513 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VSUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 154513 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSrr),
     /* 154518 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154522 */     GIR_RootConstrainSelectedInstOperands,
     /* 154523 */     // GIR_Coverage, 2214,
     /* 154523 */     GIR_Done,
     /* 154524 */   // Label 3377: @154524
     /* 154524 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(154555), // Rule ID 2230 //
     /* 154529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 154532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 154544 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (SUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 154544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPSrr),
     /* 154549 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154553 */     GIR_RootConstrainSelectedInstOperands,
     /* 154554 */     // GIR_Coverage, 2230,
     /* 154554 */     GIR_Done,
     /* 154555 */   // Label 3378: @154555
     /* 154555 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(154586), // Rule ID 6514 //
     /* 154560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 154563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154575 */     // (fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VSUBPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 154575 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rr),
     /* 154580 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154584 */     GIR_RootConstrainSelectedInstOperands,
     /* 154585 */     // GIR_Coverage, 6514,
     /* 154585 */     GIR_Done,
     /* 154586 */   // Label 3379: @154586
     /* 154586 */   GIM_Reject,
     /* 154587 */ // Label 3374: @154587
     /* 154587 */ GIM_Reject,
     /* 154588 */ // Label 3323: @154588
     /* 154588 */ GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(154786),
     /* 154593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 154596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 154599 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(154661), // Rule ID 2228 //
     /* 154604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 154607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 154611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 154615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154623 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154626 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154630 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154643 */     // (fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrm),
     /* 154646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154648 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154650 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154659 */     GIR_RootConstrainSelectedInstOperands,
     /* 154660 */     // GIR_Coverage, 2228,
     /* 154660 */     GIR_EraseRootFromParent_Done,
     /* 154661 */   // Label 3381: @154661
     /* 154661 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(154723), // Rule ID 6554 //
     /* 154666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 154669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 154673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 154677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154685 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154688 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154692 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154705 */     // (fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rm),
     /* 154708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154710 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154712 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154721 */     GIR_RootConstrainSelectedInstOperands,
     /* 154722 */     // GIR_Coverage, 6554,
     /* 154722 */     GIR_EraseRootFromParent_Done,
     /* 154723 */   // Label 3382: @154723
     /* 154723 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(154754), // Rule ID 2226 //
     /* 154728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 154731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 154735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 154739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 154743 */     // (fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VSUBPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 154743 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrr),
     /* 154748 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154752 */     GIR_RootConstrainSelectedInstOperands,
     /* 154753 */     // GIR_Coverage, 2226,
     /* 154753 */     GIR_Done,
     /* 154754 */   // Label 3383: @154754
     /* 154754 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(154785), // Rule ID 6550 //
     /* 154759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 154762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 154766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 154770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 154774 */     // (fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VSUBPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 154774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rr),
     /* 154779 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154783 */     GIR_RootConstrainSelectedInstOperands,
     /* 154784 */     // GIR_Coverage, 6550,
     /* 154784 */     GIR_Done,
     /* 154785 */   // Label 3384: @154785
     /* 154785 */   GIM_Reject,
     /* 154786 */ // Label 3380: @154786
     /* 154786 */ GIM_Reject,
     /* 154787 */ // Label 3324: @154787
     /* 154787 */ GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(154884),
     /* 154792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 154798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154806 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(154860), // Rule ID 6578 //
     /* 154811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 154814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154822 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154825 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154829 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154842 */     // (fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rm),
     /* 154845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154847 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154849 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154858 */     GIR_RootConstrainSelectedInstOperands,
     /* 154859 */     // GIR_Coverage, 6578,
     /* 154859 */     GIR_EraseRootFromParent_Done,
     /* 154860 */   // Label 3386: @154860
     /* 154860 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(154883), // Rule ID 6574 //
     /* 154865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 154868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 154872 */     // (fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VSUBPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 154872 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rr),
     /* 154877 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154881 */     GIR_RootConstrainSelectedInstOperands,
     /* 154882 */     // GIR_Coverage, 6574,
     /* 154882 */     GIR_Done,
     /* 154883 */   // Label 3387: @154883
     /* 154883 */   GIM_Reject,
     /* 154884 */ // Label 3385: @154884
     /* 154884 */ GIM_Reject,
     /* 154885 */ // Label 3325: @154885
     /* 154885 */ GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(155083),
     /* 154890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 154893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 154896 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(154958), // Rule ID 2224 //
     /* 154901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 154904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 154908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 154912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154920 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154923 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154927 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154940 */     // (fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrm),
     /* 154943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154945 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154947 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154956 */     GIR_RootConstrainSelectedInstOperands,
     /* 154957 */     // GIR_Coverage, 2224,
     /* 154957 */     GIR_EraseRootFromParent_Done,
     /* 154958 */   // Label 3389: @154958
     /* 154958 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(155020), // Rule ID 6530 //
     /* 154963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 154966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 154970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 154974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154982 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154985 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154989 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155002 */     // (fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rm),
     /* 155005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155007 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155009 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155018 */     GIR_RootConstrainSelectedInstOperands,
     /* 155019 */     // GIR_Coverage, 6530,
     /* 155019 */     GIR_EraseRootFromParent_Done,
     /* 155020 */   // Label 3390: @155020
     /* 155020 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(155051), // Rule ID 2222 //
     /* 155025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 155028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 155040 */     // (fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VSUBPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 155040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrr),
     /* 155045 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155049 */     GIR_RootConstrainSelectedInstOperands,
     /* 155050 */     // GIR_Coverage, 2222,
     /* 155050 */     GIR_Done,
     /* 155051 */   // Label 3391: @155051
     /* 155051 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(155082), // Rule ID 6526 //
     /* 155056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 155059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155071 */     // (fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VSUBPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 155071 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rr),
     /* 155076 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155080 */     GIR_RootConstrainSelectedInstOperands,
     /* 155081 */     // GIR_Coverage, 6526,
     /* 155081 */     GIR_Done,
     /* 155082 */   // Label 3392: @155082
     /* 155082 */   GIM_Reject,
     /* 155083 */ // Label 3388: @155083
     /* 155083 */ GIM_Reject,
     /* 155084 */ // Label 3326: @155084
     /* 155084 */ GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(155181),
     /* 155089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 155092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 155095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155103 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(155157), // Rule ID 6506 //
     /* 155108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 155111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155119 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155122 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155126 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155139 */     // (fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrm),
     /* 155142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155144 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155146 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155155 */     GIR_RootConstrainSelectedInstOperands,
     /* 155156 */     // GIR_Coverage, 6506,
     /* 155156 */     GIR_EraseRootFromParent_Done,
     /* 155157 */   // Label 3394: @155157
     /* 155157 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(155180), // Rule ID 6502 //
     /* 155162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 155165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155169 */     // (fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VSUBPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 155169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrr),
     /* 155174 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155178 */     GIR_RootConstrainSelectedInstOperands,
     /* 155179 */     // GIR_Coverage, 6502,
     /* 155179 */     GIR_Done,
     /* 155180 */   // Label 3395: @155180
     /* 155180 */   GIM_Reject,
     /* 155181 */ // Label 3393: @155181
     /* 155181 */ GIM_Reject,
     /* 155182 */ // Label 3327: @155182
     /* 155182 */ GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(155279),
     /* 155187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 155190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 155193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155201 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(155255), // Rule ID 6590 //
     /* 155206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 155209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155217 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155220 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155224 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155230 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155237 */     // (fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rm),
     /* 155240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155242 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155244 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155253 */     GIR_RootConstrainSelectedInstOperands,
     /* 155254 */     // GIR_Coverage, 6590,
     /* 155254 */     GIR_EraseRootFromParent_Done,
     /* 155255 */   // Label 3397: @155255
     /* 155255 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(155278), // Rule ID 6586 //
     /* 155260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 155263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 155267 */     // (fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VSUBPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 155267 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rr),
     /* 155272 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155276 */     GIR_RootConstrainSelectedInstOperands,
     /* 155277 */     // GIR_Coverage, 6586,
     /* 155277 */     GIR_Done,
     /* 155278 */   // Label 3398: @155278
     /* 155278 */   GIM_Reject,
     /* 155279 */ // Label 3396: @155279
     /* 155279 */ GIM_Reject,
     /* 155280 */ // Label 3328: @155280
     /* 155280 */ GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(155377),
     /* 155285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 155288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 155291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155299 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(155353), // Rule ID 6494 //
     /* 155304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 155307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155315 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155318 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155322 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155335 */     // (fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrm),
     /* 155338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155340 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155342 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155351 */     GIR_RootConstrainSelectedInstOperands,
     /* 155352 */     // GIR_Coverage, 6494,
     /* 155352 */     GIR_EraseRootFromParent_Done,
     /* 155353 */   // Label 3400: @155353
     /* 155353 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(155376), // Rule ID 6490 //
     /* 155358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 155361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155365 */     // (fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VSUBPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 155365 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrr),
     /* 155370 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155374 */     GIR_RootConstrainSelectedInstOperands,
     /* 155375 */     // GIR_Coverage, 6490,
     /* 155375 */     GIR_Done,
     /* 155376 */   // Label 3401: @155376
     /* 155376 */   GIM_Reject,
     /* 155377 */ // Label 3399: @155377
     /* 155377 */ GIM_Reject,
     /* 155378 */ // Label 3329: @155378
     /* 155378 */ GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(155475),
     /* 155383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 155386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 155389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155397 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(155451), // Rule ID 6566 //
     /* 155402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 155405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155413 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155416 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155420 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155426 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155433 */     // (fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrm),
     /* 155436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155438 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155440 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155449 */     GIR_RootConstrainSelectedInstOperands,
     /* 155450 */     // GIR_Coverage, 6566,
     /* 155450 */     GIR_EraseRootFromParent_Done,
     /* 155451 */   // Label 3403: @155451
     /* 155451 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(155474), // Rule ID 6562 //
     /* 155456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 155459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 155463 */     // (fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VSUBPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 155463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrr),
     /* 155468 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155472 */     GIR_RootConstrainSelectedInstOperands,
     /* 155473 */     // GIR_Coverage, 6562,
     /* 155473 */     GIR_Done,
     /* 155474 */   // Label 3404: @155474
     /* 155474 */   GIM_Reject,
     /* 155475 */ // Label 3402: @155475
     /* 155475 */ GIM_Reject,
     /* 155476 */ // Label 3330: @155476
     /* 155476 */ GIM_Reject,
     /* 155477 */ // Label 43: @155477
     /* 155477 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3418*/ GIMT_Encode4(160578),
     /* 155488 */ /*GILLT_s16*//*Label 3405*/ GIMT_Encode4(155572),
     /* 155492 */ /*GILLT_s32*//*Label 3406*/ GIMT_Encode4(155732),
     /* 155496 */ /*GILLT_s64*//*Label 3407*/ GIMT_Encode4(156845),
     /* 155500 */ /*GILLT_s80*//*Label 3408*/ GIMT_Encode4(158102), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 155512 */ /*GILLT_v2s64*//*Label 3409*/ GIMT_Encode4(158424), GIMT_Encode4(0),
     /* 155520 */ /*GILLT_v4s32*//*Label 3410*/ GIMT_Encode4(158778),
     /* 155524 */ /*GILLT_v4s64*//*Label 3411*/ GIMT_Encode4(159132), GIMT_Encode4(0),
     /* 155532 */ /*GILLT_v8s16*//*Label 3412*/ GIMT_Encode4(159455),
     /* 155536 */ /*GILLT_v8s32*//*Label 3413*/ GIMT_Encode4(159615),
     /* 155540 */ /*GILLT_v8s64*//*Label 3414*/ GIMT_Encode4(159938), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 155552 */ /*GILLT_v16s16*//*Label 3415*/ GIMT_Encode4(160098),
     /* 155556 */ /*GILLT_v16s32*//*Label 3416*/ GIMT_Encode4(160258), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 155568 */ /*GILLT_v32s16*//*Label 3417*/ GIMT_Encode4(160418),
     /* 155572 */ // Label 3405: @155572
     /* 155572 */ GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(155731),
     /* 155577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 155580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 155583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 155587 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(155645), // Rule ID 24253 //
     /* 155592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 155595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155603 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155606 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155610 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 155618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155627 */     // (fmul:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 155630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155632 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 155634 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155643 */     GIR_RootConstrainSelectedInstOperands,
     /* 155644 */     // GIR_Coverage, 24253,
     /* 155644 */     GIR_EraseRootFromParent_Done,
     /* 155645 */   // Label 3420: @155645
     /* 155645 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(155703), // Rule ID 6011 //
     /* 155650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 155653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 155657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155665 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155668 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155672 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155685 */     // (fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 155688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155690 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155692 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155701 */     GIR_RootConstrainSelectedInstOperands,
     /* 155702 */     // GIR_Coverage, 6011,
     /* 155702 */     GIR_EraseRootFromParent_Done,
     /* 155703 */   // Label 3421: @155703
     /* 155703 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(155730), // Rule ID 6009 //
     /* 155708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 155711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 155715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 155719 */     // (fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VMULSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 155719 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSHZrr),
     /* 155724 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155728 */     GIR_RootConstrainSelectedInstOperands,
     /* 155729 */     // GIR_Coverage, 6009,
     /* 155729 */     GIR_Done,
     /* 155730 */   // Label 3422: @155730
     /* 155730 */   GIM_Reject,
     /* 155731 */ // Label 3419: @155731
     /* 155731 */ GIM_Reject,
     /* 155732 */ // Label 3406: @155732
     /* 155732 */ GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(156844),
     /* 155737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 155740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155743 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(155821), // Rule ID 26021 //
     /* 155748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 155751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 155755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 155763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 155767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155775 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 155778 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155785 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 155789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 155793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155795 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155802 */     // (fmul:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_32>>), FR32:{ *:[f32] }:$src1)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 155805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155807 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 155809 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 155819 */     GIR_RootConstrainSelectedInstOperands,
     /* 155820 */     // GIR_Coverage, 26021,
     /* 155820 */     GIR_EraseRootFromParent_Done,
     /* 155821 */   // Label 3424: @155821
     /* 155821 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(155899), // Rule ID 26022 //
     /* 155826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 155829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 155833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 155841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 155845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155853 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 155856 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155863 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 155867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 155871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155873 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155880 */     // (fmul:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_32>>), FR32:{ *:[f32] }:$src1)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 155883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155885 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 155887 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 155897 */     GIR_RootConstrainSelectedInstOperands,
     /* 155898 */     // GIR_Coverage, 26022,
     /* 155898 */     GIR_EraseRootFromParent_Done,
     /* 155899 */   // Label 3425: @155899
     /* 155899 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(155977), // Rule ID 26023 //
     /* 155904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 155907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 155911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 155919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 155923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155931 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 155934 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155941 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 155945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 155949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155951 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155958 */     // (fmul:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_32>>), FR32X:{ *:[f32] }:$src1)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 155961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155963 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 155965 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 155975 */     GIR_RootConstrainSelectedInstOperands,
     /* 155976 */     // GIR_Coverage, 26023,
     /* 155976 */     GIR_EraseRootFromParent_Done,
     /* 155977 */   // Label 3426: @155977
     /* 155977 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(156055), // Rule ID 22478 //
     /* 155982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 155985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 155989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 155993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 156001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 156005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156013 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156016 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156023 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 156027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156029 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156036 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_32>>))  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 156039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156041 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156043 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 156053 */     GIR_RootConstrainSelectedInstOperands,
     /* 156054 */     // GIR_Coverage, 22478,
     /* 156054 */     GIR_EraseRootFromParent_Done,
     /* 156055 */   // Label 3427: @156055
     /* 156055 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(156133), // Rule ID 22479 //
     /* 156060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 156063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 156079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 156083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156091 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156094 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156101 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 156105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156107 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156114 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_32>>))  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 156117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156119 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156121 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 156131 */     GIR_RootConstrainSelectedInstOperands,
     /* 156132 */     // GIR_Coverage, 22479,
     /* 156132 */     GIR_EraseRootFromParent_Done,
     /* 156133 */   // Label 3428: @156133
     /* 156133 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(156211), // Rule ID 22480 //
     /* 156138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 156141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 156145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 156149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 156157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 156161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156169 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156172 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156179 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 156183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156185 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156192 */     // (fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_32>>))  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 156195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156197 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156199 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 156209 */     GIR_RootConstrainSelectedInstOperands,
     /* 156210 */     // GIR_Coverage, 22480,
     /* 156210 */     GIR_EraseRootFromParent_Done,
     /* 156211 */   // Label 3429: @156211
     /* 156211 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(156276), // Rule ID 23256 //
     /* 156216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 156219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 156223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156231 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156234 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156238 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 156246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156255 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 156258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156260 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156262 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156274 */     GIR_RootConstrainSelectedInstOperands,
     /* 156275 */     // GIR_Coverage, 23256,
     /* 156275 */     GIR_EraseRootFromParent_Done,
     /* 156276 */   // Label 3430: @156276
     /* 156276 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(156338), // Rule ID 23399 //
     /* 156281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 156284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156296 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156299 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156303 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156320 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 156323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156325 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156327 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156336 */     GIR_RootConstrainSelectedInstOperands,
     /* 156337 */     // GIR_Coverage, 23399,
     /* 156337 */     GIR_EraseRootFromParent_Done,
     /* 156338 */   // Label 3431: @156338
     /* 156338 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(156400), // Rule ID 23403 //
     /* 156343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 156346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156358 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156361 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156365 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156382 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 156385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156387 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156389 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156398 */     GIR_RootConstrainSelectedInstOperands,
     /* 156399 */     // GIR_Coverage, 23403,
     /* 156399 */     GIR_EraseRootFromParent_Done,
     /* 156400 */   // Label 3432: @156400
     /* 156400 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(156462), // Rule ID 24249 //
     /* 156405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 156408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 156412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156420 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156423 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156427 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 156435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156444 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 156447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156449 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156451 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156460 */     GIR_RootConstrainSelectedInstOperands,
     /* 156461 */     // GIR_Coverage, 24249,
     /* 156461 */     GIR_EraseRootFromParent_Done,
     /* 156462 */   // Label 3433: @156462
     /* 156462 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(156527), // Rule ID 976 //
     /* 156467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 156470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 156474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 156478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156486 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156489 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156493 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156506 */     // (fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 156509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156511 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156513 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156517 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156525 */     GIR_RootConstrainSelectedInstOperands,
     /* 156526 */     // GIR_Coverage, 976,
     /* 156526 */     GIR_EraseRootFromParent_Done,
     /* 156527 */   // Label 3434: @156527
     /* 156527 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(156589), // Rule ID 2200 //
     /* 156532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 156535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156551 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156554 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156558 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156571 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 156574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156576 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156578 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156587 */     GIR_RootConstrainSelectedInstOperands,
     /* 156588 */     // GIR_Coverage, 2200,
     /* 156588 */     GIR_EraseRootFromParent_Done,
     /* 156589 */   // Label 3435: @156589
     /* 156589 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(156651), // Rule ID 2208 //
     /* 156594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 156597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156613 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156616 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156620 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156633 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 156636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156638 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156640 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156649 */     GIR_RootConstrainSelectedInstOperands,
     /* 156650 */     // GIR_Coverage, 2208,
     /* 156650 */     GIR_EraseRootFromParent_Done,
     /* 156651 */   // Label 3436: @156651
     /* 156651 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(156713), // Rule ID 5973 //
     /* 156656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 156659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 156663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 156667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156675 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156678 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156682 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156688 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156695 */     // (fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 156698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156700 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156702 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156711 */     GIR_RootConstrainSelectedInstOperands,
     /* 156712 */     // GIR_Coverage, 5973,
     /* 156712 */     GIR_EraseRootFromParent_Done,
     /* 156713 */   // Label 3437: @156713
     /* 156713 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(156750), // Rule ID 898 //
     /* 156718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 156721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 156725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 156729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 156733 */     // (fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (MUL_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 156733 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32),
     /* 156738 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 156744 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 156748 */     GIR_RootConstrainSelectedInstOperands,
     /* 156749 */     // GIR_Coverage, 898,
     /* 156749 */     GIR_Done,
     /* 156750 */   // Label 3438: @156750
     /* 156750 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(156781), // Rule ID 2198 //
     /* 156755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 156758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156770 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VMULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 156770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSrr),
     /* 156775 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156779 */     GIR_RootConstrainSelectedInstOperands,
     /* 156780 */     // GIR_Coverage, 2198,
     /* 156780 */     GIR_Done,
     /* 156781 */   // Label 3439: @156781
     /* 156781 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(156812), // Rule ID 2206 //
     /* 156786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 156789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 156801 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (MULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 156801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSSrr),
     /* 156806 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156810 */     GIR_RootConstrainSelectedInstOperands,
     /* 156811 */     // GIR_Coverage, 2206,
     /* 156811 */     GIR_Done,
     /* 156812 */   // Label 3440: @156812
     /* 156812 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(156843), // Rule ID 5971 //
     /* 156817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 156820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 156824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 156828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 156832 */     // (fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VMULSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 156832 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSZrr),
     /* 156837 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156841 */     GIR_RootConstrainSelectedInstOperands,
     /* 156842 */     // GIR_Coverage, 5971,
     /* 156842 */     GIR_Done,
     /* 156843 */   // Label 3441: @156843
     /* 156843 */   GIM_Reject,
     /* 156844 */ // Label 3423: @156844
     /* 156844 */ GIM_Reject,
     /* 156845 */ // Label 3407: @156845
     /* 156845 */ GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(158101),
     /* 156850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 156853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156856 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(156934), // Rule ID 26024 //
     /* 156861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 156864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 156868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 156876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 156880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156888 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156891 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 156898 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 156902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 156906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156908 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156915 */     // (fmul:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_64>>), FR64:{ *:[f64] }:$src1)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 156918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156920 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156922 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 156932 */     GIR_RootConstrainSelectedInstOperands,
     /* 156933 */     // GIR_Coverage, 26024,
     /* 156933 */     GIR_EraseRootFromParent_Done,
     /* 156934 */   // Label 3443: @156934
     /* 156934 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(157012), // Rule ID 26025 //
     /* 156939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 156942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 156946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 156954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 156958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156966 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156969 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 156976 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 156980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 156984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 156986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156993 */     // (fmul:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_64>>), FR64:{ *:[f64] }:$src1)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 156996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156998 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 157000 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 157010 */     GIR_RootConstrainSelectedInstOperands,
     /* 157011 */     // GIR_Coverage, 26025,
     /* 157011 */     GIR_EraseRootFromParent_Done,
     /* 157012 */   // Label 3444: @157012
     /* 157012 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(157090), // Rule ID 26026 //
     /* 157017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 157024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 157028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 157032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 157036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157044 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157047 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157054 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 157058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 157062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157071 */     // (fmul:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_64>>), FR64X:{ *:[f64] }:$src1)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 157074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157076 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 157078 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 157088 */     GIR_RootConstrainSelectedInstOperands,
     /* 157089 */     // GIR_Coverage, 26026,
     /* 157089 */     GIR_EraseRootFromParent_Done,
     /* 157090 */   // Label 3445: @157090
     /* 157090 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(157168), // Rule ID 22481 //
     /* 157095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 157098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 157114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 157118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157126 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157129 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157136 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 157140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157142 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157149 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_64>>))  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 157152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157154 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157156 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 157166 */     GIR_RootConstrainSelectedInstOperands,
     /* 157167 */     // GIR_Coverage, 22481,
     /* 157167 */     GIR_EraseRootFromParent_Done,
     /* 157168 */   // Label 3446: @157168
     /* 157168 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(157246), // Rule ID 22482 //
     /* 157173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 157176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 157192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 157196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157204 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157207 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157214 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 157218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157220 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157227 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_64>>))  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 157230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157232 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157234 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 157244 */     GIR_RootConstrainSelectedInstOperands,
     /* 157245 */     // GIR_Coverage, 22482,
     /* 157245 */     GIR_EraseRootFromParent_Done,
     /* 157246 */   // Label 3447: @157246
     /* 157246 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(157324), // Rule ID 22483 //
     /* 157251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 157258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 157262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 157270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 157274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157282 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157285 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157292 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 157296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157298 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157305 */     // (fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_64>>))  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 157308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157310 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157312 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 157322 */     GIR_RootConstrainSelectedInstOperands,
     /* 157323 */     // GIR_Coverage, 22483,
     /* 157323 */     GIR_EraseRootFromParent_Done,
     /* 157324 */   // Label 3448: @157324
     /* 157324 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(157389), // Rule ID 23258 //
     /* 157329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 157332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 157336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 157340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157344 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157347 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157351 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 157359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157361 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157368 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 157371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157373 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 157375 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 157382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157387 */     GIR_RootConstrainSelectedInstOperands,
     /* 157388 */     // GIR_Coverage, 23258,
     /* 157388 */     GIR_EraseRootFromParent_Done,
     /* 157389 */   // Label 3449: @157389
     /* 157389 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(157461), // Rule ID 23260 //
     /* 157394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 157397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 157401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 157405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157409 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157412 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157416 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 157423 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 157431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157440 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 157443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157445 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 157447 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157451 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 157454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157459 */     GIR_RootConstrainSelectedInstOperands,
     /* 157460 */     // GIR_Coverage, 23260,
     /* 157460 */     GIR_EraseRootFromParent_Done,
     /* 157461 */   // Label 3450: @157461
     /* 157461 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(157523), // Rule ID 23401 //
     /* 157466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 157469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 157477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157481 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157484 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157488 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157498 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157505 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 157508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157510 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 157512 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157521 */     GIR_RootConstrainSelectedInstOperands,
     /* 157522 */     // GIR_Coverage, 23401,
     /* 157522 */     GIR_EraseRootFromParent_Done,
     /* 157523 */   // Label 3451: @157523
     /* 157523 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(157585), // Rule ID 23405 //
     /* 157528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 157531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 157539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157543 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157546 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157550 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157560 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157567 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 157570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157572 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 157574 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157583 */     GIR_RootConstrainSelectedInstOperands,
     /* 157584 */     // GIR_Coverage, 23405,
     /* 157584 */     GIR_EraseRootFromParent_Done,
     /* 157585 */   // Label 3452: @157585
     /* 157585 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(157647), // Rule ID 24251 //
     /* 157590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 157597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 157601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157605 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157608 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157612 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 157620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157629 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 157632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157634 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 157636 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157645 */     GIR_RootConstrainSelectedInstOperands,
     /* 157646 */     // GIR_Coverage, 24251,
     /* 157646 */     GIR_EraseRootFromParent_Done,
     /* 157647 */   // Label 3453: @157647
     /* 157647 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(157712), // Rule ID 978 //
     /* 157652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 157655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 157659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 157663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157671 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157674 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157678 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157684 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157691 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 157694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157696 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157698 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157702 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 157705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157710 */     GIR_RootConstrainSelectedInstOperands,
     /* 157711 */     // GIR_Coverage, 978,
     /* 157711 */     GIR_EraseRootFromParent_Done,
     /* 157712 */   // Label 3454: @157712
     /* 157712 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(157784), // Rule ID 980 //
     /* 157717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 157720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 157724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 157728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157736 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157739 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157743 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 157750 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157756 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157763 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 157766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157768 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157770 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 157777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157782 */     GIR_RootConstrainSelectedInstOperands,
     /* 157783 */     // GIR_Coverage, 980,
     /* 157783 */     GIR_EraseRootFromParent_Done,
     /* 157784 */   // Label 3455: @157784
     /* 157784 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(157846), // Rule ID 2204 //
     /* 157789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 157792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157808 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157811 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157815 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157828 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 157831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157833 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157835 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157844 */     GIR_RootConstrainSelectedInstOperands,
     /* 157845 */     // GIR_Coverage, 2204,
     /* 157845 */     GIR_EraseRootFromParent_Done,
     /* 157846 */   // Label 3456: @157846
     /* 157846 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(157908), // Rule ID 2212 //
     /* 157851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 157854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 157862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157870 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157873 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157877 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157883 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157890 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 157893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157895 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157897 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157906 */     GIR_RootConstrainSelectedInstOperands,
     /* 157907 */     // GIR_Coverage, 2212,
     /* 157907 */     GIR_EraseRootFromParent_Done,
     /* 157908 */   // Label 3457: @157908
     /* 157908 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(157970), // Rule ID 5992 //
     /* 157913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 157920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 157924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157932 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157935 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157939 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157952 */     // (fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 157955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157957 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157959 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157968 */     GIR_RootConstrainSelectedInstOperands,
     /* 157969 */     // GIR_Coverage, 5992,
     /* 157969 */     GIR_EraseRootFromParent_Done,
     /* 157970 */   // Label 3458: @157970
     /* 157970 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(158007), // Rule ID 900 //
     /* 157975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 157978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 157982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 157986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 157990 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (MUL_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 157990 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64),
     /* 157995 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 158001 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 158005 */     GIR_RootConstrainSelectedInstOperands,
     /* 158006 */     // GIR_Coverage, 900,
     /* 158006 */     GIR_Done,
     /* 158007 */   // Label 3459: @158007
     /* 158007 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(158038), // Rule ID 2202 //
     /* 158012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 158015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158027 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VMULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 158027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDrr),
     /* 158032 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 158036 */     GIR_RootConstrainSelectedInstOperands,
     /* 158037 */     // GIR_Coverage, 2202,
     /* 158037 */     GIR_Done,
     /* 158038 */   // Label 3460: @158038
     /* 158038 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(158069), // Rule ID 2210 //
     /* 158043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 158046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 158058 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (MULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 158058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSDrr),
     /* 158063 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 158067 */     GIR_RootConstrainSelectedInstOperands,
     /* 158068 */     // GIR_Coverage, 2210,
     /* 158068 */     GIR_Done,
     /* 158069 */   // Label 3461: @158069
     /* 158069 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(158100), // Rule ID 5990 //
     /* 158074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 158077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 158081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 158085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 158089 */     // (fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VMULSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 158089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDZrr),
     /* 158094 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 158098 */     GIR_RootConstrainSelectedInstOperands,
     /* 158099 */     // GIR_Coverage, 5990,
     /* 158099 */     GIR_Done,
     /* 158100 */   // Label 3462: @158100
     /* 158100 */   GIM_Reject,
     /* 158101 */ // Label 3442: @158101
     /* 158101 */ GIM_Reject,
     /* 158102 */ // Label 3408: @158102
     /* 158102 */ GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(158423),
     /* 158107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 158110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 158113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 158117 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(158185), // Rule ID 23262 //
     /* 158122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 158125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158133 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158136 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158140 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158147 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 158155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158157 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158164 */     // (fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 158167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158169 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158171 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158175 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158183 */     GIR_RootConstrainSelectedInstOperands,
     /* 158184 */     // GIR_Coverage, 23262,
     /* 158184 */     GIR_EraseRootFromParent_Done,
     /* 158185 */   // Label 3464: @158185
     /* 158185 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(158253), // Rule ID 23264 //
     /* 158190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 158193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158201 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158204 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158208 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158215 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 158223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158232 */     // (fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 158235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158237 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158239 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158243 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158251 */     GIR_RootConstrainSelectedInstOperands,
     /* 158252 */     // GIR_Coverage, 23264,
     /* 158252 */     GIR_EraseRootFromParent_Done,
     /* 158253 */   // Label 3465: @158253
     /* 158253 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(158321), // Rule ID 982 //
     /* 158258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 158261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 158265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158273 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158276 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158280 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158287 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158300 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 158303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158305 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158307 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158319 */     GIR_RootConstrainSelectedInstOperands,
     /* 158320 */     // GIR_Coverage, 982,
     /* 158320 */     GIR_EraseRootFromParent_Done,
     /* 158321 */   // Label 3466: @158321
     /* 158321 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(158389), // Rule ID 984 //
     /* 158326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 158329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 158333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158341 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158344 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158348 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158355 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158361 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158368 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 158371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158373 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158375 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158387 */     GIR_RootConstrainSelectedInstOperands,
     /* 158388 */     // GIR_Coverage, 984,
     /* 158388 */     GIR_EraseRootFromParent_Done,
     /* 158389 */   // Label 3467: @158389
     /* 158389 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(158422), // Rule ID 902 //
     /* 158394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 158397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 158401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 158405 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (MUL_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 158405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80),
     /* 158410 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 158416 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 158420 */     GIR_RootConstrainSelectedInstOperands,
     /* 158421 */     // GIR_Coverage, 902,
     /* 158421 */     GIR_Done,
     /* 158422 */   // Label 3468: @158422
     /* 158422 */   GIM_Reject,
     /* 158423 */ // Label 3463: @158423
     /* 158423 */ GIM_Reject,
     /* 158424 */ // Label 3409: @158424
     /* 158424 */ GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(158777),
     /* 158429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 158432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 158435 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(158497), // Rule ID 23389 //
     /* 158440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 158443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 158447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158455 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158458 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158462 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 158470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158472 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158479 */     // (fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 158482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158484 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158486 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158495 */     GIR_RootConstrainSelectedInstOperands,
     /* 158496 */     // GIR_Coverage, 23389,
     /* 158496 */     GIR_EraseRootFromParent_Done,
     /* 158497 */   // Label 3470: @158497
     /* 158497 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(158559), // Rule ID 24365 //
     /* 158502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 158505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 158509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158517 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158520 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158524 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 158532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158541 */     // (fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 158544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158546 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158548 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158557 */     GIR_RootConstrainSelectedInstOperands,
     /* 158558 */     // GIR_Coverage, 24365,
     /* 158558 */     GIR_EraseRootFromParent_Done,
     /* 158559 */   // Label 3471: @158559
     /* 158559 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(158621), // Rule ID 2180 //
     /* 158564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 158567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 158571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 158575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158583 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158586 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158590 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158596 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158603 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 158606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158608 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158610 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158619 */     GIR_RootConstrainSelectedInstOperands,
     /* 158620 */     // GIR_Coverage, 2180,
     /* 158620 */     GIR_EraseRootFromParent_Done,
     /* 158621 */   // Label 3472: @158621
     /* 158621 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(158683), // Rule ID 6425 //
     /* 158626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 158629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 158633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 158637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158645 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158648 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158652 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158665 */     // (fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 158668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158670 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158672 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158681 */     GIR_RootConstrainSelectedInstOperands,
     /* 158682 */     // GIR_Coverage, 6425,
     /* 158682 */     GIR_EraseRootFromParent_Done,
     /* 158683 */   // Label 3473: @158683
     /* 158683 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(158714), // Rule ID 2178 //
     /* 158688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 158691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 158695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 158699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 158703 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 158703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDrr),
     /* 158708 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 158712 */     GIR_RootConstrainSelectedInstOperands,
     /* 158713 */     // GIR_Coverage, 2178,
     /* 158713 */     GIR_Done,
     /* 158714 */   // Label 3474: @158714
     /* 158714 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(158745), // Rule ID 2194 //
     /* 158719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 158722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 158726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 158730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 158734 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (MULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 158734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPDrr),
     /* 158739 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 158743 */     GIR_RootConstrainSelectedInstOperands,
     /* 158744 */     // GIR_Coverage, 2194,
     /* 158744 */     GIR_Done,
     /* 158745 */   // Label 3475: @158745
     /* 158745 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(158776), // Rule ID 6421 //
     /* 158750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 158753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 158757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 158761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 158765 */     // (fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VMULPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 158765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rr),
     /* 158770 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 158774 */     GIR_RootConstrainSelectedInstOperands,
     /* 158775 */     // GIR_Coverage, 6421,
     /* 158775 */     GIR_Done,
     /* 158776 */   // Label 3476: @158776
     /* 158776 */   GIM_Reject,
     /* 158777 */ // Label 3469: @158777
     /* 158777 */ GIM_Reject,
     /* 158778 */ // Label 3410: @158778
     /* 158778 */ GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(159131),
     /* 158783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 158789 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(158851), // Rule ID 23387 //
     /* 158794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 158797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 158801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158809 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158812 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158816 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 158824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158826 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158833 */     // (fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 158836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158838 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158840 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158849 */     GIR_RootConstrainSelectedInstOperands,
     /* 158850 */     // GIR_Coverage, 23387,
     /* 158850 */     GIR_EraseRootFromParent_Done,
     /* 158851 */   // Label 3478: @158851
     /* 158851 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(158913), // Rule ID 24349 //
     /* 158856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 158859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 158863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158871 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158874 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158878 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 158886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158895 */     // (fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 158898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158900 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158902 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158911 */     GIR_RootConstrainSelectedInstOperands,
     /* 158912 */     // GIR_Coverage, 24349,
     /* 158912 */     GIR_EraseRootFromParent_Done,
     /* 158913 */   // Label 3479: @158913
     /* 158913 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(158975), // Rule ID 2176 //
     /* 158918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 158921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 158925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 158929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158937 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158940 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158944 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158957 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 158960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158962 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158964 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158973 */     GIR_RootConstrainSelectedInstOperands,
     /* 158974 */     // GIR_Coverage, 2176,
     /* 158974 */     GIR_EraseRootFromParent_Done,
     /* 158975 */   // Label 3480: @158975
     /* 158975 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(159037), // Rule ID 6401 //
     /* 158980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 158983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 158987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 158991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158999 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159002 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159006 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159019 */     // (fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 159022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159024 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159026 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159035 */     GIR_RootConstrainSelectedInstOperands,
     /* 159036 */     // GIR_Coverage, 6401,
     /* 159036 */     GIR_EraseRootFromParent_Done,
     /* 159037 */   // Label 3481: @159037
     /* 159037 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(159068), // Rule ID 2174 //
     /* 159042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159057 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 159057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSrr),
     /* 159062 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159066 */     GIR_RootConstrainSelectedInstOperands,
     /* 159067 */     // GIR_Coverage, 2174,
     /* 159067 */     GIR_Done,
     /* 159068 */   // Label 3482: @159068
     /* 159068 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(159099), // Rule ID 2190 //
     /* 159073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 159076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 159088 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (MULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 159088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPSrr),
     /* 159093 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159097 */     GIR_RootConstrainSelectedInstOperands,
     /* 159098 */     // GIR_Coverage, 2190,
     /* 159098 */     GIR_Done,
     /* 159099 */   // Label 3483: @159099
     /* 159099 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(159130), // Rule ID 6397 //
     /* 159104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159119 */     // (fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VMULPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 159119 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rr),
     /* 159124 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159128 */     GIR_RootConstrainSelectedInstOperands,
     /* 159129 */     // GIR_Coverage, 6397,
     /* 159129 */     GIR_Done,
     /* 159130 */   // Label 3484: @159130
     /* 159130 */   GIM_Reject,
     /* 159131 */ // Label 3477: @159131
     /* 159131 */ GIM_Reject,
     /* 159132 */ // Label 3411: @159132
     /* 159132 */ GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(159454),
     /* 159137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 159140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 159143 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(159205), // Rule ID 23393 //
     /* 159148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159163 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159166 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159170 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159180 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159187 */     // (fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 159190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159192 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159194 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159203 */     GIR_RootConstrainSelectedInstOperands,
     /* 159204 */     // GIR_Coverage, 23393,
     /* 159204 */     GIR_EraseRootFromParent_Done,
     /* 159205 */   // Label 3486: @159205
     /* 159205 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(159267), // Rule ID 24373 //
     /* 159210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159225 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159228 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159232 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159249 */     // (fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 159252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159254 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159256 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159265 */     GIR_RootConstrainSelectedInstOperands,
     /* 159266 */     // GIR_Coverage, 24373,
     /* 159266 */     GIR_EraseRootFromParent_Done,
     /* 159267 */   // Label 3487: @159267
     /* 159267 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(159329), // Rule ID 2188 //
     /* 159272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159291 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159294 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159298 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159311 */     // (fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 159314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159316 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159318 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159327 */     GIR_RootConstrainSelectedInstOperands,
     /* 159328 */     // GIR_Coverage, 2188,
     /* 159328 */     GIR_EraseRootFromParent_Done,
     /* 159329 */   // Label 3488: @159329
     /* 159329 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(159391), // Rule ID 6437 //
     /* 159334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159353 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159356 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159360 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159373 */     // (fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 159376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159378 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159380 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159389 */     GIR_RootConstrainSelectedInstOperands,
     /* 159390 */     // GIR_Coverage, 6437,
     /* 159390 */     GIR_EraseRootFromParent_Done,
     /* 159391 */   // Label 3489: @159391
     /* 159391 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(159422), // Rule ID 2186 //
     /* 159396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159411 */     // (fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMULPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 159411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDYrr),
     /* 159416 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159420 */     GIR_RootConstrainSelectedInstOperands,
     /* 159421 */     // GIR_Coverage, 2186,
     /* 159421 */     GIR_Done,
     /* 159422 */   // Label 3490: @159422
     /* 159422 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(159453), // Rule ID 6433 //
     /* 159427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159442 */     // (fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VMULPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 159442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rr),
     /* 159447 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159451 */     GIR_RootConstrainSelectedInstOperands,
     /* 159452 */     // GIR_Coverage, 6433,
     /* 159452 */     GIR_Done,
     /* 159453 */   // Label 3491: @159453
     /* 159453 */   GIM_Reject,
     /* 159454 */ // Label 3485: @159454
     /* 159454 */ GIM_Reject,
     /* 159455 */ // Label 3412: @159455
     /* 159455 */ GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(159614),
     /* 159460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 159466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159470 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(159528), // Rule ID 24389 //
     /* 159475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 159478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159486 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159489 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159493 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159510 */     // (fmul:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 159513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159515 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159517 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159526 */     GIR_RootConstrainSelectedInstOperands,
     /* 159527 */     // GIR_Coverage, 24389,
     /* 159527 */     GIR_EraseRootFromParent_Done,
     /* 159528 */   // Label 3493: @159528
     /* 159528 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(159586), // Rule ID 6461 //
     /* 159533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 159536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159548 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159551 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159555 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159568 */     // (fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 159571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159573 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159575 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159584 */     GIR_RootConstrainSelectedInstOperands,
     /* 159585 */     // GIR_Coverage, 6461,
     /* 159585 */     GIR_EraseRootFromParent_Done,
     /* 159586 */   // Label 3494: @159586
     /* 159586 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(159613), // Rule ID 6457 //
     /* 159591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 159594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 159602 */     // (fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VMULPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 159602 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rr),
     /* 159607 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159611 */     GIR_RootConstrainSelectedInstOperands,
     /* 159612 */     // GIR_Coverage, 6457,
     /* 159612 */     GIR_Done,
     /* 159613 */   // Label 3495: @159613
     /* 159613 */   GIM_Reject,
     /* 159614 */ // Label 3492: @159614
     /* 159614 */ GIM_Reject,
     /* 159615 */ // Label 3413: @159615
     /* 159615 */ GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(159937),
     /* 159620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 159623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 159626 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(159688), // Rule ID 23391 //
     /* 159631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159646 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159649 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159653 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159670 */     // (fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 159673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159675 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159677 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159686 */     GIR_RootConstrainSelectedInstOperands,
     /* 159687 */     // GIR_Coverage, 23391,
     /* 159687 */     GIR_EraseRootFromParent_Done,
     /* 159688 */   // Label 3497: @159688
     /* 159688 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(159750), // Rule ID 24357 //
     /* 159693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159708 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159711 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159715 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159732 */     // (fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 159735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159737 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159739 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159748 */     GIR_RootConstrainSelectedInstOperands,
     /* 159749 */     // GIR_Coverage, 24357,
     /* 159749 */     GIR_EraseRootFromParent_Done,
     /* 159750 */   // Label 3498: @159750
     /* 159750 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(159812), // Rule ID 2184 //
     /* 159755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159774 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159777 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159781 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159794 */     // (fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 159797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159799 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159801 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159810 */     GIR_RootConstrainSelectedInstOperands,
     /* 159811 */     // GIR_Coverage, 2184,
     /* 159811 */     GIR_EraseRootFromParent_Done,
     /* 159812 */   // Label 3499: @159812
     /* 159812 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(159874), // Rule ID 6413 //
     /* 159817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159836 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159839 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159843 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159849 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159856 */     // (fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 159859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159861 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159863 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159872 */     GIR_RootConstrainSelectedInstOperands,
     /* 159873 */     // GIR_Coverage, 6413,
     /* 159873 */     GIR_EraseRootFromParent_Done,
     /* 159874 */   // Label 3500: @159874
     /* 159874 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(159905), // Rule ID 2182 //
     /* 159879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 159882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 159894 */     // (fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMULPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 159894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSYrr),
     /* 159899 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159903 */     GIR_RootConstrainSelectedInstOperands,
     /* 159904 */     // GIR_Coverage, 2182,
     /* 159904 */     GIR_Done,
     /* 159905 */   // Label 3501: @159905
     /* 159905 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(159936), // Rule ID 6409 //
     /* 159910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 159913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 159925 */     // (fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VMULPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 159925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rr),
     /* 159930 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159934 */     GIR_RootConstrainSelectedInstOperands,
     /* 159935 */     // GIR_Coverage, 6409,
     /* 159935 */     GIR_Done,
     /* 159936 */   // Label 3502: @159936
     /* 159936 */   GIM_Reject,
     /* 159937 */ // Label 3496: @159937
     /* 159937 */ GIM_Reject,
     /* 159938 */ // Label 3414: @159938
     /* 159938 */ GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(160097),
     /* 159943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 159946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 159949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 159953 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(160011), // Rule ID 24341 //
     /* 159958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 159961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159969 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159972 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159976 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 159984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159986 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159993 */     // (fmul:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 159996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159998 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160000 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160009 */     GIR_RootConstrainSelectedInstOperands,
     /* 160010 */     // GIR_Coverage, 24341,
     /* 160010 */     GIR_EraseRootFromParent_Done,
     /* 160011 */   // Label 3504: @160011
     /* 160011 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(160069), // Rule ID 6389 //
     /* 160016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160031 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160034 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160038 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160044 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160051 */     // (fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 160054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160056 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160058 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160067 */     GIR_RootConstrainSelectedInstOperands,
     /* 160068 */     // GIR_Coverage, 6389,
     /* 160068 */     GIR_EraseRootFromParent_Done,
     /* 160069 */   // Label 3505: @160069
     /* 160069 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(160096), // Rule ID 6385 //
     /* 160074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160085 */     // (fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VMULPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 160085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZrr),
     /* 160090 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160094 */     GIR_RootConstrainSelectedInstOperands,
     /* 160095 */     // GIR_Coverage, 6385,
     /* 160095 */     GIR_Done,
     /* 160096 */   // Label 3506: @160096
     /* 160096 */   GIM_Reject,
     /* 160097 */ // Label 3503: @160097
     /* 160097 */ GIM_Reject,
     /* 160098 */ // Label 3415: @160098
     /* 160098 */ GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(160257),
     /* 160103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 160106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 160109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160113 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(160171), // Rule ID 24397 //
     /* 160118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 160121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160129 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160132 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160136 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160146 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160153 */     // (fmul:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 160156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160158 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160160 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160169 */     GIR_RootConstrainSelectedInstOperands,
     /* 160170 */     // GIR_Coverage, 24397,
     /* 160170 */     GIR_EraseRootFromParent_Done,
     /* 160171 */   // Label 3508: @160171
     /* 160171 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(160229), // Rule ID 6473 //
     /* 160176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 160179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160191 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160194 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160198 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160211 */     // (fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 160214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160216 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160218 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160227 */     GIR_RootConstrainSelectedInstOperands,
     /* 160228 */     // GIR_Coverage, 6473,
     /* 160228 */     GIR_EraseRootFromParent_Done,
     /* 160229 */   // Label 3509: @160229
     /* 160229 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(160256), // Rule ID 6469 //
     /* 160234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 160237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 160245 */     // (fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VMULPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 160245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rr),
     /* 160250 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160254 */     GIR_RootConstrainSelectedInstOperands,
     /* 160255 */     // GIR_Coverage, 6469,
     /* 160255 */     GIR_Done,
     /* 160256 */   // Label 3510: @160256
     /* 160256 */   GIM_Reject,
     /* 160257 */ // Label 3507: @160257
     /* 160257 */ GIM_Reject,
     /* 160258 */ // Label 3416: @160258
     /* 160258 */ GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(160417),
     /* 160263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 160266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 160269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160273 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(160331), // Rule ID 24333 //
     /* 160278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160289 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160292 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160296 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160313 */     // (fmul:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 160316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160318 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160320 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160329 */     GIR_RootConstrainSelectedInstOperands,
     /* 160330 */     // GIR_Coverage, 24333,
     /* 160330 */     GIR_EraseRootFromParent_Done,
     /* 160331 */   // Label 3512: @160331
     /* 160331 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(160389), // Rule ID 6377 //
     /* 160336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160351 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160354 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160358 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160364 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160371 */     // (fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 160374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160376 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160378 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160387 */     GIR_RootConstrainSelectedInstOperands,
     /* 160388 */     // GIR_Coverage, 6377,
     /* 160388 */     GIR_EraseRootFromParent_Done,
     /* 160389 */   // Label 3513: @160389
     /* 160389 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(160416), // Rule ID 6373 //
     /* 160394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160405 */     // (fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VMULPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 160405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZrr),
     /* 160410 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160414 */     GIR_RootConstrainSelectedInstOperands,
     /* 160415 */     // GIR_Coverage, 6373,
     /* 160415 */     GIR_Done,
     /* 160416 */   // Label 3514: @160416
     /* 160416 */   GIM_Reject,
     /* 160417 */ // Label 3511: @160417
     /* 160417 */ GIM_Reject,
     /* 160418 */ // Label 3417: @160418
     /* 160418 */ GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(160577),
     /* 160423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 160426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 160429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160433 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(160491), // Rule ID 24381 //
     /* 160438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 160441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160449 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160452 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160456 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160466 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160473 */     // (fmul:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 160476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160478 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160480 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160489 */     GIR_RootConstrainSelectedInstOperands,
     /* 160490 */     // GIR_Coverage, 24381,
     /* 160490 */     GIR_EraseRootFromParent_Done,
     /* 160491 */   // Label 3516: @160491
     /* 160491 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(160549), // Rule ID 6449 //
     /* 160496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 160499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160511 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160514 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160518 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160531 */     // (fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 160534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160536 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160538 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160547 */     GIR_RootConstrainSelectedInstOperands,
     /* 160548 */     // GIR_Coverage, 6449,
     /* 160548 */     GIR_EraseRootFromParent_Done,
     /* 160549 */   // Label 3517: @160549
     /* 160549 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(160576), // Rule ID 6445 //
     /* 160554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 160557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 160565 */     // (fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VMULPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 160565 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZrr),
     /* 160570 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160574 */     GIR_RootConstrainSelectedInstOperands,
     /* 160575 */     // GIR_Coverage, 6445,
     /* 160575 */     GIR_Done,
     /* 160576 */   // Label 3518: @160576
     /* 160576 */   GIM_Reject,
     /* 160577 */ // Label 3515: @160577
     /* 160577 */ GIM_Reject,
     /* 160578 */ // Label 3418: @160578
     /* 160578 */ GIM_Reject,
     /* 160579 */ // Label 44: @160579
     /* 160579 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3531*/ GIMT_Encode4(166566),
     /* 160590 */ /*GILLT_s16*//*Label 3519*/ GIMT_Encode4(160674),
     /* 160594 */ /*GILLT_s32*//*Label 3520*/ GIMT_Encode4(160919),
     /* 160598 */ /*GILLT_s64*//*Label 3521*/ GIMT_Encode4(161656), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 160614 */ /*GILLT_v2s64*//*Label 3522*/ GIMT_Encode4(162393), GIMT_Encode4(0),
     /* 160622 */ /*GILLT_v4s32*//*Label 3523*/ GIMT_Encode4(163130),
     /* 160626 */ /*GILLT_v4s64*//*Label 3524*/ GIMT_Encode4(163867), GIMT_Encode4(0),
     /* 160634 */ /*GILLT_v8s16*//*Label 3525*/ GIMT_Encode4(164604),
     /* 160638 */ /*GILLT_v8s32*//*Label 3526*/ GIMT_Encode4(164849),
     /* 160642 */ /*GILLT_v8s64*//*Label 3527*/ GIMT_Encode4(165586), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 160654 */ /*GILLT_v16s16*//*Label 3528*/ GIMT_Encode4(165831),
     /* 160658 */ /*GILLT_v16s32*//*Label 3529*/ GIMT_Encode4(166076), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 160670 */ /*GILLT_v32s16*//*Label 3530*/ GIMT_Encode4(166321),
     /* 160674 */ // Label 3519: @160674
     /* 160674 */ GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(160918),
     /* 160679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 160682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160685 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 160688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 160692 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(160756), // Rule ID 10157 //
     /* 160697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 160700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160708 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160711 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160715 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 160723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 160727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160736 */     // (fma:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VFMADD132SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 160736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SHZm),
     /* 160739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160741 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160743 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 160745 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 160749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160754 */     GIR_RootConstrainSelectedInstOperands,
     /* 160755 */     // GIR_Coverage, 10157,
     /* 160755 */     GIR_EraseRootFromParent_Done,
     /* 160756 */   // Label 3533: @160756
     /* 160756 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(160820), // Rule ID 10155 //
     /* 160761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 160764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 160768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160776 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160779 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160783 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 160791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160793 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160800 */     // (fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VFMADD231SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 160800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SHZm),
     /* 160803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160805 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 160807 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 160809 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 160813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160818 */     GIR_RootConstrainSelectedInstOperands,
     /* 160819 */     // GIR_Coverage, 10155,
     /* 160819 */     GIR_EraseRootFromParent_Done,
     /* 160820 */   // Label 3534: @160820
     /* 160820 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(160884), // Rule ID 10152 //
     /* 160825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 160828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 160832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 160836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160844 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160847 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160851 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160864 */     // (fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 160864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZm),
     /* 160867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160869 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160871 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 160873 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 160877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160882 */     GIR_RootConstrainSelectedInstOperands,
     /* 160883 */     // GIR_Coverage, 10152,
     /* 160883 */     GIR_EraseRootFromParent_Done,
     /* 160884 */   // Label 3535: @160884
     /* 160884 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(160917), // Rule ID 10150 //
     /* 160889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 160892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 160896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 160900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 160904 */     // (fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src3)  =>  (VFMADD213SHZr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src3)
     /* 160904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZr),
     /* 160907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160909 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160911 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 160913 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 160915 */     GIR_RootConstrainSelectedInstOperands,
     /* 160916 */     // GIR_Coverage, 10150,
     /* 160916 */     GIR_EraseRootFromParent_Done,
     /* 160917 */   // Label 3536: @160917
     /* 160917 */   GIM_Reject,
     /* 160918 */ // Label 3532: @160918
     /* 160918 */ GIM_Reject,
     /* 160919 */ // Label 3520: @160919
     /* 160919 */ GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(161655),
     /* 160924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 160927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160930 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160933 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(161001), // Rule ID 1303 //
     /* 160938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 160941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 160945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160953 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160956 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160960 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 160968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 160972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160974 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160981 */     // (fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VFMADD132SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 160981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSm),
     /* 160984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160986 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160988 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 160990 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 160994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160999 */     GIR_RootConstrainSelectedInstOperands,
     /* 161000 */     // GIR_Coverage, 1303,
     /* 161000 */     GIR_EraseRootFromParent_Done,
     /* 161001 */   // Label 3538: @161001
     /* 161001 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(161069), // Rule ID 10139 //
     /* 161006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 161009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161021 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161024 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161028 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161049 */     // (fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VFMADD132SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSZm),
     /* 161052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161054 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161056 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 161058 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161067 */     GIR_RootConstrainSelectedInstOperands,
     /* 161068 */     // GIR_Coverage, 10139,
     /* 161068 */     GIR_EraseRootFromParent_Done,
     /* 161069 */   // Label 3539: @161069
     /* 161069 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(161137), // Rule ID 23278 //
     /* 161074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 161077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161089 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161092 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161096 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161117 */     // (fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 161117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 161120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161122 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161124 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161128 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 161130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161135 */     GIR_RootConstrainSelectedInstOperands,
     /* 161136 */     // GIR_Coverage, 23278,
     /* 161136 */     GIR_EraseRootFromParent_Done,
     /* 161137 */   // Label 3540: @161137
     /* 161137 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(161205), // Rule ID 1301 //
     /* 161142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 161145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161161 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161164 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161168 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161178 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161185 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VFMADD231SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSm),
     /* 161188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161190 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 161192 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 161194 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161203 */     GIR_RootConstrainSelectedInstOperands,
     /* 161204 */     // GIR_Coverage, 1301,
     /* 161204 */     GIR_EraseRootFromParent_Done,
     /* 161205 */   // Label 3541: @161205
     /* 161205 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(161273), // Rule ID 1365 //
     /* 161210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 161213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161229 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161232 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161236 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161246 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161253 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 161253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 161256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161258 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161260 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161264 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 161266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161271 */     GIR_RootConstrainSelectedInstOperands,
     /* 161272 */     // GIR_Coverage, 1365,
     /* 161272 */     GIR_EraseRootFromParent_Done,
     /* 161273 */   // Label 3542: @161273
     /* 161273 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(161341), // Rule ID 10137 //
     /* 161278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 161281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161297 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161300 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161304 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161314 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161321 */     // (fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VFMADD231SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSZm),
     /* 161324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161326 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 161328 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 161330 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161339 */     GIR_RootConstrainSelectedInstOperands,
     /* 161340 */     // GIR_Coverage, 10137,
     /* 161340 */     GIR_EraseRootFromParent_Done,
     /* 161341 */   // Label 3543: @161341
     /* 161341 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(161409), // Rule ID 1299 //
     /* 161346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 161349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161369 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161372 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161376 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161389 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSm),
     /* 161392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161394 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161396 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 161398 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161407 */     GIR_RootConstrainSelectedInstOperands,
     /* 161408 */     // GIR_Coverage, 1299,
     /* 161408 */     GIR_EraseRootFromParent_Done,
     /* 161409 */   // Label 3544: @161409
     /* 161409 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(161477), // Rule ID 1363 //
     /* 161414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 161417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161437 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161440 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161444 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161450 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161457 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSS4rm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rm),
     /* 161460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161462 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161464 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 161466 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161475 */     GIR_RootConstrainSelectedInstOperands,
     /* 161476 */     // GIR_Coverage, 1363,
     /* 161476 */     GIR_EraseRootFromParent_Done,
     /* 161477 */   // Label 3545: @161477
     /* 161477 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(161545), // Rule ID 10134 //
     /* 161482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 161485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161505 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161508 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161512 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161525 */     // (fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZm),
     /* 161528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161530 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161532 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 161534 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161543 */     GIR_RootConstrainSelectedInstOperands,
     /* 161544 */     // GIR_Coverage, 10134,
     /* 161544 */     GIR_EraseRootFromParent_Done,
     /* 161545 */   // Label 3546: @161545
     /* 161545 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(161582), // Rule ID 1297 //
     /* 161550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 161553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161569 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADD213SSr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 161569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSr),
     /* 161572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161574 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161576 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 161578 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 161580 */     GIR_RootConstrainSelectedInstOperands,
     /* 161581 */     // GIR_Coverage, 1297,
     /* 161581 */     GIR_EraseRootFromParent_Done,
     /* 161582 */   // Label 3547: @161582
     /* 161582 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(161617), // Rule ID 1361 //
     /* 161587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 161590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 161606 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4rr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 161606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rr),
     /* 161611 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 161615 */     GIR_RootConstrainSelectedInstOperands,
     /* 161616 */     // GIR_Coverage, 1361,
     /* 161616 */     GIR_Done,
     /* 161617 */   // Label 3548: @161617
     /* 161617 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(161654), // Rule ID 10132 //
     /* 161622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 161625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 161641 */     // (fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src3)  =>  (VFMADD213SSZr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src3)
     /* 161641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZr),
     /* 161644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161646 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161648 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 161650 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 161652 */     GIR_RootConstrainSelectedInstOperands,
     /* 161653 */     // GIR_Coverage, 10132,
     /* 161653 */     GIR_EraseRootFromParent_Done,
     /* 161654 */   // Label 3549: @161654
     /* 161654 */   GIM_Reject,
     /* 161655 */ // Label 3537: @161655
     /* 161655 */ GIM_Reject,
     /* 161656 */ // Label 3521: @161656
     /* 161656 */ GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(162392),
     /* 161661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 161664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161667 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161670 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(161738), // Rule ID 1311 //
     /* 161675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 161678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 161682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161690 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161693 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161697 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 161705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 161709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161718 */     // (fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VFMADD132SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDm),
     /* 161721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161723 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161725 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 161727 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161736 */     GIR_RootConstrainSelectedInstOperands,
     /* 161737 */     // GIR_Coverage, 1311,
     /* 161737 */     GIR_EraseRootFromParent_Done,
     /* 161738 */   // Label 3551: @161738
     /* 161738 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(161806), // Rule ID 10148 //
     /* 161743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 161746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 161750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161758 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161761 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161765 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 161773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 161777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161786 */     // (fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VFMADD132SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDZm),
     /* 161789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161791 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161793 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 161795 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161804 */     GIR_RootConstrainSelectedInstOperands,
     /* 161805 */     // GIR_Coverage, 10148,
     /* 161805 */     GIR_EraseRootFromParent_Done,
     /* 161806 */   // Label 3552: @161806
     /* 161806 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(161874), // Rule ID 23306 //
     /* 161811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 161814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 161818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161826 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161829 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161833 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 161841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 161845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161854 */     // (fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 161854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 161857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161859 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161861 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161865 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 161867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161872 */     GIR_RootConstrainSelectedInstOperands,
     /* 161873 */     // GIR_Coverage, 23306,
     /* 161873 */     GIR_EraseRootFromParent_Done,
     /* 161874 */   // Label 3553: @161874
     /* 161874 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(161942), // Rule ID 1309 //
     /* 161879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 161882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 161886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 161890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161898 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161901 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161905 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 161913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161922 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VFMADD231SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 161922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDm),
     /* 161925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161927 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 161929 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 161931 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 161935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161940 */     GIR_RootConstrainSelectedInstOperands,
     /* 161941 */     // GIR_Coverage, 1309,
     /* 161941 */     GIR_EraseRootFromParent_Done,
     /* 161942 */   // Label 3554: @161942
     /* 161942 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(162010), // Rule ID 1449 //
     /* 161947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 161950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 161954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 161958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161966 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161969 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161973 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 161981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161983 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161990 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 161990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 161993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161995 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161997 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162001 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 162003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162008 */     GIR_RootConstrainSelectedInstOperands,
     /* 162009 */     // GIR_Coverage, 1449,
     /* 162009 */     GIR_EraseRootFromParent_Done,
     /* 162010 */   // Label 3555: @162010
     /* 162010 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(162078), // Rule ID 10146 //
     /* 162015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 162018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162034 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162037 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162041 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162051 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162058 */     // (fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VFMADD231SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDZm),
     /* 162061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162063 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 162065 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162067 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162076 */     GIR_RootConstrainSelectedInstOperands,
     /* 162077 */     // GIR_Coverage, 10146,
     /* 162077 */     GIR_EraseRootFromParent_Done,
     /* 162078 */   // Label 3556: @162078
     /* 162078 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(162146), // Rule ID 1307 //
     /* 162083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 162086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162106 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162109 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162113 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162119 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162126 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDm),
     /* 162129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162131 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162133 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162135 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162144 */     GIR_RootConstrainSelectedInstOperands,
     /* 162145 */     // GIR_Coverage, 1307,
     /* 162145 */     GIR_EraseRootFromParent_Done,
     /* 162146 */   // Label 3557: @162146
     /* 162146 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(162214), // Rule ID 1447 //
     /* 162151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 162154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162174 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162177 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162181 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162194 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSD4rm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rm),
     /* 162197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162199 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162201 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 162203 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162212 */     GIR_RootConstrainSelectedInstOperands,
     /* 162213 */     // GIR_Coverage, 1447,
     /* 162213 */     GIR_EraseRootFromParent_Done,
     /* 162214 */   // Label 3558: @162214
     /* 162214 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(162282), // Rule ID 10143 //
     /* 162219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 162222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162242 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162245 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162249 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162255 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162262 */     // (fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZm),
     /* 162265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162267 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162269 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162271 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162280 */     GIR_RootConstrainSelectedInstOperands,
     /* 162281 */     // GIR_Coverage, 10143,
     /* 162281 */     GIR_EraseRootFromParent_Done,
     /* 162282 */   // Label 3559: @162282
     /* 162282 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(162319), // Rule ID 1305 //
     /* 162287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 162290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162306 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADD213SDr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 162306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDr),
     /* 162309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162311 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162313 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162315 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 162317 */     GIR_RootConstrainSelectedInstOperands,
     /* 162318 */     // GIR_Coverage, 1305,
     /* 162318 */     GIR_EraseRootFromParent_Done,
     /* 162319 */   // Label 3560: @162319
     /* 162319 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(162354), // Rule ID 1445 //
     /* 162324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 162327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 162343 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4rr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 162343 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rr),
     /* 162348 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162352 */     GIR_RootConstrainSelectedInstOperands,
     /* 162353 */     // GIR_Coverage, 1445,
     /* 162353 */     GIR_Done,
     /* 162354 */   // Label 3561: @162354
     /* 162354 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(162391), // Rule ID 10141 //
     /* 162359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 162362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 162378 */     // (fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src3)  =>  (VFMADD213SDZr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src3)
     /* 162378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZr),
     /* 162381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162383 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162385 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162387 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 162389 */     GIR_RootConstrainSelectedInstOperands,
     /* 162390 */     // GIR_Coverage, 10141,
     /* 162390 */     GIR_EraseRootFromParent_Done,
     /* 162391 */   // Label 3562: @162391
     /* 162391 */   GIM_Reject,
     /* 162392 */ // Label 3550: @162392
     /* 162392 */ GIM_Reject,
     /* 162393 */ // Label 3522: @162393
     /* 162393 */ GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(163129),
     /* 162398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 162401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162404 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 162407 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(162475), // Rule ID 1191 //
     /* 162412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 162415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162427 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162430 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162434 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162448 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162455 */     // (fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDm),
     /* 162458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162460 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162462 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 162464 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162473 */     GIR_RootConstrainSelectedInstOperands,
     /* 162474 */     // GIR_Coverage, 1191,
     /* 162474 */     GIR_EraseRootFromParent_Done,
     /* 162475 */   // Label 3564: @162475
     /* 162475 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(162543), // Rule ID 9680 //
     /* 162480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162495 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162498 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162502 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162523 */     // (fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ128m),
     /* 162526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162528 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162530 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 162532 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162541 */     GIR_RootConstrainSelectedInstOperands,
     /* 162542 */     // GIR_Coverage, 9680,
     /* 162542 */     GIR_EraseRootFromParent_Done,
     /* 162543 */   // Label 3565: @162543
     /* 162543 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(162611), // Rule ID 23314 //
     /* 162548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 162551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162563 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162566 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162570 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162584 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162591 */     // (fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 162591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 162594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162596 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162598 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162602 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 162604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162609 */     GIR_RootConstrainSelectedInstOperands,
     /* 162610 */     // GIR_Coverage, 23314,
     /* 162610 */     GIR_EraseRootFromParent_Done,
     /* 162611 */   // Label 3566: @162611
     /* 162611 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(162679), // Rule ID 1189 //
     /* 162616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 162619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162635 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162638 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162642 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162659 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDm),
     /* 162662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162664 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 162666 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162668 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162677 */     GIR_RootConstrainSelectedInstOperands,
     /* 162678 */     // GIR_Coverage, 1189,
     /* 162678 */     GIR_EraseRootFromParent_Done,
     /* 162679 */   // Label 3567: @162679
     /* 162679 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(162747), // Rule ID 1473 //
     /* 162684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 162687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162703 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162706 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162710 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162720 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162727 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 162727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 162730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162732 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162734 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162738 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 162740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162745 */     GIR_RootConstrainSelectedInstOperands,
     /* 162746 */     // GIR_Coverage, 1473,
     /* 162746 */     GIR_EraseRootFromParent_Done,
     /* 162747 */   // Label 3568: @162747
     /* 162747 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(162815), // Rule ID 9140 //
     /* 162752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162771 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162774 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162778 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162788 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162795 */     // (fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ128m),
     /* 162798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162800 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 162802 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162804 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162813 */     GIR_RootConstrainSelectedInstOperands,
     /* 162814 */     // GIR_Coverage, 9140,
     /* 162814 */     GIR_EraseRootFromParent_Done,
     /* 162815 */   // Label 3569: @162815
     /* 162815 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(162883), // Rule ID 1187 //
     /* 162820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 162823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162843 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162846 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162850 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162856 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162863 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDm),
     /* 162866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162868 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162870 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 162872 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162881 */     GIR_RootConstrainSelectedInstOperands,
     /* 162882 */     // GIR_Coverage, 1187,
     /* 162882 */     GIR_EraseRootFromParent_Done,
     /* 162883 */   // Label 3570: @162883
     /* 162883 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(162951), // Rule ID 1471 //
     /* 162888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 162891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162911 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162914 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162918 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162924 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162931 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4rm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rm),
     /* 162934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162936 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162938 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 162940 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 162944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162949 */     GIR_RootConstrainSelectedInstOperands,
     /* 162950 */     // GIR_Coverage, 1471,
     /* 162950 */     GIR_EraseRootFromParent_Done,
     /* 162951 */   // Label 3571: @162951
     /* 162951 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(163019), // Rule ID 8513 //
     /* 162956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162979 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162982 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162986 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162992 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162999 */     // (fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 162999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128m),
     /* 163002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163004 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163006 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163008 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163017 */     GIR_RootConstrainSelectedInstOperands,
     /* 163018 */     // GIR_Coverage, 8513,
     /* 163018 */     GIR_EraseRootFromParent_Done,
     /* 163019 */   // Label 3572: @163019
     /* 163019 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(163056), // Rule ID 1185 //
     /* 163024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 163027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163043 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 163043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDr),
     /* 163046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163048 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163050 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163052 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 163054 */     GIR_RootConstrainSelectedInstOperands,
     /* 163055 */     // GIR_Coverage, 1185,
     /* 163055 */     GIR_EraseRootFromParent_Done,
     /* 163056 */   // Label 3573: @163056
     /* 163056 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(163091), // Rule ID 1469 //
     /* 163061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 163064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163080 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4rr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 163080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rr),
     /* 163085 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163089 */     GIR_RootConstrainSelectedInstOperands,
     /* 163090 */     // GIR_Coverage, 1469,
     /* 163090 */     GIR_Done,
     /* 163091 */   // Label 3574: @163091
     /* 163091 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(163128), // Rule ID 8509 //
     /* 163096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 163099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163115 */     // (fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src3)
     /* 163115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128r),
     /* 163118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163120 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163122 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163124 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 163126 */     GIR_RootConstrainSelectedInstOperands,
     /* 163127 */     // GIR_Coverage, 8509,
     /* 163127 */     GIR_EraseRootFromParent_Done,
     /* 163128 */   // Label 3575: @163128
     /* 163128 */   GIM_Reject,
     /* 163129 */ // Label 3563: @163129
     /* 163129 */ GIM_Reject,
     /* 163130 */ // Label 3523: @163130
     /* 163130 */ GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(163866),
     /* 163135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163141 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163144 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(163212), // Rule ID 1143 //
     /* 163149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 163152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163164 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163167 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163171 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163192 */     // (fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSm),
     /* 163195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163197 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163199 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 163201 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163210 */     GIR_RootConstrainSelectedInstOperands,
     /* 163211 */     // GIR_Coverage, 1143,
     /* 163211 */     GIR_EraseRootFromParent_Done,
     /* 163212 */   // Label 3577: @163212
     /* 163212 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(163280), // Rule ID 9648 //
     /* 163217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 163220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163232 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163235 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163239 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163253 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163260 */     // (fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ128m),
     /* 163263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163265 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163267 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 163269 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163278 */     GIR_RootConstrainSelectedInstOperands,
     /* 163279 */     // GIR_Coverage, 9648,
     /* 163279 */     GIR_EraseRootFromParent_Done,
     /* 163280 */   // Label 3578: @163280
     /* 163280 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(163348), // Rule ID 23286 //
     /* 163285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 163288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163300 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163303 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163307 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163328 */     // (fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 163328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 163331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163333 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163335 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163339 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 163341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163346 */     GIR_RootConstrainSelectedInstOperands,
     /* 163347 */     // GIR_Coverage, 23286,
     /* 163347 */     GIR_EraseRootFromParent_Done,
     /* 163348 */   // Label 3579: @163348
     /* 163348 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(163416), // Rule ID 1141 //
     /* 163353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 163356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163372 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163375 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163379 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163396 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSm),
     /* 163399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163401 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 163403 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163405 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163414 */     GIR_RootConstrainSelectedInstOperands,
     /* 163415 */     // GIR_Coverage, 1141,
     /* 163415 */     GIR_EraseRootFromParent_Done,
     /* 163416 */   // Label 3580: @163416
     /* 163416 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(163484), // Rule ID 1389 //
     /* 163421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 163424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163440 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163443 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163447 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163464 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 163464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 163467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163469 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 163471 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163475 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 163477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163482 */     GIR_RootConstrainSelectedInstOperands,
     /* 163483 */     // GIR_Coverage, 1389,
     /* 163483 */     GIR_EraseRootFromParent_Done,
     /* 163484 */   // Label 3581: @163484
     /* 163484 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(163552), // Rule ID 9108 //
     /* 163489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 163492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163508 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163511 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163515 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163532 */     // (fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ128m),
     /* 163535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163537 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 163539 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163541 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163550 */     GIR_RootConstrainSelectedInstOperands,
     /* 163551 */     // GIR_Coverage, 9108,
     /* 163551 */     GIR_EraseRootFromParent_Done,
     /* 163552 */   // Label 3582: @163552
     /* 163552 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(163620), // Rule ID 1139 //
     /* 163557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 163560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163580 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163583 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163587 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163600 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSm),
     /* 163603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163605 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163607 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163618 */     GIR_RootConstrainSelectedInstOperands,
     /* 163619 */     // GIR_Coverage, 1139,
     /* 163619 */     GIR_EraseRootFromParent_Done,
     /* 163620 */   // Label 3583: @163620
     /* 163620 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(163688), // Rule ID 1387 //
     /* 163625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 163628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163648 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163651 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163655 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163668 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4rm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rm),
     /* 163671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163673 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 163675 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 163677 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163686 */     GIR_RootConstrainSelectedInstOperands,
     /* 163687 */     // GIR_Coverage, 1387,
     /* 163687 */     GIR_EraseRootFromParent_Done,
     /* 163688 */   // Label 3584: @163688
     /* 163688 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(163756), // Rule ID 8474 //
     /* 163693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 163696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163716 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163719 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163723 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163736 */     // (fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128m),
     /* 163739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163741 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163743 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163745 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163754 */     GIR_RootConstrainSelectedInstOperands,
     /* 163755 */     // GIR_Coverage, 8474,
     /* 163755 */     GIR_EraseRootFromParent_Done,
     /* 163756 */   // Label 3585: @163756
     /* 163756 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(163793), // Rule ID 1137 //
     /* 163761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 163764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163780 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 163780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSr),
     /* 163783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163785 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163787 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163789 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 163791 */     GIR_RootConstrainSelectedInstOperands,
     /* 163792 */     // GIR_Coverage, 1137,
     /* 163792 */     GIR_EraseRootFromParent_Done,
     /* 163793 */   // Label 3586: @163793
     /* 163793 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(163828), // Rule ID 1385 //
     /* 163798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 163801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 163817 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4rr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 163817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rr),
     /* 163822 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163826 */     GIR_RootConstrainSelectedInstOperands,
     /* 163827 */     // GIR_Coverage, 1385,
     /* 163827 */     GIR_Done,
     /* 163828 */   // Label 3587: @163828
     /* 163828 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(163865), // Rule ID 8470 //
     /* 163833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 163836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 163852 */     // (fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src3)
     /* 163852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128r),
     /* 163855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163857 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163859 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163861 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 163863 */     GIR_RootConstrainSelectedInstOperands,
     /* 163864 */     // GIR_Coverage, 8470,
     /* 163864 */     GIR_EraseRootFromParent_Done,
     /* 163865 */   // Label 3588: @163865
     /* 163865 */   GIM_Reject,
     /* 163866 */ // Label 3576: @163866
     /* 163866 */ GIM_Reject,
     /* 163867 */ // Label 3524: @163867
     /* 163867 */ GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(164603),
     /* 163872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 163875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 163878 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 163881 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(163949), // Rule ID 1199 //
     /* 163886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 163889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 163893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163901 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163904 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163908 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 163916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 163920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163929 */     // (fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDYm),
     /* 163932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163934 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163936 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 163938 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163947 */     GIR_RootConstrainSelectedInstOperands,
     /* 163948 */     // GIR_Coverage, 1199,
     /* 163948 */     GIR_EraseRootFromParent_Done,
     /* 163949 */   // Label 3590: @163949
     /* 163949 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(164017), // Rule ID 9670 //
     /* 163954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 163957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163969 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163972 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163976 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163997 */     // (fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ256m),
     /* 164000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164002 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164004 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 164006 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164015 */     GIR_RootConstrainSelectedInstOperands,
     /* 164016 */     // GIR_Coverage, 9670,
     /* 164016 */     GIR_EraseRootFromParent_Done,
     /* 164017 */   // Label 3591: @164017
     /* 164017 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(164085), // Rule ID 23316 //
     /* 164022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 164025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164037 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164040 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164044 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164065 */     // (fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 164065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 164068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164070 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164072 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 164076 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164083 */     GIR_RootConstrainSelectedInstOperands,
     /* 164084 */     // GIR_Coverage, 23316,
     /* 164084 */     GIR_EraseRootFromParent_Done,
     /* 164085 */   // Label 3592: @164085
     /* 164085 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(164153), // Rule ID 1197 //
     /* 164090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 164093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164109 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164112 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164116 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164126 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164133 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDYm),
     /* 164136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164138 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 164140 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164151 */     GIR_RootConstrainSelectedInstOperands,
     /* 164152 */     // GIR_Coverage, 1197,
     /* 164152 */     GIR_EraseRootFromParent_Done,
     /* 164153 */   // Label 3593: @164153
     /* 164153 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(164221), // Rule ID 1479 //
     /* 164158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 164161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164177 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164180 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164184 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164194 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164201 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 164201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 164204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164206 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 164208 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 164212 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164219 */     GIR_RootConstrainSelectedInstOperands,
     /* 164220 */     // GIR_Coverage, 1479,
     /* 164220 */     GIR_EraseRootFromParent_Done,
     /* 164221 */   // Label 3594: @164221
     /* 164221 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(164289), // Rule ID 9130 //
     /* 164226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 164229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164245 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164248 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164252 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164269 */     // (fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ256m),
     /* 164272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164274 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 164276 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164278 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164287 */     GIR_RootConstrainSelectedInstOperands,
     /* 164288 */     // GIR_Coverage, 9130,
     /* 164288 */     GIR_EraseRootFromParent_Done,
     /* 164289 */   // Label 3595: @164289
     /* 164289 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(164357), // Rule ID 1195 //
     /* 164294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 164297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164317 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164320 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164324 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164337 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYm),
     /* 164340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164342 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164344 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164346 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164355 */     GIR_RootConstrainSelectedInstOperands,
     /* 164356 */     // GIR_Coverage, 1195,
     /* 164356 */     GIR_EraseRootFromParent_Done,
     /* 164357 */   // Label 3596: @164357
     /* 164357 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(164425), // Rule ID 1477 //
     /* 164362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 164365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164385 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164388 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164392 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164405 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4Yrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrm),
     /* 164408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164410 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 164412 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 164414 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164423 */     GIR_RootConstrainSelectedInstOperands,
     /* 164424 */     // GIR_Coverage, 1477,
     /* 164424 */     GIR_EraseRootFromParent_Done,
     /* 164425 */   // Label 3597: @164425
     /* 164425 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(164493), // Rule ID 8501 //
     /* 164430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 164433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164453 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164456 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164460 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164466 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164473 */     // (fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256m),
     /* 164476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164478 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164480 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164482 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164491 */     GIR_RootConstrainSelectedInstOperands,
     /* 164492 */     // GIR_Coverage, 8501,
     /* 164492 */     GIR_EraseRootFromParent_Done,
     /* 164493 */   // Label 3598: @164493
     /* 164493 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(164530), // Rule ID 1193 //
     /* 164498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 164501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164517 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 164517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYr),
     /* 164520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164522 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164524 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164526 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164528 */     GIR_RootConstrainSelectedInstOperands,
     /* 164529 */     // GIR_Coverage, 1193,
     /* 164529 */     GIR_EraseRootFromParent_Done,
     /* 164530 */   // Label 3599: @164530
     /* 164530 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(164565), // Rule ID 1475 //
     /* 164535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 164538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164554 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Yrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 164554 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrr),
     /* 164559 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 164563 */     GIR_RootConstrainSelectedInstOperands,
     /* 164564 */     // GIR_Coverage, 1475,
     /* 164564 */     GIR_Done,
     /* 164565 */   // Label 3600: @164565
     /* 164565 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(164602), // Rule ID 8497 //
     /* 164570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 164573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164589 */     // (fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src3)
     /* 164589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256r),
     /* 164592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164594 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164596 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164598 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164600 */     GIR_RootConstrainSelectedInstOperands,
     /* 164601 */     // GIR_Coverage, 8497,
     /* 164601 */     GIR_EraseRootFromParent_Done,
     /* 164602 */   // Label 3601: @164602
     /* 164602 */   GIM_Reject,
     /* 164603 */ // Label 3589: @164603
     /* 164603 */ GIM_Reject,
     /* 164604 */ // Label 3525: @164604
     /* 164604 */ GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(164848),
     /* 164609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 164612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164615 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 164618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164622 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(164686), // Rule ID 9616 //
     /* 164627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 164630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164638 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164641 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164645 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164666 */     // (fma:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VFMADD132PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ128m),
     /* 164669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164671 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164673 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 164675 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164684 */     GIR_RootConstrainSelectedInstOperands,
     /* 164685 */     // GIR_Coverage, 9616,
     /* 164685 */     GIR_EraseRootFromParent_Done,
     /* 164686 */   // Label 3603: @164686
     /* 164686 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(164750), // Rule ID 9076 //
     /* 164691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 164694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164706 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164709 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164713 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164730 */     // (fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VFMADD231PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ128m),
     /* 164733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164735 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 164737 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164739 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164748 */     GIR_RootConstrainSelectedInstOperands,
     /* 164749 */     // GIR_Coverage, 9076,
     /* 164749 */     GIR_EraseRootFromParent_Done,
     /* 164750 */   // Label 3604: @164750
     /* 164750 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(164814), // Rule ID 8435 //
     /* 164755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 164758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164774 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164777 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164781 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164794 */     // (fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128m),
     /* 164797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164799 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164801 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164803 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164812 */     GIR_RootConstrainSelectedInstOperands,
     /* 164813 */     // GIR_Coverage, 8435,
     /* 164813 */     GIR_EraseRootFromParent_Done,
     /* 164814 */   // Label 3605: @164814
     /* 164814 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(164847), // Rule ID 8431 //
     /* 164819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 164822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 164834 */     // (fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src3)  =>  (VFMADD213PHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src3)
     /* 164834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128r),
     /* 164837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164839 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164841 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164843 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164845 */     GIR_RootConstrainSelectedInstOperands,
     /* 164846 */     // GIR_Coverage, 8431,
     /* 164846 */     GIR_EraseRootFromParent_Done,
     /* 164847 */   // Label 3606: @164847
     /* 164847 */   GIM_Reject,
     /* 164848 */ // Label 3602: @164848
     /* 164848 */ GIM_Reject,
     /* 164849 */ // Label 3526: @164849
     /* 164849 */ GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(165585),
     /* 164854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 164857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 164860 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 164863 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(164931), // Rule ID 1151 //
     /* 164868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 164871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164883 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164886 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164890 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 164902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164911 */     // (fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSYm),
     /* 164914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164916 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164918 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 164920 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164929 */     GIR_RootConstrainSelectedInstOperands,
     /* 164930 */     // GIR_Coverage, 1151,
     /* 164930 */     GIR_EraseRootFromParent_Done,
     /* 164931 */   // Label 3608: @164931
     /* 164931 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(164999), // Rule ID 9638 //
     /* 164936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 164939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164951 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164954 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164958 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 164970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164979 */     // (fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ256m),
     /* 164982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164984 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164986 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 164988 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164997 */     GIR_RootConstrainSelectedInstOperands,
     /* 164998 */     // GIR_Coverage, 9638,
     /* 164998 */     GIR_EraseRootFromParent_Done,
     /* 164999 */   // Label 3609: @164999
     /* 164999 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(165067), // Rule ID 23288 //
     /* 165004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 165007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165019 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165022 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165026 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165047 */     // (fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 165047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 165050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165052 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165054 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 165058 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165065 */     GIR_RootConstrainSelectedInstOperands,
     /* 165066 */     // GIR_Coverage, 23288,
     /* 165066 */     GIR_EraseRootFromParent_Done,
     /* 165067 */   // Label 3610: @165067
     /* 165067 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(165135), // Rule ID 1149 //
     /* 165072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 165075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165091 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165094 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165098 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165115 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSYm),
     /* 165118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165120 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165122 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165124 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165133 */     GIR_RootConstrainSelectedInstOperands,
     /* 165134 */     // GIR_Coverage, 1149,
     /* 165134 */     GIR_EraseRootFromParent_Done,
     /* 165135 */   // Label 3611: @165135
     /* 165135 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(165203), // Rule ID 1395 //
     /* 165140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 165143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165159 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165162 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165166 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165183 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 165183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 165186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165188 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 165190 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 165194 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165201 */     GIR_RootConstrainSelectedInstOperands,
     /* 165202 */     // GIR_Coverage, 1395,
     /* 165202 */     GIR_EraseRootFromParent_Done,
     /* 165203 */   // Label 3612: @165203
     /* 165203 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(165271), // Rule ID 9098 //
     /* 165208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 165211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165227 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165230 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165234 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165251 */     // (fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ256m),
     /* 165254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165256 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165258 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165260 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165269 */     GIR_RootConstrainSelectedInstOperands,
     /* 165270 */     // GIR_Coverage, 9098,
     /* 165270 */     GIR_EraseRootFromParent_Done,
     /* 165271 */   // Label 3613: @165271
     /* 165271 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(165339), // Rule ID 1147 //
     /* 165276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 165279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165299 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165302 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165306 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165319 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYm),
     /* 165322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165324 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165326 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165328 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165337 */     GIR_RootConstrainSelectedInstOperands,
     /* 165338 */     // GIR_Coverage, 1147,
     /* 165338 */     GIR_EraseRootFromParent_Done,
     /* 165339 */   // Label 3614: @165339
     /* 165339 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(165407), // Rule ID 1393 //
     /* 165344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 165347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165367 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165370 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165374 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165387 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4Yrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrm),
     /* 165390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165392 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 165394 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 165396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165405 */     GIR_RootConstrainSelectedInstOperands,
     /* 165406 */     // GIR_Coverage, 1393,
     /* 165406 */     GIR_EraseRootFromParent_Done,
     /* 165407 */   // Label 3615: @165407
     /* 165407 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(165475), // Rule ID 8462 //
     /* 165412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 165415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165435 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165438 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165442 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165448 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165455 */     // (fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256m),
     /* 165458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165460 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165462 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165464 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165473 */     GIR_RootConstrainSelectedInstOperands,
     /* 165474 */     // GIR_Coverage, 8462,
     /* 165474 */     GIR_EraseRootFromParent_Done,
     /* 165475 */   // Label 3616: @165475
     /* 165475 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(165512), // Rule ID 1145 //
     /* 165480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 165483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165499 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 165499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYr),
     /* 165502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165504 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165506 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165508 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165510 */     GIR_RootConstrainSelectedInstOperands,
     /* 165511 */     // GIR_Coverage, 1145,
     /* 165511 */     GIR_EraseRootFromParent_Done,
     /* 165512 */   // Label 3617: @165512
     /* 165512 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(165547), // Rule ID 1391 //
     /* 165517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 165520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 165536 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Yrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 165536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrr),
     /* 165541 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 165545 */     GIR_RootConstrainSelectedInstOperands,
     /* 165546 */     // GIR_Coverage, 1391,
     /* 165546 */     GIR_Done,
     /* 165547 */   // Label 3618: @165547
     /* 165547 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(165584), // Rule ID 8458 //
     /* 165552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 165555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165571 */     // (fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src3)
     /* 165571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256r),
     /* 165574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165576 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165578 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165580 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165582 */     GIR_RootConstrainSelectedInstOperands,
     /* 165583 */     // GIR_Coverage, 8458,
     /* 165583 */     GIR_EraseRootFromParent_Done,
     /* 165584 */   // Label 3619: @165584
     /* 165584 */   GIM_Reject,
     /* 165585 */ // Label 3607: @165585
     /* 165585 */ GIM_Reject,
     /* 165586 */ // Label 3527: @165586
     /* 165586 */ GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(165830),
     /* 165591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 165594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 165597 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 165600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 165604 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(165668), // Rule ID 9658 //
     /* 165609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 165612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165620 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165623 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165627 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 165635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 165639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165641 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165648 */     // (fma:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VFMADD132PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZm),
     /* 165651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165653 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165655 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 165657 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165666 */     GIR_RootConstrainSelectedInstOperands,
     /* 165667 */     // GIR_Coverage, 9658,
     /* 165667 */     GIR_EraseRootFromParent_Done,
     /* 165668 */   // Label 3621: @165668
     /* 165668 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(165732), // Rule ID 9118 //
     /* 165673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 165676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 165680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165688 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165691 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165695 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 165703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165705 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165712 */     // (fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VFMADD231PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZm),
     /* 165715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165717 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165719 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165721 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165730 */     GIR_RootConstrainSelectedInstOperands,
     /* 165731 */     // GIR_Coverage, 9118,
     /* 165731 */     GIR_EraseRootFromParent_Done,
     /* 165732 */   // Label 3622: @165732
     /* 165732 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(165796), // Rule ID 8486 //
     /* 165737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 165740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 165744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 165748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165756 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165759 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165763 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165769 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165776 */     // (fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZm),
     /* 165779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165781 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165783 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165785 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165794 */     GIR_RootConstrainSelectedInstOperands,
     /* 165795 */     // GIR_Coverage, 8486,
     /* 165795 */     GIR_EraseRootFromParent_Done,
     /* 165796 */   // Label 3623: @165796
     /* 165796 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(165829), // Rule ID 8482 //
     /* 165801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 165804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 165808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 165812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 165816 */     // (fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src3)  =>  (VFMADD213PDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src3)
     /* 165816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZr),
     /* 165819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165821 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165823 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165825 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165827 */     GIR_RootConstrainSelectedInstOperands,
     /* 165828 */     // GIR_Coverage, 8482,
     /* 165828 */     GIR_EraseRootFromParent_Done,
     /* 165829 */   // Label 3624: @165829
     /* 165829 */   GIM_Reject,
     /* 165830 */ // Label 3620: @165830
     /* 165830 */ GIM_Reject,
     /* 165831 */ // Label 3528: @165831
     /* 165831 */ GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(166075),
     /* 165836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 165839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 165842 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 165845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165849 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(165913), // Rule ID 9606 //
     /* 165854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 165857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165865 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165868 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165872 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165886 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165893 */     // (fma:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VFMADD132PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ256m),
     /* 165896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165898 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165900 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 165902 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165911 */     GIR_RootConstrainSelectedInstOperands,
     /* 165912 */     // GIR_Coverage, 9606,
     /* 165912 */     GIR_EraseRootFromParent_Done,
     /* 165913 */   // Label 3626: @165913
     /* 165913 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(165977), // Rule ID 9066 //
     /* 165918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 165921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165933 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165936 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165940 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165957 */     // (fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VFMADD231PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ256m),
     /* 165960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165962 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165964 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165975 */     GIR_RootConstrainSelectedInstOperands,
     /* 165976 */     // GIR_Coverage, 9066,
     /* 165976 */     GIR_EraseRootFromParent_Done,
     /* 165977 */   // Label 3627: @165977
     /* 165977 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(166041), // Rule ID 8423 //
     /* 165982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 165985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 165993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166001 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166004 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166008 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166021 */     // (fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256m),
     /* 166024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166026 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166028 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166030 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166039 */     GIR_RootConstrainSelectedInstOperands,
     /* 166040 */     // GIR_Coverage, 8423,
     /* 166040 */     GIR_EraseRootFromParent_Done,
     /* 166041 */   // Label 3628: @166041
     /* 166041 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(166074), // Rule ID 8419 //
     /* 166046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 166049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 166061 */     // (fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src3)  =>  (VFMADD213PHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src3)
     /* 166061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256r),
     /* 166064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166066 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166068 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166070 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166072 */     GIR_RootConstrainSelectedInstOperands,
     /* 166073 */     // GIR_Coverage, 8419,
     /* 166073 */     GIR_EraseRootFromParent_Done,
     /* 166074 */   // Label 3629: @166074
     /* 166074 */   GIM_Reject,
     /* 166075 */ // Label 3625: @166075
     /* 166075 */ GIM_Reject,
     /* 166076 */ // Label 3529: @166076
     /* 166076 */ GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(166320),
     /* 166081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 166084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 166087 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 166090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166094 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(166158), // Rule ID 9626 //
     /* 166099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166110 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166113 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166117 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166131 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166138 */     // (fma:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VFMADD132PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZm),
     /* 166141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166143 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166145 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 166147 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166156 */     GIR_RootConstrainSelectedInstOperands,
     /* 166157 */     // GIR_Coverage, 9626,
     /* 166157 */     GIR_EraseRootFromParent_Done,
     /* 166158 */   // Label 3631: @166158
     /* 166158 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(166222), // Rule ID 9086 //
     /* 166163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166178 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166181 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166185 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166202 */     // (fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VFMADD231PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZm),
     /* 166205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166207 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 166209 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166211 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166220 */     GIR_RootConstrainSelectedInstOperands,
     /* 166221 */     // GIR_Coverage, 9086,
     /* 166221 */     GIR_EraseRootFromParent_Done,
     /* 166222 */   // Label 3632: @166222
     /* 166222 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(166286), // Rule ID 8447 //
     /* 166227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166246 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166249 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166253 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166259 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166266 */     // (fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZm),
     /* 166269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166271 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166273 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166275 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166284 */     GIR_RootConstrainSelectedInstOperands,
     /* 166285 */     // GIR_Coverage, 8447,
     /* 166285 */     GIR_EraseRootFromParent_Done,
     /* 166286 */   // Label 3633: @166286
     /* 166286 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(166319), // Rule ID 8443 //
     /* 166291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166306 */     // (fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src3)  =>  (VFMADD213PSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src3)
     /* 166306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZr),
     /* 166309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166311 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166313 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166315 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166317 */     GIR_RootConstrainSelectedInstOperands,
     /* 166318 */     // GIR_Coverage, 8443,
     /* 166318 */     GIR_EraseRootFromParent_Done,
     /* 166319 */   // Label 3634: @166319
     /* 166319 */   GIM_Reject,
     /* 166320 */ // Label 3630: @166320
     /* 166320 */ GIM_Reject,
     /* 166321 */ // Label 3530: @166321
     /* 166321 */ GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(166565),
     /* 166326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 166329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 166332 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 166335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166339 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(166403), // Rule ID 9594 //
     /* 166344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 166347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166355 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166358 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166362 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166376 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166383 */     // (fma:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VFMADD132PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZm),
     /* 166386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166388 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166390 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 166392 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166401 */     GIR_RootConstrainSelectedInstOperands,
     /* 166402 */     // GIR_Coverage, 9594,
     /* 166402 */     GIR_EraseRootFromParent_Done,
     /* 166403 */   // Label 3636: @166403
     /* 166403 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(166467), // Rule ID 9054 //
     /* 166408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 166411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166423 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166426 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166430 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166440 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166447 */     // (fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VFMADD231PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZm),
     /* 166450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166452 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 166454 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166456 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166465 */     GIR_RootConstrainSelectedInstOperands,
     /* 166466 */     // GIR_Coverage, 9054,
     /* 166466 */     GIR_EraseRootFromParent_Done,
     /* 166467 */   // Label 3637: @166467
     /* 166467 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(166531), // Rule ID 8408 //
     /* 166472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 166475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166491 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166494 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166498 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166511 */     // (fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZm),
     /* 166514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166516 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166518 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166520 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166529 */     GIR_RootConstrainSelectedInstOperands,
     /* 166530 */     // GIR_Coverage, 8408,
     /* 166530 */     GIR_EraseRootFromParent_Done,
     /* 166531 */   // Label 3638: @166531
     /* 166531 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(166564), // Rule ID 8404 //
     /* 166536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 166539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 166551 */     // (fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src3)  =>  (VFMADD213PHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src3)
     /* 166551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZr),
     /* 166554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166556 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166558 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166560 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166562 */     GIR_RootConstrainSelectedInstOperands,
     /* 166563 */     // GIR_Coverage, 8404,
     /* 166563 */     GIR_EraseRootFromParent_Done,
     /* 166564 */   // Label 3639: @166564
     /* 166564 */   GIM_Reject,
     /* 166565 */ // Label 3635: @166565
     /* 166565 */ GIM_Reject,
     /* 166566 */ // Label 3531: @166566
     /* 166566 */ GIM_Reject,
     /* 166567 */ // Label 45: @166567
     /* 166567 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3653*/ GIMT_Encode4(169960),
     /* 166578 */ /*GILLT_s16*//*Label 3640*/ GIMT_Encode4(166662),
     /* 166582 */ /*GILLT_s32*//*Label 3641*/ GIMT_Encode4(166760),
     /* 166586 */ /*GILLT_s64*//*Label 3642*/ GIMT_Encode4(167453),
     /* 166590 */ /*GILLT_s80*//*Label 3643*/ GIMT_Encode4(168290), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 166602 */ /*GILLT_v2s64*//*Label 3644*/ GIMT_Encode4(168612), GIMT_Encode4(0),
     /* 166610 */ /*GILLT_v4s32*//*Label 3645*/ GIMT_Encode4(168842),
     /* 166614 */ /*GILLT_v4s64*//*Label 3646*/ GIMT_Encode4(169072), GIMT_Encode4(0),
     /* 166622 */ /*GILLT_v8s16*//*Label 3647*/ GIMT_Encode4(169271),
     /* 166626 */ /*GILLT_v8s32*//*Label 3648*/ GIMT_Encode4(169369),
     /* 166630 */ /*GILLT_v8s64*//*Label 3649*/ GIMT_Encode4(169568), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 166642 */ /*GILLT_v16s16*//*Label 3650*/ GIMT_Encode4(169666),
     /* 166646 */ /*GILLT_v16s32*//*Label 3651*/ GIMT_Encode4(169764), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 166658 */ /*GILLT_v32s16*//*Label 3652*/ GIMT_Encode4(169862),
     /* 166662 */ // Label 3640: @166662
     /* 166662 */ GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(166759),
     /* 166667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 166670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 166673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 166677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 166681 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(166735), // Rule ID 6125 //
     /* 166686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 166689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166697 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166700 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166704 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166717 */     // (fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 166717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrm),
     /* 166720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166722 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 166724 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 166728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166733 */     GIR_RootConstrainSelectedInstOperands,
     /* 166734 */     // GIR_Coverage, 6125,
     /* 166734 */     GIR_EraseRootFromParent_Done,
     /* 166735 */   // Label 3655: @166735
     /* 166735 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(166758), // Rule ID 6123 //
     /* 166740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 166743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 166747 */     // (fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VDIVSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 166747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrr),
     /* 166752 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 166756 */     GIR_RootConstrainSelectedInstOperands,
     /* 166757 */     // GIR_Coverage, 6123,
     /* 166757 */     GIR_Done,
     /* 166758 */   // Label 3656: @166758
     /* 166758 */   GIM_Reject,
     /* 166759 */ // Label 3654: @166759
     /* 166759 */ GIM_Reject,
     /* 166760 */ // Label 3641: @166760
     /* 166760 */ GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(167452),
     /* 166765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 166768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166771 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(166849), // Rule ID 22484 //
     /* 166776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 166779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 166783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 166787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 166795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 166799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 166803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166807 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 166810 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 166817 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 166821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166823 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166830 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_32>>))  =>  (DIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 166830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSSrm),
     /* 166833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166835 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 166837 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 166841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 166847 */     GIR_RootConstrainSelectedInstOperands,
     /* 166848 */     // GIR_Coverage, 22484,
     /* 166848 */     GIR_EraseRootFromParent_Done,
     /* 166849 */   // Label 3658: @166849
     /* 166849 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(166927), // Rule ID 22485 //
     /* 166854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 166857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 166861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 166865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 166873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 166877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 166881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166885 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 166888 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 166895 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 166899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166901 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166908 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_32>>))  =>  (VDIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 166908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSrm),
     /* 166911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166913 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 166915 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 166919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 166925 */     GIR_RootConstrainSelectedInstOperands,
     /* 166926 */     // GIR_Coverage, 22485,
     /* 166926 */     GIR_EraseRootFromParent_Done,
     /* 166927 */   // Label 3659: @166927
     /* 166927 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(167005), // Rule ID 22486 //
     /* 166932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 166935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 166939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 166943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 166951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 166955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 166959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166963 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 166966 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 166973 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 166977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166979 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166986 */     // (fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_32>>))  =>  (VDIVSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 166986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrm),
     /* 166989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166991 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 166993 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 166997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 167003 */     GIR_RootConstrainSelectedInstOperands,
     /* 167004 */     // GIR_Coverage, 22486,
     /* 167004 */     GIR_EraseRootFromParent_Done,
     /* 167005 */   // Label 3660: @167005
     /* 167005 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(167070), // Rule ID 1020 //
     /* 167010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 167013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 167021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167025 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167028 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167032 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167049 */     // (fdiv:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp32m),
     /* 167052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167054 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167056 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167060 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 167063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167068 */     GIR_RootConstrainSelectedInstOperands,
     /* 167069 */     // GIR_Coverage, 1020,
     /* 167069 */     GIR_EraseRootFromParent_Done,
     /* 167070 */   // Label 3661: @167070
     /* 167070 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(167135), // Rule ID 998 //
     /* 167075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 167078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167094 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167097 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167101 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167114 */     // (fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32m),
     /* 167117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167119 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167121 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 167128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167133 */     GIR_RootConstrainSelectedInstOperands,
     /* 167134 */     // GIR_Coverage, 998,
     /* 167134 */     GIR_EraseRootFromParent_Done,
     /* 167135 */   // Label 3662: @167135
     /* 167135 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(167197), // Rule ID 2280 //
     /* 167140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 167143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167159 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167162 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167166 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167179 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSrm),
     /* 167182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167184 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167186 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167195 */     GIR_RootConstrainSelectedInstOperands,
     /* 167196 */     // GIR_Coverage, 2280,
     /* 167196 */     GIR_EraseRootFromParent_Done,
     /* 167197 */   // Label 3663: @167197
     /* 167197 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(167259), // Rule ID 2288 //
     /* 167202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 167205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167221 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167224 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167228 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167234 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167241 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSSrm),
     /* 167244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167246 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167248 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167257 */     GIR_RootConstrainSelectedInstOperands,
     /* 167258 */     // GIR_Coverage, 2288,
     /* 167258 */     GIR_EraseRootFromParent_Done,
     /* 167259 */   // Label 3664: @167259
     /* 167259 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(167321), // Rule ID 6087 //
     /* 167264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 167267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 167271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 167275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167283 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167286 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167290 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167296 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167303 */     // (fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrm),
     /* 167306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167308 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167310 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167319 */     GIR_RootConstrainSelectedInstOperands,
     /* 167320 */     // GIR_Coverage, 6087,
     /* 167320 */     GIR_EraseRootFromParent_Done,
     /* 167321 */   // Label 3665: @167321
     /* 167321 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(167358), // Rule ID 904 //
     /* 167326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 167329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 167341 */     // (fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (DIV_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 167341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32),
     /* 167346 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 167352 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 167356 */     GIR_RootConstrainSelectedInstOperands,
     /* 167357 */     // GIR_Coverage, 904,
     /* 167357 */     GIR_Done,
     /* 167358 */   // Label 3666: @167358
     /* 167358 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(167389), // Rule ID 2278 //
     /* 167363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 167366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167378 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VDIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 167378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSrr),
     /* 167383 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 167387 */     GIR_RootConstrainSelectedInstOperands,
     /* 167388 */     // GIR_Coverage, 2278,
     /* 167388 */     GIR_Done,
     /* 167389 */   // Label 3667: @167389
     /* 167389 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(167420), // Rule ID 2286 //
     /* 167394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 167397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 167409 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (DIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 167409 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSSrr),
     /* 167414 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 167418 */     GIR_RootConstrainSelectedInstOperands,
     /* 167419 */     // GIR_Coverage, 2286,
     /* 167419 */     GIR_Done,
     /* 167420 */   // Label 3668: @167420
     /* 167420 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(167451), // Rule ID 6085 //
     /* 167425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 167428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 167432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 167436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 167440 */     // (fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VDIVSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 167440 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrr),
     /* 167445 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 167449 */     GIR_RootConstrainSelectedInstOperands,
     /* 167450 */     // GIR_Coverage, 6085,
     /* 167450 */     GIR_Done,
     /* 167451 */   // Label 3669: @167451
     /* 167451 */   GIM_Reject,
     /* 167452 */ // Label 3657: @167452
     /* 167452 */ GIM_Reject,
     /* 167453 */ // Label 3642: @167453
     /* 167453 */ GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(168289),
     /* 167458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167464 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(167542), // Rule ID 22487 //
     /* 167469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 167472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 167476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 167480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 167488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 167492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 167496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167500 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 167503 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 167510 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 167514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 167516 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167523 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_64>>))  =>  (DIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSDrm),
     /* 167526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167528 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167530 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 167540 */     GIR_RootConstrainSelectedInstOperands,
     /* 167541 */     // GIR_Coverage, 22487,
     /* 167541 */     GIR_EraseRootFromParent_Done,
     /* 167542 */   // Label 3671: @167542
     /* 167542 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(167620), // Rule ID 22488 //
     /* 167547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 167550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 167554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 167558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 167566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 167570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 167574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167578 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 167581 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 167588 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 167592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 167594 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167601 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_64>>))  =>  (VDIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDrm),
     /* 167604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167606 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167608 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 167618 */     GIR_RootConstrainSelectedInstOperands,
     /* 167619 */     // GIR_Coverage, 22488,
     /* 167619 */     GIR_EraseRootFromParent_Done,
     /* 167620 */   // Label 3672: @167620
     /* 167620 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(167698), // Rule ID 22489 //
     /* 167625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 167628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 167632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 167636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 167644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 167648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 167652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167656 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 167659 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 167666 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 167670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 167672 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167679 */     // (fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_64>>))  =>  (VDIVSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrm),
     /* 167682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167684 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167686 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 167696 */     GIR_RootConstrainSelectedInstOperands,
     /* 167697 */     // GIR_Coverage, 22489,
     /* 167697 */     GIR_EraseRootFromParent_Done,
     /* 167698 */   // Label 3673: @167698
     /* 167698 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(167763), // Rule ID 1022 //
     /* 167703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 167706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 167710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 167714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167718 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167721 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167725 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 167733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167742 */     // (fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m),
     /* 167745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167747 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167749 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167753 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 167756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167761 */     GIR_RootConstrainSelectedInstOperands,
     /* 167762 */     // GIR_Coverage, 1022,
     /* 167762 */     GIR_EraseRootFromParent_Done,
     /* 167763 */   // Label 3674: @167763
     /* 167763 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(167835), // Rule ID 1024 //
     /* 167768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 167771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 167775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 167779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167783 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167786 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167790 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 167797 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 167805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167814 */     // (fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m32),
     /* 167817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167819 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167821 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 167828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167833 */     GIR_RootConstrainSelectedInstOperands,
     /* 167834 */     // GIR_Coverage, 1024,
     /* 167834 */     GIR_EraseRootFromParent_Done,
     /* 167835 */   // Label 3675: @167835
     /* 167835 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(167900), // Rule ID 1000 //
     /* 167840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 167843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 167847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 167851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167859 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167862 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167866 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167879 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m),
     /* 167882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167884 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167886 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167890 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 167893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167898 */     GIR_RootConstrainSelectedInstOperands,
     /* 167899 */     // GIR_Coverage, 1000,
     /* 167899 */     GIR_EraseRootFromParent_Done,
     /* 167900 */   // Label 3676: @167900
     /* 167900 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(167972), // Rule ID 1002 //
     /* 167905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 167908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 167912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 167916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167924 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167927 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167931 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 167938 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167944 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167951 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 167951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m32),
     /* 167954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167956 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167958 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 167965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167970 */     GIR_RootConstrainSelectedInstOperands,
     /* 167971 */     // GIR_Coverage, 1002,
     /* 167971 */     GIR_EraseRootFromParent_Done,
     /* 167972 */   // Label 3677: @167972
     /* 167972 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(168034), // Rule ID 2284 //
     /* 167977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 167980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 167984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 167988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167996 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167999 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168003 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168016 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDrm),
     /* 168019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168021 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168023 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168032 */     GIR_RootConstrainSelectedInstOperands,
     /* 168033 */     // GIR_Coverage, 2284,
     /* 168033 */     GIR_EraseRootFromParent_Done,
     /* 168034 */   // Label 3678: @168034
     /* 168034 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(168096), // Rule ID 2292 //
     /* 168039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 168042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168058 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168061 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168065 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168078 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSDrm),
     /* 168081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168083 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168094 */     GIR_RootConstrainSelectedInstOperands,
     /* 168095 */     // GIR_Coverage, 2292,
     /* 168095 */     GIR_EraseRootFromParent_Done,
     /* 168096 */   // Label 3679: @168096
     /* 168096 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(168158), // Rule ID 6106 //
     /* 168101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 168108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 168112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168120 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168123 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168127 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168140 */     // (fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrm),
     /* 168143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168145 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168147 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168156 */     GIR_RootConstrainSelectedInstOperands,
     /* 168157 */     // GIR_Coverage, 6106,
     /* 168157 */     GIR_EraseRootFromParent_Done,
     /* 168158 */   // Label 3680: @168158
     /* 168158 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(168195), // Rule ID 906 //
     /* 168163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 168166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 168178 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (DIV_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 168178 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64),
     /* 168183 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 168189 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 168193 */     GIR_RootConstrainSelectedInstOperands,
     /* 168194 */     // GIR_Coverage, 906,
     /* 168194 */     GIR_Done,
     /* 168195 */   // Label 3681: @168195
     /* 168195 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(168226), // Rule ID 2282 //
     /* 168200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 168203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168215 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VDIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 168215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDrr),
     /* 168220 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168224 */     GIR_RootConstrainSelectedInstOperands,
     /* 168225 */     // GIR_Coverage, 2282,
     /* 168225 */     GIR_Done,
     /* 168226 */   // Label 3682: @168226
     /* 168226 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(168257), // Rule ID 2290 //
     /* 168231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 168234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 168246 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (DIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 168246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSDrr),
     /* 168251 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168255 */     GIR_RootConstrainSelectedInstOperands,
     /* 168256 */     // GIR_Coverage, 2290,
     /* 168256 */     GIR_Done,
     /* 168257 */   // Label 3683: @168257
     /* 168257 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(168288), // Rule ID 6104 //
     /* 168262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 168269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 168273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 168277 */     // (fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VDIVSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 168277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrr),
     /* 168282 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168286 */     GIR_RootConstrainSelectedInstOperands,
     /* 168287 */     // GIR_Coverage, 6104,
     /* 168287 */     GIR_Done,
     /* 168288 */   // Label 3684: @168288
     /* 168288 */   GIM_Reject,
     /* 168289 */ // Label 3670: @168289
     /* 168289 */ GIM_Reject,
     /* 168290 */ // Label 3643: @168290
     /* 168290 */ GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(168611),
     /* 168295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 168298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 168301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 168305 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(168373), // Rule ID 1026 //
     /* 168310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 168313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168321 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168324 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168328 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 168335 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 168343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168352 */     // (fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m32),
     /* 168355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168357 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168359 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168363 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 168366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168371 */     GIR_RootConstrainSelectedInstOperands,
     /* 168372 */     // GIR_Coverage, 1026,
     /* 168372 */     GIR_EraseRootFromParent_Done,
     /* 168373 */   // Label 3686: @168373
     /* 168373 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(168441), // Rule ID 1028 //
     /* 168378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 168381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168389 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168392 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168396 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 168403 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 168411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168413 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168420 */     // (fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m64),
     /* 168423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168427 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168431 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 168434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168439 */     GIR_RootConstrainSelectedInstOperands,
     /* 168440 */     // GIR_Coverage, 1028,
     /* 168440 */     GIR_EraseRootFromParent_Done,
     /* 168441 */   // Label 3687: @168441
     /* 168441 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(168509), // Rule ID 1004 //
     /* 168446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 168449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 168453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168461 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168464 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168468 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 168475 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168481 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168488 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m32),
     /* 168491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168493 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168495 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168499 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 168502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168507 */     GIR_RootConstrainSelectedInstOperands,
     /* 168508 */     // GIR_Coverage, 1004,
     /* 168508 */     GIR_EraseRootFromParent_Done,
     /* 168509 */   // Label 3688: @168509
     /* 168509 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(168577), // Rule ID 1006 //
     /* 168514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 168517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 168521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168529 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168532 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168536 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 168543 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168556 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (DIV_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m64),
     /* 168559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168561 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168567 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 168570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168575 */     GIR_RootConstrainSelectedInstOperands,
     /* 168576 */     // GIR_Coverage, 1006,
     /* 168576 */     GIR_EraseRootFromParent_Done,
     /* 168577 */   // Label 3689: @168577
     /* 168577 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(168610), // Rule ID 908 //
     /* 168582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 168585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 168589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 168593 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (DIV_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 168593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80),
     /* 168598 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 168604 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 168608 */     GIR_RootConstrainSelectedInstOperands,
     /* 168609 */     // GIR_Coverage, 908,
     /* 168609 */     GIR_Done,
     /* 168610 */   // Label 3690: @168610
     /* 168610 */   GIM_Reject,
     /* 168611 */ // Label 3685: @168611
     /* 168611 */ GIM_Reject,
     /* 168612 */ // Label 3644: @168612
     /* 168612 */ GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(168841),
     /* 168617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168623 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(168685), // Rule ID 2260 //
     /* 168628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 168631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 168635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 168639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168647 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168650 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168654 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168667 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDrm),
     /* 168670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168672 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168674 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168683 */     GIR_RootConstrainSelectedInstOperands,
     /* 168684 */     // GIR_Coverage, 2260,
     /* 168684 */     GIR_EraseRootFromParent_Done,
     /* 168685 */   // Label 3692: @168685
     /* 168685 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(168747), // Rule ID 6659 //
     /* 168690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 168693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 168697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 168701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168709 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168712 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168716 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168729 */     // (fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rm),
     /* 168732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168734 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168736 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168745 */     GIR_RootConstrainSelectedInstOperands,
     /* 168746 */     // GIR_Coverage, 6659,
     /* 168746 */     GIR_EraseRootFromParent_Done,
     /* 168747 */   // Label 3693: @168747
     /* 168747 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(168778), // Rule ID 2258 //
     /* 168752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 168755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 168759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 168763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 168767 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VDIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 168767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDrr),
     /* 168772 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168776 */     GIR_RootConstrainSelectedInstOperands,
     /* 168777 */     // GIR_Coverage, 2258,
     /* 168777 */     GIR_Done,
     /* 168778 */   // Label 3694: @168778
     /* 168778 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(168809), // Rule ID 2274 //
     /* 168783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 168786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 168790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 168794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 168798 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (DIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 168798 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPDrr),
     /* 168803 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168807 */     GIR_RootConstrainSelectedInstOperands,
     /* 168808 */     // GIR_Coverage, 2274,
     /* 168808 */     GIR_Done,
     /* 168809 */   // Label 3695: @168809
     /* 168809 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(168840), // Rule ID 6655 //
     /* 168814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 168817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 168821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 168825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 168829 */     // (fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VDIVPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 168829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rr),
     /* 168834 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168838 */     GIR_RootConstrainSelectedInstOperands,
     /* 168839 */     // GIR_Coverage, 6655,
     /* 168839 */     GIR_Done,
     /* 168840 */   // Label 3696: @168840
     /* 168840 */   GIM_Reject,
     /* 168841 */ // Label 3691: @168841
     /* 168841 */ GIM_Reject,
     /* 168842 */ // Label 3645: @168842
     /* 168842 */ GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(169071),
     /* 168847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 168850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168853 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(168915), // Rule ID 2256 //
     /* 168858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 168861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 168865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 168869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168877 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168880 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168884 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168897 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSrm),
     /* 168900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168902 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168904 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168913 */     GIR_RootConstrainSelectedInstOperands,
     /* 168914 */     // GIR_Coverage, 2256,
     /* 168914 */     GIR_EraseRootFromParent_Done,
     /* 168915 */   // Label 3698: @168915
     /* 168915 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(168977), // Rule ID 6635 //
     /* 168920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 168923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 168927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 168931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168939 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168942 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168946 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168959 */     // (fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 168959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rm),
     /* 168962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168964 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168975 */     GIR_RootConstrainSelectedInstOperands,
     /* 168976 */     // GIR_Coverage, 6635,
     /* 168976 */     GIR_EraseRootFromParent_Done,
     /* 168977 */   // Label 3699: @168977
     /* 168977 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(169008), // Rule ID 2254 //
     /* 168982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 168985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 168989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 168993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 168997 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VDIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 168997 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSrr),
     /* 169002 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169006 */     GIR_RootConstrainSelectedInstOperands,
     /* 169007 */     // GIR_Coverage, 2254,
     /* 169007 */     GIR_Done,
     /* 169008 */   // Label 3700: @169008
     /* 169008 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(169039), // Rule ID 2270 //
     /* 169013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 169016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 169028 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (DIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 169028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPSrr),
     /* 169033 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169037 */     GIR_RootConstrainSelectedInstOperands,
     /* 169038 */     // GIR_Coverage, 2270,
     /* 169038 */     GIR_Done,
     /* 169039 */   // Label 3701: @169039
     /* 169039 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(169070), // Rule ID 6631 //
     /* 169044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 169047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169059 */     // (fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VDIVPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 169059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rr),
     /* 169064 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169068 */     GIR_RootConstrainSelectedInstOperands,
     /* 169069 */     // GIR_Coverage, 6631,
     /* 169069 */     GIR_Done,
     /* 169070 */   // Label 3702: @169070
     /* 169070 */   GIM_Reject,
     /* 169071 */ // Label 3697: @169071
     /* 169071 */ GIM_Reject,
     /* 169072 */ // Label 3646: @169072
     /* 169072 */ GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(169270),
     /* 169077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 169080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 169083 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(169145), // Rule ID 2268 //
     /* 169088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 169091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 169095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 169099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169107 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169114 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169127 */     // (fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrm),
     /* 169130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169132 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169143 */     GIR_RootConstrainSelectedInstOperands,
     /* 169144 */     // GIR_Coverage, 2268,
     /* 169144 */     GIR_EraseRootFromParent_Done,
     /* 169145 */   // Label 3704: @169145
     /* 169145 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(169207), // Rule ID 6671 //
     /* 169150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 169153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169169 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169172 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169176 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169189 */     // (fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rm),
     /* 169192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169194 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169196 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169205 */     GIR_RootConstrainSelectedInstOperands,
     /* 169206 */     // GIR_Coverage, 6671,
     /* 169206 */     GIR_EraseRootFromParent_Done,
     /* 169207 */   // Label 3705: @169207
     /* 169207 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(169238), // Rule ID 2266 //
     /* 169212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 169215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 169219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 169223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 169227 */     // (fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VDIVPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 169227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrr),
     /* 169232 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169236 */     GIR_RootConstrainSelectedInstOperands,
     /* 169237 */     // GIR_Coverage, 2266,
     /* 169237 */     GIR_Done,
     /* 169238 */   // Label 3706: @169238
     /* 169238 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(169269), // Rule ID 6667 //
     /* 169243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 169246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169258 */     // (fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VDIVPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 169258 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rr),
     /* 169263 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169267 */     GIR_RootConstrainSelectedInstOperands,
     /* 169268 */     // GIR_Coverage, 6667,
     /* 169268 */     GIR_Done,
     /* 169269 */   // Label 3707: @169269
     /* 169269 */   GIM_Reject,
     /* 169270 */ // Label 3703: @169270
     /* 169270 */ GIM_Reject,
     /* 169271 */ // Label 3647: @169271
     /* 169271 */ GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(169368),
     /* 169276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 169279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169290 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(169344), // Rule ID 6695 //
     /* 169295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 169298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169306 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169309 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169313 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169319 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169326 */     // (fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rm),
     /* 169329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169331 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169333 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169342 */     GIR_RootConstrainSelectedInstOperands,
     /* 169343 */     // GIR_Coverage, 6695,
     /* 169343 */     GIR_EraseRootFromParent_Done,
     /* 169344 */   // Label 3709: @169344
     /* 169344 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(169367), // Rule ID 6691 //
     /* 169349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 169352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 169356 */     // (fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VDIVPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 169356 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rr),
     /* 169361 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169365 */     GIR_RootConstrainSelectedInstOperands,
     /* 169366 */     // GIR_Coverage, 6691,
     /* 169366 */     GIR_Done,
     /* 169367 */   // Label 3710: @169367
     /* 169367 */   GIM_Reject,
     /* 169368 */ // Label 3708: @169368
     /* 169368 */ GIM_Reject,
     /* 169369 */ // Label 3648: @169369
     /* 169369 */ GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(169567),
     /* 169374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 169377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 169380 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(169442), // Rule ID 2264 //
     /* 169385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 169388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 169392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 169396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169404 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169407 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169411 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169424 */     // (fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrm),
     /* 169427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169429 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169431 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169440 */     GIR_RootConstrainSelectedInstOperands,
     /* 169441 */     // GIR_Coverage, 2264,
     /* 169441 */     GIR_EraseRootFromParent_Done,
     /* 169442 */   // Label 3712: @169442
     /* 169442 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(169504), // Rule ID 6647 //
     /* 169447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 169450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169466 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169469 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169473 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169486 */     // (fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rm),
     /* 169489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169491 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169493 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169502 */     GIR_RootConstrainSelectedInstOperands,
     /* 169503 */     // GIR_Coverage, 6647,
     /* 169503 */     GIR_EraseRootFromParent_Done,
     /* 169504 */   // Label 3713: @169504
     /* 169504 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(169535), // Rule ID 2262 //
     /* 169509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 169512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 169516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 169520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 169524 */     // (fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VDIVPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 169524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrr),
     /* 169529 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169533 */     GIR_RootConstrainSelectedInstOperands,
     /* 169534 */     // GIR_Coverage, 2262,
     /* 169534 */     GIR_Done,
     /* 169535 */   // Label 3714: @169535
     /* 169535 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(169566), // Rule ID 6643 //
     /* 169540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 169543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169555 */     // (fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VDIVPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 169555 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rr),
     /* 169560 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169564 */     GIR_RootConstrainSelectedInstOperands,
     /* 169565 */     // GIR_Coverage, 6643,
     /* 169565 */     GIR_Done,
     /* 169566 */   // Label 3715: @169566
     /* 169566 */   GIM_Reject,
     /* 169567 */ // Label 3711: @169567
     /* 169567 */ GIM_Reject,
     /* 169568 */ // Label 3649: @169568
     /* 169568 */ GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(169665),
     /* 169573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 169576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 169579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169587 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(169641), // Rule ID 6623 //
     /* 169592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 169595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169603 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169606 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169610 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169616 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169623 */     // (fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrm),
     /* 169626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169628 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169630 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169639 */     GIR_RootConstrainSelectedInstOperands,
     /* 169640 */     // GIR_Coverage, 6623,
     /* 169640 */     GIR_EraseRootFromParent_Done,
     /* 169641 */   // Label 3717: @169641
     /* 169641 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(169664), // Rule ID 6619 //
     /* 169646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 169649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169653 */     // (fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VDIVPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 169653 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrr),
     /* 169658 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169662 */     GIR_RootConstrainSelectedInstOperands,
     /* 169663 */     // GIR_Coverage, 6619,
     /* 169663 */     GIR_Done,
     /* 169664 */   // Label 3718: @169664
     /* 169664 */   GIM_Reject,
     /* 169665 */ // Label 3716: @169665
     /* 169665 */ GIM_Reject,
     /* 169666 */ // Label 3650: @169666
     /* 169666 */ GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(169763),
     /* 169671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 169674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 169677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169685 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(169739), // Rule ID 6707 //
     /* 169690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 169693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169701 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169704 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169708 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169714 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169721 */     // (fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rm),
     /* 169724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169726 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169728 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169737 */     GIR_RootConstrainSelectedInstOperands,
     /* 169738 */     // GIR_Coverage, 6707,
     /* 169738 */     GIR_EraseRootFromParent_Done,
     /* 169739 */   // Label 3720: @169739
     /* 169739 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(169762), // Rule ID 6703 //
     /* 169744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 169747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169751 */     // (fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VDIVPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 169751 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rr),
     /* 169756 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169760 */     GIR_RootConstrainSelectedInstOperands,
     /* 169761 */     // GIR_Coverage, 6703,
     /* 169761 */     GIR_Done,
     /* 169762 */   // Label 3721: @169762
     /* 169762 */   GIM_Reject,
     /* 169763 */ // Label 3719: @169763
     /* 169763 */ GIM_Reject,
     /* 169764 */ // Label 3651: @169764
     /* 169764 */ GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(169861),
     /* 169769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 169772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 169775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169783 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(169837), // Rule ID 6611 //
     /* 169788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 169791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169799 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169802 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169806 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169812 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169819 */     // (fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrm),
     /* 169822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169824 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169826 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169835 */     GIR_RootConstrainSelectedInstOperands,
     /* 169836 */     // GIR_Coverage, 6611,
     /* 169836 */     GIR_EraseRootFromParent_Done,
     /* 169837 */   // Label 3723: @169837
     /* 169837 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(169860), // Rule ID 6607 //
     /* 169842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 169845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169849 */     // (fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VDIVPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 169849 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrr),
     /* 169854 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169858 */     GIR_RootConstrainSelectedInstOperands,
     /* 169859 */     // GIR_Coverage, 6607,
     /* 169859 */     GIR_Done,
     /* 169860 */   // Label 3724: @169860
     /* 169860 */   GIM_Reject,
     /* 169861 */ // Label 3722: @169861
     /* 169861 */ GIM_Reject,
     /* 169862 */ // Label 3652: @169862
     /* 169862 */ GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(169959),
     /* 169867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 169870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 169873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169881 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(169935), // Rule ID 6683 //
     /* 169886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 169889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169897 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169900 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169904 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169910 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169917 */     // (fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrm),
     /* 169920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169922 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169924 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169933 */     GIR_RootConstrainSelectedInstOperands,
     /* 169934 */     // GIR_Coverage, 6683,
     /* 169934 */     GIR_EraseRootFromParent_Done,
     /* 169935 */   // Label 3726: @169935
     /* 169935 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(169958), // Rule ID 6679 //
     /* 169940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 169943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169947 */     // (fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VDIVPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 169947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrr),
     /* 169952 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169956 */     GIR_RootConstrainSelectedInstOperands,
     /* 169957 */     // GIR_Coverage, 6679,
     /* 169957 */     GIR_Done,
     /* 169958 */   // Label 3727: @169958
     /* 169958 */   GIM_Reject,
     /* 169959 */ // Label 3725: @169959
     /* 169959 */ GIM_Reject,
     /* 169960 */ // Label 3653: @169960
     /* 169960 */ GIM_Reject,
     /* 169961 */ // Label 46: @169961
     /* 169961 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 3731*/ GIMT_Encode4(170083),
     /* 169972 */ /*GILLT_s32*//*Label 3728*/ GIMT_Encode4(169984),
     /* 169976 */ /*GILLT_s64*//*Label 3729*/ GIMT_Encode4(170017),
     /* 169980 */ /*GILLT_s80*//*Label 3730*/ GIMT_Encode4(170050),
     /* 169984 */ // Label 3728: @169984
     /* 169984 */ GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(170016), // Rule ID 1041 //
     /* 169989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 169992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 169995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 169999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170003 */   // (fneg:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 170003 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 170008 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 170014 */   GIR_RootConstrainSelectedInstOperands,
     /* 170015 */   // GIR_Coverage, 1041,
     /* 170015 */   GIR_Done,
     /* 170016 */ // Label 3732: @170016
     /* 170016 */ GIM_Reject,
     /* 170017 */ // Label 3729: @170017
     /* 170017 */ GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(170049), // Rule ID 1042 //
     /* 170022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 170025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 170028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 170032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 170036 */   // (fneg:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 170036 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 170041 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 170047 */   GIR_RootConstrainSelectedInstOperands,
     /* 170048 */   // GIR_Coverage, 1042,
     /* 170048 */   GIR_Done,
     /* 170049 */ // Label 3733: @170049
     /* 170049 */ GIM_Reject,
     /* 170050 */ // Label 3730: @170050
     /* 170050 */ GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(170082), // Rule ID 1043 //
     /* 170055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 170058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 170061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 170065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 170069 */   // (fneg:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 170069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 170074 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 170080 */   GIR_RootConstrainSelectedInstOperands,
     /* 170081 */   // GIR_Coverage, 1043,
     /* 170081 */   GIR_Done,
     /* 170082 */ // Label 3734: @170082
     /* 170082 */ GIM_Reject,
     /* 170083 */ // Label 3731: @170083
     /* 170083 */ GIM_Reject,
     /* 170084 */ // Label 47: @170084
     /* 170084 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(20), /*)*//*default:*//*Label 3742*/ GIMT_Encode4(171015),
     /* 170095 */ /*GILLT_s32*//*Label 3735*/ GIMT_Encode4(170163),
     /* 170099 */ /*GILLT_s64*//*Label 3736*/ GIMT_Encode4(170284),
     /* 170103 */ /*GILLT_s80*//*Label 3737*/ GIMT_Encode4(170767), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 170127 */ /*GILLT_v4s64*//*Label 3738*/ GIMT_Encode4(170828), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 170139 */ /*GILLT_v8s32*//*Label 3739*/ GIMT_Encode4(170892),
     /* 170143 */ /*GILLT_v8s64*//*Label 3740*/ GIMT_Encode4(170923), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 170159 */ /*GILLT_v16s32*//*Label 3741*/ GIMT_Encode4(170984),
     /* 170163 */ // Label 3735: @170163
     /* 170163 */ GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(170283),
     /* 170168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 170171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170175 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(170244), // Rule ID 21203 //
     /* 170180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 170183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170191 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170194 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170198 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170211 */     // (fpextend:{ *:[f32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSH2SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 170211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 170214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SSZrm),
     /* 170228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170233 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 170237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170242 */     GIR_RootConstrainSelectedInstOperands,
     /* 170243 */     // GIR_Coverage, 21203,
     /* 170243 */     GIR_EraseRootFromParent_Done,
     /* 170244 */   // Label 3744: @170244
     /* 170244 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(170282), // Rule ID 21201 //
     /* 170249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 170252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 170256 */     // (fpextend:{ *:[f32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTSH2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR16X:{ *:[f16] }:$src)
     /* 170256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 170259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SSZrr),
     /* 170273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170278 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 170280 */     GIR_RootConstrainSelectedInstOperands,
     /* 170281 */     // GIR_Coverage, 21201,
     /* 170281 */     GIR_EraseRootFromParent_Done,
     /* 170282 */   // Label 3745: @170282
     /* 170282 */   GIM_Reject,
     /* 170283 */ // Label 3743: @170283
     /* 170283 */ GIM_Reject,
     /* 170284 */ // Label 3736: @170284
     /* 170284 */ GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(170343), // Rule ID 1893 //
     /* 170289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 170292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 170295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 170299 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170303 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170307 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170310 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170314 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170318 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170320 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170327 */   // (fpextend:{ *:[f64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SDrm:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /* 170327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SDrm),
     /* 170330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170332 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 170336 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170341 */   GIR_RootConstrainSelectedInstOperands,
     /* 170342 */   // GIR_Coverage, 1893,
     /* 170342 */   GIR_EraseRootFromParent_Done,
     /* 170343 */ // Label 3746: @170343
     /* 170343 */ GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(170419), // Rule ID 18001 //
     /* 170348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 170351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 170354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 170358 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170362 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170366 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170369 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170373 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170377 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170379 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170386 */   // (fpextend:{ *:[f64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SDrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 170386 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 170389 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170393 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDrm),
     /* 170403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170405 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170408 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 170412 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170417 */   GIR_RootConstrainSelectedInstOperands,
     /* 170418 */   // GIR_Coverage, 18001,
     /* 170418 */   GIR_EraseRootFromParent_Done,
     /* 170419 */ // Label 3747: @170419
     /* 170419 */ GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(170495), // Rule ID 21197 //
     /* 170424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 170427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 170430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 170434 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170438 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170442 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170445 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170449 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170453 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170455 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170462 */   // (fpextend:{ *:[f64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 170462 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 170465 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170469 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDZrm),
     /* 170479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170481 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170484 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 170488 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170493 */   GIR_RootConstrainSelectedInstOperands,
     /* 170494 */   // GIR_Coverage, 21197,
     /* 170494 */   GIR_EraseRootFromParent_Done,
     /* 170495 */ // Label 3748: @170495
     /* 170495 */ GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(170571), // Rule ID 21207 //
     /* 170500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 170503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 170506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 170510 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170514 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170518 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170521 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170525 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170529 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170531 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170538 */   // (fpextend:{ *:[f64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSH2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 170538 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 170541 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170545 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SDZrm),
     /* 170555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170557 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170560 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 170564 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170569 */   GIR_RootConstrainSelectedInstOperands,
     /* 170570 */   // GIR_Coverage, 21207,
     /* 170570 */   GIR_EraseRootFromParent_Done,
     /* 170571 */ // Label 3749: @170571
     /* 170571 */ GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(170601), // Rule ID 1891 //
     /* 170576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 170579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 170582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 170586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170590 */   // (fpextend:{ *:[f64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SDrr:{ *:[f64] } FR32:{ *:[f32] }:$src)
     /* 170590 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SDrr),
     /* 170595 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170599 */   GIR_RootConstrainSelectedInstOperands,
     /* 170600 */   // GIR_Coverage, 1891,
     /* 170600 */   GIR_Done,
     /* 170601 */ // Label 3750: @170601
     /* 170601 */ GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(170631), // Rule ID 17726 //
     /* 170606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 170612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 170616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170620 */   // (fpextend:{ *:[f64] } RFP32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } RFP32:{ *:[f32] }:$src, RFP64:{ *:[i32] })
     /* 170620 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170625 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP64RegClassID),
     /* 170630 */   // GIR_Coverage, 17726,
     /* 170630 */   GIR_Done,
     /* 170631 */ // Label 3751: @170631
     /* 170631 */ GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(170676), // Rule ID 17999 //
     /* 170636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 170639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 170642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 170646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170650 */   // (fpextend:{ *:[f64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR32:{ *:[f32] }:$src)
     /* 170650 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 170653 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170657 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDrr),
     /* 170667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170669 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170672 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 170674 */   GIR_RootConstrainSelectedInstOperands,
     /* 170675 */   // GIR_Coverage, 17999,
     /* 170675 */   GIR_EraseRootFromParent_Done,
     /* 170676 */ // Label 3752: @170676
     /* 170676 */ GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(170721), // Rule ID 21195 //
     /* 170681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 170684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 170687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 170691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170695 */   // (fpextend:{ *:[f64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR32X:{ *:[f32] }:$src)
     /* 170695 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 170698 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170702 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170707 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDZrr),
     /* 170712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170714 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170717 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 170719 */   GIR_RootConstrainSelectedInstOperands,
     /* 170720 */   // GIR_Coverage, 21195,
     /* 170720 */   GIR_EraseRootFromParent_Done,
     /* 170721 */ // Label 3753: @170721
     /* 170721 */ GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(170766), // Rule ID 21205 //
     /* 170726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 170729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 170732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 170736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 170740 */   // (fpextend:{ *:[f64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTSH2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR16X:{ *:[f16] }:$src)
     /* 170740 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 170743 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170747 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SDZrr),
     /* 170757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170759 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170762 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 170764 */   GIR_RootConstrainSelectedInstOperands,
     /* 170765 */   // GIR_Coverage, 21205,
     /* 170765 */   GIR_EraseRootFromParent_Done,
     /* 170766 */ // Label 3754: @170766
     /* 170766 */ GIM_Reject,
     /* 170767 */ // Label 3737: @170767
     /* 170767 */ GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(170797), // Rule ID 17728 //
     /* 170772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 170778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 170782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170786 */   // (fpextend:{ *:[f80] } RFP32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f80] } RFP32:{ *:[f32] }:$src, RFP80:{ *:[i32] })
     /* 170786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170791 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP80RegClassID),
     /* 170796 */   // GIR_Coverage, 17728,
     /* 170796 */   GIR_Done,
     /* 170797 */ // Label 3755: @170797
     /* 170797 */ GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(170827), // Rule ID 17730 //
     /* 170802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 170805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 170808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 170812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 170816 */   // (fpextend:{ *:[f80] } RFP64:{ *:[f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f80] } RFP64:{ *:[f64] }:$src, RFP80:{ *:[i32] })
     /* 170816 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170821 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP80RegClassID),
     /* 170826 */   // GIR_Coverage, 17730,
     /* 170826 */   GIR_Done,
     /* 170827 */ // Label 3756: @170827
     /* 170827 */ GIM_Reject,
     /* 170828 */ // Label 3738: @170828
     /* 170828 */ GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(170891),
     /* 170833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 170836 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(170863), // Rule ID 1934 //
     /* 170841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 170844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 170848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 170852 */     // (fpextend:{ *:[v4f64] } VR128:{ *:[v4f32] }:$src)  =>  (VCVTPS2PDYrr:{ *:[v4f64] } VR128:{ *:[v4f32] }:$src)
     /* 170852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDYrr),
     /* 170857 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170861 */     GIR_RootConstrainSelectedInstOperands,
     /* 170862 */     // GIR_Coverage, 1934,
     /* 170862 */     GIR_Done,
     /* 170863 */   // Label 3758: @170863
     /* 170863 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(170890), // Rule ID 10574 //
     /* 170868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 170871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 170875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 170879 */     // (fpextend:{ *:[v4f64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4f32] }:$src)
     /* 170879 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDZ256rr),
     /* 170884 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170888 */     GIR_RootConstrainSelectedInstOperands,
     /* 170889 */     // GIR_Coverage, 10574,
     /* 170889 */     GIR_Done,
     /* 170890 */   // Label 3759: @170890
     /* 170890 */   GIM_Reject,
     /* 170891 */ // Label 3757: @170891
     /* 170891 */ GIM_Reject,
     /* 170892 */ // Label 3739: @170892
     /* 170892 */ GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(170922), // Rule ID 10637 //
     /* 170897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 170900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 170903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 170907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 170911 */   // (fpextend:{ *:[v8f32] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2PSXZ256rr:{ *:[v8f32] } VR128X:{ *:[v8f16] }:$src)
     /* 170911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PSXZ256rr),
     /* 170916 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170920 */   GIR_RootConstrainSelectedInstOperands,
     /* 170921 */   // GIR_Coverage, 10637,
     /* 170921 */   GIR_Done,
     /* 170922 */ // Label 3760: @170922
     /* 170922 */ GIM_Reject,
     /* 170923 */ // Label 3740: @170923
     /* 170923 */ GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(170953), // Rule ID 10549 //
     /* 170928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 170931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 170934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 170942 */   // (fpextend:{ *:[v8f64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8f32] }:$src)
     /* 170942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDZrr),
     /* 170947 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170951 */   GIR_RootConstrainSelectedInstOperands,
     /* 170952 */   // GIR_Coverage, 10549,
     /* 170952 */   GIR_Done,
     /* 170953 */ // Label 3761: @170953
     /* 170953 */ GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(170983), // Rule ID 10663 //
     /* 170958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 170961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 170964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 170972 */   // (fpextend:{ *:[v8f64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2PDZrr:{ *:[v8f64] } VR128X:{ *:[v8f16] }:$src)
     /* 170972 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PDZrr),
     /* 170977 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170981 */   GIR_RootConstrainSelectedInstOperands,
     /* 170982 */   // GIR_Coverage, 10663,
     /* 170982 */   GIR_Done,
     /* 170983 */ // Label 3762: @170983
     /* 170983 */ GIM_Reject,
     /* 170984 */ // Label 3741: @170984
     /* 170984 */ GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(171014), // Rule ID 10612 //
     /* 170989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 170992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 170995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 170999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 171003 */   // (fpextend:{ *:[v16f32] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2PSXZrr:{ *:[v16f32] } VR256X:{ *:[v16f16] }:$src)
     /* 171003 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PSXZrr),
     /* 171008 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171012 */   GIR_RootConstrainSelectedInstOperands,
     /* 171013 */   // GIR_Coverage, 10612,
     /* 171013 */   GIR_Done,
     /* 171014 */ // Label 3763: @171014
     /* 171014 */ GIM_Reject,
     /* 171015 */ // Label 3742: @171015
     /* 171015 */ GIM_Reject,
     /* 171016 */ // Label 48: @171016
     /* 171016 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 3767*/ GIMT_Encode4(171401),
     /* 171027 */ /*GILLT_s16*//*Label 3764*/ GIMT_Encode4(171039),
     /* 171031 */ /*GILLT_s32*//*Label 3765*/ GIMT_Encode4(171130),
     /* 171035 */ /*GILLT_s64*//*Label 3766*/ GIMT_Encode4(171370),
     /* 171039 */ // Label 3764: @171039
     /* 171039 */ GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(171084), // Rule ID 21209 //
     /* 171044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 171047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 171054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 171058 */   // (fpround:{ *:[f16] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR32X:{ *:[f32] }:$src)
     /* 171058 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 171061 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171065 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171070 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SHZrr),
     /* 171075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171077 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171080 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 171082 */   GIR_RootConstrainSelectedInstOperands,
     /* 171083 */   // GIR_Coverage, 21209,
     /* 171083 */   GIR_EraseRootFromParent_Done,
     /* 171084 */ // Label 3768: @171084
     /* 171084 */ GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(171129), // Rule ID 21211 //
     /* 171089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 171092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 171099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171103 */   // (fpround:{ *:[f16] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR64X:{ *:[f64] }:$src)
     /* 171103 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 171106 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171110 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SHZrr),
     /* 171120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171125 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 171127 */   GIR_RootConstrainSelectedInstOperands,
     /* 171128 */   // GIR_Coverage, 21211,
     /* 171128 */   GIR_EraseRootFromParent_Done,
     /* 171129 */ // Label 3769: @171129
     /* 171129 */ GIM_Reject,
     /* 171130 */ // Label 3765: @171130
     /* 171130 */ GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(171189), // Rule ID 1881 //
     /* 171135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 171138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 171145 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171149 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171153 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171156 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171160 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171164 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171166 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171173 */   // (fpround:{ *:[f32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SSrm:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /* 171173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SSrm),
     /* 171176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171178 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 171182 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171187 */   GIR_RootConstrainSelectedInstOperands,
     /* 171188 */   // GIR_Coverage, 1881,
     /* 171188 */   GIR_EraseRootFromParent_Done,
     /* 171189 */ // Label 3770: @171189
     /* 171189 */ GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(171219), // Rule ID 1879 //
     /* 171194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 171197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 171204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171208 */   // (fpround:{ *:[f32] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SSrr:{ *:[f32] } FR64:{ *:[f64] }:$src)
     /* 171208 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SSrr),
     /* 171213 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171217 */   GIR_RootConstrainSelectedInstOperands,
     /* 171218 */   // GIR_Coverage, 1879,
     /* 171218 */   GIR_Done,
     /* 171219 */ // Label 3771: @171219
     /* 171219 */ GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(171249), // Rule ID 17732 //
     /* 171224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 171227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 171234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171238 */   // (fpround:{ *:[f32] } RFP64:{ *:[f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } RFP64:{ *:[f64] }:$src, RFP32:{ *:[i32] })
     /* 171238 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171243 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP32RegClassID),
     /* 171248 */   // GIR_Coverage, 17732,
     /* 171248 */   GIR_Done,
     /* 171249 */ // Label 3772: @171249
     /* 171249 */ GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(171279), // Rule ID 17734 //
     /* 171254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 171257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 171260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 171264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 171268 */   // (fpround:{ *:[f32] } RFP80:{ *:[f80] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } RFP80:{ *:[f80] }:$src, RFP32:{ *:[i32] })
     /* 171268 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171273 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP32RegClassID),
     /* 171278 */   // GIR_Coverage, 17734,
     /* 171278 */   GIR_Done,
     /* 171279 */ // Label 3773: @171279
     /* 171279 */ GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(171324), // Rule ID 17997 //
     /* 171284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 171287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 171294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171298 */   // (fpround:{ *:[f32] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR64:{ *:[f64] }:$src)
     /* 171298 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 171301 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171305 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171310 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SSrr),
     /* 171315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171317 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171320 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 171322 */   GIR_RootConstrainSelectedInstOperands,
     /* 171323 */   // GIR_Coverage, 17997,
     /* 171323 */   GIR_EraseRootFromParent_Done,
     /* 171324 */ // Label 3774: @171324
     /* 171324 */ GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(171369), // Rule ID 21199 //
     /* 171329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 171332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 171339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171343 */   // (fpround:{ *:[f32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR64X:{ *:[f64] }:$src)
     /* 171343 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 171346 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171350 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171355 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SSZrr),
     /* 171360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171362 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171365 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 171367 */   GIR_RootConstrainSelectedInstOperands,
     /* 171368 */   // GIR_Coverage, 21199,
     /* 171368 */   GIR_EraseRootFromParent_Done,
     /* 171369 */ // Label 3775: @171369
     /* 171369 */ GIM_Reject,
     /* 171370 */ // Label 3766: @171370
     /* 171370 */ GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(171400), // Rule ID 17736 //
     /* 171375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 171381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 171389 */   // (fpround:{ *:[f64] } RFP80:{ *:[f80] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } RFP80:{ *:[f80] }:$src, RFP64:{ *:[i32] })
     /* 171389 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP64RegClassID),
     /* 171399 */   // GIR_Coverage, 17736,
     /* 171399 */   GIR_Done,
     /* 171400 */ // Label 3776: @171400
     /* 171400 */ GIM_Reject,
     /* 171401 */ // Label 3767: @171401
     /* 171401 */ GIM_Reject,
     /* 171402 */ // Label 49: @171402
     /* 171402 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 3780*/ GIMT_Encode4(172782),
     /* 171413 */ /*GILLT_s32*//*Label 3777*/ GIMT_Encode4(171445),
     /* 171417 */ /*GILLT_s64*//*Label 3778*/ GIMT_Encode4(172069), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 171441 */ /*GILLT_v4s32*//*Label 3779*/ GIMT_Encode4(172693),
     /* 171445 */ // Label 3777: @171445
     /* 171445 */ GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(171504), // Rule ID 1741 //
     /* 171450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 171453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 171460 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171464 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171468 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171471 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171475 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171479 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171481 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171488 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 171488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIrm),
     /* 171491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171493 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 171497 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171502 */   GIR_RootConstrainSelectedInstOperands,
     /* 171503 */   // GIR_Coverage, 1741,
     /* 171503 */   GIR_EraseRootFromParent_Done,
     /* 171504 */ // Label 3781: @171504
     /* 171504 */ GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(171563), // Rule ID 1749 //
     /* 171509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 171512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 171519 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171523 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171527 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171530 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171534 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171538 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171540 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171547 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 171547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIrm),
     /* 171550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171552 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 171556 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171561 */   GIR_RootConstrainSelectedInstOperands,
     /* 171562 */   // GIR_Coverage, 1749,
     /* 171562 */   GIR_EraseRootFromParent_Done,
     /* 171563 */ // Label 3782: @171563
     /* 171563 */ GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(171622), // Rule ID 1765 //
     /* 171568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 171571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 171578 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171582 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171586 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171589 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171593 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171597 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171599 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171606 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 171606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SIrm),
     /* 171609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171611 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 171615 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171620 */   GIR_RootConstrainSelectedInstOperands,
     /* 171621 */   // GIR_Coverage, 1765,
     /* 171621 */   GIR_EraseRootFromParent_Done,
     /* 171622 */ // Label 3783: @171622
     /* 171622 */ GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(171681), // Rule ID 1773 //
     /* 171627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 171630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 171637 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171641 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171645 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171648 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171652 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171656 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171658 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171665 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 171665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SIrm),
     /* 171668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171670 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 171674 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171679 */   GIR_RootConstrainSelectedInstOperands,
     /* 171680 */   // GIR_Coverage, 1773,
     /* 171680 */   GIR_EraseRootFromParent_Done,
     /* 171681 */ // Label 3784: @171681
     /* 171681 */ GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(171740), // Rule ID 10362 //
     /* 171686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 171689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 171696 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171700 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171704 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171707 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171711 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171715 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171717 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171724 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 171724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIZrm),
     /* 171727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171729 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 171733 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171738 */   GIR_RootConstrainSelectedInstOperands,
     /* 171739 */   // GIR_Coverage, 10362,
     /* 171739 */   GIR_EraseRootFromParent_Done,
     /* 171740 */ // Label 3785: @171740
     /* 171740 */ GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(171799), // Rule ID 10380 //
     /* 171745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 171748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 171755 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171759 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171763 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171766 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171770 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171774 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171776 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171783 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 171783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIZrm),
     /* 171786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171788 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 171792 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171797 */   GIR_RootConstrainSelectedInstOperands,
     /* 171798 */   // GIR_Coverage, 10380,
     /* 171798 */   GIR_EraseRootFromParent_Done,
     /* 171799 */ // Label 3786: @171799
     /* 171799 */ GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(171858), // Rule ID 15170 //
     /* 171804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 171807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 171810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 171814 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171818 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171822 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171825 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171829 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171833 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171835 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171842 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 171842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrm),
     /* 171845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171847 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 171851 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171856 */   GIR_RootConstrainSelectedInstOperands,
     /* 171857 */   // GIR_Coverage, 15170,
     /* 171857 */   GIR_EraseRootFromParent_Done,
     /* 171858 */ // Label 3787: @171858
     /* 171858 */ GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(171888), // Rule ID 1739 //
     /* 171863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 171866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 171873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 171877 */   // (fp_to_sint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VCVTTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 171877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIrr),
     /* 171882 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171886 */   GIR_RootConstrainSelectedInstOperands,
     /* 171887 */   // GIR_Coverage, 1739,
     /* 171887 */   GIR_Done,
     /* 171888 */ // Label 3788: @171888
     /* 171888 */ GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(171918), // Rule ID 1747 //
     /* 171893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 171896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 171903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171907 */   // (fp_to_sint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (VCVTTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /* 171907 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIrr),
     /* 171912 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171916 */   GIR_RootConstrainSelectedInstOperands,
     /* 171917 */   // GIR_Coverage, 1747,
     /* 171917 */   GIR_Done,
     /* 171918 */ // Label 3789: @171918
     /* 171918 */ GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(171948), // Rule ID 1763 //
     /* 171923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 171926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 171933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 171937 */   // (fp_to_sint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (CVTTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 171937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SIrr),
     /* 171942 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171946 */   GIR_RootConstrainSelectedInstOperands,
     /* 171947 */   // GIR_Coverage, 1763,
     /* 171947 */   GIR_Done,
     /* 171948 */ // Label 3790: @171948
     /* 171948 */ GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(171978), // Rule ID 1771 //
     /* 171953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 171956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 171963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171967 */   // (fp_to_sint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (CVTTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /* 171967 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SIrr),
     /* 171972 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171976 */   GIR_RootConstrainSelectedInstOperands,
     /* 171977 */   // GIR_Coverage, 1771,
     /* 171977 */   GIR_Done,
     /* 171978 */ // Label 3791: @171978
     /* 171978 */ GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(172008), // Rule ID 10360 //
     /* 171983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 171986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 171993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 171997 */   // (fp_to_sint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2SIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /* 171997 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIZrr),
     /* 172002 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172006 */   GIR_RootConstrainSelectedInstOperands,
     /* 172007 */   // GIR_Coverage, 10360,
     /* 172007 */   GIR_Done,
     /* 172008 */ // Label 3792: @172008
     /* 172008 */ GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(172038), // Rule ID 10378 //
     /* 172013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 172016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 172027 */   // (fp_to_sint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2SIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /* 172027 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIZrr),
     /* 172032 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172036 */   GIR_RootConstrainSelectedInstOperands,
     /* 172037 */   // GIR_Coverage, 10378,
     /* 172037 */   GIR_Done,
     /* 172038 */ // Label 3793: @172038
     /* 172038 */ GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(172068), // Rule ID 15168 //
     /* 172043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 172046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 172049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 172057 */   // (fp_to_sint:{ *:[i32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2SIZrr:{ *:[i32] } FR16X:{ *:[f16] }:$src)
     /* 172057 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /* 172062 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172066 */   GIR_RootConstrainSelectedInstOperands,
     /* 172067 */   // GIR_Coverage, 15168,
     /* 172067 */   GIR_Done,
     /* 172068 */ // Label 3794: @172068
     /* 172068 */ GIM_Reject,
     /* 172069 */ // Label 3778: @172069
     /* 172069 */ GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(172128), // Rule ID 1745 //
     /* 172074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 172077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172084 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172088 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172092 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172095 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172099 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172103 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172105 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172112 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 172112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64rm),
     /* 172115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172117 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172121 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172126 */   GIR_RootConstrainSelectedInstOperands,
     /* 172127 */   // GIR_Coverage, 1745,
     /* 172127 */   GIR_EraseRootFromParent_Done,
     /* 172128 */ // Label 3795: @172128
     /* 172128 */ GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(172187), // Rule ID 1753 //
     /* 172133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 172136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172143 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172147 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172151 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172154 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172158 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172162 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172164 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172171 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 172171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64rm),
     /* 172174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172176 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172180 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172185 */   GIR_RootConstrainSelectedInstOperands,
     /* 172186 */   // GIR_Coverage, 1753,
     /* 172186 */   GIR_EraseRootFromParent_Done,
     /* 172187 */ // Label 3796: @172187
     /* 172187 */ GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(172246), // Rule ID 1769 //
     /* 172192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 172195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172202 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172206 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172210 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172213 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172217 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172221 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172223 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172230 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 172230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SI64rm),
     /* 172233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172235 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172239 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172244 */   GIR_RootConstrainSelectedInstOperands,
     /* 172245 */   // GIR_Coverage, 1769,
     /* 172245 */   GIR_EraseRootFromParent_Done,
     /* 172246 */ // Label 3797: @172246
     /* 172246 */ GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(172305), // Rule ID 1777 //
     /* 172251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 172254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172261 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172265 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172269 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172272 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172276 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172280 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172282 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172289 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 172289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SI64rm),
     /* 172292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172294 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172298 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172303 */   GIR_RootConstrainSelectedInstOperands,
     /* 172304 */   // GIR_Coverage, 1777,
     /* 172304 */   GIR_EraseRootFromParent_Done,
     /* 172305 */ // Label 3798: @172305
     /* 172305 */ GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(172364), // Rule ID 10371 //
     /* 172310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 172313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172320 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172324 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172328 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172331 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172335 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172339 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172341 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172348 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 172348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64Zrm),
     /* 172351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172353 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172357 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172362 */   GIR_RootConstrainSelectedInstOperands,
     /* 172363 */   // GIR_Coverage, 10371,
     /* 172363 */   GIR_EraseRootFromParent_Done,
     /* 172364 */ // Label 3799: @172364
     /* 172364 */ GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(172423), // Rule ID 10389 //
     /* 172369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 172372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172379 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172383 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172387 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172390 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172394 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172398 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172400 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172407 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 172407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64Zrm),
     /* 172410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172412 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172416 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172421 */   GIR_RootConstrainSelectedInstOperands,
     /* 172422 */   // GIR_Coverage, 10389,
     /* 172422 */   GIR_EraseRootFromParent_Done,
     /* 172423 */ // Label 3800: @172423
     /* 172423 */ GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(172482), // Rule ID 15179 //
     /* 172428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 172431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 172434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172438 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172442 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172446 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172449 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172453 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172457 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172459 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172466 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 172466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrm),
     /* 172469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172471 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172475 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172480 */   GIR_RootConstrainSelectedInstOperands,
     /* 172481 */   // GIR_Coverage, 15179,
     /* 172481 */   GIR_EraseRootFromParent_Done,
     /* 172482 */ // Label 3801: @172482
     /* 172482 */ GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(172512), // Rule ID 1743 //
     /* 172487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 172490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 172501 */   // (fp_to_sint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 172501 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64rr),
     /* 172506 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172510 */   GIR_RootConstrainSelectedInstOperands,
     /* 172511 */   // GIR_Coverage, 1743,
     /* 172511 */   GIR_Done,
     /* 172512 */ // Label 3802: @172512
     /* 172512 */ GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(172542), // Rule ID 1751 //
     /* 172517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 172520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 172531 */   // (fp_to_sint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 172531 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64rr),
     /* 172536 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172540 */   GIR_RootConstrainSelectedInstOperands,
     /* 172541 */   // GIR_Coverage, 1751,
     /* 172541 */   GIR_Done,
     /* 172542 */ // Label 3803: @172542
     /* 172542 */ GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(172572), // Rule ID 1767 //
     /* 172547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 172550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 172561 */   // (fp_to_sint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 172561 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SI64rr),
     /* 172566 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172570 */   GIR_RootConstrainSelectedInstOperands,
     /* 172571 */   // GIR_Coverage, 1767,
     /* 172571 */   GIR_Done,
     /* 172572 */ // Label 3804: @172572
     /* 172572 */ GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(172602), // Rule ID 1775 //
     /* 172577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 172580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 172591 */   // (fp_to_sint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 172591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SI64rr),
     /* 172596 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172600 */   GIR_RootConstrainSelectedInstOperands,
     /* 172601 */   // GIR_Coverage, 1775,
     /* 172601 */   GIR_Done,
     /* 172602 */ // Label 3805: @172602
     /* 172602 */ GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(172632), // Rule ID 10369 //
     /* 172607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 172610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 172621 */   // (fp_to_sint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2SI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /* 172621 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64Zrr),
     /* 172626 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172630 */   GIR_RootConstrainSelectedInstOperands,
     /* 172631 */   // GIR_Coverage, 10369,
     /* 172631 */   GIR_Done,
     /* 172632 */ // Label 3806: @172632
     /* 172632 */ GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(172662), // Rule ID 10387 //
     /* 172637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 172640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 172651 */   // (fp_to_sint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2SI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /* 172651 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64Zrr),
     /* 172656 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172660 */   GIR_RootConstrainSelectedInstOperands,
     /* 172661 */   // GIR_Coverage, 10387,
     /* 172661 */   GIR_Done,
     /* 172662 */ // Label 3807: @172662
     /* 172662 */ GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(172692), // Rule ID 15177 //
     /* 172667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 172670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 172673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 172677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 172681 */   // (fp_to_sint:{ *:[i64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16X:{ *:[f16] }:$src)
     /* 172681 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /* 172686 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172690 */   GIR_RootConstrainSelectedInstOperands,
     /* 172691 */   // GIR_Coverage, 15177,
     /* 172691 */   GIR_Done,
     /* 172692 */ // Label 3808: @172692
     /* 172692 */ GIM_Reject,
     /* 172693 */ // Label 3779: @172693
     /* 172693 */ GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(172781),
     /* 172698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 172701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172705 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(172757), // Rule ID 18053 //
     /* 172710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 172713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172721 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172724 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172728 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172734 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172741 */     // (fp_to_sint:{ *:[v4i32] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTPD2DQYrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /* 172741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTPD2DQYrm),
     /* 172744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172746 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172755 */     GIR_RootConstrainSelectedInstOperands,
     /* 172756 */     // GIR_Coverage, 18053,
     /* 172756 */     GIR_EraseRootFromParent_Done,
     /* 172757 */   // Label 3810: @172757
     /* 172757 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(172780), // Rule ID 18051 //
     /* 172762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 172765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 172769 */     // (fp_to_sint:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)  =>  (VCVTTPD2DQYrr:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)
     /* 172769 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTPD2DQYrr),
     /* 172774 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172778 */     GIR_RootConstrainSelectedInstOperands,
     /* 172779 */     // GIR_Coverage, 18051,
     /* 172779 */     GIR_Done,
     /* 172780 */   // Label 3811: @172780
     /* 172780 */   GIM_Reject,
     /* 172781 */ // Label 3809: @172781
     /* 172781 */ GIM_Reject,
     /* 172782 */ // Label 3780: @172782
     /* 172782 */ GIM_Reject,
     /* 172783 */ // Label 50: @172783
     /* 172783 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3814*/ GIMT_Encode4(173338),
     /* 172794 */ /*GILLT_s32*//*Label 3812*/ GIMT_Encode4(172802),
     /* 172798 */ /*GILLT_s64*//*Label 3813*/ GIMT_Encode4(173070),
     /* 172802 */ // Label 3812: @172802
     /* 172802 */ GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(172861), // Rule ID 10398 //
     /* 172807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 172810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172817 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172821 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172825 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172828 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172832 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172836 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172838 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172845 */   // (fp_to_uint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2USIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 172845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USIZrm),
     /* 172848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172850 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172854 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172859 */   GIR_RootConstrainSelectedInstOperands,
     /* 172860 */   // GIR_Coverage, 10398,
     /* 172860 */   GIR_EraseRootFromParent_Done,
     /* 172861 */ // Label 3815: @172861
     /* 172861 */ GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(172920), // Rule ID 10416 //
     /* 172866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 172869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172876 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172880 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172884 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172887 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172891 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172895 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172897 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172904 */   // (fp_to_uint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2USIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 172904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USIZrm),
     /* 172907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172909 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172913 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172918 */   GIR_RootConstrainSelectedInstOperands,
     /* 172919 */   // GIR_Coverage, 10416,
     /* 172919 */   GIR_EraseRootFromParent_Done,
     /* 172920 */ // Label 3816: @172920
     /* 172920 */ GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(172979), // Rule ID 15188 //
     /* 172925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 172928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 172931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172935 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172939 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172943 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172946 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172950 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172954 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172956 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172963 */   // (fp_to_uint:{ *:[i32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2USIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 172963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USIZrm),
     /* 172966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172968 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 172972 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172977 */   GIR_RootConstrainSelectedInstOperands,
     /* 172978 */   // GIR_Coverage, 15188,
     /* 172978 */   GIR_EraseRootFromParent_Done,
     /* 172979 */ // Label 3817: @172979
     /* 172979 */ GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(173009), // Rule ID 10396 //
     /* 172984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 172987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 172994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 172998 */   // (fp_to_uint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2USIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /* 172998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USIZrr),
     /* 173003 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173007 */   GIR_RootConstrainSelectedInstOperands,
     /* 173008 */   // GIR_Coverage, 10396,
     /* 173008 */   GIR_Done,
     /* 173009 */ // Label 3818: @173009
     /* 173009 */ GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(173039), // Rule ID 10414 //
     /* 173014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 173024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 173028 */   // (fp_to_uint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2USIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /* 173028 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USIZrr),
     /* 173033 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173037 */   GIR_RootConstrainSelectedInstOperands,
     /* 173038 */   // GIR_Coverage, 10414,
     /* 173038 */   GIR_Done,
     /* 173039 */ // Label 3819: @173039
     /* 173039 */ GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(173069), // Rule ID 15186 //
     /* 173044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 173050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 173054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 173058 */   // (fp_to_uint:{ *:[i32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2USIZrr:{ *:[i32] } FR16X:{ *:[f16] }:$src)
     /* 173058 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USIZrr),
     /* 173063 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173067 */   GIR_RootConstrainSelectedInstOperands,
     /* 173068 */   // GIR_Coverage, 15186,
     /* 173068 */   GIR_Done,
     /* 173069 */ // Label 3820: @173069
     /* 173069 */ GIM_Reject,
     /* 173070 */ // Label 3813: @173070
     /* 173070 */ GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(173129), // Rule ID 10407 //
     /* 173075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173085 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173089 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173093 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173096 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173100 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173104 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173106 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173113 */   // (fp_to_uint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2USI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 173113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USI64Zrm),
     /* 173116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173118 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173122 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173127 */   GIR_RootConstrainSelectedInstOperands,
     /* 173128 */   // GIR_Coverage, 10407,
     /* 173128 */   GIR_EraseRootFromParent_Done,
     /* 173129 */ // Label 3821: @173129
     /* 173129 */ GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(173188), // Rule ID 10425 //
     /* 173134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173144 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173148 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173152 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173155 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173159 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173163 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173165 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173172 */   // (fp_to_uint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2USI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 173172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USI64Zrm),
     /* 173175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173177 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173181 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173186 */   GIR_RootConstrainSelectedInstOperands,
     /* 173187 */   // GIR_Coverage, 10425,
     /* 173187 */   GIR_EraseRootFromParent_Done,
     /* 173188 */ // Label 3822: @173188
     /* 173188 */ GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(173247), // Rule ID 15197 //
     /* 173193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 173199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173203 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173207 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173211 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173214 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173218 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173222 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173224 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173231 */   // (fp_to_uint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2USI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 173231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USI64Zrm),
     /* 173234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173236 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173240 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173245 */   GIR_RootConstrainSelectedInstOperands,
     /* 173246 */   // GIR_Coverage, 15197,
     /* 173246 */   GIR_EraseRootFromParent_Done,
     /* 173247 */ // Label 3823: @173247
     /* 173247 */ GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(173277), // Rule ID 10405 //
     /* 173252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 173266 */   // (fp_to_uint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2USI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /* 173266 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USI64Zrr),
     /* 173271 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173275 */   GIR_RootConstrainSelectedInstOperands,
     /* 173276 */   // GIR_Coverage, 10405,
     /* 173276 */   GIR_Done,
     /* 173277 */ // Label 3824: @173277
     /* 173277 */ GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(173307), // Rule ID 10423 //
     /* 173282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 173296 */   // (fp_to_uint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2USI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /* 173296 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USI64Zrr),
     /* 173301 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173305 */   GIR_RootConstrainSelectedInstOperands,
     /* 173306 */   // GIR_Coverage, 10423,
     /* 173306 */   GIR_Done,
     /* 173307 */ // Label 3825: @173307
     /* 173307 */ GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(173337), // Rule ID 15195 //
     /* 173312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 173318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 173326 */   // (fp_to_uint:{ *:[i64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2USI64Zrr:{ *:[i64] } FR16X:{ *:[f16] }:$src)
     /* 173326 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USI64Zrr),
     /* 173331 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173335 */   GIR_RootConstrainSelectedInstOperands,
     /* 173336 */   // GIR_Coverage, 15195,
     /* 173336 */   GIR_Done,
     /* 173337 */ // Label 3826: @173337
     /* 173337 */ GIM_Reject,
     /* 173338 */ // Label 3814: @173338
     /* 173338 */ GIM_Reject,
     /* 173339 */ // Label 51: @173339
     /* 173339 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3839*/ GIMT_Encode4(176714),
     /* 173350 */ /*GILLT_s16*//*Label 3827*/ GIMT_Encode4(173434),
     /* 173354 */ /*GILLT_s32*//*Label 3828*/ GIMT_Encode4(173677),
     /* 173358 */ /*GILLT_s64*//*Label 3829*/ GIMT_Encode4(174340), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 173374 */ /*GILLT_v2s64*//*Label 3830*/ GIMT_Encode4(174999), GIMT_Encode4(0),
     /* 173382 */ /*GILLT_v4s32*//*Label 3831*/ GIMT_Encode4(175088),
     /* 173386 */ /*GILLT_v4s64*//*Label 3832*/ GIMT_Encode4(175386), GIMT_Encode4(0),
     /* 173394 */ /*GILLT_v8s16*//*Label 3833*/ GIMT_Encode4(175646),
     /* 173398 */ /*GILLT_v8s32*//*Label 3834*/ GIMT_Encode4(175914),
     /* 173402 */ /*GILLT_v8s64*//*Label 3835*/ GIMT_Encode4(176182), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 173414 */ /*GILLT_v16s16*//*Label 3836*/ GIMT_Encode4(176357),
     /* 173418 */ /*GILLT_v16s32*//*Label 3837*/ GIMT_Encode4(176536), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 173430 */ /*GILLT_v32s16*//*Label 3838*/ GIMT_Encode4(176625),
     /* 173434 */ // Label 3827: @173434
     /* 173434 */ GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(173510), // Rule ID 22178 //
     /* 173439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 173449 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173453 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173457 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173460 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173464 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173468 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173470 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173477 */   // (sint_to_fp:{ *:[f16] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 173477 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173480 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 173484 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173489 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 173491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SHZrm),
     /* 173494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173496 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173499 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173503 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173508 */   GIR_RootConstrainSelectedInstOperands,
     /* 173509 */   // GIR_Coverage, 22178,
     /* 173509 */   GIR_EraseRootFromParent_Done,
     /* 173510 */ // Label 3840: @173510
     /* 173510 */ GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(173586), // Rule ID 22176 //
     /* 173515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 173525 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173529 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173533 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173536 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173540 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 173544 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173546 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173553 */   // (sint_to_fp:{ *:[f16] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 173553 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173556 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 173560 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 173567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SHZrm),
     /* 173570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173572 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173575 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173579 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173584 */   GIR_RootConstrainSelectedInstOperands,
     /* 173585 */   // GIR_Coverage, 22176,
     /* 173585 */   GIR_EraseRootFromParent_Done,
     /* 173586 */ // Label 3841: @173586
     /* 173586 */ GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(173631), // Rule ID 22180 //
     /* 173591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 173601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 173605 */   // (sint_to_fp:{ *:[f16] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR32:{ *:[i32] }:$src)
     /* 173605 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173608 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 173612 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173617 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 173619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SHZrr),
     /* 173622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173624 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173627 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 173629 */   GIR_RootConstrainSelectedInstOperands,
     /* 173630 */   // GIR_Coverage, 22180,
     /* 173630 */   GIR_EraseRootFromParent_Done,
     /* 173631 */ // Label 3842: @173631
     /* 173631 */ GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(173676), // Rule ID 22182 //
     /* 173636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 173646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 173650 */   // (sint_to_fp:{ *:[f16] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR64:{ *:[i64] }:$src)
     /* 173650 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173653 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 173657 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 173664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SHZrr),
     /* 173667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173669 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173672 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 173674 */   GIR_RootConstrainSelectedInstOperands,
     /* 173675 */   // GIR_Coverage, 22182,
     /* 173675 */   GIR_EraseRootFromParent_Done,
     /* 173676 */ // Label 3843: @173676
     /* 173676 */ GIM_Reject,
     /* 173677 */ // Label 3828: @173677
     /* 173677 */ GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(173736), // Rule ID 1793 //
     /* 173682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 173685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 173692 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173696 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173700 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173703 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173707 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173711 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173713 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173720 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSI642SSrm:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /* 173720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI642SSrm),
     /* 173723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173725 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173729 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173734 */   GIR_RootConstrainSelectedInstOperands,
     /* 173735 */   // GIR_Coverage, 1793,
     /* 173735 */   GIR_EraseRootFromParent_Done,
     /* 173736 */ // Label 3844: @173736
     /* 173736 */ GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(173812), // Rule ID 17975 //
     /* 173741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 173744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 173751 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173755 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173759 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173762 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173766 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173770 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173772 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173779 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SSrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 173779 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 173782 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 173786 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 173793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSrm),
     /* 173796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173798 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173801 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173805 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173810 */   GIR_RootConstrainSelectedInstOperands,
     /* 173811 */   // GIR_Coverage, 17975,
     /* 173811 */   GIR_EraseRootFromParent_Done,
     /* 173812 */ // Label 3845: @173812
     /* 173812 */ GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(173888), // Rule ID 21129 //
     /* 173817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 173827 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173831 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173835 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173838 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173842 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173846 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173848 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173855 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 173855 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 173858 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 173862 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173867 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 173869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSZrm),
     /* 173872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173874 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173877 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173881 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173886 */   GIR_RootConstrainSelectedInstOperands,
     /* 173887 */   // GIR_Coverage, 21129,
     /* 173887 */   GIR_EraseRootFromParent_Done,
     /* 173888 */ // Label 3846: @173888
     /* 173888 */ GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(173947), // Rule ID 1789 //
     /* 173893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 173896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 173903 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173907 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173911 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173914 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173918 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 173922 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173924 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173931 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (CVTSI2SSrm:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /* 173931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI2SSrm),
     /* 173934 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173936 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 173940 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173945 */   GIR_RootConstrainSelectedInstOperands,
     /* 173946 */   // GIR_Coverage, 1789,
     /* 173946 */   GIR_EraseRootFromParent_Done,
     /* 173947 */ // Label 3847: @173947
     /* 173947 */ GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(174023), // Rule ID 17973 //
     /* 173952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 173955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 173962 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 173966 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173970 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173973 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173977 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 173981 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173983 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173990 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SSrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 173990 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 173993 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 173997 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174002 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSrm),
     /* 174007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174009 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174012 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174016 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174021 */   GIR_RootConstrainSelectedInstOperands,
     /* 174022 */   // GIR_Coverage, 17973,
     /* 174022 */   GIR_EraseRootFromParent_Done,
     /* 174023 */ // Label 3848: @174023
     /* 174023 */ GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(174099), // Rule ID 21127 //
     /* 174028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 174038 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174042 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174046 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174049 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174053 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 174057 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174059 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174066 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 174066 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174069 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174073 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174078 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSZrm),
     /* 174083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174085 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174088 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174092 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174097 */   GIR_RootConstrainSelectedInstOperands,
     /* 174098 */   // GIR_Coverage, 21127,
     /* 174098 */   GIR_EraseRootFromParent_Done,
     /* 174099 */ // Label 3849: @174099
     /* 174099 */ GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(174129), // Rule ID 1787 //
     /* 174104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 174107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 174118 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (CVTSI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /* 174118 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI2SSrr),
     /* 174123 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174127 */   GIR_RootConstrainSelectedInstOperands,
     /* 174128 */   // GIR_Coverage, 1787,
     /* 174128 */   GIR_Done,
     /* 174129 */ // Label 3850: @174129
     /* 174129 */ GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(174159), // Rule ID 1791 //
     /* 174134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 174137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 174148 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (CVTSI642SSrr:{ *:[f32] } GR64:{ *:[i64] }:$src)
     /* 174148 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI642SSrr),
     /* 174153 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174157 */   GIR_RootConstrainSelectedInstOperands,
     /* 174158 */   // GIR_Coverage, 1791,
     /* 174158 */   GIR_Done,
     /* 174159 */ // Label 3851: @174159
     /* 174159 */ GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(174204), // Rule ID 17981 //
     /* 174164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 174167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 174178 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 174178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174190 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSrr),
     /* 174195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174197 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174200 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174202 */   GIR_RootConstrainSelectedInstOperands,
     /* 174203 */   // GIR_Coverage, 17981,
     /* 174203 */   GIR_EraseRootFromParent_Done,
     /* 174204 */ // Label 3852: @174204
     /* 174204 */ GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(174249), // Rule ID 17983 //
     /* 174209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 174212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 174223 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 174223 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174226 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174230 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174235 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSrr),
     /* 174240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174242 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174245 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174247 */   GIR_RootConstrainSelectedInstOperands,
     /* 174248 */   // GIR_Coverage, 17983,
     /* 174248 */   GIR_EraseRootFromParent_Done,
     /* 174249 */ // Label 3853: @174249
     /* 174249 */ GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(174294), // Rule ID 21135 //
     /* 174254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 174264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 174268 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 174268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSZrr),
     /* 174285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174290 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174292 */   GIR_RootConstrainSelectedInstOperands,
     /* 174293 */   // GIR_Coverage, 21135,
     /* 174293 */   GIR_EraseRootFromParent_Done,
     /* 174294 */ // Label 3854: @174294
     /* 174294 */ GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(174339), // Rule ID 21137 //
     /* 174299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 174309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 174313 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 174313 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174316 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174320 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174325 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSZrr),
     /* 174330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174332 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174335 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174337 */   GIR_RootConstrainSelectedInstOperands,
     /* 174338 */   // GIR_Coverage, 21137,
     /* 174338 */   GIR_EraseRootFromParent_Done,
     /* 174339 */ // Label 3855: @174339
     /* 174339 */ GIM_Reject,
     /* 174340 */ // Label 3829: @174340
     /* 174340 */ GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(174399), // Rule ID 1801 //
     /* 174345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 174348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 174355 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174359 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174363 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174366 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174370 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174374 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174376 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174383 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSI642SDrm:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /* 174383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI642SDrm),
     /* 174386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174388 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174392 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174397 */   GIR_RootConstrainSelectedInstOperands,
     /* 174398 */   // GIR_Coverage, 1801,
     /* 174398 */   GIR_EraseRootFromParent_Done,
     /* 174399 */ // Label 3856: @174399
     /* 174399 */ GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(174475), // Rule ID 17979 //
     /* 174404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 174407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 174414 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174418 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174422 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174425 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174429 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174433 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174435 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174442 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SDrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 174442 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174445 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174449 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174454 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDrm),
     /* 174459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174461 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174464 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174473 */   GIR_RootConstrainSelectedInstOperands,
     /* 174474 */   // GIR_Coverage, 17979,
     /* 174474 */   GIR_EraseRootFromParent_Done,
     /* 174475 */ // Label 3857: @174475
     /* 174475 */ GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(174551), // Rule ID 21133 //
     /* 174480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 174490 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174494 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174498 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174501 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174505 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174509 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174511 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174518 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 174518 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174521 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174525 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174530 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDZrm),
     /* 174535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174537 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174540 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174544 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174549 */   GIR_RootConstrainSelectedInstOperands,
     /* 174550 */   // GIR_Coverage, 21133,
     /* 174550 */   GIR_EraseRootFromParent_Done,
     /* 174551 */ // Label 3858: @174551
     /* 174551 */ GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(174610), // Rule ID 1797 //
     /* 174556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 174559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 174566 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174570 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174574 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174577 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174581 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 174585 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174587 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174594 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (CVTSI2SDrm:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /* 174594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI2SDrm),
     /* 174597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174599 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174603 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174608 */   GIR_RootConstrainSelectedInstOperands,
     /* 174609 */   // GIR_Coverage, 1797,
     /* 174609 */   GIR_EraseRootFromParent_Done,
     /* 174610 */ // Label 3859: @174610
     /* 174610 */ GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(174686), // Rule ID 17977 //
     /* 174615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 174618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 174625 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174629 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174633 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174636 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174640 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 174644 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174646 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174653 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SDrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 174653 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174656 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174660 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDrm),
     /* 174670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174672 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174675 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174679 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174684 */   GIR_RootConstrainSelectedInstOperands,
     /* 174685 */   // GIR_Coverage, 17977,
     /* 174685 */   GIR_EraseRootFromParent_Done,
     /* 174686 */ // Label 3860: @174686
     /* 174686 */ GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(174762), // Rule ID 21131 //
     /* 174691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 174701 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174705 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174709 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174712 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174716 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 174720 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174722 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174729 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 174729 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174732 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174736 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174741 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDZrm),
     /* 174746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174748 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174751 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174755 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174760 */   GIR_RootConstrainSelectedInstOperands,
     /* 174761 */   // GIR_Coverage, 21131,
     /* 174761 */   GIR_EraseRootFromParent_Done,
     /* 174762 */ // Label 3861: @174762
     /* 174762 */ GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(174788), // Rule ID 1795 //
     /* 174767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 174770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 174777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 174781 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (CVTSI2SDrr:{ *:[f64] } GR32:{ *:[i32] }:$src)
     /* 174781 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI2SDrr),
     /* 174786 */   GIR_RootConstrainSelectedInstOperands,
     /* 174787 */   // GIR_Coverage, 1795,
     /* 174787 */   GIR_Done,
     /* 174788 */ // Label 3862: @174788
     /* 174788 */ GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(174818), // Rule ID 1799 //
     /* 174793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 174796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 174803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 174807 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (CVTSI642SDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /* 174807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI642SDrr),
     /* 174812 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174816 */   GIR_RootConstrainSelectedInstOperands,
     /* 174817 */   // GIR_Coverage, 1799,
     /* 174817 */   GIR_Done,
     /* 174818 */ // Label 3863: @174818
     /* 174818 */ GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(174863), // Rule ID 17985 //
     /* 174823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 174826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 174833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 174837 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 174837 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174840 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174844 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174849 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDrr),
     /* 174854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174856 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174859 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174861 */   GIR_RootConstrainSelectedInstOperands,
     /* 174862 */   // GIR_Coverage, 17985,
     /* 174862 */   GIR_EraseRootFromParent_Done,
     /* 174863 */ // Label 3864: @174863
     /* 174863 */ GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(174908), // Rule ID 17987 //
     /* 174868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 174871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 174878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 174882 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 174882 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174885 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174889 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDrr),
     /* 174899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174904 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174906 */   GIR_RootConstrainSelectedInstOperands,
     /* 174907 */   // GIR_Coverage, 17987,
     /* 174907 */   GIR_EraseRootFromParent_Done,
     /* 174908 */ // Label 3865: @174908
     /* 174908 */ GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(174953), // Rule ID 21139 //
     /* 174913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 174923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 174927 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 174927 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174930 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174934 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174939 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDZrr),
     /* 174944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174946 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174949 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174951 */   GIR_RootConstrainSelectedInstOperands,
     /* 174952 */   // GIR_Coverage, 21139,
     /* 174952 */   GIR_EraseRootFromParent_Done,
     /* 174953 */ // Label 3866: @174953
     /* 174953 */ GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(174998), // Rule ID 21141 //
     /* 174958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 174968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 174972 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 174972 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174975 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174979 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDZrr),
     /* 174989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174994 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174996 */   GIR_RootConstrainSelectedInstOperands,
     /* 174997 */   // GIR_Coverage, 21141,
     /* 174997 */   GIR_EraseRootFromParent_Done,
     /* 174998 */ // Label 3867: @174998
     /* 174998 */ GIM_Reject,
     /* 174999 */ // Label 3830: @174999
     /* 174999 */ GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(175087),
     /* 175004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175011 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(175063), // Rule ID 11378 //
     /* 175016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 175019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175027 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175030 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175034 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175047 */     // (sint_to_fp:{ *:[v2f64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 175047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ128rm),
     /* 175050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175052 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175061 */     GIR_RootConstrainSelectedInstOperands,
     /* 175062 */     // GIR_Coverage, 11378,
     /* 175062 */     GIR_EraseRootFromParent_Done,
     /* 175063 */   // Label 3869: @175063
     /* 175063 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(175086), // Rule ID 11374 //
     /* 175068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 175071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175075 */     // (sint_to_fp:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)  =>  (VCVTQQ2PDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)
     /* 175075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ128rr),
     /* 175080 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175084 */     GIR_RootConstrainSelectedInstOperands,
     /* 175085 */     // GIR_Coverage, 11374,
     /* 175085 */     GIR_Done,
     /* 175086 */   // Label 3870: @175086
     /* 175086 */   GIM_Reject,
     /* 175087 */ // Label 3868: @175087
     /* 175087 */ GIM_Reject,
     /* 175088 */ // Label 3831: @175088
     /* 175088 */ GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(175147), // Rule ID 1869 //
     /* 175093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 175096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 175103 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175107 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175111 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175114 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175118 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175122 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175124 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175131 */   // (sint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 175131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSrm),
     /* 175134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175136 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175140 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175145 */   GIR_RootConstrainSelectedInstOperands,
     /* 175146 */   // GIR_Coverage, 1869,
     /* 175146 */   GIR_EraseRootFromParent_Done,
     /* 175147 */ // Label 3871: @175147
     /* 175147 */ GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(175206), // Rule ID 10754 //
     /* 175152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 175155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175162 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175166 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175170 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175173 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175177 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175181 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175183 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175190 */   // (sint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 175190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ128rm),
     /* 175193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175195 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175199 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175204 */   GIR_RootConstrainSelectedInstOperands,
     /* 175205 */   // GIR_Coverage, 10754,
     /* 175205 */   GIR_EraseRootFromParent_Done,
     /* 175206 */ // Label 3872: @175206
     /* 175206 */ GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(175265), // Rule ID 11510 //
     /* 175211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 175214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 175217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175221 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175225 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175229 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175232 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175236 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175240 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175242 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175249 */   // (sint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PSZ256rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 175249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZ256rm),
     /* 175252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175254 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175258 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175263 */   GIR_RootConstrainSelectedInstOperands,
     /* 175264 */   // GIR_Coverage, 11510,
     /* 175264 */   GIR_EraseRootFromParent_Done,
     /* 175265 */ // Label 3873: @175265
     /* 175265 */ GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(175295), // Rule ID 1867 //
     /* 175270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 175273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 175280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 175284 */   // (sint_to_fp:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PSrr:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)
     /* 175284 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSrr),
     /* 175289 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175293 */   GIR_RootConstrainSelectedInstOperands,
     /* 175294 */   // GIR_Coverage, 1867,
     /* 175294 */   GIR_Done,
     /* 175295 */ // Label 3874: @175295
     /* 175295 */ GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(175325), // Rule ID 1875 //
     /* 175300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 175303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 175310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 175314 */   // (sint_to_fp:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)  =>  (CVTDQ2PSrr:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)
     /* 175314 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTDQ2PSrr),
     /* 175319 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175323 */   GIR_RootConstrainSelectedInstOperands,
     /* 175324 */   // GIR_Coverage, 1875,
     /* 175324 */   GIR_Done,
     /* 175325 */ // Label 3875: @175325
     /* 175325 */ GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(175355), // Rule ID 10750 //
     /* 175330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 175333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175344 */   // (sint_to_fp:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)
     /* 175344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ128rr),
     /* 175349 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175353 */   GIR_RootConstrainSelectedInstOperands,
     /* 175354 */   // GIR_Coverage, 10750,
     /* 175354 */   GIR_Done,
     /* 175355 */ // Label 3876: @175355
     /* 175355 */ GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(175385), // Rule ID 11506 //
     /* 175360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 175363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 175366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 175374 */   // (sint_to_fp:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTQQ2PSZ256rr:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)
     /* 175374 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZ256rr),
     /* 175379 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175383 */   GIR_RootConstrainSelectedInstOperands,
     /* 175384 */   // GIR_Coverage, 11506,
     /* 175384 */   GIR_Done,
     /* 175385 */ // Label 3877: @175385
     /* 175385 */ GIM_Reject,
     /* 175386 */ // Label 3832: @175386
     /* 175386 */ GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(175445), // Rule ID 1944 //
     /* 175391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 175394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 175401 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175405 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175409 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175412 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175416 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175420 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175422 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175429 */   // (sint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 175429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDYrm),
     /* 175432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175434 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175438 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175443 */   GIR_RootConstrainSelectedInstOperands,
     /* 175444 */   // GIR_Coverage, 1944,
     /* 175444 */   GIR_EraseRootFromParent_Done,
     /* 175445 */ // Label 3878: @175445
     /* 175445 */ GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(175504), // Rule ID 10727 //
     /* 175450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 175453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 175460 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175464 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175468 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175471 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175475 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175479 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175481 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175488 */   // (sint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 175488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZ256rm),
     /* 175491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175493 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175497 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175502 */   GIR_RootConstrainSelectedInstOperands,
     /* 175503 */   // GIR_Coverage, 10727,
     /* 175503 */   GIR_EraseRootFromParent_Done,
     /* 175504 */ // Label 3879: @175504
     /* 175504 */ GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(175563), // Rule ID 11390 //
     /* 175509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 175512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 175515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 175519 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175523 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175527 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175530 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175534 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175538 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175540 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175547 */   // (sint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 175547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ256rm),
     /* 175550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175552 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175556 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175561 */   GIR_RootConstrainSelectedInstOperands,
     /* 175562 */   // GIR_Coverage, 11390,
     /* 175562 */   GIR_EraseRootFromParent_Done,
     /* 175563 */ // Label 3880: @175563
     /* 175563 */ GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(175589), // Rule ID 1946 //
     /* 175568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 175571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 175578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 175582 */   // (sint_to_fp:{ *:[v4f64] } VR128:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PDYrr:{ *:[v4f64] } VR128:{ *:[v4i32] }:$src)
     /* 175582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDYrr),
     /* 175587 */   GIR_RootConstrainSelectedInstOperands,
     /* 175588 */   // GIR_Coverage, 1946,
     /* 175588 */   GIR_Done,
     /* 175589 */ // Label 3881: @175589
     /* 175589 */ GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(175615), // Rule ID 10723 //
     /* 175594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 175597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 175604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175608 */   // (sint_to_fp:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)
     /* 175608 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZ256rr),
     /* 175613 */   GIR_RootConstrainSelectedInstOperands,
     /* 175614 */   // GIR_Coverage, 10723,
     /* 175614 */   GIR_Done,
     /* 175615 */ // Label 3882: @175615
     /* 175615 */ GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(175645), // Rule ID 11386 //
     /* 175620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 175623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 175626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 175630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 175634 */   // (sint_to_fp:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTQQ2PDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)
     /* 175634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ256rr),
     /* 175639 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175643 */   GIR_RootConstrainSelectedInstOperands,
     /* 175644 */   // GIR_Coverage, 11386,
     /* 175644 */   GIR_Done,
     /* 175645 */ // Label 3883: @175645
     /* 175645 */ GIM_Reject,
     /* 175646 */ // Label 3833: @175646
     /* 175646 */ GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(175705), // Rule ID 11456 //
     /* 175651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 175654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 175657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175661 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175665 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175669 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175672 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175676 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175680 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175682 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175689 */   // (sint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PHZ256rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 175689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZ256rm),
     /* 175692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175694 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175698 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175703 */   GIR_RootConstrainSelectedInstOperands,
     /* 175704 */   // GIR_Coverage, 11456,
     /* 175704 */   GIR_EraseRootFromParent_Done,
     /* 175705 */ // Label 3884: @175705
     /* 175705 */ GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(175764), // Rule ID 14822 //
     /* 175710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 175713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175720 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175724 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175728 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175731 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175735 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175739 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175741 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175748 */   // (sint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTW2PHZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 175748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ128rm),
     /* 175751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175753 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175757 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175762 */   GIR_RootConstrainSelectedInstOperands,
     /* 175763 */   // GIR_Coverage, 14822,
     /* 175763 */   GIR_EraseRootFromParent_Done,
     /* 175764 */ // Label 3885: @175764
     /* 175764 */ GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(175823), // Rule ID 15122 //
     /* 175769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 175772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 175775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175779 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175783 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175787 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175790 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175794 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175798 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175800 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175807 */   // (sint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PHZrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 175807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PHZrm),
     /* 175810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175812 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175816 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175821 */   GIR_RootConstrainSelectedInstOperands,
     /* 175822 */   // GIR_Coverage, 15122,
     /* 175822 */   GIR_EraseRootFromParent_Done,
     /* 175823 */ // Label 3886: @175823
     /* 175823 */ GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(175853), // Rule ID 11452 //
     /* 175828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 175831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 175834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 175842 */   // (sint_to_fp:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PHZ256rr:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)
     /* 175842 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZ256rr),
     /* 175847 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175851 */   GIR_RootConstrainSelectedInstOperands,
     /* 175852 */   // GIR_Coverage, 11452,
     /* 175852 */   GIR_Done,
     /* 175853 */ // Label 3887: @175853
     /* 175853 */ GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(175883), // Rule ID 14818 //
     /* 175858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 175861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175872 */   // (sint_to_fp:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)  =>  (VCVTW2PHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)
     /* 175872 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ128rr),
     /* 175877 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175881 */   GIR_RootConstrainSelectedInstOperands,
     /* 175882 */   // GIR_Coverage, 14818,
     /* 175882 */   GIR_Done,
     /* 175883 */ // Label 3888: @175883
     /* 175883 */ GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(175913), // Rule ID 15118 //
     /* 175888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 175891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 175894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 175898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 175902 */   // (sint_to_fp:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PHZrr:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)
     /* 175902 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PHZrr),
     /* 175907 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175911 */   GIR_RootConstrainSelectedInstOperands,
     /* 175912 */   // GIR_Coverage, 15118,
     /* 175912 */   GIR_Done,
     /* 175913 */ // Label 3889: @175913
     /* 175913 */ GIM_Reject,
     /* 175914 */ // Label 3834: @175914
     /* 175914 */ GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(175973), // Rule ID 1873 //
     /* 175919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 175922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 175925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 175929 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175933 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175937 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175940 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175944 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175948 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175950 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175957 */   // (sint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 175957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSYrm),
     /* 175960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175962 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175966 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175971 */   GIR_RootConstrainSelectedInstOperands,
     /* 175972 */   // GIR_Coverage, 1873,
     /* 175972 */   GIR_EraseRootFromParent_Done,
     /* 175973 */ // Label 3890: @175973
     /* 175973 */ GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(176032), // Rule ID 10766 //
     /* 175978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 175981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 175984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 175988 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175992 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175996 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175999 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176003 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176007 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176009 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176016 */   // (sint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 176016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ256rm),
     /* 176019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176021 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176025 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176030 */   GIR_RootConstrainSelectedInstOperands,
     /* 176031 */   // GIR_Coverage, 10766,
     /* 176031 */   GIR_EraseRootFromParent_Done,
     /* 176032 */ // Label 3891: @176032
     /* 176032 */ GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(176091), // Rule ID 11495 //
     /* 176037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 176040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 176043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176047 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176051 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176055 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176058 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176062 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176066 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176068 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176075 */   // (sint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PSZrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 176075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZrm),
     /* 176078 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176080 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176084 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176089 */   GIR_RootConstrainSelectedInstOperands,
     /* 176090 */   // GIR_Coverage, 11495,
     /* 176090 */   GIR_EraseRootFromParent_Done,
     /* 176091 */ // Label 3892: @176091
     /* 176091 */ GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(176121), // Rule ID 1871 //
     /* 176096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 176099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 176102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 176106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 176110 */   // (sint_to_fp:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PSYrr:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src)
     /* 176110 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSYrr),
     /* 176115 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176119 */   GIR_RootConstrainSelectedInstOperands,
     /* 176120 */   // GIR_Coverage, 1871,
     /* 176120 */   GIR_Done,
     /* 176121 */ // Label 3893: @176121
     /* 176121 */ GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(176151), // Rule ID 10762 //
     /* 176126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 176129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 176132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176140 */   // (sint_to_fp:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)
     /* 176140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ256rr),
     /* 176145 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176149 */   GIR_RootConstrainSelectedInstOperands,
     /* 176150 */   // GIR_Coverage, 10762,
     /* 176150 */   GIR_Done,
     /* 176151 */ // Label 3894: @176151
     /* 176151 */ GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(176181), // Rule ID 11491 //
     /* 176156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 176159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 176162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176170 */   // (sint_to_fp:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PSZrr:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)
     /* 176170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZrr),
     /* 176175 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176179 */   GIR_RootConstrainSelectedInstOperands,
     /* 176180 */   // GIR_Coverage, 11491,
     /* 176180 */   GIR_Done,
     /* 176181 */ // Label 3895: @176181
     /* 176181 */ GIM_Reject,
     /* 176182 */ // Label 3835: @176182
     /* 176182 */ GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(176241), // Rule ID 10703 //
     /* 176187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 176193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176197 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176201 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176205 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176208 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176212 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176216 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176218 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176225 */   // (sint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 176225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZrm),
     /* 176228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176230 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176234 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176239 */   GIR_RootConstrainSelectedInstOperands,
     /* 176240 */   // GIR_Coverage, 10703,
     /* 176240 */   GIR_EraseRootFromParent_Done,
     /* 176241 */ // Label 3896: @176241
     /* 176241 */ GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(176300), // Rule ID 11363 //
     /* 176246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 176249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 176252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176256 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176260 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176264 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176267 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176271 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176275 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176277 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176284 */   // (sint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 176284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZrm),
     /* 176287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176289 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176293 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176298 */   GIR_RootConstrainSelectedInstOperands,
     /* 176299 */   // GIR_Coverage, 11363,
     /* 176299 */   GIR_EraseRootFromParent_Done,
     /* 176300 */ // Label 3897: @176300
     /* 176300 */ GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(176326), // Rule ID 10699 //
     /* 176305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 176311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176319 */   // (sint_to_fp:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)
     /* 176319 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZrr),
     /* 176324 */   GIR_RootConstrainSelectedInstOperands,
     /* 176325 */   // GIR_Coverage, 10699,
     /* 176325 */   GIR_Done,
     /* 176326 */ // Label 3898: @176326
     /* 176326 */ GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(176356), // Rule ID 11359 //
     /* 176331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 176334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 176337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176345 */   // (sint_to_fp:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PDZrr:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)
     /* 176345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZrr),
     /* 176350 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176354 */   GIR_RootConstrainSelectedInstOperands,
     /* 176355 */   // GIR_Coverage, 11359,
     /* 176355 */   GIR_Done,
     /* 176356 */ // Label 3899: @176356
     /* 176356 */ GIM_Reject,
     /* 176357 */ // Label 3836: @176357
     /* 176357 */ GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(176416), // Rule ID 11441 //
     /* 176362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 176368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176372 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176376 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176380 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176383 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176387 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176391 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176393 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176400 */   // (sint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PHZrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 176400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZrm),
     /* 176403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176405 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176409 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176414 */   GIR_RootConstrainSelectedInstOperands,
     /* 176415 */   // GIR_Coverage, 11441,
     /* 176415 */   GIR_EraseRootFromParent_Done,
     /* 176416 */ // Label 3900: @176416
     /* 176416 */ GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(176475), // Rule ID 14834 //
     /* 176421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 176424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 176427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176431 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176435 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176439 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176442 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176446 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176450 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176452 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176459 */   // (sint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTW2PHZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 176459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ256rm),
     /* 176462 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176464 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176473 */   GIR_RootConstrainSelectedInstOperands,
     /* 176474 */   // GIR_Coverage, 14834,
     /* 176474 */   GIR_EraseRootFromParent_Done,
     /* 176475 */ // Label 3901: @176475
     /* 176475 */ GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(176505), // Rule ID 11437 //
     /* 176480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 176486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176494 */   // (sint_to_fp:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTDQ2PHZrr:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)
     /* 176494 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZrr),
     /* 176499 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176503 */   GIR_RootConstrainSelectedInstOperands,
     /* 176504 */   // GIR_Coverage, 11437,
     /* 176504 */   GIR_Done,
     /* 176505 */ // Label 3902: @176505
     /* 176505 */ GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(176535), // Rule ID 14830 //
     /* 176510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 176513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 176516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 176524 */   // (sint_to_fp:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)  =>  (VCVTW2PHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)
     /* 176524 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ256rr),
     /* 176529 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176533 */   GIR_RootConstrainSelectedInstOperands,
     /* 176534 */   // GIR_Coverage, 14830,
     /* 176534 */   GIR_Done,
     /* 176535 */ // Label 3903: @176535
     /* 176535 */ GIM_Reject,
     /* 176536 */ // Label 3837: @176536
     /* 176536 */ GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(176624),
     /* 176541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 176544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176548 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(176600), // Rule ID 10739 //
     /* 176553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176564 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176567 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176571 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176584 */     // (sint_to_fp:{ *:[v16f32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 176584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZrm),
     /* 176587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176598 */     GIR_RootConstrainSelectedInstOperands,
     /* 176599 */     // GIR_Coverage, 10739,
     /* 176599 */     GIR_EraseRootFromParent_Done,
     /* 176600 */   // Label 3905: @176600
     /* 176600 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(176623), // Rule ID 10735 //
     /* 176605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176612 */     // (sint_to_fp:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTDQ2PSZrr:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)
     /* 176612 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZrr),
     /* 176617 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176621 */     GIR_RootConstrainSelectedInstOperands,
     /* 176622 */     // GIR_Coverage, 10735,
     /* 176622 */     GIR_Done,
     /* 176623 */   // Label 3906: @176623
     /* 176623 */   GIM_Reject,
     /* 176624 */ // Label 3904: @176624
     /* 176624 */ GIM_Reject,
     /* 176625 */ // Label 3838: @176625
     /* 176625 */ GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(176713),
     /* 176630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 176633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176637 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(176689), // Rule ID 14807 //
     /* 176642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176653 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176656 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176660 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176673 */     // (sint_to_fp:{ *:[v32f16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTW2PHZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 176673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZrm),
     /* 176676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176678 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176687 */     GIR_RootConstrainSelectedInstOperands,
     /* 176688 */     // GIR_Coverage, 14807,
     /* 176688 */     GIR_EraseRootFromParent_Done,
     /* 176689 */   // Label 3908: @176689
     /* 176689 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(176712), // Rule ID 14803 //
     /* 176694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 176701 */     // (sint_to_fp:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)  =>  (VCVTW2PHZrr:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)
     /* 176701 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZrr),
     /* 176706 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176710 */     GIR_RootConstrainSelectedInstOperands,
     /* 176711 */     // GIR_Coverage, 14803,
     /* 176711 */     GIR_Done,
     /* 176712 */   // Label 3909: @176712
     /* 176712 */   GIM_Reject,
     /* 176713 */ // Label 3907: @176713
     /* 176713 */ GIM_Reject,
     /* 176714 */ // Label 3839: @176714
     /* 176714 */ GIM_Reject,
     /* 176715 */ // Label 52: @176715
     /* 176715 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3922*/ GIMT_Encode4(178961),
     /* 176726 */ /*GILLT_s16*//*Label 3910*/ GIMT_Encode4(176810),
     /* 176730 */ /*GILLT_s32*//*Label 3911*/ GIMT_Encode4(177053),
     /* 176734 */ /*GILLT_s64*//*Label 3912*/ GIMT_Encode4(177296), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 176750 */ /*GILLT_v2s64*//*Label 3913*/ GIMT_Encode4(177539), GIMT_Encode4(0),
     /* 176758 */ /*GILLT_v4s32*//*Label 3914*/ GIMT_Encode4(177628),
     /* 176762 */ /*GILLT_v4s64*//*Label 3915*/ GIMT_Encode4(177807), GIMT_Encode4(0),
     /* 176770 */ /*GILLT_v8s16*//*Label 3916*/ GIMT_Encode4(177982),
     /* 176774 */ /*GILLT_v8s32*//*Label 3917*/ GIMT_Encode4(178250),
     /* 176778 */ /*GILLT_v8s64*//*Label 3918*/ GIMT_Encode4(178429), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 176790 */ /*GILLT_v16s16*//*Label 3919*/ GIMT_Encode4(178604),
     /* 176794 */ /*GILLT_v16s32*//*Label 3920*/ GIMT_Encode4(178783), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 176806 */ /*GILLT_v32s16*//*Label 3921*/ GIMT_Encode4(178872),
     /* 176810 */ // Label 3910: @176810
     /* 176810 */ GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(176886), // Rule ID 22186 //
     /* 176815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 176825 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176829 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176833 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176836 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176840 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176844 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176846 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176853 */   // (uint_to_fp:{ *:[f16] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUSI642SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 176853 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 176856 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 176860 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 176867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SHZrm),
     /* 176870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176872 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 176875 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176879 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176884 */   GIR_RootConstrainSelectedInstOperands,
     /* 176885 */   // GIR_Coverage, 22186,
     /* 176885 */   GIR_EraseRootFromParent_Done,
     /* 176886 */ // Label 3923: @176886
     /* 176886 */ GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(176962), // Rule ID 22184 //
     /* 176891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 176901 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176905 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176909 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176912 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176916 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 176920 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176922 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176929 */   // (uint_to_fp:{ *:[f16] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTUSI2SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 176929 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 176932 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 176936 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176941 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 176943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SHZrm),
     /* 176946 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176948 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 176951 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176955 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176960 */   GIR_RootConstrainSelectedInstOperands,
     /* 176961 */   // GIR_Coverage, 22184,
     /* 176961 */   GIR_EraseRootFromParent_Done,
     /* 176962 */ // Label 3924: @176962
     /* 176962 */ GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(177007), // Rule ID 22188 //
     /* 176967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 176977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 176981 */   // (uint_to_fp:{ *:[f16] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR32:{ *:[i32] }:$src)
     /* 176981 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 176984 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 176988 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176993 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 176995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SHZrr),
     /* 176998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177000 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 177005 */   GIR_RootConstrainSelectedInstOperands,
     /* 177006 */   // GIR_Coverage, 22188,
     /* 177006 */   GIR_EraseRootFromParent_Done,
     /* 177007 */ // Label 3925: @177007
     /* 177007 */ GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(177052), // Rule ID 22190 //
     /* 177012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177026 */   // (uint_to_fp:{ *:[f16] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR64:{ *:[i64] }:$src)
     /* 177026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SHZrr),
     /* 177043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177045 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177048 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 177050 */   GIR_RootConstrainSelectedInstOperands,
     /* 177051 */   // GIR_Coverage, 22190,
     /* 177051 */   GIR_EraseRootFromParent_Done,
     /* 177052 */ // Label 3926: @177052
     /* 177052 */ GIM_Reject,
     /* 177053 */ // Label 3911: @177053
     /* 177053 */ GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(177129), // Rule ID 21145 //
     /* 177058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177068 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177072 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177076 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177079 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177083 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177087 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177089 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177096 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUSI642SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 177096 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177099 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177103 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177108 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SSZrm),
     /* 177113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177115 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177118 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177122 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177127 */   GIR_RootConstrainSelectedInstOperands,
     /* 177128 */   // GIR_Coverage, 21145,
     /* 177128 */   GIR_EraseRootFromParent_Done,
     /* 177129 */ // Label 3927: @177129
     /* 177129 */ GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(177205), // Rule ID 21143 //
     /* 177134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177144 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177148 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177152 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177155 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177159 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 177163 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177165 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177172 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTUSI2SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 177172 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177175 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177179 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SSZrm),
     /* 177189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177191 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177194 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177198 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177203 */   GIR_RootConstrainSelectedInstOperands,
     /* 177204 */   // GIR_Coverage, 21143,
     /* 177204 */   GIR_EraseRootFromParent_Done,
     /* 177205 */ // Label 3928: @177205
     /* 177205 */ GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(177250), // Rule ID 21151 //
     /* 177210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 177224 */   // (uint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 177224 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177227 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177231 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SSZrr),
     /* 177241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177243 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177246 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 177248 */   GIR_RootConstrainSelectedInstOperands,
     /* 177249 */   // GIR_Coverage, 21151,
     /* 177249 */   GIR_EraseRootFromParent_Done,
     /* 177250 */ // Label 3929: @177250
     /* 177250 */ GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(177295), // Rule ID 21153 //
     /* 177255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177269 */   // (uint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 177269 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177272 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177276 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SSZrr),
     /* 177286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177288 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177291 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 177293 */   GIR_RootConstrainSelectedInstOperands,
     /* 177294 */   // GIR_Coverage, 21153,
     /* 177294 */   GIR_EraseRootFromParent_Done,
     /* 177295 */ // Label 3930: @177295
     /* 177295 */ GIM_Reject,
     /* 177296 */ // Label 3912: @177296
     /* 177296 */ GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(177372), // Rule ID 21149 //
     /* 177301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 177311 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177315 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177319 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177322 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177326 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177330 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177332 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177339 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUSI642SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 177339 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 177342 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177346 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SDZrm),
     /* 177356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177361 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177365 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177370 */   GIR_RootConstrainSelectedInstOperands,
     /* 177371 */   // GIR_Coverage, 21149,
     /* 177371 */   GIR_EraseRootFromParent_Done,
     /* 177372 */ // Label 3931: @177372
     /* 177372 */ GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(177448), // Rule ID 21147 //
     /* 177377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 177387 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177391 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177395 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177398 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177402 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 177406 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177408 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177415 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTUSI2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 177415 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 177418 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177422 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SDZrm),
     /* 177432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177434 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177437 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177441 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177446 */   GIR_RootConstrainSelectedInstOperands,
     /* 177447 */   // GIR_Coverage, 21147,
     /* 177447 */   GIR_EraseRootFromParent_Done,
     /* 177448 */ // Label 3932: @177448
     /* 177448 */ GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(177493), // Rule ID 21155 //
     /* 177453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 177463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 177467 */   // (uint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 177467 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 177470 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177474 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177479 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SDZrr),
     /* 177484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177486 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177489 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 177491 */   GIR_RootConstrainSelectedInstOperands,
     /* 177492 */   // GIR_Coverage, 21155,
     /* 177492 */   GIR_EraseRootFromParent_Done,
     /* 177493 */ // Label 3933: @177493
     /* 177493 */ GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(177538), // Rule ID 21157 //
     /* 177498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 177508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177512 */   // (uint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 177512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 177515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177524 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SDZrr),
     /* 177529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177531 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177534 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 177536 */   GIR_RootConstrainSelectedInstOperands,
     /* 177537 */   // GIR_Coverage, 21157,
     /* 177537 */   GIR_EraseRootFromParent_Done,
     /* 177538 */ // Label 3934: @177538
     /* 177538 */ GIM_Reject,
     /* 177539 */ // Label 3913: @177539
     /* 177539 */ GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(177627),
     /* 177544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 177547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 177551 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(177603), // Rule ID 11417 //
     /* 177556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 177559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177567 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177570 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177574 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177580 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177587 */     // (uint_to_fp:{ *:[v2f64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 177587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ128rm),
     /* 177590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177592 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177601 */     GIR_RootConstrainSelectedInstOperands,
     /* 177602 */     // GIR_Coverage, 11417,
     /* 177602 */     GIR_EraseRootFromParent_Done,
     /* 177603 */   // Label 3936: @177603
     /* 177603 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(177626), // Rule ID 11413 //
     /* 177608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 177611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 177615 */     // (uint_to_fp:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)  =>  (VCVTUQQ2PDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)
     /* 177615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ128rr),
     /* 177620 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177624 */     GIR_RootConstrainSelectedInstOperands,
     /* 177625 */     // GIR_Coverage, 11413,
     /* 177625 */     GIR_Done,
     /* 177626 */   // Label 3937: @177626
     /* 177626 */   GIM_Reject,
     /* 177627 */ // Label 3935: @177627
     /* 177627 */ GIM_Reject,
     /* 177628 */ // Label 3914: @177628
     /* 177628 */ GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(177687), // Rule ID 10961 //
     /* 177633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 177636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 177643 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177647 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177651 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177654 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177658 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177662 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177664 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177671 */   // (uint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 177671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ128rm),
     /* 177674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177676 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177680 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177685 */   GIR_RootConstrainSelectedInstOperands,
     /* 177686 */   // GIR_Coverage, 10961,
     /* 177686 */   GIR_EraseRootFromParent_Done,
     /* 177687 */ // Label 3938: @177687
     /* 177687 */ GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(177746), // Rule ID 11537 //
     /* 177692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 177695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 177698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 177702 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177706 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177710 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177713 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177717 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177721 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177723 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177730 */   // (uint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PSZ256rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 177730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZ256rm),
     /* 177733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177735 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177739 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177744 */   GIR_RootConstrainSelectedInstOperands,
     /* 177745 */   // GIR_Coverage, 11537,
     /* 177745 */   GIR_EraseRootFromParent_Done,
     /* 177746 */ // Label 3939: @177746
     /* 177746 */ GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(177776), // Rule ID 10957 //
     /* 177751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 177754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 177761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 177765 */   // (uint_to_fp:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTUDQ2PSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)
     /* 177765 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ128rr),
     /* 177770 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177774 */   GIR_RootConstrainSelectedInstOperands,
     /* 177775 */   // GIR_Coverage, 10957,
     /* 177775 */   GIR_Done,
     /* 177776 */ // Label 3940: @177776
     /* 177776 */ GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(177806), // Rule ID 11533 //
     /* 177781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 177784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 177787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 177791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 177795 */   // (uint_to_fp:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTUQQ2PSZ256rr:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)
     /* 177795 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZ256rr),
     /* 177800 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177804 */   GIR_RootConstrainSelectedInstOperands,
     /* 177805 */   // GIR_Coverage, 11533,
     /* 177805 */   GIR_Done,
     /* 177806 */ // Label 3941: @177806
     /* 177806 */ GIM_Reject,
     /* 177807 */ // Label 3915: @177807
     /* 177807 */ GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(177866), // Rule ID 10934 //
     /* 177812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 177815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 177822 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177826 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177830 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177833 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177837 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177841 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177843 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177850 */   // (uint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 177850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZ256rm),
     /* 177853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177855 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177859 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177864 */   GIR_RootConstrainSelectedInstOperands,
     /* 177865 */   // GIR_Coverage, 10934,
     /* 177865 */   GIR_EraseRootFromParent_Done,
     /* 177866 */ // Label 3942: @177866
     /* 177866 */ GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(177925), // Rule ID 11429 //
     /* 177871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 177874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 177877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 177881 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177885 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177889 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177892 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177896 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177900 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177902 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177909 */   // (uint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 177909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ256rm),
     /* 177912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177914 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177918 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177923 */   GIR_RootConstrainSelectedInstOperands,
     /* 177924 */   // GIR_Coverage, 11429,
     /* 177924 */   GIR_EraseRootFromParent_Done,
     /* 177925 */ // Label 3943: @177925
     /* 177925 */ GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(177951), // Rule ID 10930 //
     /* 177930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 177933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 177940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 177944 */   // (uint_to_fp:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTUDQ2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)
     /* 177944 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZ256rr),
     /* 177949 */   GIR_RootConstrainSelectedInstOperands,
     /* 177950 */   // GIR_Coverage, 10930,
     /* 177950 */   GIR_Done,
     /* 177951 */ // Label 3944: @177951
     /* 177951 */ GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(177981), // Rule ID 11425 //
     /* 177956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 177959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 177962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 177966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 177970 */   // (uint_to_fp:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTUQQ2PDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)
     /* 177970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ256rr),
     /* 177975 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177979 */   GIR_RootConstrainSelectedInstOperands,
     /* 177980 */   // GIR_Coverage, 11425,
     /* 177980 */   GIR_Done,
     /* 177981 */ // Label 3945: @177981
     /* 177981 */ GIM_Reject,
     /* 177982 */ // Label 3916: @177982
     /* 177982 */ GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(178041), // Rule ID 11483 //
     /* 177987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 177990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 177993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 177997 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178001 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178005 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178008 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178012 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178016 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178018 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178025 */   // (uint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PHZ256rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 178025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZ256rm),
     /* 178028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178030 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178034 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178039 */   GIR_RootConstrainSelectedInstOperands,
     /* 178040 */   // GIR_Coverage, 11483,
     /* 178040 */   GIR_EraseRootFromParent_Done,
     /* 178041 */ // Label 3946: @178041
     /* 178041 */ GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(178100), // Rule ID 14675 //
     /* 178046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 178049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178056 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178060 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178064 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178067 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178071 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178075 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178077 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178084 */   // (uint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUW2PHZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 178084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ128rm),
     /* 178087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178089 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178093 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178098 */   GIR_RootConstrainSelectedInstOperands,
     /* 178099 */   // GIR_Coverage, 14675,
     /* 178099 */   GIR_EraseRootFromParent_Done,
     /* 178100 */ // Label 3947: @178100
     /* 178100 */ GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(178159), // Rule ID 15137 //
     /* 178105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 178108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 178111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178115 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178119 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178123 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178126 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178130 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178134 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178136 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178143 */   // (uint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PHZrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 178143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PHZrm),
     /* 178146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178148 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178152 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178157 */   GIR_RootConstrainSelectedInstOperands,
     /* 178158 */   // GIR_Coverage, 15137,
     /* 178158 */   GIR_EraseRootFromParent_Done,
     /* 178159 */ // Label 3948: @178159
     /* 178159 */ GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(178189), // Rule ID 11479 //
     /* 178164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 178167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 178170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178178 */   // (uint_to_fp:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PHZ256rr:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)
     /* 178178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZ256rr),
     /* 178183 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178187 */   GIR_RootConstrainSelectedInstOperands,
     /* 178188 */   // GIR_Coverage, 11479,
     /* 178188 */   GIR_Done,
     /* 178189 */ // Label 3949: @178189
     /* 178189 */ GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(178219), // Rule ID 14671 //
     /* 178194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 178197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178208 */   // (uint_to_fp:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)  =>  (VCVTUW2PHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)
     /* 178208 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ128rr),
     /* 178213 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178217 */   GIR_RootConstrainSelectedInstOperands,
     /* 178218 */   // GIR_Coverage, 14671,
     /* 178218 */   GIR_Done,
     /* 178219 */ // Label 3950: @178219
     /* 178219 */ GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(178249), // Rule ID 15133 //
     /* 178224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 178227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 178230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 178238 */   // (uint_to_fp:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PHZrr:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)
     /* 178238 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PHZrr),
     /* 178243 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178247 */   GIR_RootConstrainSelectedInstOperands,
     /* 178248 */   // GIR_Coverage, 15133,
     /* 178248 */   GIR_Done,
     /* 178249 */ // Label 3951: @178249
     /* 178249 */ GIM_Reject,
     /* 178250 */ // Label 3917: @178250
     /* 178250 */ GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(178309), // Rule ID 10973 //
     /* 178255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 178258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 178261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178265 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178269 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178273 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178276 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178280 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178284 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178286 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178293 */   // (uint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 178293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ256rm),
     /* 178296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178298 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178302 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178307 */   GIR_RootConstrainSelectedInstOperands,
     /* 178308 */   // GIR_Coverage, 10973,
     /* 178308 */   GIR_EraseRootFromParent_Done,
     /* 178309 */ // Label 3952: @178309
     /* 178309 */ GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(178368), // Rule ID 11522 //
     /* 178314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 178317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 178320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178324 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178328 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178332 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178335 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178339 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178343 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178345 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178352 */   // (uint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PSZrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 178352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZrm),
     /* 178355 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178357 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178361 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178366 */   GIR_RootConstrainSelectedInstOperands,
     /* 178367 */   // GIR_Coverage, 11522,
     /* 178367 */   GIR_EraseRootFromParent_Done,
     /* 178368 */ // Label 3953: @178368
     /* 178368 */ GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(178398), // Rule ID 10969 //
     /* 178373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 178376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 178379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178387 */   // (uint_to_fp:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)
     /* 178387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ256rr),
     /* 178392 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178396 */   GIR_RootConstrainSelectedInstOperands,
     /* 178397 */   // GIR_Coverage, 10969,
     /* 178397 */   GIR_Done,
     /* 178398 */ // Label 3954: @178398
     /* 178398 */ GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(178428), // Rule ID 11518 //
     /* 178403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 178406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 178409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 178417 */   // (uint_to_fp:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PSZrr:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)
     /* 178417 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZrr),
     /* 178422 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178426 */   GIR_RootConstrainSelectedInstOperands,
     /* 178427 */   // GIR_Coverage, 11518,
     /* 178427 */   GIR_Done,
     /* 178428 */ // Label 3955: @178428
     /* 178428 */ GIM_Reject,
     /* 178429 */ // Label 3918: @178429
     /* 178429 */ GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(178488), // Rule ID 10910 //
     /* 178434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 178440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 178444 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178448 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178452 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178455 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178459 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178463 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178465 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178472 */   // (uint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 178472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZrm),
     /* 178475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178477 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178481 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178486 */   GIR_RootConstrainSelectedInstOperands,
     /* 178487 */   // GIR_Coverage, 10910,
     /* 178487 */   GIR_EraseRootFromParent_Done,
     /* 178488 */ // Label 3956: @178488
     /* 178488 */ GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(178547), // Rule ID 11402 //
     /* 178493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 178496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 178499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 178503 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178507 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178511 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178514 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178518 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178522 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178524 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178531 */   // (uint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 178531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZrm),
     /* 178534 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178536 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178540 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178545 */   GIR_RootConstrainSelectedInstOperands,
     /* 178546 */   // GIR_Coverage, 11402,
     /* 178546 */   GIR_EraseRootFromParent_Done,
     /* 178547 */ // Label 3957: @178547
     /* 178547 */ GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(178573), // Rule ID 10906 //
     /* 178552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 178558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 178562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178566 */   // (uint_to_fp:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)
     /* 178566 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZrr),
     /* 178571 */   GIR_RootConstrainSelectedInstOperands,
     /* 178572 */   // GIR_Coverage, 10906,
     /* 178572 */   GIR_Done,
     /* 178573 */ // Label 3958: @178573
     /* 178573 */ GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(178603), // Rule ID 11398 //
     /* 178578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 178581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 178584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 178588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 178592 */   // (uint_to_fp:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PDZrr:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)
     /* 178592 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZrr),
     /* 178597 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178601 */   GIR_RootConstrainSelectedInstOperands,
     /* 178602 */   // GIR_Coverage, 11398,
     /* 178602 */   GIR_Done,
     /* 178603 */ // Label 3959: @178603
     /* 178603 */ GIM_Reject,
     /* 178604 */ // Label 3919: @178604
     /* 178604 */ GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(178663), // Rule ID 11468 //
     /* 178609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 178612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 178615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178619 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178623 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178627 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178630 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178634 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178638 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178640 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178647 */   // (uint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PHZrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 178647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZrm),
     /* 178650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178652 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178656 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178661 */   GIR_RootConstrainSelectedInstOperands,
     /* 178662 */   // GIR_Coverage, 11468,
     /* 178662 */   GIR_EraseRootFromParent_Done,
     /* 178663 */ // Label 3960: @178663
     /* 178663 */ GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(178722), // Rule ID 14687 //
     /* 178668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 178671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 178674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178678 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178682 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178686 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178689 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178693 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178697 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178699 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178706 */   // (uint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUW2PHZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 178706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ256rm),
     /* 178709 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178711 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178715 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178720 */   GIR_RootConstrainSelectedInstOperands,
     /* 178721 */   // GIR_Coverage, 14687,
     /* 178721 */   GIR_EraseRootFromParent_Done,
     /* 178722 */ // Label 3961: @178722
     /* 178722 */ GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(178752), // Rule ID 11464 //
     /* 178727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 178730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 178733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 178741 */   // (uint_to_fp:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTUDQ2PHZrr:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)
     /* 178741 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZrr),
     /* 178746 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178750 */   GIR_RootConstrainSelectedInstOperands,
     /* 178751 */   // GIR_Coverage, 11464,
     /* 178751 */   GIR_Done,
     /* 178752 */ // Label 3962: @178752
     /* 178752 */ GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(178782), // Rule ID 14683 //
     /* 178757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 178760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 178763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 178771 */   // (uint_to_fp:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)  =>  (VCVTUW2PHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)
     /* 178771 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ256rr),
     /* 178776 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178780 */   GIR_RootConstrainSelectedInstOperands,
     /* 178781 */   // GIR_Coverage, 14683,
     /* 178781 */   GIR_Done,
     /* 178782 */ // Label 3963: @178782
     /* 178782 */ GIM_Reject,
     /* 178783 */ // Label 3920: @178783
     /* 178783 */ GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(178871),
     /* 178788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 178791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 178795 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(178847), // Rule ID 10946 //
     /* 178800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178811 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178814 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178818 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178831 */     // (uint_to_fp:{ *:[v16f32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 178831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZrm),
     /* 178834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178836 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178845 */     GIR_RootConstrainSelectedInstOperands,
     /* 178846 */     // GIR_Coverage, 10946,
     /* 178846 */     GIR_EraseRootFromParent_Done,
     /* 178847 */   // Label 3965: @178847
     /* 178847 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(178870), // Rule ID 10942 //
     /* 178852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 178859 */     // (uint_to_fp:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTUDQ2PSZrr:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)
     /* 178859 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZrr),
     /* 178864 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178868 */     GIR_RootConstrainSelectedInstOperands,
     /* 178869 */     // GIR_Coverage, 10942,
     /* 178869 */     GIR_Done,
     /* 178870 */   // Label 3966: @178870
     /* 178870 */   GIM_Reject,
     /* 178871 */ // Label 3964: @178871
     /* 178871 */ GIM_Reject,
     /* 178872 */ // Label 3921: @178872
     /* 178872 */ GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(178960),
     /* 178877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 178880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 178884 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(178936), // Rule ID 14660 //
     /* 178889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 178892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178900 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178903 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178907 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178920 */     // (uint_to_fp:{ *:[v32f16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUW2PHZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 178920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZrm),
     /* 178923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178925 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178934 */     GIR_RootConstrainSelectedInstOperands,
     /* 178935 */     // GIR_Coverage, 14660,
     /* 178935 */     GIR_EraseRootFromParent_Done,
     /* 178936 */   // Label 3968: @178936
     /* 178936 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(178959), // Rule ID 14656 //
     /* 178941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 178944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 178948 */     // (uint_to_fp:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)  =>  (VCVTUW2PHZrr:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)
     /* 178948 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZrr),
     /* 178953 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178957 */     GIR_RootConstrainSelectedInstOperands,
     /* 178958 */     // GIR_Coverage, 14656,
     /* 178958 */     GIR_Done,
     /* 178959 */   // Label 3969: @178959
     /* 178959 */   GIM_Reject,
     /* 178960 */ // Label 3967: @178960
     /* 178960 */ GIM_Reject,
     /* 178961 */ // Label 3922: @178961
     /* 178961 */ GIM_Reject,
     /* 178962 */ // Label 53: @178962
     /* 178962 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 3973*/ GIMT_Encode4(179084),
     /* 178973 */ /*GILLT_s32*//*Label 3970*/ GIMT_Encode4(178985),
     /* 178977 */ /*GILLT_s64*//*Label 3971*/ GIMT_Encode4(179018),
     /* 178981 */ /*GILLT_s80*//*Label 3972*/ GIMT_Encode4(179051),
     /* 178985 */ // Label 3970: @178985
     /* 178985 */ GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(179017), // Rule ID 1044 //
     /* 178990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 178993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 179000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 179004 */   // (fabs:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (ABS_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 179004 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp32),
     /* 179009 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 179015 */   GIR_RootConstrainSelectedInstOperands,
     /* 179016 */   // GIR_Coverage, 1044,
     /* 179016 */   GIR_Done,
     /* 179017 */ // Label 3974: @179017
     /* 179017 */ GIM_Reject,
     /* 179018 */ // Label 3971: @179018
     /* 179018 */ GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(179050), // Rule ID 1045 //
     /* 179023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 179026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 179029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 179033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 179037 */   // (fabs:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (ABS_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 179037 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp64),
     /* 179042 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 179048 */   GIR_RootConstrainSelectedInstOperands,
     /* 179049 */   // GIR_Coverage, 1045,
     /* 179049 */   GIR_Done,
     /* 179050 */ // Label 3975: @179050
     /* 179050 */ GIM_Reject,
     /* 179051 */ // Label 3972: @179051
     /* 179051 */ GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(179083), // Rule ID 1046 //
     /* 179056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 179059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 179062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 179066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 179070 */   // (fabs:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (ABS_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 179070 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp80),
     /* 179075 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 179081 */   GIR_RootConstrainSelectedInstOperands,
     /* 179082 */   // GIR_Coverage, 1046,
     /* 179082 */   GIR_Done,
     /* 179083 */ // Label 3976: @179083
     /* 179083 */ GIM_Reject,
     /* 179084 */ // Label 3973: @179084
     /* 179084 */ GIM_Reject,
     /* 179085 */ // Label 54: @179085
     /* 179085 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 3989*/ GIMT_Encode4(182405),
     /* 179096 */ /*GILLT_v2s64*//*Label 3977*/ GIMT_Encode4(179164), GIMT_Encode4(0),
     /* 179104 */ /*GILLT_v4s32*//*Label 3978*/ GIMT_Encode4(179493),
     /* 179108 */ /*GILLT_v4s64*//*Label 3979*/ GIMT_Encode4(179835), GIMT_Encode4(0),
     /* 179116 */ /*GILLT_v8s16*//*Label 3980*/ GIMT_Encode4(180152),
     /* 179120 */ /*GILLT_v8s32*//*Label 3981*/ GIMT_Encode4(180494),
     /* 179124 */ /*GILLT_v8s64*//*Label 3982*/ GIMT_Encode4(180809), GIMT_Encode4(0),
     /* 179132 */ /*GILLT_v16s8*//*Label 3983*/ GIMT_Encode4(180965),
     /* 179136 */ /*GILLT_v16s16*//*Label 3984*/ GIMT_Encode4(181307),
     /* 179140 */ /*GILLT_v16s32*//*Label 3985*/ GIMT_Encode4(181622), GIMT_Encode4(0),
     /* 179148 */ /*GILLT_v32s8*//*Label 3986*/ GIMT_Encode4(181778),
     /* 179152 */ /*GILLT_v32s16*//*Label 3987*/ GIMT_Encode4(182093), GIMT_Encode4(0),
     /* 179160 */ /*GILLT_v64s8*//*Label 3988*/ GIMT_Encode4(182249),
     /* 179164 */ // Label 3977: @179164
     /* 179164 */ GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(179492),
     /* 179169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 179172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179175 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(179237), // Rule ID 24074 //
     /* 179180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 179183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179195 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179198 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179202 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179219 */     // (smin:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMINSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 179219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ128rm),
     /* 179222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179224 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 179226 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 179230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179235 */     GIR_RootConstrainSelectedInstOperands,
     /* 179236 */     // GIR_Coverage, 24074,
     /* 179236 */     GIR_EraseRootFromParent_Done,
     /* 179237 */   // Label 3991: @179237
     /* 179237 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(179299), // Rule ID 5589 //
     /* 179242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 179245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 179257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179261 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179264 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179268 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179274 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179281 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 179281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ128rm),
     /* 179284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179286 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 179288 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 179292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179297 */     GIR_RootConstrainSelectedInstOperands,
     /* 179298 */     // GIR_Coverage, 5589,
     /* 179298 */     GIR_EraseRootFromParent_Done,
     /* 179299 */   // Label 3992: @179299
     /* 179299 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(179326), // Rule ID 5586 //
     /* 179304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 179307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179319 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMINSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 179319 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ128rr),
     /* 179324 */     GIR_RootConstrainSelectedInstOperands,
     /* 179325 */     // GIR_Coverage, 5586,
     /* 179325 */     GIR_Done,
     /* 179326 */   // Label 3993: @179326
     /* 179326 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(179491), // Rule ID 20013 //
     /* 179331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 179334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 179338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179346 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMINSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 179346 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 179349 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 179353 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 179360 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 179363 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 179367 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179372 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 179375 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 179379 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 179382 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 179387 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 179392 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 179397 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 179400 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 179404 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 179411 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 179414 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 179418 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179423 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 179426 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 179430 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 179433 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 179438 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 179443 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 179448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 179451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 179455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179460 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 179463 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 179466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 179468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 179471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179473 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 179480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 179485 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 179490 */     // GIR_Coverage, 20013,
     /* 179490 */     GIR_EraseRootFromParent_Done,
     /* 179491 */   // Label 3994: @179491
     /* 179491 */   GIM_Reject,
     /* 179492 */ // Label 3990: @179492
     /* 179492 */ GIM_Reject,
     /* 179493 */ // Label 3978: @179493
     /* 179493 */ GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(179834),
     /* 179498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179504 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(179566), // Rule ID 23498 //
     /* 179509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 179512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179524 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179527 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179531 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179548 */     // (smin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMINSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 179548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDrm),
     /* 179551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179553 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 179555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 179559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179564 */     GIR_RootConstrainSelectedInstOperands,
     /* 179565 */     // GIR_Coverage, 23498,
     /* 179565 */     GIR_EraseRootFromParent_Done,
     /* 179566 */   // Label 3996: @179566
     /* 179566 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(179628), // Rule ID 24056 //
     /* 179571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 179574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179586 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179589 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179593 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179603 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179610 */     // (smin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMINSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 179610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ128rm),
     /* 179613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179615 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 179617 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 179621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179626 */     GIR_RootConstrainSelectedInstOperands,
     /* 179627 */     // GIR_Coverage, 24056,
     /* 179627 */     GIR_EraseRootFromParent_Done,
     /* 179628 */   // Label 3997: @179628
     /* 179628 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(179690), // Rule ID 3185 //
     /* 179633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 179636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 179648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179652 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179655 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179659 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179672 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 179672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDrm),
     /* 179675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179677 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 179679 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 179683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179688 */     GIR_RootConstrainSelectedInstOperands,
     /* 179689 */     // GIR_Coverage, 3185,
     /* 179689 */     GIR_EraseRootFromParent_Done,
     /* 179690 */   // Label 3998: @179690
     /* 179690 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(179752), // Rule ID 5562 //
     /* 179695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 179698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 179710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179714 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179717 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179721 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179727 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179734 */     // (smin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 179734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ128rm),
     /* 179737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179739 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 179741 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 179745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179750 */     GIR_RootConstrainSelectedInstOperands,
     /* 179751 */     // GIR_Coverage, 5562,
     /* 179751 */     GIR_EraseRootFromParent_Done,
     /* 179752 */   // Label 3999: @179752
     /* 179752 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(179779), // Rule ID 3184 //
     /* 179757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 179760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179772 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMINSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 179772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDrr),
     /* 179777 */     GIR_RootConstrainSelectedInstOperands,
     /* 179778 */     // GIR_Coverage, 3184,
     /* 179778 */     GIR_Done,
     /* 179779 */   // Label 4000: @179779
     /* 179779 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(179806), // Rule ID 3222 //
     /* 179784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 179787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179799 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMINSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 179799 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSDrr),
     /* 179804 */     GIR_RootConstrainSelectedInstOperands,
     /* 179805 */     // GIR_Coverage, 3222,
     /* 179805 */     GIR_Done,
     /* 179806 */   // Label 4001: @179806
     /* 179806 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(179833), // Rule ID 5559 //
     /* 179811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 179814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179826 */     // (smin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMINSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 179826 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ128rr),
     /* 179831 */     GIR_RootConstrainSelectedInstOperands,
     /* 179832 */     // GIR_Coverage, 5559,
     /* 179832 */     GIR_Done,
     /* 179833 */   // Label 4002: @179833
     /* 179833 */   GIM_Reject,
     /* 179834 */ // Label 3995: @179834
     /* 179834 */ GIM_Reject,
     /* 179835 */ // Label 3979: @179835
     /* 179835 */ GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(180151),
     /* 179840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 179843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 179846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179850 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(179908), // Rule ID 24068 //
     /* 179855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 179858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179866 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179869 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179873 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179883 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179890 */     // (smin:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMINSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 179890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ256rm),
     /* 179893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179895 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 179897 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 179901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179906 */     GIR_RootConstrainSelectedInstOperands,
     /* 179907 */     // GIR_Coverage, 24068,
     /* 179907 */     GIR_EraseRootFromParent_Done,
     /* 179908 */   // Label 4004: @179908
     /* 179908 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(179966), // Rule ID 5580 //
     /* 179913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 179916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 179924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179928 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179931 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179935 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179948 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 179948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ256rm),
     /* 179951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179953 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 179955 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 179959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179964 */     GIR_RootConstrainSelectedInstOperands,
     /* 179965 */     // GIR_Coverage, 5580,
     /* 179965 */     GIR_EraseRootFromParent_Done,
     /* 179966 */   // Label 4005: @179966
     /* 179966 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(179989), // Rule ID 5577 //
     /* 179971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 179974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179982 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMINSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 179982 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ256rr),
     /* 179987 */     GIR_RootConstrainSelectedInstOperands,
     /* 179988 */     // GIR_Coverage, 5577,
     /* 179988 */     GIR_Done,
     /* 179989 */   // Label 4006: @179989
     /* 179989 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(180150), // Rule ID 20011 //
     /* 179994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 179997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180005 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMINSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 180005 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 180008 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180012 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 180019 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 180022 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 180026 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180031 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 180034 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 180038 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 180041 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 180046 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 180051 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 180056 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 180059 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180063 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 180070 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 180073 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 180077 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180082 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 180085 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 180089 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 180092 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 180097 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 180102 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 180107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 180110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 180114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180119 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 180122 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 180125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 180130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180132 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 180139 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 180144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 180149 */     // GIR_Coverage, 20011,
     /* 180149 */     GIR_EraseRootFromParent_Done,
     /* 180150 */   // Label 4007: @180150
     /* 180150 */   GIM_Reject,
     /* 180151 */ // Label 4003: @180151
     /* 180151 */ GIM_Reject,
     /* 180152 */ // Label 3980: @180152
     /* 180152 */ GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(180493),
     /* 180157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 180160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 180163 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(180225), // Rule ID 23462 //
     /* 180168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 180171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180183 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180186 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180190 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180207 */     // (smin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMINSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWrm),
     /* 180210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180212 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 180214 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180223 */     GIR_RootConstrainSelectedInstOperands,
     /* 180224 */     // GIR_Coverage, 23462,
     /* 180224 */     GIR_EraseRootFromParent_Done,
     /* 180225 */   // Label 4009: @180225
     /* 180225 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(180287), // Rule ID 24041 //
     /* 180230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 180233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180245 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180248 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180252 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180269 */     // (smin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMINSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ128rm),
     /* 180272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180274 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 180276 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180285 */     GIR_RootConstrainSelectedInstOperands,
     /* 180286 */     // GIR_Coverage, 24041,
     /* 180286 */     GIR_EraseRootFromParent_Done,
     /* 180287 */   // Label 4010: @180287
     /* 180287 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(180349), // Rule ID 2642 //
     /* 180292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 180295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 180307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180311 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180314 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180318 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180324 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180331 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWrm),
     /* 180334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180336 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 180338 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180347 */     GIR_RootConstrainSelectedInstOperands,
     /* 180348 */     // GIR_Coverage, 2642,
     /* 180348 */     GIR_EraseRootFromParent_Done,
     /* 180349 */   // Label 4011: @180349
     /* 180349 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(180411), // Rule ID 5538 //
     /* 180354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 180357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 180369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180373 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180376 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180380 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180393 */     // (smin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ128rm),
     /* 180396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180398 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 180400 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180409 */     GIR_RootConstrainSelectedInstOperands,
     /* 180410 */     // GIR_Coverage, 5538,
     /* 180410 */     GIR_EraseRootFromParent_Done,
     /* 180411 */   // Label 4012: @180411
     /* 180411 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(180438), // Rule ID 2641 //
     /* 180416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 180419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180431 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMINSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 180431 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWrr),
     /* 180436 */     GIR_RootConstrainSelectedInstOperands,
     /* 180437 */     // GIR_Coverage, 2641,
     /* 180437 */     GIR_Done,
     /* 180438 */   // Label 4013: @180438
     /* 180438 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(180465), // Rule ID 2643 //
     /* 180443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 180446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180458 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMINSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 180458 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSWrr),
     /* 180463 */     GIR_RootConstrainSelectedInstOperands,
     /* 180464 */     // GIR_Coverage, 2643,
     /* 180464 */     GIR_Done,
     /* 180465 */   // Label 4014: @180465
     /* 180465 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(180492), // Rule ID 5535 //
     /* 180470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 180473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 180485 */     // (smin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMINSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 180485 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ128rr),
     /* 180490 */     GIR_RootConstrainSelectedInstOperands,
     /* 180491 */     // GIR_Coverage, 5535,
     /* 180491 */     GIR_Done,
     /* 180492 */   // Label 4015: @180492
     /* 180492 */   GIM_Reject,
     /* 180493 */ // Label 4008: @180493
     /* 180493 */ GIM_Reject,
     /* 180494 */ // Label 3981: @180494
     /* 180494 */ GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(180808),
     /* 180499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 180502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 180505 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(180567), // Rule ID 23507 //
     /* 180510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 180513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 180517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180525 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180528 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180532 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 180540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180549 */     // (smin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMINSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDYrm),
     /* 180552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180554 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 180556 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180565 */     GIR_RootConstrainSelectedInstOperands,
     /* 180566 */     // GIR_Coverage, 23507,
     /* 180566 */     GIR_EraseRootFromParent_Done,
     /* 180567 */   // Label 4017: @180567
     /* 180567 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(180629), // Rule ID 24050 //
     /* 180572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 180575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180587 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180590 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180594 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180604 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180611 */     // (smin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMINSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ256rm),
     /* 180614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180616 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 180618 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180627 */     GIR_RootConstrainSelectedInstOperands,
     /* 180628 */     // GIR_Coverage, 24050,
     /* 180628 */     GIR_EraseRootFromParent_Done,
     /* 180629 */   // Label 4018: @180629
     /* 180629 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(180691), // Rule ID 3203 //
     /* 180634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 180637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 180641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 180645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 180649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180653 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180656 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180660 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180673 */     // (smin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDYrm),
     /* 180676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180678 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 180680 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180689 */     GIR_RootConstrainSelectedInstOperands,
     /* 180690 */     // GIR_Coverage, 3203,
     /* 180690 */     GIR_EraseRootFromParent_Done,
     /* 180691 */   // Label 4019: @180691
     /* 180691 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(180753), // Rule ID 5553 //
     /* 180696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 180699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 180711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180715 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180718 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180722 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180728 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180735 */     // (smin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ256rm),
     /* 180738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180740 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 180742 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180751 */     GIR_RootConstrainSelectedInstOperands,
     /* 180752 */     // GIR_Coverage, 5553,
     /* 180752 */     GIR_EraseRootFromParent_Done,
     /* 180753 */   // Label 4020: @180753
     /* 180753 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(180780), // Rule ID 3202 //
     /* 180758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 180761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 180765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 180769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 180773 */     // (smin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMINSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 180773 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDYrr),
     /* 180778 */     GIR_RootConstrainSelectedInstOperands,
     /* 180779 */     // GIR_Coverage, 3202,
     /* 180779 */     GIR_Done,
     /* 180780 */   // Label 4021: @180780
     /* 180780 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(180807), // Rule ID 5550 //
     /* 180785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 180788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180800 */     // (smin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMINSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 180800 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ256rr),
     /* 180805 */     GIR_RootConstrainSelectedInstOperands,
     /* 180806 */     // GIR_Coverage, 5550,
     /* 180806 */     GIR_Done,
     /* 180807 */   // Label 4022: @180807
     /* 180807 */   GIM_Reject,
     /* 180808 */ // Label 4016: @180808
     /* 180808 */ GIM_Reject,
     /* 180809 */ // Label 3982: @180809
     /* 180809 */ GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(180964),
     /* 180814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 180817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 180820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180824 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(180882), // Rule ID 24062 //
     /* 180829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 180832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180840 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180843 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180847 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180864 */     // (smin:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMINSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrm),
     /* 180867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180869 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 180871 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180880 */     GIR_RootConstrainSelectedInstOperands,
     /* 180881 */     // GIR_Coverage, 24062,
     /* 180881 */     GIR_EraseRootFromParent_Done,
     /* 180882 */   // Label 4024: @180882
     /* 180882 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(180940), // Rule ID 5571 //
     /* 180887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 180890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 180898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180902 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180905 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180909 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180922 */     // (smin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 180922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrm),
     /* 180925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180927 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 180929 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 180933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180938 */     GIR_RootConstrainSelectedInstOperands,
     /* 180939 */     // GIR_Coverage, 5571,
     /* 180939 */     GIR_EraseRootFromParent_Done,
     /* 180940 */   // Label 4025: @180940
     /* 180940 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(180963), // Rule ID 5568 //
     /* 180945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 180948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180956 */     // (smin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMINSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 180956 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 180961 */     GIR_RootConstrainSelectedInstOperands,
     /* 180962 */     // GIR_Coverage, 5568,
     /* 180962 */     GIR_Done,
     /* 180963 */   // Label 4026: @180963
     /* 180963 */   GIM_Reject,
     /* 180964 */ // Label 4023: @180964
     /* 180964 */ GIM_Reject,
     /* 180965 */ // Label 3983: @180965
     /* 180965 */ GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(181306),
     /* 180970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 180973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 180976 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(181038), // Rule ID 23503 //
     /* 180981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 180984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 180988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180996 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180999 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181003 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181020 */     // (smin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMINSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBrm),
     /* 181023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181025 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 181027 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181036 */     GIR_RootConstrainSelectedInstOperands,
     /* 181037 */     // GIR_Coverage, 23503,
     /* 181037 */     GIR_EraseRootFromParent_Done,
     /* 181038 */   // Label 4028: @181038
     /* 181038 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(181100), // Rule ID 24032 //
     /* 181043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 181046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181058 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181061 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181065 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181082 */     // (smin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMINSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ128rm),
     /* 181085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181087 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 181089 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181098 */     GIR_RootConstrainSelectedInstOperands,
     /* 181099 */     // GIR_Coverage, 24032,
     /* 181099 */     GIR_EraseRootFromParent_Done,
     /* 181100 */   // Label 4029: @181100
     /* 181100 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(181162), // Rule ID 3195 //
     /* 181105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 181108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 181120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181124 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181127 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181131 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181144 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBrm),
     /* 181147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181149 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 181151 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181160 */     GIR_RootConstrainSelectedInstOperands,
     /* 181161 */     // GIR_Coverage, 3195,
     /* 181161 */     GIR_EraseRootFromParent_Done,
     /* 181162 */   // Label 4030: @181162
     /* 181162 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(181224), // Rule ID 5520 //
     /* 181167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 181170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 181182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181186 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181189 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181193 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181206 */     // (smin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ128rm),
     /* 181209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181211 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 181213 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181222 */     GIR_RootConstrainSelectedInstOperands,
     /* 181223 */     // GIR_Coverage, 5520,
     /* 181223 */     GIR_EraseRootFromParent_Done,
     /* 181224 */   // Label 4031: @181224
     /* 181224 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(181251), // Rule ID 3194 //
     /* 181229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 181232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181244 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMINSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 181244 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBrr),
     /* 181249 */     GIR_RootConstrainSelectedInstOperands,
     /* 181250 */     // GIR_Coverage, 3194,
     /* 181250 */     GIR_Done,
     /* 181251 */   // Label 4032: @181251
     /* 181251 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(181278), // Rule ID 3220 //
     /* 181256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 181259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 181271 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMINSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 181271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSBrr),
     /* 181276 */     GIR_RootConstrainSelectedInstOperands,
     /* 181277 */     // GIR_Coverage, 3220,
     /* 181277 */     GIR_Done,
     /* 181278 */   // Label 4033: @181278
     /* 181278 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(181305), // Rule ID 5517 //
     /* 181283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 181286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181298 */     // (smin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMINSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 181298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ128rr),
     /* 181303 */     GIR_RootConstrainSelectedInstOperands,
     /* 181304 */     // GIR_Coverage, 5517,
     /* 181304 */     GIR_Done,
     /* 181305 */   // Label 4034: @181305
     /* 181305 */   GIM_Reject,
     /* 181306 */ // Label 4027: @181306
     /* 181306 */ GIM_Reject,
     /* 181307 */ // Label 3984: @181307
     /* 181307 */ GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(181621),
     /* 181312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 181315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 181318 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(181380), // Rule ID 23464 //
     /* 181323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 181326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181338 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181341 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181345 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181362 */     // (smin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMINSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWYrm),
     /* 181365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181367 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 181369 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181378 */     GIR_RootConstrainSelectedInstOperands,
     /* 181379 */     // GIR_Coverage, 23464,
     /* 181379 */     GIR_EraseRootFromParent_Done,
     /* 181380 */   // Label 4036: @181380
     /* 181380 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(181442), // Rule ID 24038 //
     /* 181385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 181388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181400 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181403 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181407 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181424 */     // (smin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMINSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ256rm),
     /* 181427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181429 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 181431 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181440 */     GIR_RootConstrainSelectedInstOperands,
     /* 181441 */     // GIR_Coverage, 24038,
     /* 181441 */     GIR_EraseRootFromParent_Done,
     /* 181442 */   // Label 4037: @181442
     /* 181442 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(181504), // Rule ID 2646 //
     /* 181447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 181450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 181462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181466 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181469 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181473 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181486 */     // (smin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWYrm),
     /* 181489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181491 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 181493 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181502 */     GIR_RootConstrainSelectedInstOperands,
     /* 181503 */     // GIR_Coverage, 2646,
     /* 181503 */     GIR_EraseRootFromParent_Done,
     /* 181504 */   // Label 4038: @181504
     /* 181504 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(181566), // Rule ID 5532 //
     /* 181509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 181512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 181524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181528 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181531 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181535 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181548 */     // (smin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ256rm),
     /* 181551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181553 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 181555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181564 */     GIR_RootConstrainSelectedInstOperands,
     /* 181565 */     // GIR_Coverage, 5532,
     /* 181565 */     GIR_EraseRootFromParent_Done,
     /* 181566 */   // Label 4039: @181566
     /* 181566 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(181593), // Rule ID 2645 //
     /* 181571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 181574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181586 */     // (smin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMINSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 181586 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWYrr),
     /* 181591 */     GIR_RootConstrainSelectedInstOperands,
     /* 181592 */     // GIR_Coverage, 2645,
     /* 181592 */     GIR_Done,
     /* 181593 */   // Label 4040: @181593
     /* 181593 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(181620), // Rule ID 5529 //
     /* 181598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 181601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181613 */     // (smin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMINSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 181613 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ256rr),
     /* 181618 */     GIR_RootConstrainSelectedInstOperands,
     /* 181619 */     // GIR_Coverage, 5529,
     /* 181619 */     GIR_Done,
     /* 181620 */   // Label 4041: @181620
     /* 181620 */   GIM_Reject,
     /* 181621 */ // Label 4035: @181621
     /* 181621 */ GIM_Reject,
     /* 181622 */ // Label 3985: @181622
     /* 181622 */ GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(181777),
     /* 181627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 181630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 181633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 181637 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(181695), // Rule ID 24044 //
     /* 181642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181653 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181656 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181660 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 181668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181670 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181677 */     // (smin:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMINSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZrm),
     /* 181680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181682 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 181684 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181693 */     GIR_RootConstrainSelectedInstOperands,
     /* 181694 */     // GIR_Coverage, 24044,
     /* 181694 */     GIR_EraseRootFromParent_Done,
     /* 181695 */   // Label 4043: @181695
     /* 181695 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(181753), // Rule ID 5544 //
     /* 181700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 181707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 181711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181715 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181718 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181722 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181728 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181735 */     // (smin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZrm),
     /* 181738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181740 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 181742 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181751 */     GIR_RootConstrainSelectedInstOperands,
     /* 181752 */     // GIR_Coverage, 5544,
     /* 181752 */     GIR_EraseRootFromParent_Done,
     /* 181753 */   // Label 4044: @181753
     /* 181753 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(181776), // Rule ID 5541 //
     /* 181758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 181765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 181769 */     // (smin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMINSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 181769 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZrr),
     /* 181774 */     GIR_RootConstrainSelectedInstOperands,
     /* 181775 */     // GIR_Coverage, 5541,
     /* 181775 */     GIR_Done,
     /* 181776 */   // Label 4045: @181776
     /* 181776 */   GIM_Reject,
     /* 181777 */ // Label 4042: @181777
     /* 181777 */ GIM_Reject,
     /* 181778 */ // Label 3986: @181778
     /* 181778 */ GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(182092),
     /* 181783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 181786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 181789 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(181851), // Rule ID 23512 //
     /* 181794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 181797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181809 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181812 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181816 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181826 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181833 */     // (smin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMINSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBYrm),
     /* 181836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181838 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 181840 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181849 */     GIR_RootConstrainSelectedInstOperands,
     /* 181850 */     // GIR_Coverage, 23512,
     /* 181850 */     GIR_EraseRootFromParent_Done,
     /* 181851 */   // Label 4047: @181851
     /* 181851 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(181913), // Rule ID 24029 //
     /* 181856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 181859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181871 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181874 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181878 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181895 */     // (smin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMINSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ256rm),
     /* 181898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181900 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 181902 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181911 */     GIR_RootConstrainSelectedInstOperands,
     /* 181912 */     // GIR_Coverage, 24029,
     /* 181912 */     GIR_EraseRootFromParent_Done,
     /* 181913 */   // Label 4048: @181913
     /* 181913 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(181975), // Rule ID 3213 //
     /* 181918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 181921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 181929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 181933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181937 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181940 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181944 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181957 */     // (smin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 181957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBYrm),
     /* 181960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181962 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 181964 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 181968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181973 */     GIR_RootConstrainSelectedInstOperands,
     /* 181974 */     // GIR_Coverage, 3213,
     /* 181974 */     GIR_EraseRootFromParent_Done,
     /* 181975 */   // Label 4049: @181975
     /* 181975 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(182037), // Rule ID 5514 //
     /* 181980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 181983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 181995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181999 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182002 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182006 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182019 */     // (smin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ256rm),
     /* 182022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182024 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 182026 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182035 */     GIR_RootConstrainSelectedInstOperands,
     /* 182036 */     // GIR_Coverage, 5514,
     /* 182036 */     GIR_EraseRootFromParent_Done,
     /* 182037 */   // Label 4050: @182037
     /* 182037 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(182064), // Rule ID 3212 //
     /* 182042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 182045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 182057 */     // (smin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMINSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 182057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBYrr),
     /* 182062 */     GIR_RootConstrainSelectedInstOperands,
     /* 182063 */     // GIR_Coverage, 3212,
     /* 182063 */     GIR_Done,
     /* 182064 */   // Label 4051: @182064
     /* 182064 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(182091), // Rule ID 5511 //
     /* 182069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 182072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182084 */     // (smin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMINSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 182084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ256rr),
     /* 182089 */     GIR_RootConstrainSelectedInstOperands,
     /* 182090 */     // GIR_Coverage, 5511,
     /* 182090 */     GIR_Done,
     /* 182091 */   // Label 4052: @182091
     /* 182091 */   GIM_Reject,
     /* 182092 */ // Label 4046: @182092
     /* 182092 */ GIM_Reject,
     /* 182093 */ // Label 3987: @182093
     /* 182093 */ GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(182248),
     /* 182098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 182101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 182104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182108 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(182166), // Rule ID 24035 //
     /* 182113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 182116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182124 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182127 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182131 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182148 */     // (smin:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMINSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZrm),
     /* 182151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182153 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 182155 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182164 */     GIR_RootConstrainSelectedInstOperands,
     /* 182165 */     // GIR_Coverage, 24035,
     /* 182165 */     GIR_EraseRootFromParent_Done,
     /* 182166 */   // Label 4054: @182166
     /* 182166 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(182224), // Rule ID 5526 //
     /* 182171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 182174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 182182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182186 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182189 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182193 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182206 */     // (smin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZrm),
     /* 182209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182211 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 182213 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182222 */     GIR_RootConstrainSelectedInstOperands,
     /* 182223 */     // GIR_Coverage, 5526,
     /* 182223 */     GIR_EraseRootFromParent_Done,
     /* 182224 */   // Label 4055: @182224
     /* 182224 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(182247), // Rule ID 5523 //
     /* 182229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 182232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182240 */     // (smin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMINSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 182240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZrr),
     /* 182245 */     GIR_RootConstrainSelectedInstOperands,
     /* 182246 */     // GIR_Coverage, 5523,
     /* 182246 */     GIR_Done,
     /* 182247 */   // Label 4056: @182247
     /* 182247 */   GIM_Reject,
     /* 182248 */ // Label 4053: @182248
     /* 182248 */ GIM_Reject,
     /* 182249 */ // Label 3988: @182249
     /* 182249 */ GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(182404),
     /* 182254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 182257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 182260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182264 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(182322), // Rule ID 24026 //
     /* 182269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 182272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182280 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182283 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182287 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182304 */     // (smin:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMINSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZrm),
     /* 182307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182309 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 182311 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182320 */     GIR_RootConstrainSelectedInstOperands,
     /* 182321 */     // GIR_Coverage, 24026,
     /* 182321 */     GIR_EraseRootFromParent_Done,
     /* 182322 */   // Label 4058: @182322
     /* 182322 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(182380), // Rule ID 5508 //
     /* 182327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 182330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 182338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182342 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182345 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182349 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182362 */     // (smin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZrm),
     /* 182365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182367 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 182369 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182378 */     GIR_RootConstrainSelectedInstOperands,
     /* 182379 */     // GIR_Coverage, 5508,
     /* 182379 */     GIR_EraseRootFromParent_Done,
     /* 182380 */   // Label 4059: @182380
     /* 182380 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(182403), // Rule ID 5505 //
     /* 182385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 182388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182396 */     // (smin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMINSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 182396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZrr),
     /* 182401 */     GIR_RootConstrainSelectedInstOperands,
     /* 182402 */     // GIR_Coverage, 5505,
     /* 182402 */     GIR_Done,
     /* 182403 */   // Label 4060: @182403
     /* 182403 */   GIM_Reject,
     /* 182404 */ // Label 4057: @182404
     /* 182404 */ GIM_Reject,
     /* 182405 */ // Label 3989: @182405
     /* 182405 */ GIM_Reject,
     /* 182406 */ // Label 55: @182406
     /* 182406 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4073*/ GIMT_Encode4(185726),
     /* 182417 */ /*GILLT_v2s64*//*Label 4061*/ GIMT_Encode4(182485), GIMT_Encode4(0),
     /* 182425 */ /*GILLT_v4s32*//*Label 4062*/ GIMT_Encode4(182814),
     /* 182429 */ /*GILLT_v4s64*//*Label 4063*/ GIMT_Encode4(183156), GIMT_Encode4(0),
     /* 182437 */ /*GILLT_v8s16*//*Label 4064*/ GIMT_Encode4(183473),
     /* 182441 */ /*GILLT_v8s32*//*Label 4065*/ GIMT_Encode4(183815),
     /* 182445 */ /*GILLT_v8s64*//*Label 4066*/ GIMT_Encode4(184130), GIMT_Encode4(0),
     /* 182453 */ /*GILLT_v16s8*//*Label 4067*/ GIMT_Encode4(184286),
     /* 182457 */ /*GILLT_v16s16*//*Label 4068*/ GIMT_Encode4(184628),
     /* 182461 */ /*GILLT_v16s32*//*Label 4069*/ GIMT_Encode4(184943), GIMT_Encode4(0),
     /* 182469 */ /*GILLT_v32s8*//*Label 4070*/ GIMT_Encode4(185099),
     /* 182473 */ /*GILLT_v32s16*//*Label 4071*/ GIMT_Encode4(185414), GIMT_Encode4(0),
     /* 182481 */ /*GILLT_v64s8*//*Label 4072*/ GIMT_Encode4(185570),
     /* 182485 */ // Label 4061: @182485
     /* 182485 */ GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(182813),
     /* 182490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 182493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 182496 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(182558), // Rule ID 23966 //
     /* 182501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 182504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182516 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182519 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182523 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182540 */     // (smax:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMAXSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ128rm),
     /* 182543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182545 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 182547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182556 */     GIR_RootConstrainSelectedInstOperands,
     /* 182557 */     // GIR_Coverage, 23966,
     /* 182557 */     GIR_EraseRootFromParent_Done,
     /* 182558 */   // Label 4075: @182558
     /* 182558 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(182620), // Rule ID 5409 //
     /* 182563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 182566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 182578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182582 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182585 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182589 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182602 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ128rm),
     /* 182605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182607 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 182609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182618 */     GIR_RootConstrainSelectedInstOperands,
     /* 182619 */     // GIR_Coverage, 5409,
     /* 182619 */     GIR_EraseRootFromParent_Done,
     /* 182620 */   // Label 4076: @182620
     /* 182620 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(182647), // Rule ID 5406 //
     /* 182625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 182628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182640 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMAXSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 182640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ128rr),
     /* 182645 */     GIR_RootConstrainSelectedInstOperands,
     /* 182646 */     // GIR_Coverage, 5406,
     /* 182646 */     GIR_Done,
     /* 182647 */   // Label 4077: @182647
     /* 182647 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(182812), // Rule ID 20009 //
     /* 182652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 182655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 182659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182667 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMAXSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 182667 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 182670 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182674 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 182681 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 182684 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182688 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182693 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 182696 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 182700 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 182703 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 182708 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 182713 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 182718 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 182721 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182725 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 182732 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 182735 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182739 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182744 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 182747 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 182751 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 182754 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 182759 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 182764 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 182769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 182772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 182776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182781 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 182784 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 182787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182794 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 182801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 182806 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 182811 */     // GIR_Coverage, 20009,
     /* 182811 */     GIR_EraseRootFromParent_Done,
     /* 182812 */   // Label 4078: @182812
     /* 182812 */   GIM_Reject,
     /* 182813 */ // Label 4074: @182813
     /* 182813 */ GIM_Reject,
     /* 182814 */ // Label 4062: @182814
     /* 182814 */ GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(183155),
     /* 182819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 182822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 182825 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(182887), // Rule ID 23500 //
     /* 182830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 182833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 182837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182845 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182848 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182852 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 182860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182869 */     // (smax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMAXSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDrm),
     /* 182872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182874 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 182876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182885 */     GIR_RootConstrainSelectedInstOperands,
     /* 182886 */     // GIR_Coverage, 23500,
     /* 182886 */     GIR_EraseRootFromParent_Done,
     /* 182887 */   // Label 4080: @182887
     /* 182887 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(182949), // Rule ID 23948 //
     /* 182892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 182895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182907 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182910 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182914 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182924 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182931 */     // (smax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMAXSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ128rm),
     /* 182934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182936 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 182938 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 182942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182947 */     GIR_RootConstrainSelectedInstOperands,
     /* 182948 */     // GIR_Coverage, 23948,
     /* 182948 */     GIR_EraseRootFromParent_Done,
     /* 182949 */   // Label 4081: @182949
     /* 182949 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(183011), // Rule ID 3189 //
     /* 182954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 182957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 182961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 182965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 182969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182973 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182976 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182980 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182986 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182993 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 182993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDrm),
     /* 182996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182998 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183000 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183009 */     GIR_RootConstrainSelectedInstOperands,
     /* 183010 */     // GIR_Coverage, 3189,
     /* 183010 */     GIR_EraseRootFromParent_Done,
     /* 183011 */   // Label 4082: @183011
     /* 183011 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(183073), // Rule ID 5382 //
     /* 183016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183035 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183038 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183042 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183048 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183055 */     // (smax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ128rm),
     /* 183058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183060 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183062 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183071 */     GIR_RootConstrainSelectedInstOperands,
     /* 183072 */     // GIR_Coverage, 5382,
     /* 183072 */     GIR_EraseRootFromParent_Done,
     /* 183073 */   // Label 4083: @183073
     /* 183073 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(183100), // Rule ID 3188 //
     /* 183078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 183081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183093 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMAXSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 183093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDrr),
     /* 183098 */     GIR_RootConstrainSelectedInstOperands,
     /* 183099 */     // GIR_Coverage, 3188,
     /* 183099 */     GIR_Done,
     /* 183100 */   // Label 4084: @183100
     /* 183100 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(183127), // Rule ID 3230 //
     /* 183105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 183108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183120 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMAXSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 183120 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSDrr),
     /* 183125 */     GIR_RootConstrainSelectedInstOperands,
     /* 183126 */     // GIR_Coverage, 3230,
     /* 183126 */     GIR_Done,
     /* 183127 */   // Label 4085: @183127
     /* 183127 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(183154), // Rule ID 5379 //
     /* 183132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183147 */     // (smax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMAXSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 183147 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ128rr),
     /* 183152 */     GIR_RootConstrainSelectedInstOperands,
     /* 183153 */     // GIR_Coverage, 5379,
     /* 183153 */     GIR_Done,
     /* 183154 */   // Label 4086: @183154
     /* 183154 */   GIM_Reject,
     /* 183155 */ // Label 4079: @183155
     /* 183155 */ GIM_Reject,
     /* 183156 */ // Label 4063: @183156
     /* 183156 */ GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(183472),
     /* 183161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 183164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 183167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183171 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(183229), // Rule ID 23960 //
     /* 183176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183187 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183190 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183194 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183211 */     // (smax:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMAXSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ256rm),
     /* 183214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183216 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183218 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183227 */     GIR_RootConstrainSelectedInstOperands,
     /* 183228 */     // GIR_Coverage, 23960,
     /* 183228 */     GIR_EraseRootFromParent_Done,
     /* 183229 */   // Label 4088: @183229
     /* 183229 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(183287), // Rule ID 5400 //
     /* 183234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183249 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183252 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183256 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183269 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ256rm),
     /* 183272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183274 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183276 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183285 */     GIR_RootConstrainSelectedInstOperands,
     /* 183286 */     // GIR_Coverage, 5400,
     /* 183286 */     GIR_EraseRootFromParent_Done,
     /* 183287 */   // Label 4089: @183287
     /* 183287 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(183310), // Rule ID 5397 //
     /* 183292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183303 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMAXSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 183303 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ256rr),
     /* 183308 */     GIR_RootConstrainSelectedInstOperands,
     /* 183309 */     // GIR_Coverage, 5397,
     /* 183309 */     GIR_Done,
     /* 183310 */   // Label 4090: @183310
     /* 183310 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(183471), // Rule ID 20007 //
     /* 183315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 183318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183326 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMAXSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 183326 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 183329 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183333 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 183340 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 183343 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183347 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183352 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 183355 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 183359 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 183362 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 183367 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183372 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 183377 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 183380 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183384 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 183391 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 183394 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183398 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183403 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 183406 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 183410 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 183413 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 183418 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183423 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 183428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 183431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 183435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183440 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 183443 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 183446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183453 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 183460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 183465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183470 */     // GIR_Coverage, 20007,
     /* 183470 */     GIR_EraseRootFromParent_Done,
     /* 183471 */   // Label 4091: @183471
     /* 183471 */   GIM_Reject,
     /* 183472 */ // Label 4087: @183472
     /* 183472 */ GIM_Reject,
     /* 183473 */ // Label 4064: @183473
     /* 183473 */ GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(183814),
     /* 183478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 183481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 183484 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(183546), // Rule ID 23468 //
     /* 183489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 183492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183504 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183507 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183511 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183521 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183528 */     // (smax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMAXSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWrm),
     /* 183531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183533 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183535 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183544 */     GIR_RootConstrainSelectedInstOperands,
     /* 183545 */     // GIR_Coverage, 23468,
     /* 183545 */     GIR_EraseRootFromParent_Done,
     /* 183546 */   // Label 4093: @183546
     /* 183546 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(183608), // Rule ID 23933 //
     /* 183551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 183554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183566 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183569 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183573 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183590 */     // (smax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMAXSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ128rm),
     /* 183593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183595 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183597 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183606 */     GIR_RootConstrainSelectedInstOperands,
     /* 183607 */     // GIR_Coverage, 23933,
     /* 183607 */     GIR_EraseRootFromParent_Done,
     /* 183608 */   // Label 4094: @183608
     /* 183608 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(183670), // Rule ID 2654 //
     /* 183613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 183616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183632 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183635 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183639 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183652 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWrm),
     /* 183655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183657 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183659 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183668 */     GIR_RootConstrainSelectedInstOperands,
     /* 183669 */     // GIR_Coverage, 2654,
     /* 183669 */     GIR_EraseRootFromParent_Done,
     /* 183670 */   // Label 4095: @183670
     /* 183670 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(183732), // Rule ID 5358 //
     /* 183675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 183678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183694 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183697 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183701 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183714 */     // (smax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ128rm),
     /* 183717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183719 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183721 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183730 */     GIR_RootConstrainSelectedInstOperands,
     /* 183731 */     // GIR_Coverage, 5358,
     /* 183731 */     GIR_EraseRootFromParent_Done,
     /* 183732 */   // Label 4096: @183732
     /* 183732 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(183759), // Rule ID 2653 //
     /* 183737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 183740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183752 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMAXSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 183752 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWrr),
     /* 183757 */     GIR_RootConstrainSelectedInstOperands,
     /* 183758 */     // GIR_Coverage, 2653,
     /* 183758 */     GIR_Done,
     /* 183759 */   // Label 4097: @183759
     /* 183759 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(183786), // Rule ID 2655 //
     /* 183764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 183767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183779 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMAXSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 183779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSWrr),
     /* 183784 */     GIR_RootConstrainSelectedInstOperands,
     /* 183785 */     // GIR_Coverage, 2655,
     /* 183785 */     GIR_Done,
     /* 183786 */   // Label 4098: @183786
     /* 183786 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(183813), // Rule ID 5355 //
     /* 183791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 183794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183806 */     // (smax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMAXSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 183806 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ128rr),
     /* 183811 */     GIR_RootConstrainSelectedInstOperands,
     /* 183812 */     // GIR_Coverage, 5355,
     /* 183812 */     GIR_Done,
     /* 183813 */   // Label 4099: @183813
     /* 183813 */   GIM_Reject,
     /* 183814 */ // Label 4092: @183814
     /* 183814 */ GIM_Reject,
     /* 183815 */ // Label 4065: @183815
     /* 183815 */ GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(184129),
     /* 183820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 183823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 183826 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(183888), // Rule ID 23509 //
     /* 183831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 183834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 183838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183846 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183849 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183853 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 183861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183863 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183870 */     // (smax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMAXSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDYrm),
     /* 183873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183875 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183877 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183886 */     GIR_RootConstrainSelectedInstOperands,
     /* 183887 */     // GIR_Coverage, 23509,
     /* 183887 */     GIR_EraseRootFromParent_Done,
     /* 183888 */   // Label 4101: @183888
     /* 183888 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(183950), // Rule ID 23942 //
     /* 183893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183908 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183911 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183915 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183932 */     // (smax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMAXSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ256rm),
     /* 183935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183937 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183939 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183948 */     GIR_RootConstrainSelectedInstOperands,
     /* 183949 */     // GIR_Coverage, 23942,
     /* 183949 */     GIR_EraseRootFromParent_Done,
     /* 183950 */   // Label 4102: @183950
     /* 183950 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(184012), // Rule ID 3207 //
     /* 183955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 183958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 183962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 183966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183974 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183977 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183981 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183994 */     // (smax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDYrm),
     /* 183997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183999 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184001 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184010 */     GIR_RootConstrainSelectedInstOperands,
     /* 184011 */     // GIR_Coverage, 3207,
     /* 184011 */     GIR_EraseRootFromParent_Done,
     /* 184012 */   // Label 4103: @184012
     /* 184012 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(184074), // Rule ID 5373 //
     /* 184017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 184020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184036 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184039 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184043 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184056 */     // (smax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ256rm),
     /* 184059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184061 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184063 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184072 */     GIR_RootConstrainSelectedInstOperands,
     /* 184073 */     // GIR_Coverage, 5373,
     /* 184073 */     GIR_EraseRootFromParent_Done,
     /* 184074 */   // Label 4104: @184074
     /* 184074 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(184101), // Rule ID 3206 //
     /* 184079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 184082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184094 */     // (smax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMAXSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 184094 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDYrr),
     /* 184099 */     GIR_RootConstrainSelectedInstOperands,
     /* 184100 */     // GIR_Coverage, 3206,
     /* 184100 */     GIR_Done,
     /* 184101 */   // Label 4105: @184101
     /* 184101 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(184128), // Rule ID 5370 //
     /* 184106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 184109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184121 */     // (smax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMAXSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 184121 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ256rr),
     /* 184126 */     GIR_RootConstrainSelectedInstOperands,
     /* 184127 */     // GIR_Coverage, 5370,
     /* 184127 */     GIR_Done,
     /* 184128 */   // Label 4106: @184128
     /* 184128 */   GIM_Reject,
     /* 184129 */ // Label 4100: @184129
     /* 184129 */ GIM_Reject,
     /* 184130 */ // Label 4066: @184130
     /* 184130 */ GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(184285),
     /* 184135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 184138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 184141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184145 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(184203), // Rule ID 23954 //
     /* 184150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 184153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184161 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184164 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184168 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184178 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184185 */     // (smax:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMAXSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrm),
     /* 184188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184190 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184192 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184201 */     GIR_RootConstrainSelectedInstOperands,
     /* 184202 */     // GIR_Coverage, 23954,
     /* 184202 */     GIR_EraseRootFromParent_Done,
     /* 184203 */   // Label 4108: @184203
     /* 184203 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(184261), // Rule ID 5391 //
     /* 184208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 184211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184223 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184226 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184230 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184243 */     // (smax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrm),
     /* 184246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184248 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184250 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184259 */     GIR_RootConstrainSelectedInstOperands,
     /* 184260 */     // GIR_Coverage, 5391,
     /* 184260 */     GIR_EraseRootFromParent_Done,
     /* 184261 */   // Label 4109: @184261
     /* 184261 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(184284), // Rule ID 5388 //
     /* 184266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 184269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184277 */     // (smax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMAXSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 184277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 184282 */     GIR_RootConstrainSelectedInstOperands,
     /* 184283 */     // GIR_Coverage, 5388,
     /* 184283 */     GIR_Done,
     /* 184284 */   // Label 4110: @184284
     /* 184284 */   GIM_Reject,
     /* 184285 */ // Label 4107: @184285
     /* 184285 */ GIM_Reject,
     /* 184286 */ // Label 4067: @184286
     /* 184286 */ GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(184627),
     /* 184291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 184294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 184297 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(184359), // Rule ID 23505 //
     /* 184302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184317 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184320 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184324 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184341 */     // (smax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMAXSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBrm),
     /* 184344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184346 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184348 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184357 */     GIR_RootConstrainSelectedInstOperands,
     /* 184358 */     // GIR_Coverage, 23505,
     /* 184358 */     GIR_EraseRootFromParent_Done,
     /* 184359 */   // Label 4112: @184359
     /* 184359 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(184421), // Rule ID 23924 //
     /* 184364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184379 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184382 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184386 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184396 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184403 */     // (smax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMAXSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ128rm),
     /* 184406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184408 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184410 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184419 */     GIR_RootConstrainSelectedInstOperands,
     /* 184420 */     // GIR_Coverage, 23924,
     /* 184420 */     GIR_EraseRootFromParent_Done,
     /* 184421 */   // Label 4113: @184421
     /* 184421 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(184483), // Rule ID 3199 //
     /* 184426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184445 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184448 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184452 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184458 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184465 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBrm),
     /* 184468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184470 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184472 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184481 */     GIR_RootConstrainSelectedInstOperands,
     /* 184482 */     // GIR_Coverage, 3199,
     /* 184482 */     GIR_EraseRootFromParent_Done,
     /* 184483 */   // Label 4114: @184483
     /* 184483 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(184545), // Rule ID 5340 //
     /* 184488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184507 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184510 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184514 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184520 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184527 */     // (smax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ128rm),
     /* 184530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184532 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184534 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184543 */     GIR_RootConstrainSelectedInstOperands,
     /* 184544 */     // GIR_Coverage, 5340,
     /* 184544 */     GIR_EraseRootFromParent_Done,
     /* 184545 */   // Label 4115: @184545
     /* 184545 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(184572), // Rule ID 3198 //
     /* 184550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184565 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMAXSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 184565 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBrr),
     /* 184570 */     GIR_RootConstrainSelectedInstOperands,
     /* 184571 */     // GIR_Coverage, 3198,
     /* 184571 */     GIR_Done,
     /* 184572 */   // Label 4116: @184572
     /* 184572 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(184599), // Rule ID 3228 //
     /* 184577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 184580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184592 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMAXSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 184592 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSBrr),
     /* 184597 */     GIR_RootConstrainSelectedInstOperands,
     /* 184598 */     // GIR_Coverage, 3228,
     /* 184598 */     GIR_Done,
     /* 184599 */   // Label 4117: @184599
     /* 184599 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(184626), // Rule ID 5337 //
     /* 184604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184619 */     // (smax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMAXSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 184619 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ128rr),
     /* 184624 */     GIR_RootConstrainSelectedInstOperands,
     /* 184625 */     // GIR_Coverage, 5337,
     /* 184625 */     GIR_Done,
     /* 184626 */   // Label 4118: @184626
     /* 184626 */   GIM_Reject,
     /* 184627 */ // Label 4111: @184627
     /* 184627 */ GIM_Reject,
     /* 184628 */ // Label 4068: @184628
     /* 184628 */ GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(184942),
     /* 184633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 184636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 184639 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(184701), // Rule ID 23470 //
     /* 184644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 184647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184659 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184662 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184666 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184683 */     // (smax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMAXSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWYrm),
     /* 184686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184688 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184690 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184699 */     GIR_RootConstrainSelectedInstOperands,
     /* 184700 */     // GIR_Coverage, 23470,
     /* 184700 */     GIR_EraseRootFromParent_Done,
     /* 184701 */   // Label 4120: @184701
     /* 184701 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(184763), // Rule ID 23930 //
     /* 184706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184721 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184724 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184728 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184745 */     // (smax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMAXSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ256rm),
     /* 184748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184750 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184752 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184761 */     GIR_RootConstrainSelectedInstOperands,
     /* 184762 */     // GIR_Coverage, 23930,
     /* 184762 */     GIR_EraseRootFromParent_Done,
     /* 184763 */   // Label 4121: @184763
     /* 184763 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(184825), // Rule ID 2658 //
     /* 184768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 184771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184787 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184790 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184794 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184800 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184807 */     // (smax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWYrm),
     /* 184810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184812 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184814 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184823 */     GIR_RootConstrainSelectedInstOperands,
     /* 184824 */     // GIR_Coverage, 2658,
     /* 184824 */     GIR_EraseRootFromParent_Done,
     /* 184825 */   // Label 4122: @184825
     /* 184825 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(184887), // Rule ID 5352 //
     /* 184830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184849 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184852 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184856 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184869 */     // (smax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ256rm),
     /* 184872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184874 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184885 */     GIR_RootConstrainSelectedInstOperands,
     /* 184886 */     // GIR_Coverage, 5352,
     /* 184886 */     GIR_EraseRootFromParent_Done,
     /* 184887 */   // Label 4123: @184887
     /* 184887 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(184914), // Rule ID 2657 //
     /* 184892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 184895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184907 */     // (smax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMAXSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 184907 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWYrr),
     /* 184912 */     GIR_RootConstrainSelectedInstOperands,
     /* 184913 */     // GIR_Coverage, 2657,
     /* 184913 */     GIR_Done,
     /* 184914 */   // Label 4124: @184914
     /* 184914 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(184941), // Rule ID 5349 //
     /* 184919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184934 */     // (smax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMAXSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 184934 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ256rr),
     /* 184939 */     GIR_RootConstrainSelectedInstOperands,
     /* 184940 */     // GIR_Coverage, 5349,
     /* 184940 */     GIR_Done,
     /* 184941 */   // Label 4125: @184941
     /* 184941 */   GIM_Reject,
     /* 184942 */ // Label 4119: @184942
     /* 184942 */ GIM_Reject,
     /* 184943 */ // Label 4069: @184943
     /* 184943 */ GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(185098),
     /* 184948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 184951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 184954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184958 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(185016), // Rule ID 23936 //
     /* 184963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 184966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184974 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184977 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184981 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184991 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184998 */     // (smax:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMAXSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZrm),
     /* 185001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185003 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185005 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185014 */     GIR_RootConstrainSelectedInstOperands,
     /* 185015 */     // GIR_Coverage, 23936,
     /* 185015 */     GIR_EraseRootFromParent_Done,
     /* 185016 */   // Label 4127: @185016
     /* 185016 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(185074), // Rule ID 5364 //
     /* 185021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 185024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185036 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185039 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185043 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185056 */     // (smax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZrm),
     /* 185059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185061 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185063 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185072 */     GIR_RootConstrainSelectedInstOperands,
     /* 185073 */     // GIR_Coverage, 5364,
     /* 185073 */     GIR_EraseRootFromParent_Done,
     /* 185074 */   // Label 4128: @185074
     /* 185074 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(185097), // Rule ID 5361 //
     /* 185079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 185082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185090 */     // (smax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMAXSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 185090 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZrr),
     /* 185095 */     GIR_RootConstrainSelectedInstOperands,
     /* 185096 */     // GIR_Coverage, 5361,
     /* 185096 */     GIR_Done,
     /* 185097 */   // Label 4129: @185097
     /* 185097 */   GIM_Reject,
     /* 185098 */ // Label 4126: @185098
     /* 185098 */ GIM_Reject,
     /* 185099 */ // Label 4070: @185099
     /* 185099 */ GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(185413),
     /* 185104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 185107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 185110 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(185172), // Rule ID 23514 //
     /* 185115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185130 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185133 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185137 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185154 */     // (smax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMAXSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBYrm),
     /* 185157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185159 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185161 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185170 */     GIR_RootConstrainSelectedInstOperands,
     /* 185171 */     // GIR_Coverage, 23514,
     /* 185171 */     GIR_EraseRootFromParent_Done,
     /* 185172 */   // Label 4131: @185172
     /* 185172 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(185234), // Rule ID 23921 //
     /* 185177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185192 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185195 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185199 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185216 */     // (smax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMAXSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ256rm),
     /* 185219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185221 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185232 */     GIR_RootConstrainSelectedInstOperands,
     /* 185233 */     // GIR_Coverage, 23921,
     /* 185233 */     GIR_EraseRootFromParent_Done,
     /* 185234 */   // Label 4132: @185234
     /* 185234 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(185296), // Rule ID 3217 //
     /* 185239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185258 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185261 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185265 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185278 */     // (smax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBYrm),
     /* 185281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185283 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185285 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185294 */     GIR_RootConstrainSelectedInstOperands,
     /* 185295 */     // GIR_Coverage, 3217,
     /* 185295 */     GIR_EraseRootFromParent_Done,
     /* 185296 */   // Label 4133: @185296
     /* 185296 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(185358), // Rule ID 5334 //
     /* 185301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185320 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185323 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185327 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185340 */     // (smax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ256rm),
     /* 185343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185345 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185347 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185356 */     GIR_RootConstrainSelectedInstOperands,
     /* 185357 */     // GIR_Coverage, 5334,
     /* 185357 */     GIR_EraseRootFromParent_Done,
     /* 185358 */   // Label 4134: @185358
     /* 185358 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(185385), // Rule ID 3216 //
     /* 185363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185378 */     // (smax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMAXSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 185378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBYrr),
     /* 185383 */     GIR_RootConstrainSelectedInstOperands,
     /* 185384 */     // GIR_Coverage, 3216,
     /* 185384 */     GIR_Done,
     /* 185385 */   // Label 4135: @185385
     /* 185385 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(185412), // Rule ID 5331 //
     /* 185390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185405 */     // (smax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMAXSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 185405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ256rr),
     /* 185410 */     GIR_RootConstrainSelectedInstOperands,
     /* 185411 */     // GIR_Coverage, 5331,
     /* 185411 */     GIR_Done,
     /* 185412 */   // Label 4136: @185412
     /* 185412 */   GIM_Reject,
     /* 185413 */ // Label 4130: @185413
     /* 185413 */ GIM_Reject,
     /* 185414 */ // Label 4071: @185414
     /* 185414 */ GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(185569),
     /* 185419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 185422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 185425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185429 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(185487), // Rule ID 23927 //
     /* 185434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 185437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185445 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185448 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185452 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185469 */     // (smax:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMAXSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZrm),
     /* 185472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185474 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185476 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185485 */     GIR_RootConstrainSelectedInstOperands,
     /* 185486 */     // GIR_Coverage, 23927,
     /* 185486 */     GIR_EraseRootFromParent_Done,
     /* 185487 */   // Label 4138: @185487
     /* 185487 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(185545), // Rule ID 5346 //
     /* 185492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 185495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185507 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185510 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185514 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185520 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185527 */     // (smax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZrm),
     /* 185530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185532 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185534 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185543 */     GIR_RootConstrainSelectedInstOperands,
     /* 185544 */     // GIR_Coverage, 5346,
     /* 185544 */     GIR_EraseRootFromParent_Done,
     /* 185545 */   // Label 4139: @185545
     /* 185545 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(185568), // Rule ID 5343 //
     /* 185550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 185553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185561 */     // (smax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMAXSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 185561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZrr),
     /* 185566 */     GIR_RootConstrainSelectedInstOperands,
     /* 185567 */     // GIR_Coverage, 5343,
     /* 185567 */     GIR_Done,
     /* 185568 */   // Label 4140: @185568
     /* 185568 */   GIM_Reject,
     /* 185569 */ // Label 4137: @185569
     /* 185569 */ GIM_Reject,
     /* 185570 */ // Label 4072: @185570
     /* 185570 */ GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(185725),
     /* 185575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 185578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 185581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185585 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(185643), // Rule ID 23918 //
     /* 185590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 185593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185601 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185604 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185608 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185618 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185625 */     // (smax:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMAXSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZrm),
     /* 185628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185630 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185632 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185641 */     GIR_RootConstrainSelectedInstOperands,
     /* 185642 */     // GIR_Coverage, 23918,
     /* 185642 */     GIR_EraseRootFromParent_Done,
     /* 185643 */   // Label 4142: @185643
     /* 185643 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(185701), // Rule ID 5328 //
     /* 185648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 185651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185663 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185666 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185670 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185683 */     // (smax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZrm),
     /* 185686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185688 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185690 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185699 */     GIR_RootConstrainSelectedInstOperands,
     /* 185700 */     // GIR_Coverage, 5328,
     /* 185700 */     GIR_EraseRootFromParent_Done,
     /* 185701 */   // Label 4143: @185701
     /* 185701 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(185724), // Rule ID 5325 //
     /* 185706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 185709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185717 */     // (smax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMAXSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 185717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZrr),
     /* 185722 */     GIR_RootConstrainSelectedInstOperands,
     /* 185723 */     // GIR_Coverage, 5325,
     /* 185723 */     GIR_Done,
     /* 185724 */   // Label 4144: @185724
     /* 185724 */   GIM_Reject,
     /* 185725 */ // Label 4141: @185725
     /* 185725 */ GIM_Reject,
     /* 185726 */ // Label 4073: @185726
     /* 185726 */ GIM_Reject,
     /* 185727 */ // Label 56: @185727
     /* 185727 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4157*/ GIMT_Encode4(189047),
     /* 185738 */ /*GILLT_v2s64*//*Label 4145*/ GIMT_Encode4(185806), GIMT_Encode4(0),
     /* 185746 */ /*GILLT_v4s32*//*Label 4146*/ GIMT_Encode4(186135),
     /* 185750 */ /*GILLT_v4s64*//*Label 4147*/ GIMT_Encode4(186477), GIMT_Encode4(0),
     /* 185758 */ /*GILLT_v8s16*//*Label 4148*/ GIMT_Encode4(186794),
     /* 185762 */ /*GILLT_v8s32*//*Label 4149*/ GIMT_Encode4(187136),
     /* 185766 */ /*GILLT_v8s64*//*Label 4150*/ GIMT_Encode4(187451), GIMT_Encode4(0),
     /* 185774 */ /*GILLT_v16s8*//*Label 4151*/ GIMT_Encode4(187607),
     /* 185778 */ /*GILLT_v16s16*//*Label 4152*/ GIMT_Encode4(187949),
     /* 185782 */ /*GILLT_v16s32*//*Label 4153*/ GIMT_Encode4(188264), GIMT_Encode4(0),
     /* 185790 */ /*GILLT_v32s8*//*Label 4154*/ GIMT_Encode4(188420),
     /* 185794 */ /*GILLT_v32s16*//*Label 4155*/ GIMT_Encode4(188735), GIMT_Encode4(0),
     /* 185802 */ /*GILLT_v64s8*//*Label 4156*/ GIMT_Encode4(188891),
     /* 185806 */ // Label 4145: @185806
     /* 185806 */ GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(186134),
     /* 185811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 185814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185817 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(185879), // Rule ID 24128 //
     /* 185822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 185825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185837 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185840 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185844 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185861 */     // (umin:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMINUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ128rm),
     /* 185864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185866 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185868 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185877 */     GIR_RootConstrainSelectedInstOperands,
     /* 185878 */     // GIR_Coverage, 24128,
     /* 185878 */     GIR_EraseRootFromParent_Done,
     /* 185879 */   // Label 4159: @185879
     /* 185879 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(185941), // Rule ID 5679 //
     /* 185884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 185887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185903 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185906 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185910 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185923 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ128rm),
     /* 185926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185928 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185930 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185939 */     GIR_RootConstrainSelectedInstOperands,
     /* 185940 */     // GIR_Coverage, 5679,
     /* 185940 */     GIR_EraseRootFromParent_Done,
     /* 185941 */   // Label 4160: @185941
     /* 185941 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(185968), // Rule ID 5676 //
     /* 185946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 185949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185961 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMINUQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 185961 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ128rr),
     /* 185966 */     GIR_RootConstrainSelectedInstOperands,
     /* 185967 */     // GIR_Coverage, 5676,
     /* 185967 */     GIR_Done,
     /* 185968 */   // Label 4161: @185968
     /* 185968 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(186133), // Rule ID 20005 //
     /* 185973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 185976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 185980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185988 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMINUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 185988 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 185991 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185995 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 186002 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 186005 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186009 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186014 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 186017 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 186021 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 186024 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 186029 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186034 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 186039 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 186042 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186046 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 186053 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 186056 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186060 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186065 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 186068 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 186072 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 186075 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 186080 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186085 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 186090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 186093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 186097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186102 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 186105 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 186108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 186110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 186113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186115 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 186122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 186127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186132 */     // GIR_Coverage, 20005,
     /* 186132 */     GIR_EraseRootFromParent_Done,
     /* 186133 */   // Label 4162: @186133
     /* 186133 */   GIM_Reject,
     /* 186134 */ // Label 4158: @186134
     /* 186134 */ GIM_Reject,
     /* 186135 */ // Label 4146: @186135
     /* 186135 */ GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(186476),
     /* 186140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 186143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186146 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(186208), // Rule ID 23499 //
     /* 186151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 186154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186166 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186169 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186173 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186190 */     // (umin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMINUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDrm),
     /* 186193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186195 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186197 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186206 */     GIR_RootConstrainSelectedInstOperands,
     /* 186207 */     // GIR_Coverage, 23499,
     /* 186207 */     GIR_EraseRootFromParent_Done,
     /* 186208 */   // Label 4164: @186208
     /* 186208 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(186270), // Rule ID 24110 //
     /* 186213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186228 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186231 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186235 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186252 */     // (umin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMINUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ128rm),
     /* 186255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186257 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186259 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186268 */     GIR_RootConstrainSelectedInstOperands,
     /* 186269 */     // GIR_Coverage, 24110,
     /* 186269 */     GIR_EraseRootFromParent_Done,
     /* 186270 */   // Label 4165: @186270
     /* 186270 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(186332), // Rule ID 3187 //
     /* 186275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 186278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186294 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186297 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186301 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186314 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDrm),
     /* 186317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186319 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186321 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186330 */     GIR_RootConstrainSelectedInstOperands,
     /* 186331 */     // GIR_Coverage, 3187,
     /* 186331 */     GIR_EraseRootFromParent_Done,
     /* 186332 */   // Label 4166: @186332
     /* 186332 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(186394), // Rule ID 5652 //
     /* 186337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186356 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186359 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186363 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186376 */     // (umin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ128rm),
     /* 186379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186381 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186383 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186392 */     GIR_RootConstrainSelectedInstOperands,
     /* 186393 */     // GIR_Coverage, 5652,
     /* 186393 */     GIR_EraseRootFromParent_Done,
     /* 186394 */   // Label 4167: @186394
     /* 186394 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(186421), // Rule ID 3186 //
     /* 186399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 186402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186414 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMINUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 186414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDrr),
     /* 186419 */     GIR_RootConstrainSelectedInstOperands,
     /* 186420 */     // GIR_Coverage, 3186,
     /* 186420 */     GIR_Done,
     /* 186421 */   // Label 4168: @186421
     /* 186421 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(186448), // Rule ID 3224 //
     /* 186426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 186429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186441 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMINUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 186441 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUDrr),
     /* 186446 */     GIR_RootConstrainSelectedInstOperands,
     /* 186447 */     // GIR_Coverage, 3224,
     /* 186447 */     GIR_Done,
     /* 186448 */   // Label 4169: @186448
     /* 186448 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(186475), // Rule ID 5649 //
     /* 186453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186468 */     // (umin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMINUDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 186468 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ128rr),
     /* 186473 */     GIR_RootConstrainSelectedInstOperands,
     /* 186474 */     // GIR_Coverage, 5649,
     /* 186474 */     GIR_Done,
     /* 186475 */   // Label 4170: @186475
     /* 186475 */   GIM_Reject,
     /* 186476 */ // Label 4163: @186476
     /* 186476 */ GIM_Reject,
     /* 186477 */ // Label 4147: @186477
     /* 186477 */ GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(186793),
     /* 186482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 186485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 186488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 186492 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(186550), // Rule ID 24122 //
     /* 186497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186508 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186511 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186515 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 186523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186532 */     // (umin:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMINUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ256rm),
     /* 186535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186537 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186548 */     GIR_RootConstrainSelectedInstOperands,
     /* 186549 */     // GIR_Coverage, 24122,
     /* 186549 */     GIR_EraseRootFromParent_Done,
     /* 186550 */   // Label 4172: @186550
     /* 186550 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(186608), // Rule ID 5670 //
     /* 186555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 186562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186570 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186573 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186577 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186590 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ256rm),
     /* 186593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186595 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186597 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186606 */     GIR_RootConstrainSelectedInstOperands,
     /* 186607 */     // GIR_Coverage, 5670,
     /* 186607 */     GIR_EraseRootFromParent_Done,
     /* 186608 */   // Label 4173: @186608
     /* 186608 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(186631), // Rule ID 5667 //
     /* 186613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 186620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 186624 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMINUQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 186624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ256rr),
     /* 186629 */     GIR_RootConstrainSelectedInstOperands,
     /* 186630 */     // GIR_Coverage, 5667,
     /* 186630 */     GIR_Done,
     /* 186631 */   // Label 4174: @186631
     /* 186631 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(186792), // Rule ID 20003 //
     /* 186636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 186639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 186643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 186647 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMINUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 186647 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 186650 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186654 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 186661 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 186664 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186668 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186673 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 186676 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 186680 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 186683 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 186688 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186693 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 186698 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 186701 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186705 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 186712 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 186715 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186719 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186724 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 186727 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 186731 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 186734 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 186739 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186744 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 186749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 186752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 186756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186761 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 186764 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 186767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 186769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 186772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186774 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 186781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 186786 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186791 */     // GIR_Coverage, 20003,
     /* 186791 */     GIR_EraseRootFromParent_Done,
     /* 186792 */   // Label 4175: @186792
     /* 186792 */   GIM_Reject,
     /* 186793 */ // Label 4171: @186793
     /* 186793 */ GIM_Reject,
     /* 186794 */ // Label 4148: @186794
     /* 186794 */ GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(187135),
     /* 186799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 186802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186805 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(186867), // Rule ID 23504 //
     /* 186810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 186813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186825 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186828 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186832 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186849 */     // (umin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMINUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWrm),
     /* 186852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186854 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186856 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186865 */     GIR_RootConstrainSelectedInstOperands,
     /* 186866 */     // GIR_Coverage, 23504,
     /* 186866 */     GIR_EraseRootFromParent_Done,
     /* 186867 */   // Label 4177: @186867
     /* 186867 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(186929), // Rule ID 24095 //
     /* 186872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 186875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186887 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186890 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186894 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186911 */     // (umin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMINUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ128rm),
     /* 186914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186916 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186918 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186927 */     GIR_RootConstrainSelectedInstOperands,
     /* 186928 */     // GIR_Coverage, 24095,
     /* 186928 */     GIR_EraseRootFromParent_Done,
     /* 186929 */   // Label 4178: @186929
     /* 186929 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(186991), // Rule ID 3197 //
     /* 186934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 186937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186953 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186956 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186960 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186966 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186973 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWrm),
     /* 186976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186978 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186980 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186989 */     GIR_RootConstrainSelectedInstOperands,
     /* 186990 */     // GIR_Coverage, 3197,
     /* 186990 */     GIR_EraseRootFromParent_Done,
     /* 186991 */   // Label 4179: @186991
     /* 186991 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(187053), // Rule ID 5628 //
     /* 186996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 186999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187015 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187018 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187022 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187028 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187035 */     // (umin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ128rm),
     /* 187038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187040 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187042 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187051 */     GIR_RootConstrainSelectedInstOperands,
     /* 187052 */     // GIR_Coverage, 5628,
     /* 187052 */     GIR_EraseRootFromParent_Done,
     /* 187053 */   // Label 4180: @187053
     /* 187053 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(187080), // Rule ID 3196 //
     /* 187058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 187061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187073 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMINUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 187073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWrr),
     /* 187078 */     GIR_RootConstrainSelectedInstOperands,
     /* 187079 */     // GIR_Coverage, 3196,
     /* 187079 */     GIR_Done,
     /* 187080 */   // Label 4181: @187080
     /* 187080 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(187107), // Rule ID 3226 //
     /* 187085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 187088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187100 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMINUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 187100 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUWrr),
     /* 187105 */     GIR_RootConstrainSelectedInstOperands,
     /* 187106 */     // GIR_Coverage, 3226,
     /* 187106 */     GIR_Done,
     /* 187107 */   // Label 4182: @187107
     /* 187107 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(187134), // Rule ID 5625 //
     /* 187112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 187115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187127 */     // (umin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMINUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 187127 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ128rr),
     /* 187132 */     GIR_RootConstrainSelectedInstOperands,
     /* 187133 */     // GIR_Coverage, 5625,
     /* 187133 */     GIR_Done,
     /* 187134 */   // Label 4183: @187134
     /* 187134 */   GIM_Reject,
     /* 187135 */ // Label 4176: @187135
     /* 187135 */ GIM_Reject,
     /* 187136 */ // Label 4149: @187136
     /* 187136 */ GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(187450),
     /* 187141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 187144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 187147 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(187209), // Rule ID 23508 //
     /* 187152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 187155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187167 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187170 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187174 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187191 */     // (umin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMINUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDYrm),
     /* 187194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187196 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187198 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187207 */     GIR_RootConstrainSelectedInstOperands,
     /* 187208 */     // GIR_Coverage, 23508,
     /* 187208 */     GIR_EraseRootFromParent_Done,
     /* 187209 */   // Label 4185: @187209
     /* 187209 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(187271), // Rule ID 24104 //
     /* 187214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187229 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187232 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187236 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187246 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187253 */     // (umin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMINUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ256rm),
     /* 187256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187258 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187260 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187269 */     GIR_RootConstrainSelectedInstOperands,
     /* 187270 */     // GIR_Coverage, 24104,
     /* 187270 */     GIR_EraseRootFromParent_Done,
     /* 187271 */   // Label 4186: @187271
     /* 187271 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(187333), // Rule ID 3205 //
     /* 187276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 187279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187295 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187298 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187302 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187315 */     // (umin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDYrm),
     /* 187318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187320 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187322 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187331 */     GIR_RootConstrainSelectedInstOperands,
     /* 187332 */     // GIR_Coverage, 3205,
     /* 187332 */     GIR_EraseRootFromParent_Done,
     /* 187333 */   // Label 4187: @187333
     /* 187333 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(187395), // Rule ID 5643 //
     /* 187338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187357 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187360 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187364 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187377 */     // (umin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ256rm),
     /* 187380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187382 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187384 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187393 */     GIR_RootConstrainSelectedInstOperands,
     /* 187394 */     // GIR_Coverage, 5643,
     /* 187394 */     GIR_EraseRootFromParent_Done,
     /* 187395 */   // Label 4188: @187395
     /* 187395 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(187422), // Rule ID 3204 //
     /* 187400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 187403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187415 */     // (umin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMINUDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 187415 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDYrr),
     /* 187420 */     GIR_RootConstrainSelectedInstOperands,
     /* 187421 */     // GIR_Coverage, 3204,
     /* 187421 */     GIR_Done,
     /* 187422 */   // Label 4189: @187422
     /* 187422 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(187449), // Rule ID 5640 //
     /* 187427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187442 */     // (umin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMINUDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 187442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ256rr),
     /* 187447 */     GIR_RootConstrainSelectedInstOperands,
     /* 187448 */     // GIR_Coverage, 5640,
     /* 187448 */     GIR_Done,
     /* 187449 */   // Label 4190: @187449
     /* 187449 */   GIM_Reject,
     /* 187450 */ // Label 4184: @187450
     /* 187450 */ GIM_Reject,
     /* 187451 */ // Label 4150: @187451
     /* 187451 */ GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(187606),
     /* 187456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 187459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 187462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 187466 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(187524), // Rule ID 24116 //
     /* 187471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 187474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187482 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187485 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187489 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 187497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187506 */     // (umin:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMINUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrm),
     /* 187509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187511 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187513 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187522 */     GIR_RootConstrainSelectedInstOperands,
     /* 187523 */     // GIR_Coverage, 24116,
     /* 187523 */     GIR_EraseRootFromParent_Done,
     /* 187524 */   // Label 4192: @187524
     /* 187524 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(187582), // Rule ID 5661 //
     /* 187529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 187532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 187536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187544 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187547 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187551 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187564 */     // (umin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrm),
     /* 187567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187569 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187580 */     GIR_RootConstrainSelectedInstOperands,
     /* 187581 */     // GIR_Coverage, 5661,
     /* 187581 */     GIR_EraseRootFromParent_Done,
     /* 187582 */   // Label 4193: @187582
     /* 187582 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(187605), // Rule ID 5658 //
     /* 187587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 187590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 187594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 187598 */     // (umin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMINUQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 187598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 187603 */     GIR_RootConstrainSelectedInstOperands,
     /* 187604 */     // GIR_Coverage, 5658,
     /* 187604 */     GIR_Done,
     /* 187605 */   // Label 4194: @187605
     /* 187605 */   GIM_Reject,
     /* 187606 */ // Label 4191: @187606
     /* 187606 */ GIM_Reject,
     /* 187607 */ // Label 4151: @187607
     /* 187607 */ GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(187948),
     /* 187612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 187615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 187618 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(187680), // Rule ID 23459 //
     /* 187623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 187626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187638 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187641 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187645 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187662 */     // (umin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMINUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBrm),
     /* 187665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187667 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187669 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187678 */     GIR_RootConstrainSelectedInstOperands,
     /* 187679 */     // GIR_Coverage, 23459,
     /* 187679 */     GIR_EraseRootFromParent_Done,
     /* 187680 */   // Label 4196: @187680
     /* 187680 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(187742), // Rule ID 24086 //
     /* 187685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 187688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187700 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187703 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187707 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187724 */     // (umin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMINUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ128rm),
     /* 187727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187729 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187731 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187740 */     GIR_RootConstrainSelectedInstOperands,
     /* 187741 */     // GIR_Coverage, 24086,
     /* 187741 */     GIR_EraseRootFromParent_Done,
     /* 187742 */   // Label 4197: @187742
     /* 187742 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(187804), // Rule ID 2636 //
     /* 187747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 187750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187766 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187769 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187773 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187786 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBrm),
     /* 187789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187791 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187793 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187802 */     GIR_RootConstrainSelectedInstOperands,
     /* 187803 */     // GIR_Coverage, 2636,
     /* 187803 */     GIR_EraseRootFromParent_Done,
     /* 187804 */   // Label 4198: @187804
     /* 187804 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(187866), // Rule ID 5610 //
     /* 187809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 187812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187828 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187831 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187835 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187848 */     // (umin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ128rm),
     /* 187851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187853 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187855 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187864 */     GIR_RootConstrainSelectedInstOperands,
     /* 187865 */     // GIR_Coverage, 5610,
     /* 187865 */     GIR_EraseRootFromParent_Done,
     /* 187866 */   // Label 4199: @187866
     /* 187866 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(187893), // Rule ID 2635 //
     /* 187871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 187874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187886 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMINUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 187886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBrr),
     /* 187891 */     GIR_RootConstrainSelectedInstOperands,
     /* 187892 */     // GIR_Coverage, 2635,
     /* 187892 */     GIR_Done,
     /* 187893 */   // Label 4200: @187893
     /* 187893 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(187920), // Rule ID 2637 //
     /* 187898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 187901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187913 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMINUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 187913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUBrr),
     /* 187918 */     GIR_RootConstrainSelectedInstOperands,
     /* 187919 */     // GIR_Coverage, 2637,
     /* 187919 */     GIR_Done,
     /* 187920 */   // Label 4201: @187920
     /* 187920 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(187947), // Rule ID 5607 //
     /* 187925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 187928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187940 */     // (umin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMINUBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 187940 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ128rr),
     /* 187945 */     GIR_RootConstrainSelectedInstOperands,
     /* 187946 */     // GIR_Coverage, 5607,
     /* 187946 */     GIR_Done,
     /* 187947 */   // Label 4202: @187947
     /* 187947 */   GIM_Reject,
     /* 187948 */ // Label 4195: @187948
     /* 187948 */ GIM_Reject,
     /* 187949 */ // Label 4152: @187949
     /* 187949 */ GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(188263),
     /* 187954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 187957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 187960 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(188022), // Rule ID 23513 //
     /* 187965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 187968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187980 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187983 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187987 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188004 */     // (umin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMINUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWYrm),
     /* 188007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188009 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188011 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188020 */     GIR_RootConstrainSelectedInstOperands,
     /* 188021 */     // GIR_Coverage, 23513,
     /* 188021 */     GIR_EraseRootFromParent_Done,
     /* 188022 */   // Label 4204: @188022
     /* 188022 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(188084), // Rule ID 24092 //
     /* 188027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188042 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188045 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188049 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188059 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188066 */     // (umin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMINUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ256rm),
     /* 188069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188071 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188073 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188082 */     GIR_RootConstrainSelectedInstOperands,
     /* 188083 */     // GIR_Coverage, 24092,
     /* 188083 */     GIR_EraseRootFromParent_Done,
     /* 188084 */   // Label 4205: @188084
     /* 188084 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(188146), // Rule ID 3215 //
     /* 188089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 188092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188108 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188111 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188115 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188128 */     // (umin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWYrm),
     /* 188131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188133 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188135 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188144 */     GIR_RootConstrainSelectedInstOperands,
     /* 188145 */     // GIR_Coverage, 3215,
     /* 188145 */     GIR_EraseRootFromParent_Done,
     /* 188146 */   // Label 4206: @188146
     /* 188146 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(188208), // Rule ID 5622 //
     /* 188151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188170 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188173 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188177 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188190 */     // (umin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ256rm),
     /* 188193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188195 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188197 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188206 */     GIR_RootConstrainSelectedInstOperands,
     /* 188207 */     // GIR_Coverage, 5622,
     /* 188207 */     GIR_EraseRootFromParent_Done,
     /* 188208 */   // Label 4207: @188208
     /* 188208 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(188235), // Rule ID 3214 //
     /* 188213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 188216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188228 */     // (umin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMINUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 188228 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWYrr),
     /* 188233 */     GIR_RootConstrainSelectedInstOperands,
     /* 188234 */     // GIR_Coverage, 3214,
     /* 188234 */     GIR_Done,
     /* 188235 */   // Label 4208: @188235
     /* 188235 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(188262), // Rule ID 5619 //
     /* 188240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188255 */     // (umin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMINUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 188255 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ256rr),
     /* 188260 */     GIR_RootConstrainSelectedInstOperands,
     /* 188261 */     // GIR_Coverage, 5619,
     /* 188261 */     GIR_Done,
     /* 188262 */   // Label 4209: @188262
     /* 188262 */   GIM_Reject,
     /* 188263 */ // Label 4203: @188263
     /* 188263 */ GIM_Reject,
     /* 188264 */ // Label 4153: @188264
     /* 188264 */ GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(188419),
     /* 188269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 188272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 188275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188279 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(188337), // Rule ID 24098 //
     /* 188284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188295 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188298 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188302 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188319 */     // (umin:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMINUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZrm),
     /* 188322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188324 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188326 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188335 */     GIR_RootConstrainSelectedInstOperands,
     /* 188336 */     // GIR_Coverage, 24098,
     /* 188336 */     GIR_EraseRootFromParent_Done,
     /* 188337 */   // Label 4211: @188337
     /* 188337 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(188395), // Rule ID 5634 //
     /* 188342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188357 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188360 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188364 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188377 */     // (umin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZrm),
     /* 188380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188382 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188384 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188393 */     GIR_RootConstrainSelectedInstOperands,
     /* 188394 */     // GIR_Coverage, 5634,
     /* 188394 */     GIR_EraseRootFromParent_Done,
     /* 188395 */   // Label 4212: @188395
     /* 188395 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(188418), // Rule ID 5631 //
     /* 188400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188411 */     // (umin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMINUDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 188411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZrr),
     /* 188416 */     GIR_RootConstrainSelectedInstOperands,
     /* 188417 */     // GIR_Coverage, 5631,
     /* 188417 */     GIR_Done,
     /* 188418 */   // Label 4213: @188418
     /* 188418 */   GIM_Reject,
     /* 188419 */ // Label 4210: @188419
     /* 188419 */ GIM_Reject,
     /* 188420 */ // Label 4154: @188420
     /* 188420 */ GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(188734),
     /* 188425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 188428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 188431 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(188493), // Rule ID 23461 //
     /* 188436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 188439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188451 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188454 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188458 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188475 */     // (umin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMINUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBYrm),
     /* 188478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188480 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188482 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188491 */     GIR_RootConstrainSelectedInstOperands,
     /* 188492 */     // GIR_Coverage, 23461,
     /* 188492 */     GIR_EraseRootFromParent_Done,
     /* 188493 */   // Label 4215: @188493
     /* 188493 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(188555), // Rule ID 24083 //
     /* 188498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188513 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188516 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188520 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188537 */     // (umin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMINUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ256rm),
     /* 188540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188542 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188544 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188553 */     GIR_RootConstrainSelectedInstOperands,
     /* 188554 */     // GIR_Coverage, 24083,
     /* 188554 */     GIR_EraseRootFromParent_Done,
     /* 188555 */   // Label 4216: @188555
     /* 188555 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(188617), // Rule ID 2640 //
     /* 188560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 188563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188579 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188582 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188586 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188592 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188599 */     // (umin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBYrm),
     /* 188602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188604 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188606 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188615 */     GIR_RootConstrainSelectedInstOperands,
     /* 188616 */     // GIR_Coverage, 2640,
     /* 188616 */     GIR_EraseRootFromParent_Done,
     /* 188617 */   // Label 4217: @188617
     /* 188617 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(188679), // Rule ID 5604 //
     /* 188622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188641 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188644 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188648 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188654 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188661 */     // (umin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ256rm),
     /* 188664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188666 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188668 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188677 */     GIR_RootConstrainSelectedInstOperands,
     /* 188678 */     // GIR_Coverage, 5604,
     /* 188678 */     GIR_EraseRootFromParent_Done,
     /* 188679 */   // Label 4218: @188679
     /* 188679 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(188706), // Rule ID 2639 //
     /* 188684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 188687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188699 */     // (umin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMINUBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 188699 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBYrr),
     /* 188704 */     GIR_RootConstrainSelectedInstOperands,
     /* 188705 */     // GIR_Coverage, 2639,
     /* 188705 */     GIR_Done,
     /* 188706 */   // Label 4219: @188706
     /* 188706 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(188733), // Rule ID 5601 //
     /* 188711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188726 */     // (umin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMINUBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 188726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ256rr),
     /* 188731 */     GIR_RootConstrainSelectedInstOperands,
     /* 188732 */     // GIR_Coverage, 5601,
     /* 188732 */     GIR_Done,
     /* 188733 */   // Label 4220: @188733
     /* 188733 */   GIM_Reject,
     /* 188734 */ // Label 4214: @188734
     /* 188734 */ GIM_Reject,
     /* 188735 */ // Label 4155: @188735
     /* 188735 */ GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(188890),
     /* 188740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 188743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 188746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188750 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(188808), // Rule ID 24089 //
     /* 188755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 188758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188766 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188769 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188773 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188790 */     // (umin:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMINUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZrm),
     /* 188793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188795 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188797 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188806 */     GIR_RootConstrainSelectedInstOperands,
     /* 188807 */     // GIR_Coverage, 24089,
     /* 188807 */     GIR_EraseRootFromParent_Done,
     /* 188808 */   // Label 4222: @188808
     /* 188808 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(188866), // Rule ID 5616 //
     /* 188813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 188816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188828 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188831 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188835 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188848 */     // (umin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZrm),
     /* 188851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188853 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188855 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188864 */     GIR_RootConstrainSelectedInstOperands,
     /* 188865 */     // GIR_Coverage, 5616,
     /* 188865 */     GIR_EraseRootFromParent_Done,
     /* 188866 */   // Label 4223: @188866
     /* 188866 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(188889), // Rule ID 5613 //
     /* 188871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 188874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188882 */     // (umin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMINUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 188882 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZrr),
     /* 188887 */     GIR_RootConstrainSelectedInstOperands,
     /* 188888 */     // GIR_Coverage, 5613,
     /* 188888 */     GIR_Done,
     /* 188889 */   // Label 4224: @188889
     /* 188889 */   GIM_Reject,
     /* 188890 */ // Label 4221: @188890
     /* 188890 */ GIM_Reject,
     /* 188891 */ // Label 4156: @188891
     /* 188891 */ GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(189046),
     /* 188896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 188899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 188902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188906 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(188964), // Rule ID 24080 //
     /* 188911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 188914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188922 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188925 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188929 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188946 */     // (umin:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMINUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZrm),
     /* 188949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188951 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188953 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188962 */     GIR_RootConstrainSelectedInstOperands,
     /* 188963 */     // GIR_Coverage, 24080,
     /* 188963 */     GIR_EraseRootFromParent_Done,
     /* 188964 */   // Label 4226: @188964
     /* 188964 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(189022), // Rule ID 5598 //
     /* 188969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 188972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188984 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188987 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188991 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189004 */     // (umin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZrm),
     /* 189007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189009 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189011 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189020 */     GIR_RootConstrainSelectedInstOperands,
     /* 189021 */     // GIR_Coverage, 5598,
     /* 189021 */     GIR_EraseRootFromParent_Done,
     /* 189022 */   // Label 4227: @189022
     /* 189022 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(189045), // Rule ID 5595 //
     /* 189027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189038 */     // (umin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMINUBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 189038 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZrr),
     /* 189043 */     GIR_RootConstrainSelectedInstOperands,
     /* 189044 */     // GIR_Coverage, 5595,
     /* 189044 */     GIR_Done,
     /* 189045 */   // Label 4228: @189045
     /* 189045 */   GIM_Reject,
     /* 189046 */ // Label 4225: @189046
     /* 189046 */ GIM_Reject,
     /* 189047 */ // Label 4157: @189047
     /* 189047 */ GIM_Reject,
     /* 189048 */ // Label 57: @189048
     /* 189048 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4241*/ GIMT_Encode4(192368),
     /* 189059 */ /*GILLT_v2s64*//*Label 4229*/ GIMT_Encode4(189127), GIMT_Encode4(0),
     /* 189067 */ /*GILLT_v4s32*//*Label 4230*/ GIMT_Encode4(189456),
     /* 189071 */ /*GILLT_v4s64*//*Label 4231*/ GIMT_Encode4(189798), GIMT_Encode4(0),
     /* 189079 */ /*GILLT_v8s16*//*Label 4232*/ GIMT_Encode4(190115),
     /* 189083 */ /*GILLT_v8s32*//*Label 4233*/ GIMT_Encode4(190457),
     /* 189087 */ /*GILLT_v8s64*//*Label 4234*/ GIMT_Encode4(190772), GIMT_Encode4(0),
     /* 189095 */ /*GILLT_v16s8*//*Label 4235*/ GIMT_Encode4(190928),
     /* 189099 */ /*GILLT_v16s16*//*Label 4236*/ GIMT_Encode4(191270),
     /* 189103 */ /*GILLT_v16s32*//*Label 4237*/ GIMT_Encode4(191585), GIMT_Encode4(0),
     /* 189111 */ /*GILLT_v32s8*//*Label 4238*/ GIMT_Encode4(191741),
     /* 189115 */ /*GILLT_v32s16*//*Label 4239*/ GIMT_Encode4(192056), GIMT_Encode4(0),
     /* 189123 */ /*GILLT_v64s8*//*Label 4240*/ GIMT_Encode4(192212),
     /* 189127 */ // Label 4229: @189127
     /* 189127 */ GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(189455),
     /* 189132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 189135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189138 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(189200), // Rule ID 24020 //
     /* 189143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189158 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189161 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189165 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189182 */     // (umax:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMAXUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ128rm),
     /* 189185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189187 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189189 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189198 */     GIR_RootConstrainSelectedInstOperands,
     /* 189199 */     // GIR_Coverage, 24020,
     /* 189199 */     GIR_EraseRootFromParent_Done,
     /* 189200 */   // Label 4243: @189200
     /* 189200 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(189262), // Rule ID 5499 //
     /* 189205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189224 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189227 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189231 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189244 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ128rm),
     /* 189247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189249 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189251 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189260 */     GIR_RootConstrainSelectedInstOperands,
     /* 189261 */     // GIR_Coverage, 5499,
     /* 189261 */     GIR_EraseRootFromParent_Done,
     /* 189262 */   // Label 4244: @189262
     /* 189262 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(189289), // Rule ID 5496 //
     /* 189267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189282 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMAXUQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 189282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ128rr),
     /* 189287 */     GIR_RootConstrainSelectedInstOperands,
     /* 189288 */     // GIR_Coverage, 5496,
     /* 189288 */     GIR_Done,
     /* 189289 */   // Label 4245: @189289
     /* 189289 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(189454), // Rule ID 20001 //
     /* 189294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 189297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 189301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189309 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMAXUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 189309 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 189312 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189316 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 189323 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 189326 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189330 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189335 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 189338 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 189342 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 189345 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 189350 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 189355 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 189360 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 189363 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189367 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 189374 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 189377 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189381 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189386 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 189389 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 189393 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 189396 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 189401 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 189406 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 189411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 189414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 189418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189423 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 189426 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 189429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 189431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 189434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189436 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 189443 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 189448 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 189453 */     // GIR_Coverage, 20001,
     /* 189453 */     GIR_EraseRootFromParent_Done,
     /* 189454 */   // Label 4246: @189454
     /* 189454 */   GIM_Reject,
     /* 189455 */ // Label 4242: @189455
     /* 189455 */ GIM_Reject,
     /* 189456 */ // Label 4230: @189456
     /* 189456 */ GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(189797),
     /* 189461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 189464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189467 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(189529), // Rule ID 23501 //
     /* 189472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 189475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 189479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189487 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189490 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189494 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 189502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189511 */     // (umax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMAXUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDrm),
     /* 189514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189516 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189518 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189527 */     GIR_RootConstrainSelectedInstOperands,
     /* 189528 */     // GIR_Coverage, 23501,
     /* 189528 */     GIR_EraseRootFromParent_Done,
     /* 189529 */   // Label 4248: @189529
     /* 189529 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(189591), // Rule ID 24002 //
     /* 189534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189549 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189552 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189556 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189573 */     // (umax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMAXUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ128rm),
     /* 189576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189578 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189580 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189589 */     GIR_RootConstrainSelectedInstOperands,
     /* 189590 */     // GIR_Coverage, 24002,
     /* 189590 */     GIR_EraseRootFromParent_Done,
     /* 189591 */   // Label 4249: @189591
     /* 189591 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(189653), // Rule ID 3191 //
     /* 189596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 189599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 189603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 189607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189615 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189618 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189622 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189635 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDrm),
     /* 189638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189640 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189642 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189651 */     GIR_RootConstrainSelectedInstOperands,
     /* 189652 */     // GIR_Coverage, 3191,
     /* 189652 */     GIR_EraseRootFromParent_Done,
     /* 189653 */   // Label 4250: @189653
     /* 189653 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(189715), // Rule ID 5472 //
     /* 189658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189677 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189680 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189684 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189690 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189697 */     // (umax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ128rm),
     /* 189700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189702 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189704 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189713 */     GIR_RootConstrainSelectedInstOperands,
     /* 189714 */     // GIR_Coverage, 5472,
     /* 189714 */     GIR_EraseRootFromParent_Done,
     /* 189715 */   // Label 4251: @189715
     /* 189715 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(189742), // Rule ID 3190 //
     /* 189720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 189723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 189727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 189731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 189735 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMAXUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 189735 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDrr),
     /* 189740 */     GIR_RootConstrainSelectedInstOperands,
     /* 189741 */     // GIR_Coverage, 3190,
     /* 189741 */     GIR_Done,
     /* 189742 */   // Label 4252: @189742
     /* 189742 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(189769), // Rule ID 3232 //
     /* 189747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 189750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 189754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 189758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 189762 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMAXUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 189762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUDrr),
     /* 189767 */     GIR_RootConstrainSelectedInstOperands,
     /* 189768 */     // GIR_Coverage, 3232,
     /* 189768 */     GIR_Done,
     /* 189769 */   // Label 4253: @189769
     /* 189769 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(189796), // Rule ID 5469 //
     /* 189774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189789 */     // (umax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMAXUDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 189789 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ128rr),
     /* 189794 */     GIR_RootConstrainSelectedInstOperands,
     /* 189795 */     // GIR_Coverage, 5469,
     /* 189795 */     GIR_Done,
     /* 189796 */   // Label 4254: @189796
     /* 189796 */   GIM_Reject,
     /* 189797 */ // Label 4247: @189797
     /* 189797 */ GIM_Reject,
     /* 189798 */ // Label 4231: @189798
     /* 189798 */ GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(190114),
     /* 189803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 189806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 189809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189813 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(189871), // Rule ID 24014 //
     /* 189818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189829 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189832 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189836 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189853 */     // (umax:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMAXUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ256rm),
     /* 189856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189858 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189860 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189869 */     GIR_RootConstrainSelectedInstOperands,
     /* 189870 */     // GIR_Coverage, 24014,
     /* 189870 */     GIR_EraseRootFromParent_Done,
     /* 189871 */   // Label 4256: @189871
     /* 189871 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(189929), // Rule ID 5490 //
     /* 189876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189891 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189894 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189898 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189911 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ256rm),
     /* 189914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189916 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189918 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189927 */     GIR_RootConstrainSelectedInstOperands,
     /* 189928 */     // GIR_Coverage, 5490,
     /* 189928 */     GIR_EraseRootFromParent_Done,
     /* 189929 */   // Label 4257: @189929
     /* 189929 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(189952), // Rule ID 5487 //
     /* 189934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189945 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMAXUQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 189945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ256rr),
     /* 189950 */     GIR_RootConstrainSelectedInstOperands,
     /* 189951 */     // GIR_Coverage, 5487,
     /* 189951 */     GIR_Done,
     /* 189952 */   // Label 4258: @189952
     /* 189952 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(190113), // Rule ID 19999 //
     /* 189957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 189960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189968 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMAXUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 189968 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 189971 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189975 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 189982 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 189985 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189989 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189994 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 189997 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 190001 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 190004 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 190009 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190014 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 190019 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 190022 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190026 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 190033 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 190036 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190040 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190045 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 190048 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 190052 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 190055 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 190060 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190065 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 190070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 190073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 190077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190082 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 190085 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 190088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 190090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 190093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190095 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 190102 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 190107 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190112 */     // GIR_Coverage, 19999,
     /* 190112 */     GIR_EraseRootFromParent_Done,
     /* 190113 */   // Label 4259: @190113
     /* 190113 */   GIM_Reject,
     /* 190114 */ // Label 4255: @190114
     /* 190114 */ GIM_Reject,
     /* 190115 */ // Label 4232: @190115
     /* 190115 */ GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(190456),
     /* 190120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 190123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190126 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(190188), // Rule ID 23506 //
     /* 190131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 190134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190146 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190149 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190153 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190170 */     // (umax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMAXUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWrm),
     /* 190173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190175 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190177 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190186 */     GIR_RootConstrainSelectedInstOperands,
     /* 190187 */     // GIR_Coverage, 23506,
     /* 190187 */     GIR_EraseRootFromParent_Done,
     /* 190188 */   // Label 4261: @190188
     /* 190188 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(190250), // Rule ID 23987 //
     /* 190193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 190196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190208 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190211 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190215 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190232 */     // (umax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMAXUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ128rm),
     /* 190235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190237 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190239 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190248 */     GIR_RootConstrainSelectedInstOperands,
     /* 190249 */     // GIR_Coverage, 23987,
     /* 190249 */     GIR_EraseRootFromParent_Done,
     /* 190250 */   // Label 4262: @190250
     /* 190250 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(190312), // Rule ID 3201 //
     /* 190255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 190258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190274 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190277 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190281 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190294 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWrm),
     /* 190297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190299 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190301 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190310 */     GIR_RootConstrainSelectedInstOperands,
     /* 190311 */     // GIR_Coverage, 3201,
     /* 190311 */     GIR_EraseRootFromParent_Done,
     /* 190312 */   // Label 4263: @190312
     /* 190312 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(190374), // Rule ID 5448 //
     /* 190317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 190320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190336 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190339 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190343 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190349 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190356 */     // (umax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ128rm),
     /* 190359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190361 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190363 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190372 */     GIR_RootConstrainSelectedInstOperands,
     /* 190373 */     // GIR_Coverage, 5448,
     /* 190373 */     GIR_EraseRootFromParent_Done,
     /* 190374 */   // Label 4264: @190374
     /* 190374 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(190401), // Rule ID 3200 //
     /* 190379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 190382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190394 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMAXUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 190394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWrr),
     /* 190399 */     GIR_RootConstrainSelectedInstOperands,
     /* 190400 */     // GIR_Coverage, 3200,
     /* 190400 */     GIR_Done,
     /* 190401 */   // Label 4265: @190401
     /* 190401 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(190428), // Rule ID 3234 //
     /* 190406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 190409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190421 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMAXUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 190421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUWrr),
     /* 190426 */     GIR_RootConstrainSelectedInstOperands,
     /* 190427 */     // GIR_Coverage, 3234,
     /* 190427 */     GIR_Done,
     /* 190428 */   // Label 4266: @190428
     /* 190428 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(190455), // Rule ID 5445 //
     /* 190433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 190436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190448 */     // (umax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMAXUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 190448 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ128rr),
     /* 190453 */     GIR_RootConstrainSelectedInstOperands,
     /* 190454 */     // GIR_Coverage, 5445,
     /* 190454 */     GIR_Done,
     /* 190455 */   // Label 4267: @190455
     /* 190455 */   GIM_Reject,
     /* 190456 */ // Label 4260: @190456
     /* 190456 */ GIM_Reject,
     /* 190457 */ // Label 4233: @190457
     /* 190457 */ GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(190771),
     /* 190462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 190465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 190468 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(190530), // Rule ID 23510 //
     /* 190473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 190476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 190480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190488 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190491 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190495 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 190503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190512 */     // (umax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMAXUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDYrm),
     /* 190515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190517 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190519 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190528 */     GIR_RootConstrainSelectedInstOperands,
     /* 190529 */     // GIR_Coverage, 23510,
     /* 190529 */     GIR_EraseRootFromParent_Done,
     /* 190530 */   // Label 4269: @190530
     /* 190530 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(190592), // Rule ID 23996 //
     /* 190535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190550 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190553 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190557 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190574 */     // (umax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMAXUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ256rm),
     /* 190577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190579 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190581 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190590 */     GIR_RootConstrainSelectedInstOperands,
     /* 190591 */     // GIR_Coverage, 23996,
     /* 190591 */     GIR_EraseRootFromParent_Done,
     /* 190592 */   // Label 4270: @190592
     /* 190592 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(190654), // Rule ID 3209 //
     /* 190597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 190600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 190604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 190608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190616 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190619 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190623 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190629 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190636 */     // (umax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDYrm),
     /* 190639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190641 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190643 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190652 */     GIR_RootConstrainSelectedInstOperands,
     /* 190653 */     // GIR_Coverage, 3209,
     /* 190653 */     GIR_EraseRootFromParent_Done,
     /* 190654 */   // Label 4271: @190654
     /* 190654 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(190716), // Rule ID 5463 //
     /* 190659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190678 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190681 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190685 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190698 */     // (umax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ256rm),
     /* 190701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190703 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190705 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190714 */     GIR_RootConstrainSelectedInstOperands,
     /* 190715 */     // GIR_Coverage, 5463,
     /* 190715 */     GIR_EraseRootFromParent_Done,
     /* 190716 */   // Label 4272: @190716
     /* 190716 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(190743), // Rule ID 3208 //
     /* 190721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 190724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 190728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 190732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 190736 */     // (umax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMAXUDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 190736 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDYrr),
     /* 190741 */     GIR_RootConstrainSelectedInstOperands,
     /* 190742 */     // GIR_Coverage, 3208,
     /* 190742 */     GIR_Done,
     /* 190743 */   // Label 4273: @190743
     /* 190743 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(190770), // Rule ID 5460 //
     /* 190748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190763 */     // (umax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMAXUDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 190763 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ256rr),
     /* 190768 */     GIR_RootConstrainSelectedInstOperands,
     /* 190769 */     // GIR_Coverage, 5460,
     /* 190769 */     GIR_Done,
     /* 190770 */   // Label 4274: @190770
     /* 190770 */   GIM_Reject,
     /* 190771 */ // Label 4268: @190771
     /* 190771 */ GIM_Reject,
     /* 190772 */ // Label 4234: @190772
     /* 190772 */ GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(190927),
     /* 190777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 190780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 190783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 190787 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(190845), // Rule ID 24008 //
     /* 190792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 190795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190803 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190806 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190810 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 190818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190820 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190827 */     // (umax:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMAXUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrm),
     /* 190830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190832 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190834 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190843 */     GIR_RootConstrainSelectedInstOperands,
     /* 190844 */     // GIR_Coverage, 24008,
     /* 190844 */     GIR_EraseRootFromParent_Done,
     /* 190845 */   // Label 4276: @190845
     /* 190845 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(190903), // Rule ID 5481 //
     /* 190850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 190853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 190857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190865 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190868 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190872 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190878 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190885 */     // (umax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrm),
     /* 190888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190890 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190892 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190901 */     GIR_RootConstrainSelectedInstOperands,
     /* 190902 */     // GIR_Coverage, 5481,
     /* 190902 */     GIR_EraseRootFromParent_Done,
     /* 190903 */   // Label 4277: @190903
     /* 190903 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(190926), // Rule ID 5478 //
     /* 190908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 190911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 190915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 190919 */     // (umax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMAXUQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 190919 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 190924 */     GIR_RootConstrainSelectedInstOperands,
     /* 190925 */     // GIR_Coverage, 5478,
     /* 190925 */     GIR_Done,
     /* 190926 */   // Label 4278: @190926
     /* 190926 */   GIM_Reject,
     /* 190927 */ // Label 4275: @190927
     /* 190927 */ GIM_Reject,
     /* 190928 */ // Label 4235: @190928
     /* 190928 */ GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(191269),
     /* 190933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 190936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190939 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(191001), // Rule ID 23465 //
     /* 190944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 190947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190959 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190962 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190966 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190983 */     // (umax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMAXUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBrm),
     /* 190986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190988 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190990 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190999 */     GIR_RootConstrainSelectedInstOperands,
     /* 191000 */     // GIR_Coverage, 23465,
     /* 191000 */     GIR_EraseRootFromParent_Done,
     /* 191001 */   // Label 4280: @191001
     /* 191001 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(191063), // Rule ID 23978 //
     /* 191006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191021 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191024 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191028 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191045 */     // (umax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMAXUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ128rm),
     /* 191048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191050 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191052 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191061 */     GIR_RootConstrainSelectedInstOperands,
     /* 191062 */     // GIR_Coverage, 23978,
     /* 191062 */     GIR_EraseRootFromParent_Done,
     /* 191063 */   // Label 4281: @191063
     /* 191063 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(191125), // Rule ID 2648 //
     /* 191068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 191071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191087 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191090 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191094 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191100 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191107 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBrm),
     /* 191110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191112 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191114 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191123 */     GIR_RootConstrainSelectedInstOperands,
     /* 191124 */     // GIR_Coverage, 2648,
     /* 191124 */     GIR_EraseRootFromParent_Done,
     /* 191125 */   // Label 4282: @191125
     /* 191125 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(191187), // Rule ID 5430 //
     /* 191130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191149 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191152 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191156 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191169 */     // (umax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ128rm),
     /* 191172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191174 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191176 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191185 */     GIR_RootConstrainSelectedInstOperands,
     /* 191186 */     // GIR_Coverage, 5430,
     /* 191186 */     GIR_EraseRootFromParent_Done,
     /* 191187 */   // Label 4283: @191187
     /* 191187 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(191214), // Rule ID 2647 //
     /* 191192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 191195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191207 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMAXUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 191207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBrr),
     /* 191212 */     GIR_RootConstrainSelectedInstOperands,
     /* 191213 */     // GIR_Coverage, 2647,
     /* 191213 */     GIR_Done,
     /* 191214 */   // Label 4284: @191214
     /* 191214 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(191241), // Rule ID 2649 //
     /* 191219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 191222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191234 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMAXUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 191234 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUBrr),
     /* 191239 */     GIR_RootConstrainSelectedInstOperands,
     /* 191240 */     // GIR_Coverage, 2649,
     /* 191240 */     GIR_Done,
     /* 191241 */   // Label 4285: @191241
     /* 191241 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(191268), // Rule ID 5427 //
     /* 191246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191261 */     // (umax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMAXUBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 191261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ128rr),
     /* 191266 */     GIR_RootConstrainSelectedInstOperands,
     /* 191267 */     // GIR_Coverage, 5427,
     /* 191267 */     GIR_Done,
     /* 191268 */   // Label 4286: @191268
     /* 191268 */   GIM_Reject,
     /* 191269 */ // Label 4279: @191269
     /* 191269 */ GIM_Reject,
     /* 191270 */ // Label 4236: @191270
     /* 191270 */ GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(191584),
     /* 191275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 191278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 191281 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(191343), // Rule ID 23515 //
     /* 191286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 191289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191301 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191304 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191308 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191318 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191325 */     // (umax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMAXUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWYrm),
     /* 191328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191330 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191332 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191341 */     GIR_RootConstrainSelectedInstOperands,
     /* 191342 */     // GIR_Coverage, 23515,
     /* 191342 */     GIR_EraseRootFromParent_Done,
     /* 191343 */   // Label 4288: @191343
     /* 191343 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(191405), // Rule ID 23984 //
     /* 191348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191363 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191366 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191370 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191387 */     // (umax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMAXUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ256rm),
     /* 191390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191392 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191394 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191403 */     GIR_RootConstrainSelectedInstOperands,
     /* 191404 */     // GIR_Coverage, 23984,
     /* 191404 */     GIR_EraseRootFromParent_Done,
     /* 191405 */   // Label 4289: @191405
     /* 191405 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(191467), // Rule ID 3219 //
     /* 191410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 191413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191429 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191432 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191436 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191449 */     // (umax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWYrm),
     /* 191452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191454 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191456 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191465 */     GIR_RootConstrainSelectedInstOperands,
     /* 191466 */     // GIR_Coverage, 3219,
     /* 191466 */     GIR_EraseRootFromParent_Done,
     /* 191467 */   // Label 4290: @191467
     /* 191467 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(191529), // Rule ID 5442 //
     /* 191472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191491 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191494 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191498 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191511 */     // (umax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ256rm),
     /* 191514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191516 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191518 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191527 */     GIR_RootConstrainSelectedInstOperands,
     /* 191528 */     // GIR_Coverage, 5442,
     /* 191528 */     GIR_EraseRootFromParent_Done,
     /* 191529 */   // Label 4291: @191529
     /* 191529 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(191556), // Rule ID 3218 //
     /* 191534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 191537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191549 */     // (umax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMAXUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 191549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWYrr),
     /* 191554 */     GIR_RootConstrainSelectedInstOperands,
     /* 191555 */     // GIR_Coverage, 3218,
     /* 191555 */     GIR_Done,
     /* 191556 */   // Label 4292: @191556
     /* 191556 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(191583), // Rule ID 5439 //
     /* 191561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191576 */     // (umax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMAXUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 191576 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ256rr),
     /* 191581 */     GIR_RootConstrainSelectedInstOperands,
     /* 191582 */     // GIR_Coverage, 5439,
     /* 191582 */     GIR_Done,
     /* 191583 */   // Label 4293: @191583
     /* 191583 */   GIM_Reject,
     /* 191584 */ // Label 4287: @191584
     /* 191584 */ GIM_Reject,
     /* 191585 */ // Label 4237: @191585
     /* 191585 */ GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(191740),
     /* 191590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 191593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 191596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191600 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(191658), // Rule ID 23990 //
     /* 191605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 191608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191616 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191619 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191623 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191640 */     // (umax:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMAXUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZrm),
     /* 191643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191645 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191647 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191656 */     GIR_RootConstrainSelectedInstOperands,
     /* 191657 */     // GIR_Coverage, 23990,
     /* 191657 */     GIR_EraseRootFromParent_Done,
     /* 191658 */   // Label 4295: @191658
     /* 191658 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(191716), // Rule ID 5454 //
     /* 191663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 191666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191678 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191681 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191685 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191698 */     // (umax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZrm),
     /* 191701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191703 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191705 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191714 */     GIR_RootConstrainSelectedInstOperands,
     /* 191715 */     // GIR_Coverage, 5454,
     /* 191715 */     GIR_EraseRootFromParent_Done,
     /* 191716 */   // Label 4296: @191716
     /* 191716 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(191739), // Rule ID 5451 //
     /* 191721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 191724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191732 */     // (umax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMAXUDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 191732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZrr),
     /* 191737 */     GIR_RootConstrainSelectedInstOperands,
     /* 191738 */     // GIR_Coverage, 5451,
     /* 191738 */     GIR_Done,
     /* 191739 */   // Label 4297: @191739
     /* 191739 */   GIM_Reject,
     /* 191740 */ // Label 4294: @191740
     /* 191740 */ GIM_Reject,
     /* 191741 */ // Label 4238: @191741
     /* 191741 */ GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(192055),
     /* 191746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 191749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 191752 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(191814), // Rule ID 23467 //
     /* 191757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 191760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191772 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191775 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191779 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191789 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191796 */     // (umax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMAXUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBYrm),
     /* 191799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191801 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191803 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191812 */     GIR_RootConstrainSelectedInstOperands,
     /* 191813 */     // GIR_Coverage, 23467,
     /* 191813 */     GIR_EraseRootFromParent_Done,
     /* 191814 */   // Label 4299: @191814
     /* 191814 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(191876), // Rule ID 23975 //
     /* 191819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191834 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191837 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191841 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191858 */     // (umax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMAXUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ256rm),
     /* 191861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191863 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191865 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191874 */     GIR_RootConstrainSelectedInstOperands,
     /* 191875 */     // GIR_Coverage, 23975,
     /* 191875 */     GIR_EraseRootFromParent_Done,
     /* 191876 */   // Label 4300: @191876
     /* 191876 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(191938), // Rule ID 2652 //
     /* 191881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 191884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191900 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191903 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191907 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191920 */     // (umax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBYrm),
     /* 191923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191925 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191927 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191936 */     GIR_RootConstrainSelectedInstOperands,
     /* 191937 */     // GIR_Coverage, 2652,
     /* 191937 */     GIR_EraseRootFromParent_Done,
     /* 191938 */   // Label 4301: @191938
     /* 191938 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(192000), // Rule ID 5424 //
     /* 191943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191962 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191965 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191969 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191982 */     // (umax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ256rm),
     /* 191985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191987 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191989 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191998 */     GIR_RootConstrainSelectedInstOperands,
     /* 191999 */     // GIR_Coverage, 5424,
     /* 191999 */     GIR_EraseRootFromParent_Done,
     /* 192000 */   // Label 4302: @192000
     /* 192000 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(192027), // Rule ID 2651 //
     /* 192005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192020 */     // (umax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMAXUBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 192020 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBYrr),
     /* 192025 */     GIR_RootConstrainSelectedInstOperands,
     /* 192026 */     // GIR_Coverage, 2651,
     /* 192026 */     GIR_Done,
     /* 192027 */   // Label 4303: @192027
     /* 192027 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(192054), // Rule ID 5421 //
     /* 192032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192047 */     // (umax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMAXUBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 192047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ256rr),
     /* 192052 */     GIR_RootConstrainSelectedInstOperands,
     /* 192053 */     // GIR_Coverage, 5421,
     /* 192053 */     GIR_Done,
     /* 192054 */   // Label 4304: @192054
     /* 192054 */   GIM_Reject,
     /* 192055 */ // Label 4298: @192055
     /* 192055 */ GIM_Reject,
     /* 192056 */ // Label 4239: @192056
     /* 192056 */ GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(192211),
     /* 192061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 192064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 192067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192071 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(192129), // Rule ID 23981 //
     /* 192076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192087 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192090 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192094 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192111 */     // (umax:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMAXUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZrm),
     /* 192114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192116 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192127 */     GIR_RootConstrainSelectedInstOperands,
     /* 192128 */     // GIR_Coverage, 23981,
     /* 192128 */     GIR_EraseRootFromParent_Done,
     /* 192129 */   // Label 4306: @192129
     /* 192129 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(192187), // Rule ID 5436 //
     /* 192134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192149 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192152 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192156 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192169 */     // (umax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZrm),
     /* 192172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192174 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192176 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192185 */     GIR_RootConstrainSelectedInstOperands,
     /* 192186 */     // GIR_Coverage, 5436,
     /* 192186 */     GIR_EraseRootFromParent_Done,
     /* 192187 */   // Label 4307: @192187
     /* 192187 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(192210), // Rule ID 5433 //
     /* 192192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192203 */     // (umax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMAXUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 192203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZrr),
     /* 192208 */     GIR_RootConstrainSelectedInstOperands,
     /* 192209 */     // GIR_Coverage, 5433,
     /* 192209 */     GIR_Done,
     /* 192210 */   // Label 4308: @192210
     /* 192210 */   GIM_Reject,
     /* 192211 */ // Label 4305: @192211
     /* 192211 */ GIM_Reject,
     /* 192212 */ // Label 4240: @192212
     /* 192212 */ GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(192367),
     /* 192217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 192220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 192223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192227 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(192285), // Rule ID 23972 //
     /* 192232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192243 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192246 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192250 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192260 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192267 */     // (umax:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMAXUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZrm),
     /* 192270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192272 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192274 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192283 */     GIR_RootConstrainSelectedInstOperands,
     /* 192284 */     // GIR_Coverage, 23972,
     /* 192284 */     GIR_EraseRootFromParent_Done,
     /* 192285 */   // Label 4310: @192285
     /* 192285 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(192343), // Rule ID 5418 //
     /* 192290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192305 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192308 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192312 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192318 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192325 */     // (umax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZrm),
     /* 192328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192330 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192332 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192341 */     GIR_RootConstrainSelectedInstOperands,
     /* 192342 */     // GIR_Coverage, 5418,
     /* 192342 */     GIR_EraseRootFromParent_Done,
     /* 192343 */   // Label 4311: @192343
     /* 192343 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(192366), // Rule ID 5415 //
     /* 192348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192359 */     // (umax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMAXUBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 192359 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZrr),
     /* 192364 */     GIR_RootConstrainSelectedInstOperands,
     /* 192365 */     // GIR_Coverage, 5415,
     /* 192365 */     GIR_Done,
     /* 192366 */   // Label 4312: @192366
     /* 192366 */   GIM_Reject,
     /* 192367 */ // Label 4309: @192367
     /* 192367 */ GIM_Reject,
     /* 192368 */ // Label 4241: @192368
     /* 192368 */ GIM_Reject,
     /* 192369 */ // Label 58: @192369
     /* 192369 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4325*/ GIMT_Encode4(194249),
     /* 192380 */ /*GILLT_v2s64*//*Label 4313*/ GIMT_Encode4(192448), GIMT_Encode4(0),
     /* 192388 */ /*GILLT_v4s32*//*Label 4314*/ GIMT_Encode4(192644),
     /* 192392 */ /*GILLT_v4s64*//*Label 4315*/ GIMT_Encode4(192835), GIMT_Encode4(0),
     /* 192400 */ /*GILLT_v8s16*//*Label 4316*/ GIMT_Encode4(193023),
     /* 192404 */ /*GILLT_v8s32*//*Label 4317*/ GIMT_Encode4(193214),
     /* 192408 */ /*GILLT_v8s64*//*Label 4318*/ GIMT_Encode4(193382), GIMT_Encode4(0),
     /* 192416 */ /*GILLT_v16s8*//*Label 4319*/ GIMT_Encode4(193467),
     /* 192420 */ /*GILLT_v16s16*//*Label 4320*/ GIMT_Encode4(193658),
     /* 192424 */ /*GILLT_v16s32*//*Label 4321*/ GIMT_Encode4(193826), GIMT_Encode4(0),
     /* 192432 */ /*GILLT_v32s8*//*Label 4322*/ GIMT_Encode4(193911),
     /* 192436 */ /*GILLT_v32s16*//*Label 4323*/ GIMT_Encode4(194079), GIMT_Encode4(0),
     /* 192444 */ /*GILLT_v64s8*//*Label 4324*/ GIMT_Encode4(194164),
     /* 192448 */ // Label 4313: @192448
     /* 192448 */ GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(192643),
     /* 192453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 192456 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(192512), // Rule ID 13266 //
     /* 192461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 192464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 192468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192476 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192479 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192483 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192496 */     // (abs:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /* 192496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSQZ128rm),
     /* 192499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192501 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 192505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192510 */     GIR_RootConstrainSelectedInstOperands,
     /* 192511 */     // GIR_Coverage, 13266,
     /* 192511 */     GIR_EraseRootFromParent_Done,
     /* 192512 */   // Label 4327: @192512
     /* 192512 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(192535), // Rule ID 13263 //
     /* 192517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 192520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 192524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 192528 */     // (abs:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPABSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 192528 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZ128rr),
     /* 192533 */     GIR_RootConstrainSelectedInstOperands,
     /* 192534 */     // GIR_Coverage, 13263,
     /* 192534 */     GIR_Done,
     /* 192535 */   // Label 4328: @192535
     /* 192535 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(192642), // Rule ID 21823 //
     /* 192540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 192543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 192547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 192551 */     // (abs:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPABSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 192551 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 192554 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 192558 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 192565 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 192568 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 192572 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192577 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 192580 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 192584 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 192587 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 192592 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 192597 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 192602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 192605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 192609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192614 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 192617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 192619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 192622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192624 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 192631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 192636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 192641 */     // GIR_Coverage, 21823,
     /* 192641 */     GIR_EraseRootFromParent_Done,
     /* 192642 */   // Label 4329: @192642
     /* 192642 */   GIM_Reject,
     /* 192643 */ // Label 4326: @192643
     /* 192643 */ GIM_Reject,
     /* 192644 */ // Label 4314: @192644
     /* 192644 */ GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(192834),
     /* 192649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 192652 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(192708), // Rule ID 2994 //
     /* 192657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 192660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 192664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192672 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192675 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192679 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192692 */     // (abs:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /* 192692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDrm),
     /* 192695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192697 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 192701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192706 */     GIR_RootConstrainSelectedInstOperands,
     /* 192707 */     // GIR_Coverage, 2994,
     /* 192707 */     GIR_EraseRootFromParent_Done,
     /* 192708 */   // Label 4331: @192708
     /* 192708 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(192764), // Rule ID 13293 //
     /* 192713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 192716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 192720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192728 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192731 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192735 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192748 */     // (abs:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)
     /* 192748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDZ128rm),
     /* 192751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192753 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 192757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192762 */     GIR_RootConstrainSelectedInstOperands,
     /* 192763 */     // GIR_Coverage, 13293,
     /* 192763 */     GIR_EraseRootFromParent_Done,
     /* 192764 */   // Label 4332: @192764
     /* 192764 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(192787), // Rule ID 2993 //
     /* 192769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 192772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 192776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 192780 */     // (abs:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)  =>  (VPABSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)
     /* 192780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDrr),
     /* 192785 */     GIR_RootConstrainSelectedInstOperands,
     /* 192786 */     // GIR_Coverage, 2993,
     /* 192786 */     GIR_Done,
     /* 192787 */   // Label 4333: @192787
     /* 192787 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(192810), // Rule ID 3005 //
     /* 192792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 192795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 192799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 192803 */     // (abs:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)  =>  (PABSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)
     /* 192803 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSDrr),
     /* 192808 */     GIR_RootConstrainSelectedInstOperands,
     /* 192809 */     // GIR_Coverage, 3005,
     /* 192809 */     GIR_Done,
     /* 192810 */   // Label 4334: @192810
     /* 192810 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(192833), // Rule ID 13290 //
     /* 192815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 192818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 192822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 192826 */     // (abs:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPABSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 192826 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZ128rr),
     /* 192831 */     GIR_RootConstrainSelectedInstOperands,
     /* 192832 */     // GIR_Coverage, 13290,
     /* 192832 */     GIR_Done,
     /* 192833 */   // Label 4335: @192833
     /* 192833 */   GIM_Reject,
     /* 192834 */ // Label 4330: @192834
     /* 192834 */ GIM_Reject,
     /* 192835 */ // Label 4315: @192835
     /* 192835 */ GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(193022),
     /* 192840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 192843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192847 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(192899), // Rule ID 13257 //
     /* 192852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 192855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192863 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192866 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192870 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192883 */     // (abs:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)
     /* 192883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSQZ256rm),
     /* 192886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192888 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 192892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192897 */     GIR_RootConstrainSelectedInstOperands,
     /* 192898 */     // GIR_Coverage, 13257,
     /* 192898 */     GIR_EraseRootFromParent_Done,
     /* 192899 */   // Label 4337: @192899
     /* 192899 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(192918), // Rule ID 13254 //
     /* 192904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 192907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192911 */     // (abs:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPABSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 192911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZ256rr),
     /* 192916 */     GIR_RootConstrainSelectedInstOperands,
     /* 192917 */     // GIR_Coverage, 13254,
     /* 192917 */     GIR_Done,
     /* 192918 */   // Label 4338: @192918
     /* 192918 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(193021), // Rule ID 21822 //
     /* 192923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 192926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192930 */     // (abs:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPABSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 192930 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 192933 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 192937 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 192944 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 192947 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 192951 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192956 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 192959 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 192963 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 192966 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 192971 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 192976 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 192981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 192984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 192988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192993 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 192996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 192998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 193001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193003 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 193010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 193015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193020 */     // GIR_Coverage, 21822,
     /* 193020 */     GIR_EraseRootFromParent_Done,
     /* 193021 */   // Label 4339: @193021
     /* 193021 */   GIM_Reject,
     /* 193022 */ // Label 4336: @193022
     /* 193022 */ GIM_Reject,
     /* 193023 */ // Label 4316: @193023
     /* 193023 */ GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(193213),
     /* 193028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 193031 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(193087), // Rule ID 2992 //
     /* 193036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 193039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193051 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193054 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193058 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193071 */     // (abs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /* 193071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWrm),
     /* 193074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 193080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193085 */     GIR_RootConstrainSelectedInstOperands,
     /* 193086 */     // GIR_Coverage, 2992,
     /* 193086 */     GIR_EraseRootFromParent_Done,
     /* 193087 */   // Label 4341: @193087
     /* 193087 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(193143), // Rule ID 13314 //
     /* 193092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 193095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193107 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193114 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193127 */     // (abs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWZ128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)
     /* 193127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWZ128rm),
     /* 193130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193132 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 193136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193141 */     GIR_RootConstrainSelectedInstOperands,
     /* 193142 */     // GIR_Coverage, 13314,
     /* 193142 */     GIR_EraseRootFromParent_Done,
     /* 193143 */   // Label 4342: @193143
     /* 193143 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(193166), // Rule ID 2991 //
     /* 193148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 193151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193159 */     // (abs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)  =>  (VPABSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)
     /* 193159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWrr),
     /* 193164 */     GIR_RootConstrainSelectedInstOperands,
     /* 193165 */     // GIR_Coverage, 2991,
     /* 193165 */     GIR_Done,
     /* 193166 */   // Label 4343: @193166
     /* 193166 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(193189), // Rule ID 3003 //
     /* 193171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 193174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193182 */     // (abs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)  =>  (PABSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)
     /* 193182 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSWrr),
     /* 193187 */     GIR_RootConstrainSelectedInstOperands,
     /* 193188 */     // GIR_Coverage, 3003,
     /* 193188 */     GIR_Done,
     /* 193189 */   // Label 4344: @193189
     /* 193189 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(193212), // Rule ID 13311 //
     /* 193194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 193197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193205 */     // (abs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (VPABSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)
     /* 193205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZ128rr),
     /* 193210 */     GIR_RootConstrainSelectedInstOperands,
     /* 193211 */     // GIR_Coverage, 13311,
     /* 193211 */     GIR_Done,
     /* 193212 */   // Label 4345: @193212
     /* 193212 */   GIM_Reject,
     /* 193213 */ // Label 4340: @193213
     /* 193213 */ GIM_Reject,
     /* 193214 */ // Label 4317: @193214
     /* 193214 */ GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(193381),
     /* 193219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 193222 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(193278), // Rule ID 3000 //
     /* 193227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 193230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 193234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193242 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193245 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193249 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193255 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193262 */     // (abs:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 193262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDYrm),
     /* 193265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193267 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 193271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193276 */     GIR_RootConstrainSelectedInstOperands,
     /* 193277 */     // GIR_Coverage, 3000,
     /* 193277 */     GIR_EraseRootFromParent_Done,
     /* 193278 */   // Label 4347: @193278
     /* 193278 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(193334), // Rule ID 13284 //
     /* 193283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193298 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193301 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193305 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193318 */     // (abs:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)
     /* 193318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDZ256rm),
     /* 193321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193323 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 193327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193332 */     GIR_RootConstrainSelectedInstOperands,
     /* 193333 */     // GIR_Coverage, 13284,
     /* 193333 */     GIR_EraseRootFromParent_Done,
     /* 193334 */   // Label 4348: @193334
     /* 193334 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(193357), // Rule ID 2999 //
     /* 193339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 193342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 193346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 193350 */     // (abs:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src)  =>  (VPABSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src)
     /* 193350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDYrr),
     /* 193355 */     GIR_RootConstrainSelectedInstOperands,
     /* 193356 */     // GIR_Coverage, 2999,
     /* 193356 */     GIR_Done,
     /* 193357 */   // Label 4349: @193357
     /* 193357 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(193380), // Rule ID 13281 //
     /* 193362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193373 */     // (abs:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPABSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 193373 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZ256rr),
     /* 193378 */     GIR_RootConstrainSelectedInstOperands,
     /* 193379 */     // GIR_Coverage, 13281,
     /* 193379 */     GIR_Done,
     /* 193380 */   // Label 4350: @193380
     /* 193380 */   GIM_Reject,
     /* 193381 */ // Label 4346: @193381
     /* 193381 */ GIM_Reject,
     /* 193382 */ // Label 4318: @193382
     /* 193382 */ GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(193466),
     /* 193387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 193390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 193394 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(193446), // Rule ID 13248 //
     /* 193399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 193402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193410 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193413 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193417 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193430 */     // (abs:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)
     /* 193430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSQZrm),
     /* 193433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193435 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 193439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193444 */     GIR_RootConstrainSelectedInstOperands,
     /* 193445 */     // GIR_Coverage, 13248,
     /* 193445 */     GIR_EraseRootFromParent_Done,
     /* 193446 */   // Label 4352: @193446
     /* 193446 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(193465), // Rule ID 13245 //
     /* 193451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 193454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 193458 */     // (abs:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPABSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 193458 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 193463 */     GIR_RootConstrainSelectedInstOperands,
     /* 193464 */     // GIR_Coverage, 13245,
     /* 193464 */     GIR_Done,
     /* 193465 */   // Label 4353: @193465
     /* 193465 */   GIM_Reject,
     /* 193466 */ // Label 4351: @193466
     /* 193466 */ GIM_Reject,
     /* 193467 */ // Label 4319: @193467
     /* 193467 */ GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(193657),
     /* 193472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 193475 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(193531), // Rule ID 2990 //
     /* 193480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 193483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193495 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193498 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193502 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193508 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193515 */     // (abs:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 193515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBrm),
     /* 193518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193520 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 193524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193529 */     GIR_RootConstrainSelectedInstOperands,
     /* 193530 */     // GIR_Coverage, 2990,
     /* 193530 */     GIR_EraseRootFromParent_Done,
     /* 193531 */   // Label 4355: @193531
     /* 193531 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(193587), // Rule ID 13332 //
     /* 193536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 193539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193551 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193554 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193558 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193571 */     // (abs:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBZ128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)
     /* 193571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBZ128rm),
     /* 193574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193576 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 193580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193585 */     GIR_RootConstrainSelectedInstOperands,
     /* 193586 */     // GIR_Coverage, 13332,
     /* 193586 */     GIR_EraseRootFromParent_Done,
     /* 193587 */   // Label 4356: @193587
     /* 193587 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(193610), // Rule ID 2989 //
     /* 193592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 193595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193603 */     // (abs:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)  =>  (VPABSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)
     /* 193603 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBrr),
     /* 193608 */     GIR_RootConstrainSelectedInstOperands,
     /* 193609 */     // GIR_Coverage, 2989,
     /* 193609 */     GIR_Done,
     /* 193610 */   // Label 4357: @193610
     /* 193610 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(193633), // Rule ID 3001 //
     /* 193615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 193618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193626 */     // (abs:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)  =>  (PABSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)
     /* 193626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSBrr),
     /* 193631 */     GIR_RootConstrainSelectedInstOperands,
     /* 193632 */     // GIR_Coverage, 3001,
     /* 193632 */     GIR_Done,
     /* 193633 */   // Label 4358: @193633
     /* 193633 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(193656), // Rule ID 13329 //
     /* 193638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 193641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193649 */     // (abs:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (VPABSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)
     /* 193649 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZ128rr),
     /* 193654 */     GIR_RootConstrainSelectedInstOperands,
     /* 193655 */     // GIR_Coverage, 13329,
     /* 193655 */     GIR_Done,
     /* 193656 */   // Label 4359: @193656
     /* 193656 */   GIM_Reject,
     /* 193657 */ // Label 4354: @193657
     /* 193657 */ GIM_Reject,
     /* 193658 */ // Label 4320: @193658
     /* 193658 */ GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(193825),
     /* 193663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 193666 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(193722), // Rule ID 2998 //
     /* 193671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 193674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 193678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193686 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193689 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193693 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193699 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193706 */     // (abs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 193706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWYrm),
     /* 193709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193711 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 193715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193720 */     GIR_RootConstrainSelectedInstOperands,
     /* 193721 */     // GIR_Coverage, 2998,
     /* 193721 */     GIR_EraseRootFromParent_Done,
     /* 193722 */   // Label 4361: @193722
     /* 193722 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(193778), // Rule ID 13308 //
     /* 193727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 193730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193742 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193745 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193749 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193762 */     // (abs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)
     /* 193762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWZ256rm),
     /* 193765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193767 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 193771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193776 */     GIR_RootConstrainSelectedInstOperands,
     /* 193777 */     // GIR_Coverage, 13308,
     /* 193777 */     GIR_EraseRootFromParent_Done,
     /* 193778 */   // Label 4362: @193778
     /* 193778 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(193801), // Rule ID 2997 //
     /* 193783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 193786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 193790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 193794 */     // (abs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src)  =>  (VPABSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src)
     /* 193794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWYrr),
     /* 193799 */     GIR_RootConstrainSelectedInstOperands,
     /* 193800 */     // GIR_Coverage, 2997,
     /* 193800 */     GIR_Done,
     /* 193801 */   // Label 4363: @193801
     /* 193801 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(193824), // Rule ID 13305 //
     /* 193806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 193809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193817 */     // (abs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (VPABSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)
     /* 193817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZ256rr),
     /* 193822 */     GIR_RootConstrainSelectedInstOperands,
     /* 193823 */     // GIR_Coverage, 13305,
     /* 193823 */     GIR_Done,
     /* 193824 */   // Label 4364: @193824
     /* 193824 */   GIM_Reject,
     /* 193825 */ // Label 4360: @193825
     /* 193825 */ GIM_Reject,
     /* 193826 */ // Label 4321: @193826
     /* 193826 */ GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(193910),
     /* 193831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 193834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 193838 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(193890), // Rule ID 13275 //
     /* 193843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 193846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193854 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193857 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193861 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193867 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193874 */     // (abs:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)
     /* 193874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDZrm),
     /* 193877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193879 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 193883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193888 */     GIR_RootConstrainSelectedInstOperands,
     /* 193889 */     // GIR_Coverage, 13275,
     /* 193889 */     GIR_EraseRootFromParent_Done,
     /* 193890 */   // Label 4366: @193890
     /* 193890 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(193909), // Rule ID 13272 //
     /* 193895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 193898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 193902 */     // (abs:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPABSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 193902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZrr),
     /* 193907 */     GIR_RootConstrainSelectedInstOperands,
     /* 193908 */     // GIR_Coverage, 13272,
     /* 193908 */     GIR_Done,
     /* 193909 */   // Label 4367: @193909
     /* 193909 */   GIM_Reject,
     /* 193910 */ // Label 4365: @193910
     /* 193910 */ GIM_Reject,
     /* 193911 */ // Label 4322: @193911
     /* 193911 */ GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(194078),
     /* 193916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 193919 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(193975), // Rule ID 2996 //
     /* 193924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 193927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 193931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193939 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193942 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193946 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193959 */     // (abs:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /* 193959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBYrm),
     /* 193962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193964 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 193968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193973 */     GIR_RootConstrainSelectedInstOperands,
     /* 193974 */     // GIR_Coverage, 2996,
     /* 193974 */     GIR_EraseRootFromParent_Done,
     /* 193975 */   // Label 4369: @193975
     /* 193975 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(194031), // Rule ID 13326 //
     /* 193980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 193983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193995 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193998 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194002 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194015 */     // (abs:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBZ256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)
     /* 194015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBZ256rm),
     /* 194018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194020 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 194024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194029 */     GIR_RootConstrainSelectedInstOperands,
     /* 194030 */     // GIR_Coverage, 13326,
     /* 194030 */     GIR_EraseRootFromParent_Done,
     /* 194031 */   // Label 4370: @194031
     /* 194031 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(194054), // Rule ID 2995 //
     /* 194036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 194039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194047 */     // (abs:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src)  =>  (VPABSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src)
     /* 194047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBYrr),
     /* 194052 */     GIR_RootConstrainSelectedInstOperands,
     /* 194053 */     // GIR_Coverage, 2995,
     /* 194053 */     GIR_Done,
     /* 194054 */   // Label 4371: @194054
     /* 194054 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(194077), // Rule ID 13323 //
     /* 194059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194070 */     // (abs:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (VPABSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)
     /* 194070 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZ256rr),
     /* 194075 */     GIR_RootConstrainSelectedInstOperands,
     /* 194076 */     // GIR_Coverage, 13323,
     /* 194076 */     GIR_Done,
     /* 194077 */   // Label 4372: @194077
     /* 194077 */   GIM_Reject,
     /* 194078 */ // Label 4368: @194078
     /* 194078 */ GIM_Reject,
     /* 194079 */ // Label 4323: @194079
     /* 194079 */ GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(194163),
     /* 194084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 194087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194091 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(194143), // Rule ID 13302 //
     /* 194096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 194099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194107 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194114 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194127 */     // (abs:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)
     /* 194127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWZrm),
     /* 194130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194132 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 194136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194141 */     GIR_RootConstrainSelectedInstOperands,
     /* 194142 */     // GIR_Coverage, 13302,
     /* 194142 */     GIR_EraseRootFromParent_Done,
     /* 194143 */   // Label 4374: @194143
     /* 194143 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(194162), // Rule ID 13299 //
     /* 194148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 194151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194155 */     // (abs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)  =>  (VPABSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)
     /* 194155 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZrr),
     /* 194160 */     GIR_RootConstrainSelectedInstOperands,
     /* 194161 */     // GIR_Coverage, 13299,
     /* 194161 */     GIR_Done,
     /* 194162 */   // Label 4375: @194162
     /* 194162 */   GIM_Reject,
     /* 194163 */ // Label 4373: @194163
     /* 194163 */ GIM_Reject,
     /* 194164 */ // Label 4324: @194164
     /* 194164 */ GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(194248),
     /* 194169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 194172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194176 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(194228), // Rule ID 13320 //
     /* 194181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 194184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194192 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194195 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194199 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194212 */     // (abs:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBZrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)
     /* 194212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBZrm),
     /* 194215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194217 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 194221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194226 */     GIR_RootConstrainSelectedInstOperands,
     /* 194227 */     // GIR_Coverage, 13320,
     /* 194227 */     GIR_EraseRootFromParent_Done,
     /* 194228 */   // Label 4377: @194228
     /* 194228 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(194247), // Rule ID 13317 //
     /* 194233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 194236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194240 */     // (abs:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)  =>  (VPABSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)
     /* 194240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZrr),
     /* 194245 */     GIR_RootConstrainSelectedInstOperands,
     /* 194246 */     // GIR_Coverage, 13317,
     /* 194246 */     GIR_Done,
     /* 194247 */   // Label 4378: @194247
     /* 194247 */   GIM_Reject,
     /* 194248 */ // Label 4376: @194248
     /* 194248 */ GIM_Reject,
     /* 194249 */ // Label 4325: @194249
     /* 194249 */ GIM_Reject,
     /* 194250 */ // Label 59: @194250
     /* 194250 */ GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(194265), // Rule ID 630 //
     /* 194255 */   // MIs[0] dst
     /* 194255 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 194258 */   // (br (bb:{ *:[Other] }):$dst)  =>  (JMP_1 (bb:{ *:[Other] }):$dst)
     /* 194258 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::JMP_1),
     /* 194263 */   GIR_RootConstrainSelectedInstOperands,
     /* 194264 */   // GIR_Coverage, 630,
     /* 194264 */   GIR_Done,
     /* 194265 */ // Label 4379: @194265
     /* 194265 */ GIM_Reject,
     /* 194266 */ // Label 60: @194266
     /* 194266 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(22), /*)*//*default:*//*Label 4394*/ GIMT_Encode4(197194),
     /* 194277 */ /*GILLT_s1*//*Label 4380*/ GIMT_Encode4(194365), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 194305 */ /*GILLT_v2s1*//*Label 4381*/ GIMT_Encode4(194606),
     /* 194309 */ /*GILLT_v2s64*//*Label 4382*/ GIMT_Encode4(194807),
     /* 194313 */ /*GILLT_v4s1*//*Label 4383*/ GIMT_Encode4(195288),
     /* 194317 */ /*GILLT_v4s32*//*Label 4384*/ GIMT_Encode4(195449),
     /* 194321 */ /*GILLT_v4s64*//*Label 4385*/ GIMT_Encode4(195930),
     /* 194325 */ /*GILLT_v8s1*//*Label 4386*/ GIMT_Encode4(196013),
     /* 194329 */ /*GILLT_v8s16*//*Label 4387*/ GIMT_Encode4(196134),
     /* 194333 */ /*GILLT_v8s32*//*Label 4388*/ GIMT_Encode4(196615), GIMT_Encode4(0),
     /* 194341 */ /*GILLT_v16s1*//*Label 4389*/ GIMT_Encode4(196698),
     /* 194345 */ /*GILLT_v16s8*//*Label 4390*/ GIMT_Encode4(196779),
     /* 194349 */ /*GILLT_v16s16*//*Label 4391*/ GIMT_Encode4(197020), GIMT_Encode4(0),
     /* 194357 */ /*GILLT_v32s1*//*Label 4392*/ GIMT_Encode4(197103),
     /* 194361 */ /*GILLT_v32s8*//*Label 4393*/ GIMT_Encode4(197144),
     /* 194365 */ // Label 4380: @194365
     /* 194365 */ GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(194405), // Rule ID 19601 //
     /* 194370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 194373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 194377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 194381 */   // MIs[0] Operand 2
     /* 194381 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 194392 */   // (extract_subvector:{ *:[v1i1] } VK2:{ *:[v2i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK2:{ *:[v2i1] }:$src, VK1:{ *:[i32] })
     /* 194392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 194395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194397 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 194399 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 194404 */   // GIR_Coverage, 19601,
     /* 194404 */   GIR_EraseRootFromParent_Done,
     /* 194405 */ // Label 4395: @194405
     /* 194405 */ GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(194445), // Rule ID 19603 //
     /* 194410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 194413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 194417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 194421 */   // MIs[0] Operand 2
     /* 194421 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 194432 */   // (extract_subvector:{ *:[v1i1] } VK4:{ *:[v4i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK4:{ *:[v4i1] }:$src, VK1:{ *:[i32] })
     /* 194432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 194435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194437 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 194439 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 194444 */   // GIR_Coverage, 19603,
     /* 194444 */   GIR_EraseRootFromParent_Done,
     /* 194445 */ // Label 4396: @194445
     /* 194445 */ GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(194485), // Rule ID 19605 //
     /* 194450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 194453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 194457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 194461 */   // MIs[0] Operand 2
     /* 194461 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 194472 */   // (extract_subvector:{ *:[v1i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK8:{ *:[v8i1] }:$src, VK1:{ *:[i32] })
     /* 194472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 194475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194477 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 194479 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 194484 */   // GIR_Coverage, 19605,
     /* 194484 */   GIR_EraseRootFromParent_Done,
     /* 194485 */ // Label 4397: @194485
     /* 194485 */ GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(194525), // Rule ID 19607 //
     /* 194490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 194493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 194497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 194501 */   // MIs[0] Operand 2
     /* 194501 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 194512 */   // (extract_subvector:{ *:[v1i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK16:{ *:[v16i1] }:$src, VK1:{ *:[i32] })
     /* 194512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 194515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194517 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 194519 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 194524 */   // GIR_Coverage, 19607,
     /* 194524 */   GIR_EraseRootFromParent_Done,
     /* 194525 */ // Label 4398: @194525
     /* 194525 */ GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(194565), // Rule ID 19609 //
     /* 194530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 194533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 194537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 194541 */   // MIs[0] Operand 2
     /* 194541 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 194552 */   // (extract_subvector:{ *:[v1i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK32:{ *:[v32i1] }:$src, VK1:{ *:[i32] })
     /* 194552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 194555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194557 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 194559 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 194564 */   // GIR_Coverage, 19609,
     /* 194564 */   GIR_EraseRootFromParent_Done,
     /* 194565 */ // Label 4399: @194565
     /* 194565 */ GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(194605), // Rule ID 19611 //
     /* 194570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 194573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 194577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 194581 */   // MIs[0] Operand 2
     /* 194581 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 194592 */   // (extract_subvector:{ *:[v1i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK64:{ *:[v64i1] }:$src, VK1:{ *:[i32] })
     /* 194592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 194595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194597 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 194599 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 194604 */   // GIR_Coverage, 19611,
     /* 194604 */   GIR_EraseRootFromParent_Done,
     /* 194605 */ // Label 4400: @194605
     /* 194605 */ GIM_Reject,
     /* 194606 */ // Label 4381: @194606
     /* 194606 */ GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(194646), // Rule ID 19613 //
     /* 194611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 194614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 194618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 194622 */   // MIs[0] Operand 2
     /* 194622 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 194633 */   // (extract_subvector:{ *:[v2i1] } VK4:{ *:[v4i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK4:{ *:[v4i1] }:$src, VK2:{ *:[i32] })
     /* 194633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 194636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194638 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 194640 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 194645 */   // GIR_Coverage, 19613,
     /* 194645 */   GIR_EraseRootFromParent_Done,
     /* 194646 */ // Label 4401: @194646
     /* 194646 */ GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(194686), // Rule ID 19615 //
     /* 194651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 194654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 194658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 194662 */   // MIs[0] Operand 2
     /* 194662 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 194673 */   // (extract_subvector:{ *:[v2i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK8:{ *:[v8i1] }:$src, VK2:{ *:[i32] })
     /* 194673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 194676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194678 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 194680 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 194685 */   // GIR_Coverage, 19615,
     /* 194685 */   GIR_EraseRootFromParent_Done,
     /* 194686 */ // Label 4402: @194686
     /* 194686 */ GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(194726), // Rule ID 19617 //
     /* 194691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 194694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 194698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 194702 */   // MIs[0] Operand 2
     /* 194702 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 194713 */   // (extract_subvector:{ *:[v2i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK16:{ *:[v16i1] }:$src, VK2:{ *:[i32] })
     /* 194713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 194716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194718 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 194720 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 194725 */   // GIR_Coverage, 19617,
     /* 194725 */   GIR_EraseRootFromParent_Done,
     /* 194726 */ // Label 4403: @194726
     /* 194726 */ GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(194766), // Rule ID 19619 //
     /* 194731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 194734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 194738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 194742 */   // MIs[0] Operand 2
     /* 194742 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 194753 */   // (extract_subvector:{ *:[v2i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK32:{ *:[v32i1] }:$src, VK2:{ *:[i32] })
     /* 194753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 194756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194758 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 194760 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 194765 */   // GIR_Coverage, 19619,
     /* 194765 */   GIR_EraseRootFromParent_Done,
     /* 194766 */ // Label 4404: @194766
     /* 194766 */ GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(194806), // Rule ID 19621 //
     /* 194771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 194774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 194778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 194782 */   // MIs[0] Operand 2
     /* 194782 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 194793 */   // (extract_subvector:{ *:[v2i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK64:{ *:[v64i1] }:$src, VK2:{ *:[i32] })
     /* 194793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 194796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194798 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 194800 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 194805 */   // GIR_Coverage, 19621,
     /* 194805 */   GIR_EraseRootFromParent_Done,
     /* 194806 */ // Label 4405: @194806
     /* 194806 */ GIM_Reject,
     /* 194807 */ // Label 4382: @194807
     /* 194807 */ GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(194878), // Rule ID 19052 //
     /* 194812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 194815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 194818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194826 */   // MIs[0] Operand 2
     /* 194826 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 194837 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v2i64] } (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 194837 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 194840 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 194844 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194849 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 194855 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 194860 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 194865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 194868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194870 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 194873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194876 */   GIR_RootConstrainSelectedInstOperands,
     /* 194877 */   // GIR_Coverage, 19052,
     /* 194877 */   GIR_EraseRootFromParent_Done,
     /* 194878 */ // Label 4406: @194878
     /* 194878 */ GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(194949), // Rule ID 19053 //
     /* 194883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 194886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 194889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194897 */   // MIs[0] Operand 2
     /* 194897 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 194908 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v2f64] } (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 194908 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 194911 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 194915 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194920 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 194926 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 194931 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 194936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 194939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 194944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194947 */   GIR_RootConstrainSelectedInstOperands,
     /* 194948 */   // GIR_Coverage, 19053,
     /* 194948 */   GIR_EraseRootFromParent_Done,
     /* 194949 */ // Label 4407: @194949
     /* 194949 */ GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(195020), // Rule ID 19059 //
     /* 194954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 194957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 194960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194968 */   // MIs[0] Operand 2
     /* 194968 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 194979 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v2i64] } (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 194979 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 194982 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 194986 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194991 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 194997 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 195002 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 195010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195012 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 195015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195018 */   GIR_RootConstrainSelectedInstOperands,
     /* 195019 */   // GIR_Coverage, 19059,
     /* 195019 */   GIR_EraseRootFromParent_Done,
     /* 195020 */ // Label 4408: @195020
     /* 195020 */ GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(195091), // Rule ID 19060 //
     /* 195025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 195028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 195031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195039 */   // MIs[0] Operand 2
     /* 195039 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 195050 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v2f64] } (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 195050 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 195053 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195057 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195062 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 195068 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 195073 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 195081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195083 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 195086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195089 */   GIR_RootConstrainSelectedInstOperands,
     /* 195090 */   // GIR_Coverage, 19060,
     /* 195090 */   GIR_EraseRootFromParent_Done,
     /* 195091 */ // Label 4409: @195091
     /* 195091 */ GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(195140), // Rule ID 23004 //
     /* 195096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 195099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 195103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195107 */   // MIs[0] Operand 2
     /* 195107 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195118 */   // (extract_subvector:{ *:[v2i64] } VR256:{ *:[v4i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } VR256:{ *:[v4i64] }:$src, sub_xmm:{ *:[i32] })
     /* 195118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195123 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 195129 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 195134 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 195139 */   // GIR_Coverage, 23004,
     /* 195139 */   GIR_EraseRootFromParent_Done,
     /* 195140 */ // Label 4410: @195140
     /* 195140 */ GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(195189), // Rule ID 23007 //
     /* 195145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 195148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 195152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195156 */   // MIs[0] Operand 2
     /* 195156 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195167 */   // (extract_subvector:{ *:[v2f64] } VR256:{ *:[v4f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } VR256:{ *:[v4f64] }:$src, sub_xmm:{ *:[i32] })
     /* 195167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195172 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 195178 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 195183 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 195188 */   // GIR_Coverage, 23007,
     /* 195188 */   GIR_EraseRootFromParent_Done,
     /* 195189 */ // Label 4411: @195189
     /* 195189 */ GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(195238), // Rule ID 23025 //
     /* 195194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 195197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 195201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195205 */   // MIs[0] Operand 2
     /* 195205 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195216 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, sub_xmm:{ *:[i32] })
     /* 195216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195221 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 195227 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 195232 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195237 */   // GIR_Coverage, 23025,
     /* 195237 */   GIR_EraseRootFromParent_Done,
     /* 195238 */ // Label 4412: @195238
     /* 195238 */ GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(195287), // Rule ID 23028 //
     /* 195243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 195246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 195250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195254 */   // MIs[0] Operand 2
     /* 195254 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195265 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, sub_xmm:{ *:[i32] })
     /* 195265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195268 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195270 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 195276 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 195281 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195286 */   // GIR_Coverage, 23028,
     /* 195286 */   GIR_EraseRootFromParent_Done,
     /* 195287 */ // Label 4413: @195287
     /* 195287 */ GIM_Reject,
     /* 195288 */ // Label 4383: @195288
     /* 195288 */ GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(195328), // Rule ID 19623 //
     /* 195293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 195296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 195300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 195304 */   // MIs[0] Operand 2
     /* 195304 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195315 */   // (extract_subvector:{ *:[v4i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK8:{ *:[v8i1] }:$src, VK4:{ *:[i32] })
     /* 195315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195320 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195322 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 195327 */   // GIR_Coverage, 19623,
     /* 195327 */   GIR_EraseRootFromParent_Done,
     /* 195328 */ // Label 4414: @195328
     /* 195328 */ GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(195368), // Rule ID 19625 //
     /* 195333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 195336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 195340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 195344 */   // MIs[0] Operand 2
     /* 195344 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195355 */   // (extract_subvector:{ *:[v4i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK16:{ *:[v16i1] }:$src, VK4:{ *:[i32] })
     /* 195355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195360 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 195367 */   // GIR_Coverage, 19625,
     /* 195367 */   GIR_EraseRootFromParent_Done,
     /* 195368 */ // Label 4415: @195368
     /* 195368 */ GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(195408), // Rule ID 19627 //
     /* 195373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 195376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 195380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 195384 */   // MIs[0] Operand 2
     /* 195384 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195395 */   // (extract_subvector:{ *:[v4i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK32:{ *:[v32i1] }:$src, VK4:{ *:[i32] })
     /* 195395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195400 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195402 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 195407 */   // GIR_Coverage, 19627,
     /* 195407 */   GIR_EraseRootFromParent_Done,
     /* 195408 */ // Label 4416: @195408
     /* 195408 */ GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(195448), // Rule ID 19629 //
     /* 195413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 195416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 195420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 195424 */   // MIs[0] Operand 2
     /* 195424 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195435 */   // (extract_subvector:{ *:[v4i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK64:{ *:[v64i1] }:$src, VK4:{ *:[i32] })
     /* 195435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195440 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 195442 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 195447 */   // GIR_Coverage, 19629,
     /* 195447 */   GIR_EraseRootFromParent_Done,
     /* 195448 */ // Label 4417: @195448
     /* 195448 */ GIM_Reject,
     /* 195449 */ // Label 4384: @195449
     /* 195449 */ GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(195520), // Rule ID 19054 //
     /* 195454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 195457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 195460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195468 */   // MIs[0] Operand 2
     /* 195468 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 195479 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v4i32] } (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 195479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 195482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195491 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 195497 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 195502 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 195510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195512 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 195515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195518 */   GIR_RootConstrainSelectedInstOperands,
     /* 195519 */   // GIR_Coverage, 19054,
     /* 195519 */   GIR_EraseRootFromParent_Done,
     /* 195520 */ // Label 4418: @195520
     /* 195520 */ GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(195591), // Rule ID 19055 //
     /* 195525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 195528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 195531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195539 */   // MIs[0] Operand 2
     /* 195539 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 195550 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 195550 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 195553 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195557 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195562 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 195568 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 195573 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 195581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195583 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 195586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195589 */   GIR_RootConstrainSelectedInstOperands,
     /* 195590 */   // GIR_Coverage, 19055,
     /* 195590 */   GIR_EraseRootFromParent_Done,
     /* 195591 */ // Label 4419: @195591
     /* 195591 */ GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(195662), // Rule ID 19061 //
     /* 195596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 195599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 195602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195610 */   // MIs[0] Operand 2
     /* 195610 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 195621 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v4i32] } (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 195621 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 195624 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195628 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195633 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 195639 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 195644 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 195652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195654 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 195657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195660 */   GIR_RootConstrainSelectedInstOperands,
     /* 195661 */   // GIR_Coverage, 19061,
     /* 195661 */   GIR_EraseRootFromParent_Done,
     /* 195662 */ // Label 4420: @195662
     /* 195662 */ GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(195733), // Rule ID 19062 //
     /* 195667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 195670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 195673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195681 */   // MIs[0] Operand 2
     /* 195681 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 195692 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 195692 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 195695 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195699 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195704 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 195710 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 195715 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 195723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 195728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195731 */   GIR_RootConstrainSelectedInstOperands,
     /* 195732 */   // GIR_Coverage, 19062,
     /* 195732 */   GIR_EraseRootFromParent_Done,
     /* 195733 */ // Label 4421: @195733
     /* 195733 */ GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(195782), // Rule ID 22998 //
     /* 195738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 195741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 195745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195749 */   // MIs[0] Operand 2
     /* 195749 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195760 */   // (extract_subvector:{ *:[v4i32] } VR256:{ *:[v8i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } VR256:{ *:[v8i32] }:$src, sub_xmm:{ *:[i32] })
     /* 195760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195765 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 195771 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 195776 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 195781 */   // GIR_Coverage, 22998,
     /* 195781 */   GIR_EraseRootFromParent_Done,
     /* 195782 */ // Label 4422: @195782
     /* 195782 */ GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(195831), // Rule ID 23001 //
     /* 195787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 195790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 195794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195798 */   // MIs[0] Operand 2
     /* 195798 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195809 */   // (extract_subvector:{ *:[v4f32] } VR256:{ *:[v8f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } VR256:{ *:[v8f32] }:$src, sub_xmm:{ *:[i32] })
     /* 195809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195814 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 195820 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 195825 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 195830 */   // GIR_Coverage, 23001,
     /* 195830 */   GIR_EraseRootFromParent_Done,
     /* 195831 */ // Label 4423: @195831
     /* 195831 */ GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(195880), // Rule ID 23019 //
     /* 195836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 195839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 195843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195847 */   // MIs[0] Operand 2
     /* 195847 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195858 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, sub_xmm:{ *:[i32] })
     /* 195858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195863 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 195869 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 195874 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195879 */   // GIR_Coverage, 23019,
     /* 195879 */   GIR_EraseRootFromParent_Done,
     /* 195880 */ // Label 4424: @195880
     /* 195880 */ GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(195929), // Rule ID 23022 //
     /* 195885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 195888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 195892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195896 */   // MIs[0] Operand 2
     /* 195896 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195907 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, sub_xmm:{ *:[i32] })
     /* 195907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195912 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 195918 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 195923 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195928 */   // GIR_Coverage, 23022,
     /* 195928 */   GIR_EraseRootFromParent_Done,
     /* 195929 */ // Label 4425: @195929
     /* 195929 */ GIM_Reject,
     /* 195930 */ // Label 4385: @195930
     /* 195930 */ GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(196012),
     /* 195935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 195938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195946 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 195957 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(195984), // Rule ID 23046 //
     /* 195962 */     // (extract_subvector:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] })
     /* 195962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195967 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 195973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 195978 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 195983 */     // GIR_Coverage, 23046,
     /* 195983 */     GIR_EraseRootFromParent_Done,
     /* 195984 */   // Label 4427: @195984
     /* 195984 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(196011), // Rule ID 23049 //
     /* 195989 */     // (extract_subvector:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] })
     /* 195989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 195992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195994 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196005 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196010 */     // GIR_Coverage, 23049,
     /* 196010 */     GIR_EraseRootFromParent_Done,
     /* 196011 */   // Label 4428: @196011
     /* 196011 */   GIM_Reject,
     /* 196012 */ // Label 4426: @196012
     /* 196012 */ GIM_Reject,
     /* 196013 */ // Label 4386: @196013
     /* 196013 */ GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(196053), // Rule ID 19631 //
     /* 196018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 196021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 196025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 196029 */   // MIs[0] Operand 2
     /* 196029 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196040 */   // (extract_subvector:{ *:[v8i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK16:{ *:[v16i1] }:$src, VK8:{ *:[i32] })
     /* 196040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196045 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 196047 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 196052 */   // GIR_Coverage, 19631,
     /* 196052 */   GIR_EraseRootFromParent_Done,
     /* 196053 */ // Label 4429: @196053
     /* 196053 */ GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(196093), // Rule ID 19633 //
     /* 196058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 196061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 196065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 196069 */   // MIs[0] Operand 2
     /* 196069 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196080 */   // (extract_subvector:{ *:[v8i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK32:{ *:[v32i1] }:$src, VK8:{ *:[i32] })
     /* 196080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196085 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 196087 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 196092 */   // GIR_Coverage, 19633,
     /* 196092 */   GIR_EraseRootFromParent_Done,
     /* 196093 */ // Label 4430: @196093
     /* 196093 */ GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(196133), // Rule ID 19635 //
     /* 196098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 196101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 196105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 196109 */   // MIs[0] Operand 2
     /* 196109 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196120 */   // (extract_subvector:{ *:[v8i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK64:{ *:[v64i1] }:$src, VK8:{ *:[i32] })
     /* 196120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196125 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 196127 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 196132 */   // GIR_Coverage, 19635,
     /* 196132 */   GIR_EraseRootFromParent_Done,
     /* 196133 */ // Label 4431: @196133
     /* 196133 */ GIM_Reject,
     /* 196134 */ // Label 4387: @196134
     /* 196134 */ GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(196205), // Rule ID 19056 //
     /* 196139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 196142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 196145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196153 */   // MIs[0] Operand 2
     /* 196153 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 196164 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v8i16] } (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 196164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 196167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196176 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196182 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196187 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 196195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196197 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 196200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196203 */   GIR_RootConstrainSelectedInstOperands,
     /* 196204 */   // GIR_Coverage, 19056,
     /* 196204 */   GIR_EraseRootFromParent_Done,
     /* 196205 */ // Label 4432: @196205
     /* 196205 */ GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(196276), // Rule ID 19057 //
     /* 196210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 196213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 196216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196224 */   // MIs[0] Operand 2
     /* 196224 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 196235 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v8f16] } (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 196235 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 196238 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196242 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196247 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196253 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196258 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 196266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196268 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 196271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196274 */   GIR_RootConstrainSelectedInstOperands,
     /* 196275 */   // GIR_Coverage, 19057,
     /* 196275 */   GIR_EraseRootFromParent_Done,
     /* 196276 */ // Label 4433: @196276
     /* 196276 */ GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(196347), // Rule ID 19063 //
     /* 196281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 196284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 196287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196295 */   // MIs[0] Operand 2
     /* 196295 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 196306 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v8i16] } (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 196306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 196309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196318 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196324 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196329 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 196337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196339 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 196342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196345 */   GIR_RootConstrainSelectedInstOperands,
     /* 196346 */   // GIR_Coverage, 19063,
     /* 196346 */   GIR_EraseRootFromParent_Done,
     /* 196347 */ // Label 4434: @196347
     /* 196347 */ GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(196418), // Rule ID 19064 //
     /* 196352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 196355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 196358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196366 */   // MIs[0] Operand 2
     /* 196366 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 196377 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v8f16] } (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 196377 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 196380 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196384 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196389 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196395 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196400 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 196408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196410 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 196413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196416 */   GIR_RootConstrainSelectedInstOperands,
     /* 196417 */   // GIR_Coverage, 19064,
     /* 196417 */   GIR_EraseRootFromParent_Done,
     /* 196418 */ // Label 4435: @196418
     /* 196418 */ GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(196467), // Rule ID 23010 //
     /* 196423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 196426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 196430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 196434 */   // MIs[0] Operand 2
     /* 196434 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196445 */   // (extract_subvector:{ *:[v8i16] } VR256:{ *:[v16i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } VR256:{ *:[v16i16] }:$src, sub_xmm:{ *:[i32] })
     /* 196445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196450 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 196456 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 196461 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 196466 */   // GIR_Coverage, 23010,
     /* 196466 */   GIR_EraseRootFromParent_Done,
     /* 196467 */ // Label 4436: @196467
     /* 196467 */ GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(196516), // Rule ID 23016 //
     /* 196472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 196475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 196479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 196483 */   // MIs[0] Operand 2
     /* 196483 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196494 */   // (extract_subvector:{ *:[v8f16] } VR256:{ *:[v16f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } VR256:{ *:[v16f16] }:$src, sub_xmm:{ *:[i32] })
     /* 196494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196499 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 196505 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 196510 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 196515 */   // GIR_Coverage, 23016,
     /* 196515 */   GIR_EraseRootFromParent_Done,
     /* 196516 */ // Label 4437: @196516
     /* 196516 */ GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(196565), // Rule ID 23031 //
     /* 196521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 196524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 196528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196532 */   // MIs[0] Operand 2
     /* 196532 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196543 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, sub_xmm:{ *:[i32] })
     /* 196543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196548 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 196554 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 196559 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196564 */   // GIR_Coverage, 23031,
     /* 196564 */   GIR_EraseRootFromParent_Done,
     /* 196565 */ // Label 4438: @196565
     /* 196565 */ GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(196614), // Rule ID 23037 //
     /* 196570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 196573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 196577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196581 */   // MIs[0] Operand 2
     /* 196581 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196592 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, sub_xmm:{ *:[i32] })
     /* 196592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196597 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 196603 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 196608 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196613 */   // GIR_Coverage, 23037,
     /* 196613 */   GIR_EraseRootFromParent_Done,
     /* 196614 */ // Label 4439: @196614
     /* 196614 */ GIM_Reject,
     /* 196615 */ // Label 4388: @196615
     /* 196615 */ GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(196697),
     /* 196620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 196623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 196627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196631 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196642 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(196669), // Rule ID 23040 //
     /* 196647 */     // (extract_subvector:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] })
     /* 196647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196652 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196668 */     // GIR_Coverage, 23040,
     /* 196668 */     GIR_EraseRootFromParent_Done,
     /* 196669 */   // Label 4441: @196669
     /* 196669 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(196696), // Rule ID 23043 //
     /* 196674 */     // (extract_subvector:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] })
     /* 196674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196679 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196685 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196690 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196695 */     // GIR_Coverage, 23043,
     /* 196695 */     GIR_EraseRootFromParent_Done,
     /* 196696 */   // Label 4442: @196696
     /* 196696 */   GIM_Reject,
     /* 196697 */ // Label 4440: @196697
     /* 196697 */ GIM_Reject,
     /* 196698 */ // Label 4389: @196698
     /* 196698 */ GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(196738), // Rule ID 19637 //
     /* 196703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 196706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 196710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 196714 */   // MIs[0] Operand 2
     /* 196714 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196725 */   // (extract_subvector:{ *:[v16i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } VK32:{ *:[v32i1] }:$src, VK16:{ *:[i32] })
     /* 196725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196730 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 196732 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 196737 */   // GIR_Coverage, 19637,
     /* 196737 */   GIR_EraseRootFromParent_Done,
     /* 196738 */ // Label 4443: @196738
     /* 196738 */ GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(196778), // Rule ID 19639 //
     /* 196743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 196746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 196750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 196754 */   // MIs[0] Operand 2
     /* 196754 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196765 */   // (extract_subvector:{ *:[v16i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } VK64:{ *:[v64i1] }:$src, VK16:{ *:[i32] })
     /* 196765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196770 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 196772 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 196777 */   // GIR_Coverage, 19639,
     /* 196777 */   GIR_EraseRootFromParent_Done,
     /* 196778 */ // Label 4444: @196778
     /* 196778 */ GIM_Reject,
     /* 196779 */ // Label 4390: @196779
     /* 196779 */ GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(196850), // Rule ID 19058 //
     /* 196784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 196787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 196790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196798 */   // MIs[0] Operand 2
     /* 196798 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 196809 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 16:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v16i8] } (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 196809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 196812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196821 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196827 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196832 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 196840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 196845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196848 */   GIR_RootConstrainSelectedInstOperands,
     /* 196849 */   // GIR_Coverage, 19058,
     /* 196849 */   GIR_EraseRootFromParent_Done,
     /* 196850 */ // Label 4445: @196850
     /* 196850 */ GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(196921), // Rule ID 19065 //
     /* 196855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 196858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 196861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196869 */   // MIs[0] Operand 2
     /* 196869 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 196880 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 16:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v16i8] } (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 196880 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 196883 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196887 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196892 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 196898 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196903 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 196911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196913 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 196916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196919 */   GIR_RootConstrainSelectedInstOperands,
     /* 196920 */   // GIR_Coverage, 19065,
     /* 196920 */   GIR_EraseRootFromParent_Done,
     /* 196921 */ // Label 4446: @196921
     /* 196921 */ GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(196970), // Rule ID 23013 //
     /* 196926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 196929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 196933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 196937 */   // MIs[0] Operand 2
     /* 196937 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196948 */   // (extract_subvector:{ *:[v16i8] } VR256:{ *:[v32i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } VR256:{ *:[v32i8] }:$src, sub_xmm:{ *:[i32] })
     /* 196948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196953 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 196959 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 196964 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 196969 */   // GIR_Coverage, 23013,
     /* 196969 */   GIR_EraseRootFromParent_Done,
     /* 196970 */ // Label 4447: @196970
     /* 196970 */ GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(197019), // Rule ID 23034 //
     /* 196975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 196978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 196982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196986 */   // MIs[0] Operand 2
     /* 196986 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 196997 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, sub_xmm:{ *:[i32] })
     /* 196997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197002 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 197008 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 197013 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197018 */   // GIR_Coverage, 23034,
     /* 197018 */   GIR_EraseRootFromParent_Done,
     /* 197019 */ // Label 4448: @197019
     /* 197019 */ GIM_Reject,
     /* 197020 */ // Label 4391: @197020
     /* 197020 */ GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(197102),
     /* 197025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 197028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197036 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197047 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(197074), // Rule ID 23052 //
     /* 197052 */     // (extract_subvector:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] })
     /* 197052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197057 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 197063 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 197068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197073 */     // GIR_Coverage, 23052,
     /* 197073 */     GIR_EraseRootFromParent_Done,
     /* 197074 */   // Label 4450: @197074
     /* 197074 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(197101), // Rule ID 23058 //
     /* 197079 */     // (extract_subvector:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] })
     /* 197079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197084 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 197090 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 197095 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197100 */     // GIR_Coverage, 23058,
     /* 197100 */     GIR_EraseRootFromParent_Done,
     /* 197101 */   // Label 4451: @197101
     /* 197101 */   GIM_Reject,
     /* 197102 */ // Label 4449: @197102
     /* 197102 */ GIM_Reject,
     /* 197103 */ // Label 4392: @197103
     /* 197103 */ GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(197143), // Rule ID 19641 //
     /* 197108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 197111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 197115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 197119 */   // MIs[0] Operand 2
     /* 197119 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197130 */   // (extract_subvector:{ *:[v32i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } VK64:{ *:[v64i1] }:$src, VK32:{ *:[i32] })
     /* 197130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197135 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197137 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /* 197142 */   // GIR_Coverage, 19641,
     /* 197142 */   GIR_EraseRootFromParent_Done,
     /* 197143 */ // Label 4452: @197143
     /* 197143 */ GIM_Reject,
     /* 197144 */ // Label 4393: @197144
     /* 197144 */ GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(197193), // Rule ID 23055 //
     /* 197149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 197152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197160 */   // MIs[0] Operand 2
     /* 197160 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 197171 */   // (extract_subvector:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] })
     /* 197171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 197174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197176 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 197182 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 197187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 197192 */   // GIR_Coverage, 23055,
     /* 197192 */   GIR_EraseRootFromParent_Done,
     /* 197193 */ // Label 4453: @197193
     /* 197193 */ GIM_Reject,
     /* 197194 */ // Label 4394: @197194
     /* 197194 */ GIM_Reject,
     /* 197195 */ // Label 61: @197195
     /* 197195 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4466*/ GIMT_Encode4(199176),
     /* 197206 */ /*GILLT_v2s64*//*Label 4454*/ GIMT_Encode4(197274), GIMT_Encode4(0),
     /* 197214 */ /*GILLT_v4s32*//*Label 4455*/ GIMT_Encode4(197476),
     /* 197218 */ /*GILLT_v4s64*//*Label 4456*/ GIMT_Encode4(197678), GIMT_Encode4(0),
     /* 197226 */ /*GILLT_v8s16*//*Label 4457*/ GIMT_Encode4(197880),
     /* 197230 */ /*GILLT_v8s32*//*Label 4458*/ GIMT_Encode4(197995),
     /* 197234 */ /*GILLT_v8s64*//*Label 4459*/ GIMT_Encode4(198197), GIMT_Encode4(0),
     /* 197242 */ /*GILLT_v16s8*//*Label 4460*/ GIMT_Encode4(198399),
     /* 197246 */ /*GILLT_v16s16*//*Label 4461*/ GIMT_Encode4(198514),
     /* 197250 */ /*GILLT_v16s32*//*Label 4462*/ GIMT_Encode4(198629), GIMT_Encode4(0),
     /* 197258 */ /*GILLT_v32s8*//*Label 4463*/ GIMT_Encode4(198831),
     /* 197262 */ /*GILLT_v32s16*//*Label 4464*/ GIMT_Encode4(198946), GIMT_Encode4(0),
     /* 197270 */ /*GILLT_v64s8*//*Label 4465*/ GIMT_Encode4(199061),
     /* 197274 */ // Label 4454: @197274
     /* 197274 */ GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(197475),
     /* 197279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 197282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /* 197285 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 197288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197296 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 197300 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(197333), // Rule ID 21695 //
     /* 197305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 197312 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 197318 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 197320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197322 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, immAllZerosV:{ *:[v2i64] })  =>  (VPCOMPRESSQZ128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 197322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrkz),
     /* 197325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197327 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197329 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197331 */     GIR_RootConstrainSelectedInstOperands,
     /* 197332 */     // GIR_Coverage, 21695,
     /* 197332 */     GIR_EraseRootFromParent_Done,
     /* 197333 */   // Label 4468: @197333
     /* 197333 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(197366), // Rule ID 21731 //
     /* 197338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 197345 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 197351 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 197353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197355 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, immAllZerosV:{ *:[v2f64] })  =>  (VCOMPRESSPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 197355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrkz),
     /* 197358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197360 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197362 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197364 */     GIR_RootConstrainSelectedInstOperands,
     /* 197365 */     // GIR_Coverage, 21731,
     /* 197365 */     GIR_EraseRootFromParent_Done,
     /* 197366 */   // Label 4469: @197366
     /* 197366 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(197395), // Rule ID 21694 //
     /* 197371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 197378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 197382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197384 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, (undef:{ *:[v2i64] }))  =>  (VPCOMPRESSQZ128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 197384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrkz),
     /* 197387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197389 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197391 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197393 */     GIR_RootConstrainSelectedInstOperands,
     /* 197394 */     // GIR_Coverage, 21694,
     /* 197394 */     GIR_EraseRootFromParent_Done,
     /* 197395 */   // Label 4470: @197395
     /* 197395 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(197424), // Rule ID 21730 //
     /* 197400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 197407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 197411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197413 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, (undef:{ *:[v2f64] }))  =>  (VCOMPRESSPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 197413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrkz),
     /* 197416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197418 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197420 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197422 */     GIR_RootConstrainSelectedInstOperands,
     /* 197423 */     // GIR_Coverage, 21730,
     /* 197423 */     GIR_EraseRootFromParent_Done,
     /* 197424 */   // Label 4471: @197424
     /* 197424 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(197449), // Rule ID 21696 //
     /* 197429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197436 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$passthru)  =>  (VPCOMPRESSQZ128rrk:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$passthru, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 197436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrk),
     /* 197439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197441 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 197443 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197445 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197447 */     GIR_RootConstrainSelectedInstOperands,
     /* 197448 */     // GIR_Coverage, 21696,
     /* 197448 */     GIR_EraseRootFromParent_Done,
     /* 197449 */   // Label 4472: @197449
     /* 197449 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(197474), // Rule ID 21732 //
     /* 197454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197461 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$passthru)  =>  (VCOMPRESSPDZ128rrk:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$passthru, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 197461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrk),
     /* 197464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197466 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 197468 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197470 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197472 */     GIR_RootConstrainSelectedInstOperands,
     /* 197473 */     // GIR_Coverage, 21732,
     /* 197473 */     GIR_EraseRootFromParent_Done,
     /* 197474 */   // Label 4473: @197474
     /* 197474 */   GIM_Reject,
     /* 197475 */ // Label 4467: @197475
     /* 197475 */ GIM_Reject,
     /* 197476 */ // Label 4455: @197476
     /* 197476 */ GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(197677),
     /* 197481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 197484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 197487 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 197502 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(197535), // Rule ID 21677 //
     /* 197507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 197514 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 197520 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 197522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197524 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4i32] })  =>  (VPCOMPRESSDZ128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 197524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrkz),
     /* 197527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197529 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197531 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197533 */     GIR_RootConstrainSelectedInstOperands,
     /* 197534 */     // GIR_Coverage, 21677,
     /* 197534 */     GIR_EraseRootFromParent_Done,
     /* 197535 */   // Label 4475: @197535
     /* 197535 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(197568), // Rule ID 21713 //
     /* 197540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 197547 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 197553 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 197555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197557 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4f32] })  =>  (VCOMPRESSPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 197557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrkz),
     /* 197560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197562 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197564 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197566 */     GIR_RootConstrainSelectedInstOperands,
     /* 197567 */     // GIR_Coverage, 21713,
     /* 197567 */     GIR_EraseRootFromParent_Done,
     /* 197568 */   // Label 4476: @197568
     /* 197568 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(197597), // Rule ID 21676 //
     /* 197573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 197580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 197584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197586 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4i32] }))  =>  (VPCOMPRESSDZ128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 197586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrkz),
     /* 197589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197591 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197593 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197595 */     GIR_RootConstrainSelectedInstOperands,
     /* 197596 */     // GIR_Coverage, 21676,
     /* 197596 */     GIR_EraseRootFromParent_Done,
     /* 197597 */   // Label 4477: @197597
     /* 197597 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(197626), // Rule ID 21712 //
     /* 197602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 197609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 197613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197615 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4f32] }))  =>  (VCOMPRESSPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 197615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrkz),
     /* 197618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197620 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197622 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197624 */     GIR_RootConstrainSelectedInstOperands,
     /* 197625 */     // GIR_Coverage, 21712,
     /* 197625 */     GIR_EraseRootFromParent_Done,
     /* 197626 */   // Label 4478: @197626
     /* 197626 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(197651), // Rule ID 21678 //
     /* 197631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197638 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$passthru)  =>  (VPCOMPRESSDZ128rrk:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 197638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrk),
     /* 197641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197643 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 197645 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197647 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197649 */     GIR_RootConstrainSelectedInstOperands,
     /* 197650 */     // GIR_Coverage, 21678,
     /* 197650 */     GIR_EraseRootFromParent_Done,
     /* 197651 */   // Label 4479: @197651
     /* 197651 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(197676), // Rule ID 21714 //
     /* 197656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197663 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$passthru)  =>  (VCOMPRESSPSZ128rrk:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 197663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrk),
     /* 197666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197668 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 197670 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197672 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197674 */     GIR_RootConstrainSelectedInstOperands,
     /* 197675 */     // GIR_Coverage, 21714,
     /* 197675 */     GIR_EraseRootFromParent_Done,
     /* 197676 */   // Label 4480: @197676
     /* 197676 */   GIM_Reject,
     /* 197677 */ // Label 4474: @197677
     /* 197677 */ GIM_Reject,
     /* 197678 */ // Label 4456: @197678
     /* 197678 */ GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(197879),
     /* 197683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 197686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 197689 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 197692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 197704 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(197737), // Rule ID 21689 //
     /* 197709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 197716 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 197722 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 197724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197726 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4i64] })  =>  (VPCOMPRESSQZ256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 197726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrkz),
     /* 197729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197731 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197733 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197735 */     GIR_RootConstrainSelectedInstOperands,
     /* 197736 */     // GIR_Coverage, 21689,
     /* 197736 */     GIR_EraseRootFromParent_Done,
     /* 197737 */   // Label 4482: @197737
     /* 197737 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(197770), // Rule ID 21725 //
     /* 197742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 197749 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 197755 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 197757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197759 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4f64] })  =>  (VCOMPRESSPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 197759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrkz),
     /* 197762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197764 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197766 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197768 */     GIR_RootConstrainSelectedInstOperands,
     /* 197769 */     // GIR_Coverage, 21725,
     /* 197769 */     GIR_EraseRootFromParent_Done,
     /* 197770 */   // Label 4483: @197770
     /* 197770 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(197799), // Rule ID 21688 //
     /* 197775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 197782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 197786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197788 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4i64] }))  =>  (VPCOMPRESSQZ256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 197788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrkz),
     /* 197791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197793 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197795 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197797 */     GIR_RootConstrainSelectedInstOperands,
     /* 197798 */     // GIR_Coverage, 21688,
     /* 197798 */     GIR_EraseRootFromParent_Done,
     /* 197799 */   // Label 4484: @197799
     /* 197799 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(197828), // Rule ID 21724 //
     /* 197804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 197811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 197815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197817 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4f64] }))  =>  (VCOMPRESSPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 197817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrkz),
     /* 197820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197822 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197824 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197826 */     GIR_RootConstrainSelectedInstOperands,
     /* 197827 */     // GIR_Coverage, 21724,
     /* 197827 */     GIR_EraseRootFromParent_Done,
     /* 197828 */   // Label 4485: @197828
     /* 197828 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(197853), // Rule ID 21690 //
     /* 197833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197840 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$passthru)  =>  (VPCOMPRESSQZ256rrk:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 197840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrk),
     /* 197843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197845 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 197847 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197849 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197851 */     GIR_RootConstrainSelectedInstOperands,
     /* 197852 */     // GIR_Coverage, 21690,
     /* 197852 */     GIR_EraseRootFromParent_Done,
     /* 197853 */   // Label 4486: @197853
     /* 197853 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(197878), // Rule ID 21726 //
     /* 197858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197865 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$passthru)  =>  (VCOMPRESSPDZ256rrk:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 197865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrk),
     /* 197868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197870 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 197872 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197874 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197876 */     GIR_RootConstrainSelectedInstOperands,
     /* 197877 */     // GIR_Coverage, 21726,
     /* 197877 */     GIR_EraseRootFromParent_Done,
     /* 197878 */   // Label 4487: @197878
     /* 197878 */   GIM_Reject,
     /* 197879 */ // Label 4481: @197879
     /* 197879 */ GIM_Reject,
     /* 197880 */ // Label 4457: @197880
     /* 197880 */ GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(197994),
     /* 197885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 197888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 197891 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197902 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 197906 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(197939), // Rule ID 22097 //
     /* 197911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 197914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 197918 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 197924 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 197926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197928 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i16] })  =>  (VPCOMPRESSWZ128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 197928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrkz),
     /* 197931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197933 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197935 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197937 */     GIR_RootConstrainSelectedInstOperands,
     /* 197938 */     // GIR_Coverage, 22097,
     /* 197938 */     GIR_EraseRootFromParent_Done,
     /* 197939 */   // Label 4489: @197939
     /* 197939 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(197968), // Rule ID 22096 //
     /* 197944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 197947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 197951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 197955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197957 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i16] }))  =>  (VPCOMPRESSWZ128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 197957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrkz),
     /* 197960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197962 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197964 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197966 */     GIR_RootConstrainSelectedInstOperands,
     /* 197967 */     // GIR_Coverage, 22096,
     /* 197967 */     GIR_EraseRootFromParent_Done,
     /* 197968 */   // Label 4490: @197968
     /* 197968 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(197993), // Rule ID 22098 //
     /* 197973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 197976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197980 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$passthru)  =>  (VPCOMPRESSWZ128rrk:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 197980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrk),
     /* 197983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197985 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 197987 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 197989 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 197991 */     GIR_RootConstrainSelectedInstOperands,
     /* 197992 */     // GIR_Coverage, 22098,
     /* 197992 */     GIR_EraseRootFromParent_Done,
     /* 197993 */   // Label 4491: @197993
     /* 197993 */   GIM_Reject,
     /* 197994 */ // Label 4488: @197994
     /* 197994 */ GIM_Reject,
     /* 197995 */ // Label 4458: @197995
     /* 197995 */ GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(198196),
     /* 198000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 198003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 198006 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 198009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198017 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 198021 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(198054), // Rule ID 21671 //
     /* 198026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198033 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198039 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198043 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i32] })  =>  (VPCOMPRESSDZ256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 198043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrkz),
     /* 198046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198048 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198050 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198052 */     GIR_RootConstrainSelectedInstOperands,
     /* 198053 */     // GIR_Coverage, 21671,
     /* 198053 */     GIR_EraseRootFromParent_Done,
     /* 198054 */   // Label 4493: @198054
     /* 198054 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(198087), // Rule ID 21707 //
     /* 198059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198066 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198072 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198076 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8f32] })  =>  (VCOMPRESSPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 198076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrkz),
     /* 198079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198081 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198083 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198085 */     GIR_RootConstrainSelectedInstOperands,
     /* 198086 */     // GIR_Coverage, 21707,
     /* 198086 */     GIR_EraseRootFromParent_Done,
     /* 198087 */   // Label 4494: @198087
     /* 198087 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(198116), // Rule ID 21670 //
     /* 198092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198105 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i32] }))  =>  (VPCOMPRESSDZ256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 198105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrkz),
     /* 198108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198110 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198112 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198114 */     GIR_RootConstrainSelectedInstOperands,
     /* 198115 */     // GIR_Coverage, 21670,
     /* 198115 */     GIR_EraseRootFromParent_Done,
     /* 198116 */   // Label 4495: @198116
     /* 198116 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(198145), // Rule ID 21706 //
     /* 198121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198134 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8f32] }))  =>  (VCOMPRESSPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 198134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrkz),
     /* 198137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198139 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198141 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198143 */     GIR_RootConstrainSelectedInstOperands,
     /* 198144 */     // GIR_Coverage, 21706,
     /* 198144 */     GIR_EraseRootFromParent_Done,
     /* 198145 */   // Label 4496: @198145
     /* 198145 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(198170), // Rule ID 21672 //
     /* 198150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198157 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$passthru)  =>  (VPCOMPRESSDZ256rrk:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 198157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrk),
     /* 198160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198162 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198164 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198166 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198168 */     GIR_RootConstrainSelectedInstOperands,
     /* 198169 */     // GIR_Coverage, 21672,
     /* 198169 */     GIR_EraseRootFromParent_Done,
     /* 198170 */   // Label 4497: @198170
     /* 198170 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(198195), // Rule ID 21708 //
     /* 198175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 198178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198182 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$passthru)  =>  (VCOMPRESSPSZ256rrk:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 198182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrk),
     /* 198185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198187 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198189 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198191 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198193 */     GIR_RootConstrainSelectedInstOperands,
     /* 198194 */     // GIR_Coverage, 21708,
     /* 198194 */     GIR_EraseRootFromParent_Done,
     /* 198195 */   // Label 4498: @198195
     /* 198195 */   GIM_Reject,
     /* 198196 */ // Label 4492: @198196
     /* 198196 */ GIM_Reject,
     /* 198197 */ // Label 4459: @198197
     /* 198197 */ GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(198398),
     /* 198202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 198205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 198208 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 198211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 198223 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(198256), // Rule ID 21683 //
     /* 198228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 198231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198235 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198241 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198245 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i64] })  =>  (VPCOMPRESSQZrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 198245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrkz),
     /* 198248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198250 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198252 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198254 */     GIR_RootConstrainSelectedInstOperands,
     /* 198255 */     // GIR_Coverage, 21683,
     /* 198255 */     GIR_EraseRootFromParent_Done,
     /* 198256 */   // Label 4500: @198256
     /* 198256 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(198289), // Rule ID 21719 //
     /* 198261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 198264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198268 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198274 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198278 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8f64] })  =>  (VCOMPRESSPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 198278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrkz),
     /* 198281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198283 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198285 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198287 */     GIR_RootConstrainSelectedInstOperands,
     /* 198288 */     // GIR_Coverage, 21719,
     /* 198288 */     GIR_EraseRootFromParent_Done,
     /* 198289 */   // Label 4501: @198289
     /* 198289 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(198318), // Rule ID 21682 //
     /* 198294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 198297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198307 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i64] }))  =>  (VPCOMPRESSQZrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 198307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrkz),
     /* 198310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198312 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198314 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198316 */     GIR_RootConstrainSelectedInstOperands,
     /* 198317 */     // GIR_Coverage, 21682,
     /* 198317 */     GIR_EraseRootFromParent_Done,
     /* 198318 */   // Label 4502: @198318
     /* 198318 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(198347), // Rule ID 21718 //
     /* 198323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 198326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198336 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8f64] }))  =>  (VCOMPRESSPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 198336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrkz),
     /* 198339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198341 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198343 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198345 */     GIR_RootConstrainSelectedInstOperands,
     /* 198346 */     // GIR_Coverage, 21718,
     /* 198346 */     GIR_EraseRootFromParent_Done,
     /* 198347 */   // Label 4503: @198347
     /* 198347 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(198372), // Rule ID 21684 //
     /* 198352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 198355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198359 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$passthru)  =>  (VPCOMPRESSQZrrk:{ *:[v8i64] } VR512:{ *:[v8i64] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 198359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrk),
     /* 198362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198364 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198366 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198368 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198370 */     GIR_RootConstrainSelectedInstOperands,
     /* 198371 */     // GIR_Coverage, 21684,
     /* 198371 */     GIR_EraseRootFromParent_Done,
     /* 198372 */   // Label 4504: @198372
     /* 198372 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(198397), // Rule ID 21720 //
     /* 198377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 198380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198384 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$passthru)  =>  (VCOMPRESSPDZrrk:{ *:[v8f64] } VR512:{ *:[v8f64] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 198384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrk),
     /* 198387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198389 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198391 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198393 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198395 */     GIR_RootConstrainSelectedInstOperands,
     /* 198396 */     // GIR_Coverage, 21720,
     /* 198396 */     GIR_EraseRootFromParent_Done,
     /* 198397 */   // Label 4505: @198397
     /* 198397 */   GIM_Reject,
     /* 198398 */ // Label 4499: @198398
     /* 198398 */ GIM_Reject,
     /* 198399 */ // Label 4460: @198399
     /* 198399 */ GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(198513),
     /* 198404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 198407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 198410 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 198413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 198425 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(198458), // Rule ID 22079 //
     /* 198430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 198433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198437 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198443 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198447 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i8] })  =>  (VPCOMPRESSBZ128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 198447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrkz),
     /* 198450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198452 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198454 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198456 */     GIR_RootConstrainSelectedInstOperands,
     /* 198457 */     // GIR_Coverage, 22079,
     /* 198457 */     GIR_EraseRootFromParent_Done,
     /* 198458 */   // Label 4507: @198458
     /* 198458 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(198487), // Rule ID 22078 //
     /* 198463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 198466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198476 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i8] }))  =>  (VPCOMPRESSBZ128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 198476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrkz),
     /* 198479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198481 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198483 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198485 */     GIR_RootConstrainSelectedInstOperands,
     /* 198486 */     // GIR_Coverage, 22078,
     /* 198486 */     GIR_EraseRootFromParent_Done,
     /* 198487 */   // Label 4508: @198487
     /* 198487 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(198512), // Rule ID 22080 //
     /* 198492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 198495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198499 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$passthru)  =>  (VPCOMPRESSBZ128rrk:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 198499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrk),
     /* 198502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198504 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198506 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198508 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198510 */     GIR_RootConstrainSelectedInstOperands,
     /* 198511 */     // GIR_Coverage, 22080,
     /* 198511 */     GIR_EraseRootFromParent_Done,
     /* 198512 */   // Label 4509: @198512
     /* 198512 */   GIM_Reject,
     /* 198513 */ // Label 4506: @198513
     /* 198513 */ GIM_Reject,
     /* 198514 */ // Label 4461: @198514
     /* 198514 */ GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(198628),
     /* 198519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 198522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 198525 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 198528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 198540 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(198573), // Rule ID 22091 //
     /* 198545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 198548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198552 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198558 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198562 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i16] })  =>  (VPCOMPRESSWZ256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 198562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrkz),
     /* 198565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198567 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198569 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198571 */     GIR_RootConstrainSelectedInstOperands,
     /* 198572 */     // GIR_Coverage, 22091,
     /* 198572 */     GIR_EraseRootFromParent_Done,
     /* 198573 */   // Label 4511: @198573
     /* 198573 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(198602), // Rule ID 22090 //
     /* 198578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 198581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198591 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i16] }))  =>  (VPCOMPRESSWZ256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 198591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrkz),
     /* 198594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198596 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198598 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198600 */     GIR_RootConstrainSelectedInstOperands,
     /* 198601 */     // GIR_Coverage, 22090,
     /* 198601 */     GIR_EraseRootFromParent_Done,
     /* 198602 */   // Label 4512: @198602
     /* 198602 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(198627), // Rule ID 22092 //
     /* 198607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 198610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198614 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$passthru)  =>  (VPCOMPRESSWZ256rrk:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 198614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrk),
     /* 198617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198619 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198621 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198623 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198625 */     GIR_RootConstrainSelectedInstOperands,
     /* 198626 */     // GIR_Coverage, 22092,
     /* 198626 */     GIR_EraseRootFromParent_Done,
     /* 198627 */   // Label 4513: @198627
     /* 198627 */   GIM_Reject,
     /* 198628 */ // Label 4510: @198628
     /* 198628 */ GIM_Reject,
     /* 198629 */ // Label 4462: @198629
     /* 198629 */ GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(198830),
     /* 198634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 198637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 198640 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 198643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 198655 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(198688), // Rule ID 21665 //
     /* 198660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 198663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198667 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198673 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198677 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i32] })  =>  (VPCOMPRESSDZrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 198677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrkz),
     /* 198680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198682 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198684 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198686 */     GIR_RootConstrainSelectedInstOperands,
     /* 198687 */     // GIR_Coverage, 21665,
     /* 198687 */     GIR_EraseRootFromParent_Done,
     /* 198688 */   // Label 4515: @198688
     /* 198688 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(198721), // Rule ID 21701 //
     /* 198693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 198696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198700 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198706 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198710 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16f32] })  =>  (VCOMPRESSPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 198710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrkz),
     /* 198713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198715 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198717 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198719 */     GIR_RootConstrainSelectedInstOperands,
     /* 198720 */     // GIR_Coverage, 21701,
     /* 198720 */     GIR_EraseRootFromParent_Done,
     /* 198721 */   // Label 4516: @198721
     /* 198721 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(198750), // Rule ID 21664 //
     /* 198726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 198729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198739 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i32] }))  =>  (VPCOMPRESSDZrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 198739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrkz),
     /* 198742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198744 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198746 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198748 */     GIR_RootConstrainSelectedInstOperands,
     /* 198749 */     // GIR_Coverage, 21664,
     /* 198749 */     GIR_EraseRootFromParent_Done,
     /* 198750 */   // Label 4517: @198750
     /* 198750 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(198779), // Rule ID 21700 //
     /* 198755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 198758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198768 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16f32] }))  =>  (VCOMPRESSPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 198768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrkz),
     /* 198771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198773 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198775 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198777 */     GIR_RootConstrainSelectedInstOperands,
     /* 198778 */     // GIR_Coverage, 21700,
     /* 198778 */     GIR_EraseRootFromParent_Done,
     /* 198779 */   // Label 4518: @198779
     /* 198779 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(198804), // Rule ID 21666 //
     /* 198784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 198787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198791 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$passthru)  =>  (VPCOMPRESSDZrrk:{ *:[v16i32] } VR512:{ *:[v16i32] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 198791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrk),
     /* 198794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198796 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198798 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198800 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198802 */     GIR_RootConstrainSelectedInstOperands,
     /* 198803 */     // GIR_Coverage, 21666,
     /* 198803 */     GIR_EraseRootFromParent_Done,
     /* 198804 */   // Label 4519: @198804
     /* 198804 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(198829), // Rule ID 21702 //
     /* 198809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 198812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198816 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$passthru)  =>  (VCOMPRESSPSZrrk:{ *:[v16f32] } VR512:{ *:[v16f32] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 198816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrk),
     /* 198819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198821 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198823 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198825 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198827 */     GIR_RootConstrainSelectedInstOperands,
     /* 198828 */     // GIR_Coverage, 21702,
     /* 198828 */     GIR_EraseRootFromParent_Done,
     /* 198829 */   // Label 4520: @198829
     /* 198829 */   GIM_Reject,
     /* 198830 */ // Label 4514: @198830
     /* 198830 */ GIM_Reject,
     /* 198831 */ // Label 4463: @198831
     /* 198831 */ GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(198945),
     /* 198836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 198839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 198842 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 198845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198853 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 198857 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(198890), // Rule ID 22073 //
     /* 198862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 198865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198869 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198875 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198879 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, immAllZerosV:{ *:[v32i8] })  =>  (VPCOMPRESSBZ256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 198879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrkz),
     /* 198882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198884 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198886 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198888 */     GIR_RootConstrainSelectedInstOperands,
     /* 198889 */     // GIR_Coverage, 22073,
     /* 198889 */     GIR_EraseRootFromParent_Done,
     /* 198890 */   // Label 4522: @198890
     /* 198890 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(198919), // Rule ID 22072 //
     /* 198895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 198898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 198906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198908 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, (undef:{ *:[v32i8] }))  =>  (VPCOMPRESSBZ256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 198908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrkz),
     /* 198911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198913 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198915 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198917 */     GIR_RootConstrainSelectedInstOperands,
     /* 198918 */     // GIR_Coverage, 22072,
     /* 198918 */     GIR_EraseRootFromParent_Done,
     /* 198919 */   // Label 4523: @198919
     /* 198919 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(198944), // Rule ID 22074 //
     /* 198924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 198927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 198931 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$passthru)  =>  (VPCOMPRESSBZ256rrk:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$passthru, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 198931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrk),
     /* 198934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198936 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 198938 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 198940 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198942 */     GIR_RootConstrainSelectedInstOperands,
     /* 198943 */     // GIR_Coverage, 22074,
     /* 198943 */     GIR_EraseRootFromParent_Done,
     /* 198944 */   // Label 4524: @198944
     /* 198944 */   GIM_Reject,
     /* 198945 */ // Label 4521: @198945
     /* 198945 */ GIM_Reject,
     /* 198946 */ // Label 4464: @198946
     /* 198946 */ GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(199060),
     /* 198951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 198954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 198957 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 198960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198968 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 198972 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(199005), // Rule ID 22085 //
     /* 198977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 198980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 198984 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 198990 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 198992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198994 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, immAllZerosV:{ *:[v32i16] })  =>  (VPCOMPRESSWZrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 198994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrkz),
     /* 198997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198999 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199001 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199003 */     GIR_RootConstrainSelectedInstOperands,
     /* 199004 */     // GIR_Coverage, 22085,
     /* 199004 */     GIR_EraseRootFromParent_Done,
     /* 199005 */   // Label 4526: @199005
     /* 199005 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(199034), // Rule ID 22084 //
     /* 199010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 199013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 199021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199023 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, (undef:{ *:[v32i16] }))  =>  (VPCOMPRESSWZrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 199023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrkz),
     /* 199026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199028 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199030 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199032 */     GIR_RootConstrainSelectedInstOperands,
     /* 199033 */     // GIR_Coverage, 22084,
     /* 199033 */     GIR_EraseRootFromParent_Done,
     /* 199034 */   // Label 4527: @199034
     /* 199034 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(199059), // Rule ID 22086 //
     /* 199039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 199042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199046 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$passthru)  =>  (VPCOMPRESSWZrrk:{ *:[v32i16] } VR512:{ *:[v32i16] }:$passthru, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 199046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrk),
     /* 199049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199051 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 199053 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199055 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199057 */     GIR_RootConstrainSelectedInstOperands,
     /* 199058 */     // GIR_Coverage, 22086,
     /* 199058 */     GIR_EraseRootFromParent_Done,
     /* 199059 */   // Label 4528: @199059
     /* 199059 */   GIM_Reject,
     /* 199060 */ // Label 4525: @199060
     /* 199060 */ GIM_Reject,
     /* 199061 */ // Label 4465: @199061
     /* 199061 */ GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(199175),
     /* 199066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 199069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 199072 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 199075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199083 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64WMRegClassID),
     /* 199087 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(199120), // Rule ID 22067 //
     /* 199092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 199095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199099 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 199105 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 199107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199109 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, immAllZerosV:{ *:[v64i8] })  =>  (VPCOMPRESSBZrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 199109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrkz),
     /* 199112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199114 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199116 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199118 */     GIR_RootConstrainSelectedInstOperands,
     /* 199119 */     // GIR_Coverage, 22067,
     /* 199119 */     GIR_EraseRootFromParent_Done,
     /* 199120 */   // Label 4530: @199120
     /* 199120 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(199149), // Rule ID 22066 //
     /* 199125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 199128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 199132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 199136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199138 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, (undef:{ *:[v64i8] }))  =>  (VPCOMPRESSBZrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 199138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrkz),
     /* 199141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199143 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199145 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199147 */     GIR_RootConstrainSelectedInstOperands,
     /* 199148 */     // GIR_Coverage, 22066,
     /* 199148 */     GIR_EraseRootFromParent_Done,
     /* 199149 */   // Label 4531: @199149
     /* 199149 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(199174), // Rule ID 22068 //
     /* 199154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 199157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199161 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$passthru)  =>  (VPCOMPRESSBZrrk:{ *:[v64i8] } VR512:{ *:[v64i8] }:$passthru, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 199161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrk),
     /* 199164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199166 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 199168 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 199170 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199172 */     GIR_RootConstrainSelectedInstOperands,
     /* 199173 */     // GIR_Coverage, 22068,
     /* 199173 */     GIR_EraseRootFromParent_Done,
     /* 199174 */   // Label 4532: @199174
     /* 199174 */   GIM_Reject,
     /* 199175 */ // Label 4529: @199175
     /* 199175 */ GIM_Reject,
     /* 199176 */ // Label 4466: @199176
     /* 199176 */ GIM_Reject,
     /* 199177 */ // Label 62: @199177
     /* 199177 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 4536*/ GIMT_Encode4(199482),
     /* 199188 */ /*GILLT_s16*//*Label 4533*/ GIMT_Encode4(199200),
     /* 199192 */ /*GILLT_s32*//*Label 4534*/ GIMT_Encode4(199294),
     /* 199196 */ /*GILLT_s64*//*Label 4535*/ GIMT_Encode4(199388),
     /* 199200 */ // Label 4533: @199200
     /* 199200 */ GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(199293),
     /* 199205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 199208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 199212 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(199267), // Rule ID 77 //
     /* 199217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 199220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 199224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 199228 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 199231 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 199235 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 199239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 199248 */     // (cttz:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (TZCNT16rm:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 199248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZCNT16rm),
     /* 199251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199253 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 199257 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 199260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 199265 */     GIR_RootConstrainSelectedInstOperands,
     /* 199266 */     // GIR_Coverage, 77,
     /* 199266 */     GIR_EraseRootFromParent_Done,
     /* 199267 */   // Label 4538: @199267
     /* 199267 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(199292), // Rule ID 76 //
     /* 199272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 199275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 199279 */     // (cttz:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (TZCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 199279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT16rr),
     /* 199284 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 199290 */     GIR_RootConstrainSelectedInstOperands,
     /* 199291 */     // GIR_Coverage, 76,
     /* 199291 */     GIR_Done,
     /* 199292 */   // Label 4539: @199292
     /* 199292 */   GIM_Reject,
     /* 199293 */ // Label 4537: @199293
     /* 199293 */ GIM_Reject,
     /* 199294 */ // Label 4534: @199294
     /* 199294 */ GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(199387),
     /* 199299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 199302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 199306 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(199361), // Rule ID 79 //
     /* 199311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 199314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 199318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 199322 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 199325 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 199329 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 199333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 199342 */     // (cttz:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (TZCNT32rm:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 199342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZCNT32rm),
     /* 199345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199347 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 199351 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 199354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 199359 */     GIR_RootConstrainSelectedInstOperands,
     /* 199360 */     // GIR_Coverage, 79,
     /* 199360 */     GIR_EraseRootFromParent_Done,
     /* 199361 */   // Label 4541: @199361
     /* 199361 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(199386), // Rule ID 78 //
     /* 199366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 199369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 199373 */     // (cttz:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (TZCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 199373 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT32rr),
     /* 199378 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 199384 */     GIR_RootConstrainSelectedInstOperands,
     /* 199385 */     // GIR_Coverage, 78,
     /* 199385 */     GIR_Done,
     /* 199386 */   // Label 4542: @199386
     /* 199386 */   GIM_Reject,
     /* 199387 */ // Label 4540: @199387
     /* 199387 */ GIM_Reject,
     /* 199388 */ // Label 4535: @199388
     /* 199388 */ GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(199481),
     /* 199393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 199396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 199400 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(199455), // Rule ID 81 //
     /* 199405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 199408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 199412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 199416 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 199419 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 199423 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 199427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 199436 */     // (cttz:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (TZCNT64rm:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 199436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZCNT64rm),
     /* 199439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199441 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 199445 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 199448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 199453 */     GIR_RootConstrainSelectedInstOperands,
     /* 199454 */     // GIR_Coverage, 81,
     /* 199454 */     GIR_EraseRootFromParent_Done,
     /* 199455 */   // Label 4544: @199455
     /* 199455 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(199480), // Rule ID 80 //
     /* 199460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 199463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 199467 */     // (cttz:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (TZCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 199467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT64rr),
     /* 199472 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 199478 */     GIR_RootConstrainSelectedInstOperands,
     /* 199479 */     // GIR_Coverage, 80,
     /* 199479 */     GIR_Done,
     /* 199480 */   // Label 4545: @199480
     /* 199480 */   GIM_Reject,
     /* 199481 */ // Label 4543: @199481
     /* 199481 */ GIM_Reject,
     /* 199482 */ // Label 4536: @199482
     /* 199482 */ GIM_Reject,
     /* 199483 */ // Label 63: @199483
     /* 199483 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 4549*/ GIMT_Encode4(199869),
     /* 199494 */ /*GILLT_s16*//*Label 4546*/ GIMT_Encode4(199506),
     /* 199498 */ /*GILLT_s32*//*Label 4547*/ GIMT_Encode4(199627),
     /* 199502 */ /*GILLT_s64*//*Label 4548*/ GIMT_Encode4(199748),
     /* 199506 */ // Label 4546: @199506
     /* 199506 */ GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(199626),
     /* 199511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 199514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 199518 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(199587), // Rule ID 22982 //
     /* 199523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 199527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 199531 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 199534 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 199538 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 199542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199544 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 199551 */     // (cttz_zero_undef:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (BSF16rm:{ *:[i16] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i16] }), addr:{ *:[iPTR] }:$src)
     /* 199551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 199554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 199565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF16rm),
     /* 199568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 199573 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 199577 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 199580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 199585 */     GIR_RootConstrainSelectedInstOperands,
     /* 199586 */     // GIR_Coverage, 22982,
     /* 199586 */     GIR_EraseRootFromParent_Done,
     /* 199587 */   // Label 4551: @199587
     /* 199587 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(199625), // Rule ID 22979 //
     /* 199592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 199596 */     // (cttz_zero_undef:{ *:[i16] } GR16:{ *:[i16] }:$src)  =>  (BSF16rr:{ *:[i16] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i16] }), GR16:{ *:[i16] }:$src)
     /* 199596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 199599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 199610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF16rr),
     /* 199613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 199618 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 199623 */     GIR_RootConstrainSelectedInstOperands,
     /* 199624 */     // GIR_Coverage, 22979,
     /* 199624 */     GIR_EraseRootFromParent_Done,
     /* 199625 */   // Label 4552: @199625
     /* 199625 */   GIM_Reject,
     /* 199626 */ // Label 4550: @199626
     /* 199626 */ GIM_Reject,
     /* 199627 */ // Label 4547: @199627
     /* 199627 */ GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(199747),
     /* 199632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 199635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 199639 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(199708), // Rule ID 22983 //
     /* 199644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 199648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 199652 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 199655 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 199659 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 199663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 199672 */     // (cttz_zero_undef:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (BSF32rm:{ *:[i32] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), addr:{ *:[iPTR] }:$src)
     /* 199672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 199675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 199686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF32rm),
     /* 199689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 199694 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 199698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 199701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 199706 */     GIR_RootConstrainSelectedInstOperands,
     /* 199707 */     // GIR_Coverage, 22983,
     /* 199707 */     GIR_EraseRootFromParent_Done,
     /* 199708 */   // Label 4554: @199708
     /* 199708 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(199746), // Rule ID 22980 //
     /* 199713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 199717 */     // (cttz_zero_undef:{ *:[i32] } GR32:{ *:[i32] }:$src)  =>  (BSF32rr:{ *:[i32] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR32:{ *:[i32] }:$src)
     /* 199717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 199720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 199731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF32rr),
     /* 199734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 199739 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 199744 */     GIR_RootConstrainSelectedInstOperands,
     /* 199745 */     // GIR_Coverage, 22980,
     /* 199745 */     GIR_EraseRootFromParent_Done,
     /* 199746 */   // Label 4555: @199746
     /* 199746 */   GIM_Reject,
     /* 199747 */ // Label 4553: @199747
     /* 199747 */ GIM_Reject,
     /* 199748 */ // Label 4548: @199748
     /* 199748 */ GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(199868),
     /* 199753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 199756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 199760 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(199829), // Rule ID 22984 //
     /* 199765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 199769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 199773 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 199776 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 199780 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 199784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 199793 */     // (cttz_zero_undef:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (BSF64rm:{ *:[i64] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i64] }), addr:{ *:[iPTR] }:$src)
     /* 199793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 199796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 199807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF64rm),
     /* 199810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 199815 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 199819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 199822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 199827 */     GIR_RootConstrainSelectedInstOperands,
     /* 199828 */     // GIR_Coverage, 22984,
     /* 199828 */     GIR_EraseRootFromParent_Done,
     /* 199829 */   // Label 4557: @199829
     /* 199829 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(199867), // Rule ID 22981 //
     /* 199834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 199838 */     // (cttz_zero_undef:{ *:[i64] } GR64:{ *:[i64] }:$src)  =>  (BSF64rr:{ *:[i64] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i64] }), GR64:{ *:[i64] }:$src)
     /* 199838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 199841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 199852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF64rr),
     /* 199855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 199860 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 199865 */     GIR_RootConstrainSelectedInstOperands,
     /* 199866 */     // GIR_Coverage, 22981,
     /* 199866 */     GIR_EraseRootFromParent_Done,
     /* 199867 */   // Label 4558: @199867
     /* 199867 */   GIM_Reject,
     /* 199868 */ // Label 4556: @199868
     /* 199868 */ GIM_Reject,
     /* 199869 */ // Label 4549: @199869
     /* 199869 */ GIM_Reject,
     /* 199870 */ // Label 64: @199870
     /* 199870 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(20), /*)*//*default:*//*Label 4568*/ GIMT_Encode4(201173),
     /* 199881 */ /*GILLT_s16*//*Label 4559*/ GIMT_Encode4(199953),
     /* 199885 */ /*GILLT_s32*//*Label 4560*/ GIMT_Encode4(200047),
     /* 199889 */ /*GILLT_s64*//*Label 4561*/ GIMT_Encode4(200141), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 199905 */ /*GILLT_v2s64*//*Label 4562*/ GIMT_Encode4(200235), GIMT_Encode4(0),
     /* 199913 */ /*GILLT_v4s32*//*Label 4563*/ GIMT_Encode4(200431),
     /* 199917 */ /*GILLT_v4s64*//*Label 4564*/ GIMT_Encode4(200627), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 199929 */ /*GILLT_v8s32*//*Label 4565*/ GIMT_Encode4(200815),
     /* 199933 */ /*GILLT_v8s64*//*Label 4566*/ GIMT_Encode4(201003), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 199949 */ /*GILLT_v16s32*//*Label 4567*/ GIMT_Encode4(201088),
     /* 199953 */ // Label 4559: @199953
     /* 199953 */ GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(200046),
     /* 199958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 199961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 199965 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(200020), // Rule ID 71 //
     /* 199970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 199973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 199977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 199981 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 199984 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 199988 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 199992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 199994 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200001 */     // (ctlz:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (LZCNT16rm:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 200001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LZCNT16rm),
     /* 200004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200006 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 200010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200018 */     GIR_RootConstrainSelectedInstOperands,
     /* 200019 */     // GIR_Coverage, 71,
     /* 200019 */     GIR_EraseRootFromParent_Done,
     /* 200020 */   // Label 4570: @200020
     /* 200020 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(200045), // Rule ID 70 //
     /* 200025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 200028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 200032 */     // (ctlz:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (LZCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 200032 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT16rr),
     /* 200037 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 200043 */     GIR_RootConstrainSelectedInstOperands,
     /* 200044 */     // GIR_Coverage, 70,
     /* 200044 */     GIR_Done,
     /* 200045 */   // Label 4571: @200045
     /* 200045 */   GIM_Reject,
     /* 200046 */ // Label 4569: @200046
     /* 200046 */ GIM_Reject,
     /* 200047 */ // Label 4560: @200047
     /* 200047 */ GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(200140),
     /* 200052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 200055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 200059 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(200114), // Rule ID 73 //
     /* 200064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 200067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200075 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200078 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200082 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 200086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200088 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200095 */     // (ctlz:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (LZCNT32rm:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 200095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LZCNT32rm),
     /* 200098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200100 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 200104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200112 */     GIR_RootConstrainSelectedInstOperands,
     /* 200113 */     // GIR_Coverage, 73,
     /* 200113 */     GIR_EraseRootFromParent_Done,
     /* 200114 */   // Label 4573: @200114
     /* 200114 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(200139), // Rule ID 72 //
     /* 200119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 200122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 200126 */     // (ctlz:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (LZCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 200126 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT32rr),
     /* 200131 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 200137 */     GIR_RootConstrainSelectedInstOperands,
     /* 200138 */     // GIR_Coverage, 72,
     /* 200138 */     GIR_Done,
     /* 200139 */   // Label 4574: @200139
     /* 200139 */   GIM_Reject,
     /* 200140 */ // Label 4572: @200140
     /* 200140 */ GIM_Reject,
     /* 200141 */ // Label 4561: @200141
     /* 200141 */ GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(200234),
     /* 200146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 200149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 200153 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(200208), // Rule ID 75 //
     /* 200158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 200161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200169 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200172 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 200176 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200189 */     // (ctlz:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LZCNT64rm:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 200189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LZCNT64rm),
     /* 200192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200194 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 200198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 200201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200206 */     GIR_RootConstrainSelectedInstOperands,
     /* 200207 */     // GIR_Coverage, 75,
     /* 200207 */     GIR_EraseRootFromParent_Done,
     /* 200208 */   // Label 4576: @200208
     /* 200208 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(200233), // Rule ID 74 //
     /* 200213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 200216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 200220 */     // (ctlz:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (LZCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 200220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT64rr),
     /* 200225 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 200231 */     GIR_RootConstrainSelectedInstOperands,
     /* 200232 */     // GIR_Coverage, 74,
     /* 200232 */     GIR_Done,
     /* 200233 */   // Label 4577: @200233
     /* 200233 */   GIM_Reject,
     /* 200234 */ // Label 4575: @200234
     /* 200234 */ GIM_Reject,
     /* 200235 */ // Label 4562: @200235
     /* 200235 */ GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(200430),
     /* 200240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200243 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(200299), // Rule ID 13356 //
     /* 200248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 200251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200263 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200266 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 200270 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200276 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200283 */     // (ctlz:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /* 200283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ128rm),
     /* 200286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200288 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 200292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200297 */     GIR_RootConstrainSelectedInstOperands,
     /* 200298 */     // GIR_Coverage, 13356,
     /* 200298 */     GIR_EraseRootFromParent_Done,
     /* 200299 */   // Label 4579: @200299
     /* 200299 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(200322), // Rule ID 13353 //
     /* 200304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 200307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200315 */     // (ctlz:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPLZCNTQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 200315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ128rr),
     /* 200320 */     GIR_RootConstrainSelectedInstOperands,
     /* 200321 */     // GIR_Coverage, 13353,
     /* 200321 */     GIR_Done,
     /* 200322 */   // Label 4580: @200322
     /* 200322 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(200429), // Rule ID 21825 //
     /* 200327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 200330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 200334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200338 */     // (ctlz:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPLZCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 200338 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 200341 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200345 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 200352 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 200355 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200359 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200364 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 200367 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 200371 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 200374 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 200379 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200384 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 200389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 200392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 200396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200401 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 200404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200411 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 200418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 200423 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200428 */     // GIR_Coverage, 21825,
     /* 200428 */     GIR_EraseRootFromParent_Done,
     /* 200429 */   // Label 4581: @200429
     /* 200429 */   GIM_Reject,
     /* 200430 */ // Label 4578: @200430
     /* 200430 */ GIM_Reject,
     /* 200431 */ // Label 4563: @200431
     /* 200431 */ GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(200626),
     /* 200436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 200439 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(200495), // Rule ID 13383 //
     /* 200444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 200447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200459 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200462 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 200466 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200472 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200479 */     // (ctlz:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTDZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)
     /* 200479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ128rm),
     /* 200482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200484 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 200488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200493 */     GIR_RootConstrainSelectedInstOperands,
     /* 200494 */     // GIR_Coverage, 13383,
     /* 200494 */     GIR_EraseRootFromParent_Done,
     /* 200495 */   // Label 4583: @200495
     /* 200495 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(200518), // Rule ID 13380 //
     /* 200500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 200503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200511 */     // (ctlz:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPLZCNTDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 200511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ128rr),
     /* 200516 */     GIR_RootConstrainSelectedInstOperands,
     /* 200517 */     // GIR_Coverage, 13380,
     /* 200517 */     GIR_Done,
     /* 200518 */   // Label 4584: @200518
     /* 200518 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(200625), // Rule ID 21827 //
     /* 200523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 200526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 200530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200534 */     // (ctlz:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPLZCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 200534 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 200537 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200541 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 200548 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 200551 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200555 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200560 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 200563 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 200567 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 200570 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 200575 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200580 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 200585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 200588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 200592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200597 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 200600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200607 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 200614 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 200619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200624 */     // GIR_Coverage, 21827,
     /* 200624 */     GIR_EraseRootFromParent_Done,
     /* 200625 */   // Label 4585: @200625
     /* 200625 */   GIM_Reject,
     /* 200626 */ // Label 4582: @200626
     /* 200626 */ GIM_Reject,
     /* 200627 */ // Label 4564: @200627
     /* 200627 */ GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(200814),
     /* 200632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 200635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 200639 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(200691), // Rule ID 13347 //
     /* 200644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 200647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200655 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200658 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 200662 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200668 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200675 */     // (ctlz:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)
     /* 200675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ256rm),
     /* 200678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200680 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 200684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200689 */     GIR_RootConstrainSelectedInstOperands,
     /* 200690 */     // GIR_Coverage, 13347,
     /* 200690 */     GIR_EraseRootFromParent_Done,
     /* 200691 */   // Label 4587: @200691
     /* 200691 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(200710), // Rule ID 13344 //
     /* 200696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 200699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 200703 */     // (ctlz:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPLZCNTQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 200703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ256rr),
     /* 200708 */     GIR_RootConstrainSelectedInstOperands,
     /* 200709 */     // GIR_Coverage, 13344,
     /* 200709 */     GIR_Done,
     /* 200710 */   // Label 4588: @200710
     /* 200710 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(200813), // Rule ID 21824 //
     /* 200715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 200718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 200722 */     // (ctlz:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPLZCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 200722 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 200725 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200729 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 200736 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 200739 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200743 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200748 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 200751 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 200755 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 200758 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 200763 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200768 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 200776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 200780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200785 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 200788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200795 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 200802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200812 */     // GIR_Coverage, 21824,
     /* 200812 */     GIR_EraseRootFromParent_Done,
     /* 200813 */   // Label 4589: @200813
     /* 200813 */   GIM_Reject,
     /* 200814 */ // Label 4586: @200814
     /* 200814 */ GIM_Reject,
     /* 200815 */ // Label 4565: @200815
     /* 200815 */ GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(201002),
     /* 200820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 200823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 200827 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(200879), // Rule ID 13374 //
     /* 200832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 200835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 200839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 200843 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 200846 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 200850 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 200854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 200856 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 200863 */     // (ctlz:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)
     /* 200863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ256rm),
     /* 200866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200868 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 200872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 200877 */     GIR_RootConstrainSelectedInstOperands,
     /* 200878 */     // GIR_Coverage, 13374,
     /* 200878 */     GIR_EraseRootFromParent_Done,
     /* 200879 */   // Label 4591: @200879
     /* 200879 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(200898), // Rule ID 13371 //
     /* 200884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 200887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 200891 */     // (ctlz:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPLZCNTDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 200891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ256rr),
     /* 200896 */     GIR_RootConstrainSelectedInstOperands,
     /* 200897 */     // GIR_Coverage, 13371,
     /* 200897 */     GIR_Done,
     /* 200898 */   // Label 4592: @200898
     /* 200898 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(201001), // Rule ID 21826 //
     /* 200903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 200906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 200910 */     // (ctlz:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPLZCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 200910 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 200913 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200917 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 200924 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 200927 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200931 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200936 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 200939 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 200943 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 200946 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 200951 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200956 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 200964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 200968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200973 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 200976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200983 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 200990 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201000 */     // GIR_Coverage, 21826,
     /* 201000 */     GIR_EraseRootFromParent_Done,
     /* 201001 */   // Label 4593: @201001
     /* 201001 */   GIM_Reject,
     /* 201002 */ // Label 4590: @201002
     /* 201002 */ GIM_Reject,
     /* 201003 */ // Label 4566: @201003
     /* 201003 */ GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(201087),
     /* 201008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 201011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 201015 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(201067), // Rule ID 13338 //
     /* 201020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 201023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 201027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 201031 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 201034 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 201038 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 201042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201044 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 201051 */     // (ctlz:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)
     /* 201051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrm),
     /* 201054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201056 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 201060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 201065 */     GIR_RootConstrainSelectedInstOperands,
     /* 201066 */     // GIR_Coverage, 13338,
     /* 201066 */     GIR_EraseRootFromParent_Done,
     /* 201067 */   // Label 4595: @201067
     /* 201067 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(201086), // Rule ID 13335 //
     /* 201072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 201075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 201079 */     // (ctlz:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPLZCNTQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 201079 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 201084 */     GIR_RootConstrainSelectedInstOperands,
     /* 201085 */     // GIR_Coverage, 13335,
     /* 201085 */     GIR_Done,
     /* 201086 */   // Label 4596: @201086
     /* 201086 */   GIM_Reject,
     /* 201087 */ // Label 4594: @201087
     /* 201087 */ GIM_Reject,
     /* 201088 */ // Label 4567: @201088
     /* 201088 */ GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(201172),
     /* 201093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 201096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 201100 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(201152), // Rule ID 13365 //
     /* 201105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 201108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 201112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 201116 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 201119 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 201123 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 201127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201129 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 201136 */     // (ctlz:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)
     /* 201136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrm),
     /* 201139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201141 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 201145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 201150 */     GIR_RootConstrainSelectedInstOperands,
     /* 201151 */     // GIR_Coverage, 13365,
     /* 201151 */     GIR_EraseRootFromParent_Done,
     /* 201152 */   // Label 4598: @201152
     /* 201152 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(201171), // Rule ID 13362 //
     /* 201157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 201160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 201164 */     // (ctlz:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPLZCNTDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 201164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 201169 */     GIR_RootConstrainSelectedInstOperands,
     /* 201170 */     // GIR_Coverage, 13362,
     /* 201170 */     GIR_Done,
     /* 201171 */   // Label 4599: @201171
     /* 201171 */   GIM_Reject,
     /* 201172 */ // Label 4597: @201172
     /* 201172 */ GIM_Reject,
     /* 201173 */ // Label 4568: @201173
     /* 201173 */ GIM_Reject,
     /* 201174 */ // Label 65: @201174
     /* 201174 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(25), /*)*//*default:*//*Label 4615*/ GIMT_Encode4(203435),
     /* 201185 */ /*GILLT_s16*//*Label 4600*/ GIMT_Encode4(201277),
     /* 201189 */ /*GILLT_s32*//*Label 4601*/ GIMT_Encode4(201371),
     /* 201193 */ /*GILLT_s64*//*Label 4602*/ GIMT_Encode4(201465), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 201209 */ /*GILLT_v2s64*//*Label 4603*/ GIMT_Encode4(201559), GIMT_Encode4(0),
     /* 201217 */ /*GILLT_v4s32*//*Label 4604*/ GIMT_Encode4(201755),
     /* 201221 */ /*GILLT_v4s64*//*Label 4605*/ GIMT_Encode4(201951), GIMT_Encode4(0),
     /* 201229 */ /*GILLT_v8s16*//*Label 4606*/ GIMT_Encode4(202139),
     /* 201233 */ /*GILLT_v8s32*//*Label 4607*/ GIMT_Encode4(202335),
     /* 201237 */ /*GILLT_v8s64*//*Label 4608*/ GIMT_Encode4(202523), GIMT_Encode4(0),
     /* 201245 */ /*GILLT_v16s8*//*Label 4609*/ GIMT_Encode4(202608),
     /* 201249 */ /*GILLT_v16s16*//*Label 4610*/ GIMT_Encode4(202804),
     /* 201253 */ /*GILLT_v16s32*//*Label 4611*/ GIMT_Encode4(202992), GIMT_Encode4(0),
     /* 201261 */ /*GILLT_v32s8*//*Label 4612*/ GIMT_Encode4(203077),
     /* 201265 */ /*GILLT_v32s16*//*Label 4613*/ GIMT_Encode4(203265), GIMT_Encode4(0),
     /* 201273 */ /*GILLT_v64s8*//*Label 4614*/ GIMT_Encode4(203350),
     /* 201277 */ // Label 4600: @201277
     /* 201277 */ GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(201370),
     /* 201282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 201285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 201289 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(201344), // Rule ID 3175 //
     /* 201294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 201297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 201301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 201305 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 201308 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 201312 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 201316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201318 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 201325 */     // (ctpop:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (POPCNT16rm:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 201325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::POPCNT16rm),
     /* 201328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201330 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 201334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 201337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 201342 */     GIR_RootConstrainSelectedInstOperands,
     /* 201343 */     // GIR_Coverage, 3175,
     /* 201343 */     GIR_EraseRootFromParent_Done,
     /* 201344 */   // Label 4617: @201344
     /* 201344 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(201369), // Rule ID 3174 //
     /* 201349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 201352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 201356 */     // (ctpop:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (POPCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 201356 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT16rr),
     /* 201361 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 201367 */     GIR_RootConstrainSelectedInstOperands,
     /* 201368 */     // GIR_Coverage, 3174,
     /* 201368 */     GIR_Done,
     /* 201369 */   // Label 4618: @201369
     /* 201369 */   GIM_Reject,
     /* 201370 */ // Label 4616: @201370
     /* 201370 */ GIM_Reject,
     /* 201371 */ // Label 4601: @201371
     /* 201371 */ GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(201464),
     /* 201376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 201379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 201383 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(201438), // Rule ID 3177 //
     /* 201388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 201391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 201395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 201399 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 201402 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 201406 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 201410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 201419 */     // (ctpop:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (POPCNT32rm:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 201419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::POPCNT32rm),
     /* 201422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201424 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 201428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 201431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 201436 */     GIR_RootConstrainSelectedInstOperands,
     /* 201437 */     // GIR_Coverage, 3177,
     /* 201437 */     GIR_EraseRootFromParent_Done,
     /* 201438 */   // Label 4620: @201438
     /* 201438 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(201463), // Rule ID 3176 //
     /* 201443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 201446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 201450 */     // (ctpop:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (POPCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 201450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT32rr),
     /* 201455 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 201461 */     GIR_RootConstrainSelectedInstOperands,
     /* 201462 */     // GIR_Coverage, 3176,
     /* 201462 */     GIR_Done,
     /* 201463 */   // Label 4621: @201463
     /* 201463 */   GIM_Reject,
     /* 201464 */ // Label 4619: @201464
     /* 201464 */ GIM_Reject,
     /* 201465 */ // Label 4602: @201465
     /* 201465 */ GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(201558),
     /* 201470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 201473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 201477 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(201532), // Rule ID 3179 //
     /* 201482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 201485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 201489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 201493 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 201496 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 201500 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 201504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201506 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 201513 */     // (ctpop:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (POPCNT64rm:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 201513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::POPCNT64rm),
     /* 201516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201518 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 201522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 201525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 201530 */     GIR_RootConstrainSelectedInstOperands,
     /* 201531 */     // GIR_Coverage, 3179,
     /* 201531 */     GIR_EraseRootFromParent_Done,
     /* 201532 */   // Label 4623: @201532
     /* 201532 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(201557), // Rule ID 3178 //
     /* 201537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 201540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 201544 */     // (ctpop:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (POPCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 201544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT64rr),
     /* 201549 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 201555 */     GIR_RootConstrainSelectedInstOperands,
     /* 201556 */     // GIR_Coverage, 3178,
     /* 201556 */     GIR_Done,
     /* 201557 */   // Label 4624: @201557
     /* 201557 */   GIM_Reject,
     /* 201558 */ // Label 4622: @201558
     /* 201558 */ GIM_Reject,
     /* 201559 */ // Label 4603: @201559
     /* 201559 */ GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(201754),
     /* 201564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 201567 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(201623), // Rule ID 13464 //
     /* 201572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 201575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 201583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 201587 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 201590 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 201594 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 201598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201600 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 201607 */     // (ctpop:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /* 201607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ128rm),
     /* 201610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201612 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 201616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 201621 */     GIR_RootConstrainSelectedInstOperands,
     /* 201622 */     // GIR_Coverage, 13464,
     /* 201622 */     GIR_EraseRootFromParent_Done,
     /* 201623 */   // Label 4626: @201623
     /* 201623 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(201646), // Rule ID 13461 //
     /* 201628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 201631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201639 */     // (ctpop:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPOPCNTQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 201639 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ128rr),
     /* 201644 */     GIR_RootConstrainSelectedInstOperands,
     /* 201645 */     // GIR_Coverage, 13461,
     /* 201645 */     GIR_Done,
     /* 201646 */   // Label 4627: @201646
     /* 201646 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(201753), // Rule ID 21829 //
     /* 201651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 201654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 201658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201662 */     // (ctpop:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPOPCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 201662 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 201665 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201669 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 201676 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 201679 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201683 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201688 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 201691 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 201695 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 201698 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 201703 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201708 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 201713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 201716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 201720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201725 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 201728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 201730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 201733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201735 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 201742 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 201747 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201752 */     // GIR_Coverage, 21829,
     /* 201752 */     GIR_EraseRootFromParent_Done,
     /* 201753 */   // Label 4628: @201753
     /* 201753 */   GIM_Reject,
     /* 201754 */ // Label 4625: @201754
     /* 201754 */ GIM_Reject,
     /* 201755 */ // Label 4604: @201755
     /* 201755 */ GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(201950),
     /* 201760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201763 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(201819), // Rule ID 13491 //
     /* 201768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 201771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 201779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 201783 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 201786 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 201790 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 201794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201796 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 201803 */     // (ctpop:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTDZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)
     /* 201803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ128rm),
     /* 201806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201808 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 201812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 201817 */     GIR_RootConstrainSelectedInstOperands,
     /* 201818 */     // GIR_Coverage, 13491,
     /* 201818 */     GIR_EraseRootFromParent_Done,
     /* 201819 */   // Label 4630: @201819
     /* 201819 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(201842), // Rule ID 13488 //
     /* 201824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 201827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201835 */     // (ctpop:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPOPCNTDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 201835 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ128rr),
     /* 201840 */     GIR_RootConstrainSelectedInstOperands,
     /* 201841 */     // GIR_Coverage, 13488,
     /* 201841 */     GIR_Done,
     /* 201842 */   // Label 4631: @201842
     /* 201842 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(201949), // Rule ID 21831 //
     /* 201847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 201850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 201854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201858 */     // (ctpop:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPOPCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 201858 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 201861 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201865 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 201872 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 201875 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201879 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201884 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 201887 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 201891 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 201894 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 201899 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201904 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 201909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 201912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 201916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201921 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 201924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 201926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 201929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201931 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 201938 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 201943 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201948 */     // GIR_Coverage, 21831,
     /* 201948 */     GIR_EraseRootFromParent_Done,
     /* 201949 */   // Label 4632: @201949
     /* 201949 */   GIM_Reject,
     /* 201950 */ // Label 4629: @201950
     /* 201950 */ GIM_Reject,
     /* 201951 */ // Label 4605: @201951
     /* 201951 */ GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(202138),
     /* 201956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 201959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201963 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(202015), // Rule ID 13455 //
     /* 201968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 201971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 201975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 201979 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 201982 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 201986 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 201990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201992 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 201999 */     // (ctpop:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)
     /* 201999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ256rm),
     /* 202002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202004 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 202008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 202013 */     GIR_RootConstrainSelectedInstOperands,
     /* 202014 */     // GIR_Coverage, 13455,
     /* 202014 */     GIR_EraseRootFromParent_Done,
     /* 202015 */   // Label 4634: @202015
     /* 202015 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(202034), // Rule ID 13452 //
     /* 202020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 202023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202027 */     // (ctpop:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPOPCNTQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 202027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ256rr),
     /* 202032 */     GIR_RootConstrainSelectedInstOperands,
     /* 202033 */     // GIR_Coverage, 13452,
     /* 202033 */     GIR_Done,
     /* 202034 */   // Label 4635: @202034
     /* 202034 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(202137), // Rule ID 21828 //
     /* 202039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 202042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202046 */     // (ctpop:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPOPCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 202046 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 202049 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202053 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 202060 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 202063 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202067 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202072 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 202075 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 202079 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 202082 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 202087 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202092 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 202097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 202100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 202104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202109 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 202112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 202114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 202117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202119 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 202126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 202131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202136 */     // GIR_Coverage, 21828,
     /* 202136 */     GIR_EraseRootFromParent_Done,
     /* 202137 */   // Label 4636: @202137
     /* 202137 */   GIM_Reject,
     /* 202138 */ // Label 4633: @202138
     /* 202138 */ GIM_Reject,
     /* 202139 */ // Label 4606: @202139
     /* 202139 */ GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(202334),
     /* 202144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202147 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(202203), // Rule ID 14518 //
     /* 202152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 202155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 202163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 202167 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 202170 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 202174 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 202178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202180 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 202187 */     // (ctpop:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTWZ128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)
     /* 202187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ128rm),
     /* 202190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202192 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 202196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 202201 */     GIR_RootConstrainSelectedInstOperands,
     /* 202202 */     // GIR_Coverage, 14518,
     /* 202202 */     GIR_EraseRootFromParent_Done,
     /* 202203 */   // Label 4638: @202203
     /* 202203 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(202226), // Rule ID 14515 //
     /* 202208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 202211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202219 */     // (ctpop:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (VPOPCNTWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)
     /* 202219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ128rr),
     /* 202224 */     GIR_RootConstrainSelectedInstOperands,
     /* 202225 */     // GIR_Coverage, 14515,
     /* 202225 */     GIR_Done,
     /* 202226 */   // Label 4639: @202226
     /* 202226 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(202333), // Rule ID 22138 //
     /* 202231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 202234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 202238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202242 */     // (ctpop:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPOPCNTWZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 202242 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 202245 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202249 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 202256 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 202259 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202263 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202268 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 202271 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 202275 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 202278 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 202283 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202288 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 202293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 202296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 202300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202305 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 202308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 202310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 202313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202315 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 202322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 202327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202332 */     // GIR_Coverage, 22138,
     /* 202332 */     GIR_EraseRootFromParent_Done,
     /* 202333 */   // Label 4640: @202333
     /* 202333 */   GIM_Reject,
     /* 202334 */ // Label 4637: @202334
     /* 202334 */ GIM_Reject,
     /* 202335 */ // Label 4607: @202335
     /* 202335 */ GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(202522),
     /* 202340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 202343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202347 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(202399), // Rule ID 13482 //
     /* 202352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 202355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 202359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 202363 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 202366 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 202370 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 202374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202376 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 202383 */     // (ctpop:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)
     /* 202383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ256rm),
     /* 202386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202388 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 202392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 202397 */     GIR_RootConstrainSelectedInstOperands,
     /* 202398 */     // GIR_Coverage, 13482,
     /* 202398 */     GIR_EraseRootFromParent_Done,
     /* 202399 */   // Label 4642: @202399
     /* 202399 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(202418), // Rule ID 13479 //
     /* 202404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 202407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202411 */     // (ctpop:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPOPCNTDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 202411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ256rr),
     /* 202416 */     GIR_RootConstrainSelectedInstOperands,
     /* 202417 */     // GIR_Coverage, 13479,
     /* 202417 */     GIR_Done,
     /* 202418 */   // Label 4643: @202418
     /* 202418 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(202521), // Rule ID 21830 //
     /* 202423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 202426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202430 */     // (ctpop:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPOPCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 202430 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 202433 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202437 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 202444 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 202447 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202451 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202456 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 202459 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 202463 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 202466 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 202471 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202476 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 202481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 202484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 202488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202493 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 202496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 202498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 202501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202503 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 202510 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 202515 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202520 */     // GIR_Coverage, 21830,
     /* 202520 */     GIR_EraseRootFromParent_Done,
     /* 202521 */   // Label 4644: @202521
     /* 202521 */   GIM_Reject,
     /* 202522 */ // Label 4641: @202522
     /* 202522 */ GIM_Reject,
     /* 202523 */ // Label 4608: @202523
     /* 202523 */ GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(202607),
     /* 202528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 202531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202535 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(202587), // Rule ID 13446 //
     /* 202540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 202543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 202547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 202551 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 202554 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 202558 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 202562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 202571 */     // (ctpop:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)
     /* 202571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrm),
     /* 202574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202576 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 202580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 202585 */     GIR_RootConstrainSelectedInstOperands,
     /* 202586 */     // GIR_Coverage, 13446,
     /* 202586 */     GIR_EraseRootFromParent_Done,
     /* 202587 */   // Label 4646: @202587
     /* 202587 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(202606), // Rule ID 13443 //
     /* 202592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 202595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202599 */     // (ctpop:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPOPCNTQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 202599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 202604 */     GIR_RootConstrainSelectedInstOperands,
     /* 202605 */     // GIR_Coverage, 13443,
     /* 202605 */     GIR_Done,
     /* 202606 */   // Label 4647: @202606
     /* 202606 */   GIM_Reject,
     /* 202607 */ // Label 4645: @202607
     /* 202607 */ GIM_Reject,
     /* 202608 */ // Label 4609: @202608
     /* 202608 */ GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(202803),
     /* 202613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 202616 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(202672), // Rule ID 14500 //
     /* 202621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 202624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 202632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 202636 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 202639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 202643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 202647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 202656 */     // (ctpop:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTBZ128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)
     /* 202656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ128rm),
     /* 202659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202661 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 202665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 202670 */     GIR_RootConstrainSelectedInstOperands,
     /* 202671 */     // GIR_Coverage, 14500,
     /* 202671 */     GIR_EraseRootFromParent_Done,
     /* 202672 */   // Label 4649: @202672
     /* 202672 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(202695), // Rule ID 14497 //
     /* 202677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 202680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202688 */     // (ctpop:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (VPOPCNTBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)
     /* 202688 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ128rr),
     /* 202693 */     GIR_RootConstrainSelectedInstOperands,
     /* 202694 */     // GIR_Coverage, 14497,
     /* 202694 */     GIR_Done,
     /* 202695 */   // Label 4650: @202695
     /* 202695 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(202802), // Rule ID 22136 //
     /* 202700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 202703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 202707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202711 */     // (ctpop:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPOPCNTBZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 202711 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 202714 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202718 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 202725 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 202728 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202732 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202737 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 202740 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 202744 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 202747 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 202752 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202757 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 202762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 202765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 202769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202774 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 202777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 202779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 202782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202784 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 202791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 202796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202801 */     // GIR_Coverage, 22136,
     /* 202801 */     GIR_EraseRootFromParent_Done,
     /* 202802 */   // Label 4651: @202802
     /* 202802 */   GIM_Reject,
     /* 202803 */ // Label 4648: @202803
     /* 202803 */ GIM_Reject,
     /* 202804 */ // Label 4610: @202804
     /* 202804 */ GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(202991),
     /* 202809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 202812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202816 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(202868), // Rule ID 14512 //
     /* 202821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 202824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 202828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 202832 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 202835 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 202839 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 202843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 202852 */     // (ctpop:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)
     /* 202852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ256rm),
     /* 202855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202857 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 202861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 202866 */     GIR_RootConstrainSelectedInstOperands,
     /* 202867 */     // GIR_Coverage, 14512,
     /* 202867 */     GIR_EraseRootFromParent_Done,
     /* 202868 */   // Label 4653: @202868
     /* 202868 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(202887), // Rule ID 14509 //
     /* 202873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 202876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202880 */     // (ctpop:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (VPOPCNTWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)
     /* 202880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ256rr),
     /* 202885 */     GIR_RootConstrainSelectedInstOperands,
     /* 202886 */     // GIR_Coverage, 14509,
     /* 202886 */     GIR_Done,
     /* 202887 */   // Label 4654: @202887
     /* 202887 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(202990), // Rule ID 22137 //
     /* 202892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 202895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202899 */     // (ctpop:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VPOPCNTWZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 202899 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 202902 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202906 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 202913 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 202916 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202920 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202925 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 202928 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 202932 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 202935 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 202940 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202945 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 202950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 202953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 202957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202962 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 202965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 202967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 202970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202972 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 202979 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 202984 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 202989 */     // GIR_Coverage, 22137,
     /* 202989 */     GIR_EraseRootFromParent_Done,
     /* 202990 */   // Label 4655: @202990
     /* 202990 */   GIM_Reject,
     /* 202991 */ // Label 4652: @202991
     /* 202991 */ GIM_Reject,
     /* 202992 */ // Label 4611: @202992
     /* 202992 */ GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(203076),
     /* 202997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 203000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203004 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(203056), // Rule ID 13473 //
     /* 203009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 203012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203020 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203023 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203027 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203040 */     // (ctpop:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)
     /* 203040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrm),
     /* 203043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203045 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203054 */     GIR_RootConstrainSelectedInstOperands,
     /* 203055 */     // GIR_Coverage, 13473,
     /* 203055 */     GIR_EraseRootFromParent_Done,
     /* 203056 */   // Label 4657: @203056
     /* 203056 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(203075), // Rule ID 13470 //
     /* 203061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 203064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203068 */     // (ctpop:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPOPCNTDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 203068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 203073 */     GIR_RootConstrainSelectedInstOperands,
     /* 203074 */     // GIR_Coverage, 13470,
     /* 203074 */     GIR_Done,
     /* 203075 */   // Label 4658: @203075
     /* 203075 */   GIM_Reject,
     /* 203076 */ // Label 4656: @203076
     /* 203076 */ GIM_Reject,
     /* 203077 */ // Label 4612: @203077
     /* 203077 */ GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(203264),
     /* 203082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 203085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 203089 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(203141), // Rule ID 14494 //
     /* 203094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 203097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203105 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203108 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203112 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203125 */     // (ctpop:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTBZ256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)
     /* 203125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ256rm),
     /* 203128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203130 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203139 */     GIR_RootConstrainSelectedInstOperands,
     /* 203140 */     // GIR_Coverage, 14494,
     /* 203140 */     GIR_EraseRootFromParent_Done,
     /* 203141 */   // Label 4660: @203141
     /* 203141 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(203160), // Rule ID 14491 //
     /* 203146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 203149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 203153 */     // (ctpop:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (VPOPCNTBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)
     /* 203153 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ256rr),
     /* 203158 */     GIR_RootConstrainSelectedInstOperands,
     /* 203159 */     // GIR_Coverage, 14491,
     /* 203159 */     GIR_Done,
     /* 203160 */   // Label 4661: @203160
     /* 203160 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(203263), // Rule ID 22135 //
     /* 203165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 203168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 203172 */     // (ctpop:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VPOPCNTBZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 203172 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 203175 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203179 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 203186 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 203189 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203193 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203198 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 203201 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 203205 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 203208 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 203213 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 203218 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 203223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 203226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 203230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203235 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 203238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 203243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203245 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 203252 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 203257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 203262 */     // GIR_Coverage, 22135,
     /* 203262 */     GIR_EraseRootFromParent_Done,
     /* 203263 */   // Label 4662: @203263
     /* 203263 */   GIM_Reject,
     /* 203264 */ // Label 4659: @203264
     /* 203264 */ GIM_Reject,
     /* 203265 */ // Label 4613: @203265
     /* 203265 */ GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(203349),
     /* 203270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 203273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203277 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(203329), // Rule ID 14506 //
     /* 203282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 203285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203293 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203296 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203300 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203313 */     // (ctpop:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)
     /* 203313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrm),
     /* 203316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203318 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203327 */     GIR_RootConstrainSelectedInstOperands,
     /* 203328 */     // GIR_Coverage, 14506,
     /* 203328 */     GIR_EraseRootFromParent_Done,
     /* 203329 */   // Label 4664: @203329
     /* 203329 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(203348), // Rule ID 14503 //
     /* 203334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 203337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203341 */     // (ctpop:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)  =>  (VPOPCNTWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)
     /* 203341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 203346 */     GIR_RootConstrainSelectedInstOperands,
     /* 203347 */     // GIR_Coverage, 14503,
     /* 203347 */     GIR_Done,
     /* 203348 */   // Label 4665: @203348
     /* 203348 */   GIM_Reject,
     /* 203349 */ // Label 4663: @203349
     /* 203349 */ GIM_Reject,
     /* 203350 */ // Label 4614: @203350
     /* 203350 */ GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(203434),
     /* 203355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 203358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203362 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(203414), // Rule ID 14488 //
     /* 203367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 203370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203378 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203381 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203385 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203391 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203398 */     // (ctpop:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTBZrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)
     /* 203398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrm),
     /* 203401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203403 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203412 */     GIR_RootConstrainSelectedInstOperands,
     /* 203413 */     // GIR_Coverage, 14488,
     /* 203413 */     GIR_EraseRootFromParent_Done,
     /* 203414 */   // Label 4667: @203414
     /* 203414 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(203433), // Rule ID 14485 //
     /* 203419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 203422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203426 */     // (ctpop:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)  =>  (VPOPCNTBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)
     /* 203426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 203431 */     GIR_RootConstrainSelectedInstOperands,
     /* 203432 */     // GIR_Coverage, 14485,
     /* 203432 */     GIR_Done,
     /* 203433 */   // Label 4668: @203433
     /* 203433 */   GIM_Reject,
     /* 203434 */ // Label 4666: @203434
     /* 203434 */ GIM_Reject,
     /* 203435 */ // Label 4615: @203435
     /* 203435 */ GIM_Reject,
     /* 203436 */ // Label 66: @203436
     /* 203436 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 4672*/ GIMT_Encode4(203935),
     /* 203447 */ /*GILLT_s16*//*Label 4669*/ GIMT_Encode4(203459),
     /* 203451 */ /*GILLT_s32*//*Label 4670*/ GIMT_Encode4(203623),
     /* 203455 */ /*GILLT_s64*//*Label 4671*/ GIMT_Encode4(203779),
     /* 203459 */ // Label 4669: @203459
     /* 203459 */ GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(203622),
     /* 203464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 203467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203471 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(203523), // Rule ID 49 //
     /* 203476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /* 203479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203487 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203490 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203494 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 203498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203507 */     // (bswap:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (MOVBE16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src1)
     /* 203507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16rm),
     /* 203510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203512 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203521 */     GIR_RootConstrainSelectedInstOperands,
     /* 203522 */     // GIR_Coverage, 49,
     /* 203522 */     GIR_EraseRootFromParent_Done,
     /* 203523 */   // Label 4674: @203523
     /* 203523 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(203575), // Rule ID 55 //
     /* 203528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /* 203531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203539 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203542 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203546 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 203550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203552 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203559 */     // (bswap:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (MOVBE16rm_EVEX:{ *:[i16] } addr:{ *:[iPTR] }:$src1)
     /* 203559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16rm_EVEX),
     /* 203562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203564 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203573 */     GIR_RootConstrainSelectedInstOperands,
     /* 203574 */     // GIR_Coverage, 55,
     /* 203574 */     GIR_EraseRootFromParent_Done,
     /* 203575 */   // Label 4675: @203575
     /* 203575 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(203594), // Rule ID 61 //
     /* 203580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 203583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203587 */     // (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (MOVBE16rr:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /* 203587 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE16rr),
     /* 203592 */     GIR_RootConstrainSelectedInstOperands,
     /* 203593 */     // GIR_Coverage, 61,
     /* 203593 */     GIR_Done,
     /* 203594 */   // Label 4676: @203594
     /* 203594 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(203621), // Rule ID 22985 //
     /* 203599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE),
     /* 203602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203606 */     // (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src)  =>  (ROL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src, 8:{ *:[i8] })
     /* 203606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri),
     /* 203609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203611 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 203613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 203616 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203619 */     GIR_RootConstrainSelectedInstOperands,
     /* 203620 */     // GIR_Coverage, 22985,
     /* 203620 */     GIR_EraseRootFromParent_Done,
     /* 203621 */   // Label 4677: @203621
     /* 203621 */   GIM_Reject,
     /* 203622 */ // Label 4673: @203622
     /* 203622 */ GIM_Reject,
     /* 203623 */ // Label 4670: @203623
     /* 203623 */ GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(203778),
     /* 203628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 203631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 203635 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(203687), // Rule ID 51 //
     /* 203640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /* 203643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203651 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203654 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203658 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 203662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203664 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203671 */     // (bswap:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (MOVBE32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 203671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32rm),
     /* 203674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203676 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203685 */     GIR_RootConstrainSelectedInstOperands,
     /* 203686 */     // GIR_Coverage, 51,
     /* 203686 */     GIR_EraseRootFromParent_Done,
     /* 203687 */   // Label 4679: @203687
     /* 203687 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(203739), // Rule ID 57 //
     /* 203692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /* 203695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203703 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203706 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203710 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 203714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203716 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203723 */     // (bswap:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (MOVBE32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 203723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32rm_EVEX),
     /* 203726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203728 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203737 */     GIR_RootConstrainSelectedInstOperands,
     /* 203738 */     // GIR_Coverage, 57,
     /* 203738 */     GIR_EraseRootFromParent_Done,
     /* 203739 */   // Label 4680: @203739
     /* 203739 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(203758), // Rule ID 5 //
     /* 203744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_Or_NoMOVBE),
     /* 203747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 203751 */     // (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src)  =>  (BSWAP32r:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 203751 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::BSWAP32r),
     /* 203756 */     GIR_RootConstrainSelectedInstOperands,
     /* 203757 */     // GIR_Coverage, 5,
     /* 203757 */     GIR_Done,
     /* 203758 */   // Label 4681: @203758
     /* 203758 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(203777), // Rule ID 62 //
     /* 203763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 203766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 203770 */     // (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (MOVBE32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 203770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE32rr),
     /* 203775 */     GIR_RootConstrainSelectedInstOperands,
     /* 203776 */     // GIR_Coverage, 62,
     /* 203776 */     GIR_Done,
     /* 203777 */   // Label 4682: @203777
     /* 203777 */   GIM_Reject,
     /* 203778 */ // Label 4678: @203778
     /* 203778 */ GIM_Reject,
     /* 203779 */ // Label 4671: @203779
     /* 203779 */ GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(203934),
     /* 203784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 203787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 203791 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(203843), // Rule ID 53 //
     /* 203796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /* 203799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203807 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203810 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203814 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203820 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203827 */     // (bswap:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MOVBE64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1)
     /* 203827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64rm),
     /* 203830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203832 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203841 */     GIR_RootConstrainSelectedInstOperands,
     /* 203842 */     // GIR_Coverage, 53,
     /* 203842 */     GIR_EraseRootFromParent_Done,
     /* 203843 */   // Label 4684: @203843
     /* 203843 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(203895), // Rule ID 59 //
     /* 203848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /* 203851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203859 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203862 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203866 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203879 */     // (bswap:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MOVBE64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1)
     /* 203879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64rm_EVEX),
     /* 203882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203884 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203893 */     GIR_RootConstrainSelectedInstOperands,
     /* 203894 */     // GIR_Coverage, 59,
     /* 203894 */     GIR_EraseRootFromParent_Done,
     /* 203895 */   // Label 4685: @203895
     /* 203895 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(203914), // Rule ID 6 //
     /* 203900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_Or_NoMOVBE),
     /* 203903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 203907 */     // (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src)  =>  (BSWAP64r:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 203907 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::BSWAP64r),
     /* 203912 */     GIR_RootConstrainSelectedInstOperands,
     /* 203913 */     // GIR_Coverage, 6,
     /* 203913 */     GIR_Done,
     /* 203914 */   // Label 4686: @203914
     /* 203914 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(203933), // Rule ID 63 //
     /* 203919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 203922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 203926 */     // (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (MOVBE64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /* 203926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE64rr),
     /* 203931 */     GIR_RootConstrainSelectedInstOperands,
     /* 203932 */     // GIR_Coverage, 63,
     /* 203932 */     GIR_Done,
     /* 203933 */   // Label 4687: @203933
     /* 203933 */   GIM_Reject,
     /* 203934 */ // Label 4683: @203934
     /* 203934 */ GIM_Reject,
     /* 203935 */ // Label 4672: @203935
     /* 203935 */ GIM_Reject,
     /* 203936 */ // Label 67: @203936
     /* 203936 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4701*/ GIMT_Encode4(206104),
     /* 203947 */ /*GILLT_s16*//*Label 4688*/ GIMT_Encode4(204031),
     /* 203951 */ /*GILLT_s32*//*Label 4689*/ GIMT_Encode4(204152),
     /* 203955 */ /*GILLT_s64*//*Label 4690*/ GIMT_Encode4(204508),
     /* 203959 */ /*GILLT_s80*//*Label 4691*/ GIMT_Encode4(204864), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 203971 */ /*GILLT_v2s64*//*Label 4692*/ GIMT_Encode4(204901), GIMT_Encode4(0),
     /* 203979 */ /*GILLT_v4s32*//*Label 4693*/ GIMT_Encode4(205104),
     /* 203983 */ /*GILLT_v4s64*//*Label 4694*/ GIMT_Encode4(205307), GIMT_Encode4(0),
     /* 203991 */ /*GILLT_v8s16*//*Label 4695*/ GIMT_Encode4(205483),
     /* 203995 */ /*GILLT_v8s32*//*Label 4696*/ GIMT_Encode4(205572),
     /* 203999 */ /*GILLT_v8s64*//*Label 4697*/ GIMT_Encode4(205748), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 204011 */ /*GILLT_v16s16*//*Label 4698*/ GIMT_Encode4(205837),
     /* 204015 */ /*GILLT_v16s32*//*Label 4699*/ GIMT_Encode4(205926), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 204027 */ /*GILLT_v32s16*//*Label 4700*/ GIMT_Encode4(206015),
     /* 204031 */ // Label 4688: @204031
     /* 204031 */ GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(204151),
     /* 204036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 204039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 204043 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(204112), // Rule ID 21420 //
     /* 204048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 204051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204059 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204062 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204066 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204079 */     // (fsqrt:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSHZm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 204079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 204082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZm),
     /* 204096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 204101 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 204105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204110 */     GIR_RootConstrainSelectedInstOperands,
     /* 204111 */     // GIR_Coverage, 21420,
     /* 204111 */     GIR_EraseRootFromParent_Done,
     /* 204112 */   // Label 4703: @204112
     /* 204112 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(204150), // Rule ID 21418 //
     /* 204117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 204120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 204124 */     // (fsqrt:{ *:[f16] } FR16X:{ *:[f16] }:$src)  =>  (VSQRTSHZr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR16X:{ *:[f16] }:$src)
     /* 204124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 204127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZr),
     /* 204141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 204146 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 204148 */     GIR_RootConstrainSelectedInstOperands,
     /* 204149 */     // GIR_Coverage, 21418,
     /* 204149 */     GIR_EraseRootFromParent_Done,
     /* 204150 */   // Label 4704: @204150
     /* 204150 */   GIM_Reject,
     /* 204151 */ // Label 4702: @204151
     /* 204151 */ GIM_Reject,
     /* 204152 */ // Label 4689: @204152
     /* 204152 */ GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(204507),
     /* 204157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 204160 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(204216), // Rule ID 2448 //
     /* 204165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE1),
     /* 204168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 204172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204180 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204183 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204187 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204200 */     // (fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSSm:{ *:[f32] } addr:{ *:[iPTR] }:$src1)
     /* 204200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSSm),
     /* 204203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204205 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204214 */     GIR_RootConstrainSelectedInstOperands,
     /* 204215 */     // GIR_Coverage, 2448,
     /* 204215 */     GIR_EraseRootFromParent_Done,
     /* 204216 */   // Label 4706: @204216
     /* 204216 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(204289), // Rule ID 18276 //
     /* 204221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 204224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 204228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204236 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204239 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204243 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204249 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204256 */     // (fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 204256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 204259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSm),
     /* 204273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 204278 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 204282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204287 */     GIR_RootConstrainSelectedInstOperands,
     /* 204288 */     // GIR_Coverage, 18276,
     /* 204288 */     GIR_EraseRootFromParent_Done,
     /* 204289 */   // Label 4707: @204289
     /* 204289 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(204362), // Rule ID 21424 //
     /* 204294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 204297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 204301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204309 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204312 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204316 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204322 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204329 */     // (fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSZm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 204329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 204332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZm),
     /* 204346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 204351 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 204355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204360 */     GIR_RootConstrainSelectedInstOperands,
     /* 204361 */     // GIR_Coverage, 21424,
     /* 204361 */     GIR_EraseRootFromParent_Done,
     /* 204362 */   // Label 4708: @204362
     /* 204362 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(204395), // Rule ID 1048 //
     /* 204367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 204370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 204374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 204378 */     // (fsqrt:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (SQRT_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 204378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp32),
     /* 204383 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 204389 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 204393 */     GIR_RootConstrainSelectedInstOperands,
     /* 204394 */     // GIR_Coverage, 1048,
     /* 204394 */     GIR_Done,
     /* 204395 */   // Label 4709: @204395
     /* 204395 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(204422), // Rule ID 2446 //
     /* 204400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 204403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 204407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 204411 */     // (fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src1)  =>  (SQRTSSr:{ *:[f32] } FR32:{ *:[f32] }:$src1)
     /* 204411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSSr),
     /* 204416 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 204420 */     GIR_RootConstrainSelectedInstOperands,
     /* 204421 */     // GIR_Coverage, 2446,
     /* 204421 */     GIR_Done,
     /* 204422 */   // Label 4710: @204422
     /* 204422 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(204464), // Rule ID 18274 //
     /* 204427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 204430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 204434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 204438 */     // (fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src)  =>  (VSQRTSSr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32:{ *:[f32] }:$src)
     /* 204438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 204441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSr),
     /* 204455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 204460 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 204462 */     GIR_RootConstrainSelectedInstOperands,
     /* 204463 */     // GIR_Coverage, 18274,
     /* 204463 */     GIR_EraseRootFromParent_Done,
     /* 204464 */   // Label 4711: @204464
     /* 204464 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(204506), // Rule ID 21422 //
     /* 204469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 204472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 204476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 204480 */     // (fsqrt:{ *:[f32] } FR32X:{ *:[f32] }:$src)  =>  (VSQRTSSZr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32X:{ *:[f32] }:$src)
     /* 204480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 204483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZr),
     /* 204497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 204502 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 204504 */     GIR_RootConstrainSelectedInstOperands,
     /* 204505 */     // GIR_Coverage, 21422,
     /* 204505 */     GIR_EraseRootFromParent_Done,
     /* 204506 */   // Label 4712: @204506
     /* 204506 */   GIM_Reject,
     /* 204507 */ // Label 4705: @204507
     /* 204507 */ GIM_Reject,
     /* 204508 */ // Label 4690: @204508
     /* 204508 */ GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(204863),
     /* 204513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 204516 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(204572), // Rule ID 2464 //
     /* 204521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 204524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 204528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204536 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204539 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204543 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204556 */     // (fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSDm:{ *:[f64] } addr:{ *:[iPTR] }:$src1)
     /* 204556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSDm),
     /* 204559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204561 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204570 */     GIR_RootConstrainSelectedInstOperands,
     /* 204571 */     // GIR_Coverage, 2464,
     /* 204571 */     GIR_EraseRootFromParent_Done,
     /* 204572 */   // Label 4714: @204572
     /* 204572 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(204645), // Rule ID 18280 //
     /* 204577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 204580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 204584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204592 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204599 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204612 */     // (fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 204612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 204615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDm),
     /* 204629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 204634 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 204638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204643 */     GIR_RootConstrainSelectedInstOperands,
     /* 204644 */     // GIR_Coverage, 18280,
     /* 204644 */     GIR_EraseRootFromParent_Done,
     /* 204645 */   // Label 4715: @204645
     /* 204645 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(204718), // Rule ID 21428 //
     /* 204650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 204653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 204657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204665 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204668 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204672 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204685 */     // (fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDZm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 204685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 204688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZm),
     /* 204702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 204707 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 204711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204716 */     GIR_RootConstrainSelectedInstOperands,
     /* 204717 */     // GIR_Coverage, 21428,
     /* 204717 */     GIR_EraseRootFromParent_Done,
     /* 204718 */   // Label 4716: @204718
     /* 204718 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(204751), // Rule ID 1050 //
     /* 204723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 204726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 204730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 204734 */     // (fsqrt:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (SQRT_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 204734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp64),
     /* 204739 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 204745 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 204749 */     GIR_RootConstrainSelectedInstOperands,
     /* 204750 */     // GIR_Coverage, 1050,
     /* 204750 */     GIR_Done,
     /* 204751 */   // Label 4717: @204751
     /* 204751 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(204778), // Rule ID 2462 //
     /* 204756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 204759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 204763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 204767 */     // (fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src1)  =>  (SQRTSDr:{ *:[f64] } FR64:{ *:[f64] }:$src1)
     /* 204767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSDr),
     /* 204772 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 204776 */     GIR_RootConstrainSelectedInstOperands,
     /* 204777 */     // GIR_Coverage, 2462,
     /* 204777 */     GIR_Done,
     /* 204778 */   // Label 4718: @204778
     /* 204778 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(204820), // Rule ID 18278 //
     /* 204783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 204786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 204790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 204794 */     // (fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src)  =>  (VSQRTSDr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64:{ *:[f64] }:$src)
     /* 204794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 204797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDr),
     /* 204811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 204816 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 204818 */     GIR_RootConstrainSelectedInstOperands,
     /* 204819 */     // GIR_Coverage, 18278,
     /* 204819 */     GIR_EraseRootFromParent_Done,
     /* 204820 */   // Label 4719: @204820
     /* 204820 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(204862), // Rule ID 21426 //
     /* 204825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 204828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 204832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 204836 */     // (fsqrt:{ *:[f64] } FR64X:{ *:[f64] }:$src)  =>  (VSQRTSDZr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64X:{ *:[f64] }:$src)
     /* 204836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 204839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZr),
     /* 204853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 204858 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 204860 */     GIR_RootConstrainSelectedInstOperands,
     /* 204861 */     // GIR_Coverage, 21426,
     /* 204861 */     GIR_EraseRootFromParent_Done,
     /* 204862 */   // Label 4720: @204862
     /* 204862 */   GIM_Reject,
     /* 204863 */ // Label 4713: @204863
     /* 204863 */ GIM_Reject,
     /* 204864 */ // Label 4691: @204864
     /* 204864 */ GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(204900), // Rule ID 1052 //
     /* 204869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 204872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 204875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 204879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 204883 */   // (fsqrt:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (SQRT_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 204883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp80),
     /* 204888 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 204894 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 204898 */   GIR_RootConstrainSelectedInstOperands,
     /* 204899 */   // GIR_Coverage, 1052,
     /* 204899 */   GIR_Done,
     /* 204900 */ // Label 4721: @204900
     /* 204900 */ GIM_Reject,
     /* 204901 */ // Label 4692: @204901
     /* 204901 */ GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(205103),
     /* 204906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 204909 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(204965), // Rule ID 2468 //
     /* 204914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 204917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 204921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204929 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204932 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204936 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204949 */     // (fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 204949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDm),
     /* 204952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204954 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 204958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204963 */     GIR_RootConstrainSelectedInstOperands,
     /* 204964 */     // GIR_Coverage, 2468,
     /* 204964 */     GIR_EraseRootFromParent_Done,
     /* 204965 */   // Label 4723: @204965
     /* 204965 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(205021), // Rule ID 12086 //
     /* 204970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 204973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204985 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204988 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204992 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205005 */     // (fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ128m:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 205005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128m),
     /* 205008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205010 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205019 */     GIR_RootConstrainSelectedInstOperands,
     /* 205020 */     // GIR_Coverage, 12086,
     /* 205020 */     GIR_EraseRootFromParent_Done,
     /* 205021 */   // Label 4724: @205021
     /* 205021 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(205048), // Rule ID 2466 //
     /* 205026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 205029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205037 */     // (fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (VSQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 205037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDr),
     /* 205042 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205046 */     GIR_RootConstrainSelectedInstOperands,
     /* 205047 */     // GIR_Coverage, 2466,
     /* 205047 */     GIR_Done,
     /* 205048 */   // Label 4725: @205048
     /* 205048 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(205075), // Rule ID 2474 //
     /* 205053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 205056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205064 */     // (fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (SQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 205064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPDr),
     /* 205069 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205073 */     GIR_RootConstrainSelectedInstOperands,
     /* 205074 */     // GIR_Coverage, 2474,
     /* 205074 */     GIR_Done,
     /* 205075 */   // Label 4726: @205075
     /* 205075 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(205102), // Rule ID 12082 //
     /* 205080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 205083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205091 */     // (fsqrt:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)  =>  (VSQRTPDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)
     /* 205091 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128r),
     /* 205096 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205100 */     GIR_RootConstrainSelectedInstOperands,
     /* 205101 */     // GIR_Coverage, 12082,
     /* 205101 */     GIR_Done,
     /* 205102 */   // Label 4727: @205102
     /* 205102 */   GIM_Reject,
     /* 205103 */ // Label 4722: @205103
     /* 205103 */ GIM_Reject,
     /* 205104 */ // Label 4693: @205104
     /* 205104 */ GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(205306),
     /* 205109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 205112 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(205168), // Rule ID 2452 //
     /* 205117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 205120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205132 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205135 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205139 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205152 */     // (fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 205152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSm),
     /* 205155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205157 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205166 */     GIR_RootConstrainSelectedInstOperands,
     /* 205167 */     // GIR_Coverage, 2452,
     /* 205167 */     GIR_EraseRootFromParent_Done,
     /* 205168 */   // Label 4729: @205168
     /* 205168 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(205224), // Rule ID 12062 //
     /* 205173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 205176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205188 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205191 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205195 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205208 */     // (fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ128m:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 205208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128m),
     /* 205211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205213 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205222 */     GIR_RootConstrainSelectedInstOperands,
     /* 205223 */     // GIR_Coverage, 12062,
     /* 205223 */     GIR_EraseRootFromParent_Done,
     /* 205224 */   // Label 4730: @205224
     /* 205224 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(205251), // Rule ID 2450 //
     /* 205229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 205232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205240 */     // (fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (VSQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 205240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSr),
     /* 205245 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205249 */     GIR_RootConstrainSelectedInstOperands,
     /* 205250 */     // GIR_Coverage, 2450,
     /* 205250 */     GIR_Done,
     /* 205251 */   // Label 4731: @205251
     /* 205251 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(205278), // Rule ID 2458 //
     /* 205256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 205259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 205267 */     // (fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (SQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 205267 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPSr),
     /* 205272 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205276 */     GIR_RootConstrainSelectedInstOperands,
     /* 205277 */     // GIR_Coverage, 2458,
     /* 205277 */     GIR_Done,
     /* 205278 */   // Label 4732: @205278
     /* 205278 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(205305), // Rule ID 12058 //
     /* 205283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 205286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205294 */     // (fsqrt:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)  =>  (VSQRTPSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)
     /* 205294 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128r),
     /* 205299 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205303 */     GIR_RootConstrainSelectedInstOperands,
     /* 205304 */     // GIR_Coverage, 12058,
     /* 205304 */     GIR_Done,
     /* 205305 */   // Label 4733: @205305
     /* 205305 */   GIM_Reject,
     /* 205306 */ // Label 4728: @205306
     /* 205306 */ GIM_Reject,
     /* 205307 */ // Label 4694: @205307
     /* 205307 */ GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(205482),
     /* 205312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 205315 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(205371), // Rule ID 2472 //
     /* 205320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 205323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 205327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205335 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205338 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205342 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205348 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205355 */     // (fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDYm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 205355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYm),
     /* 205358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205360 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205369 */     GIR_RootConstrainSelectedInstOperands,
     /* 205370 */     // GIR_Coverage, 2472,
     /* 205370 */     GIR_EraseRootFromParent_Done,
     /* 205371 */   // Label 4735: @205371
     /* 205371 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(205427), // Rule ID 12098 //
     /* 205376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 205379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 205383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205391 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205394 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205398 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205411 */     // (fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ256m:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 205411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256m),
     /* 205414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205416 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205425 */     GIR_RootConstrainSelectedInstOperands,
     /* 205426 */     // GIR_Coverage, 12098,
     /* 205426 */     GIR_EraseRootFromParent_Done,
     /* 205427 */   // Label 4736: @205427
     /* 205427 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(205454), // Rule ID 2470 //
     /* 205432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 205435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 205439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 205443 */     // (fsqrt:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)  =>  (VSQRTPDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /* 205443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYr),
     /* 205448 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205452 */     GIR_RootConstrainSelectedInstOperands,
     /* 205453 */     // GIR_Coverage, 2470,
     /* 205453 */     GIR_Done,
     /* 205454 */   // Label 4737: @205454
     /* 205454 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(205481), // Rule ID 12094 //
     /* 205459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 205462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 205466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 205470 */     // (fsqrt:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)  =>  (VSQRTPDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)
     /* 205470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256r),
     /* 205475 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205479 */     GIR_RootConstrainSelectedInstOperands,
     /* 205480 */     // GIR_Coverage, 12094,
     /* 205480 */     GIR_Done,
     /* 205481 */   // Label 4738: @205481
     /* 205481 */   GIM_Reject,
     /* 205482 */ // Label 4734: @205482
     /* 205482 */ GIM_Reject,
     /* 205483 */ // Label 4695: @205483
     /* 205483 */ GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(205571),
     /* 205488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 205491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205495 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(205547), // Rule ID 12014 //
     /* 205500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 205503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205511 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205514 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205518 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205531 */     // (fsqrt:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ128m:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 205531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128m),
     /* 205534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205536 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205545 */     GIR_RootConstrainSelectedInstOperands,
     /* 205546 */     // GIR_Coverage, 12014,
     /* 205546 */     GIR_EraseRootFromParent_Done,
     /* 205547 */   // Label 4740: @205547
     /* 205547 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(205570), // Rule ID 12010 //
     /* 205552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 205555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205559 */     // (fsqrt:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)  =>  (VSQRTPHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)
     /* 205559 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128r),
     /* 205564 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205568 */     GIR_RootConstrainSelectedInstOperands,
     /* 205569 */     // GIR_Coverage, 12010,
     /* 205569 */     GIR_Done,
     /* 205570 */   // Label 4741: @205570
     /* 205570 */   GIM_Reject,
     /* 205571 */ // Label 4739: @205571
     /* 205571 */ GIM_Reject,
     /* 205572 */ // Label 4696: @205572
     /* 205572 */ GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(205747),
     /* 205577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 205580 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(205636), // Rule ID 2456 //
     /* 205585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 205588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 205592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205600 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205603 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205607 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205620 */     // (fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSYm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 205620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYm),
     /* 205623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205634 */     GIR_RootConstrainSelectedInstOperands,
     /* 205635 */     // GIR_Coverage, 2456,
     /* 205635 */     GIR_EraseRootFromParent_Done,
     /* 205636 */   // Label 4743: @205636
     /* 205636 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(205692), // Rule ID 12074 //
     /* 205641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 205644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 205648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205656 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205659 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205663 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205676 */     // (fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ256m:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 205676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256m),
     /* 205679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205681 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205690 */     GIR_RootConstrainSelectedInstOperands,
     /* 205691 */     // GIR_Coverage, 12074,
     /* 205691 */     GIR_EraseRootFromParent_Done,
     /* 205692 */   // Label 4744: @205692
     /* 205692 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(205719), // Rule ID 2454 //
     /* 205697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 205700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 205704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 205708 */     // (fsqrt:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)  =>  (VSQRTPSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /* 205708 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYr),
     /* 205713 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205717 */     GIR_RootConstrainSelectedInstOperands,
     /* 205718 */     // GIR_Coverage, 2454,
     /* 205718 */     GIR_Done,
     /* 205719 */   // Label 4745: @205719
     /* 205719 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(205746), // Rule ID 12070 //
     /* 205724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 205727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 205731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 205735 */     // (fsqrt:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)  =>  (VSQRTPSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)
     /* 205735 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256r),
     /* 205740 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205744 */     GIR_RootConstrainSelectedInstOperands,
     /* 205745 */     // GIR_Coverage, 12070,
     /* 205745 */     GIR_Done,
     /* 205746 */   // Label 4746: @205746
     /* 205746 */   GIM_Reject,
     /* 205747 */ // Label 4742: @205747
     /* 205747 */ GIM_Reject,
     /* 205748 */ // Label 4697: @205748
     /* 205748 */ GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(205836),
     /* 205753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 205756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 205760 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(205812), // Rule ID 12050 //
     /* 205765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 205768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205776 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205779 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205783 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205789 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205796 */     // (fsqrt:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 205796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZm),
     /* 205799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205801 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205810 */     GIR_RootConstrainSelectedInstOperands,
     /* 205811 */     // GIR_Coverage, 12050,
     /* 205811 */     GIR_EraseRootFromParent_Done,
     /* 205812 */   // Label 4748: @205812
     /* 205812 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(205835), // Rule ID 12046 //
     /* 205817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 205820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 205824 */     // (fsqrt:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)  =>  (VSQRTPDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)
     /* 205824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZr),
     /* 205829 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205833 */     GIR_RootConstrainSelectedInstOperands,
     /* 205834 */     // GIR_Coverage, 12046,
     /* 205834 */     GIR_Done,
     /* 205835 */   // Label 4749: @205835
     /* 205835 */   GIM_Reject,
     /* 205836 */ // Label 4747: @205836
     /* 205836 */ GIM_Reject,
     /* 205837 */ // Label 4698: @205837
     /* 205837 */ GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(205925),
     /* 205842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 205845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 205849 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(205901), // Rule ID 12026 //
     /* 205854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 205857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205865 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205868 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205872 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205878 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205885 */     // (fsqrt:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ256m:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 205885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256m),
     /* 205888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205890 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205899 */     GIR_RootConstrainSelectedInstOperands,
     /* 205900 */     // GIR_Coverage, 12026,
     /* 205900 */     GIR_EraseRootFromParent_Done,
     /* 205901 */   // Label 4751: @205901
     /* 205901 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(205924), // Rule ID 12022 //
     /* 205906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 205909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 205913 */     // (fsqrt:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)  =>  (VSQRTPHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)
     /* 205913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256r),
     /* 205918 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 205922 */     GIR_RootConstrainSelectedInstOperands,
     /* 205923 */     // GIR_Coverage, 12022,
     /* 205923 */     GIR_Done,
     /* 205924 */   // Label 4752: @205924
     /* 205924 */   GIM_Reject,
     /* 205925 */ // Label 4750: @205925
     /* 205925 */ GIM_Reject,
     /* 205926 */ // Label 4699: @205926
     /* 205926 */ GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(206014),
     /* 205931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 205934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 205938 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(205990), // Rule ID 12038 //
     /* 205943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 205946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205954 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205957 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205961 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205974 */     // (fsqrt:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 205974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZm),
     /* 205977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205979 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 205983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205988 */     GIR_RootConstrainSelectedInstOperands,
     /* 205989 */     // GIR_Coverage, 12038,
     /* 205989 */     GIR_EraseRootFromParent_Done,
     /* 205990 */   // Label 4754: @205990
     /* 205990 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(206013), // Rule ID 12034 //
     /* 205995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 205998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206002 */     // (fsqrt:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)  =>  (VSQRTPSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)
     /* 206002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZr),
     /* 206007 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206011 */     GIR_RootConstrainSelectedInstOperands,
     /* 206012 */     // GIR_Coverage, 12034,
     /* 206012 */     GIR_Done,
     /* 206013 */   // Label 4755: @206013
     /* 206013 */   GIM_Reject,
     /* 206014 */ // Label 4753: @206014
     /* 206014 */ GIM_Reject,
     /* 206015 */ // Label 4700: @206015
     /* 206015 */ GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(206103),
     /* 206020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 206023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206027 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(206079), // Rule ID 12002 //
     /* 206032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 206035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206043 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206046 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206050 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206056 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206063 */     // (fsqrt:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 206063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZm),
     /* 206066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206068 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 206072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206077 */     GIR_RootConstrainSelectedInstOperands,
     /* 206078 */     // GIR_Coverage, 12002,
     /* 206078 */     GIR_EraseRootFromParent_Done,
     /* 206079 */   // Label 4757: @206079
     /* 206079 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(206102), // Rule ID 11998 //
     /* 206084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 206087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206091 */     // (fsqrt:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)  =>  (VSQRTPHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)
     /* 206091 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZr),
     /* 206096 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206100 */     GIR_RootConstrainSelectedInstOperands,
     /* 206101 */     // GIR_Coverage, 11998,
     /* 206101 */     GIR_Done,
     /* 206102 */   // Label 4758: @206102
     /* 206102 */   GIM_Reject,
     /* 206103 */ // Label 4756: @206103
     /* 206103 */ GIM_Reject,
     /* 206104 */ // Label 4701: @206104
     /* 206104 */ GIM_Reject,
     /* 206105 */ // Label 68: @206105
     /* 206105 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4772*/ GIMT_Encode4(210270),
     /* 206116 */ /*GILLT_s16*//*Label 4759*/ GIMT_Encode4(206200),
     /* 206120 */ /*GILLT_s32*//*Label 4760*/ GIMT_Encode4(206360),
     /* 206124 */ /*GILLT_s64*//*Label 4761*/ GIMT_Encode4(207005),
     /* 206128 */ /*GILLT_s80*//*Label 4762*/ GIMT_Encode4(207794), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 206140 */ /*GILLT_v2s64*//*Label 4763*/ GIMT_Encode4(208116), GIMT_Encode4(0),
     /* 206148 */ /*GILLT_v4s32*//*Label 4764*/ GIMT_Encode4(208470),
     /* 206152 */ /*GILLT_v4s64*//*Label 4765*/ GIMT_Encode4(208824), GIMT_Encode4(0),
     /* 206160 */ /*GILLT_v8s16*//*Label 4766*/ GIMT_Encode4(209147),
     /* 206164 */ /*GILLT_v8s32*//*Label 4767*/ GIMT_Encode4(209307),
     /* 206168 */ /*GILLT_v8s64*//*Label 4768*/ GIMT_Encode4(209630), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 206180 */ /*GILLT_v16s16*//*Label 4769*/ GIMT_Encode4(209790),
     /* 206184 */ /*GILLT_v16s32*//*Label 4770*/ GIMT_Encode4(209950), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 206196 */ /*GILLT_v32s16*//*Label 4771*/ GIMT_Encode4(210110),
     /* 206200 */ // Label 4759: @206200
     /* 206200 */ GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(206359),
     /* 206205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 206208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 206211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 206215 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(206273), // Rule ID 24246 //
     /* 206220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 206223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206231 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206234 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206238 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 206246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206255 */     // (strict_fadd:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 206255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 206258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206260 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 206262 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 206266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206271 */     GIR_RootConstrainSelectedInstOperands,
     /* 206272 */     // GIR_Coverage, 24246,
     /* 206272 */     GIR_EraseRootFromParent_Done,
     /* 206273 */   // Label 4774: @206273
     /* 206273 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(206331), // Rule ID 5953 //
     /* 206278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 206281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 206285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206293 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206296 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206300 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206313 */     // (strict_fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 206313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 206316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206318 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 206320 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 206324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206329 */     GIR_RootConstrainSelectedInstOperands,
     /* 206330 */     // GIR_Coverage, 5953,
     /* 206330 */     GIR_EraseRootFromParent_Done,
     /* 206331 */   // Label 4775: @206331
     /* 206331 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(206358), // Rule ID 5951 //
     /* 206336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 206339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 206343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 206347 */     // (strict_fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VADDSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 206347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSHZrr),
     /* 206352 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206356 */     GIR_RootConstrainSelectedInstOperands,
     /* 206357 */     // GIR_Coverage, 5951,
     /* 206357 */     GIR_Done,
     /* 206358 */   // Label 4776: @206358
     /* 206358 */   GIM_Reject,
     /* 206359 */ // Label 4773: @206359
     /* 206359 */ GIM_Reject,
     /* 206360 */ // Label 4760: @206360
     /* 206360 */ GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(207004),
     /* 206365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 206368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 206371 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(206436), // Rule ID 23233 //
     /* 206376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 206379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 206383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206391 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206394 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206398 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 206406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206415 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 206415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 206418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206420 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 206422 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 206426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 206429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206434 */     GIR_RootConstrainSelectedInstOperands,
     /* 206435 */     // GIR_Coverage, 23233,
     /* 206435 */     GIR_EraseRootFromParent_Done,
     /* 206436 */   // Label 4778: @206436
     /* 206436 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(206498), // Rule ID 23378 //
     /* 206441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 206444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 206448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206456 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206459 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206463 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 206471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206480 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 206480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 206483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206485 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 206487 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 206491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206496 */     GIR_RootConstrainSelectedInstOperands,
     /* 206497 */     // GIR_Coverage, 23378,
     /* 206497 */     GIR_EraseRootFromParent_Done,
     /* 206498 */   // Label 4779: @206498
     /* 206498 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(206560), // Rule ID 23382 //
     /* 206503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 206506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 206510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206518 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206521 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206525 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 206533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206542 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 206542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 206545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206547 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 206549 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 206553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206558 */     GIR_RootConstrainSelectedInstOperands,
     /* 206559 */     // GIR_Coverage, 23382,
     /* 206559 */     GIR_EraseRootFromParent_Done,
     /* 206560 */   // Label 4780: @206560
     /* 206560 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(206622), // Rule ID 24242 //
     /* 206565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 206568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 206572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206580 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206583 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206587 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 206595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206604 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 206604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 206607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206609 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 206611 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 206615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206620 */     GIR_RootConstrainSelectedInstOperands,
     /* 206621 */     // GIR_Coverage, 24242,
     /* 206621 */     GIR_EraseRootFromParent_Done,
     /* 206622 */   // Label 4781: @206622
     /* 206622 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(206687), // Rule ID 909 //
     /* 206627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 206630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 206634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 206638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206646 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206649 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206653 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206666 */     // (strict_fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 206666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 206669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206671 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 206673 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 206677 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 206680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206685 */     GIR_RootConstrainSelectedInstOperands,
     /* 206686 */     // GIR_Coverage, 909,
     /* 206686 */     GIR_EraseRootFromParent_Done,
     /* 206687 */   // Label 4782: @206687
     /* 206687 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(206749), // Rule ID 2159 //
     /* 206692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 206695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 206699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 206703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206711 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206714 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206718 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206731 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 206731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 206734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206736 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 206738 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 206742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206747 */     GIR_RootConstrainSelectedInstOperands,
     /* 206748 */     // GIR_Coverage, 2159,
     /* 206748 */     GIR_EraseRootFromParent_Done,
     /* 206749 */   // Label 4783: @206749
     /* 206749 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(206811), // Rule ID 2167 //
     /* 206754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 206757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 206761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 206765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206773 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206776 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206780 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206793 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 206793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 206796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206798 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 206800 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 206804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206809 */     GIR_RootConstrainSelectedInstOperands,
     /* 206810 */     // GIR_Coverage, 2167,
     /* 206810 */     GIR_EraseRootFromParent_Done,
     /* 206811 */   // Label 4784: @206811
     /* 206811 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(206873), // Rule ID 5915 //
     /* 206816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 206819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 206823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 206827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206835 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206838 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206842 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206855 */     // (strict_fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 206855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 206858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206860 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 206862 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 206866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206871 */     GIR_RootConstrainSelectedInstOperands,
     /* 206872 */     // GIR_Coverage, 5915,
     /* 206872 */     GIR_EraseRootFromParent_Done,
     /* 206873 */   // Label 4785: @206873
     /* 206873 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(206910), // Rule ID 885 //
     /* 206878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 206881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 206885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 206889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 206893 */     // (strict_fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (ADD_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 206893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32),
     /* 206898 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 206904 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 206908 */     GIR_RootConstrainSelectedInstOperands,
     /* 206909 */     // GIR_Coverage, 885,
     /* 206909 */     GIR_Done,
     /* 206910 */   // Label 4786: @206910
     /* 206910 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(206941), // Rule ID 2157 //
     /* 206915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 206918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 206922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 206926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 206930 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 206930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSrr),
     /* 206935 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206939 */     GIR_RootConstrainSelectedInstOperands,
     /* 206940 */     // GIR_Coverage, 2157,
     /* 206940 */     GIR_Done,
     /* 206941 */   // Label 4787: @206941
     /* 206941 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(206972), // Rule ID 2165 //
     /* 206946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 206949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 206953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 206957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 206961 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (ADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 206961 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSSrr),
     /* 206966 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 206970 */     GIR_RootConstrainSelectedInstOperands,
     /* 206971 */     // GIR_Coverage, 2165,
     /* 206971 */     GIR_Done,
     /* 206972 */   // Label 4788: @206972
     /* 206972 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(207003), // Rule ID 5913 //
     /* 206977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 206980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 206984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 206988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 206992 */     // (strict_fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VADDSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 206992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSZrr),
     /* 206997 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 207001 */     GIR_RootConstrainSelectedInstOperands,
     /* 207002 */     // GIR_Coverage, 5913,
     /* 207002 */     GIR_Done,
     /* 207003 */   // Label 4789: @207003
     /* 207003 */   GIM_Reject,
     /* 207004 */ // Label 4777: @207004
     /* 207004 */ GIM_Reject,
     /* 207005 */ // Label 4761: @207005
     /* 207005 */ GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(207793),
     /* 207010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 207013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207016 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(207081), // Rule ID 23235 //
     /* 207021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 207024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 207028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207036 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207039 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207043 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 207051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207053 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207060 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 207063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207065 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207067 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207071 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 207074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207079 */     GIR_RootConstrainSelectedInstOperands,
     /* 207080 */     // GIR_Coverage, 23235,
     /* 207080 */     GIR_EraseRootFromParent_Done,
     /* 207081 */   // Label 4791: @207081
     /* 207081 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(207153), // Rule ID 23237 //
     /* 207086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 207089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 207093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207101 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207104 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207108 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 207115 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 207123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207132 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 207135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207137 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207139 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207143 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 207146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207151 */     GIR_RootConstrainSelectedInstOperands,
     /* 207152 */     // GIR_Coverage, 23237,
     /* 207152 */     GIR_EraseRootFromParent_Done,
     /* 207153 */   // Label 4792: @207153
     /* 207153 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(207215), // Rule ID 23380 //
     /* 207158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 207161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207173 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207176 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207180 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207190 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207197 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 207200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207202 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207204 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207213 */     GIR_RootConstrainSelectedInstOperands,
     /* 207214 */     // GIR_Coverage, 23380,
     /* 207214 */     GIR_EraseRootFromParent_Done,
     /* 207215 */   // Label 4793: @207215
     /* 207215 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(207277), // Rule ID 23384 //
     /* 207220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 207223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207235 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207238 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207242 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207259 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 207262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207264 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207266 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207275 */     GIR_RootConstrainSelectedInstOperands,
     /* 207276 */     // GIR_Coverage, 23384,
     /* 207276 */     GIR_EraseRootFromParent_Done,
     /* 207277 */   // Label 4794: @207277
     /* 207277 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(207339), // Rule ID 24244 //
     /* 207282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 207285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 207289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207297 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207300 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207304 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 207312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207314 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207321 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 207324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207326 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207328 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207337 */     GIR_RootConstrainSelectedInstOperands,
     /* 207338 */     // GIR_Coverage, 24244,
     /* 207338 */     GIR_EraseRootFromParent_Done,
     /* 207339 */   // Label 4795: @207339
     /* 207339 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(207404), // Rule ID 911 //
     /* 207344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 207347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 207351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 207355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207363 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207366 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207370 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207376 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207383 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 207386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207388 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 207390 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207394 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 207397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207402 */     GIR_RootConstrainSelectedInstOperands,
     /* 207403 */     // GIR_Coverage, 911,
     /* 207403 */     GIR_EraseRootFromParent_Done,
     /* 207404 */   // Label 4796: @207404
     /* 207404 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(207476), // Rule ID 913 //
     /* 207409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 207412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 207416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 207420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207428 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207431 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207435 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 207442 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207448 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207455 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 207458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207460 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 207462 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 207469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207474 */     GIR_RootConstrainSelectedInstOperands,
     /* 207475 */     // GIR_Coverage, 913,
     /* 207475 */     GIR_EraseRootFromParent_Done,
     /* 207476 */   // Label 4797: @207476
     /* 207476 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(207538), // Rule ID 2163 //
     /* 207481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 207484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207500 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207503 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207507 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207513 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207520 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 207523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207525 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 207527 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207536 */     GIR_RootConstrainSelectedInstOperands,
     /* 207537 */     // GIR_Coverage, 2163,
     /* 207537 */     GIR_EraseRootFromParent_Done,
     /* 207538 */   // Label 4798: @207538
     /* 207538 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(207600), // Rule ID 2171 //
     /* 207543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 207546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207562 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207565 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207569 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207582 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 207585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207587 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 207589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207598 */     GIR_RootConstrainSelectedInstOperands,
     /* 207599 */     // GIR_Coverage, 2171,
     /* 207599 */     GIR_EraseRootFromParent_Done,
     /* 207600 */   // Label 4799: @207600
     /* 207600 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(207662), // Rule ID 5934 //
     /* 207605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 207608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 207612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 207616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207624 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207627 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207631 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207644 */     // (strict_fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 207647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207649 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 207651 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207660 */     GIR_RootConstrainSelectedInstOperands,
     /* 207661 */     // GIR_Coverage, 5934,
     /* 207661 */     GIR_EraseRootFromParent_Done,
     /* 207662 */   // Label 4800: @207662
     /* 207662 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(207699), // Rule ID 887 //
     /* 207667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 207670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 207674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 207678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 207682 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (ADD_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 207682 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64),
     /* 207687 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 207693 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 207697 */     GIR_RootConstrainSelectedInstOperands,
     /* 207698 */     // GIR_Coverage, 887,
     /* 207698 */     GIR_Done,
     /* 207699 */   // Label 4801: @207699
     /* 207699 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(207730), // Rule ID 2161 //
     /* 207704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 207707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207719 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 207719 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDrr),
     /* 207724 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 207728 */     GIR_RootConstrainSelectedInstOperands,
     /* 207729 */     // GIR_Coverage, 2161,
     /* 207729 */     GIR_Done,
     /* 207730 */   // Label 4802: @207730
     /* 207730 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(207761), // Rule ID 2169 //
     /* 207735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 207738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 207750 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (ADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 207750 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSDrr),
     /* 207755 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 207759 */     GIR_RootConstrainSelectedInstOperands,
     /* 207760 */     // GIR_Coverage, 2169,
     /* 207760 */     GIR_Done,
     /* 207761 */   // Label 4803: @207761
     /* 207761 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(207792), // Rule ID 5932 //
     /* 207766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 207769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 207773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 207777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 207781 */     // (strict_fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VADDSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 207781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDZrr),
     /* 207786 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 207790 */     GIR_RootConstrainSelectedInstOperands,
     /* 207791 */     // GIR_Coverage, 5932,
     /* 207791 */     GIR_Done,
     /* 207792 */   // Label 4804: @207792
     /* 207792 */   GIM_Reject,
     /* 207793 */ // Label 4790: @207793
     /* 207793 */ GIM_Reject,
     /* 207794 */ // Label 4762: @207794
     /* 207794 */ GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(208115),
     /* 207799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 207802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 207805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 207809 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(207877), // Rule ID 23239 //
     /* 207814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 207817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207825 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207828 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207832 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 207839 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 207847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207849 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207856 */     // (strict_fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 207859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207861 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207863 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207867 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 207870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207875 */     GIR_RootConstrainSelectedInstOperands,
     /* 207876 */     // GIR_Coverage, 23239,
     /* 207876 */     GIR_EraseRootFromParent_Done,
     /* 207877 */   // Label 4806: @207877
     /* 207877 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(207945), // Rule ID 23241 //
     /* 207882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 207885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207893 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207896 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207900 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 207907 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 207915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207924 */     // (strict_fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 207927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207929 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 207931 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 207935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 207938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207943 */     GIR_RootConstrainSelectedInstOperands,
     /* 207944 */     // GIR_Coverage, 23241,
     /* 207944 */     GIR_EraseRootFromParent_Done,
     /* 207945 */   // Label 4807: @207945
     /* 207945 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(208013), // Rule ID 915 //
     /* 207950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 207953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 207957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207965 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207968 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207972 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 207979 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207992 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 207992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 207995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207997 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 207999 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 208006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208011 */     GIR_RootConstrainSelectedInstOperands,
     /* 208012 */     // GIR_Coverage, 915,
     /* 208012 */     GIR_EraseRootFromParent_Done,
     /* 208013 */   // Label 4808: @208013
     /* 208013 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(208081), // Rule ID 917 //
     /* 208018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 208021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208033 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208036 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208040 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 208047 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208053 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208060 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 208063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208065 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208067 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208071 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 208074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208079 */     GIR_RootConstrainSelectedInstOperands,
     /* 208080 */     // GIR_Coverage, 917,
     /* 208080 */     GIR_EraseRootFromParent_Done,
     /* 208081 */   // Label 4809: @208081
     /* 208081 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(208114), // Rule ID 889 //
     /* 208086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 208089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208097 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (ADD_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 208097 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80),
     /* 208102 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 208108 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 208112 */     GIR_RootConstrainSelectedInstOperands,
     /* 208113 */     // GIR_Coverage, 889,
     /* 208113 */     GIR_Done,
     /* 208114 */   // Label 4810: @208114
     /* 208114 */   GIM_Reject,
     /* 208115 */ // Label 4805: @208115
     /* 208115 */ GIM_Reject,
     /* 208116 */ // Label 4763: @208116
     /* 208116 */ GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(208469),
     /* 208121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 208124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 208127 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(208189), // Rule ID 23368 //
     /* 208132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 208135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208147 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208150 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208154 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208171 */     // (strict_fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 208174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208176 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 208178 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208187 */     GIR_RootConstrainSelectedInstOperands,
     /* 208188 */     // GIR_Coverage, 23368,
     /* 208188 */     GIR_EraseRootFromParent_Done,
     /* 208189 */   // Label 4812: @208189
     /* 208189 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(208251), // Rule ID 24292 //
     /* 208194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 208197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208209 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208212 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208216 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208233 */     // (strict_fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 208236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208238 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 208240 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208249 */     GIR_RootConstrainSelectedInstOperands,
     /* 208250 */     // GIR_Coverage, 24292,
     /* 208250 */     GIR_EraseRootFromParent_Done,
     /* 208251 */   // Label 4813: @208251
     /* 208251 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(208313), // Rule ID 2139 //
     /* 208256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 208259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208275 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208278 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208282 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208288 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208295 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 208298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208300 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208302 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208311 */     GIR_RootConstrainSelectedInstOperands,
     /* 208312 */     // GIR_Coverage, 2139,
     /* 208312 */     GIR_EraseRootFromParent_Done,
     /* 208313 */   // Label 4814: @208313
     /* 208313 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(208375), // Rule ID 6307 //
     /* 208318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 208321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208337 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208340 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208344 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208350 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208357 */     // (strict_fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 208360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208362 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208364 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208373 */     GIR_RootConstrainSelectedInstOperands,
     /* 208374 */     // GIR_Coverage, 6307,
     /* 208374 */     GIR_EraseRootFromParent_Done,
     /* 208375 */   // Label 4815: @208375
     /* 208375 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(208406), // Rule ID 2137 //
     /* 208380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 208383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208395 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 208395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDrr),
     /* 208400 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208404 */     GIR_RootConstrainSelectedInstOperands,
     /* 208405 */     // GIR_Coverage, 2137,
     /* 208405 */     GIR_Done,
     /* 208406 */   // Label 4816: @208406
     /* 208406 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(208437), // Rule ID 2153 //
     /* 208411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 208414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208426 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (ADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 208426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPDrr),
     /* 208431 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208435 */     GIR_RootConstrainSelectedInstOperands,
     /* 208436 */     // GIR_Coverage, 2153,
     /* 208436 */     GIR_Done,
     /* 208437 */   // Label 4817: @208437
     /* 208437 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(208468), // Rule ID 6303 //
     /* 208442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 208445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208457 */     // (strict_fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VADDPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 208457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rr),
     /* 208462 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208466 */     GIR_RootConstrainSelectedInstOperands,
     /* 208467 */     // GIR_Coverage, 6303,
     /* 208467 */     GIR_Done,
     /* 208468 */   // Label 4818: @208468
     /* 208468 */   GIM_Reject,
     /* 208469 */ // Label 4811: @208469
     /* 208469 */ GIM_Reject,
     /* 208470 */ // Label 4764: @208470
     /* 208470 */ GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(208823),
     /* 208475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 208478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208481 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(208543), // Rule ID 23366 //
     /* 208486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 208489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208501 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208504 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208508 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208525 */     // (strict_fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 208528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208530 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 208532 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208541 */     GIR_RootConstrainSelectedInstOperands,
     /* 208542 */     // GIR_Coverage, 23366,
     /* 208542 */     GIR_EraseRootFromParent_Done,
     /* 208543 */   // Label 4820: @208543
     /* 208543 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(208605), // Rule ID 24276 //
     /* 208548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 208551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208563 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208566 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208570 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208580 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208587 */     // (strict_fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 208590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208592 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 208594 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208603 */     GIR_RootConstrainSelectedInstOperands,
     /* 208604 */     // GIR_Coverage, 24276,
     /* 208604 */     GIR_EraseRootFromParent_Done,
     /* 208605 */   // Label 4821: @208605
     /* 208605 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(208667), // Rule ID 2135 //
     /* 208610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 208613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208629 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208632 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208636 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208642 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208649 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 208652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208654 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208656 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208665 */     GIR_RootConstrainSelectedInstOperands,
     /* 208666 */     // GIR_Coverage, 2135,
     /* 208666 */     GIR_EraseRootFromParent_Done,
     /* 208667 */   // Label 4822: @208667
     /* 208667 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(208729), // Rule ID 6283 //
     /* 208672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 208675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208691 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208694 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208698 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208704 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208711 */     // (strict_fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 208714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208716 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 208718 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208727 */     GIR_RootConstrainSelectedInstOperands,
     /* 208728 */     // GIR_Coverage, 6283,
     /* 208728 */     GIR_EraseRootFromParent_Done,
     /* 208729 */   // Label 4823: @208729
     /* 208729 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(208760), // Rule ID 2133 //
     /* 208734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 208737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208749 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 208749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSrr),
     /* 208754 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208758 */     GIR_RootConstrainSelectedInstOperands,
     /* 208759 */     // GIR_Coverage, 2133,
     /* 208759 */     GIR_Done,
     /* 208760 */   // Label 4824: @208760
     /* 208760 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(208791), // Rule ID 2149 //
     /* 208765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 208768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208780 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (ADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 208780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPSrr),
     /* 208785 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208789 */     GIR_RootConstrainSelectedInstOperands,
     /* 208790 */     // GIR_Coverage, 2149,
     /* 208790 */     GIR_Done,
     /* 208791 */   // Label 4825: @208791
     /* 208791 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(208822), // Rule ID 6279 //
     /* 208796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 208799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208811 */     // (strict_fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VADDPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 208811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rr),
     /* 208816 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208820 */     GIR_RootConstrainSelectedInstOperands,
     /* 208821 */     // GIR_Coverage, 6279,
     /* 208821 */     GIR_Done,
     /* 208822 */   // Label 4826: @208822
     /* 208822 */   GIM_Reject,
     /* 208823 */ // Label 4819: @208823
     /* 208823 */ GIM_Reject,
     /* 208824 */ // Label 4765: @208824
     /* 208824 */ GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(209146),
     /* 208829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 208832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 208835 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(208897), // Rule ID 23372 //
     /* 208840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 208843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 208847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208855 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208858 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208862 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 208870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208879 */     // (strict_fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 208882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208884 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 208886 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208895 */     GIR_RootConstrainSelectedInstOperands,
     /* 208896 */     // GIR_Coverage, 23372,
     /* 208896 */     GIR_EraseRootFromParent_Done,
     /* 208897 */   // Label 4828: @208897
     /* 208897 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(208959), // Rule ID 24300 //
     /* 208902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 208905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 208909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208917 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208920 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208924 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 208932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208941 */     // (strict_fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 208941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 208944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208946 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 208948 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 208952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208957 */     GIR_RootConstrainSelectedInstOperands,
     /* 208958 */     // GIR_Coverage, 24300,
     /* 208958 */     GIR_EraseRootFromParent_Done,
     /* 208959 */   // Label 4829: @208959
     /* 208959 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(209021), // Rule ID 2147 //
     /* 208964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 208967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 208971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 208975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 208979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208983 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208986 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208990 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208996 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209003 */     // (strict_fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 209006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209008 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 209010 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209019 */     GIR_RootConstrainSelectedInstOperands,
     /* 209020 */     // GIR_Coverage, 2147,
     /* 209020 */     GIR_EraseRootFromParent_Done,
     /* 209021 */   // Label 4830: @209021
     /* 209021 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(209083), // Rule ID 6319 //
     /* 209026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 209029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209045 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209048 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209052 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209065 */     // (strict_fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 209068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209070 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 209072 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209081 */     GIR_RootConstrainSelectedInstOperands,
     /* 209082 */     // GIR_Coverage, 6319,
     /* 209082 */     GIR_EraseRootFromParent_Done,
     /* 209083 */   // Label 4831: @209083
     /* 209083 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(209114), // Rule ID 2145 //
     /* 209088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209103 */     // (strict_fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VADDPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 209103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDYrr),
     /* 209108 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209112 */     GIR_RootConstrainSelectedInstOperands,
     /* 209113 */     // GIR_Coverage, 2145,
     /* 209113 */     GIR_Done,
     /* 209114 */   // Label 4832: @209114
     /* 209114 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(209145), // Rule ID 6315 //
     /* 209119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 209122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209134 */     // (strict_fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VADDPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 209134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rr),
     /* 209139 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209143 */     GIR_RootConstrainSelectedInstOperands,
     /* 209144 */     // GIR_Coverage, 6315,
     /* 209144 */     GIR_Done,
     /* 209145 */   // Label 4833: @209145
     /* 209145 */   GIM_Reject,
     /* 209146 */ // Label 4827: @209146
     /* 209146 */ GIM_Reject,
     /* 209147 */ // Label 4766: @209147
     /* 209147 */ GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(209306),
     /* 209152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 209155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 209158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209162 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(209220), // Rule ID 24316 //
     /* 209167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209178 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209181 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209185 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209202 */     // (strict_fadd:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 209205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209207 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 209209 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209218 */     GIR_RootConstrainSelectedInstOperands,
     /* 209219 */     // GIR_Coverage, 24316,
     /* 209219 */     GIR_EraseRootFromParent_Done,
     /* 209220 */   // Label 4835: @209220
     /* 209220 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(209278), // Rule ID 6343 //
     /* 209225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209240 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209243 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209247 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209253 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209260 */     // (strict_fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 209263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209265 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 209267 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209276 */     GIR_RootConstrainSelectedInstOperands,
     /* 209277 */     // GIR_Coverage, 6343,
     /* 209277 */     GIR_EraseRootFromParent_Done,
     /* 209278 */   // Label 4836: @209278
     /* 209278 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(209305), // Rule ID 6339 //
     /* 209283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209294 */     // (strict_fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VADDPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 209294 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rr),
     /* 209299 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209303 */     GIR_RootConstrainSelectedInstOperands,
     /* 209304 */     // GIR_Coverage, 6339,
     /* 209304 */     GIR_Done,
     /* 209305 */   // Label 4837: @209305
     /* 209305 */   GIM_Reject,
     /* 209306 */ // Label 4834: @209306
     /* 209306 */ GIM_Reject,
     /* 209307 */ // Label 4767: @209307
     /* 209307 */ GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(209629),
     /* 209312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 209315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 209318 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(209380), // Rule ID 23370 //
     /* 209323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209338 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209341 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209345 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209362 */     // (strict_fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 209365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209367 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 209369 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209378 */     GIR_RootConstrainSelectedInstOperands,
     /* 209379 */     // GIR_Coverage, 23370,
     /* 209379 */     GIR_EraseRootFromParent_Done,
     /* 209380 */   // Label 4839: @209380
     /* 209380 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(209442), // Rule ID 24284 //
     /* 209385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 209388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209400 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209403 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209407 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209424 */     // (strict_fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 209427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209429 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 209431 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209440 */     GIR_RootConstrainSelectedInstOperands,
     /* 209441 */     // GIR_Coverage, 24284,
     /* 209441 */     GIR_EraseRootFromParent_Done,
     /* 209442 */   // Label 4840: @209442
     /* 209442 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(209504), // Rule ID 2143 //
     /* 209447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209466 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209469 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209473 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209486 */     // (strict_fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 209489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209491 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 209493 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209502 */     GIR_RootConstrainSelectedInstOperands,
     /* 209503 */     // GIR_Coverage, 2143,
     /* 209503 */     GIR_EraseRootFromParent_Done,
     /* 209504 */   // Label 4841: @209504
     /* 209504 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(209566), // Rule ID 6295 //
     /* 209509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 209512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209528 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209531 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209535 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209548 */     // (strict_fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 209551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209553 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 209555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209564 */     GIR_RootConstrainSelectedInstOperands,
     /* 209565 */     // GIR_Coverage, 6295,
     /* 209565 */     GIR_EraseRootFromParent_Done,
     /* 209566 */   // Label 4842: @209566
     /* 209566 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(209597), // Rule ID 2141 //
     /* 209571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209586 */     // (strict_fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VADDPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 209586 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSYrr),
     /* 209591 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209595 */     GIR_RootConstrainSelectedInstOperands,
     /* 209596 */     // GIR_Coverage, 2141,
     /* 209596 */     GIR_Done,
     /* 209597 */   // Label 4843: @209597
     /* 209597 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(209628), // Rule ID 6291 //
     /* 209602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 209605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209617 */     // (strict_fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VADDPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 209617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rr),
     /* 209622 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209626 */     GIR_RootConstrainSelectedInstOperands,
     /* 209627 */     // GIR_Coverage, 6291,
     /* 209627 */     GIR_Done,
     /* 209628 */   // Label 4844: @209628
     /* 209628 */   GIM_Reject,
     /* 209629 */ // Label 4838: @209629
     /* 209629 */ GIM_Reject,
     /* 209630 */ // Label 4768: @209630
     /* 209630 */ GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(209789),
     /* 209635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 209638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 209641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209645 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(209703), // Rule ID 24268 //
     /* 209650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 209653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209661 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209664 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209668 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209685 */     // (strict_fadd:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 209688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209690 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 209692 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209701 */     GIR_RootConstrainSelectedInstOperands,
     /* 209702 */     // GIR_Coverage, 24268,
     /* 209702 */     GIR_EraseRootFromParent_Done,
     /* 209703 */   // Label 4846: @209703
     /* 209703 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(209761), // Rule ID 6271 //
     /* 209708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 209711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209723 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209726 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209730 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209736 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209743 */     // (strict_fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 209746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209748 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 209750 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209759 */     GIR_RootConstrainSelectedInstOperands,
     /* 209760 */     // GIR_Coverage, 6271,
     /* 209760 */     GIR_EraseRootFromParent_Done,
     /* 209761 */   // Label 4847: @209761
     /* 209761 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(209788), // Rule ID 6267 //
     /* 209766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 209769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209777 */     // (strict_fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VADDPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 209777 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZrr),
     /* 209782 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209786 */     GIR_RootConstrainSelectedInstOperands,
     /* 209787 */     // GIR_Coverage, 6267,
     /* 209787 */     GIR_Done,
     /* 209788 */   // Label 4848: @209788
     /* 209788 */   GIM_Reject,
     /* 209789 */ // Label 4845: @209789
     /* 209789 */ GIM_Reject,
     /* 209790 */ // Label 4769: @209790
     /* 209790 */ GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(209949),
     /* 209795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 209798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 209801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209805 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(209863), // Rule ID 24324 //
     /* 209810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209821 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209824 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209828 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209838 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209845 */     // (strict_fadd:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 209848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209850 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 209852 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209861 */     GIR_RootConstrainSelectedInstOperands,
     /* 209862 */     // GIR_Coverage, 24324,
     /* 209862 */     GIR_EraseRootFromParent_Done,
     /* 209863 */   // Label 4850: @209863
     /* 209863 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(209921), // Rule ID 6355 //
     /* 209868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 209879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209883 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209886 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209890 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209903 */     // (strict_fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 209903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 209906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209908 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 209910 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 209914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209919 */     GIR_RootConstrainSelectedInstOperands,
     /* 209920 */     // GIR_Coverage, 6355,
     /* 209920 */     GIR_EraseRootFromParent_Done,
     /* 209921 */   // Label 4851: @209921
     /* 209921 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(209948), // Rule ID 6351 //
     /* 209926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209937 */     // (strict_fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VADDPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 209937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rr),
     /* 209942 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209946 */     GIR_RootConstrainSelectedInstOperands,
     /* 209947 */     // GIR_Coverage, 6351,
     /* 209947 */     GIR_Done,
     /* 209948 */   // Label 4852: @209948
     /* 209948 */   GIM_Reject,
     /* 209949 */ // Label 4849: @209949
     /* 209949 */ GIM_Reject,
     /* 209950 */ // Label 4770: @209950
     /* 209950 */ GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(210109),
     /* 209955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 209958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 209961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209965 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(210023), // Rule ID 24260 //
     /* 209970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 209973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209981 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209984 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209988 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210005 */     // (strict_fadd:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 210008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210010 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210012 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210021 */     GIR_RootConstrainSelectedInstOperands,
     /* 210022 */     // GIR_Coverage, 24260,
     /* 210022 */     GIR_EraseRootFromParent_Done,
     /* 210023 */   // Label 4854: @210023
     /* 210023 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(210081), // Rule ID 6259 //
     /* 210028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 210031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210043 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210046 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210050 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210056 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210063 */     // (strict_fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 210066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210068 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210070 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210079 */     GIR_RootConstrainSelectedInstOperands,
     /* 210080 */     // GIR_Coverage, 6259,
     /* 210080 */     GIR_EraseRootFromParent_Done,
     /* 210081 */   // Label 4855: @210081
     /* 210081 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(210108), // Rule ID 6255 //
     /* 210086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 210089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210097 */     // (strict_fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VADDPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 210097 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZrr),
     /* 210102 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210106 */     GIR_RootConstrainSelectedInstOperands,
     /* 210107 */     // GIR_Coverage, 6255,
     /* 210107 */     GIR_Done,
     /* 210108 */   // Label 4856: @210108
     /* 210108 */   GIM_Reject,
     /* 210109 */ // Label 4853: @210109
     /* 210109 */ GIM_Reject,
     /* 210110 */ // Label 4771: @210110
     /* 210110 */ GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(210269),
     /* 210115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 210118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 210121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210125 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(210183), // Rule ID 24308 //
     /* 210130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210141 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210144 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210148 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210158 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210165 */     // (strict_fadd:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 210168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210170 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210172 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210181 */     GIR_RootConstrainSelectedInstOperands,
     /* 210182 */     // GIR_Coverage, 24308,
     /* 210182 */     GIR_EraseRootFromParent_Done,
     /* 210183 */   // Label 4858: @210183
     /* 210183 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(210241), // Rule ID 6331 //
     /* 210188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210203 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210206 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210210 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210223 */     // (strict_fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 210226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210228 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210230 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210239 */     GIR_RootConstrainSelectedInstOperands,
     /* 210240 */     // GIR_Coverage, 6331,
     /* 210240 */     GIR_EraseRootFromParent_Done,
     /* 210241 */   // Label 4859: @210241
     /* 210241 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(210268), // Rule ID 6327 //
     /* 210246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210257 */     // (strict_fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VADDPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 210257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZrr),
     /* 210262 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210266 */     GIR_RootConstrainSelectedInstOperands,
     /* 210267 */     // GIR_Coverage, 6327,
     /* 210267 */     GIR_Done,
     /* 210268 */   // Label 4860: @210268
     /* 210268 */   GIM_Reject,
     /* 210269 */ // Label 4857: @210269
     /* 210269 */ GIM_Reject,
     /* 210270 */ // Label 4772: @210270
     /* 210270 */ GIM_Reject,
     /* 210271 */ // Label 69: @210271
     /* 210271 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4874*/ GIMT_Encode4(213196),
     /* 210282 */ /*GILLT_s16*//*Label 4861*/ GIMT_Encode4(210366),
     /* 210286 */ /*GILLT_s32*//*Label 4862*/ GIMT_Encode4(210464),
     /* 210290 */ /*GILLT_s64*//*Label 4863*/ GIMT_Encode4(210923),
     /* 210294 */ /*GILLT_s80*//*Label 4864*/ GIMT_Encode4(211526), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 210306 */ /*GILLT_v2s64*//*Label 4865*/ GIMT_Encode4(211848), GIMT_Encode4(0),
     /* 210314 */ /*GILLT_v4s32*//*Label 4866*/ GIMT_Encode4(212078),
     /* 210318 */ /*GILLT_v4s64*//*Label 4867*/ GIMT_Encode4(212308), GIMT_Encode4(0),
     /* 210326 */ /*GILLT_v8s16*//*Label 4868*/ GIMT_Encode4(212507),
     /* 210330 */ /*GILLT_v8s32*//*Label 4869*/ GIMT_Encode4(212605),
     /* 210334 */ /*GILLT_v8s64*//*Label 4870*/ GIMT_Encode4(212804), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 210346 */ /*GILLT_v16s16*//*Label 4871*/ GIMT_Encode4(212902),
     /* 210350 */ /*GILLT_v16s32*//*Label 4872*/ GIMT_Encode4(213000), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 210362 */ /*GILLT_v32s16*//*Label 4873*/ GIMT_Encode4(213098),
     /* 210366 */ // Label 4861: @210366
     /* 210366 */ GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(210463),
     /* 210371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 210374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 210377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 210381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 210385 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(210439), // Rule ID 6067 //
     /* 210390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210401 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210404 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210408 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210414 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210421 */     // (strict_fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrm),
     /* 210424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210426 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210428 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210437 */     GIR_RootConstrainSelectedInstOperands,
     /* 210438 */     // GIR_Coverage, 6067,
     /* 210438 */     GIR_EraseRootFromParent_Done,
     /* 210439 */   // Label 4876: @210439
     /* 210439 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(210462), // Rule ID 6065 //
     /* 210444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 210451 */     // (strict_fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VSUBSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 210451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrr),
     /* 210456 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210460 */     GIR_RootConstrainSelectedInstOperands,
     /* 210461 */     // GIR_Coverage, 6065,
     /* 210461 */     GIR_Done,
     /* 210462 */   // Label 4877: @210462
     /* 210462 */   GIM_Reject,
     /* 210463 */ // Label 4875: @210463
     /* 210463 */ GIM_Reject,
     /* 210464 */ // Label 4862: @210464
     /* 210464 */ GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(210922),
     /* 210469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 210472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210475 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(210540), // Rule ID 953 //
     /* 210480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210495 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210498 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210502 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210519 */     // (strict_fsub:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp32m),
     /* 210522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210524 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210526 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210538 */     GIR_RootConstrainSelectedInstOperands,
     /* 210539 */     // GIR_Coverage, 953,
     /* 210539 */     GIR_EraseRootFromParent_Done,
     /* 210540 */   // Label 4879: @210540
     /* 210540 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(210605), // Rule ID 931 //
     /* 210545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210564 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210567 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210571 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210584 */     // (strict_fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32m),
     /* 210587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210589 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210591 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210603 */     GIR_RootConstrainSelectedInstOperands,
     /* 210604 */     // GIR_Coverage, 931,
     /* 210604 */     GIR_EraseRootFromParent_Done,
     /* 210605 */   // Label 4880: @210605
     /* 210605 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(210667), // Rule ID 2239 //
     /* 210610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 210613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210629 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210632 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210636 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210642 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210649 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSrm),
     /* 210652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210654 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210656 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210665 */     GIR_RootConstrainSelectedInstOperands,
     /* 210666 */     // GIR_Coverage, 2239,
     /* 210666 */     GIR_EraseRootFromParent_Done,
     /* 210667 */   // Label 4881: @210667
     /* 210667 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(210729), // Rule ID 2247 //
     /* 210672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 210675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210691 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210694 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210698 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210704 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210711 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSSrm),
     /* 210714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210716 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210718 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210727 */     GIR_RootConstrainSelectedInstOperands,
     /* 210728 */     // GIR_Coverage, 2247,
     /* 210728 */     GIR_EraseRootFromParent_Done,
     /* 210729 */   // Label 4882: @210729
     /* 210729 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(210791), // Rule ID 6029 //
     /* 210734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 210737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 210741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 210745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210753 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210756 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210760 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210766 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210773 */     // (strict_fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrm),
     /* 210776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210778 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210780 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210789 */     GIR_RootConstrainSelectedInstOperands,
     /* 210790 */     // GIR_Coverage, 6029,
     /* 210790 */     GIR_EraseRootFromParent_Done,
     /* 210791 */   // Label 4883: @210791
     /* 210791 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(210828), // Rule ID 891 //
     /* 210796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210811 */     // (strict_fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (SUB_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 210811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32),
     /* 210816 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 210822 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 210826 */     GIR_RootConstrainSelectedInstOperands,
     /* 210827 */     // GIR_Coverage, 891,
     /* 210827 */     GIR_Done,
     /* 210828 */   // Label 4884: @210828
     /* 210828 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(210859), // Rule ID 2237 //
     /* 210833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 210836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210848 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VSUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 210848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSrr),
     /* 210853 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210857 */     GIR_RootConstrainSelectedInstOperands,
     /* 210858 */     // GIR_Coverage, 2237,
     /* 210858 */     GIR_Done,
     /* 210859 */   // Label 4885: @210859
     /* 210859 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(210890), // Rule ID 2245 //
     /* 210864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 210867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210879 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (SUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 210879 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSSrr),
     /* 210884 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210888 */     GIR_RootConstrainSelectedInstOperands,
     /* 210889 */     // GIR_Coverage, 2245,
     /* 210889 */     GIR_Done,
     /* 210890 */   // Label 4886: @210890
     /* 210890 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(210921), // Rule ID 6027 //
     /* 210895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 210898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 210902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 210906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 210910 */     // (strict_fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VSUBSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 210910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrr),
     /* 210915 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210919 */     GIR_RootConstrainSelectedInstOperands,
     /* 210920 */     // GIR_Coverage, 6027,
     /* 210920 */     GIR_Done,
     /* 210921 */   // Label 4887: @210921
     /* 210921 */   GIM_Reject,
     /* 210922 */ // Label 4878: @210922
     /* 210922 */ GIM_Reject,
     /* 210923 */ // Label 4863: @210923
     /* 210923 */ GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(211525),
     /* 210928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 210931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210934 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(210999), // Rule ID 955 //
     /* 210939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 210942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 210946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210954 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210957 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210961 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 210969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210978 */     // (strict_fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m),
     /* 210981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210983 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210985 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210989 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210997 */     GIR_RootConstrainSelectedInstOperands,
     /* 210998 */     // GIR_Coverage, 955,
     /* 210998 */     GIR_EraseRootFromParent_Done,
     /* 210999 */   // Label 4889: @210999
     /* 210999 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(211071), // Rule ID 957 //
     /* 211004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211019 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211022 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211026 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 211033 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211050 */     // (strict_fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m32),
     /* 211053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211055 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211057 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211069 */     GIR_RootConstrainSelectedInstOperands,
     /* 211070 */     // GIR_Coverage, 957,
     /* 211070 */     GIR_EraseRootFromParent_Done,
     /* 211071 */   // Label 4890: @211071
     /* 211071 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(211136), // Rule ID 933 //
     /* 211076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211095 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211098 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211102 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211115 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m),
     /* 211118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211120 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211122 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211126 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211134 */     GIR_RootConstrainSelectedInstOperands,
     /* 211135 */     // GIR_Coverage, 933,
     /* 211135 */     GIR_EraseRootFromParent_Done,
     /* 211136 */   // Label 4891: @211136
     /* 211136 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(211208), // Rule ID 935 //
     /* 211141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211160 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211163 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211167 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 211174 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211180 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211187 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m32),
     /* 211190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211192 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211194 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211206 */     GIR_RootConstrainSelectedInstOperands,
     /* 211207 */     // GIR_Coverage, 935,
     /* 211207 */     GIR_EraseRootFromParent_Done,
     /* 211208 */   // Label 4892: @211208
     /* 211208 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(211270), // Rule ID 2243 //
     /* 211213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 211216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211232 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211235 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211239 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211252 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDrm),
     /* 211255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211257 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211259 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211268 */     GIR_RootConstrainSelectedInstOperands,
     /* 211269 */     // GIR_Coverage, 2243,
     /* 211269 */     GIR_EraseRootFromParent_Done,
     /* 211270 */   // Label 4893: @211270
     /* 211270 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(211332), // Rule ID 2251 //
     /* 211275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 211278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211294 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211297 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211301 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211314 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSDrm),
     /* 211317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211319 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211321 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211330 */     GIR_RootConstrainSelectedInstOperands,
     /* 211331 */     // GIR_Coverage, 2251,
     /* 211331 */     GIR_EraseRootFromParent_Done,
     /* 211332 */   // Label 4894: @211332
     /* 211332 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(211394), // Rule ID 6048 //
     /* 211337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 211340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 211344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 211348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211356 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211359 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211363 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211376 */     // (strict_fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrm),
     /* 211379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211381 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211383 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211392 */     GIR_RootConstrainSelectedInstOperands,
     /* 211393 */     // GIR_Coverage, 6048,
     /* 211393 */     GIR_EraseRootFromParent_Done,
     /* 211394 */   // Label 4895: @211394
     /* 211394 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(211431), // Rule ID 893 //
     /* 211399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211414 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (SUB_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 211414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64),
     /* 211419 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 211425 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 211429 */     GIR_RootConstrainSelectedInstOperands,
     /* 211430 */     // GIR_Coverage, 893,
     /* 211430 */     GIR_Done,
     /* 211431 */   // Label 4896: @211431
     /* 211431 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(211462), // Rule ID 2241 //
     /* 211436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 211439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211451 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VSUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 211451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDrr),
     /* 211456 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 211460 */     GIR_RootConstrainSelectedInstOperands,
     /* 211461 */     // GIR_Coverage, 2241,
     /* 211461 */     GIR_Done,
     /* 211462 */   // Label 4897: @211462
     /* 211462 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(211493), // Rule ID 2249 //
     /* 211467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 211470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211482 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (SUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 211482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSDrr),
     /* 211487 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 211491 */     GIR_RootConstrainSelectedInstOperands,
     /* 211492 */     // GIR_Coverage, 2249,
     /* 211492 */     GIR_Done,
     /* 211493 */   // Label 4898: @211493
     /* 211493 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(211524), // Rule ID 6046 //
     /* 211498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 211501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 211505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 211509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 211513 */     // (strict_fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VSUBSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 211513 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrr),
     /* 211518 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 211522 */     GIR_RootConstrainSelectedInstOperands,
     /* 211523 */     // GIR_Coverage, 6046,
     /* 211523 */     GIR_Done,
     /* 211524 */   // Label 4899: @211524
     /* 211524 */   GIM_Reject,
     /* 211525 */ // Label 4888: @211525
     /* 211525 */ GIM_Reject,
     /* 211526 */ // Label 4864: @211526
     /* 211526 */ GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(211847),
     /* 211531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 211534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 211537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 211541 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(211609), // Rule ID 959 //
     /* 211546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 211549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211557 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211560 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211564 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 211571 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 211579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211588 */     // (strict_fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m32),
     /* 211591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211593 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211595 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211599 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211607 */     GIR_RootConstrainSelectedInstOperands,
     /* 211608 */     // GIR_Coverage, 959,
     /* 211608 */     GIR_EraseRootFromParent_Done,
     /* 211609 */   // Label 4901: @211609
     /* 211609 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(211677), // Rule ID 961 //
     /* 211614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 211617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211625 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211628 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211632 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 211639 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 211647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211656 */     // (strict_fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m64),
     /* 211659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211661 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211667 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211675 */     GIR_RootConstrainSelectedInstOperands,
     /* 211676 */     // GIR_Coverage, 961,
     /* 211676 */     GIR_EraseRootFromParent_Done,
     /* 211677 */   // Label 4902: @211677
     /* 211677 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(211745), // Rule ID 937 //
     /* 211682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 211685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 211689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211697 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211700 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211704 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 211711 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211724 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m32),
     /* 211727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211729 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211731 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211743 */     GIR_RootConstrainSelectedInstOperands,
     /* 211744 */     // GIR_Coverage, 937,
     /* 211744 */     GIR_EraseRootFromParent_Done,
     /* 211745 */   // Label 4903: @211745
     /* 211745 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(211813), // Rule ID 939 //
     /* 211750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 211753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 211757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211765 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211768 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211772 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 211779 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211792 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (SUB_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m64),
     /* 211795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211797 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211799 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211811 */     GIR_RootConstrainSelectedInstOperands,
     /* 211812 */     // GIR_Coverage, 939,
     /* 211812 */     GIR_EraseRootFromParent_Done,
     /* 211813 */   // Label 4904: @211813
     /* 211813 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(211846), // Rule ID 895 //
     /* 211818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 211821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 211825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 211829 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (SUB_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 211829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80),
     /* 211834 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 211840 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 211844 */     GIR_RootConstrainSelectedInstOperands,
     /* 211845 */     // GIR_Coverage, 895,
     /* 211845 */     GIR_Done,
     /* 211846 */   // Label 4905: @211846
     /* 211846 */   GIM_Reject,
     /* 211847 */ // Label 4900: @211847
     /* 211847 */ GIM_Reject,
     /* 211848 */ // Label 4865: @211848
     /* 211848 */ GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(212077),
     /* 211853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 211856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 211859 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(211921), // Rule ID 2219 //
     /* 211864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 211867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 211871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 211875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211883 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211886 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211890 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211903 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDrm),
     /* 211906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211908 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211910 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211919 */     GIR_RootConstrainSelectedInstOperands,
     /* 211920 */     // GIR_Coverage, 2219,
     /* 211920 */     GIR_EraseRootFromParent_Done,
     /* 211921 */   // Label 4907: @211921
     /* 211921 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(211983), // Rule ID 6541 //
     /* 211926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 211929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 211933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 211937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211945 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211948 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211952 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211958 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211965 */     // (strict_fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rm),
     /* 211968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211970 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211972 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211981 */     GIR_RootConstrainSelectedInstOperands,
     /* 211982 */     // GIR_Coverage, 6541,
     /* 211982 */     GIR_EraseRootFromParent_Done,
     /* 211983 */   // Label 4908: @211983
     /* 211983 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(212014), // Rule ID 2217 //
     /* 211988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 211991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 211995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 211999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212003 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VSUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 212003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDrr),
     /* 212008 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212012 */     GIR_RootConstrainSelectedInstOperands,
     /* 212013 */     // GIR_Coverage, 2217,
     /* 212013 */     GIR_Done,
     /* 212014 */   // Label 4909: @212014
     /* 212014 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(212045), // Rule ID 2233 //
     /* 212019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 212022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212034 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (SUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 212034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPDrr),
     /* 212039 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212043 */     GIR_RootConstrainSelectedInstOperands,
     /* 212044 */     // GIR_Coverage, 2233,
     /* 212044 */     GIR_Done,
     /* 212045 */   // Label 4910: @212045
     /* 212045 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(212076), // Rule ID 6537 //
     /* 212050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 212053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212065 */     // (strict_fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VSUBPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 212065 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rr),
     /* 212070 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212074 */     GIR_RootConstrainSelectedInstOperands,
     /* 212075 */     // GIR_Coverage, 6537,
     /* 212075 */     GIR_Done,
     /* 212076 */   // Label 4911: @212076
     /* 212076 */   GIM_Reject,
     /* 212077 */ // Label 4906: @212077
     /* 212077 */ GIM_Reject,
     /* 212078 */ // Label 4866: @212078
     /* 212078 */ GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(212307),
     /* 212083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 212086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 212089 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(212151), // Rule ID 2215 //
     /* 212094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212113 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212116 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212120 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212126 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212133 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSrm),
     /* 212136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212138 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212140 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212149 */     GIR_RootConstrainSelectedInstOperands,
     /* 212150 */     // GIR_Coverage, 2215,
     /* 212150 */     GIR_EraseRootFromParent_Done,
     /* 212151 */   // Label 4913: @212151
     /* 212151 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(212213), // Rule ID 6517 //
     /* 212156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 212159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212175 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212178 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212182 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212188 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212195 */     // (strict_fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rm),
     /* 212198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212200 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212202 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212211 */     GIR_RootConstrainSelectedInstOperands,
     /* 212212 */     // GIR_Coverage, 6517,
     /* 212212 */     GIR_EraseRootFromParent_Done,
     /* 212213 */   // Label 4914: @212213
     /* 212213 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(212244), // Rule ID 2213 //
     /* 212218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212233 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VSUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 212233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSrr),
     /* 212238 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212242 */     GIR_RootConstrainSelectedInstOperands,
     /* 212243 */     // GIR_Coverage, 2213,
     /* 212243 */     GIR_Done,
     /* 212244 */   // Label 4915: @212244
     /* 212244 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(212275), // Rule ID 2229 //
     /* 212249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 212252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212264 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (SUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 212264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPSrr),
     /* 212269 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212273 */     GIR_RootConstrainSelectedInstOperands,
     /* 212274 */     // GIR_Coverage, 2229,
     /* 212274 */     GIR_Done,
     /* 212275 */   // Label 4916: @212275
     /* 212275 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(212306), // Rule ID 6513 //
     /* 212280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 212283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212295 */     // (strict_fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VSUBPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 212295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rr),
     /* 212300 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212304 */     GIR_RootConstrainSelectedInstOperands,
     /* 212305 */     // GIR_Coverage, 6513,
     /* 212305 */     GIR_Done,
     /* 212306 */   // Label 4917: @212306
     /* 212306 */   GIM_Reject,
     /* 212307 */ // Label 4912: @212307
     /* 212307 */ GIM_Reject,
     /* 212308 */ // Label 4867: @212308
     /* 212308 */ GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(212506),
     /* 212313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 212316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 212319 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(212381), // Rule ID 2227 //
     /* 212324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 212331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 212335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212343 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212346 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212350 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212356 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212363 */     // (strict_fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrm),
     /* 212366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212368 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212370 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212379 */     GIR_RootConstrainSelectedInstOperands,
     /* 212380 */     // GIR_Coverage, 2227,
     /* 212380 */     GIR_EraseRootFromParent_Done,
     /* 212381 */   // Label 4919: @212381
     /* 212381 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(212443), // Rule ID 6553 //
     /* 212386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 212389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 212393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 212397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212405 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212408 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212412 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212418 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212425 */     // (strict_fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rm),
     /* 212428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212430 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212432 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212441 */     GIR_RootConstrainSelectedInstOperands,
     /* 212442 */     // GIR_Coverage, 6553,
     /* 212442 */     GIR_EraseRootFromParent_Done,
     /* 212443 */   // Label 4920: @212443
     /* 212443 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(212474), // Rule ID 2225 //
     /* 212448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 212455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 212459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 212463 */     // (strict_fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VSUBPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 212463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrr),
     /* 212468 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212472 */     GIR_RootConstrainSelectedInstOperands,
     /* 212473 */     // GIR_Coverage, 2225,
     /* 212473 */     GIR_Done,
     /* 212474 */   // Label 4921: @212474
     /* 212474 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(212505), // Rule ID 6549 //
     /* 212479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 212482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 212486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 212490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 212494 */     // (strict_fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VSUBPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 212494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rr),
     /* 212499 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212503 */     GIR_RootConstrainSelectedInstOperands,
     /* 212504 */     // GIR_Coverage, 6549,
     /* 212504 */     GIR_Done,
     /* 212505 */   // Label 4922: @212505
     /* 212505 */   GIM_Reject,
     /* 212506 */ // Label 4918: @212506
     /* 212506 */ GIM_Reject,
     /* 212507 */ // Label 4868: @212507
     /* 212507 */ GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(212604),
     /* 212512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 212515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 212518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212526 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(212580), // Rule ID 6577 //
     /* 212531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 212534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212542 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212545 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212549 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212562 */     // (strict_fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rm),
     /* 212565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212567 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212569 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212578 */     GIR_RootConstrainSelectedInstOperands,
     /* 212579 */     // GIR_Coverage, 6577,
     /* 212579 */     GIR_EraseRootFromParent_Done,
     /* 212580 */   // Label 4924: @212580
     /* 212580 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(212603), // Rule ID 6573 //
     /* 212585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 212588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212592 */     // (strict_fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VSUBPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 212592 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rr),
     /* 212597 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212601 */     GIR_RootConstrainSelectedInstOperands,
     /* 212602 */     // GIR_Coverage, 6573,
     /* 212602 */     GIR_Done,
     /* 212603 */   // Label 4925: @212603
     /* 212603 */   GIM_Reject,
     /* 212604 */ // Label 4923: @212604
     /* 212604 */ GIM_Reject,
     /* 212605 */ // Label 4869: @212605
     /* 212605 */ GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(212803),
     /* 212610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 212613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 212616 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(212678), // Rule ID 2223 //
     /* 212621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 212628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 212632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212640 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212643 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212647 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212653 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212660 */     // (strict_fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrm),
     /* 212663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212665 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212667 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212676 */     GIR_RootConstrainSelectedInstOperands,
     /* 212677 */     // GIR_Coverage, 2223,
     /* 212677 */     GIR_EraseRootFromParent_Done,
     /* 212678 */   // Label 4927: @212678
     /* 212678 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(212740), // Rule ID 6529 //
     /* 212683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 212686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 212690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 212694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212702 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212705 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212709 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212722 */     // (strict_fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rm),
     /* 212725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212727 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212729 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212738 */     GIR_RootConstrainSelectedInstOperands,
     /* 212739 */     // GIR_Coverage, 6529,
     /* 212739 */     GIR_EraseRootFromParent_Done,
     /* 212740 */   // Label 4928: @212740
     /* 212740 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(212771), // Rule ID 2221 //
     /* 212745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 212752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 212756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 212760 */     // (strict_fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VSUBPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 212760 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrr),
     /* 212765 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212769 */     GIR_RootConstrainSelectedInstOperands,
     /* 212770 */     // GIR_Coverage, 2221,
     /* 212770 */     GIR_Done,
     /* 212771 */   // Label 4929: @212771
     /* 212771 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(212802), // Rule ID 6525 //
     /* 212776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 212779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 212783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 212787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 212791 */     // (strict_fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VSUBPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 212791 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rr),
     /* 212796 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212800 */     GIR_RootConstrainSelectedInstOperands,
     /* 212801 */     // GIR_Coverage, 6525,
     /* 212801 */     GIR_Done,
     /* 212802 */   // Label 4930: @212802
     /* 212802 */   GIM_Reject,
     /* 212803 */ // Label 4926: @212803
     /* 212803 */ GIM_Reject,
     /* 212804 */ // Label 4870: @212804
     /* 212804 */ GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(212901),
     /* 212809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 212812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 212815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 212819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 212823 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(212877), // Rule ID 6505 //
     /* 212828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 212831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212839 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212842 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212846 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212859 */     // (strict_fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrm),
     /* 212862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212864 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212866 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212875 */     GIR_RootConstrainSelectedInstOperands,
     /* 212876 */     // GIR_Coverage, 6505,
     /* 212876 */     GIR_EraseRootFromParent_Done,
     /* 212877 */   // Label 4932: @212877
     /* 212877 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(212900), // Rule ID 6501 //
     /* 212882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 212885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 212889 */     // (strict_fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VSUBPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 212889 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrr),
     /* 212894 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212898 */     GIR_RootConstrainSelectedInstOperands,
     /* 212899 */     // GIR_Coverage, 6501,
     /* 212899 */     GIR_Done,
     /* 212900 */   // Label 4933: @212900
     /* 212900 */   GIM_Reject,
     /* 212901 */ // Label 4931: @212901
     /* 212901 */ GIM_Reject,
     /* 212902 */ // Label 4871: @212902
     /* 212902 */ GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(212999),
     /* 212907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 212910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 212913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 212917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 212921 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(212975), // Rule ID 6589 //
     /* 212926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 212929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212937 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212940 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212944 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212957 */     // (strict_fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rm),
     /* 212960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212962 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212964 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212973 */     GIR_RootConstrainSelectedInstOperands,
     /* 212974 */     // GIR_Coverage, 6589,
     /* 212974 */     GIR_EraseRootFromParent_Done,
     /* 212975 */   // Label 4935: @212975
     /* 212975 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(212998), // Rule ID 6585 //
     /* 212980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 212983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 212987 */     // (strict_fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VSUBPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 212987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rr),
     /* 212992 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212996 */     GIR_RootConstrainSelectedInstOperands,
     /* 212997 */     // GIR_Coverage, 6585,
     /* 212997 */     GIR_Done,
     /* 212998 */   // Label 4936: @212998
     /* 212998 */   GIM_Reject,
     /* 212999 */ // Label 4934: @212999
     /* 212999 */ GIM_Reject,
     /* 213000 */ // Label 4872: @213000
     /* 213000 */ GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(213097),
     /* 213005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 213008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 213011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213019 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(213073), // Rule ID 6493 //
     /* 213024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 213027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213035 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213038 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213042 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213048 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213055 */     // (strict_fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrm),
     /* 213058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213060 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213062 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213071 */     GIR_RootConstrainSelectedInstOperands,
     /* 213072 */     // GIR_Coverage, 6493,
     /* 213072 */     GIR_EraseRootFromParent_Done,
     /* 213073 */   // Label 4938: @213073
     /* 213073 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(213096), // Rule ID 6489 //
     /* 213078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 213081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213085 */     // (strict_fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VSUBPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 213085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrr),
     /* 213090 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213094 */     GIR_RootConstrainSelectedInstOperands,
     /* 213095 */     // GIR_Coverage, 6489,
     /* 213095 */     GIR_Done,
     /* 213096 */   // Label 4939: @213096
     /* 213096 */   GIM_Reject,
     /* 213097 */ // Label 4937: @213097
     /* 213097 */ GIM_Reject,
     /* 213098 */ // Label 4873: @213098
     /* 213098 */ GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(213195),
     /* 213103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 213106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 213109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213117 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(213171), // Rule ID 6565 //
     /* 213122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 213125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213133 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213136 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213140 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213146 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213153 */     // (strict_fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrm),
     /* 213156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213158 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213160 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213169 */     GIR_RootConstrainSelectedInstOperands,
     /* 213170 */     // GIR_Coverage, 6565,
     /* 213170 */     GIR_EraseRootFromParent_Done,
     /* 213171 */   // Label 4941: @213171
     /* 213171 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(213194), // Rule ID 6561 //
     /* 213176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 213179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 213183 */     // (strict_fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VSUBPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 213183 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrr),
     /* 213188 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213192 */     GIR_RootConstrainSelectedInstOperands,
     /* 213193 */     // GIR_Coverage, 6561,
     /* 213193 */     GIR_Done,
     /* 213194 */   // Label 4942: @213194
     /* 213194 */   GIM_Reject,
     /* 213195 */ // Label 4940: @213195
     /* 213195 */ GIM_Reject,
     /* 213196 */ // Label 4874: @213196
     /* 213196 */ GIM_Reject,
     /* 213197 */ // Label 70: @213197
     /* 213197 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4956*/ GIMT_Encode4(217362),
     /* 213208 */ /*GILLT_s16*//*Label 4943*/ GIMT_Encode4(213292),
     /* 213212 */ /*GILLT_s32*//*Label 4944*/ GIMT_Encode4(213452),
     /* 213216 */ /*GILLT_s64*//*Label 4945*/ GIMT_Encode4(214097),
     /* 213220 */ /*GILLT_s80*//*Label 4946*/ GIMT_Encode4(214886), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 213232 */ /*GILLT_v2s64*//*Label 4947*/ GIMT_Encode4(215208), GIMT_Encode4(0),
     /* 213240 */ /*GILLT_v4s32*//*Label 4948*/ GIMT_Encode4(215562),
     /* 213244 */ /*GILLT_v4s64*//*Label 4949*/ GIMT_Encode4(215916), GIMT_Encode4(0),
     /* 213252 */ /*GILLT_v8s16*//*Label 4950*/ GIMT_Encode4(216239),
     /* 213256 */ /*GILLT_v8s32*//*Label 4951*/ GIMT_Encode4(216399),
     /* 213260 */ /*GILLT_v8s64*//*Label 4952*/ GIMT_Encode4(216722), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 213272 */ /*GILLT_v16s16*//*Label 4953*/ GIMT_Encode4(216882),
     /* 213276 */ /*GILLT_v16s32*//*Label 4954*/ GIMT_Encode4(217042), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 213288 */ /*GILLT_v32s16*//*Label 4955*/ GIMT_Encode4(217202),
     /* 213292 */ // Label 4943: @213292
     /* 213292 */ GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(213451),
     /* 213297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 213300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 213303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 213307 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(213365), // Rule ID 24252 //
     /* 213312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 213315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213323 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213326 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213330 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 213338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213347 */     // (strict_fmul:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 213350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213352 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213354 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213363 */     GIR_RootConstrainSelectedInstOperands,
     /* 213364 */     // GIR_Coverage, 24252,
     /* 213364 */     GIR_EraseRootFromParent_Done,
     /* 213365 */   // Label 4958: @213365
     /* 213365 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(213423), // Rule ID 6010 //
     /* 213370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 213373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 213377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213385 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213388 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213392 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213405 */     // (strict_fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 213408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213410 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213412 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213421 */     GIR_RootConstrainSelectedInstOperands,
     /* 213422 */     // GIR_Coverage, 6010,
     /* 213422 */     GIR_EraseRootFromParent_Done,
     /* 213423 */   // Label 4959: @213423
     /* 213423 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(213450), // Rule ID 6008 //
     /* 213428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 213431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 213435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 213439 */     // (strict_fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VMULSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 213439 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSHZrr),
     /* 213444 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213448 */     GIR_RootConstrainSelectedInstOperands,
     /* 213449 */     // GIR_Coverage, 6008,
     /* 213449 */     GIR_Done,
     /* 213450 */   // Label 4960: @213450
     /* 213450 */   GIM_Reject,
     /* 213451 */ // Label 4957: @213451
     /* 213451 */ GIM_Reject,
     /* 213452 */ // Label 4944: @213452
     /* 213452 */ GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(214096),
     /* 213457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 213460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213463 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(213528), // Rule ID 23255 //
     /* 213468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 213471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 213475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213483 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213486 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213490 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 213498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213507 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 213510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213512 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213514 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 213521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213526 */     GIR_RootConstrainSelectedInstOperands,
     /* 213527 */     // GIR_Coverage, 23255,
     /* 213527 */     GIR_EraseRootFromParent_Done,
     /* 213528 */   // Label 4962: @213528
     /* 213528 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(213590), // Rule ID 23398 //
     /* 213533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 213536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 213540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213548 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213551 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213555 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 213563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213572 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 213575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213577 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213579 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213588 */     GIR_RootConstrainSelectedInstOperands,
     /* 213589 */     // GIR_Coverage, 23398,
     /* 213589 */     GIR_EraseRootFromParent_Done,
     /* 213590 */   // Label 4963: @213590
     /* 213590 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(213652), // Rule ID 23402 //
     /* 213595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 213598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 213602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213610 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213613 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213617 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 213625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213634 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 213637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213639 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213641 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213650 */     GIR_RootConstrainSelectedInstOperands,
     /* 213651 */     // GIR_Coverage, 23402,
     /* 213651 */     GIR_EraseRootFromParent_Done,
     /* 213652 */   // Label 4964: @213652
     /* 213652 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(213714), // Rule ID 24248 //
     /* 213657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 213660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 213664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213672 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213675 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213679 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 213687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213696 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 213699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213701 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213703 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213712 */     GIR_RootConstrainSelectedInstOperands,
     /* 213713 */     // GIR_Coverage, 24248,
     /* 213713 */     GIR_EraseRootFromParent_Done,
     /* 213714 */   // Label 4965: @213714
     /* 213714 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(213779), // Rule ID 975 //
     /* 213719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 213722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 213726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 213730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213738 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213741 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213745 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213751 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213758 */     // (strict_fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 213761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213763 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213765 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 213772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213777 */     GIR_RootConstrainSelectedInstOperands,
     /* 213778 */     // GIR_Coverage, 975,
     /* 213778 */     GIR_EraseRootFromParent_Done,
     /* 213779 */   // Label 4966: @213779
     /* 213779 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(213841), // Rule ID 2199 //
     /* 213784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 213787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 213791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 213795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213803 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213806 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213810 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213816 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213823 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 213826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213828 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213830 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213839 */     GIR_RootConstrainSelectedInstOperands,
     /* 213840 */     // GIR_Coverage, 2199,
     /* 213840 */     GIR_EraseRootFromParent_Done,
     /* 213841 */   // Label 4967: @213841
     /* 213841 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(213903), // Rule ID 2207 //
     /* 213846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 213849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 213853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 213857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213865 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213868 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213872 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213878 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213885 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 213888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213890 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213892 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213901 */     GIR_RootConstrainSelectedInstOperands,
     /* 213902 */     // GIR_Coverage, 2207,
     /* 213902 */     GIR_EraseRootFromParent_Done,
     /* 213903 */   // Label 4968: @213903
     /* 213903 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(213965), // Rule ID 5972 //
     /* 213908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 213911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 213915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 213919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213927 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213930 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213934 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213947 */     // (strict_fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 213950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213952 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213954 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213963 */     GIR_RootConstrainSelectedInstOperands,
     /* 213964 */     // GIR_Coverage, 5972,
     /* 213964 */     GIR_EraseRootFromParent_Done,
     /* 213965 */   // Label 4969: @213965
     /* 213965 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(214002), // Rule ID 897 //
     /* 213970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 213973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 213977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 213981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 213985 */     // (strict_fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (MUL_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 213985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32),
     /* 213990 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 213996 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 214000 */     GIR_RootConstrainSelectedInstOperands,
     /* 214001 */     // GIR_Coverage, 897,
     /* 214001 */     GIR_Done,
     /* 214002 */   // Label 4970: @214002
     /* 214002 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(214033), // Rule ID 2197 //
     /* 214007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 214010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214022 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VMULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 214022 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSrr),
     /* 214027 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214031 */     GIR_RootConstrainSelectedInstOperands,
     /* 214032 */     // GIR_Coverage, 2197,
     /* 214032 */     GIR_Done,
     /* 214033 */   // Label 4971: @214033
     /* 214033 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(214064), // Rule ID 2205 //
     /* 214038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 214041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 214053 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (MULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 214053 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSSrr),
     /* 214058 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214062 */     GIR_RootConstrainSelectedInstOperands,
     /* 214063 */     // GIR_Coverage, 2205,
     /* 214063 */     GIR_Done,
     /* 214064 */   // Label 4972: @214064
     /* 214064 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(214095), // Rule ID 5970 //
     /* 214069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 214076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 214080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 214084 */     // (strict_fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VMULSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 214084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSZrr),
     /* 214089 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214093 */     GIR_RootConstrainSelectedInstOperands,
     /* 214094 */     // GIR_Coverage, 5970,
     /* 214094 */     GIR_Done,
     /* 214095 */   // Label 4973: @214095
     /* 214095 */   GIM_Reject,
     /* 214096 */ // Label 4961: @214096
     /* 214096 */ GIM_Reject,
     /* 214097 */ // Label 4945: @214097
     /* 214097 */ GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(214885),
     /* 214102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 214105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214108 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(214173), // Rule ID 23257 //
     /* 214113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 214116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 214120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214128 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214131 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214135 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 214143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214152 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 214155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214157 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214159 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214163 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 214166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214171 */     GIR_RootConstrainSelectedInstOperands,
     /* 214172 */     // GIR_Coverage, 23257,
     /* 214172 */     GIR_EraseRootFromParent_Done,
     /* 214173 */   // Label 4975: @214173
     /* 214173 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(214245), // Rule ID 23259 //
     /* 214178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 214181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 214185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214193 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214196 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214200 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 214207 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 214215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214224 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 214227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214229 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214231 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214235 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 214238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214243 */     GIR_RootConstrainSelectedInstOperands,
     /* 214244 */     // GIR_Coverage, 23259,
     /* 214244 */     GIR_EraseRootFromParent_Done,
     /* 214245 */   // Label 4976: @214245
     /* 214245 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(214307), // Rule ID 23400 //
     /* 214250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 214253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214265 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214268 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214272 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214289 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 214292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214294 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214296 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214305 */     GIR_RootConstrainSelectedInstOperands,
     /* 214306 */     // GIR_Coverage, 23400,
     /* 214306 */     GIR_EraseRootFromParent_Done,
     /* 214307 */   // Label 4977: @214307
     /* 214307 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(214369), // Rule ID 23404 //
     /* 214312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 214315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214327 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214330 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214334 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214351 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 214354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214356 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214358 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214367 */     GIR_RootConstrainSelectedInstOperands,
     /* 214368 */     // GIR_Coverage, 23404,
     /* 214368 */     GIR_EraseRootFromParent_Done,
     /* 214369 */   // Label 4978: @214369
     /* 214369 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(214431), // Rule ID 24250 //
     /* 214374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 214381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214389 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214392 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214396 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 214404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214413 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 214416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214418 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214420 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214429 */     GIR_RootConstrainSelectedInstOperands,
     /* 214430 */     // GIR_Coverage, 24250,
     /* 214430 */     GIR_EraseRootFromParent_Done,
     /* 214431 */   // Label 4979: @214431
     /* 214431 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(214496), // Rule ID 977 //
     /* 214436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 214439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 214443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 214447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214455 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214458 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214462 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214475 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 214478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214480 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214482 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 214489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214494 */     GIR_RootConstrainSelectedInstOperands,
     /* 214495 */     // GIR_Coverage, 977,
     /* 214495 */     GIR_EraseRootFromParent_Done,
     /* 214496 */   // Label 4980: @214496
     /* 214496 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(214568), // Rule ID 979 //
     /* 214501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 214504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 214508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 214512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214520 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214523 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214527 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 214534 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214540 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214547 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 214550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214552 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214554 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 214561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214566 */     GIR_RootConstrainSelectedInstOperands,
     /* 214567 */     // GIR_Coverage, 979,
     /* 214567 */     GIR_EraseRootFromParent_Done,
     /* 214568 */   // Label 4981: @214568
     /* 214568 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(214630), // Rule ID 2203 //
     /* 214573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 214576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214592 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214599 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214612 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 214615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214617 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214628 */     GIR_RootConstrainSelectedInstOperands,
     /* 214629 */     // GIR_Coverage, 2203,
     /* 214629 */     GIR_EraseRootFromParent_Done,
     /* 214630 */   // Label 4982: @214630
     /* 214630 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(214692), // Rule ID 2211 //
     /* 214635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 214638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214654 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214657 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214661 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214667 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214674 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 214677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214679 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214681 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214690 */     GIR_RootConstrainSelectedInstOperands,
     /* 214691 */     // GIR_Coverage, 2211,
     /* 214691 */     GIR_EraseRootFromParent_Done,
     /* 214692 */   // Label 4983: @214692
     /* 214692 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(214754), // Rule ID 5991 //
     /* 214697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 214704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 214708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214716 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214719 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214723 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214736 */     // (strict_fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 214739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214741 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214743 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214752 */     GIR_RootConstrainSelectedInstOperands,
     /* 214753 */     // GIR_Coverage, 5991,
     /* 214753 */     GIR_EraseRootFromParent_Done,
     /* 214754 */   // Label 4984: @214754
     /* 214754 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(214791), // Rule ID 899 //
     /* 214759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 214762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 214766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 214770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 214774 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (MUL_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 214774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64),
     /* 214779 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 214785 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 214789 */     GIR_RootConstrainSelectedInstOperands,
     /* 214790 */     // GIR_Coverage, 899,
     /* 214790 */     GIR_Done,
     /* 214791 */   // Label 4985: @214791
     /* 214791 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(214822), // Rule ID 2201 //
     /* 214796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 214799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214811 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VMULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 214811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDrr),
     /* 214816 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214820 */     GIR_RootConstrainSelectedInstOperands,
     /* 214821 */     // GIR_Coverage, 2201,
     /* 214821 */     GIR_Done,
     /* 214822 */   // Label 4986: @214822
     /* 214822 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(214853), // Rule ID 2209 //
     /* 214827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 214830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 214842 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (MULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 214842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSDrr),
     /* 214847 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214851 */     GIR_RootConstrainSelectedInstOperands,
     /* 214852 */     // GIR_Coverage, 2209,
     /* 214852 */     GIR_Done,
     /* 214853 */   // Label 4987: @214853
     /* 214853 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(214884), // Rule ID 5989 //
     /* 214858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 214865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 214869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 214873 */     // (strict_fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VMULSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 214873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDZrr),
     /* 214878 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214882 */     GIR_RootConstrainSelectedInstOperands,
     /* 214883 */     // GIR_Coverage, 5989,
     /* 214883 */     GIR_Done,
     /* 214884 */   // Label 4988: @214884
     /* 214884 */   GIM_Reject,
     /* 214885 */ // Label 4974: @214885
     /* 214885 */ GIM_Reject,
     /* 214886 */ // Label 4946: @214886
     /* 214886 */ GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(215207),
     /* 214891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 214894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 214897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 214901 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(214969), // Rule ID 23261 //
     /* 214906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 214909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214917 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214920 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214924 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 214931 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 214939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214948 */     // (strict_fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 214951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214953 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214955 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214959 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 214962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214967 */     GIR_RootConstrainSelectedInstOperands,
     /* 214968 */     // GIR_Coverage, 23261,
     /* 214968 */     GIR_EraseRootFromParent_Done,
     /* 214969 */   // Label 4990: @214969
     /* 214969 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(215037), // Rule ID 23263 //
     /* 214974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 214977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214985 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214988 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214992 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 214999 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 215007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215016 */     // (strict_fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 215019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215021 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215023 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215027 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215035 */     GIR_RootConstrainSelectedInstOperands,
     /* 215036 */     // GIR_Coverage, 23263,
     /* 215036 */     GIR_EraseRootFromParent_Done,
     /* 215037 */   // Label 4991: @215037
     /* 215037 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(215105), // Rule ID 981 //
     /* 215042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 215045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 215049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215057 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215060 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215064 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 215071 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215077 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215084 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 215087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215089 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215091 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215095 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215103 */     GIR_RootConstrainSelectedInstOperands,
     /* 215104 */     // GIR_Coverage, 981,
     /* 215104 */     GIR_EraseRootFromParent_Done,
     /* 215105 */   // Label 4992: @215105
     /* 215105 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(215173), // Rule ID 983 //
     /* 215110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 215113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 215117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215125 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215128 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215132 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 215139 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215152 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 215155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215157 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215159 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215163 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215171 */     GIR_RootConstrainSelectedInstOperands,
     /* 215172 */     // GIR_Coverage, 983,
     /* 215172 */     GIR_EraseRootFromParent_Done,
     /* 215173 */   // Label 4993: @215173
     /* 215173 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(215206), // Rule ID 901 //
     /* 215178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 215181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 215185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 215189 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (MUL_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 215189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80),
     /* 215194 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 215200 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 215204 */     GIR_RootConstrainSelectedInstOperands,
     /* 215205 */     // GIR_Coverage, 901,
     /* 215205 */     GIR_Done,
     /* 215206 */   // Label 4994: @215206
     /* 215206 */   GIM_Reject,
     /* 215207 */ // Label 4989: @215207
     /* 215207 */ GIM_Reject,
     /* 215208 */ // Label 4947: @215208
     /* 215208 */ GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(215561),
     /* 215213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 215216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215219 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(215281), // Rule ID 23388 //
     /* 215224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 215227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215239 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215242 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215246 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215263 */     // (strict_fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 215266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215268 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215270 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215279 */     GIR_RootConstrainSelectedInstOperands,
     /* 215280 */     // GIR_Coverage, 23388,
     /* 215280 */     GIR_EraseRootFromParent_Done,
     /* 215281 */   // Label 4996: @215281
     /* 215281 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(215343), // Rule ID 24364 //
     /* 215286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 215289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 215293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215301 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215304 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215308 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 215316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215318 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215325 */     // (strict_fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 215328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215330 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215332 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215341 */     GIR_RootConstrainSelectedInstOperands,
     /* 215342 */     // GIR_Coverage, 24364,
     /* 215342 */     GIR_EraseRootFromParent_Done,
     /* 215343 */   // Label 4997: @215343
     /* 215343 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(215405), // Rule ID 2179 //
     /* 215348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 215351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215367 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215370 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215374 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215387 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 215390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215392 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215394 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215403 */     GIR_RootConstrainSelectedInstOperands,
     /* 215404 */     // GIR_Coverage, 2179,
     /* 215404 */     GIR_EraseRootFromParent_Done,
     /* 215405 */   // Label 4998: @215405
     /* 215405 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(215467), // Rule ID 6424 //
     /* 215410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 215413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 215417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 215421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215429 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215432 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215436 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215449 */     // (strict_fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 215452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215454 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215456 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215465 */     GIR_RootConstrainSelectedInstOperands,
     /* 215466 */     // GIR_Coverage, 6424,
     /* 215466 */     GIR_EraseRootFromParent_Done,
     /* 215467 */   // Label 4999: @215467
     /* 215467 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(215498), // Rule ID 2177 //
     /* 215472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 215475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215487 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 215487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDrr),
     /* 215492 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215496 */     GIR_RootConstrainSelectedInstOperands,
     /* 215497 */     // GIR_Coverage, 2177,
     /* 215497 */     GIR_Done,
     /* 215498 */   // Label 5000: @215498
     /* 215498 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(215529), // Rule ID 2193 //
     /* 215503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 215506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215518 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (MULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 215518 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPDrr),
     /* 215523 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215527 */     GIR_RootConstrainSelectedInstOperands,
     /* 215528 */     // GIR_Coverage, 2193,
     /* 215528 */     GIR_Done,
     /* 215529 */   // Label 5001: @215529
     /* 215529 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(215560), // Rule ID 6420 //
     /* 215534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 215537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 215541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 215545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 215549 */     // (strict_fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VMULPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 215549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rr),
     /* 215554 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215558 */     GIR_RootConstrainSelectedInstOperands,
     /* 215559 */     // GIR_Coverage, 6420,
     /* 215559 */     GIR_Done,
     /* 215560 */   // Label 5002: @215560
     /* 215560 */   GIM_Reject,
     /* 215561 */ // Label 4995: @215561
     /* 215561 */ GIM_Reject,
     /* 215562 */ // Label 4948: @215562
     /* 215562 */ GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(215915),
     /* 215567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215573 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(215635), // Rule ID 23386 //
     /* 215578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 215581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215593 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215596 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215600 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215610 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215617 */     // (strict_fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 215620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215622 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215624 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215633 */     GIR_RootConstrainSelectedInstOperands,
     /* 215634 */     // GIR_Coverage, 23386,
     /* 215634 */     GIR_EraseRootFromParent_Done,
     /* 215635 */   // Label 5004: @215635
     /* 215635 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(215697), // Rule ID 24348 //
     /* 215640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 215643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 215647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215655 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215658 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215662 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 215670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215672 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215679 */     // (strict_fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 215682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215684 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215686 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215695 */     GIR_RootConstrainSelectedInstOperands,
     /* 215696 */     // GIR_Coverage, 24348,
     /* 215696 */     GIR_EraseRootFromParent_Done,
     /* 215697 */   // Label 5005: @215697
     /* 215697 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(215759), // Rule ID 2175 //
     /* 215702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 215705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215721 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215724 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215728 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215734 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215741 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 215744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215746 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215748 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215757 */     GIR_RootConstrainSelectedInstOperands,
     /* 215758 */     // GIR_Coverage, 2175,
     /* 215758 */     GIR_EraseRootFromParent_Done,
     /* 215759 */   // Label 5006: @215759
     /* 215759 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(215821), // Rule ID 6400 //
     /* 215764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 215767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 215771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 215775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215783 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215786 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215790 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215796 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215803 */     // (strict_fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 215806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215808 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215810 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215819 */     GIR_RootConstrainSelectedInstOperands,
     /* 215820 */     // GIR_Coverage, 6400,
     /* 215820 */     GIR_EraseRootFromParent_Done,
     /* 215821 */   // Label 5007: @215821
     /* 215821 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(215852), // Rule ID 2173 //
     /* 215826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 215829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215841 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 215841 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSrr),
     /* 215846 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215850 */     GIR_RootConstrainSelectedInstOperands,
     /* 215851 */     // GIR_Coverage, 2173,
     /* 215851 */     GIR_Done,
     /* 215852 */   // Label 5008: @215852
     /* 215852 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(215883), // Rule ID 2189 //
     /* 215857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 215860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 215872 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (MULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 215872 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPSrr),
     /* 215877 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215881 */     GIR_RootConstrainSelectedInstOperands,
     /* 215882 */     // GIR_Coverage, 2189,
     /* 215882 */     GIR_Done,
     /* 215883 */   // Label 5009: @215883
     /* 215883 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(215914), // Rule ID 6396 //
     /* 215888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 215891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 215895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 215899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 215903 */     // (strict_fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VMULPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 215903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rr),
     /* 215908 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215912 */     GIR_RootConstrainSelectedInstOperands,
     /* 215913 */     // GIR_Coverage, 6396,
     /* 215913 */     GIR_Done,
     /* 215914 */   // Label 5010: @215914
     /* 215914 */   GIM_Reject,
     /* 215915 */ // Label 5003: @215915
     /* 215915 */ GIM_Reject,
     /* 215916 */ // Label 4949: @215916
     /* 215916 */ GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(216238),
     /* 215921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 215924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 215927 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(215989), // Rule ID 23392 //
     /* 215932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 215935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 215939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215947 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215950 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215954 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 215962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215971 */     // (strict_fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 215974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215976 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215978 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215987 */     GIR_RootConstrainSelectedInstOperands,
     /* 215988 */     // GIR_Coverage, 23392,
     /* 215988 */     GIR_EraseRootFromParent_Done,
     /* 215989 */   // Label 5012: @215989
     /* 215989 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(216051), // Rule ID 24372 //
     /* 215994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 215997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216009 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216012 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216016 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216026 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216033 */     // (strict_fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 216036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216038 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216040 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216049 */     GIR_RootConstrainSelectedInstOperands,
     /* 216050 */     // GIR_Coverage, 24372,
     /* 216050 */     GIR_EraseRootFromParent_Done,
     /* 216051 */   // Label 5013: @216051
     /* 216051 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(216113), // Rule ID 2187 //
     /* 216056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 216059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216075 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216078 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216082 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216088 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216095 */     // (strict_fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 216098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216100 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216102 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216111 */     GIR_RootConstrainSelectedInstOperands,
     /* 216112 */     // GIR_Coverage, 2187,
     /* 216112 */     GIR_EraseRootFromParent_Done,
     /* 216113 */   // Label 5014: @216113
     /* 216113 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(216175), // Rule ID 6436 //
     /* 216118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216137 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216140 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216144 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216157 */     // (strict_fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 216160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216162 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216164 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216173 */     GIR_RootConstrainSelectedInstOperands,
     /* 216174 */     // GIR_Coverage, 6436,
     /* 216174 */     GIR_EraseRootFromParent_Done,
     /* 216175 */   // Label 5015: @216175
     /* 216175 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(216206), // Rule ID 2185 //
     /* 216180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 216183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216195 */     // (strict_fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMULPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 216195 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDYrr),
     /* 216200 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216204 */     GIR_RootConstrainSelectedInstOperands,
     /* 216205 */     // GIR_Coverage, 2185,
     /* 216205 */     GIR_Done,
     /* 216206 */   // Label 5016: @216206
     /* 216206 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(216237), // Rule ID 6432 //
     /* 216211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216226 */     // (strict_fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VMULPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 216226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rr),
     /* 216231 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216235 */     GIR_RootConstrainSelectedInstOperands,
     /* 216236 */     // GIR_Coverage, 6432,
     /* 216236 */     GIR_Done,
     /* 216237 */   // Label 5017: @216237
     /* 216237 */   GIM_Reject,
     /* 216238 */ // Label 5011: @216238
     /* 216238 */ GIM_Reject,
     /* 216239 */ // Label 4950: @216239
     /* 216239 */ GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(216398),
     /* 216244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 216247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216254 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(216312), // Rule ID 24388 //
     /* 216259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 216262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216270 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216273 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216277 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216294 */     // (strict_fmul:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 216297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216299 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216301 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216310 */     GIR_RootConstrainSelectedInstOperands,
     /* 216311 */     // GIR_Coverage, 24388,
     /* 216311 */     GIR_EraseRootFromParent_Done,
     /* 216312 */   // Label 5019: @216312
     /* 216312 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(216370), // Rule ID 6460 //
     /* 216317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 216320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216332 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216335 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216339 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216352 */     // (strict_fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 216355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216357 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216359 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216368 */     GIR_RootConstrainSelectedInstOperands,
     /* 216369 */     // GIR_Coverage, 6460,
     /* 216369 */     GIR_EraseRootFromParent_Done,
     /* 216370 */   // Label 5020: @216370
     /* 216370 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(216397), // Rule ID 6456 //
     /* 216375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 216378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 216386 */     // (strict_fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VMULPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 216386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rr),
     /* 216391 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216395 */     GIR_RootConstrainSelectedInstOperands,
     /* 216396 */     // GIR_Coverage, 6456,
     /* 216396 */     GIR_Done,
     /* 216397 */   // Label 5021: @216397
     /* 216397 */   GIM_Reject,
     /* 216398 */ // Label 5018: @216398
     /* 216398 */ GIM_Reject,
     /* 216399 */ // Label 4951: @216399
     /* 216399 */ GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(216721),
     /* 216404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 216407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 216410 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(216472), // Rule ID 23390 //
     /* 216415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 216418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216430 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216433 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216437 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216454 */     // (strict_fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 216457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216459 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216461 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216470 */     GIR_RootConstrainSelectedInstOperands,
     /* 216471 */     // GIR_Coverage, 23390,
     /* 216471 */     GIR_EraseRootFromParent_Done,
     /* 216472 */   // Label 5023: @216472
     /* 216472 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(216534), // Rule ID 24356 //
     /* 216477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216492 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216499 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216516 */     // (strict_fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 216519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216521 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216523 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216532 */     GIR_RootConstrainSelectedInstOperands,
     /* 216533 */     // GIR_Coverage, 24356,
     /* 216533 */     GIR_EraseRootFromParent_Done,
     /* 216534 */   // Label 5024: @216534
     /* 216534 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(216596), // Rule ID 2183 //
     /* 216539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 216542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216558 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216561 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216565 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216578 */     // (strict_fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 216581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216583 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216585 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216594 */     GIR_RootConstrainSelectedInstOperands,
     /* 216595 */     // GIR_Coverage, 2183,
     /* 216595 */     GIR_EraseRootFromParent_Done,
     /* 216596 */   // Label 5025: @216596
     /* 216596 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(216658), // Rule ID 6412 //
     /* 216601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216620 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216623 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216627 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216640 */     // (strict_fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 216643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216645 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216647 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216656 */     GIR_RootConstrainSelectedInstOperands,
     /* 216657 */     // GIR_Coverage, 6412,
     /* 216657 */     GIR_EraseRootFromParent_Done,
     /* 216658 */   // Label 5026: @216658
     /* 216658 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(216689), // Rule ID 2181 //
     /* 216663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 216666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 216678 */     // (strict_fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMULPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 216678 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSYrr),
     /* 216683 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216687 */     GIR_RootConstrainSelectedInstOperands,
     /* 216688 */     // GIR_Coverage, 2181,
     /* 216688 */     GIR_Done,
     /* 216689 */   // Label 5027: @216689
     /* 216689 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(216720), // Rule ID 6408 //
     /* 216694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 216697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216709 */     // (strict_fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VMULPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 216709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rr),
     /* 216714 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216718 */     GIR_RootConstrainSelectedInstOperands,
     /* 216719 */     // GIR_Coverage, 6408,
     /* 216719 */     GIR_Done,
     /* 216720 */   // Label 5028: @216720
     /* 216720 */   GIM_Reject,
     /* 216721 */ // Label 5022: @216721
     /* 216721 */ GIM_Reject,
     /* 216722 */ // Label 4952: @216722
     /* 216722 */ GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(216881),
     /* 216727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 216730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 216733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 216737 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(216795), // Rule ID 24340 //
     /* 216742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 216745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216753 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216756 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216760 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 216768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216770 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216777 */     // (strict_fmul:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 216780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216782 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216784 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216793 */     GIR_RootConstrainSelectedInstOperands,
     /* 216794 */     // GIR_Coverage, 24340,
     /* 216794 */     GIR_EraseRootFromParent_Done,
     /* 216795 */   // Label 5030: @216795
     /* 216795 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(216853), // Rule ID 6388 //
     /* 216800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 216803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 216807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216815 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216818 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216822 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216828 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216835 */     // (strict_fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 216838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216840 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216842 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216851 */     GIR_RootConstrainSelectedInstOperands,
     /* 216852 */     // GIR_Coverage, 6388,
     /* 216852 */     GIR_EraseRootFromParent_Done,
     /* 216853 */   // Label 5031: @216853
     /* 216853 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(216880), // Rule ID 6384 //
     /* 216858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 216861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 216865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 216869 */     // (strict_fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VMULPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 216869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZrr),
     /* 216874 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216878 */     GIR_RootConstrainSelectedInstOperands,
     /* 216879 */     // GIR_Coverage, 6384,
     /* 216879 */     GIR_Done,
     /* 216880 */   // Label 5032: @216880
     /* 216880 */   GIM_Reject,
     /* 216881 */ // Label 5029: @216881
     /* 216881 */ GIM_Reject,
     /* 216882 */ // Label 4953: @216882
     /* 216882 */ GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(217041),
     /* 216887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 216890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 216893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216897 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(216955), // Rule ID 24396 //
     /* 216902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 216905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216913 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216916 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216920 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216930 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216937 */     // (strict_fmul:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 216940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216942 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216944 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216953 */     GIR_RootConstrainSelectedInstOperands,
     /* 216954 */     // GIR_Coverage, 24396,
     /* 216954 */     GIR_EraseRootFromParent_Done,
     /* 216955 */   // Label 5034: @216955
     /* 216955 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(217013), // Rule ID 6472 //
     /* 216960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 216963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 216967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216975 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216978 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216982 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216995 */     // (strict_fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 216998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217000 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217002 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217011 */     GIR_RootConstrainSelectedInstOperands,
     /* 217012 */     // GIR_Coverage, 6472,
     /* 217012 */     GIR_EraseRootFromParent_Done,
     /* 217013 */   // Label 5035: @217013
     /* 217013 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(217040), // Rule ID 6468 //
     /* 217018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 217021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217029 */     // (strict_fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VMULPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 217029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rr),
     /* 217034 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217038 */     GIR_RootConstrainSelectedInstOperands,
     /* 217039 */     // GIR_Coverage, 6468,
     /* 217039 */     GIR_Done,
     /* 217040 */   // Label 5036: @217040
     /* 217040 */   GIM_Reject,
     /* 217041 */ // Label 5033: @217041
     /* 217041 */ GIM_Reject,
     /* 217042 */ // Label 4954: @217042
     /* 217042 */ GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(217201),
     /* 217047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 217050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 217053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217057 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(217115), // Rule ID 24332 //
     /* 217062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 217065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 217069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217073 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217076 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217080 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217090 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217097 */     // (strict_fmul:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 217100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217102 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 217104 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217113 */     GIR_RootConstrainSelectedInstOperands,
     /* 217114 */     // GIR_Coverage, 24332,
     /* 217114 */     GIR_EraseRootFromParent_Done,
     /* 217115 */   // Label 5038: @217115
     /* 217115 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(217173), // Rule ID 6376 //
     /* 217120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 217123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217135 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217138 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217142 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217148 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217155 */     // (strict_fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 217158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217160 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217162 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217171 */     GIR_RootConstrainSelectedInstOperands,
     /* 217172 */     // GIR_Coverage, 6376,
     /* 217172 */     GIR_EraseRootFromParent_Done,
     /* 217173 */   // Label 5039: @217173
     /* 217173 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(217200), // Rule ID 6372 //
     /* 217178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 217181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217189 */     // (strict_fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VMULPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 217189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZrr),
     /* 217194 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217198 */     GIR_RootConstrainSelectedInstOperands,
     /* 217199 */     // GIR_Coverage, 6372,
     /* 217199 */     GIR_Done,
     /* 217200 */   // Label 5040: @217200
     /* 217200 */   GIM_Reject,
     /* 217201 */ // Label 5037: @217201
     /* 217201 */ GIM_Reject,
     /* 217202 */ // Label 4955: @217202
     /* 217202 */ GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(217361),
     /* 217207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 217210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 217213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217217 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(217275), // Rule ID 24380 //
     /* 217222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 217225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 217229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217233 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217236 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217240 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217250 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217257 */     // (strict_fmul:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 217260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217262 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 217264 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217273 */     GIR_RootConstrainSelectedInstOperands,
     /* 217274 */     // GIR_Coverage, 24380,
     /* 217274 */     GIR_EraseRootFromParent_Done,
     /* 217275 */   // Label 5042: @217275
     /* 217275 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(217333), // Rule ID 6448 //
     /* 217280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 217283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217295 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217298 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217302 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217315 */     // (strict_fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 217318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217320 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217322 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217331 */     GIR_RootConstrainSelectedInstOperands,
     /* 217332 */     // GIR_Coverage, 6448,
     /* 217332 */     GIR_EraseRootFromParent_Done,
     /* 217333 */   // Label 5043: @217333
     /* 217333 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(217360), // Rule ID 6444 //
     /* 217338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 217341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 217349 */     // (strict_fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VMULPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 217349 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZrr),
     /* 217354 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217358 */     GIR_RootConstrainSelectedInstOperands,
     /* 217359 */     // GIR_Coverage, 6444,
     /* 217359 */     GIR_Done,
     /* 217360 */   // Label 5044: @217360
     /* 217360 */   GIM_Reject,
     /* 217361 */ // Label 5041: @217361
     /* 217361 */ GIM_Reject,
     /* 217362 */ // Label 4956: @217362
     /* 217362 */ GIM_Reject,
     /* 217363 */ // Label 71: @217363
     /* 217363 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5058*/ GIMT_Encode4(220288),
     /* 217374 */ /*GILLT_s16*//*Label 5045*/ GIMT_Encode4(217458),
     /* 217378 */ /*GILLT_s32*//*Label 5046*/ GIMT_Encode4(217556),
     /* 217382 */ /*GILLT_s64*//*Label 5047*/ GIMT_Encode4(218015),
     /* 217386 */ /*GILLT_s80*//*Label 5048*/ GIMT_Encode4(218618), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 217398 */ /*GILLT_v2s64*//*Label 5049*/ GIMT_Encode4(218940), GIMT_Encode4(0),
     /* 217406 */ /*GILLT_v4s32*//*Label 5050*/ GIMT_Encode4(219170),
     /* 217410 */ /*GILLT_v4s64*//*Label 5051*/ GIMT_Encode4(219400), GIMT_Encode4(0),
     /* 217418 */ /*GILLT_v8s16*//*Label 5052*/ GIMT_Encode4(219599),
     /* 217422 */ /*GILLT_v8s32*//*Label 5053*/ GIMT_Encode4(219697),
     /* 217426 */ /*GILLT_v8s64*//*Label 5054*/ GIMT_Encode4(219896), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 217438 */ /*GILLT_v16s16*//*Label 5055*/ GIMT_Encode4(219994),
     /* 217442 */ /*GILLT_v16s32*//*Label 5056*/ GIMT_Encode4(220092), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 217454 */ /*GILLT_v32s16*//*Label 5057*/ GIMT_Encode4(220190),
     /* 217458 */ // Label 5045: @217458
     /* 217458 */ GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(217555),
     /* 217463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 217466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 217469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 217473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 217477 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(217531), // Rule ID 6124 //
     /* 217482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 217485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217493 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217496 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217500 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217506 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217513 */     // (strict_fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrm),
     /* 217516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217518 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217520 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217529 */     GIR_RootConstrainSelectedInstOperands,
     /* 217530 */     // GIR_Coverage, 6124,
     /* 217530 */     GIR_EraseRootFromParent_Done,
     /* 217531 */   // Label 5060: @217531
     /* 217531 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(217554), // Rule ID 6122 //
     /* 217536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 217539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 217543 */     // (strict_fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VDIVSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 217543 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrr),
     /* 217548 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217552 */     GIR_RootConstrainSelectedInstOperands,
     /* 217553 */     // GIR_Coverage, 6122,
     /* 217553 */     GIR_Done,
     /* 217554 */   // Label 5061: @217554
     /* 217554 */   GIM_Reject,
     /* 217555 */ // Label 5059: @217555
     /* 217555 */ GIM_Reject,
     /* 217556 */ // Label 5046: @217556
     /* 217556 */ GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(218014),
     /* 217561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 217564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217567 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(217632), // Rule ID 1019 //
     /* 217572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 217575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 217579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 217583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217587 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217590 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217594 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 217602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217604 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217611 */     // (strict_fdiv:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp32m),
     /* 217614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217616 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 217618 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217622 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 217625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217630 */     GIR_RootConstrainSelectedInstOperands,
     /* 217631 */     // GIR_Coverage, 1019,
     /* 217631 */     GIR_EraseRootFromParent_Done,
     /* 217632 */   // Label 5063: @217632
     /* 217632 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(217697), // Rule ID 997 //
     /* 217637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 217640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 217644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 217648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217656 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217659 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217663 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217676 */     // (strict_fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32m),
     /* 217679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217681 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217683 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217687 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 217690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217695 */     GIR_RootConstrainSelectedInstOperands,
     /* 217696 */     // GIR_Coverage, 997,
     /* 217696 */     GIR_EraseRootFromParent_Done,
     /* 217697 */   // Label 5064: @217697
     /* 217697 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(217759), // Rule ID 2279 //
     /* 217702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 217705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 217709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 217713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217721 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217724 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217728 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217734 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217741 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSrm),
     /* 217744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217746 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217748 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217757 */     GIR_RootConstrainSelectedInstOperands,
     /* 217758 */     // GIR_Coverage, 2279,
     /* 217758 */     GIR_EraseRootFromParent_Done,
     /* 217759 */   // Label 5065: @217759
     /* 217759 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(217821), // Rule ID 2287 //
     /* 217764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 217767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 217771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 217775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217783 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217786 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217790 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217796 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217803 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSSrm),
     /* 217806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217808 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217810 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217819 */     GIR_RootConstrainSelectedInstOperands,
     /* 217820 */     // GIR_Coverage, 2287,
     /* 217820 */     GIR_EraseRootFromParent_Done,
     /* 217821 */   // Label 5066: @217821
     /* 217821 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(217883), // Rule ID 6086 //
     /* 217826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 217829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 217833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 217837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217845 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217848 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217852 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217865 */     // (strict_fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrm),
     /* 217868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217870 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217872 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217881 */     GIR_RootConstrainSelectedInstOperands,
     /* 217882 */     // GIR_Coverage, 6086,
     /* 217882 */     GIR_EraseRootFromParent_Done,
     /* 217883 */   // Label 5067: @217883
     /* 217883 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(217920), // Rule ID 903 //
     /* 217888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 217891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 217895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 217899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 217903 */     // (strict_fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (DIV_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 217903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32),
     /* 217908 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 217914 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 217918 */     GIR_RootConstrainSelectedInstOperands,
     /* 217919 */     // GIR_Coverage, 903,
     /* 217919 */     GIR_Done,
     /* 217920 */   // Label 5068: @217920
     /* 217920 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(217951), // Rule ID 2277 //
     /* 217925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 217928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 217932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 217936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 217940 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VDIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 217940 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSrr),
     /* 217945 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217949 */     GIR_RootConstrainSelectedInstOperands,
     /* 217950 */     // GIR_Coverage, 2277,
     /* 217950 */     GIR_Done,
     /* 217951 */   // Label 5069: @217951
     /* 217951 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(217982), // Rule ID 2285 //
     /* 217956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 217959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 217963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 217967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 217971 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (DIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 217971 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSSrr),
     /* 217976 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217980 */     GIR_RootConstrainSelectedInstOperands,
     /* 217981 */     // GIR_Coverage, 2285,
     /* 217981 */     GIR_Done,
     /* 217982 */   // Label 5070: @217982
     /* 217982 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(218013), // Rule ID 6084 //
     /* 217987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 217990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 217994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 217998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 218002 */     // (strict_fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VDIVSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 218002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrr),
     /* 218007 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218011 */     GIR_RootConstrainSelectedInstOperands,
     /* 218012 */     // GIR_Coverage, 6084,
     /* 218012 */     GIR_Done,
     /* 218013 */   // Label 5071: @218013
     /* 218013 */   GIM_Reject,
     /* 218014 */ // Label 5062: @218014
     /* 218014 */ GIM_Reject,
     /* 218015 */ // Label 5047: @218015
     /* 218015 */ GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(218617),
     /* 218020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 218023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218026 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(218091), // Rule ID 1021 //
     /* 218031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 218034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 218042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218046 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218049 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218053 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218063 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218070 */     // (strict_fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m),
     /* 218073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218075 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 218077 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218081 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218089 */     GIR_RootConstrainSelectedInstOperands,
     /* 218090 */     // GIR_Coverage, 1021,
     /* 218090 */     GIR_EraseRootFromParent_Done,
     /* 218091 */   // Label 5073: @218091
     /* 218091 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(218163), // Rule ID 1023 //
     /* 218096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 218099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 218107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218111 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218114 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218118 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 218125 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218142 */     // (strict_fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m32),
     /* 218145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218147 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 218149 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218153 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218161 */     GIR_RootConstrainSelectedInstOperands,
     /* 218162 */     // GIR_Coverage, 1023,
     /* 218162 */     GIR_EraseRootFromParent_Done,
     /* 218163 */   // Label 5074: @218163
     /* 218163 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(218228), // Rule ID 999 //
     /* 218168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 218171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218187 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218190 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218194 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218207 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m),
     /* 218210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218212 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218214 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218226 */     GIR_RootConstrainSelectedInstOperands,
     /* 218227 */     // GIR_Coverage, 999,
     /* 218227 */     GIR_EraseRootFromParent_Done,
     /* 218228 */   // Label 5075: @218228
     /* 218228 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(218300), // Rule ID 1001 //
     /* 218233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 218236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218252 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218255 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218259 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 218266 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218279 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m32),
     /* 218282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218284 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218286 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218290 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218298 */     GIR_RootConstrainSelectedInstOperands,
     /* 218299 */     // GIR_Coverage, 1001,
     /* 218299 */     GIR_EraseRootFromParent_Done,
     /* 218300 */   // Label 5076: @218300
     /* 218300 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(218362), // Rule ID 2283 //
     /* 218305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 218308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 218312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 218316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218324 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218327 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218331 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218344 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDrm),
     /* 218347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218349 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218351 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218360 */     GIR_RootConstrainSelectedInstOperands,
     /* 218361 */     // GIR_Coverage, 2283,
     /* 218361 */     GIR_EraseRootFromParent_Done,
     /* 218362 */   // Label 5077: @218362
     /* 218362 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(218424), // Rule ID 2291 //
     /* 218367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 218370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 218374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 218378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218386 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218389 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218393 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218406 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSDrm),
     /* 218409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218411 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218413 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218422 */     GIR_RootConstrainSelectedInstOperands,
     /* 218423 */     // GIR_Coverage, 2291,
     /* 218423 */     GIR_EraseRootFromParent_Done,
     /* 218424 */   // Label 5078: @218424
     /* 218424 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(218486), // Rule ID 6105 //
     /* 218429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 218432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 218436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 218440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218448 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218451 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218455 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218468 */     // (strict_fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrm),
     /* 218471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218473 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218475 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218484 */     GIR_RootConstrainSelectedInstOperands,
     /* 218485 */     // GIR_Coverage, 6105,
     /* 218485 */     GIR_EraseRootFromParent_Done,
     /* 218486 */   // Label 5079: @218486
     /* 218486 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(218523), // Rule ID 905 //
     /* 218491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 218494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 218506 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (DIV_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 218506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64),
     /* 218511 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 218517 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 218521 */     GIR_RootConstrainSelectedInstOperands,
     /* 218522 */     // GIR_Coverage, 905,
     /* 218522 */     GIR_Done,
     /* 218523 */   // Label 5080: @218523
     /* 218523 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(218554), // Rule ID 2281 //
     /* 218528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 218531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 218535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 218539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 218543 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VDIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 218543 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDrr),
     /* 218548 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218552 */     GIR_RootConstrainSelectedInstOperands,
     /* 218553 */     // GIR_Coverage, 2281,
     /* 218553 */     GIR_Done,
     /* 218554 */   // Label 5081: @218554
     /* 218554 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(218585), // Rule ID 2289 //
     /* 218559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 218562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 218566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 218570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 218574 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (DIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 218574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSDrr),
     /* 218579 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218583 */     GIR_RootConstrainSelectedInstOperands,
     /* 218584 */     // GIR_Coverage, 2289,
     /* 218584 */     GIR_Done,
     /* 218585 */   // Label 5082: @218585
     /* 218585 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(218616), // Rule ID 6103 //
     /* 218590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 218593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 218597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 218601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 218605 */     // (strict_fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VDIVSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 218605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrr),
     /* 218610 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218614 */     GIR_RootConstrainSelectedInstOperands,
     /* 218615 */     // GIR_Coverage, 6103,
     /* 218615 */     GIR_Done,
     /* 218616 */   // Label 5083: @218616
     /* 218616 */   GIM_Reject,
     /* 218617 */ // Label 5072: @218617
     /* 218617 */ GIM_Reject,
     /* 218618 */ // Label 5048: @218618
     /* 218618 */ GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(218939),
     /* 218623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 218626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 218629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 218633 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(218701), // Rule ID 1025 //
     /* 218638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 218641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 218645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218649 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218652 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218656 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 218663 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 218671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218673 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218680 */     // (strict_fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m32),
     /* 218683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218685 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 218687 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218691 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218699 */     GIR_RootConstrainSelectedInstOperands,
     /* 218700 */     // GIR_Coverage, 1025,
     /* 218700 */     GIR_EraseRootFromParent_Done,
     /* 218701 */   // Label 5085: @218701
     /* 218701 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(218769), // Rule ID 1027 //
     /* 218706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 218709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 218713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218717 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218720 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218724 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 218731 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 218739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218748 */     // (strict_fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m64),
     /* 218751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218753 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 218755 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218767 */     GIR_RootConstrainSelectedInstOperands,
     /* 218768 */     // GIR_Coverage, 1027,
     /* 218768 */     GIR_EraseRootFromParent_Done,
     /* 218769 */   // Label 5086: @218769
     /* 218769 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(218837), // Rule ID 1003 //
     /* 218774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 218777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 218781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218789 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218792 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218796 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 218803 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218816 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m32),
     /* 218819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218821 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218823 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218827 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218835 */     GIR_RootConstrainSelectedInstOperands,
     /* 218836 */     // GIR_Coverage, 1003,
     /* 218836 */     GIR_EraseRootFromParent_Done,
     /* 218837 */   // Label 5087: @218837
     /* 218837 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(218905), // Rule ID 1005 //
     /* 218842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 218845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 218849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218857 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218860 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218864 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 218871 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218884 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (DIV_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m64),
     /* 218887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218889 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218891 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218895 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218903 */     GIR_RootConstrainSelectedInstOperands,
     /* 218904 */     // GIR_Coverage, 1005,
     /* 218904 */     GIR_EraseRootFromParent_Done,
     /* 218905 */   // Label 5088: @218905
     /* 218905 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(218938), // Rule ID 907 //
     /* 218910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 218913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 218917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 218921 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (DIV_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 218921 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80),
     /* 218926 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 218932 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 218936 */     GIR_RootConstrainSelectedInstOperands,
     /* 218937 */     // GIR_Coverage, 907,
     /* 218937 */     GIR_Done,
     /* 218938 */   // Label 5089: @218938
     /* 218938 */   GIM_Reject,
     /* 218939 */ // Label 5084: @218939
     /* 218939 */ GIM_Reject,
     /* 218940 */ // Label 5049: @218940
     /* 218940 */ GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(219169),
     /* 218945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 218948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 218951 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(219013), // Rule ID 2259 //
     /* 218956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 218959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 218963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 218967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218975 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218978 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218982 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218995 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDrm),
     /* 218998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219000 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219002 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219011 */     GIR_RootConstrainSelectedInstOperands,
     /* 219012 */     // GIR_Coverage, 2259,
     /* 219012 */     GIR_EraseRootFromParent_Done,
     /* 219013 */   // Label 5091: @219013
     /* 219013 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(219075), // Rule ID 6658 //
     /* 219018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 219021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219037 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219040 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219044 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219057 */     // (strict_fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rm),
     /* 219060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219062 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219064 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219073 */     GIR_RootConstrainSelectedInstOperands,
     /* 219074 */     // GIR_Coverage, 6658,
     /* 219074 */     GIR_EraseRootFromParent_Done,
     /* 219075 */   // Label 5092: @219075
     /* 219075 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(219106), // Rule ID 2257 //
     /* 219080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 219083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219095 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VDIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 219095 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDrr),
     /* 219100 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219104 */     GIR_RootConstrainSelectedInstOperands,
     /* 219105 */     // GIR_Coverage, 2257,
     /* 219105 */     GIR_Done,
     /* 219106 */   // Label 5093: @219106
     /* 219106 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(219137), // Rule ID 2273 //
     /* 219111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 219114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219126 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (DIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 219126 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPDrr),
     /* 219131 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219135 */     GIR_RootConstrainSelectedInstOperands,
     /* 219136 */     // GIR_Coverage, 2273,
     /* 219136 */     GIR_Done,
     /* 219137 */   // Label 5094: @219137
     /* 219137 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(219168), // Rule ID 6654 //
     /* 219142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 219145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219157 */     // (strict_fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VDIVPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 219157 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rr),
     /* 219162 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219166 */     GIR_RootConstrainSelectedInstOperands,
     /* 219167 */     // GIR_Coverage, 6654,
     /* 219167 */     GIR_Done,
     /* 219168 */   // Label 5095: @219168
     /* 219168 */   GIM_Reject,
     /* 219169 */ // Label 5090: @219169
     /* 219169 */ GIM_Reject,
     /* 219170 */ // Label 5050: @219170
     /* 219170 */ GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(219399),
     /* 219175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 219178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219181 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(219243), // Rule ID 2255 //
     /* 219186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 219189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219205 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219208 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219212 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219218 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219225 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSrm),
     /* 219228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219230 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219232 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219241 */     GIR_RootConstrainSelectedInstOperands,
     /* 219242 */     // GIR_Coverage, 2255,
     /* 219242 */     GIR_EraseRootFromParent_Done,
     /* 219243 */   // Label 5097: @219243
     /* 219243 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(219305), // Rule ID 6634 //
     /* 219248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 219251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219267 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219270 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219274 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219280 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219287 */     // (strict_fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rm),
     /* 219290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219292 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219294 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219303 */     GIR_RootConstrainSelectedInstOperands,
     /* 219304 */     // GIR_Coverage, 6634,
     /* 219304 */     GIR_EraseRootFromParent_Done,
     /* 219305 */   // Label 5098: @219305
     /* 219305 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(219336), // Rule ID 2253 //
     /* 219310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 219313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219325 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VDIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 219325 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSrr),
     /* 219330 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219334 */     GIR_RootConstrainSelectedInstOperands,
     /* 219335 */     // GIR_Coverage, 2253,
     /* 219335 */     GIR_Done,
     /* 219336 */   // Label 5099: @219336
     /* 219336 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(219367), // Rule ID 2269 //
     /* 219341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 219344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 219356 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (DIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 219356 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPSrr),
     /* 219361 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219365 */     GIR_RootConstrainSelectedInstOperands,
     /* 219366 */     // GIR_Coverage, 2269,
     /* 219366 */     GIR_Done,
     /* 219367 */   // Label 5100: @219367
     /* 219367 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(219398), // Rule ID 6630 //
     /* 219372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 219375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219387 */     // (strict_fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VDIVPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 219387 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rr),
     /* 219392 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219396 */     GIR_RootConstrainSelectedInstOperands,
     /* 219397 */     // GIR_Coverage, 6630,
     /* 219397 */     GIR_Done,
     /* 219398 */   // Label 5101: @219398
     /* 219398 */   GIM_Reject,
     /* 219399 */ // Label 5096: @219399
     /* 219399 */ GIM_Reject,
     /* 219400 */ // Label 5051: @219400
     /* 219400 */ GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(219598),
     /* 219405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 219408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 219411 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(219473), // Rule ID 2267 //
     /* 219416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 219419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 219423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 219427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219435 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219438 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219442 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219448 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219455 */     // (strict_fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrm),
     /* 219458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219460 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219462 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219471 */     GIR_RootConstrainSelectedInstOperands,
     /* 219472 */     // GIR_Coverage, 2267,
     /* 219472 */     GIR_EraseRootFromParent_Done,
     /* 219473 */   // Label 5103: @219473
     /* 219473 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(219535), // Rule ID 6670 //
     /* 219478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 219481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 219485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 219489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219497 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219500 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219504 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219517 */     // (strict_fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rm),
     /* 219520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219522 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219524 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219533 */     GIR_RootConstrainSelectedInstOperands,
     /* 219534 */     // GIR_Coverage, 6670,
     /* 219534 */     GIR_EraseRootFromParent_Done,
     /* 219535 */   // Label 5104: @219535
     /* 219535 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(219566), // Rule ID 2265 //
     /* 219540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 219543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 219547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 219551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 219555 */     // (strict_fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VDIVPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 219555 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrr),
     /* 219560 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219564 */     GIR_RootConstrainSelectedInstOperands,
     /* 219565 */     // GIR_Coverage, 2265,
     /* 219565 */     GIR_Done,
     /* 219566 */   // Label 5105: @219566
     /* 219566 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(219597), // Rule ID 6666 //
     /* 219571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 219574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 219578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 219582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 219586 */     // (strict_fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VDIVPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 219586 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rr),
     /* 219591 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219595 */     GIR_RootConstrainSelectedInstOperands,
     /* 219596 */     // GIR_Coverage, 6666,
     /* 219596 */     GIR_Done,
     /* 219597 */   // Label 5106: @219597
     /* 219597 */   GIM_Reject,
     /* 219598 */ // Label 5102: @219598
     /* 219598 */ GIM_Reject,
     /* 219599 */ // Label 5052: @219599
     /* 219599 */ GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(219696),
     /* 219604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 219610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219618 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(219672), // Rule ID 6694 //
     /* 219623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 219626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219634 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219637 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219641 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219654 */     // (strict_fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rm),
     /* 219657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219659 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219661 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219670 */     GIR_RootConstrainSelectedInstOperands,
     /* 219671 */     // GIR_Coverage, 6694,
     /* 219671 */     GIR_EraseRootFromParent_Done,
     /* 219672 */   // Label 5108: @219672
     /* 219672 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(219695), // Rule ID 6690 //
     /* 219677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 219680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 219684 */     // (strict_fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VDIVPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 219684 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rr),
     /* 219689 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219693 */     GIR_RootConstrainSelectedInstOperands,
     /* 219694 */     // GIR_Coverage, 6690,
     /* 219694 */     GIR_Done,
     /* 219695 */   // Label 5109: @219695
     /* 219695 */   GIM_Reject,
     /* 219696 */ // Label 5107: @219696
     /* 219696 */ GIM_Reject,
     /* 219697 */ // Label 5053: @219697
     /* 219697 */ GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(219895),
     /* 219702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 219705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 219708 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(219770), // Rule ID 2263 //
     /* 219713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 219716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 219720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 219724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219732 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219735 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219739 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219752 */     // (strict_fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrm),
     /* 219755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219757 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219759 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219768 */     GIR_RootConstrainSelectedInstOperands,
     /* 219769 */     // GIR_Coverage, 2263,
     /* 219769 */     GIR_EraseRootFromParent_Done,
     /* 219770 */   // Label 5111: @219770
     /* 219770 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(219832), // Rule ID 6646 //
     /* 219775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 219778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 219782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 219786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219794 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219797 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219801 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219814 */     // (strict_fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rm),
     /* 219817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219819 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219821 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219830 */     GIR_RootConstrainSelectedInstOperands,
     /* 219831 */     // GIR_Coverage, 6646,
     /* 219831 */     GIR_EraseRootFromParent_Done,
     /* 219832 */   // Label 5112: @219832
     /* 219832 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(219863), // Rule ID 2261 //
     /* 219837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 219840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 219844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 219848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 219852 */     // (strict_fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VDIVPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 219852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrr),
     /* 219857 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219861 */     GIR_RootConstrainSelectedInstOperands,
     /* 219862 */     // GIR_Coverage, 2261,
     /* 219862 */     GIR_Done,
     /* 219863 */   // Label 5113: @219863
     /* 219863 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(219894), // Rule ID 6642 //
     /* 219868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 219871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 219875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 219879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 219883 */     // (strict_fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VDIVPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 219883 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rr),
     /* 219888 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219892 */     GIR_RootConstrainSelectedInstOperands,
     /* 219893 */     // GIR_Coverage, 6642,
     /* 219893 */     GIR_Done,
     /* 219894 */   // Label 5114: @219894
     /* 219894 */   GIM_Reject,
     /* 219895 */ // Label 5110: @219895
     /* 219895 */ GIM_Reject,
     /* 219896 */ // Label 5054: @219896
     /* 219896 */ GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(219993),
     /* 219901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 219904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 219907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 219911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 219915 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(219969), // Rule ID 6622 //
     /* 219920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 219923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219931 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219934 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219938 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219944 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219951 */     // (strict_fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrm),
     /* 219954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219956 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219958 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219967 */     GIR_RootConstrainSelectedInstOperands,
     /* 219968 */     // GIR_Coverage, 6622,
     /* 219968 */     GIR_EraseRootFromParent_Done,
     /* 219969 */   // Label 5116: @219969
     /* 219969 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(219992), // Rule ID 6618 //
     /* 219974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 219977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 219981 */     // (strict_fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VDIVPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 219981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrr),
     /* 219986 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219990 */     GIR_RootConstrainSelectedInstOperands,
     /* 219991 */     // GIR_Coverage, 6618,
     /* 219991 */     GIR_Done,
     /* 219992 */   // Label 5117: @219992
     /* 219992 */   GIM_Reject,
     /* 219993 */ // Label 5115: @219993
     /* 219993 */ GIM_Reject,
     /* 219994 */ // Label 5055: @219994
     /* 219994 */ GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(220091),
     /* 219999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 220002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 220005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220013 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(220067), // Rule ID 6706 //
     /* 220018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 220021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220029 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220032 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220036 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220049 */     // (strict_fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rm),
     /* 220052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220054 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220056 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220065 */     GIR_RootConstrainSelectedInstOperands,
     /* 220066 */     // GIR_Coverage, 6706,
     /* 220066 */     GIR_EraseRootFromParent_Done,
     /* 220067 */   // Label 5119: @220067
     /* 220067 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(220090), // Rule ID 6702 //
     /* 220072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 220075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 220079 */     // (strict_fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VDIVPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 220079 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rr),
     /* 220084 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220088 */     GIR_RootConstrainSelectedInstOperands,
     /* 220089 */     // GIR_Coverage, 6702,
     /* 220089 */     GIR_Done,
     /* 220090 */   // Label 5120: @220090
     /* 220090 */   GIM_Reject,
     /* 220091 */ // Label 5118: @220091
     /* 220091 */ GIM_Reject,
     /* 220092 */ // Label 5056: @220092
     /* 220092 */ GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(220189),
     /* 220097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 220100 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 220103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220111 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(220165), // Rule ID 6610 //
     /* 220116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220127 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220130 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220134 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220147 */     // (strict_fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrm),
     /* 220150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220152 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220154 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220163 */     GIR_RootConstrainSelectedInstOperands,
     /* 220164 */     // GIR_Coverage, 6610,
     /* 220164 */     GIR_EraseRootFromParent_Done,
     /* 220165 */   // Label 5122: @220165
     /* 220165 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(220188), // Rule ID 6606 //
     /* 220170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220177 */     // (strict_fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VDIVPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 220177 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrr),
     /* 220182 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220186 */     GIR_RootConstrainSelectedInstOperands,
     /* 220187 */     // GIR_Coverage, 6606,
     /* 220187 */     GIR_Done,
     /* 220188 */   // Label 5123: @220188
     /* 220188 */   GIM_Reject,
     /* 220189 */ // Label 5121: @220189
     /* 220189 */ GIM_Reject,
     /* 220190 */ // Label 5057: @220190
     /* 220190 */ GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(220287),
     /* 220195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 220198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 220201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220209 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(220263), // Rule ID 6682 //
     /* 220214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 220217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220225 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220228 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220232 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220238 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220245 */     // (strict_fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrm),
     /* 220248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220250 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220252 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220261 */     GIR_RootConstrainSelectedInstOperands,
     /* 220262 */     // GIR_Coverage, 6682,
     /* 220262 */     GIR_EraseRootFromParent_Done,
     /* 220263 */   // Label 5125: @220263
     /* 220263 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(220286), // Rule ID 6678 //
     /* 220268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 220271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 220275 */     // (strict_fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VDIVPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 220275 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrr),
     /* 220280 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220284 */     GIR_RootConstrainSelectedInstOperands,
     /* 220285 */     // GIR_Coverage, 6678,
     /* 220285 */     GIR_Done,
     /* 220286 */   // Label 5126: @220286
     /* 220286 */   GIM_Reject,
     /* 220287 */ // Label 5124: @220287
     /* 220287 */ GIM_Reject,
     /* 220288 */ // Label 5058: @220288
     /* 220288 */ GIM_Reject,
     /* 220289 */ // Label 72: @220289
     /* 220289 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5139*/ GIMT_Encode4(226276),
     /* 220300 */ /*GILLT_s16*//*Label 5127*/ GIMT_Encode4(220384),
     /* 220304 */ /*GILLT_s32*//*Label 5128*/ GIMT_Encode4(220629),
     /* 220308 */ /*GILLT_s64*//*Label 5129*/ GIMT_Encode4(221366), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 220324 */ /*GILLT_v2s64*//*Label 5130*/ GIMT_Encode4(222103), GIMT_Encode4(0),
     /* 220332 */ /*GILLT_v4s32*//*Label 5131*/ GIMT_Encode4(222840),
     /* 220336 */ /*GILLT_v4s64*//*Label 5132*/ GIMT_Encode4(223577), GIMT_Encode4(0),
     /* 220344 */ /*GILLT_v8s16*//*Label 5133*/ GIMT_Encode4(224314),
     /* 220348 */ /*GILLT_v8s32*//*Label 5134*/ GIMT_Encode4(224559),
     /* 220352 */ /*GILLT_v8s64*//*Label 5135*/ GIMT_Encode4(225296), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 220364 */ /*GILLT_v16s16*//*Label 5136*/ GIMT_Encode4(225541),
     /* 220368 */ /*GILLT_v16s32*//*Label 5137*/ GIMT_Encode4(225786), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 220380 */ /*GILLT_v32s16*//*Label 5138*/ GIMT_Encode4(226031),
     /* 220384 */ // Label 5127: @220384
     /* 220384 */ GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(220628),
     /* 220389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 220392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 220395 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 220398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 220402 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(220466), // Rule ID 10156 //
     /* 220407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 220410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220418 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220421 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220425 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 220433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 220437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220439 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220446 */     // (strict_fma:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VFMADD132SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 220446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SHZm),
     /* 220449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220451 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220453 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 220455 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 220459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220464 */     GIR_RootConstrainSelectedInstOperands,
     /* 220465 */     // GIR_Coverage, 10156,
     /* 220465 */     GIR_EraseRootFromParent_Done,
     /* 220466 */   // Label 5141: @220466
     /* 220466 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(220530), // Rule ID 10154 //
     /* 220471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 220474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 220478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220486 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220489 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220493 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 220501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220510 */     // (strict_fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VFMADD231SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 220510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SHZm),
     /* 220513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220515 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 220517 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 220519 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 220523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220528 */     GIR_RootConstrainSelectedInstOperands,
     /* 220529 */     // GIR_Coverage, 10154,
     /* 220529 */     GIR_EraseRootFromParent_Done,
     /* 220530 */   // Label 5142: @220530
     /* 220530 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(220594), // Rule ID 10151 //
     /* 220535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 220538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 220542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 220546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 220550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220554 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220557 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220561 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220574 */     // (strict_fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 220574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZm),
     /* 220577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220579 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220581 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 220583 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 220587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220592 */     GIR_RootConstrainSelectedInstOperands,
     /* 220593 */     // GIR_Coverage, 10151,
     /* 220593 */     GIR_EraseRootFromParent_Done,
     /* 220594 */   // Label 5143: @220594
     /* 220594 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(220627), // Rule ID 10149 //
     /* 220599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 220602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 220606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 220610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 220614 */     // (strict_fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src3)  =>  (VFMADD213SHZr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src3)
     /* 220614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZr),
     /* 220617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220619 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220621 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 220623 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 220625 */     GIR_RootConstrainSelectedInstOperands,
     /* 220626 */     // GIR_Coverage, 10149,
     /* 220626 */     GIR_EraseRootFromParent_Done,
     /* 220627 */   // Label 5144: @220627
     /* 220627 */   GIM_Reject,
     /* 220628 */ // Label 5140: @220628
     /* 220628 */ GIM_Reject,
     /* 220629 */ // Label 5128: @220629
     /* 220629 */ GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(221365),
     /* 220634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 220637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 220640 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 220643 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(220711), // Rule ID 1302 //
     /* 220648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 220651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 220655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220663 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220666 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220670 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 220678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 220682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220684 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220691 */     // (strict_fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VFMADD132SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 220691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSm),
     /* 220694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220696 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220698 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 220700 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 220704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220709 */     GIR_RootConstrainSelectedInstOperands,
     /* 220710 */     // GIR_Coverage, 1302,
     /* 220710 */     GIR_EraseRootFromParent_Done,
     /* 220711 */   // Label 5146: @220711
     /* 220711 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(220779), // Rule ID 10138 //
     /* 220716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 220723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220731 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220734 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220738 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 220746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 220750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220752 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220759 */     // (strict_fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VFMADD132SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 220759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSZm),
     /* 220762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220764 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220766 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 220768 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 220772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220777 */     GIR_RootConstrainSelectedInstOperands,
     /* 220778 */     // GIR_Coverage, 10138,
     /* 220778 */     GIR_EraseRootFromParent_Done,
     /* 220779 */   // Label 5147: @220779
     /* 220779 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(220847), // Rule ID 23277 //
     /* 220784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 220787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 220791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220799 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220802 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220806 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 220814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 220818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220820 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220827 */     // (strict_fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 220827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 220830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220832 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220834 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220838 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 220840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220845 */     GIR_RootConstrainSelectedInstOperands,
     /* 220846 */     // GIR_Coverage, 23277,
     /* 220846 */     GIR_EraseRootFromParent_Done,
     /* 220847 */   // Label 5148: @220847
     /* 220847 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(220915), // Rule ID 1300 //
     /* 220852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 220855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 220859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 220863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220871 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220874 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220878 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 220886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220895 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VFMADD231SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 220895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSm),
     /* 220898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220900 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 220902 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 220904 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 220908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220913 */     GIR_RootConstrainSelectedInstOperands,
     /* 220914 */     // GIR_Coverage, 1300,
     /* 220914 */     GIR_EraseRootFromParent_Done,
     /* 220915 */   // Label 5149: @220915
     /* 220915 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(220983), // Rule ID 1364 //
     /* 220920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 220923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 220927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 220931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220939 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220942 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220946 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 220954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220963 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 220963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 220966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220968 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220970 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220974 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 220976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220981 */     GIR_RootConstrainSelectedInstOperands,
     /* 220982 */     // GIR_Coverage, 1364,
     /* 220982 */     GIR_EraseRootFromParent_Done,
     /* 220983 */   // Label 5150: @220983
     /* 220983 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(221051), // Rule ID 10136 //
     /* 220988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 220995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 220999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221007 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221010 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221014 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221024 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221031 */     // (strict_fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VFMADD231SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSZm),
     /* 221034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221036 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 221038 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221040 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221049 */     GIR_RootConstrainSelectedInstOperands,
     /* 221050 */     // GIR_Coverage, 10136,
     /* 221050 */     GIR_EraseRootFromParent_Done,
     /* 221051 */   // Label 5151: @221051
     /* 221051 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(221119), // Rule ID 1298 //
     /* 221056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 221059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 221075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221079 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221082 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221086 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221099 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSm),
     /* 221102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221104 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221106 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221108 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221117 */     GIR_RootConstrainSelectedInstOperands,
     /* 221118 */     // GIR_Coverage, 1298,
     /* 221118 */     GIR_EraseRootFromParent_Done,
     /* 221119 */   // Label 5152: @221119
     /* 221119 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(221187), // Rule ID 1362 //
     /* 221124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 221127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 221143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221147 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221150 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221154 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221167 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSS4rm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rm),
     /* 221170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221172 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221174 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 221176 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221185 */     GIR_RootConstrainSelectedInstOperands,
     /* 221186 */     // GIR_Coverage, 1362,
     /* 221186 */     GIR_EraseRootFromParent_Done,
     /* 221187 */   // Label 5153: @221187
     /* 221187 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(221255), // Rule ID 10133 //
     /* 221192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 221195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 221211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221215 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221218 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221222 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221228 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221235 */     // (strict_fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZm),
     /* 221238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221240 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221242 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221244 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221253 */     GIR_RootConstrainSelectedInstOperands,
     /* 221254 */     // GIR_Coverage, 10133,
     /* 221254 */     GIR_EraseRootFromParent_Done,
     /* 221255 */   // Label 5154: @221255
     /* 221255 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(221292), // Rule ID 1296 //
     /* 221260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 221263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221279 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADD213SSr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 221279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSr),
     /* 221282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221284 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221286 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221288 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 221290 */     GIR_RootConstrainSelectedInstOperands,
     /* 221291 */     // GIR_Coverage, 1296,
     /* 221291 */     GIR_EraseRootFromParent_Done,
     /* 221292 */   // Label 5155: @221292
     /* 221292 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(221327), // Rule ID 1360 //
     /* 221297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 221300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 221316 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4rr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 221316 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rr),
     /* 221321 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 221325 */     GIR_RootConstrainSelectedInstOperands,
     /* 221326 */     // GIR_Coverage, 1360,
     /* 221326 */     GIR_Done,
     /* 221327 */   // Label 5156: @221327
     /* 221327 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(221364), // Rule ID 10131 //
     /* 221332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 221335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 221351 */     // (strict_fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src3)  =>  (VFMADD213SSZr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src3)
     /* 221351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZr),
     /* 221354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221356 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221358 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221360 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 221362 */     GIR_RootConstrainSelectedInstOperands,
     /* 221363 */     // GIR_Coverage, 10131,
     /* 221363 */     GIR_EraseRootFromParent_Done,
     /* 221364 */   // Label 5157: @221364
     /* 221364 */   GIM_Reject,
     /* 221365 */ // Label 5145: @221365
     /* 221365 */ GIM_Reject,
     /* 221366 */ // Label 5129: @221366
     /* 221366 */ GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(222102),
     /* 221371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 221374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 221377 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 221380 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(221448), // Rule ID 1310 //
     /* 221385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 221388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 221392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221400 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221403 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221407 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 221415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 221419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221421 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221428 */     // (strict_fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VFMADD132SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDm),
     /* 221431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221433 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221435 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 221437 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221446 */     GIR_RootConstrainSelectedInstOperands,
     /* 221447 */     // GIR_Coverage, 1310,
     /* 221447 */     GIR_EraseRootFromParent_Done,
     /* 221448 */   // Label 5159: @221448
     /* 221448 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(221516), // Rule ID 10147 //
     /* 221453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 221456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 221460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221468 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221471 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221475 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 221483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 221487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221496 */     // (strict_fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VFMADD132SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDZm),
     /* 221499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221501 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221503 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 221505 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221514 */     GIR_RootConstrainSelectedInstOperands,
     /* 221515 */     // GIR_Coverage, 10147,
     /* 221515 */     GIR_EraseRootFromParent_Done,
     /* 221516 */   // Label 5160: @221516
     /* 221516 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(221584), // Rule ID 23305 //
     /* 221521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 221524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 221528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221536 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221539 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221543 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 221551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 221555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221564 */     // (strict_fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 221564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 221567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221569 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221575 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 221577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221582 */     GIR_RootConstrainSelectedInstOperands,
     /* 221583 */     // GIR_Coverage, 23305,
     /* 221583 */     GIR_EraseRootFromParent_Done,
     /* 221584 */   // Label 5161: @221584
     /* 221584 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(221652), // Rule ID 1308 //
     /* 221589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 221592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 221596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 221600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221608 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221611 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221615 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 221623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221632 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VFMADD231SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDm),
     /* 221635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221637 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 221639 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221641 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221650 */     GIR_RootConstrainSelectedInstOperands,
     /* 221651 */     // GIR_Coverage, 1308,
     /* 221651 */     GIR_EraseRootFromParent_Done,
     /* 221652 */   // Label 5162: @221652
     /* 221652 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(221720), // Rule ID 1448 //
     /* 221657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 221660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 221664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 221668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221676 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221679 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221683 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 221691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221700 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 221700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 221703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221705 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221707 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221711 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 221713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221718 */     GIR_RootConstrainSelectedInstOperands,
     /* 221719 */     // GIR_Coverage, 1448,
     /* 221719 */     GIR_EraseRootFromParent_Done,
     /* 221720 */   // Label 5163: @221720
     /* 221720 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(221788), // Rule ID 10145 //
     /* 221725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 221728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 221732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 221736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221744 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221747 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221751 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 221759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221761 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221768 */     // (strict_fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VFMADD231SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDZm),
     /* 221771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221773 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 221775 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221777 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221786 */     GIR_RootConstrainSelectedInstOperands,
     /* 221787 */     // GIR_Coverage, 10145,
     /* 221787 */     GIR_EraseRootFromParent_Done,
     /* 221788 */   // Label 5164: @221788
     /* 221788 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(221856), // Rule ID 1306 //
     /* 221793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 221796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 221800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 221804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 221808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 221812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221816 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221819 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221823 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221829 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221836 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDm),
     /* 221839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221841 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221843 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221854 */     GIR_RootConstrainSelectedInstOperands,
     /* 221855 */     // GIR_Coverage, 1306,
     /* 221855 */     GIR_EraseRootFromParent_Done,
     /* 221856 */   // Label 5165: @221856
     /* 221856 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(221924), // Rule ID 1446 //
     /* 221861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 221864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 221868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 221872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 221876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 221880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221884 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221887 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221891 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221904 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSD4rm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rm),
     /* 221907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221909 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221911 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 221913 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221922 */     GIR_RootConstrainSelectedInstOperands,
     /* 221923 */     // GIR_Coverage, 1446,
     /* 221923 */     GIR_EraseRootFromParent_Done,
     /* 221924 */   // Label 5166: @221924
     /* 221924 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(221992), // Rule ID 10142 //
     /* 221929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 221932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 221936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 221940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 221944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 221948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221952 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221955 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221959 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221965 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221972 */     // (strict_fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 221972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZm),
     /* 221975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221977 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221979 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 221981 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 221985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221990 */     GIR_RootConstrainSelectedInstOperands,
     /* 221991 */     // GIR_Coverage, 10142,
     /* 221991 */     GIR_EraseRootFromParent_Done,
     /* 221992 */   // Label 5167: @221992
     /* 221992 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(222029), // Rule ID 1304 //
     /* 221997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 222000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222016 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADD213SDr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 222016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDr),
     /* 222019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222021 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222023 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222025 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 222027 */     GIR_RootConstrainSelectedInstOperands,
     /* 222028 */     // GIR_Coverage, 1304,
     /* 222028 */     GIR_EraseRootFromParent_Done,
     /* 222029 */   // Label 5168: @222029
     /* 222029 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(222064), // Rule ID 1444 //
     /* 222034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 222037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 222053 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4rr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 222053 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rr),
     /* 222058 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222062 */     GIR_RootConstrainSelectedInstOperands,
     /* 222063 */     // GIR_Coverage, 1444,
     /* 222063 */     GIR_Done,
     /* 222064 */   // Label 5169: @222064
     /* 222064 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(222101), // Rule ID 10140 //
     /* 222069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 222072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 222088 */     // (strict_fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src3)  =>  (VFMADD213SDZr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src3)
     /* 222088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZr),
     /* 222091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222093 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222095 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222097 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 222099 */     GIR_RootConstrainSelectedInstOperands,
     /* 222100 */     // GIR_Coverage, 10140,
     /* 222100 */     GIR_EraseRootFromParent_Done,
     /* 222101 */   // Label 5170: @222101
     /* 222101 */   GIM_Reject,
     /* 222102 */ // Label 5158: @222102
     /* 222102 */ GIM_Reject,
     /* 222103 */ // Label 5130: @222103
     /* 222103 */ GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(222839),
     /* 222108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 222111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 222114 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 222117 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(222185), // Rule ID 1190 //
     /* 222122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 222125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222137 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222140 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222144 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222158 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222165 */     // (strict_fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDm),
     /* 222168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222170 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222172 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 222174 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222183 */     GIR_RootConstrainSelectedInstOperands,
     /* 222184 */     // GIR_Coverage, 1190,
     /* 222184 */     GIR_EraseRootFromParent_Done,
     /* 222185 */   // Label 5172: @222185
     /* 222185 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(222253), // Rule ID 9679 //
     /* 222190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222205 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222208 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222212 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222233 */     // (strict_fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ128m),
     /* 222236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222238 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222240 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 222242 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222251 */     GIR_RootConstrainSelectedInstOperands,
     /* 222252 */     // GIR_Coverage, 9679,
     /* 222252 */     GIR_EraseRootFromParent_Done,
     /* 222253 */   // Label 5173: @222253
     /* 222253 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(222321), // Rule ID 23313 //
     /* 222258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 222261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222273 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222276 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222280 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222301 */     // (strict_fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 222301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 222304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222306 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222308 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222312 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 222314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222319 */     GIR_RootConstrainSelectedInstOperands,
     /* 222320 */     // GIR_Coverage, 23313,
     /* 222320 */     GIR_EraseRootFromParent_Done,
     /* 222321 */   // Label 5174: @222321
     /* 222321 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(222389), // Rule ID 1188 //
     /* 222326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 222329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222345 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222348 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222352 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222369 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDm),
     /* 222372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222374 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 222376 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222378 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222387 */     GIR_RootConstrainSelectedInstOperands,
     /* 222388 */     // GIR_Coverage, 1188,
     /* 222388 */     GIR_EraseRootFromParent_Done,
     /* 222389 */   // Label 5175: @222389
     /* 222389 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(222457), // Rule ID 1472 //
     /* 222394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 222397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222413 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222416 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222420 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222437 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 222437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 222440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222442 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222444 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222448 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 222450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222455 */     GIR_RootConstrainSelectedInstOperands,
     /* 222456 */     // GIR_Coverage, 1472,
     /* 222456 */     GIR_EraseRootFromParent_Done,
     /* 222457 */   // Label 5176: @222457
     /* 222457 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(222525), // Rule ID 9139 //
     /* 222462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222481 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222484 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222488 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222498 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222505 */     // (strict_fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ128m),
     /* 222508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222510 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 222512 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222514 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222523 */     GIR_RootConstrainSelectedInstOperands,
     /* 222524 */     // GIR_Coverage, 9139,
     /* 222524 */     GIR_EraseRootFromParent_Done,
     /* 222525 */   // Label 5177: @222525
     /* 222525 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(222593), // Rule ID 1186 //
     /* 222530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 222533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 222549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222553 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222556 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222560 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222573 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDm),
     /* 222576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222578 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222580 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222582 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222591 */     GIR_RootConstrainSelectedInstOperands,
     /* 222592 */     // GIR_Coverage, 1186,
     /* 222592 */     GIR_EraseRootFromParent_Done,
     /* 222593 */   // Label 5178: @222593
     /* 222593 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(222661), // Rule ID 1470 //
     /* 222598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 222601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 222617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222621 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222624 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222628 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222634 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222641 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4rm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rm),
     /* 222644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222646 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222648 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 222650 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222659 */     GIR_RootConstrainSelectedInstOperands,
     /* 222660 */     // GIR_Coverage, 1470,
     /* 222660 */     GIR_EraseRootFromParent_Done,
     /* 222661 */   // Label 5179: @222661
     /* 222661 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(222729), // Rule ID 8512 //
     /* 222666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 222685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222689 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222692 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222696 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222702 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222709 */     // (strict_fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128m),
     /* 222712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222714 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222716 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222718 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222727 */     GIR_RootConstrainSelectedInstOperands,
     /* 222728 */     // GIR_Coverage, 8512,
     /* 222728 */     GIR_EraseRootFromParent_Done,
     /* 222729 */   // Label 5180: @222729
     /* 222729 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(222766), // Rule ID 1184 //
     /* 222734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 222737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222753 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 222753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDr),
     /* 222756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222758 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222760 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222762 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 222764 */     GIR_RootConstrainSelectedInstOperands,
     /* 222765 */     // GIR_Coverage, 1184,
     /* 222765 */     GIR_EraseRootFromParent_Done,
     /* 222766 */   // Label 5181: @222766
     /* 222766 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(222801), // Rule ID 1468 //
     /* 222771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 222774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222790 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4rr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 222790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rr),
     /* 222795 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222799 */     GIR_RootConstrainSelectedInstOperands,
     /* 222800 */     // GIR_Coverage, 1468,
     /* 222800 */     GIR_Done,
     /* 222801 */   // Label 5182: @222801
     /* 222801 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(222838), // Rule ID 8508 //
     /* 222806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222825 */     // (strict_fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src3)
     /* 222825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128r),
     /* 222828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222830 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222832 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 222834 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 222836 */     GIR_RootConstrainSelectedInstOperands,
     /* 222837 */     // GIR_Coverage, 8508,
     /* 222837 */     GIR_EraseRootFromParent_Done,
     /* 222838 */   // Label 5183: @222838
     /* 222838 */   GIM_Reject,
     /* 222839 */ // Label 5171: @222839
     /* 222839 */ GIM_Reject,
     /* 222840 */ // Label 5131: @222840
     /* 222840 */ GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(223576),
     /* 222845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 222848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 222851 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 222854 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(222922), // Rule ID 1142 //
     /* 222859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 222862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222874 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222877 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222881 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222895 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222902 */     // (strict_fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSm),
     /* 222905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222907 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222909 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 222911 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222920 */     GIR_RootConstrainSelectedInstOperands,
     /* 222921 */     // GIR_Coverage, 1142,
     /* 222921 */     GIR_EraseRootFromParent_Done,
     /* 222922 */   // Label 5185: @222922
     /* 222922 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(222990), // Rule ID 9647 //
     /* 222927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222942 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222945 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222949 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222970 */     // (strict_fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 222970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ128m),
     /* 222973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222975 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222977 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 222979 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 222983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222988 */     GIR_RootConstrainSelectedInstOperands,
     /* 222989 */     // GIR_Coverage, 9647,
     /* 222989 */     GIR_EraseRootFromParent_Done,
     /* 222990 */   // Label 5186: @222990
     /* 222990 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(223058), // Rule ID 23285 //
     /* 222995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 222998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223010 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223013 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223017 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223031 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223038 */     // (strict_fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 223038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 223041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223043 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223045 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223049 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 223051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223056 */     GIR_RootConstrainSelectedInstOperands,
     /* 223057 */     // GIR_Coverage, 23285,
     /* 223057 */     GIR_EraseRootFromParent_Done,
     /* 223058 */   // Label 5187: @223058
     /* 223058 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(223126), // Rule ID 1140 //
     /* 223063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 223066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223082 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223085 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223089 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223106 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSm),
     /* 223109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223111 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 223113 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223115 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223124 */     GIR_RootConstrainSelectedInstOperands,
     /* 223125 */     // GIR_Coverage, 1140,
     /* 223125 */     GIR_EraseRootFromParent_Done,
     /* 223126 */   // Label 5188: @223126
     /* 223126 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(223194), // Rule ID 1388 //
     /* 223131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 223134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223150 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223153 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223157 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223174 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 223174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 223177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223179 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223181 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223185 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 223187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223192 */     GIR_RootConstrainSelectedInstOperands,
     /* 223193 */     // GIR_Coverage, 1388,
     /* 223193 */     GIR_EraseRootFromParent_Done,
     /* 223194 */   // Label 5189: @223194
     /* 223194 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(223262), // Rule ID 9107 //
     /* 223199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 223202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223218 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223221 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223225 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223235 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223242 */     // (strict_fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ128m),
     /* 223245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223247 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 223249 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223251 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223260 */     GIR_RootConstrainSelectedInstOperands,
     /* 223261 */     // GIR_Coverage, 9107,
     /* 223261 */     GIR_EraseRootFromParent_Done,
     /* 223262 */   // Label 5190: @223262
     /* 223262 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(223330), // Rule ID 1138 //
     /* 223267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 223270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 223286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223290 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223293 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223297 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223310 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSm),
     /* 223313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223315 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223317 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223319 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223328 */     GIR_RootConstrainSelectedInstOperands,
     /* 223329 */     // GIR_Coverage, 1138,
     /* 223329 */     GIR_EraseRootFromParent_Done,
     /* 223330 */   // Label 5191: @223330
     /* 223330 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(223398), // Rule ID 1386 //
     /* 223335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 223338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 223354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223358 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223361 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223365 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223378 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4rm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rm),
     /* 223381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223383 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223385 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 223387 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223396 */     GIR_RootConstrainSelectedInstOperands,
     /* 223397 */     // GIR_Coverage, 1386,
     /* 223397 */     GIR_EraseRootFromParent_Done,
     /* 223398 */   // Label 5192: @223398
     /* 223398 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(223466), // Rule ID 8473 //
     /* 223403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 223406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 223422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223426 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223429 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223433 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223439 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223446 */     // (strict_fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128m),
     /* 223449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223451 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223453 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223455 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223464 */     GIR_RootConstrainSelectedInstOperands,
     /* 223465 */     // GIR_Coverage, 8473,
     /* 223465 */     GIR_EraseRootFromParent_Done,
     /* 223466 */   // Label 5193: @223466
     /* 223466 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(223503), // Rule ID 1136 //
     /* 223471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 223474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223490 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 223490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSr),
     /* 223493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223495 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223497 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223499 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 223501 */     GIR_RootConstrainSelectedInstOperands,
     /* 223502 */     // GIR_Coverage, 1136,
     /* 223502 */     GIR_EraseRootFromParent_Done,
     /* 223503 */   // Label 5194: @223503
     /* 223503 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(223538), // Rule ID 1384 //
     /* 223508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 223511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 223527 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4rr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 223527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rr),
     /* 223532 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 223536 */     GIR_RootConstrainSelectedInstOperands,
     /* 223537 */     // GIR_Coverage, 1384,
     /* 223537 */     GIR_Done,
     /* 223538 */   // Label 5195: @223538
     /* 223538 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(223575), // Rule ID 8469 //
     /* 223543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 223546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 223562 */     // (strict_fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src3)
     /* 223562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128r),
     /* 223565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223567 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223569 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223571 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 223573 */     GIR_RootConstrainSelectedInstOperands,
     /* 223574 */     // GIR_Coverage, 8469,
     /* 223574 */     GIR_EraseRootFromParent_Done,
     /* 223575 */   // Label 5196: @223575
     /* 223575 */   GIM_Reject,
     /* 223576 */ // Label 5184: @223576
     /* 223576 */ GIM_Reject,
     /* 223577 */ // Label 5132: @223577
     /* 223577 */ GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(224313),
     /* 223582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 223585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 223588 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 223591 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(223659), // Rule ID 1198 //
     /* 223596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 223599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 223603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223611 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223614 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223618 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 223626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 223630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223639 */     // (strict_fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDYm),
     /* 223642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223644 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223646 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 223648 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223657 */     GIR_RootConstrainSelectedInstOperands,
     /* 223658 */     // GIR_Coverage, 1198,
     /* 223658 */     GIR_EraseRootFromParent_Done,
     /* 223659 */   // Label 5198: @223659
     /* 223659 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(223727), // Rule ID 9669 //
     /* 223664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 223667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223679 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223682 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223686 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223700 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223707 */     // (strict_fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ256m),
     /* 223710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223712 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223714 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 223716 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223725 */     GIR_RootConstrainSelectedInstOperands,
     /* 223726 */     // GIR_Coverage, 9669,
     /* 223726 */     GIR_EraseRootFromParent_Done,
     /* 223727 */   // Label 5199: @223727
     /* 223727 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(223795), // Rule ID 23315 //
     /* 223732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 223735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 223739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223747 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223750 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223754 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 223762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 223766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223768 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223775 */     // (strict_fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 223775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 223778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223780 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223782 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223786 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 223788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223793 */     GIR_RootConstrainSelectedInstOperands,
     /* 223794 */     // GIR_Coverage, 23315,
     /* 223794 */     GIR_EraseRootFromParent_Done,
     /* 223795 */   // Label 5200: @223795
     /* 223795 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(223863), // Rule ID 1196 //
     /* 223800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 223803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 223807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 223811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223819 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223822 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223826 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 223834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223836 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223843 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDYm),
     /* 223846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223848 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 223850 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223852 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223861 */     GIR_RootConstrainSelectedInstOperands,
     /* 223862 */     // GIR_Coverage, 1196,
     /* 223862 */     GIR_EraseRootFromParent_Done,
     /* 223863 */   // Label 5201: @223863
     /* 223863 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(223931), // Rule ID 1478 //
     /* 223868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 223871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 223875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 223879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223887 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223890 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223894 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 223902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223911 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 223911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 223914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223916 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223918 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223922 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 223924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223929 */     GIR_RootConstrainSelectedInstOperands,
     /* 223930 */     // GIR_Coverage, 1478,
     /* 223930 */     GIR_EraseRootFromParent_Done,
     /* 223931 */   // Label 5202: @223931
     /* 223931 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(223999), // Rule ID 9129 //
     /* 223936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 223939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223955 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223958 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223962 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223979 */     // (strict_fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 223979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ256m),
     /* 223982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223984 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 223986 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 223988 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 223992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223997 */     GIR_RootConstrainSelectedInstOperands,
     /* 223998 */     // GIR_Coverage, 9129,
     /* 223998 */     GIR_EraseRootFromParent_Done,
     /* 223999 */   // Label 5203: @223999
     /* 223999 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(224067), // Rule ID 1194 //
     /* 224004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 224007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 224023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224027 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224030 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224034 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224047 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYm),
     /* 224050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224052 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224054 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224056 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224065 */     GIR_RootConstrainSelectedInstOperands,
     /* 224066 */     // GIR_Coverage, 1194,
     /* 224066 */     GIR_EraseRootFromParent_Done,
     /* 224067 */   // Label 5204: @224067
     /* 224067 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(224135), // Rule ID 1476 //
     /* 224072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 224075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 224091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224095 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224098 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224102 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224115 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4Yrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrm),
     /* 224118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224120 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224122 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 224124 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224133 */     GIR_RootConstrainSelectedInstOperands,
     /* 224134 */     // GIR_Coverage, 1476,
     /* 224134 */     GIR_EraseRootFromParent_Done,
     /* 224135 */   // Label 5205: @224135
     /* 224135 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(224203), // Rule ID 8500 //
     /* 224140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 224143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 224159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224163 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224166 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224170 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224183 */     // (strict_fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256m),
     /* 224186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224188 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224190 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224192 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224201 */     GIR_RootConstrainSelectedInstOperands,
     /* 224202 */     // GIR_Coverage, 8500,
     /* 224202 */     GIR_EraseRootFromParent_Done,
     /* 224203 */   // Label 5206: @224203
     /* 224203 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(224240), // Rule ID 1192 //
     /* 224208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 224211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224227 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 224227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYr),
     /* 224230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224232 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224234 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224236 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 224238 */     GIR_RootConstrainSelectedInstOperands,
     /* 224239 */     // GIR_Coverage, 1192,
     /* 224239 */     GIR_EraseRootFromParent_Done,
     /* 224240 */   // Label 5207: @224240
     /* 224240 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(224275), // Rule ID 1474 //
     /* 224245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 224248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224264 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Yrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 224264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrr),
     /* 224269 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 224273 */     GIR_RootConstrainSelectedInstOperands,
     /* 224274 */     // GIR_Coverage, 1474,
     /* 224274 */     GIR_Done,
     /* 224275 */   // Label 5208: @224275
     /* 224275 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(224312), // Rule ID 8496 //
     /* 224280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 224283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224299 */     // (strict_fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src3)
     /* 224299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256r),
     /* 224302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224304 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224306 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224308 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 224310 */     GIR_RootConstrainSelectedInstOperands,
     /* 224311 */     // GIR_Coverage, 8496,
     /* 224311 */     GIR_EraseRootFromParent_Done,
     /* 224312 */   // Label 5209: @224312
     /* 224312 */   GIM_Reject,
     /* 224313 */ // Label 5197: @224313
     /* 224313 */ GIM_Reject,
     /* 224314 */ // Label 5133: @224314
     /* 224314 */ GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(224558),
     /* 224319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 224322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 224325 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 224328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224332 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(224396), // Rule ID 9615 //
     /* 224337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 224340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224348 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224351 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224355 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224376 */     // (strict_fma:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VFMADD132PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ128m),
     /* 224379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224381 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224383 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 224385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224394 */     GIR_RootConstrainSelectedInstOperands,
     /* 224395 */     // GIR_Coverage, 9615,
     /* 224395 */     GIR_EraseRootFromParent_Done,
     /* 224396 */   // Label 5211: @224396
     /* 224396 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(224460), // Rule ID 9075 //
     /* 224401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 224404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224416 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224419 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224423 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224440 */     // (strict_fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VFMADD231PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ128m),
     /* 224443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224445 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 224447 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224449 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224458 */     GIR_RootConstrainSelectedInstOperands,
     /* 224459 */     // GIR_Coverage, 9075,
     /* 224459 */     GIR_EraseRootFromParent_Done,
     /* 224460 */   // Label 5212: @224460
     /* 224460 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(224524), // Rule ID 8434 //
     /* 224465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 224468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 224480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224484 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224487 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224491 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224504 */     // (strict_fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128m),
     /* 224507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224509 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224511 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224513 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224522 */     GIR_RootConstrainSelectedInstOperands,
     /* 224523 */     // GIR_Coverage, 8434,
     /* 224523 */     GIR_EraseRootFromParent_Done,
     /* 224524 */   // Label 5213: @224524
     /* 224524 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(224557), // Rule ID 8430 //
     /* 224529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 224532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 224544 */     // (strict_fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src3)  =>  (VFMADD213PHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src3)
     /* 224544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128r),
     /* 224547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224549 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224551 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224553 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 224555 */     GIR_RootConstrainSelectedInstOperands,
     /* 224556 */     // GIR_Coverage, 8430,
     /* 224556 */     GIR_EraseRootFromParent_Done,
     /* 224557 */   // Label 5214: @224557
     /* 224557 */   GIM_Reject,
     /* 224558 */ // Label 5210: @224558
     /* 224558 */ GIM_Reject,
     /* 224559 */ // Label 5134: @224559
     /* 224559 */ GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(225295),
     /* 224564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 224567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 224570 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 224573 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(224641), // Rule ID 1150 //
     /* 224578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 224581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224593 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224596 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224600 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224621 */     // (strict_fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSYm),
     /* 224624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224626 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224628 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 224630 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224639 */     GIR_RootConstrainSelectedInstOperands,
     /* 224640 */     // GIR_Coverage, 1150,
     /* 224640 */     GIR_EraseRootFromParent_Done,
     /* 224641 */   // Label 5216: @224641
     /* 224641 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(224709), // Rule ID 9637 //
     /* 224646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 224649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224661 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224664 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224668 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224689 */     // (strict_fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ256m),
     /* 224692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224694 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224696 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 224698 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224707 */     GIR_RootConstrainSelectedInstOperands,
     /* 224708 */     // GIR_Coverage, 9637,
     /* 224708 */     GIR_EraseRootFromParent_Done,
     /* 224709 */   // Label 5217: @224709
     /* 224709 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(224777), // Rule ID 23287 //
     /* 224714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 224717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224729 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224732 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224736 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224757 */     // (strict_fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 224757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 224760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224762 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224764 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224768 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 224770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224775 */     GIR_RootConstrainSelectedInstOperands,
     /* 224776 */     // GIR_Coverage, 23287,
     /* 224776 */     GIR_EraseRootFromParent_Done,
     /* 224777 */   // Label 5218: @224777
     /* 224777 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(224845), // Rule ID 1148 //
     /* 224782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 224785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224801 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224804 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224808 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224825 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSYm),
     /* 224828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224830 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 224832 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224834 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224843 */     GIR_RootConstrainSelectedInstOperands,
     /* 224844 */     // GIR_Coverage, 1148,
     /* 224844 */     GIR_EraseRootFromParent_Done,
     /* 224845 */   // Label 5219: @224845
     /* 224845 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(224913), // Rule ID 1394 //
     /* 224850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 224853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224869 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224872 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224876 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224886 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224893 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 224893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 224896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224898 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224900 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224904 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 224906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224911 */     GIR_RootConstrainSelectedInstOperands,
     /* 224912 */     // GIR_Coverage, 1394,
     /* 224912 */     GIR_EraseRootFromParent_Done,
     /* 224913 */   // Label 5220: @224913
     /* 224913 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(224981), // Rule ID 9097 //
     /* 224918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 224921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224937 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224940 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224944 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 224952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224954 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224961 */     // (strict_fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 224961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ256m),
     /* 224964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224966 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 224968 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 224970 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 224974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224979 */     GIR_RootConstrainSelectedInstOperands,
     /* 224980 */     // GIR_Coverage, 9097,
     /* 224980 */     GIR_EraseRootFromParent_Done,
     /* 224981 */   // Label 5221: @224981
     /* 224981 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(225049), // Rule ID 1146 //
     /* 224986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 224989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 224997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 225005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225009 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225012 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225016 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225029 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYm),
     /* 225032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225034 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225036 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225038 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225047 */     GIR_RootConstrainSelectedInstOperands,
     /* 225048 */     // GIR_Coverage, 1146,
     /* 225048 */     GIR_EraseRootFromParent_Done,
     /* 225049 */   // Label 5222: @225049
     /* 225049 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(225117), // Rule ID 1392 //
     /* 225054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 225057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 225073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225077 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225080 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225084 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225090 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225097 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4Yrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrm),
     /* 225100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225102 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225104 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 225106 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225115 */     GIR_RootConstrainSelectedInstOperands,
     /* 225116 */     // GIR_Coverage, 1392,
     /* 225116 */     GIR_EraseRootFromParent_Done,
     /* 225117 */   // Label 5223: @225117
     /* 225117 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(225185), // Rule ID 8461 //
     /* 225122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 225125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 225141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225145 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225148 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225152 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225158 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225165 */     // (strict_fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256m),
     /* 225168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225170 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225172 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225174 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225183 */     GIR_RootConstrainSelectedInstOperands,
     /* 225184 */     // GIR_Coverage, 8461,
     /* 225184 */     GIR_EraseRootFromParent_Done,
     /* 225185 */   // Label 5224: @225185
     /* 225185 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(225222), // Rule ID 1144 //
     /* 225190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 225193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225209 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 225209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYr),
     /* 225212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225214 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225216 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225218 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 225220 */     GIR_RootConstrainSelectedInstOperands,
     /* 225221 */     // GIR_Coverage, 1144,
     /* 225221 */     GIR_EraseRootFromParent_Done,
     /* 225222 */   // Label 5225: @225222
     /* 225222 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(225257), // Rule ID 1390 //
     /* 225227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 225230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 225246 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Yrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 225246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrr),
     /* 225251 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 225255 */     GIR_RootConstrainSelectedInstOperands,
     /* 225256 */     // GIR_Coverage, 1390,
     /* 225256 */     GIR_Done,
     /* 225257 */   // Label 5226: @225257
     /* 225257 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(225294), // Rule ID 8457 //
     /* 225262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 225265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225281 */     // (strict_fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src3)
     /* 225281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256r),
     /* 225284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225286 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225288 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225290 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 225292 */     GIR_RootConstrainSelectedInstOperands,
     /* 225293 */     // GIR_Coverage, 8457,
     /* 225293 */     GIR_EraseRootFromParent_Done,
     /* 225294 */   // Label 5227: @225294
     /* 225294 */   GIM_Reject,
     /* 225295 */ // Label 5215: @225295
     /* 225295 */ GIM_Reject,
     /* 225296 */ // Label 5135: @225296
     /* 225296 */ GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(225540),
     /* 225301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 225304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 225307 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 225310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225314 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(225378), // Rule ID 9657 //
     /* 225319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 225322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225330 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225333 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225337 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225358 */     // (strict_fma:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VFMADD132PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZm),
     /* 225361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225363 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225365 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 225367 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225376 */     GIR_RootConstrainSelectedInstOperands,
     /* 225377 */     // GIR_Coverage, 9657,
     /* 225377 */     GIR_EraseRootFromParent_Done,
     /* 225378 */   // Label 5229: @225378
     /* 225378 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(225442), // Rule ID 9117 //
     /* 225383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 225386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225398 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225401 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225405 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225415 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225422 */     // (strict_fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VFMADD231PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZm),
     /* 225425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225427 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 225429 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225431 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225440 */     GIR_RootConstrainSelectedInstOperands,
     /* 225441 */     // GIR_Coverage, 9117,
     /* 225441 */     GIR_EraseRootFromParent_Done,
     /* 225442 */   // Label 5230: @225442
     /* 225442 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(225506), // Rule ID 8485 //
     /* 225447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 225450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 225462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225466 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225469 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225473 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225486 */     // (strict_fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZm),
     /* 225489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225491 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225493 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225495 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225504 */     GIR_RootConstrainSelectedInstOperands,
     /* 225505 */     // GIR_Coverage, 8485,
     /* 225505 */     GIR_EraseRootFromParent_Done,
     /* 225506 */   // Label 5231: @225506
     /* 225506 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(225539), // Rule ID 8481 //
     /* 225511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 225514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225526 */     // (strict_fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src3)  =>  (VFMADD213PDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src3)
     /* 225526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZr),
     /* 225529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225531 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225533 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225535 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 225537 */     GIR_RootConstrainSelectedInstOperands,
     /* 225538 */     // GIR_Coverage, 8481,
     /* 225538 */     GIR_EraseRootFromParent_Done,
     /* 225539 */   // Label 5232: @225539
     /* 225539 */   GIM_Reject,
     /* 225540 */ // Label 5228: @225540
     /* 225540 */ GIM_Reject,
     /* 225541 */ // Label 5136: @225541
     /* 225541 */ GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(225785),
     /* 225546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 225549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 225552 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 225555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225559 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(225623), // Rule ID 9605 //
     /* 225564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 225567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225575 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225578 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225582 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225596 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225603 */     // (strict_fma:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VFMADD132PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ256m),
     /* 225606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225608 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225610 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 225612 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225621 */     GIR_RootConstrainSelectedInstOperands,
     /* 225622 */     // GIR_Coverage, 9605,
     /* 225622 */     GIR_EraseRootFromParent_Done,
     /* 225623 */   // Label 5234: @225623
     /* 225623 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(225687), // Rule ID 9065 //
     /* 225628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 225631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225643 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225646 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225650 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225667 */     // (strict_fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VFMADD231PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ256m),
     /* 225670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225672 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 225674 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225676 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225685 */     GIR_RootConstrainSelectedInstOperands,
     /* 225686 */     // GIR_Coverage, 9065,
     /* 225686 */     GIR_EraseRootFromParent_Done,
     /* 225687 */   // Label 5235: @225687
     /* 225687 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(225751), // Rule ID 8422 //
     /* 225692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 225695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 225707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225711 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225714 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225718 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225731 */     // (strict_fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256m),
     /* 225734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225736 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225738 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225740 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225749 */     GIR_RootConstrainSelectedInstOperands,
     /* 225750 */     // GIR_Coverage, 8422,
     /* 225750 */     GIR_EraseRootFromParent_Done,
     /* 225751 */   // Label 5236: @225751
     /* 225751 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(225784), // Rule ID 8418 //
     /* 225756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 225759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 225771 */     // (strict_fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src3)  =>  (VFMADD213PHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src3)
     /* 225771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256r),
     /* 225774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225776 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225778 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225780 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 225782 */     GIR_RootConstrainSelectedInstOperands,
     /* 225783 */     // GIR_Coverage, 8418,
     /* 225783 */     GIR_EraseRootFromParent_Done,
     /* 225784 */   // Label 5237: @225784
     /* 225784 */   GIM_Reject,
     /* 225785 */ // Label 5233: @225785
     /* 225785 */ GIM_Reject,
     /* 225786 */ // Label 5137: @225786
     /* 225786 */ GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(226030),
     /* 225791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 225794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 225797 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 225800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225804 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(225868), // Rule ID 9625 //
     /* 225809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 225812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225820 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225823 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225827 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225848 */     // (strict_fma:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VFMADD132PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZm),
     /* 225851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225853 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225855 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 225857 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225866 */     GIR_RootConstrainSelectedInstOperands,
     /* 225867 */     // GIR_Coverage, 9625,
     /* 225867 */     GIR_EraseRootFromParent_Done,
     /* 225868 */   // Label 5239: @225868
     /* 225868 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(225932), // Rule ID 9085 //
     /* 225873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 225876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225888 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225895 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225912 */     // (strict_fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VFMADD231PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZm),
     /* 225915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225917 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 225919 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225921 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225930 */     GIR_RootConstrainSelectedInstOperands,
     /* 225931 */     // GIR_Coverage, 9085,
     /* 225931 */     GIR_EraseRootFromParent_Done,
     /* 225932 */   // Label 5240: @225932
     /* 225932 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(225996), // Rule ID 8446 //
     /* 225937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 225940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 225948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 225952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225956 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225959 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225963 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225976 */     // (strict_fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 225976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZm),
     /* 225979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225981 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225983 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 225985 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 225989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225994 */     GIR_RootConstrainSelectedInstOperands,
     /* 225995 */     // GIR_Coverage, 8446,
     /* 225995 */     GIR_EraseRootFromParent_Done,
     /* 225996 */   // Label 5241: @225996
     /* 225996 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(226029), // Rule ID 8442 //
     /* 226001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226016 */     // (strict_fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src3)  =>  (VFMADD213PSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src3)
     /* 226016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZr),
     /* 226019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226021 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226023 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226025 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 226027 */     GIR_RootConstrainSelectedInstOperands,
     /* 226028 */     // GIR_Coverage, 8442,
     /* 226028 */     GIR_EraseRootFromParent_Done,
     /* 226029 */   // Label 5242: @226029
     /* 226029 */   GIM_Reject,
     /* 226030 */ // Label 5238: @226030
     /* 226030 */ GIM_Reject,
     /* 226031 */ // Label 5138: @226031
     /* 226031 */ GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(226275),
     /* 226036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 226039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 226042 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 226045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226049 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(226113), // Rule ID 9593 //
     /* 226054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 226057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 226061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226065 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226068 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226072 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226093 */     // (strict_fma:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VFMADD132PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZm),
     /* 226096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226098 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226100 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 226102 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226111 */     GIR_RootConstrainSelectedInstOperands,
     /* 226112 */     // GIR_Coverage, 9593,
     /* 226112 */     GIR_EraseRootFromParent_Done,
     /* 226113 */   // Label 5244: @226113
     /* 226113 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(226177), // Rule ID 9053 //
     /* 226118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 226121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226133 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226136 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226140 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226157 */     // (strict_fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VFMADD231PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZm),
     /* 226160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226162 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 226164 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226166 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226175 */     GIR_RootConstrainSelectedInstOperands,
     /* 226176 */     // GIR_Coverage, 9053,
     /* 226176 */     GIR_EraseRootFromParent_Done,
     /* 226177 */   // Label 5245: @226177
     /* 226177 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(226241), // Rule ID 8407 //
     /* 226182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 226185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 226197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226201 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226204 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226208 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226214 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226221 */     // (strict_fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 226221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZm),
     /* 226224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226226 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226228 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226230 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 226234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226239 */     GIR_RootConstrainSelectedInstOperands,
     /* 226240 */     // GIR_Coverage, 8407,
     /* 226240 */     GIR_EraseRootFromParent_Done,
     /* 226241 */   // Label 5246: @226241
     /* 226241 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(226274), // Rule ID 8403 //
     /* 226246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 226249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226261 */     // (strict_fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src3)  =>  (VFMADD213PHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src3)
     /* 226261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZr),
     /* 226264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226266 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 226268 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 226270 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 226272 */     GIR_RootConstrainSelectedInstOperands,
     /* 226273 */     // GIR_Coverage, 8403,
     /* 226273 */     GIR_EraseRootFromParent_Done,
     /* 226274 */   // Label 5247: @226274
     /* 226274 */   GIM_Reject,
     /* 226275 */ // Label 5243: @226275
     /* 226275 */ GIM_Reject,
     /* 226276 */ // Label 5139: @226276
     /* 226276 */ GIM_Reject,
     /* 226277 */ // Label 73: @226277
     /* 226277 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5261*/ GIMT_Encode4(228445),
     /* 226288 */ /*GILLT_s16*//*Label 5248*/ GIMT_Encode4(226372),
     /* 226292 */ /*GILLT_s32*//*Label 5249*/ GIMT_Encode4(226493),
     /* 226296 */ /*GILLT_s64*//*Label 5250*/ GIMT_Encode4(226849),
     /* 226300 */ /*GILLT_s80*//*Label 5251*/ GIMT_Encode4(227205), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 226312 */ /*GILLT_v2s64*//*Label 5252*/ GIMT_Encode4(227242), GIMT_Encode4(0),
     /* 226320 */ /*GILLT_v4s32*//*Label 5253*/ GIMT_Encode4(227445),
     /* 226324 */ /*GILLT_v4s64*//*Label 5254*/ GIMT_Encode4(227648), GIMT_Encode4(0),
     /* 226332 */ /*GILLT_v8s16*//*Label 5255*/ GIMT_Encode4(227824),
     /* 226336 */ /*GILLT_v8s32*//*Label 5256*/ GIMT_Encode4(227913),
     /* 226340 */ /*GILLT_v8s64*//*Label 5257*/ GIMT_Encode4(228089), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 226352 */ /*GILLT_v16s16*//*Label 5258*/ GIMT_Encode4(228178),
     /* 226356 */ /*GILLT_v16s32*//*Label 5259*/ GIMT_Encode4(228267), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 226368 */ /*GILLT_v32s16*//*Label 5260*/ GIMT_Encode4(228356),
     /* 226372 */ // Label 5248: @226372
     /* 226372 */ GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(226492),
     /* 226377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 226380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 226384 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(226453), // Rule ID 21419 //
     /* 226389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 226392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 226396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226400 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226403 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226407 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226413 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226420 */     // (strict_fsqrt:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSHZm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 226420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 226423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 226427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 226432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 226434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZm),
     /* 226437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 226442 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 226446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226451 */     GIR_RootConstrainSelectedInstOperands,
     /* 226452 */     // GIR_Coverage, 21419,
     /* 226452 */     GIR_EraseRootFromParent_Done,
     /* 226453 */   // Label 5263: @226453
     /* 226453 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(226491), // Rule ID 21417 //
     /* 226458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 226461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 226465 */     // (strict_fsqrt:{ *:[f16] } FR16X:{ *:[f16] }:$src)  =>  (VSQRTSHZr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR16X:{ *:[f16] }:$src)
     /* 226465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 226468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 226472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 226477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 226479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZr),
     /* 226482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 226487 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 226489 */     GIR_RootConstrainSelectedInstOperands,
     /* 226490 */     // GIR_Coverage, 21417,
     /* 226490 */     GIR_EraseRootFromParent_Done,
     /* 226491 */   // Label 5264: @226491
     /* 226491 */   GIM_Reject,
     /* 226492 */ // Label 5262: @226492
     /* 226492 */ GIM_Reject,
     /* 226493 */ // Label 5249: @226493
     /* 226493 */ GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(226848),
     /* 226498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 226501 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(226557), // Rule ID 2447 //
     /* 226506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE1),
     /* 226509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 226513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 226517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226521 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226524 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226528 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226541 */     // (strict_fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSSm:{ *:[f32] } addr:{ *:[iPTR] }:$src1)
     /* 226541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSSm),
     /* 226544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226546 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 226550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226555 */     GIR_RootConstrainSelectedInstOperands,
     /* 226556 */     // GIR_Coverage, 2447,
     /* 226556 */     GIR_EraseRootFromParent_Done,
     /* 226557 */   // Label 5266: @226557
     /* 226557 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(226630), // Rule ID 18275 //
     /* 226562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 226565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 226569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 226573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226577 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226580 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226584 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226597 */     // (strict_fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 226597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 226600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 226604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 226609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 226611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSm),
     /* 226614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 226619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 226623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226628 */     GIR_RootConstrainSelectedInstOperands,
     /* 226629 */     // GIR_Coverage, 18275,
     /* 226629 */     GIR_EraseRootFromParent_Done,
     /* 226630 */   // Label 5267: @226630
     /* 226630 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(226703), // Rule ID 21423 //
     /* 226635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 226638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 226642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 226646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226650 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226653 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226657 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226670 */     // (strict_fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSZm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 226670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 226673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 226677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 226682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 226684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZm),
     /* 226687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 226692 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 226696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226701 */     GIR_RootConstrainSelectedInstOperands,
     /* 226702 */     // GIR_Coverage, 21423,
     /* 226702 */     GIR_EraseRootFromParent_Done,
     /* 226703 */   // Label 5268: @226703
     /* 226703 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(226736), // Rule ID 1047 //
     /* 226708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 226711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 226715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 226719 */     // (strict_fsqrt:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (SQRT_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 226719 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp32),
     /* 226724 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 226730 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 226734 */     GIR_RootConstrainSelectedInstOperands,
     /* 226735 */     // GIR_Coverage, 1047,
     /* 226735 */     GIR_Done,
     /* 226736 */   // Label 5269: @226736
     /* 226736 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(226763), // Rule ID 2445 //
     /* 226741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 226744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 226748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 226752 */     // (strict_fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src1)  =>  (SQRTSSr:{ *:[f32] } FR32:{ *:[f32] }:$src1)
     /* 226752 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSSr),
     /* 226757 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226761 */     GIR_RootConstrainSelectedInstOperands,
     /* 226762 */     // GIR_Coverage, 2445,
     /* 226762 */     GIR_Done,
     /* 226763 */   // Label 5270: @226763
     /* 226763 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(226805), // Rule ID 18273 //
     /* 226768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 226771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 226775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 226779 */     // (strict_fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src)  =>  (VSQRTSSr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32:{ *:[f32] }:$src)
     /* 226779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 226782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 226786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 226791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 226793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSr),
     /* 226796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 226801 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 226803 */     GIR_RootConstrainSelectedInstOperands,
     /* 226804 */     // GIR_Coverage, 18273,
     /* 226804 */     GIR_EraseRootFromParent_Done,
     /* 226805 */   // Label 5271: @226805
     /* 226805 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(226847), // Rule ID 21421 //
     /* 226810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 226817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 226821 */     // (strict_fsqrt:{ *:[f32] } FR32X:{ *:[f32] }:$src)  =>  (VSQRTSSZr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32X:{ *:[f32] }:$src)
     /* 226821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 226824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 226828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 226833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 226835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZr),
     /* 226838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 226843 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 226845 */     GIR_RootConstrainSelectedInstOperands,
     /* 226846 */     // GIR_Coverage, 21421,
     /* 226846 */     GIR_EraseRootFromParent_Done,
     /* 226847 */   // Label 5272: @226847
     /* 226847 */   GIM_Reject,
     /* 226848 */ // Label 5265: @226848
     /* 226848 */ GIM_Reject,
     /* 226849 */ // Label 5250: @226849
     /* 226849 */ GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(227204),
     /* 226854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 226857 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(226913), // Rule ID 2463 //
     /* 226862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 226865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 226869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 226873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226877 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226880 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226884 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226897 */     // (strict_fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSDm:{ *:[f64] } addr:{ *:[iPTR] }:$src1)
     /* 226897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSDm),
     /* 226900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226902 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 226906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226911 */     GIR_RootConstrainSelectedInstOperands,
     /* 226912 */     // GIR_Coverage, 2463,
     /* 226912 */     GIR_EraseRootFromParent_Done,
     /* 226913 */   // Label 5274: @226913
     /* 226913 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(226986), // Rule ID 18279 //
     /* 226918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 226921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 226925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 226929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226933 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226936 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226940 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226946 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226953 */     // (strict_fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 226953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 226956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 226960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 226965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 226967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDm),
     /* 226970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 226975 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 226979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226984 */     GIR_RootConstrainSelectedInstOperands,
     /* 226985 */     // GIR_Coverage, 18279,
     /* 226985 */     GIR_EraseRootFromParent_Done,
     /* 226986 */   // Label 5275: @226986
     /* 226986 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(227059), // Rule ID 21427 //
     /* 226991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 226994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 226998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227006 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227009 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227013 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227026 */     // (strict_fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDZm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 227026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 227029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZm),
     /* 227043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227048 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227057 */     GIR_RootConstrainSelectedInstOperands,
     /* 227058 */     // GIR_Coverage, 21427,
     /* 227058 */     GIR_EraseRootFromParent_Done,
     /* 227059 */   // Label 5276: @227059
     /* 227059 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(227092), // Rule ID 1049 //
     /* 227064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 227067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 227071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 227075 */     // (strict_fsqrt:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (SQRT_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 227075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp64),
     /* 227080 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 227086 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 227090 */     GIR_RootConstrainSelectedInstOperands,
     /* 227091 */     // GIR_Coverage, 1049,
     /* 227091 */     GIR_Done,
     /* 227092 */   // Label 5277: @227092
     /* 227092 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(227119), // Rule ID 2461 //
     /* 227097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 227100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 227104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 227108 */     // (strict_fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src1)  =>  (SQRTSDr:{ *:[f64] } FR64:{ *:[f64] }:$src1)
     /* 227108 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSDr),
     /* 227113 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227117 */     GIR_RootConstrainSelectedInstOperands,
     /* 227118 */     // GIR_Coverage, 2461,
     /* 227118 */     GIR_Done,
     /* 227119 */   // Label 5278: @227119
     /* 227119 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(227161), // Rule ID 18277 //
     /* 227124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 227127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 227131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 227135 */     // (strict_fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src)  =>  (VSQRTSDr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64:{ *:[f64] }:$src)
     /* 227135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 227138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDr),
     /* 227152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227157 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 227159 */     GIR_RootConstrainSelectedInstOperands,
     /* 227160 */     // GIR_Coverage, 18277,
     /* 227160 */     GIR_EraseRootFromParent_Done,
     /* 227161 */   // Label 5279: @227161
     /* 227161 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(227203), // Rule ID 21425 //
     /* 227166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 227169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 227173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 227177 */     // (strict_fsqrt:{ *:[f64] } FR64X:{ *:[f64] }:$src)  =>  (VSQRTSDZr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64X:{ *:[f64] }:$src)
     /* 227177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 227180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 227184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZr),
     /* 227194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227199 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 227201 */     GIR_RootConstrainSelectedInstOperands,
     /* 227202 */     // GIR_Coverage, 21425,
     /* 227202 */     GIR_EraseRootFromParent_Done,
     /* 227203 */   // Label 5280: @227203
     /* 227203 */   GIM_Reject,
     /* 227204 */ // Label 5273: @227204
     /* 227204 */ GIM_Reject,
     /* 227205 */ // Label 5251: @227205
     /* 227205 */ GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(227241), // Rule ID 1051 //
     /* 227210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 227213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 227216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 227220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 227224 */   // (strict_fsqrt:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (SQRT_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 227224 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp80),
     /* 227229 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 227235 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 227239 */   GIR_RootConstrainSelectedInstOperands,
     /* 227240 */   // GIR_Coverage, 1051,
     /* 227240 */   GIR_Done,
     /* 227241 */ // Label 5281: @227241
     /* 227241 */ GIM_Reject,
     /* 227242 */ // Label 5252: @227242
     /* 227242 */ GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(227444),
     /* 227247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 227250 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(227306), // Rule ID 2467 //
     /* 227255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 227258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 227262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227270 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227273 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227277 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227283 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227290 */     // (strict_fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 227290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDm),
     /* 227293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227295 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227304 */     GIR_RootConstrainSelectedInstOperands,
     /* 227305 */     // GIR_Coverage, 2467,
     /* 227305 */     GIR_EraseRootFromParent_Done,
     /* 227306 */   // Label 5283: @227306
     /* 227306 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(227362), // Rule ID 12085 //
     /* 227311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 227314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 227318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227326 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227329 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227333 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227346 */     // (strict_fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ128m:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 227346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128m),
     /* 227349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227351 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227360 */     GIR_RootConstrainSelectedInstOperands,
     /* 227361 */     // GIR_Coverage, 12085,
     /* 227361 */     GIR_EraseRootFromParent_Done,
     /* 227362 */   // Label 5284: @227362
     /* 227362 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(227389), // Rule ID 2465 //
     /* 227367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 227370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 227374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 227378 */     // (strict_fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (VSQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 227378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDr),
     /* 227383 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227387 */     GIR_RootConstrainSelectedInstOperands,
     /* 227388 */     // GIR_Coverage, 2465,
     /* 227388 */     GIR_Done,
     /* 227389 */   // Label 5285: @227389
     /* 227389 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(227416), // Rule ID 2473 //
     /* 227394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 227397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 227401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 227405 */     // (strict_fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (SQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 227405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPDr),
     /* 227410 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227414 */     GIR_RootConstrainSelectedInstOperands,
     /* 227415 */     // GIR_Coverage, 2473,
     /* 227415 */     GIR_Done,
     /* 227416 */   // Label 5286: @227416
     /* 227416 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(227443), // Rule ID 12081 //
     /* 227421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 227424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 227428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 227432 */     // (strict_fsqrt:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)  =>  (VSQRTPDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)
     /* 227432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128r),
     /* 227437 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227441 */     GIR_RootConstrainSelectedInstOperands,
     /* 227442 */     // GIR_Coverage, 12081,
     /* 227442 */     GIR_Done,
     /* 227443 */   // Label 5287: @227443
     /* 227443 */   GIM_Reject,
     /* 227444 */ // Label 5282: @227444
     /* 227444 */ GIM_Reject,
     /* 227445 */ // Label 5253: @227445
     /* 227445 */ GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(227647),
     /* 227450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 227453 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(227509), // Rule ID 2451 //
     /* 227458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 227461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 227465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227473 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227476 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227480 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227493 */     // (strict_fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 227493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSm),
     /* 227496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227507 */     GIR_RootConstrainSelectedInstOperands,
     /* 227508 */     // GIR_Coverage, 2451,
     /* 227508 */     GIR_EraseRootFromParent_Done,
     /* 227509 */   // Label 5289: @227509
     /* 227509 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(227565), // Rule ID 12061 //
     /* 227514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 227517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 227521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227529 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227532 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227536 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227549 */     // (strict_fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ128m:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 227549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128m),
     /* 227552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227554 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227563 */     GIR_RootConstrainSelectedInstOperands,
     /* 227564 */     // GIR_Coverage, 12061,
     /* 227564 */     GIR_EraseRootFromParent_Done,
     /* 227565 */   // Label 5290: @227565
     /* 227565 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(227592), // Rule ID 2449 //
     /* 227570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 227573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 227577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 227581 */     // (strict_fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (VSQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 227581 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSr),
     /* 227586 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227590 */     GIR_RootConstrainSelectedInstOperands,
     /* 227591 */     // GIR_Coverage, 2449,
     /* 227591 */     GIR_Done,
     /* 227592 */   // Label 5291: @227592
     /* 227592 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(227619), // Rule ID 2457 //
     /* 227597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 227600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 227604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 227608 */     // (strict_fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (SQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 227608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPSr),
     /* 227613 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227617 */     GIR_RootConstrainSelectedInstOperands,
     /* 227618 */     // GIR_Coverage, 2457,
     /* 227618 */     GIR_Done,
     /* 227619 */   // Label 5292: @227619
     /* 227619 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(227646), // Rule ID 12057 //
     /* 227624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 227627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 227631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 227635 */     // (strict_fsqrt:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)  =>  (VSQRTPSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)
     /* 227635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128r),
     /* 227640 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227644 */     GIR_RootConstrainSelectedInstOperands,
     /* 227645 */     // GIR_Coverage, 12057,
     /* 227645 */     GIR_Done,
     /* 227646 */   // Label 5293: @227646
     /* 227646 */   GIM_Reject,
     /* 227647 */ // Label 5288: @227647
     /* 227647 */ GIM_Reject,
     /* 227648 */ // Label 5254: @227648
     /* 227648 */ GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(227823),
     /* 227653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 227656 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(227712), // Rule ID 2471 //
     /* 227661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 227664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 227668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227676 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227679 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227683 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227696 */     // (strict_fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDYm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 227696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYm),
     /* 227699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227701 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227710 */     GIR_RootConstrainSelectedInstOperands,
     /* 227711 */     // GIR_Coverage, 2471,
     /* 227711 */     GIR_EraseRootFromParent_Done,
     /* 227712 */   // Label 5295: @227712
     /* 227712 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(227768), // Rule ID 12097 //
     /* 227717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 227720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 227724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227732 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227735 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227739 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227752 */     // (strict_fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ256m:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 227752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256m),
     /* 227755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227757 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227766 */     GIR_RootConstrainSelectedInstOperands,
     /* 227767 */     // GIR_Coverage, 12097,
     /* 227767 */     GIR_EraseRootFromParent_Done,
     /* 227768 */   // Label 5296: @227768
     /* 227768 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(227795), // Rule ID 2469 //
     /* 227773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 227776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 227780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 227784 */     // (strict_fsqrt:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)  =>  (VSQRTPDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /* 227784 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYr),
     /* 227789 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227793 */     GIR_RootConstrainSelectedInstOperands,
     /* 227794 */     // GIR_Coverage, 2469,
     /* 227794 */     GIR_Done,
     /* 227795 */   // Label 5297: @227795
     /* 227795 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(227822), // Rule ID 12093 //
     /* 227800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 227803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 227807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 227811 */     // (strict_fsqrt:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)  =>  (VSQRTPDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)
     /* 227811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256r),
     /* 227816 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227820 */     GIR_RootConstrainSelectedInstOperands,
     /* 227821 */     // GIR_Coverage, 12093,
     /* 227821 */     GIR_Done,
     /* 227822 */   // Label 5298: @227822
     /* 227822 */   GIM_Reject,
     /* 227823 */ // Label 5294: @227823
     /* 227823 */ GIM_Reject,
     /* 227824 */ // Label 5255: @227824
     /* 227824 */ GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(227912),
     /* 227829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 227832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 227836 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(227888), // Rule ID 12013 //
     /* 227841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 227844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227852 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227855 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227859 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227872 */     // (strict_fsqrt:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ128m:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 227872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128m),
     /* 227875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227877 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227886 */     GIR_RootConstrainSelectedInstOperands,
     /* 227887 */     // GIR_Coverage, 12013,
     /* 227887 */     GIR_EraseRootFromParent_Done,
     /* 227888 */   // Label 5300: @227888
     /* 227888 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(227911), // Rule ID 12009 //
     /* 227893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 227896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 227900 */     // (strict_fsqrt:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)  =>  (VSQRTPHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)
     /* 227900 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128r),
     /* 227905 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227909 */     GIR_RootConstrainSelectedInstOperands,
     /* 227910 */     // GIR_Coverage, 12009,
     /* 227910 */     GIR_Done,
     /* 227911 */   // Label 5301: @227911
     /* 227911 */   GIM_Reject,
     /* 227912 */ // Label 5299: @227912
     /* 227912 */ GIM_Reject,
     /* 227913 */ // Label 5256: @227913
     /* 227913 */ GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(228088),
     /* 227918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 227921 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(227977), // Rule ID 2455 //
     /* 227926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 227929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 227933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227941 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227944 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227948 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227954 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227961 */     // (strict_fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSYm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 227961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYm),
     /* 227964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 227970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227975 */     GIR_RootConstrainSelectedInstOperands,
     /* 227976 */     // GIR_Coverage, 2455,
     /* 227976 */     GIR_EraseRootFromParent_Done,
     /* 227977 */   // Label 5303: @227977
     /* 227977 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(228033), // Rule ID 12073 //
     /* 227982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 227985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 227989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227997 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228000 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228004 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228010 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228017 */     // (strict_fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ256m:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 228017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256m),
     /* 228020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228022 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228031 */     GIR_RootConstrainSelectedInstOperands,
     /* 228032 */     // GIR_Coverage, 12073,
     /* 228032 */     GIR_EraseRootFromParent_Done,
     /* 228033 */   // Label 5304: @228033
     /* 228033 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(228060), // Rule ID 2453 //
     /* 228038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 228041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 228045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 228049 */     // (strict_fsqrt:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)  =>  (VSQRTPSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /* 228049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYr),
     /* 228054 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228058 */     GIR_RootConstrainSelectedInstOperands,
     /* 228059 */     // GIR_Coverage, 2453,
     /* 228059 */     GIR_Done,
     /* 228060 */   // Label 5305: @228060
     /* 228060 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(228087), // Rule ID 12069 //
     /* 228065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 228068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 228072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 228076 */     // (strict_fsqrt:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)  =>  (VSQRTPSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)
     /* 228076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256r),
     /* 228081 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228085 */     GIR_RootConstrainSelectedInstOperands,
     /* 228086 */     // GIR_Coverage, 12069,
     /* 228086 */     GIR_Done,
     /* 228087 */   // Label 5306: @228087
     /* 228087 */   GIM_Reject,
     /* 228088 */ // Label 5302: @228088
     /* 228088 */ GIM_Reject,
     /* 228089 */ // Label 5257: @228089
     /* 228089 */ GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(228177),
     /* 228094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 228097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 228101 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(228153), // Rule ID 12049 //
     /* 228106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228117 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228120 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228124 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228130 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228137 */     // (strict_fsqrt:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 228137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZm),
     /* 228140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228151 */     GIR_RootConstrainSelectedInstOperands,
     /* 228152 */     // GIR_Coverage, 12049,
     /* 228152 */     GIR_EraseRootFromParent_Done,
     /* 228153 */   // Label 5308: @228153
     /* 228153 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(228176), // Rule ID 12045 //
     /* 228158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 228165 */     // (strict_fsqrt:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)  =>  (VSQRTPDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)
     /* 228165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZr),
     /* 228170 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228174 */     GIR_RootConstrainSelectedInstOperands,
     /* 228175 */     // GIR_Coverage, 12045,
     /* 228175 */     GIR_Done,
     /* 228176 */   // Label 5309: @228176
     /* 228176 */   GIM_Reject,
     /* 228177 */ // Label 5307: @228177
     /* 228177 */ GIM_Reject,
     /* 228178 */ // Label 5258: @228178
     /* 228178 */ GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(228266),
     /* 228183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 228186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 228190 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(228242), // Rule ID 12025 //
     /* 228195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 228198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228206 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228209 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228213 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228219 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228226 */     // (strict_fsqrt:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ256m:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 228226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256m),
     /* 228229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228231 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228240 */     GIR_RootConstrainSelectedInstOperands,
     /* 228241 */     // GIR_Coverage, 12025,
     /* 228241 */     GIR_EraseRootFromParent_Done,
     /* 228242 */   // Label 5311: @228242
     /* 228242 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(228265), // Rule ID 12021 //
     /* 228247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 228250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 228254 */     // (strict_fsqrt:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)  =>  (VSQRTPHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)
     /* 228254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256r),
     /* 228259 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228263 */     GIR_RootConstrainSelectedInstOperands,
     /* 228264 */     // GIR_Coverage, 12021,
     /* 228264 */     GIR_Done,
     /* 228265 */   // Label 5312: @228265
     /* 228265 */   GIM_Reject,
     /* 228266 */ // Label 5310: @228266
     /* 228266 */ GIM_Reject,
     /* 228267 */ // Label 5259: @228267
     /* 228267 */ GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(228355),
     /* 228272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 228275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 228279 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(228331), // Rule ID 12037 //
     /* 228284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228295 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228298 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228302 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228315 */     // (strict_fsqrt:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 228315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZm),
     /* 228318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228320 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228329 */     GIR_RootConstrainSelectedInstOperands,
     /* 228330 */     // GIR_Coverage, 12037,
     /* 228330 */     GIR_EraseRootFromParent_Done,
     /* 228331 */   // Label 5314: @228331
     /* 228331 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(228354), // Rule ID 12033 //
     /* 228336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 228343 */     // (strict_fsqrt:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)  =>  (VSQRTPSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)
     /* 228343 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZr),
     /* 228348 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228352 */     GIR_RootConstrainSelectedInstOperands,
     /* 228353 */     // GIR_Coverage, 12033,
     /* 228353 */     GIR_Done,
     /* 228354 */   // Label 5315: @228354
     /* 228354 */   GIM_Reject,
     /* 228355 */ // Label 5313: @228355
     /* 228355 */ GIM_Reject,
     /* 228356 */ // Label 5260: @228356
     /* 228356 */ GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(228444),
     /* 228361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 228364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 228368 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(228420), // Rule ID 12001 //
     /* 228373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 228376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228384 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228387 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228391 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228404 */     // (strict_fsqrt:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 228404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZm),
     /* 228407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228409 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 228413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228418 */     GIR_RootConstrainSelectedInstOperands,
     /* 228419 */     // GIR_Coverage, 12001,
     /* 228419 */     GIR_EraseRootFromParent_Done,
     /* 228420 */   // Label 5317: @228420
     /* 228420 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(228443), // Rule ID 11997 //
     /* 228425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 228428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 228432 */     // (strict_fsqrt:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)  =>  (VSQRTPHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)
     /* 228432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZr),
     /* 228437 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228441 */     GIR_RootConstrainSelectedInstOperands,
     /* 228442 */     // GIR_Coverage, 11997,
     /* 228442 */     GIR_Done,
     /* 228443 */   // Label 5318: @228443
     /* 228443 */   GIM_Reject,
     /* 228444 */ // Label 5316: @228444
     /* 228444 */ GIM_Reject,
     /* 228445 */ // Label 5261: @228445
     /* 228445 */ GIM_Reject,
     /* 228446 */ // Label 74: @228446
     /* 228446 */ GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(228458), // Rule ID 17073 //
     /* 228451 */   // (trap)  =>  (TRAP)
     /* 228451 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TRAP),
     /* 228456 */   GIR_RootConstrainSelectedInstOperands,
     /* 228457 */   // GIR_Coverage, 17073,
     /* 228457 */   GIR_Done,
     /* 228458 */ // Label 5319: @228458
     /* 228458 */ GIM_Reject,
     /* 228459 */ // Label 75: @228459
     /* 228459 */ GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(228474), // Rule ID 22376 //
     /* 228464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotPS),
     /* 228467 */   // (debugtrap)  =>  (INT3)
     /* 228467 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::INT3),
     /* 228472 */   GIR_RootConstrainSelectedInstOperands,
     /* 228473 */   // GIR_Coverage, 22376,
     /* 228473 */   GIR_Done,
     /* 228474 */ // Label 5320: @228474
     /* 228474 */ GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(228494), // Rule ID 22377 //
     /* 228479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsPS),
     /* 228482 */   // (debugtrap)  =>  (INT 65:{ *:[i8] })
     /* 228482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT),
     /* 228485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/65,
     /* 228488 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 228492 */   GIR_RootConstrainSelectedInstOperands,
     /* 228493 */   // GIR_Coverage, 22377,
     /* 228493 */   GIR_EraseRootFromParent_Done,
     /* 228494 */ // Label 5321: @228494
     /* 228494 */ GIM_Reject,
     /* 228495 */ // Label 76: @228495
     /* 228495 */ GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(228510), // Rule ID 17075 //
     /* 228500 */   // MIs[0] kind
     /* 228500 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 228503 */   // (ubsantrap (timm:{ *:[i32] }):$kind)  =>  (UBSAN_UD1 (timm:{ *:[i32] }):$kind)
     /* 228503 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::UBSAN_UD1),
     /* 228508 */   GIR_RootConstrainSelectedInstOperands,
     /* 228509 */   // GIR_Coverage, 17075,
     /* 228509 */   GIR_Done,
     /* 228510 */ // Label 5322: @228510
     /* 228510 */ GIM_Reject,
     /* 228511 */ // Label 77: @228511
     /* 228511 */ GIM_Reject,
     /* 228512 */ }; // Size: 228512 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const X86Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const X86Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
